! ***********************************************************************************
! *          SCATTERING CHARACTERISTICS: INCOMPLETE UNIFORM DISTRIBUTION            *
! *    ---------------------------------------------------------------------------  *
! *    Partial list of subroutines:                                                 *
! *     ScatCharact,             DSCS_SCAT,               DSCS,                     *          
! *     F_azimuthal,             F_azimuthal_tetaGS,      CQscat,                   *
! *     CQext,                   CQextGen,                CQextPolGen,              *
! *     CQextPolPlane(UNUSED)    PhaseMatrix,             ExtinctionMatrix,         *  
! *     extend_vector_positive,  extend_vector_negative,  delta_DSCS,               *  
! *     NodesAlphaBetaGamma,     IndexElements,           DiffScatCrossSectPARTSUB, *
! *     DSCSPARTSUB,             EMFPARTSUB,              delta_DSCSPARTSUB,        *
! *     readinputSCT,            readinputPARTSUB1                                  *
! ***********************************************************************************
subroutine ScatCharact (k, FileTmat, Mrank, Nrank, axsym, sphere, chiral)
!------------------------------------------------------------------------------------
! The subroutine computes the scattering characteristics of a particle using the    !
! T matrix stored in file FileTmat. The input parameters are:                       !
! - k (real) - wave number of the ambient medium.                                   !
! - FileTmat (character(80)) - name of the file containing the T matrix.            !
! - Mrank, Nrank (integer variables) - Mrank is the number of azimuthal modes       !
!   (maximum degree), while Nrank is the maximum expansion order.                   !
! - axsym (logical) - if axsym = t, the scatterer is a rotationally symmetric       !
!   particle (axisymmetric particle).                                               !
! - sphere (logical) - if sphere = t, the scatterer is a spherical particle.        !
! - chiral (logical) - if chiral = t, the scatterer is an optical active particle   !
!  (chiral particle).                                                               !
!------------------------------------------------------------------------------------
  use parameters
  use allocation, only: IndI, IndJ, NameElem
  implicit none
  integer        :: Nrank, Mrank, Nalpha, Nbeta, Ngamma, NthetaGS, NthetaRND, Nphi, &
                    Ntheta(NphiMax), Nelem, MatrixElem(16), NthetaAsym, NphiAsym,   &
                    Nrankeff, Mrankeff, ifail, itheta, Nfail, ialpha, ibeta,        &
                    igamma, i, j, kelem, iphi, NthetaAL, NphiAL
  real(O)        :: k, wavelength, alphamin, alphamax, betamin, betamax, gammamin,  &
                    gammamax, anorm, snorm, thetaGI, phiGI, alphapGauss, x0, y0,    &
                    z0, w0, deltaOrder, phiGS, thetaminRND, thetamaxRND,            &
                    phi(NphiMax), thetamin(Nphimax), thetamax(NphiMax), theta,      &
                    dtheta, AsymPar, AsymParV, Cext, Cscat, Qext, Qscat, Z(4,4),    &
                    CextAv, CscatAv, QextAv, QscatAv, alpha, beta, gamma, fact,     &
                    norm, CscatPAv, CscatSAv, CextPAv, CextSAv, QscatPAv, QscatSAv, &
                    QextPAv, QextSAv, gP_xAv, gP_yAv, gP_zAv, gS_xAv, gS_yAv,       &
                    gS_zAv, gP_x, gP_y, gP_z, gS_x, gS_y, gS_z, gP_t, gP_p, gP_r,   &
                    gS_t, gS_p, gS_r, KeAv(4,4), Ke(4,4), CscatP, CscatS, CextP,    &
                    CextS, CscatV, CextV, QscatV, QextV, aphi, bphi, atheta, btheta
  complex(O)     :: epol_beta, epol_alpha		    
  character(5)   :: TypeExcit  
  character(80)  :: FileTmat, FileDSCS, FileSCAT
  character(256) :: FailMessage(10)
  logical        :: MirorSym, axsym, sphere, chiral, RandomOrientation, DoNumAvrg,  &
                    UseSimpson, ReducedOrder, ExtThetaDom, normalized, ComputeDSCS, &
                    ComputeScatPar, FailHovTest, ComputeAsymPar, PrnProgress,       &
                    WriteInputInfo
  real(O),allocatable      :: ZE(:,:,:), walpha(:), xalpha(:), wbeta(:), xbeta(:),  &
                              wgamma(:), xgamma(:), hAv(:), vAv(:), h(:), v(:),     &
                              ZTPAv(:,:,:), ZTP(:,:,:), wphi(:), xphi(:), wtheta(:),&
                              xtheta(:)
  complex(O),allocatable   :: SS(:,:)
! -----------------------------------------------------------------------------------
!                                Read the input file                                !
! -----------------------------------------------------------------------------------           
  call readinputSCT ( .false., wavelength, k, FileTmat, Nrank, Mrank,               &
       axsym, sphere, chiral, RandomOrientation, MirorSym, DoNumAvrg,               &
       UseSimpson, ReducedOrder, deltaOrder, alphamin, alphamax, Nalpha,            &
       betamin, betamax, Nbeta, gammamin, gammamax, Ngamma, anorm, TypeExcit,       &
       thetaGI, phiGI, epol_beta, epol_alpha, alphapGauss, x0, y0, z0, w0,          &
       ComputeDSCS, phiGS, NthetaGS, ExtThetaDom, normalized, FileDSCS,             &
       ComputeScatPar, NthetaRND, thetaminRND, thetamaxRND, Nphi, phi, Ntheta,      &
       thetamin, thetamax, FileScat, Nelem, MatrixElem, ComputeAsymPar,             &
       NthetaAsym, NphiAsym, PrnProgress, WriteInputInfo, snorm )
  if (.not. ComputeDSCS .and. .not. ComputeScatPar) return     
! -----------------------------------------------------------------------------------
!                                       Main                                        !
! -----------------------------------------------------------------------------------              
  if (RandomOrientation) then          
    print "(/,2x,'Scattering Characteristics of a Randomly Oriented Particle')"  
    print "(  2x,'----------------------------------------------------------')"     
    allocate (SS(10,NthetaGS))    
    if (PrnProgress)                                                                &
    print "(/,2x,'progress of main calculation for the average matrix <SS*>:')"
    if (.not. DoNumAvrg) then                   
      call AvCscatCextEff (ReducedOrder, k, snorm, FileTmat, axsym, chiral,         &
           deltaOrder, Nrank, Mrank, Nrankeff, Mrankeff, Cext, Cscat,               &
           Qext, Qscat)                                                                       
      print "(2x,'effective number of azimuthal modes, Mrankeff = ',i3,';')",       &
              Mrankeff
      print "(2x,'effective maximum expansion order,   Nrankeff = ',i3,';')",       &
              Nrankeff   								                                        
      call SijSCpqEff (MirorSym, k, axsym, chiral, FileTmat, Nrank, Mrank,          &
           Nrankeff, Mrankeff, NthetaGS, SS, PrnProgress)                       
    else                                                               
      call SijSCpqInt (MirorSym, k, snorm, FileTmat, axsym, chiral, Nrank, Mrank,   &
           Nalpha, Nbeta, Ngamma, NthetaGS, UseSimpson, Cext, Cscat, Qext, Qscat,   &
           SS, PrnProgress)
    end if                                                                  
    CscatV = 0._O
    CextV  = 0._O
    QscatV = 0._O
    QextV  = 0._O    
    if (ComputeScatPar) then
      if (NthetaRND /= 1) then
        dtheta = (thetamaxRND - thetaminRND) / (NthetaRND - 1)
      else
        dtheta = 0._O
      end if  
      open (unit = iSCAT, file = FileScat, status = "replace")
      if (WriteInputInfo) call inputDSCS_SCATAvrg (.false., wavelength, axsym,      &
                               chiral, FileTmat, Nrank, Mrank, anorm, normalized,   &                              
                               DoNumAvrg, Nalpha, Nbeta, Ngamma, NthetaGS,          &
                               epol_beta, epol_alpha) 
      call RandomExtinctionMatrix (k, FileTmat, MirorSym, axsym, chiral, Nrank,     &
           Mrank, KeAv)     	   			                                            
      allocate (ZE(4,4,NthetaGS))
      call ExtendedScatteringMatrix (MirorSym, NthetaGS, SS, ZE)
      if (.not.MirorSym) call AvCscatCextV (k, snorm, NthetaGS, ZE, KeAv, CscatV,   &
                              CextV, QscatV, QextV)            
      call AsymmetryParameter (MirorSym, NthetaGS, ZE, Cscat, AsymPar, AsymParV)
      FailHovTest = .false.
      Nfail = 0
      do ifail = 1, 10
        FailMessage(ifail) = ' '
      end do                                
      do itheta = 1, NthetaRND
        theta = thetaminRND + (itheta - 1) * dtheta                          
        call ScatteringMatrix (MirorSym, theta, NthetaGS, ZE, Z)                      
        if (axsym) then
          FailHovTest = .false. 
          call HovTest (Z, FailHovTest, Nfail, FailMessage)
        end if          
        call write_ScatMatrix (MirorSym, axsym, FailHovTest, Nfail, FailMessage,    &
             KeAv, theta, Z, itheta, Nelem, IndI, IndJ, NameElem, Cscat, Cext,      &
             Qscat, Qext, CscatV, CextV, QscatV, QextV, AsymPar, AsymParV)
      end do        
      close (unit = iSCAT)    
      deallocate (ZE)                                            
    end if
    if (ComputeDSCS) then
      open (unit = iDSCS, file = FileDSCS, status = "replace")       			      
      if (WriteInputInfo) call inputDSCS_SCATAvrg (.true., wavelength, axsym,       &
                               chiral, FileTmat, Nrank, Mrank, anorm, normalized,   &                              
                               DoNumAvrg, Nalpha, Nbeta, Ngamma, NthetaGS,          &
                               epol_beta, epol_alpha)
      if (.not.MirorSym)  then      
        call RandomExtinctionMatrix (k, FileTmat, MirorSym, axsym, chiral, Nrank,   &
             Mrank, KeAv)     	   			                                            
        allocate (ZE(4,4,NthetaGS))
        call ExtendedScatteringMatrix (MirorSym, NthetaGS, SS, ZE)
        call AvCscatCextV (k, snorm, NthetaGS, ZE, KeAv, CscatV, CextV, QscatV,     &
	     QextV)                  
      end if  			       
      call DiffScatCrossSectAvrg (MirorSym, SS, NthetaGS, anorm, epol_beta,         &
           epol_alpha, phiGS, normalized, Cscat, Cext, Qscat, Qext, CscatV, CextV,  &
           QscatV, QextV)
      close (unit = iDSCS) 
      if (.not.MirorSym) deallocate (ZE)                          
    end if                       
    deallocate (SS)   
  else      
    print "(/,2x,'Scattering Characteristics of a Nonrandomly Oriented Particle')" 
    print "(  2x,'-------------------------------------------------------------')" 
    allocate (walpha(Nalpha), xalpha(Nalpha), wbeta(Nbeta), xbeta(Nbeta),           &
              wgamma(Ngamma), xgamma(Ngamma))                                   
    NphiAL   = Nphi
    NthetaAL = 0
    do iphi = 1, Nphi
      if (Ntheta(iphi) > NthetaAL) NthetaAL = Ntheta(iphi)
    end do
    allocate (h(NthetaGS), v(NthetaGS), ZTP(NphiAL,NthetaAL,Nelem))    
    allocate (xphi(NphiAsym), wphi(NphiAsym), xtheta(NthetaAsym), wtheta(NthetaAsym))                
    call NodesAlphaBetaGamma (alphamin, alphamax, Nalpha, betamin, betamax, Nbeta,  &
         gammamin, gammamax, Ngamma, UseSimpson, xalpha, walpha, xbeta, wbeta,      &
         xgamma, wgamma)	    	                                         
    if (ComputeDSCS)    open (unit = iDSCS, file = FileDSCS, status = "replace")       
    if (ComputeScatPar) open (unit = iSCAT, file = FileScat, status = "replace")                                            
    if (ComputeDSCS .and. WriteInputInfo)                                           &                      
      call inputDSCS_SCAT (.true., axsym, sphere, chiral, Mrank, Nrank, phiGS,      &
           thetaGI, phiGI, alphamin, alphamax, Nalpha, betamin, betamax, Nbeta,     &
           gammamin, gammamax, Ngamma, epol_beta, epol_alpha, alphapGauss, x0,      &
           y0, z0, w0, TypeExcit, wavelength, anorm, normalized, FileTmat)
    if (ComputeScatPar .and. WriteInputInfo)                                        &   
      call inputDSCS_SCAT (.false., axsym, sphere, chiral, Mrank, Nrank, phiGS,     &
           thetaGI, phiGI, alphamin, alphamax, Nalpha, betamin, betamax, Nbeta,     &
           gammamin, gammamax, Ngamma, epol_beta, epol_alpha, alphapGauss, x0,      &
           y0, z0, w0, TypeExcit, wavelength, anorm, normalized, FileTmat)                  
    if (ComputeDSCS) then
      allocate (hAv(NthetaGS), vAv(NthetaGS))
      CextAv  = 0._O
      CscatAv = 0._O
      do itheta = 1, NthetaGS
        hAv(itheta) = 0._O
        vAv(itheta) = 0._O
      end do    
    end if
    if (ComputeScatPar) then
      allocate (ZTPAv(NphiAL,NthetaAL,Nelem))  
      CextPAv  = 0._O
      CextSAv  = 0._O         
      CscatPAv = 0._O
      CscatSAv = 0._O                  
      do iphi = 1, NphiAL 
        do itheta = 1, NthetaAL               
          do kelem = 1, Nelem        
            ZTPAv(iphi,itheta,kelem) = 0._O
          end do
        end do
      end do
      do i = 1, 4
        do j = 1, 4
          KeAv(i,j) = 0._O
        end do
      end do
      if (ComputeAsymPar) then                    
        gP_xAv = 0._O
        gP_yAv = 0._O
        gP_zAv = 0._O      
        gS_xAv = 0._O
        gS_yAv = 0._O
        gS_zAv = 0._O  
!        
        aphi = 0._O
        bphi = 2._O * Pi
        call Simpson (aphi, bphi, NphiAsym, xphi, wphi)   
        if (.not. UseSimpson) then
          atheta = 0._O
          btheta = Pi   
          call Gauss_Legendre (atheta, btheta, NthetaAsym, wtheta, xtheta)   
          do itheta = 1, NthetaAsym
            theta = xtheta(itheta)
            wtheta(itheta) = wtheta(itheta) * sin(theta)      
          end do        
        else
          atheta = - 1._O
          btheta =   1._O
          call Simpson (atheta, btheta, NthetaAsym, xtheta, wtheta)     
        end if     	                  
      end if 	
    end if
    if (PrnProgress .and. Nalpha > 1)                                               &
        print "(/,2x,'progress of main calculation for the averaging procedure:')"   
    do ialpha = 1, Nalpha
      alpha = xalpha(ialpha)
      if (PrnProgress .and. Nalpha > 1) call write_progress (.false., ialpha, Nalpha)
      do ibeta = 1, Nbeta          
        if (.not. UseSimpson) then 
          beta = xbeta(ibeta)
        else
          beta = acos(xbeta(ibeta))
        end if
        do igamma = 1, Ngamma 
          gamma = xgamma(igamma)           
          fact  = walpha(ialpha) * wbeta(ibeta) * wgamma(igamma)          	       	       	       
          call DSCS_SCAT (ComputeDSCS, ComputeScatPar, ComputeAsymPar, axsym,       &
               sphere, chiral, Mrank, Nrank, NthetaGS, phiGS, Nphi, phi, Ntheta,    &
               thetamin, thetamax, NthetaAsym, NphiAsym, UseSimpson, xphi, wphi,    &
               xtheta, wtheta, thetaGI, phiGI, alpha, beta, gamma, epol_beta,       &
               epol_alpha, alphapGauss, x0, y0, z0, w0, TypeExcit, k, snorm,        &
               FileTmat, ExtThetaDom, normalized, Nelem, IndI, IndJ, h, v, ZTP,     &
               NphiAL, NthetaAL, Ke, Cscat, Cext, CscatP, CscatS, CextP, CextS,     &
               gP_x, gP_y, gP_z, gS_x, gS_y, gS_z)  	       	        
          if (ComputeDSCS) then                                        
            CextAv  = CextAv  + Cext  * fact
            CscatAv = CscatAv + Cscat * fact
            do itheta = 1, NthetaGS
              hAv(itheta) = hAv(itheta) + h(itheta) * fact
              vAv(itheta) = vAv(itheta) + v(itheta) * fact
            end do
          end if   
          if (ComputeScatPar) then
            CextPAv  = CextPAv  + CextP  * fact
            CextSAv  = CextSAv  + CextS  * fact               	    
            CscatPAv = CscatPAv + CscatP * fact
            CscatSAv = CscatSAv + CscatS * fact             	        
            do iphi = 1, Nphi 
              do itheta = 1, Ntheta(iphi)                           
                do kelem = 1, Nelem        
                  ZTPAv(iphi,itheta,kelem) = ZTPAv(iphi,itheta,kelem) +             &
                                             ZTP(iphi,itheta,kelem) * fact
                end do
              end do
            end do
            if (TypeExcit(1:5) == 'PLANE') then  
              do i = 1, 4
                do j = 1, 4
                  KeAv(i,j) = KeAv(i,j) + Ke(i,j) * fact
                end do
              end do           
            end if
	    if (ComputeAsymPar) then
              gP_xAv = gP_xAv + gP_x * fact
              gP_yAv = gP_yAv + gP_y * fact
              gP_zAv = gP_zAv + gP_z * fact	                
              gS_xAv = gS_xAv + gS_x * fact
              gS_yAv = gS_yAv + gS_y * fact
              gS_zAv = gS_zAv + gS_z * fact	                	    	    	    
            end if 	      
          end if
        end do
      end do
    end do      
    norm = Pi * anorm * anorm
    norm = 1._O / norm                 
    if (ComputeDSCS) then
      QextAv  = CextAv  * norm  
      QscatAv = CscatAv * norm      
      call write_DSCS1 (NthetaGS, normalized, ExtThetaDom, hAv, vAv, CscatAv,       &
           CextAv, QscatAv, QextAv)                                            
      close (unit = iDSCS)
      deallocate (hAv, vAv)
    end if
    if (ComputeScatPar) then
      QextPAv  = CextPAv  * norm 
      QextSAv  = CextSAv  * norm                   
      QscatPAv = CscatPAv * norm 
      QscatSAv = CscatSAv * norm 
      gP_t = 0._O
      gP_p = 0._O
      gP_r = 0._O  
      gS_t = 0._O 
      gS_p = 0._O
      gS_r = 0._O      
      if (ComputeAsymPar) then                                           
        call T_cartesian_global_local (gP_xAv, gP_yAv, gP_zAv, phiGI, thetaGI,      &
             0._O, gP_t, gP_p, gP_r)
        call T_cartesian_global_local (gS_xAv, gS_yAv, gS_zAv, phiGI, thetaGI,      &
             0._O, gS_t, gS_p, gS_r)      
      end if	     
      call write_SCAT (Nelem, NameElem, Nphi, phi, Ntheta, thetamin, thetamax,      &
           ZTPAv, NphiAL, NthetaAL, KeAv, CscatPAv, CscatSAv, CextPAv, CextSAv,     &
           QscatPAv, QscatSAv, QextPAv, QextSAv, ComputeAsymPar, gP_t, gP_p, gP_r,  &
           gS_t, gS_p, gS_r, TypeExcit)
      close (unit = iSCAT)             
      deallocate (ZTPAv)      
    end if
    deallocate (walpha, xalpha, wbeta, xbeta, wgamma, xgamma)
    deallocate (h, v, ZTP)
    deallocate (xphi, wphi, xtheta, wtheta)    
  end if
  deallocate (IndI, IndJ, NameElem)  
end subroutine ScatCharact
! **********************************************************************************
subroutine readinputSCT ( CompleteFile, wavelength, k, FileTmat, Nrank, Mrank,      &
           axsym, sphere, chiral, RandomOrientation, MirorSym, DoNumAvrg,           &
	   UseSimpson, ReducedOrder, deltaOrder, alphamin, alphamax, Nalpha,        &
	   betamin, betamax, Nbeta, gammamin, gammamax, Ngamma, anorm, TypeExcit,   &
           thetaGI, phiGI, epol_beta, epol_alpha, alphapGauss, x0, y0, z0, w0,      &
           ComputeDSCS, phiGS, NthetaGS, ExtThetaDom, normalized, FileDSCS,         &
           ComputeScatPar, NthetaRND, thetaminRND, thetamaxRND, Nphi, phi, Ntheta,  &
           thetamin, thetamax, FileScat, Nelem, MatrixElem, ComputeAsymPar,         &
           NthetaAsym, NphiAsym, PrnProgress, WriteInputInfo, snorm )
  use parameters
  use allocation, only: IndI, IndJ, NameElem
  implicit none
  integer        :: Nrank, Mrank, Nalpha, Nbeta, Ngamma, NthetaGS, NthetaRND, Nphi, &
                    Ntheta(NphiMax), Nelem, MatrixElem(16), NthetaAsym, NphiAsym,   &
                    i, ios, iphi
  real(O)        :: k, wavelength, alphamin, alphamax, betamin, betamax, gammamin,  &
                    gammamax, anorm, xpart, snorm, thetaGI, phiGI, alphapGauss,     &
                    x0, y0, z0, w0, deltaOrder, phiGS, thetaminRND, thetamaxRND,    &
                    phi(NphiMax), thetamin(Nphimax), thetamax(NphiMax), grd   
  complex(O)     :: epol_beta, epol_alpha		    
                    
  character(5)   :: TypeExcit  
  character(80)  :: FileDSCS, FileSCAT, FileTmat, string 
  logical        :: CompleteFile, axsym, sphere, chiral, RandomOrientation,         &
                    MirorSym, DoNumAvrg, UseSimpson, ReducedOrder, ExtThetaDom,     &
                    normalized, ComputeDSCS, ComputeScatPar, ComputeAsymPar,        &
                    PrnProgress, WriteInputInfo, XFindPar  
! -----------------------------------------------------------------------------------
!                           Read the input file FileInputSCT                        !
! -----------------------------------------------------------------------------------      
  open (unit = iInputSCT, file = FileInputSCT, status = "old", position = "rewind") 
!
  if (CompleteFile) then
    call DrvParameters           
!
    wavelength = 0.1_O * 2._O * Pi 
    string     = 'OptProp'
    if (XFindPar (iInputSCT, string)) then
      read (iInputSCT, *, iostat = ios) wavelength
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable wavelength;')"
        stop
      end if            
    else
      print "(/,2x,'Group name OptProp not found;')"
      stop  
    end if
    k = 2._O * Pi / wavelength
!
    FileTmat = '../TMATFILES/T.dat'
    Nrank  = 7
    Mrank  = 4  
    axsym  = .true.
    sphere = .false.
    chiral = .false.
    string = 'Tmat'
    if (XFindPar (iInputSCT, string)) then
      read (iInputSCT, *, iostat = ios) FileTmat
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable FileTmat;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) Nrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nrank;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) Mrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Mrank;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) axsym
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable axsym;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) sphere
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable sphere;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) chiral
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable chiral;')"
        stop
      end if
    else
      print "(/,2x,'Group name Tmat not found;')"
      stop  
    end if     
  else   
    wavelength = 2._O * Pi / k 
  end if
  grd = Pi / 180._O
! --- initialization of input variables ---                             
  RandomOrientation = .true.
  MirorSym     = .true.
  DoNumAvrg    = .false.
  UseSimpson   = .true.
  ReducedOrder = .true.
  deltaOrder   = 1.e-4_O
  alphamin     = 0._O
  alphamax     = 0._O
  Nalpha       = 1
  betamin      = 0._O
  betamax      = 0._O
  Nbeta        = 1  
  gammamin     = 0._O
  gammamax     = 0._O
  Ngamma       = 1  
  anorm        = 1._O 
  TypeExcit    = 'PLANE'
  thetaGI      =  0._O
  phiGI        =  0._O
  epol_beta    = one 
  epol_alpha   = zero
  alphapGauss  =  0._O
  x0 =  1._O
  y0 =  1._O
  z0 =  1._O
  w0 = 10._O  
  ComputeDSCS  = .true. 
  phiGS        =  0._O 
  NthetaGS     = 91 
  ExtThetaDom  = .true. 
  normalized   = .true.   
  FileDSCS     = '../OUTPUTFILES/dscs.dat'
  ComputeScatPar = .true.
  NthetaRND    = 1
  thetaminRND  = 0._O 
  thetamaxRND  = 0._O 
  Nphi = 1
  do iphi = 1, NphiMax
    phi(iphi)      = 0._O
    Ntheta(iphi)   = 1
    thetamin(iphi) = 0._O
    thetamax(iphi) = 0._O  
  end do      
  FileScat = '../OUTPUTFILES/scat.dat'
  Nelem         =  6
  MatrixElem(1) = 11
  MatrixElem(2) = 11
  MatrixElem(3) = 11
  MatrixElem(4) = 11
  MatrixElem(5) = 11
  MatrixElem(6) = 11
  do i = 7, 16
    MatrixElem(i) = 11 
  end do
  ComputeAsymPar = .false. 
  NthetaAsym = 61
  NphiAsym   = 31  
  PrnProgress    = .true.
  WriteInputInfo = .true. 
  allocate (IndI(Nelem), IndJ(Nelem), NameElem(Nelem))
  do i = 1, Nelem
    IndI(i) = 1
    IndJ(i) = 1   
    NameElem(i) = '11'  
  end do  
! ..................................................................................   
!                                start reading data                                !
! ..................................................................................
  string = 'TypePDF'
  if (XFindPar (iInputSCT, string)) then
    read (iInputSCT, *, iostat = ios) RandomOrientation
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable RandomOrientation;')"
      stop
    end if
  else
    print "(/,2x,'Group name TypePDF not found;')"
    stop  
  end if 
  if (sphere) then
    if (.not. axsym) axsym = .true.
    if (Randomorientation) RandomOrientation = .false.     
    Mrank = Nrank  ! redundant      
  end if               
! ..................................................................................  
!                         read data for a complete PDF                             !  
! ..................................................................................
  if (RandomOrientation) then
    string = 'CompletePDF - TypeMedium'
    if (XFindPar (iInputSCT, string)) then
      read (iInputSCT, *, iostat = ios) MirorSym
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable MirorSym;')"
        stop
      end if
    else
      print "(/,2x,'Group name CompletePDF - TypeMedium not found;')"
      stop  
    end if
    if (axsym .and. .not. MirorSym) then
      MirorSym = .true.  
      print "(/,2x,'Warning: the variable MirorSym has been setted to .true.')"         	
    end if            
!
    string = 'CompletePDF - AvrgMtrSS'
    if (XFindPar (iInputSCT, string)) then
      read (iInputSCT, *, iostat = ios) DoNumAvrg
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable DoNumAvrg;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) NthetaGS
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable NthetaGS;')"
        stop
      end if                                                                                                  
    else
      print "(/,2x,'Group name CompletePDF - AvrgMtrSS not found;')"
      stop  
    end if   
    call check_NthetaGS (NthetaGS)        
!
    if (.not. DoNumAvrg) then
      string = 'CompletePDF - AnalytComputAvrgMtrSS'
      if (XFindPar (iInputSCT, string)) then      
        read (iInputSCT, *, iostat = ios) ReducedOrder
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable ReducedOrder;')"
          stop
        end if
        if (ReducedOrder) then
          read (iInputSCT, *, iostat = ios) deltaOrder
          if (ios /= 0) then
            print "(/,2x,'Error by reading the input variable deltaOrder;')"
            stop
          end if                                                                                                
        end if	
      else
        print "(/,2x,'Group name CompletePDF - AnalytComputAvrgMtrSS not found;')"
        stop  
      end if      
    end if        
!
    if (DoNumAvrg) then
      string = 'CompletePDF - NumComputAvrgMtrSS'
      if (XFindPar (iInputSCT, string)) then      
        read (iInputSCT, *, iostat = ios) UseSimpson
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable UseSimpson;')"
          stop
        end if             
        read (iInputSCT, *, iostat = ios) Nalpha
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable Nalpha;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) Nbeta
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable Nbeta;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) Ngamma
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable Ngamma;')"
          stop
        end if 
        call check_NalphaNbetaNgamma (1, Nalpha)
        call check_NalphaNbetaNgamma (2, Nbeta)
        if (.not. axsym) call check_NalphaNbetaNgamma (3, Ngamma)
	call check_NSimpson (Nalpha)
        if (UseSimpson)  call check_NSimpson (Nbeta)
        if (.not. axsym) call check_NSimpson (Ngamma)      	
      else
        print "(/,2x,'Group name CompletePDF - NumComputAvrgMtrSS not found;')"
        stop  
      end if                        
    end if        
!
    string = 'CompletePDF - NormConst'
    if (XFindPar (iInputSCT, string)) then
      read (iInputSCT, *, iostat = ios) anorm
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable anorm;')"
        stop
      end if
    else
      print "(/,2x,'Group name CompletePDF - NormConst not found;')"
      stop  
    end if
!
    string  = 'CompletePDF - DSCS'
    if (XFindPar (iInputSCT, string)) then
      read (iInputSCT, *, iostat = ios) ComputeDSCS 
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable ComputeDSCS;')"
        stop
      end if
      if (ComputeDSCS) then      
        read (iInputSCT, *, iostat = ios) epol_beta
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable epol_beta;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) epol_alpha
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable epol_alpha;')"
          stop
        end if                  
        read (iInputSCT, *, iostat = ios) phiGS
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable phiGS;')"
          stop
        end if            
        read (iInputSCT, *, iostat = ios) normalized
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable normalized;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) FileDSCS
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable FileDSCS;')"
          stop
        end if
        call check_azimuthal_plane (phiGS)      
        phiGS = phiGS  * grd	
      end if	
    else
      print "(/,2x,'Group name CompletePDF - DSCS not found;')"
      stop  
    end if          
!
    string = 'CompletePDF - ScatPars'
    if (XFindPar (iInputSCT, string)) then
      read (iInputSCT, *, iostat = ios) ComputeScatPar 
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable ComputeScatPar;')"
        stop
      end if
      if (ComputeScatPar) then            
        read (iInputSCT, *, iostat = ios) NthetaRND
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable NthetaRND;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) thetaminRND
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable thetaminRND;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) thetamaxRND
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable thetamaxRND;')"
          stop
        end if                                         
        read (iInputSCT, *, iostat = ios) FileScat
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable FileScat;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) Nelem
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable Nelem;')"
          stop
        end if                    
        do i = 1, Nelem
          read (iInputSCT, *, iostat = ios) MatrixElem(i)                        
          if (ios /= 0) then
            print "(/,2x,'Error by reading the input variable MatrixElem;')"
            stop
          end if
        end do
        call check_tetaminmax (thetaminRND, thetamaxRND, NthetaRND)
        thetaminRND = thetaminRND * grd
        thetamaxRND = thetamaxRND * grd 						
        call check_MatrixElem (Nelem, MatrixElem)
	deallocate (indI, indJ, NameElem)
	allocate (IndI(Nelem), IndJ(Nelem), NameElem(Nelem))     
        call IndexElements (Nelem, MatrixElem, IndI, IndJ, NameElem)	
      end if	
    else
      print "(/,2x,'Group name CompletePDF - ScatPars not found;')"
      stop  
    end if                    
! ..................................................................................  
!                       read data for an incomplete PDF                            !  
! ..................................................................................    
  else
    string = 'IncompletePDF - TypeIntegration'
    if (XFindPar (iInputSCT, string)) then      
      read (iInputSCT, *, iostat = ios) UseSimpson
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable UseSimpson;')"
        stop
      end if      
    else
      print "(/,2x,'Group name IncompletePDF - TypeIntegration not found;')"
      stop  
    end if  
!      
    string  = 'IncompletePDF - OrientationAngles'
    if (XFindPar (iInputSCT, string)) then
      read (iInputSCT, *, iostat = ios) alphamin
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable alphamin;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) alphamax
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable alphamax;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) Nalpha
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nalpha;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) betamin
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable betamin;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) betamax
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable betamax;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) Nbeta
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nbeta;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) gammamin
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable gammamin;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) gammamax
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable gammamax;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) Ngamma
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Ngamma;')"
        stop
      end if
      if (sphere) then    
        alphamin = 0._O
        alphamax = 0._O
        Nalpha   = 1
        betamin  = 0._O
        betamax  = 0._O
        Nbeta    = 1  
        gammamin = 0._O
        gammamax = 0._O
        Ngamma   = 1  
      end if
      call check_alfaminmax (alphamin, alphamax, Nalpha)
      call check_betaminmax (betamin, betamax, Nbeta)     
      if (.not. axsym) then
        call check_gamaminmax (gammamin, gammamax, Ngamma)              
      else
        gammamin = 0._O
        gammamax = 0._O
        Ngamma   = 1 
      end if
      alphamin = alphamin * grd
      alphamax = alphamax * grd
      betamin  = betamin  * grd
      betamax  = betamax  * grd
      gammamin = gammamin * grd
      gammamax = gammamax * grd      
      call check_NSimpson (Nalpha)
      if (UseSimpson)  call check_NSimpson (Nbeta)
      if (.not. axsym) call check_NSimpson (Ngamma)                
    else
      print "(/,2x,'Group name IncompletePDF - OrientationAngles not found;')"
      stop  
    end if  
!              
    string = 'IncompletePDF - NormConst'
    if (XFindPar (iInputSCT, string)) then
      read (iInputSCT, *, iostat = ios) anorm
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable anorm;')"
        stop
      end if
    else
      print "(/,2x,'Group name IncompletePDF - NormConst not found;')"
      stop  
    end if   
!              
    string = 'IncompletePDF - IncWave'
    if (XFindPar (iInputSCT, string)) then
      read (iInputSCT, *, iostat = ios) TypeExcit
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable TypeExcit;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) thetaGI
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable thetaGI;')"
        stop
      end if
      read (iInputSCT, *, iostat = ios) phiGI
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable phiGI;')"
        stop
      end if
      if (TypeExcit(1:5) == 'GAUSS') then       
        read (iInputSCT, *, iostat = ios) x0
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable x0;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) y0
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable y0;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) z0
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable z0;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) w0
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable w0;')"
          stop
        end if 
      end if	
      call check_TypeExcit (TypeExcit) 
      call check_incident_direction (thetaGI, phiGI)  
      thetaGI = thetaGI * grd
      phiGI   = phiGI   * grd                      
    else
      print "(/,2x,'Group name IncompletePDF - IncWave not found;')"
      stop  
    end if                           
!
    string = 'IncompletePDF - DSCS'
    if (XFindPar (iInputSCT, string)) then
      read (iInputSCT, *, iostat = ios) ComputeDSCS 
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable ComputeDSCS;')"
        stop
      end if                                                            
      if (ComputeDSCS) then   	
        read (iInputSCT, *, iostat = ios) epol_beta
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable epol_beta;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) epol_alpha
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable epol_alpha;')"
          stop
        end if                    
        read (iInputSCT, *, iostat = ios) alphapGauss
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable alphapGauss;')"
          stop
        end if        	        
	read (iInputSCT, *, iostat = ios) phiGS
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable phiGS;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) NthetaGS
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable NthetaGS;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) ExtThetaDom
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable ExtThetaDom;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) normalized
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable normalized;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) FileDSCS
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable FileDSCS;')"
          stop
        end if									
	call check_azimuthal_plane (phiGS)
	phiGS = phiGS  * grd        		
        call check_polarization_angle (alphapGauss)        
        alphapGauss = alphapGauss * grd			
      end if                                                	
    else
      print "(/,2x,'Group name IncompletePDF - DSCS not found;')"
      stop  
    end if   
!    
    string = 'IncompletePDF - ScatPars'
    if (XFindPar (iInputSCT, string)) then
      read (iInputSCT, *, iostat = ios) ComputeScatPar 
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable ComputeScatPar;')"
        stop
      end if            
      if (ComputeScatPar) then              
        read (iInputSCT, *, iostat = ios) Nphi
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable Nphi;')"
          stop
        end if
        do iphi = 1, Nphi
          read (iInputSCT, *, iostat = ios) phi(iphi)
          if (ios /= 0) then
            print "(/,2x,'Error by reading the input variable phi;')"
            stop
          end if      
          read (iInputSCT, *, iostat = ios) Ntheta(iphi)
          if (ios /= 0) then
            print "(/,2x,'Error by reading the input variable Ntheta;')"
            stop
          end if      
          read (iInputSCT, *, iostat = ios) thetamin(iphi)
          if (ios /= 0) then
            print "(/,2x,'Error by reading the input variable thetamin;')"
            stop
          end if        
          read (iInputSCT, *, iostat = ios) thetamax(iphi)
          if (ios /= 0) then
            print "(/,2x,'Error by reading the input variable thetamax;')"
            stop
          end if                
        end do                    
        read (iInputSCT, *, iostat = ios) FileScat
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable FileScat;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) Nelem
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable Nelem;')"
          stop
        end if                    
        do i = 1, Nelem
          read (iInputSCT, *, iostat = ios) MatrixElem(i)                        
          if (ios /= 0) then
            print "(/,2x,'Error by reading the input variable MatrixElem;')"
            stop
          end if
        end do        	
	call check_Nphi (Nphi)
        call check_teta_phiminmax (.true., Nphi, phi, Ntheta, thetamin, thetamax)
        do iphi = 1, Nphi    
          phi(iphi)      = phi(iphi)      * grd
          thetamin(iphi) = thetamin(iphi) * grd
          thetamax(iphi) = thetamax(iphi) * grd      
        end do
        call check_MatrixElem (Nelem, MatrixElem)  
	deallocate (indI, indJ, NameElem)
	allocate (IndI(Nelem), IndJ(Nelem), NameElem(Nelem))    
        call IndexElements (Nelem, MatrixElem, IndI, IndJ, NameElem)	
      end if      	
    else
      print "(/,2x,'Group name IncompletePDF - ScatPars not found;')"
      stop  
    end if
!           
    string = 'IncompletePDF - MeanDirPropagatScatWave'
    if (XFindPar (iInputSCT, string)) then
      read (iInputSCT, *, iostat = ios) ComputeAsymPar
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable ComputeAsymPar;')"
        stop
      end if
      if (ComputeAsymPar .and. .not. ComputeScatPar) then
        ComputeAsymPar = .false.         
        print                                                                       &
       "(/,2x,'Warning: the variable ComputeAsymPar has been setted to .false.')"	
      end if
      if (ComputeAsymPar) then
        read (iInputSCT, *, iostat = ios) NthetaAsym
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable NthetaAsym;')"
          stop
        end if
        read (iInputSCT, *, iostat = ios) NphiAsym
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable NphiAsym;')"
          stop
        end if
        call check_NSimpson (NphiAsym)
        if (UseSimpson)  call check_NSimpson (NthetaAsym) 	
      end if   	
    else
      print "(/,2x,'Group name IncompletePDF - MeanDirPropagatScatWave not found;')"
      stop  
    end if                      
  end if
  call check_anorm (anorm)
  xpart = k * anorm
  snorm = Pi * xpart * xpart 
!
  string = 'PrintInfo'
  if (XFindPar (iInputSCT, string)) then
    read (iInputSCT, *, iostat = ios) PrnProgress
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if
    read (iInputSCT, *, iostat = ios) WriteInputInfo
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable WriteInputInfo;')"
      stop
    end if
  else
    print "(/,2x,'Group name PrintInfo not found;')"
    stop  
  end if 
  close (unit = iInputSCT) 
end subroutine readinputSCT  
! **********************************************************************************
subroutine DSCS_SCAT (ComputeDSCS, ComputeScatPar, ComputeAsymPar, axsym, sphere,   &
           chiral, Mrank, Nrank, NthetaGS, phiAZIMUT, Nphi, phi, Ntheta, thetamin,  &
           thetamax, NthetaAsym, NphiAsym, UseSimpson, xphi, wphi, xtheta, wtheta,  &
           thetaGI, phiGI, alpha, beta, gamma, epol_beta, epol_alpha, alphapGauss,  &
           x0, y0, z0, w0, TypeExcit, wavenumber, snorm, FileTmat, ExtThetaDom,     &
           normalized, Nelem, IndI, IndJ, h, v, ZTP, NphiAL, NthetaAL, Ke, Cscat,   &
           Cext, CscatX, CscatY, CextX, CextY, gX_x, gX_y, gX_z, gY_x, gY_y, gY_z )                       
! -----------------------------------------------------------------------------------
! The routine computes:                                                             !
! - the optical cross sections for incident parallel and perpendicular linear       !
!   polarizations,                                                                  !
! - the mean direction of propagation of the scattered radiation for incident       !
!   parallel and perpendicular linear polarizations,                                !
! - the extinction matrix for a plane wave incidence, and                           !   
! - the phase matrix at Nphi scattering planes.                                     !
! Note that the optical cross sections and the mean direction of propagation of the !
! scattered field are computed for linearly polarized waves (vector plane waves and ! 
! Gaussian beams propagating in the direction (thetaGI,phiGI)). The calculations    !
! are performed for incident parallel and perpendicular polarizations, that is for  !
! alphap = 0° and alphap = 90°. The code also determines the differential           !
! scattering cross sections at a set of NthetaGS scattering angles in the azimuthal !
! plane phiAZIMUT. The calculations are performed for elliptically polarized plane  !
! waves and linearly polarized Gaussian beams. For a plane wave incidence, the      !
! differential scattering cross sections correspond to the complex polarization     !
! unit vector                                                                       !      
!                 epol = epol_beta * e_beta + epol_alpha * e_alpha.                 !
! In the case of a Gaussian beam illumination, the calculations are performed for a !
! linearly polarized wave and the state of polarization of the Gaussian beam is     !
! described by the polarization angle alphapGauss. Note that all scattering         !
! characteristics are computed for a fixed particle orientation characterized by    !
! the Euler rotation angles alpha, beta and gamma.                                  !
! -----------------------------------------------------------------------------------
  use parameters
  implicit none      
  integer       :: Mrank, Nrank, NthetaGS, Ntheta(NphiMax), Nphi, Nelem,            &
                   IndI(Nelem), IndJ(Nelem), NthetaAsym, NphiAsym, NphiAL, NthetaAL
  real(O)       :: phiAZIMUT, thetamin(NphiMax), thetamax(NphiMax), phi(NphiMax),   &
                   thetaGI, phiGI, alpha, beta, gamma, alphapGauss, x0, y0, z0, w0, &
                   wavenumber, snorm, Cscat, Cext, CscatX, CscatY, CextX, CextY,    &
                   Ke(4,4), h(NthetaGS), v(NthetaGS), ZTP(NphiAL,NthetaAL,Nelem),   &
                   gX_x, gX_y, gX_z, gY_x, gY_y, gY_z, xphi(NphiAsym),              &
                   wphi(NphiAsym), xtheta(NthetaAsym), wtheta(NthetaAsym)		                   
  complex(O)    :: epol_beta, epol_alpha		    
  character(5)  :: TypeExcit
  character(80) :: FileTmat
  logical       :: ComputeDSCS, ComputeScatPar, ComputeAsymPar, sphere, axsym,      &
                   chiral, UseSimpson, ExtThetaDom, normalized
!     
  integer       :: Mstart, m, Nmax, Nmaxmax, ntg, mtg, ntl, mtl, itheta, iphi,      &
                   i, j, kelem  
  real(O)       :: alphapX, alphapY, QscatX, QscatY, QextX, QextY, thetaGSL,        &
                   phiGSL, thetaGS, phiGS, dtheta, Z(4,4), fact, Qscat, Qext, norm   
  complex(O)    :: FthetaX, FphiX, FthetaY, FphiY, S(2,2), epol1_beta, epol1_alpha
  complex(O),allocatable :: T(:,:), tvg(:), tv(:), cX(:), cY(:), c1X(:), c1Y(:),    &
                            ccX(:), ccY(:), cc(:)
!
  alphapX  = 0._O
  alphapY  = Pi / 2._O 
  Nmaxmax  = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (ccX(2*Nmaxmax), ccY(2*Nmaxmax)) 
  open (unit = iTmat, file = FileTmat, status = 'unknown')
  if (.not. axsym) then
    call read_HeadFileTmat (ntg, mtg)
    call check_dimensionMat (ntg, mtg, Nmaxmax)           
    allocate (T(2*ntg,2*mtg), cX(2*Nmaxmax), cY(2*Nmaxmax))    
    call read_FileTmat (ntg, mtg, T) 
    if (TypeExcit(1:5) == 'PLANE') then                   
      call PWcoefficients_ab (thetaGI, phiGI, alpha, beta, gamma, alphapX, Mrank,   &
           Nrank, Nmaxmax, cX)
      call PWcoefficients_ab (thetaGI, phiGI, alpha, beta, gamma, alphapY, Mrank,   &
           Nrank, Nmaxmax, cY)             	   	   	   	   
    else if (TypeExcit(1:5) == 'GAUSS') then                                             
      call GBcoefficients_ab (wavenumber, x0, y0, z0, w0, thetaGI, phiGI,           &
           alpha, beta, gamma, alphapX, Mrank, Nrank, Nmaxmax, cX) 
      call GBcoefficients_ab (wavenumber, x0, y0, z0, w0, thetaGI, phiGI,           &
           alpha, beta, gamma, alphapY, Mrank, Nrank, Nmaxmax, cY)                         
    end if                                                                              
    call product_matrix_vector (2*Nmaxmax, 2*Nmaxmax, T, 2*ntg, 2*mtg, cX, ccX)
    call product_matrix_vector (2*Nmaxmax, 2*Nmaxmax, T, 2*ntg, 2*mtg, cY, ccY)         
    deallocate (T, cX, cY)
  else 
    gamma = 0._O ! redundant
    if (.not. sphere) then      
      call read_HeadFileTmat (ntl, mtl)
      call check_dimensionMat (ntl, mtl, Nrank)             
      allocate (T(2*ntl, 2*mtl))
    else 
      call read_HeadFileTmatVct (ntl)
      call check_dimensionVct (ntl, Nrank)
      allocate (tvg(2*ntl), tv(2*ntl))
      call read_FileTmatVct (ntl, tvg)       
    end if
    allocate (cX(2*Nrank), cY(2*Nrank), c1X(2*Nrank), c1Y(2*Nrank))                                                          
    Mstart = 0
    do m = Mstart, Mrank
      if (m == 0) then
        Nmax = Nrank
      else
        Nmax = Nrank - m + 1
      end if
      if (.not. sphere) then        
        call read_FileTmat (ntl, mtl, T)
      else
        call form_Tvector (Nrank, Nmax, m, tvg, tv)
      end if
      if (TypeExcit(1:5) == 'PLANE') then             
        call PWcoefficients_ab_m (thetaGI, phiGI, alpha, beta, gamma, alphapX, m,   &
             Nrank, Nmax, cX)
        call PWcoefficients_ab_m (thetaGI, phiGI, alpha, beta, gamma, alphapY, m,   &
             Nrank, Nmax, cY)        	     	     	     	     
      else if (TypeExcit(1:5) == 'GAUSS') then   
        call GBcoefficients_ab_m (wavenumber, x0, y0, z0, w0, thetaGI, phiGI,       &
             alpha, beta, gamma, alphapX, m, Nmax, cX) 
        call GBcoefficients_ab_m (wavenumber, x0, y0, z0, w0, thetaGI, phiGI,       &
             alpha, beta, gamma, alphapY, m, Nmax, cY)                                                                                 
      end if                                       
      if (.not. sphere) then        
        call product_matrix_vector (2*Nmax, 2*Nmax, T, 2*ntl, 2*mtl, cX, c1X)
        call product_matrix_vector (2*Nmax, 2*Nmax, T, 2*ntl, 2*mtl, cY, c1Y)		  
      else 
        call product_vector_vector (2*Nmax, tv, cX, c1X)
        call product_vector_vector (2*Nmax, tv, cY, c1Y)		  
      end if                     
      call extend_vector_positive (c1X, ccX, m, Mstart, Nrank, Nmax, Nmaxmax)
      call extend_vector_positive (c1Y, ccY, m, Mstart, Nrank, Nmax, Nmaxmax)      
      if (m /= 0) then
        if (.not. sphere) then
          if (.not. chiral) then
            call matrix_m_negativ (Nmax, Nmax, T, ntl, mtl)
          else              
            call read_FileTmat (ntl, mtl, T)        
          end if    
        end if  
        if (TypeExcit(1:5) == 'PLANE') then      
          call PWcoefficients_ab_m (thetaGI, phiGI, alpha, beta, gamma, alphapX,    &
               - m, Nrank, Nmax, cX)
          call PWcoefficients_ab_m (thetaGI, phiGI, alpha, beta, gamma, alphapY,    &
               - m, Nrank, Nmax, cY)          	       	       	       	       	       	               
        else if (TypeExcit(1:5) == 'GAUSS') then         
          call GBcoefficients_ab_m (wavenumber, x0, y0, z0, w0, thetaGI, phiGI,     &
               alpha, beta, gamma, alphapX, - m, Nmax, cX) 
          call GBcoefficients_ab_m (wavenumber, x0, y0, z0, w0, thetaGI, phiGI,     &
               alpha, beta, gamma, alphapY, - m, Nmax, cY)
        end if 
        if (.not. sphere) then        
          call product_matrix_vector (2*Nmax, 2*Nmax, T, 2*ntl, 2*mtl, cX, c1X)
          call product_matrix_vector (2*Nmax, 2*Nmax, T, 2*ntl, 2*mtl, cY, c1Y)           	        
        else 
          call product_vector_vector (2*Nmax, tv, cX, c1X)
          call product_vector_vector (2*Nmax, tv, cY, c1Y)          	  
        end if                      
        call extend_vector_negative (c1X, ccX, m, Nrank, Nmax, Nmaxmax)
        call extend_vector_negative (c1Y, ccY, m, Nrank, Nmax, Nmaxmax)	
      end if 
    end do 
    if (.not. sphere) then
      deallocate (T)
    else 
      deallocate (tvg, tv)      
    end if                                   
    deallocate (cX, cY, c1X, c1Y)
  end if
  close (unit = iTmat)   
! --- DSCS and Cross Sections for plane waves and Gaussian beams ---
  Cscat = 0._O
  Cext  = 0._O
  do itheta = 1, NthetaGS
    h(itheta) = 0._O
    v(itheta) = 0._O
  end do
  if (ComputeDSCS) then        
    norm        =   sqrt ( abs(epol_beta)**2 + abs(epol_alpha)**2 )  
    epol1_beta  =   epol_beta  / norm
    epol1_alpha =   epol_alpha / norm  
    allocate (cc(2*Nmaxmax))
    if (TypeExcit(1:5) == 'PLANE') then                                                                        
      do i = 1, 2*Nmaxmax
        cc(i) = ccX(i) * epol1_beta + ccY(i) * epol1_alpha        
      end do    
    else if (TypeExcit(1:5) == 'GAUSS') then
      do i = 1, 2*Nmaxmax
        cc(i) = ccX(i) * cos(alphapGauss) + ccY(i) * sin(alphapGauss)        
      end do  
    end if             
    call DSCS (cc, Mrank, Nrank, Nmaxmax, NthetaGS, phiAZIMUT, alpha, beta, gamma,  &
         wavenumber, snorm, ExtThetaDom, normalized, h, v)
    call CQscat (cc, Mrank, Nrank, Nmaxmax, wavenumber, snorm, Cscat, Qscat)
    call CQextPolGen (cc, Mrank, Nrank, Nmaxmax, thetaGI, phiGI, alpha, beta,       &
         gamma, epol1_beta, epol1_alpha, alphapGauss, x0, y0, z0, w0, TypeExcit,    &
         wavenumber, snorm, Cext, Qext)            	      
    deallocate (cc)	 
  end if
! --- Scattering Characteristics for linearly polarized waves ---
  do i = 1, 4
    do j = 1, 4
      Ke(i,j) = 0._O
    end do
  end do
  do iphi = 1, NphiAL     
    do itheta = 1, NthetaAL               
      do kelem = 1, Nelem                           
        ZTP(iphi,itheta,kelem) = 0._O
      end do
    end do
  end do
  CextX  = 0._O
  CextY  = 0._O
  CscatX = 0._O
  CscatY = 0._O                    
  gX_x   = 0._O
  gX_y   = 0._O
  gX_z   = 0._O
  gY_x   = 0._O
  gY_y   = 0._O
  gY_z   = 0._O  
  if (ComputeScatPar) then 
!   --- extinction matrix --- 
    if (TypeExcit(1:5) == 'PLANE') then       
      thetaGSL = thetaGI
      phiGSL   = phiGI
      call F_azimuthal_tetaGS (ccX, Mrank, Nrank, Nmaxmax, thetaGSL, phiGSL, alpha, &
           beta, gamma, wavenumber, FthetaX, FphiX)
      call F_azimuthal_tetaGS (ccY, Mrank, Nrank, Nmaxmax, thetaGSL, phiGSL, alpha, &
           beta, gamma, wavenumber, FthetaY, FphiY)
      S(1,1) = FthetaX
      S(2,1) = FphiX
      S(1,2) = FthetaY
      S(2,2) = FphiY 
      call ExtinctionMatrix (wavenumber, S, Ke)        
    end if       
!   --- phase matrix ---
    do iphi = 1, Nphi
      phiGS = phi(iphi)
      if (Ntheta(iphi) /= 1) then
        dtheta = (thetamax(iphi) - thetamin(iphi)) / (Ntheta(iphi) - 1)
      else
        dtheta = 0._O
      end if        
      do itheta = 1, Ntheta(iphi)
        thetaGS = thetamin(iphi) + (itheta - 1) * dtheta      
        call F_azimuthal_tetaGS (ccX, Mrank, Nrank, Nmaxmax, thetaGS, phiGS,        &
             alpha, beta, gamma, wavenumber, FthetaX, FphiX)
        call F_azimuthal_tetaGS (ccY, Mrank, Nrank, Nmaxmax, thetaGS, phiGS,        &
             alpha, beta, gamma, wavenumber, FthetaY, FphiY)               
        S(1,1) = FthetaX
        S(2,1) = FphiX
        S(1,2) = FthetaY
        S(2,2) = FphiY     
        call PhaseMatrix (S, Z)   
        do kelem = 1, Nelem
          i = IndI(kelem)
          j = IndJ(kelem)       
          ZTP(iphi,itheta,kelem) = Z(i,j)
        end do
      end do
    end do                    
!   --- scattering and extinction cross sections for linearly polarized waves ---              
    call CQscat (ccX, Mrank, Nrank, Nmaxmax, wavenumber, snorm, CscatX, QscatX)
    call CQscat (ccY, Mrank, Nrank, Nmaxmax, wavenumber, snorm, CscatY, QscatY)  
    call CQextGen (ccX, Mrank, Nrank, Nmaxmax, thetaGI, phiGI, alpha, beta, gamma,  &
         alphapX, x0, y0, z0, w0, TypeExcit, wavenumber, snorm, CextX, QextX) 
    call CQextGen (ccY, Mrank, Nrank, Nmaxmax, thetaGI, phiGI, alpha, beta, gamma,  &
         alphapY, x0, y0, z0, w0, TypeExcit, wavenumber, snorm, CextY, QextY)     
!   --- mean direction of propagation of the scattered radiation ---    
    if (ComputeAsymPar) then        
      do itheta = 1, NthetaAsym
        if (.not. UseSimpson) then 
          thetaGS = xtheta(itheta)
        else
          thetaGS = acos(xtheta(itheta))
        end if
        do iphi = 1, NphiAsym
          phiGS = xphi(iphi)
          fact  = wtheta(itheta) * wphi(iphi)
          call F_azimuthal_tetaGS (ccX, Mrank, Nrank, Nmaxmax, thetaGS, phiGS,      &
               alpha, beta, gamma, wavenumber, FthetaX, FphiX) 
          call F_azimuthal_tetaGS (ccY, Mrank, Nrank, Nmaxmax, thetaGS, phiGS,      &
               alpha, beta, gamma, wavenumber, FthetaY, FphiY)
          gX_x = gX_x + (abs(FthetaX)**2 + abs(FphiX)**2) * sin(thetaGS) *          &
                         cos(phiGS) * fact 
          gX_y = gX_y + (abs(FthetaX)**2 + abs(FphiX)**2) * sin(thetaGS) *          &
                         sin(phiGS) * fact
          gX_z = gX_z + (abs(FthetaX)**2 + abs(FphiX)**2) * cos(thetaGS) * fact    
          gY_x = gY_x + (abs(FthetaY)**2 + abs(FphiY)**2) * sin(thetaGS) *          &
                         cos(phiGS) * fact 
          gY_y = gY_y + (abs(FthetaY)**2 + abs(FphiY)**2) * sin(thetaGS) *          &
                         sin(phiGS) * fact
          gY_z = gY_z + (abs(FthetaY)**2 + abs(FphiY)**2) * cos(thetaGS) * fact
        end do
      end do 
      gX_x = gX_x / CscatX
      gX_y = gX_y / CscatX
      gX_z = gX_z / CscatX
      gY_x = gY_x / CscatY
      gY_y = gY_y / CscatY
      gY_z = gY_z / CscatY                        	      
    end if
  end if
  deallocate (ccX, ccY)       
end subroutine DSCS_SCAT
! **********************************************************************************
subroutine DSCS (c, Mrank, Nrank, Nmax, Ntheta, phiAZIMUT, alpha, beta, gamma,      &
           wavenumber, snorm, ExtThetaDom, normalized, h, v)
!------------------------------------------------------------------------------------       
! Let                                                                               !
!           ES = [exp(jkR) / (kR)] * ESinf = [exp(jkR) / R] * FS,                   !
! be the scattered field in the direction (theta,phi), where FS is the far-field    !
! pattern, ESinf = k * FS and k is the wave number. If we consider the decomposition!
!           ESinf = ESinf_theta * e_theta + ESinf_phi * e_phi,                      !
! the routine computes the differential scattering cross sections for parallel and  !
! perpendicular polarizations                                                       !
!           h = |ESinf_theta|**2 / (k**2) = |FS_theta|**2  and                      !
!           v = |ESinf_phi|**2   / (k**2) = |FS_phi|**2,                            !
! and the normalized differential scattering cross sections for parallel and        !
! perpendicular polarizations                                                       !
!           hn = |ES_theta|**2 / [Pi * (k*a)**2] = |FS_theta|**2 / (Pi * a**2) and  !
!           vn = |ES_phi|**2   / [Pi * (k*a)**2] = |FS_phi|**2   / (Pi * a**2),     !
! where a is the characteristic dimension of the scatterer. Thus,                   !
!           hn = h / (Pi * a**2)   and  vn = v / (Pi * a**2).                       !
! Note that the normalization constant snorm is snorm = Pi * (k*a)**2. The          !
! quantities are computed at a set of Ntheta scattering angles in the azimuthal     !
! plane phiAZIMUT.                                                                  !                           
!------------------------------------------------------------------------------------
  use parameters
  implicit none
  integer      :: Mrank, Nrank, Nmax, Ntheta
  real(O)      :: phiAZIMUT, alpha, beta, gamma, wavenumber, snorm,                 &
                  h(Ntheta), v(Ntheta)
  complex(O)   :: c(2*Nmax)
  logical      :: ExtThetaDom, normalized
!
  integer      :: i, m, k, N0, l
  real(O)      :: fact, thetaGS, phiGS, thetaLS, phiLS, cosu, sinu
  complex(O)   :: sum(3)
  complex(O),allocatable :: Minf(:,:), Ninf(:,:)
!
  if (normalized) then
    fact = snorm
  else 
    fact = wavenumber * wavenumber
  end if           
  allocate (Minf(3,Nmax), Ninf(3,Nmax))
  do i = 1, Ntheta
    if (ExtThetaDom) then      
      thetaGS = real(i - 1,O) * 2._O * Pi / real(Ntheta - 1,O)
      phiGS   = phiAZIMUT
      if (thetaGS > Pi) then
        thetaGS = 2._O * Pi - thetaGS
        phiGS   = phiAZIMUT + Pi
      end if
    else 
      thetaGS = real(i - 1,O) * Pi / real(Ntheta - 1,O)
      phiGS   = phiAZIMUT    
    end if  
    call T_spherical_global_local (thetaGS, phiGS, alpha, beta, gamma, thetaLS, phiLS)         
    call MN_infinit_complete (thetaLS, phiLS, Mrank, Nrank, Nmax, .true., Minf, Ninf)
    sum(1) = zero
    sum(2) = zero
    sum(3) = zero
    do m = 0, Mrank
      if (m == 0) then
        do k = 1, Nrank
          sum(1) = sum(1) + (Minf(1,k) * c(k) + Ninf(1,k) * c(Nmax+k))
          sum(2) = sum(2) + (Minf(2,k) * c(k) + Ninf(2,k) * c(Nmax+k))
          sum(3) = sum(3) + (Minf(3,k) * c(k) + Ninf(3,k) * c(Nmax+k))
        end do
      else                    
        N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
        do l = 1, 2
          do k = 1, Nrank - m + 1
            sum(1) = sum(1) + (Minf(1,N0+k) * c(N0+k) + Ninf(1,N0+k) * c(Nmax+N0+k))
            sum(2) = sum(2) + (Minf(2,N0+k) * c(N0+k) + Ninf(2,N0+k) * c(Nmax+N0+k))
            sum(3) = sum(3) + (Minf(3,N0+k) * c(N0+k) + Ninf(3,N0+k) * c(Nmax+N0+k))
          end do
          N0 = N0 + Nrank - m + 1
        end do                        
      end if
    end do
    call angle_unitvct_ItL_ItG (thetaGS, phiGS, thetaLS, phiLS, alpha, beta, gamma, &
         cosu, sinu)        
    h(i) = (abs(cosu * sum(2) - sinu * sum(3)))**2 / fact
    v(i) = (abs(sinu * sum(2) + cosu * sum(3)))**2 / fact
  end do
  deallocate (Minf, Ninf)      
end subroutine DSCS
! **********************************************************************************
subroutine F_azimuthal (c, Mrank, Nrank, Nmax, Ntheta, phiAZIMUT, alpha, beta,      &
           gamma, wavenumber, ExtThetaDom, Ftheta, Fphi)
!------------------------------------------------------------------------------------ 
! Let                                                                               !
!           ES = [exp(jkR) / (kR)] * ESinf = [exp(jkR) / R] * FS,                   !
! be the scattered field in the direction (theta,phi), where FS is the far-field    !
! pattern, ESinf = k * FS and k is the wave number. If we consider the decomposition!
!           ESinf = ESinf_theta * e_theta + ESinf_phi * e_phi,                      !
! the routine computes                                                              ! 
!           FS_theta = ESinf_theta / k, and                                         !
!           FS_phi   = ESinf_phi   / k                                              !
! at Ntheta scattering angles in the azimuthal plane phiAZIMUT.                     !
!------------------------------------------------------------------------------------                  
  use parameters
  implicit none
  integer      :: Mrank, Nrank, Nmax, Ntheta
  real(O)      :: phiAZIMUT, alpha, beta, gamma, wavenumber             
  complex(O)   :: c(2*Nmax), Ftheta(Ntheta), Fphi(Ntheta)
  logical      :: ExtThetaDom
!
  integer      :: i, m, k, N0, l
  real(O)      :: thetaGS, phiGS, thetaLS, phiLS, cosu, sinu
  complex(O)   :: sum(3)
  complex(O),allocatable :: Minf(:,:), Ninf(:,:)
!
  allocate (Minf(3,Nmax), Ninf(3,Nmax))
  do i = 1, Ntheta
    if (ExtThetaDom) then         
      thetaGS = real(i - 1,O) * 2._O * Pi / real(Ntheta - 1,O)
      phiGS  = phiAZIMUT
      if (thetaGS > Pi) then
        thetaGS = 2._O * Pi - thetaGS
        phiGS  = phiAZIMUT + Pi
      end if
    else 
      thetaGS = real(i - 1,O) * Pi / real(Ntheta - 1,O)
      phiGS  = phiAZIMUT    
    end if  
    call T_spherical_global_local (thetaGS, phiGS, alpha, beta, gamma, thetaLS, phiLS)            
    call MN_infinit_complete (thetaLS, phiLS, Mrank, Nrank, Nmax, .true., Minf, Ninf)
    sum(1) = zero
    sum(2) = zero
    sum(3) = zero
    do m = 0, Mrank
      if (m == 0) then
        do k = 1, Nrank
          sum(1) = sum(1) + (Minf(1,k) * c(k) + Ninf(1,k) * c(Nmax+k))
          sum(2) = sum(2) + (Minf(2,k) * c(k) + Ninf(2,k) * c(Nmax+k))
          sum(3) = sum(3) + (Minf(3,k) * c(k) + Ninf(3,k) * c(Nmax+k))
        end do
      else                    
        N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
        do l = 1, 2
          do k = 1, Nrank - m + 1
            sum(1) = sum(1) + (Minf(1,N0+k) * c(N0+k) + Ninf(1,N0+k) * c(Nmax+N0+k))
            sum(2) = sum(2) + (Minf(2,N0+k) * c(N0+k) + Ninf(2,N0+k) * c(Nmax+N0+k))
            sum(3) = sum(3) + (Minf(3,N0+k) * c(N0+k) + Ninf(3,N0+k) * c(Nmax+N0+k))
          end do
          N0 = N0 + Nrank - m + 1
        end do                    
      end if
    end do
    call angle_unitvct_ItL_ItG (thetaGS, phiGS, thetaLS, phiLS, alpha, beta, gamma, &
         cosu, sinu)
    Ftheta(i) = (cosu * sum(2) - sinu * sum(3)) / wavenumber
    Fphi(i)  = (sinu * sum(2) + cosu * sum(3)) / wavenumber                              
  end do
  deallocate (Minf, Ninf)      
end subroutine F_azimuthal      
! **********************************************************************************
subroutine F_azimuthal_tetaGS (c, Mrank, Nrank, Nmax, thetaGS, phiGS, alpha, beta,  &
           gamma, wavenumber, Ftheta, Fphi)
!------------------------------------------------------------------------------------
! Let                                                                               !
!           ES = [exp(jkR) / (kR)] * ESinf = [exp(jkR) / R] * FS,                   !
! be the scattered field in the direction (theta,phi), where FS is the far-field    !
! pattern, ESinf = k * FS and k is the wave number. If we consider the decomposition!
!           ESinf = ESinf_theta * e_theta + ESinf_phi * e_phi,                      !
! the routine computes                                                              !  
!           FS_theta = ESinf_theta / k, and                                         !
!           FS_phi   = ESinf_phi   / k                                              !
! at the scattering direction (thetaGS, phiGS).                                     !     
!------------------------------------------------------------------------------------  
  use parameters
  implicit none
  integer      :: Mrank, Nrank, Nmax
  real(O)      :: thetaGS, phiGS, alpha, beta, gamma, wavenumber
  complex(O)   :: c(2*Nmax), Ftheta, Fphi
!
  integer      :: m, k, N0, l
  real(O)      :: thetaLS, phiLS, cosu, sinu
  complex(O)   :: sum(3)
  complex(O),allocatable :: Minf(:,:), Ninf(:,:)
!
  allocate (Minf(3,Nmax), Ninf(3,Nmax))            
  call T_spherical_global_local (thetaGS, phiGS, alpha, beta, gamma, thetaLS, phiLS)            
  call MN_infinit_complete (thetaLS, phiLS, Mrank, Nrank, Nmax, .true., Minf, Ninf)           
  sum(1) = zero
  sum(2) = zero
  sum(3) = zero
  do m = 0, Mrank
    if (m == 0) then
      do k = 1, Nrank
        sum(1) = sum(1) + (Minf(1,k) * c(k) + Ninf(1,k) * c(Nmax+k))
        sum(2) = sum(2) + (Minf(2,k) * c(k) + Ninf(2,k) * c(Nmax+k))
        sum(3) = sum(3) + (Minf(3,k) * c(k) + Ninf(3,k) * c(Nmax+k))
      end do
    else        
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      do l = 1, 2
        do k = 1, Nrank - m + 1
          sum(1) = sum(1) + (Minf(1,N0+k) * c(N0+k) + Ninf(1,N0+k) * c(Nmax+N0+k))
          sum(2) = sum(2) + (Minf(2,N0+k) * c(N0+k) + Ninf(2,N0+k) * c(Nmax+N0+k))
          sum(3) = sum(3) + (Minf(3,N0+k) * c(N0+k) + Ninf(3,N0+k) * c(Nmax+N0+k))
        end do
        N0 = N0 + Nrank - m + 1
      end do               
    end if
  end do
  call angle_unitvct_ItL_ItG (thetaGS, phiGS, thetaLS, phiLS, alpha, beta, gamma,   &
       cosu, sinu)   
  Ftheta = (cosu * sum(2) - sinu * sum(3)) / wavenumber
  Fphi  = (sinu * sum(2) + cosu * sum(3)) / wavenumber            
  deallocate (Minf, Ninf)      
end subroutine F_azimuthal_tetaGS       
! **********************************************************************************
subroutine CQscat (c, Mrank, Nrank, Nmax, wavenumber, snorm, Cscat, Qscat)
!------------------------------------------------------------------------------------
! The routine computes the scattering cross section                                 !
!        C_scat = (Pi / k**2) * SUM { |Fmn|**2 + |Gmn|**2 }                         !
! end the scattering efficiency                                                     !
!        Q_scat = C_scat / (Pi * a**2)                                              !
!               = [1 / (ka)**2] * SUM { |Fmn|**2 + |Gmn|**2 }                       ! 
!               = [Pi / Pi * (ka)**2] * SUM { |Fmn|**2 + |Gmn|**2 }                 !
! where Fmn and Gmn are the expansion coefficients of the scattered field, k is the !
! wave number and a is the characteristic dimension of the particle. Note that the  !
! normalization constant snorm is snorm = Pi * (k*a)**2 and that the scattered      !
! field coefficients (which are stored in the vector c) depend on the direction and !
! polarization of the incident wave.                                                ! 
!------------------------------------------------------------------------------------                 
  use parameters
  implicit none        
  integer    :: Mrank, Nrank, Nmax
  real(O)    :: wavenumber, snorm, Cscat, Qscat
  complex(O) :: c(2*Nmax)
!
  integer    :: k, m, N0, l
  real(O)    :: sum, fct, wavenumber2
!
  sum = 0._O
  do m = 0, Mrank
    if (m == 0) then
      do k = 1, Nrank
        sum = sum + abs(c(k))**2 + abs(c(k+Nmax))**2              
      end do
    else        
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      do l = 1, 2
        do k = 1, Nrank - m + 1
          sum = sum + abs(c(k+N0))**2 + abs(c(k+N0+Nmax))**2               
        end do
        N0 = N0 + Nrank - m + 1
      end do         
    end if
  end do
  fct = sum * Pi
  wavenumber2 = wavenumber * wavenumber
  Cscat = fct / wavenumber2
  Qscat = fct / snorm      
end subroutine CQscat
! **********************************************************************************
subroutine CQext (c, Mrank, Nrank, Nmax, thetaGI, phiGI, alpha, beta, gamma,        &  
           alphap, wavenumber, snorm, Cext, Qext)
!------------------------------------------------------------------------------------ 
! The routine computes the extinction cross section (according to optical theorem)  !
!        C_ext = (4 * Pi / k**2) * IM{ ES * e0 }                                    !
! and the extinction efficiency                                                     ! 
!        Q_ext = C_ext / (Pi * a**2)                                                !
!              = [4 / (ka)**2] * IM{ ES * e0 }                                      !                                
!              = [4Pi / Pi * (ka)**2] * IM{ ES * e0 }                               !
! where ES is the scattered field in the direction (thetaGI,phiGI), e0 is the unit  !
! vector along the incident polarization direction, i.e.,                           !
!        e0 = cos(alphap) * e_theta0 + sin(alphap) * e_phi0,                        !
! alphap, is the polarization angle, k is the wave number and a is the              !
! characteristic length of the particle. The incident wave is a linearly polarized  !
! plane wave traveling in the direction (thetaGI,phiGI). Note that the normalization! 
! constant snorm is snorm = Pi * (k * a)**2 and that the scattered field            !
! coefficients depend on the direction and polarization of the incident wave.       !
! The incident wave is a linearly polarized vector plane wave.                      !
!------------------------------------------------------------------------------------
  use parameters
  implicit none
  integer     :: Mrank, Nrank, Nmax
  real(O)     :: thetaGI, phiGI, alpha, beta, gamma, alphap, wavenumber, snorm,     &
                 Cext, Qext
  complex(O)  :: c(2*Nmax)
!
  integer     :: m, k, N0, l
  real(O)     :: thetaGS, phiGS, thetaLS, phiLS, cosu, sinu, Img, wavenumber2
  complex(O)  :: sum(3)
  complex(O),allocatable :: Minf(:,:), Ninf(:,:)
!
  allocate (Minf(3,Nmax), Ninf(3,Nmax))
  thetaGS = thetaGI
  phiGS  = phiGI
  call T_spherical_global_local (thetaGS, phiGS, alpha, beta, gamma, thetaLS, phiLS)          
  call MN_infinit_complete (thetaLS, phiLS, Mrank, Nrank, Nmax, .true., Minf, Ninf)            
  sum(1) = zero
  sum(2) = zero
  sum(3) = zero
  do m = 0, Mrank
    if (m == 0) then
      do k = 1, Nrank
        sum(1) = sum(1) + (Minf(1,k) * c(k) + Ninf(1,k) * c(Nmax+k))
        sum(2) = sum(2) + (Minf(2,k) * c(k) + Ninf(2,k) * c(Nmax+k))
        sum(3) = sum(3) + (Minf(3,k) * c(k) + Ninf(3,k) * c(Nmax+k))
      end do
    else        
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      do l = 1, 2
        do k = 1, Nrank - m + 1
          sum(1) = sum(1) + (Minf(1,N0+k) * c(N0+k) + Ninf(1,N0+k) * c(Nmax+N0+k))
          sum(2) = sum(2) + (Minf(2,N0+k) * c(N0+k) + Ninf(2,N0+k) * c(Nmax+N0+k))
          sum(3) = sum(3) + (Minf(3,N0+k) * c(N0+k) + Ninf(3,N0+k) * c(Nmax+N0+k))
        end do
        N0 = N0 + Nrank - m + 1
      end do          
    end if
  end do
  call angle_unitvct_ItL_ItG (thetaGS, phiGS, thetaLS, phiLS, alpha, beta, gamma,   &
       cosu, sinu)      
  Img  = aimag((cosu * sum(2) - sinu * sum(3)) * cos(alphap)) 
  Img  = Img + aimag((sinu * sum(2) + cosu * sum(3)) * sin(alphap))      
  Img  = 4._O * Img * Pi
  wavenumber2 = wavenumber * wavenumber
  Cext = Img / wavenumber2
  Qext = Img / snorm
  deallocate (Minf, Ninf)      
end subroutine CQext
! **********************************************************************************
subroutine CQextGen (c, Mrank, Nrank, Nmax, thetaGI, phiGI, alpha, beta, gamma,     &
           alphap, x0, y0, z0, w0, TypeExcit, wavenumber, snorm, Cext, Qext)
!------------------------------------------------------------------------------------ 
! The routine computes the extinction cross section                                 !
!       C_ext = - Pi * SUM { RE{ Amn * conjg(Fmn) + conjg(Bmn) * Gmn } } / k**2     !
! and the extinction efficiency                                                     !
!       Q_ext = C_ext / (Pi * a**2)                                                 !
! where Fmn and Gmn are the expansion coefficients of the scattered field, Amn and  !
! Bmn are the expansion coefficients of the incident wave, k is the wave number and !
! a is the characteristic length of the particle. Note that the normalization       !
! constant snorm is snorm = Pi*(k*a)**2. The incident wave is a linearly polarized  !
! vector plane wave.                                                                !
!------------------------------------------------------------------------------------
  use parameters
  implicit none
  integer      :: Mrank, Nrank, Nmax
  real(O)      :: thetaGI, phiGI, alpha, beta, gamma, alphap, x0, y0, z0, w0,       &
                  wavenumber, snorm, Cext, Qext 
  character(5) :: TypeExcit                  
  complex(O)   :: c(2*Nmax)
!
  integer      :: m, k, N0, l
  real(O)      :: fct, wavenumber2
  complex(O)   :: sum
  complex(O),allocatable :: cc(:)
!
  allocate (cc(2*Nmax))
  if (TypeExcit(1:5) == 'PLANE') then
    call PWcoefficients_ab (thetaGI, phiGI, alpha, beta, gamma, alphap, Mrank,      &
         Nrank, Nmax, cc)
  else if (TypeExcit(1:5) == 'GAUSS') then
    call GBcoefficients_ab (wavenumber, x0, y0, z0, w0, thetaGI, phiGI, alpha,      &
         beta, gamma, alphap, Mrank, Nrank, Nmax, cc)        
  end if
  sum = zero
  do m = 0, Mrank
    if (m == 0) then
      do k = 1, Nrank       
        sum = sum + cc(k) * conjg(c(k)) + cc(Nmax+k) * conjg(c(Nmax+k))        
      end do
    else        
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      do l = 1, 2
        do k = 1, Nrank - m + 1          
          sum = sum + cc(N0+k) * conjg(c(N0+k)) +                                   &
                      cc(Nmax+N0+k) * conjg(c(Nmax+N0+k))
        end do
        N0 = N0 + Nrank - m + 1
      end do      
    end if
  end do
  fct  = - Pi * real(sum,O)
  wavenumber2 = wavenumber * wavenumber
  Cext =   fct / wavenumber2
  Qext =   fct / snorm  
  deallocate (cc)      
end subroutine CQextGen
! **********************************************************************************
subroutine CQextPolGen (c, Mrank, Nrank, Nmax, thetaGI, phiGI, alpha, beta, gamma,  &
           epol_beta, epol_alpha, alphapGauss, x0, y0, z0, w0, TypeExcit,           &
           wavenumber, snorm, Cext, Qext)
!------------------------------------------------------------------------------------ 
! The routine computes the extinction cross section                                 !
!       C_ext = - Pi * SUM { RE{ Amn * conjg(Fmn) + conjg(Bmn) * Gmn } } / k**2     !
! and the extinction efficiency                                                     !
!       Q_ext = C_ext / (Pi * a**2)                                                 !
! where Fmn and Gmn are the expansion coefficients of the scattered field, and Amn  !
! and Bmn are the expansion coefficients of the incident wave. The incident wave is !
! an elliptically polarized vector plane wave or a linearly polarized Gaussian beam.! 
!------------------------------------------------------------------------------------
  use parameters
  implicit none
  integer      :: Mrank, Nrank, Nmax
  real(O)      :: thetaGI, phiGI, alpha, beta, gamma, alphapGauss, x0, y0, z0, w0,  &
                  wavenumber, snorm, Cext, Qext 
  character(5) :: TypeExcit                  
  complex(O)   :: epol_beta, epol_alpha, c(2*Nmax)
!
  integer      :: m, k, N0, l
  real(O)      :: fct, wavenumber2
  complex(O)   :: sum
  complex(O),allocatable :: cc(:)
!
  allocate (cc(2*Nmax))
  if (TypeExcit(1:5) == 'PLANE') then    
    call PWcoefficients_Polab (thetaGI, phiGI, alpha, beta, gamma, epol_beta,       &
         epol_alpha, Mrank, Nrank, Nmax, cc) 	 
  else if (TypeExcit(1:5) == 'GAUSS') then
    call GBcoefficients_ab (wavenumber, x0, y0, z0, w0, thetaGI, phiGI, alpha,      &
         beta, gamma, alphapGauss, Mrank, Nrank, Nmax, cc)        
  end if
  sum = zero
  do m = 0, Mrank
    if (m == 0) then
      do k = 1, Nrank       
        sum = sum + cc(k) * conjg(c(k)) + cc(Nmax+k) * conjg(c(Nmax+k))        
      end do
    else        
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      do l = 1, 2
        do k = 1, Nrank - m + 1          
          sum = sum + cc(N0+k) * conjg(c(N0+k)) +                                   &
                      cc(Nmax+N0+k) * conjg(c(Nmax+N0+k))
        end do
        N0 = N0 + Nrank - m + 1
      end do      
    end if
  end do
  fct  = - Pi * real(sum,O)
  wavenumber2 = wavenumber * wavenumber
  Cext =   fct / wavenumber2
  Qext =   fct / snorm  
  deallocate (cc)      
end subroutine CQextPolGen
! **********************************************************************************
subroutine CQextPolPlane (c, Mrank, Nrank, Nmax, thetaGI, phiGI, alpha, beta,       & 
           gamma, epol_beta, epol_alpha, wavenumber, snorm, Cext, Qext)
!------------------------------------------------------------------------------------ 
! The routine computes the extinction cross section                                 !
!       C_ext = - Pi * SUM { RE{ Amn * conjg(Fmn) + conjg(Bmn) * Gmn } } / k**2     !
! and the extinction efficiency                                                     !
!       Q_ext = C_ext / (Pi * a**2)                                                 !
! where Fmn and Gmn are the expansion coefficients of the scattered field, and Amn  !
! and Bmn are the expansion coefficients of the incident wave. The incident wave    !
! is an elliptically polarized vector plane wave.                                   ! 
!------------------------------------------------------------------------------------
  use parameters
  implicit none
  integer      :: Mrank, Nrank, Nmax
  real(O)      :: thetaGI, phiGI, alpha, beta, gamma, wavenumber, snorm, Cext, Qext                
  complex(O)   :: epol_beta, epol_alpha, c(2*Nmax)  
!
  integer      :: m, k, N0, l
  real(O)      :: fct, wavenumber2
  complex(O)   :: sum
  complex(O),allocatable :: cc(:)
! 
  allocate (cc(2*Nmax))     
  call PWcoefficients_Polab (thetaGI, phiGI, alpha, beta, gamma, epol_beta,         &
       epol_alpha, Mrank, Nrank, Nmax, cc) 	   
  sum = zero
  do m = 0, Mrank
    if (m == 0) then
      do k = 1, Nrank       
        sum = sum + cc(k) * conjg(c(k)) + cc(Nmax+k) * conjg(c(Nmax+k))        
      end do
    else        
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      do l = 1, 2
        do k = 1, Nrank - m + 1          
          sum = sum + cc(N0+k) * conjg(c(N0+k)) +                                   &
                      cc(Nmax+N0+k) * conjg(c(Nmax+N0+k))
        end do
        N0 = N0 + Nrank - m + 1
      end do      
    end if
  end do
  fct  = - Pi * real(sum,O)
  wavenumber2 = wavenumber * wavenumber
  Cext =   fct / wavenumber2
  Qext =   fct / snorm  
  deallocate (cc)      
end subroutine CQextPolPlane
! **********************************************************************************
subroutine PhaseMatrix (S, Z)
!-----------------------------------------------------------------------------------      
! The routine computes the phase matrix Z, where S is the amplitude matrix.        !
!-----------------------------------------------------------------------------------      
  use parameters
  implicit none  
  real(O)     :: Z(4,4)
  complex(O)  :: S(2,2)
!
  Z(1,1) =   0.5_O * (abs(S(1,1))**2 + abs(S(1,2))**2 +                             &
             abs(S(2,1))**2 + abs(S(2,2))**2)     
  Z(1,2) =   0.5_O * (abs(S(1,1))**2 - abs(S(1,2))**2 +                             &
             abs(S(2,1))**2 - abs(S(2,2))**2)
  Z(1,3) = - real (S(1,1) * conjg(S(1,2)) + S(2,2) * conjg(S(2,1)),O)
  Z(1,4) = - aimag(S(1,1) * conjg(S(1,2)) - S(2,2) * conjg(S(2,1)))      
  Z(2,1) =   0.5_O * (abs(S(1,1))**2 + abs(S(1,2))**2 -                             &
             abs(S(2,1))**2 - abs(S(2,2))**2)
  Z(2,2) =   0.5_O * (abs(S(1,1))**2 - abs(S(1,2))**2 -                             &
             abs(S(2,1))**2 + abs(S(2,2))**2)
  Z(2,3) = - real (S(1,1) * conjg(S(1,2)) - S(2,2) * conjg(S(2,1)),O)
  Z(2,4) = - aimag(S(1,1) * conjg(S(1,2)) + S(2,2) * conjg(S(2,1)))      
  Z(3,1) = - real (S(1,1) * conjg(S(2,1)) + S(2,2) * conjg(S(1,2)),O)
  Z(3,2) = - real (S(1,1) * conjg(S(2,1)) - S(2,2) * conjg(S(1,2)),O)
  Z(3,3) =   real (S(1,1) * conjg(S(2,2)) + S(1,2) * conjg(S(2,1)),O)
  Z(3,4) =   aimag(S(1,1) * conjg(S(2,2)) + S(2,1) * conjg(S(1,2)))      
  Z(4,1) = - aimag(S(2,1) * conjg(S(1,1)) + S(2,2) * conjg(S(1,2)))
  Z(4,2) = - aimag(S(2,1) * conjg(S(1,1)) - S(2,2) * conjg(S(1,2)))
  Z(4,3) =   aimag(S(2,2) * conjg(S(1,1)) - S(1,2) * conjg(S(2,1)))
  Z(4,4) =   real (S(2,2) * conjg(S(1,1)) - S(1,2) * conjg(S(2,1)),O)      
end subroutine PhaseMatrix
! **********************************************************************************
subroutine ExtinctionMatrix (wavenumber, S, K)
!-----------------------------------------------------------------------------------
! The routine computes the extinction matrix K, where S is the amplitude matrix.   !     
!-----------------------------------------------------------------------------------
  use parameters
  implicit none                      
  real(O)     :: wavenumber
  complex(O)  :: S(2,2)
  real(O)     :: K(4,4), fct      
!
  fct = 2._O * Pi / wavenumber
  K(1,1) =   aimag(S(1,1) + S(2,2))  * fct
  K(1,2) =   aimag(S(1,1) - S(2,2))  * fct
  K(1,3) = - aimag(S(1,2) + S(2,1))  * fct
  K(1,4) =   real(S(2,1) - S(1,2),O) * fct      
  K(2,1) =   K(1,2)
  K(2,2) =   K(1,1)
  K(2,3) =   aimag(S(2,1) - S(1,2))   * fct
  K(2,4) =   real (S(1,2) + S(2,1),O) * fct      
  K(3,1) =   K(1,3)
  K(3,2) = - K(2,3)
  K(3,3) =   K(1,1)
  K(3,4) =   real(S(2,2) - S(1,1),O) * fct      
  K(4,1) =   K(1,4)
  K(4,2) = - K(2,4)
  K(4,3) = - K(3,4)
  K(4,4) =   K(1,1)      
end subroutine ExtinctionMatrix                   
! **********************************************************************************
subroutine extend_vector_positive (c, cc, m, Mstart, Nrank, Nmax, Nmaxmax)
  use parameters
  implicit none
  integer    :: m, Nrank, Nmax, Nmaxmax, Mstart, N0, k
  complex(O) :: c(2*Nmax), cc(2*Nmaxmax)      
!
  if (m == Mstart) then
    do k = 1, 2*Nmaxmax
      cc(k) = zero
    end do
  end if               
  if (m == 0) then
    do k = 1, Nrank
      cc(k) = c(k)
      cc(k+Nmaxmax) = c(k+Nmax)
    end do
  else      
    N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
    do k = 1, Nrank - m + 1
      cc(k+N0) = c(k)
      cc(k+N0+Nmaxmax) = c(k+Nmax)
    end do
  end if      
end subroutine extend_vector_positive
! **********************************************************************************
subroutine extend_vector_negative (c, cc, m, Nrank, Nmax, Nmaxmax)
  use parameters
  implicit none
  integer    :: m, Nrank, Nmax, Nmaxmax, N0, k
  complex(O) :: c(2*Nmax), cc(2*Nmaxmax)      
!
  N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
  N0 = N0 + Nrank - m + 1  
  do k = 1, Nrank - m + 1
    cc(k+N0) = c(k)
    cc(k+N0+Nmaxmax) = c(k+Nmax)
  end do      
end subroutine extend_vector_negative
! **********************************************************************************
subroutine delta_DSCS (Ntheta, h, v, oldh, oldv, eps, nconv)
  use parameters
  use derived_parameters
  implicit none
  integer  :: Ntheta, i, nconv, pconv, sconv
  real(O)  :: h(Ntheta), v(Ntheta), oldh(Ntheta), oldv(Ntheta), eps, delta, deltaM
  logical  :: smallh, smallv 
!
  pconv  = 0
  sconv  = 0
  smallh = .false.
  smallv = .false.
  do i = 1, Ntheta
    delta  = abs(h(i) - oldh(i))
    deltaM = eps * h(i)    
    if (h(i) >= MachEps) then
      if (delta < deltaM) pconv = pconv + 1
    else
      pconv  = pconv + 1     
      smallh = .true.
    end if
    delta  = abs(v(i) - oldv(i))
    deltaM = eps * v(i)    
    if (v(i) >= MachEps) then
      if (delta < deltaM) sconv = sconv + 1
    else
      sconv  = sconv + 1     
      smallv = .true.
    end if
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do
  nconv = min(pconv, sconv)  
  if (smallh) then
    print "(/,2x,'Warning: at least one value of the parallel component ')"     
    print "(  2x,'of the DSCS is smaller than the machine precision;')"  
    if (pconv == Ntheta) nconv = 0
  end if
  if (smallv) then
    print "(/,2x,'Warning: at least one value of the perpendicular component ')"        
    print "(  2x,'of the DSCS is smaller than the machine precision;')"  
    if (sconv == Ntheta) nconv = 0
  end if                      
end subroutine delta_DSCS 
! **********************************************************************************
subroutine NodesAlphaBetaGamma (alphamin, alphamax, Nalpha, betamin, betamax, Nbeta,&
           gammamin, gammamax, Ngamma, UseSimpson, xalpha, walpha, xbeta, wbeta,    &
           xgamma, wgamma)
  use parameters
  implicit none
  integer  :: Nalpha, Nbeta, Ngamma
  real(O)  :: alphamin, alphamax, betamin, betamax, gammamin, gammamax,             &
              xalpha(Nalpha), walpha(Nalpha), xbeta(Nbeta), wbeta(Nbeta),           &
                          xgamma(Ngamma), wgamma(Ngamma)
  logical  :: UseSimpson
!
  integer  :: ialpha, ibeta, igamma
  real(O)  :: norm, aalpha, balpha, abeta, bbeta, beta, agamma, bgamma
!  
  if (Nalpha == 1) then
    xalpha(1) = 0.5_O * (alphamax + alphamin)
    walpha(1) = 1._O
  else     
    aalpha = alphamin
    balpha = alphamax
    call Simpson (aalpha, balpha, Nalpha, xalpha, walpha) 
    norm = alphamax - alphamin
    norm = 1._O / norm     
    do ialpha = 1, Nalpha
      walpha(ialpha) = walpha(ialpha) * norm
    end do       
  end if  
  if (Nbeta == 1) then
    beta = 0.5_O * (betamax + betamin)
    if (.not. UseSimpson) then
      xbeta(1) = beta
    else
      xbeta(1) = cos(beta)
    end if
    wbeta(1) = 1._O
  else  
    if (.not. UseSimpson) then
      abeta = betamin
      bbeta = betamax   
      call Gauss_Legendre (abeta, bbeta, Nbeta, wbeta, xbeta)   
    else
      abeta = cos(betamax)
      bbeta = cos(betamin)
      call Simpson (abeta, bbeta, Nbeta, xbeta, wbeta)     
    end if
    norm = cos(betamin) - cos(betamax)
    norm = 1._O / norm     
    do ibeta = 1, Nbeta    
      if (.not. UseSimpson) then 
        beta = xbeta(ibeta)
        wbeta(ibeta) = wbeta(ibeta) * norm * sin(beta)
      else
        wbeta(ibeta) = wbeta(ibeta) * norm
      end if
    end do           
  end if    
  if (Ngamma == 1) then
    xgamma(1) = 0.5_O * (gammamax + gammamin)
    wgamma(1) = 1._O
  else      
    agamma = gammamin
    bgamma = gammamax           
    call Simpson (agamma, bgamma, Ngamma, xgamma, wgamma)
    norm = gammamax - gammamin
    norm = 1._O / norm    
    do igamma = 1, Ngamma 
      wgamma(igamma) = wgamma(igamma) * norm
    end do
  end if          
end subroutine NodesAlphaBetaGamma
! **********************************************************************************
subroutine IndexElements (Nelem, MatrixElem, IndI, IndJ, NameElem)  
  implicit none
  integer      :: Nelem, MatrixElem(16), IndI(Nelem), IndJ(Nelem), i, j, ij, k
  character(2) :: AllNameElem(16), NameElem(Nelem)
  logical      :: more 
!
  AllNameElem  = (/'11', '12', '13', '14', '21', '22', '23', '24',                  &
                   '31', '32', '33', '34', '41', '42', '43', '44'/)
  do i = 1, 4
    do j = 1, 4
      ij = 10 * i + j
      k  = 0
      more = .true.
      do while (more .and. k < Nelem)
        k = k + 1
        if (ij == MatrixElem(k)) then           
          IndI(k) = i
          IndJ(k) = j
          more    = .false.
        end if
      end do      
    end do
  end do                      
  do k = 1, Nelem
    i  = IndI(k)
    j  = IndJ(k)
    ij = j + 4 * (i - 1)
    NameElem(k) = AllNameElem(ij)  
  end do           
end subroutine IndexElements 
! **********************************************************************************
! *          SCATTERING CHARACTERISTICS: PARTICLE ON OR NEAR A SUBSTRATE           *
! **********************************************************************************
subroutine DiffScatCrossSectPARTSUB (TypeScat, k, ind_ref_s, z0, snorm, Nrank,      &
           Mrank, FileTmat)     
!------------------------------------------------------------------------------------
! Let                                                                               !
!            ES = [exp(jkR) / kR] * ESinf = [exp(jkR) / R] * FS                     !
! be the scattered field in the direction (theta,phi), where FS is the far-field    !
! pattern and ESinf = k * FS. If we consider the decomposition                      !
!            ESinf = ESinf_theta * e_theta + ESinf_phi * e_phi,                     !
! where e_theta and e_phi are the spherical unit vectors, the routine computes the  !
! differential scattering cross sections for parallel and perpendicular             !
! polarizations:                                                                    !
!            h = |ESinf_theta|**2 / k**2 = |FS_theta|**2                            !
! and                                                                               !
!            v = |ESinf_phi|**2 / k**2   = |FS_phi|**2,                             !
! respectively, or the normalized differential scattering cross sections for        !
! parallel and perpendicular polarizations:                                         ! 
!     hn = |ESinf_theta|**2 / [Pi * (k*anorm)**2] = |FS_theta|**2 / [Pi * anorm**2] !
! and                                                                               !
!     vn = |ESinf_phi|**2 / [Pi * (k*anorm)**2]   = |FS_phi|**2 / [Pi * anorm**2],  !
! respectively. The subroutine also computes the electromagnetic fields ESinf_theta !
! and ES_inf_phi.                                                                   !
!                                                                                   !
! Input parameters:                                                                 !
! - TypeScat (integer) - for TypeScat = 1 the particle is illuminated by a pane     !
!   wave traveling in the ambient medium, while for TypeScat = 2 the particle is    !
!   illuminated by a plane wave traveling in the substrate. In the first case the   !
!   direction of the wave vector is (theta = beta ,phi = Pi), while in the second   !
!   case the direction is (theta = Pi - beta,phi = 0), where beta is the incident   !
!   angle.                                                                          ! 
! - k (real) - wave number of the ambient medium.                                   !
! - ind_ref_s (complex) - refractive index of the substrate.                        !
! - z0 (real) - axial position of the substrate with respect to the particle        !
!   coordinate system.                                                              !
! - snorm (real) - normalization constant.                                          !
! - FileTmat (character(80) - name of the data file containing the T matrix.        !
! - Mrank, Nrank (integer variables) - Mrank is the number of azimuthal modes       !
!   (maximum degree), while Nrank is the maximum expansion order.                   !
!------------------------------------------------------------------------------------                       
  use parameters
  implicit none 
  integer       :: TypeScat, Nrank, Mrank
  real(O)       :: snorm, k, z0
  complex(O)    :: ind_ref_s
  character(80) :: FileTmat  
!  
  integer       :: NthetaGS, Nphi, Ntheta(NphiMax), Mstart, Nmax, Nmaxmax,          &
                   m, i, itheta, iphi, ntl, mtl, NphiAL, NthetaAL
  real(O)       :: beta, alphap, phiGS, phi(NphiMax), thetamin(Nphimax),            &
                   thetamax(NphiMax)
  character(80) :: FileDSCS, FileEMF
  logical       :: ComputeDSCS, ComputeFields, normalized, WriteInputInfo
  real(O),allocatable    :: h(:), v(:)
  complex(O),allocatable :: t(:,:), c(:), c1(:), cc(:), em(:,:), emf(:,:,:)
! -----------------------------------------------------------------------------------
!                                 Read the input file                               !
! -----------------------------------------------------------------------------------               
  call readinputPARTSUB1 ( beta, alphap, ComputeDSCS, ComputeFields, NthetaGS,      &
       phiGS, Nphi, phi, Ntheta, thetamin, thetamax, normalized, FileDSCS, FileEMF, &
       WriteInputInfo )  
  if (.not. ComputeDSCS .and. .not. ComputeFields) return
! -----------------------------------------------------------------------------------
!                                       Main                                        !
! ----------------------------------------------------------------------------------- 
  print "(/,2x,'Scattering Characteristics of a Particle on or Near a Plane Surface')"  
  print "(  2x,'-------------------------------------------------------------------')"  
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)  
  allocate (c(2*Nrank), c1(2*Nrank), cc(2*Nmaxmax))        
  open (unit = iTmat, file = FileTmat, status = "old",  position = "rewind")   
  call read_HeadFileTmat (ntl, mtl)
  call check_dimensionMat (ntl, mtl, Nrank)             
  allocate (t(2*ntl, 2*mtl))
  Mstart = 0
  do m = Mstart, Mrank    
    if (m == 0) then
      Nmax = Nrank
    else
      Nmax = Nrank - m + 1
    end if    
    call read_FileTmat (ntl, mtl, t)
    if (TypeScat == 1) then                      
      call PWcoefficientsPARTSUB (beta, alphap, m, Nrank, Nmax, c)
      call PWcoefficientsPARTSUBrefl (beta, alphap, z0, k, ind_ref_s, m, Nrank,     &
           Nmax, c1)
      call sum_vectors (c, c1, 2*Nmax)     
    else
      call PWcoefficientsPARTSUBtrans (beta, alphap, z0, k, ind_ref_s, m, Nrank,    &
           Nmax, c)
    end if
    call product_matrix_vector (2*Nmax, 2*Nmax, t, 2*ntl, 2*mtl, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)         
    if (m /= 0) then
      call matrix_m_negativ (Nmax, Nmax, t, ntl, mtl)  
      if (TypeScat == 1) then    
        call PWcoefficientsPARTSUB (beta, alphap, - m, Nrank, Nmax, c)
        call PWcoefficientsPARTSUBrefl (beta, alphap, z0, k, ind_ref_s, - m, Nrank, &
             Nmax, c1)
        call sum_vectors (c, c1, 2*Nmax)      
      else
        call PWcoefficientsPARTSUBtrans (beta, alphap, z0, k, ind_ref_s, - m, Nrank,&
             Nmax, c)
      end if
      call product_matrix_vector (2*Nmax, 2*Nmax, t, 2*ntl, 2*mtl, c, c1)
      call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)                                          
    end if
  end do
  close (unit = iTmat)
  deallocate (t, c, c1) 
  if (ComputeDSCS) then
    open (unit = iDSCS, file = FileDSCS, status = "replace")
    allocate (h(NthetaGS), v(NthetaGS), em(3,NthetaGS)) 
    do i = 1, 3
      do itheta = 1, NthetaGS
        em(i,itheta) = zero
      end do
    end do         
    call DSCSPARTSUB (1, cc, k, z0, ind_ref_s, Mrank, Nrank, Nmaxmax, NthetaGS,     &
         phiGS, snorm, em, normalized, h, v)
    call DSCSPARTSUB (2, cc, k, z0, ind_ref_s, Mrank, Nrank, Nmaxmax, NthetaGS,     &
         phiGS, snorm, em, normalized, h, v)                                
    if (WriteInputInfo) call inputDSCS_EMF (.true., TypeScat, k, ind_ref_s, z0,     &
                             Mrank, Nrank, phiGS, beta, alphap, snorm, normalized,  &
                             FileTmat)
    call write_DSCSPARTSUB1 (NthetaGS, normalized, h, v)                    
    close (unit = iDSCS) 
    deallocate (h, v, em)
  end if
  if (ComputeFields) then
    open (unit = iSCAT, file = FileEMF,  status = "replace")
    NphiAL   = Nphi
    NthetaAL = 0
    do iphi = 1, Nphi
      if (Ntheta(iphi) > NthetaAL) NthetaAL = Ntheta(iphi)
    end do
    allocate (emf(3,NphiAL,NthetaAL))
    do i = 1, 3
      do iphi = 1, NphiAL
        do itheta = 1, NthetaAL
          emf(i,iphi,itheta) = zero
        end do
      end do
    end do
    call EMFPARTSUB (1, cc, k, z0, ind_ref_s, Mrank, Nrank, Nmaxmax, Nphi, phi,     &
         Ntheta, thetamin, thetamax, emf, NphiAL, NthetaAL)
    call EMFPARTSUB (2, cc, k, z0, ind_ref_s, Mrank, Nrank, Nmaxmax, Nphi, phi,     &
         Ntheta, thetamin, thetamax, emf, NphiAL, NthetaAL)
    if (WriteInputInfo) call inputDSCS_EMF (.false., TypeScat, k, ind_ref_s, z0,    &
                             Mrank, Nrank, phiGS, beta, alphap, snorm, normalized,  &
                             FileTmat)
    call write_EMF (Nphi, phi, Ntheta, thetamin, thetamax, emf, NphiAL, NthetaAL)       
    close (unit = iSCAT) 
    deallocate (emf)
  end if      
  deallocate (cc)       
end subroutine DiffScatCrossSectPARTSUB 
! **********************************************************************************
subroutine readinputPARTSUB1 ( beta, alphap, ComputeDSCS, ComputeFields, NthetaGS,  &
           phiGS, Nphi, phi, Ntheta, thetamin, thetamax, normalized, FileDSCS,      &
           FileEMF, WriteInputInfo ) 
  use parameters
  implicit none     
  integer       :: NthetaGS, Nphi, Ntheta(NphiMax), iphi, ios
  real(O)       :: beta, alphap, phiGS, phi(NphiMax), thetamin(NphiMax),            &
                   thetamax(NphiMax), deg
  character(80) :: FileDSCS, FileEMF, string
  logical       :: ComputeDSCS, ComputeFields, normalized, WriteInputInfo, XFindPar  
! -----------------------------------------------------------------------------------
!                        Read the input file FileInputPARTSUB                       !
! -----------------------------------------------------------------------------------             
  open (unit = iInputPARTSUB, file = FileInputPARTSUB, status = "old",              &
        position = "rewind")                
  beta   = 0._O
  alphap = 0._O
  string = 'IncWave'
  if (XFindPar (iInputPARTSUB, string)) then
    read (iInputPARTSUB, *, iostat = ios) beta
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable beta;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) alphap
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable alphap;')"
      stop
    end if         
  else
    print "(/,2x,'Group name IncWave not found;')"
    stop  
  end if 
  call check_incdir_partsub (beta)
  call check_polarization_angle (alphap) 
  deg    = Pi / 180._O
  beta   = beta   * deg
  alphap = alphap * deg
! 
  ComputeDSCS   = .true.
  ComputeFields = .true.
  NthetaGS = 181 
  phiGS    = 0._O  
  Nphi = 1
  do iphi = 1, NphiMax
    phi(iphi)      = 0._O
    Ntheta(iphi)   = 1
    thetamin(iphi) = 0._O
    thetamax(iphi) = 0._O  
  end do 
  normalized = .true.
  FileDSCS   = '../OUTPUTFILES/DSCSpartsub.dat'
  FileEMF    = '../OUTPUTFILES/EMFields.dat'
  WriteInputInfo = .true.
  string     = 'DSCSEM'
  if (XFindPar (iInputPARTSUB, string)) then
    read (iInputPARTSUB, *, iostat = ios) ComputeDSCS 
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ComputeDSCS;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) ComputeFields
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ComputeFields;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) NthetaGS
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable NthetaGS;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) phiGS
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable phiGS;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) Nphi
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nphi;')"
      stop
    end if
    do iphi = 1, Nphi
      read (iInputPARTSUB, *, iostat = ios) phi(iphi)
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable phi;')"
        stop
      end if
      read (iInputPARTSUB, *, iostat = ios) Ntheta(iphi)
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Ntheta;')"
        stop
      end if
      read (iInputPARTSUB, *, iostat = ios) thetamin(iphi)
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable thetamin;')"
        stop
      end if      
      read (iInputPARTSUB, *, iostat = ios) thetamax(iphi)
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable thetamax;')"
        stop
      end if      
    end do    
    read (iInputPARTSUB, *, iostat = ios) normalized
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable normalized;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) FileDSCS
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileDSCS;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) FileEMF
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileEMF;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) WriteInputInfo
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable WriteInputInfo;')"
      stop
    end if
  else
    print "(/,2x,'Group name DSCSEM not found;')"
    stop  
  end if  
  if (ComputeDSCS) then      
    call check_azimuthal_plane (phiGS)
    phiGS = phiGS * deg                 
  end if
  if (ComputeFields) then
    call check_Nphi (Nphi)
    call check_teta_phiminmax (.false., Nphi, phi, Ntheta, thetamin, thetamax)
    do iphi = 1, Nphi    
      phi(iphi)      = phi(iphi)      * deg
      thetamin(iphi) = thetamin(iphi) * deg
      thetamax(iphi) = thetamax(iphi) * deg      
    end do
  end if
  close (unit = iInputPARTSUB)
end subroutine readinputPARTSUB1
! **********************************************************************************
subroutine DSCSPARTSUB (TypeField, c, wavenumber, z0, ind_ref, Mrank, Nrank, Nmax,  &
           NthetaGS, phiAZIMUT, snorm, em, normalized, h, v)
!------------------------------------------------------------------------------------     
! The routine computes the differential scattering cross sections of an axisymmetric!
! particle on a plane substrate in the azimuthal plane phiAZIMUTH.                  !
! -----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: TypeField, Mrank, Nrank, Nmax, NthetaGS
  real(O)    :: phiAZIMUT, snorm, h(NthetaGS), v(NthetaGS), wavenumber, z0      
  complex(O) :: ind_ref, em(3,NthetaGS), c(2*Nmax)
  logical    :: normalized
!
  integer    :: itheta, m, k, N0, l
  real(O)    :: thetaGS, phiGS, fact
  complex(O) :: sum(3)
  complex(O),allocatable :: Minf(:,:), Ninf(:,:)      
!
  if (normalized) then
    fact = snorm
  else 
    fact = wavenumber * wavenumber
  end if
  fact = 1._O / fact
  allocate (Minf(3,Nmax), Ninf(3,Nmax)) 
  do itheta = 1, NthetaGS  
    thetaGS = Pi / 2._O + real(itheta - 1,O) * Pi / real(NthetaGS - 1,O)
    phiGS   = phiAZIMUT
    if (thetaGS > Pi) then
      thetaGS = 2._O * Pi - thetaGS
      phiGS   = phiAZIMUT + Pi
    end if          
    if (TypeField == 1) then               
      call MN_infinit_complete (thetaGS, phiGS, Mrank, Nrank, Nmax, .true.,         &
           Minf, Ninf)
    else if (TypeField == 2) then            
      call MN_infinit_reflection_complete (wavenumber, z0, ind_ref, thetaGS, phiGS, &
           Mrank, Nrank, Nmax, Minf, Ninf)             
    end if                         
    sum(1) = zero
    sum(2) = zero
    sum(3) = zero
    do m = 0, Mrank
      if (m == 0) then
        do k = 1, Nrank
          sum(1) = sum(1) + (Minf(1,k) * c(k) + Ninf(1,k) * c(Nmax+k))
          sum(2) = sum(2) + (Minf(2,k) * c(k) + Ninf(2,k) * c(Nmax+k))
          sum(3) = sum(3) + (Minf(3,k) * c(k) + Ninf(3,k) * c(Nmax+k))
        end do
      else          
        N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
        do l = 1, 2
          do k = 1, Nrank - m + 1
            sum(1) = sum(1) + (Minf(1,N0+k) * c(N0+k) + Ninf(1,N0+k) * c(Nmax+N0+k))
            sum(2) = sum(2) + (Minf(2,N0+k) * c(N0+k) + Ninf(2,N0+k) * c(Nmax+N0+k))
            sum(3) = sum(3) + (Minf(3,N0+k) * c(N0+k) + Ninf(3,N0+k) * c(Nmax+N0+k))
          end do           
          N0 = N0 + Nrank - m + 1
        end do
      end if
    end do                          
    em(1,itheta) = em(1,itheta) + sum(1)
    em(2,itheta) = em(2,itheta) + sum(2)
    em(3,itheta) = em(3,itheta) + sum(3)                        
    h(itheta) = abs(em(2,itheta))**2 * fact
    v(itheta) = abs(em(3,itheta))**2 * fact      
  end do
  deallocate (Minf, Ninf)      
end subroutine DSCSPARTSUB
! **********************************************************************************
subroutine EMFPARTSUB (TypeField, c, wavenumber, z0, ind_ref, Mrank, Nrank, Nmax,  &
           Nphi, phi, Ntheta, thetamin, thetamax, emf, NphiAL, NthetaAL)
!------------------------------------------------------------------------------------     
! The routine computes the electromagnetic scattered field of an axisymmetric       !
! particle on a plane substrate.                                                    !
! -----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: TypeField, Mrank, Nrank, Nmax, Nphi, Ntheta(NphiMax), NphiAL,       &
                NthetaAL
  real(O)    :: phi(NphiMax), thetamin(NphiMax), thetamax(NphiMax), wavenumber, z0      
  complex(O) :: ind_ref, emf(3,NphiAL,NthetaAL), c(2*Nmax)
!
  integer    :: iphi, itheta, m, k, N0, l
  real(O)    :: thetaGS, phiGS, dtheta
  complex(O) :: sum(3)
  complex(O),allocatable :: Minf(:,:), Ninf(:,:)      
!
  allocate (Minf(3,Nmax), Ninf(3,Nmax)) 
  do iphi = 1, Nphi
    phiGS = phi(iphi)
    if (Ntheta(iphi) /= 1) then
      dtheta = (thetamax(iphi) - thetamin(iphi)) / (Ntheta(iphi) - 1)
    else
      dtheta = 0._O
    end if          
    do itheta = 1, Ntheta(iphi)
      thetaGS = thetamin(iphi) + (itheta - 1) * dtheta              
      if (TypeField == 1) then               
        call MN_infinit_complete (thetaGS, phiGS, Mrank, Nrank, Nmax, .true.,       &
             Minf, Ninf)
      else if (TypeField == 2) then            
        call MN_infinit_reflection_complete (wavenumber, z0, ind_ref, thetaGS,      &
             phiGS, Mrank, Nrank, Nmax, Minf, Ninf)                
      end if                       
      sum(1) = zero
      sum(2) = zero
      sum(3) = zero
      do m = 0, Mrank
        if (m == 0) then
          do k = 1, Nrank
            sum(1) = sum(1) + (Minf(1,k) * c(k) + Ninf(1,k) * c(Nmax+k))
            sum(2) = sum(2) + (Minf(2,k) * c(k) + Ninf(2,k) * c(Nmax+k))
            sum(3) = sum(3) + (Minf(3,k) * c(k) + Ninf(3,k) * c(Nmax+k))
          end do
        else          
          N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
          do l = 1, 2
            do k = 1, Nrank - m + 1
              sum(1) = sum(1) + (Minf(1,N0+k) * c(N0+k) + Ninf(1,N0+k) *            &
                                   c(Nmax+N0+k))
              sum(2) = sum(2) + (Minf(2,N0+k) * c(N0+k) + Ninf(2,N0+k) *            &
                                   c(Nmax+N0+k))
              sum(3) = sum(3) + (Minf(3,N0+k) * c(N0+k) + Ninf(3,N0+k) *            &
                                   c(Nmax+N0+k))
            end do           
            N0 = N0 + Nrank - m + 1
          end do
        end if
      end do                        
      emf(1,iphi, itheta) = emf(1,iphi, itheta) + sum(1)
      emf(2,iphi, itheta) = emf(2,iphi, itheta) + sum(2)
      emf(3,iphi, itheta) = emf(3,iphi, itheta) + sum(3)                                 
    end do
  end do
  deallocate (Minf, Ninf)      
end subroutine EMFPARTSUB
! **********************************************************************************
subroutine delta_DSCSPARTSUB (m, Ntheta, h, v, oldh, oldv, eps, nconv)
  use parameters
  use derived_parameters
  implicit none
  integer  :: m, Ntheta, i, nconv, pconv, sconv
  real(O)  :: h(Ntheta), v(Ntheta), oldh(Ntheta), oldv(Ntheta), eps, delta, deltaM
  logical  :: smallh, smallv 
!
  pconv  = 0
  sconv  = 0
  smallh = .false.
  smallv = .false.  
  do i = 1, Ntheta - 2
    delta  = abs(h(i+1) - oldh(i+1))
    deltaM = eps * h(i+1)    
    if (h(i+1) >= MachEps) then
      if (delta < deltaM) pconv = pconv + 1
    else
      pconv  = pconv + 1     
      smallh = .true.            
    end if
    delta  = abs(v(i+1) - oldv(i+1))
    deltaM = eps * v(i+1)    
    if (v(i+1) >= MachEps) then
      if (delta < deltaM) sconv = sconv + 1
    else
      sconv  = sconv + 1     
      smallv = .true.
    end if
  end do
  do i = 1, Ntheta 
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do
  nconv = min(pconv,sconv)  
  if (smallh .and. m /= 0) then
    print "(/,2x,'Warning: at least one value of the parallel component ')"     
    print "(  2x,'of the DSCS is smaller than the machine precision;')"  
    if (pconv == Ntheta - 2) nconv = 0    
  end if
  if (smallv .and. m /= 0) then
    print "(/,2x,'Warning: at least one value of the perpendicular component ')"        
    print "(  2x,'of the DSCS is smaller than the machine precision;')"  
    if (sconv == Ntheta - 2) nconv = 0    
  end if                      
end subroutine delta_DSCSPARTSUB         





     

! **********************************************************************************
! *         ROUTINES FOR COMPUTING THE Q MATRIX AND THE INCIDENT MATRIX FOR        * 
! *                 AXISYMMETRIC AND NONAXISYMMETRIC PARTICLES                     *
! *    ------------------------------------------------------------------------    *
! *    Partial list of subroutines:                                                *
! *      matrix_Q,                   matrix_Q_sym,          matrix_Q_m,            *
! *      incident_matrix_m,          AzimMirSym,            ConvergenceMatrixElem  *
! **********************************************************************************
subroutine matrix_Q (FileGeom, TypeGeom, index1, index2, k, ind_ref, Nsurf, surf,   &
           rp, np, area, Nface, Mrank, Nrank, Nmax, NintAL, Nparam, Nintparam,      &
           paramG1, paramG2, weightsG, mirror, Nazimutsym, perfectcond, chiral, kb, &
           A, nap, map)
!------------------------------------------------------------------------------------
! The routine computes the Q matrix of a nonaxisymmetric particle.                  !
!------------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Nface, Mrank, Nrank, Nmax, Nsurf, NintAL, Nparam, Nintparam(Nparam),&
                TypeGeom, index1, index2, Nazimutsym, nap, map      
  real(O)    :: k, surf(Nsurf), paramG1(Nparam,NintAL*NintAL),                      &
                paramG2(Nparam,NintAL*NintAL), weightsG(Nparam,NintAL*NintAL),      &
                rp(3,NfacePD), np(3,NfacePD), area(NfacePD), kb
  complex(O) :: ind_ref, A(2*nap,2*map)
  logical    :: FileGeom, mirror, perfectcond, chiral
!
  integer    :: NmaxL, NmaxC, i, j, pint, iparam, Nintl
  real(O)    :: r, theta, phi, dA, param1, param2, pondere, nuv(3), sign, x, y, z 
  complex(O) :: ki, zc, zl, zcl, zcr, fact, f
  complex(O),allocatable :: mv1(:,:), nv1(:,:), mv3(:,:), nv3(:,:)  
!
  NmaxL = Nmax
  NmaxC = Nmax                
  allocate (mv1(3,NmaxC), nv1(3,NmaxC), mv3(3,NmaxL), nv3(3,NmaxL))
  do i = 1, 2*NmaxL
    do j = 1, 2*NmaxC
      A(i,j) = zero
    end do
  end do  
  ki   = k * ind_ref
  sign = 1._O
  if (index1 == 3 .and. index2 == 1) sign = - 1._O
  f = sign * im * k * k / Pi      
  if (.not. FileGeom) then
    do iparam = 1, Nparam
      Nintl = Nintparam(iparam)
      do pint = 1, Nintl
        param1  = paramG1(iparam,pint)
        param2  = paramG2(iparam,pint)
        pondere = weightsG(iparam,pint)       
        call elem_geom3D (TypeGeom, Nsurf, surf, param1, param2, iparam, r, theta,  &
             phi, dA, nuv, mirror, Nazimutsym)                       
        zc = ki * r
        zl = cmplx(k * r,0.0,O)
        if (chiral) then
          zcl = zc / (1._O - kb)
          zcr = zc / (1._O + kb)
        end if      
        call mvnv (index1, index2, chiral, zl, zc, zcl, zcr, theta, phi, Mrank,     &
             Nrank, Nmax, NmaxC, NmaxL, mv3, nv3, mv1, nv1)
        fact = f * dA * pondere
        call matQ (NmaxC, NmaxL, chiral, perfectcond, ind_ref, fact, mv3, nv3,      &
             mv1, nv1, nuv, A, nap, map)      
      end do
    end do 
  else
    do pint = 1, Nface
      x = rp(1,pint)
      y = rp(2,pint)
      z = rp(3,pint)
      call T_cartesian_spherical (x, y, z, r, theta, phi)
      dA = area(pint)                        
      nuv(1) =   sin(theta) * cos(phi) * np(1,pint) +                               &
                 sin(theta) * sin(phi) * np(2,pint) + cos(theta) * np(3,pint) 
      nuv(2) =   cos(theta) * cos(phi) * np(1,pint) +                               &
                 cos(theta) * sin(phi) * np(2,pint) - sin(theta) * np(3,pint)
      nuv(3) = - sin(phi) * np(1,pint) + cos(phi) * np(2,pint)
      zc = ki * r
      zl = cmplx(k * r,0.0,O)
      if (chiral) then
        zcl = zc / (1._O - kb)
        zcr = zc / (1._O + kb)
      end if      
      call mvnv (index1, index2, chiral, zl, zc, zcl, zcr, theta, phi, Mrank,       &
           Nrank, Nmax, NmaxC, NmaxL, mv3, nv3, mv1, nv1)
      fact = f * dA
      call matQ (NmaxC, NmaxL, chiral, perfectcond, ind_ref, fact, mv3, nv3,        &
           mv1, nv1, nuv, A, nap, map)   
    end do
  end if
  call AzimMirSym (Nazimutsym, mirror, Mrank, Nrank, NmaxC, NmaxL, A, nap, map)  
  deallocate (mv1, nv1, mv3, nv3) 
end subroutine matrix_Q 
!***********************************************************************************
subroutine matrix_Q_sym (TypeGeom, index1, index2, k, ind_ref, Nsurf, surf, Mrank,  &
           Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG, mirror,          &
           perfectcond, A, nap, map)
!------------------------------------------------------------------------------------
! The routine computes the Q matrix of an axisymmetric particle, for the            !
! azimuthal modes m = 0, 1,..., Mrank. Only localized sources are used for          !
! calculation.                                                                      !
!------------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax, Nsurf, Nint, Nparam, Nintparam(Nparam),         &
                TypeGeom, index1, index2, nap, map
  real(O)    :: k, surf(Nsurf), paramG(Nparam,Nint), weightsG(Nparam,Nint)      
  complex(O) :: ind_ref, A(2*nap,2*map)
  logical    :: mirror, perfectcond
!      
  integer    :: i, j, pint, m, N0, N1, iparam, Nintl, ni, nj
  real(O)    :: r, theta, phi, dA, param, pondere, nuv(3), s
  complex(O) :: ki, zc, zl, mvl(3), nvl(3), mvc(3), nvc(3), v1, v2, fact, f,        &
                mixt_product
  complex(O),allocatable :: mv1(:,:), nv1(:,:), mv3(:,:), nv3(:,:)
!
  allocate (mv1(3,Nmax), nv1(3,Nmax), mv3(3,Nmax), nv3(3,Nmax))
  do i = 1, 2*Nmax
    do j = 1, 2*Nmax
      A(i,j) = zero
    end do
  end do      
  ki = k * ind_ref
  f  = im * 2._O * k * k
  do iparam = 1, Nparam
    Nintl = Nintparam(iparam)
    do pint = 1, Nintl
      param   = paramG(iparam,pint)
      pondere = weightsG(iparam,pint)    
      call elem_geomAXSYM (TypeGeom, Nsurf, surf, param, iparam, r, theta, phi,     &
           dA, nuv)        
      zc = ki * r
      zl = cmplx(k * r,0.0,O)     
      if (index1 == 3 .and. index2 == 1) then
        call MN_complete (3, zl, theta, phi, Mrank, Nrank, Nmax,.false.,.true.,     &
             mv3, nv3)          
        call MN_complete (1, zc, theta, phi, Mrank, Nrank, Nmax,.true.,.true.,      &
             mv1, nv1)
      else if (index1 == 3 .and. index2 == 3) then
        call MN_complete (3, zl, theta, phi, Mrank, Nrank, Nmax,.false.,.true.,     &
             mv3, nv3)
        call MN_complete (3, zc, theta, phi, Mrank, Nrank, Nmax,.true.,.true.,      &
             mv1, nv1)
      else if (index1 == 1 .and. index2 == 1) then
        call MN_complete (1, zl, theta, phi, Mrank, Nrank, Nmax,.false.,.true.,     &
             mv3, nv3)          
        call MN_complete (1, zc, theta, phi, Mrank, Nrank, Nmax,.true.,.true.,      &
             mv1, nv1)        
      else if (index1 == 1 .and. index2 == 3) then
        call MN_complete (1, zl, theta, phi, Mrank, Nrank, Nmax,.false.,.true.,     &
             mv3, nv3)
        call MN_complete (3, zc, theta, phi, Mrank, Nrank, Nmax,.true.,.true.,      &
             mv1, nv1)
      end if     
      fact = f * dA * pondere
      do m = 0, Mrank
        if (m == 0) then
          do i = 1, Nrank
            ni = i
            mvl(1) = mv3(1,i)
            mvl(2) = mv3(2,i)
            mvl(3) = mv3(3,i)
            nvl(1) = nv3(1,i)
            nvl(2) = nv3(2,i)
            nvl(3) = nv3(3,i)
            do j = 1, Nrank
              nj = j
              mvc(1) = mv1(1,j)
              mvc(2) = mv1(2,j)
              mvc(3) = mv1(3,j)
              nvc(1) = nv1(1,j)
              nvc(2) = nv1(2,j)
              nvc(3) = nv1(3,j)
              s = (-1._O)**(ni + nj)
              v1 = mixt_product (nuv, mvc, nvl)
              v2 = mixt_product (nuv, nvc, mvl)
              if (.not. perfectcond) then
                A(i,j) = A(i,j) + (v1 + ind_ref * v2) * fact
                if(mirror) A(i,j) = A(i,j) + s * (v1 + ind_ref * v2) * fact
              else 
                A(i,j) = A(i,j) + v2 * fact
                if (mirror) A(i,j) = A(i,j) + s * v2 * fact
              end if                                                                                                 
              v1 = mixt_product (nuv, nvc, mvl)
              v2 = mixt_product (nuv, mvc, nvl)
              if (.not. perfectcond) then
                A(i+Nmax,j+Nmax) = A(i+Nmax,j+Nmax) + (v1 + ind_ref * v2) * fact
                if (mirror) A(i+Nmax,j+Nmax) = A(i+Nmax,j+Nmax) +                   &
                                              s * (v1 + ind_ref * v2) * fact
              else 
                A(i+Nmax,j+Nmax) = A(i+Nmax,j+Nmax) + v2*fact
                if (mirror) A(i+Nmax,j+Nmax) = A(i+Nmax,j+Nmax) + s * v2 * fact
              end if                                              
            end do
          end do
        else          
          N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
          do i = 1, Nrank - m + 1
            ni = m + i - 1
            mvl(1) = mv3(1,i+N0)
            mvl(2) = mv3(2,i+N0)
            mvl(3) = mv3(3,i+N0)
            nvl(1) = nv3(1,i+N0)
            nvl(2) = nv3(2,i+N0)
            nvl(3) = nv3(3,i+N0)
            do j = 1, Nrank - m + 1
              nj = m + j - 1
              mvc(1) = mv1(1,j+N0)
              mvc(2) = mv1(2,j+N0)
              mvc(3) = mv1(3,j+N0)
              nvc(1) = nv1(1,j+N0)
              nvc(2) = nv1(2,j+N0)
              nvc(3) = nv1(3,j+N0)
              s  = (-1._O)**(ni + nj)
              v1 = mixt_product (nuv, mvc, nvl)
              v2 = mixt_product (nuv, nvc, mvl)
              if (.not. perfectcond) then
                A(i+N0,j+N0) = A(i+N0,j+N0) + (v1 + ind_ref * v2) * fact
                if(mirror) A(i+N0,j+N0) = A(i+N0,j+N0) +                            &
                                         s * (v1 + ind_ref * v2) * fact
              else 
                A(i+N0,j+N0) = A(i+N0,j+N0) + v2 * fact
                if(mirror) A(i+N0,j+N0) = A(i+N0,j+N0) + s * v2 * fact
              end if                                                                        
              v1 = mixt_product (nuv, nvc, nvl)
              v2 = mixt_product (nuv, mvc, mvl)
              if (.not. perfectcond) then
                A(i+N0,j+N0+Nmax) = A(i+N0,j+N0+Nmax) + (v1 + ind_ref * v2) * fact
                if (mirror) A(i+N0,j+N0+Nmax) = A(i+N0,j+N0+Nmax) -                 &
                                               s * (v1 + ind_ref * v2) * fact
              else 
                A(i+N0,j+N0+Nmax) = A(i+N0,j+N0+Nmax) + v2 * fact
                if (mirror) A(i+N0,j+N0+Nmax) = A(i+N0,j+N0+Nmax) - s * v2 * fact
              end if                                              
              v1 = mixt_product (nuv, mvc, mvl)
              v2 = mixt_product (nuv, nvc, nvl)
              if (.not. perfectcond) then 
                A(i+N0+Nmax,j+N0) = A(i+N0+Nmax,j+N0) + (v1 + ind_ref * v2) * fact
                if (mirror) A(i+N0+Nmax,j+N0) = A(i+N0+Nmax,j+N0) -                 &
                                               s * (v1 + ind_ref * v2) * fact
              else 
                A(i+N0+Nmax,j+N0) = A(i+N0+Nmax,j+N0) + v2 * fact
                if (mirror) A(i+N0+Nmax,j+N0) = A(i+N0+Nmax,j+N0) - s * v2 * fact
              end if                                                              
              v1 = mixt_product (nuv, nvc, mvl)
              v2 = mixt_product (nuv, mvc, nvl)
              if (.not. perfectcond) then 
                A(i+N0+Nmax,j+N0+Nmax) = A(i+N0+Nmax,j+N0+Nmax) +                   &
                                        (v1 + ind_ref * v2) * fact
                if (mirror) A(i+N0+Nmax,j+N0+Nmax) = A(i+N0+Nmax,j+N0+Nmax) +       &
                                                    s * (v1+ind_ref * v2) * fact
              else 
                A(i+N0+Nmax,j+N0+Nmax) = A(i+N0+Nmax,j+N0+Nmax) + v2 * fact
                if (mirror) A(i+N0+Nmax,j+N0+Nmax) = A(i+N0+Nmax,j+N0+Nmax) +       &
                                                    s * v2 * fact
              end if                                              
            end do
          end do
          N1 = N0 + Nrank - m + 1
          do i = 1, Nrank - m + 1
            do j = 1, Nrank - m + 1
              A(i+N1,j+N1) = A(i+N0,j+N0)
              A(i+N1,j+N1+Nmax) = - A(i+N0,j+N0+Nmax)
              A(i+N1+Nmax,j+N1) = - A(i+N0+Nmax,j+N0)
              A(i+N1+Nmax,j+N1+Nmax) = A(i+N0+Nmax,j+N0+Nmax)
            end do
          end do
        end if
      end do 
    end do
  end do
  deallocate (mv1, nv1, mv3, nv3)       
end subroutine matrix_Q_sym 
!***********************************************************************************
subroutine matrix_Q_m (FileGeom, TypeGeom, index1, index2, k, ind_ref, Nsurf, surf, &
           rp, np, area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam,  &
           paramG, weightsG, mirror, perfectcond, DS, chiral, kb, A, nap, map)
!------------------------------------------------------------------------------------
! The routine computes the Q matrix of an axisymmetric particle, and the            !
! azimuthal mode m                                                                  !
!------------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: m, Nrank, Nmax, Nsurf, Nface, Nint, Nparam, Nintparam(Nparam),      &
                TypeGeom, index1, index2, nap, map          
  real(O)    :: k, kb, surf(Nsurf), paramG(Nparam,Nint), weightsG(Nparam,Nint),     &
                zRe(Nrank), zIm(Nrank), rp(2,NfacePD), np(2,NfacePD), area(NfacePD)
  complex(O) :: ind_ref, A(2*nap,2*map)
  logical    :: FileGeom, mirror, perfectcond, DS, chiral
!      
  integer    :: NmaxL, NmaxC, i, j, pint, iparam, Nintl
  real(O)    :: r, theta, phi, dA, param, pondere, nuv(3), sign, x, z, za, thetaA
  complex(O) :: kc, ki, kil, kir, zc, zl, zcl, zcr, fact, f
  complex(O),allocatable :: mv1(:,:), nv1(:,:), mv3(:,:), nv3(:,:)
!
  NmaxL = Nmax
  NmaxC = Nmax
  if (DS) then
    NmaxC = Nrank 
    if (index1 == 3) then
      NmaxL = Nrank   
    else if (index1 == 1) then
      NmaxL = Nmax    
    end if
  end if  
  allocate (mv1(3,NmaxC), nv1(3,NmaxC), mv3(3,NmaxL), nv3(3,NmaxL))
  kc = cmplx(k,0.0,O)
  do i = 1, 2*NmaxL
    do j = 1, 2*NmaxC
      A(i,j) = zero
    end do
  end do      
  ki = k * ind_ref
  if (chiral) then
    kil = ki / (1._O - kb)
    kir = ki / (1._O + kb)
  end if
  sign = 1._O
  if (index1 == 3 .and. index2 == 1) sign = - 1._O
  f = sign * im * 2._O * k * k 
  if (.not. FileGeom) then
    do iparam = 1, Nparam
      Nintl = Nintparam(iparam)
      do pint = 1, Nintl
        param   = paramG(iparam,pint)
        pondere = weightsG(iparam,pint)   
        call elem_geomAXSYM (TypeGeom, Nsurf, surf, param, iparam, r, theta, phi,   &
             dA, nuv)  
        zc = ki * r
        zl = cmplx(k * r,0.0,O)
        if (chiral) then
          zcl = zc / (1._O - kb)
          zcr = zc / (1._O + kb)
        end if
        call mvnv_m (index1, index2, chiral, DS, zl, zc, zcl, zcr, kc, ki, kil, kir,&
             r, theta, m, Nrank, Nmax, NmaxC, NmaxL, zRe, zIm, mv3, nv3, mv1, nv1)                   
        fact = f * dA * pondere 
        call matQ_m (m, NmaxC, NmaxL, chiral, perfectcond, mirror, ind_ref, fact,   &
             mv3, nv3, mv1, nv1, nuv, A, nap, map)       
      end do
    end do
  else
    do pint = 1, Nface
      x  = rp(1,pint)     
      z  = rp(2,pint)
      r  = sqrt(x * x + z * z)      
      za = abs(z)
      if (za < MachEps) then
        theta = Pi / 2._O
      else
        thetaA = atan(x / za)   ! x > 0
        if (z >= MachEps) then
          theta = thetaA
        else
          theta = Pi - thetaA
        end if
      end if 
      dA = area(pint) 
      nuv(1) =   np(2,pint) * cos(theta) + np(1,pint) * sin(theta)
      nuv(2) = - np(2,pint) * sin(theta) + np(1,pint) * cos(theta)
      nuv(3) = 0._O
      zc = ki * r
      zl = cmplx(k * r,0.0,O)
      if (chiral) then
        zcl = zc / (1._O - kb)
        zcr = zc / (1._O + kb)
      end if
      call mvnv_m (index1, index2, chiral, DS, zl, zc, zcl, zcr, kc, ki, kil, kir,  &
           r, theta, m, Nrank, Nmax, NmaxC, NmaxL, zRe, zIm, mv3, nv3, mv1, nv1)             
      fact = f * dA  
      call matQ_m (m, NmaxC, NmaxL, chiral, perfectcond, mirror, ind_ref, fact,     &
           mv3, nv3, mv1, nv1, nuv, A, nap, map)            
    end do  
  end if            
  deallocate (mv1, nv1, mv3, nv3)       
end subroutine matrix_Q_m
!***********************************************************************************
subroutine incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area,     &
           Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,        &
           weightsG, A, nap, map)
!-----------------------------------------------------------------------------------
! The routine computes the incident matrix of an axisymmetric particle             !
! using distributed sources.                                                       !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: TypeGeom, m, Nrank, Nmax, Nint, Nsurf, Nparam, Nintparam(Nparam),   &
                nap, map, Nface
  real(O)    :: k, surf(Nsurf), zRe(Nrank), zIm(Nrank), paramG(Nparam,Nint),        &
                weightsG(Nparam,Nint), rp(2,NfacePD), np(2,NfacePD), area(NfacePD)
  complex(O) :: A(2*nap,2*map)
  logical    :: FileGeom  
!    
  integer    :: i, j, pint, iparam, Nintl
  real(O)    :: r, theta, phi, dA, param, pondere, nuv(3), x, z, za, thetaA
  complex(O) :: kc, zl, fact, f
  complex(O),allocatable :: mv1(:,:), nv1(:,:), mv3(:,:), nv3(:,:)
!
  allocate (mv1(3,Nmax), nv1(3,Nmax), mv3(3,Nrank), nv3(3,Nrank))
  kc = cmplx(k,0.0,O)
  do i = 1, 2*Nrank
    do j = 1, 2*Nmax
      A(i,j) = zero
    end do
  end do
  f = - im * 2._O * k * k
  if (.not. FileGeom) then
    do iparam = 1, Nparam
      Nintl = Nintparam(iparam)
      do pint = 1, Nintl
        param   = paramG(iparam,pint)
        pondere = weightsG(iparam,pint)
        call elem_geomAXSYM (TypeGeom, Nsurf, surf, param, iparam, r, theta, phi,   &
             dA, nuv)        
        zl = cmplx(k * r,0.0,O)
        call mvnvinc_m (zl, kc, r, theta, m, Nrank, Nmax, zRe, zIm, mv3, nv3,       &
             mv1, nv1)          
        fact = f * dA * pondere
        call matQinc_m (m, Nmax, Nrank, fact, mv3, nv3, mv1, nv1, nuv, A, nap, map)       
      end do
    end do
  else
    do pint = 1, Nface
      x  = rp(1,pint)     
      z  = rp(2,pint)
      r  = sqrt(x * x + z * z)      
      za = abs(z)
      if (za < MachEps) then
        theta = Pi / 2._O
      else
        thetaA = atan(x / za)   ! x > 0
        if (z >= MachEps) then
          theta = thetaA
        else
          theta = Pi - thetaA
        end if
      end if 
      dA = area(pint) 
      nuv(1) =   np(2,pint) * cos(theta) + np(1,pint) * sin(theta)
      nuv(2) = - np(2,pint) * sin(theta) + np(1,pint) * cos(theta)
      nuv(3) = 0._O
      zl = cmplx(k * r,0.0,O)      
      call mvnvinc_m (zl, kc, r, theta, m, Nrank, Nmax, zRe, zIm, mv3, nv3,         &
           mv1, nv1)          
      fact = f * dA 
      call matQinc_m (m, Nmax, Nrank, fact, mv3, nv3, mv1, nv1, nuv, A, nap, map) 
    end do
  end if            
  deallocate (mv1, nv1, mv3, nv3)     
end subroutine incident_matrix_m
!***********************************************************************************
subroutine AzimMirSym (Nazimutsym, mirror, Mrank, Nrank, NmaxC, NmaxL, A, nap, map)
!-----------------------------------------------------------------------------------
! The routine completes the calculation of the Q matrix of a nonaxisymmetric       !
! particle taking into account the mirror and azimuthal symmetry.                  !
! Note: The real dimensions of A are (2*NmaxL,2*NmaxC). The rows are characterized !
! by the azimuthal indices                                                         !
!                             m = 0,-1,+1,-2,+2,...,                               !
! while the columns are characterized by zhe azimuthal indices                     ! 
!                             m'= 0,+1,-1,+2,-2,...                                !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Nazimutsym, Mrank, Nrank, NmaxC, NmaxL, nap, map  
  complex(O) :: A(2*nap,2*map)
  logical    :: mirror
!
  integer    :: m, ml, n, m1, m1l, n1, i, j, p, Nc, Nl, l, l1
  real(O)    :: dalfa, arg, sp, sm 
  complex(O) :: fact
!
  if (Nazimutsym >= 2 .or. mirror) then
    if (Nazimutsym >= 2) dalfa = 2._O * Pi / Nazimutsym
    do m = 0, Mrank
      if (m == 0) then
        ml = m
        do i = 1, Nrank
          n = i
          do m1 = 0, Mrank
            if (m1 == 0) then
              m1l = m1                    
              if (mirror) then                         
                do j = 1, Nrank
                  n1 = j
                  sp = 1._O + (-1._O)**(n + n1 + m + m1)
                  sm = 2._O - sp
                  A(i,j) = sp * A(i,j)
                  A(i,j+NmaxC) = sm * A(i,j+NmaxC)
                  A(i+NmaxL,j) = sm * A(i+NmaxL,j)
                  A(i+NmaxL,j+NmaxC) = sp * A(i+NmaxL,j+NmaxC)
                end do
              end if 
              if (Nazimutsym >= 2) then
                fact = one
                do p = 2, Nazimutsym
                  arg  = real((ml + m1l) * (p - 1),O) * dalfa
                  fact = fact + exp(im * arg)
                end do
                do j = 1, Nrank                    
                  A(i,j) = fact * A(i,j)
                  A(i,j+NmaxC) = fact * A(i,j+NmaxC)
                  A(i+NmaxL,j) = fact * A(i+NmaxL,j)
                  A(i+NmaxL,j+NmaxC) = fact * A(i+NmaxL,j+NmaxC)
                end do
              end if
            else                          
              m1l = m1                    
              Nc  = Nrank + (m1 - 1) * (2*Nrank - m1 + 2)
              do l1 = 1, 2
                if (mirror) then
                  do j = 1, Nrank - m1 + 1
                    n1 = m1 + j - 1 
                    sp = 1._O + (-1._O)**(n + n1 + m + m1)
                    sm = 2._O - sp             
                    A(i,j+Nc) = sp * A(i,j+Nc) 
                    A(i,j+Nc+NmaxC) = sm * A(i,j+Nc+NmaxC)
                    A(i+NmaxL,j+Nc) = sm * A(i+NmaxL,j+Nc)
                    A(i+NmaxL,j+Nc+NmaxC) = sp * A(i+NmaxL,j+Nc+NmaxC)
                  end do
                end if
                if (Nazimutsym >= 2) then
                  fact = one
                  do p = 2, Nazimutsym
                    arg  = real((ml + m1l) * (p - 1),O) * dalfa
                    fact = fact + exp(im * arg)
                  end do                                  
                  do j = 1, Nrank - m1 + 1                                     
                    A(i,j+Nc) = fact * A(i,j+Nc) 
                    A(i,j+Nc+NmaxC) = fact * A(i,j+Nc+NmaxC)
                    A(i+NmaxL,j+Nc) = fact * A(i+NmaxL,j+Nc)
                    A(i+NmaxL,j+Nc+NmaxC) = fact * A(i+NmaxL,j+Nc+NmaxC)
                  end do
                end if
                m1l = - m1l
                Nc  =   Nc + Nrank - m1 + 1
              end do                      
            end if
          end do
        end do
      else
        ml = - m 
        Nl =   Nrank + (m - 1) * (2 * Nrank - m + 2)
        do l = 1, 2
          do i = 1, Nrank - m + 1
            n = m + i - 1
            do m1 = 0, Mrank
              if (m1 == 0) then
                m1l = m1
                if (mirror) then
                  do j = 1, Nrank                                   
                    n1 = j 
                    sp = 1._O + (-1._O)**(n + n1 + m + m1)
                    sm = 2._O - sp  
                    A(i+Nl,j) = sp * A(i+Nl,j)
                    A(i+Nl,j+NmaxC) = sm * A(i+Nl,j+NmaxC)
                    A(i+Nl+NmaxL,j) = sm * A(i+Nl+NmaxL,j)
                    A(i+Nl+NmaxL,j+NmaxC) = sp * A(i+Nl+NmaxL,j+NmaxC)
                  end do
                end if
                if (Nazimutsym >= 2) then
                  fact = one
                  do p = 2, Nazimutsym
                    arg  = real((ml + m1l) * (p - 1),O) * dalfa
                    fact = fact + exp(im * arg)
                  end do
                  do j = 1, Nrank                            
                    A(i+Nl,j) = fact * A(i+Nl,j)
                    A(i+Nl,j+NmaxC) = fact * A(i+Nl,j+NmaxC)
                    A(i+Nl+NmaxL,j) = fact * A(i+Nl+NmaxL,j)
                    A(i+Nl+NmaxL,j+NmaxC) = fact * A(i+Nl+NmaxL,j+NmaxC)
                  end do
                end if
              else
                m1l = m1
                Nc  = Nrank + (m1 - 1) * (2 * Nrank - m1 + 2)
                do l1 = 1, 2
                  if (mirror) then
                    do j = 1, Nrank - m1 + 1
                      n1 = m1 + j - 1 
                      sp = 1._O + (-1._O)**(n + n1 + m + m1)
                      sm = 2._O - sp              
                      A(i+Nl,j+Nc) = sp * A(i+Nl,j+Nc)
                      A(i+Nl,j+Nc+NmaxC) = sm * A(i+Nl,j+Nc+NmaxC)
                      A(i+Nl+NmaxL,j+Nc) = sm * A(i+Nl+NmaxL,j+Nc)
                      A(i+Nl+NmaxL,j+Nc+NmaxC) = sp * A(i+Nl+NmaxL,j+Nc+NmaxC) 
                    end do
                  end if
                  if (Nazimutsym >= 2) then
                    fact = one
                    do p = 2, Nazimutsym
                      arg  = real((ml + m1l) * (p - 1),O) * dalfa
                      fact = fact + exp(im * arg)
                    end do
                    do j = 1, Nrank - m1 + 1                                               
                      A(i+Nl,j+Nc) = fact * A(i+Nl,j+Nc)
                      A(i+Nl,j+Nc+NmaxC) = fact * A(i+Nl,j+Nc+NmaxC)
                      A(i+Nl+NmaxL,j+Nc) = fact * A(i+Nl+NmaxL,j+Nc)
                      A(i+Nl+NmaxL,j+Nc+NmaxC) = fact * A(i+Nl+NmaxL,j+Nc+NmaxC) 
                    end do
                  end if
                  m1l = - m1l
                  Nc  =  Nc + Nrank - m1 + 1
                end do
              end if
            end do
          end do
          ml = - ml
          Nl =   Nl + Nrank - m + 1
        end do
      end if  
    end do
  end if            
end subroutine AzimMirSym
!***********************************************************************************
subroutine ConvergenceMatrixElem ( index1, index2, TypeGeom, Nsurf, Nparam, ml, mc, &
           Nrank, NintMax, Nint1, Nint2, Nazimutsym, k, surf, kb, ind_ref, mirror,  &
           perfectcond, chiral )  
  use parameters
  use derived_parameters
  implicit none
  integer    :: index1, index2, TypeGeom, Nsurf, Nparam, ml, mc, Nrank, NintMax,    &
                Nint1, Nint2, Nazimutsym                  
  real(O)    :: k, surf(Nsurf), kb
  complex(O) :: ind_ref
  logical    :: mirror, perfectcond, chiral
!      
  integer    :: NmaxL, NmaxC, ml_minus, i, j, Nint1l, Nint2l, NintAL, iparam,       &
                Nintl, pint, iint, imn, jmn   
  real(O)    :: r, theta, phi, dA, param1, param2, pondere, nuv(3), sign, MaxA(2),  &
                MinA(2)
  complex(O) :: ki, zc, zl, zcl, zcr, fact, f, mvl(3), nvl(3), mvc(3), nvc(3), v1,  &
                v2, mixt_product, A11(2,2), A12(2,2), A21(2,2), A22(2,2), expfctL,  &
                expfctC
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG1(:,:), paramG2(:,:), weightsG(:,:) 
  complex(O),allocatable :: mvl1(:,:), nvl1(:,:), mvr1(:,:), nvr1(:,:) 
  complex(O),allocatable :: mv1(:,:), nv1(:,:), mv3(:,:), nv3(:,:)  
!
  NmaxL = Nrank - ml + 1
  NmaxC = Nrank - mc + 1
  ml_minus = - ml                     
  allocate (mv1(3,NmaxC), nv1(3,NmaxC), mv3(3,NmaxL), nv3(3,NmaxL))        
  if (chiral) allocate (mvl1(3,NmaxC), nvl1(3,NmaxC), mvr1(3,NmaxC), nvr1(3,NmaxC))  
  ki   = k * ind_ref
  sign = 1._O
  if (index1 == 3 .and. index2 == 1) sign = - 1._O
  f = sign * im * k * k / Pi 
  if (ml == 1) then 
    print "(2x,'Integral Test over Matrix Elements of Blocks (1,Mrank):')"
  else 
    print "(2x,'Integral Test over Matrix Elements of Blocks (Mrank,Mrank):')"
  end if
  print "(2x,'Nint1   Nint2          max-min (A11,A22)             max-min (A12,A21) ')"            
  do iint = 1, NintMax
    Nint1l = Nint1 + iint - 1
    Nint2l = Nint2 + iint - 1
    NintAL = max(Nint1l,Nint2l)                      
    allocate (paramG1(Nparam,NintAL*NintAL), paramG2(Nparam,NintAL*NintAL),         &
              weightsG(Nparam,NintAL*NintAL))
    allocate (Nintparam(Nparam))
    call interpolation_list3D (TypeGeom, Nsurf, surf, Nint1l, Nint2l, NintAL,       &
         Nparam, Nintparam, paramG1, paramG2, weightsG, mirror, Nazimutsym) 
    do i = 1, 2
      do j = 1, 2
        A11(i,j) = zero
        A12(i,j) = zero
        A21(i,j) = zero
        A22(i,j) = zero
      end do
    end do  
    do iparam = 1, Nparam
      Nintl = Nintparam(iparam)
      do pint = 1, Nintl
        param1  = paramG1(iparam,pint)
        param2  = paramG2(iparam,pint)
        pondere = weightsG(iparam,pint)       
        call elem_geom3D (TypeGeom, Nsurf, surf, param1, param2, iparam, r, theta,  &
             phi, dA, nuv, mirror, Nazimutsym)                       
        zc = ki * r
        zl = cmplx(k * r,0.0,O)
        if (chiral) then
          zcl = zc / (1._O - kb)
          zcr = zc / (1._O + kb)
        end if                    
        if (index1 == 3 .and. index2 == 1) then
          call MN (3, zl, theta, ml_minus, Nrank, NmaxL, mv3, nv3)
          if (.not. chiral) then
            call MN (1, zc, theta, mc, Nrank, NmaxC, mv1, nv1)             
          else
            call MN (1, zcl, theta, mc, Nrank, NmaxC, mvl1, nvl1)
            call MN (1, zcr, theta, mc, Nrank, NmaxC, mvr1, nvr1)
            call MN_left_right (NmaxC, mvl1, nvl1, mvr1, nvr1, mv1, nv1)
          end if                    
        else if (index1 == 1 .and. index2 == 1) then
          call MN (1, zl, theta, ml_minus, Nrank, NmaxL, mv3, nv3)
          if (.not. chiral) then
            call MN (1, zc, theta, mc, Nrank, NmaxC, mv1, nv1)       
          else 
            call MN (1, zcl, theta, mc, Nrank, NmaxC, mvl1, nvl1)
            call MN (1, zcr, theta, mc, Nrank, NmaxC, mvr1, nvr1)
            call MN_left_right (NmaxC, mvl1, nvl1, mvr1, nvr1, mv1, nv1)
          end if                
        end if
        fact    = f * dA * pondere       
        expfctL =  exp(im * ml_minus * phi)
        expfctC =  exp(im * mc * phi)
        do i = 1, 2
          if (i == 1) then
            imn = 1
          else
            imn = NmaxL
          end if     
          mvl(1) = mv3(1,imn) * expfctL
          mvl(2) = mv3(2,imn) * expfctL
          mvl(3) = mv3(3,imn) * expfctL
          nvl(1) = nv3(1,imn) * expfctL
          nvl(2) = nv3(2,imn) * expfctL
          nvl(3) = nv3(3,imn) * expfctL
          do j = 1, 2
            if (j == 1) then
              jmn = 1
            else
              jmn = NmaxC
            end if 
            mvc(1) = mv1(1,jmn) * expfctC
            mvc(2) = mv1(2,jmn) * expfctC
            mvc(3) = mv1(3,jmn) * expfctC
            nvc(1) = nv1(1,jmn) * expfctC
            nvc(2) = nv1(2,jmn) * expfctC
            nvc(3) = nv1(3,jmn) * expfctC
            if (.not. chiral) then
              v1 = mixt_product (nuv, mvc, nvl)
              v2 = mixt_product (nuv, nvc, mvl)
              if (.not. perfectcond) then
                A11(i,j) = A11(i,j) + (v1 + ind_ref * v2) * fact          
              else 
                A11(i,j) = A11(i,j) + v2 * fact          
              end if
            else 
              v1 = mixt_product (nuv, mvc, nvl)
              v2 = mixt_product (nuv, mvc, mvl)             
              A11(i,j) = A11(i,j) + (v1 + ind_ref * v2) * fact                  
            end if                                                                                
            if (.not. chiral) then             
              v1 = mixt_product (nuv, nvc, nvl)
              v2 = mixt_product (nuv, mvc, mvl)
              if (.not. perfectcond) then
                A12(i,j) = A12(i,j) + (v1 + ind_ref * v2) * fact                        
              else 
                A12(i,j) = A12(i,j) + v2 * fact                 
              end if
              v1 = mixt_product (nuv, mvc, mvl)
              v2 = mixt_product (nuv, nvc, nvl)
              if (.not. perfectcond) then
                A21(i,j) = A21(i,j) + (v1 + ind_ref * v2) * fact                        
              else 
                A21(i,j) = A21(i,j) + v2 * fact                 
              end if              
            else 
              v1 = mixt_product (nuv, nvc, nvl)
              v2 = mixt_product (nuv, nvc, mvl)                   
              A12(i,j) = A12(i,j) + (v1 - ind_ref * v2) * fact
              v1 = mixt_product (nuv, mvc, mvl)
              v2 = mixt_product (nuv, mvc, nvl)                   
              A21(i,j) = A21(i,j) + (v1 + ind_ref * v2) * fact 
            end if
            if (.not. chiral) then 
              v1 = mixt_product (nuv, nvc, mvl)
              v2 = mixt_product (nuv, mvc, nvl)
              if (.not. perfectcond) then
                A22(i,j) = A22(i,j) + (v1 + ind_ref * v2) * fact          
              else 
                A22(i,j) = A22(i,j) + v2 * fact              
              end if
            else 
              v1 = mixt_product (nuv, nvc, mvl)
              v2 = mixt_product (nuv, nvc, nvl)             
              A22(i,j) = A22(i,j) + (v1 - ind_ref * v2) * fact  
            end if                                
          end do   
        end do
      end do
    end do     
    MaxA(1) = max(abs(A11(1,1)), abs(A11(1,2)), abs(A11(2,1)), abs(A11(2,2)),       &
                  abs(A22(1,1)), abs(A22(1,2)), abs(A22(2,1)), abs(A22(2,2)))
    MinA(1) = min(abs(A11(1,1)), abs(A11(1,2)), abs(A11(2,1)), abs(A11(2,2)),       &
                  abs(A22(1,1)), abs(A22(1,2)), abs(A22(2,1)), abs(A22(2,2)))
        
    MaxA(2) = max(abs(A12(1,1)), abs(A12(1,2)), abs(A12(2,1)), abs(A12(2,2)),       &
                  abs(A21(1,1)), abs(A21(1,2)), abs(A21(2,1)), abs(A21(2,2)))
    MinA(2) = min(abs(A12(1,1)), abs(A12(1,2)), abs(A12(2,1)), abs(A12(2,2)),       &
                  abs(A21(1,1)), abs(A21(1,2)), abs(A21(2,1)), abs(A21(2,2)))       
    print "(3x,i3,5x,i3,4x,1pe14.6,1x,1pe14.6,1x,1pe14.6,1x,1pe14.6)", Nint1l,      &
            Nint2l, MaxA(1), MinA(1), MaxA(2), MinA(2)                                                          
    deallocate (paramG1, paramG2, weightsG, Nintparam)
  end do
  deallocate (mv1, nv1, mv3, nv3)
  if (chiral) deallocate (mvl1, nvl1, mvr1, nvr1) 
end subroutine ConvergenceMatrixElem            
   
  

subroutine TINHOM2SPH
!------------------------------------------------------------------------------------
! 1. General Considerations                                                         !
! --------------------------                                                        !
! TINHOM2SPH is a routine for computing the T matrix and the scattering             !
! characteristics of an an inhomogeneous, dielectric sphere with a spherical        !
! inclusion. The program supports calculation for dielectric host spheres with      !
! REAL refractive indices.                                                          !
!                                                                                   !
! For axisymmetric inhomogeneous particles, the scattering problem decouples over   !
! the azimuthal modes m and the T matrix can be computed separately for each m.     !
!                                                                                   !
! 2. Convergence Test                                                               !
! --------------------                                                              !
! Convergence tests precede the scattering characteristics calculation. The         !
! parameters which control the T-matrix computation are the maximum expansion order !
! Nrank, and the maximum azimuthal order Mrank for the host particle.               ! 
!                                                                                   !
! For convergence tests, the incident wave is assumed to be a plane wave traveling  !
! along the Z-axis of the global coordinate system and the scattering               !
! characteristics are computed in the azimuthal plane  phi = 0°.  The convergence   !
! test over Nrank is interactive, while the convergence test over Mrank is          !
! automatically performed.                                                          !
!                                                                                   !
! Nrank is assumed to not depend on Nrank1, which is the maximum expansion order    !
! of the inclusion. The convergence tests are carried out over Nrank and Mrank,     !
! while Nrank1 is kept constant. For the expansion order test, an axisymmetric      !
! orientation of the inhomogeneous particle is considered, i.e., the incident wave  !
! propagates along the axis of symmetry of the particle. In this case, all          !
! azimuthal modes are zero except for m = - 1 and m = 1. The scattering problem is  !
! solved for Nrank and Nrank - 1 and the normalized differential scattering cross   !
! section (DSCS) will be checked at 20° increments for convergence within epsNrank  !
! tolerance. If the calculated results converge within this tolerance at 80% of     !
! the scattering angles, then  convergence is achieved.                             !
!                                                                                   ! 
! After Nrank has been determined we pass to the azimuthal order test. The program  !
! automatically sets the particle to a more general orientation, i.e., alpha =      !
! beta = 45°, and solves the scattering problem  for increasing m values until      !
! convergence of the angular scattering is achieved. The T matrix is stored for     !
! later use by other programs, and the values of Nrank and Mrank are printed to     !
! the screen and to the T-matrix information file (see "Description.txt"). These    !
! values together with the T matrix serve as INPUT PARAMETERS for other programs.   !
!                                                                                   ! 
! The above convergence tests require an estimate of Nrank. This estimate must be   !
! supplied by the user, and for this purpose, Wiscomb's truncation limit criterion  !
! [W. J. Wiscombe, Improved Mie scattering algorithms, Applied Optics, 19,          !
! 1505-1509, 1980] can be used.                                                     !
!                                                                                   !
! The truncation limit criterion proposed by Wiscombe provides the estimate         !
!                                                                                   !
!                NrankW = int(x + 4.05 * x**0.33 + 2),                              !
!                                                                                   ! 
! where x is the size parameter, x = k * r, k is the wave number and r is the       !
! radius of the host sphere.                                                        !
!                                                                                   !
! The convergence test over Nrank can be switched off by setting the logical        !
! variable DoConvTest to false. In this case, the value of Nrank must be specified  !
! in the input file.                                                                !
!                                                                                   !
! 3. Input Parameters                                                               !
! --------------------                                                              !
! The parameters specified in the input file "/INPUTFILES/InputINHOM2SPH.dat"       !
! are listed below.                                                                 !
!                                                                                   !
! - wavelength (real) - wavelength of the incident light in vacuo.                  !
!                                                                                   !
! - ind_refMed (real) - refractive index of the ambient medium (nonabsorbing        !
!   dielectric medium).                                                             !
!                                                                                   !
! - ind_refRel (REAL) - relative refractive index of the host sphere with respect   !
!   to the ambient medium.                                                          !
!                                                                                   !
! - ind_refRel1 (complex) - relative refractive index of the spherical inclusion    !
!   with respect to the host sphere.                                                !
!                                                                                   !
! - r (real) - radius of the host sphere.                                           !
!                                                                                   !
! - anorm (real) - characteristic length of the host sphere which is used to        !
!   normalize the differential scattering cross sections.                           !
!                                                                                   !
! - Nrank1 (integer) - maximum expansion order for the spherical inclusion.         !
!                                                                                   !
! - r1 (real) - radius of the spherical inclusion.                                  !
!                                                                                   !
! - z1 (real) - axial position of the spherical inclusion origin with respect to    !
!   the host sphere.                                                                !
!                                                                                   !
! - DoConvTest (logical) - if DoConvTest = t, the interactive convergence test      !
!   over Nrank is performed. An estimates of Nrank is given by Wiscombe's           !
!   truncation limit criterion. If DoConvTest = f, the value of Nrank must be       !
!   supplied in the input file.                                                     !
!                                                                                   !
! - Nrank (integer) - maximum expansion order for the host sphere. This             !
!   parameter is used if the convergence test is not performed (DoConvTest = f).    !
!                                                                                   !
!   The following table explain the significance of the variable Nrank.             !
!                                                                                   !
!          DoConvTest           Nrank             TypeConvTest                      !
!              t             console input          1 or 2                          !
!              f              file input              2                             !
!                                                                                   !  
!   The significance of the variable TypeConvTest is summarized below.              !
!                                                                                   !
!           TypeConvTest                    Significance                            !  
!               1                      convergence test over Nrank                  ! 
!               2                      convergence test over Mrank                  !
!                                                                                   !
! - epsNrank (real) - error tolerance for the expansion order test.                 !
!                                                                                   !
! - epsMrank (real) - error tolerance for the azimuthal order test.                 !
!                                                                                   !
! - FileTmat (character(80)) - name of the file to which the T matrix of the        !
!   inhomogeneous spherical particle is written.                                    !
!                                                                                   !
! - PrnProgress (logical) - if PrnProgress = t, the progress of calculation         !
!   is printed.                                                                     !
!                                                                                   !
! Note that all input parameters specifying lengths must be provided in the same    !
! units of lengths.                                                                 !
!                                                                                   !
! 4. Logical Scheme                                                                 !
! ------------------                                                                !  
! The organization of the code is as follows:                                       !
! 1. < read input data; the input file provides                                     !
!    - the maximum expansion order Nrank1 for the inclusion,                        ! 
!    - the radius of the spherical inclusion, and                                   !
!    - the axial position of the inclusion with respect to the host particle >      !  
!                                                                                   !
! 2. < T-matrix calculation >                                                       !
!                                                                                   !
!    if ( do convergence test ) then                                                !
!                                                                                   !
!       < the code computes an estimate of Nrank accordingly to                     !
!         Wiscombe's truncation criterion >                                         !
!       < the code prompts for the estimated value of Nrank >                       !
!       < the code prompts for the type of convergence test:                        !
!         1 - over Nrank, 2 - over Mrank >                                          !
!                                                                                   !
!    else if ( .not. do convergence test ) then                                     !
!                                                                                   !
!       < the input file provides the value of Nrank >                              !
!       type of convergence test = 2 (convergence test over Mrank)                  !
!                                                                                   !
!    end if                                                                         !
!    if ( do expansion order test, i.e., type of convergence test = 1 ) then        !
!       < the code computes the DSCS for Nrank and Nrank - 1 and                    !
!         write the results to the file "Output.dat" >                              !
!       < the execution is terminated >                                             !
!    end if                                                                         !
!    if ( do azimuthal order test, i.e., type of convergence test = 2 ) then        !
!       < the code computes the DSCS for increasing m values and                    !
!         write the results to the file "Output.dat" >                              !
!       < the T matrix is stored in the file FileTmat and the T-matrix information  !
!         file is created >                                                         !
!       < Mrank and Nrank are written to the screen and to the T-matrix             !
!         information file >                                                        ! 
!       < go to Step 3 >                                                            !
!    end if                                                                         !
! 3. < scattering characteristics calculation >                                     !    
!------------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none 
  integer       :: Nrank, Nrank1, TypeConvTest                     
  real(O)       :: ks, ind_refMed, ind_refRel, wavelength, r, r1, anorm, snorm,     &
                   epsNrank, epsMrank, z1 
  complex(O)    :: ind_refRel1
  character(80) :: FileTmat
  logical       :: DoConvTest, PrnProgress
! -----------------------------------------------------------------------------------
!                                Read the input file                                ! 
! -----------------------------------------------------------------------------------
  call readinputINHOM2SPH ( wavelength, ind_refMed, ind_refRel, ind_refRel1, r,     &
       anorm, Nrank1, r1, z1, DoConvTest, Nrank, epsNrank, epsMrank, FileTmat,      &
       PrnProgress, TypeConvTest, ks, snorm ) 
! -----------------------------------------------------------------------------------
!                                      Main                                         !
! -----------------------------------------------------------------------------------                   
  open (unit = iOutput, file = FileOutput, status = "replace") 
  call printinputINHOM2SPH (wavelength, anorm, ind_refMed, ind_refRel, ind_refRel1, &
       r, r1, z1, Nrank1, epsNrank, epsMrank)
  if (DoConvTest) then
    if (TypeConvTest == 1) then
      call convergence_NrankINHOM2SPH (ks, ind_refRel, ind_refRel1, r, r1, snorm,   &
           z1, Nrank, Nrank1, epsNrank, PrnProgress )
    else
      call convergence_MrankINHOM2SPH (ks, ind_refRel, ind_refRel1, r, r1, snorm,   &
           z1, Nrank, Nrank1, epsMrank, FileTmat, PrnProgress )    
    end if 
  else
    call convergence_MrankINHOM2SPH (ks, ind_refRel, ind_refRel1, r, r1, snorm, z1, &
         Nrank, Nrank1, epsMrank, FileTmat, PrnProgress )
  end if
  close (unit = iOutput)  
end subroutine TINHOM2SPH
!***********************************************************************************
subroutine readinputINHOM2SPH ( wavelength, ind_refMed, ind_refRel, ind_refRel1,    &
           r, anorm, Nrank1, r1, z1, DoConvTest, Nrank, epsNrank, epsMrank,         &
           FileTmat, PrnProgress, TypeConvTest, ks, snorm) 
  use parameters
  use derived_parameters
  implicit none 
  integer       :: Nrank, Nrank1, NrankW, TypeConvTest, ios                     
  real(O)       :: ks, ind_refMed, ind_refRel, wavelength, r, r1, anorm, xpart,     &
                   snorm, epsNrank, epsMrank, z1, x 
  complex(O)    :: ind_refRel1
  character(80) :: FileTmat, string
  logical       :: DoConvTest, PrnProgress, XFindPar
! -----------------------------------------------------------------------------------
!                       Read the input file FileInputINHOM2SPH                      ! 
! -----------------------------------------------------------------------------------    
  call DrvParameters  
  open (unit = iInputINHOM2SPH, file = FileInputINHOM2SPH, status = "old",          &
        position = "rewind")   
  wavelength  = 0.1_O * 2._O * Pi
  ind_refMed  = 1._O
  ind_refRel  = 1.2_O
  ind_refRel1 = (1.5_O,0._O)
  string     = 'OptProp'
  if (XFindPar (iInputINHOM2SPH, string)) then
    read (iInputINHOM2SPH, *, iostat = ios) wavelength
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if
    read (iInputINHOM2SPH, *, iostat = ios) ind_refMed
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refMed;')"
      stop
    end if
    read (iInputINHOM2SPH, *, iostat = ios) ind_refRel
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refRel;')"
      stop
    end if 
    read (iInputINHOM2SPH, *, iostat = ios) ind_refRel1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refRel1;')"
      stop
    end if
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if  
  call check_ind_ref (ind_refRel1) 
  ks = 2._O * Pi * ind_refMed / wavelength
!     
  r = 1._O  
  anorm  = 1._O
  string = 'GeomPropHost'
  if (XFindPar (iInputINHOM2SPH, string)) then
    read (iInputINHOM2SPH, *, iostat = ios) r
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable r;')"
      stop
    end if
    read (iInputINHOM2SPH, *, iostat = ios) anorm
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anorm;')"
      stop
    end if
  else
    print "(/,2x,'Group name GeomPropHost not found;')"
    stop  
  end if  
  call check_anorm (anorm)    
  xpart = ks * anorm
  snorm = Pi * xpart * xpart        
!
  Nrank1 = 12
  string = 'TmatIncl'
  if (XFindPar (iInputINHOM2SPH, string)) then
    read (iInputINHOM2SPH, *, iostat = ios) Nrank1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nrank1;')"
      stop
    end if
  else
    print "(/,2x,'Group name TmatIncl not found;')"
    stop  
  end if                            
!
  r1 = 0.5_O  
  z1 = 0.3_O  
  string = 'GeomPropIncl'
  if (XFindPar (iInputINHOM2SPH, string)) then
    read (iInputINHOM2SPH, *, iostat = ios) r1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable r1;')"
      stop
    end if
    read (iInputINHOM2SPH, *, iostat = ios) z1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable z1;')"
      stop
    end if
  else
    print "(/,2x,'Group name GeomPropIncl not found;')"
    stop  
  end if         
!
  DoConvTest = .true.
  string     = 'ConvTest'
  if (XFindPar (iInputINHOM2SPH, string)) then
    read (iInputINHOM2SPH, *, iostat = ios) DoConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DoConvTest;')"
      stop
    end if
  else
    print "(/,2x,'Group name ConvTest not found;')"
    stop  
  end if
! 
  if (DoConvTest) then  
    print "(/,2x,'Convergence Test for an Inhomogeneous Sphere')"
    print "(  2x,'--------------------------------------------')"
  else
    print "(/,2x,'Convergence Test for an Inhomogeneous Sphere over Mrank')"
    print "(  2x,'-------------------------------------------------------')"
  end if      
!
  x = ks * r
  NrankW = int(x + 4.05_O * x**0.33_O + 2._O)
  if (.not. DoConvTest) then        
    Nrank  =  17
    string = 'NrankHost'
    if (XFindPar (iInputINHOM2SPH, string)) then
      read (iInputINHOM2SPH, *, iostat = ios) Nrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nrank;')"
        stop
      end if
    else
      print "(/,2x,'Group name NrankHost not found;')"
      stop  
    end if
    print "(/,2x,'Input values:')"
    print "(  2x,'the input value of Nrank is ', i3,', while the estimated')", Nrank 
    print "(  2x,'value of Nrank from Wiscombe''s criterion is ', i3,';')", NrankW                      
  else    
    print "(/,2x,'Nrank estimate:')"                                                    
    print "(  2x, a, i3, a)",                                                       &
   'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'                             
    print "(/,2x,'- enter the estimated value of Nrank;')"
    call read_integer (Nrank)  
  end if
  if (Nrank < Nrank1) print "(/,2x,'Warning: the value of Nrank is too low;')"
!
  if (DoConvTest) then  
    print "(/,2x,'- enter the type of convergence test: 1 - Nrank, 2 - Mrank;')"
    call read_integerbound (TypeConvTest, 1, 2)
  else
    TypeConvTest = 2
  end if 
!
  epsNrank = 5.e-2_O
  epsMrank = 5.e-2_O 
  string   = 'Errors'
  if (XFindPar (iInputINHOM2SPH, string)) then
    read (iInputINHOM2SPH, *, iostat = ios) epsNrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNrank;')"
      stop
    end if
    read (iInputINHOM2SPH, *, iostat = ios) epsMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsMrank;')"
      stop
    end if
  else
    print "(/,2x,'Group name Errors not found;')"
    stop  
  end if       
!
  FileTmat = '../TMATFILES/T.dat'
  string   = 'Tmat'
  if (XFindPar (iInputINHOM2SPH, string)) then
    read (iInputINHOM2SPH, *, iostat = ios) FileTmat
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileTmat;')"
      stop
    end if
  else
    print "(/,2x,'Group name Tmat not found;')"
    stop  
  end if        
!
  PrnProgress = .true.
  string      = 'PrintProgress'
  if (XFindPar (iInputINHOM2SPH, string)) then
    read (iInputINHOM2SPH, *, iostat = ios) PrnProgress
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if
  else
    print "(/,2x,'Group name PrintProgress not found;')"
    stop  
  end if    
  close (unit = iInputINHOM2SPH)
end subroutine readinputINHOM2SPH
!***********************************************************************************
subroutine printinputINHOM2SPH (wavelength, anorm, ind_refMed, ind_refRel,          &
           ind_refRel1, r, r1, z1, Nrank1, epsNrank, epsMrank)
  use parameters
  implicit none
  integer       :: Nrank1 
  real(O)       :: wavelength, anorm, ind_refMed, ind_refRel, r, r1, z1, epsNrank,  &
                   epsMrank
  complex(O)    :: ind_refRel1 
!
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x,'wavelength of the free space, wavelength = ',1pe13.4,';')")  &
         wavelength
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'refractive index of the ambient medium, ind_refMed = ', ind_refMed, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'relative refractive index of the host particle, ind_refRel = ', ind_refRel, ';'
  write (iOutput,"(2x,'relative refractive index of the inclusion with respect ')")
  write (iOutput,"(2x, a, 1pe10.3,',', 1pe10.3, a)")                                &
 'to the host particle, ind_refRel1 = (', ind_refRel1, ');' 
  write (iOutput,*)
  write (iOutput,"(2x,'radius of the host particle, r = ',1pe10.3,';')") r
  write (iOutput,"(2x,'radius of the inclusion, r1 = ',1pe10.3,';')") r1
  write (iOutput,"(2x, a, i3, a)")                                                  &
 'maximum expansion order for the inclusion: Nrank = ', Nrank1, ';'
  write (iOutput,"(2x,'axial position of the inclusion, z1 = ', 1pe10.3,';')") z1
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'characteristic length of the host particle, anorm = ', anorm, ';'  
  write (iOutput,*) 
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum expansion order tolerance, epsNrank = ', epsNrank, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum azimuthal order tolerance, epsMrank = ', epsMrank, '.'            
  write (iOutput,"(/)")                       
end subroutine printinputINHOM2SPH
!***********************************************************************************
subroutine convergence_NrankINHOM2SPH (ks, ind_ref, ind_ref1, r, r1, snorm, z1,     &
           Nrank, Nrank1, epsNrank, PrnProgress )          
  use parameters
  implicit none
  integer       :: Mrank, Nrank, Nrank1 
  real(O)       :: ks, ind_ref, r, r1, snorm, epsNrank, z1
  complex(O)    :: ind_ref1           
  logical       :: PrnProgress 
!       
  integer       :: Nteta, MM, NN, Mstart, Nmaxmax, m, Nmax, Nmax1, i, NthetaConv,   &
                   NrankAL
  real(O)       :: k, alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,  &
                   Cext, Qext 
  complex(O)    :: ind_refC     
  real(O),allocatable    :: h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: CC(:,:), S1(:,:), S2(:,:), S(:,:)
  complex(O),allocatable :: t(:), t1(:), t2(:), t3(:), t4(:), a(:,:), b(:,:), c(:), &
                            c1(:), ce(:) 
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1 
  MM = max(Nrank, Nrank1)
  NN = MM + 5
  Nmax  = Nrank
  Nmax1 = Nrank1 
  NrankAL = MM
  k = ks * ind_ref  
  ind_refC = cmplx(ind_ref,0.0,O)
  call write_TypeConvHead (2)
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)             
  allocate (CC(0:NN,0:2*NN+1))
  allocate (S1(2*NrankAL,2*NrankAL), S2(2*NrankAL,2*NrankAL),                       &
            S(2*NrankAL,2*NrankAL))
  allocate (t(2*NrankAL), t1(2*NrankAL), t2(2*NrankAL), t3(2*NrankAL),              &
            t4(2*NrankAL), a(2*NrankAL,2*NrankAL), b(2*NrankAL,2*NrankAL),          &
            c(2*NrankAL), c1(2*NrankAL))
  allocate (ce(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do
  if (PrnProgress) call write_progress (.true., 1, 7)    
! --- Nrank configuration ---
  do m = 0, 1                      
    call MatTransCmnn1 (1, k, -z1, m, NN, CC, NN)
    if (m /= 0) then
      call coefficients_fg_m (k, r1, ind_ref1, m, Nrank1, Nmax1, c)
      call MatTransAB_mnn1 (k, .true., -z1, m, CC, NN, Nmax1, Nmax, S2,             &
           NrankAL, NrankAL)
      call matrix_S1 (Nmax, Nmax1, S2, NrankAL, NrankAL, S1, NrankAL, NrankAL)
      call product_matrix_vector2 (2*Nmax1, 2*Nmax, c, S2, 2*NrankAL, 2*NrankAL)
      call product_matrices1 (2*Nmax, 2*Nmax1, 2*Nmax, S1, 2*NrankAL, 2*NrankAL,    &
           S2, 2*NrankAL, 2*NrankAL, S, 2*NrankAL, 2*NrankAL)
      if (PrnProgress) call write_progress (.false., 2, 7)
      call vector_Q_sphere1_m (1, 3, ks, r, ind_refC, m, Nrank, Nmax, t)
      call copy_vector (t, t1, 2*Nmax)          
      call product_matrix_vector1 (2*Nmax, 2*Nmax, t, S, 2*NrankAL, 2*NrankAL,      &
           b, 2*NrankAL, 2*NrankAL)
      call vector_Q_sphere1_m (1, 1, ks, r, ind_refC, m, Nrank, Nmax, t)
      call copy_vector (t, t2, 2*Nmax)  
      call sum_diagonal_elements (2*Nmax, t, b, 2*NrankAL, 2*NrankAL) 
      if (PrnProgress) call write_progress (.false., 3, 7)
      call vector_Q_sphere1_m (3, 3, ks, r, ind_refC, m, Nrank, Nmax, t)
      call copy_vector (t, t3, 2*Nmax)                  
      call product_matrix_vector1 (2*Nmax, 2*Nmax, t, S, 2*NrankAL, 2*NrankAL,      &
           a, 2*NrankAL, 2*NrankAL)
      call vector_Q_sphere1_m (3, 1, ks, r, ind_refC, m, Nrank, Nmax, t)
      call copy_vector (t, t4, 2*Nmax)  
      call sum_diagonal_elements (2*Nmax, t, a, 2*NrankAL, 2*NrankAL)
      if (PrnProgress) call write_progress (.false., 4, 7)
      call LU_SYSTEM (a, 2*NrankAL, 2*NrankAL, b, 2*NrankAL, 2*NrankAL, 2*Nmax)
      if (PrnProgress) call write_progress (.false., 5, 7)
      call minus_matrix (2*Nmax, 2*Nmax, b, 2*NrankAL, 2*NrankAL)
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,   &
           Nmax, c)
      call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*NrankAL, 2*NrankAL, c, c1)
      call extend_vector_positive (c1, ce, m, Mstart, Nrank, Nmax, Nmaxmax)
      call matrix_m_negativ (Nmax, Nmax, b, NrankAL, NrankAL)         
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,  &
           Nmax, c) 
      call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*NrankAL, 2*NrankAL, c, c1)
      call extend_vector_negative (c1, ce, m, Nrank, Nmax, Nmaxmax)
    end if
  end do                    
  call DSCS (ce, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, ks, snorm,  &
      .false.,.true., h, v)
  call CQscat (ce, Mrank, Nrank, Nmaxmax, ks, snorm, Cscat, Qscat)
  call CQext (ce, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama, alfap,    &
       ks, snorm, Cext, Qext)
  do i = 1, Nteta
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do  
  call write_2ConvParam (Nrank, Mrank)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
! --- (Nrank - 1) configuration ---
  m = 1 
  call matrix_Nrank_m (Nmax, S, NrankAL, NrankAL)
  call copy_vector (t1, t, 2*Nmax)
  call vector_Nrank_m (Nmax, t) 
  call product_matrix_vector1 (2*Nmax, 2*Nmax, t, S, 2*NrankAL, 2*NrankAL, b,       &
       2*NrankAL, 2*NrankAL)
  call copy_vector (t2, t, 2*Nmax)
  call vector_Nrank_m (Nmax, t)
  call sum_diagonal_elements (2*Nmax, t, b, 2*NrankAL, 2*NrankAL) 
  call copy_vector (t3, t, 2*Nmax)      
  call vector_Nrank_m (Nmax, t)
  call product_matrix_vector1 (2*Nmax, 2*Nmax, t, S, 2*NrankAL, 2*NrankAL, a,       &
       2*NrankAL, 2*NrankAL)
  call copy_vector (t4, t, 2*Nmax)      
  call vector_Nrank_m (Nmax, t)
  call sum_diagonal_elements (2*Nmax, t, a, 2*NrankAL, 2*NrankAL) 
  call matrix_Nrank_m_left (Nmax, a, NrankAL, NrankAL)
  if (PrnProgress) call write_progress (.false., 6, 7)
  call LU_SYSTEM (a, 2*NrankAL, 2*NrankAL, b, 2*NrankAL, 2*NrankAL, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 7, 7)
  call minus_matrix (2*Nmax, 2*Nmax, b, 2*NrankAL, 2*NrankAL)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,       &
       Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*NrankAL, 2*NrankAL, c, c1)
  call extend_vector_positive (c1, ce, m, Mstart, Nrank, Nmax, Nmaxmax)
  call matrix_m_negativ (Nmax, Nmax, b, NrankAL, NrankAL)             
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,      &
       Nmax, c) 
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*NrankAL, 2*NrankAL, c, c1)
  call extend_vector_negative (c1, ce, m, Nrank, Nmax, Nmaxmax)     
  call DSCS (ce, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, ks, snorm,  &
      .false.,.true., h, v)
  call CQscat (ce, Mrank, Nrank, Nmaxmax, ks, snorm, Cscat, Qscat)
  call CQext (ce, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, ks, snorm, Cext, Qext)
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConv)  
  call write_2ConvParam (Nrank - 1, Mrank)
  call write_DSCS (Nteta,.false., h, v) 
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConv, Nteta, epsNrank)
  deallocate (CC, S1, S2, S, t, t1, t2, t3, t4, a, b, c, c1, ce, h, v, oldh, oldv) 
end subroutine convergence_NrankINHOM2SPH
!***********************************************************************************
subroutine convergence_MrankINHOM2SPH (ks, ind_ref, ind_ref1, r, r1, snorm, z1,     &
           Nrank, Nrank1, epsMrank, FileTmat, PrnProgress )          
  use parameters
  implicit none
  integer       :: Mrank, Nrank, Nrank1 
  real(O)       :: ks, ind_ref, r, r1, snorm, epsMrank, z1
  complex(O)    :: ind_ref1           
  character(80) :: FileTmat
  logical       :: PrnProgress 
!       
  integer       :: Nteta, MM, NN, Mstart, Nmaxmax, m, Nmax, Nmax1, i, NthetaConv,   &
                   NrankAL
  real(O)       :: k, alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,  &
                   Cext, Qext      
  complex(O)    :: ind_refC
  real(O),allocatable    :: h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: CC(:,:), S1(:,:), S2(:,:), S(:,:)
  complex(O),allocatable :: t(:), a(:,:), b(:,:), c(:), c1(:), ce(:) 
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 0
  Mrank  = Nrank 
  MM = max(Nrank, Nrank1)
  NN = MM + 5 
  NrankAL = MM
  k = ks * ind_ref  
  ind_refC = cmplx(ind_ref,0.0,O)  
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call write_HeadFileTmat (NrankAL, NrankAL) 
  call write_TypeConvHead (3)
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)             
  allocate (CC(0:NN,0:2*NN+1))
  allocate (S1(2*NrankAL,2*NrankAL), S2(2*NrankAL,2*NrankAL),                       &
            S(2*NrankAL,2*NrankAL))
  allocate (t(2*NrankAL), a(2*NrankAL,2*NrankAL), b(2*NrankAL,2*NrankAL),           &
            c(2*NrankAL), c1(2*NrankAL))
  allocate (ce(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do  
  Mrank = - 1
  do m = Mstart, MM    
    call write_1ConvParam (m)
    Mrank = Mrank + 1        
    if (m > Nrank1) Nrank1 = m
    if (m == 0) then
      Nmax  = Nrank
      Nmax1 = Nrank1
    else
      Nmax  = Nrank - m + 1
      Nmax1 = Nrank1 - m + 1
    end if
    if (PrnProgress) call write_progress_m (.true., m, 1, 5)        
    call MatTransCmnn1 (1, k, -z1, m, NN, CC, NN)
    call coefficients_fg_m (k, r1, ind_ref1, m, Nrank1, Nmax1, c)
    call MatTransAB_mnn1 (k,.true., -z1, m, CC, NN, Nmax1, Nmax, S2,                &
         NrankAL, NrankAL)
    call matrix_S1 (Nmax, Nmax1, S2, NrankAL, NrankAL, S1, NrankAL, NrankAL)
    call product_matrix_vector2 (2*Nmax1, 2*Nmax, c, S2, 2*NrankAL, 2*NrankAL)
    call product_matrices1 (2*Nmax, 2*Nmax1, 2*Nmax, S1, 2*NrankAL, 2*NrankAL,      &
         S2, 2*NrankAL, 2*NrankAL, S, 2*NrankAL, 2*NrankAL)
    if (PrnProgress) call write_progress_m (.false., m, 2, 5)   
    call vector_Q_sphere1_m (1, 3, ks, r, ind_refC, m, Nrank, Nmax, t)              
    call product_matrix_vector1 (2*Nmax, 2*Nmax, t, S, 2*NrankAL, 2*NrankAL,        &
         b, 2*NrankAL, 2*NrankAL)
    call vector_Q_sphere1_m (1, 1, ks, r, ind_refC, m, Nrank, Nmax, t)
    call sum_diagonal_elements (2*Nmax, t, b, 2*NrankAL, 2*NrankAL) 
    if (PrnProgress) call write_progress_m (.false., m, 3, 5)   
    call vector_Q_sphere1_m (3, 3, ks, r, ind_refC, m, Nrank, Nmax, t)          
    call product_matrix_vector1 (2*Nmax, 2*Nmax, t, S, 2*NrankAL, 2*NrankAL,        &
         a, 2*NrankAL, 2*NrankAL)
    call vector_Q_sphere1_m (3, 1, ks, r, ind_refC, m, Nrank, Nmax, t)
    call sum_diagonal_elements (2*Nmax, t, a, 2*NrankAL, 2*NrankAL)
    if (PrnProgress) call write_progress_m (.false., m, 4, 5)
    call LU_SYSTEM (a, 2*NrankAL, 2*NrankAL, b, 2*NrankAL, 2*NrankAL, 2*Nmax)
    if (PrnProgress) call write_progress_m (.false., m, 5, 5)
    call minus_matrix (2*Nmax, 2*Nmax, b, 2*NrankAL, 2*NrankAL)    
    call write_FileTmat (NrankAL, NrankAL, b)       
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         Nmax, c)
    call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*NrankAL, 2*NrankAL, c, c1)
    call extend_vector_positive (c1, ce, m, Mstart, Nrank, Nmax, Nmaxmax)
    if (m /= 0) then      
      call matrix_m_negativ (Nmax, Nmax, b, NrankAL, NrankAL)         
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,  &
           Nmax, c) 
      call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*NrankAL, 2*NrankAL, c, c1)
      call extend_vector_negative (c1, ce, m, Nrank, Nmax, Nmaxmax)     
    end if
    call DSCS (ce, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, ks,       &
         snorm,.false.,.true., h, v)
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsMrank, NthetaConv)     
    call write_DSCS (Nteta,.false., h, v)
    if (NthetaConv >= int(0.8*Nteta)) exit 
  end do
  close (unit = iTmat)
  call CQscat (ce, Mrank, Nrank, Nmaxmax, ks, snorm, Cscat, Qscat)
  call CQext (ce, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, ks, snorm, Cext, Qext)
  call write_Effic (Qscat, Qext)
  call write_MrankConvRes (NthetaConv, epsMrank)
  if (NthetaConv >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criterion for Mrank is satisfied;')"                                     
  else
    print "(/,2x,'Convergence criterion for Mrank is not satisfied;')"
  end if
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .true., .false., .false.)
  call ScatCharact (ks, FileTmat, Mrank, Nrank, .true., .false., .false.)
  print "(/,2x,'T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')" 
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank                     
  deallocate (CC, S1, S2, S, t, a, b, c, c1, ce, h, v, oldh, oldv) 
end subroutine convergence_MrankINHOM2SPH

! **********************************************************************************
! *          ROUTINES FOR COMPUTING THE SPHERICAL VECTOR WAVE FUNCTIONS            *
! *    -----------------------------------------------------------------------     *
! *    Partial list of subroutines:                                                *
! *      MN,                  MN_infinit,      MN_DS,          MN_poles_COMP,      *
! *      MN_poles_COMP1,      MN_DS_COMP,      MN_DS_COMP1,    MN_poles_LAY,       *
! *      MN_DS_LAY,           MN_complete,     MN_infinit_complete,                *
! *      MN_infinit_reflection_complete,       MN_left_right,  MN_anisotrop,       *
! *      MN_m_anisotrop.                                                           *
! **********************************************************************************
subroutine MN (index, z, theta, m, Nrank, Nmax, MV, NV)
!----------------------------------------------------------------------------------- 
! The routine computes the localized vector spherical wave functions (excepting    !
! the factor exp(j*m*phi)) for the azimuthal mode m.                               !
!                                                                                  !
! Input parameters:                                                                !
! - index (integer) - if index = 1, the regular vector wave functions are          !
!   computed. If index = 3, the radiating vector wave functions are computed.      !
! - z (complex,) - z = k * r, where k is the wave number and r is the module of    !
!   the position vector.                                                           !
! - theta (real) - zenith angle.                                                   !
! - m (integer) - azimuthal mode.                                                  !
! - Nrank (integer) - maximum expansion order.                                     !
! - Nmax (integer) - specifies the dimension of the vectors.                       !
!   For m = 0, Nmax = Nrank, while for m > 0, Nmax = Nrank - |m| + 1.              !
!                                                                                  !
! Output parameters:                                                               !
! - MV, NV (complex arrays) - vector spherical wave functions.                     !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: index, m, Nrank, Nmax  
  real(O)    :: theta
  complex(O) :: z, MV(3,Nmax), NV(3,Nmax)
!
  integer    :: k, n
  real(O)    :: nm, mr, nr, fp, ft, fl  
  complex(O) :: zc
  real(O),allocatable    :: Pnm(:), dPnm(:), pinm(:), taunm(:)
  complex(O),allocatable :: jh(:), jhd(:)
! 
  allocate (jh(0:Nrank), jhd(0:Nrank))
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  zc = z
  if (abs(zc) < MachEps) zc = cmplx(MachEps,MachEps,O) 
  if (index == 1) then
    call besel_j (zc, Nrank, jh, jhd) 
  else if (index == 3) then
    call besel_h (zc, Nrank, jh, jhd)      
  endif
  call leg_normalized (theta, abs(m), Nrank, Pnm, dPnm, pinm, taunm)
  mr = real(m,O)  
  do k = 1, Nmax
    if (m == 0) then
      n = k
    else
      n = abs(m) + k - 1
    end if
    nr = real(n * (n + 1),O)
    nm = 1._O / sqrt(2._O * nr)
    fp = mr * pinm(n) * nm
    ft = taunm(n) * nm
    fl = nr * Pnm(n) * nm
    MV(1,k) =   zero
    MV(2,k) =   jh(n)  * im * fp   
    MV(3,k) = - jh(n)  * ft         
    NV(1,k) =   jh(n)  * fl / zc
    NV(2,k) =   jhd(n) * ft / zc
    NV(3,k) =   jhd(n) * im * fp / zc           
  end do  
  deallocate (jh, jhd)
  deallocate (Pnm, dPnm, pinm, taunm)      
end subroutine MN
!***********************************************************************************
subroutine MN_infinit (theta, phi, m, Nrank, Nmax, Minf, Ninf)
!-----------------------------------------------------------------------------------
! The routine computes the localized vector spherical wave functions at infinity   !
! (excepting the factor exp(j*k*R)/(k*R)) for the azimuthal mode m.                !
!                                                                                  !
! Input parameters:                                                                !
! - theta, phi (real variables) - polar angles.                                    !
! - m (integer) - azimuthal mode.                                                  !
! - Nrank (integer) - maximum expansion order.                                     !
! - Nmax (integer) - specifies the dimension of the vectors.                       !
!   For m = 0, Nmax = Nrank, while for m > 0, Nmax = Nrank - |m| + 1.              !
!                                                                                  !
! Output parameters:                                                               !
! - Minf, Ninf (complex arrays) - vector spherical wave functions at infinity.     !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: m, Nrank, Nmax
  real(O)    :: theta, phi
  complex(O) :: Minf(3,Nmax), Ninf(3,Nmax)
!
  integer    :: k, n  
  real(O)    :: arg, nm, mr
  complex(O) :: fact, factc, factt, factp
  real(O),allocatable :: Pnm(:), dPnm(:), pinm(:), taunm(:)
!
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  call leg_normalized (theta, abs(m), Nrank, Pnm, dPnm, pinm, taunm)
  mr   = real(m,O)
  arg  = mr * phi
  fact = exp(im * arg)  
  do k = 1, Nmax
    if (m == 0) then
      n = k
    else
      n = abs(m) + k - 1
    end if
    nm    = real(2 * n * (n + 1),O)         
    nm    = 1._O / sqrt(nm)     
    factc = fact  * (-im)**(n + 1) * nm     
    factp = factc * mr * pinm(n)
    factt = factc * taunm(n)
    Minf(1,k) =   zero
    Minf(2,k) =   im * factp
    Minf(3,k) = - factt
    Ninf(1,k) =   zero
    Ninf(2,k) =   im * factt
    Ninf(3,k) = - factp
  end do
  deallocate (Pnm, dPnm, pinm, taunm)     
end subroutine MN_infinit
!***********************************************************************************
subroutine MN_DS (index, k, r, theta, zRe, zIm, m, Nrank, MV, NV)
!-----------------------------------------------------------------------------------
! The routine computes the distributed vector spherical wave functions (excepting  !
! the factor exp(j*m*phi)) for the azimuthal mode m.                               !
!                                                                                  ! 
! Input parameters:                                                                !
! - index (integer) - if index = 1, the regular vector wave functions are          !
!   computed. If index = 3, the radiating vector wave functions are computed.      !
! - k (complex) - wave number.                                                     !
! - r (real) - module of the position vector.                                      !
! - theta (real) - zenith angle.                                                   !
! - zRe, zIm (real arrays) - coordinates of distributed sources in the complex     !
!   plane.                                                                         !                                      
! - m (integer) - azimuthal mode.                                                  !
! - Nrank (integer) - maximum expansion order or the number of distributed         !
!   sources.                                                                       !
!                                                                                  ! 
! Output parameters:                                                               !
! - MV, NV (complex arrays) - distributed vector spherical wave functions.         !
!-----------------------------------------------------------------------------------                
  use parameters
  use derived_parameters
  implicit none
  integer    :: index, m, Nrank  
  real(O)    :: r, theta, zRe(Nrank), zIm(Nrank)
  complex(O) :: k, MV(3,Nrank), NV(3,Nrank) 
!         
  integer    :: p, n, Nbes     
  real(O)    :: ro, z, nm, mr, nr, cth, sth, dz
  complex(O) :: RR, sint, cost, argJ, sinc, cosc, Pmm, pimm, taumm, fp, ft, fl,     &
                factp, factt, factl, roc, dzc
  complex(O),allocatable :: jh(:), jhd(:)
!
  if (m == 0) then
    n = 1
  else
    n = abs(m)
  end if
  Nbes = n + 1
  mr   = real(m,O) 
  nr   = real(n * (n + 1),O)
  nm   = 1._O / sqrt(2._O * nr)   
  allocate (jh(0:Nbes), jhd(0:Nbes))
  sth = sin(theta)
  cth = cos(theta)
  ro  = r * sth
  z   = r * cth
  roc = cmplx(ro,0.0,O)
  do p = 1, Nrank
    dz  = z - zRe(p)
    dzc = cmplx(dz,0.0,O)    
    RR  = sqrt(roc * roc + (dzc - im * zIm(p))**2)
    if (abs(RR) < MachEps) RR = cmplx(MachEps,MachEps,O)
    sint = ro / RR
    cost = (dzc - im * zIm(p)) / RR
    argJ = k * RR
    if (index == 1) then
      call besel_j (argJ, Nbes, jh, jhd)
    else if (index == 3) then
      call besel_h (argJ, Nbes, jh, jhd)
    end if
    call P_mm (sint, cost, abs(m), Pmm)
    call pi_mm (sint, abs(m), pimm)
    call tau_mm (sint, cost, abs(m), taumm)
    sinc = sth * cost - cth * sint
    cosc = cth * cost + sth * sint
    fp   = im * mr * pimm * nm
    ft   = taumm * nm
    fl   = nr * Pmm * nm
    factp   =   jh(n)  * fp     
    MV(1,p) =   factp  * sinc
    MV(2,p) =   factp  * cosc
    MV(3,p) = - jh(n)  * ft             
    factl   =   jh(n)  * fl               
    factt   =   jhd(n) * ft
    NV(1,p) =   (   factl * cosc + factt * sinc) / argJ
    NV(2,p) =   ( - factl * sinc + factt * cosc) / argJ
    NV(3,p) =   jhd(n) * fp / argJ    
  end do
  deallocate (jh, jhd)      
end subroutine MN_DS
!***********************************************************************************
subroutine MN_poles_COMP (index, kk, r, theta, m, Npart, zpart, Nrankp, Nmax, MV, NV)
!-----------------------------------------------------------------------------------
! The routine computes the localized vector spherical wave functions (excepting    !
! the factor exp(j*m*phi)) for a composite particle and the azimuthal mode m.      !
!                                                                                  !
! Input parameters:                                                                !
! - index (integer) - if index = 1, the regular vector wave functions are          !
!   computed. If index = 3, the radiating vector wave functions are computed.      !
! - kk (complex) - wave number.                                                    !
! - r (real) - module of the position vector.                                      !
! - theta (real) - zenith  angle.                                                  !
! - m (integer) - azimuthal mode.                                                  !
! - Npart (integer) - number of homogeneous regions.                               !
! - zpart (real array) -  axial coordinates of the region origins.                 !
! - Nrankp (integer array) - maximum expansion orders of the regions.              !
! - Nmax (integer) - specifies the dimension of the vectors.                       !
!                                                                                  !
! Output parameters:                                                               !
! - MV, NV (complex arrays) - vector spherical wave functions.                     !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: index, m, Npart, Nmax, Nrankp(Npart)  
  real(O)    :: r, theta, zpart(Npart)
  complex(O) :: kk, MV(3,Nmax), NV(3,Nmax)
!
  integer    :: k, n, p, Nstart, Nmaxp, Nbes
  real(O)    :: r1, theta1, sinc, cosc, nm, mr, nr, fp, ft, fl, cth  
  complex(O) :: zz, nvr, nvtheta, nvphi, mvtheta
  real(O),allocatable    :: Pnm(:), dPnm(:), pinm(:), taunm(:)
  complex(O),allocatable :: jh(:), jhd(:)
!
  cth  = cos(theta)
  Nbes = 1
  do p = 1, Npart
    if (Nrankp(p) > Nbes) then
      Nbes = Nrankp(p)
    end if 
  end do
  allocate (jh(0:Nbes), jhd(0:Nbes))
  allocate (Pnm(0:Nbes), dPnm(0:Nbes), pinm(0:Nbes), taunm(0:Nbes))      
  mr = real(m,O)
  Nstart = 0
  do p = 1, Npart       
    if (Nrankp(p) >= abs(m)) then
      if (m == 0) then
        Nmaxp = Nrankp(p)
      else
        Nmaxp = Nrankp(p) - abs(m) + 1
      end if
      r1 = sqrt(r**2 + zpart(p)**2 - 2._O * r * zpart(p) * cth)
      if (r1 < MachEps) r1 = MachEps
      theta1 = acos((r * cth - zpart(p)) / r1)
      zz    = kk * r1
      if (index == 1) then
        call besel_j (zz, Nrankp(p), jh, jhd)
      else if (index == 3) then
        call besel_h (zz, Nrankp(p), jh, jhd)
      end if
      call leg_normalized (theta1, abs(m), Nrankp(p), Pnm, dPnm, pinm, taunm)
      sinc = sin(theta - theta1)
      cosc = cos(theta - theta1)
      do k = 1, Nmaxp
        if (m == 0) then
          n = k
        else
          n = abs(m) + k - 1
        end if
        nr = real(n * (n + 1),O)
        nm = 1._O / sqrt(2._O * nr)
        fp = mr * pinm(n) * nm
        ft = taunm(n) * nm
        fl = nr * Pnm(n) * nm
        mvtheta = jh(n) * im * fp 
        MV(1,Nstart+k) =    mvtheta * sinc
        MV(2,Nstart+k) =    mvtheta * cosc
        MV(3,Nstart+k) = - jh(n)   * ft
        nvr     = fl * jh(n) / zz
        nvtheta = jhd(n) * ft / zz
        nvphi   = jhd(n) * im * fp / zz
        NV(1,Nstart+k) =   nvr * cosc + nvtheta * sinc
        NV(2,Nstart+k) = - nvr * sinc + nvtheta * cosc
        NV(3,Nstart+k) =   nvphi                                                   
      end do    
      Nstart = Nstart + Nmaxp          
    endif
  end do
  deallocate (jh, jhd)
  deallocate (Pnm, dPnm, pinm, taunm)      
end subroutine MN_poles_COMP
!***********************************************************************************
subroutine MN_poles_COMP1 (index, ipart, kk, r, theta, m, Npart, zpart, Nrankp,     &
           Nmax, MV, NV)
!-----------------------------------------------------------------------------------
! The routine computes the localized vector spherical wave functions (excepting    !
! the factor exp(j*m*phi)) for the homogeneous region ipart (which is a part of    !
! the composite particle) and the azimuthal mode m.                                !
!                                                                                  ! 
! Input parameters:                                                                !
! - index (integer) - if index = 1, the regular vector wave functions are          !
!   computed. If index = 3, the radiating vector wave functions are computed.      !
! - ipart (integer) - index of the homogeneous region.                             ! 
! - kk (complex) - wave number.                                                    !
! - r (real) - module of the position vector.                                      !
! - theta (real) - zenith angle.                                                   !
! - m (integer) - azimuthal mode.                                                  !
! - Npart (integer) - number of homogeneous regions.                               !
! - zpart (real array) - axial coordinates of the region origins.                  !
! - Nrankp (integer array) - maximum expansion orders of the regions.              !
! - Nmax (integer) - specifies the dimension of the vectors.                       !
!                                                                                  !
! Output parameters:                                                               !
! - MV, NV (complex arrays) - vector spherical wave functions.                     !
!----------------------------------------------------------------------------------- 
  use parameters
  use derived_parameters
  implicit none
  integer    :: index, m, Npart, Nmax, Nrankp(Npart), ipart     
  real(O)    :: r, theta, zpart(Npart)
  complex(O) :: kk, MV(3,Nmax), NV(3,Nmax)
!
  integer    :: k, n, p, Nstart, Nmaxp, Nbes
  real(O)    :: r1, theta1, sinc, cosc, nm, mr, nr, fp, ft, fl, cth  
  complex(O) :: zz, nvr, nvtheta, nvphi, mvtheta
  real(O),allocatable    :: Pnm(:), dPnm(:), pinm(:), taunm(:)
  complex(O),allocatable :: jh(:), jhd(:)
!
  cth  = cos(theta)
  Nbes = 1
  do p = 1, Npart
    if (Nrankp(p) > Nbes) then
      Nbes = Nrankp(p)
    end if 
  end do
  allocate (jh(0:Nbes), jhd(0:Nbes))
  allocate (Pnm(0:Nbes), dPnm(0:Nbes), pinm(0:Nbes), taunm(0:Nbes))
  mr = real(m,O)
  do k = 1, 3
    do p = 1, Nmax
      MV(k,p) = zero
      NV(k,p) = zero
    end do
  end do      
  Nstart = 0
  do p = 1, Npart       
    if (Nrankp(p) >= abs(m)) then
      if (m == 0) then
        Nmaxp = Nrankp(p)
      else
        Nmaxp = Nrankp(p) - abs(m) + 1
      end if
      if (p == ipart) then
        r1 = sqrt(r**2 + zpart(p)**2 - 2._O * r * zpart(p) * cth)
        if (r1 < MachEps) r1 = MachEps
        theta1 = acos((r * cth - zpart(p)) / r1)
        zz     = kk * r1
        if (index == 1) then
          call besel_j (zz, Nrankp(p), jh, jhd)
        else if (index == 3) then
          call besel_h (zz, Nrankp(p), jh, jhd)
        end if
        call leg_normalized (theta1, abs(m), Nrankp(p), Pnm, dPnm, pinm, taunm)
        sinc = sin(theta - theta1)
        cosc = cos(theta - theta1)
        do k = 1, Nmaxp
          if (m == 0) then
            n = k
          else
            n = abs(m) + k - 1
          end if
          nr = real(n * (n + 1),O)
          nm = 1._O / sqrt(2._O * nr)
          fp = mr * pinm(n) * nm
          ft = taunm(n) * nm
          fl = nr * Pnm(n) * nm
          mvtheta = jh(n) * im * fp 
          MV(1,Nstart+k) =   mvtheta * sinc
          MV(2,Nstart+k) =   mvtheta * cosc
          MV(3,Nstart+k) = - jh(n)  * ft
          nvr     = fl * jh(n) / zz
          nvtheta = jhd(n) * ft / zz
          nvphi   = jhd(n) * im * fp / zz
          NV(1,Nstart+k) =   nvr * cosc + nvtheta * sinc
          NV(2,Nstart+k) = - nvr * sinc + nvtheta * cosc
          NV(3,Nstart+k) =   nvphi
        end do
      end if     
      Nstart = Nstart + Nmaxp          
    endif
  end do      
  deallocate (jh, jhd)
  deallocate (Pnm, dPnm, pinm, taunm)      
end subroutine MN_poles_COMP1
!***********************************************************************************
subroutine MN_DS_COMP (index, k, r, theta, Npart, Nrankpmax, Nrankp, zRe, zIm, m,   &
           Nrank, MV, NV)
!-----------------------------------------------------------------------------------
! The routine computes the distributed vector spherical wave functions (excepting  !
! the factor exp(j*m*phi)) for a composite particle and the azimuthal mode m.      !
!                                                                                  !
! Input parameters:                                                                !
! - index (integer) - if index = 1, the regular vector wave functions are          !
!   computed. If index = 3, the radiating vector wave functions are computed.      !
! - k (complex) - wave number.                                                     !
! - r (real) - module of the position vector.                                      !
! - theta (real) - zenith angle.                                                   !
! - m (integer) - azimuthal mode.                                                  !
! - Npart (integer) - number of homogeneous regions.                               !
! - zRe, zIm (real array) - coordinates of the region origins in the complex       !
!   plane.                                                                         !
! - Nrankpmax (integer) - specifies the dimension of zRe and zIm.                  !
! - Nrankp (integer array) - maximum expansion orders of the homogeneous regions.  !
! - Nrank (integer) - specifies the dimension of the vectors.                      !
!                                                                                  !
! Output parameters:                                                               !
! - MV, NV (complex arrays) - vector spherical wave functions.                     !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: index, Npart, Nrankpmax, Nrankp(Npart), m, Nrank           
  real(O)    :: r, theta, zRe(Npart,Nrankpmax), zIm(Npart,Nrankpmax)
  complex(O) :: k, MV(3,Nrank), NV(3,Nrank)
!
  integer    :: p, n, Nbes, Nstart, Nrankpl, ipart      
  real(O)    :: ro, z, nm, mr, nr, sth, cth, dz
  complex(O) :: RR, sint, cost, argJ, sinc, cosc, Pmm, pimm, taumm, fp, ft, fl,     &
                factp, factt, factl, roc, dzc
  complex(O),allocatable :: jh(:), jhd(:)
!
  if (m == 0) then
    n = 1
  else
    n = abs(m)
  end if
  Nbes = n + 1
  mr   = real(m,O)
  nr   = real(n * (n + 1),O)
  nm   = 1._O / sqrt(2._O * nr)
  allocate (jh(0:Nbes), jhd(0:Nbes))
  sth = sin(theta)
  cth = cos(theta)
  ro  = r * sth
  z   = r * cth
  roc = cmplx(ro,0.0,O)
  Nstart = 0
  do ipart = 1, Npart
    Nrankpl = Nrankp(ipart)
    do p = 1, Nrankpl
      dz  = z - zRe(ipart,p)
      dzc = cmplx(dz,0.0,O)      
      RR  = sqrt(roc * roc + (dzc - im * zIm(ipart,p))**2)
      if (abs(RR) < MachEps) RR = cmplx(MachEps,MachEps,O)
      sint = ro / RR
      cost = (dzc - im * zIm(ipart,p)) / RR
      argJ = k * RR
      if (index == 1) then
        call besel_j (argJ, Nbes, jh, jhd)
      else if (index == 3) then
        call besel_h (argJ, Nbes, jh, jhd)
      end if 
      call P_mm (sint, cost, abs(m), Pmm)
      call pi_mm (sint, abs(m), pimm)
      call tau_mm (sint, cost, abs(m), taumm)
      sinc  = sth * cost - cth * sint
      cosc  = cth * cost + sth * sint
      fp    = im * mr * pimm * nm
      ft    = taumm * nm
      fl    = nr * Pmm * nm
      factp = jh(n) * fp
      MV(1,Nstart+p) =   factp * sinc
      MV(2,Nstart+p) =   factp * cosc
      MV(3,Nstart+p) = - jh(n) * ft
      factt = jhd(n) * ft
      factl = jh(n)  * fl             
      NV(1,Nstart+p) = (  factl * cosc + factt * sinc) / argJ
      NV(2,Nstart+p) = (- factl * sinc + factt * cosc) / argJ
      NV(3,Nstart+p) = jhd(n) * fp / argJ 
    end do
    Nstart = Nstart + Nrankpl
  end do
  deallocate (jh, jhd)       
end subroutine MN_DS_COMP
!***********************************************************************************
subroutine MN_DS_COMP1 (index, ipart, k, r, theta, Npart, Nrankpmax, Nrankp, zRe,   &
           zIm, m, Nrank, MV, NV)
!-----------------------------------------------------------------------------------
! The routine computes the localized vector spherical wave functions (excepting    !
! the factor exp(j*m*phi)) for the homogeneous region ipart (which is a part of    !
! a composite paticle) and the azimuthal mode m.                                   !
!                                                                                  ! 
! Input parameters:                                                                !
! - index (integer) - if index = 1, the regular vector wave functions are          !
!   computed. If index = 3, the radiating vector wave functions are computed.      !
! - ipart (integer) - index of the homogeneous region.                             !
! - k (complex) - wave number.                                                     !
! - r (real) - module of the position vector.                                      !
! - theta (real) - zenith angle.                                                   !
! - m (integer) - azimuthal mode.                                                  !
! - Npart (integer) - number of homogeneous regions.                               !
! - zRe, zIm (real array) - coordinates of the region origins in the complex       !
!   plane.                                                                         ! 
! - Nrankpmax (integer) - specifies the dimension of zRe and zIm.                  !
! - Nrankp (integer array) - maximum expansion orders of the homogeneous regions.  ! 
! - Nrank (integer) - specifies the dimension of the vectors.                      !
!                                                                                  !
! Output parameters:                                                               !
! - MV, NV (complex arrays) - vector spherical wave functions.                     !
!----------------------------------------------------------------------------------- 
  use parameters
  use derived_parameters
  implicit none
  integer    :: index, ipart, Npart, Nrankpmax, Nrankp(Npart), m, Nrank               
  real(O)    :: r, theta, zRe(Npart,Nrankpmax), zIm(Npart,Nrankpmax)
  complex(O) :: k, MV(3,Nrank), NV(3,Nrank)
!
  integer    :: l, p, n, Nbes, Nstart, Nrankpl, iipart      
  real(O)    :: ro, z, nm, mr, nr, sth, cth, dz
  complex(O) :: RR, sint, cost, argJ, sinc, cosc, Pmm, pimm, taumm, fp, ft, fl,     &
                factp, factl, factt, roc, dzc
  complex(O),allocatable :: jh(:), jhd(:)
!
  if (m == 0) then
    n = 1
  else
    n = abs(m)
  end if
  Nbes = n + 1
  mr   = real(m,O)
  nr   = real(n * (n + 1),O)
  nm   = 1._O / sqrt(2._O * nr)  
  allocate (jh(0:Nbes), jhd(0:Nbes))
  do l = 1, 3
    do p = 1, Nrank
      MV(l,p) = zero
      NV(l,p) = zero
    end do
  end do
  sth = sin(theta)
  cth = cos(theta)
  ro  = r * sth
  z   = r * cth 
  roc = cmplx(ro,0.0,O) 
  Nstart = 0
  do iipart = 1, Npart
    Nrankpl = Nrankp(iipart)
    if (iipart == ipart) then
      do p = 1, Nrankpl
        dz  = z - zRe(ipart,p)
        dzc = cmplx(dz,0.0,O)              
        RR  = sqrt(roc * roc + (dzc - im * zIm(ipart,p))**2)
        if (abs(RR) < MachEps) RR = cmplx(MachEps,MachEps,O) 
        sint = ro / RR
        cost = (dzc - im * zIm(ipart,p)) / RR
        argJ = k * RR
        if (index == 1) then
          call besel_j (argJ, Nbes, jh, jhd)
        else if (index == 3) then
          call besel_h (argJ, Nbes, jh, jhd)
        end if         
        call P_mm (sint, cost, abs(m), Pmm)
        call pi_mm (sint, abs(m), pimm)
        call tau_mm (sint, cost, abs(m), taumm)
        sinc  = sth * cost - cth * sint
        cosc  = cth * cost + sth * sint
        fp    = im * mr * pimm * nm
        ft    = taumm * nm
        fl    = nr * Pmm * nm
        factp = jh(n) * fp
        MV(1,Nstart+p) =   factp * sinc
        MV(2,Nstart+p) =   factp * cosc
        MV(3,Nstart+p) = - jh(n) * ft
        factt = jhd(n) * ft
        factl = jh(n)  * fl               
        NV(1,Nstart+p) = (  factl * cosc + factt * sinc) / argJ
        NV(2,Nstart+p) = (- factl * sinc + factt * cosc) / argJ
        NV(3,Nstart+p) = jhd(n) * fp / argJ 
      end do
    endif
    Nstart = Nstart + Nrankpl
  end do
  deallocate (jh, jhd)      
end subroutine MN_DS_COMP1
!***********************************************************************************
subroutine MN_poles_LAY (index, kk, r, theta, m, ipart, Npart, Nrankp, Nmaxpmax,    &
           Nmaxp, zpart, MV, NV)
!-----------------------------------------------------------------------------------
! The routine computes the localized vector spherical wave functions (excepting    !
! the factor exp(j*m*phi)) for the layer ipart and the azimuthal mode m.           !
!                                                                                  !
! Input Parameters:                                                                !
! - index (integer) - if index = 1, the regular vector wave functions are          !
!   computed. If index = 3, the radiating vector wave functions are computed.      !
! - kk (complex) - wave number.                                                    !
! - r (real) - module of the position vector.                                      !
! - theta (real) - zenith angle.                                                   !
! - m (integer) - azimuthal mode.                                                  !
! - ipart (integer) - index of the layer.                                          !
! - Npart (integer) - number of layers.                                            !
! - zpart (real array) - axial coordinates of the layer origins.                   !
! - Nrankp (integer array) - maximum expansion orders of the layers.               !
! - Nmaxp (integer array) - real dimensions of the vector functions corresponding  !
!   to a specific layer.                                                           !
! - Nmaxpmax (integer) - specifies the physical dimension of the vectors.          !
!                                                                                  !
! Output parameters:                                                               !
! - MV, NV (complex arrays) - vector spherical wave functions.                     !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: index, m, ipart, Npart, Nrankp(Npart), Nmaxpmax, Nmaxp(Npart)
  real(O)    :: r, theta, zpart(Npart)
  complex(O) :: kk, MV(3,Nmaxpmax), NV(3,Nmaxpmax)
!      
  integer    :: l, k, n, p, Nbes
  real(O)    :: r1, theta1, sinc, cosc, nm, mr, nr, fp, ft, fl, cth  
  complex(O) :: zz, nvr, nvtheta, nvphi, mvtheta
  real(O),allocatable    :: Pnm(:), dPnm(:), pinm(:), taunm(:)
  complex(O),allocatable :: jh(:), jhd(:)
!
  cth = cos(theta)
  do l = 1, 3
    do p = 1, Nmaxpmax
      MV(l,p) = zero
      NV(l,p) = zero
    end do
  end do
  Nbes = Nrankp(ipart)   
  allocate (jh(0:Nbes), jhd(0:Nbes))
  allocate (Pnm(0:Nbes), dPnm(0:Nbes), pinm(0:Nbes), taunm(0:Nbes))      
  mr = real(m,O)
  r1 = sqrt(r**2 + zpart(ipart)**2 - 2._O * r * zpart(ipart) * cth)
  if (r1 < MachEps) r1 = MachEps
  theta1 = acos((r * cth - zpart(ipart)) / r1)
  zz    = kk * r1
  if (index == 1) then  
    call besel_j (zz, Nrankp(ipart), jh, jhd)
  else if (index == 3) then
    call besel_h (zz, Nrankp(ipart), jh, jhd)
  end if
  call leg_normalized (theta1, abs(m), Nrankp(ipart), Pnm, dPnm, pinm, taunm)
  sinc = sin(theta - theta1)
  cosc = cos(theta - theta1)
  do k = 1, Nmaxp(ipart)
    if (m == 0) then
      n = k
    else
      n = abs(m) + k - 1
    end if
    nr = real(n * (n + 1),O)
    nm = 1._O / sqrt(2._O * nr)
    fp = mr * pinm(n) * nm
    ft = taunm(n) * nm
    fl = nr * Pnm(n) * nm
    mvtheta = jh(n) * im * fp 
    MV(1,k) =   mvtheta * sinc
    MV(2,k) =   mvtheta * cosc
    MV(3,k) = - jh(n)  * ft
    nvr     =   fl * jh(n) / zz
    nvtheta =   jhd(n) * ft / zz
    nvphi   =   jhd(n) * im * fp / zz
    NV(1,k) =   nvr * cosc + nvtheta * sinc
    NV(2,k) = - nvr * sinc + nvtheta * cosc
    NV(3,k) =   nvphi
  end do        
  deallocate (jh, jhd)
  deallocate (Pnm, dPnm, pinm, taunm)  
end subroutine MN_poles_LAY
!***********************************************************************************
subroutine MN_DS_LAY (index, k, r, theta, ipart, Npart, Nrankpmax, Nrankp,          &
           zRe, zIm, m, MV, NV)
!-----------------------------------------------------------------------------------
! The routine computes the distributed vector spherical wave functions (excepting  !
! the factor exp(j*m*phi)) for the layer ipart and the azimuthal mode m.           !
!                                                                                  !
! Input parameters:                                                                !
! - index (integer) - if index = 1, the regular vector wave functions are          !
!   computed. If index = 3, the radiating vector wave functions are computed.      !
! - k (complex) - wave number.                                                     !
! - r (real) - module of the position vector.                                      !
! - theta (real) - zenith angle.                                                   !
! - m (integer) - azimuthal mode.                                                  !
! - ipart (integer) - index of the layer.                                          !
! - Npart (integer) - number of layers.                                            !
! - zRe, zIm (real array) - coordinates of the region origins in the complex       !
!   plane.                                                                         !
! - Nrankp (integer array) - maximum expansion orders of the layers.               !
! - Nrankpmax (integer) - specifies the physical dimension of the vectors.         !
!                                                                                  !
! Output parameters:                                                               !
! - MV, NV (complex arrays) - vector spherical wave functions.                     !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: index, ipart, Npart, Nrankpmax, Nrankp(Npart), m      
  real(O)    :: r, theta
  real(O)    :: zRe(Npart,Nrankpmax), zIm(Npart,Nrankpmax)
  complex(O) :: k, MV(3,Nrankpmax), NV(3,Nrankpmax)
!
  integer    :: p, n, Nbes, Nrankpl, l      
  real(O)    :: ro, z, nm, mr, nr, sth, cth, dz
  complex(O) :: Pmm, pimm, taumm, RR, sint, cost, argJ, sinc, cosc, fp, ft, fl,     &
                factp, factl, factt, roc, dzc
  complex(O),allocatable :: jh(:), jhd(:)
!
  if (m == 0) then
    n = 1
  else
    n = abs(m)
  end if
  Nbes = n + 1
  mr   = real(m,O)
  nr   = real(n * (n + 1),O)
  nm   = 1._O / sqrt(2._O * nr)   
  allocate (jh(0:Nbes), jhd(0:Nbes))
  do l = 1, 3
    do p = 1, Nrankpmax
      MV(l,p) = zero
      NV(l,p) = zero
    end do
  end do
  sth = sin(theta)
  cth = cos(theta)
  ro  = r * sth
  z   = r * cth  
  roc = cmplx(ro,0.0,O) 
  Nrankpl = Nrankp(ipart)
  do p = 1, Nrankpl 
    dz  = z - zRe(ipart,p)
    dzc = cmplx(dz,0.0,O)   
    RR  = sqrt(roc * roc + (dzc - im * zIm(ipart,p))**2)
    if (abs(RR) < MachEps) RR = cmplx(MachEps,MachEps,O) 
    sint = ro / RR
    cost = (dzc - im * zIm(ipart,p)) / RR
    argJ = k * RR
    if (index == 1) then
      call besel_j (argJ, Nbes, jh, jhd)
    else if (index == 3) then
      call besel_h (argJ, Nbes, jh, jhd)
    end if
    call P_mm (sint, cost, abs(m), Pmm)
    call pi_mm (sint, abs(m), pimm)
    call tau_mm (sint, cost, abs(m), taumm)
    sinc  = sth * cost - cth * sint
    cosc  = cth * cost + sth * sint
    fp    = im * mr * pimm * nm
    ft    = taumm * nm
    fl    = nr * Pmm * nm
    factp = jh(n) * fp
    MV(1,p) =   factp * sinc
    MV(2,p) =   factp * cosc
    MV(3,p) = - jh(n) * ft
    factt   = jhd(n) * ft
    factl   = jh(n) * fl                
    NV(1,p) = (  factl * cosc + factt * sinc) / argJ
    NV(2,p) = (- factl * sinc + factt * cosc) / argJ
    NV(3,p) = jhd(n) * fp / argJ 
  end do   
  deallocate (jh, jhd)
end subroutine MN_DS_LAY
!***********************************************************************************
subroutine MN_complete (index, z, theta, phi, Mrank, Nrank, Nmax, plus, sym, MV, NV)
!-----------------------------------------------------------------------------------
! The routine computes the localized vector spherical wave functions for the       !
! azimuthal modes m = 0,1,...,Mrank.                                               !
!                                                                                  !  
! Input parameters:                                                                !
! - index (integer) - if index = 1, the regular vector wave functions are          !
!   computed. If index = 3, the radiating vector wave functions are computed.      !
! - z (complex) - z = k*r, where k is the wave number and r is the module of the   !
!   position vector.                                                               !
! - theta, phi (real variables) - polar angles.                                    !
! - Mrank (integer) - number of azimuthal modes.                                   !
! - Nrank (integer) - maximum expansion order.                                     !
! - Nmax (integer) - specifies the dimension of the vectors.                       !
! - plus (logical) -  if plus = true the vector functions are computed for the     !
!   azimuthal modes m = 0,+1,-1,...,+Mrank,-Mrank. If plus = false the vector      !
!   functions are computed for the azimuthal modes m = 0,-1,+1,...,-Mrank,+Mrank.  !
! - sym (logical) - if sym = true the azimuthal dependence exp(j*m*phi) is         !
!   omitted. If sym = false, this dependence is taken into account.                !
!                                                                                  ! 
! Output parameters:                                                               !
! - MV, NV (complex arrays) - vector spherical wave functions.                     !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: index, Mrank, Nrank, Nmax  
  real(O)    :: theta, phi
  complex(O) :: z, MV(3,Nmax), NV(3,Nmax)
  logical    :: plus, sym
!
  integer    :: k, m, l, ml, N0, n  
  real(O)    :: nr, nm, mlr, ft, fl, arg
  complex(O) :: zc, fact, factp, factt, factl  
  real(O),allocatable    :: Pnm(:), dPnm(:), pinm(:), taunm(:)
  complex(O),allocatable :: jh(:), jhd(:)
!
  allocate (jh(0:Nrank), jhd(0:Nrank))
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  zc = z
  if (abs(zc) < MachEps) zc = cmplx(MachEps,MachEps,O) 
  if (index == 1) then
    call besel_j (zc, Nrank, jh, jhd)
  else if (index == 3) then
    call besel_h (zc, Nrank, jh, jhd)
  end if                    
  do m = 0, Mrank
    call leg_normalized (theta, m, Nrank, Pnm, dPnm, pinm, taunm)    
    if (m == 0) then      
      do k = 1, Nrank
        n  = k
        nr = real(n * (n + 1),O)
        nm = 1._O / sqrt(2._O * nr)     
        ft = taunm(n) * nm
        fl = nr * Pnm(n) * nm        
        MV(1,k) =   zero
        MV(2,k) =   zero
        MV(3,k) = - jh(n)  * ft
        NV(1,k) =   jh(n)  * fl / zc
        NV(2,k) =   jhd(n) * ft / zc
        NV(3,k) =   zero
      end do
    else    
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      ml = m
      if (.not. plus) ml = - m                                 
      do l = 1, 2
        mlr = real(ml,O)
        if (sym) then
          fact = one
        else 
          arg  = mlr * phi
          fact = exp(im * arg) 
        end if 
        do k = 1, Nrank - m + 1
          n     = m + k - 1
          nr    = real(n * (n + 1),O)
          nm    = 1._O / sqrt(2._O * nr)
          factp = im * mlr * pinm(n) * nm * fact
          factt = taunm(n) * nm * fact
          factl = nr * Pnm(n) * nm * fact
          MV(1,N0+k) =   zero
          MV(2,N0+k) =   jh(n)  * factp   
          MV(3,N0+k) = - jh(n)  * factt         
          NV(1,N0+k) =   jh(n)  * factl / zc
          NV(2,N0+k) =   jhd(n) * factt / zc
          NV(3,N0+k) =   jhd(n) * factp / zc
        end do
        N0 =   N0 + Nrank - m + 1
        ml = - ml
      end do
    end if
  end do
  deallocate (jh, jhd)
  deallocate (Pnm, dPnm, pinm, taunm)   
end subroutine MN_complete
!***********************************************************************************
subroutine MN_infinit_complete (theta, phi, Mrank, Nrank, Nmax, plus, Minf, Ninf)
!-----------------------------------------------------------------------------------
! The routine computes the localized vector spherical wave functions at infinity   !
! (excepting the factor exp(j*k*R)/(k*R)) for the azimuthal modes                  !
!  m = 0,1,...,Mrank.                                                              !
!                                                                                  !
! Input parameters:                                                                !
! - theta, phi (real variables) - polar angles.                                    !
! - Mrank (integer) - number of azimuthal modes.                                   !
! - Nrank (integer) - maximum expansion order.                                     !
! - Nmax (integer) - specifies the dimension of the vectors.                       !
! - plus (logical) - if plus = true the vector functiosn are computed for the      !
!   azimuthal modes m = 0,+1,-1,...,+Mrank,-Mrank. If plus = false, the vector     !
!   functions are computed for the azimuthal modes m = 0,-1,+1,...,-Mrank,+Mrank.  !
!                                                                                  !
! Output parameters:                                                               !
! - Minf, Ninf (complex arrays) - vector spherical wave functions.                 !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none  
  integer    :: Mrank, Nrank, Nmax
  real(O)    :: theta, phi
  complex(O) :: Minf(3,Nmax), Ninf(3,Nmax)
  logical    :: plus
!
  integer    :: k, m, l, ml, N0, n  
  real(O)    :: nm, mlr, arg
  complex(O) :: fact, factc, factt, factp
  real(O),allocatable :: Pnm(:), dPnm(:), pinm(:), taunm(:)
!
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))      
  do m = 0, Mrank
    call leg_normalized (theta, m, Nrank, Pnm, dPnm, pinm, taunm)    
    if (m == 0) then      
      do k = 1, Nrank
        n     = k
        nm    = real(2 * n * (n + 1),O)         
        nm    = 1._O / sqrt(nm)             
        factc = (-im)**(n + 1) * nm
        factt = factc * taunm(n)
        Minf(1,k) =   zero
        Minf(2,k) =   zero
        Minf(3,k) = - factt
        Ninf(1,k) =   zero
        Ninf(2,k) =   im * factt
        Ninf(3,k) =   zero
      end do
    else    
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      ml = m
      if (.not. plus) ml = - m
      do l = 1, 2
        mlr  = real(ml,O)
        arg  = mlr * phi
        fact = exp(im * arg)            
        do k = 1, Nrank - m + 1
          n     = m + k - 1
          nm    = real(2 * n * (n + 1),O)               
          nm    = 1._O / sqrt(nm)             
          factc = fact * (-im)**(n + 1) * nm
          factp = factc * mlr * pinm(n)
          factt = factc * taunm(n)
          Minf(1,N0+k) =   zero
          Minf(2,N0+k) =   im * factp
          Minf(3,N0+k) = - factt
          Ninf(1,N0+k) =   zero
          Ninf(2,N0+k) =   im * factt
          Ninf(3,N0+k) = - factp
        end do
        N0 =   N0 + Nrank - m + 1
        ml = - ml
      end do      
    end if
  end do
  deallocate (Pnm, dPnm, pinm, taunm)     
end subroutine  MN_infinit_complete
!***********************************************************************************
subroutine MN_infinit_reflection_complete (wavenumber, z0, ind_ref, theta, phi,     &
           Mrank, Nrank, Nmax, Minf, Ninf)
!-----------------------------------------------------------------------------------
! The routine computes the reflected localized vector spherical wave functions     !
! at infinity (excepting the factor exp(j*k*R)/(k*R)) and the azimuthal modes      !
! m = 0,+1,-1,...,+Mrank,-Mrank.                                                   !
!                                                                                  !
! Input parameters:                                                                !
! - wavenumber (real) - wave number in the ambient medium.                         !
! - z0 (real) - axial coordinate of the substrate.                                 !
! - ind_ref (complex) - relative refractive index of the substrate.                !
! - theta, phi (real variables) - polar angles.                                    !
! - Mrank (integer) - number of azimuthal modes.                                   !
! - Nrank (integer) - maximum expansion order.                                     !
! - Nmax (integer) - specifies the dimension of the vectors.                       !
!                                                                                  !
! Output parameters:                                                               !
! - Minf, Ninf (complex arrays) - vector spherical wave functions.                 !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax, k, m, N0, ml, l, n
  real(O)    :: theta, theta0, phi, wavenumber, z0, arga, mlr, nm
  complex(O) :: ind_ref, Rpar, Rperp, Tpar, Tperp, cost, sint, cost0, fact,         &
                facta, factr, factc, factt, factp, arg, Minf(3,Nmax), Ninf(3,Nmax)
  real(O),allocatable :: Pnm(:), dPnm(:), pinm(:), taunm(:)       
!
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  theta0 = Pi - theta
  cost0 = cmplx(cos(theta0),0.0,O)
  call Fresnel_aer_sub (cost0, ind_ref, Rpar, Rperp, Tpar, Tperp, cost, sint)
  arg   = 2._O * cost0 * wavenumber * z0 
  factr = exp(im * arg)       
  do m = 0, Mrank                  
    call leg_normalized (theta0, m, Nrank, Pnm, dPnm, pinm, taunm)
    if (m == 0) then
      do k = 1, Nrank
        n     = k               
        nm    = real(2 * n * (n + 1),O)         
        nm    = 1._O / sqrt(nm)             
        factc = factr * (-im)**(n + 1) * nm
        factt = factc * taunm(n)                        
        Minf(1,k) =   zero
        Minf(2,k) =   zero
        Minf(3,k) = - factt * Rperp
        Ninf(1,k) =   zero
        Ninf(2,k) =   im * factt * Rpar
        Ninf(3,k) =   zero
      end do    
    else
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      ml = m
      do l = 1, 2
        mlr   = real(ml,O)
        arga  = mlr * phi
        facta = exp(im * arga)
        fact  = facta * factr
        do k = 1, Nrank - m + 1
          n     = m + k - 1
          nm    = real(2 * n * (n + 1),O)               
          nm    = 1._O / sqrt(nm)            
          factc = fact * (-im)**(n + 1) * nm    
          factp = factc * mlr * pinm(n)
          factt = factc * taunm(n)
          Minf(1,N0+k) =   zero
          Minf(2,N0+k) =   im * factp * Rpar
          Minf(3,N0+k) = - factt * Rperp
          Ninf(1,N0+k) =   zero
          Ninf(2,N0+k) =   im * factt * Rpar
          Ninf(3,N0+k) = - factp * Rperp         
        end do
        N0 =   N0 + Nrank - m + 1
        ml = - ml       
      end do
    end if                         
  end do
  deallocate (Pnm, dPnm, pinm, taunm)      
end subroutine MN_infinit_reflection_complete
!***********************************************************************************
subroutine MN_left_right (Nmax, mvl, nvl, mvr, nvr, mv, nv)
  use parameters
  implicit none
  integer    :: Nmax, i, j
  complex(O) :: mvl(3,Nmax), nvl(3,Nmax), mvr(3,Nmax), nvr(3,Nmax), mv(3,Nmax),     &
                nv(3,Nmax)
!
  do i = 1, 3
    do j = 1, Nmax
      mv(i,j) = mvl(i,j) + nvl(i,j)
      nv(i,j) = mvr(i,j) - nvr(i,j) 
    end do
  end do
end subroutine MN_left_right
!***********************************************************************************
subroutine MN_anisotrop (k1, ind_ref, ind_refZ, rBIG, thetaBIG, phiBIG, alphaP,    &
           betaP, gammaP, Mrank, Nrank, Nmax, Nbeta, Xe, Ye, Xh, Yh)
!-----------------------------------------------------------------------------------
! The routine computes the system of vector wave functions (vector quasispherical  !
! wave functions) for uniaxial anisotropic particles.                              !
!                                                                                  !
! Input parameters:                                                                !
! - k1 (complex) - wave number.                                                    ! 
! - ind_ref, ind_refZ (complex variables) - relative refractive indices of the     !
!   uniaxial anisotropic particle.                                                 !
! - rBIG, thetaBIG, phiBIG (real avriables) - spherical coordinates of the         !
!   generic point in the particle coordinate system.                               ! 
! - alphaP, betaP, gammaP (real variables) - Euler angles specifying the           !
!   orientation of the principal coordinate system with respect to the particle    !
!   coordinate system.                                                             !
! - Mrank (integer) - number of azimuthal modes.                                   !
! - Nrank (integer) - maximum expansion order.                                     !
! - Nmax (integer) - specifies the dimension of the vectors.                       !
! - Nbeta (integer) - number of integration points.                                !
!                                                                                  !
! Output parameters:                                                               !
! - Xe, Ye, Xh, Yh (complex arrays) - vector wave functions for the uniaxial       !
!   anisotropic particle.                                                          !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax, Nbeta       
  real(O)    :: rBIG, thetaBIG, phiBIG, alphaP, betaP, gammaP
  complex(O) :: k1, ind_ref, ind_refZ, Xe(3,Nmax), Ye(3,Nmax), Xh(3,Nmax), Yh(3,Nmax)
!
  integer    :: i, k, p, m, n, N0, ml, l      
  real(O)    :: xBIG, yBIG, zBIG, x, y, z, r, theta, phi, abeta, bbeta, beta, fact, &
                Pi2, ct, st, cp, sp, cth, sth, cph, sph, cb, sb, nm, mr, mrp, mrm,  &
                arg, argp, argm, s, mlr, stcp, stsp, sthcph, sthsph, cthcph, cthsph
  complex(O) :: f1, f2, x1, x2, y1, y2, fcp, fsp, f1s, ex1, ex2, f12p, f12m, o1, o2,&
                s1, c1, s2, c2, ft, fp, fJ1, fJ2, fJ1p, fJ1m, fJ2p, fJ2m, Imx1,     &
                Imx2, ImCx1, ImCx2, ImSx1, ImSx2, Xe1, Xe2, Xe3, Ye1, Ye2, Ye3,     &
                Xh1, Xh2, Xh3, Yh1, Yh2, Yh3, ind_refZc, ind_ref2, ind_refZ2,       &
                k1rsth, k1rcth, Pi2im, Piimp, Piimm
  real(O),allocatable    :: Pnm(:), dPnm(:), pinm(:), taunm(:), xbeta(:), wbeta(:) 
  complex(O),allocatable :: J1(:), J2(:)
!
  Pi2  = 2._O * Pi  
  ct   = cos(thetaBIG)
  st   = sin(thetaBIG)
  cp   = cos(phiBIG)
  sp   = sin(phiBIG)
  stcp = st * cp 
  stsp = st * sp 
  xBIG = rBIG * stcp
  yBIG = rBIG * stsp
  zBIG = rBIG * ct
  call T_cartesian_global_local (xBIG, yBIG, zBIG, alphaP, betaP, gammaP, x, y, z)  
  call T_cartesian_spherical (x, y, z, r, theta, phi)  
  cth = cos(theta)
  sth = sin(theta)
  cph = cos(phi)
  sph = sin(phi)
  sthcph = sth * cph 
  sthsph = sth * sph 
  cthcph = cth * cph 
  cthsph = cth * sph
  fcp = Pi2 * im * cph  
  fsp = Pi2 * im * sph
  k1rsth = k1 * r * sth
  k1rcth = k1 * r * cth
  do i = 1, 3
    do k = 1, Nmax
      Xe(i,k) = zero
      Ye(i,k) = zero
      Xh(i,k) = zero
      Yh(i,k) = zero
    end do
  end do  
  allocate (xbeta(Nbeta), wbeta(Nbeta))
  abeta = 0._O
  bbeta = Pi
  call Gauss_Legendre (abeta, bbeta, Nbeta, wbeta, xbeta)                        
  allocate (J1(0:Mrank+1), J2(0:Mrank+1))
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  ind_refZc = ind_refZ
  if (abs(ind_refZc) < MachEps) ind_refZc = cmplx(MachEps,MachEps,O)
  ind_ref2  = ind_ref * ind_ref
  ind_refZ2 = ind_refZc * ind_refZc
  do p = 1, Nbeta
    beta = xbeta(p)
    cb   = cos(beta)
    sb   = sin(beta)
    f1   = (ind_refZ2 * cb**2 + ind_ref2 * sb**2) / ind_refZ2
    f2   = (ind_refZ2 - ind_ref2) * sb * cb / ind_refZ2
    f1s  = sqrt(f1) 
    x1   = k1rsth * sb
    x2   = x1 / f1s
    y1   = k1rcth * cb 
    y2   = y1 / f1s
    ex1  = exp(im * y1)
    ex2  = exp(im * y2)
    f12p =   f1 * cb + f2 * sb
    f12m = - f1 * sb + f2 * cb      
    call bes_J (x1, Mrank + 1, J1)
    call bes_J (x2, Mrank + 1, J2)
    fact = - wbeta(p) * sb / 4._O / Pi      
    do m = 0, Mrank         
      if (m == 0) then   
        call Leg_normalized (beta, m, Nrank, Pnm, dPnm, pinm, taunm)   
        Imx1  = Pi2 * J1(0)
        Imx2  = Pi2 * J2(0)         
        ImCx1 = fcp * J1(1)
        ImCx2 = fcp * J2(1) 
        ImSx1 = fsp * J1(1)
        ImSx2 = fsp * J2(1)
        o1 = Imx1  * ex1
        o2 = Imx2  * ex2
        s1 = ImSx1 * ex1
        c1 = ImCx1 * ex1
        s2 = ImSx2 * ex2
        c2 = ImCx2 * ex2                
        do k = 1, Nrank
          n   = k
          nm  = real(2 * n * (n + 1),O)
          nm  = 1._O / sqrt(nm)                             
          ft  = taunm(n) * nm * (-im)**(n + 1) * fact            
          f1  = im * ft                     
          Xe1 = - f1 * s1
          Xe2 =   f1 * c1
          Xe3 =   zero
          Xe(1,k) = Xe(1,k) + Xe1
          Xe(2,k) = Xe(2,k) + Xe2
          Xe(3,k) = Xe(3,k) + Xe3                           
!
          f2  = f12p * ft
          Ye1 = f2   * c2
          Ye2 = f2   * s2
          Ye3 = f12m * ft * o2      
          Ye(1,k) = Ye(1,k) + Ye1
          Ye(2,k) = Ye(2,k) + Ye2
          Ye(3,k) = Ye(3,k) + Ye3     
!             
          f1  =   ft * cb                       
          Xh1 =   f1 * c1
          Xh2 =   f1 * s1
          Xh3 = - ft * sb * o1
          Xh(1,k) = Xh(1,k) + Xh1
          Xh(2,k) = Xh(2,k) + Xh2
          Xh(3,k) = Xh(3,k) + Xh3 
!                                       
          f2  =   f1s * im * ft
          Yh1 = - f2 * s2
          Yh2 =   f2 * c2
          Yh3 =   zero
          Yh(1,k) = Yh(1,k) + Yh1
          Yh(2,k) = Yh(2,k) + Yh2
          Yh(3,k) = Yh(3,k) + Yh3                 
        end do         
      else   
        N0    = Nrank + (m - 1) * (2 * Nrank - m + 2)
        mr    = real(m,O)
        mrp   = real(m + 1,O)
        mrm   = real(m - 1,O)
        arg   = mr  * phi
        argp  = mrp * phi
        argm  = mrm * phi
        Pi2im = Pi2 * im**m     
        Piimp = Pi  * im**(m + 1)
        Piimm = Pi  * im**(m - 1)           
        call Leg_normalized (beta, m, Nrank, Pnm, dPnm, pinm, taunm)
        ml = m
        s  = 1._O               
        do l = 1, 2
          mlr   = real(ml,O)
          f1    = exp(s * im * arg)               
          fJ1   = f1 * J1(m)
          fJ2   = f1 * J2(m)
          f1    = exp(s * im * argp)
          fJ1p  = f1 * J1(m+1)
          fJ2p  = f1 * J2(m+1)
          f1    = exp(s * im * argm)
          fJ1m  = f1 * J1(m-1)
          fJ2m  = f1 * J2(m-1)
          f1    = Pi2im
          Imx1  = f1 * fJ1
          Imx2  = f1 * fJ2
          f1    = Piimp * fJ1p
          f2    = Piimm * fJ1m
          ImCx1 =   f1 + f2
          ImSx1 = - im * (s * f1 - s * f2)
          f1    = Piimp * fJ2p
          f2    = Piimm * fJ2m
          ImCx2 = f1 + f2
          ImSx2 = - im * (s * f1 - s * f2)
          o1 = Imx1  * ex1
          o2 = Imx2  * ex2
          s1 = ImSx1 * ex1
          c1 = ImCx1 * ex1
          s2 = ImSx2 * ex2
          c2 = ImCx2 * ex2
          do k = 1, Nrank - m + 1
            n   = m + k - 1            
            nm  = real(2 * n * (n + 1),O)
            nm  = 1._O / sqrt(nm)            
            fp  = mlr * pinm(n) * nm * (-im)**(n + 1) * fact
            ft  = taunm(n) * nm * (-im)**(n + 1) * fact            
            f1  = im * ft
            f2  = f12p * fp    
            Xe1 = - f1 * s1 + f2 * c2
            Xe2 =   f1 * c1 + f2 * s2
            Xe3 =   f12m * fp * o2
            Xe(1,k+N0) = Xe(1,k+N0) + Xe1
            Xe(2,k+N0) = Xe(2,k+N0) + Xe2
            Xe(3,k+N0) = Xe(3,k+N0) + Xe3
!               
            f1  =   im * fp
            f2  =   f12p * ft
            Ye1 = - f1 * s1 + f2 * c2
            Ye2 =   f1 * c1 + f2 * s2
            Ye3 =   f12m * ft * o2
            Ye(1,k+N0) = Ye(1,k+N0) + Ye1
            Ye(2,k+N0) = Ye(2,k+N0) + Ye2
            Ye(3,k+N0) = Ye(3,k+N0) + Ye3             
!              
            f1  =   ft * cb
            f2  =   f1s * im * fp
            Xh1 =   f1 * c1 - f2 * s2
            Xh2 =   f1 * s1 + f2 * c2
            Xh3 = - ft * sb * o1
            Xh(1,k+N0) = Xh(1,k+N0) + Xh1
            Xh(2,k+N0) = Xh(2,k+N0) + Xh2
            Xh(3,k+N0) = Xh(3,k+N0) + Xh3
!
            f1  =   fp * cb
            f2  =   f1s * im * ft
            Yh1 =   f1 * c1 - f2 * s2
            Yh2 =   f1 * s1 + f2 * c2
            Yh3 = - fp * sb * o1     
            Yh(1,k+N0) = Yh(1,k+N0) + Yh1
            Yh(2,k+N0) = Yh(2,k+N0) + Yh2
            Yh(3,k+N0) = Yh(3,k+N0) + Yh3
          end do  
          N0 =   N0 + Nrank - m + 1                   
          ml = - m
          s  = - s
        end do        
      end if
    end do  
  end do
! --- pass to spherical coordinates ---              
  do k = 1, Nmax
    Xe1 = Xe(1,k) 
    Xe2 = Xe(2,k) 
    Xe3 = Xe(3,k)  
    Xe(1,k) =   Xe1 * sthcph + Xe2 * sthsph + Xe3 * cth
    Xe(2,k) =   Xe1 * cthcph + Xe2 * cthsph - Xe3 * sth
    Xe(3,k) = - Xe1 * sph    + Xe2 * cph
!
    Ye1 = Ye(1,k) 
    Ye2 = Ye(2,k) 
    Ye3 = Ye(3,k)  
    Ye(1,k) =   Ye1 * sthcph + Ye2 * sthsph + Ye3 * cth
    Ye(2,k) =   Ye1 * cthcph + Ye2 * cthsph - Ye3 * sth
    Ye(3,k) = - Ye1 * sph    + Ye2 * cph
!
    Xh1 = Xh(1,k) 
    Xh2 = Xh(2,k) 
    Xh3 = Xh(3,k)  
    Xh(1,k) =   Xh1 * sthcph + Xh2 * sthsph + Xh3 * cth
    Xh(2,k) =   Xh1 * cthcph + Xh2 * cthsph - Xh3 * sth
    Xh(3,k) = - Xh1 * sph    + Xh2 * cph
!
    Yh1 = Yh(1,k) 
    Yh2 = Yh(2,k) 
    Yh3 = Yh(3,k)  
    Yh(1,k) =   Yh1 * sthcph + Yh2 * sthsph + Yh3 * cth
    Yh(2,k) =   Yh1 * cthcph + Yh2 * cthsph - Yh3 * sth
    Yh(3,k) = - Yh1 * sph    + Yh2 * cph            
  end do        
  deallocate (J1, J2, xbeta, wbeta)
  deallocate (Pnm, dPnm, pinm, taunm)      
end subroutine MN_anisotrop
!***********************************************************************************
subroutine MN_m_anisotrop (k1, ind_ref, ind_refZ, rBIG, thetaBIG, phiBIG, alphaP,   &
           betaP, gammaP, m, Nrank, Nmax, Nbeta, Xe, Ye, Xh, Yh)

!-----------------------------------------------------------------------------------
! The routine computes the system of vector wave functions (vector quasispherical  !
! wave functions) for uniaxial anisotropic particles and the azimuthal mode m.     !
!                                                                                  !
! Input parameters:                                                                !
! - k1 (complex) - wave number.                                                    ! 
! - ind_ref, ind_refZ (complex variables) - relative refractive indices of the     !
!   uniaxial anisotropic particle.                                                 !
! - rBIG, thetaBIG, phiBIG (real avriables) - spherical coordinates of the         !
!   generic point in the particle coordinate system.                               ! 
! - alphaP, betaP, gammaP (real variables) - Euler angles specifying the           !
!   orientation of the principal coordinate system with respect to the particle    !
!   coordinate system.                                                             !
! - m (integer) - azimuthal mode. m is postive or negative.                        !
! - Nrank (integer) - maximum expansion order.                                     !
! - Nmax (integer) - specifies the dimension of the vectors.                       !
! - Nbeta (integer) - number of integration points.                                !
!                                                                                  !
! Output parameters:                                                               !
! - Xe, Ye, Xh, Yh (complex arrays) - vector wave functions for the uniaxial       !
!   anisotropic particle.                                                          !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: m, Nrank, Nmax, Nbeta   
  real(O)    :: rBIG, thetaBIG, phiBIG, alphaP, betaP, gammaP
  complex(O) :: k1, ind_ref, ind_refZ, Xe(3,Nmax), Ye(3,Nmax), Xh(3,Nmax), Yh(3,Nmax)
!
  integer    :: i, k, p, mabs, n      
  real(O)    :: xBIG, yBIG, zBIG, x, y, z, r, theta, phi, abeta, bbeta, beta, fact, &
                Pi2, ct, st, cp, sp, cth, sth, cph, sph, cb, sb, nm, mr, mrp, mrm,  &
                arg, argp, argm, s, mlr, stcp, stsp, sthcph, sthsph, cthcph, cthsph
  complex(O) :: f1, f2, x1, x2, y1, y2, fcp, fsp, f1s, ex1, ex2, f12p, f12m, o1, o2,&
                s1, c1, s2, c2, ft, fp, fJ1, fJ2, fJ1p, fJ1m, fJ2p, fJ2m, Imx1,     &
                Imx2, ImCx1, ImCx2, ImSx1, ImSx2, Xe1, Xe2, Xe3, Ye1, Ye2, Ye3,     &
                Xh1, Xh2, Xh3, Yh1, Yh2, Yh3, ind_refZc, ind_ref2, ind_refZ2,       &
                k1rsth, k1rcth, Pi2im, Piimp, Piimm
  real(O),allocatable    :: Pnm(:), dPnm(:), pinm(:), taunm(:), xbeta(:), wbeta(:) 
  complex(O),allocatable :: J1(:), J2(:)
!
  Pi2  = 2._O * Pi  
  ct   = cos(thetaBIG)
  st   = sin(thetaBIG)
  cp   = cos(phiBIG)
  sp   = sin(phiBIG)
  stcp = st * cp 
  stsp = st * sp 
  xBIG = rBIG * stcp
  yBIG = rBIG * stsp
  zBIG = rBIG * ct
  call T_cartesian_global_local (xBIG, yBIG, zBIG, alphaP, betaP, gammaP, x, y, z)  
  call T_cartesian_spherical (x, y, z, r, theta, phi)  
  cth = cos(theta)
  sth = sin(theta)
  cph = cos(phi)
  sph = sin(phi)
  sthcph = sth * cph 
  sthsph = sth * sph 
  cthcph = cth * cph 
  cthsph = cth * sph
  fcp = Pi2 * im * cph  
  fsp = Pi2 * im * sph
  k1rsth = k1 * r * sth
  k1rcth = k1 * r * cth
  do i = 1, 3
    do k = 1, Nmax
      Xe(i,k) = zero
      Ye(i,k) = zero
      Xh(i,k) = zero
      Yh(i,k) = zero
    end do
  end do  
  allocate (xbeta(Nbeta), wbeta(Nbeta))
  abeta = 0._O
  bbeta = Pi
  call Gauss_Legendre (abeta, bbeta, Nbeta, wbeta, xbeta)                        
  mabs  = abs(m)
  mr    = real(mabs,O)
  mrp   = real(mabs + 1,O)
  mrm   = real(mabs - 1,O)
  arg   = mr  * phi
  argp  = mrp * phi
  argm  = mrm * phi
  Pi2im = Pi2 * im**mabs        
  Piimp = Pi  * im**(mabs + 1)
  Piimm = Pi  * im**(mabs - 1)  
  allocate (J1(0:mabs+1), J2(0:mabs+1))
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  ind_refZc = ind_refZ
  if (abs(ind_refZc) < MachEps) ind_refZc = cmplx(MachEps,MachEps,O)
  ind_ref2  = ind_ref * ind_ref
  ind_refZ2 = ind_refZc * ind_refZc
  do p = 1, Nbeta
    beta = xbeta(p)
    cb   = cos(beta)
    sb   = sin(beta)
    f1   = (ind_refZ2 * cb**2 + ind_ref2 * sb**2) / ind_refZ2
    f2   = (ind_refZ2 - ind_ref2) * sb * cb / ind_refZ2
    f1s  = sqrt(f1) 
    x1   = k1rsth * sb
    x2   = x1 / f1s
    y1   = k1rcth * cb 
    y2   = y1 / f1s
    ex1  = exp(im * y1)
    ex2  = exp(im * y2)
    f12p =   f1 * cb + f2 * sb
    f12m = - f1 * sb + f2 * cb      
    call bes_J (x1, mabs + 1, J1)
    call bes_J (x2, mabs + 1, J2)
    fact = - wbeta(p) * sb / 4._O / Pi          
    if (m == 0) then     
      call Leg_normalized (beta, 0, Nrank, Pnm, dPnm, pinm, taunm)   
      Imx1  = Pi2 * J1(0)
      Imx2  = Pi2 * J2(0)           
      ImCx1 = fcp * J1(1)
      ImCx2 = fcp * J2(1) 
      ImSx1 = fsp * J1(1)
      ImSx2 = fsp * J2(1)
      o1 = Imx1  * ex1
      o2 = Imx2  * ex2
      s1 = ImSx1 * ex1
      c1 = ImCx1 * ex1
      s2 = ImSx2 * ex2
      c2 = ImCx2 * ex2              
      do k = 1, Nmax
        n   = k
        nm  = real(2 * n * (n + 1),O)
        nm  = 1._O / sqrt(nm)                               
        ft  = taunm(n) * nm * (-im)**(n + 1) * fact            
        f1  = im * ft                       
        Xe1 = - f1 * s1
        Xe2 =   f1 * c1
        Xe3 =   zero
        Xe(1,k) = Xe(1,k) + Xe1
        Xe(2,k) = Xe(2,k) + Xe2
        Xe(3,k) = Xe(3,k) + Xe3                             
!
        f2  = f12p * ft
        Ye1 = f2   * c2
        Ye2 = f2   * s2
        Ye3 = f12m * ft * o2        
        Ye(1,k) = Ye(1,k) + Ye1
        Ye(2,k) = Ye(2,k) + Ye2
        Ye(3,k) = Ye(3,k) + Ye3       
!             
        f1  =   ft * cb                 
        Xh1 =   f1 * c1
        Xh2 =   f1 * s1
        Xh3 = - ft * sb * o1
        Xh(1,k) = Xh(1,k) + Xh1
        Xh(2,k) = Xh(2,k) + Xh2
        Xh(3,k) = Xh(3,k) + Xh3 
!                                       
        f2  =   f1s * im * ft
        Yh1 = - f2 * s2
        Yh2 =   f2 * c2
        Yh3 =   zero
        Yh(1,k) = Yh(1,k) + Yh1
        Yh(2,k) = Yh(2,k) + Yh2
        Yh(3,k) = Yh(3,k) + Yh3                   
      end do         
    else                    
      call Leg_normalized (beta, mabs, Nrank, Pnm, dPnm, pinm, taunm)     
      if (m > 0) then
        s = 1._O        
      else
        s = - 1._O
      end if                      
      mlr   = real(m,O)
      f1    = exp(s * im * arg)               
      fJ1   = f1 * J1(mabs)
      fJ2   = f1 * J2(mabs)
      f1    = exp(s * im * argp)
      fJ1p  = f1 * J1(mabs+1)
      fJ2p  = f1 * J2(mabs+1)
      f1    = exp(s * im * argm)
      fJ1m  = f1 * J1(mabs-1)
      fJ2m  = f1 * J2(mabs-1)
      f1    = Pi2im
      Imx1  = f1 * fJ1
      Imx2  = f1 * fJ2
      f1    = Piimp * fJ1p
      f2    = Piimm * fJ1m
      ImCx1 =   f1 + f2
      ImSx1 = - im * (s * f1 - s * f2)
      f1    = Piimp * fJ2p
      f2    = Piimm * fJ2m
      ImCx2 = f1 + f2
      ImSx2 = - im * (s * f1 - s * f2)
      o1 = Imx1  * ex1
      o2 = Imx2  * ex2
      s1 = ImSx1 * ex1
      c1 = ImCx1 * ex1
      s2 = ImSx2 * ex2
      c2 = ImCx2 * ex2
      do k = 1, Nmax
        n   = mabs + k - 1            
        nm  = real(2 * n * (n + 1),O)
        nm  = 1._O / sqrt(nm)            
        fp  = mlr * pinm(n) * nm * (-im)**(n + 1) * fact
        ft  = taunm(n) * nm * (-im)**(n + 1) * fact            
        f1  = im * ft
        f2  = f12p * fp    
        Xe1 = - f1 * s1 + f2 * c2
        Xe2 =   f1 * c1 + f2 * s2
        Xe3 =   f12m * fp * o2
        Xe(1,k) = Xe(1,k) + Xe1
        Xe(2,k) = Xe(2,k) + Xe2
        Xe(3,k) = Xe(3,k) + Xe3
!               
        f1  =   im * fp
        f2  =   f12p * ft
        Ye1 = - f1 * s1 + f2 * c2
        Ye2 =   f1 * c1 + f2 * s2
        Ye3 =   f12m * ft * o2
        Ye(1,k) = Ye(1,k) + Ye1
        Ye(2,k) = Ye(2,k) + Ye2
        Ye(3,k) = Ye(3,k) + Ye3               
!              
        f1  =   ft * cb
        f2  =   f1s * im * fp
        Xh1 =   f1 * c1 - f2 * s2
        Xh2 =   f1 * s1 + f2 * c2
        Xh3 = - ft * sb * o1
        Xh(1,k) = Xh(1,k) + Xh1
        Xh(2,k) = Xh(2,k) + Xh2
        Xh(3,k) = Xh(3,k) + Xh3
!
        f1  =   fp * cb
        f2  =   f1s * im * ft
        Yh1 =   f1 * c1 - f2 * s2
        Yh2 =   f1 * s1 + f2 * c2
        Yh3 = - fp * sb * o1         
        Yh(1,k) = Yh(1,k) + Yh1
        Yh(2,k) = Yh(2,k) + Yh2
        Yh(3,k) = Yh(3,k) + Yh3                                                                                                     
      end do                 
    end if      
  end do
! --- pass to spherical coordinates ---              
  do k = 1, Nmax
    Xe1 = Xe(1,k) 
    Xe2 = Xe(2,k) 
    Xe3 = Xe(3,k)  
    Xe(1,k) =   Xe1 * sthcph + Xe2 * sthsph + Xe3 * cth
    Xe(2,k) =   Xe1 * cthcph + Xe2 * cthsph - Xe3 * sth
    Xe(3,k) = - Xe1 * sph    + Xe2 * cph
!
    Ye1 = Ye(1,k) 
    Ye2 = Ye(2,k) 
    Ye3 = Ye(3,k)  
    Ye(1,k) =   Ye1 * sthcph + Ye2 * sthsph + Ye3 * cth
    Ye(2,k) =   Ye1 * cthcph + Ye2 * cthsph - Ye3 * sth
    Ye(3,k) = - Ye1 * sph    + Ye2 * cph
!
    Xh1 = Xh(1,k) 
    Xh2 = Xh(2,k) 
    Xh3 = Xh(3,k)  
    Xh(1,k) =   Xh1 * sthcph + Xh2 * sthsph + Xh3 * cth
    Xh(2,k) =   Xh1 * cthcph + Xh2 * cthsph - Xh3 * sth
    Xh(3,k) = - Xh1 * sph    + Xh2 * cph
!
    Yh1 = Yh(1,k) 
    Yh2 = Yh(2,k) 
    Yh3 = Yh(3,k)  
    Yh(1,k) =   Yh1 * sthcph + Yh2 * sthsph + Yh3 * cth
    Yh(2,k) =   Yh1 * cthcph + Yh2 * cthsph - Yh3 * sth
    Yh(3,k) = - Yh1 * sph    + Yh2 * cph            
  end do        
  deallocate (J1, J2, xbeta, wbeta)
  deallocate (Pnm, dPnm, pinm, taunm)      
end subroutine MN_m_anisotrop

subroutine TLAY
!------------------------------------------------------------------------------------
! 1. General Considerations                                                         !
! --------------------------                                                        !
! TLAY is a routine for computing the T matrix and the scattering characteristics   !
! of axisymmetric layered particles. The particle consists of Npart layers, each    !
! characterized by arbitrary but constant values of electric permittivity and       !
! magnetic permeability. Each layer is bounded by two surfaces. The enclosing       !
! (exterior) surface will be referred to as the layer surface, and obviously, the   !
! first layer surface is the largest surface.                                       ! 
!                                                                                   !
! The domain of analysis is divided into homogeneous layers. The electric and       !
! magnetic fields of a specific layer i can be approximated by using localized      !
! or distributed vector spherical wave functions, and Nrankp(i) will be referred    !
! to as the maximum expansion order of the layer i.                                 !
!                                                                                   !
! The transition matrix of a layered particle can be obtained by considering the    !
! null-field condition for the total electric field inside and outside each region. !
! Note that for axisymmetric layered particles, the scattering problem decouples    !
! over the azimuthal modes m and the T matrix can be computed separately for each m.!
!                                                                                   !
! Particle geometries currently supported include layered spheroids and cylinders.  !
! The following routines (from the file "GeomLib.f90") provide the required         !
! geometry parameters:                                                              !
! - the routine "interpolation_listLAY" computes the integration nodes and weights  !
!   for each layer generatrix,                                                      !
! - the routine "elem_geomLAY" provides the geometry parameters (position vector,   !
!   polar and azimuthal angles and normal unit vector in spherical coordinates)     !
!   at each integration node, and                                                   !
! - the routine "zDSLAY" generates the coordinates of the distributed sources.      !
! The generatrix of each layer is described with respect to a local coordinate      !
! system and the axial positions of the local coordinate systems are specified in   !
! the global coordinate system of the layered particle by the array OriginPart.     !
! The global coordinate system can be chosen as the local coordinate system of the  !
! first layer surface (host particle) by setting OriginPart(1) = 0.0. By convention,! 
! the COORDINATES OF THE DISTRIBUTED SOURCES corresponding to a specific layer are  !
! provided in the GLOBAL COORDINATE SYSTEM. The user can easily modify the above    !
! routines to generate particles with other geometries. Note that the list of       !
! parameters must be maintained and only geometries with an analytical description  !
! of the surface can be implemented.                                                !
!                                                                                   !
! 2. Convergence Test                                                               !
! --------------------                                                              !
! Convergence tests precede the scattering characteristics calculation. Three       !
! parameters control the T-matrix computation:                                      !
! - the number of integration points Nint,                                          !
! - the maximum expansion order Nrank, and                                          !
! - the maximum azimuthal order Mrank.                                              !
!                                                                                   !
! Before going any further, we will explain the significance of the parameters      !
! Nrank and Nint. Let Nrankp(i) be the maximum expansion order of the layer i,      !
! i = 1,2,...,Npart, where Npart is the number of layers. Nrank is defined as:      !
!                                                                                   !
!                             Nrank = Nrankp(1),                                    !
!                                                                                   !
! i.e., Nrank is the maximum expansion order corresponding to the host particle.    !
! The parameter Nrank determines the dimension of the T matrix and by convention,   !          
! Nrank will be referred to as the maximum expansion order of the layered particle. !
! Analogously, we define Nint as the number of integration points on the first      !
! generatrix, and Nint will be referred to as the global number of integration      !
! points for the layered particle. The number of integration points on the layer    !
! generatrix i is                                                                   !
!                                                                                   !
!                    Nint_layer(i) = l(i) * Nint / l(1),                            !
!                                                                                   !
! where l(i) is a characteristic length of the layer i. Each layer generatrix i     !
! can be divided into NparamPart(i) piecewise smooth curves and the number of       !
! integration points on the smooth curve j is                                       !
!                                                                                   !
!               Nint_layer_curve(i,j) = int { c(j) * Nint_layer(i) },               !
!                                                                                   !
! where c(j) is a multiplicative factor. The parameters c(j), do not appear as      !
! explicit parameters; they are hard coded in the routine "interpolation_listLAY"   !
! from the file "GeomLib.f90". For the supplied geometries,                         !
!                                                                                   !
!                         l(i) = max {a(i),b(i)},                                   !
!                                                                                   !
! where a(i) and b(i) are the semi-axes of the spheroidal surface i, or the         !
! half-length and the radius of the cylindrical surface i. The generatrix of a      !
! cylinder is divided into three straight lines. The first and third lines are      !
! perpendicular to the axis of symmetry, while the second line is parallel to the   !
! axis of symmetry. Denoting by a the half-length  of the cylinder and by b the     !
! cylinder radius, we have:                                                         !
!                                                                                   !
!                 Nint_layer_curve(cylinder,first line)                             !
!               = Nint_layer_curve(cylinder,third line)                             !
!               = int {[b/2/(a + b)] * Nint_layer(cylinder)}                        !
!                                                                                   !
! and                                                                               !
!                                                                                   !  
!               Nint_layer_curve(cylinder, second line)                             ! 
!      = Nint_layer(cylinder) - 2 * int {[b/2/(a + b)] * Nint_layer(cylinder) }.    !
!                                                                                   !
! For convergence tests, the incident wave is assumed to be a plane wave traveling  !
! along the Z-axis of the global coordinate system and the scattering               !
! characteristics  are computed in the azimuthal plane  phi = 0°. The convergence   !
! tests over Nint and Nrank are interactive, while the convergence test over Mrank  !
! is automatically performed.                                                       !  
!                                                                                   !
! For the integration and expansion order test, an axisymmetric orientation of the  !
! particle is considered, i.e., the incident wave propagates along the axis of      !
! symmetry of the particle. In this case, all azimuthal modes are zero except       !
! for m = - 1 and m = 1. For the convergence test over Nint, the scattering problem !
! is solved for Nint and Nint + dNint, while for the convergence test over Nrank,   !
! the scattering problem is solved for                                              !
!                                                                                   !
!                 Nrankp(i), i = 1,2,...,Npart,                                     !
!                                                                                   !
! and                                                                               !
!                                                                                   !
!                 Nrankp(i) - 1, i = 1,2,...,Npart.                                 !
!                                                                                   !  
! The normalized differential scattering cross section (DSCS) will be checked at    !
! 20° increments for convergence within epsX (epsNint or epsNrank) tolerance. If    !
! the calculated results converge within this tolerance at 80% of the scattering    !
! angles, then convergence is achieved.                                             !
!                                                                                   ! 
! After Nrank and Nint have been determined we pass to the azimuthal order test.    !
! The program automatically sets the particle to a more general orientation, i.e.,  !
! alpha = beta = 45°, and solves the scattering problem  for increasing m values    !
! until convergence of the angular scattering is achieved. The T matrix is stored   !
! for later use by other programs, and the values of Nrank and Mrank are printed to !
! the screen and to the T-matrix information file.  These values together with the  !
! T matrix serve as INPUT PARAMETERS for other programs.                            !
!                                                                                   !
! 3. Estimates of Nint and Nrank                                                    !
! -------------------------------                                                   !
! The above convergence tests require estimates for the number of integration       !
! points (Nint), and the maximum expansion orders for each layer (Nrankp(i),        !
! i = 1,2,...,Npart). These estimates are user-defined.                             !
!                                                                                   !
! A reasonable starting value of Nrankp is given by Wiscombe's truncation limit     !
! criterion [W. J. Wiscombe, Improved Mie scattering algorithms, Applied Optics,    !
! 19, 1505-1509, 1980], i.e.,                                                       !
!                                                                                   !                       
!                NrankpW = int(xp + 4.05 * xp**0.33 + 2),                           !
!                                                                                   !
! where xp is the size parameter of the layer, xp = k * lnormPart, k is the wave    !
! number and lnormPart is the radius of the smallest sphere circumscribing the      !
! layer.                                                                            !
!                                                                                   !
! The value of Nint depends on the type of discrete sources, the size parameter,    !
! and the optical properties of the layered particle. If                            !
!                                                                                   ! 
!                        Nrank = Nrankp(1),                                         !
!                                                                                   !
! we propose the following estimate                                                 !
!                                                                                   !
!                        Nint = Ndgs * Nrank,                                       !
!                                                                                   !
! where Ndgs = 15, 20, 25, .... For distributed sources, the value of Nint should   !
! be substantially larger than the value corresponding to localized sources.        !
!                                                                                   !
! 4. Strategies for Performing Convergence Tests                                    !
! -----------------------------------------------                                   !
! Two strategies for performing convergence tests over Nint and Nrank are           !
! recommended. The following technique is an extension of the approach used for     !
! homogeneous axisymmetric particles:                                               !
! 1. for each layer i, choose a value of Nrankp(i) close to the value predicted     !
!    by Wiscombe's truncation limit criterion;                                      !
! 2. for the set Nrankp(i), perform the expansion order test with                   !
!    Nint = Ndgs * Nrank, where e.g., Ndgs = 15;                                    !
! 3. if convergence is not achieved, set Nrankp(i) = Nrankp(i) + 1 for all layers   !
!    i, maintain the relation Nint = Ndgs * Nrank and go to Step 2;                 !
! 4. if convergence is achieved, perform several integration tests with the initial !
!    Nint-value, Nint = Ndgs * Nrank, until the DSCS converges.                     !
! At Step 3, it is not necessary to increase all Nrankp-values (for all layers).    !
! If the user has the feeling that some Nrankp-values are correct, these values     !
! need not to be changed.                                                           !  
!                                                                                   !
! For large and/or highly aspherical layered particles, T-matrix computations       !
! become poorly covergent or divergent. Frequently, a semi-convergent behaviour is  !
! attended: the errors decrease with increasing the maximum expansion order,        !
! attain a relative constant level and afterwards increase. The region of           !
! stability can be localized by using the following technique:                      !
! 1. for each layer i, choose a value of Nrankp(i) smaller than the value           !
!    predicted by Wiscombe's truncation limit criterion;                            !
! 2. for the set Nrankp(i), perform several integration tests with the initial      !
!    Nint-value, Nint = Ndgs * Nrank, until the DSCS converges;                     !
! 3. if convergence is not achieved, set Nrankp(i) = Nrankp(i) - 1 for all layers   !
!    i, or increase the tolerance epsNint, and go to Step 2;                        !
! 4. if convergence is achieved (for some Nint), perform several expansion order    !
!    tests for increasing Nrankp-values and monitor the errors of the               !
!    differential scattering cross sections.                                        ! 
! As before, at Steps 3 and 4, not all Nrankp-values need to be changed.            !
!                                                                                   !
! For particles which are too extreme in size and/or aspect ratio, the errors of    !
! the extinction and scattering cross sections (instead of the differential         !
! scattering cross section) can be analyzed.                                        ! 
!                                                                                   !
! 5. Additional Comments                                                            !
! -----------------------                                                           !
! For the expansion order test and distributed sources, two configurations of       !
! sources are considered. For both configurations, the coordinates of the           !
! distributed sources can be generated automatically or can be specified in the     !
! input file.                                                                       !
!                                                                                   !
! The convergence tests over Nint and Nrank can be switched off by setting the      !
! logical variable DoConvTest to false. In this case, the values of Nint and        !
! Nrank must be specified in the input file.                                        !
!                                                                                   !
! Nint and Nrank have been determined for the azimuthal orders m = 1 and m = - 1.   ! 
! For higher azimuthal orders and sources distributed in the complex plane, the     !
! chosen values of Nint and Nrank may lead to false convergence. There are two      !
! strategies for improving the numerical stability.                                 !
! 1. The number of integration points can be increased at each azimuthal mode       !
! calculation with the integration step dNintMrank. The parameter dNintMrank         !
! should be found experimentally by repeating the azimuthal order test for          !
! different input values until the differential scattering cross section converges. !
! A conservative estimate is: dNintMrank = (0.1,...,0.2) * Nint.                    !
! 2. For sources generated automatically, an interactive convergence test over      !
! Nint and Nrank can be performed at each azimuthal mode calculation. The general   !
! strategy is to reduce the number of discrete sources (Nrankp(i), i = 1,2,...,     !
! Npart) and to increase the number of integration points (Nint) for increasing     !
! values of m. However, in the current version of the program, this test is not     !
! active (see the comments in the subroutine "convergence_MrankDSLAY").             !
!                                                                                   !
! The number of azimuthal modes is the same for all layers, and for localized       !
! sources, the relation Mrank <= Nrankp(i), for all i = 1,2,...,Npart, should be    !
! satisfied. However, the Nrankp(i), i = 1,2,...,Npart, are determined before Mrank !
! is computed. Therefore, for the azimuthal mode calculation m, with |m| > 1,       !
! we set Nrankp(i) = |m|, if Nrankp(i) < |m| for some i. In this case, the maximum  !
! expansion order of a layer is m-dependent and                                     !
!                                                                                   !
!                    n = |m|,|m|+1,...,Nrankp(i,|m|).                               !
!                                                                                   !
! 6. Input Parameters                                                               !
! ---------------------                                                             !
! The parameters specified in the input file "/INPUTFILES/InputLAY.dat" are listed  !
! below                                                                             !
!                                                                                   !
! - wavelength (real) - wavelength of the incident light in vacuo.                  !
!                                                                                   !
! - ind_refMed (real) - refractive index of the ambient medium (nonabsorbing        !
!   dielectric medium).                                                             !
!                                                                                   !
! - TypeGeom (integer) - parameter specifying the type of the particle geometry.    !
!                                                                                   !
! - Npart (integer) - number of layers.                                             !
!                                                                                   !
! - anorm (real) - characteristic length of the layered particle which is used      !
!   to normalize the differential scattering cross sections.                        !
!                                                                                   !
! - DoConvTest (logical) - if DoConvTest = t, the interactive convergence tests     !
!   over Nint and Nrank are invoked. Estimates of Nrank for all layers are          !
!   provided by Wiscombe's truncation limit criterion. If DoConvTest = f, the       !
!   values of Nint and Nrank must be supplied in the input file.                    !
!                                                                                   !
! - DS (logical) - if DS = t, distributed sources are used for T-matrix             !
!   calculation, otherwise localized sources are employed.                          !
!                                                                                   !
! - autGenDS (logical) - if autGenDS = t, the routine "zDSLAY" generates the        !
!   coordinates of the distributed sources. Otherwise, the coordinates of the       !
!   distributed sources must be provided by the user. If DS = f, the logical        ! 
!   variable autGenDS is ignored.                                                   ! 
!                                                                                   !
! - Nint (integer) - global number of integration points for the layered            !
!   particle. This parameter is used if the convergence tests are not performed     !
!   (DoConvTest = f).                                                               !
!                                                                                   !
! The next parameters (specified in a sequence of group statements) characterize     !
! each layer.                                                                       !
! - ind_refPartRel (complex) - relative refractive index of the actual layer        !
!   with respect to the ambient medium. The imaginary part of the relative          !
!   refractive index must be zero for nonabsorbing particles and positive for       !
!   absorbing particles.                                                            !
!                                                                                   !
! - NsurfPart (integer) - number of surface parameters of the actual layer.         !
!                                                                                   !
! - NparamPart (integer) - number of smooth curves forming the generatrix curve of  !
!   the actual layer.                                                               !
!                                                                                   !
! - OriginPart (real) - axial position of the local coordinate system of the        !
!   actual layer with respect to the global coordinate system of the layered        !
!   particle. This parameter can be positive or negative.                           !
!                                                                                   !
! - surfPart (real array: surfPart(1), surfPart(2),...,surfPart(NsurfPart)) -       !
!   surface parameters specifying the shape of the actual layer. The dimension of   !
!   the array is NsurfPD. The integer parameter NsurfPD is specified in the         !
!   routine  "Parameters.f90" and has the value NsurfPD = 10. If                    !
!   NsurfPart > NsurfPD, the execution is automatically terminated.                 !
!                                                                                   !
!   The permissive values of the surface parameters (for the supported geometries)  !
!   are summarized below.                                                           !
!                                                                                   !
!      Particle      TypeGeom   Nsurf   Nparam                surf                  ! 
!     concentric        1         2        1        surf(1) - length of the semi-   ! 
!     spheroids                                               axis along the        ! 
!                                                             symmetry axis         !  
!                                                   surf(2) - length of the second  ! 
!                                                             semi-axis             !     
!                                                                                   ! 
!     concentric        2         2        3        surf(1) - half-length of        ! 
!     cylinders                                               the cylinder          !  
!                                                   surf(2) - cylinder radius       ! 
!                                                                                   !
! - lnormPart (real) - characteristic length of the actual layer (usually the       !
!   radius of the smallest circumscribing sphere) which is used to compute an       !
!   estimate of the maximum expansion order by using Wiscombe's truncation limit    !
!   criterion. Alternatively, lnormPart can be chosen as the equal-volume sphere    !
!   radius or the surface-equivalent-sphere radius.                                 !
!                                                                                   !
! - ComplexPlanePart (logical) - if ComplexPlanePart = t, the distributed sources   !
!   are situated in the complex plane. This parameter is used if distributed sources!
!   are required and the coordinates of the distributed sources are automatically   !
!   generated (DS = t and autGenDS = t).                                            !
!                                                                                   !
! - EpsZReImPart (real) - input parameter of the routine "zDSLAY" which controls    !
!   the distribution of the discrete sources. This parameter is used if distributed !
!   sources are required and the coordinates of the distributed sources are         !
!   automatically generated (DS = t and autGenDS = t).                              !
!                                                                                   !
! - NrankPart (integer) - maximum expansion order for the actual layer. This        !
!   parameter is used if the convergence tests are not performed, or the coordinates!
!   of the distributed sources are user-defined. More specifically, NrankPart is    !
!   used if                                                                         !
!   - (DS = f, DoConvTest = f),                                                     !
!   - (DS = t, autGenDS = t, DoConvTest = f), or                                    ! 
!   - (DS = t, autGenDS = f, DoConvTest = t/f).                                     !
!                                                                                   !
! - zRePart, zImPart (real arrays: zXPart(1), zXPart(2),...,zXPart(Nrankp),         !
!   X = Re, Im) - coordinates of the distributed sources for the actual layer and   !
!   the expansion order NrankPart. These parameters are used if the coordinates of  !
!   the distributed sources are user-defined (DS = t and autGenDS = f). The         !
!   dimension of the arrays zRePart and zImPart is NrankPD and the inequality       !
!   NrankPart <= NrankPD must hold. The integer parameter NrankPD is specified in   !
!   the routine "Parameters.f90" and has the value NrankPD = 200. If                !
!   NrankPart > NrankPD, the execution is automatically terminated. Note that the   !
!   coordinates of the distributed sources are defined with respect to the GLOBAL   !
!   COORDINATE SYSTEM of the layered particle.                                      !
!                                                                                   !
! - zRePart1, zImPart1 (real arrays: zXPart1(1), zXPart1(2),...,zXPart1(Nrankp-1),  !
!   X = Re, Im) - coordinates of the distributed sources for the actual layer and   !
!   the expansion order NrankPart - 1. These parameters are used if the             !
!   coordinates of the distributed sources are user-defined and the expansion order !
!   test is performed (DS = t and autGenDS = f and TypeConvTest = 2). The dimension !
!   of the arrays zRePart1 and zImPart1 is NrankPD. As before, zRePart1 and zImPart1!
!   are defined with respect to the GLOBAL COORDINATE SYSTEM of the layered         !
!   particle.                                                                       !
!                                                                                   !
! NOTE: THE INPUT ARRAYS zRe, zIm AND zRe1, zIm1 MUST BE SPECIFIED IF (DS = t AND   !
! autGenDS = f), AND MUST BE SEPARATED BY A BLANK LINE. IF THE EXPANSION ORDER TEST !
! IS NOT PERFORMED (TypeConvTest /= 2), THE INPUT ARRAYS zRePart1 AND zImPart1 CAN  !
! BE OMITTED.                                                                       !
!                                                                                   !
! - epsNint (real) - error tolerance for the integration test.                      !
!                                                                                   !
! - epsNrank (real) - error tolerance for the expansion order test.                 !
!                                                                                   !
! - epsMrank (real) - error tolerance for the azimuthal order test.                 !
!                                                                                   !
! - dNint (integer) - number of division points for the integration test. Note      !
!   that the scattering problem is solved for Nint and Nint + dNint.                ! 
!                                                                                   !
! - dNintMrank (integer) - number of division points for azimuthal mode             !
!   calculation. This parameter is used if distributed sources are employed         !
!   (DS = t) and THERE EXISTS AT LEST ONE LAYER with ComplexPlanePart = t). At      !
!   each azimuthal mode calculation, the number of integration points increases     !
!   with dNintMrank. For layers with sources distributed along the symmetry axis,   !
!   the number of integration points is also increased.                             ! 
!                                                                                   !
! - FileTmat (character(80)) - name of the file to which the T matrix is written.   !
!                                                                                   !
! - PrnProgress (logical) - if PrnProgress = t, the progress of calculation         !
!   is printed.                                                                     !
!                                                                                   !
! Note that all input parameters specifying lengths must be provided in the same    !
! units of lengths.                                                                 !
!                                                                                   !
! The statements with the group names OptRegProp, GeomRegProp, SourceRegPosAut,     !
! NrankReg and SourceRegPosInp characterize a specific layer. THESE STATEMENTS      !
! MUST BE REPEATED FOR ALL Npart LAYERS.                                            !
!                                                                                   !
! 7. Logical Scheme                                                                 !
! ------------------                                                                !  
! The organization of the code is as follows:                                       !
! 1. < read input data >                                                            !
! 2. < T-matrix calculation >                                                       ! 
!                                                                                   !
!    if ( use localized sources ) then                                              !
!                                                                                   !
!       if ( do convergence test) then                                              !
!          < the code computes an estimate of Nrankp(i) for each layer i            !
!            by using Wiscombe's truncation criterion, and prompts for the          !
!            input value of Nrankp(i) >                                             !
!          < the code prompts for the estimated value of Nint for the layered       !
!            particle>                                                              !
!          < the code prompts for the type of convergence test:                     !
!            1 - over Nint, 2 - over Nrank or 3 - over Mrank >                      !
!       else if ( .not. do convergence test) then                                   !
!          < the input file provides the values of Nrankp(i) for each layer i >     !
!          < the input file provides the value of Nint for the layered particle>    !
!          type of convergence test = 3 (convergence test over Mrank)               !
!       end if                                                                      !
!                                                                                   !
!    else if ( use distributed sources ) then                                       !
!                                                                                   !
!       if ( use automatic sources generation ) then                                !
!          if ( do convergence test) then                                           !
!             < the code computes an estimate of Nrankp(i) for each layer i         !
!               by using Wiscombe's truncation criterion, and prompts for the       !
!               input value of Nrankp(i) >                                          !
!             < the code generates the coordinates of the distributed sources for   !
!               Nrank and all layers >                                              !
!             < the code prompts for the estimated value of Nint for the layered    !
!               particle>                                                           !
!             < the code prompts for the type of convergence test:                  !
!               1 - over Nint, 2 - over Nrank or 3 - over Mrank >                   !
!             if ( do maximum expansion order test ) then                           !
!                < the code generates the coordinates of the distributed sources    !
!                  for Nrank1 and all layers >                                      !
!             end if                                                                !
!          else if ( .not. do convergence test) then                                !
!             < the input file provides the values of Nrankp(i) for each layer i>   !
!             < the code generates the coordinates of the distributed sources for   !
!               Nrank and all layers >                                              !
!             < the input file provides the value of Nint for the layered particle> !
!             type of convergence test = 3 (convergence test over Mrank)            !
!       else if ( .not. use automatic sources generation ) then                     !
!          if ( do convergence test) then                                           !
!             < the input file provides the values of Nrankp(i) for each layer i >  !
!             < the input file provides the coordinates of the distributed sources  !
!               for Nrank and all layers >                                          !
!             < the code prompts for the estimated value of Nint for the layered    !
!               particle>                                                           !
!             < the code prompts for the type of convergence test:                  !
!               1 - over Nint, 2 - over Nrank or 3 - over Mrank >                   !
!             if ( do maximum expansion order test ) then                           !
!                < the input file provides the coordinates of the distributed       !
!                  sources for Nrank1 and all layers >                              ! 
!             end if                                                                ! 
!          else if ( .not. do convergence test) then                                !
!             < the input file provides the values of Nrankp(i) for each layer i >  !
!             < the input file provides the coordinates of the distributed sources  !
!               for Nrank and all layers >                                          !
!             < the input file provides the value of Nint for the layered particle> !
!             type of convergence test = 3 (convergence test over Mrank)            !  
!          end if                                                                   !
!       end if                                                                      !
!                                                                                   !
!    end if                                                                         !
!    if ( do integration test, i.e., type of convergence test = 1 ) then            !
!       < the code computes the DSCS for Nint and Nint + dNint and                  !
!         write the results to the file "Output.dat" >                              !
!       < the execution is terminated >                                             !
!    end if                                                                         !
!    if ( do expansion order test, i.e., type of convergence test = 2 ) then        !
!       < the code computes the DSCS for Nrank and Nrank1 and                       !
!         write the results to the file "Output.dat" >                              !
!       < the execution is terminated >                                             !
!    end if                                                                         !
!    if ( do azimuthal order test, i.e., type of convergence test = 3 ) then        !
!       < the code computes the DSCS for increasing m values and                    !
!         write the results to the file "Output.dat"  >                             !
!       if ( use distributed sources .and. use automatic sources generation         !
!           .and. sources are distributed in the complex plane ) then               ! 
!          < an interactive convergence test over Nint and Nrank can be performed   !
!            at each azimuthal mode m >                                             !
!          Note: to make this test active comment out some lines in the subroutine  !
!          "convergence_MrankDSLAY".                                                ! 
!       end if                                                                      !
!       < the T matrix is stored in the file FileTmat and the T-matrix information  !
!         file is created >                                                         !
!       < Mrank and Nrank are printed to the screen and to the T-matrix             !
!         information file >                                                        !
!       < go to Step 3 >                                                            !
!    end if                                                                         !
! 3. < scattering characteristics calculation >                                     !
!------------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  use allocation, only: Nsurf, Nparam, Nrankp, Nrankp1, surf, zpart, zRe, zIm,      &
                        zRe1, zIm1, lnorm, ind_ref, ComplexPlane, EpsZReIm 
  implicit none 
  integer       :: TypeGeom, Npart, dNint, TypeConvTest, Nsurfmax, Nparammax,       &
                   Nrankpmax, Nrankpmax1, Nint, dNintMrank 
  real(O)       :: k, ind_refMed, wavelength, anorm, snorm, epsNint, epsNrank,      &
                   epsMrank                                           
  logical       :: DoConvTest, DS, autGenDS, PrnProgress 
  character(80) :: FileTmat  
! -----------------------------------------------------------------------------------
!                            Read the input file                                    ! 
! -----------------------------------------------------------------------------------       
  call readinputLAY ( wavelength, ind_refMed, TypeGeom, Npart, anorm,               &
       DoConvTest, DS, autGenDS, Nint, epsNint, epsNrank, epsMrank, dNint,          &
       dNintMrank, FileTmat, PrnProgress, k, snorm, Nsurfmax, Nparammax,            &
       Nrankpmax, Nrankpmax1, TypeConvTest )
! -----------------------------------------------------------------------------------
!                                      Main                                         !
! -----------------------------------------------------------------------------------   
  open (unit = iOutput, file = FileOutput, status = "replace") 
  call printinputLAY (TypeConvTest, TypeGeom, Nsurfmax, Nsurf, surf, Nparam, Npart, &
       lnorm, anorm, Nrankpmax, Nrankp, zpart, zRe, zIm, Nrankpmax1, Nrankp1, zRe1, &
       zIm1, ind_ref, dNintMrank, dNint, wavelength, ind_refMed, epsNint, epsNrank, &
       epsMrank, DS, autGenDS)  
  if (DoConvTest) then
    if (TypeConvTest == 1) then
      if (.not. DS) then
        call convergence_NintLAY (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,      &
             Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zpart, Nint, dNint,       &
             epsNint, PrnProgress)      
      else 
        call convergence_NintDSLAY (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,    &
             Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, Nint,    &
             dNint, epsNint, PrnProgress)      
      end if
    else if (TypeConvTest == 2) then
      if (.not. DS) then
        call convergence_NrankLAY (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,     &
             Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zpart, Nint, epsNrank,    &
             PrnProgress)          
      else 
        call convergence_NrankDSLAY (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,   &
             Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, Nrankpmax1,     &
             Nrankp1, zRe1, zIm1, zpart, Nint, epsNrank, PrnProgress)      
      end if
    else 
      if (.not. DS) then
        call convergence_MrankLAY (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,     &
             Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zpart, Nint, epsMrank,    &
             FileTmat, PrnProgress)          
      else 
        call convergence_MrankDSLAY (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,   &
             Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, Nint,    &
             ComplexPlane, EpsZReIm, autGenDS, epsMrank, epsNrank, dNintMrank,      &
             FileTmat, PrnProgress)                              
      end if
    end if 
  else
    if (.not. DS) then
      call convergence_MrankLAY (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,       &
           Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zpart, Nint, epsMrank,      &
           FileTmat, PrnProgress)            
    else 
      call convergence_MrankDSLAY (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,     &
           Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, Nint,      &
           ComplexPlane, EpsZReIm, autGenDS, epsMrank, epsNrank, dNintMrank,        &
           FileTmat, PrnProgress)                
    end if  
  end if             
  close (unit = iOutput)           
  deallocate (zRe, zIm, zRe1, zIm1)   
  deallocate (surf, Nsurf, Nparam, Nrankp, Nrankp1, ind_ref, zpart, lnorm) 
  deallocate (ComplexPlane, EpsZReIm)   
end subroutine TLAY
!***********************************************************************************
subroutine readinputLAY ( wavelength, ind_refMed, TypeGeom, Npart, anorm,           &
           DoConvTest, DS, autGenDS, Nint, epsNint, epsNrank, epsMrank, dNint,      &
           dNintMrank, FileTmat, PrnProgress, k, snorm, Nsurfmax, Nparammax,        &
           Nrankpmax, Nrankpmax1, TypeConvTest ) 
  use parameters
  use derived_parameters
  use allocation, only: Nsurf, Nparam, Nrankp, Nrankp1, surf, zpart, zRe, zIm,      &
                        zRe1, zIm1, lnorm, EpsZReIm, ind_ref, ComplexPlane  
  implicit none 
  integer       :: TypeGeom, Npart, NsurfPart, NparamPart, dNint, TypeConvTest,     &
                   i, ipart, isurf, NrankPart, NrankW, Nsurfmax, Nparammax,         &
                   Nrankpmax, Nrankpmax1, Nint, dNintMrank, ios
  real(O)       :: k, ind_refMed, wavelength, anorm, surfPart(NsurfPD), xpart,      &
                   snorm, epsNint, epsNrank, epsMrank, zRePart(NrankPD),            &
                   zImPart(NrankPD), zRePart1(NrankPD), zImPart1(NrankPD),          &
                   OriginPart, x, lnormPart, EpsZReImPart                        
  complex(O)    :: ind_refPartRel
  logical       :: DoConvTest, DS, autGenDS, InputDS, ComplexPlanePart,             &
                   PrnProgress, XFindPar 
  character(80) :: FileTmat, string  
! -----------------------------------------------------------------------------------
!                           Read the input file FileInputLAY                        ! 
! -----------------------------------------------------------------------------------
  call DrvParameters 
  open (unit = iInputLAY, file = FileInputLAY, status = "old", position = "rewind")   
  wavelength = 0.1_O * 2._O * Pi 
  ind_refMed = 1._O  
  string     = 'OptProp'
  if (XFindPar (iInputLAY, string)) then
    read (iInputLAY, *, iostat = ios) wavelength
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if
    read (iInputLAY, *, iostat = ios) ind_refMed
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refMed;')"
      stop
    end if         
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if                                                          
  k = 2._O * Pi * ind_refMed / wavelength 
!
  TypeGeom = 1
  Npart = 2
  anorm = 1._O
  string   = 'GeomProp'
  if (XFindPar (iInputLAY, string)) then
    read (iInputLAY, *, iostat = ios) TypeGeom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable TypeGeom;')"
      stop
    end if
    read (iInputLAY, *, iostat = ios) Npart
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Npart;')"
      stop
    end if
    read (iInputLAY, *, iostat = ios) anorm
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anorm;')"
      stop
    end if
  else
    print "(/,2x,'Group name GeomProp not found;')"
    stop  
  end if 
  call check_anorm (anorm)  
  xpart = k * anorm
  snorm = Pi * xpart * xpart 
!
  DoConvTest = .true.    
  string     = 'ConvTest'
  if (XFindPar (iInputLAY, string)) then
    read (iInputLAY, *, iostat = ios) DoConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DoConvTest;')"
      stop
    end if          
  else
    print "(/,2x,'Group name ConvTest not found;')"
    stop  
  end if                         
!
  DS = .false.
  autGenDS = .true.
  string   = 'Sources'
  if (XFindPar (iInputLAY, string)) then
    read (iInputLAY, *, iostat = ios) DS
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DS;')"
      stop
    end if
    read (iInputLAY, *, iostat = ios) autGenDS
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable autGenDS;')"
      stop
    end if         
  else
    print "(/,2x,'Group name Sources not found;')"
    stop  
  end if  
  InputDS = .false.
  if (DS .and. .not. autGenDS) InputDS = .true. 
!
  allocate (Nsurf(Npart), Nparam(Npart), ind_ref(Npart), zpart(Npart), lnorm(Npart))
  Nsurfmax  = 1
  Nparammax = 1
  do ipart = 1, Npart
    ind_refPartRel = (1.5_O,0._O)
    string = 'OptRegProp'
    if (XFindPar (iInputLAY, string)) then
      read (iInputLAY, *, iostat = ios) ind_refPartRel
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable ind_refPartRel;')"
        print "(  2x,'for the layer ',i3,';')", ipart
        stop
      end if               
    else
      print "(/,2x,'Group name OptRegProp not found;')"
      print "(  2x,'for the layer ',i3,';')", ipart
      stop  
    end if
    call check_ind_ref1 (ipart, ind_refPartRel)
    ind_ref(ipart) = ind_refPartRel
    NsurfPart  = 2
    NparamPart = 1
    OriginPart = 0._O
    do isurf = 1, NsurfPD
      surfPart(isurf) = 1._O
    end do
    lnormPart = 1._O
    string    = 'GeomRegProp'
    if (XFindPar (iInputLAY, string)) then
      read (iInputLAY, *, iostat = ios) NsurfPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable NsurfPart;')"
        print "(  2x,'for the layer ',i3,';')", ipart
        stop
      end if
      if (NsurfPart > NsurfPD) then
        print "(/,2x,'Input error: NsurfPart exceeds NsurfPD for the layer',i3)",   &
                ipart                                    
        stop
      end if      
      read (iInputLAY, *, iostat = ios) NparamPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable NparamPart;')"
        print "(  2x,'for the layer ',i3,';')", ipart
        stop
      end if
      read (iInputLAY, *, iostat = ios) OriginPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable OriginPart;')"
        print "(  2x,'for the layer ',i3,';')", ipart
        stop
      end if
      do isurf = 1, NsurfPart
        read (iInputLAY, *, iostat = ios) surfPart(isurf)
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable surfPart;')"
          print "(  2x,'for the layer ',i3,';')", ipart
          stop
        end if
      end do
      read (iInputLAY, *, iostat = ios) lnormPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable lnormPart;')"
        print "(  2x,'for the layer ',i3,';')", ipart
        stop
      end if
    else
      print "(/,2x,'Group name GeomRegProp not found;')"
      print "(  2x,'for the layer ',i3,';')", ipart
      stop  
    end if    
    Nsurf(ipart) = NsurfPart
    Nparam(ipart)= NparamPart
    zpart(ipart) = OriginPart
    lnorm(ipart) = lnormPart
    if (Nsurf(ipart)  > Nsurfmax)  Nsurfmax  = Nsurf(ipart)
    if (Nparam(ipart) > Nparammax) Nparammax = Nparam(ipart)
  end do
  rewind (unit = iInputLAY)
  allocate (surf(Npart, Nsurfmax))
  do ipart = 1, Npart  
    do isurf = 1, Nsurfmax
      surf(ipart,isurf) = 0._O
    end do   
    NsurfPart  = 2
    NparamPart = 1
    OriginPart = 0._O
    do isurf = 1, NsurfPD
      surfPart(isurf) = 1._O
    end do
    lnormPart = 1._O
    string    = 'GeomRegProp'
    if (XFindPar (iInputLAY, string)) then
      read (iInputLAY, *, iostat = ios) NsurfPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable NsurfPart;')"
        print "(  2x,'for the layer ',i3,';')", ipart
        stop
      end if
      read (iInputLAY, *, iostat = ios) NparamPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable NparamPart;')"
        print "(  2x,'for the layer ',i3,';')", ipart
        stop
      end if
      read (iInputLAY, *, iostat = ios) OriginPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable OriginPart;')"
        print "(  2x,'for the layer ',i3,';')", ipart
        stop
      end if
      do isurf = 1, NsurfPart
        read (iInputLAY, *, iostat = ios) surfPart(isurf)
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable surfPart;')"
          print "(  2x,'for the layer ',i3,';')", ipart
          stop
        end if
      end do
      read (iInputLAY, *, iostat = ios) lnormPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable lnormPart;')"
        print "(  2x,'for the layer ',i3,';')", ipart
        stop
      end if
    else
      print "(/,2x,'Group name GeomRegProp not found;')"
      print "(  2x,'for the layer ',i3,';')", ipart
      stop  
    end if
    do isurf = 1, NsurfPart
      surf(ipart,isurf) = surfPart(isurf)
    end do
  end do  
  call check_geomLAY (TypeGeom, Npart, Nsurf, Nparam)
!
  allocate (ComplexPlane(Npart), EpsZReIm(Npart))
  rewind (unit = iInputLAY)
  do ipart = 1, Npart
    ComplexPlane(ipart) = .false.
    EpsZReIm(ipart) = 0.95_O
    if (DS .and. autGenDS) then
      ComplexPlanePart = .false.
      EpsZReImPart = 0.95_O
      string     = 'SourceRegPosAut'
      if (XFindPar (iInputLAY, string)) then
        read (iInputLAY, *, iostat = ios) ComplexPlanePart
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable ComplexPlanePart;')"
          print "(  2x,'for the layer ',i3,';')", ipart
          stop
        end if
        read (iInputLAY, *, iostat = ios) EpsZReImPart
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable EpsZReImPart;')"
          print "(  2x,'for the layer ',i3,';')", ipart
          stop
        end if               
      else
        print "(/,2x,'Group name SourceRegPosAut not found;')"
        print "(  2x,'for the layer ',i3,';')", ipart
        stop  
      end if       
      ComplexPlane(ipart) = ComplexPlanePart
      EpsZReIm(ipart) = EpsZReImPart
    end if
  end do 
!  
  if (DoConvTest) then
    print "(/,2x,'Convergence Test for a Layered Particle')" 
    print "(  2x,'---------------------------------------')"         
  else
    print "(/,2x,'Convergence Test for a Layered Particle over Mrank')" 
    print "(  2x,'--------------------------------------------------')"    
  end if                          
  allocate (Nrankp(Npart), Nrankp1(Npart)) 
  rewind (unit = iInputLAY)
  Nrankpmax  = 0
  Nrankpmax1 = 0
  do ipart = 1, Npart
    if (ipart == 1) then
      x = k * lnorm(ipart)
    else
      x = k * lnorm(ipart) * abs(ind_ref(ipart)) ! or the real part of the ref. index
    end if
    NrankW = int(x + 4.05_O * x**0.33_O + 2._O)
    if (.not. DoConvTest .or. InputDS) then
      NrankPart = 17
      string    = 'NrankReg'
      if (XFindPar (iInputLAY, string)) then
        read (iInputLAY, *, iostat = ios) NrankPart
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable NrankPart;')"
          print "(  2x,'for the layer ',i3,';')", ipart
          stop
        end if
      else
        print "(/,2x,'Group name NrankReg not found;')"
        print "(  2x,'for the layer ',i3,';')", ipart
        stop  
      end if        
      Nrankp(ipart) = NrankPart
      if (ipart == 1) print "(/,2x,'Nrank input values:')"
      print "(2x,'the input value of Nrank for the layer ',i3,' is ', i4,',')",     &
              ipart, NrankPart
      print "(2x, a, i3, a)",                                                       &
     'while the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';' 
    else
      if (ipart == 1) print "(/,2x,'Nrank estimates:')"  
      print "(2x,'the estimated value of Nrank from Wiscombe''s criterion')" 
      print "(2x,'for layer ',i2,' is ',i3,';')", ipart, NrankW 
      print "(2x,'- enter the estimated value of Nrank for layer ',i2)", ipart      
      call read_integer (Nrankp(ipart))
    end if
    if (Nrankp(ipart) > Nrankpmax) Nrankpmax = Nrankp(ipart)
    Nrankp1(ipart) = Nrankp(ipart) - 1
    if (Nrankp1(ipart) > Nrankpmax1) Nrankpmax1 = Nrankp1(ipart)
  end do
!
  rewind (unit = iInputLAY)  
  if (DoConvTest) then
    print "(/,2x, a)",                                                              &
   '- enter the estimated values of Nint, where Nint = Ndgs * Nrankpmax,'        
    print "(  2x,'  Ndgs = 15,20,..., and Nrankpmax = ',i4,';')", Nrankpmax                 
    call read_integer (Nint) 
  else    
    Nint   = 100
    string = 'NintGlobal'
    if (XFindPar (iInputLAY, string)) then
      read (iInputLAY, *, iostat = ios) Nint
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nint;')"
        stop
      end if          
    else
      print "(/,2x,'Group name NintGlobal not found;')"
      stop  
    end if 
    print "(/,2x,'Nint input value:')"
    print "(  2x, a, i4, a)",                                                       &
   'the input value of Nint is ', Nint, ', while Nint = Ndgs * Nrankpmax,'
    print "(  2x,'Ndgs = 15,20,..., and Nrankpmax = ',i4,';')", Nrankpmax                   
  end if
!
  if (DoConvTest) then     
    print "(/,2x, a)",                                                              &
   '- enter the type of convergence test: 1 - Nint, 2 - Nrank, 3 - Mrank;'
    call read_integerbound (TypeConvTest, 1, 3)     
  else    
    TypeConvTest = 3 
  end if
!
  allocate (zRe(Npart,Nrankpmax), zIm(Npart,Nrankpmax), zRe1(Npart,Nrankpmax1),     &
            zIm1(Npart,Nrankpmax1)) 
  rewind (unit = iInputLAY)
  do ipart = 1, Npart
    do i = 1, Nrankpmax     
      zRe(ipart,i) = 0._O
      zIm(ipart,i) = 0._O
    end do
    do i = 1, Nrankpmax1            
      zRe1(ipart,i) = 0._O
      zIm1(ipart,i) = 0._O
    end do     
    if (DS) then
      call check_MaxNrank (Nrankpmax)
      if (autGenDS) then
        call zDSLAY (TypeGeom, Npart, Nsurfmax, surf, Nrankpmax, Nrankp, zpart,     &
             ComplexPlane, EpsZReIm, zRe, zIm)
        if (TypeConvTest == 2) call zDSLAY (TypeGeom, Npart, Nsurfmax, surf,        &
                                    Nrankpmax1, Nrankp1, zpart, ComplexPlane,       &
                                    EpsZReIm, zRe1, zIm1)
      else
        do i = 1, NrankPD
          zRePart(i)  = 0._O
          zImPart(i)  = 0._O
          zRePart1(i) = 0._O
          zImPart1(i) = 0._O
        end do
        string = 'SourceRegPosInp'
        if (XFindPar (iInputLAY, string)) then
          do i = 1, Nrankp(ipart)
            read (iInputLAY, *, iostat = ios) zRePart(i), zImPart(i)
            if (ios /= 0) then
              print "(/,2x, a)",                                                    &
             'Error by reading the input variables zRePart and zImPart;'   	      
              print "(  2x,'for the layer ',i3,';')", ipart
              stop
            end if 
          end do
          if (TypeConvTest == 2) then	  
            read (iInputLAY, *)
            do i = 1, Nrankp(ipart) - 1
              read (iInputLAY, *, iostat = ios) zRePart1(i), zImPart1(i)
              if (ios /= 0) then
                print "(/,2x, a)",                                                  &
               'Error by reading the input variables zRePart1 and zImPart1;'		
                print "(  2x,'for the layer ',i3,';')", ipart
                stop
              end if 
            end do
          end if	    
        else
          print "(/,2x,'Group name SourceRegPosInp not found;')"
          print "(  2x,'for the layer ',i3,';')", ipart
          stop  
        end if
        do i = 1, Nrankp(ipart)
          zRe(ipart,i) = zRePart(i)  
          zIm(ipart,i) = zImPart(i)               
        end do  
        if (TypeConvTest == 2) then             
          do i = 1, Nrankp1(ipart)
            zRe1(ipart,i) = zRePart1(i) 
            zIm1(ipart,i) = zImPart1(i) 
          end do          
        end if  
      end if                                
    end if
  end do         
!
  epsNint  = 5.e-2
  epsNrank = 5.e-2
  epsMrank = 5.e-2
  dNint = 4
  dNintMrank = 10
  string     = 'Errors'
  if (XFindPar (iInputLAY, string)) then
    read (iInputLAY, *, iostat = ios) epsNint
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNint;')"
      stop
    end if
    read (iInputLAY, *, iostat = ios) epsNrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNrank;')"
      stop
    end if
    read (iInputLAY, *, iostat = ios) epsMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsMrank;')"
      stop
    end if 
    read (iInputLAY, *, iostat = ios) dNint
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable dNint;')"
      stop
    end if
    read (iInputLAY, *, iostat = ios) dNintMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable dNintMrank;')"
      stop
    end if         
  else
    print "(/,2x,'Group name Errors not found;')"
    stop  
  end if
!
  FileTmat = '../TMATFILES/T.dat'
  string   = 'Tmat' 
  if (XFindPar (iInputLAY, string)) then
    read (iInputLAY, *, iostat = ios) FileTmat
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileTmat;')"
      stop
    end if             
  else
    print "(/,2x,'Group name Tmat not found;')"
    stop  
  end if
!
  PrnProgress = .true.
  string   = 'PrintProgress' 
  if (XFindPar (iInputLAY, string)) then
    read (iInputLAY, *, iostat = ios) PrnProgress
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if             
  else
    print "(/,2x,'Group name PrintProgress not found;')"
    stop  
  end if  
  close (unit = iInputLAY)     
end subroutine readinputLAY    
!***********************************************************************************
subroutine printinputLAY (ic, TypeGeom, Nsurfmax, Nsurf, surf, Nparam, Npart,       &
           lnorm, anorm, Nrankpmax, Nrankp, zpart, zRe, zIm, Nrankpmax1, Nrankp1,   &
           zRe1, zIm1, ind_ref, dNintMrank, dNint, wavelength, ind_refMed, epsNint, &
           epsNrank, epsMrank, DS, autGenDS)
  use parameters
  implicit none  
  integer    :: ic, TypeGeom, Nsurfmax, Npart, Nrankpmax, Nrankpmax1, dNint,        &
                Nrankp(Npart), Nrankp1(Npart), Nparam(Npart), Nsurf(Npart),         &
                NsurfPart, Nrank, dNintMrank, i, j
  real(O)    :: wavelength, anorm, surf(Npart,Nsurfmax), zpart(Npart),              &
                lnorm(Npart), zRe(Npart,Nrankpmax), zIm(Npart,Nrankpmax),           &
                zRe1(Npart,Nrankpmax1), zIm1(Npart,Nrankpmax1),                     &
                epsNint, epsNrank, epsMrank, ind_refMed
  complex(O) :: ind_ref(Npart)  
  logical    :: DS, autGenDS  
!
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x,'wavelength of the free space, wavelength = ',1pe13.4,';')")  &
         wavelength
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'refractive index of the ambient medium, ind_refMed = ', ind_refMed, ';'
  write (iOutput,"(2x, a)")                                                         &
 'relative refractive index of each layer with respect to the ambient medium:'
  do i = 1, Npart
    if (i /= Npart) then
      write (iOutput,"(2x,'ind_ref(',i2,') = (',1pe13.4,',',1pe13.4,'),')")         &
             i, ind_ref(i)
    else
      write (iOutput,"(2x,'ind_ref(',i2,') = (',1pe13.4,',',1pe13.4,');')")         &
             i, ind_ref(i)
    end if
  end do    
  write (iOutput,*)
  write (iOutput,"(2x,'index of the particle geometry, TypeGeom = ',i2,';')")       &
         TypeGeom
  if (TypeGeom == 1) then
    write (iOutput,"(2x,'concentric spheroids;')")      
  else if (TypeGeom == 2) then
    write (iOutput,"(2x,'concentric cylinders;')")      
  end if
  write (iOutput,"(2x,'number of homogeneous layers, Npart = ',i2,';')") Npart
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'characteristic length of the layered particle, anorm = ', anorm, ';'
  do i = 1, Npart
    write (iOutput,*)
    write (iOutput,"(2x,'layer: ',i2)") i
    write (iOutput,"(2x,'number of surface parameters, Nsurf = ',i2,';')") Nsurf(i)
    write (iOutput,"(2x,'surface parameters:')")
    NsurfPart = Nsurf(i)
    do j = 1, NsurfPart     
      write (iOutput,"(2x,'surf(',i2,') = ',1pe10.3,',')") j, surf(i,j)     
    end do
    if (TypeGeom == 1) then
      write (iOutput,"(2x,'where surf(1) is the semi-axis along the symmetry axis')")
      write (iOutput,"(2x,'and   surf(2) is the second semi-axis;')")
    else if (TypeGeom == 2) then
      write (iOutput,"(2x,'where surf(1) is the half-length of the cylinder')")
      write (iOutput,"(2x,'and   surf(2) is the cylinder radius;')")
    end if       
    write (iOutput,"(2x,'number of integration surfaces, Nparam = ',i2,';')")       &
           Nparam(i)
    write (iOutput,"(2x, a, 1pe10.3, a)")                                           &
   'caracteristic length of the layer, lnorm = ', lnorm(i), ';'
  end do
  write (iOutput,*)
  if (.not. DS) then
    write (iOutput,"(2x,'computation with localized sources;')")
    write (iOutput,"(2x,'origins of the localized sorces:')")
    do i = 1, Npart
      if (i /= Npart) then
        write (iOutput,"(2x,'zpart(',i2,') = ',1pe10.3,',')") i, zpart(i)
      else
        write (iOutput,"(2x,'zpart(',i2,') = ',1pe10.3,';')") i, zpart(i)
      end if
    end do
  else
    write (iOutput,"(2x,'computation with distributed sources;')")
    if (autGenDS) then
      write (iOutput,"(2x,'the sources are generated automatically;')") 
    else
      write (iOutput,"(2x,'the sources are user-defined;')")
    end if                      
    write (iOutput,*)       
    write (iOutput,"(2x,'z - coordinates of the sources:')")
    write (iOutput,"(2x,'first configuration:')")
    do i = 1, Npart       
      write (iOutput,"(2x,'layer: ',i2)") i
      Nrank = Nrankp(i)
      do j = 1, Nrank       
        if (j /= Nrank) then
          write (iOutput,"(2x,'zRe(',i2,') = ',1pe10.3,', zIm(',i2,') = ',1pe10.3,',')")&
                 j, zRe(i,j), j, zIm(i,j)
        else
          write (iOutput,"(2x,'zRe(',i2,') = ',1pe10.3,', zIm(',i2,') = ',1pe10.3,';')")&
                 j, zRe(i,j), j, zIm(i,j)
        end if
      end do
      write (iOutput,*)
    end do
    if (ic == 2) then         
      write (iOutput,"(2x,'second configuration:')")
      do i = 1, Npart       
        write (iOutput,"(2x,'layer: ',i2)") i
        Nrank = Nrankp1(i)
        do j = 1, Nrank     
          if (j /= Nrank) then
            write (iOutput,"(2x,'zRe(',i2,') = ',1pe10.3,', zIm(',i2,') = ',1pe10.3,',')")&
                   j, zRe1(i,j), j, zIm1(i,j)
          else
            write (iOutput,"(2x,'zRe(',i2,') = ',1pe10.3,', zIm(',i2,') = ',1pe10.3,';')")&
                   j, zRe1(i,j), j, zIm1(i,j)
          end if
        end do
        write (iOutput,*)
      end do
    end if  
  end if    
  write (iOutput,"(2x,'integration tolerance, epsNint = ',1pe10.3,';')") epsNint
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum expansion order tolerance, epsNrank = ', epsNrank, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum azimuthal order tolerance, epsMrank = ', epsMrank, ';'          
  write (iOutput,"(2x,'integration step, dNint = ',i4,'.')") dNint
  write (iOutput,"(2x, a, i3, a)")                                                  &
 'integration step for Mrank calculation, dNintMrank = ', dNintMrank, '.'
  write (iOutput,"(/)")                       
end subroutine printinputLAY
! **********************************************************************************
subroutine convergence_NintLAY (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,        &
           Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zpart, Nint, dNint,         &
           epsNint, PrnProgress)    
  use parameters 
  implicit none
  integer    :: TypeGeom, Nsurfmax, Nparammax, Npart, Nrankpmax, Nint, dNint,       &
                Nrankp(Npart), Nparam(Npart)
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), snorm, epsNint                
  complex(O) :: ind_ref(Npart)
  logical    :: PrnProgress
!        
  integer    :: Mstart, Mrank, Nmax, Nmaxmax, Nmaxpmax, Nteta, i, ipart,            &
                m, iNint, NthetaConv
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext  
  integer,allocatable    :: Nintparam(:,:), Nmaxp(:)
  real(O),allocatable    :: paramG(:,:,:), weightsG(:,:,:), h(:), v(:), oldh(:),    &
                            oldv(:)
  complex(O),allocatable :: aa(:,:), bb(:,:), a(:,:), b(:,:), c(:,:), cv(:),        &
                            cv1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1     
  m = 1
  call write_TypeConvHead (1)
  allocate (Nmaxp(Npart))
  Nmaxpmax = 0
  Nmax = 0
  do ipart = 1, Npart    
    Nmaxp(ipart) = Nrankp(ipart)    
    if (Nmaxp(ipart) > Nmaxpmax) Nmaxpmax = Nmaxp(ipart)
    if (ipart < Npart) then
      Nmax = Nmax + 2 * Nmaxp(ipart)
    else
      Nmax = Nmax + Nmaxp(ipart)
    endif
  end do
  allocate (aa(2*Nmax,2*Nmax), bb(2*Nmax,2*Nmax))            
  allocate (a(2*Nrankpmax,2*Nrankpmax), b(2*Nrankpmax,2*Nrankpmax),                 &
            c(2*Nrankpmax,2*Nrankpmax), cv(2*Nrankpmax),cv1(2*Nrankpmax))
  Nmaxmax = Nrankpmax + Mrank * (2 * Nrankpmax - Mrank + 1)    
  allocate (cc(2*Nmaxmax)) 
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do
  if (PrnProgress) call write_progress (.true., 1, 11)
  do iNint = 1, 2        
    allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),         &
              Nintparam(Npart,Nparammax))                 
    call interpolation_listLAY (TypeGeom, Npart, Nsurfmax, surf, Nint, Nparammax,   &
         Nintparam, paramG, weightsG)     
    call matrix_Q31_LAY (TypeGeom, k, ind_ref, Nsurfmax, surf, Npart, Nrankp,       &
         Nmaxpmax, Nmaxp, zpart, m, Nmax, Nint, Nparammax, Nparam, Nintparam,       &
         paramG, weightsG, aa, Nmax, Nmax)  
    if (PrnProgress) call write_progress (.false., 2+5*(iNint-1), 11)                           
    call inverse_matrix (aa, 2*Nmax, 2*Nmax, bb, 2*Nmax, 2*Nmax, 2*Nmax)
    if (PrnProgress) call write_progress (.false., 3+5*(iNint-1), 11)
    call matrix_Q1_LAY (TypeGeom, 1, k, ind_ref, Nsurfmax, surf, Npart, Nrankpmax,  &
         Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint, Nparammax, Nparam, Nintparam,     &
         paramG, weightsG, a, Nrankpmax, Nrankpmax)    
    call extract_matrix3 (1, Nmaxpmax, bb, Nmax, Nmax, b, Nrankpmax, Nrankpmax)  
    call product_matrices (2*Nmaxpmax, 2*Nmaxpmax, 2*Nmaxpmax,                      &
         a, 2*Nrankpmax, 2*Nrankpmax, b, 2*Nrankpmax, 2*Nrankpmax)     
    if (PrnProgress) call write_progress (.false., 4+5*(iNint-1), 11)
    call matrix_Q1_LAY (TypeGeom, 3, k, ind_ref, Nsurfmax, surf, Npart, Nrankpmax,  &
         Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint, Nparammax, Nparam, Nintparam,     &
         paramG, weightsG, c, Nrankpmax, Nrankpmax)            
    call extract_matrix3 (2, Nmaxpmax, bb, Nmax, Nmax, b, Nrankpmax, Nrankpmax)  
    call product_matrices (2*Nmaxpmax, 2*Nmaxpmax, 2*Nmaxpmax,                      &
         c, 2*Nrankpmax, 2*Nrankpmax, b, 2*Nrankpmax, 2*Nrankpmax)
    if (PrnProgress) call write_progress (.false., 5+5*(iNint-1), 11)
    call sum_matrices (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax, 2*Nrankpmax,         &
         c, 2*Nrankpmax, 2*Nrankpmax)
    call incident_matrix_LAY (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax,        &
         Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint, Nparammax, Nparam, Nintparam,     &
         paramG, weightsG, c, Nrankpmax, Nrankpmax)     
    call product_matrices (2*Nmaxpmax, 2*Nmaxpmax, 2*Nmaxpmax,                      &
         a, 2*Nrankpmax, 2*Nrankpmax, c, 2*Nrankpmax, 2*Nrankpmax)               
    if (PrnProgress) call write_progress (.false., 6+5*(iNint-1), 11)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m,            &
         Nrankpmax, Nmaxpmax, cv)
    call product_matrix_vector (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,             &
         2*Nrankpmax, cv, cv1)      
    call extend_vector_positive (cv1, cc, m, Mstart, Nrankpmax, Nmaxpmax, Nmaxmax)                                   
    call matrix_m_negativ (Nmaxpmax, Nmaxpmax, a, Nrankpmax, Nrankpmax)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m,           &
         Nrankpmax, Nmaxpmax, cv)
    call product_matrix_vector (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,             &
         2*Nrankpmax, cv, cv1)
    call extend_vector_negative (cv1, cc, m, Nrankpmax, Nmaxpmax, Nmaxmax)
    call DSCS (cc, Mrank, Nrankpmax, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k,    &
         snorm,.false.,.true., h, v)
    call CQscat (cc, Mrank, Nrankpmax, Nmaxmax, k, snorm, Cscat, Qscat)
    call CQext (cc, Mrank, Nrankpmax, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,     &
         alfap, k, snorm, Cext, Qext)
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsNint, NthetaConv)
    call write_3ConvParamReg (Nint, m, Npart, Nrankp, .false.)
    call write_DSCS  (Nteta,.false., h, v)
    call write_Effic (Qscat, Qext)
    Nint = Nint + dNint
    deallocate (paramG, weightsG, Nintparam)
  end do
  call write_NintConvRes (NthetaConv, Nteta, epsNint)           
  deallocate (aa, bb, a, b, c, cv, cv1, cc, h, v, oldh, oldv, Nmaxp)
end subroutine convergence_NintLAY
! **********************************************************************************
subroutine convergence_NrankLAY (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,       &
           Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zpart, Nint, epsNrank,      &
           PrnProgress)    
  use parameters 
  implicit none
  integer    :: TypeGeom, Nsurfmax, Nparammax, Npart, Nrankpmax, Nint,              &
                Nrankp(Npart), Nparam(Npart)
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), snorm, epsNrank                
  complex(O) :: ind_ref(Npart)
  logical    :: PrnProgress
!        
  integer    :: Mstart, Mrank, Nmax, Nmaxpmax, Nmaxmax, Nteta, i, m, ipart,         &
                NthetaConv
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext  
  integer,allocatable    :: Nintparam(:,:), Nmaxp(:)
  real(O),allocatable    :: paramG(:,:,:), weightsG(:,:,:), h(:), v(:), oldh(:),    &
                            oldv(:)
  complex(O),allocatable :: aa(:,:), bb(:,:), a(:,:), b(:,:), c(:,:), cv(:),        &
                            cv1(:), cc(:), aa1(:,:), b1(:,:), b3(:,:), a0(:,:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1     
  m = 1
  call write_TypeConvHead (2)
  allocate (Nmaxp(Npart))
  Nmaxpmax = 0
  Nmax = 0
  do ipart = 1, Npart    
    Nmaxp(ipart) = Nrankp(ipart)    
    if (Nmaxp(ipart) > Nmaxpmax) Nmaxpmax = Nmaxp(ipart)
    if (ipart < Npart) then
      Nmax = Nmax + 2 * Nmaxp(ipart)
    else
      Nmax = Nmax + Nmaxp(ipart)
    end if
  end do    
  allocate (aa1(2*Nmax,2*Nmax), b1(2*Nrankpmax,2*Nrankpmax),                        &
            b3(2*Nrankpmax,2*Nrankpmax), a0(2*Nrankpmax,2*Nrankpmax))
  allocate (aa(2*Nmax,2*Nmax), bb(2*Nmax,2*Nmax))            
  allocate (a(2*Nrankpmax,2*Nrankpmax), b(2*Nrankpmax,2*Nrankpmax),                 &
            c(2*Nrankpmax,2*Nrankpmax), cv(2*Nrankpmax), cv1(2*Nrankpmax))
  Nmaxmax = Nrankpmax + Mrank * (2 * Nrankpmax - Mrank + 1)    
  allocate (cc(2*Nmaxmax)) 
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))                        
  allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),           &
            Nintparam(Npart,Nparammax))           
  call interpolation_listLAY (TypeGeom, Npart, Nsurfmax, surf, Nint, Nparammax,     &
       Nintparam, paramG, weightsG)
  if (PrnProgress) call write_progress (.true., 1, 9)
! --- Nrank configuration ---  
  call matrix_Q31_LAY (TypeGeom, k, ind_ref, Nsurfmax, surf, Npart, Nrankp,         &
       Nmaxpmax, Nmaxp, zpart, m, Nmax, Nint, Nparammax, Nparam, Nintparam,         &
       paramG, weightsG, aa, Nmax, Nmax)
  if (PrnProgress) call write_progress (.false., 2, 9)
  call copy_matrix (2*Nmax, 2*Nmax, aa, 2*Nmax, 2*Nmax, aa1, 2*Nmax, 2*Nmax)
  call inverse_matrix (aa, 2*Nmax, 2*Nmax, bb, 2*Nmax, 2*Nmax, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 3, 9)
  call matrix_Q1_LAY (TypeGeom, 1, k, ind_ref, Nsurfmax, surf, Npart, Nrankpmax,    &
       Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint, Nparammax, Nparam, Nintparam,       &
       paramG, weightsG, a, Nrankpmax, Nrankpmax)
  call copy_matrix (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax, 2*Nrankpmax,            &
       b1, 2*Nrankpmax, 2*Nrankpmax)
  call extract_matrix3 (1, Nmaxpmax, bb, Nmax, Nmax, b, Nrankpmax, Nrankpmax)           
  call product_matrices (2*Nmaxpmax, 2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,        &
       2*Nrankpmax, b, 2*Nrankpmax, 2*Nrankpmax)           
  if (PrnProgress) call write_progress (.false., 4, 9) 
  call matrix_Q1_LAY (TypeGeom, 3, k, ind_ref, Nsurfmax, surf, Npart, Nrankpmax,    &
       Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint, Nparammax, Nparam, Nintparam,       &
       paramG, weightsG, c, Nrankpmax, Nrankpmax)
  call copy_matrix (2*Nmaxpmax, 2*Nmaxpmax, c, 2*Nrankpmax, 2*Nrankpmax,            &
       b3, 2*Nrankpmax, 2*Nrankpmax)
  call extract_matrix3 (2, Nmaxpmax, bb, Nmax, Nmax, b, Nrankpmax, Nrankpmax)   
  call product_matrices (2*Nmaxpmax, 2*Nmaxpmax, 2*Nmaxpmax, c, 2*Nrankpmax,        &
       2*Nrankpmax, b, 2*Nrankpmax, 2*Nrankpmax)
  if (PrnProgress) call write_progress (.false., 5, 9)
  call sum_matrices (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax, 2*Nrankpmax,           &
       c, 2*Nrankpmax, 2*Nrankpmax)
  call incident_matrix_LAY (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax,          &
       Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint, Nparammax, Nparam, Nintparam,       &
       paramG, weightsG, c, Nrankpmax, Nrankpmax)
  call copy_matrix (2*Nmaxpmax, 2*Nmaxpmax, c, 2*Nrankpmax, 2*Nrankpmax,            &
       a0, 2*Nrankpmax, 2*Nrankpmax)
  call product_matrices (2*Nmaxpmax, 2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,        &
       2*Nrankpmax, c, 2*Nrankpmax, 2*Nrankpmax)             
  if (PrnProgress) call write_progress (.false., 6, 9)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m,              &
       Nrankpmax, Nmaxpmax, cv)
  call product_matrix_vector (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,               &
       2*Nrankpmax, cv, cv1)
  call extend_vector_positive (cv1, cc, m, Mstart, Nrankpmax, Nmaxpmax, Nmaxmax)                                 
  call matrix_m_negativ (Nmaxpmax, Nmaxpmax, a, Nrankpmax, Nrankpmax)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m,             &
       Nrankpmax, Nmaxpmax, cv)
  call product_matrix_vector (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,               &
       2*Nrankpmax, cv, cv1)
  call extend_vector_negative (cv1, cc, m, Nrankpmax, Nmaxpmax, Nmaxmax)
  call DSCS (cc, Mrank, Nrankpmax, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k,      &
       snorm,.false.,.true., h, v)
  call CQscat (cc, Mrank, Nrankpmax, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrankpmax, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,       &
       alfap, k, snorm, Cext, Qext)
  do i = 1, Nteta
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do
  call write_3ConvParamReg (Nint, m, Npart, Nrankp,.false.)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
! --- (Nrank - 1) configuration --- 
  call copy_matrix (2*Nmax, 2*Nmax, aa1, 2*Nmax, 2*Nmax, aa, 2*Nmax, 2*Nmax)
  call internal_matrix_LAY_Nrank_m (Npart, Nmaxp, aa, Nmax, Nmax)      
  if (PrnProgress) call write_progress (.false., 7, 9)
  call inverse_matrix (aa, 2*Nmax, 2*Nmax, bb, 2*Nmax, 2*Nmax, 2*Nmax) 
  if (PrnProgress) call write_progress (.false., 8, 9)
  call copy_matrix (2*Nmaxpmax, 2*Nmaxpmax, b1, 2*Nrankpmax, 2*Nrankpmax,           &
       a, 2*Nrankpmax, 2*Nrankpmax)
  call matrix_Nrank_m (Nmaxpmax, a, Nrankpmax, Nrankpmax)   
  call extract_matrix3 (1, Nmaxpmax, bb, Nmax, Nmax, b, Nrankpmax, Nrankpmax)         
  call product_matrices (2*Nmaxpmax, 2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,        &
       2*Nrankpmax, b, 2*Nrankpmax, 2*Nrankpmax)
  call copy_matrix (2*Nmaxpmax, 2*Nmaxpmax, b3, 2*Nrankpmax, 2*Nrankpmax,           &
       c, 2*Nrankpmax, 2*Nrankpmax)
  call matrix_Nrank_m (Nmaxpmax, c, Nrankpmax, Nrankpmax)                  
  call extract_matrix3 (2, Nmaxpmax, bb, Nmax, Nmax, b, Nrankpmax, Nrankpmax)        
  call product_matrices (2*Nmaxpmax, 2*Nmaxpmax, 2*Nmaxpmax, c, 2*Nrankpmax,        &
       2*Nrankpmax, b, 2*Nrankpmax, 2*Nrankpmax)
  call sum_matrices (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax, 2*Nrankpmax,           &
       c, 2*Nrankpmax, 2*Nrankpmax)
  call copy_matrix (2*Nmaxpmax, 2*Nmaxpmax, a0, 2*Nrankpmax, 2*Nrankpmax,           &
       c, 2*Nrankpmax, 2*Nrankpmax)
  call matrix_Nrank_m (Nmaxpmax, c, Nrankpmax, Nrankpmax)
  call product_matrices (2*Nmaxpmax, 2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,        &
       2*Nrankpmax, c, 2*Nrankpmax, 2*Nrankpmax)             
  if (PrnProgress) call write_progress (.false., 9, 9)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m,              &
       Nrankpmax, Nmaxpmax, cv)
  call product_matrix_vector (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,               &
       2*Nrankpmax, cv, cv1)
  call extend_vector_positive (cv1, cc, m, Mstart, Nrankpmax, Nmaxpmax, Nmaxmax)                                 
  call matrix_m_negativ (Nmaxpmax, Nmaxpmax, a, Nrankpmax, Nrankpmax)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m,             &
       Nrankpmax, Nmaxpmax, cv)
  call product_matrix_vector (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,               &
       2*Nrankpmax, cv, cv1)
  call extend_vector_negative (cv1, cc, m, Nrankpmax, Nmaxpmax, Nmaxmax)
  call DSCS (cc, Mrank, Nrankpmax, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k,      &
       snorm,.false.,.true., h, v)
  call CQscat (cc, Mrank, Nrankpmax, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrankpmax, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,       &
       alfap, k, snorm, Cext, Qext)
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConv)
  call write_3ConvParamReg (Nint, m, Npart, Nrankp, .true.)  
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConv, Nteta, epsNrank)
  deallocate (aa1, b1, b3, a0)
  deallocate (aa, bb, a, b, c, cv, cv1, cc, h, v, oldh, oldv, Nmaxp, paramG,        &
              weightsG, Nintparam)
end subroutine convergence_NrankLAY
! **********************************************************************************
subroutine convergence_MrankLAY (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,       &
           Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zpart, Nint, epsMrank,      &
           FileTmat, PrnProgress)          
  use parameters 
  implicit none
  integer       :: TypeGeom, Nsurfmax, Nparammax, Npart, Nrankpmax, Nint,           &
                   Nrankp(Npart), Nparam(Npart)
  real(O)       :: k, surf(Npart,Nsurfmax), zpart(Npart), snorm, epsMrank                
  complex(O)    :: ind_ref(Npart)
  character(80) :: FileTmat
  logical       :: PrnProgress
!             
  integer       :: Mstart, Mrank, Nmaxpmax, Nrank, Nmax, Nmaxmax, Nteta,            &
                   i, m, ipart, NthetaConv
  real(O)       :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,     &
                   Cext, Qext
  integer,allocatable    :: Nintparam(:,:), Nmaxp(:)
  real(O),allocatable    :: paramG(:,:,:), weightsG(:,:,:), h(:), v(:), oldh(:),    &
                            oldv(:)
  complex(O),allocatable :: aa(:,:), bb(:,:), a(:,:), b(:,:), c(:,:), cv(:),        &
                            cv1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O  
  Mstart = 0
  Mrank  = Nrankpmax   
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call write_HeadFileTmat (Nrankpmax, Nrankpmax)    
  call write_TypeConvHead (3)
  call write_2ConvParamReg (Nint, Npart, Nrankp)
  Nrank = 0
  do ipart = 1, Npart        
    if(ipart < Npart) then
      Nrank = Nrank + 2 * Nrankp(ipart)
    else
      Nrank = Nrank + Nrankp(ipart)
    endif
  end do
  allocate (aa(2*Nrank,2*Nrank), bb(2*Nrank,2*Nrank))            
  allocate (a(2*Nrankpmax,2*Nrankpmax), b(2*Nrankpmax,2*Nrankpmax),                 &
            c(2*Nrankpmax,2*Nrankpmax), cv(2*Nrankpmax),cv1(2*Nrankpmax))       
  Nmaxmax = Nrankpmax + Mrank * (2 * Nrankpmax - Mrank + 1)
  allocate (cc(2*Nmaxmax)) 
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do     
  allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),           &
            Nintparam(Npart,Nparammax))           
  call interpolation_listLAY (TypeGeom, Npart, Nsurfmax, surf, Nint, Nparammax,     &
       Nintparam, paramG, weightsG)     
  Mrank = - 1
  do m = Mstart, Nrankpmax
    call write_1ConvParam (m)
    Mrank = Mrank + 1    
    do ipart = 1, Npart     
      if (Nrankp(ipart) < m) Nrankp(ipart) = m      
    end do
    allocate (Nmaxp(Npart))
    Nmaxpmax = 0
    Nmax = 0
    do ipart = 1, Npart
      if (m == 0) then
        Nmaxp(ipart) = Nrankp(ipart)
      else
        Nmaxp(ipart) = Nrankp(ipart) - iabs(m) + 1
      end if
      if (Nmaxp(ipart) > Nmaxpmax) Nmaxpmax = Nmaxp(ipart)
      if (ipart < Npart) then
        Nmax = Nmax + 2 * Nmaxp(ipart)
      else
        Nmax = Nmax + Nmaxp(ipart)
      end if
    end do
    if (PrnProgress) call write_progress_m (.true., m, 1, 6)  
    call matrix_Q31_LAY (TypeGeom, k, ind_ref, Nsurfmax, surf, Npart, Nrankp,       &
         Nmaxpmax, Nmaxp, zpart, m, Nmax, Nint, Nparammax, Nparam, Nintparam,       &
         paramG, weightsG, aa, Nrank, Nrank)
    if (PrnProgress) call write_progress_m (.false., m, 2, 6)  
    call inverse_matrix (aa, 2*Nrank, 2*Nrank, bb, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress_m (.false., m, 3, 6)
    call matrix_Q1_LAY (TypeGeom, 1, k, ind_ref, Nsurfmax, surf, Npart, Nrankpmax,  &
         Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint, Nparammax, Nparam, Nintparam,     &
         paramG, weightsG, a, Nrankpmax, Nrankpmax)
    call extract_matrix3 (1, Nmaxpmax, bb, Nrank, Nrank, b, Nrankpmax, Nrankpmax)    
    call product_matrices (2*Nmaxpmax, 2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,      &
         2*Nrankpmax, b, 2*Nrankpmax, 2*Nrankpmax)     
    if (PrnProgress) call write_progress_m (.false., m, 4, 6)
    call matrix_Q1_LAY (TypeGeom, 3, k, ind_ref, Nsurfmax, surf, Npart, Nrankpmax,  &
         Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint, Nparammax, Nparam, Nintparam,     &
         paramG, weightsG, c, Nrankpmax, Nrankpmax)        
    call extract_matrix3 (2, Nmaxpmax, bb, Nrank, Nrank, b, Nrankpmax, Nrankpmax)    
    call product_matrices (2*Nmaxpmax, 2*Nmaxpmax, 2*Nmaxpmax, c, 2*Nrankpmax,      &
         2*Nrankpmax, b, 2*Nrankpmax, 2*Nrankpmax)
    if (PrnProgress) call write_progress_m (.false., m, 5, 6)
    call sum_matrices (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax, 2*Nrankpmax,         &
         c, 2*Nrankpmax, 2*Nrankpmax)
    call incident_matrix_LAY (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax,        &
         Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint, Nparammax, Nparam, Nintparam,     &
         paramG, weightsG, c, Nrankpmax, Nrankpmax)
    call product_matrices (2*Nmaxpmax, 2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,      &
         2*Nrankpmax, c, 2*Nrankpmax, 2*Nrankpmax)
    if (PrnProgress) call write_progress_m (.false., m, 6, 6) 
    call write_FileTmat (Nrankpmax, Nrankpmax, a)        
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m,            &
         Nrankpmax, Nmaxpmax, cv)
    call product_matrix_vector (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,             &
         2*Nrankpmax, cv, cv1)
    call extend_vector_positive (cv1, cc, m, Mstart, Nrankpmax, Nmaxpmax, Nmaxmax)                                 
    if (m /= 0) then
      call matrix_m_negativ (Nmaxpmax, Nmaxpmax, a, Nrankpmax, Nrankpmax)
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m,         &
           Nrankpmax, Nmaxpmax, cv)
      call product_matrix_vector (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,           &
           2*Nrankpmax, cv, cv1)
      call extend_vector_negative (cv1, cc, m, Nrankpmax, Nmaxpmax, Nmaxmax)
    end if      
    deallocate (Nmaxp)        
    call DSCS (cc, Mrank, Nrankpmax, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k,    &
         snorm,.false.,.true., h, v)    
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsMrank, NthetaConv)    
    call write_DSCS (Nteta,.false., h, v)
    if (NthetaConv >= int(0.8d0*Nteta)) exit
  end do  
  close (unit = iTmat)  
  call CQscat (cc, Mrank, Nrankpmax, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrankpmax, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,       &
       alfap, k, snorm, Cext, Qext)
  call write_Effic (Qscat, Qext)
  call write_MrankConvRes (NthetaConv, epsMrank)               
  if (NthetaConv >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criterion for Mrank is satisfied;')"                            
  else
    print "(/,2x,'Convergence criterion for Mrank is not satisfied;')"
  end if
  call write_InfoFileTmat (FileTmat, Mrank, Nrankpmax, .true., .false., .false.)
  call ScatCharact (k, FileTmat, Mrank, Nrankpmax, .true., .false., .false.)    
  print "(/,2x,'T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrankpmax   
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank  
  deallocate (aa, bb, a, b, c, cv, cv1, cc, h, v, oldh, oldv, paramG, weightsG,     &
              Nintparam)
end subroutine convergence_MrankLAY    
! **********************************************************************************
subroutine convergence_NintDSLAY (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,      &
           Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, Nint,      &
           dNint, epsNint, PrnProgress)    
  use parameters 
  implicit none
  integer    :: TypeGeom, Nsurfmax, Nparammax, Npart, Nrankpmax, Nint, dNint,       &
                Nrankp(Npart), Nparam(Npart)
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), snorm, epsNint,              &
                zRe(Npart,Nrankpmax), zIm(Npart,Nrankpmax)                
  complex(O) :: ind_ref(Npart)
  logical    :: PrnProgress
!        
  integer    :: Mstart, Mrank, Nrank, Nmaxmax, Nmaxpmax, Nteta, i, ipart,           &
                m, iNint, NthetaConv
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext  
  integer,allocatable    :: Nintparam(:,:)
  real(O),allocatable    :: paramG(:,:,:), weightsG(:,:,:), h(:), v(:), oldh(:),    &
                            oldv(:)
  complex(O),allocatable :: aa(:,:), bb(:,:), a(:,:), b(:,:), c(:,:), cv(:),        &
                            cv1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1     
  m = 1
  call write_TypeConvHead (1)
  Nmaxpmax = Nrankpmax
  Nrank = 0
  do ipart = 1,Npart - 1
    Nrank = Nrank + 2 * Nrankp(ipart)
  end do          
  Nrank = Nrank + Nrankp(Npart)    
  allocate (aa(2*Nrank,2*Nrank), bb(2*Nrank,2*Nrank))            
  allocate (a(2*Nrankpmax,2*Nrankpmax), b(2*Nrankpmax,2*Nrankpmax),                 &
            c(2*Nrankpmax,2*Nrankpmax), cv(2*Nrankpmax),cv1(2*Nrankpmax))
  Nmaxmax = Nrankpmax + Mrank * (2 * Nrankpmax - Mrank + 1)    
  allocate (cc(2*Nmaxmax)) 
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do
  if (PrnProgress) call write_progress (.true., 1, 11)
  do iNint = 1, 2        
    allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),         &
              Nintparam(Npart,Nparammax))                 
    call interpolation_listLAY (TypeGeom, Npart, Nsurfmax, surf, Nint, Nparammax,   &
         Nintparam, paramG, weightsG)     
    call matrix_Q31_DS_LAY (TypeGeom, k, ind_ref, Nsurfmax, surf, Npart,            &
         Nrankpmax, Nrankp, zRe, zIm, zpart, m, Nrank, Nint, Nparammax, Nparam,     &
         Nintparam, paramG, weightsG, aa, Nrank, Nrank)                                          
    if (PrnProgress) call write_progress (.false., 2+5*(iNint-1), 11)
    call inverse_matrix (aa, 2*Nrank, 2*Nrank, bb, 2*Nrank, 2*Nrank, 2*Nrank)     
    if (PrnProgress) call write_progress (.false., 3+5*(iNint-1), 11)
    call matrix_Q1_DS_LAY (TypeGeom, 1, k, ind_ref, Nsurfmax, surf, Npart,          &
         Nrankpmax, Nrankp, zRe, zIm, zpart, m, Nrankpmax, Nmaxpmax, Nint,          &
         Nparammax, Nparam, Nintparam, paramG, weightsG, a, Nrankpmax, Nrankpmax)    
    call extract_matrix3 (1, Nrankpmax, bb, Nrank, Nrank, b, Nrankpmax, Nrankpmax)        
    call product_matrices (2*Nmaxpmax, 2*Nrankpmax, 2*Nrankpmax, a, 2*Nrankpmax,    &
         2*Nrankpmax, b, 2*Nrankpmax, 2*Nrankpmax)     
    if (PrnProgress) call write_progress (.false., 4+5*(iNint-1), 11)
    call matrix_Q1_DS_LAY (TypeGeom, 3, k, ind_ref, Nsurfmax, surf, Npart,          &
         Nrankpmax, Nrankp, zRe, zIm, zpart, m, Nrankpmax, Nmaxpmax, Nint,          &
         Nparammax, Nparam, Nintparam, paramG, weightsG, c, Nrankpmax, Nrankpmax)             
    call extract_matrix3 (2, Nrankpmax, bb, Nrank, Nrank, b, Nrankpmax, Nrankpmax)           
    call product_matrices (2*Nmaxpmax, 2*Nrankpmax, 2*Nrankpmax, c, 2*Nrankpmax,    &
         2*Nrankpmax, b, 2*Nrankpmax, 2*Nrankpmax)    
    if (PrnProgress) call write_progress (.false., 5+5*(iNint-1), 11)
    call sum_matrices (2*Nmaxpmax, 2*Nrankpmax, a, 2*Nrankpmax, 2*Nrankpmax,        &
         c, 2*Nrankpmax, 2*Nrankpmax)
    call incident_matrix_DS_LAY (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax,     &
         Nrankp, zRe, zIm, zpart, m, Nrankpmax, Nmaxpmax, Nint, Nparammax, Nparam,  &
         Nintparam, paramG, weightsG, c, Nrankpmax, Nrankpmax)     
    call product_matrices (2*Nmaxpmax, 2*Nrankpmax, 2*Nmaxpmax, a, 2*Nrankpmax,     &
         2*Nrankpmax, c, 2*Nrankpmax, 2*Nrankpmax)               
    if (PrnProgress) call write_progress (.false., 6+5*(iNint-1), 11)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m,            &
         Nrankpmax, Nmaxpmax, cv)
    call product_matrix_vector (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,             &
         2*Nrankpmax, cv, cv1)
    call extend_vector_positive (cv1, cc, m, Mstart, Nrankpmax, Nmaxpmax, Nmaxmax)                                 
    call matrix_m_negativ (Nmaxpmax, Nmaxpmax, a, Nrankpmax, Nrankpmax)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m,           &
         Nrankpmax, Nmaxpmax, cv)
    call product_matrix_vector (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,             &
         2*Nrankpmax, cv, cv1)
    call extend_vector_negative (cv1, cc, m, Nrankpmax, Nmaxpmax, Nmaxmax)
    call DSCS (cc, Mrank, Nrankpmax, Nmaxmax, Nteta, phiGS, alfa, beta, gama,k,     &
         snorm,.false.,.true., h, v)
    call CQscat (cc, Mrank, Nrankpmax, Nmaxmax, k, snorm, Cscat, Qscat)
    call CQext (cc, Mrank, Nrankpmax, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,     &
         alfap, k, snorm, Cext, Qext)
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsNint, NthetaConv)    
    call write_3ConvParamReg (Nint, m, Npart, Nrankp,.false.)
    call write_DSCS (Nteta,.false., h, v)
    call write_Effic (Qscat, Qext)
    Nint = Nint + dNint
    deallocate (paramG, weightsG, Nintparam)
  end do
  call write_NintConvRes (NthetaConv, Nteta, epsNint)
  deallocate (aa, bb, a, b, c, cv, cv1, cc, h, v, oldh, oldv)
end subroutine convergence_NintDSLAY 
! **********************************************************************************   
subroutine convergence_NrankDSLAY (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,     &
           Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, Nrankpmax1,       &
           Nrankp1, zRe1, zIm1, zpart, Nint, epsNrank, PrnProgress)        
  use parameters 
  implicit none
  integer    :: TypeGeom, Nsurfmax, Nparammax, Npart, Nrankpmax, Nrankpmax1, Nint,  &
                Nrankp(Npart), Nrankp1(Npart), Nparam(Npart)
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), snorm, epsNrank,             &
                zRe(Npart,Nrankpmax), zIm(Npart,Nrankpmax),                         &
                zRe1(Npart,Nrankpmax1), zIm1(Npart,Nrankpmax1)
  complex(O) :: ind_ref(Npart)
  logical    :: PrnProgress
!        
  integer    :: Mstart, Mrank, Nteta, Nrank, Nrank1, Nmaxpmax, Nmaxmax, i,          &
                m, ipart, NthetaConv
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext  
  integer,allocatable    :: Nintparam(:,:)
  real(O),allocatable    :: paramG(:,:,:), weightsG(:,:,:), h(:), v(:), oldh(:),    &
                            oldv(:)
  complex(O),allocatable :: aa(:,:), bb(:,:), a(:,:), b(:,:), c(:,:), cv(:),        &
                            cv1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1     
  m = 1
  call write_TypeConvHead (2)
  Nmaxpmax = Nrankpmax
  Nrank  = 0
  Nrank1 = 0
  do ipart = 1,Npart - 1
    Nrank  = Nrank  + 2 * Nrankp(ipart)
    Nrank1 = Nrank1 + 2 * Nrankp1(ipart)
  end do         
  Nrank  = Nrank  + Nrankp(Npart) 
  Nrank1 = Nrank1 + Nrankp1(Npart)   
  allocate (aa(2*Nrank,2*Nrank), bb(2*Nrank,2*Nrank))            
  allocate (a(2*Nrankpmax,2*Nrankpmax), b(2*Nrankpmax,2*Nrankpmax),                 &  
            c(2*Nrankpmax,2*Nrankpmax), cv(2*Nrankpmax), cv1(2*Nrankpmax))
  Nmaxmax = Nrankpmax + Mrank * (2 * Nrankpmax - Mrank + 1)    
  allocate (cc(2*Nmaxmax)) 
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))    
  allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),           &
            Nintparam(Npart,Nparammax))           
  call interpolation_listLAY (TypeGeom, Npart, Nsurfmax, surf, Nint, Nparammax,     &
       Nintparam, paramG, weightsG)
  if (PrnProgress) call write_progress (.true., 1, 11)          
! --- Nrank configuration ---  
  call matrix_Q31_DS_LAY (TypeGeom, k, ind_ref, Nsurfmax, surf, Npart, Nrankpmax,   &
       Nrankp, zRe, zIm, zpart, m, Nrank, Nint, Nparammax, Nparam, Nintparam,       &
       paramG, weightsG, aa, Nrank, Nrank)                           
  if (PrnProgress) call write_progress (.false., 2, 11)
  call inverse_matrix (aa, 2*Nrank, 2*Nrank, bb, 2*Nrank, 2*Nrank, 2*Nrank)
  if (PrnProgress) call write_progress (.false., 3, 11)
  call matrix_Q1_DS_LAY (TypeGeom, 1, k, ind_ref, Nsurfmax, surf, Npart, Nrankpmax, &
       Nrankp, zRe, zIm, zpart, m, Nrankpmax, Nmaxpmax, Nint, Nparammax, Nparam,    &
       Nintparam, paramG, weightsG, a, Nrankpmax, Nrankpmax)    
  call extract_matrix3 (1, Nrankpmax, bb, Nrank, Nrank, b, Nrankpmax, Nrankpmax)           
  call product_matrices (2*Nmaxpmax, 2*Nrankpmax, 2*Nrankpmax, a, 2*Nrankpmax,      &
       2*Nrankpmax, b, 2*Nrankpmax, 2*Nrankpmax)           
  if (PrnProgress) call write_progress (.false., 4, 11)
  call matrix_Q1_DS_LAY (TypeGeom, 3, k, ind_ref, Nsurfmax, surf, Npart, Nrankpmax, &
       Nrankp, zRe, zIm, zpart, m, Nrankpmax, Nmaxpmax, Nint, Nparammax, Nparam,    &
       Nintparam, paramG, weightsG, c, Nrankpmax, Nrankpmax)              
  call extract_matrix3 (2, Nrankpmax, bb, Nrank, Nrank, b, Nrankpmax, Nrankpmax)             
  call product_matrices (2*Nmaxpmax, 2*Nrankpmax, 2*Nrankpmax, c, 2*Nrankpmax,      &
       2*Nrankpmax, b, 2*Nrankpmax, 2*Nrankpmax)    
  if (PrnProgress) call write_progress (.false., 5, 11)
  call sum_matrices (2*Nmaxpmax, 2*Nrankpmax, a, 2*Nrankpmax, 2*Nrankpmax,          &
       c, 2*Nrankpmax, 2*Nrankpmax)
  call incident_matrix_DS_LAY (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax,       &
       Nrankp, zRe, zIm, zpart, m, Nrankpmax, Nmaxpmax, Nint, Nparammax, Nparam,    &
       Nintparam, paramG, weightsG, c, Nrankpmax, Nrankpmax)   
  call product_matrices (2*Nmaxpmax, 2*Nrankpmax, 2*Nmaxpmax, a, 2*Nrankpmax,       &
       2*Nrankpmax, c, 2*Nrankpmax, 2*Nrankpmax)             
  if (PrnProgress) call write_progress (.false., 6, 11)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrankpmax,   &
       Nmaxpmax, cv)
  call product_matrix_vector (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,               &
       2*Nrankpmax, cv, cv1)
  call extend_vector_positive (cv1, cc, m, Mstart, Nrankpmax, Nmaxpmax, Nmaxmax)                                 
  call matrix_m_negativ (Nmaxpmax, Nmaxpmax, a, Nrankpmax, Nrankpmax)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m,             &
       Nrankpmax, Nmaxpmax, cv)
  call product_matrix_vector (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,               &
       2*Nrankpmax, cv, cv1)
  call extend_vector_negative (cv1, cc, m, Nrankpmax, Nmaxpmax, Nmaxmax)
  call DSCS (cc, Mrank, Nrankpmax, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k,      &
       snorm,.false.,.true., h, v)
  call CQscat (cc, Mrank, Nrankpmax, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrankpmax, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,       &
       alfap, k, snorm, Cext, Qext)  
  do i = 1, Nteta
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do
  call write_3ConvParamReg (Nint, m, Npart, Nrankp,.false.)
  call write_DSCS  (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
! --- Nrank1 configuration ---  
  Nmaxpmax = Nrankpmax1
  Nmaxmax  = Nrankpmax1 + Mrank * (2 * Nrankpmax1 - Mrank + 1)       
  call matrix_Q31_DS_LAY (TypeGeom, k, ind_ref, Nsurfmax, surf, Npart, Nrankpmax1,  &
       Nrankp1, zRe1, zIm1, zpart, m, Nrank1, Nint, Nparammax, Nparam, Nintparam,   &
       paramG, weightsG, aa, Nrank, Nrank)                          
  if (PrnProgress) call write_progress (.false., 7, 11)
  call inverse_matrix (aa, 2*Nrank, 2*Nrank, bb, 2*Nrank, 2*Nrank, 2*Nrank1)
  if (PrnProgress) call write_progress (.false., 8, 11)
  call matrix_Q1_DS_LAY (TypeGeom, 1, k, ind_ref, Nsurfmax, surf, Npart,            &
       Nrankpmax1, Nrankp1, zRe1, zIm1, zpart, m, Nrankpmax1, Nmaxpmax, Nint,       &
       Nparammax, Nparam, Nintparam, paramG, weightsG, a, Nrankpmax, Nrankpmax)    
  call extract_matrix3 (1, Nrankpmax1, bb, Nrank, Nrank, b, Nrankpmax, Nrankpmax)       
  call product_matrices (2*Nmaxpmax, 2*Nrankpmax1, 2*Nrankpmax1, a, 2*Nrankpmax,    &
       2*Nrankpmax, b, 2*Nrankpmax, 2*Nrankpmax)           
  if (PrnProgress) call write_progress (.false., 9, 11)
  call matrix_Q1_DS_LAY (TypeGeom, 3, k, ind_ref, Nsurfmax, surf, Npart,            &
       Nrankpmax1, Nrankp1, zRe1, zIm1, zpart, m, Nrankpmax1, Nmaxpmax, Nint,       &
       Nparammax, Nparam, Nintparam, paramG, weightsG, c, Nrankpmax, Nrankpmax)           
  call extract_matrix3 (2, Nrankpmax1, bb, Nrank, Nrank, b, Nrankpmax, Nrankpmax)            
  call product_matrices (2*Nmaxpmax, 2*Nrankpmax1, 2*Nrankpmax1, c, 2*Nrankpmax,    &
       2*Nrankpmax, b, 2*Nrankpmax, 2*Nrankpmax)    
  if (PrnProgress) call write_progress (.false., 10, 11)
  call sum_matrices (2*Nmaxpmax, 2*Nrankpmax1, a, 2*Nrankpmax, 2*Nrankpmax,         &
       c, 2*Nrankpmax, 2*Nrankpmax)
  call incident_matrix_DS_LAY (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax1,      &
       Nrankp1, zRe1, zIm1, zpart, m, Nrankpmax1, Nmaxpmax, Nint, Nparammax,        &
       Nparam, Nintparam, paramG, weightsG, c, Nrankpmax, Nrankpmax)   
  call product_matrices (2*Nmaxpmax, 2*Nrankpmax1, 2*Nmaxpmax, a, 2*Nrankpmax,      &
       2*Nrankpmax, c, 2*Nrankpmax, 2*Nrankpmax)             
  if (PrnProgress) call write_progress (.false., 11, 11)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrankpmax1,  &
       Nmaxpmax, cv)
  call product_matrix_vector (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,               &
       2*Nrankpmax, cv, cv1)
  call extend_vector_positive (cv1, cc, m, Mstart, Nrankpmax1, Nmaxpmax, Nmaxmax)                                
  call matrix_m_negativ (Nmaxpmax, Nmaxpmax, a, Nrankpmax, Nrankpmax)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m,             &
       Nrankpmax1, Nmaxpmax, cv)
  call product_matrix_vector (2*Nmaxpmax, 2*Nmaxpmax, a, 2*Nrankpmax,               &
       2*Nrankpmax, cv, cv1)
  call extend_vector_negative (cv1, cc, m, Nrankpmax1, Nmaxpmax, Nmaxmax)
  call DSCS (cc, Mrank, Nrankpmax1, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k,     &
       snorm,.false.,.true., h, v)
  call CQscat (cc, Mrank, Nrankpmax1, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrankpmax1, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,      &
       alfap, k, snorm, Cext, Qext)  
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConv)  
  call write_3ConvParamReg (Nint, m, Npart, Nrankp1,.false.)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConv, Nteta, epsNrank)
  deallocate (aa, bb, a, b, c, cv, cv1, cc, h, v, oldh, oldv, paramG, weightsG,     &
              Nintparam)
end subroutine convergence_NrankDSLAY 
! **********************************************************************************
subroutine convergence_MrankDSLAY (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,     &
           Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, Nint,      &
           ComplexPlane, EpsZReIm, autGenDS, epsMrank, epsNrank, dNintMrank,        &
           FileTmat, PrnProgress)    
  use parameters 
  implicit none
  integer       :: TypeGeom, Nsurfmax, Nparammax, Npart, Nrankpmax, Nint,           &
                   Nrankp(Npart), Nparam(Npart), dNintMrank
  real(O)       :: k, surf(Npart,Nsurfmax), zpart(Npart), snorm, epsMrank,          &
                   epsNrank, zRe(Npart,Nrankpmax), zIm(Npart,Nrankpmax),            &
                   EpsZReIm(Npart)
  complex(O)    :: ind_ref(Npart)
  character(80) :: FileTmat
  logical       :: autGenDS, PrnProgress, ComplexPlane(Npart)
!             
  integer       :: Mstart, Mrank, Nteta, Nrank, Nmaxmax, i, m, ipart, NthetaConv,   &
                   NrankAL, NrankpmaxAL, NrankG, NmaxG, NrankpmaxL, NrankpmaxL1
  real(O)       :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat,            &
                   Qscat, Cext, Qext
  logical       :: ComplexDS, ChangeDS, more, continuare, ConvTest
  integer,allocatable    :: Nintparam(:,:), Nrankp1(:)
  real(O),allocatable    :: paramG(:,:,:), weightsG(:,:,:), h(:), v(:), oldh(:),    &
                            oldv(:), zReL(:,:), zImL(:,:), zReL1(:,:), zImL1(:,:)
  complex(O),allocatable :: aa(:,:), bb(:,:), a(:,:), b(:,:), c(:,:), cv(:),        &
                            cv1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 0
  Mrank  = Nrankpmax 
  Nrank  = 0
  do ipart = 1, Npart - 1
    Nrank = Nrank + 2 * Nrankp(ipart)
  end do     
  Nrank   = Nrank + Nrankp(Npart)      
  NrankAL = Nrank
  NrankpmaxAL = Nrankpmax  
  NrankG  = Nrankpmax 
  Nmaxmax = NrankG + Mrank * (2 * NrankG - Mrank + 1)
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call write_HeadFileTmat (NrankpmaxAL, NrankpmaxAL) 
  call write_TypeConvHead (3)
  call write_2ConvParamReg (Nint, Npart, Nrankp)                  
  allocate (aa(2*NrankAL,2*NrankAL), bb(2*NrankAL,2*NrankAL))            
  allocate (a(2*NrankpmaxAL,2*NrankpmaxAL), b(2*NrankpmaxAL,2*NrankpmaxAL),         &
            c(2*NrankpmaxAL,2*NrankpmaxAL)) 
  allocate (cv(2*NrankG), cv1(2*NrankG))      
  allocate (cc(2*Nmaxmax))   
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do    
  allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),           &
            Nintparam(Npart,Nparammax))           
  call interpolation_listLAY (TypeGeom, Npart, Nsurfmax, surf, Nint, Nparammax,     &
       Nintparam, paramG, weightsG)
  ComplexDS = .false.
  do ipart = 1, Npart           
    do i = 1, Nrankp(ipart)                    
      if (zIm(ipart,i) /= 0._O) ComplexDS = .true.
    end do                      
  end do 
  ChangeDS = .false.
! -----------------------------------------------------------------------------------  
! If the sources are distributed in the complex plane and they are automatically    !
! generated, an interactive convergence test over Nint and Nrank can be performed   !
! at each azimuthal mode calculation. To make this test active comment out the next !
! lines.                                                                            !  
! ----------------------------------------------------------------------------------- 
! if (ComplexDS .and. autGenDS) then
!   print "(/,2x, a)",                                                              &
!   '- enter true to change the values of Nint and Nrank at each azimuthal mode and'	                                  
!   print "( 2x, 'false otherwise')"        
!   call read_logical (ChangeDS)    
! end if                               
  Mrank = - 1
  do m = Mstart, NrankG
    call write_1ConvParam (m)
    Mrank = Mrank + 1
    if (m == 0) then
      NmaxG = NrankG
    else
      NmaxG = NrankG - m + 1
    end if
!   --- local convergence test for sources distributed in the complex plane ---    
    NrankpmaxL = Nrankpmax
    allocate (zReL(Npart,NrankpmaxL), zImL(Npart,NrankpmaxL))   
    do ipart = 1, Npart	    
      do i = 1, Nrankp(ipart)
        zReL(ipart,i) = zRe(ipart,i)
        zImL(ipart,i) = zIm(ipart,i)	    	
      end do        
    end do      
    if (ComplexDS .and. m > 1) then
      if (.not. ChangeDS) then
        deallocate (paramG, weightsG, Nintparam)
        Nint = Nint + dNintMrank
        allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),     &
                  Nintparam(Npart,Nparammax))           
        call interpolation_listLAY (TypeGeom, Npart, Nsurfmax, surf, Nint,          &
             Nparammax, Nintparam, paramG, weightsG)     
      else
        print "(/,2x,'Azimuthal mode: m = ',i3)", m  
        more = .true.
        do while (more)
          print "(  2x, '- enter the number of integration points Nint')"
          call read_integer (Nint) 
          deallocate (paramG, weightsG, Nintparam)        
          allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),   &
                    Nintparam(Npart,Nparammax))           
          call interpolation_listLAY (TypeGeom, Npart, Nsurfmax, surf, Nint,        &
               Nparammax, Nintparam, paramG, weightsG)                 
          NrankpmaxL = 0  
          Nrank      = 0             
          do ipart = 1, Npart
            if (ComplexPlane(ipart)) then
              print "(2x,'- enter the estimated value of Nrank for region ',i2)",   &
	              ipart
              call read_integer (Nrankp(ipart))		
	    end if	 
            if (Nrankp(ipart)  > NrankpmaxL)  NrankpmaxL  = Nrankp(ipart)
            if (ipart < Npart) then
              Nrank = Nrank + 2 * Nrankp(ipart)
            else
              Nrank = Nrank + Nrankp(ipart)
            end if             	  
          end do 
          if (NrankpmaxL > Nrankpmax) then
            print "(/,2x,'Input error:')"
            print "(  2x, a)",                                                      &
           'the number of discrete sources for the first layer exceeds the number'	    
            print "(  2x, a)",                                                      &
           'of discrete sources corresponding to the initial configuration;'            
            stop   
	  end if                                     
          deallocate (zReL, zImL)	   	   
          allocate (zReL(Npart,NrankpmaxL), zImL(Npart,NrankpmaxL))               
          call zDSLAY (TypeGeom, Npart, Nsurfmax, surf, NrankpmaxL, Nrankp, zpart,  &
               ComplexPlane, EpsZReIm, zReL, zImL)               
          print "(/,2x, a)",                                                        &
         '- enter true to perform a convergence test over the new values of Nrank and'	                                  
          print "( 2x, 'false otherwise')"             
	  call read_logical (ConvTest)		
	  if (ConvTest) then
	    allocate (Nrankp1(Npart))        
	    NrankpmaxL1 = 0    	   
            do ipart = 1, Npart          
	      Nrankp1(ipart) = Nrankp(ipart) - 1	          
	      if (Nrankp1(ipart) > NrankpmaxL1) NrankpmaxL1 = Nrankp1(ipart) 	   
            end do  	     
	    allocate (zReL1(Npart,NrankpmaxL1), zImL1(Npart,NrankpmaxL1)) 
            call zDSLAY (TypeGeom, Npart, Nsurfmax, surf, NrankpmaxL1, Nrankp1,     &
                 zpart, ComplexPlane, EpsZReIm, zReL1, zImL1)  
            call convergence_NrankDSLAY_m (m, TypeGeom, k, ind_ref, snorm,          &
                 Nsurfmax, surf, Nparammax, Nparam, Npart, NrankpmaxL, Nrankp,      &
                 zReL, zImL, NrankpmaxL1, Nrankp1, zReL1, zImL1, zpart, NrankG,     &
                 NmaxG, Nint, Nintparam, paramG, weightsG, epsNrank)	    
            deallocate (zReL1, zImL1, Nrankp1)	     
          end if 	       	  	 	             	  	   	    	   	  	
	  if (ConvTest) then
            print "(2x, a)",                                                        &
           '- enter true for new input values of Nint and Nrank and false to continue;'	
            call read_logical (continuare)
            if (.not. continuare) more = .false.             	      
	  else
            more = .false.
	  end if  
        end do
      end if                                                                               
    end if
    if (Nrank > NrankAL) then
      NrankAL = Nrank
      deallocate (aa, bb)
      allocate (aa(2*NrankAL,2*NrankAL), bb(2*NrankAL,2*NrankAL))                                  
    end if    
!   --- end local convergence test ---     
    if (PrnProgress) call write_progress_m (.true., m, 1, 6)                    
    call matrix_Q31_DS_LAY (TypeGeom, k, ind_ref, Nsurfmax, surf, Npart,            &
         NrankpmaxL, Nrankp, zReL, zImL, zpart, m, Nrank, Nint, Nparammax,          &
         Nparam, Nintparam, paramG, weightsG, aa, NrankAL, NrankAL)         
    if (PrnProgress) call write_progress_m (.false., m, 2, 6)                                            
    call inverse_matrix (aa, 2*NrankAL, 2*NrankAL, bb, 2*NrankAL, 2*NrankAL, 2*Nrank)
    if (PrnProgress) call write_progress_m (.false., m, 3, 6)        
    call matrix_Q1_DS_LAY (TypeGeom, 1, k, ind_ref, Nsurfmax, surf, Npart,          &
         NrankpmaxL, Nrankp, zReL, zImL, zpart, m, NrankG, NmaxG, Nint, Nparammax,  &
         Nparam, Nintparam, paramG, weightsG, a, NrankpmaxAL, NrankpmaxAL)                               
    call extract_matrix3 (1, NrankpmaxL, bb, NrankAL, NrankAL, b,                   &    
         NrankpmaxAL, NrankpmaxAL)                
    call product_matrices (2*NmaxG, 2*NrankpmaxL, 2*NrankpmaxL, a, 2*NrankpmaxAL,   &
         2*NrankpmaxAL, b, 2*NrankpmaxAL, 2*NrankpmaxAL)                       
    if (PrnProgress) call write_progress_m (.false., m, 4, 6)
    call matrix_Q1_DS_LAY (TypeGeom, 3, k, ind_ref, Nsurfmax, surf, Npart,          &
         NrankpmaxL, Nrankp, zReL, zImL, zpart, m, NrankG, NmaxG, Nint, Nparammax,  &
         Nparam, Nintparam, paramG, weightsG, c, NrankpmaxAL, NrankpmaxAL)                      
    call extract_matrix3 (2, NrankpmaxL, bb, NrankAL, NrankAL, b,                   &
         NrankpmaxAL, NrankpmaxAL)               
    call product_matrices (2*NmaxG, 2*NrankpmaxL, 2*NrankpmaxL, c, 2*NrankpmaxAL,   &
         2*NrankpmaxAL, b, 2*NrankpmaxAL, 2*NrankpmaxAL)             
    if (PrnProgress) call write_progress_m (.false., m, 5, 6)    
    call sum_matrices (2*NmaxG, 2*NrankpmaxL, a, 2*NrankpmaxAL, 2*NrankpmaxAL,      &
         c, 2*NrankpmaxAL, 2*NrankpmaxAL)         
    call incident_matrix_DS_LAY (TypeGeom, k, Nsurfmax, surf, Npart, NrankpmaxL,    &
         Nrankp, zReL, zImL, zpart, m, NrankG, NmaxG, Nint, Nparammax, Nparam,      &
         Nintparam, paramG, weightsG, c, NrankpmaxAL, NrankpmaxAL)                                         
    call product_matrices (2*NmaxG, 2*NrankpmaxL, 2*NmaxG, a, 2*NrankpmaxAL,        &
         2*NrankpmaxAL, c, 2*NrankpmaxAL, 2*NrankpmaxAL)         
    if (PrnProgress) call write_progress_m (.false., m, 6, 6)
    call write_FileTmat (NrankpmaxAL, NrankpmaxAL, a)                    
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m,            &
         NrankG, NmaxG, cv)
    call product_matrix_vector (2*NmaxG, 2*NmaxG, a, 2*NrankpmaxAL, 2*NrankpmaxAL,  &
         cv, cv1)
    call extend_vector_positive (cv1, cc, m, Mstart, NrankG, NmaxG, Nmaxmax)                                 
    if (m /= 0) then
      call matrix_m_negativ (NmaxG, NmaxG, a, NrankpmaxAL, NrankpmaxAL)
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m,         &
           NrankG, NmaxG, cv)
      call product_matrix_vector (2*NmaxG, 2*NmaxG, a, 2*NrankpmaxAL,               &
           2*NrankpmaxAL, cv, cv1)
      call extend_vector_negative (cv1, cc, m, NrankG, NmaxG, Nmaxmax)
    end if      
    call DSCS (cc, Mrank, NrankG, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k,       &
         snorm,.false.,.true., h, v)                                        
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsMrank, NthetaConv)    
    call write_DSCS (Nteta,.false., h, v)
    deallocate (zReL, zImL)     
    if (NthetaConv >= int(0.8*Nteta)) exit
  end do 
  close (unit = iTmat)  
  call CQscat (cc, Mrank, NrankG, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, NrankG, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,          &
       alfap, k, snorm, Cext, Qext)      
  call write_Effic (Qscat, Qext)             
  call write_MrankConvRes (NthetaConv, epsMrank)
  if (NthetaConv >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criterion for Mrank is satisfied;')"                                                              
  else
    print "(/,2x,'Convergence criterion for Mrank is not satisfied;')"
  end if 
  call write_InfoFileTmat (FileTmat, Mrank, NrankG, .true., .false., .false.)
  call ScatCharact (k, FileTmat, Mrank, NrankG, .true., .false., .false.) 
  print "(/,2x,'T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", NrankG
  print "(  2x,'- number of azimuthal modes, Mrank = ',i2,';')", Mrank            
  deallocate (aa, bb, a, b, c, cv, cv1, cc, h, v, oldh, oldv, paramG, weightsG,     &
              Nintparam)
end subroutine convergence_MrankDSLAY
! **********************************************************************************   
subroutine convergence_NrankDSLAY_m (m, TypeGeom, k, ind_ref, snorm, Nsurfmax,      &
           surf, Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, Nrankpmax1, &
           Nrankp1, zRe1, zIm1, zpart, NrankG, NmaxG, Nint, Nintparam, paramG,      &
           weightsG, epsNrank)        
  use parameters 
  implicit none
  integer    :: m, TypeGeom, Nsurfmax, Nparammax, Npart, Nrankpmax, Nrankpmax1,     &
                Nint, Nrankp(Npart), Nrankp1(Npart), Nparam(Npart), NrankG, NmaxG,  &
                Nintparam(Npart,Nparammax)                
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), snorm, epsNrank,             &
                zRe(Npart,Nrankpmax), zIm(Npart,Nrankpmax),                         &
                zRe1(Npart,Nrankpmax1), zIm1(Npart,Nrankpmax1),                     &
                paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint) 
  complex(O) :: ind_ref(Npart)  
!        
  integer    :: Mstart, Mrank, Nteta, Nrank, Nrank1, Nmaxmax, i, ipart, NthetaConv, &
                NrankAL, NrankpmaxAL
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext, teta  
  real(O),allocatable    :: h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: aa(:,:), bb(:,:), a(:,:), b(:,:), c(:,:), cv(:),        &
                            cv1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = m  
  Mrank  = m       
  Nrank  = 0
  do ipart = 1,Npart - 1
    Nrank  = Nrank  + 2 * Nrankp(ipart)    
  end do         
  Nrank  = Nrank  + Nrankp(Npart)     
  NrankpmaxAL = max(Nrankpmax,NrankG)
  NrankAL     = Nrank  
  allocate (aa(2*NrankAL,2*NrankAL), bb(2*NrankAL,2*NrankAL))            
  allocate (a(2*NrankpmaxAL,2*NrankpmaxAL), b(2*NrankpmaxAL,2*NrankpmaxAL),         &  
            c(2*NrankpmaxAL,2*NrankpmaxAL)) 
  allocate (cv(2*NrankG), cv1(2*NrankG))
  Nmaxmax = NrankG + Mrank * (2 * NrankG - Mrank + 1)    
  allocate (cc(2*Nmaxmax)) 
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))                  
! --- Nrank configuration ---  
  call matrix_Q31_DS_LAY (TypeGeom, k, ind_ref, Nsurfmax, surf, Npart, Nrankpmax,   &
       Nrankp, zRe, zIm, zpart, m, Nrank, Nint, Nparammax, Nparam, Nintparam,       &
       paramG, weightsG, aa, NrankAL, NrankAL)                                    
  call inverse_matrix (aa, 2*NrankAL, 2*NrankAL, bb, 2*NrankAL, 2*NrankAL, 2*Nrank)   
  call matrix_Q1_DS_LAY (TypeGeom, 1, k, ind_ref, Nsurfmax, surf, Npart,            &
       Nrankpmax, Nrankp, zRe, zIm, zpart, m, NrankG, NmaxG, Nint, Nparammax,       &
       Nparam, Nintparam, paramG, weightsG, a, NrankpmaxAL, NrankpmaxAL)           
  call extract_matrix3 (1, Nrankpmax, bb, NrankAL, NrankAL, b,                      &
       NrankpmaxAL, NrankpmaxAL)             
  call product_matrices (2*NmaxG, 2*Nrankpmax, 2*Nrankpmax, a, 2*NrankpmaxAL,       &
       2*NrankpmaxAL, b, 2*NrankpmaxAL, 2*NrankpmaxAL)                   
  call matrix_Q1_DS_LAY (TypeGeom, 3, k, ind_ref, Nsurfmax, surf, Npart,            &
       Nrankpmax, Nrankp, zRe, zIm, zpart, m, NrankG, NmaxG, Nint, Nparammax,       &
       Nparam, Nintparam, paramG, weightsG, c, NrankpmaxAL, NrankpmaxAL)                     
  call extract_matrix3 (2, Nrankpmax, bb, NrankAL, NrankAL, b,                      &
       NrankpmaxAL, NrankpmaxAL)               
  call product_matrices (2*NmaxG, 2*Nrankpmax, 2*Nrankpmax, c, 2*NrankpmaxAL,       &
       2*NrankpmaxAL, b, 2*NrankpmaxAL, 2*NrankpmaxAL)            
  call sum_matrices (2*NmaxG, 2*Nrankpmax, a, 2*NrankpmaxAL, 2*NrankpmaxAL,         &
       c, 2*NrankpmaxAL, 2*NrankpmaxAL)       
  call incident_matrix_DS_LAY (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax,       &
       Nrankp, zRe, zIm, zpart, m, NrankG, NmaxG, Nint, Nparammax, Nparam,          &
       Nintparam, paramG, weightsG, c, NrankpmaxAL, NrankpmaxAL)          
  call product_matrices (2*NmaxG, 2*Nrankpmax, 2*NmaxG, a, 2*NrankpmaxAL,           &
       2*NrankpmaxAL, c, 2*NrankpmaxAL, 2*NrankpmaxAL)                    
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, NrankG,      &
       NmaxG, cv)       
  call product_matrix_vector (2*NmaxG, 2*NmaxG, a, 2*NrankpmaxAL,                   &
       2*NrankpmaxAL, cv, cv1)       
  call extend_vector_positive (cv1, cc, m, Mstart, NrankG, NmaxG, Nmaxmax)
  call matrix_m_negativ (NmaxG, NmaxG, a, NrankpmaxAL, NrankpmaxAL)  
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m,             &
       NrankG, NmaxG, cv)       
  call product_matrix_vector (2*NmaxG, 2*NmaxG, a, 2*NrankpmaxAL,                   &
       2*NrankpmaxAL, cv, cv1)       
  call extend_vector_negative (cv1, cc, m, NrankG, NmaxG, Nmaxmax)  
  call DSCS (cc, Mrank, NrankG, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k,         &
       snorm,.false.,.true., h, v)
  call CQscat (cc, Mrank, NrankG, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, NrankG, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,          &
       alfap, k, snorm, Cext, Qext)  
  do i = 1, Nteta
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do    
  print "(1x,'Convergence Test over Nrank')"
  print "(1x,'---------------------------')"  
  print "(1x,'Nint = ',i5,',',1x,'Nrank = ',i3,',',1x,'Mrank = ',i3)", Nint,        &
          NrankG, m  
  do ipart = 1, Npart
    print "(1x,'Nrank for region ',i2,', Nrank = ',i3)", ipart, Nrankp(ipart)  
  end do          
  print "(/,1x, a, /, 2x, a, 9x, a, 8x, a)",                                        &
 'normalized differential scattering cross section', 'theta', 'parallel',           &
 'perpendicular' 
  do i = 1, Nteta    
    teta = real(i - 1,O) * 180._O / real(Nteta - 1,O)                
    print "(1x,f6.2,5x,1pe13.4,5x,1pe13.4)", teta, h(i), v(i)   
  end do  
  print "(1x,'scattering efficiency = ',1pe13.4)",   Qscat
  print "(1x,'extinction efficiency = ',1pe13.4,/)", Qext
! --- Nrank1 configuration (only the DS configuration is changed) --- 
  Nrank1 = 0
  do ipart = 1, Npart - 1   
    Nrank1 = Nrank1 + 2 * Nrankp1(ipart)
  end do         
  Nrank1 = Nrank1 + Nrankp1(Npart)  
  call matrix_Q31_DS_LAY (TypeGeom, k, ind_ref, Nsurfmax, surf, Npart, Nrankpmax1,  &
       Nrankp1, zRe1, zIm1, zpart, m, Nrank1, Nint, Nparammax, Nparam, Nintparam,   &
       paramG, weightsG, aa, NrankAL, NrankAL)                                    
  call inverse_matrix (aa, 2*NrankAL, 2*NrankAL, bb, 2*NrankAL, 2*NrankAL, 2*Nrank1)   
  call matrix_Q1_DS_LAY (TypeGeom, 1, k, ind_ref, Nsurfmax, surf, Npart,            &
       Nrankpmax1, Nrankp1, zRe1, zIm1, zpart, m, NrankG, NmaxG, Nint, Nparammax,   &
       Nparam, Nintparam, paramG, weightsG, a, NrankpmaxAL, NrankpmaxAL)           
  call extract_matrix3 (1, Nrankpmax1, bb, NrankAL, NrankAL, b,                     &
       NrankpmaxAL, NrankpmaxAL)             
  call product_matrices (2*NmaxG, 2*Nrankpmax1, 2*Nrankpmax1, a, 2*NrankpmaxAL,     &
       2*NrankpmaxAL, b, 2*NrankpmaxAL, 2*NrankpmaxAL)                   
  call matrix_Q1_DS_LAY (TypeGeom, 3, k, ind_ref, Nsurfmax, surf, Npart,            &
       Nrankpmax1, Nrankp1, zRe1, zIm1, zpart, m, NrankG, NmaxG, Nint, Nparammax,   &
       Nparam, Nintparam, paramG, weightsG, c, NrankpmaxAL, NrankpmaxAL)                     
  call extract_matrix3 (2, Nrankpmax1, bb, NrankAL, NrankAL, b,                     &
       NrankpmaxAL, NrankpmaxAL)               
  call product_matrices (2*NmaxG, 2*Nrankpmax1, 2*Nrankpmax1, c, 2*NrankpmaxAL,     &
       2*NrankpmaxAL, b, 2*NrankpmaxAL, 2*NrankpmaxAL)            
  call sum_matrices (2*NmaxG, 2*Nrankpmax1, a, 2*NrankpmaxAL, 2*NrankpmaxAL,        &
       c, 2*NrankpmaxAL, 2*NrankpmaxAL)       
  call incident_matrix_DS_LAY (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax1,      &
       Nrankp1, zRe1, zIm1, zpart, m, NrankG, NmaxG, Nint, Nparammax, Nparam,       &
       Nintparam, paramG, weightsG, c, NrankpmaxAL, NrankpmaxAL)          
  call product_matrices (2*NmaxG, 2*Nrankpmax1, 2*NmaxG, a, 2*NrankpmaxAL,          &
       2*NrankpmaxAL, c, 2*NrankpmaxAL, 2*NrankpmaxAL)                    
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, NrankG,      &
       NmaxG, cv)       
  call product_matrix_vector (2*NmaxG, 2*NmaxG, a, 2*NrankpmaxAL,                   &
       2*NrankpmaxAL, cv, cv1)       
  call extend_vector_positive (cv1, cc, m, Mstart, NrankG, NmaxG, Nmaxmax)  
  call matrix_m_negativ (NmaxG, NmaxG, a, NrankpmaxAL, NrankpmaxAL)  
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m,             &
       NrankG, NmaxG, cv)       
  call product_matrix_vector (2*NmaxG, 2*NmaxG, a, 2*NrankpmaxAL,                   &
       2*NrankpmaxAL, cv, cv1)       
  call extend_vector_negative (cv1, cc, m, NrankG, NmaxG, Nmaxmax)  
  call DSCS (cc, Mrank, NrankG, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k,         &
       snorm,.false.,.true., h, v)
  call CQscat (cc, Mrank, NrankG, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, NrankG, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,          &
       alfap, k, snorm, Cext, Qext) 
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConv)   
  print "(1x,'Nint = ',i5,',',1x,'Nrank = ',i3,',',1x,'Mrank = ',i3)", Nint,        &
          NrankG, m  
  do ipart = 1, Npart
    print "(1x,'Nrank for region ',i2,', Nrank = ',i3)", ipart, Nrankp1(ipart)  
  end do          
  print "(/,1x, a, /, 2x, a, 9x, a, 8x, a)",                                        &
 'normalized differential scattering cross section', 'theta', 'parallel',           &
 'perpendicular' 
  do i = 1, Nteta    
    teta = real(i - 1,O) * 180._O / real(Nteta - 1,O)                
    print "(1x,f6.2,5x,1pe13.4,5x,1pe13.4)", teta, h(i), v(i)   
  end do  
  print "(1x,'scattering efficiency = ',1pe13.4)",   Qscat
  print "(1x,'extinction efficiency = ',1pe13.4,/)", Qext 
  print "(1x, a, i2, a, 1f5.2, a, /)",                                              &
 'The solution converges in ', NthetaConv, ' points with an relative error of ',    &
  100 * epsNrank, ' %;'                  
  deallocate (aa, bb, a, b, c, cv, cv1, cc, h, v, oldh, oldv)
end subroutine convergence_NrankDSLAY_m 

subroutine TNONAXSYM
!------------------------------------------------------------------------------------
! 1. General Considerations                                                         !
! --------------------------                                                        !
! TNONAXSYM is a routine for computing the T matrix and the scattering              !
! characteristics of homogeneous, dielectric (isotropic, uniaxial anisotropic,      !
! chiral) and perfectly conducting, nonaxisymmetric particles.                      !
!                                                                                   !
! For electrically anisotropic media, the permittivity is a tensor and in general,  !
! the permittivity tensor of a crystal is symmetric. Since there always exists a    !
! coordinate transformation that transforms a symmetric matrix into a diagonal      !
! matrix, we can take this coordinate system as reference frame. This coordinate    !
! system is called the principal coordinate system, and in the principal coordinate !
! system the permittivity tensor is a diagonal matrix with elements eps_x, eps_y    !
! and eps_z. The three coordinate axes are the principal axes of the crystal, and   !
! if eps = eps_x = eps_y and eps_z /= eps, the  medium is uniaxial anisotropic.     ! 
!                                                                                   !
! For anisotropic particles, the internal fields are approximated by the system of  !
! vector quasispherical wave functions. These vector functions can be regarded as a !
! generalization of the regular vector spherical wave functions for uniaxial        !
! anisotropic media, and can be expressed as integrals of plane waves over the      !
! spherical angles alpha and beta. The integration over the azimuth angle alpha can !
! be analytically performed and essentially, the vector quasispherical wave         !
! functions are expressed as simple integrals over the zenith angle beta.           !
!                                                                                   !
! The integrals over the particle surface are evaluated by means of the             !
! Gauss-Legendre quadrature method. For particles with a plane of symmetry          !
! perpendicular to the axis of rotation, i.e., mirror symmetric particles with the  !
! surface parametrization                                                           !
!                                                                                   !
!                      r(theta,phi) = r(Pi - theta,phi),                            !
!                                                                                   !
! the T matrix can be computed by integrating theta over the interval [0,Pi/2].     !
! For particles with azimuthal symmetry, i.e., particles with the surface           !       
! parametrization                                                                   !
!                                                                                   !   
!                      r(theta,phi) = r(theta,phi + 2*Pi / Nazimutsym),             !
!                                                                                   !                  
! where Nazimutsym >= 2, the T matrix can be computed by integrating phi over the   !
! interval [0,2*Pi/Nazimutsym]. The numerical stability and accuracy of T-matrix    !
! computations for an unsmooth surface can be enhanced by dividing the surface      !
! into piecewise smooth surfaces and applying separate quadrature formulas to each  !
! surface. Note that no mirror and azimuthal symmetries are considered for          !
! anisotropic particles.                                                            !
!                                                                                   !
! Particle geometries currently supported include: ellipsoids, quadratic prisms     !
! and regular polyhedral prisms (regular N-hedral finite prisms with azimuthal      !
! and mirror symmetries). A regular N-hedral finite prism refers to a shape with    !
! N + 2 facets, that is, to a prism with top and bottom facets with the shape of a  !
! regular polygon with N corners and with N equal-sized rectangular side facets.    !
! Certainly, quadratic prisms also possess azimuthal and mirror symmetries, but in  !
! this specific case, the T matrix is computed by disregarding the surface          !
! symmetries. Quadratic prisms have been included for anisotropic particles and     !
! testing purposes. As mentioned before, for anisotropic particles, no mirror and   !
! azimuthal symmetries are taken into account. Therefore, the regular N-hedral      !
! finite prisms with azimuthal and mirror symmetries is NOT a valid geometry for    !
! anisotropic particles. The following routines (from the file "GeomLib.f90")       !
! provide the required geometry parameters:                                         !
! - the routine "interpolation_list3D" computes the integration nodes and weights   !
!   for a nonaxisymmmetric surface,                                                 !
! - the routine "elem_geom3D" provides the geometry parameters (position vector,    !
!   polar and azimuthal angles and normal unit vector in spherical coordinates)     !
!   at each integration node, and                                                   !
! - the routine "SurfaceElemNint" computes some parameters of the discretized       !
!   surface: the mean, maximum and minimum areas of the surface elements and the    !
!   number of elements per unit surface (number density).                           !
! The user can easily modify these routines to generate particles with other        !
! geometries. Note that the list of parameters must be maintained and only          !
! geometries with an analytical description of the surface can be implemented.      !
! Alternatively, the option FileGeom  = .true., causes the code to read the         !
! particle geometry information from the file FileFEM. The FileFEM is read by the   !
! routine "read_FileFEM" from the file "InputOutput.f90". The user can customize    !
! the routine "read_FileFEM" as needed to conform to the manner in which the        !
! particle geometry is stored in the file FileFEM. However, as supplied, the        !
! routine "read_FileFEM" expects the file FileFEM to have the following structure:  !
! - one line providing the number of smooth surfaces Nfaces; the format for         !
!   reading Nfaces is i7, i.e.,                                                     !
!                 read (iFEM, "(i7)", iostat = ios)  Nfaces;                        ! 
! - a set of Nfaces-sequences of data specifying the geometry parameters on each    !
!   smooth surface; each sequence includes                                          !
!   - one line containing the number of surface elements (vertices) NVvr; the       !
!     format for reading NVvr is i7, i.e.,                                          !
!                 read (iFEM, "(i7)", iostat = ios) NVvr;                           !                                         
!   - NVvr lines containing the current index ielem, the Cartesian coordinates      !   
!     of the surface element center: x = r(1), y = r(2) and z = r(3), the Cartesian ! 
!     components of the unit normal vector at the surface element center:           !
!     nx = n(1), ny = n(2) and nz = n(3), and the area of the surface element;      !
!     the format for reading the data is:                                           !
!                 read (iFEM, "(i7,2x,7(e15.7,2x))", iostat = ios)                  !
!                       ielem, r(1), r(2), r(3), n(1), n(2), n(3), area.            ! 
! As provided, the file FileFEM is contained in the directory "GEOMFILES".          !
!                                                                                   !
! 2. Convergence Test                                                               !
! -------------------                                                               !
! Convergence tests precede the scattering characteristics calculation. The         !
! following parameters control the T-matrix computation:                            !
! - the numbers of integration points for computing integrals over the particle     !
!   surface Nint1 and Nint2,                                                        !
! - the maximum expansion order Nrank and                                           !
! - the maximum azimuthal order Mrank.                                              ! 
! Nint1 and Nint2 are the global numbers of integration points on the particle      !
! surface. They depend on the surface parametrization and have the following        ! 
! significance.                                                                     !
! a. For an ellipsoid with semi-axes a, b and c, the surface parametrization is     !
! (explicit form)                                                                   !
!                                                                                   !
!                 x = a * sin(u) * cos(v),                                          !
!                 y = b * sin(u) * sin(v),                                          !
!                 z = c * cos(u),                                                   !
!                                                                                   !
! where u belongs to [0,Pi] and v belongs to [0,2Pi]. Nint1 and Nint2 are the       !
! number of division points for the integration over u and v, respectively. If      ! 
! miror = .true., u is integrated over [0,Pi/2] and the number of integration       !
! points in the interval [0,Pi/2] is Nint1 / 2.                                     !
! b. The surface parameters describing regular polyhedral prism are the prism length!
! and the side of the regular polygon basis. In this specific case it is appropriate! 
! to describe each face with respect to a local (two-dimensional) Cartesian         !
! coordinate system. For regular polyhedral prisms, Nint1 is the number of          !
! integration points along the prism length (for the integration over the lateral   !
! rectangular faces), and  Nint2 is the number of integration points along the side !
! of the regular polygon basis (for the integration over the lateral rectangular    !
! faces, and over the top and bottom faces). Roughly speaking, the number of        !
! integration points on a lateral rectangular face is Nint1*Nint2, while the number !
! of integration points on the regular polygon basis is Nint2*Nint2.                !
! If miror = .true., the integration over a lateral rectangular face is performed   !
! over the half-face, and the number of integration points along the prism length   !
! is Nint1 / 2.  For a regular N-hedral finite prims with azimuthal symmetry, the   !
! top and bottom integration faces are triangles; the triangle basis is the side of !
! the regular polygon. The integration is performed by passing to the polar         !
! coordinates ro and phi, and the numbers of devision points for the integration over
! ro and phi are both equal to Nint2.                                               !
!                                                                                   !
! For convergence tests, the incident wave is assumed to be a plane wave traveling  !
! along the Z-axis of the global coordinate system and the scattering               !
! characteristics are computed in the azimuthal plane phi = 0°. The particle is     !
! placed in a general orientation (characterized by the Euler rotation angles       !
! alpha = beta = 45° and gamma = 0°), and interactive convergence tests over Nint,  !
! Nrank and Mrank are performed.                                                    !
!                                                                                   !
! For the integration test, the scattering problem is solved for the pairs          !
! (Nint1, Nint2) and (Nint1 + dNint1, Nint2 + dNint2), while Nrank and Mrank are    !
! keep constant. Note that no integration test will be performed if the particle    !
! geometry is generated from input file. For the convergence test over the expansion! 
! order, the scattering problem is solved for the pairs (Nrank, Mrank) and          !
! (Nrank - 1, Mrank), while for the azimuthal order test the cases (Nrank, Mrank)   !
! and (Nrank, Mrank - 1) are considered. The normalized differential scattering     !
! cross section will be checked at 20° increments for convergence within epsX       !
! (epsNint, epsNrank or epsMrank) tolerance. If the calculated results are converged! 
! within this tolerance at 80% of the scattering angles, then convergence is        !
! achieved, and the T matrix is stored for later use by other programs. The values  !
! of Nrank and Mrank are printed to the screen and to the T-matrix information file.!  
! These values together with the T matrix serve as INPUT PARAMETERS for other       !
! programs.                                                                         ! 
!                                                                                   !
! At each calculation, the extinction and scattering cross sections Cext and Cscat  !
! are also computed. Although the convergence of Cext and Cscat does not guarantee  !
! that the DSCS converges, the divergence of Cext and Cscat implies the divergence  !
! of the DSCS. The results of the convergence analysis are written to the file      !
! "/OUTPUTFILES/Output.dat". The above convergence tests (based on the analysis     !
! of the differential scattering cross section) have been proposed by Barber and    !
! Hill [P. W. Barber and S. C. Hill, Light scattering by particles: Computational   !
! Methods, World Scientific, Singapore, 1990].                                      !
!                                                                                   !
! 3. Estimates of Nint1, Nint2, Nrank and Mrank                                     !
! ----------------------------------------------                                    !
! The above convergence tests require estimates of Nint1, Nint2, Nrank and Mrank.   !
! These estimates must be supplied by the user, and for this purpose, Wiscombe's    !
! truncation limit criterion [W. J. Wiscombe, Improved Mie scattering algorithms,   !
! Applied Optics, 19, 1505-1509, 1980] can be used.                                 !
!                                                                                   !
! The truncation limit criterion proposed by Wiscombe provides the estimate         !
!                                                                                   !
!                NrankW = int(x + 4.05 * x**0.33 + 2),                              !
!                                                                                   !
! where x is the size parameter, x = k * Rcirc, and Rcirc is the radius of the      !
! smallest circumscribing sphere. For almost spherical particles, Mrank can be      !
! chosen as Nrank - 2,..,Nrank, while for less spherical particles Mrank can be     !
! smaller than Nrank - 2.                                                           !
!                                                                                   !
! The values of Nint1 and Nint2 depend on the the size parameter, the particle      !
! shape and the relative refractive index of the particle. For each input pair      !
! (Nint1,Nint2), the code computes some parameters of the discretized surface: the  !
! mean, maximum and minimum areas of the surface elements and the number of         !
! elements per unit surface (number density). Large values of the mean area (or     !
! small values of the number density) mean that the mesh (the discretization)       !
! is too rough. Large deviations of the maximum and minimum areas from the mean     !
! value show that the mesh is not uniform. In this case, the surface                !
! parametrization must be changed, i.e., the routines "interpolation_list3D" and    !
! "elem_geom3D" from the file "GeomLib.f90" have to be modified. The code also      !
! computes specific elements of the matrix Q31 for increasing Nint1- and            !
! Nint2-values, i.e., (Nint1 + 1,Nint2 + 1),...,(Nint1 + 4,Nint2 + 4). The          !
! computed quantities are:                                                          !
! - MAX {                                                                           ! 
!   A11(m,n,m1,n1) for m = Mrank, m1 = Mrank, n = Mrank, Nrank, n1 = Mrank, Nrank,  !
!   A22(m,n,m1,n1) for m = Mrank, m1 = Mrank, n = Mrank, Nrank, n1 = Mrank, Nrank } !
! - MIN {                                                                           !
!   A11(m,n,m1,n1) for m = Mrank, m1 = Mrank, n = Mrank, Nrank, n1 = Mrank, Nrank,  !
!   A22(m,n,m1,n1) for m = Mrank, m1 = Mrank, n = Mrank, Nrank, n1 = Mrank, Nrank } !  
! - MAX {                                                                           !
!   A12(m,n,m1,n1) for m = Mrank, m1 = Mrank, n = Mrank, Nrank, n1 = Mrank, Nrank,  ! 
!   A21(m,n,m1,n1) for m = Mrank, m1 = Mrank, n = Mrank, Nrank, n1 = Mrank, Nrank } !
! - MIN {                                                                           !
!   A12(m,n,m1,n1) for m = Mrank, m1 = Mrank, n = Mrank, Nrank, n1 = Mrank, Nrank,  !
!   A21(m,n,m1,n1) for m = Mrank, m1 = Mrank, n = Mrank, Nrank, n1 = Mrank, Nrank } !
! and                                                                               !
! - MAX {                                                                           !
!   A11(m,n,m1,n1) for m = 1, m1 = Mrank, n = 1, Nrank, n1 = Mrank, Nrank,          ! 
!   A22(m,n,m1,n1) for m = 1, m1 = Mrank, n = 1, Nrank, n1 = Mrank, Nrank }         !
! - MIN {                                                                           !
!   A11(m,n,m1,n1) for m = 1, m1 = Mrank, n = 1, Nrank, n1 = Mrank, Nrank,          !
!   A22(m,n,m1,n1) for m = 1, m1 = Mrank, n = 1, Nrank, n1 = Mrank, Nrank }         !
! - MAX {                                                                           ! 
!   A12(m,n,m1,n1) for m = 1, m1 = Mrank, n = 1, Nrank, n1 = Mrank, Nrank,          !
!   A21(m,n,m1,n1) for m = 1, m1 = Mrank, n = 1, Nrank, n1 = Mrank, Nrank }         !
! - MIN {                                                                           !
!   A12(m,n,m1,n1) for m = 1, m1 = Mrank, n = 1, Nrank, n1 = Mrank, Nrank,          ! 
!   A21(m,n,m1,n1) for m = 1, m1 = Mrank, n = 1, Nrank, n1 = Mrank, Nrank }         !
! where A11, A12, A21 and A22 are the four block matrices of Q31. The submatrices   !
! corresponding to m = Mrank and m1 = Mrank are diagonal block matrices,            !
! while the submatrices corresponding to m = 1 and m1 = Mrank are off-diagonal      !
! block matrices (of Aij, i = 1,2, j = 1,2). The variation of the computed          !
! quantities give an impression about the required numbers of integration points.   !
! Note that no convergence can be expected for small values of the matrix elements  !
! and the convergence over the number of integration points does not imply the      !
! convergence of the T-matrix calculation.                                          !      
!                                                                                   !
! 4. Strategy for Performing Convergence Tests                                      !
! ----------------------------------------------                                    !
! For nonaxisymmetric particles, a semi-convergent behaviour is usually attended:   !
! the errors decrease with increasing the maximum expansion order, attain a         !
! relative constant level and afterwards increase. The region of stability can be   !
! localized by using the following technique:                                       !
! 1. choose a value of Nrank close to the value predicted by Wiscombe's truncation  !
!    limit criterion (or smaller) and set Mrank = Nrank - 2 (or smaller);           !
! 2. find reliable Nint1- and Nit2-values such that the relative errors in          !
!    computing the matrix elements are sufficiently small;                          !
! 3. perform the convergence tests over Nrank and Mrank;                            ! 
! 4. if convergence is not achieved, set Nrank = Nrank + 1, maintain the relation   !
!    Mrank = Nrank - 2 and go to Step 2;                                            !
! 5. if convergence is achieved, perform several integration tests with the         !
!    initial Nint1- and Nint2-values found at step 2, until the DSCS converges.     !
!                                                                                   !
! For particles which are too extreme in size and/or aspect ratio, the errors of    !
! the extinction and scattering cross sections (instead of the differential         !
! scattering cross section) can be analyzed.                                        ! 
!                                                                                   !
! 5. Additional Comments                                                            !
! -----------------------                                                           !
! If the geometry of the particle is provided by the file FileFEM, only the         !
! integration test over Nrank and Mrank can be performed.                           !
!                                                                                   !
! The convergence tests can be switched off by setting the logical variable         !
! DoConvTest to false. In this case, the values of Nint1, Nint2 (if FileGeom = f),  !
! Nrank and Mrank must be specified in the input file.                              !
!                                                                                   !
! 6. Input Parameters                                                               !
! --------------------                                                              !
! The parameters specified in the input file "/INPUTFILES/InputNONAXSYM.dat" are    !
! listed below.                                                                     !
!                                                                                   !
! - wavelength (real) - wavelength of the incident light in vacuo.                  !
!                                                                                   !
! - ind_refMed (real) - refractive index of the ambient medium (nonabsorbing        !
!   dielectric medium).                                                             !
!                                                                                   !
! - ind_refRel (complex) - relative refractive index of the particle with respect   !
!   to the ambient medium. The imaginary part of the relative refractive index      !
!   must be zero for nonabsorbing particles and positive for absorbing particles.   !
!                                                                                   !  
! - perfectcond (logical) - if perfectcond = t, the particle is perfectly           !
!   conducting.                                                                     !
!                                                                                   !
! - anisotropic (logical) - if anisotropic = t, the particle is a uniaxial          !
!   anisotropic crystal.                                                            !  
!                                                                                   !
! - chiral (logical) - if chiral = t, the particle is optical active (chiral).      !
!                                                                                   !
!   The permissive values of the logical variables perfectcond and chiral are       !
!   summarized below.                                                               !
!                                                                                   !
!       particle              perfectcond            chiral       anisotropic       !
!      dielectric                  f                   f               f            !
!   perfectly conducting           t                   f               f            !
!      anisotropic                 f                   f               t            !
!        chiral                    f                   t               f            !
!                                                                                   !
! - kb (real) - parameter of chirality. This parameter is used for chiral           !
!   particles. The wave numbers for the left- and right-handed circularly           !
!   polarized waves are given by:                                                   !
!                kil = ki / (1.0 - kb)  and   kir = ki / (1.0 + kb)                 !
!   where ki is the wave number in the chiral medium.                               !
!                                                                                   !
! - FileGeom (logical) - if FileGeom = t, the particle geometry is supplied by the  !
!   input file FileFEM.                                                             ! 
!                                                                                   !
! - TypeGeom (integer) - parameter specifying the type of the particle geometry.    !
!                                                                                   !
! - FileFEM (character(80)) - name of the file containing the particle geometry.    !
!                                                                                   !
! - Nsurf (integer) - number of surface parameters.                                 !
!                                                                                   !
! - surf (real array: surf(1), surf(2),...,surf(Nsurf)) - surface parameters        !
!   specifying the shape of the particle. The dimension of the array surf is        !
!   NsurfPD. The integer parameter NsurfPD is specified in the routine              !
!   "Parameters.f90" and has the value NsurfPD = 10. If Nsurf > NsurfPD, the        !
!   execution is automatically terminated.                                          !
!                                                                                   !
! - Nparam (integer) - number of smooth surfaces forming the particle surface.      !
!                                                                                   !
!   The permissive values of the surface parameters (for the supported geometries)  !
!   are given below.                                                                !
!                                                                                   !
!   Particle      TypeGeom   Nsurf   Nparam                surf                     !
!   ellipsoid        1         3       1         surf(1) - length of the semi-      !
!                                                          axis along the x-axis    !         
!                                                surf(2) - length of the semi-      !
!                                                          axis along the y-axis    !
!                                                surf(3) - length of the semi-      !
!                                                          axis along the z-axis    !
!                                                                                   !  
!   quadratic        2         2       6         surf(1) - half-length of           !
!     prism                                                the prism                ! 
!                                                surf(2) - half-length of the       !
!                                                          square side              !
!                                                                                   !
!  regular N-hedral  3         2       2         surf(1) - half-length of           !
!      prism                       if miror = t;           the prism                !
!  (with azimuthal                     3         surf(2) - half-length of the       ! 
!   symmetry and                   if miror = f            side of the regular      !
!   OPTIONALLY with                                        basis                    !
!   mirror symmetry                                                                 !
!                                                                                   !
! NOTE: FOR ANISOTROPIC PARTICLES, A REGULAR N-HEDRAL PRISM IS NOT A VALID          !
! GEOMETRY.                                                                         !
!                                                                                   !
! - anorm (real) - characteristic length of the particle which is used to           !
!   normalize the differential scattering cross sections.                           !
!                                                                                   !
! - Rcirc (real) - characteristic length of the particle (usually the radius of     !
!   the smallest circumscribing sphere) which is used to compute an estimate of the !
!   maximum expansion order by using Wiscombe's truncation limit criterion (the     !
!   size parameter is x = k * Rcirc, where k is the wave number in the ambient      !
!   medium). Alternatively, Rcirc can be chosen as the equal-volume sphere radius   !
!   or the surface-equivalent-sphere radius. This parameter is used if the          !
!   interactive convergence tests are performed (DoConvTest = t).                   ! 
!                                                                                   !
! - miror (logical) - if miror = t, the particle is mirror symmetric (the plane of  !
!   symmetry or the plane of reflection is perpendicular to the axis of rotation).  !
!                                                                                   !
! NOTE: FOR CHIRAL AND ANISOTROPIC PARTICLES SET miror = f.                         !
!                                                                                   !
! - Nazimutsym (integer) - number of azimuthal symmetric sections. The T-matrix     !
!   calculation accounts for the azimuthal symmetry if Nazimutsym >= 2. If          !
!   Nazimutsym = 0, no azimuthal symmetry is considered.                            !
!                                                                                   !
! NOTE: FOR ANISOTROPIC PARTICLES SET Nazimutsym = 0.                               ! 
!                                                                                   !
!   For dielectric and perfectly conducting particles, the permissive values of     !
!   the variables miror and Nazimutsym are summarized below.                        !
!             TypeGeom           miror           Nazimutsym                         !  
!                1               t or f               0                             !
!                2                 f                  0                             !
!                3               t or f              >=3                            !
!   For chiral particles, the permissive values of the variables miror and          !
!   Nazimutsym are given below.                                                     !
!             TypeGeom           miror           Nazimutsym                         !  
!                1                 f                  0                             !
!                2                 f                  0                             !
!                3                 f                 >=3                            ! 
!                                                                                   !
! - DoConvTest (logical) - if DoConvTest = t, the interactive convergence tests     !
!   over Nint, Nrank and Mrank are invoked. An estimates of Nrank is given by       !
!   Wiscombe's truncation limit criterion. If DoConvTest = f, the values of Nint1,  !
!   Nint2, Nrank and Mrank must be supplied in the input file.                      !
!                                                                                   !
! - ExtThetaDom (logical) - if ExtThetaDom = t, the DSCS is computed for            !
!   scattering angles ranging from 0° to 180° in the azimuthal plane phiGS = 0°,    !
!   and from 180° to 0° in the azimuthal plane phiGS = 180°. The total number of    !
!   scattering angles is 10. If ExtThetaDom = f, the DSCS is computed for           !
!   scattering angles ranging from 0° to 180° in the azimuthal plane phiGS = 0°.    !
!                                                                                   !
! - ind_refRelZ (complex) - the second relative refractive index of the uniaxial    !
!   anisotropic particle. The imaginary part must be positive.                      !
!   If ind_refRelZ > ind_refRel, the crystal is positive anisotropic and if         !
!   ind_refRelZ < ind_refRel, the crystal is negative anisotropic.                  !    
!                                                                                   !
! - alphaPR, betaPR (real variables) - Euler angles specifying the orientation of   !
!   the principal coordinate system with respect to the particle coordinate system. !
!                                                                                   !
! - Nbeta (integer) - number of integration points for computing the vector         !
!   quasispherical wave functions.                                                  !
!                                                                                   !
! - Nrank (integer) - maximum expansion order. This parameter is used if the        !
!   convergence tests are not performed (DoConvTest = f).                           !
!                                                                                   !
! - Mrank (integer) - maximum azimuthal order. This parameter is used if the        !
!   convergence tests are not performed (DoConvTest = f).                           !
!                                                                                   !
! - Nint1, Nint2 (integer variables) - numbers of integration points in computing   !
!   integrals over the particle surface. These parameters are used if the           !
!   convergence tests are not performed (DoConvTest = f) and the particle geometry  !
!   is not supplied by the file FileFEM (FileGeom = f).                             !
!                                                                                   !
!   The following table explain the significance of the variables Nint1, Nint2,     !
!   Nrank and Mrank.                                                                !
!     DoConvTest    FileGeom    Nrank and Mrank   Nint1 and Nint2   TypeConvTest    !
!         t            f         console input     console input       1 or 2       !
!         t            t         console input      not required         2          !
!         f            f          file input         file input          0          ! 
!         f            t          file input        not required         0          !
!   The significance of the variable TypeConvTest is given below.                   !
!           TypeConvTest                    Significance                            !
!               0                        no convergence test                        !  
!               1                 convergence test over Nint1 and Nint2             ! 
!               2                 convergence test over Nrank and Mrank             !
!                                                                                   !
! - epsNint (real) - error tolerance for the integration test.                      !
!                                                                                   !
! - epsNrank (real) - error tolerance for the expansion order test.                 !
!                                                                                   !
! - epsMrank (real) - error tolerance for the azimuthal order test.                 !
!                                                                                   !
! - dNint1, dNint2 (integer variables) - numbers of division points for the         !
!   integration test. Note that the scattering problem is solved for the pairs      !
!   (Nint1,Nint2) and (Nint1 + dNint1,Nint2 + dNint2).                              ! 
!                                                                                   !
! - FileTmat (character(80)) - name of the file to which the T matrix is written.   !
!                                                                                   !
! - PrnProgress (logical) - if PrnProgress = t, the progress of calculation         !
!   is printed.                                                                     !
!                                                                                   !
! Note that all input parameters specifying lengths must be provided in the same    !
! units of lengths.                                                                 !
!                                                                                   !
! 7. Logical Scheme                                                                 !
! -------------------                                                               !  
! The organization of the code is as follows:                                       !
! 1. < read input data >                                                            !
! 2. < T-matrix calculation >                                                       !
!                                                                                   !
!    if ( do convergence test ) then                                                !
!                                                                                   !
!       if ( .not. read geometry from file) then                                    !        
!          < the code computes an estimate of Nrank by using                        !
!            Wiscombe's truncation criterion >                                      !
!          < the code prompts for the estimated values of Nrank and Mrank >         !
!          < the code prompts for the estimated values of Nint1 and Nint2,          !
!            computes the surface parameters for these input values and performs    ! 
!            a convergence test over some elements of the matrix Q31 >              !
!          < the code prompts for the type of convergence test:                     !
!            1 - over Nint, 2 - over Nrank and Mrank >                              !
!       else if ( read geometry from file) then                                     !
!          < the code computes an estimate of Nrank by using                        !
!            Wiscombe's truncation criterion >                                      !
!          < the code prompts for the estimated values of Nrank and Mrank >         !
!           type of convergence test = 2 (convergence test over Nrank and Mrank)    !
!       end if                                                                      !
!                                                                                   !
!    else if ( .not. do convergence test ) then                                     !
!                                                                                   !
!       if ( .not. read geometry from file) then                                    !        
!          < the input file provides the values of Nrank and Mrank >                !
!          < the input file provides the values of Nint1 and Nint2 >                !
!          < the code computes the surface parameters for Nint1 and Nint2           !
!            and performs a convergence test over some elements of the matrix Q31 > !
!          type of convergence test = 0 (no convergence test)                       !
!       else if ( read geometry from file) then                                     !
!          < the input file provides the values of Nrank and Mrank >                !
!          type of convergence test = 0 (no convergence test)                       !
!    end if                                                                         !
!    if ( do integration test, i.e., type of convergence test = 1 ) then            !
!       < the code computes the DSCS for (Nint1,Nint2) and                          !
!        (Nint1 + dNint1,Nint2 + dNint2) and write the results                      !
!         to the file "Output.dat" >                                                !
!       < the execution is terminated >                                             !
!    end if                                                                         !
!    if ( do expansion and azimuthal order tests,                                   !
!         i.e., type of convergence test = 2 ) then                                 !
!       < the code computes the DSCS for (Nrank,Mrank), (Nrank - 1,Mrank) and       ! 
!         (Nrank, Mrank - 1) and write the results to the file "Output.dat" >       !
!       < the T matrix is stored in the file FileTmat and the T-matrix information  !
!         file is created >                                                         !
!       < Mrank and Nrank are written to the screen and to the T-matrix             !
!         information file >                                                        !
!       < go to Step 3 >                                                            !
!    end if                                                                         !
!    if ( .not. do convergence test, i.e., type of convergence test = 0 ) then      !
!       < the T matrix is computed and stored in the file FileTmat >                !
!       < the T-matrix information file is created >                                ! 
!       < Mrank and Nrank are written to the screen and to the T-matrix             !
!         information file >                                                        !
!       < go to Step 3 >                                                            !
!    end if                                                                         !
! 3. < scattering characteristics calculation >                                     !    
!------------------------------------------------------------------------------------
  use parameters  
  implicit none 
  integer       :: TypeGeom, Nsurf, Nface, Nparam, Nazimutsym, TypeConvTest, Mrank, &
                   Nrank, Nbeta, Nint1, Nint2, dNint1, dNint2                     
  real(O)       :: k, ind_refMed, wavelength, anorm, surf(NsurfPD), snorm,          &
                   kb, epsNint, epsNrank, epsMrank, Rcirc, rp(3,NfacePD),           &
                   np(3,NfacePD), area(NfacePD), alphaPR, betaPR, gammaPR
  complex(O)    :: ind_refRel, ind_RefRelZ
  logical       :: FileGeom, miror, perfectcond, chiral, anisotropic, DoConvTest,   &
                   ExtThetaDom, PrnProgress
  character(80) :: FileTmat, FileFEM  
! -----------------------------------------------------------------------------------
!                              Read the input file                                  ! 
! -----------------------------------------------------------------------------------  
  call readinputNONAXSYM (wavelength, ind_refMed, ind_refRel, ind_RefRelZ,          &
       alphaPR, betaPR, perfectcond, anisotropic, chiral, kb, FileGeom,             &
       TypeGeom, FileFEM, Nsurf, surf, Nparam, anorm, Rcirc, miror, Nazimutsym,     &   
       DoConvTest, ExtThetaDom, Nbeta, Nint1, Nint2, Nrank, Mrank, epsNint,         &
       epsNrank, epsMrank, dNint1, dNint2, FileTmat, PrnProgress, k, gammaPR,       &
       snorm, rp, np, area, Nface, TypeConvTest )    
! -----------------------------------------------------------------------------------
!                                      Main                                         !
! -----------------------------------------------------------------------------------                            
  if (DoConvTest) then
    open (unit = iOutput, file = FileOutput, status = "replace")
    call printinputNONAXSYM (FileGeom, TypeGeom, FileFEM, Nsurf, Nparam, Nazimutsym,&
         dNint1, dNint2, ind_refMed, wavelength, anorm, Rcirc, surf, kb, epsNint,   &
         epsNrank, epsMrank,  ind_refRel, ind_refRelZ, alphaPR, betaPR, anisotropic,&
         miror, perfectcond, chiral) 
    if (TypeConvTest == 1) then  
      if (.not. anisotropic) then             
        call convergence_NintNONAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,    &
             Nsurf, surf, rp, np, area, Nface, Nparam, Mrank, Nrank, Nint1, Nint2,  &
             dNint1, dNint2, miror, Nazimutsym, perfectcond, chiral, kb, epsNint,   &
             ExtThetaDom, PrnProgress)      
      else
        call convergence_NintAnis (FileGeom, TypeGeom, k, ind_refRel, ind_refRelZ,  &
             alphaPR, betaPR, gammaPR, snorm, Nsurf, surf, rp, np, area, Nface,     &
             Nparam, Mrank, Nrank, Nbeta, Nint1, Nint2, dNint1, dNint2, epsNint,    &
             ExtThetaDom, PrnProgress) 
      end if
    else if (TypeConvTest == 2) then      
      if (.not. anisotropic) then
        call convergence_Nrank_MrankNONAXSYM (FileGeom, TypeGeom, k, ind_refRel,    &
             snorm, Nsurf, surf, rp, np, area, Nface, Nparam, Mrank, Nrank, Nint1,  &
             Nint2, miror, Nazimutsym, perfectcond, chiral, kb, epsNrank, epsMrank, &
             ExtThetaDom, FileTmat, PrnProgress)             
      else
        call convergence_Nrank_MrankAnis (FileGeom, TypeGeom, k, ind_refRel,        &
             ind_refRelZ, alphaPR, betaPR, gammaPR, snorm, Nsurf, surf, rp, np,     &
             area, Nface, Nparam, Mrank, Nrank, Nbeta, Nint1, Nint2, epsNrank,      &
             epsMrank, ExtThetaDom, FileTmat, PrnProgress)  
        end if
    end if
    close (unit = iOutput)           
  else       
    if (.not. anisotropic) then          
      call TMatrix_Nrank_MrankNONAXSYM (FileGeom, TypeGeom, k, ind_refRel, Nsurf,   &
           surf, rp, np, area, Nface, Nparam, Mrank, Nrank, Nint1, Nint2, miror,    &
           Nazimutsym, perfectcond, chiral, kb, FileTmat, PrnProgress)                                                     
    else
      call TMatrix_Nrank_MrankAnis (FileGeom, TypeGeom, k, ind_refRel, ind_refRelZ, &
           alphaPR, betaPR, gammaPR, Nsurf, surf, rp, np, area, Nface, Nparam,      &
           Mrank, Nrank, Nbeta, Nint1, Nint2, FileTmat, PrnProgress) 
    end if 
  end if    
end subroutine TNONAXSYM
!***********************************************************************************
subroutine readinputNONAXSYM (wavelength, ind_refMed, ind_refRel, ind_RefRelZ,      &
           alphaPR, betaPR, perfectcond, anisotropic, chiral, kb, FileGeom,         &
           TypeGeom, FileFEM, Nsurf, surf, Nparam, anorm, Rcirc, miror, Nazimutsym, &   
           DoConvTest, ExtThetaDom, Nbeta, Nint1, Nint2, Nrank, Mrank, epsNint,     &
           epsNrank, epsMrank, dNint1, dNint2, FileTmat, PrnProgress, k, gammaPR,   &
           snorm, rp, np, area, Nface, TypeConvTest )
  use parameters
  use derived_parameters
  implicit none 
  integer       :: TypeGeom, Nsurf, Nface, Nparam, Nazimutsym, TypeConvTest, Mrank, &
                   Nrank, NrankW, Nbeta, Nint1, Nint2, dNint1, dNint2, i, j, ios,   &
                   icall                     
  real(O)       :: k, ind_refMed, wavelength, anorm, surf(NsurfPD), xpart, snorm,   &
                   kb, epsNint, epsNrank, epsMrank, Rcirc, x, rp(3,NfacePD),        &
                   np(3,NfacePD), area(NfacePD), dp, alphaPR, betaPR, gammaPR, grd
  complex(O)    :: ind_refRel, ind_RefRelZ
  logical       :: FileGeom, miror, perfectcond, chiral, anisotropic, DoConvTest,   &
                   ExtThetaDom, PrnProgress, more, continuare, IntTest, XFindPar
  character(80) :: FileTmat, FileFEM, string    
! -----------------------------------------------------------------------------------
!                        Read the input file FileInputNONAXSYM                      ! 
! ----------------------------------------------------------------------------------- 
  call DrvParameters   
  open (unit = iInputNONAXSYM, file = FileInputNONAXSYM, status = "old",            &
        position = "rewind")   
  wavelength  = 0.1_O * 2._O * Pi
  ind_refMed  = 1._O
  ind_refRel  = (1.5_O,0._O)  
  string  = 'OptProp'
  if (XFindPar (iInputNONAXSYM, string)) then
    read (iInputNONAXSYM, *, iostat = ios) wavelength
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if
    read (iInputNONAXSYM, *, iostat = ios) ind_refMed
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refMed;')"
      stop
    end if    
    read (iInputNONAXSYM, *, iostat = ios) ind_refRel
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refRel;')"
      stop
    end if        
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if                          
  k   = 2._O * Pi * ind_refMed / wavelength
  grd = Pi / 180._O 
!
  perfectcond = .false.
  anisotropic = .false.  
  chiral      = .false.
  kb     = 0._O
  string = 'MatProp'    
  if (XFindPar (iInputNONAXSYM, string)) then
    read (iInputNONAXSYM, *, iostat = ios) perfectcond
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable perfectcond;')"
      stop
    end if
    read (iInputNONAXSYM, *, iostat = ios) anisotropic
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anisotropic;')"
      stop
    end if    
    read (iInputNONAXSYM, *, iostat = ios) chiral
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable chiral;')"
      stop
    end if    
    read (iInputNONAXSYM, *, iostat = ios) kb
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable kb;')"
      stop
    end if              
  else
    print "(/,2x,'Group name MatProp not found;')"
    stop  
  end if   
  call check_MatPropNONAXSYM (perfectcond, anisotropic, chiral, kb) 
  if (chiral) call check_chirality (kb) 
!
  FileGeom = .false.  
  FileFEM  = ' '
  TypeGeom = 1  
  Nsurf = 3
  do i = 1, NsurfPD
    surf(i) = 1._O
  end do
  Nparam = 1
  anorm  = 1._O
  Rcirc  = 1._O
  miror  = .true.
  Nazimutsym = 0
  string = 'GeomProp'    
  if (XFindPar (iInputNONAXSYM, string)) then
    read (iInputNONAXSYM, *, iostat = ios) FileGeom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileGeom;')"
      stop
    end if      
    read (iInputNONAXSYM, *, iostat = ios) FileFEM
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileFEM;')"
      stop
    end if
    read (iInputNONAXSYM, *, iostat = ios) TypeGeom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable TypeGeom;')"
      stop
    end if          
    read (iInputNONAXSYM, *, iostat = ios) Nsurf
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nsurf;')"
      stop
    end if
    if (Nsurf > NsurfPD) then
      print "(/,2x,'Input error: Nsurf exceeds NsurfPD;')"                                    
      stop
    end if
    do i = 1, Nsurf
      read (iInputNONAXSYM, *, iostat = ios) surf(i)
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable surf;')"
        stop
      end if
    end do 
    read (iInputNONAXSYM, *, iostat = ios) Nparam
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nparam;')"
      stop
    end if
    read (iInputNONAXSYM, *, iostat = ios) anorm
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anorm;')"
      stop
    end if
    read (iInputNONAXSYM, *, iostat = ios) Rcirc
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Rcirc;')"
      stop
    end if
    read (iInputNONAXSYM, *, iostat = ios) miror
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable miror;')"
      stop
    end if
    read (iInputNONAXSYM, *, iostat = ios) Nazimutsym
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nazimutsym;')"
      stop
    end if
  else
    print "(/,2x,'Group name GeomProp not found;')"
    stop  
  end if
  call check_inputNONAXSYM (FileGeom, FileFEM, miror, chiral, anisotropic,          &
       Nazimutsym)
  call check_geom3D (TypeGeom, Nsurf, Nparam, anisotropic, miror, Nazimutsym)    
  call check_anorm (anorm)
  xpart = k * anorm
  snorm = Pi * xpart * xpart 
  Nface = 1
  do i = 1, NfacePD
    do j = 1, 3
      rp(j,i) = 0._O
      np(j,i) = 0._O
    end do
    area(i) = 0._O
  end do 
  if (FileGeom) then    
    call read_FileFEM (FileFEM, Nface, rp, np, area) 
    Rcirc = 0._O
    do i = 1, Nface
      dp = sqrt(rp(1,i)**2 + rp(2,i)**2 + rp(3,i)**2)
      if (dp > Rcirc) Rcirc = dp
    end do            
  end if                    
!
  DoConvTest   = .true.
  ExtThetaDom  = .true.
  string = 'ConvTest'    
  if (XFindPar (iInputNONAXSYM, string)) then
    read (iInputNONAXSYM, *, iostat = ios) DoConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DoConvTest;')"
      stop
    end if
    read (iInputNONAXSYM, *, iostat = ios) ExtThetaDom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ExtThetaDom;')"
      stop
    end if                     
  else
    print "(/,2x,'Group name ConvTest not found;')"
    stop  
  end if     
!
  ind_refRelZ = (1.5_O,0._O)
  alphaPR = 0._O
  betaPR  = 0._O
  Nbeta   = 60
  if (anisotropic) then
    string = 'AnSVWF'    
    if (XFindPar (iInputNONAXSYM, string)) then
      read (iInputNONAXSYM, *, iostat = ios) ind_refRelZ
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable ind_refRelZ;')"
        stop
      end if    
      read (iInputNONAXSYM, *, iostat = ios) alphaPR
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable alphaPR;')"
        stop
      end if    
      read (iInputNONAXSYM, *, iostat = ios) betaPR
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable betaPR;')"
        stop
      end if            
      read (iInputNONAXSYM, *, iostat = ios) Nbeta
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nbeta;')"
        stop
      end if
    else
      print "(/,2x,'Group name AnSVWF not found;')"
      stop  
    end if      
  end if
  if (anisotropic) call check_ind_ref3 (ind_refRel, ind_refRelZ)  
  alphaPR = alphaPR * grd
  betaPR  = betaPR  * grd
  gammaPR = 0._O  
!  
  if (DoConvTest) then
    if (.not. FileGeom) then
      print "(/,2x,'Convergence Test for a Nonaxisymmetric Particle')"
      print "(  2x,'-----------------------------------------------')"      
    else
      print "(/,2x, a)",                                                            &
     'Convergence Test for a Nonaxisymmetric Particle over Nrank and Mrank'
      print "(  2x, a)",                                                            &
     '--------------------------------------------------------------------'             
    end if      
  else
    print "(/,2x,'T-Matrix Computation for a Nonaxisymmetric Particle')"
    print "(  2x,'---------------------------------------------------')"
  end if
!  
  x = k * Rcirc
  NrankW = int(x + 4.05_O * x**0.33_O + 2._O)
  Nrank  = 16
  Mrank  = 14
  if (.not. DoConvTest) then
    string = 'NrankMrank'    
    if (XFindPar (iInputNONAXSYM, string)) then
      read (iInputNONAXSYM, *, iostat = ios) Nrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nrank;')"
        stop
      end if
      read (iInputNONAXSYM, *, iostat = ios) Mrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Mrank;')"
        stop
      end if
    else
      print "(/,2x,'Group name NrankMrank not found;')"
      stop  
    end if
    print "(/,2x,'Nrank and Mrank input values:')"
    print "(  2x,'the input values of Nrank and Mrank are ', i3,' and ', i3, ',')",  &
              Nrank, Mrank
    print "(  2x, a, i3, a)",                                                        &
   'while the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';' 
  else  
    print "(/,2x,'Nrank estimate:')"  
    print "(  2x, a, i3, a)" ,                                                       &
   'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';' 
    print "(/,2x,'- enter the estimated values of Nrank and Mrank,')"
    print "(  2x, a)",                                                               &
   '  where for almost spherical particles Mrank = Nrank - 2,...,Nrank,'
    print "(  2x, a)",                                                               &
   '  while for less spherical particles Mrank can be smaller than Nrank - 2;'
    call read_integer2 (Nrank, Mrank)                                                               
  end if 
  call check_MrankNrank (Mrank, Nrank)  
! 
  Nint1 = 12
  Nint2 = 12  
  if (.not. FileGeom) then
    if (DoConvTest) then
      more  = .true.
      icall = 0
      do while (more)
        icall = icall + 1     
        print "(/,2x,'- enter the estimated values of Nint1 and Nint2;')"
        call read_integer2 (Nint1, Nint2)
        if (Nint1 < 5) Nint1 = 5
        if (Nint2 < 5) Nint2 = 5
        if (.not. anisotropic) then          
          call SurfaceElemNint (k, TypeGeom, Nparam, Nsurf, surf, miror,            &
               Nazimutsym, Nint1, Nint2)
          if (icall == 1) then
            print "(/,2x, a)",                                                      &
           '- enter true to perform an integration test over specific matrix '	                             
            print "(  2x,'elements and false otherwise;')"
            call read_logical (IntTest)
          end if           
          if (IntTest) then            
            call ConvergenceMatrixElem (3, 1, TypeGeom, Nsurf, Nparam, Mrank,       &
                 Mrank, Nrank, 5, Nint1, Nint2, Nazimutsym, k, surf, kb,            &
                 ind_refRel, miror, perfectcond, chiral)
            call ConvergenceMatrixElem (3, 1, TypeGeom, Nsurf, Nparam, 1, Mrank,    &
                 Nrank, 5, Nint1, Nint2, Nazimutsym, k, surf, kb, ind_refRel,       &
                 miror, perfectcond, chiral)
          end if
        else
          call SurfaceElemNint (k, TypeGeom, Nparam, Nsurf, surf, .false., 0,       &
          Nint1, Nint2)
          if (icall == 1) then
            print "(/,2x, a)",                                                      &
           '- enter true to perform an integration test over specific matrix '	                      
            print "(  2x,'elements and false otherwise;')"
            call read_logical (IntTest)
          end if           
          if (IntTest) then                  
            call ConvergenceMatrixElemAnis (TypeGeom, 3, 1, k, ind_refRel,          &
                 ind_refRelZ, alphaPR, betaPR, gammaPR, Nsurf, surf, Mrank, Mrank,  &
                 Nrank, 5, Nint1, Nint2, Nbeta, Nparam)
            call ConvergenceMatrixElemAnis (TypeGeom, 3, 1, k, ind_refRel,          &
                 ind_refRelZ, alphaPR, betaPR, gammaPR, Nsurf, surf, 1, Mrank,      &
                 Nrank, 5, Nint1, Nint2, Nbeta, Nparam)     
          end if
        end if 
        print "(2x,'- enter true for a new input of number of integration points')"
        print "(2x,'or false to continue;')"        
        call read_logical (continuare)
        if (.not. continuare) more = .false.
      end do
    else
      string = 'Nint'    
      if (XFindPar (iInputNONAXSYM, string)) then
        read (iInputNONAXSYM, *, iostat = ios) Nint1
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable Nint1;')"
          stop
        end if
        read (iInputNONAXSYM, *, iostat = ios) Nint2
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable Nint2;')"
          stop
        end if
      else
        print "(/,2x,'Group name Nint not found;')"
        stop  
      end if
      if (Nint1 < 5) Nint1 = 5
      if (Nint2 < 5) Nint2 = 5
      print "(/,2x,'Nint1 and Nint2 input values:')"
      print "(  2x,'the input values of Nint1 and Nint2 are ', i4,' and',i4,';')",  &
                Nint1, Nint2
      if (.not. anisotropic) then
        call SurfaceElemNint (k, TypeGeom, Nparam, Nsurf, surf, miror, Nazimutsym,  &
             Nint1, Nint2)        
        print "(/,2x,'- enter true to perform an integration test over')"                  
        print "(  2x,'specific matrix elements and false otherwise;')"
        call read_logical (IntTest)                        
        if (IntTest) then       
          call ConvergenceMatrixElem (3, 1, TypeGeom, Nsurf, Nparam, Mrank, Mrank,  &
               Nrank, 5, Nint1, Nint2, Nazimutsym, k, surf, kb, ind_refRel, miror,  &
               perfectcond, chiral )
          call ConvergenceMatrixElem (3, 1, TypeGeom, Nsurf, Nparam, 1, Mrank,      &
               Nrank, 5, Nint1, Nint2, Nazimutsym, k, surf, kb, ind_refRel, miror,  &
               perfectcond, chiral )                                                         
        end if
      else
        call SurfaceElemNint (k, TypeGeom, Nparam, Nsurf, surf, .false., 0,         &
             Nint1, Nint2)
        print "(/,2x,'- enter true to perform an integration test over')"                  
        print "(  2x,'specific matrix elements and false otherwise;')"
        call read_logical (IntTest)                        
        if (IntTest) then                          
          call ConvergenceMatrixElemAnis (TypeGeom, 3, 1, k, ind_refRel,            &
               ind_refRelZ, alphaPR, betaPR, gammaPR, Nsurf, surf, Mrank, Mrank,    &
               Nrank, 5, Nint1, Nint2, Nbeta, Nparam)
          call ConvergenceMatrixElemAnis (TypeGeom, 3, 1, k, ind_refRel,            &
               ind_refRelZ, alphaPR, betaPR, gammaPR, Nsurf, surf, 1, Mrank,        &
               Nrank, 5, Nint1, Nint2, Nbeta, Nparam)       
        end if
      end if
    end if
  end if
!  
  if (DoConvTest) then   
    if (.not. FileGeom) then   
      print "(/,2x, a)",                                                            &
     '- enter the type of convergence test: 1 - Nint, 2 - Nrank and Mrank;'
      call read_integerbound (TypeConvTest, 1, 2)              
    else    
      TypeConvTest = 2 
    end if  
  else
    TypeConvTest = 0
  end if
!         
  epsNint  = 5.e-2_O
  epsNrank = 5.e-2_O
  epsMrank = 5.e-2_O
  dNint1 = 4
  dNint2 = 4
  string   = 'Errors'
  if (XFindPar (iInputNONAXSYM, string)) then
    read (iInputNONAXSYM, *, iostat = ios) epsNint
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNint;')"
      stop
    end if
    read (iInputNONAXSYM, *, iostat = ios) epsNrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNrank;')"
      stop
    end if
    read (iInputNONAXSYM, *, iostat = ios) epsMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsMrank;')"
      stop
    end if 
    read (iInputNONAXSYM, *, iostat = ios) dNint1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable dNint1;')"
      stop
    end if
    read (iInputNONAXSYM, *, iostat = ios) dNint2
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable dNint2;')"
      stop
    end if         
  else
    print "(/,2x,'Group name Errors not found;')"
    stop  
  end if  
!
  FileTmat = '../TMATFILES/T.dat'
  string   = 'Tmat' 
  if (XFindPar (iInputNONAXSYM, string)) then
    read (iInputNONAXSYM, *, iostat = ios) FileTmat
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileTmat;')"
      stop
    end if             
  else
    print "(/,2x,'Group name Tmat not found;')"
    stop  
  end if   
!
  PrnProgress = .true.
  string   = 'PrintProgress' 
  if (XFindPar (iInputNONAXSYM, string)) then
    read (iInputNONAXSYM, *, iostat = ios) PrnProgress
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if             
  else
    print "(/,2x,'Group name PrintProgress not found;')"
    stop  
  end if     
  close (unit = iInputNONAXSYM)  
end subroutine readinputNONAXSYM                            
!***********************************************************************************
subroutine printinputNONAXSYM (FileGeom, TypeGeom, FileFEM, Nsurf, Nparam,          &
           Nazimutsym, dNint1, dNint2, ind_refMed, wavelength, anorm, Rcirc, surf,  &
           kb, epsNint, epsNrank, epsMrank, ind_refRel, ind_refRelZ, alphaPR,       &
           betaPR, anisotropic, miror, perfectcond, chiral)
  use parameters
  implicit none
  integer        :: TypeGeom, Nsurf, Nparam, Nazimutsym, dNint1, dNint2, i, LenString                     
  real(O)        :: ind_refMed, wavelength, anorm, surf(Nsurf), kb, epsNint,        &
                    epsNrank, epsMrank, Rcirc, alphaPR, betaPR
  complex(O)     :: ind_refRel, ind_refRelZ
  character(80)  :: FileFEM, FileFEMWrite
  logical        :: FileGeom, miror, perfectcond, chiral, anisotropic
!
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x,'wavelength of the free space, wavelength = ',1pe13.4,';')")  &
         wavelength
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'refractive index of the ambient medium,ind_refMed = ', ind_refMed, ';'
  if (.not. anisotropic) then
    write (iOutput,"(2x, a, 1pe10.3, ',', 1pe10.3, a)")                             &
   'relative refractive index of the particle, ind_refRel = (', ind_refRel, ');'
  else
    write (iOutput,"(2x,'relative refractive indices of the uniaxial particle:')")
    write (iOutput,"(2x, a, 1pe10.3, ',', 1pe10.3, a, 1pe10.3, ',', 1pe10.3, a)")   &
   'ind_refRel = (', ind_refRel, '), ind_refRelZ = (', ind_refRelZ, ');' 
  end if
  write (iOutput,*)
  if (FileGeom) then
    FileFEMWrite = FileFEM(14:LenString(FileFEM))
    write (iOutput,"(2x, a, a30)")                                                  &
   'name of the file containing the particle geometry, FileFEM = ',     FileFEMWrite
  else
    write (iOutput,"(2x,'index of the particle geometry, TypeGeom = ',i2,';')")     &
           TypeGeom
    if (TypeGeom == 1) then
      write (iOutput,"(2x,'ellipsoid;')")       
    else if (TypeGeom == 2) then
      write (iOutput,"(2x,'quadratic prism;')") 
    else if (TypeGeom == 3) then
      write (iOutput,"(2x,'regular N-hedral prism;')")
    end if
    write (iOutput,"(2x,'number of surface parameters, Nsurf = ',i2,';')") Nsurf
    write (iOutput,"(2x,'surface parameters:')")
    do i = 1, Nsurf
      write (iOutput,"(2x,'surf(',i2,') = ',1pe10.3,',')") i, surf(i)
    end do       
    if (TypeGeom == 1) then
      write (iOutput,"(2x,'where surf(1) is the semi-axis along the x-axis,')")
      write (iOutput,"(2x,'surf(2) is the semi-axis along the y-axis and')")
      write (iOutput,"(2x,'surf(3) is the semi-axis along the z-axis;')")
    else if (TypeGeom == 2 .or. TypeGeom == 3) then
      write (iOutput,"(2x,'where surf(1) is the half-length of the prism,')")
      write (iOutput,"(2x,'and   surf(2) is the half-length of the basis side;')")
    end if 
    write (iOutput,"(2x,'number of integration surfaces, Nparam = ',i2,';')")       &
           Nparam
  end if
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'characteristic length of the particle, anorm = ', anorm, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'radius of the circumscribing sphere, Rcirc = ', Rcirc, ';'
  if (anisotropic) then
    write (iOutput,"(2x, a)")                                                       &
   'Euler angles specifying the orientation of the principal coordinate system:'
    write (iOutput,"(2x, a, 1pe10.3, a, 1pe10.3, a, 1pe10.3, a)")                   &
   'alpha = ', alphaPR * 180._O / Pi, ', beta = ', betaPR * 180._O / Pi,            &
   ', gamma = ', 0._O, ';'        
  end if
  if (miror) write (iOutput,"(2x,'mirror symmetric particle;')")
  write (iOutput,"(2x, a, i2, a)")                                                  &
 'number of azimuthal symmetric sections, Nazimutsym = ', Nazimutsym, ';'
  if (Nazimutsym >=2) then
    write (iOutput,"(2x,'azimuthal symmetry is taken into account;')")
  else
    write (iOutput,"(2x,'azimuthal symmetry is disregarded;')")
  end if
  write (iOutput,*)
  if (perfectcond) then
    write (iOutput,"(2x,'perfectly conducting particle;')")
  else if (chiral) then
    write (iOutput,"(2x,'chiral particle;')")
    write (iOutput,"(2x,'characteristic of chirality, kb = ',1pe10.3,';')") kb  
  else if (anisotropic) then
    write (iOutput,"(2x,'uniaxial anisotropic particle;')")
  else 
    write (iOutput,"(2x,'dielectric particle;')")
  end if 
  write (iOutput,*)    
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum expansion order tolerance, epsNrank = ', epsNrank, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum azimuthal order tolerance, epsMrank = ', epsMrank, ';'
  if (.not. FileGeom) then               
    write (iOutput,"(2x,'integration tolerance, epsNint = ',1pe10.3,';')") epsNint                         
    write (iOutput,"(2x,'integration steps, dNint1 = ',i4,', dNint2 = ',i4,'.')")   &
           dNint1, dNint2 
  end if
  write (iOutput,"(/)")                       
end subroutine printinputNONAXSYM
!***********************************************************************************
subroutine convergence_NintNONAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm, Nsurf,  &
           surf, rp, np, area, Nface, Nparam, Mrank, Nrank, Nint1, Nint2, dNint1,   &
           dNint2, miror, Nazimutsym, perfectcond, chiral, kb, epsNint, ExtThetaDom,&
           PrnProgress)
  use parameters
  implicit none
  integer    :: TypeGeom, Nsurf, Nface, Nparam, Mrank, Nrank, Nint1, Nint2, dNint1, &
                dNint2, Nazimutsym                  
  real(O)    :: k, snorm, surf(Nsurf), rp(3,NfacePD), np(3,NfacePD), area(NfacePD), &
                kb, epsNint
  complex(O) :: ind_ref
  logical    :: FileGeom, miror, perfectcond, chiral, ExtThetaDom, PrnProgress
!      
  integer    :: Nmax, Nteta, i, NthetaConv, iNint, NintAL   
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG1(:,:), paramG2(:,:), weightsG(:,:), h(:), v(:),  &
                            oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), c(:), b(:,:), c1(:)   
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Nmax   = Nrank + Mrank * (2 * Nrank - Mrank + 1) 
  call write_TypeConvHead (1)
  allocate (a(2*Nmax,2*Nmax), c(2*Nmax), b(2*Nmax,2*Nmax), c1(2*Nmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do
  if (PrnProgress) call write_progress (.true., 1, 7)
  do iNint = 1, 2
    NintAL = max(Nint1,Nint2)                            
    allocate (paramG1(Nparam,NintAL*NintAL), paramG2(Nparam,NintAL*NintAL),         &
              weightsG(Nparam,NintAL*NintAL))
    allocate (Nintparam(Nparam))
    call interpolation_list3D (TypeGeom, Nsurf, surf, Nint1, Nint2, NintAL, Nparam, &
         Nintparam, paramG1, paramG2, weightsG, miror, Nazimutsym) 
    call matrix_Q (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, area, &
         Nface, Mrank, Nrank, Nmax, NintAL, Nparam, Nintparam, paramG1, paramG2,    &
         weightsG, miror, Nazimutsym, perfectcond, chiral, kb, a, Nmax, Nmax)  
    if (PrnProgress) call write_progress (.false., 2+3*(iNint-1), 7)
    call matrix_Q (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, area, &
         Nface, Mrank, Nrank, Nmax, NintAL, Nparam, Nintparam, paramG1, paramG2,    &
         weightsG, miror, Nazimutsym, perfectcond, chiral, kb, b, Nmax, Nmax)
    if (PrnProgress) call write_progress (.false., 3+3*(iNint-1), 7)
    call LU_SYSTEM (a, 2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, 2*Nmax)
    if (PrnProgress) call write_progress (.false., 4+3*(iNint-1), 7)
    call PWcoefficients_ab (tetaGI, phiGI, alfa, beta, gama, alfap, Mrank, Nrank,   &
         Nmax, c)    
    call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, c, c1)
    call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfa, beta, gama, k, snorm,    &
         ExtThetaDom,.true., h, v)
    call CQscat (c1, Mrank, Nrank, Nmax, k, snorm, Cscat, Qscat)
    call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfa, beta, gama,            &
         alfap, k, snorm, Cext, Qext)     
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsNint, NthetaConv)  
    call write_4ConvParam (Nint1, Nint2, Nrank, Mrank)
    call write_DSCS (Nteta, ExtThetaDom, h, v)
    call write_Effic (Qscat, Qext)
    Nint1 = Nint1 + dNint1
    Nint2 = Nint2 + dNint2
    deallocate (paramG1, paramG2, weightsG, Nintparam)
  end do
  call write_NintConvRes (NthetaConv, Nteta, epsNint)
  deallocate (a, b, c, c1, h, v, oldh, oldv)    
end subroutine convergence_NintNONAXSYM 
!***********************************************************************************
subroutine convergence_Nrank_MrankNONAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm,  &
           Nsurf, surf, rp, np, area, Nface, Nparam, Mrank, Nrank, Nint1, Nint2,    &
           miror, Nazimutsym, perfectcond, chiral, kb, epsNrank, epsMrank,          &
           ExtThetaDom, FileTmat, PrnProgress)
  use parameters
  implicit none
  integer       :: TypeGeom, Nsurf, Nface, Nparam, Mrank, Nrank, Nint1, Nint2,      &
                   Nazimutsym                   
  real(O)       :: k, snorm, surf(Nsurf), rp(3,NfacePD), np(3,NfacePD),             &
                   area(NfacePD), kb, epsNrank, epsMrank
  complex(O)    :: ind_ref
  logical       :: FileGeom, miror, perfectcond, chiral, ExtThetaDom, PrnProgress 
  character(80) :: FileTmat
!      
  integer       :: Nmax, Nteta, i, j, NthetaConvN, NthetaConvM, NintAL
  real(O)       :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,     &
                   Cext, Qext
  integer,allocatable    :: Nintparam(:) 
  real(O),allocatable    :: paramG1(:,:), paramG2(:,:), weightsG(:,:), h(:), v(:),  &
                            oldh(:), oldv(:), oldh0(:), oldv0(:)
  complex(O),allocatable :: a(:,:), c(:), b(:,:), c1(:), a1(:,:), b1(:,:)   
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Nmax   = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  NintAL = max(Nint1,Nint2) 
  call write_TypeConvHead (4)  
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call write_HeadFileTmat (Nmax, Nmax)     
  allocate (a1(2*Nmax,2*Nmax), b1(2*Nmax,2*Nmax))  
  allocate (a(2*Nmax,2*Nmax), c(2*Nmax), b(2*Nmax,2*Nmax), c1(2*Nmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta), oldh0(Nteta),             &
            oldv0(Nteta))                        
  allocate (paramG1(Nparam,NintAL*NintAL), paramG2(Nparam,NintAL*NintAL),           &
            weightsG(Nparam,NintAL*NintAL))
  allocate (Nintparam(Nparam))
  if (.not. FileGeom) then    
    call interpolation_list3D (TypeGeom, Nsurf, surf, Nint1, Nint2, NintAL, Nparam, &
         Nintparam, paramG1, paramG2, weightsG, miror, Nazimutsym)                            
  else
    do i = 1, Nparam
      do j = 1, NintAL*NintAL
        paramG1(i,j)  = 0._O
        paramG2(i,j)  = 0._O
        weightsG(i,j) = 0._O
      end do
      Nintparam(i) = 1
    end do   
  end if
  if (PrnProgress) call write_progress (.true., 1, 4)
  call matrix_Q (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, area,   &
       Nface, Mrank, Nrank, Nmax, NintAL, Nparam, Nintparam, paramG1, paramG2,      &
       weightsG, miror, Nazimutsym, perfectcond, chiral, kb, a, Nmax, Nmax)
  if (PrnProgress) call write_progress (.false., 2, 4)    
  call copy_matrix (2*Nmax, 2*Nmax, a, 2*Nmax, 2*Nmax, a1, 2*Nmax, 2*Nmax)  
  call matrix_Q (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, area,   &
       Nface, Mrank, Nrank, Nmax, NintAL, Nparam, Nintparam, paramG1, paramG2,      &
       weightsG, miror, Nazimutsym, perfectcond, chiral, kb, b, Nmax, Nmax)
  if (PrnProgress) call write_progress (.false., 3, 4)    
  call copy_matrix (2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, b1, 2*Nmax, 2*Nmax) 
  call LU_SYSTEM (a, 2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 4, 4)
  call write_FileTmat (Nmax, Nmax, b)
  call PWcoefficients_ab (tetaGI, phiGI, alfa, beta, gama, alfap, Mrank, Nrank,     &
       Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfa, beta, gama, k, snorm,      &
       ExtThetaDom,.true., h, v)
  call CQscat (c1, Mrank, Nrank, Nmax, k, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfa, beta, gama,              &
       alfap, k, snorm, Cext, Qext)  
  if (.not. FileGeom) then             
    call write_4ConvParam (Nint1, Nint2, Nrank, Mrank)                  
  else
    call write_2ConvParam (Nrank, Mrank)
  end if
  call write_DSCS (Nteta, ExtThetaDom, h, v)
  call write_Effic (Qscat, Qext)
  deallocate (paramG1, paramG2, weightsG, Nintparam)
  do i = 1, Nteta
    oldh(i)  = h(i)
    oldv(i)  = v(i)
    oldh0(i) = h(i)
    oldv0(i) = v(i)
  end do
  close (unit = iTmat)  
! --- (Nrank - 1) configuration ---
  if (PrnProgress) call write_progress_low  
  call copy_matrix (2*Nmax, 2*Nmax, a1, 2*Nmax, 2*Nmax, a, 2*Nmax,2*Nmax)    
  call matrix_Nrank_1_left (Mrank, Nrank, Nmax, a, Nmax, Nmax)  
  call copy_matrix (2*Nmax, 2*Nmax, b1, 2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax) 
  call matrix_Nrank_1_right (Mrank, Nrank, Nmax, b, Nmax, Nmax)
  call LU_SYSTEM (a,2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, 2*Nmax)          
  call PWcoefficients_ab (tetaGI, phiGI, alfa, beta, gama, alfap, Mrank, Nrank,     &
       Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfa, beta, gama, k, snorm,      &
       ExtThetaDom,.true., h, v)
  call CQscat (c1, Mrank, Nrank, Nmax, k, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfa, beta, gama,              &
       alfap, k, snorm, Cext, Qext)    
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConvN)
  if (.not. FileGeom) then    
    call write_4ConvParam (Nint1, Nint2, Nrank - 1, Mrank)
  else    
    call write_2ConvParam (Nrank - 1, Mrank)
  end if
  call write_DSCS (Nteta, ExtThetaDom, h, v)
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConvN, Nteta, epsNrank)
! --- (Mrank - 1) configuration ---  
  call copy_matrix (2*Nmax, 2*Nmax, a1, 2*Nmax, 2*Nmax, a, 2*Nmax, 2*Nmax)   
  call matrix_Mrank_1_left (Mrank, Nrank, Nmax, a, Nmax, Nmax)  
  call copy_matrix (2*Nmax, 2*Nmax, b1, 2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax) 
  call matrix_Mrank_1_right (Mrank, Nrank, Nmax, b, Nmax, Nmax)
  call LU_SYSTEM (a, 2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, 2*Nmax)         
  call PWcoefficients_ab (tetaGI, phiGI, alfa, beta, gama, alfap, Mrank, Nrank,     &
       Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfa, beta, gama, k, snorm,      &
       ExtThetaDom,.true., h, v)
  call CQscat (c1, Mrank, Nrank, Nmax, k, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfa, beta, gama,              &
       alfap, k, snorm, Cext, Qext)    
  call delta_DSCS (Nteta, h, v, oldh0, oldv0, epsMrank, NthetaConvM)
  if (.not. FileGeom) then
    call write_4ConvParam (Nint1, Nint2, Nrank, Mrank - 1)
  else
    call write_2ConvParam (Nrank, Mrank - 1)
  end if
  call write_DSCS (Nteta, ExtThetaDom, h, v) 
  call write_Effic (Qscat, Qext)
  call write_MrankConvRes (NthetaConvM, epsMrank)
  if (NthetaConvN >= int(0.8*Nteta) .and. NthetaConvM >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criteria for Nrank and Mrank are satisfied;')"                                
  else
    print "(/,2x,'Convergence criteria for Nrank and Mrank are not satisfied;')"
  end if
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .false., .false., chiral)
  call ScatCharact (k, FileTmat, Mrank, Nrank, .false., .false., chiral)
  print "(/,2x,'T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank    
  deallocate (a1, b1)  
  deallocate (a, b, c, c1, h, v, oldh, oldv, oldh0, oldv0)      
end subroutine convergence_Nrank_MrankNONAXSYM 
!***********************************************************************************
subroutine TMatrix_Nrank_MrankNONAXSYM (FileGeom, TypeGeom, k, ind_ref, Nsurf, surf,&
           rp, np, area, Nface, Nparam, Mrank, Nrank, Nint1, Nint2, miror,          &
           Nazimutsym, perfectcond, chiral, kb, FileTmat, PrnProgress)
  use parameters
  implicit none
  integer       :: TypeGeom, Nsurf, Nface, Nparam, Mrank, Nrank, Nint1, Nint2,      &
                   Nazimutsym                   
  real(O)       :: k, surf(Nsurf), rp(3,NfacePD), np(3,NfacePD), area(NfacePD), kb
  complex(O)    :: ind_ref
  logical       :: FileGeom, miror, perfectcond, chiral, PrnProgress 
  character(80) :: FileTmat
!      
  integer       :: Nmax, i, j, NintAL
  integer,allocatable    :: Nintparam(:) 
  real(O),allocatable    :: paramG1(:,:), paramG2(:,:), weightsG(:,:)
  complex(O),allocatable :: a(:,:), b(:,:)
!  
  Nmax   = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  NintAL = max(Nint1,Nint2)  
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call write_HeadFileTmat (Nmax, Nmax)   
  allocate (a(2*Nmax,2*Nmax), b(2*Nmax,2*Nmax))
  allocate (paramG1(Nparam,NintAL*NintAL), paramG2(Nparam,NintAL*NintAL),           &
            weightsG(Nparam,NintAL*NintAL))
  allocate (Nintparam(Nparam))
  if (.not. FileGeom) then    
    call interpolation_list3D (TypeGeom, Nsurf, surf, Nint1, Nint2, NintAL, Nparam, &
         Nintparam, paramG1, paramG2, weightsG, miror, Nazimutsym)                            
  else
    do i = 1, Nparam
      do j = 1, NintAL*NintAL
        paramG1(i,j)  = 0._O
        paramG2(i,j)  = 0._O
        weightsG(i,j) = 0._O
      end do
      Nintparam(i) = 1
    end do   
  end if
  if (PrnProgress) call write_progress (.true., 1, 4)
  call matrix_Q (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, area,   &
       Nface, Mrank, Nrank, Nmax, NintAL, Nparam, Nintparam, paramG1, paramG2,      &
       weightsG, miror, Nazimutsym, perfectcond, chiral, kb, a, Nmax, Nmax)
  if (PrnProgress) call write_progress (.false., 2, 4)  
  call matrix_Q (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, area,   &
       Nface, Mrank, Nrank, Nmax, NintAL, Nparam, Nintparam, paramG1, paramG2,      &
       weightsG, miror, Nazimutsym, perfectcond, chiral, kb, b, Nmax, Nmax)
  if (PrnProgress) call write_progress (.false., 3, 4)  
  call LU_SYSTEM (a, 2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 4, 4)
  call write_FileTmat (Nmax, Nmax, b) 
  close (unit = iTmat)  
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .false., .false., chiral)
  call ScatCharact (k, FileTmat, Mrank, Nrank, .false., .false., chiral)
  print "(/,2x,'T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank  
  deallocate (a, b, paramG1, paramG2, weightsG, Nintparam)      
end subroutine TMatrix_Nrank_MrankNONAXSYM 
!***********************************************************************************
!                   ROUTINES FOR UNIAXIAL ANISOTROPIC PARTICLES                    *
!***********************************************************************************
subroutine convergence_NintAnis (FileGeom, TypeGeom, k, ind_ref, ind_refZ, alfaPR,  &
           betaPR, gamaPR, snorm, Nsurf, surf, rp, np, area, Nface, Nparam, Mrank,  &
           Nrank, Nbeta, Nint1, Nint2, dNint1, dNint2, epsNint, ExtThetaDom,        &
           PrnProgress)
  use parameters
  implicit none
  integer    :: TypeGeom, Nsurf, Nface, Nparam, Mrank, Nrank, Nbeta, Nint1, Nint2,  &
                dNint1, dNint2
  real(O)    :: k, snorm, surf(Nsurf), rp(3,NfacePD), np(3,NfacePD), area(NfacePD), &
                epsNint, alfaPR, betaPR, gamaPR
  complex(O) :: ind_ref, ind_refZ  
  logical    :: FileGeom, ExtThetaDom, PrnProgress
!      
  integer    :: Nmax, Nteta, i, NthetaConv, iNint, NintAL  
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext
  integer,allocatable    :: Nintparam(:) 
  real(O),allocatable    :: paramG1(:,:), paramG2(:,:), weightsG(:,:), h(:), v(:),  &
                            oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), c(:), b(:,:), c1(:)   
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Nmax   = Nrank + Mrank * (2 * Nrank - Mrank + 1)         
  call write_TypeConvHead (1)
  allocate (a(2*Nmax,2*Nmax), c(2*Nmax), b(2*Nmax,2*Nmax), c1(2*Nmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do
  if (PrnProgress) call write_progress (.true., 1, 7)
  do iNint = 1, 2                       
    NintAL = max(Nint1,Nint2) 
    allocate (paramG1(Nparam,NintAL*NintAL), paramG2(Nparam,NintAL*NintAL),         &
              weightsG(Nparam,NintAL*NintAL))
    allocate (Nintparam(Nparam))
    call interpolation_list3D (TypeGeom, Nsurf, surf, Nint1, Nint2, NintAL, Nparam, &
         Nintparam, paramG1, paramG2, weightsG,.false., 1)   
    call matrix_Q_anis (FileGeom, TypeGeom, 3, 1, k, ind_ref, ind_refZ, alfaPR,     &
         betaPR, gamaPR, Nsurf, surf, rp, np, area, Nface, Mrank, Nrank, Nmax,      &
         Nbeta, NintAL, Nparam, Nintparam, paramG1, paramG2, weightsG, a, Nmax, Nmax)
    if (PrnProgress) call write_progress (.false., 2+3*(iNint-1), 7)                                                    
    call matrix_Q_anis (FileGeom, TypeGeom, 1, 1, k, ind_ref, ind_refZ, alfaPR,     &
         betaPR, gamaPR, Nsurf, surf, rp, np, area, Nface, Mrank, Nrank, Nmax,      &
         Nbeta, NintAL, Nparam, Nintparam, paramG1, paramG2, weightsG, b, Nmax, Nmax)
    if (PrnProgress) call write_progress (.false., 3+3*(iNint-1), 7)
    call LU_SYSTEM (a, 2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, 2*Nmax)
    if (PrnProgress) call write_progress (.false., 4+3*(iNint-1), 7)
    call PWcoefficients_ab (tetaGI, phiGI, alfa, beta, gama, alfap, Mrank, Nrank,   &
         Nmax, c)    
    call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, c, c1)
    call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfa, beta, gama, k, snorm,    &
         ExtThetaDom,.true., h, v)
    call CQscat (c1, Mrank, Nrank, Nmax, k, snorm, Cscat, Qscat)
    call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfa, beta, gama,            &
         alfap, k, snorm, Cext, Qext)     
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsNint, NthetaConv) 
    call write_4ConvParam (Nint1, Nint2, Nrank, Mrank)                  
    call write_DSCS (Nteta, ExtThetaDom, h, v)
    call write_Effic (Qscat, Qext)
    Nint1 = Nint1 + dNint1
    Nint2 = Nint2 + dNint2
    deallocate (paramG1, paramG2, weightsG, Nintparam)
  end do
  call write_NintConvRes (NthetaConv, Nteta, epsNint)                           
  deallocate (a, b, c, c1, h, v, oldh, oldv)    
end subroutine convergence_NintAnis
!***********************************************************************************
subroutine convergence_Nrank_MrankAnis (FileGeom, TypeGeom, k, ind_ref, ind_refZ,   &
           alfaPR, betaPR, gamaPR, snorm, Nsurf, surf, rp, np, area, Nface, Nparam, &
           Mrank, Nrank, Nbeta, Nint1, Nint2, epsNrank, epsMrank, ExtThetaDom,      &
           FileTmat, PrnProgress)
  use parameters
  implicit none
  integer       :: TypeGeom, Nsurf, Nface, Nparam, Mrank, Nrank, Nint1, Nint2, Nbeta
  real(O)       :: k, snorm, surf(Nsurf), rp(3,NfacePD), np(3,NfacePD),             &
                   area(NfacePD), epsNrank, epsMrank, alfaPR, betaPR, gamaPR
  complex(O)    :: ind_ref, ind_refZ
  character(80) :: FileTmat
  logical       :: FileGeom, ExtThetaDom, PrnProgress
!        
  integer       :: Nmax, Nteta, i, NthetaConvN, NthetaConvM, NintAL
  real(O)       :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,     &
                   Cext, Qext
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG1(:,:), paramG2(:,:), weightsG(:,:), h(:), v(:),  &
                            oldh(:), oldv(:), oldh0(:), oldv0(:)
  complex(O),allocatable :: a(:,:), c(:), b(:,:), c1(:), a1(:,:), b1(:,:)   
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Nmax   = Nrank + Mrank * (2 * Nrank - Mrank + 1)   
  NintAL = max(Nint1,Nint2)
  call write_TypeConvHead (4)  
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call  write_HeadFileTmat (Nmax, Nmax)    
  allocate (a1(2*Nmax,2*Nmax), b1(2*Nmax,2*Nmax))  
  allocate (a(2*Nmax,2*Nmax), c(2*Nmax), b(2*Nmax,2*Nmax), c1(2*Nmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta), oldh0(Nteta),             &
            oldv0(Nteta))                        
  allocate (paramG1(Nparam,NintAL*NintAL), paramG2(Nparam,NintAL*NintAL),           &
            weightsG(Nparam,NintAL*NintAL))
  allocate (Nintparam(Nparam))
  call interpolation_list3D (TypeGeom, Nsurf, surf, Nint1, Nint2, NintAL, Nparam,   &
       Nintparam, paramG1, paramG2, weightsG,.false., 1)   
  if (PrnProgress) call write_progress (.true., 1, 4)
  call matrix_Q_anis (FileGeom, TypeGeom, 3, 1, k, ind_ref, ind_refZ, alfaPR,       &
       betaPR, gamaPR, Nsurf, surf, rp, np, area, Nface, Mrank, Nrank, Nmax, Nbeta, &
       NintAL, Nparam, Nintparam, paramG1, paramG2, weightsG, a, Nmax, Nmax)
  if (PrnProgress) call write_progress (.false., 2, 4)   
  call copy_matrix (2*Nmax, 2*Nmax, a, 2*Nmax, 2*Nmax, a1, 2*Nmax, 2*Nmax)
  call matrix_Q_anis (FileGeom, TypeGeom, 1, 1, k, ind_ref, ind_refZ, alfaPR,       &
       betaPR, gamaPR, Nsurf, surf, rp, np, area, Nface, Mrank, Nrank, Nmax, Nbeta, &
       NintAL, Nparam, Nintparam, paramG1, paramG2, weightsG, b, Nmax, Nmax)
  if (PrnProgress) call write_progress (.false., 3, 4)  
  call copy_matrix (2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, b1, 2*Nmax, 2*Nmax)
  call LU_SYSTEM (a, 2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 4, 4)
  call write_FileTmat (Nmax, Nmax, b)
  call PWcoefficients_ab (tetaGI, phiGI, alfa, beta, gama, alfap, Mrank, Nrank,     &
       Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfa, beta, gama, k, snorm,      &
       ExtThetaDom,.true., h, v)
  call CQscat (c1, Mrank, Nrank, Nmax, k, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfa, beta, gama,              &
       alfap, k, snorm, Cext, Qext)             
  call write_4ConvParam (Nint1, Nint2, Nrank, Mrank)
  call write_DSCS (Nteta, ExtThetaDom, h, v)
  call write_Effic (Qscat, Qext)
  deallocate (paramG1, paramG2, weightsG, Nintparam)
  do i = 1, Nteta
    oldh(i)  = h(i)
    oldv(i)  = v(i)
    oldh0(i) = h(i)
    oldv0(i) = v(i)
  end do
  close (unit = iTmat)  
! --- (Nrank - 1) configuration ---
  if (PrnProgress) call write_progress_low  
  call copy_matrix (2*Nmax, 2*Nmax, a1, 2*Nmax, 2*Nmax, a, 2*Nmax, 2*Nmax) 
  call matrix_Nrank_1_left (Mrank, Nrank, Nmax, a, Nmax, Nmax)  
  call copy_matrix (2*Nmax, 2*Nmax, b1,  2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax)  
  call matrix_Nrank_1_right (Mrank, Nrank, Nmax, b, Nmax, Nmax)
  call LU_SYSTEM (a, 2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, 2*Nmax)         
  call PWcoefficients_ab (tetaGI, phiGI, alfa, beta, gama, alfap, Mrank, Nrank,     &
       Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfa, beta, gama, k, snorm,      &
       ExtThetaDom,.true., h, v)
  call CQscat (c1, Mrank, Nrank, Nmax, k, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfa, beta, gama,              &
       alfap, k, snorm, Cext, Qext)    
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConvN)
  call write_4ConvParam (Nint1, Nint2, Nrank - 1, Mrank)
  call write_DSCS (Nteta, ExtThetaDom, h, v)
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConvN, Nteta, epsNrank)                                          
! --- (Mrank - 1) configuration ---  
  call copy_matrix (2*Nmax, 2*Nmax, a1, 2*Nmax, 2*Nmax, a, 2*Nmax, 2*Nmax) 
  call matrix_Mrank_1_left (Mrank, Nrank, Nmax, a, Nmax, Nmax)  
  call copy_matrix (2*Nmax, 2*Nmax, b1, 2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax)  
  call matrix_Mrank_1_right (Mrank, Nrank, Nmax, b, Nmax, Nmax)
  call LU_SYSTEM (a, 2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, 2*Nmax)         
  call PWcoefficients_ab (tetaGI, phiGI, alfa, beta, gama, alfap, Mrank, Nrank,     &
       Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfa, beta, gama, k, snorm,      &
       ExtThetaDom,.true., h, v)
  call CQscat (c1, Mrank, Nrank, Nmax, k, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfa, beta, gama,              &
       alfap, k, snorm, Cext, Qext)    
  call delta_DSCS (Nteta, h, v, oldh0, oldv0, epsMrank, NthetaConvM)
  call write_4ConvParam (Nint1, Nint2, Nrank, Mrank - 1)
  call write_DSCS (Nteta, ExtThetaDom, h, v) 
  call write_Effic (Qscat, Qext)
  call write_MrankConvRes (NthetaConvM, epsMrank)
  if (NthetaConvN >= int(0.8*Nteta) .and. NthetaConvM >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criteria for Nrank and Mrank are satisfied;')"
  else
    print "(/,2x,'Convergence criteria for Nrank and Mrank are not satisfied;')"
  end if          
  deallocate (a1, b1)  
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .false., .false., .false.)
  call ScatCharact (k, FileTmat, Mrank, Nrank, .false., .false., .false.)
  print "(/,2x,'The T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,';')", Nrank
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank  
  deallocate (a, b, c, c1, h, v, oldh, oldv, oldh0, oldv0)      
end subroutine convergence_Nrank_MrankAnis
!***********************************************************************************
subroutine TMatrix_Nrank_MrankAnis (FileGeom, TypeGeom, k, ind_ref, ind_refZ,       &
           alfaPR, betaPR, gamaPR, Nsurf, surf, rp, np, area, Nface, Nparam, Mrank, &
           Nrank, Nbeta, Nint1, Nint2, FileTmat, PrnProgress)
  use parameters
  implicit none
  integer       :: TypeGeom, Nsurf, Nface, Nparam, Mrank, Nrank, Nint1, Nint2, Nbeta
  real(O)       :: k, surf(Nsurf), rp(3,NfacePD), np(3,NfacePD), area(NfacePD),     &
                   alfaPR, betaPR, gamaPR
  complex(O)    :: ind_ref, ind_refZ
  character(80) :: FileTmat
  logical       :: FileGeom, PrnProgress
!        
  integer       :: Nmax, NintAL  
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG1(:,:), paramG2(:,:), weightsG(:,:)
  complex(O),allocatable :: a(:,:), b(:,:) 
!  
  Nmax   = Nrank + Mrank * (2 * Nrank - Mrank + 1)   
  NintAL = max(Nint1,Nint2)  
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call  write_HeadFileTmat (Nmax, Nmax)    
  allocate (a(2*Nmax,2*Nmax), b(2*Nmax,2*Nmax))                          
  allocate (paramG1(Nparam,NintAL*NintAL), paramG2(Nparam,NintAL*NintAL),           &
            weightsG(Nparam,NintAL*NintAL))
  allocate (Nintparam(Nparam))
  call interpolation_list3D (TypeGeom, Nsurf, surf, Nint1, Nint2, NintAL, Nparam,   &
       Nintparam, paramG1, paramG2, weightsG,.false., 1)   
  if (PrnProgress) call write_progress (.true., 1, 4)
  call matrix_Q_anis (FileGeom, TypeGeom, 3, 1, k, ind_ref, ind_refZ, alfaPR,       &
       betaPR, gamaPR, Nsurf, surf, rp, np, area, Nface, Mrank, Nrank, Nmax, Nbeta, &
       NintAL, Nparam, Nintparam, paramG1, paramG2, weightsG, a, Nmax, Nmax)
  if (PrnProgress) call write_progress (.false., 2, 4)   
  call matrix_Q_anis (FileGeom, TypeGeom, 1, 1, k, ind_ref, ind_refZ, alfaPR,       &
       betaPR, gamaPR, Nsurf, surf, rp, np, area, Nface, Mrank, Nrank, Nmax, Nbeta, &
       NintAL, Nparam, Nintparam, paramG1, paramG2, weightsG, b, Nmax, Nmax)
  if (PrnProgress) call write_progress (.false., 3, 4)  
  call LU_SYSTEM (a, 2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 4, 4)
  call write_FileTmat (Nmax, Nmax, b)
  close (unit = iTmat)
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .false., .false., .false.)
  call ScatCharact (k, FileTmat, Mrank, Nrank, .false., .false., .false.)
  print "(/,2x,'The T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,';')", Nrank
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank  
  deallocate (a, b, paramG1, paramG2, weightsG, Nintparam)      
end subroutine TMatrix_Nrank_MrankAnis

subroutine EFMED
!-----------------------------------------------------------------------------------
! 1. General Considerations                                                        !
! --------------------------                                                       !
! EFMED is a code for computing the effective wave number of a medium with         !
! randomly distributed spheroidal particles. The particles are identical and are   !
! illuminated by a vector plane wave traveling along the Z-axis of the global      !
! coordinate system (normal incidence). The T-matrix method together with the      !
! quasi-crystalline approximation is used to generate a set of homogeneous         !
! equations (the generalized Lorentz-Lorenz law):                                  ! 
!                                                                                  !
!                         [I - n * T * (J1 + J2)] * s = 0,                         !
!                                                                                  !
! where I is the identity matrix, T is the transition matrix, n is the number      !
! of particles per unit volume (n = N / V), J1 and J2 are the averaged translation ! 
! matrices and s is the unknown vector of the scattered field coefficients.        !
! Note that the elements of the averaged translation matrices are expressed as     !
! integrals over the zenith angle beta. For a nontrivial solution of the system of ! 
! homogeneous equations, the determinant must vanishes giving an equation for      ! 
! the effective wave number. The code computes the effective wave numbers for      !
! size parameters ranging from xmin to xmax in dx steps. For a spheroidal          ! 
! particles with semi-axes a and b, the size parameter is defined as               !
!                                                                                  !
!                             x = k * max(a,b),                                    !
!                                                                                  !
! where k is the wave number in the ambient medium. The root of the equation       !
!                                                                                  !
!                   det {I - n * T * (J1 + J2)} = 0,                               !
!                                                                                  !
! is searched in the complex plane using Mueller's method. Mueller's method        ! 
! requires an initial guess and two starting values for the effective wave         !
! number. For x = xmin, the initial guess is computed by using the first and       !
! second order approximations of the long-wavelength T-matrix method. The          !
! second and third starting values of the wave number are given by:                !
!                                                                                  !
!                           K2 = K1 + delta,                                       !
!                                                                                  ! 
! and                                                                              !
!                                                                                  ! 
!                           K3 = K2 + delta,                                       !
!                                                                                  !
! respectively, where K1 is the initial guess and delta is a parameter specified   !
! in the namelist input. The process of calculation is iterative, i.e., the wave   !
! number corresponding to the size parameter x serves as initial guess for         !
! computing the wave number corresponding to the size parameter x + dx.            !
!                                                                                  !
! For axisymmetric particles with the axis of symmetry directed along the Z-axis,  !
! the transition matrix is diagonal with respect to azimuthal index. Because the   !
! non-vanishing incident field coefficients correspond to the azimuthal modes      !
! m = 1 and m = -1, only these modes are required for computing the effective      !
! wave number.                                                                     !   
!                                                                                  !
! The elements of the averaged translation matrix J2 are expressed in terms of     !
! the quantities:                                                                  !
!                                                                                  !
!                   |inf                                                           !
!             G_n = |  [g(2Rx) - 1] * h_n(2kRx) * j_n(2Krx) x**2 dx,               !                  
!                   |0                                                             !
!                                                                                  !
! where g is the pair distribution function, R is the radius of a sphere           !
! enclosing the particle (for spherical particles, R is the particle radius),      !
! k is the wave number in the ambient medium and h_n and j_n are the spherical     !
! Hankel and Bessel functions. For the Percus-Yevick pair distribution function,   !
! we have:                                                                         !
!                                                                                  !
!                             Pi  |inf          sin(ux)                            !
!              g(2Rx) - 1 = ------|  H(u/2R) * --------- u**2 du                   !  
!                           2R**2 |0              ux                               !
!                                                                                  !
! where H is the Fourier transform of the total correlation function. Note that    !
! Percus-Yevick pair distribution function is the solution of the Ornstein-Zernike ! 
! equation for the total and direct correlation functions of two particles h(r)    !
! and d(r) under the assumption that h(r) - d(r) = y(r) - 1. For the case of       !
! hard-sphere potential, the Ornstein-Zernicke equation with Percus-Yevick         !
! approximation has a closed-form solution H. The function g(2Rx) - 1 is computed  !
! by sintransform                                                                  !
!                                                                                  !
!                              Pi  |L                                              !
!              g(2Rx) - 1 = -------|  H(u/2R) * u * sin(ux) du,                    !
!                           2xR**2 |0                                              !
!                                                                                  !
! while the G_n are given by                                                       !
!                                                                                  !  
!                   |Xmax                                                          !
!             G_n = |  [g(2Rx) - 1] * h_n(2kRx) * j_n(2Krx) x**2 dx.               !
!                   |0                                                             !
!                                                                                  !
! The number of discrete points N for computing the pair distribution function     ! 
! by sintransform is                                                               !
!                                                                                  !
!                         N = 2**pN,                                               !
!                                                                                  !
! while the upper limits L and Xmax are                                            !
!                                                                                  !
!                         L ~ 2**(pN - p)                                          !
!                                                                                  !
! and                                                                              !
!                                                                                  !
!                         Xmax ~ 2**p,                                             !
!                                                                                  !
! respectively. The integers p and pN are supplied in the namelist input, and the  !
! coefficients G_n are computed by using the trapez integration method.            !
!                                                                                  !
! For spherical particles with small size parameters, the effective wave numbers   !
! can be also computed by using the long-wavelength quasi-crystalline              !
! approximations with and without coherent potential.                              !
!                                                                                  !   
! The input data are supplied by the file "/INPUTFILES/InputEFMED.dat", while      !
! the output data are written to the file "/OUTPUTFILES/Output.dat".               !
!                                                                                  !
! 2. Input Parameters                                                              !
! --------------------                                                             !
! The parameters specified in the input file "/INPUTFILES/InputEFMED.dat" are      !  
! listed below.                                                                    !
!                                                                                  !
! - ind_refMed (real) - refractive index of the ambient medium.                    !
!                                                                                  !
! - ind_refRel (complex) - relative refractive index of the spheroidal particles   !
!   with respect to the ambient medium.                                            !
!                                                                                  !
! - xmax (real) - maximum size parameter. The size parameter is defined as         !
!   x = k * max(a,b), where k is the wave number in the ambient medium, a is       !
!   the semi-axis along the axis of symmetry and b is the second half-axis.        !
!                                                                                  !
! - xmin (real) - minimum size parameter.                                          !
!                                                                                  !
! - dx (real) - size parameter step. This parameter MUST BE POSITIVE.              !
!                                                                                  !
! - e (real) - eccentricity of the spheroidal particle. e is defined as            !
!   e = a / b, where as before, a is the semi-axis along the axis of symmetry      !
!   and b is the second half-axis. For spherical particles, set e = 1.0.           !
!                                                                                  !
! - c (real) - volume concentration, c = N * Vp / V, where N is the number of      !
!   particles, Vp is the volume of the particle and V is the volume occupied by    !      
!   the particles.                                                                 !
!                                                                                  !
! - Nint (integer) - number of integration points on the particle surface for      !
!   computing the T matrix.                                                        !
!                                                                                  !
! - RandomOrientation (logical) - if RandomOrientation = t, the spheroidal         !
!   particle is randomly oriented, otherwise the axis of symmetry is along the     ! 
!   Z-axis (the incident direction).                                               !
!                                                                                  !
! - ComputeQCA (logical) - if ComputeQCA = t, the long-wavelength                  !  
!   quasicrystalline approximations with and without coherent potential are used   !
!   to compute the effective wave number. These methods can be used for spherical  !
!   particles with small size parameter.                                           !
!                                                                                  !
! - Nbeta (integer) - number of integration points for computing the elements of   !
!   the averaged translation matrices J1 and J2.                                   !
!                                                                                  !
! - p, pN (integer variables) - determine the numbers of discretization points     !
!   for computing the pair distribution function by sintransform,                  !
!                                                                                  !
!                                |L                                                !
!                         f(x) = |  F(u)*sin(u*x) du,                              !
!                                |0                                                !
!                                                                                  !
!   The number of discrete points is N = 2**pN, L ~ Pi * 2**(pN - p), and the      !
!   upper limit for the pair-distribution function integration is Xmax ~ 2**p.     !
!   For low volume concentration we recommend to use p = 3, while for high         !
!   volume concentration we recommend to use p = 4. Here is a table giving some    !
!   approximate values of the parameters.                                          !
!                                                                                  !
!                         N         L          Xmax                                !
!                                                                                  !
!     p = 3, pN =  8     256       100           8                                 !
!     p = 3, pN =  9     512       200           8                                 ! 
!     p = 3, pN = 10    1024       400           8                                 !
!     p = 3, pN = 11    2048       800           8                                 ! 
!     p = 3, pN = 12    4096      1600           8                                 !
!     p = 3, pN = 13    8192      3200           8                                 ! 
!                                                                                  !
!     p = 4, pN =  8     256        50          16                                 !
!     p = 4, pN =  9     512       100          16                                 ! 
!     p = 4, pN = 10    1024       200          16                                 !
!     p = 4, pN = 11    2048       400          16                                 ! 
!     p = 4, pN = 12    4096       800          16                                 !
!     p = 4, pN = 13    8192      1600          16                                 !
!                                                                                  !
!     p = 5, pN =  8     256        25          32                                 !
!     p = 5, pN =  9     512        50          32                                 ! 
!     p = 5, pN = 10    1024       100          32                                 !
!     p = 5, pN = 11    2048       200          32                                 ! 
!     p = 5, pN = 12    4096       400          32                                 !
!     p = 5, pN = 13    8192       800          32                                 !  
!                                                                                  !
!  - epsX, epsY (real variables) - tolerance specifying the accuracy of root     !
!    computation.  For Mueller's method we impose a conservative criterion, i.e.,  !
!    the convergence is achieved if the iterates converge (epsX cratered) and     !
!    the residual is smaller than a given tolerance (epsY criterion).             !
!                                                                                  !
! - Niter (integer) - maximum number of iterations for Mueller's method.           !
!                                                                                  !
! WARNING: OUR FEELING IS THAT THERE IS AN ERROR IN THE ROUTINE FOR COMPUTING THE  !
! EFFECTIVE WAVE NUMBER OF SPHEROIDAL PARTICLES. IN THIS REGARD, WE RECOMMEND TO   !
! USE THE CODE ONLY FOR SPHERICAL PARTICLES.                                       ! 
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none 
  integer    :: Nint, Nbeta, Niter, p, pN, ios, N
  real(O)    :: xmax, xmin, dx, e, c, wavelength, epsX, epsY, ind_refMed,           &
                lambdaMed, wavenumberMed, du, L, Lmax 
  complex(O) :: ind_refRel
  logical    :: RandomOrientation, ComputeQCA
! -----------------------------------------------------------------------------------
!                               Read the Input File                                 ! 
! ----------------------------------------------------------------------------------- 
  call readinputEFMED ( wavelength, ind_refMed, ind_refRel, xmax, xmin, dx, e,      &
       c, Nint, Nbeta, p, pN, epsX, epsY, Niter, RandomOrientation, ComputeQCA )       
  lambdaMed     = wavelength / ind_refMed
  wavenumberMed = 2 * Pi / lambdaMed        
! ----------------------------------------------------------------------------------
!                         Write Informations to Output File                        ! 
! ----------------------------------------------------------------------------------               
  open (unit = iOutput, file = FileOutput, status = "replace") 
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'refractive index of the ambient medium, ind_refMed = ', ind_refMed, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'wave number in the ambient medium, wave_numberMed  = ', wavenumberMed, ';'
  write (iOutput,"(2x, a, 1pe10.3, ',', 1pe10.3, a)")                               &
 'relative refractive index of the particle, ind_refRel = (', ind_refRel, ');'  
  write (iOutput,"(2x,'volume concentration,   c    = ',1pe10.3,';')") c
  write (iOutput,"(2x,'maximum size parameter, xmax = ',1pe10.3,';')") xmax
  write (iOutput,"(2x,'minimum size parameter, xmin = ',1pe10.3,';')") xmin
  write (iOutput,"(2x,'size parameter step,    dx   = ',1pe10.3,';')") dx
  write (iOutput,"(2x,'spheroid eccentricity,  e    = ',1pe10.3,';')") e                       
  write (iOutput,"(2x, a, i3,';')")                                                 &
 'number of integration points on the particle surface, Nint = ', Nint
  if (RandomOrientation) then
    write (iOutput,"(2x,'randomly oriented spheroidal particles;')")
  else
    write (iOutput,"(2x,'particles in fixed orientation;')")
  end if
  N    = 2**pN
  du   = Pi / 2**p
  L    = real(N - 1,O) * du  
  Lmax = real(N - 1,O) * Pi / real(N,O) / du
  write (iOutput,"(2x, a, i2, a, i2, a)")                                           &
 'parameters controlling the discretization process, p = ', p, ', pN = ', pN, ';'
  write (iOutput,"(2x,'number of discrete points, N = ',i6,';')") N
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'upper limit for sintransform integration, L = ', L, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'upper limit for pair-distribution function integration, Xmax = ', Lmax, ';'
  write (iOutput,"(2x, a, i6, a)")                                                  &
 'maximum number of iterations for Mueller''s method, Niter = ', Niter, ';'
  write (iOutput,"(2x, a, 1pe10.3, a, 1pe10.3, a)")                                 &
 'tolerences controlling Mueller''s iterations, epsX = ', epsX, ', epsY = ', epsY, ';'
!-----------------------------------------------------------------------------------
!                                   Main                                           !
!----------------------------------------------------------------------------------- 
  print "(/,2x,'Effective Wavenumber of a Medium with Spheroidal Particles',/)"
  call IterativeSpheroidMullerSolver ( wavenumberMED, ind_refRel, xmax, xmin, dx,   &
       e, c, Nint, Nbeta, p, pN, Niter, epsX, epsY, RandomOrientation, ComputeQCA )
  close (unit = iOutput)  
end subroutine EFMED
!***********************************************************************************
subroutine readinputEFMED ( wavelength, ind_refMed, ind_refRel, xmax, xmin, dx, e,  &
           c, Nint, Nbeta, p, pN, epsX, epsY, Niter, RandomOrientation, ComputeQCA ) 
  use parameters
  use derived_parameters
  implicit none 
  integer       :: Nint, Nbeta, Niter, p, pN, ios
  real(O)       :: wavelength, xmax, xmin, dx, e, c, epsX, epsY, ind_refMed
  complex(O)    :: ind_refRel
  character(80) :: string
  logical       :: RandomOrientation, ComputeQCA, XFindPar    
!
  call DrvParameters  
  open (unit = iInputEFMED, file = FileInputEFMED, status = "old", position = "rewind")
  wavelength = 0.2_O * Pi        
  ind_refMed = 1._O                                                         
  ind_refRel = (1.668_O,0.510_O)
  string     = 'OptProp'
  if (XFindPar (iInputEFMED, string)) then   
    read (iInputEFMED, *, iostat = ios) wavelength
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if   
    read (iInputEFMED, *, iostat = ios) ind_refMed
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refMed;')"
      stop
    end if
    read (iInputEFMED, *, iostat = ios) ind_refRel
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refRel;')"
      stop
    end if      
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if
!
  xmax = 0.5_O
  xmin = 0.1_O  
  dx   = 0.1_O  
  e    = 1.0_O
  c    = 0.1_O 
  Nint = 60
  RandomOrientation = .true.
  ComputeQCA        = .true.      
  string = 'TmatPart'
  if (XFindPar (iInputEFMED, string)) then    
    read (iInputEFMED, *, iostat = ios) xmax
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable xmax;')"
      stop
    end if
    read (iInputEFMED, *, iostat = ios) xmin    
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable xmin;')"
      stop
    end if    
    read (iInputEFMED, *, iostat = ios) dx    
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable dx;')"
      stop
    end if 
    read (iInputEFMED, *, iostat = ios) e    
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable e;')"
      stop
    end if                         
    read (iInputEFMED, *, iostat = ios) c
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable c;')"
      stop
    end if 
    read (iInputEFMED, *, iostat = ios) Nint
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nint;')"
      stop
    end if 
    read (iInputEFMED, *, iostat = ios) RandomOrientation    
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable RandomOrientation;')"
      stop
    end if 
    read (iInputEFMED, *, iostat = ios) ComputeQCA
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ComputeQCA;')"
      stop
    end if                    
  else
    print "(/,2x,'Group name TmatPart not found;')"
    stop  
  end if
  if (e == 1._O) then
    RandomOrientation = .false.
  else
    ComputeQCA = .false. 
  end if
!
  Nbeta = 180
  p  = 5
  pN = 10            
  epsX   = 1.e-6_O
  epsY   = 1.e-6_O 
  Niter  = 1000
  string = 'AlgProp'
  if (XFindPar (iInputEFMED, string)) then    
    read (iInputEFMED, *, iostat = ios) Nbeta
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nbeta;')"
      stop
    end if
    read (iInputEFMED, *, iostat = ios) p
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable p;')"
      stop
    end if 
    read (iInputEFMED, *, iostat = ios) pN
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable pN;')"
      stop
    end if    
    read (iInputEFMED, *, iostat = ios) epsX
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsX;')"
      stop
    end if
    read (iInputEFMED, *, iostat = ios) epsY
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsY;')"
      stop
    end if
    read (iInputEFMED, *, iostat = ios) Niter
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Niter;')"
      stop
    end if
  else
    print "(/,2x,'Group name AlgProp not found;')"
    stop  
  end if
  close (unit = iInputEFMED)
end subroutine readinputEFMED
!***********************************************************************************
subroutine IterativeSpheroidMullerSolver ( wavenumberMED, ind_refRel, xmax, xmin,   &
           dx, e, c, Nint, Nbeta, p, pN, Niter, epsX, epsY, RandomOrientation,      &
           ComputeQCA )
  use parameters
  implicit none 
  integer    :: Nint, Nbeta, p, pN, Niter
  real(O)    :: xmax, xmin, dx, e, c, epsX, epsY, wavenumberMed
  complex(O) :: ind_refRel            
  logical    :: RandomOrientation, ComputeQCA           
!
  integer    :: Nx, ix, Nrank
  real(O)    :: Nxreal, x, SemiAxisA, SemiAxisB, a, x3
  complex(O) :: kX, wavenumberEFMED, epsRel, tamp, fct
  logical    :: sphere, Conv
!
  sphere = .false.
  if ( e == 1._O ) sphere = .true.
  if ( xmin > xmax ) then
    Nx = 1
  else
    Nxreal = ( xmax - xmin ) / dx
    Nx     = int(Nxreal)
    if (Nx + 0.1_O > Nxreal) then
      Nx = Nx + 1
    else
      Nx = Nx + 2
    end if
  end if
  kX = cmplx(wavenumberMED,0.0,O)
  print "(2x,'Iterative calculation over the size parameter:')"
! ----------------------------------------------------------------------------------
!                              T-Matrix Method                                     !
! ----------------------------------------------------------------------------------
  write (iOutput,"(/)")
  write (iOutput,"(2x,'Results',/)")
  write (iOutput,"(2x,'T-Matrix Method')")
  write (iOutput,"(2x,'size parameter          effective wave number',/)") 
  do ix = 1, Nx
    if (ix < Nx) then
      x = xmin + (ix - 1) * dx
    else
      x = xmax
    end if
    if (e >= 1._O) then
      SemiAxisA = x / wavenumberMED
      SemiAxisB = SemiAxisA / e
    else
      SemiAxisB = x / wavenumberMED
      SemiAxisA = SemiAxisB * e
    end if
    Nrank = int(x + 4.05_O * x**0.33_O + 2._O)
    if (Nrank < 4) Nrank = Nrank + 4
    a = max (SemiAxisA, SemiAxisB) 
    print "(2x,'iteration      = ', i3, ';')", ix
    print "(2x,'size parameter =', 1pe13.4, ';')", x 
    if ( ix == 1) then
      call InitialGuessSpheroid (wavenumberMED, ind_refRel, a, SemiAxisA,           &
           SemiAxisB, sphere, RandomOrientation, c, Nrank, Nint, epsX, epsY,        &
           Niter, Conv, kX)
      if (Conv) then        
        print "(2x,'initial guess  = (',1pe13.4,',',1pe13.4,'   );')", kX
      else
        print "(/,2x,'convergence is not achieved at the initial guess;')" 
        print "(  2x, a)",                                                          &
       'the tolerances epsX/epsY, or the iteration number Niter are too low;'	             
        stop
      end if		         
    end if
    wavenumberEFMED = kX
    call MullerSpheroid (wavenumberEFMED, wavenumberMED, ind_refRel, a, SemiAxisA,  &
         SemiAxisB, sphere, RandomOrientation, c, Nrank, Nint, Nbeta, p, pN, Niter, &
         epsX, epsY, Conv, kX)	  				               		                                                        
    if (Conv) then	  	  
      print "(2x,'initial  effective wave number = (',1pe13.4,',',1pe13.4,'   );')",  &
	      wavenumberEFMED
      print "(2x,'computed effective wave number = (',1pe13.4,',',1pe13.4,'   );',/)",&
              kX
      write (iOutput,"(2x, 1pe13.4, '      (',1pe13.4,',',1pe13.4,'   )')") x, kX
     !write (iOutput,"(2x, 1pe13.4, 2x, 1pe13.4, 2x, 1pe13.4)") x, wavenumberMED/real(kX), &
     !	     2.d0*aimag(kX)/real(kX)
    else
      print "(/,2x,'convergence is not achieved;')" 
      print "(  2x, a)",                                                            &
     'the tolerances epsX/epsY, or the iteration number Niter are too low;'	             
      stop
    end if
  end do
  if (sphere .and. ComputeQCA) then
    write (iOutput,"(/,2x,'QCA and QCA-CP')")
    write (iOutput,"(2x, a,/)")                                                     &
   'size parameter         effective wave number QCA          effective wave number QCA-CP'
    epsRel = ind_refRel**2   
    tamp   = (epsRel - 1._O) / (epsRel + 2._O)
    do ix = 1, Nx
      if (ix < Nx) then
        x = xmin + (ix - 1) * dx
      else
        x = xmax
      end if	  	  
      a = x / wavenumberMED
!     ------------------------------------------------------------------------------
!                 Long-Wavelength Quasicrystalline Approximation                   !
!     ------------------------------------------------------------------------------   
      x3  = x**3
      fct = 3._O * c * tamp  / (1._O - c * tamp)
      fct = fct * (1._O + im * 2._O * x3 * tamp * (1._O - c)**4 /                   &
          ((1._O - c * tamp) * (1._O + 2._O * c)**2 * 3._O))
      wavenumberEFMED = wavenumberMed * sqrt(1._O + fct)            
!     ------------------------------------------------------------------------------
!         Long-Wavelength Quasicrystalline Approximation with Coherent Potential   !
!     ------------------------------------------------------------------------------       
      call MullerQCACP (wavenumberEFMED, wavenumberMED, ind_refRel, a, c, Niter,    &
           epsX, epsY, Conv, kX)      
      if (Conv) then	  	  	  
        write (iOutput,"(2x,1pe13.4,a,1pe13.4,',',1pe13.4,a,1pe13.4,',',1pe13.4,a)")&
               x,'      (', wavenumberEFMED, '   )     (', kX, '   )'   
      else
        print "(/,2x,'convergence is not achieved for QCA-CP;')" 
        print "(  2x, a)",                                                          &
       'the tolerances epsX/epsY, or the iteration number Niter are too low;'	             
        stop
      end if
    end do
  end if
end subroutine IterativeSpheroidMullerSolver  
!***********************************************************************************
subroutine MullerSpheroid (wavenumberEFMED, wavenumberMED, ind_refRel, a, SemiAxisA,&
           SemiAxisB, sphere, RandomOrientation, c, Nrank, Nint, Nbeta, p, pN,      &
           Niter, epsX, epsY, Conv, x)
  use parameters
  implicit none 
  integer    :: Nrank, Nint, Nbeta, p, pN, Niter
  real(O)    :: a, SemiAxisA, SemiAxisB, c, epsX, epsY, wavenumberMed
  complex(O) :: wavenumberEFMED, ind_refRel, x
  logical    :: sphere, RandomOrientation, Conv 
!  
  integer    :: iter
  real(O)    :: deltaX
  complex(O) :: delta, x0, x1, x2, P0, P1, P2, s, t, u, den, den1, d, q         
! 
  delta = 0.01_O * wavenumberEFMED 
  x0 = wavenumberEFMED
  x1 = x0 + delta
  x2 = x1 + delta
  call DeterminantEFMEDSpheroid (x0, wavenumberMED, ind_refRel, a, SemiAxisA,       &
       SemiAxisB, sphere, RandomOrientation, c, Nrank, Nint, Nbeta, p, pN, P0)
  call DeterminantEFMEDSpheroid (x1, wavenumberMED, ind_refRel, a, SemiAxisA,       &
       SemiAxisB, sphere, RandomOrientation, c, Nrank, Nint, Nbeta, p, pN, P1)
  call DeterminantEFMEDSpheroid (x2, wavenumberMED, ind_refRel, a, SemiAxisA,       &
       SemiAxisB, sphere, RandomOrientation, c, Nrank, Nint, Nbeta, p, pN, P2)        
  iter = 0
  Conv = .false.        
  print "(2x,'iteration summary of Mueller''s method:')"
  print "(2x,'determinants at starting points:')"
  print "(2x,'                  x0              x1              x2')"
  print "(2x,'determinant ', 1pe12.3, 4x, 1pe12.3, 4x, 1pe12.3)", abs(P0), abs(P1), abs(P2)
  print "(2x,'iteration',1x,'|x(n) - x(n-1)|',6x,'|det(x(n))|')"  
  do while ((iter < Niter) .and. (.not.Conv))
    iter = iter + 1
    q = (x2 - x1) / (x1 - x0)                   
    s = q * P2 - q * (1._O + q) * P1 + q**2 * P0
    t = (2._O * q + 1._O) * P2 - (1._O + q)**2 * P1 + q**2 * P0
    u = (1._O + q) * P2
    d = sqrt(t**2 - 4._O * s * u)
    den  = t + d
    den1 = t - d
    if (abs(den) < abs(den1)) den = den1 
    x = x2 - (x2 - x1) * 2._O * u / den    
    deltaX = abs(x - x2)
    if (abs(x - x1) < abs(x - x0)) then
      s  = x1
      x1 = x0
      x0 = s
      t  = P1
      P1 = P0
      P0 = t
    else if (abs(x - x1) > abs(x - x2)) then
      s  = x2  
      x2 = x1  
      x1 = s
      t  = P2  
      P2 = P1  
      P1 = t
    end if
    x2 = x    
    call DeterminantEFMEDSpheroid (x2, wavenumberMED, ind_refRel, a, SemiAxisA,     &
         SemiAxisB, sphere, RandomOrientation, c, Nrank, Nint, Nbeta, p, pN, P2)          
    print "(5x,i3,4x,1pe12.3,7x,1pe12.3)", iter, deltaX, abs(P2)    
    if ((deltaX < epsX) .and. (abs(P2) < epsY)) Conv = .true.           
  end do  
  x = x2
  if (imag(x) < 0._O) x = wavenumberEFMED  
end subroutine MullerSpheroid 
!***********************************************************************************
subroutine InitialGuessSpheroid (k, ind_refRel, a, SemiAxisA, SemiAxisB, sphere,    &
           RandomOrientation, c, Nrank, Nint, epsX, epsY, Niter, Conv, kX) 
  use parameters
  implicit none
  integer    :: Nrank, Nint, Niter
  real(O)    :: a, SemiAxisA, SemiAxisB, c, k, epsX, epsY
  complex(O) :: kX, ind_refRel
  logical    :: sphere, RandomOrientation, Conv
!  
  integer    :: iter
  real(O)    :: deltaX  
  complex(O) :: delta, T11, T22, T12, T21, x, alpha, x0, x1, x2, P0, P1, P2, s, v,  &
                u, den, den1, d, q 
  complex(O),allocatable :: T(:,:), tv(:), tv11(:), tv12(:), tv21(:), tv22(:)
! --- first order approximation ---        
  if (.not. sphere) then
    if (.not. RandomOrientation) then
      allocate (T(2*Nrank,2*Nrank)) 
      call TmatrixSpheroid (k, ind_refRel, SemiAxisA, SemiAxisB, Nrank, Nint, T)
      T11 = T(1,1)
      T22 = T(Nrank+1,Nrank+1)  
      T12 = T(1,Nrank+1)
      T21 = T(Nrank+1,1)
      deallocate (T)
    else
      allocate (tv11(Nrank), tv12(Nrank), tv21(Nrank), tv22(Nrank))      
      call AverageTmatrixSpheroid (k, ind_refRel, SemiAxisA, SemiAxisB, Nrank,      &
           Nint, tv11, tv12, tv21, tv22)
      T11 = tv11(1)
      T22 = tv22(1)
      T12 = tv12(1)
      T21 = tv21(1)
      deallocate (tv11, tv12, tv21, tv22)
    end if
  else
    allocate (tv(2*Nrank)) 
    call coefficients_fg_m (k, SemiAxisA, ind_refRel, 1, Nrank, Nrank, tv)
    T11 = tv(1)
    T22 = tv(Nrank+1)
    T12 = 0._O
    T21 = 0._O
    deallocate (tv)
  end if
  x     = cmplx(k * a,0.0,O)
  alpha = x * x * x * ( (1._O - c)**4 / (1._O + 2._O * c)**2 - 1._O / T22 )
  kX    = k * sqrt ( (2._O * alpha + 6._O * im * c) / (2._O * alpha - 3._O * im * c) ) 
  if ( imag(kX) < 0._O ) kX = - kX
! --- second order approximation --- 
  delta = 0.01_O * kX
  x0 = kX
  x1 = x0 + delta
  x2 = x1 + delta
  call DeterminantLWLSpheroid (x0, k, a, c, T11, T22, T12, T21, P0)
  call DeterminantLWLSpheroid (x1, k, a, c, T11, T22, T12, T21, P1)
  call DeterminantLWLSpheroid (x2, k, a, c, T11, T22, T12, T21, P2)
  iter = 0
  Conv = .false.    
  do while ((iter < Niter) .and. (.not. Conv))
    iter = iter + 1
    q = (x2 - x1) / (x1 - x0)                   
    s = q * P2 - q * (1._O + q) * P1 + q**2 * P0
    v = (2._O * q + 1._O) * P2 - (1._O + q)**2 * P1 + q**2 * P0
    u = (1._O + q) * P2
    d = sqrt(v**2 - 4._O * s * u)
    den  = v + d
    den1 = v - d
    if (abs(den) < abs(den1)) den = den1 
    x = x2 - (x2 - x1) * 2._O * u / den    
    deltaX = abs(x - x2)
    if (abs(x - x1) < abs(x - x0)) then
      s  = x1
      x1 = x0
      x0 = s
      v  = P1
      P1 = P0
      P0 = v
    else if (abs(x - x1) > abs(x - x2)) then
      s  = x2  
      x2 = x1  
      x1 = s
      v  = P2  
      P2 = P1  
      P1 = v
    end if
    x2 = x    
    call DeterminantLWLSpheroid (x2, k, a, c, T11, T22, T12, T21, P2)    
    if ((deltaX < epsX) .and. (abs(P2) < epsY)) Conv = .true.           
  end do  
  if (imag(x2) >= 0._O) kX  = x2
end subroutine InitialGuessSpheroid
!***********************************************************************************
subroutine DeterminantEFMEDSpheroid (kX, k, ind_refRel, a, SemiAxisA, SemiAxisB,    &
           sphere, RandomOrientation, c, Nrank, Nint, Nbeta, p, pN, Pv) 
  use parameters
  implicit none
  integer    :: Nrank, Nint, Nbeta, p, pN
  real(O)    :: a, SemiAxisA, SemiAxisB,c, k
  complex(O) :: kX, ind_refRel, Pv
  logical    :: sphere, RandomOrientation
!  
  integer    :: i, j
  complex(O) :: fact, det
  complex(O),allocatable :: AB(:,:), T(:,:), tv(:), tv11(:), tv12(:), tv21(:),      &
                            tv22(:)
! 
  allocate (AB(2*Nrank,2*Nrank), T(2*Nrank,2*Nrank))
  call matrix_translationAB_mn_m1n1_EFMED (k, kX, a, c, Nrank, Nbeta, p, pN,        &
       AB, Nrank, Nrank)
  if ( .not. sphere) then
    if (.not. RandomOrientation) then   	           
      call TmatrixSpheroid (k, ind_refRel, SemiAxisA, SemiAxisB, Nrank, Nint, T)  
      call product_matrices (2*Nrank, 2*Nrank, 2*Nrank, T, 2*Nrank, 2*Nrank,        &
           AB, 2*Nrank, 2*Nrank)  
    else 		 
      allocate (tv11(Nrank), tv12(Nrank), tv21(Nrank), tv22(Nrank))
      call AverageTmatrixSpheroid (k, ind_refRel, SemiAxisA, SemiAxisB, Nrank,      &
           Nint, tv11, tv12, tv21, tv22)
      call product_AverageTmatrix (Nrank, tv11, tv12, tv21, tv22, Nrank,            &
           AB, 2*Nrank, 2*Nrank, T, 2*Nrank, 2*Nrank)	
      deallocate (tv11, tv12, tv21, tv22)		     		 
    end if		   
  else
    allocate (tv(2*Nrank))
    call coefficients_fg_m (k, SemiAxisA, ind_refRel, 1, Nrank, Nrank, tv)                  
    call product_matrix_vector1 (2*Nrank, 2*Nrank, tv, AB, 2*Nrank, 2*Nrank,        &
         T, 2*Nrank, 2*Nrank)
    deallocate (tv)		    
  end if
  fact = 24._O * c / ((k * a)**2 - (kX * a)**2)
  do i = 1, 2*Nrank
    do j = 1, 2*Nrank
      if (i == j) then
        T(i,j) = one - fact * T(i,j)
      else
        T(i,j) = - fact * T(i,j)
      end if
    end do
  end do
  call determinant (T, 2*Nrank, 2*Nrank, 2*Nrank, det)
  Pv = det   
  deallocate (AB, T)
end subroutine DeterminantEFMEDSpheroid
!***********************************************************************************
subroutine DeterminantLWLSpheroid (kX, k, r, c, T11, T22, T12, T21, P)
  use parameters
  implicit none
  real(O)    :: r, c, k
  complex(O) :: kX, T11, T22, T12, T21, P
!
  complex(O) :: x, xx, x2, ci, JH0, JH1, JH2, A, B, a11, a12, a21, a22
!    
  x   = cmplx(k * r,0.0,O) 
  xx  = kX * r
  x2  = x**2 - xx**2
  ci  = 3._O * im * c
  JH0 = ci / x / x2 + (1._O - c)**4 / (1._O + 2._O * c)**2
  JH1 = ci * xx / x / x / x2
  JH2 = ci * xx**2 / x / x / x / x2
  A   = JH0 + 0.5_O * JH2
  B   = 1.5_O * JH1
  a11 = one - ( T11 * A + T12 * B )
  a12 = - ( T11 * B + T12 * A )
  a21 = - ( T21 * A + T22 * B )
  a22 = one - ( T21 * B + T22 * A )
  P   = a11 * a22 - a12 * a21
end subroutine DeterminantLWLSpheroid
!***********************************************************************************
subroutine TmatrixSpheroid (k, ind_ref, SemiAxisA, SemiAxisB, Nrank, Nint, T)                
  use parameters
  implicit none   
  integer       :: Nrank, Nint
  real(O)       :: k, SemiAxisA, SemiAxisB
  complex(O)    :: ind_ref, T(2*Nrank,2*Nrank)  
!      
  integer       :: Nmax, TypeGeom, Nsurf, Nparam, Nface, i, j, m
  real(O)       :: rp(2,NfacePD), np(2,NfacePD), area(NfacePD), kb
  logical       :: FileGeom, miror, perfectcond, DS, chiral
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: surf(:), zRe(:), zIm(:), paramG(:,:), pondereG(:,:)
  complex(O),allocatable :: a(:,:)
!       
  m      = 1
  Nmax   = Nrank
  DS     = .false.          
  chiral = .false.       
  kb     =  0.1  
  miror  = .false. 
  perfectcond = .false.          
  FileGeom = .false.
  TypeGeom = 1                                                
  Nsurf    = 2  
  allocate (surf(Nsurf))               
  surf(1) = SemiAxisA              
  surf(2) = SemiAxisB               
  Nparam  = 1                               
  Nface   = 1
  do i = 1, NfacePD
    do j = 1, 2
      rp(j,i) = 0._O
      np(j,i) = 0._O
    end do
    area(i) = 0._O
  end do 			    
  allocate (zRe(Nrank), zIm(Nrank)) 
  do i = 1, Nrank
    zRe(i)  = 0._O
    zIm(i)  = 0._O   
  end do              
  allocate (a(2*Nrank,2*Nrank))  
  allocate (paramG(Nparam,Nint), pondereG(Nparam,Nint), Nintparam(Nparam))
  call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,                &
       Nintparam, paramG, pondereG, miror)	   	   	         
  call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,       &
       area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,      &
       pondereG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)      
  call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,       &
       area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,      &
       pondereG, miror, perfectcond, DS, chiral, kb, T, Nrank, Nrank)                           
  call LU_SYSTEM (a, 2*Nrank, 2*Nrank, T, 2*Nrank, 2*Nrank, 2*Nmax)                                   
  deallocate (a, surf, zRe, zIm, paramG, pondereG, Nintparam)
end subroutine TMatrixSpheroid
!***********************************************************************************
subroutine AverageTmatrixSpheroid (k, ind_ref, SemiAxisA, SemiAxisB, Nrank, Nint,   &
           tv11, tv12, tv21, tv22)                
  use parameters
  implicit none   
  integer       :: Nrank, Nint
  real(O)       :: k, SemiAxisA, SemiAxisB
  complex(O)    :: ind_ref, tv11(Nrank), tv12(Nrank), tv21(Nrank), tv22(Nrank)   
!      
  integer       :: Nmax, TypeGeom, Nsurf, Nparam, Nface, i, j, m, n, kn
  real(O)       :: rp(2,NfacePD), np(2,NfacePD), area(NfacePD), kb, fact
  logical       :: FileGeom, miror, perfectcond, DS, chiral
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: surf(:), zRe(:), zIm(:), paramG(:,:), pondereG(:,:)
  complex(O),allocatable :: a(:,:), T(:,:)
!       
  DS     = .false.          
  chiral = .false.       
  kb     =  0.1  
  miror  = .false. 
  perfectcond = .false.          
  FileGeom = .false.
  TypeGeom = 1                                                
  Nsurf    = 2  
  allocate (surf(Nsurf))               
  surf(1) = SemiAxisA              
  surf(2) = SemiAxisB               
  Nparam  = 1                               
  Nface   = 1
  do i = 1, NfacePD
    do j = 1, 2
      rp(j,i) = 0._O
      np(j,i) = 0._O
    end do
    area(i) = 0._O
  end do 			    
  allocate (zRe(Nrank), zIm(Nrank)) 
  do i = 1, Nrank
    zRe(i)  = 0._O
    zIm(i)  = 0._O   
  end do              
  allocate (a(2*Nrank,2*Nrank), T(2*Nrank,2*Nrank))  
  allocate (paramG(Nparam,Nint), pondereG(Nparam,Nint), Nintparam(Nparam))
  call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,                &
       Nintparam, paramG, pondereG, miror)	   	   	                                           
  do n = 1, Nrank
    tv11(n) = zero
    tv12(n) = zero
    tv21(n) = zero
    tv22(n) = zero
  end do
  do m = 0, Nrank        
    if (m == 0) then
      Nmax = Nrank
    else
      Nmax = Nrank - m + 1
    end if  
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         pondereG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank) 
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         pondereG, miror, perfectcond, DS, chiral, kb, T, Nrank, Nrank)                       
    call LU_SYSTEM (a, 2*Nrank, 2*Nrank, T, 2*Nrank, 2*Nrank, 2*Nmax)
    do kn = 1, Nmax
      if (m == 0) then
        n    = kn
        fact = 1._O
      else
        n    = m + kn - 1
        fact = 2._O
      end if
      tv11(n) = tv11(n) + fact * T(kn,kn)
      tv12(n) = tv12(n) + fact * T(kn,kn+Nmax)
      tv21(n) = tv21(n) + fact * T(kn+Nmax,kn)
      tv22(n) = tv22(n) + fact * T(kn+Nmax,kn+Nmax)
    end do  
  end do
  do n = 1, Nrank
    fact    = 1._O / (2._O * n + 1._O)
    tv11(n) = fact * tv11(n)
    tv12(n) = fact * tv12(n)
    tv21(n) = fact * tv21(n)
    tv22(n) = fact * tv22(n)			
  end do  
  deallocate (a, T, surf, zRe, zIm, paramG, pondereG, Nintparam)
end subroutine AverageTMatrixSpheroid
!***********************************************************************************
subroutine matrix_translationAB_mn_m1n1_EFMED (wavenumber, wavenumberX, a, c, Nrank,&
           Nbeta, pow, powN, AB, NP, MP)
  use parameters
  implicit none
  integer    :: Nrank, Nbeta, pow, powN, NP, MP
  real(O)    :: a, c, wavenumber 
  complex(O) :: wavenumberX, AB(2*NP,2*MP)
!  
  integer    :: Nsup, n, n1, n2, pint
  real(O)    :: abeta, bbeta, beta, f, nn1
  complex(O) :: ka, kaX, sum, Fn2, fact, nm, hder, jder, fpp, ftt, fpt, ftp 
  real(O),allocatable    :: bt(:), wt(:), Pn(:), dPn(:), pin(:), taun(:),           &
                            Pnm(:), dPnm(:), pinm(:), taunm(:)
  complex(O),allocatable :: j(:), jd(:), h(:), hd(:), Fn2C(:)
!
  Nsup = 4 * Nrank ! we can use a lower limit for summation, i.e., Nsup = 2*Nrank;
  do n1 = 1, 2*Nrank
    do n = 1, 2*Nrank
      AB(n1,n) = zero
    end do  
  end do 
  allocate (j(0:Nsup+1), jd(0:Nsup+1), h(0:Nsup+1), hd(0:Nsup+1))
  allocate (bt(Nbeta), wt(Nbeta))
  allocate (Pn(0:Nsup), dPn(0:Nsup), pin(0:Nsup), taun(0:Nsup))
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank)) 
  ka  = cmplx(2._O * wavenumber * a,0.0,O)
  kaX = 2._O * wavenumberX * a     
  call besel_h (ka, Nsup + 1, h, hd)
  call besel_j (kaX, Nsup + 1, j, jd)  
  allocate (Fn2C(0:Nsup))
  call Fn2Cor (wavenumber, wavenumberX, a, c, pow, powN, Nsup, Fn2C)
  abeta = 0._O
  bbeta = Pi
  call Gauss_Legendre (abeta, bbeta, Nbeta, wt, bt)   
  do pint = 1, Nbeta
    beta = bt(pint)
    call Leg_normalized (beta, 0, Nsup, Pn, dPn, pin, taun)
    sum = zero
    do n2 = 0, Nsup
      hder = n2 * h(n2) / ka - h(n2+1)
      jder = n2 * j(n2) / kaX - j(n2+1)
      Fn2  = 0.5_O * (ka * hder * j(n2) - kaX * jder * h(n2))         
      Fn2  = Fn2 + Fn2C(n2)	  
      f = (- 1._O)**n2 * sqrt(real(2 * n2 + 1,O) / 2._O)
      sum = sum + f * Fn2 * Pn(n2)
    end do      
    fact = sum * wt(pint) * sin(beta)
    call Leg_normalized (beta, 1, Nrank, Pnm, dPnm, pinm, taunm)          
    do n = 1, Nrank      
      do n1 = 1, Nrank        
        nn1 = real(n * (n + 1) * n1 * (n1 + 1),O)
        nm  = im**(n1 - n) * fact / sqrt(nn1)		
        fpp = pinm(n)  * pinm(n1)  * nm
        ftt = taunm(n) * taunm(n1) * nm
        fpt = pinm(n)  * taunm(n1) * nm
        ftp = taunm(n) * pinm(n1)  * nm 
        AB(n,n1)       = AB(n,n1) + (fpp + ftt)        
		AB(n,n1+Nrank) = AB(n,n1+Nrank) - (fpt + ftp)	
      end do  
    end do 	 	                                           
  end do
  do n = 1, Nrank
    do n1 = 1, Nrank
      AB(n+Nrank,n1)       = AB(n,n1+Nrank)
      AB(n+Nrank,n1+Nrank) = AB(n,n1)
     end do  
  end do                           
  deallocate (j, jd, h, hd, bt, wt, Pn, dPn, pin, taun, Pnm, dPnm, pinm,            &
              taunm, Fn2C)
end subroutine matrix_translationAB_mn_m1n1_EFMED
!***********************************************************************************
subroutine MullerQCACP (wavenumberEFMED, wavenumberMED, ind_refRel, a, c, Niter,    &
           epsX, epsY, Conv, kX)
  use parameters
  implicit none 
  integer    :: Niter
  real(O)    :: a, c, epsX, epsY, wavenumberMed
  complex(O) :: wavenumberEFMED, ind_refRel, kX 
  logical    :: Conv                       
!  
  integer    :: iter
  real(O)    :: deltaX
  complex(O) :: delta, x0, x1, x2, x, P0, P1, P2, s, t, u, den, den1, d, q         
!  
  delta = 0.01_O * wavenumberEFMED
  x0 = wavenumberEFMED
  x1 = x0 + delta
  x2 = x1 + delta  
  call FuncQCACP (x0, wavenumberMED, ind_refRel, a, c, P0) 
  call FuncQCACP (x1, wavenumberMED, ind_refRel, a, c, P1)
  call FuncQCACP (x2, wavenumberMED, ind_refRel, a, c, P2)                       
  iter = 0
  Conv = .false.    
  do while ((iter < Niter) .and. (.not.Conv))
    iter = iter + 1
    q = (x2 - x1) / (x1 - x0)                   
    s = q * P2 - q * (1._O + q) * P1 + q**2 * P0
    t = (2._O * q + 1._O) * P2 - (1._O + q)**2 * P1 + q**2 * P0
    u = (1._O + q) * P2
    d = sqrt(t**2 - 4._O * s * u)
    den  = t + d
    den1 = t - d
    if (abs(den) < abs(den1)) den = den1 
    x = x2 - (x2 - x1) * 2._O * u / den    
    deltaX = abs(x - x2)
    if (abs(x - x1) < abs(x - x0)) then
      s  = x1
      x1 = x0
      x0 = s
      t  = P1
      P1 = P0
      P0 = t
    else if (abs(x - x1) > abs(x - x2)) then
      s  = x2  
      x2 = x1  
      x1 = s
      t  = P2  
      P2 = P1  
      P1 = t
    end if
    x2 = x        
    call FuncQCACP (x2, wavenumberMED, ind_refRel, a, c, P2)    
    if ((deltaX < epsX) .and. (abs(P2) < epsY)) Conv = .true.           
  end do
  if (imag(x2) >= 0._O) then    
    kX = x2 
  else
    kX = wavenumberEFMED
  end if
end subroutine MullerQCACP 
!***********************************************************************************
subroutine FuncQCACP (kX, k, ind_refRel, a, c, PQCA) 
  use parameters
  implicit none
  real(O)    :: a, c, k
  complex(O) :: kX, ind_refRel, PQCA
!
  complex(O) :: ks, k2, ka3, dk, fct
!
  ks  = k * ind_refRel
  k2  = ks * ks - k * k
  ka3 = k2 * kX * a**3
  dk  = k2 / (3._O * kX * kX)
  fct = c * k2 / (1._O + dk * (1._O - c))
  fct = fct * (1._O + im * 2._O * ka3 * (1._O - c)**4 /                             &
       (9._O * (1._O + dk * (1._O - c)) * (1._O + 2._O * c)**2))
  PQCA = fct + k**2 - kX**2
end subroutine FuncQCACP
!***********************************************************************************
subroutine Fn2Cor (wavenumber, wavenumberX, a, c, p, pN, Nsup, Fn2C)
  use parameters
  implicit none
  integer    :: p, pN, Nsup
  real(O)    :: a, c, wavenumber
  complex(O) :: wavenumberX, Fn2C(0:Nsup) 
!
  integer    :: N, kmin, k, n2
  real(O)    :: dx, xl, gPY, w
  complex(O) :: sum, ka, kaX
  real(O),allocatable    :: x(:), G(:)
  complex(O),allocatable :: j(:), jd(:), h(:), hd(:)
!
  N = 2**pN
  allocate (x(N), G(N))
  allocate (j(0:Nsup), jd(0:Nsup), h(0:Nsup), hd(0:Nsup))
  call PYVct (c, p, N, x, G, kmin)  
  dx = 1._O / 2**(pN - p)  
  do n2 = 0, Nsup
    sum = zero
    do k = kmin, N
      if (k == kmin .or. k == N) then
        w = 0.5_O * dx
      else
        w = dx
      end if
      xl  = x(k)                  
      gPY = G(k)
      ka  = cmplx(2._O * wavenumber * a * xl,0.0,O)
      kaX = 2._O * wavenumberX * a * xl     
      call besel_h (ka, Nsup, h, hd)
      call besel_j (kaX, Nsup, j, jd) 
      sum = sum + (gPY - 1._O) * h(n2) * j(n2) * xl * xl * w      
    end do            
    Fn2C(n2) = 2._O * ((wavenumber * a)**2 - (wavenumberX * a)**2) * sum
  end do
  deallocate (x, G, j, jd, h, hd)
end
!***********************************************************************************   
subroutine PYVct (c, p, N, x, G, kmin)
  use parameters
  implicit none
  integer :: p, N, kmin
  real(O) :: c, x(N), G(N)
!
  integer :: j, k
  real(O) :: Nr, N1r, L, du, uj, dx, f, max 
!
  Nr  = real(N,O)
  N1r = Nr - 1._O
  L   = Pi * N1r / 2**p  
  du  = L / N1r 
  do j = 1, N    
    uj   = real(j - 1,O) * du
    G(j) = f(c,uj) * du
  end do 
  call SINFT (G, N)
  dx = Pi / Nr / du
  do k = 1, N
    x(k) = real(k - 1,O) * dx
    if (x(k) >= 1._O) then
      G(k) = 1._O + G(k) / x(k)
    else
      G(k) = 0._O
    end if
  end do
! --- compute kmin for which the maximum of G is attained ---
  max  = - 1.e+10_O
  kmin =   0
  do k = 1, N
    if (G(k) > max) then
      max  = G(k)
      kmin = k
    end if
  end do                          
end subroutine PYVct   
!***********************************************************************************
function f(c,u) result(func)
  use parameters
  real(O),intent(in) :: c, u
  real(O) :: func
  real(O) :: a, b, d, g
!
  a =   (1._O + 2._O * c)**2 / (1._O - c)**4
  b = - 6._O * c * (1._O + 0.5_O * c)**2 / (1._O - c)**4
  d =   0.5_O * c * a  
  g =   (a + b + d) * u**4 * cos(u) - (a + 2 * b + 4 * d) * u**3 * sin(u) -         &
        2._O * (b + 6 * d) * u**2 * cos(u) + 2._O * b * u**2 +                      &
        24._O * d * u * sin(u) + 24._O * d * (cos(u) - 1._O)   
  g =   (u**6 / (u**6 - 24._O * c * g) - 1._O) / 24._O / c           
  func = 2._O * g * u / Pi
end function f
! **********************************************************************************
subroutine product_AverageTmatrix (Nrank, tv11, tv12, tv21, tv22, ntp, a, nap, map, &
           b, nbp, mbp)
!-----------------------------------------------------------------------------------
!     The routine computes the matrix product:                                     ! 
!         | t11   t12 |   | a11   a12 |   | t11*a11 + t12*a21   t11*a12 + t12*a22 |!
!     b = |           | * |           | = |                                       |!
!         | t21   t22 |   | a21   a22 |   | t21*a11 + t22*a21   t21*a12 + t22*a22 |!
!     where t11, t12, t21, t22 are diagonal matrices.                              !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Nrank, ntp, nap, map, nbp, mbp, j, i
  complex(O) :: tv11(ntp), tv12(ntp), tv21(ntp), tv22(ntp), a(nap,map), b(nbp,mbp)
!
  do i = 1, Nrank
    do j = 1, Nrank
      b(i,j)             = tv11(i) * a(i,j)       + tv12(i) * a(i+Nrank,j)
	  b(i,j+Nrank)       = tv11(i) * a(i,j+Nrank) + tv12(i) * a(i+Nrank,j+Nrank)
      b(i+Nrank,j)       = tv21(i) * a(i,j)       + tv22(i) * a(i+Nrank,j)
	  b(i+Nrank,j+Nrank) = tv21(i) * a(i,j+Nrank) + tv22(i) * a(i+Nrank,j+Nrank)
    end do
  end do      
end subroutine product_AverageTmatrix
! ***********************************************************************************
! *             FAST SIN TRANSFORM ROUTINE FROM NUMERICAL RECIPES                   *
! ***********************************************************************************
subroutine SINFT (Y, N)
  use parameters
  implicit none
  integer :: N, M, j
  real(O) :: Y(N), wr, wi, wpr, wpi, wtemp, theta, Y1, Y2, sum
!
  theta = Pi / N
  wr  =   1._O
  wi  =   0._O
  wpr = - 2._O * sin(0.5_O * theta)**2
  wpi =   sin(theta)
  M   =   N / 2
  Y(1) = 0._O  
  do j = 1, M
    wtemp = wr
    wr = wr * wpr - wi * wpi + wr
    wi = wi * wpr + wtemp * wpi + wi
    Y1 = wi * (Y(j+1) + Y(N-j+1))
    Y2 = 0.5_O * (Y(j+1) - Y(N-j+1))
    Y(j+1)   = Y1 + Y2
    Y(N-j+1) = Y1 - Y2
  end do
  call REALFT (Y, M, 1)
  sum  = 0._O
  Y(1) = 0.5_O * Y(1)
  Y(2) = 0._O
  do j = 1, N - 1, 2
    sum    = sum + Y(j)
    Y(j)   = Y(j+1)
    Y(j+1) = sum
  end do
end subroutine SINFT
!*********************************************************************************
subroutine REALFT (Y, N, isign)
  use parameters
  implicit none
  integer :: N, isign, n2p3, i, i1, i2, i3, i4
  real(O) :: Y(2*N), wr, wi, wpr, wpi, wtemp, c1, c2, h1r, h1i, h2r, h2i, theta
!    
  theta = Pi / N
  c1    = 0.5_O
  if (isign == 1) then
    c2 = - 0.5_O
    call FOUR (Y, N, +1)
  else
    c2    =   0.5_O
    theta = - theta
  end if
  wpr  = - 2._O * sin(0.5_O * theta)**2
  wpi  =   sin(theta)
  wr   =   1._O + wpr
  wi   =   wpi
  n2p3 =   2 * N + 3
  do i = 2, N/2 + 1
    i1  = 2 * i - 1
    i2  = i1 + 1
    i3  = n2p3 - i2
    i4  = i3 + 1
    h1r =   c1 * (Y(i1) + Y(i3))
    h1i =   c1 * (Y(i2) - Y(i4))
    h2r = - c2 * (Y(i2) + Y(i4))
    h2i =   c2 * (Y(i1) - Y(i3))
    Y(i1) =   h1r + wr * h2r - wi * h2i
    Y(i2) =   h1i + wr * h2i + wi * h2r
    Y(i3) =   h1r - wr * h2r + wi * h2i
    Y(i4) = - h1i + wr * h2i + wi * h2r
    wtemp = wr
    wr = wr * wpr - wi * wpi + wr
    wi = wi * wpr + wtemp * wpi + wi
  end do     
  if (isign == 1) then   
    h1r  = Y(1)
    Y(1) = h1r + Y(2)
    Y(2) = h1r - Y(2)       
  else
    h1r  = Y(1)
    Y(1) = c1 * (h1r + Y(2))
    Y(2) = c1 * (h1r - Y(2))                
    call FOUR (Y, N, -1)
  end if
end subroutine REALFT  
!*********************************************************************************
subroutine FOUR (Y, NN, isign)
  use parameters
  implicit none
  integer :: NN, isign, n, j, i, m, mmax, istep
  real(O) :: Y(2*NN), tempr, tempi, wr, wi, wpr, wpi, wtemp, theta   
!      
  n = 2 * nn              
  j = 1
  do i = 1, n, 2
    if (j > i) then
      tempr  = Y(j)
      tempi  = Y(j+1)
      Y(j)   = Y(i)
      Y(j+1) = Y(i+1)
      Y(i)   = tempr
      Y(i+1) = tempi
    end if
    m = n / 2  
    do while (m >= 2 .and. j > m)
      j = j - m
      m = m / 2   
    end do
    j = j + m
  end do            
  mmax = 2
  do while (n > mmax)
    istep =   2 * mmax
    theta =   2._O * Pi / (isign * mmax)
    wpr   = - 2._O * sin(0.5_O * theta)**2
    wpi   =   sin(theta)
    wr = 1._O
    wi = 0._O
    do m = 1, mmax, 2
      do i = m, n, istep
        j = i + mmax
        tempr  = wr * Y(j) - wi * Y(j+1)
        tempi  = wr * Y(j+1) + wi * Y(j)
        Y(j)   = Y(i) - tempr
        Y(j+1) = Y(i+1) - tempi
        Y(i)   = Y(i) + tempr
        Y(i+1) = Y(i+1) + tempi
      end do
      wtemp = wr
      wr = wr * wpr - wi * wpi + wr
      wi = wi * wpr + wtemp * wpi + wi
    end do
    mmax = istep
  end do                                                
end subroutine FOUR 

subroutine TCOMP
!------------------------------------------------------------------------------------
! 1. General Considerations                                                         !
! --------------------------                                                        !
! TCOMP is a routine for computing the T matrix and the scattering characteristics  !
! of axisymmetric composite particles. A composite particle consists of several     !
! nonenclosing regions (parts), each characterized by arbitrary but constant        !
! values of electric permittivity and magnetic permeability.                        !
!                                                                                   !
! A composite particle is divided into homogeneous regions. The electric and        !
! magnetic fields of a specific region i can be approximated by using localized     !
! or distributed vector spherical wave functions, and Nrankp(i) will be referred    !
! to as the maximum expansion order of the region i.                                !
!                                                                                   !
! The transition matrix of a composite particle can be obtained by considering the  !
! null-field equation for the total electric field inside each region. Note that    !
! for axisymmetric composite particles, the scattering problem decouples over the   !
! azimuthal modes m and the T matrix can be computed separately for each m.         !
!                                                                                   !
! Particle geometries currently supported include: half-spheroids with offset       ! 
! origins and three cylinders. The following routines (from the file "GeomLib.f90") !
! provide the required geometry parameters:                                         !
! - the routine "interpolation_listCOMP" computes the integration nodes and         !
!   weights for each generatrix curve,                                              !
! - the routine "elem_geomCOMP" provides the geometry parameters (position vector,  !
!   polar and azimuthal angles and normal unit vector in spherical coordinates)     !
!   at each integration node, and                                                   !
! - the routine "zDSCOMP" generates the coordinates of the distributed sources.     !
! The generatrix of each homogeneous region is described with respect to a local    !
! coordinate system and the axial positions of the local coordinate systems are     !
! specified in the global coordinate system of the composite particle. By           !
! convention, the COORDINATES OF THE DISTRIBUTED SOURCES corresponding to a         !
! specific region are provided in the GLOBAL COORDINATE SYSTEM. The user can easily !
! modify the above routines to generate particles with other geometries. Note that  !
! the list of parameters must be maintained and only geometries with an analytical  !
! description of the surface can be implemented.                                    !
!                                                                                   !
! 2. Convergence Test                                                               !
! --------------------                                                              !
! Convergence tests precede the scattering characteristics calculation. The         !
! following parameters control the T-matrix computation:                            !
! - the number of integration points Nint,                                          !
! - the maximum expansion order for each region Nrankp,                             !
! - the maximum expansion order for the composite particle Nrank, and               !
! - the maximum azimuthal order Mrank.                                              !
!                                                                                   !
! Before going any further, we will explain the significance of the parameters      !
! controlling the convergence process. Let Nrankp(i) denotes the maximum expansion  !
! order of the region i, i = 1,2,...,Npart, where Npart is the number of            !
! nonenclosing regions. Nrank determines the dimension of the T matrix (centered    !
! at the origin of the global coordinate system) and, by convention, Nrank will be  !
! referred to as the maximum expansion order of the composite particle.             !
! Analogously, Nint will be referred to as the global number of integration points  !
! for the composite particle and its significance will be described below. The      !
! generatrix curve i (corresponding to the homogeneous region i) consists of        !
! NparamPart(i) piecewise smooth curves. On each smooth curve j, j = 1,2,...,       !
! NparamPart(i), the number of integration points is                                !
!                                                                                   !
!               Nint_region_curve(i,j) = int { c(i,j) * Nint },                     !
!                                                                                   !
! where c(i,j) is a multiplicative factor. The parameters c(i,j), do not appear     !
! as explicit parameters; they are hard coded in the routine                        !
! "interpolation_listCOMP" from the file "GeomLib.f90". For half-spheroids, Nint    !
! is the number of integration points corresponding to each half-spheroid. The       !
! generatrix of a half-spheroid is divided into a quarter-ellipse and a straight    !
! line. Denoting by a the semi-axis of the spheroid along the axis of symmetry and  !
! by b the second semi-axis, we have                                                !
!                                                                                   !
!    Nint_region_curve(half-spheroid,quarter-ellipse) = int {Le * Nint / (Le + b)}  !
!                                                                                   !
! and                                                                               !
!                                                                                   !  
!    Nint_region_curve(half-spheroid,line) = Nint - int {Le * Nint / (Le + b)},     !
!                                                                                   !
! where                                                                             !
!                                                                                   !
!             Le = Pi * { 3(a + b) - sqrt[(a + 3b) * (3a + b)] } / 4                !
!                                                                                   !
! is an approximation of the length of the quarter-ellipse.                         !  
! For three cylinders, Nint is the number of integration points corresponding to    !
! each cylinder. The generatrix of a cylinder is divided into three straight lines. ! 
! The first and third lines are perpendicular to the axis of symmetry, while the    !
! second line is parallel to the axis of symmetry. Denoting by a the half-length    !
! of the cylinder and by b the cylinder radius, we have:                            !
!                                                                                   !
!               Nint_region_curve(cylinder,first line)                              !
!      = Nint_region_curve(cylinder,third line) = int {[b/2/(a + b)] * Nint}        !
!                                                                                   !
! and                                                                               !
!                                                                                   !
!                 Nint_region_curve(cylinder, second line)                          ! 
!                 = Nint - 2 * int {[b/2/(a + b)] * Nint }.                         !
!                                                                                   !
! The above selection rules choose the same number of integration points (Nint)     !
! for each homogeneous regions. Therefore, a conservative parameter choice rule is  !
!                                                                                   !  
!                      Nint = max {Nint_region},                                    !
!                                                                                   !
! where Nint_region(i) is the required number of integration points for the         !
! homogeneous region i.                                                             !
!                                                                                   !
! For convergence tests, the incident wave is assumed to be a plane wave traveling  !
! along the Z-axis of the global coordinate system and the scattering               !
! characteristics are computed in the azimuthal plane phi = 0°.                     !
!                                                                                   !
! For the integration and expansion order test, an axisymmetric orientation of the  !
! particle is considered, i.e., the incident wave propagates along the axis of      !
! symmetry of the particle. In this case, all azimuthal modes are zero except       !
! for m = - 1 and m = 1. For the convergence test over the number of integration    !
! points, the scattering problem is solved for Nint and Nint + dNint, while for     !
! the convergence test over the expansion orders, the scattering problem is         !
! solved for                                                                        !
!                                                                                   !
!                 Nrankp(i), i = 1,2,...,Npart, and Nrank,                          !
!                                                                                   !
! and                                                                               !
!                 Nrankp(i) - 1, i = 1,2,...,Npart, and Nrank - 1.                  !
!                                                                                   !
! By convention, the convergence test over the expansion orders will be referred    !
! to as the convergence test over Nrank. The normalized differential scattering     !
! cross section (DSCS) will be checked at 20° increments for convergence within     !
! epsX (epsNint or epsNrank) tolerance. If the calculated results converge within   !
! this tolerance at 80% of the scattering angles, then convergence is achieved.     !
!                                                                                   ! 
! When the convergence tests over Nrank and Nint are finished, we pass to the       !
! azimuthal order test. The program automatically sets the particle to a more       !
! general orientation, i.e., alpha = beta = 45°, and solves the scattering problem  !
! for increasing m values until convergence of the angular scattering is achieved.  !
! The T matrix is stored for later use by other programs, and the values of Nrank   !
! and Mrank are printed to the screen and to the T-matrix information file.  These  !
! values together with the T matrix serve as INPUT PARAMETERS for other programs.   !
!                                                                                   !
! 3. Estimates of Nint and Nrank                                                    !
! -------------------------------                                                   !
! The above convergence tests require estimates for Nint, Nrankp(i),                ! 
! i = 1,2,...,Npart, and Nrank. These estimates are user-defined.                   !
!                                                                                   !
! Reasonable starting values of Nrankp and Nrank are given by Wiscombe's truncation !
! limit criterion [W. J. Wiscombe, Improved Mie scattering algorithms, Applied      !
! Optics, 19, 1505-1509, 1980]. For Nrankp, we have                                 !
!                                                                                   !                     
!                NrankpW = int(xp + 4.05 * xp**0.33 + 2),                           !
!                                                                                   ! 
! where xp is the size parameter of the region, xp = k * lnormPart, k is the wave   !
! number and lnormPart is the radius of the smallest sphere circumscribing the      !
! region. The estimate of Nrank is                                                  !
!                                                                                   !
!                NrankW = int(x + 4.05 * x**0.33 + 2),                              !
!                                                                                   !
! where x is the size parameter of the composite particle, x = k * Rcirc, and       !
! Rcirc is the radius of the smallest sphere circumscribing the composite particle. !
!                                                                                   !
! The value of Nint depends on the type of discrete sources, the size parameter,    !
! and the optical properties of the composite particle. Denoting by Nrankpmax the   !
! maximum value of Nrankp(i), i = 1,2,...,Npart, i.e.,                              !
!                                                                                   !
!                        Nrankpmax = max {Nrankp(i)},                               !
!                                                                                   !
! we propose the following estimate                                                 !
!                                                                                   ! 
!                        Nint = Ndgs * Nrankpmax,                                   !
!                                                                                   !
! where Ndgs = 15, 20, 25, .... For distributed sources, the value of Nint should   !
! be substantially larger than the value corresponding to localized sources.        !
!                                                                                   !
! 4. Strategies for Performing Convergence Tests                                    !
! -----------------------------------------------                                   !
! Two strategies for performing convergence tests over Nint and Nrank are           !
! recommended. The following technique is an extension of the approach used for     !
! homogeneous axisymmetric particles:                                               !
! 1. for each region i, choose a value of Nrankp(i) close to the value predicted    !
!    by Wiscombe's truncation limit criterion and proceed similarly for Nrank;      !
! 2. for the set Nrankp(i) and Nrank, perform the expansion order test with         !
!    Nint = Ndgs * Nrankpmax, where e.g., Ndgs = 15;                                !
! 3. if convergence is not achieved, set Nrankp(i) = Nrankp(i) + 1 for all regions  !
!    i, set Nrank = Nrank + 1, maintain the relation Nint = Ndgs * Nrankpmax and    !
!    go to Step 2;                                                                  !
! 4. if convergence is achieved, perform several integration tests with the         ! 
!    initial Nint-value, Nint = Ndgs * Nrankpmax, until the DSCS converges.         !
! At Step 3, it is not necessary to increase all Nrankp-values (for all regions).   !
! If the user has the feeling that some Nrankp-values are correct, these values     !
! need not to be changed.                                                           !  
!                                                                                   !
! For large and/or highly aspherical composite particles, T-matrix computations     !
! become poorly covergent or divergent. Frequently, a semi-convergent behaviour is  !
! attended: the errors decrease with increasing the maximum expansion order,        !
! attain a relative constant level and afterwards increase. The region of           !
! stability can be localized by using the following technique:                      !
! 1. for each region i, choose a value of Nrankp(i) smaller than the value          !
!    predicted by Wiscombe's truncation limit criterion and proceed similarly for   !
!    Nrank;                                                                         !
! 2. for the set Nrankp(i) and Nrank, perform several integration tests with the    !
!    initial Nint-value, Nint = Ndgs * Nrankpmax, until the DSCS converges;         !
! 3. if convergence is not achieved, set Nrankp(i) = Nrankp(i) - 1,                 !
!    i = 1,2,...,Npart, and Nrank = Nrank - 1, or increase the tolerance epsNint,   !
!    and go to Step 2,                                                              !
! 4. if convergence is achieved (for some Nint), perform several expansion order    !
!    tests for increasing Nrankp- and Nrank-values and monitor the errors of the    !
!    differential scattering cross sections.                                        ! 
! As before, at Steps 3 and 4, not all Nrankp-values need to be changed.            !
!                                                                                   !
! For particles which are too extreme in size and/or aspect ratio, the errors of    !
! the extinction and scattering cross sections (instead of the differential         !
! scattering cross section) can be analyzed.                                        ! 
!                                                                                   !
! 5. Additional Comments                                                            !
! -----------------------                                                           !
! For the expansion order test and distributed sources, two configurations of       !
! sources are considered. For both configurations, the coordinates of the           !
! distributed sources can be generated automatically or can be specified in the     !
! input file.                                                                       !
!                                                                                   !
! The convergence tests over Nint and Nrank can be switched off by setting the      !
! logical variable DoConvTest to false. In this case, the values of Nint,           !
! Nrankp(i), i = 1,2,...,Npart, and Nrank must be specified in the input file.      !
!                                                                                   !
! Nint and Nrank have been determined for the azimuthal orders m = 1 and m = - 1.   ! 
! For higher azimuthal orders and sources distributed in the complex plane, the     !
! chosen values of Nint and Nrank may lead to false convergence. There are two      !
! strategies for improving the numerical stability.                                 !
! 1. The number of integration points can be increased at each azimuthal mode       !
! calculation with the integration step dNintMrank. The parameter dNintMrank        !
! should be found experimentally by repeating the azimuthal order test for          !
! different input values until the differential scattering cross section converges. !
! A conservative estimate is: dNintMrank = (0.1,...,0.2) * Nint.                    !
! 2. For sources generated automatically, an interactive convergence test over      !
! Nint and Nrank can be performed at each azimuthal mode calculation. The general   !
! strategy is to reduce the number of discrete sources (Nrankp(i), i = 1,2,...,     !
! Npart) and to increase the number of integration points (Nint) for increasing     !
! values of m.  However, in the current version of the program, this test is not    !
! active (see the comments in the subroutine "convergence_MrankDSCOMP").            !
!                                                                                   !
! The number of azimuthal modes is the same for all regions, and for localized      !
! sources, the relation Mrank <= Nrankp(i), for all i = 1,2,...,Npart, should be    !
! satisfied. However, Nrankp(i), i = 1,2,...,Npart, are determined before Mrank     !
! is computed. Therefore, for the azimuthal mode calculation m, with |m| > 1,       !
! we set Nrankp(i) = |m|, if Nrankp(i) < |m| for some i. In this case, the maximum  !
! expansion order of a region is m-dependent and                                    !
!                                                                                   !
!                    n = |m|,|m|+1,...,Nrankp(i,|m|).                               !
!                                                                                   !
! 6. Input Parameters                                                               !
! ---------------------                                                             !
! The parameters specified in the input file "/INPUTFILES/InputCOMP.dat" are listed !
! below                                                                             !
!                                                                                   !
! - wavelength (real) - wavelength of the incident light in vacuo.                  !
!                                                                                   !
! - ind_refMed (real) - refractive index of the ambient medium (nonabsorbing        !
!   dielectric medium).                                                             !
!                                                                                   !
! - TypeGeom (integer) - parameter specifying the type of the particle geometry.    !
!                                                                                   !
! - Npart (integer) - number of homogeneous regions.                                !
!                                                                                   !
! - anorm (real) - characteristic length of the composite particle which is used    !
!   to normalize the differential scattering cross sections.                        !
!                                                                                   !
! - Rcirc (real) - characteristic length of the composite particle (usually the     !
!   radius of the smallest circumscribing sphere) which is used to compute an       !
!   estimate of the maximum expansion order by using Wiscombe's truncation limit    !
!   criterion. Alternatively, Rcirc can be chosen as the equal-volume sphere radius !
!   or the surface-equivalent-sphere radius.                                        !
!                                                                                   !
! - DoConvTest (logical) - if DoConvTest = t, the interactive convergence tests     !
!   over Nint and Nrank are invoked. Estimates of Nrank for all homogeneous         !
!   regions are provided by Wiscombe's truncation limit criterion. If               !
!   DoConvTest = f, the values of Nint and Nrank must be supplied in the input      !
!   file.                                                                           !
!                                                                                   !
! - DS (logical) - if DS = t, distributed sources are used for T-matrix             !
!   calculation, otherwise localized sources are employed.                          !
!                                                                                   !
! - autGenDS (logical) - if autGenDS = t, the routine "zDSCOMP" generates the       !
!   coordinates of the distributed sources. Otherwise, the coordinates of the       !
!   distributed sources must be provided by the user. If DS = f, the logical        !
!   variable autGenDS is ignored.                                                   !
!                                                                                   !
! - Nint (integer) - global number of integration points for the composite          !
!   particle. This parameter is used if the convergence tests are not performed     !
!   (DoConvTest = f).                                                               !
!                                                                                   !
! - Nrank (integer) - maximum expansion order for the composite particle. This      !
!   parameter is used if the convergence tests are not performed (DoConvTest = f).  !
!                                                                                   !
! The next parameters (specified in a sequence of group statements) characterize     !
! each homogeneous region.                                                          !
! - ind_refPartRel (complex) - relative refractive index of the actual region       !
!   with respect to the ambient medium. The imaginary part of the relative          !
!   refractive index must be zero for nonabsorbing particles and positive for       !
!   absorbing particles.                                                            !
!                                                                                   !
! - NsurfPart (integer) - number of surface parameters of the actual region.        !
!                                                                                   !
! - NparamPart (integer) - number of smooth curves forming the generatrix curve of  !
!   the actual region.                                                              !
!                                                                                   !
! - OriginPart (real) - axial position of the local coordinate system of the        !
!   actual region with respect to the global coordinate system of the composite     !
!   particle. This parameter can be positive or negative.                           !
!                                                                                   !
! - surfPart (real array: surfPart(1), surfPart(2),...,surfPart(NsurfPart)) -       !
!   surface parameters specifying the shape of the actual region. The dimension of  !
!   the array is NsurfPD. The integer parameter NsurfPD is specified in the         !
!   routine  "Parameters.f90" and has the value NsurfPD = 10.                       !
!   If NsurfPart > NsurfPD, the execution is automatically terminated.              !
!                                                                                   !
!   The permissive values of the surface parameters (for the supported geometries)  !
!   are listed below.                                                               !
!                                                                                   !
!      Particle      TypeGeom  NsurfPart  NparamPart          surfPart              !      
!   half-spheroids                                                                  !
!    with offset         1         3         2         surfPart(1) - length of the  !
!      origins                                             semi-axis along the      !
!                                                          symmetry axis            !    
!                                                      surfPart(2) - length of the  !
!                                                          second semi-axis         !
!                                                      surfPart(3) - distance       !
!                                                          between the half-        ! 
!                                                          spheroid basis and the   !
!                                                          origin of the local      !
!                                                          coordinate system        ! 
!                                                                                   !   
!    3 cylinders         2         2         3         surfPart(1) - half-length    !
!                                                          of the cylinder          !  
!                                                      surfPart(2) - cylinder       !
!                                                          radius                   !
!                                                                                   !
!   For half-spheroids, surf(3) specifies the position of the local coordinate      !
!   system, and this parameter has been introduced for a general characterization   !
!   of the surface. It is recommended to set surfPart(3) = 0.5 * surfPart(1). For   !
!   touching half-spheroids, surf(3) = |OriginPart|, and THIS SPECIFIC SITUATION    !
!   IS CONSIDERED IN THE CODE. Note that the program DOES NOT CHECK if this         !
!   condition is satisfied.                                                         !
!                                                                                   !
! - lnormPart (real) - characteristic length of the actual region (usually the      !
!   radius of the smallest circumscribing sphere) which is used to compute an       !
!   estimate of the maximum expansion order by using Wiscombe's truncation limit    !
!   criterion. Alternatively, lnormPart can be chosen as the equal-volume sphere    !
!   radius or the surface-equivalent-sphere radius.                                 ! 
!                                                                                   !
! - ComplexPlanePart (logical) - if ComplexPlanePart = t, the distributed sources   !
!   are situated in the complex plane. This parameter is used if distributed sources!
!   are required and the coordinates of the distributed sources are automatically   !
!   generated (DS = t and autGenDS = t).                                            !
!                                                                                   !
! - EpsZReImPart (real) - input parameter of the routine "zDSCOMP" which controls  !
!   the distribution of the discrete sources. This parameter is used if distributed !
!   sources are required and the coordinates of the distributed sources are         !
!   automatically generated (DS = t and autGenDS = t).                              !
!                                                                                   !
! - NrankPart (integer) - maximum expansion order for the actual region. This       !
!   parameter is used if the convergence tests are not performed or the coordinates !
!   of the distributed sources are user-defined. More specifically, NrankPart is    !
!   used if                                                                         !
!   - (DS = f, DoConvTest = f),                                                     !
!   - (DS = t, autGenDS = t, DoConvTest = f), or                                    ! 
!   - (DS = t, autGenDS = f, DoConvTest = t/f).                                     !                                                                  !
!                                                                                   !
! - zRePart, zImPart (real arrays: zXPart(1), zXPart(2),...,zXPart(Nrankp),         !
!   X = Re, Im) - coordinates of the distributed sources for the actual region and  !
!   the expansion order NrankPart. These parameters are used if the coordinates of  !
!   the distributed sources are user-defined (DS = t and autGenDS = f). The         !
!   dimension of the arrays zRePart and zImPart is NrankPD and the inequality       !
!   NrankPart <= NrankPD must hold. The integer parameter NrankPD is specified in   !
!   the routine "Parameters.f90" and has the value NrankPD = 200. If                !
!   NrankPart > NrankPD, the execution is automatically terminated. Note that the   !
!   coordinates of the distributed sources are defined with respect to the GLOBAL   !
!   COORDINATE SYSTEM of the composite particle.                                    !
!                                                                                   !
! - zRePart1, zImPart1 (real arrays: zXPart1(1), zXPart1(2),...,zXPart1(Nrankp-1),  !
!   X = Re, Im) - coordinates of the distributed sources for the actual region and  !
!   the expansion order NrankPart - 1. These parameters are used if the             !
!   coordinates of the distributed sources are user-defined and the expansion order !
!   test is performed (DS = t and autGenDS = f and TypeConvTest = 2). The dimension !
!   of the arrays zRePart1 and zImPart1 is NrankPD. As before, zRePart1 and         !
!   zImPart1 are defined with respect to the GLOBAL COORDINATE SYSTEM of the        !
!   composite particle.                                                             !
!                                                                                   !
! NOTE: THE INPUT ARRAYS zRe, zIm AND zRe1, zIm1 MUST BE SPECIFIED IF (DS = t AND   !
! autGenDS = f), AND MUST BE SEPARATED BY A BLANK LINE. IF THE EXPANSION ORDER TEST !
! IS NOT PERFORMED (TypeConvTest /= 2), THE INPUT ARRAYS zRePart1 AND zImPart1      !
! CAN BE OMITTED.                                                                   !
!                                                                                   !
! - epsNint (real) - error tolerance for the integration test.                      !
!                                                                                   !
! - epsNrank (real) - error tolerance for the expansion order test.                 !
!                                                                                   !
! - epsMrank (real) - error tolerance for the azimuthal order test.                 !
!                                                                                   !
! - dNint (integer) - number of division points for the integration test. Note      !
!   that the scattering problem is solved for Nint and Nint + dNint.                ! 
!                                                                                   !
! - dNintMrank (integer) - number of division points for azimuthal mode             !
!   calculation. This parameter is used if distributed sources are employed         !
!   (DS = t) and THERE EXISTS AT LEST ONE LAYER with ComplexPlanePart = t. At       !
!   each azimuthal mode calculation, the number of integration points increases     !
!   with dNintMrank. For regions with sources distributed along the symmetry axis,  !
!   the number of integration points is also increased.                             !
!                                                                                   !
! - FileTmat (character(80)) - name of the file to which the T matrix is written.   !
!                                                                                   !
! - PrnProgress (logical) - if PrnProgress = t, the progress of calculation         !
!   is printed.                                                                     !
!                                                                                   !
! Note that all input parameters specifying lengths must be provided in the same    !
! units of lengths.                                                                 !
!                                                                                   !
! The statements with the group names OptRegProp, GeomRegProp, SourceRegPosAut,     !
! NrankReg and SourceRegPosInp characterize a specific region. THESE STATEMENTS     !
! MUST BE REPEATED FOR ALL Npart REGIONS.                                           !
!                                                                                   !
! 7. Logical Scheme                                                                 !
! ------------------                                                                !  
! The organization of the code is as follows:                                       !
! 1. < read input data >                                                            !
! 2. < T-matrix calculation >                                                       !
!                                                                                   !
!    if ( use localized sources ) then                                              !
!                                                                                   !
!       if ( do convergence test) then                                              !
!          < the code computes an estimate of Nrankp(i) for each region i           !
!            by using Wiscombe's truncation criterion, and prompts for the          !
!            input value of Nrankp(i) >                                             !
!          < the code computes an estimate of Nrank for the composite particle      !
!            by using Wiscombe's truncation criterion >                             !
!          < the code prompts for the estimated values of Nint and Nrank for the    !
!            composite particle >                                                   !
!          < the code prompts for the type of convergence test:                     !
!            1 - over Nint, 2 - over Nrank or 3 - over Mrank >                      !
!       else if ( .not. do convergence test) then                                   !
!          < the input file provides the values of Nrankp(i) for each region i >    !
!          < the input file provides the values of Nint and Nrank for the           !
!            composite particle>                                                    !
!          type of convergence test = 3 (convergence test over Mrank)               !     
!       end if                                                                      !
!                                                                                   !
!    else if ( use distributed sources ) then                                       !
!                                                                                   !
!       if ( use automatic sources generation ) then                                !
!          if ( do convergence test) then                                           !
!             < the code computes an estimate of Nrankp(i) for each region i        !
!               by using Wiscombe's truncation criterion, and prompts for the       !
!               input value of Nrankp(i) >                                          !
!             < the code generates the coordinates of the distributed sources for   !
!               Nrankp(i) and all regions i >                                       !
!             < the code computes an estimate of Nrank for the composite particle   !
!               by using Wiscombe's truncation criterion >                          !
!             < the code prompts for the estimated values of Nint and Nrank for the !
!               composite particle>                                                 !
!             < the code prompts for the type of convergence test:                  !
!               1 - over Nint, 2 - over Nrank or 3 - over Mrank >                   !
!             if ( do expansion order test ) then                                   !
!                < the code generates the coordinates of the distributed sources    !
!                  for Nrankp(i) - 1 and all regions i >                            !
!             end if                                                                !
!          else if ( .not. do convergence test) then                                !
!             < the input file provides the values of Nrankp(i) for each region i > !
!             < the code generates the coordinates of the distributed sources for   !
!               Nrankp(i) and all regions i >                                       !
!             < the input file provides the values of Nint and Nrank for the        !
!               composite particle >                                                !
!             type of convergence test = 3 (convergence test over Mrank)            !
!       else if ( .not. use automatic sources generation ) then                     !
!          if ( do convergence test) then                                           !
!             < the input file provides the values of Nrankp(i) for each region i > !
!             < the input file provides the coordinates of the distributed sources  !
!               for Nrankp(i) and all regions i >                                   !
!             < the code computes an estimate of Nrank for the composite particle   !
!               by using Wiscombe's truncation criterion >                          !
!             < the code prompts for the estimated values of Nint and Nrank for the !
!               composite particle >                                                !
!             < the code prompts for the type of convergence test:                  !
!               1 - over Nint, 2 - over Nrank or 3 - over Mrank >                   !
!             if ( do maximum expansion order test ) then                           !
!                < the input file provides the coordinates of the distributed       !
!                  sources for Nrankp(i) - 1 and all regions i >                    !
!             end if                                                                !
!          else if ( .not. do convergence test) then                                !
!             < the input file provides the values of Nrankp(i) for each region i > !
!             < the input file provides the coordinates of the distributed sources  !
!               for Nrankp(i) and all regions i >                                   !
!             < the input file provides the values of Nint and Nrank for the        !
!               composite particle >                                                !
!             type of convergence test = 3 (convergence test over Mrank)            !  
!          end if                                                                   !
!       end if                                                                      !
!                                                                                   !
!    end if                                                                         !
!    if ( do integration test, i.e., type of convergence test = 1 ) then            !
!       < the code computes the DSCS for Nint and Nint + dNint and                  !
!         write the results to the file "Output.dat" >                              !
!       < the execution is terminated >                                             !
!    end if                                                                         !
!    if ( do expansion order test, i.e., type of convergence test = 2 ) then        !
!       < the code computes the DSCS for Nrankp(i), Nrank and Nrankp(i)-1, Nrank-1  ! 
!         and write the results to the file "Output.dat" >                          !
!       < the execution is terminated >                                             !
!    end if                                                                         !
!    if ( do azimuthal order test, i.e., type of convergence test = 3 ) then        !
!       < the code computes the DSCS for increasing m values and                    !
!         write the results to the file "Output.dat">                               !
!       if ( use distributed sources .and. use automatic sources generation         !
!           .and. sources are distributed in the complex plane ) then               ! 
!          < an interactive convergence test over Nint and Nrank can be performed   !
!            at each azimuthal mode m  >                                            ! 
!        end if                                                                     !
!        Note: to make this test active comment out some lines in the subroutine    !
!        "convergence_MrankDSCOMP".                                                 ! 
!       < the T matrix is stored in the file FileTmat and the T-matrix information  !
!         file is created >                                                         !
!       < Mrank and Nrank are printed to the screen and to the T-matrix             !
!         information file >                                                        !
!       < go to Step 3 >                                                            !
!    end if                                                                         !
! 3. < scattering characteristics calculation >                                     !
!------------------------------------------------------------------------------------
  use parameters  
  use allocation, only: Nsurf, Nparam, Nrankp, Nrankp1, surf, zpart, zRe, zIm,      &
                        zRe1, zIm1, lnorm, ind_ref, ComplexPlane, EpsZReIm    
  implicit none 
  integer       :: TypeGeom, Npart, dNint, TypeConvTest, Nsurfmax, Nparammax,       &
                   Nrankpmax, Nrankpmax1, Nint, Nrank, dNintMrank
  real(O)       :: k, ind_refMed, wavelength, anorm, snorm, epsNint, epsNrank,      &
                   epsMrank                                                 
  logical       :: DoConvTest, DS, autGenDS, PrnProgress 
  character(80) :: FileTmat  
! -----------------------------------------------------------------------------------
!                             Read the input file                                   ! 
! -----------------------------------------------------------------------------------  
  call readinputCOMP ( wavelength, ind_refMed, TypeGeom, Npart, anorm,              &
       DoConvTest, DS, autGenDS, Nint, Nrank, epsNint, epsNrank, epsMrank, dNint,   &
       dNintMrank, FileTmat, PrnProgress, k, snorm, Nsurfmax, Nparammax, Nrankpmax, &
       Nrankpmax1, TypeConvTest )                                
! -----------------------------------------------------------------------------------
!                                      Main                                         !
! ----------------------------------------------------------------------------------- 
  open (unit = iOutput, file = FileOutput, status = "replace")   
  call printinputCOMP (TypeConvTest, TypeGeom, Nsurfmax, Nsurf, surf, Nparam, Npart,&
       lnorm, anorm, Nrankpmax, Nrankp, zpart, zRe, zIm, Nrankpmax1, Nrankp1,       &
       zRe1, zIm1, ind_ref, dNint, wavelength, ind_refMed, epsNint, epsNrank,       &
       epsMrank, DS, autGenDS)
  if (DoConvTest) then         
    if (TypeConvTest == 1) then
      if (.not. DS) then
        call convergence_NintCOMP (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,     &
             Nparammax, Nparam, Npart, Nrankp, zpart, Nrank, Nint, dNint,           &
             epsNint, PrnProgress)
      else 
        call convergence_NintDSCOMP (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,   &
             Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, Nrank,   &
             Nint, dNint, epsNint, PrnProgress)
      end if
    else if (TypeConvTest == 2) then
      if (.not. DS) then
        call convergence_NrankCOMP (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,    &
             Nparammax, Nparam, Npart, Nrankp, zpart, Nrank, Nint, epsNrank,        &
             PrnProgress)  
      else 
        call convergence_NrankDSCOMP (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,  &
             Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, Nrankpmax1,     &
             Nrankp1, zRe1, zIm1, zpart, Nrank, Nint, epsNrank, PrnProgress)
      end if
    else 
      if (.not. DS) then
        call convergence_MrankCOMP (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,    &
             Nparammax, Nparam, Npart, Nrankp, zpart, Nrank, Nint, epsMrank,        &
             FileTmat, PrnProgress)
      else 
        call convergence_MrankDSCOMP (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,  &
             Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, Nrank,   &
             Nint, ComplexPlane, EpsZReIm, autGenDS, epsMrank, epsNrank,            &
             dNintMrank, FileTmat, PrnProgress)
      end if
    end if   
  else    
    if (.not. DS) then
      call convergence_MrankCOMP (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,      &
           Nparammax, Nparam, Npart, Nrankp, zpart, Nrank, Nint, epsMrank,          &
           FileTmat, PrnProgress)
    else 
      call convergence_MrankDSCOMP (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,    &
           Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, Nrank,     &
           Nint, ComplexPlane, EpsZReIm, autGenDS, epsMrank, epsNrank,              &
           dNintMrank, FileTmat, PrnProgress)
    end if
  end if  
  close (unit = iOutput)          
  deallocate (zRe, zIm, zRe1, zIm1) 
  deallocate (surf, Nsurf, Nparam, Nrankp, Nrankp1, ind_ref, zpart, lnorm)
  deallocate (ComplexPlane, EpsZReIm)  
end subroutine TCOMP
!***********************************************************************************
subroutine readinputCOMP ( wavelength, ind_refMed, TypeGeom, Npart, anorm,          &
           DoConvTest, DS, autGenDS, Nint, Nrank, epsNint, epsNrank, epsMrank,      &
           dNint, dNintMrank, FileTmat, PrnProgress, k, snorm, Nsurfmax, Nparammax, &
           Nrankpmax, Nrankpmax1, TypeConvTest ) 
  use parameters
  use derived_parameters
  use allocation, only: Nsurf, Nparam, Nrankp, Nrankp1, surf, zpart, zRe, zIm,      &
                        zRe1, zIm1, lnorm, EpsZReIm, ind_ref, ComplexPlane  
  implicit none 
  integer       :: TypeGeom, Npart, NsurfPart, NparamPart, dNint, TypeConvTest, i,  &
                   ipart, isurf, Nsurfmax, Nparammax, Nrankpmax, Nrankpmax1, Nint,  &
                   dNintMrank, NrankPart, Nrank, NrankW, ios
  real(O)       :: k, ind_refMed, wavelength, anorm, surfPart(NsurfPD), xpart,      &
                   snorm, epsNint, epsNrank, epsMrank, OriginPart, zRePart(NrankPD),&
                   x, zImPart(NrankPD), zRePart1(NrankPD), zImPart1(NrankPD),       &
                   lnormPart, EpsZReImPart, Rcirc                        
  complex(O)    :: ind_refPartRel
  logical       :: DoConvTest, DS, autGenDS, InputDS, ComplexPlanePart,             &
                   PrnProgress, XFindPar  
  character(80) :: FileTmat, string  
! -----------------------------------------------------------------------------------
!                          Read the input file FileInputCOMP                        ! 
! ----------------------------------------------------------------------------------- 
  call DrvParameters  
  open (unit = iInputCOMP, file = FileInputCOMP, status = "old", position = "rewind")   
  wavelength = 0.1_O * 2._O * Pi
  ind_refMed = 1._O
  string     = 'OptProp'
  if (XFindPar (iInputCOMP, string)) then
    read (iInputCOMP, *, iostat = ios) wavelength                
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if
    read (iInputCOMP, *, iostat = ios) ind_refMed
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refMed;')"
      stop
    end if         
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if      
  k = 2._O * Pi * ind_refMed / wavelength
!
  TypeGeom = 1
  Npart    = 2
  anorm    = 1._O
  Rcirc    = 1._O
  string   = 'GeomProp'
  if (XFindPar (iInputCOMP, string)) then
    read (iInputCOMP, *, iostat = ios) TypeGeom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable TypeGeom;')"
      stop
    end if
    read (iInputCOMP, *, iostat = ios) Npart
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Npart;')"
      stop
    end if
    read (iInputCOMP, *, iostat = ios) anorm
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anorm;')"
      stop
    end if
    read (iInputCOMP, *, iostat = ios) Rcirc
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Rcirc;')"
      stop
    end if    
  else
    print "(/,2x,'Group name GeomProp not found;')"
    stop  
  end if 
  call check_anorm (anorm)  
  xpart = k * anorm
  snorm = Pi * xpart * xpart     
!
  DoConvTest = .true.
  string     = 'ConvTest'
  if (XFindPar (iInputCOMP, string)) then
    read (iInputCOMP, *, iostat = ios) DoConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DoConvTest;')"
      stop
    end if          
  else
    print "(/,2x,'Group name ConvTest not found;')"
    stop  
  end if             
!
  DS = .false.
  autGenDS = .true. 
  string     = 'Sources'
  if (XFindPar (iInputCOMP, string)) then
    read (iInputCOMP, *, iostat = ios) DS
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DS;')"
      stop
    end if
    read (iInputCOMP, *, iostat = ios) autGenDS
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable autGenDS;')"
      stop
    end if         
  else
    print "(/,2x,'Group name Sources not found;')"
    stop  
  end if    
  InputDS = .false.
  if (DS .and. .not. autGenDS) InputDS = .true. 
!
  allocate (Nsurf(Npart), Nparam(Npart), ind_ref(Npart), zpart(Npart), lnorm(Npart))
  Nsurfmax  = 1
  Nparammax = 1
  do ipart = 1, Npart
    ind_refPartRel = (1.5_O,0._O)
    string = 'OptRegProp'
    if (XFindPar (iInputCOMP, string)) then
      read (iInputCOMP, *, iostat = ios) ind_refPartRel
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable ind_refPartRel;')"
        print "(  2x,'for the region ',i3,';')", ipart
        stop
      end if                                                   
    else
      print "(/,2x,'Group name OptRegProp not found;')"
      print "(  2x,'for the region ',i3,';')", ipart
      stop  
    end if      
    call check_ind_ref1 (ipart, ind_refPartRel)
    ind_ref(ipart) = ind_refPartRel                        
!
    NsurfPart  = 3
    NparamPart = 2
    OriginPart = 0._O
    do isurf = 1, NsurfPD
      surfPart(isurf) = 1._O
    end do
    lnormPart = 1._O
    string    = 'GeomRegProp'
    if (XFindPar (iInputCOMP, string)) then
      read (iInputCOMP, *, iostat = ios) NsurfPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable NsurfPart;')"
        print "(  2x,'for the region ',i3,';')", ipart
        stop
      end if      
      if (NsurfPart > NsurfPD) then
        print "(/,2x,'Input error: NsurfPart exceeds NsurfPD for the region',i3)", &
                ipart                                    
        stop
      end if            
      read (iInputCOMP, *, iostat = ios) NparamPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable NparamPart;')"
        print "(  2x,'for the region ',i3,';')", ipart
        stop
      end if
      read (iInputCOMP, *, iostat = ios) OriginPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable OriginPart;')"
        print "(  2x,'for the region ',i3,';')", ipart
        stop
      end if
      do isurf = 1, NsurfPart
        read (iInputCOMP, *, iostat = ios) surfPart(isurf)
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable surfPart;')"
          print "(  2x,'for the region ',i3,';')", ipart
          stop
        end if
      end do
      read (iInputCOMP, *, iostat = ios) lnormPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable lnormPart;')"
        print "(  2x,'for the region ',i3,';')", ipart
        stop
      end if
    else
      print "(/,2x,'Group name GeomRegProp not found;')"
      print "(  2x,'for the region ',i3,';')", ipart
      stop  
    end if    
    Nsurf(ipart) = NsurfPart
    Nparam(ipart)= NparamPart
    zpart(ipart) = OriginPart
    lnorm(ipart) = lnormPart
    if (Nsurf(ipart)  > Nsurfmax)   Nsurfmax  = Nsurf(ipart)
    if (Nparam(ipart) > Nparammax)  Nparammax = Nparam(ipart)
  end do
  rewind (unit = iInputCOMP)
  allocate (surf(Npart,Nsurfmax))
  do ipart = 1, Npart 
    do isurf = 1, Nsurfmax
      surf(ipart,isurf) = 0._O
    end do 
    NsurfPart  = 3
    NparamPart = 2
    OriginPart = 0._O
    do isurf = 1, NsurfPD
      surfPart(isurf) = 1._O
    end do
    lnormPart = 1._O
    string    = 'GeomRegProp'
    if (XFindPar (iInputCOMP, string)) then
      read (iInputCOMP, *, iostat = ios) NsurfPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable NsurfPart;')"
        print "(  2x,'for the region ',i3,';')", ipart
        stop
      end if
      read (iInputCOMP, *, iostat = ios) NparamPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable NparamPart;')"
        print "(  2x,'for the region ',i3,';')", ipart
        stop
      end if
      read (iInputCOMP, *, iostat = ios) OriginPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable OriginPart;')"
        print "(  2x,'for the region ',i3,';')", ipart
        stop
      end if
      do isurf = 1, NsurfPart
        read (iInputCOMP, *, iostat = ios) surfPart(isurf)
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable surfPart;')"
          print "(  2x,'for the region ',i3,';')", ipart
          stop
        end if
      end do
      read (iInputCOMP, *, iostat = ios) lnormPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable lnormPart;')"
        print "(  2x,'for the region ',i3,';')", ipart
        stop
      end if
    else
      print "(/,2x,'Group name GeomRegProp not found;')"
      print "(  2x,'for the region ',i3,';')", ipart
      stop  
    end if
    do isurf = 1, NsurfPart
      surf(ipart,isurf) = surfPart(isurf)
    end do                    
  end do 
  call check_geomCOMP (TypeGeom, Npart, Nsurf, Nparam)
!
  allocate (ComplexPlane(Npart), EpsZReIm(Npart))
  rewind (unit = iInputCOMP)
  do ipart = 1, Npart
    ComplexPlane(ipart) = .false.
    EpsZReIm(ipart) = 0.95_O
    if (DS .and. autGenDS) then
      ComplexPlanePart = .false.
      EpsZReImPart = 0.95_O
      string       = 'SourceRegPosAut'
      if (XFindPar (iInputCOMP, string)) then
        read (iInputCOMP, *, iostat = ios) ComplexPlanePart
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable ComplexPlanePart;')"
          print "(  2x,'for the region ',i3,';')", ipart
          stop
        end if
        read (iInputCOMP, *, iostat = ios) EpsZReImPart
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable EpsZReImPart;')"
          print "(  2x,'for the region ',i3,';')", ipart
          stop
        end if               
      else
        print "(/,2x,'Group name SourceRegPosAut not found;')"
        print "(  2x,'for the region ',i3,';')", ipart
        stop  
      end if        
      ComplexPlane(ipart) = ComplexPlanePart
      EpsZReIm(ipart) = EpsZReImPart
    end if
  end do
!  
  if (DoConvTest) then
    print "(/,2x,'Convergence Test for a Composite Particle')" 
    print "(  2x,'-----------------------------------------')"       
  else
    print "(/,2x,'Convergence Test for a Composite Particle over Mrank')" 
    print "(  2x,'----------------------------------------------------')"    
  end if                          
  allocate (Nrankp(Npart), Nrankp1(Npart)) 
  rewind (unit = iInputCOMP)
  Nrankpmax  = 1
  Nrankpmax1 = 1
  do ipart = 1, Npart
    x = k * lnorm(ipart)
    NrankW = int(x + 4.05_O * x**0.33_O + 2._O)
    if (.not. DoConvTest .or. InputDS) then
      NrankPart = 17
      string    = 'NrankReg'
      if (XFindPar (iInputCOMP, string)) then
        read (iInputCOMP, *, iostat = ios) NrankPart
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable NrankPart;')"
          print "(  2x,'for the region ',i3,';')", ipart
          stop
        end if
      else
        print "(/,2x,'Group name NrankReg not found;')"
        print "(  2x,'for the region ',i3,';')", ipart
        stop  
      end if       
      Nrankp(ipart) = NrankPart
      if (ipart == 1) print "(/,2x,'Nrank input values:')"
      print "(2x,'the input value of Nrank for the region ',i3,' is ', i4,',')",    &
              ipart, NrankPart
      print "(2x, a, i3, a)",                                                       &
     'while the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';' 
    else    
      if (ipart == 1) print "(/,2x,'Nrank estimates:')"  
      print "(2x,'the estimated value of Nrank from Wiscombe''s criterion')" 
      print "(2x,'for region ',i2,' is ',i3,';')", ipart, NrankW 
      print "(2x,'- enter the estimated value of Nrank for region ',i2)", ipart
      call read_integer (Nrankp(ipart))
    end if
    if (Nrankp(ipart) > Nrankpmax) Nrankpmax = Nrankp(ipart)
    Nrankp1(ipart) = Nrankp(ipart) - 1
    if (Nrankp1(ipart) > Nrankpmax1) Nrankpmax1 = Nrankp1(ipart)
  end do    
!
  rewind (unit = iInputCOMP)
  x = k * Rcirc
  NrankW = int(x + 4.05_O * x**0.33_O + 2._O)    
  if (DoConvTest) then
    print "(/,2x,'Global Nrank estimate:')"                                                            
    print "(  2x, a, i3, a)",                                                       &  
   'the estimated value of the global Nrank from Wiscombe''s criterion is ',        &
    NrankW, ';'
    print "(/,2x, a)",                                                              &
   '- enter the estimated values of Nint and Nrank, where Nint = Ndgs * Nrankpmax'
    print "(  2x,'  Ndgs = 15,20,..., and Nrankpmax = ',i4,';')", Nrankpmax  
    call read_integer2 (Nint, Nrank)                
  else    
    Nint   = 100
    Nrank  =  17    
    string = 'NintNrank'
    if (XFindPar (iInputCOMP, string)) then
      read (iInputCOMP, *, iostat = ios) Nint
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nint;')"
        stop
      end if
      read (iInputCOMP, *, iostat = ios) Nrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nrank;')"
        stop
      end if                
    else
      print "(/,2x,'Group name NintNrank not found;')"
      stop  
    end if  
    print "(/,2x,'Input values:')"
    print "(  2x, a, i4, a, i4, a)",                                                & 
   'the input values of Nint and Nrank are ', Nint, ' and ', Nrank, ', respectively,'  
    print "(  2x, a, i3, a)",                                                       &
   'while the estimate of the global Nrank from Wiscombe''s criterion is ', NrankW,','
    print "(  2x, a, i3, a)",                                                       &
   'and Nint = Ndgs * Nrankpmax, with Ndgs = 15,20,..., and Nrankpmax = ',          &
    Nrankpmax,';'                                       
  end if
!
  if (DoConvTest) then     
    print "(/,2x, a)",                                                              &
   '- enter the type of convergence test: 1 - Nint, 2 - Nrank, 3 - Mrank;'
    call read_integerbound (TypeConvTest, 1, 3)     
  else    
    TypeConvTest = 3 
  end if
!
  allocate (zRe(Npart,Nrankpmax), zIm(Npart,Nrankpmax), zRe1(Npart,Nrankpmax1),     &
            zIm1(Npart,Nrankpmax1)) 
  rewind (unit = iInputCOMP)
  do ipart = 1, Npart    
    do i = 1, Nrankpmax         
      zRe(ipart,i) = 0._O
      zIm(ipart,i) = 0._O
    end do
    do i = 1, Nrankpmax1            
      zRe1(ipart,i) = 0._O
      zIm1(ipart,i) = 0._O
    end do
    if (DS) then
      call check_MaxNrank (Nrankpmax)
      if (autGenDS) then
        call zDSCOMP (TypeGeom, Npart, Nsurfmax, surf, Nrankpmax, Nrankp, zpart,     &
             ComplexPlane, EpsZReIm, zRe, zIm)
        if (TypeConvTest == 2) call zDSCOMP (TypeGeom, Npart, Nsurfmax, surf,        &
                                    Nrankpmax1, Nrankp1, zpart, ComplexPlane,        &
                                    EpsZReIm, zRe1, zIm1)
      else
        do i = 1, NrankPD
          zRePart(i)  = 0._O
          zImPart(i)  = 0._O
          zRePart1(i) = 0._O
          zImPart1(i) = 0._O
        end do 
        string = 'SourceRegPosInp'
        if (XFindPar (iInputCOMP, string)) then
          do i = 1, Nrankp(ipart)
            read (iInputCOMP, *, iostat = ios) zRePart(i), zImPart(i)
            if (ios /= 0) then
              print "(/,2x, a)",                                                    &
             'Error by reading the input variables zRePart and zImPart;'	      
              print "(  2x,'for the region ',i3,';')", ipart
              stop
            end if 
          end do
          if (TypeConvTest == 2) then	  
            read (iInputCOMP, *)
            do i = 1, Nrankp(ipart) - 1
              read (iInputCOMP, *, iostat = ios) zRePart1(i), zImPart1(i)
              if (ios /= 0) then
                print "(/,2x, a)",                                                  &
               'Error by reading the input variables zRePart1 and zImPart1;'		
                print "(  2x,'for the region ',i3,';')", ipart
                stop
              end if 
            end do
          end if 	    
        else
          print "(/,2x,'Group name SourceRegPosInp not found;')"
          print "(  2x,'for the region ',i3,';')", ipart
          stop  
        end if
        do i = 1, Nrankp(ipart)
          zRe(ipart,i) = zRePart(i)  
          zIm(ipart,i) = zImPart(i)               
        end do
        if (TypeConvTest == 2) then             
          do i = 1, Nrankp1(ipart)
            zRe1(ipart,i) = zRePart1(i) 
            zIm1(ipart,i) = zImPart1(i) 
          end do          
        end if  
      end if                                
    end if
  end do         
!
  epsNint  = 5.e-2_O
  epsNrank = 5.e-2_O
  epsMrank = 5.e-2_O
  dNint = 4  
  dNintMrank = 10
  string     = 'Errors'
  if (XFindPar (iInputCOMP, string)) then
    read (iInputCOMP, *, iostat = ios) epsNint
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNint;')"
      stop
    end if
    read (iInputCOMP, *, iostat = ios) epsNrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNrank;')"
      stop
    end if
    read (iInputCOMP, *, iostat = ios) epsMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsMrank;')"
      stop
    end if 
    read (iInputCOMP, *, iostat = ios) dNint
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable dNint;')"
      stop
    end if  
    read (iInputCOMP, *, iostat = ios) dNintMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable dNintMrank;')"
      stop
    end if                 
  else
    print "(/,2x,'Group name Errors not found;')"
    stop  
  end if
!
  FileTmat = '../TMATFILES/T.dat'
  string   = 'Tmat' 
  if (XFindPar (iInputCOMP, string)) then
    read (iInputCOMP, *, iostat = ios) FileTmat
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileTmat;')"
      stop
    end if             
  else
    print "(/,2x,'Group name Tmat not found;')"
    stop  
  end if   
!
  PrnProgress = .true.
  string   = 'PrintProgress' 
  if (XFindPar (iInputCOMP, string)) then
    read (iInputCOMP, *, iostat = ios) PrnProgress
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if             
  else
    print "(/,2x,'Group name PrintProgress not found;')"
    stop  
  end if        
  close (unit = iInputCOMP)            
end subroutine readinputCOMP      
!***********************************************************************************
subroutine printinputCOMP (ic, TypeGeom, Nsurfmax, Nsurf, surf, Nparam, Npart,      &
           lnorm, anorm, Nrankpmax, Nrankp, zpart, zRe, zIm, Nrankpmax1, Nrankp1,   &
           zRe1, zIm1, ind_ref, dNint, wavelength, ind_refMed, epsNint, epsNrank,   &
           epsMrank, DS, autGenDS)
  use parameters
  implicit none  
  integer    :: ic, TypeGeom, Nsurfmax, Npart, Nrankpmax, Nrankpmax1, dNint,        &
                Nrankp(Npart), Nrankp1(Npart), Nparam(Npart), Nsurf(Npart),         &
                NsurfPart, Nrank, i, j
  real(O)    :: wavelength, anorm, surf(Npart,Nsurfmax), zpart(Npart), lnorm(Npart),&
                zRe(Npart,Nrankpmax), zIm(Npart,Nrankpmax),                         &
                zRe1(Npart,Nrankpmax1), zIm1(Npart,Nrankpmax1),                     &
                epsNint, epsNrank, epsMrank, ind_refMed
  complex(O) :: ind_ref(Npart)  
  logical    :: DS,autGenDS
!
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x,'wavelength of the free space, wavelength = ',1pe13.4,';')")  &
         wavelength
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'refractive index of the ambient medium, ind_refMed = ', ind_refMed, ';'
  write (iOutput,"(2x,'relative refractive index of each homogeneous region:')")
  do i = 1, Npart         
    if (i /= Npart) then
      write (iOutput,"(2x,'ind_ref(',i2,') = (',1pe13.4,',',1pe13.4,'),')")         &
             i, ind_ref(i)
    else
      write (iOutput,"(2x,'ind_ref(',i2,') = (',1pe13.4,',',1pe13.4,');')")         &
             i, ind_ref(i)	     	     	     
    end if
  end do    
  write (iOutput,*)
  write (iOutput,"(2x,'index of the particle geometry, TypeGeom = ',i2,';')")       &
         TypeGeom
  if (TypeGeom == 1) then
    write (iOutput,"(2x,'half-spheroids;')")    
  else if (TypeGeom == 2) then
    write (iOutput,"(2x,'three cylinders;')")   
  end if
  write (iOutput,"(2x,'number of homogeneous regions, Npart = ',i2,';')") Npart
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'characteristic length of the composite particle, anorm = ', anorm, ';'
  do i = 1,Npart
    write (iOutput,*)
    write (iOutput,"(2x,'region: ',i2)") i
    write (iOutput,"(2x,'number of surface parameters, Nsurf = ',i2,';')") Nsurf(i)
    write (iOutput,"(2x,'surface parameters:')")
    NsurfPart = Nsurf(i)
    do j = 1, NsurfPart
      write (iOutput,"(2x,'surf(',i2,') = ',1pe10.3,',')") j, surf(i,j)      
    end do       
    if (TypeGeom == 1) then
      write (iOutput,"(2x,'where surf(1) is the semi-axis along the symmetry axis,')")
      write (iOutput,"(2x,'surf(2) is the second semi-axis and')")
      write (iOutput,"(2x,'surf(3) is the axial position of the particle origin;')")
    else if (TypeGeom == 2) then
      write (iOutput,"(2x,'where surf(1) is the half-length of the cylinder')")
      write (iOutput,"(2x,'and   surf(2) is the cylinder radius;')")
    end if  
    write (iOutput,"(2x,'number of integration surfaces, Nparam = ',i2,';')")       &
           Nparam(i)
    write (iOutput,"(2x, a, 1pe10.3, a)")                                           &
   'caracteristic length of the region, lnorm = ', lnorm(i), ';'
  end do
  write (iOutput,*)
  if (.not. DS) then
    write (iOutput,"(2x,'computation with localized sources;')")
    write (iOutput,"(2x,'origins of the localized sorces:')")
    do i = 1, Npart
      if (i /= Npart) then
        write (iOutput,"(2x,'zpart(',i2,') = ',1pe10.3,',')") i, zpart(i)
      else
        write (iOutput,"(2x,'zpart(',i2,') = ',1pe10.3,';')") i, zpart(i)
      end if
    end do
  else
    write (iOutput,"(2x,'computation with distributed sources;')")
    if (autGenDS) then
      write (iOutput,"(2x,'the sources are generated automatically;')") 
    else
      write (iOutput,"(2x,'the sources are user-defined;')")
    end if                      
    write (iOutput,*)       
    write (iOutput,"(2x,'z - coordinates of the sources:')")
    write (iOutput,"(2x,'first configuration:')")
    do i = 1, Npart       
      write (iOutput,"(2x,'region: ',i2)") i
      Nrank = Nrankp(i)
      do j = 1, Nrank       
        if (j /= Nrank) then
          write (iOutput,"(2x,'zRe(',i2,') = ',1pe10.3,', zIm(',i2,') = ',1pe10.3,',')")&
                 j, zRe(i,j), j, zIm(i,j)
        else
          write (iOutput,"(2x,'zRe(',i2,') = ',1pe10.3,', zIm(',i2,') = ',1pe10.3,';')")&
                 j, zRe(i,j), j, zIm(i,j)
        end if
      end do
      write (iOutput,*)
    end do
    if (ic == 2) then         
      write (iOutput,"(2x,'second configuration:')")
      do i = 1, Npart       
        write (iOutput,"(2x,'region: ',i2)") i
        Nrank = Nrankp1(i)
        do j = 1, Nrank     
          if (j /= Nrank) then
            write (iOutput,"(2x,'zRe(',i2,') = ',1pe10.3,', zIm(',i2,') = ',1pe10.3,',')")&
                   j, zRe1(i,j), j, zIm1(i,j)
          else
            write (iOutput,"(2x,'zRe(',i2,') = ',1pe10.3,', zIm(',i2,') = ',1pe10.3,';')")&
                   j, zRe1(i,j), j, zIm1(i,j)
          end if
        end do
        write (iOutput,*)
      end do
    end if  
  end if    
  write (iOutput,"(2x,'integration tolerance, epsNint = ',1pe10.3,';')") epsNint
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum expansion order tolerance, epsNrank = ', epsNrank, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum azimuthal order tolerance, epsMrank = ', epsMrank, ';'          
  write (iOutput,"(2x,'integration step, dNint = ',i4,'.')") dNint  
  write (iOutput,"(/)")                       
end subroutine printinputCOMP
! **********************************************************************************
subroutine convergence_NintCOMP (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,       &
           Nparammax, Nparam, Npart, Nrankp, zpart, Nrank, Nint, dNint, epsNint,    &
           PrnProgress)    
  use parameters 
  implicit none
  integer    :: TypeGeom, Nsurfmax, Nparammax, Npart, Nrank, Nint, dNint,           &
                Nrankp(Npart), Nparam(Npart)
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), snorm, epsNint                
  complex(O) :: ind_ref(Npart)
  logical    :: PrnProgress
!        
  integer    :: Mstart, Mrank, NmaxC, NmaxL, Nmaxmax, Nteta, i, m, iNint,           &
                dimension_column, dimension_row, NthetaConv, ipart, NrankAL
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext  
  integer,allocatable    :: Nintparam(:,:)
  real(O),allocatable    :: paramG(:,:,:), weightsG(:,:,:), h(:), v(:), oldh(:),    &
                            oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1     
  m = 1
  NrankAL = 0
  do ipart = 1, Npart
    NrankAL = NrankAL + Nrankp(ipart)
  end do
  NrankAL = max(Nrank,NrankAL)
  NmaxC   = dimension_column (m, Npart, Nrankp)
  NmaxL   = dimension_row (m, Nrank)
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  call write_TypeConvHead (1)
  allocate (a(2*NrankAL,2*NrankAL), b(2*NrankAL,2*NrankAL)) 
  allocate (c(2*Nrank), c1(2*Nrank))  
  allocate (cc(2*Nmaxmax)) 
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do
  if (PrnProgress) call write_progress (.true., 1, 9)
  do iNint = 1, 2 
    allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),         &
              Nintparam(Npart,Nparammax))             
    call interpolation_listCOMP (TypeGeom, Npart, Nsurfmax, surf, Nint, Nparammax,  &
         Nintparam, paramG, weightsG)       
    call matrix_Q_COMP (TypeGeom, 3, 1, k, ind_ref, Nsurfmax, surf, m, Npart,       &
         zpart, Nrankp, NmaxC, Nrank, NmaxC, Nint, Nparammax, Nparam, Nintparam,    &
         paramG, weightsG, a, NrankAL, NrankAL) 
    if (PrnProgress) call write_progress (.false., 2+4*(iNint-1), 9)            
    call incident_matrix_COMP (TypeGeom, k, Nsurfmax, surf, m, Npart, zpart,        &
         Nrankp, NmaxC, Nrank, NmaxL, Nint, Nparammax, Nparam, Nintparam, paramG,   &
         weightsG, b, NrankAL, NrankAL)      
    if (PrnProgress) call write_progress (.false., 3+4*(iNint-1), 9)                         
    call LU_SYSTEM_DIRECT (a, 2*NrankAL, 2*NrankAL, b, 2*NrankAL, 2*NrankAL,        &
         2*NmaxC, 2*NmaxL)
    if (PrnProgress) call write_progress (.false., 4+4*(iNint-1), 9)
    call matrix_Q_COMP (TypeGeom, 1, 1, k, ind_ref, Nsurfmax, surf, m, Npart,       &
         zpart, Nrankp, NmaxC, Nrank, NmaxL, Nint, Nparammax, Nparam, Nintparam,    &
         paramG, weightsG, a, NrankAL, NrankAL)                          
    call product_matrices (2*NmaxL, 2*NmaxC, 2*NmaxL, a, 2*NrankAL, 2*NrankAL,      &
         b, 2*NrankAL, 2*NrankAL)
    if (PrnProgress) call write_progress (.false., 5+4*(iNint-1), 9)                     
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         NmaxL, c)
    call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, NmaxL, Nmaxmax)                               
    call matrix_m_negativ (NmaxL, NmaxL, a, NrankAL, NrankAL)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,    &
         NmaxL, c)
    call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
    call extend_vector_negative (c1, cc, m, Nrank, NmaxL, Nmaxmax)
    call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm, &
        .false.,.true., h, v)
    call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
    call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,         &
         alfap, k, snorm, Cext, Qext)
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsNint, NthetaConv)    
    call write_3ConvParamRegCOMP (Nint, m, Nrank, Npart, Nrankp, .false.)   
    call write_DSCS (Nteta,.false., h, v)
    call write_Effic (Qscat, Qext)
    Nint = Nint + dNint
    deallocate (paramG, weightsG, Nintparam)
  end do
  call write_NintConvRes (NthetaConv, Nteta, epsNint)
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv)
end subroutine convergence_NintCOMP
! **********************************************************************************
subroutine convergence_NrankCOMP (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,      &
           Nparammax, Nparam, Npart, Nrankp, zpart, Nrank, Nint, epsNrank,          &
           PrnProgress)    
  use parameters 
  implicit none
  integer    :: TypeGeom, Nsurfmax, Nparammax, Npart, Nrank, Nint, Nrankp(Npart),   &
                Nparam(Npart)
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), snorm, epsNrank                
  complex(O) :: ind_ref(Npart)
  logical    :: PrnProgress 
!       
  integer    :: Mstart, Mrank, NmaxC, NmaxL, Nmaxmax, Nteta, i, m, NthetaConv,      &
                dimension_column, dimension_row, ipart, NrankAL
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext  
  integer,allocatable    :: Nintparam(:,:)
  real(O),allocatable    :: paramG(:,:,:), weightsG(:,:,:), h(:), v(:), oldh(:),    &
                            oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:), a1(:,:), b1(:,:),   &
                            a0(:,:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1   
  m      = 1
  NrankAL = 0
  do ipart = 1, Npart
    NrankAL = NrankAL + Nrankp(ipart)
  end do
  NrankAL = max(Nrank,NrankAL)
  NmaxC   = dimension_column (m, Npart, Nrankp)
  NmaxL   = dimension_row (m, Nrank) 
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  call write_TypeConvHead (2)
  allocate (a(2*NrankAL,2*NrankAL), b(2*NrankAL,2*NrankAL)) 
  allocate (c(2*Nrank), c1(2*Nrank))
  allocate (a1(2*NrankAL,2*NrankAL), b1(2*NrankAL,2*NrankAL), a0(2*NrankAL,2*NrankAL))  
  allocate (cc(2*Nmaxmax)) 
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))      
  allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),           &
            Nintparam(Npart,Nparammax))           
  call interpolation_listCOMP (TypeGeom, Npart, Nsurfmax, surf, Nint, Nparammax,    &
       Nintparam, paramG, weightsG)     
  if (PrnProgress) call write_progress (.true., 1, 9)
! --- Nrank configuration ---  
  call matrix_Q_COMP (TypeGeom, 3, 1, k, ind_ref, Nsurfmax, surf, m, Npart, zpart,  &
       Nrankp, NmaxC, Nrank, NmaxC, Nint, Nparammax, Nparam, Nintparam, paramG,     &
       weightsG, a, NrankAL, NrankAL)
  if (PrnProgress) call write_progress (.false., 2, 9)
  call copy_matrix (2*NmaxC, 2*NmaxC, a, 2*NrankAL, 2*NrankAL, a1,                  &
       2*NrankAL, 2*NrankAL)
  call incident_matrix_COMP (TypeGeom, k, Nsurfmax, surf, m, Npart, zpart, Nrankp,  &
       NmaxC, Nrank, NmaxL, Nint, Nparammax, Nparam, Nintparam, paramG, weightsG,   &
       b, NrankAL, NrankAL)
  if (PrnProgress) call write_progress (.false., 3, 9)
  call copy_matrix (2*NmaxC, 2*NmaxL, b, 2*NrankAL, 2*NrankAL, a0,                  &
       2*NrankAL, 2*NrankAL)
  call LU_SYSTEM_DIRECT (a, 2*NrankAL, 2*NrankAL, b, 2*NrankAL, 2*NrankAL,          &
       2*NmaxC, 2*NmaxL)
  if (PrnProgress) call write_progress (.false., 4, 9)
  call matrix_Q_COMP (TypeGeom, 1, 1, k, ind_ref, Nsurfmax, surf, m, Npart, zpart,  &
       Nrankp, NmaxC, Nrank, NmaxL, Nint, Nparammax, Nparam, Nintparam, paramG,     &
       weightsG, a, NrankAL, NrankAL)  
  call copy_matrix (2*NmaxL, 2*NmaxC, a, 2*NrankAL, 2*NrankAL, b1,                  &
       2*NrankAL, 2*NrankAL)
  call product_matrices (2*NmaxL, 2*NmaxC, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, b,     &
       2*NrankAL, 2*NrankAL)
  if (PrnProgress) call write_progress (.false., 5, 9)               
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,       &
       NmaxL, c)
  call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank, NmaxL, Nmaxmax)                                 
  call matrix_m_negativ (NmaxL, NmaxL, a, NrankAL, NrankAL)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,      &
       NmaxL, c)
  call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank, NmaxL, Nmaxmax)
  call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,   &
      .false.,.true., h, v)
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  do i = 1, Nteta
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do
  call write_3ConvParamRegCOMP (Nint, m, Nrank, Npart, Nrankp, .false.)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
! --- (Nrank - 1) configuration --- 
  call copy_matrix (2*NmaxC, 2*NmaxC, a1, 2*NrankAL, 2*NrankAL, a,                  &
       2*NrankAL, 2*NrankAL)
  call internal_matrix_Nrank_m (m, Npart, Nrankp, NmaxC, a, NrankAL, NrankAL)        
  if (PrnProgress) call write_progress (.false., 6, 9)
  call copy_matrix (2*NmaxC, 2*NmaxL, a0, 2*NrankAL, 2*NrankAL, b,                  &
       2*NrankAL, 2*NrankAL)
  call incident_matrix_Nrank_m (m, Npart, Nrankp, NmaxC, NmaxL, b, NrankAL, NrankAL)                            
  if (PrnProgress) call write_progress (.false., 7, 9)
  call LU_SYSTEM_DIRECT (a, 2*NrankAL, 2*NrankAL, b, 2*NrankAL, 2*NrankAL,          &
       2*NmaxC, 2*NmaxL)    
  if (PrnProgress) call write_progress (.false., 8, 9)
  call copy_matrix (2*NmaxL, 2*NmaxC, b1, 2*NrankAL, 2*NrankAL, a,                  &
       2*NrankAL, 2*NrankAL)
  call difusion_matrix_Nrank_m (m, Npart, Nrankp, NmaxC, NmaxL, a, NrankAL, NrankAL)                        
  call product_matrices (2*NmaxL, 2*NmaxC, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, b,     &
       2*NrankAL,2*NrankAL) 
  if (PrnProgress) call write_progress (.false., 9, 9)          
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,       &
       NmaxL, c)
  call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank, NmaxL, Nmaxmax)                                 
  call matrix_m_negativ (NmaxL, NmaxL, a, NrankAL, NrankAL)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,      &
       NmaxL, c)
  call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank, NmaxL, Nmaxmax)
  call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,   &
      .false.,.true., h, v)
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConv)  
  call write_3ConvParamRegCOMP (Nint, m, Nrank - 1, Npart, Nrankp, .true.)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConv, Nteta, epsNrank)
  deallocate (a1, b1, a0)
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv, paramG, weightsG, Nintparam)
end subroutine convergence_NrankCOMP
! **********************************************************************************
subroutine convergence_MrankCOMP (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,      &
           Nparammax, Nparam, Npart, Nrankp, zpart, Nrank, Nint, epsMrank,          &
           FileTmat, PrnProgress)          
  use parameters 
  implicit none
  integer       :: TypeGeom, Nsurfmax, Nparammax, Npart, Nrank, Nint,               &
                   Nrankp(Npart), Nparam(Npart)
  real(O)       :: k, surf(Npart,Nsurfmax), zpart(Npart), snorm, epsMrank                
  complex(O)    :: ind_ref(Npart)
  character(80) :: FileTmat
  logical       :: PrnProgress
!             
  integer       :: Mstart, Mrank, NmaxC, NmaxL, Nmaxmax, Nteta, i, m, NthetaConv,   &
                   dimension_column, dimension_row, ipart, NrankAL
  real(O)       :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,     &
                   Cext, Qext
  integer,allocatable    :: Nintparam(:,:)
  real(O),allocatable    :: paramG(:,:,:), weightsG(:,:,:), h(:), v(:), oldh(:),    &
                            oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O  
  Mstart = 0
  Mrank  = Nrank   
  NrankAL = 0
  do ipart = 1, Npart
    NrankAL = NrankAL + Nrankp(ipart)
  end do
  NrankAL = max(Nrank,NrankAL)
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call  write_HeadFileTmat (NrankAL, NrankAL)    
  call  write_TypeConvHead (3)
  call  write_2ConvParamRegCOMP (Nint, Nrank, Npart, Nrankp)
  allocate (a(2*NrankAL,2*NrankAL), b(2*NrankAL,2*NrankAL))
  allocate (c(2*Nrank), c1(2*Nrank))            
  allocate (cc(2*Nmaxmax)) 
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do     
  call zero_matrix (2*NrankAL, 2*NrankAL, a, 2*NrankAL, 2*NrankAL)
  allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),           &
            Nintparam(Npart,Nparammax))           
  call interpolation_listCOMP (TypeGeom, Npart, Nsurfmax, surf, Nint, Nparammax,    &
       Nintparam, paramG, weightsG)     
  Mrank = - 1
  do m = Mstart, Nrank    
    call write_1ConvParam (m)
    Mrank = Mrank + 1
    do i = 1, Npart
      if (Nrankp(i) < m) Nrankp(i) = m
    end do      
    NmaxC = dimension_column (m, Npart, Nrankp)
    NmaxL = dimension_row (m, Nrank)
    if (PrnProgress) call write_progress_m (.true., m, 1, 5)  
    call matrix_Q_COMP (TypeGeom, 3, 1, k, ind_ref, Nsurfmax, surf, m, Npart,       &
         zpart, Nrankp, NmaxC, Nrank, NmaxC, Nint, Nparammax, Nparam, Nintparam,    &
         paramG, weightsG, a, NrankAL, NrankAL)
    if (PrnProgress) call write_progress_m (.false., m, 2, 5)  
    call incident_matrix_COMP (TypeGeom, k, Nsurfmax, surf, m, Npart, zpart,        &
         Nrankp, NmaxC, Nrank, NmaxL, Nint, Nparammax, Nparam, Nintparam, paramG,   &
         weightsG, b, NrankAL, NrankAL)
    if (PrnProgress) call write_progress_m (.false., m, 3, 5)                                
    call LU_SYSTEM_DIRECT (a, 2*NrankAL, 2*NrankAL, b, 2*NrankAL, 2*NrankAL,        &
         2*NmaxC, 2*NmaxL)
    if (PrnProgress) call write_progress_m (.false., m, 4, 5) 
    call matrix_Q_COMP (TypeGeom, 1, 1, k, ind_ref, Nsurfmax, surf, m, Npart,       &
         zpart, Nrankp, NmaxC, Nrank, NmaxL, Nint, Nparammax, Nparam, Nintparam,    &
         paramG, weightsG, a, NrankAL, NrankAL)                      
    call product_matrices (2*NmaxL, 2*NmaxC, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, b,       &
         2*NrankAL, 2*NrankAL)
    if (PrnProgress) call write_progress_m (.false., m, 5, 5) 
    call write_FileTmat (NrankAL, NrankAL, a)   
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         NmaxL, c)
    call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, NmaxL, Nmaxmax)                               
    if (m /= 0) then
      call matrix_m_negativ (NmaxL, NmaxL, a, NrankAL, NrankAL)
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,  &
           NmaxL, c)
      call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
      call extend_vector_negative (c1, cc, m, Nrank, NmaxL, Nmaxmax)
    end if  
    call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm, &
        .false.,.true., h, v)    
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsMrank, NthetaConv)    
    call write_DSCS (Nteta,.false., h, v)
    if (NthetaConv >= int(0.8*Nteta)) exit
  end do    
  close (unit = iTmat)
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  call write_Effic (Qscat, Qext)              
  call write_MrankConvRes (NthetaConv, epsMrank)
  if (NthetaConv >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criterion for Mrank is satisfied;')"       
  else
    print "(/,2x,'Convergence criterion for Mrank is not satisfied;')"
  end if      
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .true., .false., .false.)
  call ScatCharact (k, FileTmat, Mrank, Nrank, .true., .false., .false.)    
  print "(/,2x,'T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank  
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank  
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv, paramG, weightsG, Nintparam)
end subroutine convergence_MrankCOMP    
! **********************************************************************************
subroutine convergence_NintDSCOMP (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,     &
           Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, Nrank,     &
           Nint, dNint, epsNint, PrnProgress)      
  use parameters 
  implicit none
  integer    :: TypeGeom, Nsurfmax, Nparammax, Npart, Nrankpmax, Nrank, Nint,       &
                dNint, Nrankp(Npart), Nparam(Npart)
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), snorm, epsNint,              &
                zRe(Npart,Nrankpmax), zIm(Npart,Nrankpmax)
  complex(O) :: ind_ref(Npart)
  logical    :: PrnProgress
!        
  integer    :: Mstart, Mrank, Nteta, NmaxC, NmaxL, Nmaxmax, i, m, iNint,           &
                NthetaConv, ipart, dimension_row, NrankAL
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext  
  integer,allocatable    :: Nintparam(:,:)
  real(O),allocatable    :: paramG(:,:,:), weightsG(:,:,:), h(:), v(:), oldh(:),    &
                            oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1  
  m = 1
  NmaxC = 0
  do ipart = 1, Npart
    NmaxC = NmaxC + Nrankp(ipart)
  end do
  NmaxL   = dimension_row (m, Nrank)
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  NrankAL = max(NmaxC,Nrank)
  call write_TypeConvHead (1)
  allocate (a(2*NrankAL,2*NrankAL), b(2*NrankAL,2*NrankAL))
  allocate (c(2*Nrank), c1(2*Nrank))        
  allocate (cc(2*Nmaxmax)) 
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do
  if (PrnProgress) call write_progress (.true., 1, 9)
  do iNint = 1, 2 
    allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),         &
              Nintparam(Npart,Nparammax))             
    call interpolation_listCOMP (TypeGeom, Npart, Nsurfmax, surf, Nint, Nparammax,  &
         Nintparam, paramG, weightsG)       
    call matrix_Q_DS_COMP (TypeGeom, 3, 1, k, ind_ref, Nsurfmax, surf, Npart,       &
         Nrankpmax, Nrankp, zRe, zIm, zpart, m, NmaxC, Nrank, NmaxC, Nint,          &
         Nparammax, Nparam, Nintparam, paramG, weightsG, a, NrankAL, NrankAL)
    if (PrnProgress) call write_progress (.false., 2+4*(iNint-1), 9)     
    call incident_matrix_DS_COMP (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax,    &
         Nrankp, zRe, zIm, zpart, m, NmaxC, Nrank, NmaxL, Nint, Nparammax, Nparam,  &
         Nintparam, paramG, weightsG, b, NrankAL, NrankAL)
    if (PrnProgress) call write_progress (.false., 3+4*(iNint-1), 9)     
    call LU_SYSTEM_DIRECT (a, 2*NrankAL, 2*NrankAL, b, 2*NrankAL, 2*NrankAL,        &
         2*NmaxC, 2*NmaxL)             
    if (PrnProgress) call write_progress (.false., 4+4*(iNint-1), 9)     
    call matrix_Q_DS_COMP (TypeGeom, 1, 1, k, ind_ref, Nsurfmax, surf, Npart,       &
         Nrankpmax, Nrankp, zRe, zIm, zpart, m, NmaxC, Nrank, NmaxL, Nint,          &
         Nparammax, Nparam, Nintparam, paramG, weightsG, a, NrankAL, NrankAL)  
    call product_matrices (2*NmaxL, 2*NmaxC, 2*NmaxL, a, 2*NrankAL, 2*NrankAL,      &
         b, 2*NrankAL, 2*NrankAL)   
    if (PrnProgress) call write_progress (.false., 5+4*(iNint-1), 9)     
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         NmaxL, c)
    call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, NmaxL, Nmaxmax)                                   
    call matrix_m_negativ (NmaxL, NmaxL, a, NrankAL, NrankAL)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,    &
         NmaxL, c)
    call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
    call extend_vector_negative (c1, cc, m, Nrank, NmaxL, Nmaxmax)
    call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm, &
        .false.,.true., h, v)
    call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
    call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,         &
         alfap, k, snorm, Cext, Qext)
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsNint, NthetaConv)
    call write_3ConvParamRegCOMP (Nint, m, Nrank, Npart, Nrankp, .false.)
    call write_DSCS (Nteta,.false., h, v)
    call write_Effic (Qscat, Qext)
    Nint = Nint + dNint
    deallocate (paramG, weightsG, Nintparam)
  end do
  call write_NintConvRes (NthetaConv, Nteta, epsNint)
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv)
end subroutine convergence_NintDSCOMP
! **********************************************************************************   
subroutine convergence_NrankDSCOMP (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,    &
           Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, Nrankpmax1,       &
           Nrankp1, zRe1, zIm1, zpart, Nrank, Nint, epsNrank, PrnProgress)         
  use parameters 
  implicit none
  integer    :: TypeGeom, Nsurfmax, Nparammax, Npart, Nrankpmax, Nrankpmax1,        &
                Nrank, Nint, Nrankp(Npart), Nrankp1(Npart), Nparam(Npart)
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), snorm, epsNrank,             &
                zRe(Npart,Nrankpmax), zIm(Npart,Nrankpmax),                         &
                zRe1(Npart,Nrankpmax1), zIm1(Npart,Nrankpmax1)
  complex(O) :: ind_ref(Npart)
  logical    :: PrnProgress
!        
  integer    :: Mstart, Mrank, Nteta, NmaxC, NmaxL, Nmaxmax, i, m, NthetaConv,      &
                ipart, dimension_row, Nrank1, NrankAL
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext  
  integer,allocatable    :: Nintparam(:,:)
  real(O),allocatable    :: paramG(:,:,:), weightsG(:,:,:), h(:), v(:), oldh(:),    &
                            oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1  
  m = 1
  NmaxC = 0
  do ipart = 1, Npart
    NmaxC = NmaxC + Nrankp(ipart)
  end do
  NmaxL   = dimension_row (m, Nrank)
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  NrankAL = max(NmaxC,Nrank)
  call write_TypeConvHead (2)
  allocate (a(2*NrankAL,2*NrankAL), b(2*NrankAL,2*NrankAL)) 
  allocate (c(2*Nrank), c1(2*Nrank))        
  allocate (cc(2*Nmaxmax)) 
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))    
  allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),           &
            Nintparam(Npart,Nparammax))           
  call interpolation_listCOMP (TypeGeom, Npart, Nsurfmax, surf, Nint, Nparammax,    &
       Nintparam, paramG, weightsG)     
  if (PrnProgress) call write_progress (.true., 1, 9)
! --- Nrank configuration ---  
  call matrix_Q_DS_COMP (TypeGeom, 3, 1, k, ind_ref, Nsurfmax, surf, Npart,         &
       Nrankpmax, Nrankp, zRe, zIm, zpart, m, NmaxC, Nrank, NmaxC, Nint, Nparammax, &
       Nparam, Nintparam, paramG, weightsG, a, NrankAL, NrankAL)
  if (PrnProgress) call write_progress (.false., 2, 9)
  call incident_matrix_DS_COMP (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax,      &
       Nrankp, zRe, zIm, zpart, m, NmaxC, Nrank, NmaxL, Nint, Nparammax, Nparam,    &
       Nintparam, paramG, weightsG, b, NrankAL, NrankAL)
  if (PrnProgress) call write_progress (.false., 3, 9)
  call LU_SYSTEM_DIRECT (a, 2*NrankAL, 2*NrankAL, b, 2*NrankAL, 2*NrankAL,          &
       2*NmaxC, 2*NmaxL)               
  if (PrnProgress) call write_progress (.false., 4, 9)
  call matrix_Q_DS_COMP (TypeGeom, 1, 1, k, ind_ref, Nsurfmax, surf, Npart,         &
       Nrankpmax, Nrankp, zRe, zIm, zpart, m, NmaxC, Nrank, NmaxL, Nint, Nparammax, &
       Nparam, Nintparam, paramG, weightsG, a, NrankAL, NrankAL)        
  call product_matrices (2*NmaxL, 2*NmaxC, 2*NmaxL, a, 2*NrankAL, 2*NrankAL,        &
       b, 2*NrankAL, 2*NrankAL)
  if (PrnProgress) call write_progress (.false., 5, 9)           
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,       &
       NmaxL, c)
  call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank, NmaxL, Nmaxmax)                                     
  call matrix_m_negativ (NmaxL, NmaxL, a, NrankAL, NrankAL)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,      &
       NmaxL, c)
  call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank, NmaxL, Nmaxmax)
  call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,   &
      .false.,.true., h, v)
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  do i = 1, Nteta
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do
  call write_3ConvParamRegCOMP (Nint, m, Nrank, Npart, Nrankp, .false.)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
! --- Nrank1 configuration ---
  NmaxC = 0
  do ipart = 1, Npart
    NmaxC = NmaxC + Nrankp1(ipart)
  end do
  Nrank1  = Nrank - 1
  NmaxL   = dimension_row (m, Nrank1)
  Nmaxmax = Nrank1 + Mrank * (2 * Nrank1 - Mrank + 1)
  call matrix_Q_DS_COMP (TypeGeom, 3, 1, k, ind_ref, Nsurfmax, surf, Npart,         &
       Nrankpmax1, Nrankp1, zRe1, zIm1, zpart, m, NmaxC, Nrank1, NmaxC, Nint,       &
       Nparammax, Nparam, Nintparam, paramG, weightsG, a, NrankAL, NrankAL)
  if (PrnProgress) call write_progress (.false., 6, 9)
  call incident_matrix_DS_COMP (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax1,     &
       Nrankp1, zRe1, zIm1, zpart, m, NmaxC, Nrank1, NmaxL, Nint, Nparammax,        &
       Nparam, Nintparam, paramG, weightsG, b, NrankAL, NrankAL)
  if (PrnProgress) call write_progress (.false., 7, 9)
  call LU_SYSTEM_DIRECT (a, 2*NrankAL, 2*NrankAL, b, 2*NrankAL, 2*NrankAL,          &
       2*NmaxC, 2*NmaxL)              
  if (PrnProgress) call write_progress (.false., 8, 9)
  call matrix_Q_DS_COMP (TypeGeom, 1, 1, k, ind_ref, Nsurfmax, surf, Npart,         &
       Nrankpmax1, Nrankp1, zRe1, zIm1, zpart, m, NmaxC, Nrank1, NmaxL, Nint,       &
       Nparammax, Nparam, Nintparam, paramG, weightsG, a, NrankAL, NrankAL)        
  call product_matrices (2*NmaxL, 2*NmaxC, 2*NmaxL, a, 2*NrankAL, 2*NrankAL,        &
       b, 2*NrankAL, 2*NrankAL)  
  if (PrnProgress) call write_progress (.false., 9, 9)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank1,      &
       NmaxL, c)
  call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank1, NmaxL, Nmaxmax)                                    
  call matrix_m_negativ (NmaxL, NmaxL, a, NrankAL, NrankAL)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank1,     &
       NmaxL, c)
  call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank1, NmaxL, Nmaxmax)
  call DSCS (cc, Mrank, Nrank1, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,  &
      .false.,.true., h, v)
  call CQscat (cc, Mrank, Nrank1, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank1, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,          &
       alfap, k, snorm, Cext, Qext)
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConv)
  call write_3ConvParamRegCOMP (Nint, m, Nrank1, Npart, Nrankp1, .false.)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConv, Nteta, epsNrank)
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv, paramG, weightsG, Nintparam)
end subroutine convergence_NrankDSCOMP 
! **********************************************************************************
subroutine convergence_MrankDSCOMP (TypeGeom, k, ind_ref, snorm, Nsurfmax, surf,    &
           Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, Nrank,     &
           Nint, ComplexPlane, EpsZReIm, autGenDS, epsMrank, epsNrank, dNintMrank,  &
           FileTmat, PrnProgress)      
  use parameters 
  implicit none
  integer       :: TypeGeom, Nsurfmax, Nparammax, Npart, Nrankpmax, Nrank, Nint,    &
                   Nrankp(Npart), Nparam(Npart), dNintMrank
  real(O)       :: k, surf(Npart,Nsurfmax), zpart(Npart), snorm, epsMrank,          &
                   epsNrank, zRe(Npart,Nrankpmax), zIm(Npart,Nrankpmax),            &
                   EpsZReIm(Npart)
  complex(O)    :: ind_ref(Npart)
  character(80) :: FileTmat
  logical       :: autGenDS, PrnProgress, ComplexPlane(Npart)
!             
  integer       :: Mstart, Mrank, Nteta, NmaxC, NmaxL, Nmaxmax, i, m, NthetaConv,   &
                   ipart, dimension_row, NrankAL, NrankpmaxL, NrankpmaxL1
  real(O)       :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,     &
                   Cext, Qext
  logical       :: ComplexDS, ChangeDS, more, continuare, ConvTest
  integer,allocatable    :: Nintparam(:,:), Nrankp1(:)
  real(O),allocatable    :: paramG(:,:,:), weightsG(:,:,:), h(:), v(:), oldh(:),    &
                            oldv(:), zReL(:,:), zImL(:,:), zReL1(:,:), zImL1(:,:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 0
  Mrank  = Nrank  
  NmaxC = 0
  do ipart = 1, Npart
    NmaxC = NmaxC + Nrankp(ipart)
  end do
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  NrankAL = max(NmaxC,Nrank)
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call write_HeadFileTmat (NrankAL, NrankAL) 
  call write_TypeConvHead (3)
  call write_2ConvParamRegCOMP (Nint, Nrank, Npart, Nrankp)
  allocate (a(2*NrankAL,2*NrankAL), b(2*NrankAL,2*NrankAL))
  allocate (c(2*Nrank), c1(2*Nrank))       
  allocate (cc(2*Nmaxmax)) 
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do
  call zero_matrix (2*NrankAL, 2*NrankAL, a, 2*NrankAL, 2*NrankAL)     
  allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),           &
            Nintparam(Npart,Nparammax))           
  call interpolation_listCOMP (TypeGeom, Npart, Nsurfmax, surf, Nint, Nparammax,    &
       Nintparam, paramG, weightsG)
  ComplexDS = .false.
  do ipart = 1, Npart           
    do i = 1,Nrankp(ipart)                    
      if (zIm(ipart,i) /= 0._O) ComplexDS = .true.
    end do                      
  end do
  ChangeDS = .false.
! -----------------------------------------------------------------------------------  
! If the sources are distributed in the complex plane and they are automatically    !
! generated, an interactive convergence test over Nint and Nrank can be performed   !
! at each azimuthal mode calculation. To make this test active comment out the next !
! lines.                                                                            !  
! -----------------------------------------------------------------------------------   
! if (ComplexDS .and. autGenDS) then
!   print "(/,2x, a)",                                                              &
!   '- enter true to change the values of Nint and Nrank at each azimuthal mode and'	                                  
!   print "( 2x, 'false otherwise')"        
!   call read_logical (ChangeDS)    
! end if
  Mrank = - 1
  do m = Mstart, Nrank    
    call write_1ConvParam (m)
    Mrank = Mrank + 1
    NmaxL = dimension_row (m, Nrank)                                     
!   --- local convergence test for sources distributed in the complex plane ---    
    NrankpmaxL = Nrankpmax
    allocate (zReL(Npart,NrankpmaxL), zImL(Npart,NrankpmaxL))   
    do ipart = 1, Npart	    
      do i = 1, Nrankp(ipart)
        zReL(ipart,i) = zRe(ipart,i)
        zImL(ipart,i) = zIm(ipart,i)	    	
      end do        
    end do    
    if (ComplexDS .and. m > 1) then
      if (ChangeDS) then
        print "(/,2x,'Azimuthal mode: m = ',i3)", m  
        more = .true.
        do while (more)
          print "(  2x, '- enter the number of integration points Nint')"
          call read_integer (Nint)
          deallocate (paramG, weightsG, Nintparam)      
          allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),   &
                    Nintparam(Npart,Nparammax))            
          call interpolation_listCOMP (TypeGeom, Npart, Nsurfmax, surf, Nint,       &
               Nparammax, Nintparam, paramG, weightsG)       	   	   	   	   
          NrankpmaxL = 0 
	  NmaxC      = 0          	   
          do ipart = 1, Npart
            if (ComplexPlane(ipart)) then
              print "(2x,'- enter the estimated value of Nrank for region ',i2)",   &
	              ipart
              call read_integer (Nrankp(ipart))		
	    end if	 
            if (Nrankp(ipart) > NrankpmaxL)  NrankpmaxL  = Nrankp(ipart)
            NmaxC = NmaxC + Nrankp(ipart)	     	  
          end do
	  if (NrankpmaxL > Nrankpmax) then
            print "(/,2x,'Input error:')"
            print "(  2x, a)",                                                      &
           'the number of discrete sources exceeds the number of discrete'	    
            print "(  2x,'sources corresponding to the initial configuration;')"
            stop  
	  end if	  	  	  	  	  	  	  
          deallocate (zReL, zImL)	   	   
          allocate (zReL(Npart,NrankpmaxL), zImL(Npart,NrankpmaxL))
          call zDSCOMP (TypeGeom, Npart, Nsurfmax, surf, NrankpmaxL, Nrankp, zpart, &
               ComplexPlane, EpsZReIm, zReL, zImL)		     
          print "(/,2x, a)",                                                        &
         '- enter true to perform a convergence test over the new values of Nrank and'	                                  
          print "( 2x, 'false otherwise')"             
	  call read_logical (ConvTest)		
	  if (ConvTest) then
	    allocate (Nrankp1(Npart))        
	    NrankpmaxL1 = 0    	   
            do ipart = 1, Npart          
	      Nrankp1(ipart) = Nrankp(ipart) - 1	          
	      if (Nrankp1(ipart) > NrankpmaxL1) NrankpmaxL1 = Nrankp1(ipart) 	   
            end do  	     
	    allocate (zReL1(Npart,NrankpmaxL1), zImL1(Npart,NrankpmaxL1))       
            call zDSCOMP (TypeGeom, Npart, Nsurfmax, surf, NrankpmaxL1, Nrankp1,    &
                 zpart, ComplexPlane, EpsZReIm, zReL1, zImL1)    	      		   
	    call convergence_NrankDSCOMP_m (m, TypeGeom, k, ind_ref, snorm,         &
                 Nsurfmax, surf, Nparammax, Nparam, Npart, NrankpmaxL, Nrankp,      &
                 zReL, zImL, NrankpmaxL1, Nrankp1, zReL1, zImL1, zpart, Nrank,      &
                 Nint, Nintparam, paramG, weightsG, epsNrank) 
            deallocate (zReL1, zImL1, Nrankp1)	     
          end if 	       	  	 	             	  	   	    	   	  	
	  if (ConvTest) then
            print "(2x, a)",                                                        &
           '- enter true for new input values of Nint and Nrank and false to continue;'	
            call read_logical (continuare)
            if (.not. continuare) more = .false.             	      
	  else
            more = .false.
	  end if  
        end do
      else
        deallocate (paramG, weightsG, Nintparam) 
        Nint = Nint + dNintMrank	     
        allocate (paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint),     &
                  Nintparam(Npart,Nparammax))            
        call interpolation_listCOMP (TypeGeom, Npart, Nsurfmax, surf, Nint,         &
             Nparammax, Nintparam, paramG, weightsG)                                      
      end if  		   	   	   	   	   	   	                    
    end if      
!   --- end local convergence test ---                                                                                                                          
    if (PrnProgress) call write_progress_m (.true., m, 1, 5)   
    call matrix_Q_DS_COMP (TypeGeom, 3, 1, k, ind_ref, Nsurfmax, surf, Npart,       &
         NrankpmaxL, Nrankp, zReL, zImL, zpart, m, NmaxC, Nrank, NmaxC, Nint,       &
         Nparammax, Nparam, Nintparam, paramG, weightsG, a, NrankAL, NrankAL)	     	 
    if (PrnProgress) call write_progress_m (.false., m, 2, 5)  
    call incident_matrix_DS_COMP (TypeGeom, k, Nsurfmax, surf, Npart, NrankpmaxL,   &
         Nrankp, zReL, zImL, zpart, m, NmaxC, Nrank, NmaxL, Nint, Nparammax,        &
         Nparam, Nintparam, paramG, weightsG, b, NrankAL, NrankAL)	     	 
    if (PrnProgress) call write_progress_m (.false., m, 3, 5) 
    call LU_SYSTEM_DIRECT (a, 2*NrankAL, 2*NrankAL, b, 2*NrankAL, 2*NrankAL,        &
         2*NmaxC, 2*NmaxL)              	 
    if (PrnProgress) call write_progress_m (.false., m, 4, 5) 
    call matrix_Q_DS_COMP (TypeGeom, 1, 1, k, ind_ref, Nsurfmax, surf, Npart,       &
         NrankpmaxL, Nrankp, zReL, zImL, zpart, m, NmaxC, Nrank, NmaxL, Nint,          &
         Nparammax, Nparam, Nintparam, paramG, weightsG, a, NrankAL, NrankAL)  	     
    call product_matrices (2*NmaxL, 2*NmaxC, 2*NmaxL, a, 2*NrankAL, 2*NrankAL,      &
         b, 2*NrankAL, 2*NrankAL)
    if (PrnProgress) call write_progress_m (.false., m, 5, 5) 
    call write_FileTmat (NrankAL, NrankAL, a)    
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         NmaxL, c)
    call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, NmaxL, Nmaxmax)                                   
    if (m /= 0) then
      call matrix_m_negativ (NmaxL, NmaxL, a, NrankAL, NrankAL)
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,  &
           NmaxL, c)
      call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
      call extend_vector_negative (c1, cc, m, Nrank, NmaxL, Nmaxmax)
    end if  
    call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm, &
        .false.,.true., h, v)    
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsMrank, NthetaConv)    
    call write_DSCS (Nteta,.false., h, v)        
    deallocate (zReL, zImL)        
    if (NthetaConv >= int(0.8d0*Nteta)) exit
  end do 
  close (unit = iTmat)
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  call write_Effic (Qscat, Qext)              
  call write_MrankConvRes (NthetaConv, epsMrank)
  if (NthetaConv >= int(0.8d0*Nteta)) then
    print "(/,2x,'Convergence criterion for Mrank is satisfied;')"     
  else
    print "(/,2x,'Convergence criterion for Mrank is not satisfied;')"
  end if 
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .true., .false., .false.)
  call ScatCharact (k, FileTmat, Mrank, Nrank, .true., .false., .false.) 
  print "(/,2x,'T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank 
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank       
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv, paramG, weightsG, Nintparam)
end subroutine convergence_MrankDSCOMP
! **********************************************************************************   
subroutine convergence_NrankDSCOMP_m (m, TypeGeom, k, ind_ref, snorm, Nsurfmax,     &
           surf, Nparammax, Nparam, Npart, Nrankpmax, Nrankp, zRe, zIm, Nrankpmax1, &
           Nrankp1, zRe1, zIm1, zpart, Nrank, Nint, Nintparam, paramG, weightsG,    &                                             
           epsNrank)         
  use parameters 
  implicit none
  integer    :: m, TypeGeom, Nsurfmax, Nparammax, Npart, Nrankpmax, Nrankpmax1,     &
                Nrank, Nint, Nrankp(Npart), Nrankp1(Npart), Nparam(Npart),          &
                Nintparam(Npart,Nparammax)                
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), snorm, epsNrank,             &
                zRe(Npart,Nrankpmax), zIm(Npart,Nrankpmax),                         &
                zRe1(Npart,Nrankpmax1), zIm1(Npart,Nrankpmax1),                     &
                paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint)                
  complex(O) :: ind_ref(Npart)  
!        
  integer    :: Mstart, Mrank, Nteta, NmaxC, NmaxL, Nmaxmax, i, NthetaConv,         &
                ipart, dimension_row, NrankAL
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext, teta  
  real(O),allocatable    :: h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = m
  Mrank  = m    
  NmaxC = 0
  do ipart = 1, Npart
    NmaxC = NmaxC + Nrankp(ipart)
  end do
  NmaxL   = dimension_row (m, Nrank)
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  NrankAL = max(NmaxC,Nrank)  
  allocate (a(2*NrankAL,2*NrankAL), b(2*NrankAL,2*NrankAL)) 
  allocate (c(2*Nrank), c1(2*Nrank))        
  allocate (cc(2*Nmaxmax)) 
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))                   
! --- Nrank configuration ---  
  call matrix_Q_DS_COMP (TypeGeom, 3, 1, k, ind_ref, Nsurfmax, surf, Npart,         &
       Nrankpmax, Nrankp, zRe, zIm, zpart, m, NmaxC, Nrank, NmaxC, Nint, Nparammax, &
       Nparam, Nintparam, paramG, weightsG, a, NrankAL, NrankAL) 
  call incident_matrix_DS_COMP (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax,      &
       Nrankp, zRe, zIm, zpart, m, NmaxC, Nrank, NmaxL, Nint, Nparammax, Nparam,    &
       Nintparam, paramG, weightsG, b, NrankAL, NrankAL)
  call LU_SYSTEM_DIRECT (a, 2*NrankAL, 2*NrankAL, b, 2*NrankAL, 2*NrankAL,          &
       2*NmaxC, 2*NmaxL)               
  call matrix_Q_DS_COMP (TypeGeom, 1, 1, k, ind_ref, Nsurfmax, surf, Npart,         &
       Nrankpmax, Nrankp, zRe, zIm, zpart, m, NmaxC, Nrank, NmaxL, Nint, Nparammax, &
       Nparam, Nintparam, paramG, weightsG, a, NrankAL, NrankAL)        
  call product_matrices (2*NmaxL, 2*NmaxC, 2*NmaxL, a, 2*NrankAL, 2*NrankAL,        &
       b, 2*NrankAL, 2*NrankAL)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,       &
       NmaxL, c)
  call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank, NmaxL, Nmaxmax)                                     
  call matrix_m_negativ (NmaxL, NmaxL, a, NrankAL, NrankAL)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,      &
       NmaxL, c)
  call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank, NmaxL, Nmaxmax)
  call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,   &
      .false.,.true., h, v)
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  do i = 1, Nteta
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do
  print "(1x,'Convergence Test over Nrank')"
  print "(1x,'---------------------------')"  
  print "(1x,'Nint = ',i5,',',1x,'Nrank = ',i3,',',1x,'Mrank = ',i3)", Nint,        &
          Nrank, m  
  do ipart = 1, Npart
    print "(1x,'Nrank for region ',i2,', Nrank = ',i3)", ipart, Nrankp(ipart)  
  end do          
  print "(/,1x, a, /, 2x, a, 9x, a, 8x, a)",                                        &
 'normalized differential scattering cross section', 'theta', 'parallel',           &
 'perpendicular' 
  do i = 1, Nteta    
    teta = real(i - 1,O) * 180._O / real(Nteta - 1,O)                
    print "(1x,f6.2,5x,1pe13.4,5x,1pe13.4)", teta, h(i), v(i)   
  end do  
  print "(1x,'scattering efficiency = ',1pe13.4)",   Qscat
  print "(1x,'extinction efficiency = ',1pe13.4,/)", Qext          
! --- Nrank1 configuration (only the DS configuration is changed) ---
  NmaxC = 0
  do ipart = 1, Npart
    NmaxC = NmaxC + Nrankp1(ipart)
  end do    
  call matrix_Q_DS_COMP (TypeGeom, 3, 1, k, ind_ref, Nsurfmax, surf, Npart,         &
       Nrankpmax1, Nrankp1, zRe1, zIm1, zpart, m, NmaxC, Nrank, NmaxC, Nint,        &
       Nparammax, Nparam, Nintparam, paramG, weightsG, a, NrankAL, NrankAL)
  call incident_matrix_DS_COMP (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax1,     &
       Nrankp1, zRe1, zIm1, zpart, m, NmaxC, Nrank, NmaxL, Nint, Nparammax,         &
       Nparam, Nintparam, paramG, weightsG, b, NrankAL, NrankAL)
  call LU_SYSTEM_DIRECT (a, 2*NrankAL, 2*NrankAL, b, 2*NrankAL, 2*NrankAL,          &
       2*NmaxC, 2*NmaxL)              
  call matrix_Q_DS_COMP (TypeGeom, 1, 1, k, ind_ref, Nsurfmax, surf, Npart,         &
       Nrankpmax1, Nrankp1, zRe1, zIm1, zpart, m, NmaxC, Nrank, NmaxL, Nint,        &
       Nparammax, Nparam, Nintparam, paramG, weightsG, a, NrankAL, NrankAL)        
  call product_matrices (2*NmaxL, 2*NmaxC, 2*NmaxL, a, 2*NrankAL, 2*NrankAL,        &
       b, 2*NrankAL, 2*NrankAL)    
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,       &
       NmaxL, c)
  call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank, NmaxL, Nmaxmax)                                    
  call matrix_m_negativ (NmaxL, NmaxL, a, NrankAL, NrankAL)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,      &
       NmaxL, c)
  call product_matrix_vector (2*NmaxL, 2*NmaxL, a, 2*NrankAL, 2*NrankAL, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank, NmaxL, Nmaxmax)
  call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,   &
      .false.,.true., h, v)
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConv)
  print "(1x,'Nint = ',i5,',',1x,'Nrank = ',i3,',',1x,'Mrank = ',i3)", Nint,        &
          Nrank, m  
  do ipart = 1, Npart
    print "(1x,'Nrank for region ',i2,', Nrank = ',i3)", ipart, Nrankp1(ipart)  
  end do          
  print "(/,1x, a, /, 2x, a, 9x, a, 8x, a)",                                        &
 'normalized differential scattering cross section', 'theta', 'parallel',           &
 'perpendicular' 
  do i = 1, Nteta    
    teta = real(i - 1,O) * 180._O / real(Nteta - 1,O)                
    print "(1x,f6.2,5x,1pe13.4,5x,1pe13.4)", teta, h(i), v(i)   
  end do  
  print "(1x,'scattering efficiency = ',1pe13.4)",   Qscat
  print "(1x,'extinction efficiency = ',1pe13.4,/)", Qext 
  print "(1x, a, i2, a, 1f5.2, a, /)",                                               &
 'The solution converges in ', NthetaConv,' points with an relative error of ',      &
  100 * epsNrank, ' %;'              
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv)
end subroutine convergence_NrankDSCOMP_m 

Subroutine TMULT2SPH
!------------------------------------------------------------------------------------
! 1. General Considerations                                                         !
! --------------------------                                                        !
! TMULT2SPH is a routine for computing the T matrix and the scattering              !
! characteristics of two homogeneous, dielectric spheres .                          !  
!                                                                                   !
! For axisymmetric systems of particles, the scattering problem decouples over      !
! the azimuthal modes m and the T matrix can be computed separately for each m.     !
!                                                                                   !
! 2. Convergence Test                                                               !
! --------------------                                                              !
! In the code, the maximum expansion and azimuthal orders Nrank and Mrank of the    !
! cluster are independent on the maximum expansion and azimuthal orders             !
! NrankPart(i) and MrankPart(i), i = 1,2, of the spherical particles forming the    !
! cluster. The convergence tests are carried out over Nrank and Mrank, while        !
! NrankPart(i) and MrankPart(i), i = 1,2, are kept constant.                        !
!                                                                                   !
! For convergence tests, the incident wave is assumed to be a plane wave traveling  !
! along the Z-axis of the global coordinate system and the scattering               !
! characteristics are computed in the azimuthal plane  phi = 0°. The convergence    !
! test over Nrank is interactive, while the convergence test over Mrank is          !
! automatically performed.                                                          !
!                                                                                   !
! For the expansion order test, an axisymmetric orientation of the cluster is       !
! considered, i.e., the incident wave propagates along the axis of symmetry of      !
! the cluster. In this case, all azimuthal modes are zero except for m = - 1 and    !
! m = 1. For the convergence test over Nrank, the scattering problem is solved for  !
! Nrank and Nrank - 1. The normalized differential scattering cross section (DSCS)  !
! will be checked at 20° increments for convergence within epsNrank tolerance.      !
! If the calculated results converge within this tolerance at 80% of the            !
! scattering angles, then convergence is achieved.                                  !
!                                                                                   ! 
! After Nrank has been determined we pass to the azimuthal order test. The program  !
! automatically sets the cluster to a more general orientation, i.e., alpha = beta  !
! = 45°, and solves the scattering problem  for increasing m values until           !
! convergence of the angular scattering is achieved. The T matrix is stored for     !
! later use by other programs, and the values of Nrank and Mrank are printed to     !
! the screen and to the T-matrix information file (see "Description.txt"). These    !
! values together with the T matrix serve as INPUT PARAMETERS for other programs.   ! 
!                                                                                   !
! An estimate of Nrank is given by Wiscombe's truncation limit criterion            !
! [W. J. Wiscombe, Improved Mie scattering algorithms, Applied Optics, 19,          !
! 1505-1509, 1980], i.e.,                                                           !
!                                                                                   !
!                NrankW = int(x + 4.05 * x**0.33 + 2),                              !
!                                                                                   !
! where x is the size parameter, x = k * Rcirc, k is the wave number and Rcirc is   !
! the radius of the smallest sphere enclosing the cluster.                          !
!                                                                                   ! 
! The convergence test over Nrank can be switched off by setting the logical        !
! variable DoConvTest to false. In this case, the value of Nrank must be specified  !
! in the input file.                                                                !
!                                                                                   !
! 3. Input Parameters                                                               !
! --------------------                                                              !
! The parameters specified in the input file "/INPUTFILES/InputMULT.dat" are listed !
! below.                                                                            !
!                                                                                   !
! - wavelength (real) - wavelength of the incident light in vacuo.                  !
!                                                                                   !
! - ind_refMed (real) - refractive index of the ambient medium (nonabsorbing        !
!   dielectric medium).                                                             !
!                                                                                   !
! - anorm (real) - characteristic length of the cluster which is used to normalize  !
!   the differential scattering cross sections.                                     !
!                                                                                   !
! - Rcirc (real) - characteristic length of the cluster (usually the radius of the  !
!   smallest circumscribing sphere) which is used to compute an estimate of the     !
!   maximum  expansion order by using Wiscombe's truncation limit criterion (the    !
!   size parameter is x = k * Rcirc, where k is the wave number in the ambient      !
!   medium). This parameter must be specified if the interactive convergence tests  !
!   are performed (DoConvTest = t).                                                 !  
!                                                                                   !
! The next parameters (specified in a group statement) correspond to each            !
! particle. THE GROUP STATEMENT MUST BE REPEATED FOR BOTH PARTICLES.                !
!                                                                                   !
! - rp (real) - radius of the actual spherical particle.                            !
!                                                                                   !
! - Nrankp (integer) - maximum expansion order for the actual spherical particle.   !
!                                                                                   !
! - ind_refp (complex) - relative refractive index of the actual spherical          !
!   particle with respect to the ambient medium.                                    !
!                                                                                   !
! - zp (real) - axial position of the actual spherical particle with respect        !
!   to the coordinate system of the cluster.                                        !
!                                                                                   ! 
! - DoConvTest (logical) - if DoConvTest = t, the interactive convergence test      !
!   over Nrank is performed. An estimates of Nrank is given by Wiscombe's           !
!   truncation limit criterion. If DoConvTest = f, the values of Nrank must be      !
!   supplied in the namelist input.                                                 !
!                                                                                   !
! - Nrank (integer) - maximum expansion order for the cluster. This parameter is    !
!   used if the convergence test is not performed (DoConvTest = f).                 !
!                                                                                   !
!   The following table explain the significance of the variable Nrank.             !
!          DoConvTest           Nrank             TypeConvTest                      !
!              t             console input          1 or 2                          !
!              f              file input              2                             !  
!   where the significance of the variable TypeConvTest is                          !
!           TypeConvTest                    Significance                            !  
!               1                      convergence test over Nrank                  ! 
!               2                      convergence test over Mrank                  !
!                                                                                   !
! - epsNrank (real) - error tolerance for the expansion order test.                 !
!                                                                                   !
! - epsMrank (real) - error tolerance for the azimuthal order test.                 !
!                                                                                   !
! - FileTmat (character(80)) - name of the file to which the T matrix of the        !
!   cluster is written.                                                             !
!                                                                                   !
! - PrnProgress (logical) - if PrnProgress = t, the progress of calculation         !
!   is printed.                                                                     !
!                                                                                   !
! Note that all input parameters specifying lengths must be provided in the same    !
! units of lengths.                                                                 !
!                                                                                   !
! 4. Logical Scheme                                                                 !
! ------------------                                                                !  
! The organization of the code is as follows:                                       !
! 1. < read input data; the input file provides:                                    !
!    - the maximum expansion order Nrankp,                                          ! 
!    - the radius of each spherical particle, and                                   !                               
!    - the axial position of each spherical particle >                              !
!                                                                                   !   
! 2. < T-matrix calculation >                                                       !
!                                                                                   ! 
!    if ( do convergence test ) then                                                !
!                                                                                   !
!      < the code computes an estimate of Nrank accordingly to                      !
!        Wiscombe's truncation criterion >                                          !
!      < the code prompts for the estimated value of Nrank >                        !
!      < the code prompts for the type of convergence test:                         !
!        1 - over Nrank, 2 - over Mrank >                                           !
!                                                                                   !
!    else if ( .not. do convergence test ) then                                     !
!                                                                                   !
!       < the input file provides the value of Nrank >                              !
!       type of convergence test = 2 (convergence test over Mrank)                  !
!                                                                                   !
!    end if                                                                         !
!    if ( do expansion order test, i.e., type of convergence test = 1 ) then        !
!       < the code computes the DSCS for Nrank and Nrank - 1 and                    !
!         write the results to the file "Output.dat" >                              !
!       < the execution is terminated >                                             !
!    end if                                                                         !
!    if ( do azimuthal order test, i.e., type of convergence test = 2 ) then        !
!       < the code computes the DSCS for increasing m values and                    !
!         write the results to the file "Output.dat" >                              !
!       < the T matrix is stored in the file FileTmat and the T-matrix information  !
!         file is created >                                                         !
!       < Mrank and Nrank are written to the screen and to the T-matrix             !
!         information file >                                                        ! 
!       < go to Step 3 >                                                            !
!    end if                                                                         !
! 3. < scattering characteristics calculation >                                     !    
!------------------------------------------------------------------------------------
  use parameters
  implicit none 
  integer       :: Nrank1, Nrank2, Nrank, TypeConvTest                                   
  real(O)       :: k, ind_refMed, wavelength, anorm, snorm, epsNrank, epsMrank, r1, &
                   r2, z1, z2, Rcirc
  complex(O)    :: ind_ref1, ind_ref2
  logical       :: DoConvTest, PrnProgress
  character(80) :: FileTmat
! -----------------------------------------------------------------------------------
!                               Read the input file                                 ! 
! -----------------------------------------------------------------------------------
  call readinputMULT2SPH (wavelength, ind_refMed, anorm, Rcirc, r1, r2,             &
       z1, z2, Nrank1, Nrank2, ind_ref1, ind_ref2, DoConvTest, Nrank, epsNrank,     &
       epsMrank, FileTmat, TypeConvTest, PrnProgress, k, snorm)  
! -----------------------------------------------------------------------------------
!                                      Main                                         !
! -----------------------------------------------------------------------------------                   
  open (unit = iOutput,file = FileOutput,status = "replace") 
  call printinputMULT2SPH (wavelength, ind_refMed, r1, r2, z1, z2, ind_ref1,        &
       ind_ref2, Nrank1, Nrank2, epsNrank, epsMrank, anorm, Rcirc)
  if (DoConvTest) then
    if (TypeConvTest == 1) then
      call convergence_NrankMULT2SPH (k, snorm, r1, r2, ind_ref1, ind_ref2, z1, z2, &
           Nrank1, Nrank2, Nrank, epsNrank, PrnProgress )
    else 
      call convergence_MrankMULT2SPH (k, snorm, r1, r2, ind_ref1, ind_ref2, z1, z2, &
           Nrank1, Nrank2, Nrank, epsMrank, FileTmat, PrnProgress )  
    end if   
  else
    call convergence_MrankMULT2SPH (k, snorm, r1, r2, ind_ref1, ind_ref2, z1, z2,   &
         Nrank1, Nrank2, Nrank, epsMrank, FileTmat, PrnProgress )
  end if
  close (unit = iOutput)
end subroutine TMULT2SPH
!***********************************************************************************
subroutine readinputMULT2SPH (wavelength, ind_refMed, anorm, Rcirc, r1, r2,         &
           z1, z2, Nrank1, Nrank2, ind_ref1, ind_ref2, DoConvTest, Nrank, epsNrank, &
           epsMrank, FileTmat, TypeConvTest, PrnProgress, k, snorm)   
  use parameters
  use derived_parameters
  implicit none 
  integer       :: Nrankp, Nrank1, Nrank2, Nrank, TypeConvTest, ios, NrankW                                    
  real(O)       :: k, ind_refMed, wavelength, anorm, x, snorm, epsNrank, epsMrank,  &
                   rp, zp, r1, r2, z1, z2, Rcirc, xR
  complex(O)    :: ind_refp, ind_ref1, ind_ref2
  logical       :: DoConvTest, PrnProgress, XFindPar
  character(80) :: FileTmat, string
! -----------------------------------------------------------------------------------
!                        Read the input file FileInputMULT2SPH                      ! 
! -----------------------------------------------------------------------------------    
  call DrvParameters  
  open (unit = iInputMULT2SPH, file = FileInputMULT2SPH, status = "old",            &
        position = "rewind")   
  wavelength = 0.1_O * 2._O * Pi                                                                    
  ind_refMed = 1._O
  string     = 'OptProp'
  if (XFindPar (iInputMULT2SPH, string)) then
    read (iInputMULT2SPH, *, iostat = ios) wavelength
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if
    read (iInputMULT2SPH, *, iostat = ios) ind_refMed
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refMed;')"
      stop
    end if         
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if  
  k = 2._O * Pi * ind_refMed / wavelength         
!
  anorm  = 1._O     
  Rcirc  = 1._O
  string = 'GenProp'
  if (XFindPar (iInputMULT2SPH, string)) then
    read (iInputMULT2SPH, *, iostat = ios) anorm
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anorm;')"
      stop
    end if
    read (iInputMULT2SPH, *, iostat = ios) Rcirc
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Rcirc;')"
      stop
    end if         
  else
    print "(/,2x,'Group name GenProp not found;')"
    stop  
  end if    
  call check_anorm (anorm)     
  x = k * anorm
  snorm = Pi * x * x  
!
  rp = 0.2_O
  zp = 0._O             
  Nrankp   = 9
  ind_refp = (1.5_O,0._O) 
  string   = 'PartProp'
  if (XFindPar (iInputMULT2SPH, string)) then
    read (iInputMULT2SPH, *, iostat = ios) rp
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable rp;')"
      print "(  2x,'for the first particle;')"
      stop
    end if
    read (iInputMULT2SPH, *, iostat = ios) zp
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable zp;')"
      print "(  2x,'for the first particle;')"
      stop
    end if
    read (iInputMULT2SPH, *, iostat = ios) Nrankp
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nrankp;')"
      print "(  2x,'for the first particle;')"
      stop
    end if
    read (iInputMULT2SPH, *, iostat = ios) ind_refp
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refp;')"
      print "(  2x,'for the first particle;')"
      stop
    end if
  else
    print "(/,2x,'Group name PartProp not found;')"
    stop  
  end if        
  r1 = rp
  z1 = zp
  Nrank1   = Nrankp
  ind_ref1 = ind_refp
  call check_ind_ref1 (1, ind_ref1)
!
  rp = 0.2_O
  zp = 0._O             
  Nrankp   = 9
  ind_refp = (1.5_O,0._O) 
  string   = 'PartProp'
  if (XFindPar (iInputMULT2SPH, string)) then
    read (iInputMULT2SPH, *, iostat = ios) rp
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable rp;')"
      print "(  2x,'for the second particle;')"
      stop
    end if
    read (iInputMULT2SPH, *, iostat = ios) zp
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable zp;')"
      print "(  2x,'for the second particle;')"
      stop
    end if
    read (iInputMULT2SPH, *, iostat = ios) Nrankp
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nrankp;')"
      print "(  2x,'for the second particle;')"
      stop
    end if
    read (iInputMULT2SPH, *, iostat = ios) ind_refp
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refp;')"
      print "(  2x,'for the second particle;')"
      stop
    end if
  else
    print "(/,2x,'Group name PartProp not found;')"
    stop  
  end if     
  r2 = rp
  z2 = zp
  Nrank2   = Nrankp
  ind_ref2 = ind_refp  
  call check_ind_ref1 (2, ind_ref2)
!
  DoConvTest = .true.
  string     = 'ConvTest'
  if (XFindPar (iInputMULT2SPH, string)) then
    read (iInputMULT2SPH, *, iostat = ios) DoConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DoConvTest;')"
      stop
    end if          
  else
    print "(/,2x,'Group name ConvTest not found;')"
    stop  
  end if   
! 
  if (DoConvTest) then  
    print "(/,2x,'Convergence Test for an Ensemble of Two Spheres')"
    print "(  2x,'-----------------------------------------------')"
  else
    print "(/,2x,'Convergence Test for an Ensemble of Two Spheres over Mrank')"
    print "(  2x,'----------------------------------------------------------')"
  end if   
!
  xR = k * Rcirc 
  NrankW = int(xR + 4.05_O * xR**0.33_O + 2._O)
  if (.not. DoConvTest) then        
    Nrank  =  17
    string = 'NrankCluster'
    if (XFindPar (iInputMULT2SPH, string)) then
      read (iInputMULT2SPH, *, iostat = ios) Nrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nrank;')"
        stop
      end if          
    else
      print "(/,2x,'Group name NrankCluster not found;')"
      stop  
    end if     
    print "(/,2x,'Input values:')"
    print "(  2x,'the input value of Nrank is ', i3,', while the estimated')", Nrank 
    print "(  2x,'value of Nrank from Wiscombe''s criterion is ', i3,';')", NrankW 
  else    
    print "(/,2x,'Nrank estimate:')"                                                    
    print "(  2x, a, i3, a)",                                                       &
   'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'           
    print "(/,2x,'- enter the estimated value of Nrank;')"
    call read_integer (Nrank)       
  end if
  if (Nrank < Nrank1 .or. Nrank < Nrank2)                                           &
      print "(/,2x,'Warning: the value of Nrank is too low;')"
!
  if (DoConvTest) then  
    print "(/,2x,'- enter the type of convergence test: 1 - Nrank, 2 - Mrank;')"
    call read_integerbound (TypeConvTest, 1, 2)
  else
    TypeConvTest = 2
  end if 
!
  epsNrank = 5.e-2_O
  epsMrank = 5.e-2_O 
  string   = 'Errors'
  if (XFindPar (iInputMULT2SPH, string)) then
     read (iInputMULT2SPH, *, iostat = ios) epsNrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNrank;')"
      stop
    end if 
    read (iInputMULT2SPH, *, iostat = ios) epsMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsMrank;')"
      stop
    end if
  else
    print "(/,2x,'Group name Errors not found;')"
    stop  
  end if   
!
  FileTmat = '../TMATFILES/T.dat'
  string   = 'Tmat'
  if (XFindPar (iInputMULT2SPH, string)) then
    read (iInputMULT2SPH, *, iostat = ios) FileTmat
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileTmat;')"
      stop
    end if          
  else
    print "(/,2x,'Group name Tmat not found;')"
    stop  
  end if  
!
  PrnProgress = .true.
  string      = 'PrintProgress'
  if (XFindPar (iInputMULT2SPH, string)) then
    read (iInputMULT2SPH, *, iostat = ios) PrnProgress
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if          
  else
    print "(/,2x,'Group name PrintProgress not found;')"
    stop  
  end if    
  close (unit = iInputMULT2SPH)
end subroutine readinputMULT2SPH
!***********************************************************************************
subroutine printinputMULT2SPH (wavelength, ind_refMed, r1, r2, z1, z2, ind_ref1,    &
           ind_ref2, Nrank1, Nrank2, epsNrank, epsMrank, anorm, Rcirc)
  use parameters
  implicit none  
  integer       :: Nrank1, Nrank2, Nrank
  real(O)       :: wavelength, ind_refMed, r1, r2, z1, z2, epsNrank, epsMrank, x,   &
                   anorm, Rcirc, k
  complex(O)    :: ind_ref1, ind_ref2  
!
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x,'wavelength of the free space, wavelength = ',1pe13.4,';')")  &
         wavelength
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'refractive index of the ambient medium, ind_refMed = ', ind_refMed, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'characteristic length of the cluster, anorm = ', anorm, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'radius of the circumscribing sphere, Rcirc = ', Rcirc, ';'
  write (iOutput,*)
  write (iOutput,"(2x,'particle 1: ')")
  write (iOutput,"(2x,'radius: r = ',1pe10.3,';')") r1
  write (iOutput,"(2x,'axial position: z = ',1pe10.3,';')") z1
  write (iOutput,"(2x, a, 1pe10.3, ',', 1pe10.3, a)")                               &
 'relative refractive index of the particle, ind_refRel = (', ind_ref1, ');' 
  write (iOutput,"(2x,'maximum expansion order: Nrank = ',i3,';')") Nrank1
  k = 2._O * Pi * ind_refMed / wavelength  
  x = k * r1
  Nrank = int(x + 4.05_O * x**0.33_O + 2._O)
  write (iOutput,"(2x, a, i3, a)")                                                  &
 'the estimated value of Nrank from Wiscombe criterion is ', Nrank, ';' 
  write (iOutput,*)
  write (iOutput,"(2x,'particle 2: ')")
  write (iOutput,"(2x,'radius: r = ',1pe10.3,';')") r2
  write (iOutput,"(2x,'axial position: z = ',1pe10.3,';')") z2
  write (iOutput,"(2x, a, 1pe10.3, ',', 1pe10.3, a)")                               &
 'relative refractive index of the particle, ind_refRel = (', ind_ref2, ');' 
  write (iOutput,"(2x,'maximum expansion order: Nrank = ',i3,';')") Nrank2
  x = k * r2
  Nrank = int(x + 4.05_O * x**0.33_O + 2._O)
  write (iOutput,"(2x, a, i3, a)")                                                  &
 'the estimated value of Nrank from Wiscombe criterion is ', Nrank, ';' 
  write (iOutput,*)
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum expansion order tolerance, epsNrank = ', epsNrank, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum azimuthal order tolerance, epsMrank = ', epsMrank, '.'            
  write (iOutput,"(/)")                       
end subroutine printinputMULT2SPH
!***********************************************************************************
subroutine convergence_NrankMULT2SPH (k, snorm, r1, r2, ind_ref1, ind_ref2, z1, z2, &
           Nrank1, Nrank2, Nrank, epsNrank, PrnProgress )
  use parameters
  implicit none
  integer       :: Nrank1, Nrank2, Nrank  
  real(O)       :: k, snorm, r1, r2, z1, z2, epsNrank
  complex(O)    :: ind_ref1, ind_ref2
  logical       :: PrnProgress 
!       
  integer       :: m, Mstart, Mrank, MM, NN, Nmaxim, Nrankrank, Nmax, Nmax1, Nmax2, &
                   Nmaxmax, Nteta, i, NthetaConv, NrankAL  
  real(O)       :: alfap, tetaGI, phiGI, phiGS, alfa, beta, gama, Cscat, Qscat,     &
                   Cext, Qext, z1z2
  logical       :: type1, type2                             
  real(O),allocatable    :: h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: CC1(:,:), CC2(:,:), CC3(:,:), aa(:,:), bb(:,:), a(:,:), &
                            b(:,:), c(:,:), t1(:), t2(:), c1(:), c2(:), ce(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1
  MM = Nrank
  NN = Nrank + 5
  Nmax   = Nrank
  Nmax1  = Nrank1
  Nmax2  = Nrank2
  Nmaxim = Nrank  + Mrank * (2 * Nrank - Mrank + 1) 
  Nrankrank = Nrank1 + Nrank2 
  Nmaxmax = Nmax1  + Nmax2 
  NrankAL = max(Nrank, Nrank1, Nrank2)
  call write_TypeConvHead (2)
  allocate (CC1(0:NN,0:2*NN+1),  CC2(0:NN,0:2*NN+1),  CC3(0:NN,0:2*NN+1))   
  allocate (aa(2*Nrankrank,2*Nrankrank), bb(2*Nrankrank,2*NrankAL))        
  allocate (a(2*NrankAL,2*NrankAL), b(2*NrankAL,2*NrankAL), c(2*NrankAL,2*NrankAL))
  allocate (t1(2*Nrank1), t2(2*Nrank2))
  allocate (c1(2*NrankAL), c2(2*NrankAL), ce(2*Nmaxim))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do 
  z1z2 = abs(z1 - z2)
  if (z1 > z2) then
    type1 = .false.
    type2 = .true.
  else
    type1 = .true.
    type2 = .false.
  end if
  if (PrnProgress) call write_progress (.true., 1, 8)
! --- Nrank configuration ---  
  do m = 0, 1    
    call MatTransCmnn1 (3, k, z1z2, m, NN, CC3,  NN)
    call MatTransCmnn1 (1, k, z1,   m, NN, CC1,  NN)          
    call MatTransCmnn1 (1, k, z2,   m, NN, CC2,  NN)      
    if (m /= 0) then
      call coefficients_fg_m (k, r1, ind_ref1, m, Nrank1, Nmax1, t1)    
      call coefficients_fg_m (k, r2, ind_ref2, m, Nrank2, Nmax2, t2)        
      call identity_matrix (2*Nmaxmax, aa, 2*Nrankrank, 2*Nrankrank)    
      call MatTransAB_mnn1 (k,type1, z1z2, m, CC3, NN, Nmax1, Nmax2, a,             &
           NrankAL, NrankAL)        
      call product_matrix_vector1 (2*Nmax1, 2*Nmax2, t1, a, 2*NrankAL, 2*NrankAL,   &
           b, 2*NrankAL, 2*NrankAL) 
      call extend_matrix3 (Nmax1, Nmax2, 0, 2*Nmax1, b, NrankAL, NrankAL, aa,       &
           Nrankrank, Nrankrank)
      if (PrnProgress) call write_progress (.false., 2, 8)                                    
      call MatTransAB_mnn1 (k,type2, z1z2, m, CC3, NN, Nmax2, Nmax1, a,             &
           NrankAL, NrankAL)          
      call product_matrix_vector1 (2*Nmax2, 2*Nmax1, t2, a, 2*NrankAL, 2*NrankAL,   &
           b, 2*NrankAL, 2*NrankAL)
      call extend_matrix3 (Nmax2, Nmax1, 2*Nmax1, 0, b, NrankAL, NrankAL, aa,       &
           Nrankrank, Nrankrank)
      if (PrnProgress) call write_progress (.false., 3, 8)                      
      call MatTransAB_mnn1 (k,.false., z1, m, CC1, NN, Nmax1, Nmax, a,              &
           NrankAL, NrankAL)           
      call product_matrix_vector1 (2*Nmax1, 2*Nmax, t1, a, 2*NrankAL, 2*NrankAL,    &
           b, 2*NrankAL, 2*NrankAL)
      call extend_matrix4 (1, Nmax1, Nmax, Nmaxmax, 0, b, NrankAL, NrankAL, bb,     &
           Nrankrank, NrankAL) 
      if (PrnProgress) call write_progress (.false., 4, 8)
      call MatTransAB_mnn1 (k,.false., z2, m, CC2, NN, Nmax2, Nmax, a,              &
           NrankAL, NrankAL)      
      call product_matrix_vector1 (2*Nmax2, 2*Nmax, t2, a, 2*NrankAL, 2*NrankAL,    &
           b, 2*NrankAL, 2*NrankAL)
      call extend_matrix4 (2, Nmax2, Nmax, Nmaxmax, 2*Nmax1, b, NrankAL, NrankAL,   &
           bb, Nrankrank, NrankAL)  
      if (PrnProgress) call write_progress (.false., 5, 8)
      call LU_SYSTEM_DIRECT (aa, 2*Nrankrank, 2*Nrankrank, bb, 2*Nrankrank,         &
           2*NrankAL, 2*Nmaxmax, 2*Nmax)
      if (PrnProgress) call write_progress (.false., 6, 8)                   
      call extract_matrix2 (Nmax1, Nmax, 0, b, NrankAL, NrankAL, bb, Nrankrank,     &
           NrankAL)
      call MatTransAB_mnn1 (k,.true., z1, m, CC1, NN, Nmax, Nmax1, a,               &
           NrankAL, NrankAL)
      call product_matrices2 (1, 2*Nmax, 2*Nmax1, 2*Nmax, a, 2*NrankAL, 2*NrankAL,  &
           b, 2*NrankAL, 2*NrankAL, c, 2*NrankAL, 2*NrankAL)    
      if (PrnProgress) call write_progress (.false., 7, 8)
      call extract_matrix2 (Nmax2, Nmax, 2*Nmax1, b, NrankAL, NrankAL,              &
           bb, Nrankrank, NrankAL)
      call MatTransAB_mnn1 (k,.true., z2, m, CC2, NN, Nmax, Nmax2, a,               &
           NrankAL, NrankAL)
      call product_matrices2 (2, 2*Nmax, 2*Nmax2, 2*Nmax, a, 2*NrankAL, 2*NrankAL,  &
           b, 2*NrankAL, 2*NrankAL, c, 2*NrankAL, 2*NrankAL)                
      if (PrnProgress) call write_progress (.false., 8, 8)
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,   &
           Nmax, c1)
      call product_matrix_vector (2*Nmax, 2*Nmax, c, 2*NrankAL, 2*NrankAL, c1, c2)
      call extend_vector_positive (c2, ce, m, Mstart, Nrank, Nmax, Nmaxim)        
      call matrix_m_negativ (Nmax, Nmax, c, NrankAL, NrankAL)         
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,  &
           Nmax, c1)        
      call product_matrix_vector (2*Nmax, 2*Nmax, c, 2*NrankAL, 2*NrankAL, c1, c2)
      call extend_vector_negative (c2, ce, m, Nrank, Nmax, Nmaxim)      
    end if
  end do 
  call DSCS (ce, Mrank, Nrank, Nmaxim, Nteta, phiGS, alfa, beta, gama, k, snorm,    &
      .false.,.true., h, v)    
  call CQscat (ce, Mrank, Nrank, Nmaxim, k, snorm, Cscat, Qscat)
  call CQext (ce, Mrank, Nrank, Nmaxim, tetaGI, phiGI, alfa, beta, gama,            &
       alfap, k, snorm, Cext, Qext)
  do i = 1, Nteta
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do  
  call write_2ConvParam (Nrank, Mrank)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)   
! --- (Nrank - 1) configuration ---
  m = 1
  if (PrnProgress) call write_progress_low
  call matrix_m_negativ (Nmax, Nmax, c, NrankAL, NrankAL)
  call matrix_Nrank_m (Nmax, c, NrankAL, NrankAL)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,       &
       Nmax, c1)
  call product_matrix_vector (2*Nmax, 2*Nmax, c, 2*NrankAL, 2*NrankAL, c1, c2)
  call extend_vector_positive (c2, ce, m, Mstart, Nrank, Nmax, Nmaxim)
  call matrix_m_negativ (Nmax, Nmax, c, NrankAL, NrankAL)             
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap,-m, Nrank,       &
       Nmax, c1)        
  call product_matrix_vector (2*Nmax, 2*Nmax, c, 2*NrankAL, 2*NrankAL, c1, c2)
  call extend_vector_negative (c2, ce, m, Nrank, Nmax, Nmaxim)
  call DSCS (ce, Mrank, Nrank, Nmaxim, Nteta, phiGS, alfa, beta, gama, k, snorm,    &
      .false.,.true., h, v)
  call CQscat (ce, Mrank, Nrank, Nmaxim, k, snorm, Cscat, Qscat)
  call CQext (ce, Mrank, Nrank, Nmaxim, tetaGI, phiGI, alfa, beta, gama,            &
       alfap, k, snorm, Cext, Qext)
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConv)  
  call write_2ConvParam (Nrank - 1, Mrank)
  call write_DSCS (Nteta,.false., h, v) 
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConv, Nteta, epsNrank)
  deallocate (CC1, CC2, CC3, aa, bb, a, b, c, c1, c2, ce, t1, t2, h, v, oldh, oldv) 
end subroutine convergence_NrankMULT2SPH
!***********************************************************************************
subroutine convergence_MrankMULT2SPH (k, snorm, r1, r2, ind_ref1, ind_ref2, z1, z2, &
           Nrank1, Nrank2, Nrank, epsMrank, FileTmat, PrnProgress )
  use parameters
  implicit none
  integer       :: Nrank1, Nrank2, Nrank  
  real(O)       :: k, snorm, r1, r2, z1, z2, epsMrank
  complex(O)    :: ind_ref1, ind_ref2
  character(80) :: FileTmat
  logical       :: PrnProgress 
!       
  integer       :: m, Mstart, Mrank, MM, NN, Nmaxim, Nrankrank, Nmax, Nmax1, Nmax2, &
                   Nmaxmax, Nteta, i, NthetaConv, NrankAL  
  real(O)       :: alfap, tetaGI, phiGI, phiGS, alfa, beta, gama, Cscat, Qscat,     &
                   Cext, Qext, z1z2 
  logical       :: type1, type2
  real(O),allocatable    :: h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: CC1(:,:), CC2(:,:), CC3(:,:), aa(:,:), bb(:,:), a(:,:), &
                            b(:,:), c(:,:), t1(:), t2(:), c1(:), c2(:), ce(:)   
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 0
  Mrank  = Nrank
  MM = Nrank
  NN = Nrank  + 5
  Nmaxim  = Nrank  + Mrank * (2 * Nrank - Mrank + 1) 
  Nrankrank = Nrank1 + Nrank2  
  NrankAL = max(Nrank,Nrank1,Nrank2)
  call write_TypeConvHead (3)
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call  write_HeadFileTmat (NrankAL, NrankAL) 
  allocate (CC1(0:NN,0:2*NN+1), CC2(0:NN,0:2*NN+1), CC3(0:NN,0:2*NN+1))   
  allocate (aa(2*Nrankrank,2*Nrankrank), bb(2*Nrankrank,2*NrankAL))        
  allocate (a(2*NrankAL,2*NrankAL), b(2*NrankAL,2*NrankAL), c(2*NrankAL,2*NrankAL))
  allocate (t1(2*Nrank1), t2(2*Nrank2))
  allocate (c1(2*NrankAL), c2(2*NrankAL), ce(2*Nmaxim))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do 
  z1z2 = abs(z1 - z2)
  if (z1 > z2) then
    type1 = .false.
    type2 = .true.
  else
    type1 = .true.
    type2 = .false.
  end if
  Mrank = - 1
  do m = Mstart, MM    
    call write_1ConvParam (m)
    Mrank = Mrank + 1       
    if (m > Nrank1) Nrank1 = m
    if (m > Nrank2) Nrank2 = m
    if (m == 0) then
      Nmax  = Nrank
      Nmax1 = Nrank1
      Nmax2 = Nrank2
    else
      Nmax  = Nrank - m + 1
      Nmax1 = Nrank1 - m + 1
      Nmax2 = Nrank2 - m + 1
    end if
    Nmaxmax = Nmax1 + Nmax2
    if (PrnProgress) call write_progress_m (.true., m, 1, 8)        
    call MatTransCmnn1 (3, k, z1z2, m, NN, CC3, NN)
    call MatTransCmnn1 (1, k, z1, m, NN, CC1, NN)     
    call MatTransCmnn1 (1, k, z2, m, NN, CC2, NN) 
    call coefficients_fg_m (k, r1, ind_ref1, m, Nrank1, Nmax1, t1)  
    call coefficients_fg_m (k, r2, ind_ref2, m, Nrank2, Nmax2, t2)  
    call identity_matrix (2*Nmaxmax, aa, 2*Nrankrank, 2*Nrankrank)     
    call MatTransAB_mnn1 (k, type1, z1z2, m, CC3, NN, Nmax1, Nmax2, a,              &
         NrankAL, NrankAL)  
    call product_matrix_vector1 (2*Nmax1, 2*Nmax2, t1, a, 2*NrankAL, 2*NrankAL,     &
         b, 2*NrankAL, 2*NrankAL)   
    call extend_matrix3 (Nmax1, Nmax2, 0, 2*Nmax1, b, NrankAL, NrankAL, aa,         &
         Nrankrank, Nrankrank)   
    if (PrnProgress) call write_progress_m (.false., m, 2, 8)         
    call MatTransAB_mnn1 (k, type2, z1z2, m, CC3, NN, Nmax2, Nmax1, a,              &
         NrankAL, NrankAL)
    call product_matrix_vector1 (2*Nmax2, 2*Nmax1, t2, a, 2*NrankAL, 2*NrankAL,     &
         b, 2*NrankAL, 2*NrankAL)
    call extend_matrix3 (Nmax2, Nmax1, 2*Nmax1, 0, b, NrankAL, NrankAL, aa,         &
         Nrankrank, Nrankrank)      
    if (PrnProgress) call write_progress_m (.false., m, 3, 8)   
    call MatTransAB_mnn1 (k,.false., z1, m, CC1, NN, Nmax1, Nmax, a,                &
         NrankAL, NrankAL)
    call product_matrix_vector1 (2*Nmax1, 2*Nmax, t1, a, 2*NrankAL, 2*NrankAL,      &
         b, 2*NrankAL, 2*NrankAL)
    call extend_matrix4 (1, Nmax1, Nmax, Nmaxmax, 0, b, NrankAL, NrankAL, bb,       &
         Nrankrank, NrankAL) 
    if (PrnProgress) call write_progress_m (.false., m, 4, 8)   
    call MatTransAB_mnn1 (k,.false., z2, m, CC2, NN, Nmax2, Nmax, a,                &  
         NrankAL, NrankAL)
    call product_matrix_vector1 (2*Nmax2, 2*Nmax, t2, a, 2*NrankAL, 2*NrankAL,      &
         b, 2*NrankAL, 2*NrankAL)
    call extend_matrix4 (2, Nmax2, Nmax, Nmaxmax, 2*Nmax1, b, NrankAL, NrankAL,     &
         bb, Nrankrank, NrankAL)             
    if (PrnProgress) call write_progress_m (.false., m, 5, 8)   
    call LU_SYSTEM_DIRECT (aa, 2*Nrankrank, 2*Nrankrank, bb, 2*Nrankrank,           &
         2*NrankAL, 2*Nmaxmax,2*Nmax)  
    if (PrnProgress) call write_progress_m (.false., m, 6, 8)   
    call extract_matrix2 (Nmax1, Nmax, 0, b, NrankAL, NrankAL, bb, Nrankrank,       &
         NrankAL)
    call MatTransAB_mnn1 (k,.true., z1, m, CC1, NN, Nmax, Nmax1, a,                 &
         NrankAL, NrankAL)
    call product_matrices2 (1, 2*Nmax, 2*Nmax1, 2*Nmax, a, 2*NrankAL, 2*NrankAL,    &
         b, 2*NrankAL, 2*NrankAL, c, 2*NrankAL, 2*NrankAL)    
    if (PrnProgress) call write_progress_m (.false., m, 7, 8)   
    call extract_matrix2 (Nmax2, Nmax, 2*Nmax1, b, NrankAL, NrankAL, bb,            &
         Nrankrank, NrankAL)
    call MatTransAB_mnn1 (k,.true., z2, m, CC2, NN, Nmax, Nmax2, a,                 &
         NrankAL, NrankAL)
    call product_matrices2 (2, 2*Nmax, 2*Nmax2, 2*Nmax, a, 2*NrankAL, 2*NrankAL,    &
         b, 2*NrankAL, 2*NrankAL, c, 2*NrankAL, 2*NrankAL)                      
    if (PrnProgress) call write_progress_m (.false., m, 8, 8)   
    call write_FileTmat (NrankAL, NrankAL, c)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         Nmax, c1)
    call product_matrix_vector (2*Nmax, 2*Nmax, c, 2*NrankAL, 2*NrankAL, c1, c2)
    call extend_vector_positive (c2, ce, m, Mstart, Nrank, Nmax, Nmaxim)
    if (m /= 0) then      
      call matrix_m_negativ (Nmax, Nmax, c, NrankAL, NrankAL)         
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap,-m, Nrank,   &
           Nmax, c1)        
      call product_matrix_vector (2*Nmax, 2*Nmax, c, 2*NrankAL, 2*NrankAL, c1, c2)
      call extend_vector_negative (c2, ce, m, Nrank, Nmax, Nmaxim)      
    end if
    call DSCS (ce, Mrank, Nrank, Nmaxim, Nteta, phiGS, alfa, beta, gama, k, snorm,  &
        .false.,.true., h, v)
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsMrank, NthetaConv)     
    call write_DSCS (Nteta,.false., h, v)
    if (NthetaConv >= int(0.8*Nteta)) exit 
  end do
  close (unit = iTmat)
  call CQscat (ce, Mrank, Nrank, Nmaxim, k, snorm, Cscat, Qscat)
  call CQext (ce, Mrank, Nrank, Nmaxim, tetaGI, phiGI, alfa, beta, gama,            &
       alfap, k, snorm, Cext, Qext)
  call write_Effic (Qscat, Qext)
  call write_MrankConvRes (NthetaConv, epsMrank)
  if (NthetaConv >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criterion for Mrank is satisfied;')"
  else
    print "(/,2x,'Convergence criterion for Mrank is not satisfied;')"
  end if
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .true., .false., .false.)
  call ScatCharact (k, FileTmat, Mrank, Nrank, .true., .false., .false.)
  print "(/,2x,'The T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank 
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank                     
  deallocate (CC1, CC2, CC3, aa, bb, a, b, c, c1, c2, ce, t1, t2, h, v, oldh, oldv) 
end subroutine convergence_MrankMULT2SPH

       

! **********************************************************************************
! *           SCATTERING CHARACTERISTICS: RANDOMLY ORIENTED PARTICLES              *
! *   --------------------------------------------------------------------------   *
! *   Partial list of subroutines:                                                 *
! *     DiffScatCrossSectAvrg,      ScatteringMatrix,           HovTest,           *     
! *     ExtendedScatteringMatrix,   AsymmetryParameter,         SijSCpqEff,        *
! *     AvCscatCextEff,             tnScatEff,                  tnScatAxsymEff,    *
! *     tnExtEff,                   tnExtAxsymEff,              tnExtOffEff,       *
! *     RandomExtinctionMatrix,     AvCscatCextV,               MNinfiniteMatrix,  * 
! *     IdentifyMatrixElement,      IdentifyMatrixElementAxsym, IdentifyIndex,     *
! *     Hv,                         dimensionTV,                formTV,            *  
! *     SijSCpqInt,                 Smatrix                                        *
! **********************************************************************************
subroutine DiffScatCrossSectAvrg (MirorSym, SS, Ntheta, anorm, epol_beta,           &
           epol_alpha, phiGS, normalized, Cscat, Cext, Qscat, Qext,                 &
           CscatV, CextV, QscatV, QextV)
! -----------------------------------------------------------------------------------
! The routine computes the average differential scattering cross section at a set   !
! of Ntheta scattering angles in the azimuthal plane phiGS. The incident            !
! polarization state is described by the polarization vector                        !
!                 epol = epol_beta * e_beta + epol_alpha * e_alpha.                 !
! The average differential scattering cross section for parallel and perpendicular  !
! polarizations are given by                                                        !
!           <h> = <|FS_theta|**2>                                                   !    
!               = <|S(1,1)|**2> * |e_beta|**2 + <|S(1,2)|**2> * |e_alpha|**2        !
!                 + 2*Re{ <S(1,1)*conjg(S(1,2))> * e_beta * conjg(e_alpha) }        !
! and                                                                               !                                             
!           <v> = <|FS_phi|**2>                                                     !
!               = <|S(2,1)|**2> * |e_beta|**2 + <|S(2,2)|**2> * |e_alpha|**2        !                   
!                 + 2*Re{ <S(2,1)*conjg(S(2,2))> * e_beta * conjg(e_alpha) }        !
! where                                                                             !
!           e_beta  =   epol_beta * cos(phiGS) + epol_alpha * sin(phiGS),           !
!           e_alpha = - epol_beta * sin(phiGS) + epol_alpha * cos(phiGS).           !
! For isotropic and mirror-symmetric media                                          !
!              Re{ <S(1,1)*conjg(S(1,2))> } = 0                                     !    
! and                                                                               !
!              Re{ <S(2,1)*conjg(S(2,2))> } = 0.                                    !
! -----------------------------------------------------------------------------------
  use parameters
  implicit none 
  integer       :: Ntheta, i
  real(O)       :: anorm, phiGS, Cscat, Cext, Qscat, Qext, CscatV, CextV, QscatV,   &
                   QextV, eb2, ea2, fact, h, v, theta, norm     
  complex(O)    :: SS(10,Ntheta), epol_beta, epol_alpha, e_beta, e_alpha, eba,      &
                   S11S12eba, S21S22eba 
  logical       :: MirorSym, normalized
!  
  write (iDSCS,"(/,2x,'Results:',/)")
  write (iDSCS,"(  2x,'Cross Sections and Efficiencies:')")      
  if (.not.MirorSym) then
    write (iDSCS,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                                &
          '<Cscat>_I = ', Cscat,  '<Qscat>_I = ', Qscat 
    write (iDSCS,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                                &
          '<Cscat>_V = ', CscatV, '<Qscat>_V = ', QscatV 
    write (iDSCS,*)	    
    write (iDSCS,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                                &
          '<Cext>_I  = ', Cext,   '<Qext>_I  = ', Qext
    write (iDSCS,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                                &
          '<Cext>_V  = ', CextV,  '<Qext>_V  = ', QextV	    
    write (iDSCS,*)           	    	                          
  else   
    write (iDSCS,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                                &
          '<Cscat> = ', Cscat,  '<Qscat> = ', Qscat
    write (iDSCS,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                                &
          '<Cext>  = ', Cext,   '<Qext>  = ', Qext       
  end if 
  write (iDSCS,*)        
  write (iDSCS,"(2x,'Differential Scattering Cross Section:')")      
  if (normalized) then
    write (iDSCS,"(2x, a, /, 2x, a, 9x, a, 8x, a, /)")                              &
   'normalized average  differential scattering cross section', 'theta',            &
   'parallel', 'perpendicular'                  
  else
    write (iDSCS,"(8x, a, /, 2x, a, 9x, a, 8x, a, /)")                              &
   'average differential scattering cross section', 'theta',                        &
   'parallel', 'perpendicular'                            
  end if  
  norm       =   sqrt ( abs(epol_beta)**2 + abs(epol_alpha)**2 )  
  epol_beta  =   epol_beta  / norm
  epol_alpha =   epol_alpha / norm       
  e_beta     =   epol_beta * cos(phiGS) + epol_alpha * sin(phiGS)  
  e_alpha    = - epol_beta * sin(phiGS) + epol_alpha * cos(phiGS)    
  eb2  = abs(e_beta )**2
  ea2  = abs(e_alpha)**2
  eba  = e_beta * conjg(e_alpha)               
  fact = Pi * anorm * anorm
  fact = 1._O / fact
  do i = 1, Ntheta    
    theta = real(i - 1,O) * 180._O / real(Ntheta - 1,O)
    if (.not.MirorSym) then
      S11S12eba = SS(2,i) * eba
      h = real(SS(1,i),O) * eb2 + real(SS( 5,i),O) * ea2 +                          &
          2._O * real(S11S12eba,O)	    
      S21S22eba = SS(9,i) * eba	    
      v = real(SS(8,i),O) * eb2 + real(SS(10,i),O) * ea2 +                          &
          2._O * real(S21S22eba,O)          
    else
      h = real(SS(1,i),O) * eb2 + real(SS( 5,i),O) * ea2             
      v = real(SS(8,i),O) * eb2 + real(SS(10,i),O) * ea2        
    end if               
    if (normalized) then
      h = h * fact
      v = v * fact                                          
    end if  
    write (iDSCS,"(1x,f6.2,5x,1pe13.4,5x,1pe13.4)") theta, h, v
  end do
end subroutine DiffScatCrossSectAvrg 
! **********************************************************************************
subroutine ScatteringMatrix (MirorSym, theta, Ntheta, ZE, Z)
!-----------------------------------------------------------------------------------
! The routine computes the scattering matrix Z at a specified scattering angle     !
! theta. ZE is the extended scattering matrix and Ntheta is the number of zenith   !
! angles (at which the extended scattering matrix is computed) in the azimuthal    !
! plane phi = 0°.                                                                  !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Ntheta
  real(O)    :: theta, ZE(4,4,Ntheta), Z(4,4)
  logical    :: MirorSym   
!
  integer    :: i
  real(O)    :: Z11, Z12, Z13, Z14, Z22, Z23, Z24, Z33, Z34, Z44    
  real(O),allocatable :: thetaV(:), ZV(:) 
! 
  allocate (thetaV(Ntheta), ZV(Ntheta))
  do i = 1, Ntheta
    thetaV(i) = real(i - 1,O) * Pi / real(Ntheta - 1,O)            
  end do  
  do i = 1, Ntheta
    ZV(i) = ZE(1,1,i)
  end do      
  call Interp (Ntheta, thetaV, ZV, theta, Z11)                          
  do i = 1, Ntheta
    ZV(i) = ZE(1,2,i)
  end do
  call Interp (Ntheta, thetaV, ZV, theta, Z12)  
!  
  do i = 1, Ntheta
    ZV(i) = ZE(2,2,i)
  end do   
  call Interp (Ntheta, thetaV, ZV, theta, Z22)      
!  
  do i = 1, Ntheta
    ZV(i) = ZE(3,3,i)
  end do
  call Interp (Ntheta, thetaV, ZV, theta, Z33)    
  do i = 1, Ntheta
    ZV(i) = ZE(3,4,i)
  end do
  call Interp (Ntheta, thetaV, ZV, theta, Z34)    
!  
  do i = 1, Ntheta
    ZV(i) = ZE(4,4,i)
  end do
  call Interp (Ntheta, thetaV, ZV, theta, Z44)  
!
  if (.not.MirorSym) then
    do i = 1, Ntheta
      ZV(i) = ZE(1,3,i)
    end do    
    call Interp (Ntheta, thetaV, ZV, theta, Z13)    
    do i = 1, Ntheta
      ZV(i) = ZE(1,4,i)
    end do
    call Interp (Ntheta, thetaV, ZV, theta, Z14)  
!
    do i = 1, Ntheta
      ZV(i) = ZE(2,3,i)
    end do
    call Interp (Ntheta, thetaV, ZV, theta, Z23)
    do i = 1, Ntheta
      ZV(i) = ZE(2,4,i)
    end do
    call Interp (Ntheta, thetaV, ZV, theta, Z24)         
  end if   
  Z(1,1) = Z11    
  Z(1,2) = Z12
  if (.not.MirorSym) then
    Z(1,3) = Z13
    Z(1,4) = Z14              
  else
    Z(1,3) = 0._O
    Z(1,4) = 0._O            
  end if     
!  
  Z(2,1) = Z12
  Z(2,2) = Z22
  if (.not.MirorSym) then
    Z(2,3) = Z23
    Z(2,4) = Z24              
  else
    Z(2,3) = 0._O
    Z(2,4) = 0._O            
  end if    
! 
  if (.not.MirorSym) then
    Z(3,1) = - Z13
    Z(3,2) = - Z23              
  else
    Z(3,1) = 0._O
    Z(3,2) = 0._O            
  end if   
  Z(3,3) = Z33
  Z(3,4) = Z34
! 
  if (.not.MirorSym) then
    Z(4,1) = Z14
    Z(4,2) = Z24              
  else
    Z(4,1) = 0._O
    Z(4,2) = 0._O            
  end if  
  Z(4,3) = - Z34
  Z(4,4) =   Z44
  deallocate (thetaV, ZV)
end subroutine ScatteringMatrix
! **********************************************************************************
subroutine HovTest (Z, FailHovTest, Nfail, FailMessage)
! ----------------------------------------------------------------------------------
! The routine performs the Hovenier and van der Mee test of the phase matrix.      !
! ----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer        :: Nfail
  real(O)        :: Z(4,4)
  logical        :: FailHovTest
  character(256) :: FailMessage(10)
!
  integer :: ifail
  real(O) :: tol, tmp 
!  
  ifail = 0
  tol   = 1.e-3_O
  if (Z(1,1) < 0._O) then
    FailHovTest = .true.      
    ifail = ifail + 1
    FailMessage (ifail) = 'the condition Z11 > 0 is not satisfied;'
  end if
  if (abs(Z(1,2)) > Z(1,1)) then
    FailHovTest = .true.
    ifail = ifail + 1
    FailMessage (ifail) = 'the condition |Z12| < Z11 is not satisfied;'
  end if
  if (abs(Z(2,2)) > Z(1,1)) then
    FailHovTest = .true.
    ifail = ifail + 1
    FailMessage (ifail) = 'the condition |Z22| < Z11 is not satisfied;'
  end if
  if (abs(Z(3,3)) > Z(1,1)) then
    FailHovTest = .true.
    ifail = ifail + 1
    FailMessage (ifail) = 'the condition |Z33| < Z11 is not satisfied;'
  end if
  if (abs(Z(3,4)) > Z(1,1)) then
    FailHovTest = .true.
    ifail = ifail + 1
    FailMessage (ifail) = 'the condition |Z34| < Z11 is not satisfied;'
  end if
  if (abs(Z(4,4)) > Z(1,1)) then
    FailHovTest = .true.
    ifail = ifail + 1
    FailMessage (ifail) = 'the condition |Z44| < Z11 is not satisfied;'
  end if   
  tmp = (Z(3,3) + Z(4,4))**2 + 4._O * Z(3,4)**2 - (Z(1,1) + Z(2,2))**2 +            &
         4._O * Z(1,2)**2 
  if (tmp > tol) then
    FailHovTest = .true.
    ifail = ifail + 1
    FailMessage (ifail) =                                                           &
   'the condition (Z33 + Z44)**2 + 4*Z34**2 < (Z11 + Z22)**2 - 4*Z12**2  is not satisfied;'
  end if
  tmp = abs(Z(3,3) - Z(4,4)) - Z(1,1) + Z(2,2)
  if (tmp > tol) then
    FailHovTest = .true.
    ifail = ifail + 1
    FailMessage (ifail) =                                                           &
   'the condition |Z33 - Z44| < Z11 - Z22 is not satisfied;'
  end if
  tmp = abs(Z(2,2) - Z(1,2)) - Z(1,1) + Z(1,2)
  if (tmp > tol) then
    FailHovTest = .true.
    ifail = ifail + 1
    FailMessage (ifail) =                                                           &
   'the condition |Z22 - Z12| < Z11 - Z12 is not satisfied;'
  end if
  tmp = abs(Z(2,2) + Z(1,2)) - Z(1,1) - Z(1,2)
  if (tmp > tol) then
    FailHovTest = .true.
    ifail = ifail + 1
    FailMessage (ifail) =                                                           &
   'the condition |Z22 + Z12| < Z11 + Z12 is not satisfied;'
  end if
  Nfail = ifail
end subroutine HovTest
! **********************************************************************************
subroutine ExtendedScatteringMatrix (MirorSym, Ntheta, SS, ZE)
!-----------------------------------------------------------------------------------
! The routine computes the scattering matrix ZE for all scattering angles in the   !
! azimuthal plane phi = 0°. SS is the average matrix <SpqSp1q1*> and Ntheta is the !
! number of zenith angles in the azimuthale plane phi = 0°.                        !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Ntheta, i
  real(O)    :: ZE(4,4,Ntheta)
  complex(O) :: SS(10,Ntheta)
  complex(O) :: S11SC11, S11SC12, S11SC21, S11SC22, S12SC12, S12SC21, S12SC22,      &
                S21SC21, S21SC22, S22SC22, S21SC11, S21SC12, S22SC11, S22SC12,      &
                S22SC21   
  logical    :: MirorSym		
!
  do i = 1, Ntheta        
    S11SC11 = SS(1,i)                    
    S11SC22 = SS(4,i)        
    S12SC12 = SS(5,i)        
    S12SC21 = SS(6,i)            
    S21SC21 = SS(8,i)          
    S22SC22 = SS(10,i)
    if (.not.MirorSym) then
      S11SC12 = SS(2,i)
      S11SC21 = SS(3,i)
      S12SC22 = SS(7,i)
      S21SC22 = SS(9,i)                
    end if 
!         
    S21SC12 = conjg(S12SC21)
    S22SC11 = conjg(S11SC22)             
    if (.not.MirorSym) then
      S21SC11 = conjg(S11SC21)     
      S22SC12 = conjg(S12SC22) 
      S22SC21 = conjg(S21SC22)    
    end if     
!
    ZE(1,1,i) =   0.5_O * real(S11SC11 + S12SC12 + S21SC21 + S22SC22,O)     
    ZE(1,2,i) =   0.5_O * real(S11SC11 - S12SC12 + S21SC21 - S22SC22,O)    
    if (.not.MirorSym) then
      ZE(1,3,i) = - real (S11SC12 + S22SC21,O)
      ZE(1,4,i) = - aimag(S11SC12 - S22SC21)            
    else
      ZE(1,3,i) =   0._O
      ZE(1,4,i) =   0._O        
    end if         
!    
    ZE(2,1,i) =   ZE(1,2,i)
    ZE(2,2,i) =   0.5_O * real(S11SC11 - S12SC12 - S21SC21 + S22SC22,O)      
    if (.not.MirorSym) then
      ZE(2,3,i) = - real (S11SC12 - S22SC21,O)  
      ZE(2,4,i) = - aimag(S11SC12 + S22SC21)    
    else
      ZE(2,3,i) =   0._O
      ZE(2,4,i) =   0._O        
    end if     
!        
    if (.not.MirorSym) then
      ZE(3,1,i) = - real (S11SC21 + S22SC12,O)  
      ZE(3,2,i) = - real (S11SC21 - S22SC12,O)    
    else
      ZE(3,1,i) =   0._O
      ZE(3,2,i) =   0._O        
    end if     
    ZE(3,3,i) =   real (S11SC22 + S12SC21,O)  
    ZE(3,4,i) =   aimag(S11SC22 + S21SC12)        
!        
    if (.not.MirorSym) then
      ZE(4,1,i) = - aimag(S21SC11 + S22SC12)  
      ZE(4,2,i) = - aimag(S21SC11 - S22SC12)      
    else
      ZE(4,1,i) =   0._O
      ZE(4,2,i) =   0._O        
    end if     
    ZE(4,3,i) =   - ZE(3,4,i)
    ZE(4,4,i) =   real (S22SC11 - S12SC21,O) 
  end do
end subroutine ExtendedScatteringMatrix
! **********************************************************************************
subroutine AsymmetryParameter (MirorSym, Ntheta, ZE, Cscat, AsymPar, AsymParV)
!------------------------------------------------------------------------------------     
! The routine computes the asymmetry parameter for a randomly oriented particle.    ! 
! The relations are                                                                 !
!                        2*Pi     |Pi                                               ! 
!     <cos THETA>    = ---------- |  <F11(theta)> cos(theta)sin(theta) d(theta)     !
!                        <Cscat>  |0                                                !
!  and                                                                              !
!                        2*Pi     |Pi                                               !
!     <cos THETA >_V = ---------- |  <F14(theta)> cos(theta)sin(theta) d(theta)     !
!                        <Cscat>  |0                                                ! 
!------------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Ntheta
  real(O)    :: ZE(4,4,Ntheta), Cscat, AsymPar, AsymParV
  logical    :: MirorSym 
!
  integer    :: i
  real(O)    :: atheta, btheta, theta, sum, sumV
  real(O),allocatable :: wtheta(:), xtheta(:)
!
  allocate (wtheta(Ntheta), xtheta(Ntheta))   
  atheta = 0._O
  btheta = Pi
  call Simpson (atheta, btheta, Ntheta, xtheta, wtheta)
  sum  = 0._O 
  sumV = 0._O
  do i = 1, Ntheta    
    theta = xtheta(i)                         
    sum  = sum  + wtheta(i) * sin(theta) * cos(theta) * ZE(1,1,i)
    if (.not.MirorSym) sumV = sumV + wtheta(i) * sin(theta) * cos(theta) * ZE(1,4,i)                           
  end do                     
  AsymPar = 2._O * Pi * sum / Cscat
  if (.not.MirorSym) then
    AsymParV = 2._O * Pi * sumV / Cscat  
  else
    AsymParV = 0._O  
  end if     
  deallocate (wtheta, xtheta)     
end subroutine AsymmetryParameter
! **********************************************************************************
! *               ANALYTICAL ORIENTATION AVERAGING PROCEDURE                       *
! **********************************************************************************
subroutine SijSCpqEff (MirorSym, wavenumber, axsym, chiral, FileTmat, Nrank, Mrank, &
           Nrankeff, Mrankeff, Ntheta, S, PrnProgress)
!-----------------------------------------------------------------------------------
! The routine computes the matrix <Spq Sp1q1*> by using an analytical averaging    !
! procedure.                                                                       !      
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer       :: Nrank, Mrank, Nrankeff, Mrankeff, Ntheta
  real(O)       :: wavenumber 
  complex(O)    :: S(10,Ntheta)
  character(80) :: FileTmat
  logical       :: MirorSym, axsym, chiral, PrnProgress
!      
  integer       :: i, j, n, nt, m, m1tl, m1l, u, dmp, m1, mp, m1p, n1inf, n1sup, n1,&
                   k, kt, nTV, m1t, mt, dimensionTV, IdentifyIndex, ntg, mtg,       &
                   dm, dmmin, dmmax, mpmin, mpmax, mmin, mmax, Nmax, Nmaxeff 
  real(O)       :: factr, m11t, Hv, factur, factmr
  complex(O)    :: T11, T12, T21, T22, fact, AXX, AXY, AYX, AYY, BXX, BXY, BYX, BYY,&
                   CXX, CXY, CYX, CYY, DXX, DXY, DYX, DYY, MTh, MPh, MThC, MPhC,    &
                   m1c, m1tc
  real(O),allocatable    :: C(:)
  complex(O),allocatable :: T(:,:), TV(:), M2inf(:,:), M3inf(:,:), SA(:,:,:,:,:),   &
                            SB(:,:,:,:,:), SC(:,:,:,:,:), SD(:,:,:,:,:),            &
                            A(:,:,:), B(:,:,:), Al(:,:), Bl(:,:)
!
  Nmax    = Nrank + Mrank * (2 * Nrank - Mrank + 1)   
  Nmaxeff = Nrankeff + Mrankeff * (2 * Nrankeff - Mrankeff + 1)   
  if (.not. axsym) then    
    open (unit = iTmat, file = FileTmat, status = 'unknown')       
    call read_HeadFileTmat (ntg, mtg)
    call check_dimensionMat (ntg, mtg, Nmax)              
    allocate (T(2*ntg,2*mtg))
    call read_FileTmat (ntg, mtg, T) 
    close (unit = iTmat)
  else 
    nTV = dimensionTV (Mrank, Nrank, chiral)
    allocate (TV(nTV))
    call formTV (FileTmat, chiral, Mrank, Nrank, TV, nTV)    
  end if                  
  allocate (M2inf(Ntheta,Nmaxeff), M3inf(Ntheta,Nmaxeff)) 
  call MNinfiniteMatrix (Mrankeff, Nrankeff, Nmaxeff, Ntheta, M2inf, M3inf)
  allocate (SA(Nrankeff,Nrankeff,-Mrankeff:Mrankeff,2,2),                           &
            SB(Nrankeff,Nrankeff,-Mrankeff:Mrankeff,2,2),                           &
            SC(Nrankeff,Nrankeff,-Mrankeff:Mrankeff,2,2),                           &
            SD(Nrankeff,Nrankeff,-Mrankeff:Mrankeff,2,2))
  allocate (A(Nrankeff,-Mrankeff:Mrankeff,2), B(Nrankeff,-Mrankeff:Mrankeff,2),     &
            Al(2,Nrankeff), Bl(2,Nrankeff))
  do n = 1, Nrankeff
    do nt = 1, Nrankeff
      do m = - Mrankeff, Mrankeff          
        do m1l = 1, 2
          do m1tl = 1, 2
            SA(n,nt,m,m1l,m1tl) = zero
            SB(n,nt,m,m1l,m1tl) = zero
            SC(n,nt,m,m1l,m1tl) = zero
            SD(n,nt,m,m1l,m1tl) = zero                 
          end do  
        end do    
      end do
    end do
  end do
  if (.not. axsym) then
    do u = 0, 2*Nrankeff
      if (PrnProgress) call write_progress (.false., u+1, 2*Nrankeff+3)
      factur = sqrt(real(2 * u + 1,O)) / wavenumber
      do dmp = - u, u
        do n = 1, Nrankeff
          do m = - Mrankeff, Mrankeff
            do m1l = 1, 2
              A(n,m,m1l) = zero
              B(n,m,m1l) = zero
            end do
          end do
        end do              
        do n = 1, Nrankeff
          allocate (C(0:n+u))
          n1inf = max(1, abs(n - u))                      
          n1sup = min(Nrankeff, n + u)
          do m1l = 1, 2
            do n1 = n1inf, n1sup                          
              Al(m1l,n1) = zero
              Bl(m1l,n1) = zero 
            end do
          end do                                                 
          mpmax = min(n, Mrankeff, Mrankeff + dmp)
          mpmin = min(n, Mrankeff, Mrankeff - dmp)
          do mp = - mpmin, mpmax 
            m1p = mp - dmp  
            call CouplingCoef (dmp, u, - mp, n, C)
            n1inf  = max(1, abs(n - u), abs(m1p))                         
            n1sup  = min(Nrankeff, n + u)
            factmr = Hv(mp) * Hv(m1p)                                       
            do n1 = n1inf, n1sup                                                                            
              call IdentifyMatrixElement (mp, n, m1p, n1, Nrank, Nmax, T, ntg,  &
                   mtg, T11, T12, T21, T22)                                  
              factr = factmr * C(n1) 
              do m1l = 1, 2
                m1 = -3 + 2 * m1l
                Al(m1l,n1) = Al(m1l,n1) + factr * (m1 * T11 + T12)
                Bl(m1l,n1) = Bl(m1l,n1) + factr * (m1 * T21 + T22)
              end do              
            end do
          end do                           
          do m1l = 1, 2
            m1 = - 3 + 2 * m1l
            mmax = min(n, Mrankeff, u + m1)
            mmin = min(n, Mrankeff, u - m1)
            do m = - mmin, mmax                     
              call CouplingCoef (m1 - m, u, m, n, C)
              n1inf  = max(1, abs(n - u))                     
              n1sup  = min(Nrankeff, n + u)                                     
              factmr = Hv(m) * Hv(m1)
              do n1 = n1inf, n1sup
                factr = factmr * factur / sqrt(real(2 * n1 + 1,O))                                      
                fact  = (- 1._O)**(n + n1) * im**(n1 - 1) * C(n1) * factr                                        
                A(n,m,m1l) = A(n,m,m1l) + fact * Al(m1l,n1)
                B(n,m,m1l) = B(n,m,m1l) + fact * Bl(m1l,n1)
              end do
            end do
          end do
          deallocate (C)
        end do                                                                  
        do m1l = 1, 2
          m1 = - 3 + 2 * m1l
          do m1tl = 1, 2
            m1t = - 3 + 2 * m1tl
            dmmax = min(u, Mrankeff - m1, Mrankeff - m1t)
            dmmin = min(u, Mrankeff + m1, Mrankeff + m1t)
            do dm = - dmmin, dmmax
              m  = dm + m1
              mt = dm + m1t
              do n = max(1,abs(m)), Nrankeff
                do nt = max(1,abs(mt)), Nrankeff
                  SA(n,nt,m,m1l,m1tl) = SA(n,nt,m,m1l,m1tl) +                       &
                                        A(n,m,m1l) * conjg(A(nt,mt,m1tl))
                  SB(n,nt,m,m1l,m1tl) = SB(n,nt,m,m1l,m1tl) +                       &
                                        A(n,m,m1l) * conjg(B(nt,mt,m1tl))
                  SC(n,nt,m,m1l,m1tl) = SC(n,nt,m,m1l,m1tl) +                       &
                                        B(n,m,m1l) * conjg(A(nt,mt,m1tl))
                  SD(n,nt,m,m1l,m1tl) = SD(n,nt,m,m1l,m1tl) +                       &
                                        B(n,m,m1l) * conjg(B(nt,mt,m1tl))           
                end do  
              end do
            end do
          end do
        end do                                                    
      end do
    end do
  else 
    do u = 0, 2*Nrankeff
      if (PrnProgress) call write_progress (.false., u+1, 2*Nrankeff+3)
      factur = sqrt(real(2 * u + 1,O)) / wavenumber
      do n = 1, Nrankeff
        do m = - Mrankeff, Mrankeff
          do m1l = 1, 2
            A(n,m,m1l) = zero
            B(n,m,m1l) = zero
          end do
        end do
      end do                  
      do n = 1, Nrankeff
        allocate (C(0:n+u))
        n1inf = max(1, abs(n - u))                        
        n1sup = min(Nrankeff, n + u)
        do m1l = 1, 2
          do n1 = n1inf, n1sup
            Al(m1l,n1) = zero
            Bl(m1l,n1) = zero 
          end do
        end do                                                    
        do mp = - min(n,Mrankeff), min(n,Mrankeff)              
          call CouplingCoef (0, u, - mp, n, C)
          n1inf = max(1, abs(n - u), abs(mp))                     
          n1sup = min(Nrankeff, n + u)                                  
          do n1 = n1inf, n1sup                
            call IdentifyMatrixElementAxsym (mp, n, n1, Nrank, chiral, TV, nTV,     &
                 T11, T12, T21, T22)                
            do m1l = 1, 2
              m1 = - 3 + 2 * m1l
              Al(m1l,n1) = Al(m1l,n1) + C(n1) * (m1 * T11 + T12)
              Bl(m1l,n1) = Bl(m1l,n1) + C(n1) * (m1 * T21 + T22)
            end do
          end do
        end do    
        do m1l = 1, 2
          m1 = - 3 + 2 * m1l
          mmax = min(n, Mrankeff, u + m1)
          mmin = min(n, Mrankeff, u - m1)
          do m = - mmin, mmax   
            call CouplingCoef (m1 - m, u, m, n, C)
            n1inf  = max(1, abs(n - u))                       
            n1sup  = min(Nrankeff, n + u)
            factmr = Hv(m) * Hv(m1)                                 
            do n1 = n1inf, n1sup
              factr = factmr * factur / sqrt(real(2 * n1 + 1,O))                                    
              fact  = (- 1._O)**(n + n1) * im**(n1 - 1) * C(n1) * factr                                        
              A(n,m,m1l) = A(n,m,m1l) + fact * Al(m1l,n1)
              B(n,m,m1l) = B(n,m,m1l) + fact * Bl(m1l,n1)
            end do                  
          end do
        end do
        deallocate (C)
      end do      
      do m1l = 1, 2
        m1 = - 3 + 2 * m1l
        do m1tl = 1, 2
          m1t = - 3 + 2 * m1tl
          dmmax = min(u, Mrankeff - m1, Mrankeff - m1t)
          dmmin = min(u, Mrankeff + m1, Mrankeff + m1t)
          do dm = - dmmin, dmmax
            m  = dm + m1
            mt = dm + m1t
            do n = max(1,abs(m)), Nrankeff
              do nt = max(1,abs(mt)), Nrankeff
                SA(n,nt,m,m1l,m1tl) = SA(n,nt,m,m1l,m1tl) +                         &
                                      A(n,m,m1l) * conjg(A(nt,mt,m1tl))
                SB(n,nt,m,m1l,m1tl) = SB(n,nt,m,m1l,m1tl) +                         &
                                      A(n,m,m1l) * conjg(B(nt,mt,m1tl))
                SC(n,nt,m,m1l,m1tl) = SC(n,nt,m,m1l,m1tl) +                         &
                                      B(n,m,m1l) * conjg(A(nt,mt,m1tl))
                SD(n,nt,m,m1l,m1tl) = SD(n,nt,m,m1l,m1tl) +                         &
                                      B(n,m,m1l) * conjg(B(nt,mt,m1tl))                                       
              end do  
            end do
          end do
        end do
      end do
    end do                  
  end if    
  do j = 1, 10        
    do i = 1, Ntheta
      S(j,i) = zero       
    end do
  end do
  do m1l = 1, 2
    if (PrnProgress) call write_progress (.false., m1l+2*Nrankeff+1, 2*Nrankeff+3) 
    m1 = - 3 + 2 * m1l
    do m1tl = 1, 2
      m1t   = - 3 + 2 * m1tl 
      m1c   = im * real(m1,O)
      m1tc  = im * real(m1t,O)
      m11t  = real(m1 * m1t,O)   
      dmmax = min(Mrankeff - m1, Mrankeff - m1t)
      dmmin = min(Mrankeff + m1, Mrankeff + m1t)
      do dm = - dmmin, dmmax
        m  = dm + m1
        mt = dm + m1t
        do n = max(1,abs(m)), Nrankeff
          do nt = max(1,abs(mt)), Nrankeff                                        
            AXX  =   SA(n,nt,m,m1l,m1tl)
            AXY  =   m1tc * SA(n,nt,m,m1l,m1tl)
            AYX  = - m1c  * SA(n,nt,m,m1l,m1tl)
            AYY  =   m11t * SA(n,nt,m,m1l,m1tl)           
            BXX  =   im * SB(n,nt,m,m1l,m1tl)
            BXY  =   im * m1tc * SB(n,nt,m,m1l,m1tl)
            BYX  = - im * m1c  * SB(n,nt,m,m1l,m1tl)
            BYY  =   im * m11t * SB(n,nt,m,m1l,m1tl)              
            CXX  =   im * SC(n,nt,m,m1l,m1tl)
            CXY  =   im * m1tc * SC(n,nt,m,m1l,m1tl)
            CYX  = - im * m1c  * SC(n,nt,m,m1l,m1tl)
            CYY  =   im * m11t * SC(n,nt,m,m1l,m1tl)              
            DXX  =   SD(n,nt,m,m1l,m1tl)
            DXY  =   m1tc * SD(n,nt,m,m1l,m1tl)
            DYX  = - m1c  * SD(n,nt,m,m1l,m1tl)
            DYY  =   m11t * SD(n,nt,m,m1l,m1tl)
            k    = IdentifyIndex (m, n, Nrankeff)
            kt   = IdentifyIndex (mt, nt, Nrankeff) 
            do i = 1, Ntheta
              MTh  = M2inf(i,k)                                
              MPh  = M3inf(i,k)
              MThC = conjg(M2inf(i,kt))                            
              MPhC = conjg(M3inf(i,kt))
              S(1,i)  = S(1,i)  + AXX * MTh * MThC + BXX * MTh * MPhC -             &
                                  CXX * MPh * MThC + DXX * MPh * MPhC 
              S(4,i)  = S(4,i)  + AXY * MTh * MPhC - BXY * MTh * MThC -             &
                                  CXY * MPh * MPhC - DXY * MPh * MThC
              S(5,i)  = S(5,i)  + AYY * MTh * MThC + BYY * MTh * MPhC -             &
                                  CYY * MPh * MThC + DYY * MPh * MPhC				
              S(6,i)  = S(6,i)  + AYX * MTh * MPhC - BYX * MTh * MThC -             &
                                  CYX * MPh * MPhC - DYX * MPh * MThC			
              S(8,i)  = S(8,i)  + AXX * MPh * MPhC - BXX * MPh * MThC +             &
                                  CXX * MTh * MPhC + DXX * MTh * MThC
              S(10,i) = S(10,i) + AYY * MPh * MPhC - BYY * MPh * MThC +             & 
                                  CYY * MTh * MPhC + DYY * MTh * MThC
              if (.not.MirorSym) then 				 				 				 
                S(2,i) = S(2,i) + AXY * MTh * MThC + BXY * MTh * MPhC -             &
                                  CXY * MPh * MThC + DXY * MPh * MPhC
                S(3,i) = S(3,i) + AXX * MTh * MPhC - BXX * MTh * MThC -             &
                                  CXX * MPh * MPhC - DXX * MPh * MThC
                S(7,i) = S(7,i) + AYY * MTh * MPhC - BYY * MTh * MThC -             &
                                  CYY * MPh * MPhC - DYY * MPh * MThC				    				 
                S(9,i) = S(9,i) + AXY * MPh * MPhC - BXY * MPh * MThC +             &
                                  CXY * MTh * MPhC + DXY * MTh * MThC	 
              end if				  
            end do                  
          end do
        end do          
      end do
    end do
  end do                      
  deallocate (M2inf, M3inf, SA, SB, SC, SD, A, B)
  if (.not.axsym) then
    deallocate (T)
  else 
    deallocate (TV)
  end if  
end subroutine SijSCpqEff
! **********************************************************************************
subroutine AvCscatCextEff (ReducedOrder, wavenumber, snorm, FileTmat, axsym, chiral,&
           delta, Nrank, Mrank, Nrankeff, Mrankeff, Cext, Cscat, Qext, Qscat)
!------------------------------------------------------------------------------------     
! The routine computes the average optical cross sections and efficiencies.         !
! The optical cross sections are:                                                   !
!                        2*Pi                                                       !
!            <Cext> = - ------ Re {SUM (2n+1) * (t11_n + t22_n)                     !
!                        k**2                                                       !                         
! and                                                                               !
!                         2*Pi                                                      !
!            <Cscat> =   ------ SUM (2n+1) * (t'11_n + t'22_n).                     !
!                         k**2                                                      !  
! The efficiencies are:                                                             ! 												 !
! 			  <Cext>         <Cext> * k**2		                    !
!            <Qext>  = ------------- = -----------------                            !
! 			Pi*anorm**2	     snorm                                  !
! and 			                                                            !
! 			 <Cscat>         <Cscat> * k**2	                            !
!            <Qscat> = ------------- = -----------------.                           !
! 			Pi*anorm**2	     snorm                                  !
!------------------------------------------------------------------------------------
  use parameters                                            
  implicit none
  integer       :: Nrank, Mrank, Nrankeff, Mrankeff
  real(O)       :: wavenumber, snorm, delta, Cext, Cscat, Qext, Qscat       
  character(80) :: FileTmat
  logical       :: ReducedOrder, axsym, chiral
!      
  integer       :: Nmax, nTV, n, dimensionTV, ntg, mtg
  real(O)       :: wavenumber2, Cexteff, Cscateff, dCext, dCscat 
  complex(O)    :: sum1, sum2, t11, t22
  logical       :: more, changeMrank
  complex(O),allocatable :: T(:,:), TV(:)
!
  Nmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)   
  if (.not. axsym) then                                           
    open (unit = iTmat, file = FileTmat, status = 'unknown')       
    call read_HeadFileTmat (ntg, mtg)
    call check_dimensionMat (ntg, mtg, Nmax)              
    allocate (T(2*ntg,2*mtg))
    call read_FileTmat (ntg, mtg, T) 
    close (unit = iTmat)
  else 
    nTV = dimensionTV (Mrank, Nrank, chiral)
    allocate (TV(nTV))
    call formTV (FileTmat, chiral, Mrank, Nrank, TV, nTV)  
  end if          
  Nrankeff = Nrank
  Mrankeff = Mrank
  sum1 = zero
  sum2 = zero
  do n = 1, Nrank
    if (.not. axsym) then
      call tnExtEff (n, Nrank, Mrankeff, Nmax, T, ntg, mtg, t11, t22)
    else 
      call tnExtAxsymEff (n, Nrank, Mrankeff, chiral, TV, nTV, t11, t22)
    end if
    sum1 = sum1 + (t11 + t22)
    if (.not. axsym) then
      call tnScatEff (n, Nrank, Mrankeff, Nrankeff, Nmax, T, ntg, mtg, t11, t22)
    else 
      call tnScatAxsymEff (n, Nrank, Mrankeff, Nrankeff, chiral, TV, nTV, t11, t22)
    end if
    sum2 = sum2 + (t11 + t22)
  end do                
  wavenumber2 = wavenumber * wavenumber
  Cext  = - 2._O * Pi * real(sum1,O) / wavenumber2
  Cscat =   2._O * Pi * real(sum2,O) / wavenumber2  
  if (ReducedOrder) then   
    Cexteff  = Cext
    Cscateff = Cscat
    dCext    = abs(Cext  - Cexteff)
    dCscat   = abs(Cscat - Cscateff)
    more     = (dCext < delta * abs(Cext)) .and. (dCscat < delta * abs(Cscat))
    changeMrank = .false.
    do while (more .and. Nrankeff > 1)
      Nrankeff = Nrankeff - 1
      if (Nrankeff < Mrank) then
        Mrankeff    =  Mrankeff - 1
        changeMrank = .true.
      end if
      sum1 = zero
      sum2 = zero
      do n = 1, Nrankeff
        if (.not. axsym) then
          call tnExtEff (n, Nrank, Mrankeff, Nmax, T, ntg, mtg, t11, t22)
        else 
          call tnExtAxsymEff (n, Nrank, Mrankeff, chiral, TV, nTV, t11, t22)
        end if
        sum1 = sum1 + (t11 + t22)
        if (.not. axsym) then
          call tnScatEff (n, Nrank, Mrankeff, Nrankeff, Nmax, T, ntg, mtg,          &
               t11, t22)
        else 
          call tnScatAxsymEff (n, Nrank, Mrankeff, Nrankeff, chiral, TV, nTV,       &
               t11, t22)
        end if
        sum2 = sum2 + (t11 + t22)
      end do                
      Cexteff  = - 2._O * Pi * real(sum1,O) / wavenumber2
      Cscateff =   2._O * Pi * real(sum2,O) / wavenumber2
      dCext  = abs(Cext  - Cexteff)
      dCscat = abs(Cscat - Cscateff)
      more   = (dCext < delta * abs(Cext)) .and. (dCscat < delta * abs(Cscat))
    end do  
    Nrankeff = Nrankeff + 1
    if (changeMrank) Mrankeff = Mrankeff + 1
  end if
  Qscat =  Cscat * wavenumber2 / snorm
  Qext  =  Cext  * wavenumber2 / snorm
  if (.not. axsym) then
    deallocate (T)
  else 
    deallocate (TV)
  end if                
end subroutine AvCscatCextEff
! **********************************************************************************
subroutine tnScatEff (n, Nrank, Mrankeff, Nrankeff, Nmax, T, ntg, mtg, t11, t22)
  use parameters
  implicit none                
  integer    :: n, Nrank, Mrankeff, Nrankeff, Nmax, ntg, mtg
  complex(O) :: T(2*ntg,2*mtg), t11, t22
!      
  integer    :: mp, m1, n1inf, n1
  real(O)    :: sum1, sum2
  complex(O) :: TG11, TG12, TG21, TG22
!
  sum1 = 0._O
  sum2 = 0._O      
  do mp = - Mrankeff, Mrankeff
    if (mp <= n) then
      do m1 = - Mrankeff, Mrankeff
        n1inf = max(1, abs(m1))
        do n1 = n1inf, Nrankeff
          call IdentifyMatrixElement (m1, n1, mp, n, Nrank, Nmax, T, ntg, mtg,      &
               TG11, TG12, TG21, TG22)
          sum1 = sum1 + abs(TG11)**2 + abs(TG21)**2   
          sum2 = sum2 + abs(TG12)**2 + abs(TG22)**2
        end do
      end do
    end if
  end do  
  t11 = cmplx(sum1,0.0,O)
  t22 = cmplx(sum2,0.0,O)
end subroutine tnScatEff
! **********************************************************************************
subroutine tnScatAxsymEff (n, Nrank, Mrankeff, Nrankeff, chiral, TV, nTV, t11, t22)
  use parameters
  implicit none                
  integer    :: n, Nrank, Mrankeff, Nrankeff, nTV
  complex(O) :: TV(nTV), t11, t22
  logical    :: chiral
!      
  integer    :: mp, n1inf, n1
  real(O)    :: sum1, sum2
  complex(O) :: TG11, TG12, TG21, TG22
!
  sum1 = 0._O
  sum2 = 0._O      
  do mp = - Mrankeff, Mrankeff
    if (mp <= n) then     
      n1inf = max(1, abs(mp))
      do n1 = n1inf, Nrankeff       
        call IdentifyMatrixElementAxsym (mp, n1, n, Nrank, chiral, TV, nTV,         &
             TG11, TG12, TG21, TG22)
        sum1 = sum1 + abs(TG11)**2 + abs(TG21)**2   
        sum2 = sum2 + abs(TG12)**2 + abs(TG22)**2
      end do      
    end if
  end do        
  t11 = cmplx(sum1,0.0,O)
  t22 = cmplx(sum2,0.0,O)
end subroutine tnScatAxsymEff
! **********************************************************************************
subroutine tnExtEff (n, Nrank, Mrankeff, Nmax, T, ntg, mtg, t11, t22)
  use parameters
  implicit none                
  integer    :: n, Nrank, Mrankeff, Nmax, ntg, mtg
  complex(O) :: T(2*ntg,2*mtg), t11, t22
!      vmr_main_input.dat
  integer    :: mp
  complex(O) :: sum1, sum2, TG11, TG12, TG21, TG22
!
  sum1 = zero
  sum2 = zero       
  do mp = - Mrankeff, Mrankeff
    if (abs(mp) <= n) then                        
      call IdentifyMatrixElement (mp, n, mp, n, Nrank, Nmax, T, ntg, mtg,           &
           TG11, TG12, TG21, TG22)       
      sum1 = sum1 + TG11            
      sum2 = sum2 + TG22            
    end if
  end do
  t11 = sum1
  t22 = sum2
end subroutine tnExtEff 
! **********************************************************************************
subroutine tnExtAxsymEff (n, Nrank, Mrankeff, chiral, TV, nTV, t11, t22)
  use parameters
  implicit none                
  integer    :: n, Nrank, Mrankeff, nTV
  complex(O) :: TV(nTV), t11, t22
  logical    :: chiral
!      
  integer    :: mp
  complex(O) :: sum1, sum2, TG11, TG12, TG21, TG22
!
  sum1 = zero
  sum2 = zero      
  do mp = - Mrankeff, Mrankeff
    if (abs(mp) <= n) then      
      call IdentifyMatrixElementAxsym (mp, n, n, Nrank, chiral, TV, nTV,            &
           TG11, TG12, TG21, TG22)        
      sum1 = sum1 + TG11      
      sum2 = sum2 + TG22            
    end if
  end do
  t11 = sum1
  t22 = sum2
end subroutine tnExtAxsymEff
! **********************************************************************************
subroutine RandomExtinctionMatrix (wavenumber, FileTmat, MirorSym, axsym, chiral,   &
           Nrank, Mrank, KeAv)
!------------------------------------------------------------------------------------     
! The routine computes the average extinction matrix. The elements of the           !
! extinction matrix are given by                                                    !
!                       2*Pi                                                        !
!            <Kii> = - ------ Re {SUM (2n+1) * (t11_n + t22_n)                      !
!                       k**2                                                        !
! for i = 1,2,3,4 and                                                               ! 
!                                2*Pi                                               !
!            <K14> = <K41>   =  ------ Re {SUM (2n+1) * (t12_n + t21_n),            !
!                                k**2                                               !
!                                                                                   !
!                                2*Pi                                               !
!            <K23> = - <K32> =  ------ Im {SUM (2n+1) * (t12_n + t21_n).            !
!                                k**2                                               !      
!------------------------------------------------------------------------------------
  use parameters                                            
  implicit none
  integer       :: Nrank, Mrank
  real(O)       :: wavenumber, KeAv(4,4)
  character(80) :: FileTmat
  logical       :: MirorSym, axsym, chiral
!      
  integer       :: Nmax, nTV, n, dimensionTV, ntg, mtg, i, j
  real(O)       :: wavenumber2, KII, K14, K23
  complex(O)    :: sum1, sum2, t11, t22, t12, t21  
  complex(O),allocatable :: T(:,:), TV(:)
!
  Nmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)   
  if (.not. axsym) then                                           
    open (unit = iTmat, file = FileTmat, status = 'unknown')       
    call read_HeadFileTmat (ntg, mtg)
    call check_dimensionMat (ntg, mtg, Nmax)              
    allocate (T(2*ntg,2*mtg))
    call read_FileTmat (ntg, mtg, T) 
    close (unit = iTmat)
  else 
    nTV = dimensionTV (Mrank, Nrank, chiral)
    allocate (TV(nTV))
    call formTV (FileTmat, chiral, Mrank, Nrank, TV, nTV)  
  end if            
  sum1 = zero
  sum2 = zero
  do n = 1, Nrank  
    if (.not. axsym) then
      call tnExtEff (n, Nrank, Mrank, Nmax, T, ntg, mtg, t11, t22)
    else 
      call tnExtAxsymEff (n, Nrank, Mrank, chiral, TV, nTV, t11, t22)
    end if
    if (.not.MirorSym .and. .not.axsym) then
      call tnExtOffEff (n, Nrank, Mrank, Nmax, T, ntg, mtg, t12, t21)        
    end if                
    sum1 = sum1 + (t11 + t22)
    sum2 = sum2 + (t12 + t21)        
  end do                
  wavenumber2 = wavenumber * wavenumber
  KII = - 2._O * Pi * real (sum1,O) / wavenumber2
  K14 =   2._O * Pi * real (sum2,O) / wavenumber2
  K23 =   2._O * Pi * aimag(sum2)   / wavenumber2    
  do i = 1, 4
    do j = 1, 4
      KeAv(i,j) = 0._O
    end do
  end do
  do i = 1, 4
    KeAv(i,i) = KII
  end do
  if (.not. MirorSym) then  
    KeAv(1,4) =   K14
    KeAv(4,1) =   K14      
    KeAv(2,3) =   K23
    KeAv(3,2) = - K23    
  end if                                        
  if (.not. axsym) then
    deallocate (T)
  else 
    deallocate (TV)
  end if                
end subroutine RandomExtinctionMatrix
! **********************************************************************************
subroutine tnExtOffEff (n, Nrank, Mrankeff, Nmax, T, ntg, mtg, t12, t21)
  use parameters
  implicit none                
  integer    :: n, Nrank, Mrankeff, Nmax, ntg, mtg
  complex(O) :: T(2*ntg,2*mtg), t12, t21
!      
  integer    :: mp
  complex(O) :: sum1, sum2, TG11, TG12, TG21, TG22
!
  sum1 = zero
  sum2 = zero       
  do mp = - Mrankeff, Mrankeff
    if (abs(mp) <= n) then                        
      call IdentifyMatrixElement (mp, n, mp, n, Nrank, Nmax, T, ntg, mtg,           &
           TG11, TG12, TG21, TG22)       
      sum1 = sum1 + TG12            
      sum2 = sum2 + TG21            
    end if
  end do
  t12 = sum1
  t21 = sum2
end subroutine tnExtOffEff 
! **********************************************************************************
subroutine AvCscatCextV (wavenumber, snorm, Ntheta, ZE, KeAv, CscatV, CextV,         &
                         QscatV, QextV)
!------------------------------------------------------------------------------------     
! The routine computes the V-component of the average scattering cross section,     !
!                                                                                   !
!                            |Pi                                                    !
!           <Cscat>_V = 2*Pi |  <F14(theta)> sin(theta) d(theta).                   !
!                            |0                                                     !
!                                                                                   !
! and the V-component of the average extinction cross section,                      !
!                                                                                   !
!                           <Cext>_V = <K14>                                        !        
!------------------------------------------------------------------------------------		     
  use parameters
  implicit none
  integer    :: Ntheta
  real(O)    :: wavenumber, snorm, ZE(4,4,Ntheta), KeAv(4,4), CscatV, QscatV,        &
                CextV, QextV
  
!
  integer    :: i
  real(O)    :: wavenumber2, atheta, btheta, theta, sum
  real(O),allocatable :: wtheta(:), xtheta(:)
!
  wavenumber2 = wavenumber * wavenumber
  allocate (wtheta(Ntheta), xtheta(Ntheta))
  atheta = 0._O
  btheta = Pi
  call Simpson (atheta, btheta, Ntheta, xtheta, wtheta)
  sum = 0._O 
  do i = 1, Ntheta    
    theta = xtheta(i)                         
    sum  = sum + wtheta(i) * sin(theta) * ZE(1,4,i)                           
  end do                   
  CscatV = 2._O * Pi * sum  
  CextV  = KeAv(1,4)   
  QscatV = CscatV * wavenumber2 / snorm      
  QextV  = CextV  * wavenumber2 / snorm          
  deallocate (wtheta, xtheta)  
end subroutine AvCscatCextV
! **********************************************************************************
subroutine MNinfiniteMatrix (Mrank, Nrank, Nmax, Ntheta, M2inf, M3inf)
!-----------------------------------------------------------------------------------
! The routine computes the theta- and phi- components of the vector spherical wave !
! functions Mmn at infinity. The scattering direction is in the azimuthal plane    !
! phi = 0° and therefore the azimuthal dependence exp(j * m * phi) is omitted.     !
! Note that N2inf = - j * M3inf and N3inf =  j * M2inf.                            !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax, Ntheta
  complex(O) :: M2inf(Ntheta,Nmax), M3inf(Ntheta,Nmax)
!
  integer    :: i, k, m, N0, n, l, ml
  real(O)    :: theta, nm, mlr 
  complex(O) :: factc, factp, factt
  real(O),allocatable :: Pnm(:), dPnm(:), pinm(:), taunm(:) 
!
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  do i = 1, Ntheta    
    theta = real(i - 1,O) * Pi / real(Ntheta - 1,O)          
    do m = 0, Mrank
      call leg_normalized (theta, m, Nrank, Pnm, dPnm, pinm, taunm)
      if (m == 0) then
        do k = 1, Nrank
          n  = k
          nm = real(2 * n * (n + 1),O)          
          nm = 1._O / sqrt(nm)        
          factc  = (- im)**(n + 1) * nm           
          factt  = factc * taunm(n)            
          M2inf(i,k) =   zero
          M3inf(i,k) = - factt          
        end do
      else
        N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
        ml = m
        do l = 1, 2
          mlr  = real(ml,O)              
          do k = 1, Nrank - m + 1
            n  = m + k - 1
            nm = real(2 * n * (n + 1),O)                
            nm = 1._O / sqrt(nm)              
            factc  = (- im)**(n + 1) * nm
            factp  = factc * mlr * pinm(n)
            factt  = factc * taunm(n)            
            M2inf(i,N0+k) =   im * factp
            M3inf(i,N0+k) = - factt           
          end do          
          N0 =   N0 + Nrank - m + 1
          ml = - ml
        end do
      end if                
    end do
  end do    
  deallocate (Pnm, dPnm, pinm, taunm)      
end subroutine MNinfiniteMatrix   
! **********************************************************************************
subroutine  IdentifyMatrixElement (m, n, m1, n1, Nrank, Nmax, T, ntg, mtg, T11, T12,&
            T21, T22)
  use parameters
  implicit none
  integer    :: m, n, m1, n1, Nrank, Nmax, ntg, mtg, k, k1, N0
  complex(O) :: T(2*ntg,2*mtg), T11, T12, T21, T22 
!
  if (m == 0) then      
    k = n
  else
    N0  = Nrank + (abs(m) - 1) * (2 * Nrank - abs(m) + 2)
    if (m > 0) then        
      k  = N0 + n - abs(m) + 1
    else
      N0 = N0 + Nrank - abs(m) + 1
      k  = N0 + n - abs(m) + 1
    end if
  end if      
  if (m1 == 0) then      
    k1 = n1
  else
    N0 = Nrank + (abs(m1) - 1) * (2 * Nrank - abs(m1) + 2)
    if (m1 > 0) then       
      k1 = N0 + n1 - abs(m1) + 1
    else
      N0 = N0 + Nrank - abs(m1) + 1
      k1 = N0 + n1 - abs(m1) + 1
    end if
  end if
  T11 = T(k,k1)
  T12 = T(k,k1+Nmax)
  T21 = T(k+Nmax,k1)
  T22 = T(k+Nmax,k1+Nmax)
end subroutine IdentifyMatrixElement 
! **********************************************************************************
subroutine IdentifyMatrixElementAxsym (m, n, n1, Nrank, chiral, TV, nTV, T11, T12,  &
           T21, T22)
  use parameters
  implicit none
  integer     :: m, n, n1, Nrank, nTV, Nc, Nmax, i, j, ma, tn, tm
  complex(O)  :: TV(nTV), T11, T12, T21, T22      
  logical     :: chiral
!
  if (m == 0) then        
    Nc = 0
    Nmax = Nrank
    i  = n
    j  = n1
    T11  = TV(Nc+i+2*(j-1)*Nmax)        
    T12  = TV(Nc+i+2*(j+Nmax-1)*Nmax)   
    T21  = TV(Nc+i+Nmax+2*(j-1)*Nmax)     
    T22  = TV(Nc+i+Nmax+2*(j+Nmax-1)*Nmax) 
  else        
    ma = abs(m)
    tn = Nrank * Nrank
    tm = (ma - 2) * (ma - 1)
    if (.not. chiral) then
      Nc = 8 * tn + 4 * (ma - 2) * tn - 4 * tm * Nrank + 2 * tm * (2 * ma - 3) / 3
    else 
      Nc = 12 * tn + 8 * (ma - 2) * tn - 8 * tm * Nrank + 4 * tm * (2 * ma - 3) / 3
    end if              
    Nmax = Nrank - ma + 1       
    i = n - ma + 1
    j = n1 - ma + 1
    if (m > 0) then
      T11 = TV(Nc+i+2*(j-1)*Nmax)              
      T12 = TV(Nc+i+2*(j+Nmax-1)*Nmax)        
      T21 = TV(Nc+i+Nmax+2*(j-1)*Nmax)        
      T22 = TV(Nc+i+Nmax+2*(j+Nmax-1)*Nmax)   
    else
      if (.not. chiral) then
        T11 =   TV(Nc+i+2*(j-1)*Nmax)         
        T12 = - TV(Nc+i+2*(j+Nmax-1)*Nmax)     
        T21 = - TV(Nc+i+Nmax+2*(j-1)*Nmax)    
        T22 =   TV(Nc+i+Nmax+2*(j+Nmax-1)*Nmax) 
      else 
        Nc  = Nc + 4 * Nmax * Nmax
        T11 = TV(Nc+i+2*(j-1)*Nmax)            
        T12 = TV(Nc+i+2*(j+Nmax-1)*Nmax)       
        T21 = TV(Nc+i+Nmax+2*(j-1)*Nmax)       
        T22 = TV(Nc+i+Nmax+2*(j+Nmax-1)*Nmax)  
      end if  
    end if        
  end if
end subroutine IdentifyMatrixElementAxsym  
! **********************************************************************************
function  IdentifyIndex (m, n, Nrank) result (k)
  implicit none
  integer  :: m, n, Nrank, k, N0
!
  if (m == 0) then      
    k = n
  else
    N0  = Nrank + (abs(m) - 1) * (2 * Nrank - abs(m) + 2)
    if (m > 0) then        
      k  = N0 + n - abs(m) + 1
    else
      N0 = N0 + Nrank - abs(m) + 1
      k  = N0 + n - abs(m) + 1
    end if
  end if            
end function IdentifyIndex                      
! **********************************************************************************
function Hv (m) result (a)
  use parameters
  implicit none
  integer  :: m
  real(O)  :: a
!
  if (m >= 0 ) then
    a = 1._O
  else 
    a = (- 1._O)**m  
  end if
end function Hv
! **********************************************************************************
function dimensionTV (Mrank, Nrank, chiral) result (nTV)
  implicit none
  integer   :: nTV, m, Mrank, Nrank, Nmax
  logical   :: chiral
!
  nTV = 0
  do m = 0, Mrank
    if (m == 0) then
      Nmax = Nrank
    else
      Nmax = Nrank - m + 1
    end if
    nTV = nTV + 4 * Nmax * Nmax
    if (chiral .and. m /= 0) then
      nTV = nTV + 4 * Nmax * Nmax
    end if
  end do      
end function dimensionTV
! **********************************************************************************
subroutine formTV (FileTmat, chiral, Mrank, Nrank, TV, nTV)
  use parameters
  implicit none
  integer       :: Mrank, Nrank, nTV
  complex(O)    :: TV(nTV)
  character(80) :: FileTmat
  logical       :: chiral
!      
  integer       :: Nc, m, Nmax, i, j, ntl, mtl
  complex(O),allocatable :: TL(:,:) 
!
  open (unit = iTmat, file = FileTmat, status = 'unknown')
  call read_HeadFileTmat (ntl, mtl)
  call check_dimensionMat (ntl, mtl, Nrank)             
  allocate (TL(2*ntl, 2*mtl))
  Nc = 0
  do m = 0, Mrank
    if (m == 0) then
      Nmax = Nrank
    else
      Nmax = Nrank - m + 1
    end if    
    call read_FileTmat (ntl, mtl, TL)
    do i = 1, 2*Nmax
      do j = 1, 2*Nmax
        TV(Nc+i+2*(j-1)*Nmax) = TL(i,j)
      end do
    end do
    Nc = Nc + 4 * Nmax * Nmax
    if (chiral .and. m /= 0) then      
      call read_FileTmat (ntl, mtl, TL)
      do i = 1, 2*Nmax
        do j = 1, 2*Nmax
          TV(Nc+i+2*(j-1)*Nmax) = TL(i,j)
        end do
      end do
      Nc = Nc + 4 * Nmax * Nmax
    end if
  end do
  close (unit = iTmat)
  deallocate (TL) 
end subroutine formTV 
! **********************************************************************************
! *               NUMERICAL ORIENTATION AVERAGING PROCEDURE                        *
! **********************************************************************************
subroutine SijSCpqInt (MirorSym, wavenumber, snorm, FileTmat, axsym, chiral, Nrank, &
           Mrank, Nalpha, Nbeta, Ngamma, Ntheta, UseSimpson, CextAv, CscatAv,       &
           QextAv, QscatAv, S, PrnProgress)
!------------------------------------------------------------------------------------
! The routine computes the matrix <Spq Sp1q1*> by using a numerical averaging       !
! procedure.                                                                        !      
!------------------------------------------------------------------------------------
  use parameters
  implicit none
  integer       :: Nrank, Mrank, Nalpha, Nbeta, Ngamma, Ntheta
  real(O)       :: wavenumber, snorm, CextAv, CscatAv, QextAv, QscatAv       
  complex(O)    :: S(10,Ntheta)
  character(80) :: FileTmat
  logical       :: MirorSym, axsym, chiral, UseSimpson, PrnProgress
!      
  integer       :: nTV, i, j, ialpha, ibeta, igamma, m, Nc, Mstart, Nmaxl,          &
                   dimensionTV, ntg, mtg, Nmax
  real(O)       :: aalpha, balpha, abeta, bbeta, agamma, bgamma, thetaGI, phiGI,    &
                   alphapX, alphapY, phiAZIMUT, norm, alpha, beta, gamma, Cext,     &
                   Cscat, Qext, Qscat, fact 
  complex(O)    :: FthetaX, FphiX, FthetaY, FphiY
  logical       :: ExtThetaDom                                 
  real(O),allocatable    :: walpha(:), xalpha(:), wbeta(:), xbeta(:), wgamma(:),    &
                            xgamma(:)      
  complex(O),allocatable :: T(:,:), TV(:), cX(:), cY(:), cX1(:), cY1(:), ccX(:),    &
                            ccY(:), FtX(:), FpX(:), FtY(:), FpY(:)
!
  Nmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  if (.not. axsym) then          
    open (unit = iTmat, file = FileTmat, status = 'unknown')       
    call read_HeadFileTmat (ntg, mtg)
    call check_dimensionMat (ntg, mtg, Nmax)              
    allocate (T(2*ntg,2*mtg))
    call read_FileTmat (ntg, mtg, T) 
    close (unit = iTmat)                                          
  else 
    nTV = dimensionTV (Mrank, Nrank, chiral)
    allocate (TV(nTV))
    call formTV (FileTmat, chiral, Mrank, Nrank, TV, nTV)  
  end if
  norm = 2._O * Pi
  norm = 1._O / norm
  allocate (walpha(Nalpha), xalpha(Nalpha))  
  aalpha = 0._O
  balpha = 2._O * Pi    
  call Simpson (aalpha, balpha, Nalpha, xalpha, walpha) 
  do ialpha = 1, Nalpha
    walpha(ialpha) = walpha(ialpha) * norm
  end do         
  allocate (wbeta(Nbeta), xbeta(Nbeta))
  if (.not. UseSimpson) then
    abeta = 0._O
    bbeta = Pi   
    call Gauss_Legendre (abeta, bbeta, Nbeta, wbeta, xbeta)   
  else
    abeta = - 1._O
    bbeta =   1._O 
    call Simpson (abeta, bbeta, Nbeta, xbeta, wbeta)     
  end if 
  do ibeta = 1, Nbeta      
    if (.not. UseSimpson) then 
      beta = xbeta(ibeta)
      wbeta(ibeta) = 0.5_O * wbeta(ibeta) * sin(beta)
    else
      wbeta(ibeta) = 0.5_O * wbeta(ibeta)
    end if
  end do           
  if (.not. axsym) then
    allocate (wgamma(Ngamma), xgamma(Ngamma))
    agamma = 0._O
    bgamma = 2._O * Pi           
    call Simpson (agamma, bgamma, Ngamma, xgamma, wgamma)
    do igamma = 1, Ngamma 
      wgamma(igamma) = wgamma(igamma) * norm
    end do
  end if
  thetaGI = 0._O
  phiGi   = 0._O
  ExtThetaDom = .false.   
  alphapX   = 0._O
  alphapY   = Pi / 2._O      
  phiAZIMUT = 0._O      
  allocate (ccX(2*Nmax), ccY(2*Nmax))
  allocate (FtX(Ntheta), FpX(Ntheta), FtY(Ntheta), FpY(Ntheta))
  do j = 1, 10
    do i = 1, Ntheta
      S(j,i) = zero
    end do
  end do
  CscatAv = 0._O
  CextAv  = 0._O                                  
  if (axsym) then
    allocate (cX(2*Nrank), cY(2*Nrank), cX1(2*Nrank), cY1(2*Nrank))     
    Mstart = 0
    do ialpha = 1, Nalpha
      alpha = xalpha(ialpha)
      if (PrnProgress) call write_progress (.false., ialpha, Nalpha)
      do ibeta = 1, Nbeta          
        if (.not. UseSimpson) then 
          beta = xbeta(ibeta)
        else
          beta = acos(xbeta(ibeta))
        end if
        gamma = 0._O    
        Nc = 0
        do m = Mstart, Mrank
          if (m == 0) then
            Nmaxl = Nrank
          else
            Nmaxl = Nrank - m + 1
          end if        
          call PWcoefficients_ab_m (thetaGI, phiGI, alpha, beta, gamma,             &
               alphapX, m, Nrank, Nmaxl, cX)
          call PWcoefficients_ab_m (thetaGI, phiGI, alpha, beta, gamma,             &
               alphapY, m, Nrank, Nmaxl, cY)          
          call product_vector_vector_AVplus (Nc, Nmaxl, TV, nTV, cX, cX1)
          call product_vector_vector_AVplus (Nc, Nmaxl, TV, nTV, cY, cY1)             
          call extend_vector_positive (cX1, ccX, m, Mstart, Nrank, Nmaxl, Nmax)
          call extend_vector_positive (cY1, ccY, m, Mstart, Nrank, Nmaxl, Nmax)                    
          if (m /= 0) then
            call PWcoefficients_ab_m (thetaGI, phiGI, alpha, beta, gamma,           &
                 alphapX, - m, Nrank, Nmaxl, cX)
            call PWcoefficients_ab_m (thetaGI, phiGI, alpha, beta, gamma,           &
                 alphapY, - m, Nrank, Nmaxl, cY)                        
            if (.not. chiral) then
              call product_vector_vector_AVminus (Nc, Nmaxl, TV, nTV, cX, cX1)
              call product_vector_vector_AVminus (Nc, Nmaxl, TV, nTV, cY, cY1)              
            else 
              Nc = Nc + 4 * Nmaxl * Nmaxl
              call product_vector_vector_AVplus (Nc, Nmaxl, TV, nTV, cX, cX1)
              call product_vector_vector_AVplus (Nc, Nmaxl, TV, nTV, cY, cY1)                         
            end if  
            call extend_vector_negative (cX1, ccX, m, Nrank, Nmaxl, Nmax)
            call extend_vector_negative (cY1, ccY, m, Nrank, Nmaxl, Nmax)                   
          end if    
          Nc = Nc + 4 * Nmaxl * Nmaxl           
        end do
        call F_azimuthal (ccX, Mrank, Nrank, Nmax, Ntheta, phiAZIMUT,               &
             alpha, beta, gamma, wavenumber, ExtThetaDom, FtX, FpX)
        call F_azimuthal (ccY, Mrank, Nrank, Nmax, Ntheta, phiAZIMUT,               &
             alpha, beta, gamma, wavenumber, ExtThetaDom, FtY, FpY)                       
        fact = walpha(ialpha) * wbeta(ibeta)                  
        call Smatrix  (MirorSym, Ntheta, fact, FtX, FpX, FtY, FpY, S)
        call F_azimuthal_tetaGS (ccX, Mrank, Nrank, Nmax, thetaGI, phiGI, alpha,    &
             beta, gamma, wavenumber, FthetaX, FphiX)
        call F_azimuthal_tetaGS (ccY, Mrank, Nrank, Nmax, thetaGI, phiGI, alpha,    &
             beta, gamma, wavenumber, FthetaY, FphiY)                     
        call CQscat (ccX, Mrank, Nrank, Nmax, wavenumber, snorm, Cscat, Qscat)
        call CQext  (ccX, Mrank, Nrank, Nmax, thetaGI, phiGI, alpha, beta, gamma,   &
             alphapX, wavenumber, snorm, Cext, Qext)         
        CscatAv = CscatAv + fact * Cscat
        CextAv  = CextAv + fact * Cext
      end do
    end do 
    deallocate (cX, cY, cX1, cY1)       
  else 
    allocate (cX(2*Nmax), cY(2*Nmax))   
    do ialpha = 1, Nalpha
      alpha = xalpha(ialpha)
      if (PrnProgress) call write_progress (.false., ialpha, Nalpha)
      do ibeta = 1, Nbeta                                       
        if (.not. UseSimpson) then 
          beta = xbeta(ibeta)
        else
          beta = acos(xbeta(ibeta))
        end if       
        do igamma = 1, Ngamma 
          gamma = xgamma(igamma)
          call PWcoefficients_ab (thetaGI, phiGI, alpha, beta, gamma,               &
               alphapX, Mrank, Nrank, Nmax, cX)
          call PWcoefficients_ab (thetaGI, phiGI, alpha, beta, gamma,               &
               alphapY, Mrank, Nrank, Nmax, cY)           
          call product_matrix_vector (2*Nmax, 2*Nmax, T, 2*ntg, 2*mtg, cX, ccX)   
          call product_matrix_vector (2*Nmax, 2*Nmax, T, 2*ntg, 2*mtg, cY, ccY)                
          call F_azimuthal (ccX, Mrank, Nrank, Nmax, Ntheta, phiAZIMUT,             &
               alpha, beta, gamma, wavenumber, ExtThetaDom, FtX, FpX)
          call F_azimuthal (ccY, Mrank, Nrank, Nmax, Ntheta, phiAZIMUT,             &
               alpha, beta, gamma, wavenumber, ExtThetaDom, FtY, FpY)                                               
          fact = walpha(ialpha) * wbeta(ibeta) * wgamma(igamma)                              
          call Smatrix  (MirorSym, Ntheta, fact, FtX, FpX, FtY, FpY, S)
          call F_azimuthal_tetaGS (ccX, Mrank, Nrank, Nmax, thetaGI, phiGI, alpha,  &
               beta, gamma, wavenumber, FthetaX, FphiX)
          call F_azimuthal_tetaGS (ccY, Mrank, Nrank, Nmax, thetaGI, phiGI, alpha,  &
               beta, gamma, wavenumber, FthetaY, FphiY)                             
          call CQscat (ccX, Mrank, Nrank, Nmax, wavenumber, snorm, Cscat, Qscat)
          call CQext  (ccX, Mrank, Nrank, Nmax, thetaGI, phiGI, alpha, beta, gamma, &
               alphapX, wavenumber, snorm, Cext, Qext)          
          CscatAv = CscatAv + fact * Cscat
          CextAv  = CextAv + fact * Cext
        end do        
      end do
    end do
    deallocate (cX, cY)         
  end if        
  norm    = wavenumber * wavenumber / snorm
  QscatAv = CscatAv * norm
  QextAv  = CextAv  * norm                                    
  deallocate (ccX, ccY, FtX, FpX, FtY, FpY)
  deallocate (walpha, xalpha, wbeta, xbeta)
  if (.not. axsym) then
    deallocate (T, wgamma, xgamma)
  else 
    deallocate (TV)
  end if
end subroutine SijSCpqInt
! **********************************************************************************
subroutine Smatrix (MirorSym, Ntheta, fact, FtX, FpX, FtY, FpY, S)
  use parameters
  implicit none
  integer    :: Ntheta, i
  real(O)    :: fact
  complex(O) :: FtX(Ntheta), FpX(Ntheta), FtY(Ntheta), FpY(Ntheta), S(10,Ntheta) 
  logical    :: MirorSym  
!
  do i = 1, Ntheta
    S(1,i)  = S(1,i)  + fact * FtX(i) * conjg(FtX(i))        
    S(4,i)  = S(4,i)  + fact * FtX(i) * conjg(FpY(i))             
    S(5,i)  = S(5,i)  + fact * FtY(i) * conjg(FtY(i))        
    S(6,i)  = S(6,i)  + fact * FtY(i) * conjg(FpX(i))                
    S(8,i)  = S(8,i)  + fact * FpX(i) * conjg(FpX(i))           
    S(10,i) = S(10,i) + fact * FpY(i) * conjg(FpY(i))
    if (.not.MirorSym) then
      S(2,i) = S(2,i) + fact * FtX(i) * conjg(FtY(i))
      S(3,i) = S(3,i) + fact * FtX(i) * conjg(FpX(i))     
      S(7,i) = S(7,i) + fact * FtY(i) * conjg(FpY(i))
      S(9,i) = S(9,i) + fact * FpX(i) * conjg(FpY(i))            
    end if    
  end do
end subroutine Smatrix

include 'Parameters.f90'
include 'Allocation.f90'
include 'AdditonTh.f90'
include 'BesLeg.f90'
include 'Check.f90'
include 'EFMED.f90'
include 'GeomLib.f90'
include 'GeomTrans.f90'
include 'IncCoeff.f90'
include 'InputOutput.f90'
include 'Integr.f90'
include 'Interp.f90'
include 'MachParam.f90'
include 'MatrixOp.f90'
include 'MatrixQ.f90'
include 'MatrixSolv.f90'
include 'MatrixTrans.f90'
include 'PostProces1.f90'
include 'PostProces2.f90'
include 'PostProces3.f90'
include 'Proces1.f90'
include 'Proces2.f90'
include 'Proces3.f90'
include 'Random.f90'
include 'SCT.f90'
include 'SCTAVRGSPH.f90'
include 'SVWF.f90'
include 'TCOMP.f90'
include 'TINHOM.f90'
include 'TINHOM2SPH.f90'
include 'TINHOMSPH.f90'
include 'TINHOMSPHREC.f90'
include 'TLAY.f90'
include 'TMULT.f90'
include 'TMULT2SPH.f90'	
include 'TMULTSPH.f90'
include 'TMULTSPHREC.f90'
include 'TNONAXSYM.f90'
include 'TPARTSUB.f90'
include 'TSPHERE.f90'
program TAXSYM
!------------------------------------------------------------------------------------
! 1. General Considerations                                                         !
! --------------------------                                                        !
! TAXSYM is a routine for computing the T matrix and the scattering characteristics !
! of homogeneous, dielectric (isotropic, chiral) and perfectly conducting,          !
! axisymmetric particles.                                                           !
!                                                                                   !
! The transition matrix of a homogeneous particle can be written as:                !
!                                                                                   !
!                        T = - Q11 * Q31^(-1),                                      !
!                                                                                   ! 
! where the expressions of the matrices Q31 and Q11 follow from the extinction      !
! theorem and Huygens principle, respectively. The elements of the matrices Q31     !
! and Q11 are expressed as integrals over the particle surface. For axisymmetric    !
! particles, the T-matrix computation decouples over the azimuthal modes and the    !
! surface integrals reduce to line integrals over the generatrix. The integrals     !
! are evaluated by means of the Gauss-Legendre quadrature method, and note that for !
! particles with a plane of symmetry perpendicular to the axis of rotation (mirror  !
! symmetric particles), the integration can be performed along the half-generatrix  !
! curve. The numerical stability and accuracy of T-matrix computations for an       !
! nonsmooth generatrix can be enhanced by dividing the generatrix into piecewise    !
! smooth curves and applying separate quadrature formulas to each curve.            !
!                                                                                   !
! Localized or distributed sources can be used for T-matrix calculation and note    !
! that distributed sources are preferable for highly aspherical particles. For      !
! highly elongated particles, the sources are distributed along the axis of         !
! symmetry of the particle, while for highly flattened particles, the sources       !
! are distributed in the complex plane. 			                    !
!                                                                                   !
! Particle geometries currently supported include: spheroids, cylinders and         !
! rounded oblate cylinders. The following routines (from the file "GeomLib.f90")    !
! provide the required geometry parameters:                                         !
! - the routine "interpolation_listAXSYM" computes the integration nodes and        !
!   weights for an axisymmmetric surface,                                           !
! - the routine "elem_geomAXSYM" provides the geometry parameters (position vector, !
!   zenith and azimuthal angles, and normal unit vector in spherical coordinates)   !
!   at each integration node, and                                                   !
! - the routine "zDSAXSYM" generates the coordinates of the distributed sources.    !
! The user can easily modify these routines to generate particles with other        !
! geometries. Note that the list of parameters must be maintained and only          !
! geometries with an analytical description of the surface can be implemented.      !
! Alternatively, the option FileGeom  = .true., causes the code to read the         !
! particle geometry information from the file FileFEM. The file FileFEM is read     !
! by the routine "read_FileFEMAxsym" from the file "InputOutput.f90". The user can  !
! customize the routine "read_FileFEMAxsym" as needed to conform to the manner in   !
! which the particle geometry is stored in the file FileFEM. However, as supplied,  !
! the routine "read_FileFEMAxsym" expects the file FileFEM to have the following    !
! structure:                                                                        !
! - one line providing the number of smooth curves Nlines; the format for           !
!   reading Nlines is i7, i.e.,                                                     !
!                   read (iFEM, "(i7)", iostat = ios)  Nlines;                      ! 
! - a set of Nlines-sequences of data specifying the geometry parameters on each     !
!   smooth curve; each sequence includes:                                           !
!   - one line containing the number of curve elements (vertices) NVvr; the         !
!     format for reading NVvr is i7, i.e.,                                          !
!                   read (iFEM, "(i7)", iostat = ios) NVvr;                         !                                         
!   - NVvr lines containing the current index ielem, the Cartesian coordinates      !   
!     of the curve element center: x = r(1) and z = r(2), the Cartesian components  !
!     of the unit normal vector at the curve element center: nx = n(1) and          !
!     nz = n(2), and the area of the surface element; the format for reading the    !
!     data is:                                                                      !
!                   read (iFEM, "(i7,2x,5(e15.7,2x))", iostat = ios)                !
!                         ielem, r(1), r(2), n(1), n(2), area.                      !
! As provided, the file FileFEM is contained in the directory "GEOMFILES".          !
! If the particle geometry is read from file, the coordinates of the distributed    !
! sources (if used) must be supplied by the user.                                   ! 
!                                                                                   !
! 2. Convergence Test                                                               !
! -------------------                                                               !
! Convergence tests precede the scattering characteristics calculation. Three       !
! parameters control the T-matrix computation:                                      !
! - the number of integration points for computing integrals over the generatrix,   !
!   Nint,                                                                           !
! - the maximum expansion order Nrank, and                                          !
! - the maximum azimuthal order Mrank.                                              ! 
! Nint is the global number of integration points on the generatrix curve. As       ! 
! mentioned before, the generatrix of an nonsmooth surface is divided into Nparam   !
! piecewise smooth curves and the number of integration points on the curve j is    !
!                   Nint_curve(j) = int { c(j) * Nint },                            !
! where c(j) is a multiplicative factor and j = 1, 2,.., Nparam. The parameters     !
! c(j), j = 1, 2,..., Nparam, do not appear as explicit parameters; they are hard   !
! coded in the routine "interpolation_listAXSYM" from the file "GeomLib.f90".       !
! For example, the generatrix of a cylinder is divided into three straight lines.   !
! The first and third lines are perpendicular to the axis of symmetry, while the    ! 
! second line is parallel to the axis of symmetry. Denoting by a the                !
! half-length of the cylinder and by b the cylinder radius, we have:                !
!                                                                                   !
!     Nint_curve(first line) = Nint_curve(third line) = int {[b/2/(a+b)] * Nint}    !
!                                                                                   !
! and                                                                               !
!                                                                                   ! 
!     Nint_curve(second line) = Nint - 2 * int {[b/2/(a+b)] * Nint }.               !
!                                                                                   !
! For convergence tests, the incident wave is assumed to be a vector plane wave     !
! traveling along the Z-axis of the global coordinate system and the scattering     !
! characteristics are computed in the azimuthal plane phi = 0°. The convergence     !
! tests over Nint and Nrank are interactive, while the convergence test over Mrank  !
! is automatically performed.                                                       ! 
!                                                                                   !
! The convergence tests discussed in the literature are based on the analysis of    !
! the differential scattering cross section or extinction and scattering cross      !
! sections. The convergence test based on differential scattering cross section     !
! analysis is more conservative and is implemented in our code.                     !
!                                                                                   !
! For the integration and expansion order test an axisymmetric orientation of the   !
! particle is considered, i.e., the incident wave propagates along the axis of      !
! symmetry of the particle. In this case, all azimuthal modes are zero except       !
! for m = - 1 and m = 1. For the convergence test over Nint the scattering problem  !
! is solved for Nint and Nint + dNint, while for the convergence test over Nrank    !
! the scattering problem is solved for Nrank and Nrank - 1. The normalized          !
! differential scattering cross section (DSCS) will be checked at 20° increments    !
! for convergence within epsX (epsNint or epsNrank) tolerance. If the calculated    !
! results converge within this tolerance at 80% of the scattering angles, then      !
! convergence is achieved. At each calculation, the extinction and scattering       !
! cross sections Cext and Cscat are also computed. Although the convergence of Cext !
! and Cscat does not guarantee that the DSCS converges, the divergence of Cext and  !
! Cscat implies the divergence of the DSCS. The results of the convergence          !
! analysis are written to the file "/OUTPUTFILES/Output.dat". The above             !
! convergence tests (based on the analysis of the differential scattering cross     !
! section) have been proposed by Barber and Hill [P. W. Barber and S. C. Hill,      !
! Light scattering by particles: Computational Methods, World Scientific,           !
! Singapore, 1990].                                                                 ! 
!                                                                                   ! 
! After Nrank and Nint have been determined we pass to the azimuthal order test.    !
! The program automatically sets the particle to a more general orientation, i.e.,  !
! alpha = beta = 45°, and solves the scattering problem  for increasing m values    !
! until convergence of the angular scattering is achieved. The T matrix is stored   !
! for later use by other programs, and the values of Nrank and Mrank are printed to !
! the screen and to the T-matrix information file (see "Description.txt"). These    !
! values together with the T matrix serve as INPUT PARAMETERS for other programs.   ! 
!                                                                                   !
! 3. Estimates of Nint and Nrank                                                    !
! -------------------------------                                                   !
! The above convergence tests require estimates of Nint and Nrank. These            !
! estimates must be supplied by the user, and for this purpose, the automatic       !
! convergence procedure proposed by Mishchenko [M. I. Mishchenko, Light scattering  !
! by a size-shape distributions of randomly oriented axially symmetric particles    !
! of a size comparable to the wavelength, Applied Optics, 32, 4652-4666, 1993]      !
! or Wiscombe's truncation limit criterion [W. J. Wiscombe, Improved Mie            !
! scattering algorithms, Applied Optics, 19, 1505-1509, 1980] can be used.          !
!                                                                                   !
! The procedure developed by Mishchenko finds reliable a priori estimates of        !
! both Nint and Nrank by using only the zeroth order block matrices of the T        !
! matrix. The estimates are computed by checking the convergence of the quantities: !
!                                                                                   !
!        Ce = - (2Pi / k**2) Re {SUM (2n + 1) * [T11_0n0n + T22_0n0n] }             !
!                                                                                   !
! and                                                                               !
!                                                                                   !
!        Cs =   (2Pi / k**2) SUM (2n + 1) * [|T11_0n0n|**2 + |T22_0n0n|**2]         !
!                                                                                   ! 
! where T11_0n0n' and T22_0n0n' are the zeroth order block matrices of the T        !
! matrix. Note that for spherical particles, Ce and Cs are the extinction and       !
! scattering cross sections. An important numerical parameter of the convergence    !
! procedure is the multiplicity factor Ndgs,                                        !
!                                                                                   !
!                          Nint = Ndgs * Nrank,                                     !
!                                                                                   !
! which controls the number of integration points and must be optimized for each    !
! particle shape. The main steps of the convergence procedure are                   !
! 1. choose Ndgs;                                                                   !
! 2. compute a starting value of Nrank, as for instance                             !
!                                                                                   !
!                 NrankW = int(x + 4.05 * x**0.33),                                 !
!                                                                                   !
!    where x is the size parameter, x = k * Rcirc, and Rcirc is the radius of the   !
!    smallest circumscribing sphere;                                                !
! 3. solve the scattering problem for increasing Nrank-values (in unit steps) and   !
!    Nint = Ndgs * Nrank until the convergence criterion                            !
!                                                                                   !
!          max { [Cs(Nrank) - Cs(Nrank-1) ] / Cs(Nrank),                            !
!                [Ce(Nrank)  - Ce(Nrank-1)] / Ce(Nrank) } < delta                   !
!                                                                                   !
!    is satisfied, where delta is the desired accuracy;                             !
! 4. after Nrank has been determined, increase Nint in dNint steps until Cs(Nrank)  !
!    and Ce(Nrank) converge within delta.                                           !
!                                                                                   !
! If the convergence procedure is finished WE CAN PASS DIRECTLY TO THE AZIMUTHAL    !
! ORDER TEST. However, it is recommended to check at least the value of Nrank by    !
! using the convergence procedures based on the differential scattering cross       !
! section analysis. The convergence procedure proposed by Mishchenko can not be     !
! used for chiral particles, if the coordinates of the discrete sources are         !
! user-defined and if the particle geometry is read from file.                      !
!                                                                                   !
! A reasonable starting value of Nrank is given by Wiscombe's truncation limit      !
! criterion, i.e.,                                                                  !
!                                                                                   !    
!                NrankW = int(x + 4.05 * x**0.33 + 2),                              !
!                                                                                   !
! and note that the convergence procedure proposed by Mishchenko also uses NrankW   !
! as initial Nrank-value.                                                           !
!                                                                                   !
! The value of Nint depends on the type of discrete sources, the size parameter,    !
! the particle shape and the relative refractive index. For localized sources,      !
! size parameters smaller than 15.0, and particle aspect ratios ranging between     !
! 0.33 and 3.0, the recommended values are:                                         !
!                for spheroids:       Ndgs = (3...5), and                           !
!                for cylinders:       Ndgs = (4...7).                               !
! These values should be substantially increased as the size parameter increases,   !
! the particles become less aspherical or distributed sources are used.             !
! For spheroids with a size parameter smaller than 30.0, the following routine      !
! can be used to compute a conservative estimate of Nint:                           !
!                                                                                   !
! a = surf(1), length of the semi-axis along the axis of symmetry                   !
! b = surf(2), knight of the second semi-axis                                       !
! e = a / b                                                                         !
! xmax  = k * max(a,b)                                                              !
! Nrank = int(xmax + 4.05 * xmax**0.33 + 2.0)                                       !
! if (xmax <= 30.0) then                                                            !
!     if (e == 1.0) then                                                            !
!         Nint = 4 * Nrank                                                          !
!     else if (e < 1.0) then                                                        !
!         kb = k * b                                                                !
!         if (kb < 5.0) then                                                        !
!             Nint = 100                                                            !
!         else                                                                      !
!             Nint = 20 * int(kb)                                                   !
!         end if                                                                    !
!         if (e < 0.5) then                                                         !
!             dNr  = 25.0 + 10.0 * kb                                               !
!             Nint = Nint + int(dNr * (1.0 / e - 2.0))                              !
!         end if                                                                    ! 
!     else                                                                          !
!         ka = k * a                                                                !
!         if (ka < 10.0) then                                                       !
!             Nint = 40                                                             !
!         else                                                                      !
!             Nint = 4 * int(ka)                                                    !
!         end if                                                                    !
!         if (e > 2) then                                                           !
!             if (ka < 10.0) then                                                   !
!                 dNr = 30.0                                                        !
!             else                                                                  !
!                 dNr = 30.0 + 3.5 * (ka - 10.0)                                    !
!             end if                                                                !
!             Nint = Nint + int(dNr * (e - 2.0))                                    !
!         end if                                                                    !
!     end if                                                                        !
! end if                                                                            !
!                                                                                   !
! 4. Strategies for Performing Convergence Tests                                    !
! ----------------------------------------------                                    !
! Two strategies for performing convergence tests over Nint and Nrank are           !
! recommended. The following technique has been proposed by Barber and Hill:        !
! 1. choose a value of Nrank close to the value predicted by Wiscombe's truncation  !
!    limit criterion;                                                               !
! 2. for Nrank, perform the expansion order test with Nint = Ndgs * Nrank (in the   !
!    original code of Barber and Hill, Ndgs = 2);                                   !
! 3. if convergence is not achieved, set Nrank = Nrank + 1, maintain the relation   !
!    Nint = Ndgs * Nrank and go to Step 2;                                          !
! 4. if convergence is achieved, perform several integration tests with the         !
!    initial Nint-value, Nint = Ndgs * Nrank, until the DSCS converges.             !
!                                                                                   !
! For large and/or highly aspherical particles, T-matrix computations become        !
! poorly convergent or even divergent. Frequently, a semi-convergent behaviour is   !
! attended: the errors decrease with increasing the maximum expansion order,        !
! attain a relative constant level and afterwards increase. The region of           !
! stability can be localized by using the following technique:                      !
! 1. choose a value of Nrank smaller (or significantly smaller) than the value      !
!    predicted by Wiscombe's truncation limit criterion;                            !
! 2. for Nrank, perform several integration tests with the initial Nint-value,      !
!    Nint = Ndgs * Nrank, until the DSCS converges;                                 !
! 3. if convergence can not be achieved, set Nrank = Nrank - 1 or increase the      !
!    tolerance epsNint, and go to Step 2;                                           !
! 4. if convergence is achieved (for some Nint), perform several expansion order    !
!    tests for increasing Nrank-values and monitor the errors of the differential   !
!    scattering cross sections.                                                     !
!                                                                                   !
! For particles which are too extreme in size and/or aspect ratio, the errors of    !
! the extinction and scattering cross sections (instead of the differential         !
! scattering cross section) can be analyzed.                                        ! 
!                                                                                   !
! 5. Additional Comments                                                            !
! ----------------------                                                            !
! For the expansion order test and distributed sources, two configurations of       !
! sources (with Nrank and Nrank - 1 discrete sources) are considered. For both      !
! configurations, the coordinates of the distributed sources can be generated       !
! automatically or can be specified in the input file.                              !
!                                                                                   !
! The convergence tests over Nint and Nrank can be switched off by setting the      !
! logical variable DoConvTest to false. In this case, the values of Nint and        !
! Nrank must be specified in the input file.                                        !
!                                                                                   !
! The number of integration points has been determined for the azimuthal orders     !
! m = 1 and m = - 1. For higher azimuthal orders and sources distributed in the     !
! complex plane, the chosen value of Nint may lead to false convergence. Therefore, !
! the number of integration points should be increased at each azimuthal mode       !
! calculation. The integation step is dNintMrank. The parameter dNintMrank should   !
! be found experimentally by repeating the azimuthal order test for different       !
! input values until the differential scattering cross section converges.           !
! A conservative estimate is: dNintMrank = (0.1,...,0.2) * Nint.                    !
!                                                                                   !
! 6. Input Parameters                                                               !
! --------------------                                                              !
! The parameters specified in the input file "/INPUTFILES/InputAXSYM.dat" are       !
! listed below.                                                                     !
!                                                                                   !
! - wavelength (real) - wavelength of the incident light in vacuo.                  !
!                                                                                   !
! - ind_refMed (real) - refractive index of the ambient medium (nonabsorbing        !
!   dielectric medium).                                                             !
!                                                                                   !
! - ind_refRel (complex) - relative refractive index of the particle with respect   !
!   to the ambient medium. The imaginary part of the relative refractive index      !
!   must be zero for nonabsorbing particles and positive for absorbing particles.   !
!                                                                                   !
! - perfectcond (logical) - if perfectcond = t, the particle is perfectly           !
!   conducting.                                                                     !
!                                                                                   !
! - chiral (logical) - if chiral = t, the particle is optical active (chiral).      !
!                                                                                   !
!   The permissive values of the logical variables perfectcond and chiral are       !
!   given below.                                                                    !
!                                                                                   !
!       particle              perfectcond            chiral                         !
!      dielectric                  f                   f                            !
!   perfectly conducting           t                   f                            !
!        chiral                    f                   t                            !
!                                                                                   !
! - kb (real) - parameter of chirality. This parameter is used for chiral           !
!   particles and is ignored for dielectric and perfectly conducting particles.     !
!   The wave numbers for the left- and right-handed circularly polarized waves      !
!   are given by:                                                                   !
!               kil = ki / (1.0 - kb)  and   kir = ki / (1.0 + kb)                  !
!   where ki is the wave number in the chiral medium.                               !
!                                                                                   !
! - FileGeom (logical) - if FileGeom = t, the particle geometry is supplied by the  !
!   input file FileFEM,                                                             ! 
!                                                                                   !
! - FileFEM (character(80)) - name of the file containing the particle geometry.    !
!                                                                                   !
! - TypeGeom (integer) - parameter specifying the type of the particle geometry.    !
!                                                                                   !
! - Nsurf (integer) - number of surface parameters.                                 !
!                                                                                   !
! - surf (real array: surf(1), surf(2),...,surf(Nsurf)) - surface parameters        !
!   specifying the shape of the particle. The dimension of the array surf is        !
!   NsurfPD. The integer parameter NsurfPD is specified in the routine              !
!   "Parameters.f90" and has the value NsurfPD = 10. If Nsurf > NsurfPD, the        !
!   execution is automatically terminated.                                          !
!                                                                                   !
! - Nparam (integer) - number of smooth curves forming the generatrix curve.        !
!                                                                                   !
!   The permissive values of the surface parameters (for the supported geometries)  !
!   are summarized below.                                                           !
!                                                                                   !
!   Particle      TypeGeom   Nsurf   Nparam                surf                     !
!   spheroid         1         2       1         surf(1) - length of the semi-      !
!                                                          axis along the           !
!                                                          axis of symmetry         !
!                                                surf(2) - length of the second     !
!                                                          semi-axis                !
!                                                                                   !
!   cylinder         2         2       3         surf(1) - half-length of           !
!                                                          the cylinder             !
!                                                surf(2) - cylinder radius          !
!                                                                                   !
!   rounded          3         2       3         surf(1) - half-length of           !
!    oblate                                                the cylinder             !
!   cylinder                                     surf(2) - cylinder radius          ! 
!                                                          including the rounded    !
!                                                          part                     !
!                                                                                   !
! - anorm (real) - characteristic length of the particle which is used to           !
!   normalize the differential scattering cross sections.                           !
!                                                                                   !
! - Rcirc (real) - characteristic length of the particle (usually the radius of     !
!   the smallest circumscribing sphere) which is used to compute an estimate of the !
!   maximum expansion order by using Wiscombe's truncation limit criterion (the     !
!   size parameter is x = k * Rcirc, where k is the wave number in the ambient      !
!   medium). Alternatively, Rcirc can be chosen as the equal-volume sphere radius   !
!   or the surface-equivalent-sphere radius. This parameter is used if the          !
!   interactive convergence tests over Nint and Nrank are performed                 !
!  (DoConvTest = t). Otherwise, Rcirc is ignored.                                   !
!                                                                                   !
! - miror (logical) - if miror = t, the particle is mirror symmetric (the plane of  !
!   symmetry or the plane of reflection is perpendicular to the axis of rotation).  !
!                                                                                   ! 
! NOTE: FOR CHIRAL PARTICLES AND DISTRIBUTED SOURCES SET miror = f.                 ! 
!                                                                                   !
! - DoConvTest (logical) - if DoConvTest = t, the interactive convergence tests     !
!   over Nint and Nrank are invoked. Estimates of Nint and Nrank can be obtained    !
!   by using Mishchenko's convergence procedure. Alternatively, an estimate of      !
!   Nrank is given by Wiscombe's truncation limit criterion.                        !
!                                                                                   !
! - MishConvTest (logical) - if MishConvTest = t, estimates of Nint and Nrank are   !
!   computed with the convergence procedure proposed by Mishchenko. The code        !
!   prompts for the integer parameter Ndgs which controls the initial value of the  !
!   number of integration points. Some orientative values of Ndgs are printed and   !
!   the user can enter his option. This convergence test can be performed if:       !
!   - localized sources are used, the interactive convergence tests are performed,  !
!     the particle is not optical active, and the particle geometry is not read from!
!     file (DS = f and DoConvTest = t and chiral = f and FileGeom = f), or          !
!   - distributed sources are used, the coordinates of the distributed sources are  !
!     not user-defined, the interactive convergence tests are performed, the        !
!     particle is not optical active, and the particle geometry is not read from    ! 
!     file (DS = t and autGenDS = t and DoConvTest = t and chiral = f and           !
!     FileGeom = f).                                                                !
!                                                                                   !
! NOTE: IF THE PARTICLE IS OPTICAL ACTIVE (chiral = t) OR THE PARTICLE GEOMETRY IS  !
! SUPPLIED BY THE FILE FileFEM (FileGeom = t), THE CODE SETS MishConvTest = f.      !
!                                                                                   !
! - DS (logical) - if DS = t, distributed sources are used for T-matrix             !
!   calculation, otherwise localized sources are employed.                          !
!                                                                                   !
! - autGenDS (logical) - if autGenDS = t, the routine "zDSAXSYM" generates the      !
!   coordinates of the distributed sources. Otherwise, the coordinates of the       !
!   distributed sources must be provided by the user. If DS = f, the logical        !
!   variable autGenDS is ignored. If the particle geometry is read from file        !  
!   (FileGeom = t), the coordinates of the distributed sources are user-defined,    !
!   and the code sets autgenDS = f.                                                 !
!                                                                                   !
! - ComplexPlane (logical) - if ComplexPlane = t, the distributed sources are       !
!   situated in the complex plane. This parameter is used if distributed sources    !
!   are required and the coordinates of the distributed sources are automatically   !
!   generated (DS = t and autGenDS = t).                                            !
!                                                                                   !
! - epsZReIm (real) - input parameter of the routine "zDSAXSYM" which controls      !
!   the distribution of the discrete sources. This parameter is used if distributed !
!   sources are required and the coordinates of the distributed sources are         !
!   automatically generated (DS = t and autGenDS = t).                              !
!                                                                                   !
! - Nint (integer) - number of integration points in computing integrals over       !
!   the generatrix curve. This parameter is used (for localized and distributed     !
!   sources) if the convergence tests are not performed and the particle geometry   !
!   is not supplied by the file FileFEM. More specifically, Nint is used if         !
!   - (DS = f and DoConvTest = f and FileGeom = f) or,                              !
!   - (DS = t and autGenDS = t and DoConvTest = f) or,                              !
!   - (DS = t and autGenDS = f and DoConvTest = f and FileGeom = f).                !
!                                                                                   !
! - Nrank (integer) - maximum expansion order. This parameter is used (for localized!
!   and distributed sources) if the convergence tests are not performed, or the     !
!   coordinates of the distributed sources are user-defined. More specifically,     !
!   Nrank is used if                                                                !
!   - (DS = f and DoConvTest = f), or                                               !
!   - (DS = t and autGenDS = t and DoConvTest = f), or                              !
!   - (DS = t and autGenDS = f and DoConvTest = t), or                              !
!   - (DS = t and autGenDS = f and DoConvTest = f).                                 !
!                                                                                   !
! NOTE: IN ORDER TO SIMPLIFY THE ROUTINE FOR READING THE DATA, THE VARIABLES Nint   !
! AND Nrank MUST BE PROVIDED (IN THE INPUT FILE "InptAXSYM.dat") IF                 !
! ((DoConvTest = f) OR (DS = t AND autgenDS = f)). BECAUSE THE SIGNIFICANCE OF      !
! THESE PARAMETERS IS AS ABOVE, THE MAIN PROGRAM WILL IGNORE THE IRRELEVANT DATA    !
! INFORMATIONS.                                                                     !
!                                                                                   !
! - zRe, zIm (real arrays: zX(1), zX(2),...,zX(Nrank), X = Re, Im) - coordinates    !
!   of the distributed sources for the expansion order Nrank. These parameters      !
!   are used if the coordinates of the distributed sources are user-defined         !
!   (DS = t and autGenDS = f). The dimension of the arrays zRe and zIm is NrankPD   !
!   and the inequality Nrank <= NrankPD must hold. The integer parameter NrankPD is !
!   specified in the routine "Parameters.f90" and has the value NrankPD = 200. If   !
!   Nrank > NrankPD, the execution is automatically terminated.                     !
!                                                                                   !
! - zRe1, zIm1 (real arrays: zX1(1), zX1(2),...,zX1(Nrank-1), X = Re, Im) -         !
!   coordinates of the distributed sources for the expansion order Nrank - 1.       !
!   These parameters are used if the coordinates of the distributed sources are     !
!   user-defined and the expansion order test is performed (DS = t and autGenDS = f !
!   and TypeConvTest = 2). As before, the dimension of the arrays zRe1 and zIm1     !
!   is NrankPD.                                                                     !
!                                                                                   !
! NOTE: IN ORDER TO SIMPLIFY THE ROUTINE FOR READING THE DATA, THE REAL ARRAYS      !
! zRe, zIm AND zRe1, zIm1 MUST BE SPECIFIED (IN THE INPUT FILE "InptAXSYM.dat") IF  !
! (DS = t AND autGenDS = f). FURTHER NOTE THAT THE INPUT ARRAYS MUST BE SEPARATED   !
! BY A BLANK LINE, AND THAT THE INPUT ARRAYS zRe1 AND zIm1 MUST BE SPECIFIED AS     !
! VECTORS WITH Nrank - 1 COMPONENTS.                                                !
!                                                                                   !
! - epsNint (real) - error tolerance for the integration test.                      !
!                                                                                   !
! - epsNrank (real) - error tolerance for the expansion order test.                 !
!                                                                                   !
! - epsMrank (real) - error tolerance for the azimuthal order test.                 !
!                                                                                   !
! - dNint (integer) - number of division points for the integration test and        !
!   Mishchenko's convergence procedure. Note that the scattering problem is solved  !
!   for Nint and Nint + dNint.                                                      ! 
!                                                                                   !
! - dNintMrank (integer) - number of division points for azimuthal mode             !
!   calculation. This parameter is used if the distributed sources are situated     !
!   in the complex plane (DS = t and ComplexPlane = t). At each azimuthal mode      !
!   calculation, the number of integration points increases with dNintMrank.        !
!                                                                                   !
! - FileTmat (character(80)) - name of the file to which the T matrix is written.   !
!                                                                                   !
! - PrnProgress (logical) - if PrnProgress = t, the progress of calculation         !
!   is printed.                                                                     !
!                                                                                   !
! Note that all input parameters specifying lengths must be provided in the same    !
! units of lengths.                                                                 !
!                                                                                   !
! 7. Logical Scheme                                                                 !
! ------------------                                                                !  
! The organization of the code is as follows:                                       !
! 1.  < read input data >                                                           !
! 2.  < T-matrix calculation >                                                      !
!                                                                                   !
!    if ( read geometry from file ) then                                            !
!       < do not use Mishchenko's convergence procedure >                           !
!       < do not use automatic sources generation >                                 !
!    end if                                                                         !
!    if ( chiral particle ) then                                                    !
!       < do not use Mishchenko's convergence procedure >                           !
!    end if                                                                         !
!    if ( use localized sources ) then                                              !
!                                                                                   !
!       if ( do convergence test) then                                              !
!          if ( use Mishchenko's convergence procedure ) then                       !
!             < the code prompts for the integer parameter Ndgs and computes        !
!               the estimated values of Nint and Nrank by using Mishchenko's        !
!               convergence procedure >                                             !
!          else                                                                     !
!             < the code computes an estimate of Nrank by using                     !
!               Wiscombe's truncation criterion >                                   !
!          end if                                                                   !  
!          if ( .not. read geometry from file) then                                 !
!            < the code prompts for the estimated values of Nint and Nrank >        !
!            < the code prompts for the type of convergence test:                   !
!              1 - over Nint, 2 - over Nrank or 3 - over Mrank >                    !
!          else                                                                     !
!            < the code prompts for the estimated value of Nrank >                  !
!            < the code prompts for the type of convergence test:                   !
!              2 - over Nrank or 3 - over Mrank >                                   !           
!          end if                                                                   !
!       else if ( .not. do convergence test) then                                   !
!          if ( .not. read geometry from file) then                                 !
!             < the input file provides the values of Nint and Nrank >              !
!          else                                                                     ! 
!             < the input file provides the value of Nrank >                        !
!          end if                                                                   !
!          type of convergence test = 3 (convergence test over Mrank)               !
!       end if                                                                      !
!                                                                                   !
!    else if ( use distributed sources ) then                                       !
!                                                                                   !
!       if ( use automatic sources generation ) then                                !
!          if ( do convergence test) then                                           !
!             if ( use Mishchenko's convergence procedure ) then                    !
!                < the code prompts for the integer parameter Ndgs and computes     !
!                  the estimated values of Nint and Nrank by using Mishchenko's     !
!                  convergence procedure >                                          ! 
!             else                                                                  !
!                < the code computes an estimate of Nrank by using                  !
!                  Wiscombe's truncation criterion >                                !
!             end if                                                                !
!             < the code prompts for the estimated values of Nint and Nrank >       !
!             < the code generates the coordinates of the distributed sources       !
!               zRe and zIm corresponding to Nrank >                                !
!             < the code prompts for the type of convergence test:                  !
!               1 - over Nint, 2 - over Nrank or 3 - over Mrank >                   !
!             if ( do maximum expansion order test ) then                           !
!                < the code generate the coordinates of the distributed sources     !
!                  zRe1 and zIm1 corresponding to Nrank - 1 >                       !
!             end if                                                                !
!          else if ( .not. do convergence test) then                                !
!             < the input file provides the values of Nint and Nrank >              !
!             < the code generate the coordinates of the distributed sources        !
!               zRe and zIm corresponding to Nrank >                                !
!             type of convergence test = 3 (convergence test over Mrank)            ! 
!          end if                                                                   !
!       else if ( .not. use automatic sources generation ) then                     !
!          if ( do convergence test) then                                           !
!             < the input file provides the value of Nrank >                        !
!             < the input file provides the coordinates of the distributed sources  !
!               zRe and zIm corresponding to Nrank >                                !
!             if ( .not. read geometry from file ) then                             !
!                < the code prompts for the estimated value of Nint >               !
!                < the code prompts for the type of convergence test:               !
!                  1 - over Nint, 2 - over Nrank or 3 - over Mrank >                !
!             else                                                                  !
!                < the code prompts for the type of convergence test:               !
!                  2 - over Nrank or 3 - over Mrank >                               !
!             end if                                                                !
!             if ( do expansion order test ) then                                   !
!                < the input file provides the coordinates of the distributed       !
!                  sources zRe1 and zIm1 corresponding to Nrank - 1 >               !
!             end if                                                                !
!          else if ( .not. do convergence test) then                                !
!             if ( .not. read geometry from file ) then                             !
!                < the input file provides the values of Nint and Nrank >           !
!             else                                                                  !
!                < the input file provides the value of Nrank >                     !
!             end if                                                                ! 
!             < the input file provides the coordinates of the distributed sources  !
!               zRe and zIm corresponding to Nrank >                                !
!             type of convergence test = 3 (convergence test over Mrank)            !
!          end if                                                                   !
!       end if                                                                      !
!                                                                                   !
!    end if                                                                         !
!    if ( do integration test, i.e., type of convergence test = 1 ) then            !
!       < the code computes the DSCS for Nint and Nint + dNint and                  !
!         write the results to the file "Output.dat" >                              !
!       < the execution is terminated >                                             !
!    end if                                                                         !
!    if ( do expansion order test, i.e., type of convergence test = 2 ) then        !
!       < the code computes the DSCS for Nrank and Nrank - 1 and                    !
!         write the results to the file "Output.dat" >                              !
!       < the execution is terminated >                                             !
!    end if                                                                         !
!    if ( do azimuthal order test, i.e., type of convergence test = 3 ) then        !
!       < the code computes the DSCS for increasing m values and                    !
!         write the results to the file "Output.dat" >                              !
!       < the T matrix is stored in the file FileTmat and the T-matrix information  !
!         file is created >                                                         !
!       < Mrank and Nrank are printed to the screen and to the T-matrix             !
!         information file >                                                        !
!       < go to Step 3 >                                                            !
!    end if                                                                         !
! 3. < scattering characteristics calculation >                                     !
!------------------------------------------------------------------------------------
  use parameters  
  implicit none 
  integer       :: TypeGeom, Nsurf, Nparam, TypeConvTest, dNint, Nrank, Nint,       &
                   Nrank1, dNintMrank, Ndgs, NrankMax, NrankW, Nface                     
  real(O)       :: k, ind_refMed, wavelength, anorm, surf(NsurfPD), snorm,          &
                   kb, epsNint, epsNrank, epsMrank, zRe(NrankPD), zIm(NrankPD),     &
                   zRe1(NrankPD), zIm1(NrankPD), Rcirc, x, delta, Cscat1, Cext1,    &
                   epsZReIm, rp(2,NfacePD), np(2,NfacePD), area(NfacePD)                          
  complex(O)    :: ind_refRel
  logical       :: FileGeom, miror, perfectcond, DoConvTest, DS, chiral, autGenDS,  &
                   ComplexPlane, MishConvTest, PrnProgress
  character(80) :: FileTmat, FileFEM
! -----------------------------------------------------------------------------------
!                               Read the input file                                 ! 
! -----------------------------------------------------------------------------------       
  call readinputAXSYM ( wavelength, ind_refMed, ind_refRel, perfectcond,            &
       chiral, kb, FileGeom, TypeGeom, FileFEM, Nsurf, surf, Nparam, anorm,         &
       Rcirc, miror, DoConvTest, MishConvTest, DS, autGenDS, ComplexPlane,          &
       epsZReIm, Nint, Nrank, zRe, zIm, zRe1, zIm1, epsNint, epsNrank, epsMrank,    &
       dNint, dNintMrank, FileTmat, PrnProgress, k, snorm, Nface, rp, np, area )                   
! -----------------------------------------------------------------------------------
!         Select the type of convergence test and the values of Nint and Nrank      !
! -----------------------------------------------------------------------------------
  x = k * Rcirc
  NrankW = int(x + 4.05_O * x**0.33_O + 2._O)
  if (.not. DS) then
    if (DoConvTest) then                      
      if (MishConvTest) then                         
        print "(/,2x, a)",                                                          &
       'Estimates of Nint and Nrank Using Mishchenko''s Convergence Procedure' 
        print "(  2x, a)",                                                          &
       '---------------------------------------------------------------------'                                         
        call estimateNrankMishchenko (TypeGeom, k, ind_refRel, Nsurf, surf,         &
             zRe, zIm, Nparam, miror, perfectcond, DS, ComplexPlane,                &
             epsZReIm, x, delta, Ndgs, Nint, Nrank, NrankMax, Cscat1, Cext1)
        call estimateNintMishchenko (TypeGeom, k, ind_refRel, Nsurf, surf,          &
             zRe, zIm, Nparam, miror, perfectcond, DS, x, delta, Ndgs, Nint,        &
             dNint, Nrank, NrankMax, Cscat1, Cext1)
        print "(/,2x,'Convergence Test for an Axisymmetric Particle')"
        print "(  2x,'---------------------------------------------')"	       
        print "(/,2x,'- enter the estimated values of Nint and Nrank;')"            
        call read_integer2 (Nint, Nrank)                                
      else 
        print "(/,2x,'Convergence Test for an Axisymmetric Particle')"
        print "(  2x,'---------------------------------------------')"             
        print "(/,2x,'Nrank estimate:')"                                                            
        print "(  2x, a, i3, a)",                                                   &  
       'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'
        if (.not. FileGeom) then
          print "(/,2x, a)",                                                        &
         '- enter the estimated values of Nint and Nrank, where Nint = Ndgs * Nrank'
          print "(  2x,'  and Ndgs = 3,4,...;')"
          call read_integer2 (Nint, Nrank)                                                                      
        else
          print "(/,2x,'- enter the estimated value of Nrank;')"              
          call read_integer (Nrank)     
        end if  
      end if
      if (.not. FileGeom) then        
        print "(/,2x, a)",                                                          &
       '- enter the type of convergence test: 1 - Nint, 2 - Nrank, 3 - Mrank;' 
        call read_integerbound (TypeConvTest, 1, 3)
      else
        print "(/,2x,'- enter the type of convergence test: 2 - Nrank, 3 - Mrank;')"
        call read_integerbound (TypeConvTest, 2, 3)
      end if
    else
      print "(/,2x,'Convergence Test for an Axisymmetric Particle over Mrank')" 
      print "(  2x,'--------------------------------------------------------')"
      print "(/,2x,'Input values:')"
      if (.not. FileGeom) then
        print "(  2x, a, i4, a, i4, a)",                                            & 
       'the input values of Nint and Nrank are ', Nint, ' and ', Nrank,             &
       ', respectively,'  
        print "(  2x, a, i3, a)",                                                   &
       'while the estimated value of Nrank from Wiscombe''s criterion is ', NrankW,';'
      else
        print "(  2x,'the input value of Nrank is ', i4,', while')", Nrank
        print "(  2x, a, i3, a)",                                                   &
       'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';' 
      end if                                                                          
      TypeConvTest = 3      
    end if
    Nrank1 = Nrank - 1 ! redundant            
  else
    if (autGenDS) then
      if (DoConvTest) then                        
        if (MishConvTest) then           
          print "(/,2x, a)",                                                        &
         'Estimates of Nint and Nrank Using Mishchenko''s Convergence Procedure'
          print "(  2x, a)",                                                        &
         '---------------------------------------------------------------------'	  	 	 	                    
          call estimateNrankMishchenko (TypeGeom, k, ind_refRel, Nsurf, surf,       &
               zRe, zIm, Nparam, miror, perfectcond, DS, ComplexPlane,              &
               epsZReIm, x, delta, Ndgs, Nint, Nrank, NrankMax, Cscat1, Cext1)
          call estimateNintMishchenko (TypeGeom, k, ind_refRel, Nsurf, surf,        &
               zRe, zIm, Nparam, miror, perfectcond, DS, x, delta, Ndgs, Nint,      &
               dNint, Nrank, NrankMax, Cscat1, Cext1)   
          print "(/,2x,'Convergence Test for an Axisymmetric Particle')"
          print "(  2x,'---------------------------------------------')"	       
          print "(/,2x,'- enter the estimated values of Nint and Nrank;')"           
          call read_integer2 (Nint, Nrank)                               
        else
          print "(/,2x,'Convergence Test for an Axisymmetric Particle')"
          print "(  2x,'---------------------------------------------')"	
          print "(/,2x,'Nrank estimate:')"                                                                
          print "(  2x, a, i3, a)",                                                 &
         'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'
          print "(/,2x, a)",                                                        &
         '- enter the estimated values of Nint and Nrank, where Nint = Ndgs * Nrank'
          print "(  2x,'  and Ndgs = 5,6,...;')"
          call read_integer2 (Nint, Nrank)                                                                                 
        end if      
        call check_MaxNrank (Nrank)             
        call zDSAXSYM (TypeGeom, Nsurf, surf, Nrank, ComplexPlane, epsZReIm, zRe, zIm)     
        print "(/,2x, a)",                                                          &
       '- enter the type of convergence test: 1 - Nint, 2 - Nrank, 3 - Mrank;'
        call read_integerbound (TypeConvTest, 1, 3)
        if (TypeConvTest == 2) then
          Nrank1 = Nrank - 1
          call zDSAXSYM (TypeGeom, Nsurf, surf, Nrank1, ComplexPlane, epsZReIm,     &
               zRe1, zIm1)         
        end if
      else
        print "(/,2x,'Convergence Test for an Axisymmetric Particle over Mrank')" 
        print "(  2x,'--------------------------------------------------------')"
        print "(/,2x,'Input values:')"
        print "(  2x, a, i4, a, i4, a)",                                            &
       'the input values of Nint and Nrank are ', Nint, ' and ', Nrank,             &
       ', respectively,' 
        print "(  2x, a, i3, a)",                                                   &
       'while the estimated value of Nrank from Wiscombe''s criterion is ', NrankW,';'         
        call check_MaxNrank (Nrank)
        call zDSAXSYM (TypeGeom, Nsurf, surf, Nrank, ComplexPlane, epsZReIm, zRe, zIm) 
        TypeConvTest = 3    
      end if
      Nrank1 = Nrank - 1 ! redundant  
    else 
      if (DoConvTest) then      
        print "(/,2x,'Convergence Test for an Axisymmetric Particle')"
        print "(  2x,'---------------------------------------------')"
        print "(/,2x,'Input values:')"
        print "(  2x,'the input value of Nrank is ', i4,', while')", Nrank
        print "(  2x, a, i3, a)",                                                   &
       'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'
        if (.not. FileGeom) then                                            
          print "(/,2x, a)",                                                        &
         '- enter the estimated value of Nint, where Nint = Ndgs * Nrank'
          print "(  2x,'  and Ndgs = 5,6,...;')"
          call read_integer (Nint) 
          print "(/,2x, a)",                                                        &
         '- enter the type of convergence test: 1 - Nint, 2 - Nrank, 3 - Mrank;'
          call read_integerbound (TypeConvTest, 1, 3)
        else
          print "(/,2x,'- enter the type of convergence test: 2 - Nrank, 3 - Mrank;')"
          call read_integerbound (TypeConvTest, 2, 3)
        end if
        if (TypeConvTest == 2) Nrank1 = Nrank - 1
      else
        print "(/,2x,'Convergence Test for an Axisymmetric Particle over Mrank')" 
        print "(  2x,'--------------------------------------------------------')" 
        print "(/,2x,'Input values:')" 
        if (.not. FileGeom) then                  
          print "(  2x, a, i4, a, i4, a)",                                          &
         'the input values of Nint and Nrank are ', Nint, ' and ', Nrank,           &
         ', respectively,' 
          print "(  2x, a, i3, a)",                                                 &
         'while the estimated value of Nrank from Wiscombe''s criterion is ',       &
          NrankW,';' 
        else
          print "(  2x,'the input value of Nrank is ', i4,', while')", Nrank
          print "(  2x, a, i3, a)",                                                 &
         'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';' 
        end if
        TypeConvTest = 3              
      end if
      Nrank1 = Nrank - 1 ! redundant          
    end if
  end if                                                                            
! -----------------------------------------------------------------------------------
!                               Convergence test                                    !
! -----------------------------------------------------------------------------------
  open (unit = iOutput, file = FileOutput, status = "replace") 
  call printinputAXSYM (TypeConvTest, FileGeom, TypeGeom, FileFEM, Nsurf, Nparam,   &
       Nrank, Nrank1, dNint, dNintMrank, ind_refMed, wavelength, anorm, Rcirc,      &
       surf, kb, epsNint, epsNrank, epsMrank, zRe, zIm, zRe1, zIm1, ind_refRel,     &
       miror, perfectcond, DS, chiral, autGenDS)                     
  if (DoConvTest) then              
    if (TypeConvTest == 1) then
      if (.not. DS) then                  
        call convergence_NintAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,       &
             Nsurf, surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint,       &
             dNint, miror, perfectcond, DS, chiral, kb, epsNint, PrnProgress)
      else 
        call convergence_NintDSAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,     &
             Nsurf, surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint,       &
             dNint, miror, perfectcond, DS, chiral, kb, epsNint, PrnProgress)
      end if
    else if (TypeConvTest == 2) then
      if (.not. DS) then        
        call convergence_NrankAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,      &
             Nsurf, surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint,       &
             miror, perfectcond, DS, chiral, kb, epsNrank, PrnProgress)
      else      
        call convergence_NrankDSAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,    &
             Nsurf, surf, rp, np, area, Nface, zRe, zIm, zRe1, zIm1, Nparam, Nrank, &
             Nrank1, Nint, miror, perfectcond, DS, chiral, kb, epsNrank,            &
             PrnProgress)
      end if
    else 
      if (.not. DS) then    
        call convergence_MrankAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,      &
             Nsurf, surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint,       &
             miror, perfectcond, DS, chiral, kb, epsMrank, FileTmat, PrnProgress)
      else 
        call convergence_MrankDSAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,    &
             Nsurf, surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint,       &
             miror, perfectcond, DS, chiral, kb, epsMrank, dNintMrank, FileTmat,    &
             PrnProgress)
      end if
    end if  
  else      
    if (.not. DS) then    
      call convergence_MrankAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm, Nsurf, &
           surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, miror,         &
           perfectcond, DS, chiral, kb, epsMrank, FileTmat, PrnProgress)
    else          
      call convergence_MrankDSAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,      &
           Nsurf, surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, miror,  &
           perfectcond, DS, chiral, kb, epsMrank, dNintMrank, FileTmat, PrnProgress)
    end if  
  end if 
  close (unit = iOutput)
end program TAXSYM
!************************************************************************************
subroutine readinputAXSYM ( wavelength, ind_refMed, ind_refRel, perfectcond,        &
           chiral, kb, FileGeom, TypeGeom, FileFEM, Nsurf, surf, Nparam, anorm,     &
           Rcirc, miror, DoConvTest, MishConvTest, DS, autGenDS, ComplexPlane,      &
           epsZReIm, Nint, Nrank, zRe, zIm, zRe1, zIm1, epsNint, epsNrank,          &
           epsMrank, dNint, dNintMrank, FileTmat, PrnProgress, k, snorm, Nface,     &
           rp, np, area )
  use parameters
  use derived_parameters
  implicit none 
  integer       :: TypeGeom, Nsurf, Nparam, dNint, Nrank, Nint, i, dNintMrank, ios, &
                   Nface, j                     
  real(O)       :: k, ind_refMed, wavelength, anorm, surf(NsurfPD), xpart, snorm,   &
                   kb, epsNint, epsNrank, epsMrank, zRe(NrankPD), zIm(NrankPD),     &
                   zRe1(NrankPD), zIm1(NrankPD), Rcirc, epsZReIm, rp(2,NfacePD),    &
                   np(2,NfacePD), area(NfacePD), dp                          
  complex(O)    :: ind_refRel
  logical       :: FileGeom, miror, perfectcond, DoConvTest, DS, chiral, autGenDS,  &
                   ComplexPlane, InputDS, MishConvTest, PrnProgress, XFindPar
  character(80) :: FileTmat, FileFEM, string       
! -----------------------------------------------------------------------------------
!                        Read the input file FileInputAXSYM                         ! 
! -----------------------------------------------------------------------------------    
  call DrvParameters  
  open (unit = iInputAXSYM, file = FileInputAXSYM, status = "old",                  &
        position = "rewind")   
  wavelength = 0.1_O * 2._O * Pi  
  ind_refMed = 1._O                                                                 
  ind_refRel = (1.5_O,0._O) 
  string     = 'OptProp'    
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) wavelength
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) ind_refMed
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refMed;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) ind_refRel
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refRel;')"
      stop
    end if      
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if
  call check_ind_ref (ind_refRel)
  k = 2._O * Pi * ind_refMed / wavelength 
!
  perfectcond = .false.  
  chiral = .false.
  kb     = 0._O  
  string = 'MatProp'
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) perfectcond
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable perfectcond;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) chiral
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable chiral;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) kb
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable kb;')"
      stop
    end if      
  else
    print "(/,2x,'Group name MatProp not found;')"
    stop  
  end if      
  call check_MatPropAXSYM (perfectcond, chiral, kb)   
  if (chiral) call check_chirality (kb)
!
  FileGeom = .false.
  FileFEM  = ' '  
  TypeGeom = 1  
  Nsurf    = 2
  do i = 1, NsurfPD
    surf(i)= 1._O
  end do
  Nparam = 1
  anorm  = 1._O
  Rcirc  = 1._O 
  miror  = .false.
  string = 'GeomProp'
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) FileGeom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileGeom;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) FileFEM
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileFEM;')"
      stop
    end if       
    read (iInputAXSYM, *, iostat = ios) TypeGeom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable TypeGeom;')"
      stop
    end if       
    read (iInputAXSYM, *, iostat = ios) Nsurf
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nsurf;')"
      stop
    end if
    if (Nsurf > NsurfPD) then
      print "(/,2x,'Input error: Nsurf exceeds NsurfPD;')"                                    
      stop
    end if            
    do i = 1, Nsurf
      read (iInputAXSYM, *, iostat = ios) surf(i)
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable surf;')"
        stop
      end if
    end do    
    read (iInputAXSYM, *, iostat = ios) Nparam
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nparam;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) anorm
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anorm;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) Rcirc
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Rcirc;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) miror
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable miror;')"
      stop
    end if                                                
  else
    print "(/,2x,'Group name GeomProp not found;')"
    stop  
  end if                          
  call check_geomAXSYM (TypeGeom, Nsurf, Nparam)
  call check_geomAXSYMOblate (TypeGeom, Nsurf, surf)  
  call check_anorm (anorm)
  xpart = k * anorm
  snorm = Pi * xpart * xpart 
  Nface = 1
  do i = 1, NfacePD
    do j = 1, 2
      rp(j,i) = 0._O
      np(j,i) = 0._O
    end do
    area(i) = 0._O
  end do   
  if (FileGeom) then    
    call read_FileFEMAxsym (FileFEM, Nface, rp, np, area)     
    Rcirc = 0._O    
    do i = 1, Nface
      dp = sqrt(rp(1,i)**2 + rp(2,i)**2)
      if (dp > Rcirc) Rcirc = dp
    end do    
  end if          
!
  DoConvTest   = .true.
  MishConvTest = .true.
  string       = 'ConvTest'
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) DoConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DoConvTest;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) MishConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable MishConvTest;')"
      stop
    end if         
  else
    print "(/,2x,'Group name ConvTest not found;')"
    stop  
  end if   
  if (chiral)   MishConvTest = .false.     
  if (FileGeom) MishConvTest = .false.  
!
  DS = .false.
  autGenDS = .true.
  string   = 'Sources'
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) DS
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DS;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) autGenDS
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable autGenDS;')"
      stop
    end if         
  else
    print "(/,2x,'Group name Sources not found;')"
    stop  
  end if          
  call check_inputAXSYM (miror, chiral, DS)
  if (FileGeom) autGenDS = .false.  
  InputDS = .false.
  if (DS .and. .not. autGenDS) InputDS = .true. 
!
  ComplexPlane = .false.
  epsZReIm = 0.95_O 
  if (DS .and. autGenDS) then
    string = 'SourcePosAut'
    if (XFindPar (iInputAXSYM, string)) then
      read (iInputAXSYM, *, iostat = ios) ComplexPlane
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable ComplexPlane;')"
        stop
      end if
      read (iInputAXSYM, *, iostat = ios) epsZReIm
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable epsZReIm;')"
        stop
      end if         
    else
      print "(/,2x,'Group name SourcePosAut not found;')"
      stop  
    end if              
  end if
!
  Nint   = 100
  Nrank  =  17 
  if (.not. DoConvTest .or. InputDS) then       
    string = 'NintNrank'
    if (XFindPar (iInputAXSYM, string)) then
      read (iInputAXSYM, *, iostat = ios) Nint
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nint;')"
        stop
      end if
      read (iInputAXSYM, *, iostat = ios) Nrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nrank;')"
        stop
      end if         
    else
      print "(/,2x,'Group name NintNrank not found;')"
      stop  
    end if                              
  end if    
!
  do i = 1, NrankPD
    zRe(i)  = 0._O
    zIm(i)  = 0._O
    zRe1(i) = 0._O
    zIm1(i) = 0._O
  end do
  if (InputDS) then   
    call check_MaxNrank (Nrank) 
    string = 'SourcePosInp'
    if (XFindPar (iInputAXSYM, string)) then
      do i = 1, Nrank
        read (iInputAXSYM, *, iostat = ios) zRe(i), zIm(i)
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variables zRe and zIm;')"
          stop
        end if
      end do      
      read (iInputAXSYM, *)
      do i = 1, Nrank - 1
        read (iInputAXSYM, *, iostat = ios) zRe1(i), zIm1(i)
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variables zRe1 and zIm1;')"
          stop
        end if
      end do
    else
      print "(/,2x,'Group name SourcePosInp not found;')"
      stop  
    end if                       
  end if         
!
  epsNint  = 5.e-2_O
  epsNrank = 5.e-2_O
  epsMrank = 5.e-2_O
  dNint    = 4
  dNintMrank = 10
  string   = 'Errors'
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) epsNint
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNint;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) epsNrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNrank;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) epsMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsMrank;')"
      stop
    end if 
    read (iInputAXSYM, *, iostat = ios) dNint
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable dNint;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) dNintMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable dNintMrank;')"
      stop
    end if         
  else
    print "(/,2x,'Group name Errors not found;')"
    stop  
  end if
!
  FileTmat = '../TMATFILES/T.dat'
  string   = 'Tmat' 
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) FileTmat
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileTmat;')"
      stop
    end if             
  else
    print "(/,2x,'Group name Tmat not found;')"
    stop  
  end if   
!
  PrnProgress = .true.
  string   = 'PrintProgress' 
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) PrnProgress
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if             
  else
    print "(/,2x,'Group name PrintProgress not found;')"
    stop  
  end if       
  close (unit = iInputAXSYM) 
end subroutine readinputAXSYM   
!************************************************************************************
subroutine printinputAXSYM (ic, FileGeom, TypeGeom, FileFEM, Nsurf, Nparam, Nrank,  &
           Nrank1, dNint, dNintMrank,ind_refMed, wavelength, anorm, Rcirc, surf,    &
           kb, epsNint, epsNrank, epsMrank, zRe, zIm, zRe1, zIm1, ind_refRel,       &
           miror, perfectcond, DS, chiral, autGenDS)
  use parameters
  implicit none
  integer       :: ic, TypeGeom, Nsurf, Nparam, Nrank, Nrank1, dNint, dNintMrank,   &
                   i, LenString                     
  real(O)       :: ind_refMed, wavelength, anorm, Rcirc, surf(Nsurf), kb, epsNint,  &
                   epsNrank, epsMrank, zRe(Nrank), zIm(Nrank), zRe1(Nrank1),        &
                   zIm1(Nrank1)
  complex(O)    :: ind_refRel
  character(80) :: FileFEM, FileFEMWrite
  logical       :: FileGeom, miror, perfectcond, DS, chiral, autGenDS  
!
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x,'wavelength of the free space, wavelength = ',1pe13.4,';')")  &
         wavelength
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'refractive index of the ambient medium, ind_refMed = ', ind_refMed, ';'
  write (iOutput,"(2x, a, 1pe10.3, ',', 1pe10.3, a)")                               &
 'relative refractive index of the particle, ind_refRel = (', ind_refRel, ');' 
  write (iOutput,*)
  if (FileGeom) then
    FileFEMWrite = FileFEM(14:LenString(FileFEM))
    write (iOutput,"(2x, a, a30)")                                                  &
   'name of the file containing the particle geometry, FileFEM = ', FileFEMWrite
  else
    write (iOutput,"(2x,'index of the particle geometry, TypeGeom = ',i2,';')")     &
           TypeGeom
    if (TypeGeom == 1) then
      write (iOutput,"(2x,'spheroid;')")        
    else if (TypeGeom == 2) then
      write (iOutput,"(2x,'cylinder;')")        
    else if (TypeGeom == 3) then
      write (iOutput,"(2x,'rounded oblate cylinder;')")
    end if
    write (iOutput,"(2x,'number of surface parameters, Nsurf = ',i2,';')") Nsurf
    write (iOutput,"(2x,'surface parameters:')")
    do i = 1, Nsurf
      write (iOutput,"(2x,'surf(',i2,') = ',1pe10.3,',')") i, surf(i)
    end do
    if (TypeGeom == 1) then
      write (iOutput,"(2x,'where surf(1) is the semi-axis along the symmetry axis,')")
      write (iOutput,"(2x,'and   surf(2) is the second semi-axis;')")
    else if (TypeGeom == 2 .or. TypeGeom == 3) then
      write (iOutput,"(2x,'where surf(1) is the half-length of the cylinder')") 
      write (iOutput,"(2x,'and   surf(2) is the cylinder radius;')")
    end if               
    write (iOutput,"(2x,'number of integration surfaces, Nparam = ',i2,';')") Nparam
  end if  
  write (iOutput,"(2x,a, 1pe10.3, a)")                                              &
 'characteristic length of the particle, anorm = ', anorm, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'radius of the circumscribing sphere, Rcirc = ', Rcirc, ';'
  if (miror) write (iOutput,"(2x,'mirror symmetric particle;')")  
  write (iOutput,*)
  if (perfectcond) then
    write (iOutput,"(2x,'perfectly conducting particle;')")
  else if (chiral) then
    write (iOutput,"(2x,'chiral particle;')")
    write (iOutput,"(2x,'characteristic of chirality, kb = ',1pe10.3,';')") kb  
  else 
    write (iOutput,"(2x,'dielectric particle;')")
  end if 
  write (iOutput,*)
  if (.not.DS) then
    write (iOutput,"(2x,'computation with localized sources;')")
  else
    write (iOutput,"(2x,'computation with distributed sources;')")
    if (autGenDS) then
      write (iOutput,"(2x,'the sources are generated automatically;')") 
    else
      write (iOutput,"(2x,'the sources are user-defined;')")
    end if                      
    write (iOutput,*)       
    write (iOutput,"(2x,'z - coordinates of the sources:')")
    write (iOutput,"(2x,'first configuration:')")
    do i = 1, Nrank
      if (i /= Nrank) then
        write (iOutput,"(2x,'zRe(',i3,') = ',1pe10.3,', zIm(',i3,') = ',1pe10.3,',')")&
               i, zRe(i), i, zIm(i)
      else
        write (iOutput,"(2x,'zRe(',i3,') = ',1pe10.3,', zIm(',i3,') = ',1pe10.3,';')")&
               i, zRe(i), i, zIm(i)
      end if
    end do
    if (ic == 2) then
      write (iOutput,*)
      write (iOutput,"(2x,'second configuration:')")
      do i = 1,Nrank1
        if (i /= Nrank1) then
          write (iOutput,"(2x,'zRe(',i3,') = ',1pe10.3,', zIm(',i3,') = ',1pe10.3,',')")&
                 i, zRe1(i), i, zIm1(i)
        else
          write (iOutput,"(2x,'zRe(',i3,') = ',1pe10.3,', zIm(',i3,') = ',1pe10.3,';')")&
                 i, zRe1(i), i, zIm1(i)
        end if
      end do
    end if
  end if
  write (iOutput,*)
  write (iOutput,"(2x,'integration tolerance, epsNint = ',1pe10.3,';')") epsNint
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum expansion order tolerance, epsNrank = ', epsNrank, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum azimuthal order tolerance, epsMrank = ', epsMrank, ';'          
  write (iOutput,"(2x,'integration step, dNint = ',i3,'.')") dNint
  if (DS) then
    write (iOutput,"(2x, a, i3, a)")                                                &
   'integration step for Mrank calculation, dNintMrank = ',     dNintMrank, '.'
  end if
  write (iOutput,"(/)")                       
end subroutine printinputAXSYM
!***********************************************************************************
subroutine convergence_NintAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm, Nsurf,     &
           surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, dNint, miror,  &
           perfectcond, DS, chiral, kb, epsNint, PrnProgress)
  use parameters                                                                           
  implicit none 
  integer    :: TypeGeom, Nsurf, Nface, Nparam, Nrank, Nint, dNint
  real(O)    :: k, surf(Nsurf), snorm, epsNint, kb, zRe(Nrank), zIm(Nrank),         &
                rp(2,NfacePD), np(2,NfacePD), area(NfacePD)
  complex(O) :: ind_ref
  logical    :: FileGeom, miror, perfectcond, DS, chiral, PrnProgress
!      
  integer    :: Nteta, Mstart, Mrank, Nmax, Nmaxmax, i, m, iNint, NthetaConv,       &
                iprog, Nprog
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O  
  Mstart = 1
  Mrank  = 1
  Nmax   = Nrank        
  m = 1            
  call write_TypeConvHead (1)
  allocate (a(2*Nrank,2*Nrank), b(2*Nrank,2*Nrank), c(2*Nrank), c1(2*Nrank))
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))  
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do
  if (.not. chiral) then
    Nprog = 7
    iprog = 3
  else
    Nprog = 13
    iprog =  6
  end if
  if (PrnProgress) call write_progress (.true., 1, Nprog)
  do iNint = 1, 2         
    allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, miror)       
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 2+iprog*(iNint-1), Nprog)
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, b, Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 3+iprog*(iNint-1), Nprog)
    call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress (.false., 4+iprog*(iNint-1), Nprog)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         Nmax, c)
    call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)
    if (.not. chiral) then
      call matrix_m_negativ (Nmax, Nmax, b, Nrank, Nrank)
    else 
      call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,   &
           area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, &
           weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
      if (PrnProgress) call write_progress (.false., 5+iprog*(iNint-1), Nprog)
      call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,   &
           area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, &
           weightsG, miror, perfectcond, DS, chiral, kb, b, Nrank, Nrank)
      if (PrnProgress) call write_progress (.false., 6+iprog*(iNint-1), Nprog)
      call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)
      if (PrnProgress) call write_progress (.false., 7+iprog*(iNint-1), Nprog)
    end if
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,    &
         Nmax, c)
    call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)
    call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm, &
        .false.,.true., h, v)    
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsNint, NthetaConv)
    call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
    call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,         &
         alfap, k, snorm, Cext, Qext)
    call write_3ConvParam (Nint, Nrank, m)
    call write_DSCS(Nteta,.false., h, v)
    call write_Effic (Qscat, Qext)  
    Nint = Nint + dNint
    deallocate (paramG, weightsG, Nintparam)
  end do  
  call write_NintConvRes (NthetaConv, Nteta, epsNint)                 
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv)
end subroutine convergence_NintAXSYM 
!***********************************************************************************
subroutine convergence_NrankAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm, Nsurf,    &
           surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, miror,         &
           perfectcond, DS, chiral, kb, epsNrank, PrnProgress)                  
  use parameters
  implicit none  
  integer    :: TypeGeom, Nsurf, Nface, Nparam, Nrank, Nint
  real(O)    :: k, surf(Nsurf), snorm, epsNrank, kb, zRe(Nrank), zIm(Nrank),        &
                rp(2,NfacePD), np(2,NfacePD), area(NfacePD)
  complex(O) :: ind_ref
  logical    :: FileGeom, miror, perfectcond, DS, chiral, PrnProgress
!      
  integer    :: Nteta, Mstart, Mrank, Nmax, Nmaxmax, i, m, NthetaConv, iprog,       &
                Nprog, j   
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:), ap(:,:), bp(:,:),   &
                            am(:,:), bm(:,:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1
  Nmax   = Nrank    
  m = 1 
  call write_TypeConvHead (2)
  allocate (a(2*Nrank,2*Nrank), b(2*Nrank,2*Nrank), c(2*Nrank), c1(2*Nrank))     
  allocate (ap(2*Nrank,2*Nrank), bp(2*Nrank,2*Nrank))
  allocate (am(2*Nrank,2*Nrank), bm(2*Nrank,2*Nrank))  
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))  
  allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
  if (.not. FileGeom) then
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, miror)
  else
    do i = 1, Nparam
      do j = 1, Nint
        paramG(i,j)   = 0._O 
        weightsG(i,j) = 0._O
      end do
      Nintparam(i) = 1
    end do
  end if
  if (.not. chiral) then
    Nprog = 5
  else
    Nprog = 8
  end if
  if (PrnProgress) call write_progress (.true., 1, Nprog)             
! --- Nrank configuration ---                    
  call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, area, &
       Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG,  &
       miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
  if (PrnProgress) call write_progress (.false., 2, Nprog)
  call copy_matrix (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, ap, 2*Nrank, 2*Nrank)
  call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, area, &
       Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG,  &
       miror, perfectcond, DS, chiral, kb, b, Nrank, Nrank)
  if (PrnProgress) call write_progress (.false., 3, Nprog)
  call copy_matrix (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, bp, 2*Nrank, 2*Nrank)
  call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 4, Nprog)
  iprog = 4
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,       &
       Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)
  if (.not. chiral) then
    call matrix_m_negativ (Nmax, Nmax, b, Nrank, Nrank)
  else 
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,   &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 4, Nprog)
    call copy_matrix (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, am, 2*Nrank, 2*Nrank)        
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,   &
         weightsG, miror, perfectcond, DS, chiral, kb, b, Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 5, Nprog)
    call copy_matrix (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, bm, 2*Nrank, 2*Nrank)    
    call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress (.false., 6, Nprog)
    iprog = 6
  end if
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,      &
       Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)
  call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,   &
      .false.,.true., h, v) 
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  do i = 1, Nteta
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do  
  call write_3ConvParam (Nint, Nrank, m)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
! --- (Nrank - 1) configuration ---
  call copy_matrix (2*Nmax, 2*Nmax, ap, 2*Nrank, 2*Nrank, a, 2*Nrank, 2*Nrank)
  call matrix_Nrank_m_left (Nmax, a, Nrank, Nrank)
  call copy_matrix (2*Nmax, 2*Nmax, bp, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank)
  call matrix_Nrank_m (Nmax, b, Nrank, Nrank)
  call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)
  if (PrnProgress) call write_progress (.false., iprog+1, Nprog)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,       &
       Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)
  if (.not. chiral) then
    call matrix_m_negativ (Nmax, Nmax, b, Nrank, Nrank)
  else 
    call copy_matrix (2*Nmax, 2*Nmax, am, 2*Nrank, 2*Nrank, a, 2*Nrank, 2*Nrank)
    call matrix_Nrank_m_left (Nmax, a, Nrank, Nrank)
    call copy_matrix (2*Nmax, 2*Nmax, bm, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank)        
    call matrix_Nrank_m (Nmax, b, Nrank, Nrank)
    call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress (.false., iprog+2, Nprog)
  end if
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,      &
       Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)
  call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,   &
      .false.,.true., h, v)
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConv)  
  call write_3ConvParam (Nint, Nrank - 1, m)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConv, Nteta, epsNrank) 
  deallocate (ap, bp, am, bm)
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv, paramG, weightsG, Nintparam)
end subroutine convergence_NrankAXSYM
!***********************************************************************************
subroutine convergence_MrankAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm, Nsurf,    &
           surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, miror,         &
           perfectcond, DS, chiral, kb, epsMrank, FileTmat, PrnProgress)                
  use parameters
  implicit none   
  integer       :: TypeGeom, Nsurf, Nface, Nparam, Nrank, Nint
  real(O)       :: k, surf(Nsurf), snorm, epsMrank, kb, zRe(Nrank), zIm(Nrank),     &
                   rp(2,NfacePD), np(2,NfacePD), area(NfacePD)
  complex(O)    :: ind_ref
  logical       :: FileGeom, miror, perfectcond, DS, chiral, PrnProgress
  character(80) :: FileTmat
!      
  integer       :: Nteta, Mstart, Mrank, Nmax, Nmaxmax, i, m, NthetaConv, Nprog, j
  real(O)       :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,     &
                   Cext, Qext  
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 0
  Mrank  = Nrank      
  open (unit = iTmat, file = FileTmat, status = 'replace')  
  call write_HeadFileTmat (Nrank, Nrank) 
  call write_TypeConvHead (3)
  call write_2ConvParamAxsym (Nint, Nrank)
  allocate (a(2*Nrank,2*Nrank), b(2*Nrank,2*Nrank), c(2*Nrank), c1(2*Nrank))
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do  
  allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
  if (.not. FileGeom) then
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, miror)
  else
    do i = 1, Nparam
      do j = 1, Nint
        paramG(i,j)   = 0._O 
        weightsG(i,j) = 0._O
      end do
      Nintparam(i) = 1
    end do
  end if        
  if (.not. chiral) then
    Nprog = 4
  else
    Nprog = 7
  end if
  Mrank = - 1
  do m = Mstart, Nrank    
    call write_1ConvParam (m)
    Mrank = Mrank + 1
    if (m == 0) then
      Nmax = Nrank
    else
      Nmax = Nrank - m + 1
    end if  
    if (PrnProgress) call write_progress_m (.true., m, 1, Nprog)    
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank) 
    if (PrnProgress) call write_progress_m (.false., m, 2, Nprog)       
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, b, Nrank, Nrank) 
    if (PrnProgress) call write_progress_m (.false., m, 3, Nprog)                           
    call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress_m (.false., m, 4, Nprog)                   
    call write_FileTmat (Nrank, Nrank, b)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         Nmax, c)
    call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)       
    if (m /= 0) then
      if (.not. chiral) then
        call matrix_m_negativ (Nmax, Nmax, b, Nrank, Nrank)     
      else 
        call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, &
             area, Nface, zRe, zIm, -m, Nrank,Nmax, Nint, Nparam, Nintparam,        &
             paramG, weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
        if (PrnProgress) call write_progress_m (.false., m, 5, Nprog)                     
        call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, &
             area, Nface, zRe, zIm, -m, Nrank,Nmax, Nint, Nparam, Nintparam,        &
             paramG, weightsG, miror, perfectcond, DS, chiral, kb, b, Nrank, Nrank)    
        if (PrnProgress) call write_progress_m (.false., m, 6, Nprog)
        call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)       
        if (PrnProgress) call write_progress_m (.false., m, 7, Nprog)
        call write_FileTmat (Nrank, Nrank, b)   
      end if
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,  &
           Nmax, c) 
      call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
      call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)     
    end if
    call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm, &
        .false.,.true., h, v)
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsMrank, NthetaConv)     
    call write_DSCS (Nteta,.false., h, v)
    if (NthetaConv >= int(0.8*Nteta)) exit 
  end do
  close (unit = iTmat) 
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  call write_Effic (Qscat, Qext)
  call write_MrankConvRes (NthetaConv, epsMrank)
  if (NthetaConv >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criterion for Mrank is satisfied;')"                                              
  else
    print "(/,2x,'Convergence criterion for Mrank is not satisfied;')"
  end if
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .true., .false., chiral)
  call ScatCharact (k, FileTmat, Mrank, Nrank, .true., .false., chiral)
  print "(/,2x,'T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"      
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank                     
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv, paramG, weightsG, Nintparam)
end subroutine convergence_MrankAXSYM
!***********************************************************************************
subroutine convergence_NintDSAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm, Nsurf,   &
           surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, dNint, miror,  &
           perfectcond, DS, chiral, kb, epsNint, PrnProgress)
  use parameters                                                                           
  implicit none 
  integer    :: TypeGeom, Nsurf, Nface, Nparam, Nrank, Nint, dNint
  real(O)    :: k, surf(Nsurf), snorm, epsNint, kb, zRe(Nrank), zIm(Nrank),         &
                rp(2,NfacePD), np(2,NfacePD), area(NfacePD)
  complex(O) :: ind_ref
  logical    :: FileGeom, miror, perfectcond, DS, chiral, PrnProgress
!      
  integer    :: Nteta, Mstart, Mrank, Nmax, Nmaxmax, i, m, iNint, NthetaConv,       &
                iprog, Nprog 
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1
  Nmax   = Nrank        
  m = 1           
  call write_TypeConvHead (1)
  allocate (a(2*Nrank,2*Nrank), b(2*Nrank,2*Nrank), c(2*Nrank), c1(2*Nrank))
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))  
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do
  if (.not. chiral) then
    Nprog = 9
    iprog = 4
  else
    Nprog = 17
    iprog =  8
  end if
  if (PrnProgress) call write_progress (.true., 1, Nprog)
  do iNint = 1, 2         
    allocate(paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, miror)       
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 2+iprog*(iNint-1), Nprog)
    call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area, Nface,& 
         zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG, b,    &
         Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 3+iprog*(iNint-1), Nprog)
    call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress (.false., 4+iprog*(iNint-1), Nprog)
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    call product_matrices (2*Nmax, 2*Nrank, 2*Nmax, a, 2*Nrank, 2*Nrank, b, 2*Nrank,&
         2*Nrank)    
    if (PrnProgress) call write_progress (.false., 5+iprog*(iNint-1), Nprog)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         Nmax, c)
    call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)
    if (.not. chiral) then
      call matrix_m_negativ (Nmax, Nmax, a, Nrank, Nrank)
    else 
      call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,   &
           area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, &
           weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
      if (PrnProgress) call write_progress (.false., 6+iprog*(iNint-1), Nprog)
      call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area,     &
           Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,       &
           weightsG, b, Nrank, Nrank)
      if (PrnProgress) call write_progress (.false., 7+iprog*(iNint-1), Nprog)
      call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank,     &
           2*Nmax)
      if (PrnProgress) call write_progress (.false., 8+iprog*(iNint-1), Nprog)
      call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,   &
           area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, &
           weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)    
      call product_matrices (2*Nmax, 2*Nrank, 2*Nmax, a, 2*Nrank, 2*Nrank,          &
           b, 2*Nrank, 2*Nrank)
      if (PrnProgress) call write_progress (.false., 9+iprog*(iNint-1), Nprog)
    end if
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,    &
         Nmax, c)
    call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)
    call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm, &
        .false.,.true., h, v)
    call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
    call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,         &
         alfap, k, snorm, Cext, Qext)    
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsNint, NthetaConv)
    call write_3ConvParam (Nint, Nrank, m)
    call write_DSCS (Nteta,.false., h, v)
    call write_Effic (Qscat, Qext)
    Nint = Nint + dNint
    deallocate (paramG, weightsG, Nintparam)
  end do
  call write_NintConvRes (NthetaConv, Nteta, epsNint)                 
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv)
end subroutine convergence_NintDSAXSYM
!***********************************************************************************
subroutine convergence_NrankDSAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm, Nsurf,  &
           surf, rp, np, area, Nface, zRe, zIm, zRe1, zIm1, Nparam, Nrank, Nrank1,  &
           Nint, miror, perfectcond, DS, chiral, kb, epsNrank, PrnProgress)              
  use parameters
  implicit none  
  integer    :: TypeGeom, Nsurf, Nface, Nparam, Nrank, Nrank1, Nint
  real(O)    :: k, surf(Nsurf), snorm, epsNrank, kb, zRe(Nrank), zIm(Nrank),        &
                zRe1(Nrank1), zIm1(Nrank1), rp(2,NfacePD), np(2,NfacePD),           &
                area(NfacePD)
  complex(O) :: ind_ref
  logical    :: FileGeom, miror, perfectcond, DS, chiral, PrnProgress
!      
  integer    :: Nteta, Mstart, Mrank, Nmax, Nmaxmax, i, m, NthetaConv,              &
                iprog, Nprog, j
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1
  Nmax   = Nrank  
  m = 1
  call write_TypeConvHead (2)
  allocate (a(2*Nrank,2*Nrank), b(2*Nrank,2*Nrank), c(2*Nrank), c1(2*Nrank))
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))  
  allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
  if (.not. FileGeom) then
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, miror)
  else
    do i = 1, Nparam
      do j = 1, Nint
        paramG(i,j)   = 0._O 
        weightsG(i,j) = 0._O
      end do
      Nintparam(i) = 1
    end do
  end if         
  if (.not. chiral) then
    Nprog = 9
  else
    Nprog = 17
  end if
  if (PrnProgress) call write_progress (.true., 1, Nprog)
! --- Nrank configuration ---                    
  call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, area, &
       Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG,  &
       miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
  if (PrnProgress) call write_progress (.false., 2, Nprog)
  call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area, Nface,  &
       zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG, b,      &
       Nrank, Nrank)                              
  if (PrnProgress) call write_progress (.false., 3, Nprog)
  call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 4, Nprog)
  call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, area, &
       Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG,  &
       miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
  call product_matrices (2*Nmax, 2*Nrank, 2*Nmax, a, 2*Nrank, 2*Nrank, b, 2*Nrank,  &
       2*Nrank)    
  if (PrnProgress) call write_progress (.false., 5, Nprog)
  iprog = 5
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank, Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)
  if (.not. chiral) then
    call matrix_m_negativ (Nmax, Nmax, a, Nrank, Nrank)
  else 
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,   &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 6, Nprog)
    call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area, Nface,&
         zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG, b,   &
         Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 7, Nprog)
    call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress (.false., 8, Nprog)
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,   &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    call product_matrices (2*Nmax, 2*Nrank, 2*Nmax, a, 2*Nrank, 2*Nrank, b, 2*Nrank,&
         2*Nrank) 
    if (PrnProgress) call write_progress (.false., 9, Nprog)
        iprog = 9
  end if
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,      &
       Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)  
  call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,   &
      .false.,.true., h, v)
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  do i = 1, Nteta
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do  
  call write_3ConvParam (Nint, Nrank, m)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
! --- Nrank1 configuration ---
  Nmax   = Nrank1
  Nmaxmax= Nrank1 + Mrank*(2*Nrank1 - Mrank + 1)  
  call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, area, &
       Nface, zRe1, zIm1, m, Nrank1, Nmax, Nint, Nparam, Nintparam, paramG,         &
       weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
  if (PrnProgress) call write_progress (.false., iprog+1, Nprog)
  call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area, Nface,  &
       zRe1, zIm1, m, Nrank1, Nmax, Nint, Nparam, Nintparam, paramG, weightsG, b,   &
       Nrank, Nrank)
  if (PrnProgress) call write_progress (.false., iprog+2, Nprog)
  call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank1, 2*Nmax)
  if (PrnProgress) call write_progress (.false., iprog+3, Nprog)
  call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, area, &
       Nface, zRe1, zIm1, m, Nrank1, Nmax, Nint, Nparam, Nintparam, paramG,         &
       weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
  call product_matrices (2*Nmax, 2*Nrank1, 2*Nmax, a, 2*Nrank, 2*Nrank, b, 2*Nrank, &
       2*Nrank)    
  if (PrnProgress) call write_progress (.false., iprog+4, Nprog)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank1,      &
       Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank1, Nmax, Nmaxmax)  
  if (.not. chiral) then 
    call matrix_m_negativ (Nmax, Nmax, a, Nrank, Nrank)
  else 
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe1, zIm1, -m, Nrank1, Nmax, Nint, Nparam, Nintparam,        &
         paramG, weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)    
    if (PrnProgress) call write_progress (.false., iprog+5, Nprog)
    call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area, Nface,& 
         zRe1, zIm1, -m, Nrank1, Nmax, Nint, Nparam, Nintparam, paramG, weightsG,   &
         b, Nrank, Nrank)    
    if (PrnProgress) call write_progress (.false., iprog+6, Nprog)
    call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank1,      &
         2*Nmax)    
    if (PrnProgress) call write_progress (.false., iprog+7, Nprog)
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe1, zIm1, -m, Nrank1, Nmax, Nint, Nparam, Nintparam,        &
         paramG, weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)    
    call product_matrices (2*Nmax, 2*Nrank1, 2*Nmax, a, 2*Nrank, 2*Nrank,           &
         b, 2*Nrank, 2*Nrank)       
    if (PrnProgress) call write_progress (.false., iprog+8, Nprog)
  end if
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank1,     &
       Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank1, Nmax, Nmaxmax)  
  call DSCS (cc, Mrank, Nrank1, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,  &
      .false.,.true., h, v)
  call CQscat (cc, Mrank, Nrank1, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank1, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,          &
       alfap, k, snorm, Cext, Qext)
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConv)  
  call write_3ConvParam (Nint, Nrank1, m)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConv, Nteta, epsNrank)
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv, paramG, weightsG, Nintparam)
end subroutine convergence_NrankDSAXSYM 
!***********************************************************************************
subroutine convergence_MrankDSAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm, Nsurf,  &
           surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, miror,         &
           perfectcond, DS, chiral, kb, epsMrank, dNintMrank, FileTmat, PrnProgress)            
  use parameters
  implicit none   
  integer       :: TypeGeom, Nsurf, Nface, Nparam, Nrank, Nint, dNintMrank
  real(O)       :: k, surf(Nsurf), snorm, epsMrank, kb, zRe(Nrank), zIm(Nrank),     &
                   rp(2,NfacePD), np(2,NfacePD), area(NfacePD)
  complex(O)    :: ind_ref
  logical       :: FileGeom, miror, perfectcond, DS, chiral, PrnProgress
  character(80) :: FileTmat
!      
  integer       :: Nteta, Mstart, Mrank, Nmax, Nmaxmax, i, m, NthetaConv, Nprog, j
  real(O)       :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,     &
                   Cext, Qext  
  logical       :: ComplexPlane
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 0
  Mrank  = Nrank      
  open (unit = iTmat, file = FileTmat, status = 'replace') 
  call write_HeadFileTmat (Nrank, Nrank) 
  call write_TypeConvHead (3)
  call write_2ConvParamAxsym (Nint, Nrank)
  allocate (a(2*Nrank,2*Nrank), b(2*Nrank,2*Nrank), c(2*Nrank), c1(2*Nrank))
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do  
  allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
  if (.not. FileGeom) then
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, miror)
  else
    do i = 1, Nparam
      do j = 1, Nint
        paramG(i,j)   = 0._O 
        weightsG(i,j) = 0._O
      end do
      Nintparam(i) = 1
    end do
  end if       
  ComplexPlane = .false.        
  do i = 1, Nrank                  
    if (zIm(i) /= 0._O) ComplexPlane = .true.
  end do
  if (.not. chiral) then
    Nprog = 5
  else
    Nprog = 9
  end if                        
  Mrank = - 1
  do m = Mstart, Nrank          
    call write_1ConvParam (m)
    Mrank = Mrank + 1
    if (m == 0) then
      Nmax = Nrank
    else
      Nmax = Nrank - m + 1
    end if  
    if (ComplexPlane) then
      deallocate (paramG, weightsG, Nintparam)
      Nint = Nint + dNintMrank
      allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
      call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,            &
           Nintparam, paramG, weightsG, miror)          
    end if 
    if (PrnProgress) call write_progress_m (.true., m, 1, Nprog)  
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    if (PrnProgress) call write_progress_m (.false., m, 2, Nprog) 
    call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area, Nface,&
         zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG, b,    &
         Nrank, Nrank)
    if (PrnProgress) call write_progress_m (.false., m, 3, Nprog)
    call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress_m (.false., m, 4, Nprog)
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    call product_matrices (2*Nmax, 2*Nrank, 2*Nmax, a, 2*Nrank, 2*Nrank, b, 2*Nrank,&
         2*Nrank)   
    if (PrnProgress) call write_progress_m (.false., m, 5, Nprog)
    call write_FileTmat (Nrank, Nrank, a)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         Nmax, c)           
    call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)       
    if (m /= 0) then
      if (.not. chiral) then
        call matrix_m_negativ (Nmax, Nmax, a, Nrank, Nrank)
      else 
        call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, &
             area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam,       &
             paramG, weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
        if (PrnProgress) call write_progress_m (.false., m, 6, Nprog)
        call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area,   &
             Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,     &
             weightsG, b, Nrank, Nrank)
        if (PrnProgress) call write_progress_m (.false., m, 7, Nprog)
        call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank,   &
             2*Nmax)
        if (PrnProgress) call write_progress_m (.false., m, 8, Nprog)
        call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, &
             area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam,       &
             paramG, weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
        call product_matrices (2*Nmax, 2*Nrank, 2*Nmax, a, 2*Nrank, 2*Nrank,        &
             b, 2*Nrank, 2*Nrank)               
        if (PrnProgress) call write_progress_m (.false., m, 9, Nprog)
        call write_FileTmat (Nrank, Nrank, a)   
      end if
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,  &
           Nmax, c)
      call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
      call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)
    end if
    call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm, &
        .false.,.true., h, v)
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsMrank, NthetaConv)     
    call write_DSCS (Nteta,.false., h, v)
    if (NthetaConv >= int(0.8*Nteta)) exit 
  end do
  close (unit = iTmat)
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  call write_Effic (Qscat, Qext)
  call write_MrankConvRes (NthetaConv, epsMrank)
  if (NthetaConv >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criterion for Mrank is satisfied;')"                                   
  else
    print "(/,2x,'Convergence criterion for Mrank is not satisfied;')"
  end if
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .true., .false., chiral)     
  call ScatCharact (k, FileTmat, Mrank, Nrank, .true., .false., chiral) 
  print "(/,2x,'T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank 
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank             
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv, paramG, weightsG, Nintparam)
end subroutine convergence_MrankDSAXSYM

subroutine TAXSYM
!------------------------------------------------------------------------------------
! 1. General Considerations                                                         !
! --------------------------                                                        !
! TAXSYM is a routine for computing the T matrix and the scattering characteristics !
! of homogeneous, dielectric (isotropic, chiral) and perfectly conducting,          !
! axisymmetric particles.                                                           !
!                                                                                   !
! The transition matrix of a homogeneous particle can be written as:                !
!                                                                                   !
!                        T = - Q11 * Q31^(-1),                                      !
!                                                                                   ! 
! where the expressions of the matrices Q31 and Q11 follow from the extinction      !
! theorem and Huygens principle, respectively. The elements of the matrices Q31     !
! and Q11 are expressed as integrals over the particle surface. For axisymmetric    !
! particles, the T-matrix computation decouples over the azimuthal modes and the    !
! surface integrals reduce to line integrals over the generatrix. The integrals     !
! are evaluated by means of the Gauss-Legendre quadrature method, and note that for !
! particles with a plane of symmetry perpendicular to the axis of rotation (mirror  !
! symmetric particles), the integration can be performed along the half-generatrix  !
! curve. The numerical stability and accuracy of T-matrix computations for an       !
! nonsmooth generatrix can be enhanced by dividing the generatrix into piecewise    !
! smooth curves and applying separate quadrature formulas to each curve.            !
!                                                                                   !
! Localized or distributed sources can be used for T-matrix calculation and note    !
! that distributed sources are preferable for highly aspherical particles. For      !
! highly elongated particles, the sources are distributed along the axis of         !
! symmetry of the particle, while for highly flattened particles, the sources       !
! are distributed in the complex plane. 			                    !
!                                                                                   !
! Particle geometries currently supported include: spheroids, cylinders and         !
! rounded oblate cylinders. The following routines (from the file "GeomLib.f90")    !
! provide the required geometry parameters:                                         !
! - the routine "interpolation_listAXSYM" computes the integration nodes and        !
!   weights for an axisymmmetric surface,                                           !
! - the routine "elem_geomAXSYM" provides the geometry parameters (position vector, !
!   zenith and azimuthal angles, and normal unit vector in spherical coordinates)   !
!   at each integration node, and                                                   !
! - the routine "zDSAXSYM" generates the coordinates of the distributed sources.    !
! The user can easily modify these routines to generate particles with other        !
! geometries. Note that the list of parameters must be maintained and only          !
! geometries with an analytical description of the surface can be implemented.      !
! Alternatively, the option FileGeom  = .true., causes the code to read the         !
! particle geometry information from the file FileFEM. The file FileFEM is read     !
! by the routine "read_FileFEMAxsym" from the file "InputOutput.f90". The user can  !
! customize the routine "read_FileFEMAxsym" as needed to conform to the manner in   !
! which the particle geometry is stored in the file FileFEM. However, as supplied,  !
! the routine "read_FileFEMAxsym" expects the file FileFEM to have the following    !
! structure:                                                                        !
! - one line providing the number of smooth curves Nlines; the format for           !
!   reading Nlines is i7, i.e.,                                                     !
!                   read (iFEM, "(i7)", iostat = ios)  Nlines;                      ! 
! - a set of Nlines-sequences of data specifying the geometry parameters on each     !
!   smooth curve; each sequence includes:                                           !
!   - one line containing the number of curve elements (vertices) NVvr; the         !
!     format for reading NVvr is i7, i.e.,                                          !
!                   read (iFEM, "(i7)", iostat = ios) NVvr;                         !                                         
!   - NVvr lines containing the current index ielem, the Cartesian coordinates      !   
!     of the curve element center: x = r(1) and z = r(2), the Cartesian components  !
!     of the unit normal vector at the curve element center: nx = n(1) and          !
!     nz = n(2), and the area of the surface element; the format for reading the    !
!     data is:                                                                      !
!                   read (iFEM, "(i7,2x,5(e15.7,2x))", iostat = ios)                !
!                         ielem, r(1), r(2), n(1), n(2), area.                      !
! As provided, the file FileFEM is contained in the directory "GEOMFILES".          !
! If the particle geometry is read from file, the coordinates of the distributed    !
! sources (if used) must be supplied by the user.                                   ! 
!                                                                                   !
! 2. Convergence Test                                                               !
! -------------------                                                               !
! Convergence tests precede the scattering characteristics calculation. Three       !
! parameters control the T-matrix computation:                                      !
! - the number of integration points for computing integrals over the generatrix,   !
!   Nint,                                                                           !
! - the maximum expansion order Nrank, and                                          !
! - the maximum azimuthal order Mrank.                                              ! 
! Nint is the global number of integration points on the generatrix curve. As       ! 
! mentioned before, the generatrix of an nonsmooth surface is divided into Nparam   !
! piecewise smooth curves and the number of integration points on the curve j is    !
!                   Nint_curve(j) = int { c(j) * Nint },                            !
! where c(j) is a multiplicative factor and j = 1, 2,.., Nparam. The parameters     !
! c(j), j = 1, 2,..., Nparam, do not appear as explicit parameters; they are hard   !
! coded in the routine "interpolation_listAXSYM" from the file "GeomLib.f90".       !
! For example, the generatrix of a cylinder is divided into three straight lines.   !
! The first and third lines are perpendicular to the axis of symmetry, while the    ! 
! second line is parallel to the axis of symmetry. Denoting by a the                !
! half-length of the cylinder and by b the cylinder radius, we have:                !
!                                                                                   !
!     Nint_curve(first line) = Nint_curve(third line) = int {[b/2/(a+b)] * Nint}    !
!                                                                                   !
! and                                                                               !
!                                                                                   ! 
!     Nint_curve(second line) = Nint - 2 * int {[b/2/(a+b)] * Nint }.               !
!                                                                                   !
! For convergence tests, the incident wave is assumed to be a vector plane wave     !
! traveling along the Z-axis of the global coordinate system and the scattering     !
! characteristics are computed in the azimuthal plane phi = 0°. The convergence     !
! tests over Nint and Nrank are interactive, while the convergence test over Mrank  !
! is automatically performed.                                                       ! 
!                                                                                   !
! The convergence tests discussed in the literature are based on the analysis of    !
! the differential scattering cross section or extinction and scattering cross      !
! sections. The convergence test based on differential scattering cross section     !
! analysis is more conservative and is implemented in our code.                     !
!                                                                                   !
! For the integration and expansion order test an axisymmetric orientation of the   !
! particle is considered, i.e., the incident wave propagates along the axis of      !
! symmetry of the particle. In this case, all azimuthal modes are zero except       !
! for m = - 1 and m = 1. For the convergence test over Nint the scattering problem  !
! is solved for Nint and Nint + dNint, while for the convergence test over Nrank    !
! the scattering problem is solved for Nrank and Nrank - 1. The normalized          !
! differential scattering cross section (DSCS) will be checked at 20° increments    !
! for convergence within epsX (epsNint or epsNrank) tolerance. If the calculated    !
! results converge within this tolerance at 80% of the scattering angles, then      !
! convergence is achieved. At each calculation, the extinction and scattering       !
! cross sections Cext and Cscat are also computed. Although the convergence of Cext !
! and Cscat does not guarantee that the DSCS converges, the divergence of Cext and  !
! Cscat implies the divergence of the DSCS. The results of the convergence          !
! analysis are written to the file "/OUTPUTFILES/Output.dat". The above             !
! convergence tests (based on the analysis of the differential scattering cross     !
! section) have been proposed by Barber and Hill [P. W. Barber and S. C. Hill,      !
! Light scattering by particles: Computational Methods, World Scientific,           !
! Singapore, 1990].                                                                 ! 
!                                                                                   ! 
! After Nrank and Nint have been determined we pass to the azimuthal order test.    !
! The program automatically sets the particle to a more general orientation, i.e.,  !
! alpha = beta = 45°, and solves the scattering problem  for increasing m values    !
! until convergence of the angular scattering is achieved. The T matrix is stored   !
! for later use by other programs, and the values of Nrank and Mrank are printed to !
! the screen and to the T-matrix information file (see "Description.txt"). These    !
! values together with the T matrix serve as INPUT PARAMETERS for other programs.   ! 
!                                                                                   !
! 3. Estimates of Nint and Nrank                                                    !
! -------------------------------                                                   !
! The above convergence tests require estimates of Nint and Nrank. These            !
! estimates must be supplied by the user, and for this purpose, the automatic       !
! convergence procedure proposed by Mishchenko [M. I. Mishchenko, Light scattering  !
! by a size-shape distributions of randomly oriented axially symmetric particles    !
! of a size comparable to the wavelength, Applied Optics, 32, 4652-4666, 1993]      !
! or Wiscombe's truncation limit criterion [W. J. Wiscombe, Improved Mie            !
! scattering algorithms, Applied Optics, 19, 1505-1509, 1980] can be used.          !
!                                                                                   !
! The procedure developed by Mishchenko finds reliable a priori estimates of        !
! both Nint and Nrank by using only the zeroth order block matrices of the T        !
! matrix. The estimates are computed by checking the convergence of the quantities: !
!                                                                                   !
!        Ce = - (2Pi / k**2) Re {SUM (2n + 1) * [T11_0n0n + T22_0n0n] }             !
!                                                                                   !
! and                                                                               !
!                                                                                   !
!        Cs =   (2Pi / k**2) SUM (2n + 1) * [|T11_0n0n|**2 + |T22_0n0n|**2]         !
!                                                                                   ! 
! where T11_0n0n' and T22_0n0n' are the zeroth order block matrices of the T        !
! matrix. Note that for spherical particles, Ce and Cs are the extinction and       !
! scattering cross sections. An important numerical parameter of the convergence    !
! procedure is the multiplicity factor Ndgs,                                        !
!                                                                                   !
!                          Nint = Ndgs * Nrank,                                     !
!                                                                                   !
! which controls the number of integration points and must be optimized for each    !
! particle shape. The main steps of the convergence procedure are                   !
! 1. choose Ndgs;                                                                   !
! 2. compute a starting value of Nrank, as for instance                             !
!                                                                                   !
!                 NrankW = int(x + 4.05 * x**0.33),                                 !
!                                                                                   !
!    where x is the size parameter, x = k * Rcirc, and Rcirc is the radius of the   !
!    smallest circumscribing sphere;                                                !
! 3. solve the scattering problem for increasing Nrank-values (in unit steps) and   !
!    Nint = Ndgs * Nrank until the convergence criterion                            !
!                                                                                   !
!          max { [Cs(Nrank) - Cs(Nrank-1) ] / Cs(Nrank),                            !
!                [Ce(Nrank)  - Ce(Nrank-1)] / Ce(Nrank) } < delta                   !
!                                                                                   !
!    is satisfied, where delta is the desired accuracy;                             !
! 4. after Nrank has been determined, increase Nint in dNint steps until Cs(Nrank)  !
!    and Ce(Nrank) converge within delta.                                           !
!                                                                                   !
! If the convergence procedure is finished WE CAN PASS DIRECTLY TO THE AZIMUTHAL    !
! ORDER TEST. However, it is recommended to check at least the value of Nrank by    !
! using the convergence procedures based on the differential scattering cross       !
! section analysis. The convergence procedure proposed by Mishchenko can not be     !
! used for chiral particles, if the coordinates of the discrete sources are         !
! user-defined and if the particle geometry is read from file.                      !
!                                                                                   !
! A reasonable starting value of Nrank is given by Wiscombe's truncation limit      !
! criterion, i.e.,                                                                  !
!                                                                                   !    
!                NrankW = int(x + 4.05 * x**0.33 + 2),                              !
!                                                                                   !
! and note that the convergence procedure proposed by Mishchenko also uses NrankW   !
! as initial Nrank-value.                                                           !
!                                                                                   !
! The value of Nint depends on the type of discrete sources, the size parameter,    !
! the particle shape and the relative refractive index. For localized sources,      !
! size parameters smaller than 15.0, and particle aspect ratios ranging between     !
! 0.33 and 3.0, the recommended values are:                                         !
!                for spheroids:       Ndgs = (3...5), and                           !
!                for cylinders:       Ndgs = (4...7).                               !
! These values should be substantially increased as the size parameter increases,   !
! the particles become less aspherical or distributed sources are used.             !
! For spheroids with a size parameter smaller than 30.0, the following routine      !
! can be used to compute a conservative estimate of Nint:                           !
!                                                                                   !
! a = surf(1), length of the semi-axis along the axis of symmetry                   !
! b = surf(2), knight of the second semi-axis                                       !
! e = a / b                                                                         !
! xmax  = k * max(a,b)                                                              !
! Nrank = int(xmax + 4.05 * xmax**0.33 + 2.0)                                       !
! if (xmax <= 30.0) then                                                            !
!     if (e == 1.0) then                                                            !
!         Nint = 4 * Nrank                                                          !
!     else if (e < 1.0) then                                                        !
!         kb = k * b                                                                !
!         if (kb < 5.0) then                                                        !
!             Nint = 100                                                            !
!         else                                                                      !
!             Nint = 20 * int(kb)                                                   !
!         end if                                                                    !
!         if (e < 0.5) then                                                         !
!             dNr  = 25.0 + 10.0 * kb                                               !
!             Nint = Nint + int(dNr * (1.0 / e - 2.0))                              !
!         end if                                                                    ! 
!     else                                                                          !
!         ka = k * a                                                                !
!         if (ka < 10.0) then                                                       !
!             Nint = 40                                                             !
!         else                                                                      !
!             Nint = 4 * int(ka)                                                    !
!         end if                                                                    !
!         if (e > 2) then                                                           !
!             if (ka < 10.0) then                                                   !
!                 dNr = 30.0                                                        !
!             else                                                                  !
!                 dNr = 30.0 + 3.5 * (ka - 10.0)                                    !
!             end if                                                                !
!             Nint = Nint + int(dNr * (e - 2.0))                                    !
!         end if                                                                    !
!     end if                                                                        !
! end if                                                                            !
!                                                                                   !
! 4. Strategies for Performing Convergence Tests                                    !
! ----------------------------------------------                                    !
! Two strategies for performing convergence tests over Nint and Nrank are           !
! recommended. The following technique has been proposed by Barber and Hill:        !
! 1. choose a value of Nrank close to the value predicted by Wiscombe's truncation  !
!    limit criterion;                                                               !
! 2. for Nrank, perform the expansion order test with Nint = Ndgs * Nrank (in the   !
!    original code of Barber and Hill, Ndgs = 2);                                   !
! 3. if convergence is not achieved, set Nrank = Nrank + 1, maintain the relation   !
!    Nint = Ndgs * Nrank and go to Step 2;                                          !
! 4. if convergence is achieved, perform several integration tests with the         !
!    initial Nint-value, Nint = Ndgs * Nrank, until the DSCS converges.             !
!                                                                                   !
! For large and/or highly aspherical particles, T-matrix computations become        !
! poorly convergent or even divergent. Frequently, a semi-convergent behaviour is   !
! attended: the errors decrease with increasing the maximum expansion order,        !
! attain a relative constant level and afterwards increase. The region of           !
! stability can be localized by using the following technique:                      !
! 1. choose a value of Nrank smaller (or significantly smaller) than the value      !
!    predicted by Wiscombe's truncation limit criterion;                            !
! 2. for Nrank, perform several integration tests with the initial Nint-value,      !
!    Nint = Ndgs * Nrank, until the DSCS converges;                                 !
! 3. if convergence can not be achieved, set Nrank = Nrank - 1 or increase the      !
!    tolerance epsNint, and go to Step 2;                                           !
! 4. if convergence is achieved (for some Nint), perform several expansion order    !
!    tests for increasing Nrank-values and monitor the errors of the differential   !
!    scattering cross sections.                                                     !
!                                                                                   !
! For particles which are too extreme in size and/or aspect ratio, the errors of    !
! the extinction and scattering cross sections (instead of the differential         !
! scattering cross section) can be analyzed.                                        ! 
!                                                                                   !
! 5. Additional Comments                                                            !
! ----------------------                                                            !
! For the expansion order test and distributed sources, two configurations of       !
! sources (with Nrank and Nrank - 1 discrete sources) are considered. For both      !
! configurations, the coordinates of the distributed sources can be generated       !
! automatically or can be specified in the input file.                              !
!                                                                                   !
! The convergence tests over Nint and Nrank can be switched off by setting the      !
! logical variable DoConvTest to false. In this case, the values of Nint and        !
! Nrank must be specified in the input file.                                        !
!                                                                                   !
! The number of integration points has been determined for the azimuthal orders     !
! m = 1 and m = - 1. For higher azimuthal orders and sources distributed in the     !
! complex plane, the chosen value of Nint may lead to false convergence. Therefore, !
! the number of integration points should be increased at each azimuthal mode       !
! calculation. The integation step is dNintMrank. The parameter dNintMrank should   !
! be found experimentally by repeating the azimuthal order test for different       !
! input values until the differential scattering cross section converges.           !
! A conservative estimate is: dNintMrank = (0.1,...,0.2) * Nint.                    !
!                                                                                   !
! 6. Input Parameters                                                               !
! --------------------                                                              !
! The parameters specified in the input file "/INPUTFILES/InputAXSYM.dat" are       !
! listed below.                                                                     !
!                                                                                   !
! - wavelength (real) - wavelength of the incident light in vacuo.                  !
!                                                                                   !
! - ind_refMed (real) - refractive index of the ambient medium (nonabsorbing        !
!   dielectric medium).                                                             !
!                                                                                   !
! - ind_refRel (complex) - relative refractive index of the particle with respect   !
!   to the ambient medium. The imaginary part of the relative refractive index      !
!   must be zero for nonabsorbing particles and positive for absorbing particles.   !
!                                                                                   !
! - perfectcond (logical) - if perfectcond = t, the particle is perfectly           !
!   conducting.                                                                     !
!                                                                                   !
! - chiral (logical) - if chiral = t, the particle is optical active (chiral).      !
!                                                                                   !
!   The permissive values of the logical variables perfectcond and chiral are       !
!   given below.                                                                    !
!                                                                                   !
!       particle              perfectcond            chiral                         !
!      dielectric                  f                   f                            !
!   perfectly conducting           t                   f                            !
!        chiral                    f                   t                            !
!                                                                                   !
! - kb (real) - parameter of chirality. This parameter is used for chiral           !
!   particles and is ignored for dielectric and perfectly conducting particles.     !
!   The wave numbers for the left- and right-handed circularly polarized waves      !
!   are given by:                                                                   !
!               kil = ki / (1.0 - kb)  and   kir = ki / (1.0 + kb)                  !
!   where ki is the wave number in the chiral medium.                               !
!                                                                                   !
! - FileGeom (logical) - if FileGeom = t, the particle geometry is supplied by the  !
!   input file FileFEM,                                                             ! 
!                                                                                   !
! - FileFEM (character(80)) - name of the file containing the particle geometry.    !
!                                                                                   !
! - TypeGeom (integer) - parameter specifying the type of the particle geometry.    !
!                                                                                   !
! - Nsurf (integer) - number of surface parameters.                                 !
!                                                                                   !
! - surf (real array: surf(1), surf(2),...,surf(Nsurf)) - surface parameters        !
!   specifying the shape of the particle. The dimension of the array surf is        !
!   NsurfPD. The integer parameter NsurfPD is specified in the routine              !
!   "Parameters.f90" and has the value NsurfPD = 10. If Nsurf > NsurfPD, the        !
!   execution is automatically terminated.                                          !
!                                                                                   !
! - Nparam (integer) - number of smooth curves forming the generatrix curve.        !
!                                                                                   !
!   The permissive values of the surface parameters (for the supported geometries)  !
!   are summarized below.                                                           !
!                                                                                   !
!   Particle      TypeGeom   Nsurf   Nparam                surf                     !
!   spheroid         1         2       1         surf(1) - length of the semi-      !
!                                                          axis along the           !
!                                                          axis of symmetry         !
!                                                surf(2) - length of the second     !
!                                                          semi-axis                !
!                                                                                   !
!   cylinder         2         2       3         surf(1) - half-length of           !
!                                                          the cylinder             !
!                                                surf(2) - cylinder radius          !
!                                                                                   !
!   rounded          3         2       3         surf(1) - half-length of           !
!    oblate                                                the cylinder             !
!   cylinder                                     surf(2) - cylinder radius          ! 
!                                                          including the rounded    !
!                                                          part                     !
!                                                                                   !
! - anorm (real) - characteristic length of the particle which is used to           !
!   normalize the differential scattering cross sections.                           !
!                                                                                   !
! - Rcirc (real) - characteristic length of the particle (usually the radius of     !
!   the smallest circumscribing sphere) which is used to compute an estimate of the !
!   maximum expansion order by using Wiscombe's truncation limit criterion (the     !
!   size parameter is x = k * Rcirc, where k is the wave number in the ambient      !
!   medium). Alternatively, Rcirc can be chosen as the equal-volume sphere radius   !
!   or the surface-equivalent-sphere radius. This parameter is used if the          !
!   interactive convergence tests over Nint and Nrank are performed                 !
!  (DoConvTest = t). Otherwise, Rcirc is ignored.                                   !
!                                                                                   !
! - miror (logical) - if miror = t, the particle is mirror symmetric (the plane of  !
!   symmetry or the plane of reflection is perpendicular to the axis of rotation).  !
!                                                                                   ! 
! NOTE: FOR CHIRAL PARTICLES AND DISTRIBUTED SOURCES SET miror = f.                 ! 
!                                                                                   !
! - DoConvTest (logical) - if DoConvTest = t, the interactive convergence tests     !
!   over Nint and Nrank are invoked. Estimates of Nint and Nrank can be obtained    !
!   by using Mishchenko's convergence procedure. Alternatively, an estimate of      !
!   Nrank is given by Wiscombe's truncation limit criterion.                        !
!                                                                                   !
! - MishConvTest (logical) - if MishConvTest = t, estimates of Nint and Nrank are   !
!   computed with the convergence procedure proposed by Mishchenko. The code        !
!   prompts for the integer parameter Ndgs which controls the initial value of the  !
!   number of integration points. Some orientative values of Ndgs are printed and   !
!   the user can enter his option. This convergence test can be performed if:       !
!   - localized sources are used, the interactive convergence tests are performed,  !
!     the particle is not optical active, and the particle geometry is not read from!
!     file (DS = f and DoConvTest = t and chiral = f and FileGeom = f), or          !
!   - distributed sources are used, the coordinates of the distributed sources are  !
!     not user-defined, the interactive convergence tests are performed, the        !
!     particle is not optical active, and the particle geometry is not read from    ! 
!     file (DS = t and autGenDS = t and DoConvTest = t and chiral = f and           !
!     FileGeom = f).                                                                !
!                                                                                   !
! NOTE: IF THE PARTICLE IS OPTICAL ACTIVE (chiral = t) OR THE PARTICLE GEOMETRY IS  !
! SUPPLIED BY THE FILE FileFEM (FileGeom = t), THE CODE SETS MishConvTest = f.      !
!                                                                                   !
! - DS (logical) - if DS = t, distributed sources are used for T-matrix             !
!   calculation, otherwise localized sources are employed.                          !
!                                                                                   !
! - autGenDS (logical) - if autGenDS = t, the routine "zDSAXSYM" generates the      !
!   coordinates of the distributed sources. Otherwise, the coordinates of the       !
!   distributed sources must be provided by the user. If DS = f, the logical        !
!   variable autGenDS is ignored. If the particle geometry is read from file        !  
!   (FileGeom = t), the coordinates of the distributed sources are user-defined,    !
!   and the code sets autgenDS = f.                                                 !
!                                                                                   !
! - ComplexPlane (logical) - if ComplexPlane = t, the distributed sources are       !
!   situated in the complex plane. This parameter is used if distributed sources    !
!   are required and the coordinates of the distributed sources are automatically   !
!   generated (DS = t and autGenDS = t).                                            !
!                                                                                   !
! - epsZReIm (real) - input parameter of the routine "zDSAXSYM" which controls      !
!   the distribution of the discrete sources. This parameter is used if distributed !
!   sources are required and the coordinates of the distributed sources are         !
!   automatically generated (DS = t and autGenDS = t).                              !
!                                                                                   !
! - Nint (integer) - number of integration points in computing integrals over       !
!   the generatrix curve. This parameter is used (for localized and distributed     !
!   sources) if the convergence tests are not performed and the particle geometry   !
!   is not supplied by the file FileFEM. More specifically, Nint is used if         !
!   - (DS = f and DoConvTest = f and FileGeom = f) or,                              !
!   - (DS = t and autGenDS = t and DoConvTest = f) or,                              !
!   - (DS = t and autGenDS = f and DoConvTest = f and FileGeom = f).                !
!                                                                                   !
! - Nrank (integer) - maximum expansion order. This parameter is used (for localized!
!   and distributed sources) if the convergence tests are not performed, or the     !
!   coordinates of the distributed sources are user-defined. More specifically,     !
!   Nrank is used if                                                                !
!   - (DS = f and DoConvTest = f), or                                               !
!   - (DS = t and autGenDS = t and DoConvTest = f), or                              !
!   - (DS = t and autGenDS = f and DoConvTest = t), or                              !
!   - (DS = t and autGenDS = f and DoConvTest = f).                                 !
!                                                                                   !
! NOTE: IN ORDER TO SIMPLIFY THE ROUTINE FOR READING THE DATA, THE VARIABLES Nint   !
! AND Nrank MUST BE PROVIDED (IN THE INPUT FILE "InptAXSYM.dat") IF                 !
! ((DoConvTest = f) OR (DS = t AND autgenDS = f)). BECAUSE THE SIGNIFICANCE OF      !
! THESE PARAMETERS IS AS ABOVE, THE MAIN PROGRAM WILL IGNORE THE IRRELEVANT DATA    !
! INFORMATIONS.                                                                     !
!                                                                                   !
! - zRe, zIm (real arrays: zX(1), zX(2),...,zX(Nrank), X = Re, Im) - coordinates    !
!   of the distributed sources for the expansion order Nrank. These parameters      !
!   are used if the coordinates of the distributed sources are user-defined         !
!   (DS = t and autGenDS = f). The dimension of the arrays zRe and zIm is NrankPD   !
!   and the inequality Nrank <= NrankPD must hold. The integer parameter NrankPD is !
!   specified in the routine "Parameters.f90" and has the value NrankPD = 200. If   !
!   Nrank > NrankPD, the execution is automatically terminated.                     !
!                                                                                   !
! - zRe1, zIm1 (real arrays: zX1(1), zX1(2),...,zX1(Nrank-1), X = Re, Im) -         !
!   coordinates of the distributed sources for the expansion order Nrank - 1.       !
!   These parameters are used if the coordinates of the distributed sources are     !
!   user-defined and the expansion order test is performed (DS = t and autGenDS = f !
!   and TypeConvTest = 2). As before, the dimension of the arrays zRe1 and zIm1     !
!   is NrankPD.                                                                     !
!                                                                                   !
! NOTE: IN ORDER TO SIMPLIFY THE ROUTINE FOR READING THE DATA, THE REAL ARRAYS      !
! zRe, zIm AND zRe1, zIm1 MUST BE SPECIFIED (IN THE INPUT FILE "InptAXSYM.dat") IF  !
! (DS = t AND autGenDS = f). FURTHER NOTE THAT THE INPUT ARRAYS MUST BE SEPARATED   !
! BY A BLANK LINE, AND THAT THE INPUT ARRAYS zRe1 AND zIm1 MUST BE SPECIFIED AS     !
! VECTORS WITH Nrank - 1 COMPONENTS.                                                !
!                                                                                   !
! - epsNint (real) - error tolerance for the integration test.                      !
!                                                                                   !
! - epsNrank (real) - error tolerance for the expansion order test.                 !
!                                                                                   !
! - epsMrank (real) - error tolerance for the azimuthal order test.                 !
!                                                                                   !
! - dNint (integer) - number of division points for the integration test and        !
!   Mishchenko's convergence procedure. Note that the scattering problem is solved  !
!   for Nint and Nint + dNint.                                                      ! 
!                                                                                   !
! - dNintMrank (integer) - number of division points for azimuthal mode             !
!   calculation. This parameter is used if the distributed sources are situated     !
!   in the complex plane (DS = t and ComplexPlane = t). At each azimuthal mode      !
!   calculation, the number of integration points increases with dNintMrank.        !
!                                                                                   !
! - FileTmat (character(80)) - name of the file to which the T matrix is written.   !
!                                                                                   !
! - PrnProgress (logical) - if PrnProgress = t, the progress of calculation         !
!   is printed.                                                                     !
!                                                                                   !
! Note that all input parameters specifying lengths must be provided in the same    !
! units of lengths.                                                                 !
!                                                                                   !
! 7. Logical Scheme                                                                 !
! ------------------                                                                !  
! The organization of the code is as follows:                                       !
! 1.  < read input data >                                                           !
! 2.  < T-matrix calculation >                                                      !
!                                                                                   !
!    if ( read geometry from file ) then                                            !
!       < do not use Mishchenko's convergence procedure >                           !
!       < do not use automatic sources generation >                                 !
!    end if                                                                         !
!    if ( chiral particle ) then                                                    !
!       < do not use Mishchenko's convergence procedure >                           !
!    end if                                                                         !
!    if ( use localized sources ) then                                              !
!                                                                                   !
!       if ( do convergence test) then                                              !
!          if ( use Mishchenko's convergence procedure ) then                       !
!             < the code prompts for the integer parameter Ndgs and computes        !
!               the estimated values of Nint and Nrank by using Mishchenko's        !
!               convergence procedure >                                             !
!          else                                                                     !
!             < the code computes an estimate of Nrank by using                     !
!               Wiscombe's truncation criterion >                                   !
!          end if                                                                   !  
!          if ( .not. read geometry from file) then                                 !
!            < the code prompts for the estimated values of Nint and Nrank >        !
!            < the code prompts for the type of convergence test:                   !
!              1 - over Nint, 2 - over Nrank or 3 - over Mrank >                    !
!          else                                                                     !
!            < the code prompts for the estimated value of Nrank >                  !
!            < the code prompts for the type of convergence test:                   !
!              2 - over Nrank or 3 - over Mrank >                                   !           
!          end if                                                                   !
!       else if ( .not. do convergence test) then                                   !
!          if ( .not. read geometry from file) then                                 !
!             < the input file provides the values of Nint and Nrank >              !
!          else                                                                     ! 
!             < the input file provides the value of Nrank >                        !
!          end if                                                                   !
!          type of convergence test = 3 (convergence test over Mrank)               !
!       end if                                                                      !
!                                                                                   !
!    else if ( use distributed sources ) then                                       !
!                                                                                   !
!       if ( use automatic sources generation ) then                                !
!          if ( do convergence test) then                                           !
!             if ( use Mishchenko's convergence procedure ) then                    !
!                < the code prompts for the integer parameter Ndgs and computes     !
!                  the estimated values of Nint and Nrank by using Mishchenko's     !
!                  convergence procedure >                                          ! 
!             else                                                                  !
!                < the code computes an estimate of Nrank by using                  !
!                  Wiscombe's truncation criterion >                                !
!             end if                                                                !
!             < the code prompts for the estimated values of Nint and Nrank >       !
!             < the code generates the coordinates of the distributed sources       !
!               zRe and zIm corresponding to Nrank >                                !
!             < the code prompts for the type of convergence test:                  !
!               1 - over Nint, 2 - over Nrank or 3 - over Mrank >                   !
!             if ( do maximum expansion order test ) then                           !
!                < the code generate the coordinates of the distributed sources     !
!                  zRe1 and zIm1 corresponding to Nrank - 1 >                       !
!             end if                                                                !
!          else if ( .not. do convergence test) then                                !
!             < the input file provides the values of Nint and Nrank >              !
!             < the code generate the coordinates of the distributed sources        !
!               zRe and zIm corresponding to Nrank >                                !
!             type of convergence test = 3 (convergence test over Mrank)            ! 
!          end if                                                                   !
!       else if ( .not. use automatic sources generation ) then                     !
!          if ( do convergence test) then                                           !
!             < the input file provides the value of Nrank >                        !
!             < the input file provides the coordinates of the distributed sources  !
!               zRe and zIm corresponding to Nrank >                                !
!             if ( .not. read geometry from file ) then                             !
!                < the code prompts for the estimated value of Nint >               !
!                < the code prompts for the type of convergence test:               !
!                  1 - over Nint, 2 - over Nrank or 3 - over Mrank >                !
!             else                                                                  !
!                < the code prompts for the type of convergence test:               !
!                  2 - over Nrank or 3 - over Mrank >                               !
!             end if                                                                !
!             if ( do expansion order test ) then                                   !
!                < the input file provides the coordinates of the distributed       !
!                  sources zRe1 and zIm1 corresponding to Nrank - 1 >               !
!             end if                                                                !
!          else if ( .not. do convergence test) then                                !
!             if ( .not. read geometry from file ) then                             !
!                < the input file provides the values of Nint and Nrank >           !
!             else                                                                  !
!                < the input file provides the value of Nrank >                     !
!             end if                                                                ! 
!             < the input file provides the coordinates of the distributed sources  !
!               zRe and zIm corresponding to Nrank >                                !
!             type of convergence test = 3 (convergence test over Mrank)            !
!          end if                                                                   !
!       end if                                                                      !
!                                                                                   !
!    end if                                                                         !
!    if ( do integration test, i.e., type of convergence test = 1 ) then            !
!       < the code computes the DSCS for Nint and Nint + dNint and                  !
!         write the results to the file "Output.dat" >                              !
!       < the execution is terminated >                                             !
!    end if                                                                         !
!    if ( do expansion order test, i.e., type of convergence test = 2 ) then        !
!       < the code computes the DSCS for Nrank and Nrank - 1 and                    !
!         write the results to the file "Output.dat" >                              !
!       < the execution is terminated >                                             !
!    end if                                                                         !
!    if ( do azimuthal order test, i.e., type of convergence test = 3 ) then        !
!       < the code computes the DSCS for increasing m values and                    !
!         write the results to the file "Output.dat" >                              !
!       < the T matrix is stored in the file FileTmat and the T-matrix information  !
!         file is created >                                                         !
!       < Mrank and Nrank are printed to the screen and to the T-matrix             !
!         information file >                                                        !
!       < go to Step 3 >                                                            !
!    end if                                                                         !
! 3. < scattering characteristics calculation >                                     !
!------------------------------------------------------------------------------------
  use parameters  
  implicit none 
  integer       :: TypeGeom, Nsurf, Nparam, TypeConvTest, dNint, Nrank, Nint,       &
                   Nrank1, dNintMrank, Ndgs, NrankMax, NrankW, Nface                     
  real(O)       :: k, ind_refMed, wavelength, anorm, surf(NsurfPD), snorm,          &
                   kb, epsNint, epsNrank, epsMrank, zRe(NrankPD), zIm(NrankPD),     &
                   zRe1(NrankPD), zIm1(NrankPD), Rcirc, x, delta, Cscat1, Cext1,    &
                   epsZReIm, rp(2,NfacePD), np(2,NfacePD), area(NfacePD)                          
  complex(O)    :: ind_refRel
  logical       :: FileGeom, miror, perfectcond, DoConvTest, DS, chiral, autGenDS,  &
                   ComplexPlane, MishConvTest, PrnProgress
  character(80) :: FileTmat, FileFEM
! -----------------------------------------------------------------------------------
!                               Read the input file                                 ! 
! -----------------------------------------------------------------------------------       
  call readinputAXSYM ( wavelength, ind_refMed, ind_refRel, perfectcond,            &
       chiral, kb, FileGeom, TypeGeom, FileFEM, Nsurf, surf, Nparam, anorm,         &
       Rcirc, miror, DoConvTest, MishConvTest, DS, autGenDS, ComplexPlane,          &
       epsZReIm, Nint, Nrank, zRe, zIm, zRe1, zIm1, epsNint, epsNrank, epsMrank,    &
       dNint, dNintMrank, FileTmat, PrnProgress, k, snorm, Nface, rp, np, area )                   
! -----------------------------------------------------------------------------------
!         Select the type of convergence test and the values of Nint and Nrank      !
! -----------------------------------------------------------------------------------
  x = k * Rcirc
  NrankW = int(x + 4.05_O * x**0.33_O + 2._O)
  if (.not. DS) then
    if (DoConvTest) then                      
      if (MishConvTest) then                         
        print "(/,2x, a)",                                                          &
       'Estimates of Nint and Nrank Using Mishchenko''s Convergence Procedure' 
        print "(  2x, a)",                                                          &
       '---------------------------------------------------------------------'                                         
        call estimateNrankMishchenko (TypeGeom, k, ind_refRel, Nsurf, surf,         &
             zRe, zIm, Nparam, miror, perfectcond, DS, ComplexPlane,                &
             epsZReIm, x, delta, Ndgs, Nint, Nrank, NrankMax, Cscat1, Cext1)
        call estimateNintMishchenko (TypeGeom, k, ind_refRel, Nsurf, surf,          &
             zRe, zIm, Nparam, miror, perfectcond, DS, x, delta, Ndgs, Nint,        &
             dNint, Nrank, NrankMax, Cscat1, Cext1)
        print "(/,2x,'Convergence Test for an Axisymmetric Particle')"
        print "(  2x,'---------------------------------------------')"	       
        print "(/,2x,'- enter the estimated values of Nint and Nrank;')"            
        call read_integer2 (Nint, Nrank)                                
      else 
        print "(/,2x,'Convergence Test for an Axisymmetric Particle')"
        print "(  2x,'---------------------------------------------')"             
        print "(/,2x,'Nrank estimate:')"                                                            
        print "(  2x, a, i3, a)",                                                   &  
       'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'
        if (.not. FileGeom) then
          print "(/,2x, a)",                                                        &
         '- enter the estimated values of Nint and Nrank, where Nint = Ndgs * Nrank'
          print "(  2x,'  and Ndgs = 3,4,...;')"
          call read_integer2 (Nint, Nrank)                                                                      
        else
          print "(/,2x,'- enter the estimated value of Nrank;')"              
          call read_integer (Nrank)     
        end if  
      end if
      if (.not. FileGeom) then        
        print "(/,2x, a)",                                                          &
       '- enter the type of convergence test: 1 - Nint, 2 - Nrank, 3 - Mrank;' 
        call read_integerbound (TypeConvTest, 1, 3)
      else
        print "(/,2x,'- enter the type of convergence test: 2 - Nrank, 3 - Mrank;')"
        call read_integerbound (TypeConvTest, 2, 3)
      end if
    else
      print "(/,2x,'Convergence Test for an Axisymmetric Particle over Mrank')" 
      print "(  2x,'--------------------------------------------------------')"
      print "(/,2x,'Input values:')"
      if (.not. FileGeom) then
        print "(  2x, a, i4, a, i4, a)",                                            & 
       'the input values of Nint and Nrank are ', Nint, ' and ', Nrank,             &
       ', respectively,'  
        print "(  2x, a, i3, a)",                                                   &
       'while the estimated value of Nrank from Wiscombe''s criterion is ', NrankW,';'
      else
        print "(  2x,'the input value of Nrank is ', i4,', while')", Nrank
        print "(  2x, a, i3, a)",                                                   &
       'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';' 
      end if                                                                          
      TypeConvTest = 3      
    end if
    Nrank1 = Nrank - 1 ! redundant            
  else
    if (autGenDS) then
      if (DoConvTest) then                        
        if (MishConvTest) then           
          print "(/,2x, a)",                                                        &
         'Estimates of Nint and Nrank Using Mishchenko''s Convergence Procedure'
          print "(  2x, a)",                                                        &
         '---------------------------------------------------------------------'	  	 	 	                    
          call estimateNrankMishchenko (TypeGeom, k, ind_refRel, Nsurf, surf,       &
               zRe, zIm, Nparam, miror, perfectcond, DS, ComplexPlane,              &
               epsZReIm, x, delta, Ndgs, Nint, Nrank, NrankMax, Cscat1, Cext1)
          call estimateNintMishchenko (TypeGeom, k, ind_refRel, Nsurf, surf,        &
               zRe, zIm, Nparam, miror, perfectcond, DS, x, delta, Ndgs, Nint,      &
               dNint, Nrank, NrankMax, Cscat1, Cext1)   
          print "(/,2x,'Convergence Test for an Axisymmetric Particle')"
          print "(  2x,'---------------------------------------------')"	       
          print "(/,2x,'- enter the estimated values of Nint and Nrank;')"           
          call read_integer2 (Nint, Nrank)                               
        else
          print "(/,2x,'Convergence Test for an Axisymmetric Particle')"
          print "(  2x,'---------------------------------------------')"	
          print "(/,2x,'Nrank estimate:')"                                                                
          print "(  2x, a, i3, a)",                                                 &
         'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'
          print "(/,2x, a)",                                                        &
         '- enter the estimated values of Nint and Nrank, where Nint = Ndgs * Nrank'
          print "(  2x,'  and Ndgs = 5,6,...;')"
          call read_integer2 (Nint, Nrank)                                                                                 
        end if      
        call check_MaxNrank (Nrank)             
        call zDSAXSYM (TypeGeom, Nsurf, surf, Nrank, ComplexPlane, epsZReIm, zRe, zIm)     
        print "(/,2x, a)",                                                          &
       '- enter the type of convergence test: 1 - Nint, 2 - Nrank, 3 - Mrank;'
        call read_integerbound (TypeConvTest, 1, 3)
        if (TypeConvTest == 2) then
          Nrank1 = Nrank - 1
          call zDSAXSYM (TypeGeom, Nsurf, surf, Nrank1, ComplexPlane, epsZReIm,     &
               zRe1, zIm1)         
        end if
      else
        print "(/,2x,'Convergence Test for an Axisymmetric Particle over Mrank')" 
        print "(  2x,'--------------------------------------------------------')"
        print "(/,2x,'Input values:')"
        print "(  2x, a, i4, a, i4, a)",                                            &
       'the input values of Nint and Nrank are ', Nint, ' and ', Nrank,             &
       ', respectively,' 
        print "(  2x, a, i3, a)",                                                   &
       'while the estimated value of Nrank from Wiscombe''s criterion is ', NrankW,';'         
        call check_MaxNrank (Nrank)
        call zDSAXSYM (TypeGeom, Nsurf, surf, Nrank, ComplexPlane, epsZReIm, zRe, zIm) 
        TypeConvTest = 3    
      end if
      Nrank1 = Nrank - 1 ! redundant  
    else 
      if (DoConvTest) then      
        print "(/,2x,'Convergence Test for an Axisymmetric Particle')"
        print "(  2x,'---------------------------------------------')"
        print "(/,2x,'Input values:')"
        print "(  2x,'the input value of Nrank is ', i4,', while')", Nrank
        print "(  2x, a, i3, a)",                                                   &
       'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'
        if (.not. FileGeom) then                                            
          print "(/,2x, a)",                                                        &
         '- enter the estimated value of Nint, where Nint = Ndgs * Nrank'
          print "(  2x,'  and Ndgs = 5,6,...;')"
          call read_integer (Nint) 
          print "(/,2x, a)",                                                        &
         '- enter the type of convergence test: 1 - Nint, 2 - Nrank, 3 - Mrank;'
          call read_integerbound (TypeConvTest, 1, 3)
        else
          print "(/,2x,'- enter the type of convergence test: 2 - Nrank, 3 - Mrank;')"
          call read_integerbound (TypeConvTest, 2, 3)
        end if
        if (TypeConvTest == 2) Nrank1 = Nrank - 1
      else
        print "(/,2x,'Convergence Test for an Axisymmetric Particle over Mrank')" 
        print "(  2x,'--------------------------------------------------------')" 
        print "(/,2x,'Input values:')" 
        if (.not. FileGeom) then                  
          print "(  2x, a, i4, a, i4, a)",                                          &
         'the input values of Nint and Nrank are ', Nint, ' and ', Nrank,           &
         ', respectively,' 
          print "(  2x, a, i3, a)",                                                 &
         'while the estimated value of Nrank from Wiscombe''s criterion is ',       &
          NrankW,';' 
        else
          print "(  2x,'the input value of Nrank is ', i4,', while')", Nrank
          print "(  2x, a, i3, a)",                                                 &
         'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';' 
        end if
        TypeConvTest = 3              
      end if
      Nrank1 = Nrank - 1 ! redundant          
    end if
  end if                                                                            
! -----------------------------------------------------------------------------------
!                               Convergence test                                    !
! -----------------------------------------------------------------------------------
  open (unit = iOutput, file = FileOutput, status = "replace") 
  call printinputAXSYM (TypeConvTest, FileGeom, TypeGeom, FileFEM, Nsurf, Nparam,   &
       Nrank, Nrank1, dNint, dNintMrank, ind_refMed, wavelength, anorm, Rcirc,      &
       surf, kb, epsNint, epsNrank, epsMrank, zRe, zIm, zRe1, zIm1, ind_refRel,     &
       miror, perfectcond, DS, chiral, autGenDS)                     
  if (DoConvTest) then              
    if (TypeConvTest == 1) then
      if (.not. DS) then                  
        call convergence_NintAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,       &
             Nsurf, surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint,       &
             dNint, miror, perfectcond, DS, chiral, kb, epsNint, PrnProgress)
      else 
        call convergence_NintDSAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,     &
             Nsurf, surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint,       &
             dNint, miror, perfectcond, DS, chiral, kb, epsNint, PrnProgress)
      end if
    else if (TypeConvTest == 2) then
      if (.not. DS) then        
        call convergence_NrankAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,      &
             Nsurf, surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint,       &
             miror, perfectcond, DS, chiral, kb, epsNrank, PrnProgress)
      else      
        call convergence_NrankDSAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,    &
             Nsurf, surf, rp, np, area, Nface, zRe, zIm, zRe1, zIm1, Nparam, Nrank, &
             Nrank1, Nint, miror, perfectcond, DS, chiral, kb, epsNrank,            &
             PrnProgress)
      end if
    else 
      if (.not. DS) then    
        call convergence_MrankAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,      &
             Nsurf, surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint,       &
             miror, perfectcond, DS, chiral, kb, epsMrank, FileTmat, PrnProgress)
      else 
        call convergence_MrankDSAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,    &
             Nsurf, surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint,       &
             miror, perfectcond, DS, chiral, kb, epsMrank, dNintMrank, FileTmat,    &
             PrnProgress)
      end if
    end if  
  else      
    if (.not. DS) then    
      call convergence_MrankAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm, Nsurf, &
           surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, miror,         &
           perfectcond, DS, chiral, kb, epsMrank, FileTmat, PrnProgress)
    else          
      call convergence_MrankDSAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,      &
           Nsurf, surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, miror,  &
           perfectcond, DS, chiral, kb, epsMrank, dNintMrank, FileTmat, PrnProgress)
    end if  
  end if 
  close (unit = iOutput)
end subroutine TAXSYM
!************************************************************************************
subroutine readinputAXSYM ( wavelength, ind_refMed, ind_refRel, perfectcond,        &
           chiral, kb, FileGeom, TypeGeom, FileFEM, Nsurf, surf, Nparam, anorm,     &
           Rcirc, miror, DoConvTest, MishConvTest, DS, autGenDS, ComplexPlane,      &
           epsZReIm, Nint, Nrank, zRe, zIm, zRe1, zIm1, epsNint, epsNrank,          &
           epsMrank, dNint, dNintMrank, FileTmat, PrnProgress, k, snorm, Nface,     &
           rp, np, area )
  use parameters
  use derived_parameters
  implicit none 
  integer       :: TypeGeom, Nsurf, Nparam, dNint, Nrank, Nint, i, dNintMrank, ios, &
                   Nface, j                     
  real(O)       :: k, ind_refMed, wavelength, anorm, surf(NsurfPD), xpart, snorm,   &
                   kb, epsNint, epsNrank, epsMrank, zRe(NrankPD), zIm(NrankPD),     &
                   zRe1(NrankPD), zIm1(NrankPD), Rcirc, epsZReIm, rp(2,NfacePD),    &
                   np(2,NfacePD), area(NfacePD), dp                          
  complex(O)    :: ind_refRel
  logical       :: FileGeom, miror, perfectcond, DoConvTest, DS, chiral, autGenDS,  &
                   ComplexPlane, InputDS, MishConvTest, PrnProgress, XFindPar
  character(80) :: FileTmat, FileFEM, string       
! -----------------------------------------------------------------------------------
!                        Read the input file FileInputAXSYM                         ! 
! -----------------------------------------------------------------------------------    
  call DrvParameters  
  open (unit = iInputAXSYM, file = FileInputAXSYM, status = "old",                  &
        position = "rewind")   
  wavelength = 0.1_O * 2._O * Pi  
  ind_refMed = 1._O                                                                 
  ind_refRel = (1.5_O,0._O) 
  string     = 'OptProp'    
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) wavelength
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) ind_refMed
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refMed;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) ind_refRel
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refRel;')"
      stop
    end if      
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if
  call check_ind_ref (ind_refRel)
  k = 2._O * Pi * ind_refMed / wavelength 
!
  perfectcond = .false.  
  chiral = .false.
  kb     = 0._O  
  string = 'MatProp'
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) perfectcond
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable perfectcond;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) chiral
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable chiral;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) kb
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable kb;')"
      stop
    end if      
  else
    print "(/,2x,'Group name MatProp not found;')"
    stop  
  end if      
  call check_MatPropAXSYM (perfectcond, chiral, kb)   
  if (chiral) call check_chirality (kb)
!
  FileGeom = .false.
  FileFEM  = ' '  
  TypeGeom = 1  
  Nsurf    = 2
  do i = 1, NsurfPD
    surf(i)= 1._O
  end do
  Nparam = 1
  anorm  = 1._O
  Rcirc  = 1._O 
  miror  = .false.
  string = 'GeomProp'
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) FileGeom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileGeom;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) FileFEM
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileFEM;')"
      stop
    end if       
    read (iInputAXSYM, *, iostat = ios) TypeGeom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable TypeGeom;')"
      stop
    end if       
    read (iInputAXSYM, *, iostat = ios) Nsurf
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nsurf;')"
      stop
    end if
    if (Nsurf > NsurfPD) then
      print "(/,2x,'Input error: Nsurf exceeds NsurfPD;')"                                    
      stop
    end if            
    do i = 1, Nsurf
      read (iInputAXSYM, *, iostat = ios) surf(i)
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable surf;')"
        stop
      end if
    end do    
    read (iInputAXSYM, *, iostat = ios) Nparam
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nparam;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) anorm
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anorm;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) Rcirc
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Rcirc;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) miror
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable miror;')"
      stop
    end if                                                
  else
    print "(/,2x,'Group name GeomProp not found;')"
    stop  
  end if                          
  call check_geomAXSYM (TypeGeom, Nsurf, Nparam)
  call check_geomAXSYMOblate (TypeGeom, Nsurf, surf)  
  call check_anorm (anorm)
  xpart = k * anorm
  snorm = Pi * xpart * xpart 
  Nface = 1
  do i = 1, NfacePD
    do j = 1, 2
      rp(j,i) = 0._O
      np(j,i) = 0._O
    end do
    area(i) = 0._O
  end do   
  if (FileGeom) then    
    call read_FileFEMAxsym (FileFEM, Nface, rp, np, area)     
    Rcirc = 0._O    
    do i = 1, Nface
      dp = sqrt(rp(1,i)**2 + rp(2,i)**2)
      if (dp > Rcirc) Rcirc = dp
    end do    
  end if          
!
  DoConvTest   = .true.
  MishConvTest = .true.
  string       = 'ConvTest'
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) DoConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DoConvTest;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) MishConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable MishConvTest;')"
      stop
    end if         
  else
    print "(/,2x,'Group name ConvTest not found;')"
    stop  
  end if   
  if (chiral)   MishConvTest = .false.     
  if (FileGeom) MishConvTest = .false.  
!
  DS = .false.
  autGenDS = .true.
  string   = 'Sources'
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) DS
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DS;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) autGenDS
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable autGenDS;')"
      stop
    end if         
  else
    print "(/,2x,'Group name Sources not found;')"
    stop  
  end if          
  call check_inputAXSYM (miror, chiral, DS)
  if (FileGeom) autGenDS = .false.  
  InputDS = .false.
  if (DS .and. .not. autGenDS) InputDS = .true. 
!
  ComplexPlane = .false.
  epsZReIm = 0.95_O 
  if (DS .and. autGenDS) then
    string = 'SourcePosAut'
    if (XFindPar (iInputAXSYM, string)) then
      read (iInputAXSYM, *, iostat = ios) ComplexPlane
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable ComplexPlane;')"
        stop
      end if
      read (iInputAXSYM, *, iostat = ios) epsZReIm
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable epsZReIm;')"
        stop
      end if         
    else
      print "(/,2x,'Group name SourcePosAut not found;')"
      stop  
    end if              
  end if
!
  Nint   = 100
  Nrank  =  17 
  if (.not. DoConvTest .or. InputDS) then       
    string = 'NintNrank'
    if (XFindPar (iInputAXSYM, string)) then
      read (iInputAXSYM, *, iostat = ios) Nint
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nint;')"
        stop
      end if
      read (iInputAXSYM, *, iostat = ios) Nrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nrank;')"
        stop
      end if         
    else
      print "(/,2x,'Group name NintNrank not found;')"
      stop  
    end if                              
  end if    
!
  do i = 1, NrankPD
    zRe(i)  = 0._O
    zIm(i)  = 0._O
    zRe1(i) = 0._O
    zIm1(i) = 0._O
  end do
  if (InputDS) then   
    call check_MaxNrank (Nrank) 
    string = 'SourcePosInp'
    if (XFindPar (iInputAXSYM, string)) then
      do i = 1, Nrank
        read (iInputAXSYM, *, iostat = ios) zRe(i), zIm(i)
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variables zRe and zIm;')"
          stop
        end if
      end do      
      read (iInputAXSYM, *)
      do i = 1, Nrank - 1
        read (iInputAXSYM, *, iostat = ios) zRe1(i), zIm1(i)
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variables zRe1 and zIm1;')"
          stop
        end if
      end do
    else
      print "(/,2x,'Group name SourcePosInp not found;')"
      stop  
    end if                       
  end if         
!
  epsNint  = 5.e-2_O
  epsNrank = 5.e-2_O
  epsMrank = 5.e-2_O
  dNint    = 4
  dNintMrank = 10
  string   = 'Errors'
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) epsNint
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNint;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) epsNrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNrank;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) epsMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsMrank;')"
      stop
    end if 
    read (iInputAXSYM, *, iostat = ios) dNint
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable dNint;')"
      stop
    end if
    read (iInputAXSYM, *, iostat = ios) dNintMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable dNintMrank;')"
      stop
    end if         
  else
    print "(/,2x,'Group name Errors not found;')"
    stop  
  end if
!
  FileTmat = '../TMATFILES/T.dat'
  string   = 'Tmat' 
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) FileTmat
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileTmat;')"
      stop
    end if             
  else
    print "(/,2x,'Group name Tmat not found;')"
    stop  
  end if   
!
  PrnProgress = .true.
  string   = 'PrintProgress' 
  if (XFindPar (iInputAXSYM, string)) then
    read (iInputAXSYM, *, iostat = ios) PrnProgress
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if             
  else
    print "(/,2x,'Group name PrintProgress not found;')"
    stop  
  end if       
  close (unit = iInputAXSYM) 
end subroutine readinputAXSYM   
!************************************************************************************
subroutine printinputAXSYM (ic, FileGeom, TypeGeom, FileFEM, Nsurf, Nparam, Nrank,  &
           Nrank1, dNint, dNintMrank,ind_refMed, wavelength, anorm, Rcirc, surf,    &
           kb, epsNint, epsNrank, epsMrank, zRe, zIm, zRe1, zIm1, ind_refRel,       &
           miror, perfectcond, DS, chiral, autGenDS)
  use parameters
  implicit none
  integer       :: ic, TypeGeom, Nsurf, Nparam, Nrank, Nrank1, dNint, dNintMrank,   &
                   i, LenString                     
  real(O)       :: ind_refMed, wavelength, anorm, Rcirc, surf(Nsurf), kb, epsNint,  &
                   epsNrank, epsMrank, zRe(Nrank), zIm(Nrank), zRe1(Nrank1),        &
                   zIm1(Nrank1)
  complex(O)    :: ind_refRel
  character(80) :: FileFEM, FileFEMWrite
  logical       :: FileGeom, miror, perfectcond, DS, chiral, autGenDS  
!
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x,'wavelength of the free space, wavelength = ',1pe13.4,';')")  &
         wavelength
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'refractive index of the ambient medium, ind_refMed = ', ind_refMed, ';'
  write (iOutput,"(2x, a, 1pe10.3, ',', 1pe10.3, a)")                               &
 'relative refractive index of the particle, ind_refRel = (', ind_refRel, ');' 
  write (iOutput,*)
  if (FileGeom) then
    FileFEMWrite = FileFEM(14:LenString(FileFEM))
    write (iOutput,"(2x, a, a30)")                                                  &
   'name of the file containing the particle geometry, FileFEM = ', FileFEMWrite
  else
    write (iOutput,"(2x,'index of the particle geometry, TypeGeom = ',i2,';')")     &
           TypeGeom
    if (TypeGeom == 1) then
      write (iOutput,"(2x,'spheroid;')")        
    else if (TypeGeom == 2) then
      write (iOutput,"(2x,'cylinder;')")        
    else if (TypeGeom == 3) then
      write (iOutput,"(2x,'rounded oblate cylinder;')")
    end if
    write (iOutput,"(2x,'number of surface parameters, Nsurf = ',i2,';')") Nsurf
    write (iOutput,"(2x,'surface parameters:')")
    do i = 1, Nsurf
      write (iOutput,"(2x,'surf(',i2,') = ',1pe10.3,',')") i, surf(i)
    end do
    if (TypeGeom == 1) then
      write (iOutput,"(2x,'where surf(1) is the semi-axis along the symmetry axis,')")
      write (iOutput,"(2x,'and   surf(2) is the second semi-axis;')")
    else if (TypeGeom == 2 .or. TypeGeom == 3) then
      write (iOutput,"(2x,'where surf(1) is the half-length of the cylinder')") 
      write (iOutput,"(2x,'and   surf(2) is the cylinder radius;')")
    end if               
    write (iOutput,"(2x,'number of integration surfaces, Nparam = ',i2,';')") Nparam
  end if  
  write (iOutput,"(2x,a, 1pe10.3, a)")                                              &
 'characteristic length of the particle, anorm = ', anorm, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'radius of the circumscribing sphere, Rcirc = ', Rcirc, ';'
  if (miror) write (iOutput,"(2x,'mirror symmetric particle;')")  
  write (iOutput,*)
  if (perfectcond) then
    write (iOutput,"(2x,'perfectly conducting particle;')")
  else if (chiral) then
    write (iOutput,"(2x,'chiral particle;')")
    write (iOutput,"(2x,'characteristic of chirality, kb = ',1pe10.3,';')") kb  
  else 
    write (iOutput,"(2x,'dielectric particle;')")
  end if 
  write (iOutput,*)
  if (.not.DS) then
    write (iOutput,"(2x,'computation with localized sources;')")
  else
    write (iOutput,"(2x,'computation with distributed sources;')")
    if (autGenDS) then
      write (iOutput,"(2x,'the sources are generated automatically;')") 
    else
      write (iOutput,"(2x,'the sources are user-defined;')")
    end if                      
    write (iOutput,*)       
    write (iOutput,"(2x,'z - coordinates of the sources:')")
    write (iOutput,"(2x,'first configuration:')")
    do i = 1, Nrank
      if (i /= Nrank) then
        write (iOutput,"(2x,'zRe(',i3,') = ',1pe10.3,', zIm(',i3,') = ',1pe10.3,',')")&
               i, zRe(i), i, zIm(i)
      else
        write (iOutput,"(2x,'zRe(',i3,') = ',1pe10.3,', zIm(',i3,') = ',1pe10.3,';')")&
               i, zRe(i), i, zIm(i)
      end if
    end do
    if (ic == 2) then
      write (iOutput,*)
      write (iOutput,"(2x,'second configuration:')")
      do i = 1,Nrank1
        if (i /= Nrank1) then
          write (iOutput,"(2x,'zRe(',i3,') = ',1pe10.3,', zIm(',i3,') = ',1pe10.3,',')")&
                 i, zRe1(i), i, zIm1(i)
        else
          write (iOutput,"(2x,'zRe(',i3,') = ',1pe10.3,', zIm(',i3,') = ',1pe10.3,';')")&
                 i, zRe1(i), i, zIm1(i)
        end if
      end do
    end if
  end if
  write (iOutput,*)
  write (iOutput,"(2x,'integration tolerance, epsNint = ',1pe10.3,';')") epsNint
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum expansion order tolerance, epsNrank = ', epsNrank, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum azimuthal order tolerance, epsMrank = ', epsMrank, ';'          
  write (iOutput,"(2x,'integration step, dNint = ',i3,'.')") dNint
  if (DS) then
    write (iOutput,"(2x, a, i3, a)")                                                &
   'integration step for Mrank calculation, dNintMrank = ',     dNintMrank, '.'
  end if
  write (iOutput,"(/)")                       
end subroutine printinputAXSYM
!***********************************************************************************
subroutine convergence_NintAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm, Nsurf,     &
           surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, dNint, miror,  &
           perfectcond, DS, chiral, kb, epsNint, PrnProgress)
  use parameters                                                                           
  implicit none 
  integer    :: TypeGeom, Nsurf, Nface, Nparam, Nrank, Nint, dNint
  real(O)    :: k, surf(Nsurf), snorm, epsNint, kb, zRe(Nrank), zIm(Nrank),         &
                rp(2,NfacePD), np(2,NfacePD), area(NfacePD)
  complex(O) :: ind_ref
  logical    :: FileGeom, miror, perfectcond, DS, chiral, PrnProgress
!      
  integer    :: Nteta, Mstart, Mrank, Nmax, Nmaxmax, i, m, iNint, NthetaConv,       &
                iprog, Nprog
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O  
  Mstart = 1
  Mrank  = 1
  Nmax   = Nrank        
  m = 1            
  call write_TypeConvHead (1)
  allocate (a(2*Nrank,2*Nrank), b(2*Nrank,2*Nrank), c(2*Nrank), c1(2*Nrank))
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))  
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do
  if (.not. chiral) then
    Nprog = 7
    iprog = 3
  else
    Nprog = 13
    iprog =  6
  end if
  if (PrnProgress) call write_progress (.true., 1, Nprog)
  do iNint = 1, 2         
    allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, miror)       
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 2+iprog*(iNint-1), Nprog)
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, b, Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 3+iprog*(iNint-1), Nprog)
    call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress (.false., 4+iprog*(iNint-1), Nprog)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         Nmax, c)
    call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)
    if (.not. chiral) then
      call matrix_m_negativ (Nmax, Nmax, b, Nrank, Nrank)
    else 
      call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,   &
           area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, &
           weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
      if (PrnProgress) call write_progress (.false., 5+iprog*(iNint-1), Nprog)
      call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,   &
           area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, &
           weightsG, miror, perfectcond, DS, chiral, kb, b, Nrank, Nrank)
      if (PrnProgress) call write_progress (.false., 6+iprog*(iNint-1), Nprog)
      call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)
      if (PrnProgress) call write_progress (.false., 7+iprog*(iNint-1), Nprog)
    end if
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,    &
         Nmax, c)
    call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)
    call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm, &
        .false.,.true., h, v)    
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsNint, NthetaConv)
    call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
    call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,         &
         alfap, k, snorm, Cext, Qext)
    call write_3ConvParam (Nint, Nrank, m)
    call write_DSCS(Nteta,.false., h, v)
    call write_Effic (Qscat, Qext)  
    Nint = Nint + dNint
    deallocate (paramG, weightsG, Nintparam)
  end do  
  call write_NintConvRes (NthetaConv, Nteta, epsNint)                 
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv)
end subroutine convergence_NintAXSYM 
!***********************************************************************************
subroutine convergence_NrankAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm, Nsurf,    &
           surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, miror,         &
           perfectcond, DS, chiral, kb, epsNrank, PrnProgress)                  
  use parameters
  implicit none  
  integer    :: TypeGeom, Nsurf, Nface, Nparam, Nrank, Nint
  real(O)    :: k, surf(Nsurf), snorm, epsNrank, kb, zRe(Nrank), zIm(Nrank),        &
                rp(2,NfacePD), np(2,NfacePD), area(NfacePD)
  complex(O) :: ind_ref
  logical    :: FileGeom, miror, perfectcond, DS, chiral, PrnProgress
!      
  integer    :: Nteta, Mstart, Mrank, Nmax, Nmaxmax, i, m, NthetaConv, iprog,       &
                Nprog, j   
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:), ap(:,:), bp(:,:),   &
                            am(:,:), bm(:,:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1
  Nmax   = Nrank    
  m = 1 
  call write_TypeConvHead (2)
  allocate (a(2*Nrank,2*Nrank), b(2*Nrank,2*Nrank), c(2*Nrank), c1(2*Nrank))     
  allocate (ap(2*Nrank,2*Nrank), bp(2*Nrank,2*Nrank))
  allocate (am(2*Nrank,2*Nrank), bm(2*Nrank,2*Nrank))  
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))  
  allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
  if (.not. FileGeom) then
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, miror)
  else
    do i = 1, Nparam
      do j = 1, Nint
        paramG(i,j)   = 0._O 
        weightsG(i,j) = 0._O
      end do
      Nintparam(i) = 1
    end do
  end if
  if (.not. chiral) then
    Nprog = 5
  else
    Nprog = 8
  end if
  if (PrnProgress) call write_progress (.true., 1, Nprog)             
! --- Nrank configuration ---                    
  call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, area, &
       Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG,  &
       miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
  if (PrnProgress) call write_progress (.false., 2, Nprog)
  call copy_matrix (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, ap, 2*Nrank, 2*Nrank)
  call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, area, &
       Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG,  &
       miror, perfectcond, DS, chiral, kb, b, Nrank, Nrank)
  if (PrnProgress) call write_progress (.false., 3, Nprog)
  call copy_matrix (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, bp, 2*Nrank, 2*Nrank)
  call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 4, Nprog)
  iprog = 4
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,       &
       Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)
  if (.not. chiral) then
    call matrix_m_negativ (Nmax, Nmax, b, Nrank, Nrank)
  else 
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,   &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 4, Nprog)
    call copy_matrix (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, am, 2*Nrank, 2*Nrank)        
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,   &
         weightsG, miror, perfectcond, DS, chiral, kb, b, Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 5, Nprog)
    call copy_matrix (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, bm, 2*Nrank, 2*Nrank)    
    call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress (.false., 6, Nprog)
    iprog = 6
  end if
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,      &
       Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)
  call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,   &
      .false.,.true., h, v) 
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  do i = 1, Nteta
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do  
  call write_3ConvParam (Nint, Nrank, m)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
! --- (Nrank - 1) configuration ---
  call copy_matrix (2*Nmax, 2*Nmax, ap, 2*Nrank, 2*Nrank, a, 2*Nrank, 2*Nrank)
  call matrix_Nrank_m_left (Nmax, a, Nrank, Nrank)
  call copy_matrix (2*Nmax, 2*Nmax, bp, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank)
  call matrix_Nrank_m (Nmax, b, Nrank, Nrank)
  call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)
  if (PrnProgress) call write_progress (.false., iprog+1, Nprog)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,       &
       Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)
  if (.not. chiral) then
    call matrix_m_negativ (Nmax, Nmax, b, Nrank, Nrank)
  else 
    call copy_matrix (2*Nmax, 2*Nmax, am, 2*Nrank, 2*Nrank, a, 2*Nrank, 2*Nrank)
    call matrix_Nrank_m_left (Nmax, a, Nrank, Nrank)
    call copy_matrix (2*Nmax, 2*Nmax, bm, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank)        
    call matrix_Nrank_m (Nmax, b, Nrank, Nrank)
    call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress (.false., iprog+2, Nprog)
  end if
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,      &
       Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)
  call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,   &
      .false.,.true., h, v)
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConv)  
  call write_3ConvParam (Nint, Nrank - 1, m)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConv, Nteta, epsNrank) 
  deallocate (ap, bp, am, bm)
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv, paramG, weightsG, Nintparam)
end subroutine convergence_NrankAXSYM
!***********************************************************************************
subroutine convergence_MrankAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm, Nsurf,    &
           surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, miror,         &
           perfectcond, DS, chiral, kb, epsMrank, FileTmat, PrnProgress)                
  use parameters
  implicit none   
  integer       :: TypeGeom, Nsurf, Nface, Nparam, Nrank, Nint
  real(O)       :: k, surf(Nsurf), snorm, epsMrank, kb, zRe(Nrank), zIm(Nrank),     &
                   rp(2,NfacePD), np(2,NfacePD), area(NfacePD)
  complex(O)    :: ind_ref
  logical       :: FileGeom, miror, perfectcond, DS, chiral, PrnProgress
  character(80) :: FileTmat
!      
  integer       :: Nteta, Mstart, Mrank, Nmax, Nmaxmax, i, m, NthetaConv, Nprog, j
  real(O)       :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,     &
                   Cext, Qext  
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 0
  Mrank  = Nrank      
  open (unit = iTmat, file = FileTmat, status = 'replace')  
  call write_HeadFileTmat (Nrank, Nrank) 
  call write_TypeConvHead (3)
  call write_2ConvParamAxsym (Nint, Nrank)
  allocate (a(2*Nrank,2*Nrank), b(2*Nrank,2*Nrank), c(2*Nrank), c1(2*Nrank))
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do  
  allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
  if (.not. FileGeom) then
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, miror)
  else
    do i = 1, Nparam
      do j = 1, Nint
        paramG(i,j)   = 0._O 
        weightsG(i,j) = 0._O
      end do
      Nintparam(i) = 1
    end do
  end if        
  if (.not. chiral) then
    Nprog = 4
  else
    Nprog = 7
  end if
  Mrank = - 1
  do m = Mstart, Nrank    
    call write_1ConvParam (m)
    Mrank = Mrank + 1
    if (m == 0) then
      Nmax = Nrank
    else
      Nmax = Nrank - m + 1
    end if  
    if (PrnProgress) call write_progress_m (.true., m, 1, Nprog)    
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank) 
    if (PrnProgress) call write_progress_m (.false., m, 2, Nprog)       
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, b, Nrank, Nrank) 
    if (PrnProgress) call write_progress_m (.false., m, 3, Nprog)                           
    call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress_m (.false., m, 4, Nprog)                   
    call write_FileTmat (Nrank, Nrank, b)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         Nmax, c)
    call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)       
    if (m /= 0) then
      if (.not. chiral) then
        call matrix_m_negativ (Nmax, Nmax, b, Nrank, Nrank)     
      else 
        call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, &
             area, Nface, zRe, zIm, -m, Nrank,Nmax, Nint, Nparam, Nintparam,        &
             paramG, weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
        if (PrnProgress) call write_progress_m (.false., m, 5, Nprog)                     
        call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, &
             area, Nface, zRe, zIm, -m, Nrank,Nmax, Nint, Nparam, Nintparam,        &
             paramG, weightsG, miror, perfectcond, DS, chiral, kb, b, Nrank, Nrank)    
        if (PrnProgress) call write_progress_m (.false., m, 6, Nprog)
        call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)       
        if (PrnProgress) call write_progress_m (.false., m, 7, Nprog)
        call write_FileTmat (Nrank, Nrank, b)   
      end if
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,  &
           Nmax, c) 
      call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
      call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)     
    end if
    call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm, &
        .false.,.true., h, v)
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsMrank, NthetaConv)     
    call write_DSCS (Nteta,.false., h, v)
    if (NthetaConv >= int(0.8*Nteta)) exit 
  end do
  close (unit = iTmat) 
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  call write_Effic (Qscat, Qext)
  call write_MrankConvRes (NthetaConv, epsMrank)
  if (NthetaConv >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criterion for Mrank is satisfied;')"                                              
  else
    print "(/,2x,'Convergence criterion for Mrank is not satisfied;')"
  end if
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .true., .false., chiral)
  call ScatCharact (k, FileTmat, Mrank, Nrank, .true., .false., chiral)
  print "(/,2x,'T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"      
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank                     
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv, paramG, weightsG, Nintparam)
end subroutine convergence_MrankAXSYM
!***********************************************************************************
subroutine convergence_NintDSAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm, Nsurf,   &
           surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, dNint, miror,  &
           perfectcond, DS, chiral, kb, epsNint, PrnProgress)
  use parameters                                                                           
  implicit none 
  integer    :: TypeGeom, Nsurf, Nface, Nparam, Nrank, Nint, dNint
  real(O)    :: k, surf(Nsurf), snorm, epsNint, kb, zRe(Nrank), zIm(Nrank),         &
                rp(2,NfacePD), np(2,NfacePD), area(NfacePD)
  complex(O) :: ind_ref
  logical    :: FileGeom, miror, perfectcond, DS, chiral, PrnProgress
!      
  integer    :: Nteta, Mstart, Mrank, Nmax, Nmaxmax, i, m, iNint, NthetaConv,       &
                iprog, Nprog 
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1
  Nmax   = Nrank        
  m = 1           
  call write_TypeConvHead (1)
  allocate (a(2*Nrank,2*Nrank), b(2*Nrank,2*Nrank), c(2*Nrank), c1(2*Nrank))
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))  
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do
  if (.not. chiral) then
    Nprog = 9
    iprog = 4
  else
    Nprog = 17
    iprog =  8
  end if
  if (PrnProgress) call write_progress (.true., 1, Nprog)
  do iNint = 1, 2         
    allocate(paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, miror)       
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 2+iprog*(iNint-1), Nprog)
    call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area, Nface,& 
         zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG, b,    &
         Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 3+iprog*(iNint-1), Nprog)
    call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress (.false., 4+iprog*(iNint-1), Nprog)
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    call product_matrices (2*Nmax, 2*Nrank, 2*Nmax, a, 2*Nrank, 2*Nrank, b, 2*Nrank,&
         2*Nrank)    
    if (PrnProgress) call write_progress (.false., 5+iprog*(iNint-1), Nprog)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         Nmax, c)
    call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)
    if (.not. chiral) then
      call matrix_m_negativ (Nmax, Nmax, a, Nrank, Nrank)
    else 
      call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,   &
           area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, &
           weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
      if (PrnProgress) call write_progress (.false., 6+iprog*(iNint-1), Nprog)
      call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area,     &
           Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,       &
           weightsG, b, Nrank, Nrank)
      if (PrnProgress) call write_progress (.false., 7+iprog*(iNint-1), Nprog)
      call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank,     &
           2*Nmax)
      if (PrnProgress) call write_progress (.false., 8+iprog*(iNint-1), Nprog)
      call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,   &
           area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, &
           weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)    
      call product_matrices (2*Nmax, 2*Nrank, 2*Nmax, a, 2*Nrank, 2*Nrank,          &
           b, 2*Nrank, 2*Nrank)
      if (PrnProgress) call write_progress (.false., 9+iprog*(iNint-1), Nprog)
    end if
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,    &
         Nmax, c)
    call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)
    call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm, &
        .false.,.true., h, v)
    call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
    call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,         &
         alfap, k, snorm, Cext, Qext)    
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsNint, NthetaConv)
    call write_3ConvParam (Nint, Nrank, m)
    call write_DSCS (Nteta,.false., h, v)
    call write_Effic (Qscat, Qext)
    Nint = Nint + dNint
    deallocate (paramG, weightsG, Nintparam)
  end do
  call write_NintConvRes (NthetaConv, Nteta, epsNint)                 
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv)
end subroutine convergence_NintDSAXSYM
!***********************************************************************************
subroutine convergence_NrankDSAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm, Nsurf,  &
           surf, rp, np, area, Nface, zRe, zIm, zRe1, zIm1, Nparam, Nrank, Nrank1,  &
           Nint, miror, perfectcond, DS, chiral, kb, epsNrank, PrnProgress)              
  use parameters
  implicit none  
  integer    :: TypeGeom, Nsurf, Nface, Nparam, Nrank, Nrank1, Nint
  real(O)    :: k, surf(Nsurf), snorm, epsNrank, kb, zRe(Nrank), zIm(Nrank),        &
                zRe1(Nrank1), zIm1(Nrank1), rp(2,NfacePD), np(2,NfacePD),           &
                area(NfacePD)
  complex(O) :: ind_ref
  logical    :: FileGeom, miror, perfectcond, DS, chiral, PrnProgress
!      
  integer    :: Nteta, Mstart, Mrank, Nmax, Nmaxmax, i, m, NthetaConv,              &
                iprog, Nprog, j
  real(O)    :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,        &
                Cext, Qext
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1
  Nmax   = Nrank  
  m = 1
  call write_TypeConvHead (2)
  allocate (a(2*Nrank,2*Nrank), b(2*Nrank,2*Nrank), c(2*Nrank), c1(2*Nrank))
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))  
  allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
  if (.not. FileGeom) then
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, miror)
  else
    do i = 1, Nparam
      do j = 1, Nint
        paramG(i,j)   = 0._O 
        weightsG(i,j) = 0._O
      end do
      Nintparam(i) = 1
    end do
  end if         
  if (.not. chiral) then
    Nprog = 9
  else
    Nprog = 17
  end if
  if (PrnProgress) call write_progress (.true., 1, Nprog)
! --- Nrank configuration ---                    
  call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, area, &
       Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG,  &
       miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
  if (PrnProgress) call write_progress (.false., 2, Nprog)
  call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area, Nface,  &
       zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG, b,      &
       Nrank, Nrank)                              
  if (PrnProgress) call write_progress (.false., 3, Nprog)
  call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 4, Nprog)
  call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, area, &
       Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG,  &
       miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
  call product_matrices (2*Nmax, 2*Nrank, 2*Nmax, a, 2*Nrank, 2*Nrank, b, 2*Nrank,  &
       2*Nrank)    
  if (PrnProgress) call write_progress (.false., 5, Nprog)
  iprog = 5
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank, Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)
  if (.not. chiral) then
    call matrix_m_negativ (Nmax, Nmax, a, Nrank, Nrank)
  else 
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,   &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 6, Nprog)
    call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area, Nface,&
         zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG, b,   &
         Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 7, Nprog)
    call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress (.false., 8, Nprog)
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,   &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    call product_matrices (2*Nmax, 2*Nrank, 2*Nmax, a, 2*Nrank, 2*Nrank, b, 2*Nrank,&
         2*Nrank) 
    if (PrnProgress) call write_progress (.false., 9, Nprog)
        iprog = 9
  end if
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,      &
       Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)  
  call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,   &
      .false.,.true., h, v)
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  do i = 1, Nteta
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do  
  call write_3ConvParam (Nint, Nrank, m)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
! --- Nrank1 configuration ---
  Nmax   = Nrank1
  Nmaxmax= Nrank1 + Mrank*(2*Nrank1 - Mrank + 1)  
  call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, area, &
       Nface, zRe1, zIm1, m, Nrank1, Nmax, Nint, Nparam, Nintparam, paramG,         &
       weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
  if (PrnProgress) call write_progress (.false., iprog+1, Nprog)
  call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area, Nface,  &
       zRe1, zIm1, m, Nrank1, Nmax, Nint, Nparam, Nintparam, paramG, weightsG, b,   &
       Nrank, Nrank)
  if (PrnProgress) call write_progress (.false., iprog+2, Nprog)
  call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank1, 2*Nmax)
  if (PrnProgress) call write_progress (.false., iprog+3, Nprog)
  call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, area, &
       Nface, zRe1, zIm1, m, Nrank1, Nmax, Nint, Nparam, Nintparam, paramG,         &
       weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
  call product_matrices (2*Nmax, 2*Nrank1, 2*Nmax, a, 2*Nrank, 2*Nrank, b, 2*Nrank, &
       2*Nrank)    
  if (PrnProgress) call write_progress (.false., iprog+4, Nprog)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank1,      &
       Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank1, Nmax, Nmaxmax)  
  if (.not. chiral) then 
    call matrix_m_negativ (Nmax, Nmax, a, Nrank, Nrank)
  else 
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe1, zIm1, -m, Nrank1, Nmax, Nint, Nparam, Nintparam,        &
         paramG, weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)    
    if (PrnProgress) call write_progress (.false., iprog+5, Nprog)
    call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area, Nface,& 
         zRe1, zIm1, -m, Nrank1, Nmax, Nint, Nparam, Nintparam, paramG, weightsG,   &
         b, Nrank, Nrank)    
    if (PrnProgress) call write_progress (.false., iprog+6, Nprog)
    call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank1,      &
         2*Nmax)    
    if (PrnProgress) call write_progress (.false., iprog+7, Nprog)
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe1, zIm1, -m, Nrank1, Nmax, Nint, Nparam, Nintparam,        &
         paramG, weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)    
    call product_matrices (2*Nmax, 2*Nrank1, 2*Nmax, a, 2*Nrank, 2*Nrank,           &
         b, 2*Nrank, 2*Nrank)       
    if (PrnProgress) call write_progress (.false., iprog+8, Nprog)
  end if
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank1,     &
       Nmax, c)
  call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank1, Nmax, Nmaxmax)  
  call DSCS (cc, Mrank, Nrank1, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,  &
      .false.,.true., h, v)
  call CQscat (cc, Mrank, Nrank1, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank1, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,          &
       alfap, k, snorm, Cext, Qext)
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConv)  
  call write_3ConvParam (Nint, Nrank1, m)
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConv, Nteta, epsNrank)
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv, paramG, weightsG, Nintparam)
end subroutine convergence_NrankDSAXSYM 
!***********************************************************************************
subroutine convergence_MrankDSAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm, Nsurf,  &
           surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, miror,         &
           perfectcond, DS, chiral, kb, epsMrank, dNintMrank, FileTmat, PrnProgress)            
  use parameters
  implicit none   
  integer       :: TypeGeom, Nsurf, Nface, Nparam, Nrank, Nint, dNintMrank
  real(O)       :: k, surf(Nsurf), snorm, epsMrank, kb, zRe(Nrank), zIm(Nrank),     &
                   rp(2,NfacePD), np(2,NfacePD), area(NfacePD)
  complex(O)    :: ind_ref
  logical       :: FileGeom, miror, perfectcond, DS, chiral, PrnProgress
  character(80) :: FileTmat
!      
  integer       :: Nteta, Mstart, Mrank, Nmax, Nmaxmax, i, m, NthetaConv, Nprog, j
  real(O)       :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,     &
                   Cext, Qext  
  logical       :: ComplexPlane
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), c(:), c1(:), cc(:)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 0
  Mrank  = Nrank      
  open (unit = iTmat, file = FileTmat, status = 'replace') 
  call write_HeadFileTmat (Nrank, Nrank) 
  call write_TypeConvHead (3)
  call write_2ConvParamAxsym (Nint, Nrank)
  allocate (a(2*Nrank,2*Nrank), b(2*Nrank,2*Nrank), c(2*Nrank), c1(2*Nrank))
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do  
  allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
  if (.not. FileGeom) then
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, miror)
  else
    do i = 1, Nparam
      do j = 1, Nint
        paramG(i,j)   = 0._O 
        weightsG(i,j) = 0._O
      end do
      Nintparam(i) = 1
    end do
  end if       
  ComplexPlane = .false.        
  do i = 1, Nrank                  
    if (zIm(i) /= 0._O) ComplexPlane = .true.
  end do
  if (.not. chiral) then
    Nprog = 5
  else
    Nprog = 9
  end if                        
  Mrank = - 1
  do m = Mstart, Nrank          
    call write_1ConvParam (m)
    Mrank = Mrank + 1
    if (m == 0) then
      Nmax = Nrank
    else
      Nmax = Nrank - m + 1
    end if  
    if (ComplexPlane) then
      deallocate (paramG, weightsG, Nintparam)
      Nint = Nint + dNintMrank
      allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
      call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,            &
           Nintparam, paramG, weightsG, miror)          
    end if 
    if (PrnProgress) call write_progress_m (.true., m, 1, Nprog)  
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    if (PrnProgress) call write_progress_m (.false., m, 2, Nprog) 
    call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area, Nface,&
         zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG, b,    &
         Nrank, Nrank)
    if (PrnProgress) call write_progress_m (.false., m, 3, Nprog)
    call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress_m (.false., m, 4, Nprog)
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    call product_matrices (2*Nmax, 2*Nrank, 2*Nmax, a, 2*Nrank, 2*Nrank, b, 2*Nrank,&
         2*Nrank)   
    if (PrnProgress) call write_progress_m (.false., m, 5, Nprog)
    call write_FileTmat (Nrank, Nrank, a)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         Nmax, c)           
    call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)       
    if (m /= 0) then
      if (.not. chiral) then
        call matrix_m_negativ (Nmax, Nmax, a, Nrank, Nrank)
      else 
        call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, &
             area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam,       &
             paramG, weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
        if (PrnProgress) call write_progress_m (.false., m, 6, Nprog)
        call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area,   &
             Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,     &
             weightsG, b, Nrank, Nrank)
        if (PrnProgress) call write_progress_m (.false., m, 7, Nprog)
        call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank,   &
             2*Nmax)
        if (PrnProgress) call write_progress_m (.false., m, 8, Nprog)
        call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, &
             area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam,       &
             paramG, weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
        call product_matrices (2*Nmax, 2*Nrank, 2*Nmax, a, 2*Nrank, 2*Nrank,        &
             b, 2*Nrank, 2*Nrank)               
        if (PrnProgress) call write_progress_m (.false., m, 9, Nprog)
        call write_FileTmat (Nrank, Nrank, a)   
      end if
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,  &
           Nmax, c)
      call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
      call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)
    end if
    call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm, &
        .false.,.true., h, v)
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsMrank, NthetaConv)     
    call write_DSCS (Nteta,.false., h, v)
    if (NthetaConv >= int(0.8*Nteta)) exit 
  end do
  close (unit = iTmat)
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)
  call write_Effic (Qscat, Qext)
  call write_MrankConvRes (NthetaConv, epsMrank)
  if (NthetaConv >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criterion for Mrank is satisfied;')"                                   
  else
    print "(/,2x,'Convergence criterion for Mrank is not satisfied;')"
  end if
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .true., .false., chiral)     
  call ScatCharact (k, FileTmat, Mrank, Nrank, .true., .false., chiral) 
  print "(/,2x,'T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank 
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank             
  deallocate (a, b, c, c1, cc, h, v, oldh, oldv, paramG, weightsG, Nintparam)
end subroutine convergence_MrankDSAXSYM

! **********************************************************************************
! *                      ROUTINES FOR NUMERICAL INTEGRATION                        *
! *      ----------------------------------------------------------------------    *
! *      Partial list of subroutines:                                              *
! *        Gauss_Legendre,       Laguerre,         Simpson,        Trapez,         *
! *        Gauss_Legendre1,      Laguerre1,        Lgroot,         Lgrecr,         *
! *        gaussq,               class,            gausq2,         readinputIntegr *
! **********************************************************************************
subroutine Gauss_Legendre (x1, x2, Np, wp, xp)
!------------------------------------------------------------------------------------ 
! The routine computes the weights and nodes for the Gauss-Legendre quadrature      !
! method.                                                                           !
!                                                                                   !
! Input parameters:                                                                 !
! - x1, x2 (real variables) - lower and upper integration limits.                   !
! - Np (integer) - number of quadrature points.                                     !
!                                                                                   !
! Output parameters:                                                                !
! - wp (real array) - weights.                                                      !
! - xp (real array) - quadrature points (nodes).                                    !
!                                                                                   !
! The following parameters (specified in the group statement "Integration"          !
! from the input file "../INPUTFILES/Input.dat") control the integration            !
! process:                                                                          !
!                                                                                   !
! - TypeIntegr (character array) - specifies the source of the numerical            !
!   integration routines. The permissive values are:                                !
!   - 'MET1' - routines from Numerical Recipes,                                     !
!   - 'MET2' - modified routines from Slatec library.                               !
!   The recommended value of the parameter TypeIntegr is 'MET1'.                    !
!                                                                                   !
! - epsGauss (real) - tolerance for computing the roots of the Legendre polynomials.!
!   The accuracy of the T-matrix calculation strongly depends on epsGauss. The      !
!   value of this parameter should be set AS SMALL AS POSSIBLE. For double          !
!   precision arithmetic, epsGauss = 1.e-15,...,1.e-12.                             !
!------------------------------------------------------------------------------------
  use parameters
  implicit none
  integer       :: Np, i
  real(O)       :: x1, x2, wp(Np), xp(Np), epsGauss, epsLaguerre, xs, xd
  character(20) :: TypeIntegr
  real(O),allocatable :: work(:)
!   
  call readinputIntegr ( TypeIntegr, epsGauss, epsLaguerre ) 
  call check_Integration (TypeIntegr) 
  if (TypeIntegr(1:4) == 'MET1') then
    call Gauss_Legendre1 (x1, x2, Np, wp, xp, epsGauss)
  else if (TypeIntegr(1:4) == 'MET2') then   
    allocate (work(Np))
    call gaussq (1, Np, work, xp, wp)   
    xd = (x2 - x1) / 2._O
    xs = (x2 + x1) / 2._O
    do i = 1, Np
      wp(i) = xd * wp(i)
      xp(i) = xd * xp(i) + xs
    end do
    deallocate (work)
  end if
end subroutine Gauss_Legendre
! **********************************************************************************
subroutine Laguerre (n, x, a)
!------------------------------------------------------------------------------------ 
! The routine computes the weights and nodes for the Laguerre quadrature method.    !
!                                                                                   !
! Input parameters:                                                                 !
! - n (integer) - number of quadrature points.                                      !
!                                                                                   !
! Output parameters:                                                                !
! - x (real array) - quadrature points (nodes).                                     !
! - a (real array) - weights.                                                       !
!                                                                                   !
! The following parameters (specified in the group statement "Integration"          !
! from the input file "../INPUTFILES/Input.dat") control the integration            !
! process:                                                                          !
!                                                                                   !
! - TypeIntegr (character array) - specifies the source of the numerical            !
!   integration routines. The permissive values are:                                !
!   - 'MET1' - routines from Numerical Recipes,                                     !
!   - 'MET2' - modified routines from Slatec library.                               !
!   The recommended value of the parameter TypeIntegr is 'MET1'.                    !
!                                                                                   !
! - epsLaguerre (real) - tolerance for computing the roots of the Laguerre          !
!   polynoms. The default value is 1.e-10.                                          !
!------------------------------------------------------------------------------------
  use parameters
  implicit none      
  integer :: n
  real(O) :: x(n), a(n), epsGauss, epsLaguerre
  character(20) :: TypeIntegr
  real(O),allocatable :: work(:)    
!         
  call readinputIntegr ( TypeIntegr, epsGauss, epsLaguerre )  
  call check_Integration (TypeIntegr)  
  close (unit = iInput)
  if (TypeIntegr(1:4) == 'MET1') then
    call  Laguerre1 (n, x, a, epsLaguerre)
  else if (TypeIntegr(1:4) == 'MET2') then   
    allocate (work(n))
    call gaussq (2, n, work, x, a)      
    deallocate (work)
  end if
end subroutine Laguerre
! **********************************************************************************
subroutine readinputIntegr ( TypeIntegr, epsGauss, epsLaguerre )
  use parameters
  implicit none
  integer       :: ios
  real(O)       :: epsGauss, epsLaguerre
  character(20) :: TypeIntegr
  character(80) :: string
  logical       :: XFindPar
!
  open (unit = iInput, file = FileInput, status = "old", position = "rewind")
  TypeIntegr  = 'MET1'  
  epsGauss    = 1.e-10_O  
  epsLaguerre = 1.e-10_O
  string      = 'Integration'
  if (XFindPar (iInput, string)) then
    read (iInput, *, iostat = ios) TypeIntegr
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable TypeIntegr;')"
      stop
    end if
    read (iInput, *, iostat = ios) epsGauss
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsGauss;')"
      stop
    end if
    read (iInput, *, iostat = ios) epsLaguerre
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsLaguerre;')"
      stop
    end if
  else
    print "(/,2x,'Group name Integration not found;')"
    stop  
  end if  
  call check_Integration (TypeIntegr)  
  close (unit = iInput) 
end subroutine readinputIntegr  
!***********************************************************************************
subroutine Simpson (a, b, N, x, w)
!------------------------------------------------------------------------------------ 
! The routine computes the weights and nodes for the Simpson quadrature method.     !
!                                                                                   !
! Input parameters:                                                                 !
! - a, b (real variables) - lower and upper integration limits.                     !
! - N (integer) - number of quadrature points.                                      !
!                                                                                   !
! Output parameters:                                                                !
! - w (real array) - weights.                                                       !
! - x (real array) - quadrature points (nodes).                                     !
!                                                                                   !
! Note: The number of integration points must be an odd number.                     !
!------------------------------------------------------------------------------------
  use parameters
  implicit none
  integer  :: N, i
  real(O)  :: a, b, h, x(N), w(N), N1r, i1r
!         
  N1r = real(N - 1,O)
  h   = (b - a) / N1r
  do i = 1, N
    i1r  = real(i - 1,O)
    x(i) = a + i1r * h
  end do  
  if (mod(N - 1,2) == 0) then
    w(1) = h / 3._O
    w(N) = h / 3._O
    do i = 2, N - 1, 2
      w(i) = 4._O * h / 3._O
    end do
    do i = 3, N - 2, 2
      w(i) = 2._O * h / 3._O
    end do
  else
    print "(/,2x,'Warning in subroutine Simpson in module Integr:')"
    print "(  2x,'the number of integration points is an even number and therefore')"
    print "(  2x,'the last interval integration is performed with the trapez rule;')"
    w(1)   = h / 3._O
    w(N-1) = 5._O * h / 6._O
    w(N)   = h / 2._O
    do i = 2, N - 2, 2
      w(i) = 4._O * h / 3._O
    end do
    do i = 3, N - 3, 2
      w(i) = 2._O * h / 3._O
    end do       
  end if
end subroutine Simpson
!***********************************************************************************
subroutine Trapez (a, b, N, x, w)
!------------------------------------------------------------------------------------ 
! The routine computes the weights and nodes for the trapez integration method.     !
!                                                                                   !
! Input parameters:                                                                 !
! - a, b (real variables) - lower and upper integration limits.                     !
! - N (integer) - number of quadrature points.                                      !
!                                                                                   !
! Output parameters:                                                                !
! - w (real array) - weights.                                                       !
! - x (real array) - quadrature points (nodes).                                     !
!------------------------------------------------------------------------------------
  use parameters
  implicit none
  integer  :: N, i
  real(O)  :: a, b, h, x(N), w(N), N1r, i1r
!         
  N1r = real(N - 1,O)
  h   = (b - a) / N1r
  do i = 1, N
    i1r  = real(i - 1,O)
    x(i) = a + i1r * h
  end do  
  w(1) = 0.5_O * h
  w(N) = 0.5_O * h
  do i = 2, N - 1
    w(i) = h
  end do 
end subroutine Trapez
! **********************************************************************************
! *                  ROUTINES FOR COMPUTING THE NODES AND WEIGHTS                  *
! *              FOR GAUSSIAN-TYPE QUADRATURE RULES - NUMERICAL RECIPES            *
! **********************************************************************************
subroutine Gauss_Legendre1 (x1, x2, Np, wp, xp, epsGauss)
!-----------------------------------------------------------------------------------
! The significance of the input and ouput parameters is as in the routine          !
! Gauss_Legendre. The following parmeters control the computation:                 !
! - TolRootPol (real) - if epsGauss < TolRootPol, then epsGauss is setted to       !
!   TolRootPol. Default value: TolRootPol = MachEps.                               !
! - NIterPol (integer) - maximum number of iteration for computing the roots       !
!   with the desired accuracy. Default value: NIterPol = 100000.                   !
! These parameters are specified in the routine "DrvParameters" from the file      !
! '../TMATROUTINES/MachParam.f90'.                                                 !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer :: Np, i, j, M, iter
  real(O) :: x1, x2, wp(Np), xp(Np), xm, xl, z, p1, p2, p3, pp, z1,                 &
             jr, j1r, j2r, Npr, ir, epsGauss
  logical :: more
!  
  if (epsGauss < TolRootPol) then
    epsGauss = TolRootPol 
    print "(/,2x,'Warning in subroutine Gauss_Legendre in module Integr:')"
    print "(  2x,'the tolerance epsGauss is too low and epsGauss has been setted')"    
    print "(  2x,'to TolRootPol, where TolRootPol =',1pe13.4,';')", TolRootPol    
  end if
  Npr = real(Np,O)
  M   = int(0.5_O * (Npr + 1._O))
  xm  = 0.5_O * (x1 + x2)
  xl  = 0.5_O * (x2 - x1)
  do i = 1, M
    ir   = real(i,O)
    z    = cos(Pi * (ir - 0.25_O) / (Npr + 0.5_O))
    more =.true.
    iter = 0
    do while (more)
      iter = iter + 1     
      p1   = 1._O
      p2   = 0._O
      do j = 1,Np
        p3  = p2
        p2  = p1
        jr  = real(j,O)
        j1r = real(j - 1,O)
        j2r = real(2 * j - 1,O)
        p1  = (j2r * z * p2 - j1r * p3) / jr
      end do
      pp = Npr * (z * p1 - p2) / (z * z - 1._O)
      z1 = z
      z  = z1 - p1 / pp      
      if (abs(z - z1) <= epsGauss .or. iter == NIterPol) more = .false.
    end do 
    if (abs(z - z1) > epsGauss ) then        
      print "(/,2x,'Error in subroutine Gauss_Legendre in module Integr:')"
      print "(  2x,'the  root was not determined with the prescribed accuracy because ')"
      print "(  2x,'the tolerance epsGauss or the iteration number NIterPol specified ')"
      print "(  2x,'in the subroutine MachParam are too low;')"
      stop 
    end if  
    xp(i)      = xm - xl * z
    xp(Np+1-i) = xm + xl * z
    wp(i)      = 2._O * xl / ((1._O - z * z) * pp * pp)
    wp(Np+1-i) = wp(i)
  end do      
end subroutine Gauss_Legendre1
! **********************************************************************************
subroutine Laguerre1 (n, x, a, epsLaguerre)
!-----------------------------------------------------------------------------------
! The significance of the input and ouput parameters is as in the routine          !
! Laquerre. The parameter NIterPol  specifies the maximum number of iteration      !
! for computing the roots with the desired accuracy. NIterPol is specified in      !
! the routine "DrvParameters" from the file '../TMATROUTINES/MachParam.f90' and    !
! the default value is NIterPol = 100000.                                          !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer :: n
  real(O) :: x(n), a(n), epsLaguerre
!      
  integer :: i, exp, j
  real(O) :: csx, csa, r1, dpn, pn1, xt, nr, i2r, tmp
!    
  nr  = real(n,O) 
  csx = 0._O
  csa = 0._O
  do i = 1, n
    if (i == 1) xt = 3._O / (1._O + 2.4_O * nr)        
    if (i == 2) xt = xt + 15._O / (1._O + 2.5_O * nr)        
    if (i > 2) then
      i2r = real(i - 2,O)
      r1  = (1._O + 2.55_O * i2r) / (1.9_O * i2r)
      xt  = xt + r1 * (xt - x(i-2))
    end if
    call Lgroot (xt, n, dpn, pn1, epsLaguerre, exp)
    x(i) = xt
    tmp  = 1._O / dpn / pn1 / nr
    if (exp > 0) then
      do j = 1, 2 * exp
        tmp = tmp * 0.1_O
      end do
    end if
    a(i) = tmp 
    csx  = csx + xt
    csa  = csa + a(i)
  end do      
end subroutine Laguerre1
! **********************************************************************************
subroutine Lgroot (x, n, dpn, pn1, epsLaguerre, exp)
  use parameters
  use derived_parameters
  implicit none  
  integer  :: n, exp
  real(O)  :: x, dpn, pn1, epsLaguerre
!      
  integer  :: iter
  real(O)  :: p, d, dp
  logical  :: more
!
  iter  = 0
  more  = .true.
  do while (more)
    iter = iter + 1
    call Lgrecr (p, dp, pn1, x, n, exp)
    d = p / dp
    x = x - d  
    if (abs(d / x) <= epsLaguerre .or. iter == NIterPol) more = .false.                         
  end do
  if (abs(d / x) > epsLaguerre ) then
    print "(/,2x,'Error in subroutine Laguerre in module Integr:')"
    print "(  2x,'the root was not determined with the prescribed accuracy because the')"
    print "(  2x,'tolerance  epsLaguerre  or the iteration number  NIterPol  specified')"
    print "(  2x,'in the subroutine MachParam are too low;')"
    stop
  end if
  dpn = dp                                 
end subroutine Lgroot
! ******** *************************************************************************
subroutine Lgrecr (pn, dpn, pn1, x, n, exp)
  use parameters
  implicit none
  integer  :: n, exp
  real(O)  :: pn, dpn, pn1, x
!      
  integer  :: j, dexp
  real(O)  :: p1, p, dp1, dp, q, dq, jr, j1r, j2r, big, low
!
  p1   = 1._O
  p    = x - 1._O
  dp1  = 0._O
  dp   = 1._O
  exp  = 0
  big  = 1.e+3_O
  low  = 1.e-3_O 
  dexp = int(log10(big))
  do j = 2, n
    jr  = real(j,O)
    j1r = real(j - 1,O)
    j2r = real(2*j - 1,O)
    q   = (x - j2r) *  p / jr - j1r * p1 / jr
    dq  = (x - j2r) * dp / jr + p / jr - j1r * dp1 / jr
    if (q > big .or. dq > big) then
      q   =  q * low
      dq  = dq * low
      p   =  p * low
      dp  = dp * low
      exp = exp + dexp
    end if
    p1  = p
    p   = q
    dp1 = dp
    dp  = dq
  end do
  pn  = p
  dpn = dp
  pn1 = p1        
end subroutine Lgrecr
! **********************************************************************************
! *         ROUTINES FOR COMPUTING THE NODES AND WEIGHTS FOR GAUSSIAN-TYPE         *
! *           QUADRATURE RULES - SIMPLIFIED VERSION FROM SLATEC LIBRARY            *
! **********************************************************************************
subroutine gaussq (kindt, n, b, t, w)                  
!-----------------------------------------------------------------------------------
! Input parameters:                                                                !
! - kindt (integer) - specifies the type of quadrature rule, i.e.,                 !
!   kindt = 1 for Legendre quadrature with w(x) = 1 on (-1, 1), and                !
!   kindt = 2 for the generalized Laguerre quadrature with w(x) = exp(-x) on       !
!   (0, +infinity).                                                                !
! - n (integer) - number of points used for the quadrature rule.                   ! 
! - b (real array) - scratch array of length n.                                    ! 
!                                                                                  !
! Output parameters:                                                               !
! - t (real array) - quadrature nodes.                                             !
! - w (real array) - weights.                                                      !
!-----------------------------------------------------------------------------------
  use parameters 
  implicit none
  integer  :: kindt, n
  real(O)  :: b(n), t(n), w(n)
!  
  integer  :: i 
  real(O)  :: muzero      
!                 
  call class (kindt, n, b, t, muzero)   
  w(1) = 1._O
  do i = 2, n
    w(i) = 0._O
  end do
  call gausq2 (kindt, n, t, b, w)
  do i = 1, n
    w(i) = muzero * w(i) * w(i)
  end do                              
end subroutine gaussq
!***********************************************************************************
subroutine class (kindt, n, b, a, muzero)
  use parameters
  implicit none
  integer  :: kindt, n
  real(O)  :: a(n), b(n), muzero
!      
  integer  :: nm1, i     
  real(O)  :: abi
!
  nm1 = n - 1
  if (kindt == 1) then
    muzero = 2._O
    do i = 1, nm1
      a(i) = 0._O
      abi  = i
      b(i) = abi / sqrt(4._O * abi * abi - 1._O)
    end do
    a(n) = 0._O  
  else if (kindt == 2) then      
    muzero = 1._O 
    do i = 1, nm1
      a(i) = 2._O * i - 1._O 
      b(i) = real(i,O)       
    end do
    a(n) = 2._O * n - 1 
  end if             
end subroutine class
!***********************************************************************************
subroutine gausq2 (kindt, n, d, e, z)
  use parameters
  use derived_parameters
  implicit none
  integer :: kindt, n
  real(O) :: d(n), e(n), z(n)
!
  integer :: i, j, k, l, m, ii, mml
  real(O) :: b, c, f, g, p, r, s
!    
  e(n) = 0._O
  do l = 1, n
    j = 0
    do while (j < NIterPol)
      j = j + 1    
      m = l - 1
      do while (m < n)
        m = m + 1           
        if (m < n .and. abs(e(m)) <= MachEps * (abs(d(m)) + abs(d(m+1)))) exit
      end do
      p = d(l)
      if (m == l)  exit                     
      g   = (d(l+1) - p) / (2._O * e(l))
      r   = sqrt(g * g + 1._O)
      g   = d(m) - p + e(l) / (g + sign(r, g))
      s   = 1._O
      c   = 1._O
      p   = 0._O
      mml = m - l                
      do ii = 1, mml
        i = m - ii
        f = s * e(i)
        b = c * e(i)
        if (abs(f) < abs(g)) then
          s = f / g
          r = sqrt(s * s + 1._O)
          e(i+1) = g * r
          c = 1._O / r
          s = s * c         
        else
          c = g / f
          r = sqrt(c * c + 1._O)
          e(i+1) = f * r
          s = 1._O / r
          c = c * s
        end if              
        g = d(i+1) - p
        r = (d(i) - g) * s + 2._O * c * b
        p = s * r
        d(i+1) = g + p
        g = c * r - b
        f = z(i+1)
        z(i+1) = s * z(i) + c * f
        z(i)   = c * z(i) - s * f
      end do                                                                     
      d(l) = d(l) - p
      e(l) = g
      e(m) = 0._O
    end do
    if (j == NIterPol) then
      if (kindt == 1) then
        print "(/,2x,'Error in subroutine gausq2 in module Integr:')"
        print "(  2x,'the Legendre quadratures were not determined with the prescribed ')"
        print "(  2x,'accuracy, because the iteration number NIterPol specified in the')"
        print "(  2x,'subroutine MachParam is too low;')"
      else if (kindt == 2) then
        print "(/,2x,'Error in subroutine gausq2 in module Integr:')"
        print "(  2x,'the Laguerre quadratures were not determined with the prescribed ')"
        print "(  2x,'accuracy, because the iteration number NIterPol specified in the')"
        print "(  2x,'subroutine MachParam is too low;')"
      end if              
      stop
    end if  
  end do  
  do ii = 2, n
    i = ii - 1
    k = i
    p = d(i)
    do j = ii, n
      if (d(j) < p) then
        k = j
        p = d(j)
      end if  
    end do
    if (k /= i) then
      d(k) = d(i)
      d(i) = p
      p    = z(i)
      z(i) = z(k)
      z(k) = p
    end if  
  end do     
end subroutine gausq2

subroutine TINHOM
!------------------------------------------------------------------------------------
! 1. General Considerations                                                         !
! --------------------------                                                        !
! TINHOM is a routine for computing the T matrix and the scattering characteristics !
! of an inhomogeneous, dielectric, axisymmetric particle with an arbitrarily shaped !
! inclusion The program supports calculation for dielectric and axisymmetric host   !
! particles with REAL refractive indices. The main feature of this routine is that  !
! the T matrix of the inclusion is provided as input parameter in the file FileTmat.!
! The inclusion can be a homogeneous, axisymmetric or nonaxisymmetric particle, a   !
! composite or a layered scatterer and an aggregate. This choice enables the        !
! analysis of particles with complex structure and enhances the flexibility of the  !
! program. For computing the T matrix of the inclusion, the refractive index of the !
! ambient medium (the parameter ind_refMed in the corresponding T-matrix program)   !
! must be identical with the relative refractive index of host particle (the        !
! parameter indrefRel in the present T-matrix program). As an example we consider   !
! the scattering problem of an inhomogeneous, axisymmetric particle with an         !
! axisymmetric inclusion. The refractive index of the ambient medium is n_medium,   !
! the relative refractive index of the host particle with respect to the ambient    !
! medium is nRel_host (REAL), while the RELATIVE REFRACTIVE INDEX OF THE INCLUSION  !
! WITH RESPECT TO THE HOST PARTICLE is nRel_inclusion. The T matrix of the          !
! inclusion will be computed with the TAXSYM routine by setting                     !
! ind_refMed = nRel_host and ind_refRel = nRel_inclusion. Note that the T matrix of !
! a spherical inclusion must be computed with the routine TAXSYM and not with the   !
! program TSPHERE (because the T matrix of the inclusion must be specified as a     !
! two-dimensional array and the routine TSPHERE provides an one-dimensional array). ! 
!                                                                                   !
! The T matrix of an inhomogeneous particle can be expressed in terms of the T      !
! matrices of the host particle and the inclusion as                                !
!                                                                                   !
!            T =  { T_host - Q13 * [TR(O1,O2) * T_incl * TR(O2,O1)] * Q31^(-1) }    !
!               * { I - Q33 * [TR(O1,O2) * T_incl * TR(O2,O1)] * Q31^(-1) }^(-1),   !
!                                                                                   !
! where T_host is the transition matrix of the host particle, T_incl is the         !
! transition matrix of the inclusion and TR(O1,O2) is the matrix transforming the   !
! vector spherical wave functions from the origin O1 of the host particle to the    !
! origin O2 of the inclusion (through rotations and translations).                  ! 
!                                                                                   !
! For axisymmetric host particles, the surface integrals reduce to line integrals   !
! over the generatrix. The integrals are evaluated by means of Gauss-Legendre       !
! quadrature method, and note that for host particles with a plane of symmetry      !
! perpendicular to the axis of rotation, the integration can be performed along the !
! half-generatrix curve. The numerical stability and accuracy of T-matrix           !
! computations for an nonsmooth generatrix can be enhanced by dividing the          !
! generatrix into piecewise smooth curves and applying separate quadrature formulas !
! to each curve.                                                                    !
!                                                                                   !
! Host particle geometries currently supported include: spheroids, cylinders and    !
! rounded oblate cylinders. As for axisymmetric particles, the routines             !
! "interpolation_listAXSYM" and "elem_geomAXSYM" provide the required geometry      !
! parameters. For more details, consult the TAXSYM routine.                         !
!                                                                                   !
! 2. Convergence Test                                                               !
! --------------------                                                              !
! Convergence tests precede the scattering characteristics calculation. The         !
! parameters of the convergence procedure correspond to the host particle and they  !
! are:                                                                              !
! - the number of integration points for computing integrals over the generatrix,   !
!   Nint,                                                                           !
! - the maximum expansion order Nrank, and                                          !
! - the maximum azimuthal order Mrank.                                              !
! The significance of the number of integration points Nint is given in the routine !
! "TAXSYM.f90".                                                                     ! 
!                                                                                   !
! For convergence tests, the incident wave is assumed to be a plane wave traveling  !
! along the Z-axis of the global coordinate system and the scattering               !
! characteristics are computed in the azimuthal plane  phi = 0°. The Euler          !
! orientation angles of the host particle are alpha = beta = 45° and gamma = 0°,    !
! and interactive convergence tests over Nint, Nrank and Mrank are performed.       !
!                                                                                   !  
! Nrank and Mrank are assumed to not depend on Nrank1 and Mrank1, which are the     !
! maximum expansion and azimuthal orders of the inclusion. The convergence tests    !
! are carried out over Nint, Nrank and Mrank, while Nrank1 and Mrank1 are kept      !
! constant. For the integration test, the scattering problem is solved for          !
! Nint and Nint + dNint, while Nrank and Mrank are constant. For the convergence    !
! test over the expansion order, the scattering problem is solved for the pairs     !
! (Nrank, Mrank) and (Nrank - 1, Mrank). Finally, for the azimuthal order test,     !
! the cases (Nrank, Mrank) and (Nrank, Mrank - 1) are considered. The normalized    !
! differential scattering cross section will be checked at 20° increments for       !
! convergence within epsX (epsNint,epsNrank or epsMrank) tolerance. If the          !
! calculated results are converged within this tolerance at 80% of the scattering   !
! angles, then convergence is achieved. The T matrix is stored for later use by     !
! other programs, and the values of Nrank and Mrank are printed to the screen and   !
! to the T-matrix information file (see "Description.txt"). These values together   !
! with the T matrix serve as INPUT PARAMETERS for other programs.                   !
!                                                                                   !
! 3. Estimates of Nint, Nrank and Mrank                                             !
! --------------------------------------                                            !
! The above convergence tests require estimates of Nint, Nrank and Mrank.           ! 
! These estimates must be supplied by the user, and for this purpose, Wiscombe's    !
! truncation limit criterion [W. J. Wiscombe, Improved Mie scattering algorithms,   !
! Applied Optics, 19, 1505-1509, 1980] can be used.                                 !
!                                                                                   !
! The truncation limit criterion proposed by Wiscombe provides the estimate         !
!                                                                                   !
!                NrankW = int(x + 4.05 * x**0.33 + 2),                              !
!                                                                                   !
! where x is the size parameter, x = k * Rcirc, k is the wave number and Rcirc is   !
! the radius of the smallest circumscribing sphere. For almost spherical particles, !
! Mrank can be chosen as Nrank - 2,..,Nrank, while for less spherical particles     !
! Mrank can be smaller than Nrank - 2.                                              !
!                                                                                   ! 
! The value of Nint depends on the size parameter, the shape and the relative       !
! refractive index of the host particle. A conservative estimate of Nint is         !
!                                                                                   !
!                        Nint = Ndgs * Nrank,                                       !
!                                                                                   ! 
! where Ndgs = 10, 12, 14, ....                                                     !
!                                                                                   !
! 4. Strategies for Performing Convergence Tests                                    !
! -----------------------------------------------                                   !
! The following strategy for performing convergence tests can be employed:          !
! 1. choose a value of Nrank close to the value predicted by Wiscombe's truncation  !
!    limit criterion (or smaller) and set Mrank = Nrank - 2 (or smaller);           !
! 2. set Nint = Ndgs * Nrank, where Ndgs = 10, 12, ...;                             !
! 3. perform the convergence tests over Nrank and Mrank;                            ! 
! 4. if convergence is not achieved, set Nrank = Nrank + 1, maintain the relations  !
!    Nint = Ndgs * Nrank and Mrank = Nrank - 2, and go to Step 2;                   !
! 5. if convergence is achieved, perform several integration tests with the         !
!    initial Nint-value, Nint = Ndgs * Nrank, until the DSCS converges.             !
! For particles which are too extreme in size and/or aspect ratio, the errors of    !
! the extinction and scattering cross sections (instead of the differential         !
! scattering cross section) can be analyzed.                                        ! 
!                                                                                   !
! 5. Additional Comments                                                            !
! -----------------------                                                           !
! The convergence tests can be switched off by setting the logical variable         !
! DoConvTest to false. In this case, the values of Nint, Nrank and Mrank must be    !
! specified in the input file.                                                      !    
!                                                                                   !
! 6. Input Parameters                                                               !
! --------------------                                                              !
! The parameters specified in the input file "/INPUTFILES/InputINHOM.dat" are       !
! listed below.                                                                     !
!                                                                                   !
! - wavelength (real) - wavelength of the incident light in vacuo.                  !
!                                                                                   !
! - ind_refMed (real) - refractive index of the ambient medium (nonabsorbing        !
!   dielectric medium).                                                             !
!                                                                                   !
! - ind_refRel (REAL) - relative refractive index of the host particle with respect !
!   to the ambient medium.                                                          !
!                                                                                   !
! - TypeGeom (integer) - parameter specifying the type of the host particle         !
!   geometry.                                                                       !
!                                                                                   !
! - Nsurf (integer) - number of surface parameters for the host particle.           !
!                                                                                   !
! - surf (real array: surf(1), surf(2),...,surf(Nsurf)) - surface parameters        !
!   specifying the shape of the host particle. The dimension of the array surf is   !
!   NsurfPD. The integer parameter NsurfPD is specified in the routine              !
!   "Parameters.f90" and has the value NsurfPD = 10. If Nsurf > NsurfPD, the        !
!   execution is automatically terminated.                                          !
!                                                                                   !
! - Nparam (integer) - number of smooth curves forming the generatrix curve of      !
!   the host particle.                                                              !
!                                                                                   !
!   The permissive values of the surface parameters (for the supported geometries)  !
!   are summarized below.                                                           !
!                                                                                   !
!   Host particle TypeGeom   Nsurf   Nparam                surf                     !
!   spheroid         1         2       1         surf(1) - length of the semi-      !
!                                                          axis along the           !
!                                                          symmetry axis            !
!                                                surf(2) - length of the second     ! 
!                                                          semi-axis                !
!                                                                                   !
!   cylinder         2         2       3         surf(1) - half-length of           !
!                                                          the cylinder             !
!                                                surf(2) - cylinder radius          !
!                                                                                   !
!   rounded          3         2       3         surf(1) - half-length of           !
!    oblate                                                the cylinder             !
!   cylinder                                     surf(2) - cylinder radius          ! 
!                                                          including the rounded    !
!                                                          part                     !
!                                                                                   !
! - anorm (real) - characteristic length of the host particle which is used to      !
!   normalize the differential scattering cross sections.                           !
!                                                                                   !
! - Rcirc (real) - characteristic length of the host particle (usually the radius   !
!   of the smallest circumscribing sphere) which is used to compute an estimate     !
!   of the maximum expansion order by using Wiscombe's truncation limit criterion   !
!  (the size parameter is x = k * Rcirc, where k is the wave number in the ambient  !
!   medium). Alternatively, Rcirc can be chosen as the equal-volume sphere radius   !
!   or the surface-equivalent-sphere radius. This parameter must be specified if    !
!   the interactive convergence tests are performed (DoConvTest = t).               !
!                                                                                   !
! - miror (logical) - if miror = t, the host particle is mirror symmetric (the      !
!   plane of symmetry or the plane of reflection is perpendicular to the axis of    !
!   rotation).                                                                      !
!                                                                                   !
! - FileTmat (character(80)) - name of the file containing the T matrix of the      !
!   inclusion.                                                                      !
!                                                                                   !
! - axsym1 (logical) - if axsym1 = t, the inclusion is a rotationally symmetric     !
!   particle (axisymmetric particle).                                               !
!                                                                                   !
! - chiral1 (logical) - if chiral1 = t, the inclusion is an optical active particle  !
!   (chiral particle).                                                              !
!                                                                                   !
! - Nrank1, Mrank1 (integer variables) - the maximum expansion and azimuthal        !
!   orders of the inclusion.                                                        !
!                                                                                   !   
! - x1, y1, z1 (real variables) - Cartesian coordinates specifying the position     !
!   of the inclusion with respect to the coordinate system of the host particle.    !
!                                                                                   ! 
! - alpha1, beta1, gamma1 (real variables) - Euler angles specifying the            !
!   orientation of the coordinate system of the inclusion with respect to the       !
!   coordinate system of the host particle.                                         !
!                                                                                   !
! - DoConvTest (logical) - if DoConvTest = t, the interactive convergence tests     !
!   over Nint, Nrank and Mrank are invoked. An estimates of Nrank is given by       !
!   Wiscombe's truncation limit criterion. If DoConvTest = f, the values of Nint,   !
!   Nrank and Mrank must be supplied in the input file.                             !
!                                                                                   !
! - ExtThetaDom (logical) - if ExtThetaDom = t the DSCS is computed for             !
!   scattering angles ranging from 0° to 180° in the azimuthal plane phiGS = 0°, and!
!   from 180° to 0° in the azimuthal plane phiGS = 180°. The total number of        !
!   scattering angles is 10. If ExtThetaDom = f the DSCS is computed for            !
!   scattering angles ranging from 0 to 180° in the azimuthal plane phiGS = 0.      !
!                                                                                   !
! - Nint (integer) - number of integration points in computing integrals over       !
!   the generatrix curve of the host particle. This parameter is used if the        !
!   convergence tests are not performed (DoConvTest = f).                           !
!                                                                                   !
! - Nrank (integer) - maximum expansion order for the host particle. This           !
!   parameter is used if the convergence tests are not performed (DoConvTest = f).  !
!                                                                                   !
! - Mrank (integer) - maximum azimuthal order for the host particle. This           !
!   parameter is used if the convergence tests are not performed (DoConvTest = f).  !
!                                                                                   !
!   The following table explain the significance of the variables Nint, Nrank and   !
!   Mrank.                                                                          !
!                                                                                   !
!     DoConvTest       Nrank and Mrank      Nint1 and Nint2     TypeConvTest        !
!         t             console input        console input         1 or 2           !
!         f              file input           file input             0              !
!                                                                                   !  
!   The significance of the variable TypeConvTest is summarized below.              !
!                                                                                   !
!           TypeConvTest                    Significance                            !
!               0                        no convergence test                        !  
!               1                      convergence test over Nint                   ! 
!               2                 convergence test over Nrank and Mrank             !
!                                                                                   !
! - epsNint (real) - error tolerance for the integration test.                      !
!                                                                                   !
! - epsNrank (real) - error tolerance for the expansion order test.                 !
!                                                                                   !
! - epsMrank (real) - error tolerance for the azimuthal order test.                 !
!                                                                                   !
! - dNint (integer) - number of division points for the integration test. Note      !
!   that the scattering problem is solved for Nint and Nint + dNint.                ! 
!                                                                                   !
! - FileTmatG (character(80)) - name of the file to which the T matrix of the       !
!   inhomogeneous particle is written.                                              !
!                                                                                   !
! - PrnProgress (logical) - if PrnProgress = t, the progress of calculation         !
!   is printed.                                                                     !
!                                                                                   !
! Note that all input parameters specifying lengths must be provided in the same    !
! units of lengths.                                                                 !
!                                                                                   !
! 7. Logical Scheme                                                                 !
! ------------------                                                                !  
! The organization of the code is as follows:                                       !
! 1. < read input data; the input file provides                                     !
!    - the name of the file containing the T matrix of the inclusion,               !
!    - the maximum expansion and azimuthal orders Nrank1 and Mrank1,                ! 
!    - the Cartesian coordinates specifying the position of the inclusion, and      !
!    - the Euler angles specifying the orientation of the inclusion >               !  
!                                                                                   !
! 2. < T-matrix calculation >                                                       !
!                                                                                   !
!    if ( do convergence test ) then                                                !
!                                                                                   !
!       < the code computes an estimate of Nrank by using                           !
!         Wiscombe's truncation criterion >                                         !
!       < the code prompts for the estimated values of Nint, Nrank and Mrank >      !
!       < the code prompts for the type of convergence test:                        !
!          1 - over Nint, 2 - over Nrank and Mrank >                                !
!                                                                                   !
!    else if ( .not. do convergence test ) then                                     !
!                                                                                   !
!       < the input file provides the values of Nint, Nrank and Mrank >             !
!       type of convergence test = 0 (no convergence test)                          !
!                                                                                   !
!    end if                                                                         !
!    if ( do integration test, i.e., type of convergence test = 1 ) then            !
!       < the code computes the DSCS for Nint and Nint + dNint                      !
!         and write the results to the file "Output.dat" >                          !
!       < the execution is terminated >                                             !
!    end if                                                                         !
!    if ( do expansion and azimuthal order tests,                                   !
!         i.e., type of convergence test = 2 ) then                                 !
!       < the code computes the DSCS for (Nrank,Mrank), (Nrank - 1,Mrank) and       ! 
!         (Nrank, Mrank - 1), and write the results to the file "Output.dat" >      !
!       < the T matrix is stored in the file FileTmatG and the T-matrix             !
!         information file is created >                                             !
!       < Mrank and Nrank are written to the screen and to the T-matrix             !
!         information file >                                                        !      
!       < go to Step 3 >                                                            !
!    end if                                                                         !
!    if ( .not. do convergence test, i.e., type of convergence test = 0 ) then      !
!       < the T matrix is computed and stored in the file FileTmatG >               !
!       < the T-matrix information file is created >                                !
!       < Mrank and Nrank are written to the screen and to the T-matrix             !
!         information file >                                                        !
!       < go to Step 3 >                                                            !
!    end if                                                                         !
! 3. < scattering characteristics calculation >                                     !   
!------------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none 
  integer       :: TypeGeom, Nsurf, Nparam, TypeConvTest, Mrank, Nrank, Nint,       &
                   Mrank1, Nrank1, dNint                    
  real(O)       :: ks, ind_refMed, ind_refRel, wavelength, anorm, surf(NsurfPD),    &
                   snorm, epsNint, epsNrank, epsMrank, x1, y1, z1, alpha1, beta1,   &
                   gamma1, Rcirc 
  character(80) :: FileTmat, FileTmatG 
  logical       :: miror, axsym1, chiral1, DoConvTest, ExtThetaDom, PrnProgress
! -----------------------------------------------------------------------------------
!                              Read the input file                                  ! 
! -----------------------------------------------------------------------------------
  call readinputINHOM ( wavelength, ind_refMed, ind_refRel, TypeGeom,               &
       Nsurf, surf, Nparam, anorm, Rcirc, miror, FileTmat, axsym1, chiral1,         &
       Nrank1, Mrank1, x1, y1, z1, alpha1, beta1, gamma1, DoConvTest,               &
       ExtThetaDom, Nint, Nrank, Mrank, epsNint, epsNrank, epsMrank, dNint,         &
       FileTmatG, PrnProgress, TypeConvTest, ks, snorm )  
! -----------------------------------------------------------------------------------
!                                      Main                                         !
! -----------------------------------------------------------------------------------           
  if (DoConvTest) then
    open (unit = iOutput, file = FileOutput, status = "replace")
    call printinputINHOM (TypeGeom, Nsurf, surf, Nparam, miror, FileTmat, axsym1,   &
         Mrank1, Nrank1, x1, y1, z1, alpha1, beta1, gamma1, wavelength, anorm,      &
         Rcirc, ind_refMed, ind_refRel, dNint, epsNint, epsNrank, epsMrank)
    if (TypeConvTest == 1) then
      call convergence_NintINHOM (TypeGeom, ks, ind_refRel, snorm, Nsurf, surf,     &
           Nparam, Mrank, Nrank, Nint, dNint, miror, x1, y1, z1, alpha1, beta1,     &
           gamma1, Mrank1, Nrank1, FileTmat, axsym1, chiral1, epsNint, ExtThetaDom, &
           PrnProgress)
    else if (TypeConvTest == 2) then          
      call convergence_Nrank_MrankINHOM (TypeGeom, ks, ind_refRel, snorm, Nsurf,    &
           surf, Nparam, Mrank, Nrank, Nint, miror, x1, y1, z1, alpha1, beta1,      &
           gamma1, Mrank1, Nrank1, FileTmat, axsym1, chiral1, epsNrank, epsMrank,   &
           ExtThetaDom, FileTmatG, PrnProgress)
      
    end if
    close (unit = iOutput)  
  else
    call TMatrix_Nrank_MrankINHOM (TypeGeom, ks, ind_refRel, Nsurf, surf, Nparam,   &
         Mrank, Nrank, Nint, miror, x1, y1, z1, alpha1, beta1, gamma1, Mrank1,      &
         Nrank1, FileTmat, axsym1, chiral1, FileTmatG, PrnProgress)    
  end if   
end subroutine TINHOM
!***********************************************************************************
subroutine readinputINHOM ( wavelength, ind_refMed, ind_refRel, TypeGeom,           &
           Nsurf, surf, Nparam, anorm, Rcirc, miror, FileTmat, axsym1, chiral1,     &
           Nrank1, Mrank1, x1, y1, z1, alpha1, beta1, gamma1, DoConvTest,           &
           ExtThetaDom, Nint, Nrank, Mrank, epsNint, epsNrank, epsMrank, dNint,     &
           FileTmatG, PrnProgress, TypeConvTest, ks, snorm )
  use parameters
  use derived_parameters
  implicit none 
  integer       :: TypeGeom, Nsurf, Nparam, TypeConvTest, Mrank, Nrank, Nint,       &
                   Mrank1, Nrank1, dNint, i, ios, NrankW                     
  real(O)       :: ks, ind_refMed, ind_refRel, wavelength, anorm, surf(NsurfPD),    &
                   xpart, snorm, epsNint, epsNrank, epsMrank, x1, y1, z1, alpha1,   &
                   beta1, gamma1, Rcirc, x, grd 
  character(80) :: FileTmat, FileTmatG, string 
  logical       :: miror, axsym1, chiral1, DoConvTest, ExtThetaDom, PrnProgress,    &
                   XFindPar
! -----------------------------------------------------------------------------------
!                         Read the input file FileInputINHOM                        ! 
! ----------------------------------------------------------------------------------- 
  call DrvParameters 
  open (unit = iInputINHOM, file = FileInputINHOM, status = "old",                  &
        position = "rewind")   
  wavelength = 0.1_O * 2._O * Pi
  ind_refMed = 1._O
  ind_refRel = 1.2_O
  string     = 'OptProp'
  if (XFindPar (iInputINHOM, string)) then
    read (iInputINHOM, *, iostat = ios) wavelength
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if
    read (iInputINHOM, *, iostat = ios) ind_refMed
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refMed;')"
      stop
    end if
    read (iInputINHOM, *, iostat = ios) ind_refRel
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refRel;')"
      stop
    end if      
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if
  ks = 2._O * Pi * ind_refMed / wavelength   
!
  TypeGeom = 1
  Nsurf = 2
  do i = 1, NsurfPD
    surf(i) = 1._O
  end do
  Nparam = 1
  anorm  = 1._O
  Rcirc  = 1._O
  miror  = .true. 
  string = 'GeomPropHost'
  if (XFindPar (iInputINHOM, string)) then    
    read (iInputINHOM, *, iostat = ios) TypeGeom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable TypeGeom;')"
      stop
    end if         
    read (iInputINHOM, *, iostat = ios) Nsurf
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nsurf;')"
      stop
    end if
    if (Nsurf > NsurfPD) then
      print "(/,2x,'Input error: Nsurf exceeds NsurfPD;')"                                    
      stop
    end if    
    do i = 1, Nsurf
      read (iInputINHOM, *, iostat = ios) surf(i)
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable surf;')"
        stop
      end if
    end do    
    read (iInputINHOM, *, iostat = ios) Nparam
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nparam;')"
      stop
    end if
    read (iInputINHOM, *, iostat = ios) anorm
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anorm;')"
      stop
    end if
    read (iInputINHOM, *, iostat = ios) Rcirc
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Rcirc;')"
      stop
    end if
    read (iInputINHOM, *, iostat = ios) miror
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable miror;')"
      stop
    end if                                                
  else
    print "(/,2x,'Group name GeomPropHost not found;')"
    stop  
  end if      
  call check_geomAXSYM (TypeGeom, Nsurf, Nparam)
  call check_geomAXSYMOblate (TypeGeom, Nsurf, surf) 
  call check_anorm (anorm)  
  xpart = ks * anorm
  snorm = Pi * xpart * xpart     
!
  FileTmat = '../TMATFILES/T.dat'
  axsym1   = .true.
  chiral1  = .false.
  Nrank1   = 6
  Mrank1   = 4  
  string = 'TmatIncl'
  if (XFindPar (iInputINHOM, string)) then    
    read (iInputINHOM, *, iostat = ios) FileTmat
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileTmat;')"
      stop
    end if         
    read (iInputINHOM, *, iostat = ios) axsym1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable axsym1;')"
      stop
    end if       
    read (iInputINHOM, *, iostat = ios) chiral1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable chiral1;')"
      stop
    end if
    read (iInputINHOM, *, iostat = ios) Nrank1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nrank1;')"
      stop
    end if
    read (iInputINHOM, *, iostat = ios) Mrank1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Mrank1;')"
      stop
    end if                                                   
  else
    print "(/,2x,'Group name TmatIncl not found;')"
    stop  
  end if                              
  call check_MrankNrank (Mrank1, Nrank1)   
!
  x1 = 0.1_O
  y1 = 0.1_O
  z1 = 0.1_O
  alpha1 = 45._O
  beta1  = 45._O
  gamma1 = 0._O
  string = 'GeomPropIncl'
  if (XFindPar (iInputINHOM, string)) then    
    read (iInputINHOM, *, iostat = ios) x1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable x1;')"
      stop
    end if         
    read (iInputINHOM, *, iostat = ios) y1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable y1;')"
      stop
    end if       
    read (iInputINHOM, *, iostat = ios) z1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable z1;')"
      stop
    end if
    read (iInputINHOM, *, iostat = ios) alpha1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable alpha1;')"
      stop
    end if
    read (iInputINHOM, *, iostat = ios) beta1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable beta1;')"
      stop
    end if 
    read (iInputINHOM, *, iostat = ios) gamma1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable gamma1;')"
      stop
    end if
  else
    print "(/,2x,'Group name GeomPropIncl not found;')"
    stop  
  end if    
  grd    = Pi / 180._O
  alpha1 = alpha1 * grd
  beta1  = beta1  * grd
  gamma1 = gamma1 * grd
!
  DoConvTest   = .true.
  ExtThetaDom  = .true.
  string       = 'ConvTest'
  if (XFindPar (iInputINHOM, string)) then
    read (iInputINHOM, *, iostat = ios) DoConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DoConvTest;')"
      stop
    end if
    read (iInputINHOM, *, iostat = ios) ExtThetaDom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ExtThetaDom;')"
      stop
    end if        
  else
    print "(/,2x,'Group name ConvTest not found;')"
    stop  
  end if      
!  
  if (DoConvTest) then    
    print "(/,2x,'Convergence Test for an Inhomogeneous Particle')"
    print "(  2x,'----------------------------------------------')"          
  else
    print "(/,2x,'T-Matrix Computation for an Inhomogeneous Particle')"
    print "(  2x,'--------------------------------------------------')"
  end if
!
  x = ks * Rcirc          
  NrankW = int(x + 4.05_O * x**0.33_O + 2._O)
  if (.not. DoConvTest) then    
    Nint   = 100
    Nrank  =  16
    Mrank  =   8
    string = 'NintNrankMrankHost'
    if (XFindPar (iInputINHOM, string)) then
      read (iInputINHOM, *, iostat = ios) Nint
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nint;')"
        stop
      end if
      read (iInputINHOM, *, iostat = ios) Nrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nrank;')"
        stop
      end if 
      read (iInputINHOM, *, iostat = ios) Mrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Mrank;')"
        stop
      end if
    else
      print "(/,2x,'Group name NintNrankMrankHost not found;')"
      stop  
    end if
    print "(/,2x,'Input values:')"
    print "(  2x,'the input values of  Nint,  Nrank and  Mrank are ',i4,',',i4)",   &
              Nint, Nrank
    print "(  2x,'and ',i4,', respectively, while the estimated value of Nrank')",  &
              Mrank 
    print "(  2x,'from Wiscombe''s criterion is ', i3,';')", NrankW              
  else  
    print "(/,2x,'Nrank estimate:')"                                                    
    print "(  2x, a, i3, a)",                                                       &
   'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'
    print "(/,2x,'- enter the estimated values of Nint, Nrank and Mrank, where')"
    print "(  2x,'  Nint = Ndgs * Nrank, Ndgs = 10,12,... , and for almost spherical')"
    print "(  2x,'  particles Mrank = Nrank - 2,...,Nrank, while for less spherical;')"
    print "(  2x,'  Mrank can be smaller than Nrank - 2;')"    
    call read_integer3 (Nint, Nrank, Mrank)
  end if
  call check_MrankNrank (Mrank, Nrank)
  if (Nrank < Nrank1) print "(/,2x,'Warning: Nrank is too low;')"
  if (Mrank < Mrank1) print "(/,2x,'Warning: Mrank is too low;')"
!  
  if (DoConvTest) then      
    print "(/,2x, a)",                                                              &
   '- enter the type of convergence test: 1 - Nint, 2 - Nrank and Mrank;'
    call read_integerbound (TypeConvTest, 1, 2)                      
  else
    TypeConvTest = 0
  end if
!
  epsNint  = 5.e-2_O
  epsNrank = 5.e-2_O
  epsMrank = 5.e-2_O
  dNint    = 4
  string   = 'Errors'
  if (XFindPar (iInputINHOM, string)) then
    read (iInputINHOM, *, iostat = ios) epsNint
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNint;')"
      stop
    end if
    read (iInputINHOM, *, iostat = ios) epsNrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNrank;')"
      stop
    end if
    read (iInputINHOM, *, iostat = ios) epsMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsMrank;')"
      stop
    end if
    read (iInputINHOM, *, iostat = ios) dNint
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable dNint;')"
      stop
    end if
  else
    print "(/,2x,'Group name Errors not found;')"
    stop  
  end if
!     
  FileTmatG = '../TMATFILES/TG.dat'
  string    = 'Tmat'
  if (XFindPar (iInputINHOM, string)) then
    read (iInputINHOM, *, iostat = ios) FileTmatG
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileTmatG;')"
      stop
    end if           
  else
    print "(/,2x,'Group name Tmat not found;')"
    stop  
  end if    
!
  PrnProgress = .true.
  string      = 'PrintProgress'
  if (XFindPar (iInputINHOM, string)) then
    read (iInputINHOM, *, iostat = ios) PrnProgress
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if           
  else
    print "(/,2x,'Group name PrintProgress not found;')"
    stop  
  end if           
  close (unit = iInputINHOM)
end subroutine readinputINHOM
!***********************************************************************************
subroutine printinputINHOM (TypeGeom, Nsurf, surf, Nparam, miror, FileTmat, axsym1, &
           Mrank1, Nrank1, x1, y1, z1, alfa1, beta1, gama1, wavelength, anorm,      &
           Rcirc, ind_refMed, ind_refRel, dNint, epsNint, epsNrank, epsMrank)
  use parameters
  implicit none
  integer       :: TypeGeom, Nsurf, Nparam, dNint, Mrank1, Nrank1, i, LenString
  real(O)       :: wavelength, anorm, ind_refMed, ind_refRel, surf(Nsurf), x1, y1,  &
                   z1, alfa1, beta1, gama1, epsNint, epsNrank, epsMrank, Rcirc
  character(80) :: FileTmat, FileTmatWrite
  logical       :: miror, axsym1
!
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x,'wavelength of the free space, wavelength = ',1pe13.4,';')")  &
         wavelength
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'refractive index of the ambient medium, ind_refMed = ', ind_refMed, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'relative refractive index of the host particle, ind_refRel = ', ind_refRel, ';'
  write (iOutput,*)
  write (iOutput,"(2x,'index of the host particle geometry, TypeGeom = ',i2,';')")  &
         TypeGeom
  if (TypeGeom == 1) then
    write (iOutput,"(2x,'spheroid;')")  
  else if (TypeGeom == 2) then
    write (iOutput,"(2x,'cylinder;')")
  else if (TypeGeom == 3) then
    write (iOutput,"(2x,'rounded oblate cylinder;')")           
  end if
  write (iOutput,"(2x,'number of surface parameters, Nsurf = ',i2,';')") Nsurf
  write (iOutput,"(2x,'surface parameters:')")
  do i = 1, Nsurf   
    write (iOutput,"(2x,'surf(',i2,') = ',1pe10.3,',')") i, surf(i)    
  end do        
  if (TypeGeom == 1) then
    write (iOutput,"(2x,'where surf(1) is the half-axis along the symmetry axis')")
    write (iOutput,"(2x,'and   surf(2) is the second half-axis;')")
  else if (TypeGeom == 2 .or. TypeGeom == 3) then
    write (iOutput,"(2x,'where surf(1) is the half-length of the cylinder')")
    write (iOutput,"(2x,'and   surf(2) is the cylinder radius;')")
  end if     
  write (iOutput,"(2x,'number of integration surfaces, Nparam = ',i2,';')") Nparam
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'characteristic length of the host particle, anorm = ', anorm, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'radius of the circumscribing sphere, Rcirc = ', Rcirc, ';'
  if (miror) write (iOutput,"(2x,'mirror symmetric host particle;')")  
  write (iOutput,*)
  FileTmatWrite = FileTmat(14:LenString(FileTmat))
  write (iOutput,"(2x, a, a)")                                                      &
 'name of the file containing the T matrix of the inclusion = ', FileTmatWrite
  if (axsym1) then
    write (iOutput,"(2x,'axisymmetric inclusion;')")
    write (iOutput,"(2x,'maximum expansion order, Nrank = ',i3,';')") Nrank1
    write (iOutput,"(2x,'maximum azimuthal order, Mrank = ',i3,';')") Mrank1    
  else
    write (iOutput,"(2x,'nonaxisymmetric inclusion;')")
    write (iOutput,"(2x,'maximum expansion order, Nrank =',i3,';')") Nrank1
    write (iOutput,"(2x,'maximum azimuthal order, Mrank =',i3,';')") Mrank1     
  end if
  write (iOutput,"(2x, a, 1pe10.3, a, 1pe10.3, a, 1pe10.3, a)")                     &
 'Cartesian coordinates of the inclusion: x = ', x1, ', y = ', y1, ', z = ', z1, ';'             
  write (iOutput,"(2x, a, 1pe10.3, a, 1pe10.3, a, 1pe10.3, a)")                     &
 'Euler angles: alpha = ', alfa1 * 180._O / Pi, ', beta = ', beta1 * 180._O / Pi,   &
 ', gamma = ', gama1 * 180._O / Pi, ';'  
  write (iOutput,*)
  write (iOutput,"(2x,'integration tolerance, epsNint = ',1pe10.3,';')") epsNint
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum expansion order tolerance, epsNrank = ', epsNrank, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum azimuthal order tolerance, epsMrank = ', epsMrank, ';'          
  write (iOutput,"(2x,'integration step, dNint = ',i4,'.')") dNint
  write (iOutput,"(/)")                       
end subroutine printinputINHOM
!***********************************************************************************
subroutine convergence_NintINHOM (TypeGeom, ks, ind_ref, snorm, Nsurf, surf, Nparam,&
           Mrank, Nrank, Nint, dNint, miror, x1, y1, z1, alfa1, beta1, gama1,       &
           Mrank1, Nrank1, FileTmat, axsym1, chiral1, epsNint, ExtThetaDom,         &
           PrnProgress)
  use parameters
  implicit none
  integer       :: TypeGeom, Nsurf, Nparam, Mrank, Nrank, Nint, dNint, Mrank1,      &
                   Nrank1
  real(O)       :: ks, ind_ref, snorm, surf(Nsurf), x1, y1, z1, alfa1, beta1,       &
                   gama1, epsNint
  character(80) :: FileTmat
  logical       :: miror, axsym1, chiral1, ExtThetaDom, PrnProgress
!
  integer       :: Nmax, Nmax1, Nteta, NthetaConv, iNint, NmaxAL, nt1g, mt1g, i
  real(O)       :: k, alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,  &
                   Cext, Qext 
  complex(O)    :: ind_refC
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), b(:,:), d(:,:), t1(:,:), s(:,:), c(:), c1(:)  
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Nmax   = Nrank + Mrank * (2 * Nrank - Mrank + 1) 
  Nmax1  = Nrank1 + Mrank1 * (2 * Nrank1 - Mrank1 + 1)
  NmaxAL = max(Nmax,Nmax1) 
  k = ks * ind_ref
  ind_refC = cmplx(ind_ref,0.0,O)
  call write_TypeConvHead (1)
  allocate (a(2*NmaxAL,2*NmaxAL), b(2*NmaxAL,2*NmaxAL), d(2*NmaxAL,2*NmaxAL),       &
            s(2*NmaxAL,2*NmaxAL), c(2*NmaxAL),c1(2*NmaxAL))  
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do
  open (unit = iTmat, file = FileTmat, status = "old", position = "rewind")
  if (.not. axsym1) then
    call read_HeadFileTmat (nt1g, mt1g)
    call check_dimensionMat (nt1g, mt1g, Nmax1)       
    allocate (t1(2*nt1g,2*mt1g))
    call read_FileTmat (nt1g, mt1g, t1) 
  else
    nt1g = Nmax1
    mt1g = Nmax1
    allocate (t1(2*nt1g,2*mt1g))
    call read_Tmatrix (chiral1, Nrank1, Mrank1, Nmax1, t1, nt1g, mt1g)            
  end if
  close (unit = iTmat)
  if (PrnProgress) call write_progress (.true., 1, 9)     
  call MatTransRot_TR_mn_m1n1 (1, k, x1, y1, z1, alfa1, beta1, gama1, Mrank,        &
       Nrank, Nmax, Mrank1, Nrank1, Nmax1, s, NmaxAL, NmaxAL)
  call product_matrices (2*Nmax, 2*Nmax1, 2*Nmax1, s, 2*NmaxAL, 2*NmaxAL, t1,       &
       2*nt1g, 2*mt1g)
  if (PrnProgress) call write_progress (.false., 2, 9)
  call MatRotTrans_RT_mn_m1n1 (1, k, x1, y1, z1, alfa1, beta1, gama1, Mrank1,       &
       Nrank1, Nmax1, Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)
  call product_matrices (2*Nmax, 2*Nmax1, 2*Nmax, s, 2*NmaxAL, 2*NmaxAL, a,         &
       2*NmaxAL, 2*NmaxAL)
  if (PrnProgress) call write_progress (.false., 3, 9)           
  do iNint = 1, 2
    allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, miror)
    call matrix_Q_sym (TypeGeom, 3, 3, ks, ind_refC, Nsurf, surf, Mrank, Nrank,     &
         Nmax, Nint, Nparam, Nintparam, paramG, weightsG, miror,.false., a,         &
         NmaxAL, NmaxAL)    
    call product_matrices (2*Nmax, 2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, s,        &
         2*NmaxAL, 2*NmaxAL)
    call matrix_Q_sym (TypeGeom, 3, 1, ks, ind_refC, Nsurf, surf, Mrank, Nrank,     &
         Nmax, Nint, Nparam, Nintparam, paramG, weightsG, miror,.false., d,         &
         NmaxAL, NmaxAL)
    call sum_matrices (2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, d, 2*NmaxAL, 2*NmaxAL)  
    if (PrnProgress) call write_progress (.false., 4+3*(iNint-1), 9)     
    call matrix_Q_sym (TypeGeom, 1, 3, ks, ind_refC, Nsurf, surf, Mrank, Nrank,     &
         Nmax, Nint, Nparam, Nintparam, paramG, weightsG, miror,.false., b,         &
         NmaxAL, NmaxAL)
    call product_matrices (2*Nmax, 2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, s,        &
         2*NmaxAL, 2*NmaxAL)  
    call matrix_Q_sym (TypeGeom, 1, 1, ks, ind_refC, Nsurf, surf, Mrank, Nrank,     &
         Nmax, Nint, Nparam, Nintparam, paramG, weightsG, miror,.false., d,         &
         NmaxAL, NmaxAL) 
    call sum_matrices (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, d, 2*NmaxAL, 2*NmaxAL)  
    if (PrnProgress) call write_progress (.false., 5+3*(iNint-1), 9)     
    call LU_SYSTEM (a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL, 2*Nmax)
    if (PrnProgress) call write_progress (.false., 6+3*(iNint-1), 9)     
    call minus_matrix (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL)
    call PWcoefficients_ab (tetaGI, phiGI, alfa, beta, gama, alfap, Mrank, Nrank,   &
         Nmax, c)    
    call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, c, c1)
    call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfa, beta, gama, ks, snorm,   &
         ExtThetaDom,.true., h, v)
    call CQscat (c1, Mrank, Nrank, Nmax, ks, snorm, Cscat, Qscat)
    call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfa, beta, gama,            &
         alfap, ks, snorm, Cext, Qext)
    call delta_DSCS (Nteta, h, v, oldh, oldv, epsNint, NthetaConv)       
    call write_3ConvParam (Nint, Nrank, Mrank)                  
    call write_DSCS (Nteta, ExtThetaDom, h, v)
    call write_Effic (Qscat, Qext)
    Nint = Nint + dNint
    deallocate (paramG, weightsG, Nintparam)
  end do
  call write_NintConvRes (NthetaConv, Nteta, epsNint)
  deallocate (a, b, d, c, c1, t1, s, h, v, oldh, oldv)  
end subroutine convergence_NintINHOM
!***********************************************************************************
subroutine convergence_Nrank_MrankINHOM (TypeGeom, ks, ind_ref, snorm, Nsurf, surf, &
           Nparam, Mrank, Nrank, Nint, miror, x1, y1, z1, alfa1, beta1, gama1,      &
           Mrank1, Nrank1, FileTmat, axsym1, chiral1, epsNrank, epsMrank,           &
           ExtThetaDom, FileTmatG, PrnProgress)
  use parameters
  implicit none
  integer       :: TypeGeom, Nsurf, Nparam, Mrank, Nrank, Nint, Mrank1, Nrank1
  real(O)       :: ks, ind_ref, snorm, surf(Nsurf), x1, y1, z1, alfa1, beta1,       &
                   gama1, epsNrank, epsMrank
  character(80) :: FileTmat, FileTmatG
  logical       :: miror, axsym1, chiral1, ExtThetaDom, PrnProgress
!
  integer       :: Nmax, Nmax1, Nteta, i, NthetaConvN, NthetaConvM, NmaxAL,         &
                   nt1g, mt1g
  real(O)       :: k, alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,  &
                   Cext, Qext, r1, sumang
  complex(O)    :: ind_refC
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:),                 &
                            oldh(:), oldv(:), oldh0(:), oldv0(:)
  complex(O),allocatable :: a(:,:), b(:,:), d(:,:), c(:), c1(:),                    &
                            t1(:,:), s(:,:), q11(:,:), q13(:,:),                    &
                            q31(:,:), q33(:,:)     
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Nmax   = Nrank + Mrank * (2 * Nrank - Mrank + 1) 
  Nmax1  = Nrank1 + Mrank1 * (2 * Nrank1 - Mrank1 + 1) 
  NmaxAL = max(Nmax,Nmax1)
  k = ks * ind_ref
  ind_refC = cmplx(ind_ref,0.0,O)               
  call write_TypeConvHead (4)
  allocate (a(2*NmaxAL,2*NmaxAL), b(2*NmaxAL,2*NmaxAL), d(2*NmaxAL,2*NmaxAL),       &
            c(2*NmaxAL), c1(2*NmaxAL))
  allocate (s(2*NmaxAL,2*NmaxAL), q11(2*NmaxAL,2*NmaxAL), q13(2*NmaxAL,2*NmaxAL),   &
            q31(2*NmaxAL,2*NmaxAL), q33(2*NmaxAL,2*NmaxAL))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta), oldh0(Nteta),             &
            oldv0(Nteta))                        
  allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
  call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,                &
       Nintparam, paramG, weightsG, miror)         
! --- Nrank configuration --- 
  open (unit = iTmat, file = FileTmat, status = "old", position = "rewind")
  if (.not. axsym1) then
    call read_HeadFileTmat (nt1g, mt1g)
    call check_dimensionMat (nt1g, mt1g, Nmax1)       
    allocate (t1(2*nt1g,2*mt1g))
    call read_FileTmat (nt1g, mt1g, t1) 
  else
    nt1g = Nmax1
    mt1g = Nmax1
    allocate (t1(2*nt1g,2*mt1g))
    call read_Tmatrix (chiral1, Nrank1, Mrank1, Nmax1, t1, nt1g, mt1g)            
  end if
  close (unit = iTmat)
  open  (unit = iTmat, file = FileTmatG, status = 'replace')
  call  write_HeadFileTmat (NmaxAL, NmaxAL) 
  if (PrnProgress) call  write_progress (.true., 1, 6)
  r1 = sqrt(x1**2 + y1**2 + z1**2)
  sumang = abs(alfa1) + abs(beta1) + abs(gama1)
  if (r1 /= 0 .and. sumang /= 0) then
    call MatTransRot_TR_mn_m1n1 (1, k, x1, y1, z1, alfa1, beta1, gama1, Mrank,      &
         Nrank, Nmax, Mrank1, Nrank1, Nmax1, s, NmaxAL, NmaxAL)
  else if (r1 /= 0 .and. sumang == 0) then 
    call MatTransAB_mn_m1n1 (1, k, x1, y1, z1, Mrank, Nrank, Nmax, Mrank1, Nrank1,  &
         Nmax1, s, NmaxAL, NmaxAL)
  else if (r1 == 0 .and. sumang /= 0) then    
    call MatRot_R_mn_m1n1 (alfa1, beta1, gama1, Mrank, Nrank, Nmax, Mrank1, Nrank1, &
         Nmax1, s, NmaxAL, NmaxAL, .true.)
  else if (r1 == 0 .and. sumang == 0) then
    call identity_transformation (Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1, s,     &
         NmaxAL, NmaxAL)    
  end if  
  call product_matrices (2*Nmax, 2*Nmax1, 2*Nmax1, s, 2*NmaxAL, 2*NmaxAL, t1,       &
       2*nt1g, 2*mt1g)
  if (PrnProgress) call write_progress (.false., 2, 6)
  if (r1 /=0 .and. sumang /= 0) then
    call MatRotTrans_RT_mn_m1n1 (1, k, x1, y1, z1, alfa1, beta1, gama1, Mrank1,     &
         Nrank1, Nmax1, Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)
  else if (r1 /=0 .and. sumang == 0) then 
    call MatTransAB_mn_m1n1 (1, k, -x1, -y1, -z1, Mrank1, Nrank1, Nmax1, Mrank,     &
         Nrank, Nmax, a, NmaxAL, NmaxAL)
  else if (r1 == 0 .and. sumang /= 0) then    
    call MatRot_R_mn_m1n1 (-gama1, -beta1, -alfa1, Mrank1, Nrank1, Nmax1, Mrank,    &
         Nrank, Nmax, a, NmaxAL, NmaxAL, .true.)
  else if (r1 == 0 .and. sumang == 0) then
    call identity_transformation (Mrank1, Nrank1, Nmax1, Mrank, Nrank, Nmax, a,     &
         NmaxAL, NmaxAL)    
  end if   
  call product_matrices (2*Nmax, 2*Nmax1, 2*Nmax, s, 2*NmaxAL, 2*NmaxAL, a,         &
       2*NmaxAL, 2*NmaxAL) 
  if (PrnProgress) call write_progress (.false., 3, 6)          
  call matrix_Q_sym (TypeGeom, 3, 3, ks, ind_refC, Nsurf, surf, Mrank, Nrank, Nmax, &
       Nint, Nparam, Nintparam, paramG, weightsG, miror,.false., a, NmaxAL, NmaxAL)
  call copy_matrix (2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, q33, 2*NmaxAL, 2*NmaxAL)
  call product_matrices (2*Nmax, 2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, s,          &
       2*NmaxAL, 2*NmaxAL)
  call matrix_Q_sym (TypeGeom, 3, 1, ks, ind_refC, Nsurf, surf, Mrank, Nrank, Nmax, &
       Nint, Nparam, Nintparam, paramG, weightsG, miror,.false., q31, NmaxAL, NmaxAL)
  call sum_matrices (2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, q31, 2*NmaxAL, 2*NmaxAL)  
  if (PrnProgress) call write_progress (.false., 4, 6)
  call matrix_Q_sym (TypeGeom, 1, 3, ks, ind_refC, Nsurf, surf, Mrank, Nrank, Nmax, &
       Nint, Nparam, Nintparam, paramG, weightsG, miror,.false., b, NmaxAL, NmaxAL)
  call copy_matrix (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, q13, 2*NmaxAL, 2*NmaxAL) 
  call product_matrices (2*Nmax, 2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, s,          &
       2*NmaxAL, 2*NmaxAL)  
  call matrix_Q_sym (TypeGeom, 1, 1, ks, ind_refC, Nsurf, surf, Mrank, Nrank, Nmax, &
       Nint, Nparam, Nintparam, paramG, weightsG, miror,.false., q11, NmaxAL, NmaxAL) 
  call sum_matrices (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, q11, 2*NmaxAL, 2*NmaxAL)  
  if (PrnProgress) call write_progress (.false., 5, 6)
  call LU_SYSTEM (a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 6, 6)
  call minus_matrix (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL)
  call write_FileTmat (NmaxAL, NmaxAL, b)       
  call PWcoefficients_ab (tetaGI, phiGI, alfa, beta, gama, alfap, Mrank, Nrank,     &
       Nmax,c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfa, beta, gama, ks, snorm,     &
       ExtThetaDom,.true., h, v)
  call CQscat (c1, Mrank, Nrank, Nmax, ks, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfa, beta, gama,              &
       alfap, ks, snorm, Cext, Qext)       
  call write_3ConvParam (Nint, Nrank, Mrank)    
  call write_DSCS (Nteta, ExtThetaDom, h, v)
  call write_Effic (Qscat, Qext)
  do i = 1, Nteta
    oldh(i)  = h(i)
    oldv(i)  = v(i)
    oldh0(i) = h(i)
    oldv0(i) = v(i)
  end do 
  close (unit = iTmat)  
! --- (Nrank - 1) configuration ---
  if (PrnProgress) call write_progress_low
  call copy_matrix (2*Nmax, 2*Nmax, q33, 2*NmaxAL, 2*NmaxAL, a, 2*NmaxAL, 2*NmaxAL)
  call matrix_Nrank_1_right (Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)
  call product_matrices (2*Nmax, 2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, s,          &
       2*NmaxAL, 2*NmaxAL)
  call copy_matrix (2*Nmax, 2*Nmax, q31, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)
  call matrix_Nrank_1_right (Mrank, Nrank, Nmax, b, NmaxAL, NmaxAL)
  call sum_matrices (2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)
  call matrix_Nrank_1_left (Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)  
  call copy_matrix (2*Nmax, 2*Nmax, q13, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)
  call matrix_Nrank_1_right (Mrank, Nrank, Nmax, b, NmaxAL, NmaxAL)
  call product_matrices (2*Nmax, 2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, s,          &
       2*NmaxAL, 2*NmaxAL)
  call copy_matrix (2*Nmax, 2*Nmax, q11, 2*NmaxAL, 2*NmaxAL, d, 2*NmaxAL, 2*NmaxAL)
  call matrix_Nrank_1_right (Mrank, Nrank, Nmax, d, NmaxAL, NmaxAL)
  call sum_matrices (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, d, 2*NmaxAL, 2*NmaxAL)
  call matrix_Nrank_1_right (Mrank, Nrank, Nmax, b, NmaxAL, NmaxAL)  
  call LU_SYSTEM (a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL, 2*Nmax)
  call minus_matrix (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL) 
  call PWcoefficients_ab (tetaGI, phiGI, alfa, beta, gama, alfap, Mrank, Nrank,     &
       Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfa, beta, gama, ks, snorm,     &
       ExtThetaDom,.true., h, v)
  call CQscat (c1, Mrank, Nrank, Nmax, ks, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfa, beta, gama,              &
       alfap, ks, snorm, Cext, Qext)
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConvN)
  call write_3ConvParam (Nint, Nrank - 1, Mrank)
  call write_DSCS (Nteta, ExtThetaDom, h, v)
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConvN, Nteta, epsNrank)
! --- (Mrank - 1) configuration ---
  call copy_matrix (2*Nmax, 2*Nmax, q33, 2*NmaxAL, 2*NmaxAL, a, 2*NmaxAL, 2*NmaxAL)
  call matrix_Mrank_1_right (Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)
  call product_matrices (2*Nmax, 2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, s,          &
       2*NmaxAL, 2*NmaxAL)
  call copy_matrix (2*Nmax, 2*Nmax, q31, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)
  call matrix_Mrank_1_right (Mrank, Nrank, Nmax, b, NmaxAL, NmaxAL)
  call sum_matrices (2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)
  call matrix_Mrank_1_left (Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)
  call copy_matrix (2*Nmax, 2*Nmax, q13, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)
  call matrix_Mrank_1_right (Mrank, Nrank, Nmax, b, NmaxAL, NmaxAL)
  call product_matrices (2*Nmax, 2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, s,          &
       2*NmaxAL, 2*NmaxAL)
  call copy_matrix (2*Nmax, 2*Nmax, q11, 2*NmaxAL, 2*NmaxAL, d, 2*NmaxAL, 2*NmaxAL)
  call matrix_Mrank_1_right (Mrank, Nrank, Nmax, d, NmaxAL, NmaxAL)
  call sum_matrices (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, d, 2*NmaxAL, 2*NmaxAL)
  call matrix_Mrank_1_right (Mrank, Nrank, Nmax, b, NmaxAL, NmaxAL)
  call LU_SYSTEM (a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL, 2*Nmax)
  call minus_matrix (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL)
  call PWcoefficients_ab (tetaGI, phiGI, alfa, beta, gama, alfap, Mrank, Nrank,     &
       Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfa, beta, gama, ks, snorm,     &
       ExtThetaDom,.true., h, v)
  call CQscat (c1, Mrank, Nrank, Nmax, ks, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfa, beta, gama,              &
       alfap, ks, snorm, Cext, Qext)
  call delta_DSCS (Nteta, h, v, oldh0, oldv0, epsMrank, NthetaConvM)
  call write_3ConvParam (Nint, Nrank, Mrank - 1)
  call write_DSCS (Nteta, ExtThetaDom, h, v)
  call write_Effic (Qscat, Qext)
  call write_MrankConvRes (NthetaConvM, epsMrank)
  if (NthetaConvN >= int(0.8*Nteta) .and. NthetaConvM >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criteria for Nrank and Mrank are satisfied;')"                                      
  else
    print "(/,2x,'Convergence criteria for Nrank and Mrank are not satisfied;')"
  end if 
  call write_InfoFileTmat (FileTmatG, Mrank, Nrank, .false., .false., .false.)
  call ScatCharact (ks, FileTmatG, Mrank, Nrank, .false., .false., .false.) 
  print "(/,2x,'T matrix is stored in ',a50)", FileTmatG
  print "(  2x,'The dimensions of the T matrix are given by:')" 
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank    
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank  
  deallocate (paramG, weightsG, Nintparam) 
  deallocate (a, b, d, c, c1, t1, s, q11, q13, q31, q33, h, v, oldh, oldv,          &
              oldh0, oldv0)     
end subroutine convergence_Nrank_MrankINHOM
!***********************************************************************************
subroutine TMatrix_Nrank_MrankINHOM (TypeGeom, ks, ind_ref, Nsurf, surf, Nparam,    &
           Mrank, Nrank, Nint, miror, x1, y1, z1, alfa1, beta1, gama1, Mrank1,      &
           Nrank1, FileTmat, axsym1, chiral1, FileTmatG, PrnProgress)
  use parameters
  implicit none
  integer       :: TypeGeom, Nsurf, Nparam, Mrank, Nrank, Nint, Mrank1, Nrank1
  real(O)       :: ks, ind_ref, surf(Nsurf), x1, y1, z1, alfa1, beta1, gama1
  character(80) :: FileTmat, FileTmatG
  logical       :: miror, axsym1, chiral1, PrnProgress
!
  integer       :: Nmax, Nmax1, NmaxAL, nt1g, mt1g
  real(O)       :: k, r1, sumang
  complex(O)    :: ind_refC
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:)
  complex(O),allocatable :: a(:,:), b(:,:), t1(:,:), s(:,:), q11(:,:), q31(:,:)     
!  
  Nmax   = Nrank + Mrank * (2 * Nrank - Mrank + 1) 
  Nmax1  = Nrank1 + Mrank1 * (2 * Nrank1 - Mrank1 + 1) 
  NmaxAL = max(Nmax,Nmax1)
  k = ks * ind_ref
  ind_refC = cmplx(ind_ref,0.0,O)                 
  allocate (a(2*NmaxAL,2*NmaxAL), b(2*NmaxAL,2*NmaxAL))
  allocate (s(2*NmaxAL,2*NmaxAL), q11(2*NmaxAL,2*NmaxAL), q31(2*NmaxAL,2*NmaxAL))                        
  allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
  call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,                &
       Nintparam, paramG, weightsG, miror)         
  open (unit = iTmat, file = FileTmat, status = "old", position = "rewind")
  if (.not. axsym1) then
    call read_HeadFileTmat (nt1g, mt1g)
    call check_dimensionMat (nt1g, mt1g, Nmax1)       
    allocate (t1(2*nt1g,2*mt1g))
    call read_FileTmat (nt1g, mt1g, t1) 
  else
    nt1g = Nmax1
    mt1g = Nmax1
    allocate (t1(2*nt1g,2*mt1g))
    call read_Tmatrix (chiral1, Nrank1, Mrank1, Nmax1, t1, nt1g, mt1g)            
  end if
  close (unit = iTmat)
  open  (unit = iTmat, file = FileTmatG, status = 'replace')
  call  write_HeadFileTmat (NmaxAL, NmaxAL) 
  if (PrnProgress) call  write_progress (.true., 1, 6)
  r1 = sqrt(x1**2 + y1**2 + z1**2)
  sumang = abs(alfa1) + abs(beta1) + abs(gama1)
  if (r1 /= 0 .and. sumang /= 0) then
    call MatTransRot_TR_mn_m1n1 (1, k, x1, y1, z1, alfa1, beta1, gama1, Mrank,      &
         Nrank, Nmax, Mrank1, Nrank1, Nmax1, s, NmaxAL, NmaxAL)
  else if (r1 /= 0 .and. sumang == 0) then 
    call MatTransAB_mn_m1n1 (1, k, x1, y1, z1, Mrank, Nrank, Nmax, Mrank1, Nrank1,  &
         Nmax1, s, NmaxAL, NmaxAL)
  else if (r1 == 0 .and. sumang /= 0) then    
    call MatRot_R_mn_m1n1 (alfa1, beta1, gama1, Mrank, Nrank, Nmax, Mrank1, Nrank1, &
         Nmax1, s, NmaxAL, NmaxAL, .true.)
  else if (r1 == 0 .and. sumang == 0) then
    call identity_transformation (Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1, s,     &
         NmaxAL, NmaxAL)    
  end if  
  call product_matrices (2*Nmax, 2*Nmax1, 2*Nmax1, s, 2*NmaxAL, 2*NmaxAL, t1,       &
       2*nt1g, 2*mt1g)
  if (PrnProgress) call write_progress (.false., 2, 6)
  if (r1 /=0 .and. sumang /= 0) then
    call MatRotTrans_RT_mn_m1n1 (1, k, x1, y1, z1, alfa1, beta1, gama1, Mrank1,     &
         Nrank1, Nmax1, Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)
  else if (r1 /=0 .and. sumang == 0) then 
    call MatTransAB_mn_m1n1 (1, k, -x1, -y1, -z1, Mrank1, Nrank1, Nmax1, Mrank,     &
         Nrank, Nmax, a, NmaxAL, NmaxAL)
  else if (r1 == 0 .and. sumang /= 0) then    
    call MatRot_R_mn_m1n1 (-gama1, -beta1, -alfa1, Mrank1, Nrank1, Nmax1, Mrank,    &
         Nrank, Nmax, a, NmaxAL, NmaxAL, .true.)
  else if (r1 == 0 .and. sumang == 0) then
    call identity_transformation (Mrank1, Nrank1, Nmax1, Mrank, Nrank, Nmax, a,     &
         NmaxAL, NmaxAL)    
  end if   
  call product_matrices (2*Nmax, 2*Nmax1, 2*Nmax, s, 2*NmaxAL, 2*NmaxAL, a,         &
       2*NmaxAL, 2*NmaxAL) 
  if (PrnProgress) call write_progress (.false., 3, 6)          
  call matrix_Q_sym (TypeGeom, 3, 3, ks, ind_refC, Nsurf, surf, Mrank, Nrank, Nmax, &
       Nint, Nparam, Nintparam, paramG, weightsG, miror,.false., a, NmaxAL, NmaxAL)
  call product_matrices (2*Nmax, 2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, s,          &
       2*NmaxAL, 2*NmaxAL)
  call matrix_Q_sym (TypeGeom, 3, 1, ks, ind_refC, Nsurf, surf, Mrank, Nrank, Nmax, &
       Nint, Nparam, Nintparam, paramG, weightsG, miror,.false., q31, NmaxAL, NmaxAL)
  call sum_matrices (2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, q31, 2*NmaxAL, 2*NmaxAL)  
  if (PrnProgress) call write_progress (.false., 4, 6)
  call matrix_Q_sym (TypeGeom, 1, 3, ks, ind_refC, Nsurf, surf, Mrank, Nrank, Nmax, &
       Nint, Nparam, Nintparam, paramG, weightsG, miror,.false., b, NmaxAL, NmaxAL) 
  call product_matrices (2*Nmax, 2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, s,          &
       2*NmaxAL, 2*NmaxAL)  
  call matrix_Q_sym (TypeGeom, 1, 1, ks, ind_refC, Nsurf, surf, Mrank, Nrank, Nmax, &
       Nint, Nparam, Nintparam, paramG, weightsG, miror,.false., q11, NmaxAL, NmaxAL) 
  call sum_matrices (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, q11, 2*NmaxAL, 2*NmaxAL)  
  if (PrnProgress) call write_progress (.false., 5, 6)
  call LU_SYSTEM (a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 6, 6)
  call minus_matrix (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL)
  call write_FileTmat (NmaxAL, NmaxAL, b)         
  close (unit = iTmat)  
  call write_InfoFileTmat (FileTmatG, Mrank, Nrank, .false., .false., .false.)
  call ScatCharact (ks, FileTmatG, Mrank, Nrank, .false., .false., .false.) 
  print "(/,2x,'T matrix is stored in ',a50)", FileTmatG
  print "(  2x,'The dimensions of the T matrix are given by:')" 
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank    
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank  
  deallocate (paramG, weightsG, Nintparam) 
  deallocate (a, b, t1, s, q11, q31)    
end subroutine TMatrix_Nrank_MrankINHOM

! **********************************************************************************
! *                  ROUTINES FOR CHECKING THE INPUT DATA                          *
! *    ------------------------------------------------------------------------    *
! *    Partial list of subroutines:                                                *
! *      check_MatPropAXSYM,       check_MatPropNONAXSYM,    check_inputAXSYM,     *
! *      check_inputNONAXSYM,      check_inputSCTAVRGSPH,    check_geomAXSYM,      *
! *      check_geomAXSYMOblate,    check_geom3D,             check_geomCOMP,       *      
! *      check_geomLAY,            check_MrankNrank,         check_chirality,      * 
! *      check_ind_ref,            check_ind_ref1,           check_ind_ref2,       *          
! *      check_ind_ref3,           check_Interpolation,      check_MatrixSolver,   *  
! *      check_Integration,        check_anorm,              check_tetaminmax,     *  
! *      check_Nphi,               check_teta_phiminmax,     check_betaminmax,     *  
! *      check_alfaminmax,         check_gamaminmax,         check_TypeExcit,      *        
! *      check_Random,             check_incident_direction, check_incdir_partsub, *    
! *      check_polarization_angle, check_azimuthal_plane,    check_MatrixElem,     *      
! *      check_StoreAvrgMtrSS,     check_NSimpson,                                 *
! *      check_NalphaNbetaNgamma.                                                  *
! *   Subroutines requiring the restarting of the program:                         * 
! *      check_dimensionMat,       check_dimensionVct,       check_circum_radii,   *
! *      check_MaxNrank,           check_MaxNface.                                 *
! **********************************************************************************
recursive subroutine check_MatPropAXSYM (perfectcond, chiral, kb)
  use parameters
  implicit none
  integer  :: ierr
  real(O)  :: kb
  logical  :: perfectcond, chiral, continuare
!  
  if (perfectcond .and. chiral) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the logical variables perfectcond and chiral are both true;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the logical variables perfectcond and chiral;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) perfectcond, chiral
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the logical variables perfectcond and chiral;')"
      end if
    end do
    call check_MatPropAXSYM (perfectcond, chiral, kb)
  end if
  if (chiral .and. kb == 0._O)                                                      &
  print "(/,2x,'Warning: the chirality parameter is zero;')"  
end subroutine check_MatPropAXSYM
!***********************************************************************************
recursive subroutine check_MatPropNONAXSYM (perfectcond, anisotrop, chiral, kb)
  use parameters
  implicit none
  integer       :: ierr
  real(O)       :: kb
  logical       :: perfectcond, chiral, anisotrop, continuare
!  
  if (perfectcond .and. chiral) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the logical variables perfectcond and chiral are both true;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the logical variables perfectcond and chiral;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) perfectcond, chiral
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the logical variables perfectcond and chiral;')"
      end if
    end do
    call check_MatPropNONAXSYM (perfectcond, anisotrop, chiral, kb)
  end if
  if (perfectcond .and. anisotrop) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the logical variables perfectcond and anisotrop are both true;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
      print "(2x,'- enter the logical variables perfectcond and anisotrop;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) perfectcond, anisotrop
        if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the logical variables perfectcond and anisotrop;')"
      end if
    end do
    call check_MatPropNONAXSYM (perfectcond, anisotrop, chiral, kb)
  end if
  if (chiral .and. anisotrop) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the logical variables chiral and anisotrop are both true;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
      print "(2x,'- enter the logical variables chiral and anisotrop;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) chiral, anisotrop
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the logical variables chiral and anisotrop;')"
      end if
    end do
    call check_MatPropNONAXSYM (perfectcond, anisotrop, chiral, kb)
  end if  
  if (chiral .and. kb == 0._O)                                                      &
  print "(/,2x,'Warning: the chirality parameter is zero;')"  
end subroutine check_MatPropNONAXSYM
! **********************************************************************************
recursive subroutine check_inputAXSYM (miror, chiral, DS)  
  implicit none
  integer  :: ierr
  logical  :: miror, DS, chiral, continuare
!
  if (miror .and. chiral) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'for chiral particles set the logical variable miror to false;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the logical variable miror;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) miror
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the logical variable miror;')"
      end if
    end do
    call check_inputAXSYM (miror, chiral, DS)
  end if
  if (miror .and. DS) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the logical variables miror and DS are both true;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
      print "(2x,'- enter the logical variables miror and DS;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) miror, DS
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the logical variables miror and DS;')"
      end if
    end do
    call check_inputAXSYM (miror, chiral, DS)
  end if    
end subroutine check_inputAXSYM
!***********************************************************************************
recursive subroutine check_inputNONAXSYM (FileGeom, FileFEM, miror, chiral,         &
          anisotrop, Nazimutsym) 
  implicit none
  integer       :: Nazimutsym, ierr
  logical       :: FileGeom, miror, chiral, anisotrop, continuare
  character(80) :: FileFEM
!
  if (FileGeom .and. FileFEM(1:1) == ' ') then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the name of the geometry file is omitted;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the name of the geometry file;')"
    call read_char80 (3, FileFEM)   
    call check_inputNONAXSYM (FileGeom, FileFEM, miror, chiral, anisotrop,          &
         Nazimutsym)
  end if
  if (miror .and. chiral) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'for chiral particles set the logical variable miror to false;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the logical variable miror;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) miror
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the logical variable miror;')"
      end if
    end do
    call check_inputNONAXSYM (FileGeom, FileFEM, miror, chiral, anisotrop,          &
         Nazimutsym)
  end if 
  if (miror .and. anisotrop) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'for anisotropic particles set the logical variable miror to false;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
      print "(2x,'- enter the logical variable miror;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) miror
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the logical variable miror;')"
      end if
    end do
    call check_inputNONAXSYM (FileGeom, FileFEM, miror, chiral, anisotrop,          &
         Nazimutsym)
  end if     
  if (anisotrop .and. Nazimutsym /= 0) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'for anisotropic particles set the integer variable Nazimutsym to 0;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
      print "(2x,'- enter the integer variable Nazimutsym;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) Nazimutsym
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the integer variable Nazimutsym;')"
      end if
    end do
    call check_inputNONAXSYM (FileGeom, FileFEM, miror, chiral, anisotrop,          &
         Nazimutsym)
  end if
end subroutine check_inputNONAXSYM
! **********************************************************************************
recursive subroutine check_inputSCTAVRGSPH (amin, amax, TypeDist, Npar)                          
  use parameters
  implicit none
  integer  :: TypeDist, Npar, ierr
  real(O)  :: amin, amax  
  logical  :: continuare 
!  
  if (TypeDist > 5) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'incorrect value of the variable TypeDist;')"
    print "(  2x,'the permissive values are:')"
    print "(  2x,'- 1 for the modified gamma distribution,')" 
    print "(  2x,'- 2 for the log normal distribution,')"
    print "(  2x,'- 3 for the gamma distribution,')"
    print "(  2x,'- 4 for the power law distribution,')"
    print "(  2x,'- 5 for the modified bimodal log normal distribution;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the variable TypeDist;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) TypeDist
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the variable TypeDist;')"
      end if
    end do
    call check_inputSCTAVRGSPH (amin, amax, TypeDist, Npar)
  end if 
  if (TypeDist == 1 .and. Npar /= 3) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'incorrect number of parameters for TypeDist = 1, set Npar to 3;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    print "(  2x,'  Note: the program can be continued if the input values of the')"
    print "(  2x,'  three parameters of the distribution are correct;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the number of parameters Npar;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) Npar
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the number of parameters Npar;')"
      end if
    end do
    call check_inputSCTAVRGSPH (amin, amax, TypeDist, Npar)
  else if (TypeDist == 2 .and. Npar /= 2) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'incorrect number of parameters for TypeDist = 2, set Npar to 2;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    print "(  2x,'  Note: the program can be continued if the input values of the')"
    print "(  2x,'  two parameters of the distribution are correct;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the number of parameters Npar;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) Npar
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the number of parameters Npar;')"
      end if
    end do
    call check_inputSCTAVRGSPH (amin, amax, TypeDist, Npar) 
  else if (TypeDist == 3 .and. Npar /= 2) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'incorrect number of parameters for TypeDist = 3, set Npar to 2;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    print "(  2x,'  Note: the program can be continued if the input values of the')"
    print "(  2x,'  two parameters of the distribution are correct;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the number of parameters Npar;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) Npar
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the number of parameters Npar;')"
      end if
    end do
    call check_inputSCTAVRGSPH (amin, amax, TypeDist, Npar)
  else if (TypeDist == 4 .and. Npar /= 1) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'incorrect number of parameters for TypeDist = 4, set Npar to 1;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    print "(  2x,'  Note: the program can be continued if the input value of the')"
    print "(  2x,'  parameter of the distribution is correct;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the number of parameters Npar;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) Npar
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the number of parameters Npar;')"
      end if
    end do
    call check_inputSCTAVRGSPH (amin, amax, TypeDist, Npar)
  else if (TypeDist == 5 .and. Npar /= 5) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'incorrect number of parameters for TypeDist = 5, set Npar to 5;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    print "(  2x,'  Note: the program can be continued if the input values of the')"
    print "(  2x,'  five parameters of the distribution are correct;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the number of parameters Npar;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) Npar
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the number of parameters Npar;')"
      end if
    end do
    call check_inputSCTAVRGSPH (amin, amax, TypeDist, Npar)
  end if
  if (amax < amin) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the lower bound of the size distribution exceeds the upper bound;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
      print "(2x,'- enter the bounds amin and amax;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) amin, amax
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the bounds amin and amax;')"
      end if
    end do
    call check_inputSCTAVRGSPH (amin, amax, TypeDist, Npar) 
  end if              
end subroutine check_inputSCTAVRGSPH
! **********************************************************************************
recursive subroutine check_geomAXSYM (TypeGeom, Nsurf, Nparam)
  implicit none
  integer  :: TypeGeom, Nsurf, Nparam, ierr
  logical  :: continuare   
!
  if (TypeGeom > 3) then
    print "(/,2x,'Warning: the geometry is not contained in the library;')"     
  end if 
  select case (TypeGeom)
  case (1)
    if (Nsurf  /= 2)  then
      print "(/,2x,'Error in the input file: set Nsurf to 2;')"
      print "(  2x, a)",                                                            &
     '- enter true to continue the program or false to stop the program; '
      print "(  2x, a)",                                                            &
     '  Note: the program can be continued if the input values of surf(1)'
      print "(  2x,'  and surf(2) are correct;')"
      call read_logical (continuare)
      if (.not. continuare) stop 
      print "(2x,'- enter the number of surface parameters Nsurf;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) Nsurf
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the number of surface parameters Nsurf;')"
        end if
      end do
      call check_geomAXSYM (TypeGeom, Nsurf, Nparam)
    end if
    if (Nparam /= 1)  then
      print "(/,2x,'Error in the input file: set Nparam to 1;')"
      print "(  2x, a)",                                                            &
     '- enter true to continue the program or false to stop the program;'
      call read_logical (continuare)
      if (.not. continuare) stop 
      print "(2x,'- enter the number of parameters Nparam;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) Nparam
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the number of parameters Nparam;')"
        end if
      end do
      call check_geomAXSYM (TypeGeom, Nsurf, Nparam)
    end if
  case (2,3)
    if (Nsurf  /= 2)  then
      print "(/,2x,'Error in the input file: set Nsurf to 2;')"
      print "(  2x, a)",                                                            &
     '- enter true to continue the program or false to stop the program; '
      print "(  2x, a)",                                                            &
     '  Note: the program can be continued if the input values of surf(1)'
      print "(  2x,'  and surf(2) are correct;')"
      call read_logical (continuare)
      if (.not. continuare) stop 
      print "(2x,'- enter the number of surface parameters Nsurf;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) Nsurf
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the number of surface parameters Nsurf;')"
        end if
      end do
      call check_geomAXSYM (TypeGeom, Nsurf, Nparam)
    end if
    if (Nparam /= 3)  then
      print "(/,2x,'Error in the input file: set Nparam to 3;')" 
      print "(  2x, a)",                                                            &
     '- enter true to continue the program or false to stop the program;'
      call read_logical (continuare)
      if (.not. continuare) stop 
      print "(2x,'- enter the number of parameters Nparam;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) Nparam
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the number of parameters Nparam;')"
        end if
      end do
      call check_geomAXSYM (TypeGeom, Nsurf, Nparam)
    end if
  end select
end subroutine check_geomAXSYM
! **********************************************************************************
recursive subroutine check_geomAXSYMOblate (TypeGeom, Nsurf, surf)
  use parameters
  implicit none
  integer  :: TypeGeom, Nsurf, ierr
  real(O)  :: surf(Nsurf)
  logical  :: continuare   
!
  if (TypeGeom == 3 .and. surf(1) >= surf(2)) then
    print "(/,2x,'Error in the input file:')"   
    print "(  2x,'the relation surf(1) < surf(2) is not satisfied;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the surface parameters surf(1) and surf(2);')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) surf(1), surf(2)
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the surface parameters surf(1) and surf(2);')"
      end if
    end do
    call check_geomAXSYMOblate (TypeGeom, Nsurf, surf)
  end if 
end subroutine check_geomAXSYMOblate
! **********************************************************************************
recursive subroutine check_geom3D (TypeGeom, Nsurf, Nparam, anisotropic, miror,     &
                     Nazimutsym)
  implicit none
  integer  :: TypeGeom, Nsurf, Nparam, Nazimutsym, ierr
  logical  :: anisotropic, miror, continuare 
!
  if (TypeGeom > 3) then
    print "(/,2x,'Warning: the geometry is not contained in the library;')"     
  end if 
  select case (TypeGeom)
  case (1)
    if (Nsurf  /= 3) then
      print "(/,2x,'Error in the input file: set Nsurf to 3;')"
      print "(  2x, a)",                                                            &
     '- enter true to continue the program or false to stop the program;'
      print "(  2x, a)",                                                            &
     '  Note: the program can be continued if the input values of surf(1),'
      print "(  2x,'  surf(2) and surf(3) are correct;')"
      call read_logical (continuare)
      if (.not. continuare) stop 
      print "(2x,'- enter the number of surface parameters Nsurf;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) Nsurf
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the number of surface parameters Nsurf;')"
        end if
      end do
      call check_geom3D (TypeGeom, Nsurf, Nparam, anisotropic, miror, Nazimutsym)
    end if
    if (Nparam /= 1)  then
      print "(/,2x,'Error in the input file: set Nparam to 1;')"
      print "(  2x, a)",                                                            &
     '- enter true to continue the program or false to stop the program;'
      call read_logical (continuare)
      if (.not. continuare) stop 
      print "(2x,'- enter the number of parameters Nparam;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) Nparam
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the number of parameters Nparam;')"
        end if
      end do
      call check_geom3D (TypeGeom, Nsurf, Nparam, anisotropic, miror, Nazimutsym)
    end if
    if (miror .and. anisotropic)  then
      print "(/,2x,'Error in the input file: set miror to false;')"
      print "(  2x, a)",                                                            &
     '- enter true to continue the program or false to stop the program;'
      call read_logical (continuare)
      if (.not. continuare) stop 
      print "(2x,'- enter the logical variable miror;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) miror
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the logical variable miror;')"
        end if
      end do
      call check_geom3D (TypeGeom, Nsurf, Nparam, anisotropic, miror, Nazimutsym)
    end if
    if (Nazimutsym /= 0)  then
      print "(/,2x,'Error in the input file: set Nazimutsym to 0;')"
      print "(  2x, a)",                                                            &
     '- enter true to continue the program or false to stop the program;'
      call read_logical (continuare)
      if (.not. continuare) stop 
      print "(2x,'- enter the integer variable Nazimutsym;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) Nazimutsym
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the integer variable Nazimutsym;')"
        end if
      end do
      call check_geom3D (TypeGeom, Nsurf, Nparam, anisotropic, miror, Nazimutsym)
    end if
  case (2)
    if (Nsurf  /= 2)  then
      print "(/,2x,'Error in the input file: set Nsurf to 2;')"
      print "(  2x, a)",                                                            &
     '- enter true to continue the program or false to stop the program;'
      print "(  2x, a)",                                                            &
     '  Note: the program can be continued if the input values of surf(1)'
      print "(  2x,'  and surf(2) are correct;')"
      call read_logical (continuare)
      if (.not. continuare) stop 
        print "(2x,'- enter the number of surface parameters Nsurf;')"
        ierr = 1
        do while (ierr /= 0)
          read (*, *, iostat = ierr) Nsurf
          if (ierr /= 0) then 
            print "(/,2x,'Input error during the read statement;')"
            print "(  2x,'- enter the number of surface parameters Nsurf;')"
        end if
      end do
      call check_geom3D (TypeGeom, Nsurf, Nparam, anisotropic, miror, Nazimutsym)
    end if
    if (Nparam /= 6)  then
      print "(/,2x,'Error in the input file: set Nparam to 6;')"
      print "(  2x, a)",                                                            &
     '- enter true to continue the program or false to stop the program;'
      call read_logical (continuare)
      if (.not. continuare) stop 
      print "(2x,'- enter the number of parameters Nparam;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) Nparam
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the number of parameters Nparam;')"
        end if
      end do
      call check_geom3D (TypeGeom, Nsurf, Nparam, anisotropic, miror, Nazimutsym)
    end if
    if (miror)  then
      print "(/,2x,'Error in the input file: set miror to false;')"
      print "(  2x, a)",                                                            &
     '- enter true to continue the program or false to stop the program;'
      call read_logical (continuare)
      if (.not. continuare) stop 
      print "(2x,'- enter the logical variable miror;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) miror
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the logical variable miror;')"
        end if
      end do
      call check_geom3D (TypeGeom, Nsurf, Nparam, anisotropic, miror, Nazimutsym)
    end if
      if (Nazimutsym /= 0)  then
        print "(/,2x,'Error in the input file: set Nazimutsym to 0;')"
        print "(  2x, a)",                                                          &
     '- enter true to continue the program or false to stop the program;'
        call read_logical (continuare)
        if (.not. continuare) stop 
        print "(2x,'- enter the integer variable Nazimutsym;')"
        ierr = 1
        do while (ierr /= 0)
          read (*, *, iostat = ierr) Nazimutsym
          if (ierr /= 0) then 
            print "(/,2x,'Input error during the read statement;')"
            print "(  2x,'- enter the integer variable Nazimutsym;')"
        end if
      end do
      call check_geom3D (TypeGeom, Nsurf, Nparam, anisotropic, miror, Nazimutsym)
    end if
  case (3)
    if (.not. anisotropic) then
      if (Nsurf  /= 2)  then
        print "(/,2x,'Error in the input file: set Nsurf to 2;')"
        print "(  2x, a)",                                                          &
       '- enter true to continue the program or false to stop the program;'
        print "(  2x, a)",                                                          &
       '  Note: the program can be continued if the input values of surf(1)'
        print "(  2x,'  and surf(2) are correct;')"
        call read_logical (continuare)
        if (.not. continuare) stop 
        print "(2x,'- enter the number of surface parameters Nsurf;')"
        ierr = 1
        do while (ierr /= 0)
          read (*, *, iostat = ierr) Nsurf
          if (ierr /= 0) then 
            print "(/,2x,'Input error during the read statement;')"
            print "(  2x,'- enter the number of surface parameters Nsurf;')"
          end if
        end do
        call check_geom3D (TypeGeom, Nsurf, Nparam, anisotropic, miror, Nazimutsym)
      end if 
      if (miror .and. Nparam /= 2)  then
        print "(/,2x,'Error in the input file: set Nparam to 2;')"
        print "(  2x, a)",                                                          &
       '- enter true to continue the program or false to stop the program;'
        call read_logical (continuare)
        if (.not. continuare) stop 
        print "(2x,'- enter the number of parameters Nparam;')"
        ierr = 1
        do while (ierr /= 0)
          read (*, *, iostat = ierr) Nparam
          if (ierr /= 0) then 
            print "(/,2x,'Input error during the read statement;')"
            print "(  2x,'- enter the number of parameters Nparam;')"
          end if
        end do
        call check_geom3D (TypeGeom, Nsurf, Nparam, anisotropic, miror, Nazimutsym)
      end if
      if (.not. miror .and. Nparam /= 3)  then
        print "(/,2x,'Error in the input file: set Nparam to 3;')"
        print "(  2x, a)",                                                          &
       '- enter true to continue the program or false to stop the program;'
        call read_logical (continuare)
        if (.not. continuare) stop 
        print "(2x,'- enter the number of parameters Nparam;')"
        ierr = 1
        do while (ierr /= 0)
          read (*, *, iostat = ierr) Nparam
          if (ierr /= 0) then 
            print "(/,2x,'Input error during the read statement;')"
            print "(  2x,'- enter the number of parameters Nparam;')"
          end if
        end do
        call check_geom3D (TypeGeom, Nsurf, Nparam, anisotropic, miror, Nazimutsym)
      end if 
      if (Nazimutsym < 2)  then
        print "(/,2x,'Error in the input file: set Nazimutsym > 1;')"
        print "(  2x, a)",                                                          &
       '- enter true to continue the program or false to stop the program;'
        call read_logical (continuare)
        if (.not. continuare) stop 
        print "(2x,'- enter the integer variable Nazimutsym;')"
        ierr = 1
        do while (ierr /= 0)
          read (*, *, iostat = ierr) Nazimutsym
          if (ierr /= 0) then 
            print "(/,2x,'Input error during the read statement;')"
            print "(  2x,'- enter the integer variable Nazimutsym;')"
          end if
        end do
        call check_geom3D (TypeGeom, Nsurf, Nparam, anisotropic, miror, Nazimutsym)
      end if 
    else
      print "(/,2x,'Error in the input file:')"
      print "(  2x,'the integer variable TypeGeom is 3 and for uniaxial particles ')"
      print "(  2x,'no mirror and azimuthal symmetries are considered')"
      stop      
    end if  
  end select
end subroutine check_geom3D
! **********************************************************************************
recursive subroutine check_geomCOMP (TypeGeom, Npart, Nsurf, Nparam)
  implicit none
  integer  :: TypeGeom, Npart, Nsurf(Npart), Nparam(Npart), ipart, ierr
  logical  :: continuare
!
  if (TypeGeom > 2) then
    print "(/,2x,'Warning: the geometry is not contained in the library;')"     
  end if 
  select case (TypeGeom)
  case (1)
    do ipart = 1, Npart
      if (Nsurf(ipart)  /= 3)  then
        print "(/,2x,'Error in the input file: set Nsurf for region',i3,' to 3;')", &
                ipart
        print "(  2x, a)",                                                          &
       '- enter true to continue the program or false to stop the program;'
        print "(  2x, a)",                                                          &
       '  Note: the program can be continued if the input values of the'
        print "(  2x,'  surface parameters for region',i3,' are correct;')", ipart
        call read_logical (continuare)
        if (.not. continuare) stop                           
        print "(2x,'- enter the number of surface parameters Nsurf for this region;')"
        ierr = 1
        do while (ierr /= 0)
          read (*, *, iostat = ierr) Nsurf(ipart)
          if (ierr /= 0) then 
            print "(/,2x,'Input error during the read statement;')"
            print "(  2x, a)",                                                      &
           '- enter the number of surface parameters Nsurf for this region;'
          end if
        end do
        call check_geomCOMP (TypeGeom, Npart, Nsurf, Nparam)
      end if
      if (Nparam(ipart) /= 2)  then
        print "(/,2x,'Error in the input file: set Nparam for region',i3,' to 2;')",&
                ipart
        print "(  2x, a)",                                                          &
       '- enter true to continue the program or false to stop the program;'
        call read_logical (continuare)
        if (.not. continuare) stop 
        print "(2x,'- enter the number of parameters Nparam for this region;')"
        ierr = 1
        do while (ierr /= 0)
          read (*, *, iostat = ierr) Nparam(ipart)
          if (ierr /= 0) then 
            print "(/,2x,'Input error during the read statement;')"
            print "(  2x,'- enter the number of parameters Nparam for this region;')"
          end if
        end do
        call check_geomCOMP (TypeGeom, Npart, Nsurf, Nparam)
      end if
    end do
  case (2)
    do ipart = 1, Npart
      if (Nsurf(ipart)  /= 2)  then
        print "(/,2x,'Error in the input file: set Nsurf for region',i3,' to 2;')", &
                ipart
        print "(  2x, a)",                                                          &
       '- enter true to continue the program or false to stop the program;' 
        print "(  2x, a)",                                                          &
       '  Note: the program can be continued if the input values of the' 
        print "(  2x,'  surface parameters for region',i3,' are correct;')", ipart
        call read_logical (continuare)
        if (.not. continuare) stop 
        print "(2x,'- enter the number of surface parameters Nsurf for this region;')"
        ierr = 1
        do while (ierr /= 0)
          read (*, *, iostat = ierr) Nsurf(ipart)
          if (ierr /= 0) then 
            print "(/,2x,'Input error during the read statement;')"
            print "(  2x, a)",                                                      &
           '- enter the number of surface parameters Nsurf for this region;'
          end if
        end do
        call check_geomCOMP (TypeGeom, Npart, Nsurf, Nparam)
      end if
      if (Nparam(ipart) /= 3)  then
        print "(/,2x,'Error in the input file: set Nparam for region',i3,' to 3;')",&
                ipart
        print "(  2x, a)",                                                          &
       '- enter true to continue the program or false to stop the program;'
        call read_logical (continuare)
        if (.not. continuare) stop 
        print "(2x,'- enter the number of parameters Nparam for this region;')"
        ierr = 1
        do while (ierr /= 0)
          read (*, *, iostat = ierr) Nparam(ipart)
          if (ierr /= 0) then 
            print "(/,2x,'Input error during the read statement;')"
            print "(  2x,'- enter the number of parameters Nparam for this region;')"
          end if
        end do
        call check_geomCOMP (TypeGeom, Npart, Nsurf, Nparam)
      end if
    end do    
  end select
end subroutine check_geomCOMP
! **********************************************************************************
recursive subroutine check_geomLAY (TypeGeom, Npart, Nsurf, Nparam)
  implicit none
  integer  :: TypeGeom, Npart, Nsurf(Npart), Nparam(Npart), ipart, ierr
  logical  :: continuare
!
  if (TypeGeom > 2) then
    print "(/,2x,'Warning: the geometry is not contained in the library;')"     
  end if 
  select case (TypeGeom)
  case (1)
    do ipart = 1, Npart
      if (Nsurf(ipart)  /= 2)  then
        print "(/,2x,'Error in the input file: set Nsurf for region',i3,' to 2;')", &
                ipart
        print "(  2x, a)",                                                          &
       '- enter true to continue the program or false to stop the program;'
        print "(  2x, a)",                                                          &
       '  Note: the program can be continued if the input values of the'
        print "(  2x,'  surface parameters for region',i3,' are correct;')", ipart
        call read_logical (continuare)
        if (.not. continuare) stop 
        print "(2x,'- enter the number of surface parameters Nsurf for this region;')"
        ierr = 1
        do while (ierr /= 0)
          read (*, *, iostat = ierr) Nsurf(ipart)
          if (ierr /= 0) then 
            print "(/,2x,'Input error during the read statement;')"
            print "(  2x, a)",                                                      &
           '- enter the number of surface parameters Nsurf for this region;'  
          end if
        end do
        call check_geomLAY (TypeGeom, Npart, Nsurf, Nparam)
      end if
      if (Nparam(ipart) /= 1)  then
        print "(/,2x,'Error in the input file: set Nparam for region',i3,' to 1;')",&
                ipart
        print "(  2x, a)",                                                          &
       '- enter true to continue the program or false to stop the program;'
        call read_logical (continuare)
        if (.not. continuare) stop 
        print "(2x,'- enter the number of parameters Nparam for this region;')"
        ierr = 1
        do while (ierr /= 0)
          read (*, *, iostat = ierr) Nparam(ipart)
          if (ierr /= 0) then 
            print "(/,2x,'Input error during the read statement;')"
            print "(  2x,'- enter the number of parameters Nparam for this region;')"
          end if
        end do
        call check_geomLAY (TypeGeom, Npart, Nsurf, Nparam)
      end if
    end do
  case (2)
    do ipart = 1, Npart
      if (Nsurf(ipart)  /= 2)  then
        print "(/,2x,'Error in the input file: set Nsurf for region',i3,' to 2;')", &
                ipart
        print "(  2x, a)",                                                          &
       '- enter true to continue the program or false to stop the program;'
        print "(  2x, a)",                                                          &
       '  Note: the program can be continued if the input values of the'
        print "(  2x,'  surface parameters for region',i3,' are correct;')", ipart
        call read_logical (continuare)
        if (.not. continuare) stop 
        print "(2x,'- enter the number of surface parameters Nsurf for this region;')"
        ierr = 1
        do while (ierr /= 0)
          read (*, *, iostat = ierr) Nsurf(ipart)
          if (ierr /= 0) then 
            print "(/,2x,'Input error during the read statement;')"
            print "(  2x, a)",                                                      &
           '- enter the number of surface parameters Nsurf for this region;'
          end if
        end do
        call check_geomLAY (TypeGeom, Npart, Nsurf, Nparam)
      end if
      if (Nparam(ipart) /= 3)  then
        print "(/,2x,'Error in the input file: set Nparam for region',i3,' to 3;')",&
                ipart
        print "(  2x, a)",                                                          &
       '- enter true to continue the program or false to stop the program;'
        call read_logical (continuare)
        if (.not. continuare) stop 
        print "(2x,'- enter the number of parameters Nparam for this region;')"
        ierr = 1
        do while (ierr /= 0)
          read (*, *, iostat = ierr) Nparam(ipart)
          if (ierr /= 0) then 
            print "(/,2x,'Input error during the read statement;')"
            print "(  2x,'- enter the number of parameters Nparam for this region;')"
          end if
        end do
        call check_geomLAY (TypeGeom, Npart, Nsurf, Nparam)
      end if
    end do    
  end select
end subroutine check_geomLAY
! **********************************************************************************
recursive subroutine check_MrankNrank (Mrank, Nrank)
  implicit none
  integer :: Mrank, Nrank, ierr
  logical :: continuare   
!  
  if (Mrank > Nrank) then
    print "(/,2x,'Input error: Mrank exceeds Nrank;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the estimated values of Nrank and Mrank;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) Nrank, Mrank
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the estimated values of Nrank and Mrank;')"
      end if
    end do
    call check_MrankNrank (Mrank, Nrank)
  end if 
end subroutine check_MrankNrank
! **********************************************************************************
recursive subroutine check_chirality (kb)
  use parameters
  use derived_parameters
  implicit none
  real(O)  :: kb
  integer  :: ierr
  logical  :: continuare
!  
  if (abs(kb - 1._O) <= MachEps) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the chirality parameter kb is one;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the chirality parameter kb;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) kb
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the chirality parameter kb;')"
      end if
    end do
    call check_chirality (kb)
  end if 
end subroutine check_chirality
! **********************************************************************************
recursive subroutine check_ind_ref (ind_ref)
  use parameters
  use derived_parameters
  implicit none
  complex(O)  :: ind_ref
  integer     :: ierr
  logical     :: continuare
!  
  if (aimag(ind_ref) < 0._O .or. abs(ind_ref) < MachEps) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the refractive index is zero or the imaginary part is negative')"               
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop                              
    print "(2x,'- enter the refractive index;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) ind_ref
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the refractive index;')"
      end if
    end do
    call check_ind_ref (ind_ref)
  end if 
end subroutine check_ind_ref
! **********************************************************************************
recursive subroutine check_ind_ref1 (ipart, ind_ref)
  use parameters
  use derived_parameters
  implicit none
  integer     :: ipart, ierr
  complex(O)  :: ind_ref
  logical     :: continuare
!    
  if (aimag(ind_ref) < 0._O .or. abs(ind_ref) < MachEps) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the refractive index is zero or the imaginary part')"
    print "(  2x,'is negative for the region/particle ',i2,';')", ipart
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the refractive index for this region;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) ind_ref
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the refractive index for this region;')"
      end if
    end do
    call check_ind_ref1 (ipart, ind_ref)
  end if 
end subroutine check_ind_ref1
! **********************************************************************************
recursive subroutine  check_ind_ref2 (ind_ref1, ind_ref2)  
  use parameters
  use derived_parameters
  implicit none  
  complex(O)  :: ind_ref1, ind_ref2
  integer     :: ierr
  logical     :: continuare
!    
  if (aimag(ind_ref1) < 0._O .or. abs(ind_ref1) < MachEps ) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the refractive index of the particle is zero or')"
    print "(  2x,'the imaginary part is negative;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the refractive index of the particle;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) ind_ref1
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the refractive index of the particle;')"
      end if
    end do      
    call check_ind_ref2 (ind_ref1, ind_ref2)
  end if 
  if (aimag(ind_ref2) < 0._O .or. abs(ind_ref2) < MachEps) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the refractive index of the substrate is zero or')"
    print "(  2x,'the imaginary part is negative;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the refractive index of the substrate;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) ind_ref2
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the refractive index of the substrate;')"
      end if
    end do
    call check_ind_ref2 (ind_ref1, ind_ref2)        
  end if   
end subroutine check_ind_ref2
! **********************************************************************************
recursive subroutine  check_ind_ref3 (ind_ref1, ind_ref2)  
  use parameters
  use derived_parameters
  implicit none  
  complex(O)  :: ind_ref1, ind_ref2
  integer     :: ierr
  logical     :: continuare
!    
  if (aimag(ind_ref1) < 0._O .or. abs(ind_ref1) < MachEps) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the first refractive index of the uniaxial particle')"
    print "(  2x,'is zero or the imaginary part is negative;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the first refractive index of the uniaxial particle;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) ind_ref1
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the first refractive index of the uniaxial particle;')"
      end if
    end do
    call check_ind_ref3 (ind_ref1, ind_ref2)        
  end if 
  if (aimag(ind_ref2) < 0._O .or. abs(ind_ref2) < MachEps) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the second refractive index of the uniaxial particle')"
    print "(  2x,'is zero or the imaginary part is negative;')"
    print "(  2x,'- enter true to continue the program or false to stop the program;')"
    call read_logical (continuare)
    if (.not. continuare) stop 
    print "(2x,'- enter the second refractive index of the uniaxial particle;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) ind_ref2
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the second refractive index of the uniaxial particle;')"
      end if
    end do
    call check_ind_ref3 (ind_ref1, ind_ref2)        
  end if 
end subroutine check_ind_ref3
! **********************************************************************************
recursive subroutine check_Interpolation (TypeInterp)
  implicit none
  integer       :: ierr
  character(20) :: TypeInterp
!
  if ( TypeInterp(1:6) /= 'LINEAR' .and.                                            &
       TypeInterp(1:6) /= 'SPLINE' .and.                                            &
       TypeInterp(1:7) /= 'HERMITE' ) then
    print "(/,2x,'Error in the general input file:')"
    print "(  2x,'incorrect value of the variable TypeInterp;')"
    print "(  2x,'the permissive values are: LINEAR, SPLINE and HERMITE;')"
    print "(  2x,'- enter the character type variable TypeInterp;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) TypeInterp
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the character type variable TypeInterp;')"
      end if
    end do
    call check_Interpolation (TypeInterp)
  end if  
end subroutine check_Interpolation
! **********************************************************************************
recursive subroutine check_MatrixSolver (TypeMatrSolv)
  implicit none
  integer       :: ierr
  character(20) :: TypeMatrSolv
!
  if (TypeMatrSolv(1:3) /= 'LU1'   .and.                                            &
      TypeMatrSolv(1:3) /= 'LU2'   .and.                                            &
      TypeMatrSolv(1:3) /= 'LU3'   .and.                                            &
      TypeMatrSolv(1:4) /= 'BICG'        )  then
    print "(/,2x,'Error in the general input file:')"
    print "(  2x,'incorrect value of the variable TypeMatrSolv;')"
    print "(  2x,'the permissive values are: LU1, LU2, LU3 and BICG;')"
    print "(  2x,'- enter the character type variable TypeMatrSolv;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) TypeMatrSolv
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the character type variable TypeMatrSolv;')"
      end if
    end do
    call check_MatrixSolver (TypeMatrSolv)
  end if  
end subroutine check_MatrixSolver
! **********************************************************************************
recursive subroutine check_Integration (TypeIntegr) 
  implicit none
  integer       :: ierr 
  character(20) :: TypeIntegr
!
  if (TypeIntegr(1:4) /= 'MET1' .and. TypeIntegr(1:4) /= 'MET2') then
    print "(/,2x,'Error in the general input file:')"
    print "(  2x,'incorrect value of the variable TypeIntegr;')"
    print "(  2x,'the permissive values are:')"
    print "(  2x,'MET1 - routines from Numerical Recipes,')"
    print "(  2x,'MET2 - modified routines from Slatec library;')"
    print "(  2x,'- enter the character type variable TypeIntegr;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) TypeIntegr
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the character type variable TypeIntegr;')"
      end if
    end do
    call check_Integration (TypeIntegr) 
  end if  
end subroutine check_Integration
! **********************************************************************************
recursive subroutine check_Random (TypeRND) 
  implicit none
  integer       :: ierr 
  character(20) :: TypeRND
!
  if (TypeRND(1:4) /= 'SLAT' .and. TypeRND(1:4) /= 'LPCK'.and.                      &
      TypeRND(1:4) /= 'ZIGG') then
    print "(/,2x,'Error in the general input file:')"
    print "(  2x,'incorrect value of the variable TypeRND;')"
    print "(  2x,'the permissive values are:')"
    print "(  2x,'SLAT - modified routine from Slatec library,')"
    print "(  2x,'LPCK - modified routine from Lapack library;')"
    print "(  2x,'ZIGG - Ziggurat method of Marsaglia and Tsang;')"
    print "(  2x,'- enter the character type variable TypeRND;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) TypeRND
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the character type variable TypeRND;')"
      end if
    end do
    call check_Random (TypeRND) 
  end if  
end subroutine check_Random
! **********************************************************************************
recursive subroutine check_anorm (anorm)
  use parameters
  implicit none
  real(O)  :: anorm
  integer  :: ierr
!  
  if (anorm <= 0._O) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the characteristic length anorm is negative or zero;')"
    print "(  2x,'- enter the characteristic length anorm;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) anorm
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the characteristic length anorm;')"
      end if
    end do
    call check_anorm (anorm)
  end if 
end subroutine check_anorm 
! **********************************************************************************
recursive subroutine check_tetaminmax (thetamin, thetamax, Ntheta)
  use parameters
  use derived_parameters
  implicit none
  integer  :: Ntheta, ierr
  real(O)  :: thetamin, thetamax, min, max
!  
  min = 0._O
  max = 180._O    
  if (thetamin < min .or. thetamin > max .or. thetamax < min .or. thetamax > max .or.&
      thetamin > thetamax) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the relation 0 <= thetamin <= thetamax <= 180 deg is not satisfied;')"
    print "(  2x,'- enter the variables thetamin and thetamax;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) thetamin, thetamax
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the variables thetamin and thetamax;')"
      end if
    end do
    call check_tetaminmax (thetamin, thetamax, Ntheta)                  
  end if   
  if (abs(thetamax - thetamin) <= MachEps .and. Ntheta /= 1) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the number of sample points Ntheta should be 1;')"      
    print "(  2x,'- enter the number of sample points Ntheta;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) Ntheta
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the number of sample points Ntheta;')"
      end if
    end do
    call check_tetaminmax (thetamin, thetamax, Ntheta)
  end if 
end subroutine check_tetaminmax
! **********************************************************************************
recursive subroutine check_Nphi (Nphi)
  use parameters
  implicit none
  integer  :: Nphi, ierr
!      
  if (Nphi > NphiMax) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x, a)",                                                              &
   'the number of scattering planes Nphi exceeds the maximum dimension NphiMax;'                
    print "(  2x,'- enter the number of scattering planes Nphi < ',i3,';')", NphiMax
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) Nphi
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the number of scattering planes Nphi < ',i3,';')",    &
                NphiMax
      end if
    end do
    call check_Nphi (Nphi)
  end if 
end subroutine check_Nphi
! **********************************************************************************
recursive subroutine check_teta_phiminmax (complete, Nphi, phi, Ntheta, thetamin,   &
                     thetamax)
  use parameters
  use derived_parameters
  implicit none
  integer  :: Nphi, Ntheta(NphiMax), iphi, ierr
  real(O)  :: phi(NphiMax), thetamin(NphiMax), thetamax(NphiMax), min, max, grd
  logical  :: complete 
!
  grd = 180._O / Pi
  do iphi = 1, Nphi
    min = 0._O
    max = 360._O    
    if (phi(iphi) < min .or. phi(iphi) > max) then
      print "(/,2x,'Error in the input file:')"
      print "(  2x,'the relation 0 <= phi <= 360 deg is not satisfied')"
      print "(  2x,'for the scattering plane iphi = ',i3,';')", iphi
      print "(  2x, a, i3, a)",                                                     &
     '- enter the azimuthal angle phi of the scattering plane ', iphi, ';'
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) phi(iphi)
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x, a, i3, a)",                                                 &
         '- enter the azimuthal angle phi of the scattering plane ', iphi, ';'
        end if
      end do
      call check_teta_phiminmax (complete, Nphi, phi, Ntheta, thetamin, thetamax)                       
    end if   
    if (complete) then
      min = 0._O
    else
      min = 90._O
      end if
    max = 180._O    
    if (thetamin(iphi) < min .or. thetamin(iphi) > max .or.                         &
        thetamax(iphi) < min .or. thetamax(iphi) > max .or.                         &
        thetamin(iphi) > thetamax(iphi)) then
      print "(/,2x,'Error in the input file:')"
      if (complete) then
        print "(2x, a)",                                                            &
       'the relation 0 <= thetamin <= thetamax <= 180 deg is not satisfied'
      else
        print "(2x, a)",                                                            &
       'the relation 90 <= thetamin <= thetamax <= 180 deg is not satisfied' 
      end if
      print "(2x,'for the scattering plane phi = ',f7.2,';')", phi(iphi) * grd
      print "(2x,'- enter the variables thetamin and thetamax')"
      print "(2x,'for the scattering plane phi = ',f7.2,';')", phi(iphi) * grd        
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) thetamin(iphi), thetamax(iphi)
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the variables thetamin and thetamax')"
          print "(  2x,'for the scattering plane phi = ',f7.2,';')", phi(iphi) * grd              
        end if
      end do
      call check_teta_phiminmax (complete, Nphi, phi, Ntheta, thetamin, thetamax)                               
    end if   
    if (abs(thetamax(iphi) - thetamin(iphi)) <= MachEps .and. Ntheta(iphi) /= 1) then
      print "(/,2x,'Error in the input file:')"
      print "(  2x,'the number of sample points Ntheta for the scattering plane')"
      print "(  2x,'phi = ',f7.2,' should be 1;')", phi(iphi) * grd                                                     
      print "(  2x,'- enter the number of sample points Ntheta')"
      print "(  2x,'for the scattering plane phi = ',f7.2,';')", phi(iphi) * grd
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) Ntheta(iphi)
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"             
          print "(  2x,'- enter the number of sample points Ntheta')"
          print "(  2x,'for the scattering plane phi = ',f7.2,';')", phi(iphi) * grd
        end if
      end do
      call check_teta_phiminmax (complete, Nphi, phi, Ntheta, thetamin, thetamax)
    end if 
  end do          
end subroutine check_teta_phiminmax
! **********************************************************************************
recursive subroutine check_betaminmax (betamin, betamax, Nbeta)
  use parameters
  use derived_parameters
  implicit none
  integer  :: Nbeta, ierr
  real(O)  :: betamin, betamax, min, max, deltacos
!  
  min = 0._O
  max = 180._O    
  if (betamin < min .or. betamin > max .or. betamax < min .or. betamax > max .or.   &
      betamin > betamax) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the relation 0 <= betamin <= betamax <= 180 deg is not satisfied;')"
    print "(  2x,'- enter the variables betamin and betamax;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) betamin, betamax
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the variables betamin and betamax;')"
      end if
    end do
    call check_betaminmax (betamin, betamax, Nbeta)                     
  end if   
  deltacos = cos(betamin) - cos(betamax)
  if (abs(deltacos) <= MachEps .and. Nbeta /= 1) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the number of quadrature points Nbeta should be 1;')"   
    print "(  2x,'- enter the number of quadrature points Nbeta;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) Nbeta
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the number of quadrature points Nbeta;')"
      end if
    end do
    call check_betaminmax (betamin, betamax, Nbeta)
  end if 
end subroutine check_betaminmax
! **********************************************************************************
recursive subroutine check_alfaminmax (alphamin, alphamax, Nalpha)
  use parameters
  use derived_parameters
  implicit none
  integer  :: Nalpha, ierr
  real(O)  :: alphamin, alphamax, min, max
!
  min = 0._O
  max = 360._O    
  if (alphamin < min .or. alphamin > max .or. alphamax < min .or. alphamax > max .or.&
      alphamin > alphamax) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the relation 0 <= alphamin <= alphamax <= 360 deg is not satisfied;')"
    print "(  2x,'- enter the variables alphamin and alphamax;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) alphamin, alphamax
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the variables alphamin and alphamax;')"
      end if
    end do
    call check_alfaminmax (alphamin, alphamax, Nalpha)                  
  end if   
  if (abs(alphamax - alphamin) <= MachEps .and. Nalpha /= 1) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the number of quadrature points Nalpha should be 1;')"  
    print "(  2x,'- enter the number of quadrature points Nalpha;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) Nalpha
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the number of quadrature points Nalpha;')"
      end if
    end do
    call check_alfaminmax (alphamin, alphamax, Nalpha)
  end if 
end subroutine check_alfaminmax
! **********************************************************************************
recursive subroutine check_gamaminmax (gammamin, gammamax, Ngamma)
  use parameters
  use derived_parameters
  implicit none
  integer  :: Ngamma, ierr
  real(O)  :: gammamin, gammamax, min, max
!
  min = 0._O
  max = 360._O    
  if (gammamin < min .or. gammamin > max .or. gammamax < min .or. gammamax > max .or.&
      gammamin > gammamax) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the relation 0 <= gammamin <= gammamax <= 360 deg is not satisfied;')"
    print "(  2x,'- enter the variables gammamin and gammamax;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) gammamin, gammamax
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the variables gammamin and gammamax;')"
      end if
    end do
    call check_gamaminmax (gammamin, gammamax, Ngamma)                  
  end if  
  if (abs(gammamax - gammamin) <= MachEps .and. Ngamma /= 1) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the number of quadrature points Ngamma should be 1;')"  
    print "(  2x,'- enter the number of quadrature points Ngamma;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) Ngamma
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the number of quadrature points Ngamma;')"
      end if
    end do
    call check_gamaminmax (gammamin, gammamax, Ngamma)
  end if  
end subroutine check_gamaminmax
! **********************************************************************************
recursive subroutine check_TypeExcit (TypeExcit)
  implicit none  
  character(5) :: TypeExcit 
  integer      :: ierr
!
  if ( TypeExcit(1:5) /= 'PLANE' .and. TypeExcit(1:5) /= 'GAUSS' ) then     
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'incorrect value of the variable TypeExcit;')"
    print "(  2x,'the permissive values are: PLANE and GAUSS;')"
    print "(  2x,'- enter the character type variable TypeExcit;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) TypeExcit
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the character type variable TypeExcit;')"
      end if
    end do
    call check_TypeExcit (TypeExcit)
  end if  
end subroutine check_TypeExcit
! **********************************************************************************
recursive subroutine check_incident_direction (thetaGI, phiGI)
  use parameters
  implicit none
  integer  :: ierr
  real(O)  :: thetaGI, phiGI, thetamin, thetamax, phimin, phimax
!  
  thetamin = 0._O
  thetamax = 180._O
  phimin   = 0._O
  phimax   = 360._O
  if (thetaGI < thetamin .or. thetaGI > thetamax) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the incident polar angle thetaGI varies between 0 and 180 deg;')"
    print "(  2x,'- enter the incident polar angle thetaGI;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) thetaGI
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the incident polar angle thetaGI;')"
      end if
    end do
    call check_incident_direction (thetaGI, phiGI)
  end if  
  if (phiGI < phimin .or. phiGI > phimax) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the incident azimuth angle phiGI varies between 0 and 360 deg;')"
    print "(  2x,'- enter the incident azimuth angle phiGI;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) phiGI
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the incident azimuth angle phiGI;')"
      end if
    end do
    call check_incident_direction (thetaGI, phiGI)
  end if  
end subroutine check_incident_direction
! **********************************************************************************
recursive subroutine check_incdir_partsub (beta)
  use parameters
  implicit none
  integer  :: ierr
  real(O)  :: beta, betamin, betamax
!
  betamin =  0._O
  betamax = 90._O
  if (beta < betamin .or. beta > betamax) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the incident angle beta varies between 0 and 90 deg;')"
    print "(  2x,'- enter the incident angle beta;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) beta
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the incident angle beta;')"
      end if
    end do
    call check_incdir_partsub (beta)    
  end if 
end subroutine check_incdir_partsub
! **********************************************************************************
recursive subroutine check_polarization_angle (alphap)
  use parameters
  implicit none
  integer  :: ierr
  real(O)  :: alphap, phimin, phimax
!        
  phimin   = 0._O
  phimax   = 360._O   
  if (alphap < phimin .or. alphap > phimax) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the polarization angle alphap varies between 0 and 360 deg;')"
    print "(  2x,'- enter the polarization angle alphap;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) alphap
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the polarization angle alphap;')"
      end if
    end do
    call check_polarization_angle (alphap)          
  end if   
end subroutine check_polarization_angle
! **********************************************************************************
recursive subroutine check_azimuthal_plane (phiGS)
  use parameters
  implicit none
  integer  :: ierr
  real(O)  :: phiGS, phimin, phimax
!
  phimin   = 0._O
  phimax   = 360._O   
  if (phiGS < phimin .or. phiGS > phimax) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the azimuth angle phiGS varies between 0 and 360 deg;')"
    print "(  2x,'- enter the azimuth angle phiGS;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) phiGS
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the azimuth angle phiGS;')"
      end if
    end do
    call check_azimuthal_plane (phiGS)              
  end if   
end subroutine check_azimuthal_plane
! **********************************************************************************
recursive subroutine check_MatrixElem (Nelem, MatrixElem) 
  implicit none
  integer  :: Nelem, MatrixElem(16), k, ij, i, j, ierr
  logical  :: fail
!  
  if (Nelem < 1 .or. Nelem > 16) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'incorrect value of the number of matrix elements Nelem;')"
    print "(  2x,'the relation 1 <= Nelem <= 16 is not satisfied;')"
    print "(  2x,'- enter the number of matrix elements Nelem;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) Nelem
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the number of matrix elements Nelem;')"
      end if
    end do
    call check_MatrixElem (Nelem, MatrixElem)
  end if
  fail = .false.
  do k = 1, Nelem
    ij = MatrixElem(k)
    if (ij <= 10) then
      fail = .true.
    else
      j = mod(ij,10)
      i = (ij - j) / 10
      if (i < 1 .or. i > 4 .or. j < 1 .or. j > 4) fail = .true.
    end if
  end do
  if (fail) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'incorrect values of the matrix elements in the array MatrixElem;')"
    print "(  2x,'the permissive values are: 11, 12, 13, 14, 21, 22, 23, 24,')"
    print "(  2x,'31, 32, 33, 34, 41, 42, 43, 44')"
    do k = 1, Nelem
      print "(2x,'- enter the matrix element ',i2,';')", k
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) MatrixElem(k)
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the matrix element ',i2,';')", k
        end if
      end do
    end do 
    call check_MatrixElem (Nelem, MatrixElem)
  end if 
end subroutine check_MatrixElem 
! **********************************************************************************
recursive subroutine check_StoreAvrgMtrSS (ComputeAvrgMtrSS, StoreAvrgMtrSS)  
  implicit none
  integer  :: ierr
  logical  :: ComputeAvrgMtrSS, StoreAvrgMtrSS
!  
  if (StoreAvrgMtrSS .and. .not. ComputeAvrgMtrSS) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'ComputeAvrgMtrSS = f and StoreAvrgMtrSS = t;')"
    print "(  2x,'- enter the logical variables ComputeAvrgMtrSS and StoreAvrgMtrSS;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) ComputeAvrgMtrSS, StoreAvrgMtrSS
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x, a)",                                                            &
       '- enter the logical variables ComputeAvrgMtrSS and StoreAvrgMtrSS;' 
      end if
    end do
    call check_StoreAvrgMtrSS (ComputeAvrgMtrSS, StoreAvrgMtrSS)
  end if
end subroutine check_StoreAvrgMtrSS
! **********************************************************************************
recursive subroutine check_NSimpson (N) 
  implicit none
  integer :: N, ierr
!      
  if (mod(N,2) == 0) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x, a, i5, a)",                                                       & 
   'the number of integration points for the Simpson rule is even: N = ', N, ';'
    print "(  2x,'- enter the number of integration points;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) N
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the number of integration points;')"
      end if
    end do
    call check_NSimpson (N)                     
  end if   
end subroutine check_NSimpson
! **********************************************************************************
recursive subroutine check_NthetaGS (N) 
  implicit none
  integer :: N, ierr
!      
  if (mod(N,2) == 0) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x, a, i5, a)",                                                       & 
   'the number of zenith angles for <SS*> calculation is even: N = ', N, ';'
    print "(  2x,'- enter the number of zenith angles;')"
    ierr = 1
    do while (ierr /= 0)
      read (*, *, iostat = ierr) N
      if (ierr /= 0) then 
        print "(/,2x,'Input error during the read statement;')"
        print "(  2x,'- enter the number of zenith angles;')"
      end if
    end do
    call check_NthetaGS (N)                     
  end if   
end subroutine check_NthetaGS
! **********************************************************************************
recursive subroutine check_NalphaNbetaNgamma (index, N) 
  implicit none
  integer :: index, N, ierr
!      
  if (N <= 1) then
    print "(/,2x,'Error in the input file:')"
    if (index == 1) then
      print "(2x,'the number of division points Nalpha is 1;')"
      print "(2x,'- enter the number of division points Nalpha;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) N
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the number of division points Nalpha;')"
        end if
      end do
      call check_NalphaNbetaNgamma (index, N)                   
    else if (index == 2) then
      print "(2x,'the number of division points Nbeta is 1;')"
      print "(2x,'- enter the number of division points Nbeta;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) N
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the number of division points Nbeta;')"
        end if
      end do
      call check_NalphaNbetaNgamma (index, N)
    else if (index == 3) then
      print "(2x,'the number of division points Ngamma is 1;')"
      print "(2x,'- enter the number of division points Ngamma;')"
      ierr = 1
      do while (ierr /= 0)
        read (*, *, iostat = ierr) N
        if (ierr /= 0) then 
          print "(/,2x,'Input error during the read statement;')"
          print "(  2x,'- enter the number of division points Ngamma;')"
        end if
      end do
      call check_NalphaNbetaNgamma (index, N)
    end if
  end if   
end subroutine check_NalphaNbetaNgamma
! **********************************************************************************
! *                 SUBROUTINES REQUIRING RESTARTING OF THE PROGRAM                * 
! **********************************************************************************
subroutine check_dimensionMat (ntg, mtg, Nmax)
  implicit none
  integer  :: ntg, mtg, Nmax
!
  if (ntg < Nmax .or. mtg < Nmax) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the physical dimensions of the T matrix are smaller than the ')"
    print "(  2x,'real  dimensions: Nrank  or/and  Mrank  should be increased;')"
    stop
  end if
end subroutine check_dimensionMat
! **********************************************************************************
subroutine check_dimensionVct (ntg, Nmax)
  implicit none
  integer  :: ntg, Nmax
!
  if (ntg < Nmax) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the physical  dimension of the T vector is smaller')"
    print "(  2x,'than the real dimension: Nrank should be increased;')"
    stop
  end if
end subroutine check_dimensionVct
! **********************************************************************************
subroutine check_circum_radii (Ncs, Rcs)
  use parameters
  implicit none
  integer  :: Ncs, i
  real(O)  :: Rcs(Ncs)
!
  do i = 1, Ncs - 1
    if (Rcs(i) >= Rcs(i+1)) then
      print "(/,2x,'Error in the input file:')"
      print "(  2x,'the radii of the circumscribing spheres are not in increasing order;')"    
      stop
    end if
  end do
end subroutine check_circum_radii 
! **********************************************************************************
subroutine check_MaxNrank (Nrank)
  use parameters
  implicit none
  integer  :: Nrank
!
  if (NrankPD < Nrank) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the number of distributed sources Nrank exceeds')"
    print "(  2x,'the maximum number of distributed sources NrankPD;')"
    stop
  end if
end subroutine check_MaxNrank
! **********************************************************************************
subroutine check_MaxNface (Nface)
  use parameters
  implicit none
  integer  :: Nface
!
  if (NfacePD < Nface) then
    print "(/,2x,'Error in the input file:')"
    print "(  2x,'the number of surface elements Nface exceeds')"
    print "(  2x,'the maximum number of surface elements NfacePD;')"
    stop
  end if
end subroutine check_MaxNface
! **********************************************************************************

! **********************************************************************************
! *                  ROUTINES FOR COMPUTING MACHINE CONSTANTS                      *
! *    -----------------------------------------------------------------------     *
! *    List of subroutines:                                                        *
! *      DrvParameters,       machr.                                               *  
! **********************************************************************************
subroutine DrvParameters
!-----------------------------------------------------------------------------------
! The routine computes the following machine constants:                            !
! - NBaseDig (integer),        NIterBes (integer),         NIterPol (integer),     !
! - LargestPosNumber (real),   SmallestPosNumber (real),   MachEps (real),         !               
! - ZeroCoord (real),          TolJ0Val (real),            TolRootPol (real),      !
! - InitBesVal (real),         FactNBes (real),            LargestBesVal (real),   !
! - UpperBoundSeq (real),      LowerBoundSeq (real),       ZeroSinXX (real),       ! 
! - MaxArgBes (real),          ZeroLUVal (real),           LargestSplineVal (real) !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none  
  integer  :: ibeta, it, irnd, ngrd, machep, negep, iexp, minexp, maxexp
  real(O)  :: eps, epsneg, xmin, xmax, x, step, fct
!  
  call machr ( ibeta, it, irnd, ngrd, machep, negep, iexp, minexp, maxexp,          &
       eps, epsneg, xmin, xmax )    
  LargestPosNumber  = xmax
  SmallestPosNumber = xmin
  MachEps  = eps
  NBaseDig = it
  NIterBes = 5000 
  NIterPol = 100000    
!  
  ZeroCoord  = eps**0.666_O
  if (O == kind(1.e0)) then
    fct = 10._O
  else
    fct = 1._O
  end if
  TolJ0Val   = fct * eps**0.666_O
  TolRootPol = eps
  InitBesVal = 1.e-35_O 
  FactNBes   = 400._O
  LargestBesVal = xmax**0.333_O 
  MaxArgBes     = 1.e+4_O  
  UpperBoundSeq = 1.e+10_O
  LowerBoundSeq = 1.e-10_O  
  x    = 1._O
  step = 0.5_O
  fct  = sin(x) / x
  do while (fct < 1._O)
    x   = step * x
    fct = sin(x) / x
  end do
  ZeroSinXX = x 
  ZeroLUVal = 1.e-20_O
  x = sqrt (xmax)
  LargestSplineVal = sqrt(x)                  
end subroutine DrvParameters
! **********************************************************************************
subroutine machr ( ibeta, it, irnd, ngrd, machep, negep, iexp, minexp, maxexp,      &
           eps, epsneg, xmin, xmax)
!----------------------------------------------------------------------------------- 
! The routine computes the parameters of the floating-point arithmetic system.     !
!                                                                                  !
! Output parameters:                                                               !
! - ibeta (integer) - the radix for the floating-point representation.             !
! - it (integer) - the number of base ibeta digits in the floating-point           !
!   significand.                                                                   !
! - irnd (integer) - specifies if floating-point addition chops or rounds          !
!   appear.                                                                        ! 
! - ngrd (integer) - the number of guard digits for multiplication with            !
!   truncating arithmetic.                                                         !
! - machep (integer) - the largest negative integer such that                      !
!   1.0 + real(ibeta) ** machep /= 1.0.                                            !
! - negeps (integer) - the largest negative integer such that                      ! 
!   1.0 - real(ibeta) ** negeps /= 1.0.                                            !
! - iexp (integer) - the number of bits reserved for the representation of         !
!   the exponent of a floating-point number.                                       !
! - minexp (integer) - the largest in magnitude negative integer such that         !
!   real(ibeta) ** minexp is positive and normalized.                              !
! - maxexp (integer) - the smallest positive power of beta that overflows.         !
! - eps (real) - the smallest positive floating-point number such that             !
!   1.0 + eps /= 0.0.                                                              !
! - epsneg (real) - the smallest positive floating-point number such that          !
!   1.0 - epsneg /= 0.0.                                                           !
! - xmin (real) - the smallest non-vanishing normalized floating-point power.      !
!   of the radix: xmin = real(ibeta) ** minexp.                                    !
! - xmax (real) - the largest finite floating-point number.                        !
!   xmax = (1.0 - epsneg) * real(ibeta) ** maxexp.                                 ! 
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer  :: ibeta, it, irnd, ngrd, machep, negep, iexp, minexp, maxexp
  real(O)  :: eps, epsneg, xmin, xmax
!  
  integer  :: i, itemp, iz, j, k, mx, nxres
  real(O)  :: a, b, beta, betah, betain, oner, t, temp, temp1, tempa, twor,          &
              y, z, zeror 
!
  oner  = 1._O
  twor  = oner + oner
  zeror = oner - oner
  a = oner
  do 
    a = a + a
    temp  = a + oner
    temp1 = temp - a
    if (temp1 - oner /= zeror ) exit    
  end do
  b = oner
  do 
    b = b + b
    temp  = a + b
    itemp = int (temp - a)
    if (itemp /= 0) exit    
  end do  
  ibeta = itemp
  beta  = real(ibeta,O)
  it = 0
  b  = oner
  do
    it = it + 1
    b  = b * beta
    temp  = b + oner
    temp1 = temp - b
    if (temp1 - oner /= zeror) exit
  end do                 
  irnd  = 0
  betah = beta / twor
  temp  = a + betah
  if (temp - a /= zeror) irnd = 1
  tempa = a + beta
  temp  = tempa + betah
  if (irnd == 0 .and. temp - tempa /= zeror) irnd = 2
  negep  = it +3
  betain = oner / beta
  a = oner
  do i = 1, negep
    a = a * betain
  end do
  b = a
  do 
    temp = oner - a
    if (temp - oner /= zeror) exit
    a = a * beta
    negep = negep - 1
  end do  
  negep  = - negep
  epsneg = a 
  if (ibeta /= 2 .and. irnd /= 0) then
    a = (a * (oner + a)) / twor
    temp = oner - a 
    if (temp - oner /= zeror) epsneg = a
  end if
  machep = -it - 3
  a = b
  do
    temp = oner + a
    if (temp - oner /= zeror) exit
    a = a * beta
    machep = machep + 1
  end do
  eps  = a
  temp = tempa + beta * (oner + eps)
  if (ibeta /= 2 .and. irnd /= 0) then
    a = (a * (oner + a)) / twor
    temp = oner + a
    if (temp - oner /= zeror) eps = a
  end if
  ngrd = 0
  temp = oner + eps
  if (irnd == 0 .and. temp * oner - oner /= zeror) ngrd = 1
  i = 0
  k = 1
  z = betain
  t = oner + eps
  nxres = 0
  do 
    y = z
    z = y * y
    a = z * oner
    temp = z * t
    if (a + a == zeror .or. abs(z) >= y) exit
    temp1 = temp * betain
    if (temp1 * beta == z) exit
    i = i + 1
    k = k + k
  end do
  if (ibeta /= 10) then
    iexp = i + 1
    mx   = k + k
  else
    iexp = 2
    iz   = ibeta
    do 
      if (k < iz) exit
      iz   = iz * ibeta
      iexp = iexp + 1        
    end do
    mx = iz + iz - 1
  end if
  do
    xmin = y
    y = y * betain    
    a = y * oner
    temp = y * t
    if ( a + a == zeror .or. abs(y) >= xmin) exit
    k = k + 1
    temp1 = temp * betain
    if (temp1 * beta == y) then
      nxres = 3
      xmin  = y
      exit
    end if
  end do
  minexp = - k  
  if (mx <= k + k - 3 .and. ibeta /= 10) then
    mx   = mx + mx
    iexp = iexp + 1    
  end if
  maxexp = mx + minexp
  irnd   = irnd + nxres
  if (irnd == 2 .or. irnd == 5) maxexp = maxexp - 2
  if (irnd == 3 .or. irnd == 4) maxexp = maxexp - it
  i = maxexp + minexp
  if (ibeta ==2 .and. i == 0) maxexp = maxexp - 1
  if (i > 20) maxexp = maxexp - 1
  if (a /= y) maxexp = maxexp - 2
  xmax = oner - epsneg
  if (xmax * oner /= xmax) xmax = oner - beta * epsneg
  xmax = xmax / ( beta * beta * beta * xmin)
  i = maxexp + minexp + 3
  do j = 1, i
    if (ibeta == 2) then
      xmax = xmax + xmax
    else
      xmax = xmax * beta
    end if
  end do
end subroutine machr

! **********************************************************************************
! *         ANALYTICAL SIZE AVERAGING PROCEDURE FOR SPHERICAL PARTICLES            *
! *    -------------------------------------------------------------------------   *
! *    Partial list of subroutines:                                                *
! *      DiffScatCrossSectAvrgSPH,         ScatteringMatrixSPH,                    *
! *      ExtendedScatteringMatrixSPH,      SijSCpqSPH,                             *
! *      AVSCTCOEF,                        AvCscatCextSPH,                         *
! *      AVSCTCOEF1,                       GeometryPars,                           *
! *      PDF                                                                       *
! **********************************************************************************
subroutine DiffScatCrossSectAvrgSPH (anorm, alphap, Ntheta, SS, normalized, Cext,   &
           Cscat, Qext, Qscat)
!-----------------------------------------------------------------------------------
! The routine computes the average differential scattering cross section in the    !
! azimuthal plane phi = 0. The incident wave propagates along the Z-axis of the    !
! global coordinate system.                                                        !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none 
  integer       :: Ntheta, i
  real(O)       :: anorm, alphap, Cext, Cscat, Qext, Qscat, fact, ca, sa, ca2, sa2, &
                   theta, h, v   
  complex(O)    :: SS(3,Ntheta)
  logical       :: normalized
!
  write (iDSCS,"(/,2x,'Results:',/)")
  write (iDSCS,"(2x,'Cross Sections and Efficiencies:')") 
  write (iDSCS,"(2x,'average scattering cross section = ',1pe13.4,';')") Cscat
  write (iDSCS,"(2x,'average extinction cross section = ',1pe13.4,';')") Cext 
  write (iDSCS,*)    
  write (iDSCS,"(2x,'average scattering efficiency    = ',1pe13.4,';')") Qscat
  write (iDSCS,"(2x,'average extinction efficiency    = ',1pe13.4,';')") Qext 
  write (iDSCS,*)   
  write (iDSCS,"(2x,'Differential Scattering Cross Section:')")
  if (normalized) then
    write (iDSCS,"(2x, a, /, 2x, a, 9x, a, 8x, a, /)")                              &
   'normalized average  differential scattering cross section', 'theta',            &
   'parallel', 'perpendicular'                  
  else
    write (iDSCS,"(8x, a, /, 2x, a, 9x, a, 8x, a, /)")                              &
   'average differential scattering cross section', 'theta',                        &
   'parallel', 'perpendicular'                            
  end if  
  ca   = cos(alphap)
  sa   = sin(alphap) 
  ca2  = ca * ca
  sa2  = sa * sa
  fact = Pi * anorm * anorm
  fact = 1._O / fact
  do i = 1, Ntheta    
    theta = real(i - 1,O) * 180._O / real(Ntheta - 1,O)       
    h = real(SS(1,i),O) * ca2
    v = real(SS(3,i),O) * sa2  
    if (normalized) then
      h = h * fact
      v = v * fact                                          
    end if  
    write (iDSCS,"(1x,f6.2,5x,1pe13.4,5x,1pe13.4)") theta, h, v
  end do
end subroutine DiffScatCrossSectAvrgSPH 
! **********************************************************************************
subroutine ScatteringMatrixSPH (theta, Ntheta, ZE, Z)
!-----------------------------------------------------------------------------------
! The routine computes the scattering matrix Z at the scattering angle theta. ZE is!
! the extended scattering matrix and Ntheta is the number of scattering angles (at !
! which the extended scattering matrix is computed) in the azimuthale plane        !
! phi = 0.                                                                         !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Ntheta
  real(O)    :: theta, ZE(4,Ntheta), Z(4,4)
! 
  integer    :: i
  real(O)    :: Z11, Z12, Z33, Z34
  real(O),allocatable :: thetaV(:), ZV(:) 
! 
  allocate (thetaV(Ntheta), ZV(Ntheta))
  do i = 1, Ntheta
    thetaV(i) = real(i - 1,O) * Pi / real(Ntheta - 1,O)        
  end do
  do i = 1, Ntheta
    ZV(i) = ZE(1,i)
  end do
  call Interp (Ntheta, thetaV, ZV, theta, Z11)
  do i = 1, Ntheta
    ZV(i) = ZE(2,i)
  end do
  call Interp (Ntheta, thetaV, ZV, theta, Z12)
  do i = 1, Ntheta
    ZV(i) = ZE(3,i)
  end do
  call Interp (Ntheta, thetaV, ZV, theta, Z33)
  do i = 1, Ntheta
    ZV(i) = ZE(4,i)
  end do
  call Interp (Ntheta, thetaV, ZV, theta, Z34)
  Z(1,1) =   Z11     
  Z(1,2) =   Z12
  Z(1,3) =   0._O
  Z(1,4) =   0._O 
  Z(2,1) =   Z12
  Z(2,2) =   Z11  
  Z(2,3) =   0._O
  Z(2,4) =   0._O
  Z(3,1) =   0._O
  Z(3,2) =   0._O
  Z(3,3) =   Z33  
  Z(3,4) =   Z34        
  Z(4,1) =   0._O
  Z(4,2) =   0._O
  Z(4,3) = - Z34 
  Z(4,4) =   Z33 
  deallocate (thetaV, ZV)
end subroutine ScatteringMatrixSPH
! **********************************************************************************
subroutine ExtendedScatteringMatrixSPH (Ntheta, SS, ZE)
!-----------------------------------------------------------------------------------
! The routine computes the scattering matrix ZE, for all scattering angles. SS is  !
! the average size matrix and Ntheta is the number of scattering angles.           !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Ntheta, i
  real(O)    :: ZE(4,Ntheta)
  complex(O) :: SS(3,Ntheta)
  complex(O) :: S11SC11, S11SC22, S22SC22 
!
  do i = 1, Ntheta     
    S11SC11 = SS(1,i) 
    S11SC22 = SS(2,i) 
    S22SC22 = SS(3,i)        
    ZE(1,i) = 0.5_O * real(S11SC11 + S22SC22,O)     
    ZE(2,i) = 0.5_O * real(S11SC11 - S22SC22,O)   
    ZE(3,i) = real (S11SC22,O)  
    ZE(4,i) = aimag(S11SC22)        
  end do
end subroutine ExtendedScatteringMatrixSPH
! **********************************************************************************
subroutine SijSCpqSPH (wavenumber, ind_ref, amin, amax, TypeDist, Npar, par, Cnst,  &
           Nrank, Nint, Ntheta, S, PrnProgress)
!-----------------------------------------------------------------------------------     
! The routine computes the size average matrix <Spq Sp1q1*> by using an analytical !
! averaging procedure.                                                             ! 
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer      :: TypeDist, Npar, Nrank, Nint, Ntheta
  real(O)      :: wavenumber, amin, amax, Cnst, par(Npar)
  complex(O)   :: ind_ref, S(3,Ntheta)  
  logical      :: PrnProgress
!      
  integer       :: i, j, n, nt, ml, m, mtl, mt, k, kt, Nmax, IdentifyIndex
  real(O)       :: wavenumber2, invwno
  complex(O)    :: fct, Ptt, Ptp, Ppt, Ppp, MTh, MPh, MThC, MPhC  
  complex(O),allocatable :: M2inf(:,:), M3inf(:,:), A(:,:), B(:,:), C(:,:)
!
  Nmax = 3 * Nrank
  allocate (M2inf(Ntheta,Nmax), M3inf(Ntheta,Nmax)) 
  call MNinfiniteMatrix (1, Nrank, Nmax, Ntheta, M2inf, M3inf)
  allocate (A(Nrank,Nrank), B(Nrank,Nrank), C(Nrank,Nrank))
  call AVSCTCOEF (wavenumber, ind_ref, amin, amax, TypeDist, Npar, par, Cnst,       &
       Nrank, Nint, Nrank, A, B, C)
  wavenumber2 = wavenumber * wavenumber
  invwno      = 1._O / wavenumber2
  do j = 1,3        
    do i = 1, Ntheta
      S(j,i) = zero       
    end do
  end do
  do n = 1, Nrank
    if (PrnProgress) call write_progress (.false., n, Nrank)
    do nt = 1, Nrank
      do i = 1, Ntheta
        Ptt = zero
        Ptp = zero
        Ppt = zero
        Ppp = zero
        fct = im**(n - nt) * sqrt(real((2 * n + 1) * (2 * nt + 1),O))
        fct = fct * invwno
        do ml = 1, 2
          m = - 3 + 2 * ml
          k = IdentifyIndex (m, n, Nrank)                 
          do mtl = 1, 2
            mt = - 3 + 2 * mtl
            kt = IdentifyIndex (mt, nt, Nrank)
            MTh  = M2inf(i,k)                                  
            MPh  = M3inf(i,k)
            MThC = conjg(M2inf(i,kt))                              
            MPhC = conjg(M3inf(i,kt))
            Ptt  = Ptt + m * mt * MTh * MThC * fct
            Ptp  = Ptp + im * m * MTh * MPhC * fct
            Ppt  = Ppt - im * mt * MPh * MThC * fct
            Ppp  = Ppp + MPh * MPhC * fct
          end do
        end do
        S(1,i) = S(1,i) + A(n,nt) * Ptt + C(n,nt) * Ptp +                           &
                          conjg(C(nt,n)) * Ppt + B(n,nt) * Ppp
        S(2,i) = S(2,i) + A(n,nt) * Ptp + C(n,nt) * Ptt +                           &
                          conjg(C(nt,n)) * Ppp + B(n,nt) * Ppt
        S(3,i) = S(3,i) + A(n,nt) * Ppp + C(n,nt) * Ppt +                           &
                          conjg(C(nt,n)) * Ptp + B(n,nt) * Ptt                            
      end do 
    end do
  end do
  deallocate (M2inf, M3inf, A, B, C)  
end subroutine SijSCpqSPH    
! **********************************************************************************
subroutine AVSCTCOEF (wavenumber, ind_ref, amin, amax, TypeDist, Npar, par, Cnst,   &
           Nrank, Nint, NP, A, B, C)
  use parameters
  implicit none
  integer      :: TypeDist, Npar, Nrank, Nint, NP
  real(O)      :: wavenumber, amin, amax, Cnst, par(Npar)
  complex(O)   :: ind_ref, A(NP,NP), B(NP,NP), C(NP,NP)
!
  integer      :: n, nt, p
  real(O)      :: r, f, PDF 
  real(O),allocatable    :: x(:), w(:)
  complex(O),allocatable :: cv(:)

  allocate (cv(2*Nrank))
  allocate (x(Nint), w(Nint))
  call Simpson (amin, amax, Nint, x, w)
  do n = 1, Nrank
    do nt = 1, Nrank
      A(n,nt) = zero
      B(n,nt) = zero
      C(n,nt) = zero
    end do
  end do
  do p = 1, Nint    
    r = x(p)
    f = w(p) * Cnst * PDF(TypeDist, Npar, par, r)
    call coefficients_fg_m (wavenumber, r, ind_ref, 1, Nrank, Nrank, cv)
    do n = 1, Nrank
      do nt = 1, Nrank      
        A(n,nt) = A(n,nt) + cv(n) * conjg(cv(nt)) * f
        B(n,nt) = B(n,nt) + cv(Nrank+n) * conjg(cv(Nrank+nt)) * f
        C(n,nt) = C(n,nt) + cv(n) * conjg(cv(Nrank+nt)) * f
      end do
    end do
  end do
  deallocate (cv, x, w)
end subroutine AVSCTCOEF
! **********************************************************************************
subroutine AvCscatCextSPH (wavenumber, snorm, ind_ref, amin, amax, TypeDist, Npar,  &
           par, Cnst, Nrank, Nint, Cext, Cscat, Qext, Qscat, AsymPar)
!-----------------------------------------------------------------------------------     
! The routine computes the average cross sections, efficiencies and asymmetry      !
! parameter.                                                                       !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer      :: TypeDist, Npar, Nrank, Nint
  real(O)      :: wavenumber, amin, amax, Cnst, par(Npar), Cext, Cscat, Qext,       &
                  Qscat, AsymPar, snorm
  complex(O)   :: ind_ref  
!      
  integer       :: n
  real(O)       :: sum, fct, wavenumber2, invwno
  complex(O)    :: sum1, sum2
  real(O),allocatable    :: ccav(:)               
  complex(O),allocatable :: cav(:), cav1(:), cav2(:)
!
  wavenumber2 = wavenumber * wavenumber
  invwno      = 1._O / wavenumber2
  allocate (cav(2*Nrank), ccav(2*Nrank), cav1(Nrank-1), cav2(Nrank))
  call AVSCTCOEF1 (wavenumber, ind_ref, amin, amax, TypeDist, Npar, par, Cnst,      &
       Nrank, Nint, cav, ccav, cav1, cav2)
  sum1 = zero
  sum  = 0._O
  sum2 = zero
  do n = 1, Nrank
    fct  = real(2 * n + 1,O)
    sum1 = sum1 + fct * (cav(n)  + cav(Nrank+n))
    sum  = sum  + fct * (ccav(n) + ccav(Nrank+n))
    fct  = fct / real(n * (n + 1),O)
    sum2 = sum2 + fct * cav2(n)
  end do        
  Cext  = - 2._O * Pi * real(sum1,O) * invwno
  Cscat =   2._O * Pi * sum * invwno
  sum1 = zero
  do n = 1, Nrank - 1
    fct  = real(n * (n + 2),O) / real(n + 1,O)
    sum1 = sum1 + fct * cav1(n)
  end do   
  AsymPar = 4._O * Pi * real(sum1 + sum2,O) * invwno / Cscat
  Qscat   = Cscat * wavenumber2 / snorm
  Qext    = Cext * wavenumber2 / snorm
  deallocate (cav, ccav, cav1, cav2)
end subroutine AvCscatCextSPH
! **********************************************************************************
subroutine AVSCTCOEF1 (wavenumber, ind_ref, amin, amax, TypeDist, Npar, par, Cnst,  &
           Nrank, Nint, cav, ccav, cav1, cav2)
  use parameters
  implicit none
  integer      :: TypeDist, Npar, Nrank, Nint
  real(O)      :: wavenumber, amin, amax, Cnst, par(Npar), ccav(2*Nrank) 
  complex(O)   :: ind_ref, cav(2*Nrank), cav1(Nrank-1), cav2(Nrank)
!
  integer      :: n, p
  real(O)      :: r, f, PDF 
  real(O),allocatable    :: x(:), w(:)
  complex(O),allocatable :: c(:)
!
  allocate (c(2*Nrank))
  allocate (x(Nint), w(Nint))
  call Simpson (amin, amax, Nint, x, w)
  do n = 1, 2*Nrank
    cav(n)  = zero
    ccav(n) = 0._O
  end do
  do n = 1, Nrank - 1
    cav1(n) = zero
  end do
  do n = 1, Nrank
    cav2(n) = zero
  end do
  do p = 1, Nint
    r = x(p)
    f = w(p) * Cnst * PDF(TypeDist, Npar, par, r)
    call coefficients_fg_m (wavenumber, r, ind_ref, 1, Nrank, Nrank, c)
    do n = 1, 2*Nrank
      cav (n) = cav(n)  + c(n) * f
      ccav(n) = ccav(n) + abs(c(n)) * abs(c(n)) * f      
    end do
    do n = 1, Nrank - 1
      cav1(n) = cav1(n) + (c(n) * conjg(c(n+1)) +                                   &
      c(Nrank+n) * conjg(c(Nrank+n+1))) * f
    end do
    do n = 1, Nrank
      cav2(n) = cav2(n) + c(n) * conjg(c(Nrank+n)) * f 
    end do
  end do
  deallocate (c, x, w)
end subroutine AVSCTCOEF1
! **********************************************************************************
subroutine GeometryPars (amin, amax, TypeDist, Npar, par, Nint, Cnst, AvrgArea,     &
           EffRadius, AvrgRadius, AvrgVolume, VWAvrgRadius, EffVar)
  use parameters
  implicit none
  integer      :: TypeDist, Npar, Nint
  real(O)      :: amin, amax, par(Npar), Cnst, AvrgArea, EffRadius, AvrgRadius,     &
                  AvrgVolume, VWAvrgRadius, EffVar
!
  integer      :: p
  real(O)      :: r, r2, r3, r4, dr2, sum, sum1, sum2, sum3, sum4, PDF 
  real(O),allocatable    :: x(:), w(:)
!
  allocate (x(Nint), w(Nint))
  call Simpson (amin, amax, Nint, x, w)  
  sum  = 0._O
  sum1 = 0._O
  sum2 = 0._O
  sum3 = 0._O
  sum4 = 0._O
  do p = 1, Nint
    r    = x(p) 
    r2   = r  * r
    r3   = r2 * r
    r4   = r2 * r2
    sum  = sum  + w(p) * PDF(TypeDist, Npar, par, r)
    sum1 = sum1 + w(p) * r  * PDF(TypeDist, Npar, par, r)
    sum2 = sum2 + w(p) * r2 * PDF(TypeDist, Npar, par, r)
    sum3 = sum3 + w(p) * r3 * PDF(TypeDist, Npar, par, r)  
    sum4 = sum4 + w(p) * r4 * PDF(TypeDist, Npar, par, r)         
  end do
  Cnst = 1._O / sum
  AvrgArea     = Pi * sum2 * Cnst
  EffRadius    = Pi * sum3 * Cnst / AvrgArea
  AvrgRadius   = sum1 * Cnst
  AvrgVolume   = 4._O * Pi * sum3 * Cnst / 3._O
  VWAvrgRadius = 4._O * Pi * sum4 * Cnst / (3._O * AvrgVolume)
  sum  = 0._O
  do p = 1, Nint
    r   = x(p)  
    r2  = r * r             
    dr2 = (r - EffRadius) * (r - EffRadius)
    sum = sum + w(p) * dr2 * r2 * PDF(TypeDist, Npar, par, r)
  end do
  EffVar = Pi * sum * Cnst / (AvrgArea * EffRadius * EffRadius)  
  deallocate (x, w)
end subroutine GeometryPars
!***********************************************************************************
function PDF (TypeDist, Npar, par, a) result(func)
  use parameters
  implicit none
  integer,intent(in) :: TypeDist, Npar
  real(O),intent(in) :: par(Npar), a
  real(O) :: func
!
  real(O) :: alpha, gamma, ac, ag, sg, ag1, sg1, lnf, lnf1
!
  select case (TypeDist)
  case (1)
!   --- modified gamma distribution ---
    alpha = par(1)
    gamma = par(2)  
    ac    = par(3)
    lnf   = alpha * log(a) - alpha * (a / ac)**gamma / gamma    
    func  = exp(lnf)
  case (2)
!   --- log normal distribution ---
    ag    = par(1)
    sg    = par(2)
    lnf   = - log(a) - 0.5_O * (log(a/ag) / log(sg))**2 
    func  = exp(lnf)
  case (3)
!   --- gamma distribution ---
    alpha = par(1)
    gamma = par(2)
    lnf   = (1._O - 3._O * gamma) * log(a) / gamma - a / alpha / gamma
    func  = exp(lnf)
  case (4)
!   --- power law distribution ---    
    alpha =   par(1)
    lnf   = - alpha * log(a)
    func  =   exp(lnf)
  case (5)
!   --- modified bimodal log normal distribution ---
    ag    = par(1)   
    sg    = par(2)
    ag1   = par(3)
    sg1   = par(4)
    gamma = par(5)
    lnf   = - 4._O * log(a) - 0.5_O * (log(a/ag)  / log(sg))**2 
    lnf1  = - 4._O * log(a) - 0.5_O * (log(a/ag1) / log(sg1))**2 
    func  = exp(lnf) + gamma * exp(lnf1)     
  end select
end function PDF

! **********************************************************************************
! *             ROUTINES FOR COMPUTING THE TRANSLATION ADDITION                    *
! *        COEFFICIENTS, ROTATION FUNCTIONS AND COUPLING COEFFICIENTS              *
! *     ----------------------------------------------------------------------     *
! *     Partial list of subroutines:                                               *
! *       Jacobi_n0,                  dmm1n,                   dmm1nVect,          *
! *       coef_rotation,              coef_rotationVect,       coef_rotationMatr,  *
! *       MatTransCmnn1,              MatTransAB_mnn1,         MatTransAB_mn_m1n1, *
! *       matrix_inverse,             MatRot_R_mn_m1n1_single, MatRot_R_mn_m1n1,   *
! *       MatTransRot_TR_mn_m1n1,     MatRotTrans_RT_mn_m1n1,                      *
! *       MatRotTransRot_RTR_mn_m1n1, identity_transformation, lnfactorial,        *  
! *       gumnkl,                     CouplingCoef                                 *
! ********************************************************************************** 
function Jacobi_n0 (beta, m, m1) result (Pmm1n0)
!-----------------------------------------------------------------------------------
! The routine computes the Jacobi polynom for m >= 0, m1 >= 0, and n0 = max(m,m1). !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: m, m1
  real(O)    :: beta, x
  complex(O) :: Pmm1n0
!
  integer    :: p, maxm, minm
  real(O)    :: prod, fact  
!
  x = cos(beta)  
  if (m == m1) then  
    fact   = ((1._O + x) / 2._O)**m
    Pmm1n0 = cmplx(fact,0.0,O)
  else
    maxm = max(m,m1)
    minm = min(m,m1)  
    prod = 1._O
    do p = 1, maxm - minm
      fact = sqrt(real(m + m1 + p,O) / real(p,O))
      prod = prod * fact
    end do  
    fact   = sqrt((1._O - x) / 2._O)
    Pmm1n0 = (-im)**(maxm - minm) * prod * fact**(maxm - minm)
    fact   = sqrt((1._O + x) / 2._O)
    Pmm1n0 = Pmm1n0 * fact**(maxm + minm)
  end if
!..................................................................................!
!       Take into account that: cos(beta/2) = -((1 + cos(beta))/2) for beta > 180  !
!       and sin(beta/2) = -((1 - cos(beta))/2) for beta < 0.                       !
!..................................................................................!
  if (beta > Pi .or. beta < 0) then
    Pmm1n0 = (-1._O)**(m + m1) * Pmm1n0
  end if 
end function Jacobi_n0
!***********************************************************************************
function dmm1n (beta, n, m, m1) result (d)
!-----------------------------------------------------------------------------------
!The routine computes the dmm1n coeffcients for m >= 0, m1 >= 0, and n >= max(m,m1)! 
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none
  integer     :: n, m, m1
  real(O)     :: beta
  complex(O)  :: d
!
  integer     :: n0, l
  real(O)     :: x, fact1, fact2
  complex(O)  :: Pmm1n, Pmm1_m, Pmm1, Pmm1_p, Jacobi_n0
!
  x  = cos(beta)
  n0 = max(m,m1)
  d  = zero
  if ((m <= n) .and. (m1 <= n)) then
    if (n0 == 0) then
      if (n == 0) then
        Pmm1n = (1._O,0._O)
      else
        Pmm1_m = zero
        Pmm1   = (1._O,0._O)
        do l = 0, n - 1
          fact1  = real(2 * l + 1,O) * x / real(l + 1,O)
          fact2  = real(l,O) / real(l + 1,O)
          Pmm1_p = fact1 * Pmm1 - fact2 * Pmm1_m
          Pmm1_m = Pmm1
          Pmm1   = Pmm1_p
        end do  
        Pmm1n = Pmm1
      end if
    else
      if (n == n0) then
        Pmm1n = Jacobi_n0 (beta, m, m1)    
      else 
        Pmm1_m = zero
        Pmm1   = Jacobi_n0 (beta, m, m1)
        do l = n0, n - 1                        
          fact1  = real(l * (l + 1),O) * x - real(m * m1,O)
          fact1  = fact1 / sqrt(real((l + 1)**2 - m**2,O))
          fact1  = fact1 / sqrt(real((l + 1)**2 - m1**2,O))
          fact1  = fact1 * real(2 * l + 1,O) / real(l,O)
          fact2  = sqrt(real(l**2 - m**2,O)) * sqrt(real(l**2 - m1**2,O))
          fact2  = fact2 / sqrt(real((l + 1)**2 - m**2,O))
          fact2  = fact2 / sqrt(real((l + 1)**2 - m1**2,O))
          fact2  = fact2 * real(l + 1,O) / real(l,O)       
          Pmm1_p = fact1 * Pmm1 - fact2 * Pmm1_m
          Pmm1_m = Pmm1
          Pmm1   = Pmm1_p
        end do  
        Pmm1n = Pmm1
      end if
    end if
    d = im**(m1 - m) * Pmm1n
  end if  
end function dmm1n
!***********************************************************************************
subroutine dmm1nVect (beta, Nrank, m, m1, dmm1)
!-----------------------------------------------------------------------------------
! The routine computes the dmm1 vector coeffcients for m >= 0, m1 >= 0, and        !
! n = 0,...,Nrank.                                                                 !
!-----------------------------------------------------------------------------------  
  use parameters
  implicit none
  integer     :: Nrank, m, m1
  real(O)     :: beta
  complex(O)  :: dmm1(0:Nrank)
!
  integer     :: n0, n
  real(O)     :: x, fact1, fact2
  complex(O)  :: Jacobi_n0
!
  x  = cos(beta)
  n0 = max(m,m1)
  if (m <= Nrank .and. m1 <= Nrank) then
    if (n0 == 0) then     
      dmm1(0) = one      
      dmm1(1) = x * dmm1(0)
      do n = 1, Nrank - 1
        fact1 = real(2 * n + 1,O) * x / real(n + 1,O)
        fact2 = real(n,O) / real(n + 1,O)
        dmm1(n+1) = fact1 * dmm1(n) - fact2 * dmm1(n-1)
      end do
    else
      do n = 0, n0 - 1
        dmm1(n) = zero
      end do
      dmm1(n0) = im**(m1 - m) * Jacobi_n0 (beta, m, m1)      
      do n = n0, Nrank - 1                      
        fact1 = real(n * (n + 1),O) * x - real(m * m1,O)
        fact1 = fact1 / sqrt(real((n + 1)**2 - m**2,O))
        fact1 = fact1 / sqrt(real((n + 1)**2 - m1**2,O))
        fact1 = fact1 * real(2 * n + 1,O) / real(n,O)
        fact2 = sqrt(real(n**2 - m**2,O)) * sqrt(real(n**2 - m1**2,O))
        fact2 = fact2 / sqrt(real((n + 1)**2 - m**2,O))
        fact2 = fact2 / sqrt(real((n + 1)**2 - m1**2,O))
        fact2 = fact2 * real(n + 1,O) / real(n,O)
        dmm1(n+1) = fact1 * dmm1(n) - fact2 * dmm1(n-1)
      end do
    end if  
  else
    do n = 0, Nrank
      dmm1(n) = zero
    end do
  end if            
end subroutine dmm1nVect
!***********************************************************************************         
function coef_rotation (alfa, beta, gama, n, m, m1) result (Dnmm1)
!-----------------------------------------------------------------------------------
! The routine computes the rotation coefficients Dnmm1(alfa,beta,gama).            !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: n, m, m1
  real(O)    :: alfa, beta, gama
  complex(O) :: Dnmm1
!
  real(O)    :: arga, argg       
  complex(O) :: d, dmm1n
!
  if (m >= 0 .and. m1 >= 0) then
    d = dmm1n (beta, n, m, m1)  
  else if (m < 0 .and. m1 >= 0) then
    d = (-1._O)**n * dmm1n (beta + Pi, n, - m, m1)
  else if (m >= 0 .and. m1 < 0) then
    d = (-1._O)**n * dmm1n (beta + Pi, n, m, - m1)    
  else if (m < 0 .and. m1 < 0) then
    d = dmm1n (beta, n, - m, - m1)
  end if
  arga  = real(m,O) * alfa
  argg  = real(m1,O) * gama
  Dnmm1 = (-1._O)**(m + m1) * d * exp(im * arga) * exp(im * argg)
end function coef_rotation
!***********************************************************************************         
subroutine coef_rotationVect (alfa, beta, gama, Nrank, m, m1, Dmm1)
!------------------------------------------------------------------------------------
! The routine computes the vector rotation coefficients Dmm1(alfa,beta,gama)        !
! for n = 0,...,Nrank.                                                              !
!------------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Nrank, m, m1
  real(O)    :: alfa, beta, gama
  complex(O) :: Dmm1(0:Nrank)
!
  integer    :: n
  real(O)    :: arga, argg
  complex(O) :: fact     
  complex(O),allocatable :: d(:)
!
  allocate (d(0:Nrank))
  if (m >= 0 .and. m1 >= 0) then
    call dmm1nVect (beta, Nrank, m, m1, d)
  else if (m < 0 .and. m1 >= 0) then  
    call dmm1nVect (beta + Pi, Nrank, - m, m1, d)
    do n = 0, Nrank
      d(n) = (-1._O)**n * d(n)
    end do
  else if (m >= 0 .and. m1 < 0) then
    call dmm1nVect (beta + Pi, Nrank, m, - m1, d)
    do n = 0, Nrank
      d(n) = (-1._O)**n * d(n)
    end do
  else if (m < 0 .and. m1 < 0) then
    call dmm1nVect (beta, Nrank, - m, - m1, d)
  end if
  arga  = real(m,O) * alfa
  argg  = real(m1,O) * gama
  fact  = (-1._O)**(m + m1) * exp(im * arga) * exp(im * argg)
  do n = 0, Nrank
    Dmm1(n) = fact * d(n)
  end do
  deallocate (d)
end subroutine coef_rotationVect
!***********************************************************************************         
subroutine coef_rotationMatr (alfa, beta, gama, Nrank, Mrank, Mrank1, D)
!-----------------------------------------------------------------------------------
! The routine computes the matrix rotation coefficients D(alfa,beta,gama)          !
! for m = -Mrank,Mrank, m1 = -Mrank1,Mrank1, n = 0,...,Nrank.                      !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Nrank, Mrank, Mrank1
  real(O)    :: alfa, beta, gama
  complex(O) :: D(-Mrank:Mrank,-Mrank1:Mrank1,0:Nrank)
!
  integer    :: m, m1, n
  complex(O),allocatable :: Dmm1(:)
!
  allocate (Dmm1(0:Nrank))
  do m = - Mrank, Mrank
    do m1 = - Mrank1, Mrank1
      call coef_rotationVect (alfa, beta, gama, Nrank, m, m1, Dmm1)
      do n = 0, Nrank
        D(m,m1,n) = Dmm1(n)
      end do
    end do
  end do 
  deallocate (Dmm1)
end subroutine coef_rotationMatr
!***********************************************************************************
subroutine MatTransCmnn1 (index, wavenumber, z0, m, NN, c, NNP)
!-----------------------------------------------------------------------------------
! The routine computes the axial-translation matrix Cm(z0) for spherical wave      !
! functions and the azimuthal mode m. For index = 1, the translation coefficients  !
! involve the Bessel functions, while for index = 3, the translation coefficients  !
! involve the Hankel functions of the first order. Note that if index = 3, the     !
! routine must be called with positive values of the axial distance z0.            !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer     :: m, NN, NNP, index
  real(O)     :: z0, wavenumber
  complex(O)  :: c(0:NNP,0:2*NNP+1)
!                 
  integer     :: n, n1
  real(O)     :: f1, f2, f3, fm, fn ,fnm
  complex(O)  :: x 
  complex(O), allocatable :: j(:),jd(:)
!
  allocate (j(0:2*NN+1), jd(0:2*NN+1))
  if (m == 0) then 
    do n = 0, NN
      do n1 = 0, 2*NN + 1
        c(n,n1) = zero
      end do  
    end do
  end if        
  x = cmplx (wavenumber * z0,0.0,O)
  if (m == 0) then
    if (index == 1) then
      call besel_j (x, 2*NN + 1, j, jd)
    else if (index == 3) then
      call besel_h (x, 2*NN + 1, j, jd)      
    end if
    do n1 = 0, 2*NN + 1
      f1 = sqrt(real(2 * n1 + 1,O))       
      c(0,n1) = (-1._O)**n1 * f1 * j(n1)
    end do  
  else
    fm = sqrt(real(2 * m + 1,O) / 2._O / real(m,O))
    do n1 = m, 2*NN + 1 - m       
      f1 = fm * sqrt(real(n1 + m - 1,O) / real(2 * n1 - 1,O))
      f1 = f1 * sqrt(real(n1 + m,O) / real(2 * n1 + 1,O))     
      f2 = fm * sqrt(real(n1 - m + 1,O) / real(2 * n1 + 1,O))                
      f2 = f2 * sqrt(real(n1 - m + 2,O) / real(2 * n1 + 3,O))
      c(m,n1) = f1 * c(m-1,n1-1) + f2 * c(m-1,n1+1)
    end do  
  end if
  fm = sqrt(real(2 * m + 3,O))
  do n = m + 1, NN
    fn  = sqrt(real(2 * n - 1,O) * real(2 * n + 1,O))
    fnm = sqrt(real(n - m,O) * real(n + m,O))       
    if (n == m + 1) then          
      f3 = fn / fm
      f3 = f3 / fnm   
      c(n,m) = - f3 * c(n-1,m+1)
      do n1 = m + 1, 2*NN + 1 - n
        f2 = fn /  sqrt(real(2 * n1 - 1,O)  * real(2 * n1 + 1,O))
        f2 = f2 * (sqrt(real(n1 - m,O) * real(n1 + m,O)) / fnm)         
        f3 = fn /  sqrt(real(2 * n1 + 1,O) * real(2 * n1 + 3,O))
        f3 = f3 * (sqrt(real(n1 - m + 1,O) * real(n1 + m + 1,O)) / fnm)         
        c(n,n1) = f2 * c(n-1,n1-1) - f3 * c(n-1,n1+1)
      end do  
    else          
      f1 = sqrt(real(2 * n + 1,O) / real(2 * n - 3,O))
      f1 = f1 * (sqrt(real(n - m - 1,O) * real(n + m - 1,O)) / fnm)   
      f3 = fn / fm
      f3 = f3 / fnm   
      c(n,m) = f1 * c(n-2,m) - f3 * c(n-1,m+1)
      do n1 = m + 1, 2*NN + 1 - n           
        f2 = fn /  sqrt(real(2 * n1 - 1,O)  * real(2 * n1 + 1,O))
        f2 = f2 * (sqrt(real(n1 - m,O) * real(n1 + m,O)) / fnm) 
        f3 = fn /  sqrt(real(2 * n1 + 1,O) * real(2 * n1 + 3,O))
        f3 = f3 * (sqrt(real(n1 - m + 1,O) * real(n1 + m + 1,O)) / fnm)         
        c(n,n1) = f1 * c(n-2,n1) + f2 * c(n-1,n1-1) - f3 * c(n-1,n1+1)
      end do  
    end if
  end do   
  deallocate (j, jd)    
end subroutine MatTransCmnn1
!***********************************************************************************
subroutine MatTransAB_mnn1 (wavenumber, direct, z0, m, c, NNP, Nmax, Nmax1,         &
           AA, NP, MP)
!-----------------------------------------------------------------------------------
! The routine computes the axial-translation matrix Tm(z0) for vector spherical    !
! wave functions and the azimuthal mode m. For direct = t, the direct              !
! transformation matrix is computed, while for direct = f, the inverse             !
! transformation matrix is computed. The structure of the matrix is:               !
!                                 |  A    -B |                                     !                                             
!                            T =  |          |.                                    !                          
!                                 | -B     A |                                     !                            
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: m, NNP, Nmax, Nmax1, NP, MP
  real(O)    :: z0, wavenumber
  complex(O) :: AA(2*NP,2*MP), c(0:NNP,0:2*NNP+1)               
  logical    :: direct
!
  integer    :: n, n1, k, k1
  real(O)    :: xr, f1, f2, f3, f, s
  complex(O) :: A, B, x
!
  do k = 1, 2*Nmax
    do k1 = 1, 2*Nmax1
      AA(k,k1) = zero
    end do      
  end do
  xr = wavenumber * z0
  x  = cmplx(xr,0.0,O)  
  do k1 = 1, Nmax1
    if (m == 0) then
      n1 = k1
    else
      n1 = m + k1 - 1
    end if            
    f1 = sqrt(real(n1 - m + 1,O) / real(2 * n1 + 1,O))
    f1 = f1 * sqrt(real(n1 + m + 1,O) / real(2 * n1 + 3,O))
    f1 = f1 * xr / real(n1 + 1,O)
    if (m <= n1 - 1) then
      f2 = sqrt(real(n1 - m,O) / real(2 * n1 + 1,O))
      f2 = f2 * sqrt(real(n1 + m,O) / real(2 * n1 - 1,O))
      f2 = f2 * xr / real(n1,O)    
    end if
    f3  = real(m,O) / real(n1 * (n1 + 1),O)
    do k = 1, Nmax
      if (m == 0) then
        n = k
      else
        n = m + k - 1
      end if 
      if (m <= n1 - 1) then
        A = c(n,n1) + f1 * c(n,n1+1) + f2 * c(n,n1-1)
      else
        A = c(n,n1) + f1 * c(n,n1+1)
      end if              
      B = im * x * f3 * c(n,n1)   
      f = sqrt(real(n1 * (n1 + 1),O) / real(n * (n + 1),O))
      A = A * f
      B = B * f
      if (direct) then       
        AA(k,k1)       =   A
        AA(k,k1+Nmax1) = - B 
      else 
        s = (-1._O)**(n + n1) 
        AA(k,k1)       = s * A
        AA(k,k1+Nmax1) = s * B
      end if
    end do  
  end do      
  do k = 1, Nmax
    do k1 = 1, Nmax1
      AA(k+Nmax,k1)       = AA(k,k1+Nmax1)
      AA(k+Nmax,k1+Nmax1) = AA(k,k1)
    end do
  end do                
end subroutine MatTransAB_mnn1
!***********************************************************************************
subroutine MatTransAB_mn_m1n1 (index, wavenumber, x0, y0, z0, Mrank, Nrank, Nmax,   &
           Mrank1, Nrank1, Nmax1, AB, NP, MP)
!-----------------------------------------------------------------------------------
! The routine computes the axial-translation matrix T(x0,y0,z0) for vector         !
! spherical wave functions. For index = 1, the translation coefficients involve the!
! Bessel functions, while for index = 3, the translation coefficients involve the  !
! Hankel functions of the first order. The structure of the matrix is              !
!                                |  A     B |                                      ! 
!                            T = |          |.                                     !                           
!                                |  B     A |                                      ! 
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1, NP, MP, index
  real(O)    :: x0, y0, z0, wavenumber
  complex(O) :: AB(2*NP,2*MP)   
!
  integer    :: n, n1, m, m1, k, k1, m2, l, ml, l1, m1l, N_1, N_0, NN, MM
  real(O)    :: r, alfa, beta, z, xr, f1, f2, f3, f4, f, fn, fm, fnm
  complex(O) :: A, B, Dn1m2m1, Dn1_m2m1, AA, BB, Dnmm2, Dnm_m2, x, f3i
  complex(O), allocatable :: j(:), jd(:), c(:,:), DP(:,:,:), DM(:,:,:)
!
  NN = max(Nrank,Nrank1) + 5
  MM = max(Nrank,Nrank1)    
  do k = 1, 2*Nmax
    do k1 = 1, 2*Nmax1
      AB(k,k1) = zero
    end do  
  end do     
  allocate (c(0:NN,0:2*NN+1), j(0:2*NN+1), jd(0:2*NN+1))  
  do n = 0, NN
    do n1 = 0, 2*NN + 1
      c(n,n1) = zero
    end do  
  end do
  call T_cartesian_spherical (x0, y0, z0, r, beta, alfa)  
  xr = wavenumber * r
  x  = cmplx(xr,0.0,O)
  z  = 0._O  
  allocate (DP(-MM:MM,-MM:MM,0:NN), DM(-MM:MM,-MM:MM,0:NN))
  call coef_rotationMatr (alfa, beta, z, NN, MM, MM, DP)
  call coef_rotationMatr (z, - beta, - alfa, NN, MM, MM, DM)
  do m2 = 0, MM
    if (m2 == 0) then
      if (index == 1) then
        call besel_j (x, 2*NN+1, j, jd)         
      else if (index == 3) then
        call besel_h(x, 2*NN+1, j, jd)      
      end if                                     
      do n1 = 0, 2*NN + 1 
        f1 = sqrt(real(2 * n1 + 1,O))
        c(0,n1) = (-1._O)**n1 * f1 * j(n1)
      end do  
    else
      fm = sqrt(real(2 * m2 + 1,O) / 2._O / real(m2,O))
      do n1 = m2, 2*NN + 1 - m2     
        f1 = fm * sqrt(real(n1 + m2 - 1,O) / real(2 * n1 - 1,O))
        f1 = f1 * sqrt(real(n1 + m2,O) / real(2 * n1 + 1,O))            
        f2 = fm * sqrt(real(n1 - m2 + 1,O) / real(2 * n1 + 1,O))
        f2 = f2 * sqrt(real(n1 - m2 + 2,O) / real(2 * n1 + 3,O))
        c(m2,n1) = f1 * c(m2-1,n1-1) + f2 * c(m2-1,n1+1)
      end do  
    end if
    fm = sqrt(real(2 * m2 + 3,O))      
    do n = m2 + 1, NN
      fn  = sqrt(real(2 * n - 1,O) * real(2 * n + 1,O))
      fnm = sqrt(real(n - m2,O) * real(n + m2,O))
      if (n == m2 + 1) then         
        f3 = fn / fm
        f3 = f3 / fnm                       
        c(n,m2) = - f3 * c(n-1,m2+1)
        do n1 = m2 + 1, 2*NN + 1 - n
          f2 = fn /  sqrt(real(2 * n1 - 1,O) * real(2 * n1 + 1,O))
          f2 = f2 * (sqrt(real(n1 - m2,O) * real(n1 + m2,O)) / fnm)               
          f3 = fn /  sqrt(real(2 * n1 + 1,O) * real(2 * n1 + 3,O))
          f3 = f3 * (sqrt(real(n1 - m2 + 1,O) * real(n1 + m2 + 1,O)) / fnm)               
          c(n,n1) = f2 * c(n-1,n1-1) - f3 * c(n-1,n1+1)
        end do  
      else              
        f1 = sqrt(real(2 * n + 1,O) / real(2 * n - 3,O))
        f1 = f1 * (sqrt(real(n - m2 - 1,O) * real(n + m2 - 1,O)) / fnm)                                 
        f3 = fn / fm
        f3 = f3 / fnm           
        c(n,m2) = f1 * c(n-2,m2) - f3 * c(n-1,m2+1)
        do n1 = m2 + 1, 2*NN + 1 - n
          f2 = fn /  sqrt(real(2 * n1 - 1,O) * real(2 * n1 + 1,O))
          f2 = f2 * (sqrt(real(n1 - m2,O) * real(n1 + m2,O)) / fnm)               
          f3 = fn /  sqrt(real(2 * n1 + 1,O) * real(2 * n1 + 3,O))
          f3 = f3 * (sqrt(real(n1 - m2 + 1,O) * real(n1 + m2 + 1,O)) / fnm)                               
          c(n,n1) = f1 * c(n-2,n1) + f2 * c(n-1,n1-1) - f3 * c(n-1,n1+1)
        end do  
      end if
    end do      
    do m1 = 0, Mrank1     
      if (m1 == 0) then   
        do k1 = 1, Nrank1
          n1 = k1
          if (m2 <= n1) then            
            Dn1m2m1  = DM( m2, m1, n1)
            Dn1_m2m1 = DM(-m2, m1, n1)
            f1 = sqrt(real(n1 - m2 + 1,O) / real(2 * n1 + 1,O))
            f1 = f1 * sqrt(real(n1 + m2 + 1,O) / real(2 * n1 + 3,O))
            f1 = f1 * xr / real(n1 + 1,O)           
            if (m2 <= n1 - 1) then                              
              f2 = sqrt(real(n1 - m2,O) / real(2 * n1 + 1,O))
              f2 = f2 * sqrt(real(n1 + m2,O) / real(2 * n1 - 1,O))
              f2 = f2 * xr / real(n1,O)
            end if
            f3  = real(m2,O) / real(n1 * (n1 + 1),O)
            f3i = im * x * f3
            f4  = sqrt(real(n1 * (n1 + 1),O))
            do m = 0, Mrank                             
              if (m == 0) then                      
                do k = 1, Nrank
                  n = k                 
                  Dnmm2  = DP(m,  m2, n)
                  Dnm_m2 = DP(m,- m2, n)
                  if (m2 <= n1 - 1) then
                    A = c(n,n1) + f1 * c(n,n1+1) + f2 * c(n,n1-1)
                  else                                                    
                    A = c(n,n1) + f1 * c(n,n1+1)
                  end if                                  
                  B = f3i * c(n,n1)                               
                  f = f4 / sqrt(real(n * (n + 1),O))
                  A = A * f
                  B = B * f
                  if (m2 == 0) then
                    AA = Dnmm2 * A * Dn1m2m1
                    BB = Dnmm2 * B * Dn1m2m1
                  else
                    AA = Dnmm2 * A * Dn1m2m1 + Dnm_m2 * A * Dn1_m2m1
                    BB = Dnmm2 * B * Dn1m2m1 - Dnm_m2 * B * Dn1_m2m1
                  end if
                  AB(k,k1)       = AB(k,k1) + AA
                  AB(k,k1+Nmax1) = AB(k,k1+Nmax1) + BB    
                end do  
              else
                N_0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
                ml  = m
                do l = 1, 2                          
                  do k = 1, Nrank - m + 1
                    n = m + k - 1                    
                    Dnmm2  = DP(- ml,  m2, n)
                    Dnm_m2 = DP(- ml,- m2, n)
                    if (m2 <= n1 - 1) then
                      A = c(n,n1) + f1 * c(n,n1+1) + f2 * c(n,n1-1)
                    else                                                          
                      A = c(n,n1) + f1 * c(n,n1+1)
                    end if                                
                    B = f3i * c(n,n1)                             
                    f = f4 / sqrt(real(n * (n + 1),O))
                    A = A * f
                    B = B * f
                    if (m2 == 0) then
                      AA = Dnmm2 * A * Dn1m2m1
                      BB = Dnmm2 * B * Dn1m2m1
                    else
                      AA = Dnmm2 * A * Dn1m2m1 + Dnm_m2 * A * Dn1_m2m1
                      BB = Dnmm2 * B * Dn1m2m1 - Dnm_m2 * B * Dn1_m2m1
                    end if
                    AB(k+N_0,k1)       = AB(k+N_0,k1) + AA
                    AB(k+N_0,k1+Nmax1) = AB(k+N_0,k1+Nmax1) + BB
                  end do  
                  N_0 =   N_0 + Nrank - m + 1
                  ml  = - m
                end do      
              end if
            end do                            
          end if
        end do  
      else          
        N_1 = Nrank1 + (m1 - 1) * (2 * Nrank1 - m1 + 2)
        m1l = m1
        do l1 = 1, 2             
          do k1 = 1, Nrank1 - m1 + 1
            n1 = m1 + k1 - 1
            if (m2 <= n1) then             
              Dn1m2m1  = DM(  m2, - m1l, n1)
              Dn1_m2m1 = DM(- m2, - m1l, n1)          
              f1 = sqrt(real(n1 - m2 + 1,O) / real(2 * n1 + 1,O))
              f1 = f1 * sqrt(real(n1 + m2 + 1,O) / real(2 * n1 + 3,O))
              f1 = f1 * xr / real(n1 + 1,O)         
              if (m2 <= n1 - 1) then                            
                f2 = sqrt(real(n1 - m2,O) / real(2 * n1 + 1,O))
                f2 = f2 * sqrt(real(n1 + m2,O) / real(2 * n1 - 1,O))
                f2 = f2 * xr / real(n1,O)
              end if
              f3  = real(m2,O) / real(n1 * (n1 + 1),O)
              f3i = im * x * f3
              f4  = sqrt(real(n1 * (n1 + 1),O))
              do m = 0, Mrank
                if (m == 0) then                                  
                  do k = 1, Nrank
                    n = k                    
                    Dnmm2  = DP(m,  m2, n)
                    Dnm_m2 = DP(m,- m2, n)
                    if (m2 <= n1 - 1) then
                      A = c(n,n1) + f1 * c(n,n1+1) + f2 * c(n,n1-1)
                    else                                                          
                      A = c(n,n1) + f1 * c(n,n1+1)
                    end if                                
                    B = f3i * c(n,n1)                             
                    f = f4 / sqrt(real(n * (n + 1),O))
                    A = A * f
                    B = B * f
                    if (m2 == 0) then
                      AA = Dnmm2 * A * Dn1m2m1
                      BB = Dnmm2 * B * Dn1m2m1
                    else
                      AA = Dnmm2 * A * Dn1m2m1 + Dnm_m2 * A * Dn1_m2m1
                      BB = Dnmm2 * B * Dn1m2m1 - Dnm_m2 * B * Dn1_m2m1
                    end if
                    AB(k,k1+N_1)       = AB(k,k1+N_1) + AA
                    AB(k,k1+N_1+Nmax1) = AB(k,k1+N_1+Nmax1) + BB    
                  end do  
                else
                  N_0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
                  ml  = m
                  do l = 1, 2                                   
                    do k = 1, Nrank - m + 1
                      n = m + k - 1                      
                      Dnmm2  = DP(- ml,  m2, n)
                      Dnm_m2 = DP(- ml,- m2, n)
                      if (m2 <= n1 - 1) then
                        A = c(n,n1) + f1 * c(n,n1+1) + f2 * c(n,n1-1)
                      else                                                        
                        A = c(n,n1) + f1 * c(n,n1+1)
                      end if                              
                      B = f3i * c(n,n1)                           
                      f = f4 / sqrt(real(n * (n + 1),O))
                      A = A * f
                      B = B * f
                      if (m2 == 0) then
                        AA = Dnmm2 * A * Dn1m2m1
                        BB = Dnmm2 * B * Dn1m2m1
                      else
                        AA = Dnmm2 * A * Dn1m2m1 + Dnm_m2 * A * Dn1_m2m1
                        BB = Dnmm2 * B * Dn1m2m1 - Dnm_m2 * B * Dn1_m2m1
                      end if
                      AB(k+N_0,k1+N_1)       = AB(k+N_0,k1+N_1) + AA
                      AB(k+N_0,k1+N_1+Nmax1) = AB(k+N_0,k1+N_1+Nmax1) + BB
                    end do  
                    N_0 =   N_0 + Nrank - m + 1
                    ml  = - m
                  end do      
                end if
              end do                   
            end if
          end do  
          N_1 =   N_1 + Nrank1 - m1 + 1
          m1l = - m1
        end do          
      end if
    end do  
  end do  
  do k = 1, Nmax
    do k1 = 1, Nmax1
      AB(k+Nmax,k1)       = AB(k,k1+Nmax1)
      AB(k+Nmax,k1+Nmax1) = AB(k,k1)
     end do  
  end do
  deallocate (c, j, jd)  
  deallocate (DM, DP)   
end subroutine MatTransAB_mn_m1n1
!***********************************************************************************
subroutine matrix_inverse (Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1, AB, NP, MP)
!-----------------------------------------------------------------------------------
! The routine computes the inverse T(-x0,-y0,-z0) of the general translation       !
! matrix T(x0,y0,z0) for vector spherical wave functions.                          !
!-----------------------------------------------------------------------------------       
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1, NP, MP
  complex(O) :: AB(2*NP,2*MP)
!
  integer    :: n, n1, m, m1, k, k1, l, l1, N_1, N_0
  real(O)    :: s
!
  do m = 0, Mrank
    if (m == 0) then
      do k = 1, Nrank
        n = k    
        do m1 = 0, Mrank1
          if (m1 == 0) then
            do k1 = 1, Nrank1
              n1 = k1 
              s  = (- 1._O)**(n + n1)       
              AB(k,k1)       =   s * AB(k,k1)
              AB(k,k1+Nmax1) = - s * AB(k,k1+Nmax1)
            end do  
          else        
            N_1 = Nrank1 + (m1 - 1) * (2 * Nrank1 - m1 + 2)
            do l1 = 1, 2
              do k1 = 1, Nrank1 - m1 + 1
                n1 = m1 + k1 - 1  
                s  = ( -1._O)**(n + n1)      
                AB(k,k1+N_1)       =   s * AB(k,k1+N_1)
                AB(k,k1+N_1+Nmax1) = - s * AB(k,k1+N_1+Nmax1)
              end do  
              N_1 = N_1 + Nrank1 - m1 + 1
            end do          
          end if
        end do  
      end do  
    else
      N_0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      do l = 1, 2
        do k = 1, Nrank - m + 1
          n = m + k - 1    
          do m1 = 0, Mrank1
            if (m1 == 0) then
              do k1 = 1, Nrank1
                n1 = k1
                s  = ( -1._O)**(n + n1)
                AB(k+N_0,k1)       =   s * AB(k+N_0,k1)
                AB(k+N_0,k1+Nmax1) = - s * AB(k+N_0,k1+Nmax1)
              end do  
            else        
              N_1 = Nrank1 + (m1 - 1) * (2 * Nrank1 - m1 + 2)
              do l1 = 1, 2
                do k1 = 1, Nrank1 - m1 + 1
                  n1 = m1 + k1 - 1      
                  s  = ( -1._O)**(n + n1) 
                  AB(k+N_0,k1+N_1)       =   s * AB(k+N_0,k1+N_1)
                  AB(k+N_0,k1+N_1+Nmax1) = - s * AB(k+N_0,k1+N_1+Nmax1)
                end do  
                N_1 = N_1 + Nrank1 - m1 + 1
              end do           
            end if
          end do  
        end do  
        N_0 = N_0 + Nrank - m + 1
      end do
    end if
  end do  
  do k = 1, Nmax
    do k1 = 1, Nmax1
      AB(k+Nmax,k1)       = AB(k,k1+Nmax1)
      AB(k+Nmax,k1+Nmax1) = AB(k,k1)
     end do      
  end do  
end subroutine matrix_inverse
!***********************************************************************************
subroutine MatRot_R_mn_m1n1_single (alfa, beta, gama, Mrank, Nrank, Nmax, Mrank1,   &
           Nrank1, Nmax1, R, NP, MP, matrix)
!-----------------------------------------------------------------------------------
! The routine computes the individual rotation matrix R(alfa,beta,gama) for        !
! vector spherical wave functions.                                                 !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1, NP, MP  
  real(O)    :: alfa, beta, gama
  complex(O) :: R(NP,MP)
  logical    :: matrix
!    
  integer    :: n, m, m1, k, k1, l, ml, l1, m1l, N_1, N_0
  complex(O) :: coef_rotation
  complex(O),allocatable :: D(:,:,:)
!
  if (matrix) then
    allocate (D(-Mrank:Mrank,-Mrank1:Mrank1,0:Nrank1))
    call coef_rotationMatr (alfa, beta, gama, Nrank1, Mrank, Mrank1, D)
  end if
  do k = 1, Nmax
    do k1 = 1, Nmax1
      R(k,k1) = zero
    end do  
  end do    
  do m = 0, Mrank
    if (m == 0) then
      do k = 1, Nrank
        n = k    
        do m1 = 0, Mrank1
          if (m1 == 0) then                 
            k1 = n
            if (k1 <= Nrank1) then
              if (matrix) then                        
                R(k,k1) = D(m, m1, n)
              else
                R(k,k1) = coef_rotation (alfa, beta, gama, n, m, m1)
              end if     
            end if
          else        
            N_1 = Nrank1 + (m1 - 1) * (2 * Nrank1 - m1 + 2)
            m1l = m1
            do l1 = 1, 2                          
              k1 = n - m1 + 1
              if (1 <= k1 .and. k1 <= Nrank1 - m1 + 1) then
                if (matrix) then                        
                  R(k,k1+N_1) = D(m, - m1l, n)
                else
                  R(k,k1+N_1) = coef_rotation (alfa, beta, gama, n, m, - m1l)
                end if
              end if
              N_1 =   N_1 + Nrank1 - m1 + 1
              m1l = - m1
            end do          
          end if
        end do  
      end do  
    else
      N_0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      ml  = m
      do l = 1, 2
        do k = 1, Nrank - m + 1
          n = m + k - 1    
          do m1 = 0, Mrank1
            if (m1 == 0) then                     
              k1 = n
              if (k1 <= Nrank1) then
                if (matrix) then                        
                  R(k+N_0,k1) = D(- ml, m1, n)
                else
                  R(k+N_0,k1) = coef_rotation (alfa, beta, gama, n, - ml, m1)
                end if
              end if           
            else        
              N_1 = Nrank1 + (m1 - 1) * (2 * Nrank1 - m1 + 2)
              m1l = m1
              do l1 = 1, 2                
                k1 = n - m1 + 1
                if (1 <= k1 .and. k1 <= Nrank1 - m1 + 1) then
                  if (matrix) then                               
                    R(k+N_0,k1+N_1) = D(- ml, - m1l, n)
                  else
                    R(k+N_0,k1+N_1) = coef_rotation (alfa, beta, gama, n, - ml, - m1l)
                  end if
                end if                
                N_1 =   N_1 + Nrank1 - m1 + 1
                m1l = - m1                
              end do         
            end if
          end do  
        end do  
        N_0 =   N_0 + Nrank - m + 1
        ml  = - m
      end do     
    end if
  end do
  if (matrix) deallocate (D)         
end subroutine MatRot_R_mn_m1n1_single
!***********************************************************************************
subroutine MatRot_R_mn_m1n1 (alfa, beta, gama, Mrank, Nrank, Nmax, Mrank1, Nrank1,  &
           Nmax1, R, NP, MP, matrix)
!-----------------------------------------------------------------------------------
! The routine computes the rotation matrix R(alfa,beta,gama) for vector spherical  !
! wave functions. The structure of the matrix is:                                  !
!                                     |  Ri   0  |                                 !                                              
!                                 R = |          |,                                !                           
!                                     |  0    Ri |                                 ! 
! where Ri is the individual rotation matrix.                                      !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1, NP, MP  
  real(O)    :: alfa, beta, gama
  complex(O) :: R(2*NP,2*MP)
  logical    :: matrix
!      
  integer    :: n, m, m1, k, k1, l, ml, l1, m1l, N_1, N_0
  complex(O) :: coef_rotation
  complex(O),allocatable :: D(:,:,:)
!
  if (matrix) then
    allocate (D(-Mrank:Mrank,-Mrank1:Mrank1,0:Nrank1))
    call coef_rotationMatr (alfa, beta, gama, Nrank1, Mrank, Mrank1, D)
  end if
  do k = 1, 2*Nmax
    do k1 = 1, 2*Nmax1
      R(k,k1) = zero
    end do  
  end do  
  do m = 0, Mrank
    if (m == 0) then
      do k = 1, Nrank
        n = k    
        do m1 = 0, Mrank1
          if (m1 == 0) then                 
            k1 = n
            if (k1 <= Nrank1) then  
              if (matrix) then               
                R(k,k1) = D(m, m1, n)
              else
                R(k,k1) = coef_rotation (alfa, beta, gama, n, m, m1)
              end if                                                        
            end if             
          else        
            N_1 = Nrank1 + (m1 - 1) * (2 * Nrank1 - m1 + 2)
            m1l = m1
            do l1 = 1, 2                          
              k1 = n - m1 + 1
              if (1 <= k1 .and. k1 <= Nrank1 - m1 + 1) then                    
                if (matrix) then
                  R(k,k1+N_1) = D(m, - m1l, n)
                else
                  R(k,k1+N_1) = coef_rotation (alfa, beta, gama, n, m, - m1l)
                end if
              end if                
              N_1 =   N_1 + Nrank1 - m1 + 1
              m1l = - m1
            end do 
          end if 
        end do  
      end do  
    else
      N_0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      ml  = m
      do l = 1, 2
        do k = 1, Nrank - m + 1
          n = m + k - 1    
          do m1 = 0, Mrank1
            if (m1 == 0) then                     
              k1 = n
              if (k1 <= Nrank1) then
                if (matrix) then                                                  
                  R(k+N_0,k1) = D(- ml, m1, n)
                else
                  R(k+N_0,k1) = coef_rotation (alfa, beta, gama, n, - ml, m1)
                end if
              end if              
            else        
              N_1 = Nrank1 + (m1 - 1) * (2 * Nrank1 - m1 + 2)
              m1l = m1
              do l1 = 1, 2                          
                k1 = n - m1 + 1
                if (1 <=k1 .and. k1 <= Nrank1 - m1 + 1) then
                  if (matrix) then                                                                
                    R(k+N_0,k1+N_1) = D(- ml, - m1l, n)
                  else
                    R(k+N_0,k1+N_1) = coef_rotation (alfa, beta, gama, n, - ml, - m1l)
                  end if
                end if                   
                N_1 =   N_1 + Nrank1 - m1 + 1
                m1l = - m1
              end do
            end if
          end do  
        end do  
        N_0 =   N_0 + Nrank - m + 1
        ml  = - m
      end do
    end if
  end do  
  do k = 1, Nmax
    do k1 = 1, Nmax1
      R(k+Nmax,k1+Nmax1) = R(k,k1)
    end do   
  end do  
  if (matrix) deallocate (D)
end subroutine MatRot_R_mn_m1n1
!***********************************************************************************
subroutine MatTransRot_TR_mn_m1n1 (index, wavenumber, x0, y0, z0, alfa, beta, gama,  &
           Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1, TR, NP, MP)            
!-----------------------------------------------------------------------------------
! The routine computes the transformation matrix                                   !
!                    TR = T(x0,y0,z0) * R(alfa,beta,gama),                         !
! where T is a translation matrix and R is a rotation matrix.                      !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer     :: index, Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1, NP, MP
  complex(O)  :: TR(2*NP,2*MP)
  real(O)     :: wavenumber, x0, y0, z0, alfa, beta, gama
!
  integer     :: i, j, k, Nmaxim
  complex(O)  :: sum, sum1
  complex(O), allocatable :: R(:,:)
!
  Nmaxim = max(Nmax,Nmax1)
  allocate (R(Nmaxim,Nmaxim))
  if (Nmax1 >= Nmax) then
    call MatTransAB_mn_m1n1 (index, wavenumber, x0, y0, z0, Mrank, Nrank,           &
         Nmax, Mrank1, Nrank1, Nmax1, TR, NP, MP)  
    call MatRot_R_mn_m1n1_single (alfa, beta, gama,Mrank1, Nrank1, Nmax1,           &
         Mrank1, Nrank1, Nmax1, R, Nmaxim, Nmaxim, .true.)   
    do i = 1, Nmax
      do j = 1, Nmax1
        sum  = zero
        sum1 = zero
        do k = 1, Nmax1
          sum  = sum  + TR(i,k+Nmax1) * R(k,j)
          sum1 = sum1 + TR(i+Nmax,k+Nmax1) * R(k,j)
        end do
        TR(i,j)      = sum1  
        TR(i+Nmax,j) = sum          
      end do  
    end do
  else
    call MatTransAB_mn_m1n1 (index, wavenumber, x0, y0, z0, Mrank, Nrank,           &
         Nmax, Mrank, Nrank, Nmax, TR, NP, MP)  
    call MatRot_R_mn_m1n1_single (alfa, beta, gama, Mrank, Nrank, Nmax,             &
         Mrank1, Nrank1, Nmax1, R, Nmaxim, Nmaxim, .true.)    
    do i = 1, Nmax
      do j = 1, Nmax1
        sum  = zero
        sum1 = zero
        do k = 1, Nmax
          sum  = sum  + TR(i,k+Nmax) * R(k,j)
          sum1 = sum1 + TR(i+Nmax,k+Nmax) * R(k,j)
        end do  
        TR(i,j)      = sum1
        TR(i+Nmax,j) = sum          
      end do  
    end do
  end if
  do i = 1, Nmax
    do j = 1, Nmax1
      TR(i,j+Nmax1)      = TR(i+Nmax,j)
      TR(i+Nmax,j+Nmax1) = TR(i,j)
    end do  
  end do
  deallocate (R)  
end subroutine MatTransRot_TR_mn_m1n1
!***********************************************************************************                               
subroutine MatRotTrans_RT_mn_m1n1 (index, wavenumber, x0, y0, z0, alfa, beta, gama, &
           Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1, RT, NP, MP)           
!-----------------------------------------------------------------------------------
! The routine computes the transformation matrix                                   !
!           RT = R(-gama,-beta,-alfa) * T(-x0,-y0,-z0),                            !
! where T is a translation matrix and R is a rotation matrix.                      !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer     :: index, Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1, NP, MP
  real(O)     :: wavenumber, x0, y0, z0, alfa, beta, gama
  complex(O)  :: RT(2*NP,2*MP)
!   
  integer         :: i, j, k, Nmaxim
  complex(O)  :: sum, sum1
  complex(O), allocatable :: R(:,:)
!
  Nmaxim = max(Nmax,Nmax1)
  allocate (R(Nmaxim,Nmaxim))
  if (Nmax >= Nmax1) then
    call MatRot_R_mn_m1n1_single (- gama, - beta, - alfa, Mrank, Nrank, Nmax,       &
         Mrank, Nrank, Nmax, R, Nmaxim, Nmaxim, .true.)
    call MatTransAB_mn_m1n1 (index, wavenumber, - x0, - y0, - z0, Mrank, Nrank,     &
         Nmax, Mrank1, Nrank1, Nmax1, RT, NP, MP)         
    do i = 1, Nmax
      do j = 1, Nmax1
        sum  = zero
        sum1 = zero
        do k = 1, Nmax
          sum  = sum  + R(i,k) * RT(k,j+Nmax1)
          sum1 = sum1 + R(i,k) * RT(k+Nmax,j+Nmax1)
        end do  
        RT(i,j)      = sum1
        RT(i+Nmax,j) = sum          
      end do  
    end do
  else
    call MatRot_R_mn_m1n1_single (- gama, - beta, - alfa, Mrank, Nrank, Nmax,       &
         Mrank1, Nrank1, Nmax1, R, Nmaxim, Nmaxim, .true.)
    call MatTransAB_mn_m1n1 (index, wavenumber, - x0, - y0, - z0, Mrank1, Nrank1,   &
         Nmax1, Mrank1, Nrank1, Nmax1, RT, NP, MP)              
    do i = 1, Nmax
      do j = 1, Nmax1
        sum  = zero
        sum1 = zero
        do k = 1, Nmax1
          sum  = sum  + R(i,k) * RT(k,j+Nmax1)
          sum1 = sum1 + R(i,k) * RT(k+Nmax1,j+Nmax1)
        end do  
        RT(i,j)      = sum1
        RT(i+Nmax,j) = sum          
      end do  
    end do
  end if         
  do i = 1, Nmax
    do j = 1, Nmax1
      RT(i,j+Nmax1)      = RT(i+Nmax,j)
      RT(i+Nmax,j+Nmax1) = RT(i,j)
    end do  
  end do
  deallocate (R)  
end subroutine MatRotTrans_RT_mn_m1n1
!***********************************************************************************
subroutine MatRotTransRot_RTR_mn_m1n1 (index, wavenumber, x, y, z, alfa, beta, gama, &
           Mrank, Nrank, Nmax, x1, y1, z1, alfa1, beta1, gama1, Mrank1, Nrank1,      &
           Nmax1, RTR, NP, MP)                         
!-----------------------------------------------------------------------------------               
! The routine computes the transformation matrix                                   ! 
!             RTR = R(-gama,-beta,-alfa) * T(r1-r) *  R1(alfa1,beta1,gama1),       !
! where T is a translation matrix and R is a rotation matrix.                      !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer     :: index, Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1, NP, MP
  real(O)     :: wavenumber, x, y, z, alfa, beta, gama, x1, y1, z1, alfa1,          &
                 beta1, gama1
  complex(O)  :: RTR(2*NP,2*MP)
!         
  integer         :: i, j, k, l, Nmaxim
  real(O)     :: dx, dy, dz
  complex(O)  :: sum, sum1
  complex(O), allocatable :: R(:,:),R1(:,:)     
!
  Nmaxim = max(Nmax,Nmax1)
  allocate (R(Nmaxim,Nmaxim), R1(Nmaxim,Nmaxim))
  if (Nmax >= Nmax1) then
    call MatRot_R_mn_m1n1_single (- gama, - beta, - alfa, Mrank, Nrank, Nmax,       &
         Mrank, Nrank, Nmax, R, Nmaxim, Nmaxim, .true.)
    dx = x1 - x
    dy = y1 - y
    dz = z1 - z
    call MatTransAB_mn_m1n1 (index, wavenumber, dx, dy, dz, Mrank, Nrank,           &
         Nmax, Mrank, Nrank, Nmax, RTR, NP, MP)
    call MatRot_R_mn_m1n1_single (alfa1, beta1, gama1, Mrank, Nrank, Nmax,          &
         Mrank1, Nrank1, Nmax1, R1, Nmaxim, Nmaxim, .true.)           
    do i = 1, Nmax
      do j = 1, Nmax1
        sum  = zero
        sum1 = zero
        do l = 1, Nmax
          do k = 1, Nmax
            sum  = sum  + R(i,k) * RTR(k,l+Nmax) * R1(l,j)
            sum1 = sum1 + R(i,k) * RTR(k+Nmax,l+Nmax) * R1(l,j)
          end do  
        end do
        RTR(i,j)      = sum1
        RTR(i+Nmax,j) = sum         
      end do  
    end do 
  else
    call MatRot_R_mn_m1n1_single (- gama, - beta, - alfa, Mrank, Nrank, Nmax,       &
         Mrank1, Nrank1, Nmax1, R, Nmaxim, Nmaxim, .true.)
    dx = x1 - x
    dy = y1 - y
    dz = z1 - z
    call MatTransAB_mn_m1n1 (index, wavenumber, dx, dy, dz, Mrank1, Nrank1,         &
         Nmax1, Mrank1, Nrank1, Nmax1, RTR, NP, MP)
    call MatRot_R_mn_m1n1_single (alfa1, beta1, gama1, Mrank1, Nrank1, Nmax1,       &
         Mrank1, Nrank1, Nmax1, R1, Nmaxim, Nmaxim, .true.)          
    do i = 1, Nmax
      do j = 1, Nmax1
        sum  = zero
        sum1 = zero
        do l = 1, Nmax1
          do k = 1, Nmax1
            sum  = sum  + R(i,k) * RTR(k,l+Nmax1) * R1(l,j)
            sum1 = sum1 + R(i,k) * RTR(k+Nmax1,l+Nmax1) * R1(l,j)
          end do  
        end do
        RTR(i,j)      = sum1
        RTR(i+Nmax,j) = sum         
      end do  
    end do 
  end if
  do i = 1, Nmax
    do j = 1, Nmax1
      RTR(i,j+Nmax1)      = RTR(i+Nmax,j)
      RTR(i+Nmax,j+Nmax1) = RTR(i,j)
    end do  
  end do
  deallocate (R, R1)  
end subroutine MatRotTransRot_RTR_mn_m1n1
!***********************************************************************************
subroutine identity_transformation (Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1,      &
           T, NP, MP)
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1, NP, MP   
  complex(O) :: T(2*NP,2*MP)
!
  integer    :: i, j, m, m1, n, n1, k, k1, N_0, N_1, l
!
  do i = 1, 2*Nmax
    do j = 1, 2*Nmax1
      T(i,j) = zero
    end do
  end do
  do m = 0, Mrank
    if (m == 0) then
      m1 = m
      do k = 1, Nrank
        n = k                           
        do k1 = 1, Nrank1
          n1 = k1
          if (n == n1) then                
            T(k,k1)            = one
            T(k+Nmax,k1+Nmax1) = one
          end if 
        end do          
      end do                                
    else
      N_0 = Nrank + (m - 1) * (2 * Nrank - m + 2)        
      m1  = m
      N_1 = Nrank1 + (m1 - 1) * (2 * Nrank1 - m1 + 2)
      if (m1 <= Mrank1) then        
        do l = 1, 2     
          do k = 1, Nrank - m + 1
            n = m + k - 1                                 
            do k1 = 1, Nrank1 - m1 + 1
              n1 = m1 + k1 - 1
              if (n == n1) then
                T(k+N_0,k1+N_1)            = one
                T(k+N_0+Nmax,k1+N_1+Nmax1) = one
              end if
            end do                
          end do          
          N_1 = N_1 + Nrank1 - m1 + 1
          N_0 = N_0 + Nrank - m + 1      
        end do
      end if
    end if
  end do  
end subroutine identity_transformation    
!***********************************************************************************
function lnfactorial (n) result (lnfact)
  use parameters
  implicit none
  integer :: n, k
  real(O) :: lnfact, sum, kr
!
  if (n < 0) then
    print "(/,2x,'Error in subroutine lnfactorial in module AdditonTh:')" 
    print "(  2x,'the argument of the factorial function is negative; ')"              
    stop    
  else if (n > 1) then
    sum = 0._O
    do k = 1,n
      kr  = real(k,O) 
      sum = sum + log(kr)
    end do
    lnfact = sum
  else
    lnfact = 0._O
  end if 
end function lnfactorial
!***********************************************************************************
function gumnkl (u, m, n, k, l) result (g)
  use parameters
  implicit none
  integer :: u, m, n, k, l
  real(O) :: g
!  
  integer :: int
  real(O) :: lnfactorial, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, f
!
  int = u + m + k
  a1  = lnfactorial (int)
  int = u - m - k
  a2  = lnfactorial (int)
  int = n + l - u
  a3  = lnfactorial (int)
  int = u + n - l
  a4  = lnfactorial (int)
  int = u + l - n
  a5  = lnfactorial (int)
  int = n - m
  a6  = lnfactorial (int)
  int = n + m
  a7  = lnfactorial (int)
  int = l - k
  a8  = lnfactorial (int)
  int = l + k
  a9  = lnfactorial (int)
  int = n + l + u + 1
  a10 = lnfactorial (int)
  g   = 0.5_O * (a1 + a2 + a3 + a4 + a5 - a6 - a7 - a8 - a9 - a10)
  f   = sqrt(real(2 * u + 1,O))
  g   = f * exp(g)
end function gumnkl
!***********************************************************************************
subroutine CouplingCoef (m, n, k, l, Cmnkl)
!-----------------------------------------------------------------------------------
! The routine computes the coupling coefficients Cmnkl.                            !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer :: m, n, k, l
  real(O) :: Cmnkl(0:n+l)
!
  integer :: u, Linf
  real(O) :: bu, cu, Su, Sup1, Sum1, gumnkl
!
  Linf = max(abs(m + k), abs(n - l))
  if (Linf > 0) then
    do u = 0, Linf - 1
      Cmnkl(u) = 0._O
    end do
  end if    
  Cmnkl(n+l) = gumnkl (n + l, m, n, k, l)   
  if (n + l > Linf) then  
    u  = n + l
    bu = real((m - k) * u * (u + 1) - (m + k) * (n * (n + 1) - l * (l + 1)),O)
    bu = bu / real(n + l - u + 1,O) / real(n + l + u + 1,O)
    bu = bu * real(2 * u + 1,O) / real(u + 1,O)
    Cmnkl(n+l-1) = bu * gumnkl (n + l - 1, m, n, k, l) 
    if (n + l - 1 > Linf) then
      Sup1 = 1._O
      Su   = bu
      do u = n + l - 1, Linf + 1, -1    
        bu   = real((m - k) * u * (u + 1) - (m + k) * (n * (n + 1) - l * (l + 1)),O)
        bu   = bu / real(n + l - u + 1,O) / real(n + l + u + 1,O)
        bu   = bu * real(2 * u + 1,O) / real(u + 1,O)  
        cu   = real((u + m + k + 1) * (u - m - k + 1),O)
        cu   = cu * real(u,O) / real(u + 1,O)
        cu   = cu * real(u + n - l + 1,O) / real(n + l - u + 1,O)
        cu   = - cu * real(u + l - n + 1,O) / real(n + l + u + 1,O)
        Sum1 = bu * Su + cu * Sup1
        Cmnkl(u-1) = gumnkl(u - 1, m, n, k, l) * Sum1
        Sup1 = Su
        Su   = Sum1
      end do
    end if
  end if  
end subroutine CouplingCoef

subroutine TSPHERE
!------------------------------------------------------------------------------------
! 1. General Considerations                                                         !
! --------------------------                                                        !
! TSPHERE is a routine for computing the T vector and the scattering                !
! characteristics of concentrically layered spheres. The spherical particle         !
! consists of Npart layers, each characterized by arbitrary but constant values     !
! of electric permittivity and magnetic permeability. Each layer is bounded by two  ! 
! surfaces. The enclosing (exterior) surface will be referred to as the layer       !
! surface. The first layer surface is the largest surface and corresponds to the    !
! host sphere.                                                                      !
!                                                                                   !
! The T matrix of a concentrically layered sphere is diagonal and is completely     !
! described by the diagonal elements corresponding to the azimuthal mode m = 1.     !
! Therefore, for concentrically layered spheres, the T matrix simplifies to a       !
! T vector.                                                                         !
!                                                                                   !
! The domain of analysis is divided into homogeneous layers. The electric and       !
! magnetic fields of a specific layer i are approximated by using localized vector  !
! spherical wave functions, and Nrankp(i) will be referred to as the maximum        !
! expansion order of the layer i.                                                   !
!                                                                                   !
! In contrast to the program for computing the T matrix of a layered particle,      !
! the present code assumes that the maximum expansion orders of all layers are      !
! identically, i.e., Nrankp(1) = Nrankp(2) = ...= Nrankp(Npart) = Nrank.            !
!                                                                                   !
! 2. Convergence Test                                                               !
! --------------------                                                              !
! For convergence tests, the incident wave is assumed to be a vector plane wave     !
! traveling along the Z-axis of the global coordinate system and the scattering     !
! characteristics  are computed in the azimuthal plane  phi = 0° . Note that only   !
! two azimuthal modes m = 1 and m = - 1 are required to compute the scattering      !
! characteristics.                                                                  !
!                                                                                   !
! The convergence test is carried out over the maximum expansion order Nrank.       !
! The scattering problem is solved for Nrank and Nrank - 1 and the normalized       !
! differential scattering cross section (DSCS) will be checked at 20° increments    !
! for convergence within epsNrank tolerance. If the calculated results converge     !
! within this tolerance at 80% of the scattering angles, then convergence is        !
! achieved.                                                                         ! 
!                                                                                   !
! An estimate of Nrank is given by Wiscombe's truncation limit criterion            !
! [W. J. Wiscombe, Improved Mie scattering algorithms, Applied Optics, 19,          !
! 1505-1509, 1980], i.e.,                                                           !
!                                                                                   !                     
!                NrankW = int(xp + 4.05 * xp**0.33 + 2),                            !
!                                                                                   !
! where xp is the size parameter of the layer, xp = k * r(1), k is the wave         !
! number and r(1) is the radius of the host sphere.                                 !
!                                                                                   !
! The convergence tests over Nrank can be switched off by setting the logical       !
! variable DoConvTest to false. In this case, the value of Nrank must be specified  !
! in the input file.                                                                !
!                                                                                   !
! 3. Input Parameters                                                               !
! --------------------                                                              !
! The parameters specified in the input file "/INPUTFILES/InputSPHERE.dat" are      !
! listed below.                                                                     !
!                                                                                   !
! - wavelength (real) - wavelength of the incident light in vacuo.                  !
!                                                                                   !
! - ind_refMed (real) - refractive index of the ambient medium (nonabsorbing        !
!   dielectric medium).                                                             !
!                                                                                   !
! - Npart (integer) - number of spherical layers.                                   !
!                                                                                   !
! - anorm (real) - characteristic length of the layered sphere which is used        !
!   to normalize the differential scattering cross sections.                        !
!                                                                                   !
! The next parameters (specified in a sequence of group statements) characterize     !
! each layer.                                                                       !
! - ind_refPartRel (complex) - relative refractive index of the actual spherical    !
!   layer with respect to the ambient medium. The imaginary part of the relative    !
!   refractive index must be zero for nonabsorbing particles and positive for       !
!   absorbing particles.                                                            ! 
!                                                                                   !
! - rPart (real) - radius of the actual spherical layer.                            !
!                                                                                   !
! - DoConvTest (logical) - if DoConvTest = t, the interactive convergence test      !
!   over Nrank is invoked. An estimate of Nrank for all layers is provided by       !
!   Wiscombe's truncation limit criterion. If DoConvTest = f, the values of Nrank   !
!   must be supplied in the input file.                                             !
!                                                                                   !
! - Nrank (integer) - maximum expansion order for the host sphere. This parameter   !
!   is used if the convergence test is not performed (DoConvTest = f)               !  
!                                                                                   !
! - epsNrank (real) - error tolerance for the expansion order test.                 !
!                                                                                   !
! - FileTmat (character(80)) - name of the file to which the T matrix is written.   !
!                                                                                   !
! - PrnProgress (logical) - if PrnProgress = t, the progress of calculation         !
!   is printed.                                                                     !
!                                                                                   !
! Note that all input parameters specifying lengths must be provided in the same    !
! units of lengths.                                                                 ! 
!------------------------------------------------------------------------------------
  use parameters
  use allocation, only: rp, ind_refp
  implicit none 
  integer       :: Npart, Nrank                                   
  real(O)       :: k, ind_refMed, wavelength, anorm, snorm, epsNrank
  character(80) :: FileTmat
  logical       :: DoConvTest, PrnProgress  
! -----------------------------------------------------------------------------------
!                                Read the input file                                ! 
! -----------------------------------------------------------------------------------
  call readinputSPHERE ( wavelength, ind_refMed, Npart, anorm, DoConvTest, Nrank,   &
       epsNrank, FileTmat, PrnProgress, k, snorm)  
! -----------------------------------------------------------------------------------
!                                      Main                                         !
! ----------------------------------------------------------------------------------- 
  if (DoConvTest) then            
    open (unit = iOutput, file = FileOutput, status = "replace") 
    call printinputSPHERE (wavelength, ind_refMed, Npart, rp, ind_refp, epsNrank,   &
         anorm)
    call convergence_NrankSPHERE (k, Npart, ind_refp, rp, snorm, Nrank, epsNrank,   &
         FileTmat, PrnProgress)      
    close (unit = iOutput) 
  else
    call Tvector_NrankSPHERE (k, Npart, ind_refp, rp, Nrank, FileTmat, PrnProgress) 
  end if
  deallocate (rp,ind_refp)
end subroutine TSPHERE
!************************************************************************************
subroutine readinputSPHERE ( wavelength, ind_refMed, Npart, anorm, DoConvTest,      &
           Nrank, epsNrank, FileTmat, PrnProgress, k, snorm)    
  use parameters
  use derived_parameters
  use allocation, only: rp, ind_refp
  implicit none 
  integer       :: Npart, Nrank, NrankW, ipart, ios                                   
  real(O)       :: k, ind_refMed, rPart, wavelength, anorm, xpart, snorm,           &
                   epsNrank, x
  complex(O)    :: ind_refPartRel
  character(80) :: FileTmat, string
  logical       :: DoConvTest, PrnProgress, XFindPar
! -----------------------------------------------------------------------------------
!                          Read the input file FileInputSPHERE                      ! 
! -----------------------------------------------------------------------------------    
  call DrvParameters
  open (unit = iInputSPHERE, file = FileInputSPHERE, status = "old",                &
        position = "rewind")   
  wavelength = 0.1_O * 2._O * Pi  
  ind_refMed = 1._O
  string     = 'OptProp'
  if (XFindPar (iInputSPHERE, string)) then
    read (iInputSPHERE, *, iostat = ios) wavelength
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if
    read (iInputSPHERE, *, iostat = ios) ind_refMed
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refMed;')"
      stop
    end if        
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if
  k = 2._O * Pi * ind_refMed / wavelength
!
  Npart  = 1
  anorm  = 1._O
  string = 'GeomProp'
  if (XFindPar (iInputSPHERE, string)) then
    read (iInputSPHERE, *, iostat = ios) Npart
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Npart;')"
      stop
    end if
    read (iInputSPHERE, *, iostat = ios) anorm
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anorm;')"
      stop
    end if        
  else
    print "(/,2x,'Group name GeomProp not found;')"
    stop  
  end if
  call check_anorm (anorm)  
  xpart = k * anorm
  snorm = Pi * xpart * xpart
!
  allocate (ind_refp(Npart), rp(Npart))
  do ipart = 1, Npart
    ind_refPartRel = (1.5_O,0._O)
    string = 'OptPartProp'
    if (XFindPar (iInputSPHERE, string)) then
      read (iInputSPHERE, *, iostat = ios) ind_refPartRel
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable ind_refPartRel;')"
        print "(  2x,'for the particle ',i3,';')", ipart
        stop
      end if             
    else
      print "(/,2x,'Group name OptPartProp not found;')"
      stop  
    end if
    call check_ind_ref1 (ipart, ind_refPartRel)
    ind_refp(ipart) = ind_refPartRel
    rPart  = 1._O
    string = 'GeomPartProp'
    if (XFindPar (iInputSPHERE, string)) then
      read (iInputSPHERE, *, iostat = ios) rPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable rPart;')"
        print "(  2x,'for the particle ',i3,';')", ipart
        stop
      end if             
    else
      print "(/,2x,'Group name GeomPartProp not found;')"
      stop  
    end if
    rp(ipart) = rPart
  end do 
!
  DoConvTest = .true.
  string     = 'ConvTest'
  if (XFindPar (iInputSPHERE, string)) then
    read (iInputSPHERE, *, iostat = ios) DoConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DoConvTest;')"
      stop
    end if          
  else
    print "(/,2x,'Group name ConvTest not found;')"
    stop  
  end if
!
  if (DoConvTest) then
    print "(/,2x,'Convergence Test for a Spherical Layered Particle')"
    print "(  2x,'-------------------------------------------------')"
  else
    print "(/,2x,'T-vector calculation for a Spherical Layered Particle')"
    print "(  2x,'-----------------------------------------------------')"
  end if
!
  x = k * rp(1)
  NrankW = int(x + 4.05_O * x**0.33_O + 2._O)
  if (.not. DoConvTest) then
    Nrank  = 20
    string = 'NrankSph'
    if (XFindPar (iInputSPHERE, string)) then
      read (iInputSPHERE, *, iostat = ios) Nrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nrank;')"
        stop
      end if          
    else
      print "(/,2x,'Group name NrankSph not found;')"
      stop  
    end if
    print "(/,2x,'Input values:')"
    print "(  2x,'the input value of Nrank is ', i3,', while the estimated')", Nrank 
    print "(  2x,'value of Nrank from Wiscombe''s criterion is ', i3,';')", NrankW 
  else
    print "(/,2x,'Nrank estimate:')"                                                    
    print "(  2x, a, i3, a)",                                                       &
   'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'                             
    print "(/,2x,'- enter the estimated value of Nrank;')"
    call read_integer (Nrank)      
  end if
!
  epsNrank = 5.e-2_O
  string   = 'Errors'
  if (XFindPar (iInputSPHERE, string)) then
    read (iInputSPHERE, *, iostat = ios) epsNrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNrank;')"
      stop
    end if          
  else
    print "(/,2x,'Group name Errors not found;')"
    stop  
  end if  
!
  FileTmat = 'T.dat'
  string   = 'Tmat'
  if (XFindPar (iInputSPHERE, string)) then
    read (iInputSPHERE, *, iostat = ios) FileTmat
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileTmat;')"
      stop
    end if          
  else
    print "(/,2x,'Group name Tmat not found;')"
    stop  
  end if
!
  PrnProgress = .true.
  string = 'PrintProgress'
  if (XFindPar (iInputSPHERE, string)) then
    read (iInputSPHERE, *, iostat = ios) PrnProgress
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if          
  else
    print "(/,2x,'Group name PrintProgress not found;')"
    stop  
  end if
  close (unit = iInputSPHERE)
end subroutine readinputSPHERE
!***********************************************************************************
subroutine printinputSPHERE (wavelength, ind_refMed, Npart, r, ind_ref, epsNrank,   &
           anorm)
  use parameters
  implicit none  
  integer       :: Npart,i
  real(O)       :: wavelength, ind_refMed, r(Npart), epsNrank, anorm                   
  complex(O)    :: ind_ref(Npart)  
!
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x,'wavelength of the free space, wavelength = ',1pe13.4,';')")  &
         wavelength
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'refractive index of the ambient medium, ind_refMed = ', ind_refMed, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'characteristic length of the particle, anorm = ', anorm, ';'
  write (iOutput,*) 
  write (iOutput,"(2x,'number of layers, Nlayer = ',i3,';')") Npart 
  do i = 1, Npart      
    write (iOutput,"(2x,'radius of the layer ',i3,': r = ',1pe10.3,';')") i,r(i)
    write (iOutput,"(2x, a, i3, a, 1pe10.3, ',', 1pe10.3, a)")                      &
   'relative refractive index of the layer ', i, ', ind_refRel = (',                &
    ind_ref(i), ');'           
  end do
  write (iOutput,*)     
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum expansion order tolerance, epsNrank = ', epsNrank, '.'              
  write (iOutput,"(/)")  
end subroutine printinputSPHERE
! **********************************************************************************
subroutine convergence_NrankSPHERE (k, Npart, ind_ref, r, snorm, Nrank, epsNrank,   &
           FileTmat, PrnProgress)   
  use parameters               
  implicit none 
  integer       :: Npart, Nrank      
  real(O)       :: k, r(Npart), snorm, epsNrank
  complex(O)    :: ind_ref(Npart)
  character(80) :: FileTmat
  logical       :: PrnProgress
!  
  integer       :: Mstart, Nteta, Mrank, Nmax, Nmaxmax, i, m, NthetaConv
  real(O)       :: alfa, beta, gama, alfap, phiGS, tetaGI, phiGI, Cscat, Qscat,     &
                   Cext, Qext
  real(O),allocatable    :: h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: t(:), c(:), c1(:), cc(:)             
!
  phiGS  = 0._O
  Nteta  = 10
  alfa   = 0._O        
  beta   = 0._O
  gama   = 0._O
  alfap  = Pi / 4._O
  tetaGI = 0._O
  phiGI  = 0._O
  Mstart = 1
  Mrank  = 1
  Nmax   = Nrank 
  m = 1 
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call write_HeadFileTmatVct (Nrank) 
  call write_TypeConvHead (2) 
  allocate (t(2*Nrank), c(2*Nrank), c1(2*Nrank))
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  if (PrnProgress) call write_progress (.true., 1, 5)             
! --- Nrank configuration ---
  call coefficients_fg_m_coated (k, Npart, r, ind_ref, m, Nrank, Nmax, t) 
  if (PrnProgress) call write_progress (.false., 2, 5)  
  call write_FileTmatVct (Nrank, t)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,       &
       Nmax, c)             
  call product_vector_vector (2*Nmax, t, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)         
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap,-m, Nrank,       &
       Nmax, c)
  call product_vector_vector (2*Nmax, t, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax) 
  if (PrnProgress) call write_progress (.false., 3, 5)                                             
  call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,   &
      .false.,.true., h, v)
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext)   
  do i = 1, Nteta
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do  
  write (iOutput,"(17x,'Nrank = ',i3,/)") Nrank
  call  write_DSCS (Nteta,.false., h, v)
  call  write_Effic (Qscat, Qext)
  close (unit = iTmat)  
! --- (Nrank - 1) configuration ---  ...  
  call vector_Nrank_m (Nmax, t)
  if (PrnProgress) call write_progress (.false., 4, 5)
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,       &
       Nmax, c)             
  call product_vector_vector (2*Nmax, t, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)         
  call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,      &
       Nmax, c)
  call product_vector_vector (2*Nmax, t, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)                                                  
  if (PrnProgress) call write_progress (.false., 5, 5)
  call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm,   &
      .false.,.true., h, v)
  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
       alfap, k, snorm, Cext, Qext) 
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConv)  
  write (iOutput,"(17x,'Nrank = ',i3,' ---',/)") Nrank - 1
  call write_DSCS (Nteta,.false., h, v)
  call write_Effic (Qscat, Qext)
  call write_MrankConvRes (NthetaConv, epsNrank)
  if (NthetaConv >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criterion for Nrank is satisfied;')"    
  else
    print "(/,2x,'Convergence criterion for Nrank is not satisfied;')"
  end if
  Mrank = Nrank 
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .true., .true., .false.) 
  call ScatCharact (k, FileTmat, Mrank, Nrank, .true., .true., .false.)  
  print "(/,2x,'The T vector is stored in ',a50)", FileTmat
  print "(  2x,'The dimension of the T vector is given by:')"
  print "(  2x,'- maximum expansion order, Nrank = ',i3,';')", Nrank                      
  deallocate (t, c, c1, cc, h, v, oldh, oldv)   
end subroutine convergence_NrankSPHERE 
! **********************************************************************************
subroutine Tvector_NrankSPHERE (k, Npart, ind_ref, r, Nrank, FileTmat, PrnProgress)   
  use parameters                    
  implicit none 
  integer       :: Npart, Nrank    
  real(O)       :: k, r(Npart)
  complex(O)    :: ind_ref(Npart)
  character(80) :: FileTmat
  logical       :: PrnProgress
!  
  integer       :: Mrank, m
  complex(O),allocatable :: t(:)
!  
  m = 1 
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call write_HeadFileTmatVct (Nrank) 
  allocate (t(2*Nrank))  
  if (PrnProgress) call write_progress (.true., 1, 2)             
  call coefficients_fg_m_coated (k, Npart, r, ind_ref, m, Nrank, Nrank, t) 
  if (PrnProgress) call write_progress (.false., 2, 2)    
  call write_FileTmatVct (Nrank, t)  
  close (unit = iTmat)  
  Mrank = Nrank 
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .true., .true., .false.) 
  call ScatCharact (k, FileTmat, Mrank, Nrank, .true., .true., .false.)  
  print "(/,2x,'The T vector is stored in ',a50)", FileTmat
  print "(  2x,'The dimension of the T vector is given by:')"
  print "(  2x,'- maximum expansion order, Nrank = ',i3,';')", Nrank                      
  deallocate (t)      
end subroutine Tvector_NrankSPHERE     

module allocation
  use parameters
  implicit none 
!  
  integer,allocatable,save       :: Nsurf(:), Nparam(:), Nrankp(:), Nrankp1(:)
  real(O),allocatable,save       :: surf(:,:), zpart(:), zRe(:,:), zIm(:,:),        &
                                    zRe1(:,:), zIm1(:,:), lnorm(:), EpsZReIm(:)			       			       			          
  complex(O),allocatable,save    :: ind_ref(:)
  logical,allocatable,save       :: ComplexPlane(:)
!
  integer,allocatable,save       :: Mrankcs(:), Nrankcs(:)
  real(O),allocatable,save       :: Rcs(:)
!
  integer,allocatable,save       :: Mrankp(:)
  real(O),allocatable,save       :: xp(:), yp(:), zp(:),                            &
                                    alphap(:), betap(:), gammap(:)
  character(80),allocatable,save :: FileTmatp(:)
  logical,allocatable,save       :: axsymp(:), chiralp(:)
!
  real(O),allocatable,save       :: rp(:)
  complex(O),allocatable,save    :: ind_refp(:)  
!
  integer,allocatable,save       :: IndI(:), IndJ(:)
  character(2),allocatable,save  :: NameElem(:)
end module allocation  

! *********************************************************************************
! *                          GEOMETRIC TRANSFORMATIONS                            *
! *     ---------------------------------------------------------------------     *
! *     Partial list of subroutine:                                               *                                  
! *       scalar_product,                       vector_product,                   *
! *       mixt_product,                         scalar_product_real,              *
! *       vector_product_real,                  T_cartesian_spherical,            *
! *       T_spherical_cartesian,                m_rotation,                       *
! *       m_rotation_inverse,                   T_cartesian_global_local,         *
! *       T_cartesian_local_global,             T_cartesian_local_globalC (unused)*
! *       T_cartesian_global_localC (unused),   T_spherical_global_local,         *    
! *       T_spherical_local_global,             m_unitvct_spherical,              * 
! *       m_unitvct_spherical_global,           angle_unitvct_ItL_ItG,            *     
! *       parameters_coefficients_ab,           parameters_coefficients_Polab     * 
! *********************************************************************************
function scalar_product (n, a) result (na)
  use parameters
  real(O)    :: n(3)
  complex(O) :: a(3), na
!
  na = n(1) * a(1) + n(2) * a(2) + n(3) * a(3)     
end function scalar_product
! **********************************************************************************
subroutine vector_product (a, b, c)
  use parameters
  complex(O) :: a(3), b(3), c(3)
!
  c(1) = a(2) * b(3) - a(3) * b(2)
  c(2) = a(3) * b(1) - a(1) * b(3)
  c(3) = a(1) * b(2) - a(2) * b(1)   
end subroutine vector_product
! **********************************************************************************
function mixt_product (n, a, b) result (nab)
  use parameters
  real(O)    :: n(3)
  complex(O) :: a(3), b(3), nab
!
  complex(O) :: ab(3), scalar_product
!
  call vector_product (a, b, ab)
  nab = scalar_product (n, ab)   
end function mixt_product
! **********************************************************************************
function scalar_product_real (a, b) result (prod)
  use parameters
  implicit none
  real(O) :: a(3), b(3), prod
!
  prod = a(1) * b(1) + a(2) * b(2) + a(3) * b(3)   
end function scalar_product_real 
! **********************************************************************************
subroutine vector_product_real (a, b, c)
  use parameters
  real(O) :: a(3), b(3), c(3)
!
  c(1) = a(2) * b(3) - a(3) * b(2)
  c(2) = a(3) * b(1) - a(1) * b(3)
  c(3) = a(1) * b(2) - a(2) * b(1)   
end subroutine vector_product_real   
!***********************************************************************************
subroutine T_cartesian_spherical (x, y, z, R, theta, phi)
!-----------------------------------------------------------------------------------
! The routine computes the spherical coordinates given the Cartesian coordinates.  !
! For theta = 0 or theta = Pi, the solution is undetermined with respect to phi,   !
! and in these cases we set (by convention) phi = 0.                               !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  real(O) :: x, y, z, R, theta, phi, za, ro, ro2, thetaA
!  
  za  = abs(z)
  ro2 = x * x + y * y
  ro  = sqrt(ro2)
  R   = sqrt(ro2 + z * z)
  if (ro < MachEps .and. za < MachEps) then
    theta = 0._O
    phi   = 0._O
    return
  end if
  if (za < MachEps) then
    theta = Pi / 2._O
  else
    thetaA = atan(ro / za)
    if (z >= MachEps) then
      theta = thetaA
    else
      theta = Pi - thetaA
    end if
  end if
  if (ro < MachEps) then
    phi = 0._O                  !undetermined
  else    
    phi = atan2(y,x)
    if (phi < 0._O) phi = 2._O * Pi + phi     
  end if               
end subroutine T_cartesian_spherical
! **********************************************************************************
subroutine T_spherical_cartesian (R, theta, phi, x, y, z)
!-----------------------------------------------------------------------------------
! The routine computes the Cartesian coordinates given the spherical coordinates.  !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  real(O) :: R, theta, phi, x, y, z
!
  x = R * sin(theta) * cos(phi)
  y = R * sin(theta) * sin(phi)
  z = R * cos(theta)   
end subroutine T_spherical_cartesian
!***********************************************************************************
subroutine m_rotation (alpha, beta, gamma, R)
!-----------------------------------------------------------------------------------      
! The routine computes the rotation matrix of Euler angles alpha, beta and gamma.  !
! The rotation matrix gives the following relations between the local and the      !
! global coordinates:                                                              !
!                          [x,y,z]^T = [R] * [X,Y,Z]^T                             !
! and                                                                              !
!                          [i,j,k]^T = [R] * [I,J,K]^T.                            !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none      
  real(O) :: alpha, beta, gamma, R(3,3)
!
  R(1,1) =   cos(alpha) * cos(beta) * cos(gamma) - sin(alpha) * sin(gamma)
  R(2,1) = - cos(alpha) * cos(beta) * sin(gamma) - sin(alpha) * cos(gamma)
  R(3,1) =   cos(alpha) * sin(beta)
!
  R(1,2) =   sin(alpha) * cos(beta) * cos(gamma) + cos(alpha) * sin(gamma)
  R(2,2) = - sin(alpha) * cos(beta) * sin(gamma) + cos(alpha) * cos(gamma)
  R(3,2) =   sin(alpha) * sin(beta)
!
  R(1,3) = - sin(beta) * cos(gamma)
  R(2,3) =   sin(beta) * sin(gamma)
  R(3,3) =   cos(beta)   
end subroutine m_rotation
!***********************************************************************************
subroutine m_rotation_inverse (alpha, beta, gamma, RT)
!-----------------------------------------------------------------------------------
! The routine computes the inverse of the rotation matrix of Euler angles          !
! alpha, beta and gamma. This matrix gives the following relations between the     !
! global and the local coordinates:                                                !  
!                         [X,Y,Z]^T = [RT] * [x,y,z]^T                             !
! and                                                                              !
!                         [I,J,K]^T = [RT] * [i,j,k]^T.                            !
!----------------------------------------------------------------------------------- 
  use parameters 
  implicit none
  real(O) :: alpha, beta, gamma, RT(3,3)
!
  RT(1,1) =   cos(alpha) * cos(beta) * cos(gamma) - sin(alpha) * sin(gamma)
  RT(1,2) = - cos(alpha) * cos(beta) * sin(gamma) - sin(alpha) * cos(gamma)
  RT(1,3) =   cos(alpha) * sin(beta)
!
  RT(2,1) =   sin(alpha) * cos(beta) * cos(gamma) + cos(alpha) * sin(gamma)
  RT(2,2) = - sin(alpha) * cos(beta) * sin(gamma) + cos(alpha) * cos(gamma)
  RT(2,3) =   sin(alpha) * sin(beta)
!
  RT(3,1) = - sin(beta) * cos(gamma)
  RT(3,2) =   sin(beta) * sin(gamma)
  RT(3,3) =   cos(beta)      
end subroutine  m_rotation_inverse
!***********************************************************************************
subroutine T_cartesian_global_local (xG, yG, zG, alpha, beta, gamma, xL, yL, zL)
!-----------------------------------------------------------------------------------
! The routine computes the local Cartesian coordinates at a rotation with Euler    !
! angles alpha, beta and gamma, given the global Cartesian coordinates.            !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  real(O) :: xG, yG, zG, alpha, beta, gamma, xL, yL, zL, R(3,3)
!
  call m_rotation (alpha, beta, gamma, R)
  xL = R(1,1) * xG + R(1,2) * yG + R(1,3) * zG
  yL = R(2,1) * xG + R(2,2) * yG + R(2,3) * zG
  zL = R(3,1) * xG + R(3,2) * yG + R(3,3) * zG   
end subroutine T_cartesian_global_local
!***********************************************************************************
subroutine T_cartesian_local_global (xL, yL, zL, alpha, beta, gamma, xG, yG, zG)
!-----------------------------------------------------------------------------------
! The routine computes the global Cartesian coordinates at a rotation with Euler   !
! angles alpha, beta and gamma, given the local Cartesian coordinates.             !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  real(O) :: xL, yL, zL, alpha, beta, gamma, xG, yG, zG, RT(3,3)
!
  call m_rotation_inverse (alpha, beta, gamma, RT)
  xG = RT(1,1) * xL + RT(1,2) * yL + RT(1,3) * zL
  yG = RT(2,1) * xL + RT(2,2) * yL + RT(2,3) * zL
  zG = RT(3,1) * xL + RT(3,2) * yL + RT(3,3) * zL   
end subroutine T_cartesian_local_global
!***********************************************************************************
subroutine T_cartesian_global_localC (xG, yG, zG, alpha, beta, gamma, xL, yL, zL)
!-----------------------------------------------------------------------------------
! The routine computes the local Cartesian coordinates at a rotation with Euler    !
! angles alpha, beta and gamma, given the global Cartesian coordinates.            !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  real(O)    :: alpha, beta, gamma, R(3,3)
  complex(O) :: xG, yG, zG,  xL, yL, zL 
!
  call m_rotation (alpha, beta, gamma, R)
  xL = R(1,1) * xG + R(1,2) * yG + R(1,3) * zG
  yL = R(2,1) * xG + R(2,2) * yG + R(2,3) * zG
  zL = R(3,1) * xG + R(3,2) * yG + R(3,3) * zG   
end subroutine T_cartesian_global_localC
!***********************************************************************************
subroutine T_cartesian_local_globalC (xL, yL, zL, alpha, beta, gamma, xG, yG, zG)
  use parameters
  implicit none
  real(O)    :: alpha, beta, gamma, RT(3,3)
  complex(O) :: xL, yL, zL, xG, yG, zG
!
  call m_rotation_inverse (alpha, beta, gamma, RT)
  xG = RT(1,1) * xL + RT(1,2) * yL + RT(1,3) * zL
  yG = RT(2,1) * xL + RT(2,2) * yL + RT(2,3) * zL
  zG = RT(3,1) * xL + RT(3,2) * yL + RT(3,3) * zL   
end subroutine T_cartesian_local_globalC
! **********************************************************************************
subroutine T_spherical_global_local (thetaG, phiG, alpha, beta, gamma, thetaL, phiL)
!-----------------------------------------------------------------------------------
! The routine computes the local spherical coordinates at a rotation with Euler    !
! angles alpha, beta and gamma, given the global spherical coordinates.            !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  real(O) :: thetaG, phiG, alpha, beta, gamma, thetaL, phiL
  real(O) :: raza, xG, yG, zG, xL, yL, zL, theta, phi
!
  raza = 1._O
  call T_spherical_cartesian (raza, thetaG, phiG, xG, yG, zG)
  call T_cartesian_global_local (xG, yG, zG, alpha, beta, gamma, xL, yL, zL)
  call T_cartesian_spherical (xL, yL, zL, raza, theta, phi)
  thetaL = theta
  phiL   = phi 
!..................................................................................!
!          If thetaL = 0 or thetaL = 180 then phiL is undetermined and we          !
!          choose phiL such that: ItG = ItL and IpG = IpL.                         !
!..................................................................................!
  if (abs(thetaL) < MachEps) then    
    if (abs(gamma) < MachEps) then
      phiL = 0._O
    else
      phiL = 2._O * Pi - gamma
    end if
  end if        
  if (abs(thetaL - Pi) < MachEps) then    
    phiL = Pi - gamma
    if (phiL < 0._O) phiL = 2._O * Pi + phiL
  end if                  
end subroutine T_spherical_global_local  
! **********************************************************************************    
subroutine T_spherical_local_global (thetaL, phiL, alpha, beta, gamma, thetaG, phiG)
!-----------------------------------------------------------------------------------
! The routine computes the global spherical coordinates at a rotation with Euler   !
! angles alpha, beta and gamma, given the local spherical coordinates.             !
!-----------------------------------------------------------------------------------    
  use parameters
  use derived_parameters
  implicit none
  real(O) :: thetaL, phiL, alpha, beta, gamma, thetaG, phiG
  real(O) :: raza, xG, yG, zG, xL, yL, zL, theta, phi
!
  raza = 1._O
  call T_spherical_cartesian (raza, thetaL, phiL, xL, yL, zL)
  call T_cartesian_local_global (xL, yL, zL, alpha, beta, gamma, xG, yG, zG)
  call T_cartesian_spherical (xG, yG, zG, raza, theta, phi)
  thetaG = theta
  phiG   = phi 
!..................................................................................!      
!         Íf thetaG = 0 or thetaG = 180 then phiG is undetermined and we           !
!         choose phiG such that: ItG = ItL and IpG = IpL.                          !    
!..................................................................................!
  if (abs(thetaG) < MachEps) then    
    phiG = Pi + alpha
    if (phiG >= 2._O * Pi) phiG = phiG - 2._O * Pi      
  end if        
  if (abs(thetaG - Pi) < MachEps) phiG = alpha          
end subroutine T_spherical_local_global
! **********************************************************************************
subroutine m_unitvct_spherical (theta, phi, S)
!-----------------------------------------------------------------------------------
! The routine computes the matrix [S]: [Ir,It,Ip]^T = [S] * [i,j,k]^T.             !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  real(O) :: theta, phi, S(3,3)
!
  S(1,1) =   sin(theta) * cos(phi)
  S(1,2) =   sin(theta) * sin(phi)
  S(1,3) =   cos(theta)
!
  S(2,1) =   cos(theta) * cos(phi)
  S(2,2) =   cos(theta) * sin(phi)
  S(2,3) = - sin(theta)
!
  S(3,1) = - sin(phi)
  S(3,2) =   cos(phi)
  S(3,3) =   0._O   
end subroutine m_unitvct_spherical
!***********************************************************************************
subroutine m_unitvct_spherical_global (thetaL, phiL, alpha, beta, gamma, SG)
!-----------------------------------------------------------------------------------
! The routine computes the matrix [SG] as:                                         !       
!               [IrL,ItL,IpL]^T = [S] * [i,j,k]^T                                  !
!                               = [S] * [R] * [I,J,K]^T                            !
!                               = [SG] * [I,J,K]^T,                                ! 
! where:                                                                           !
!               [x,y,z]^T = [R] * [X,Y,Z]^T, or equivalently,                      !
!               [i,j,k]^T = [R] * [I,J,K]^T.                                       !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  real(O) :: thetaL, phiL, alpha, beta, gamma, SG(3,3)
!
  integer :: i, j, k
  real(O) :: S(3,3), R(3,3), sum
!
  call m_unitvct_spherical (thetaL, phiL, S)
  call m_rotation (alpha, beta, gamma, R)      
  do i = 1, 3
    do j = 1, 3
      sum = 0._O
      do k = 1, 3
        sum = sum + S(i,k) * R(k,j)
      end do
      SG(i,j) = sum
    end do  
  end do   
end subroutine m_unitvct_spherical_global
!***********************************************************************************
subroutine angle_unitvct_ItL_ItG (thetaG, phiG, thetaL, phiL, alpha, beta, gamma,   &
           cos_angle, sin_angle)
!-----------------------------------------------------------------------------------
! The routine computes cos_angle = ItL * ItG and sin_angle = ItL * IpG.            !
! For this purpose, we compute the matrix [S] as                                   !
!                       [IrG,ItG,IpG]^T = [S] * [I,J,K]^T                          ! 
! and the matrix [SG] as                                                           !
!                       [IrL,ItL,IpL]^T = [SG] * [I,J,K]^T.                        !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  real(O) :: thetaG, phiG, thetaL, phiL, alpha, beta, gamma, cos_angle, sin_angle
!      
  integer :: i
  real(O) :: ItL(3), ItG(3), IpG(3), SG(3,3), S(3,3), scalar_product_real 
!
  call m_unitvct_spherical (thetaG, phiG, S)      
  call m_unitvct_spherical_global (thetaL, phiL, alpha, beta, gamma, SG)
  do i = 1, 3
    ItL(i) = SG(2,i)   
    ItG(i) = S(2,i)    
    IpG(i) = S(3,i)
  end do
  cos_angle = scalar_product_real (ItL, ItG)
  sin_angle = scalar_product_real (ItL, IpG)  
end subroutine angle_unitvct_ItL_ItG  
! **********************************************************************************
subroutine parameters_coefficients_ab (thetaG, phiG, thetaL, phiL, alpha, beta,     &
           gamma, alphap, e0eT, e0eP)
!-----------------------------------------------------------------------------------
! The routine computes e0eT = e0 * ItL and e0eP = e0 * IpL, where                  !
!                      e0 = cos(alphap) * ItG + sin(alphap) * IpG.                 !
! For this purpose, we compute the matrix [S] as                                   !
!                      [IrG,ItG,IpG]^T = [S] * [I,J,K]^T                           !
! and the matrix [SG] as                                                           !
!                      [IrL,ItL,IpL]^T = [SG] * [I,J,K]^T.                         !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  real(O)  :: thetaG, phiG, thetaL, phiL, alpha, beta, gamma, alphap, e0eT, e0eP
!    
  integer  :: i
  real(O)  :: ItL(3), IpL(3), e0(3), SG(3,3), S(3,3), scalar_product_real
!
  call m_unitvct_spherical (thetaG, phiG, S)
  call m_unitvct_spherical_global (thetaL, phiL, alpha, beta, gamma, SG)
  do i = 1, 3
    ItL(i) = SG(2,i)    
    IpL(i) = SG(3,i)
    e0(i)  = cos(alphap) * S(2,i) + sin(alphap) * S(3,i)                          
  end do
  e0eT = scalar_product_real (e0, ItL)
  e0eP = scalar_product_real (e0, IpL)   
end subroutine parameters_coefficients_ab
! **********************************************************************************
subroutine parameters_coefficients_Polab (thetaG, phiG, thetaL, phiL, alpha, beta,  &
           gamma, epol_theta, epol_phi, e0eT, e0eP)
!-----------------------------------------------------------------------------------
! The routine computes e0eT = e0 * ItL and e0eP = e0 * IpL, where                  !
!                      e0 = epol_theta * ItG + epol_phi * IpG,                     !
! and epol_theta and epol_phi are complex numbers. As before we compute the        !
! matrix [S] as                                                                    !
!                      [IrG,ItG,IpG]^T = [S] * [I,J,K]^T                           !
! and the matrix [SG] as                                                           !
!                      [IrL,ItL,IpL]^T = [SG] * [I,J,K]^T.                         !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  real(O)    :: thetaG, phiG, thetaL, phiL, alpha, beta, gamma
  complex(O) :: epol_theta, epol_phi, e0eT, e0eP
!    
  integer    :: i
  real(O)    :: ItL(3), IpL(3), SG(3,3), S(3,3)
  complex(O) :: e0(3), scalar_product
!
  call m_unitvct_spherical (thetaG, phiG, S)
  call m_unitvct_spherical_global (thetaL, phiL, alpha, beta, gamma, SG)
  do i = 1, 3
    ItL(i) = SG(2,i)    
    IpL(i) = SG(3,i)
    e0(i)  = epol_theta * S(2,i) + epol_phi * S(3,i)                          
  end do
  e0eT = scalar_product (ItL, e0) 
  e0eP = scalar_product (IpL, e0)   
end subroutine parameters_coefficients_Polab

! **********************************************************************************
! *                  ROUTINES FOR READING THE INPUT DATA                           *
! *   -------------------------------------------------------------------------    *
! *   Partial list of subroutines:                                                 *
! *     read_FileFEM,             read_FileFEMAxsym,        read_HeadFileTmat,     *
! *     read_FileTmat,            read_HeadFileTmatVct,     read_FileTmatVct,      *
! *     read_FileSmat(UNUSED),    read_Tmatrix,             read_integer,          *
! *     read_integerbound,        read_integer2,            read_integer3,         *
! *     read_real,                read_logical,             read_char80,           *
! *     LenString,                XFindPar,                 LcString               *
! **********************************************************************************
subroutine read_FileFEM (filein_name, face_num, face_point, face_normal, face_area)
!-----------------------------------------------------------------------------------
! The routine read the surface parameters from the file filein_name.               !
!-----------------------------------------------------------------------------------  
  use parameters
  implicit none
  integer        :: face_num
  real(O)        :: face_point(3,NfacePD), face_normal(3,NfacePD), face_area(NfacePD)
  character(80)  :: filein_name
!
  integer        :: nfaces, NVvr, nelem, nf, nv, ielem, i, ios
  real(O)        :: r(3), n(3), area
!  
  open (unit = iFEM, file = filein_name, status = "old", position = "rewind")      
  read (iFEM, "(i7)", iostat = ios)  nfaces
  if (ios < 0 ) then
    print "(/,2x,'EOF by reading the number of surfaces from the geometry file;')"
    stop
  else if (ios > 0) then
    print "(/,2x,'Error by reading the number of surfaces from the geometry file;')"
    stop
  end if      
  nelem = 0
  do nf = 1, nfaces      
    read (iFEM, "(i7)", iostat = ios) NVvr
    if (ios < 0 ) then
      print "(/,2x,'EOF by reading the number of vertices from the geometry file;')"
      stop
    else if (ios > 0) then
      print "(/,2x,'Error by reading the number of vertices from the geometry file;')"
      stop
    end if                
    do nv = 1, NVvr                   
      nelem = nelem + 1
      call check_MaxNface (nelem)               
      read (iFEM, "(i7,2x,7(e15.7,2x))", iostat = ios) ielem, r(1), r(2), r(3),     &
            n(1), n(2), n(3), area            
      if (ios /= 0) exit
      do i = 1, 3
        face_point (i,nelem) = r(i)
        face_normal(i,nelem) = n(i)
      end do
      face_area(nelem) = area
    end do
    if (ios < 0 ) then
      print "(/,2x,'EOF detected during the reading of the geometry file;')"
      stop
    else if (ios > 0) then
      print "(/,2x,'Error during the reading of the geometry file;')"
      stop
    end if          
  end do
  face_num = nelem                
  close (unit = iFEM)
end subroutine read_FileFEM
! **********************************************************************************
subroutine read_FileFEMAxsym (filein_name, line_num, line_point, line_normal,       &
           line_area)
!-----------------------------------------------------------------------------------
! The routine reads the curve parameters from the file filein_name.                !
!-----------------------------------------------------------------------------------  
  use parameters
  implicit none
  integer        :: line_num
  real(O)        :: line_point(2,NfacePD), line_normal(2,NfacePD), line_area(NfacePD)
  character(80)  :: filein_name
!
  integer        :: nlines, NVvr, nelem, nf, nv, ielem, i, ios
  real(O)        :: r(2), n(2), area
!  
  open (unit = iFEM, file = filein_name, status = "old", position = "rewind")      
  read (iFEM, "(i7)", iostat = ios)  nlines
  if (ios < 0 ) then
    print "(/,2x,'EOF by reading the number of curves from the geometry file;')"
    stop
  else if (ios > 0) then
    print "(/,2x,'Error by reading the number of curves from the geometry file;')"
    stop
  end if
  nelem = 0
  do nf = 1, nlines      
    read  (iFEM, "(i7)", iostat = ios)  NVvr
    if (ios < 0 ) then
      print "(/,2x,'EOF by reading the number of vertices from the geometry file;')"
      stop
    else if (ios > 0) then
      print "(/,2x,'Error by reading the number of vertices from the geometry file;')"
      stop
    end if
    do nv = 1, NVvr                   
      nelem = nelem + 1
      call check_MaxNface (nelem)               
      read (iFEM, "(i7,2x,5(e15.7,2x))", iostat = ios) ielem, r(1), r(2),           &
            n(1), n(2), area          
      if (ios /= 0) exit
      do i = 1, 2
        line_point (i,nelem) = r(i)    
        line_normal(i,nelem) = n(i)                 
      end do
      line_area(nelem) = area                  
    end do
    if (ios < 0 ) then
      print "(/,2x,'EOF detected during the reading of the geometry file;')"
      stop
    else if (ios > 0) then
      print "(/,2x,'Error during the reading of the geometry file;')"
      stop
    end if          
  end do
  line_num = nelem        
  close (unit = iFEM)
end subroutine read_FileFEMAxsym
! **********************************************************************************
subroutine read_HeadFileTmat (nt, mt)
  use parameters
  implicit none
  integer       :: nt, mt, ios
  character(85) :: string
!
  read (iTmat, "(2x,a)", iostat = ios) string
  if (ios < 0 ) then
    print "(/,2x,'EOF detected during the reading of the T - matrix file;')"
    stop
  else if (ios > 0) then
    print "(/,2x,'Error by reading the string: Half - Dimensions of the T Matrix;')"
    stop
  end if  
  read (iTmat, "(2x,i10,2x,i10)", iostat = ios) nt, mt
  if (ios < 0 ) then
    print "(/,2x,'EOF detected during the reading of the T - matrix file;')"
    stop
  else if (ios > 0) then
    print "(/,2x,'Error during the reading of the dimensions of the T matrix;')"
    stop
  end if 
  read (iTmat, "(2x,a)",iostat = ios) string  
  if (ios < 0 ) then
    print "(/,2x,'EOF detected during the reading of the T - matrix file;')"
    stop
  else if (ios > 0) then
    print "(/,2x,'Error during the reading of the string: T Matrix;')"
    stop
  end if 
end subroutine read_HeadFileTmat
! **********************************************************************************
subroutine read_FileTmat (nt, mt, a)
  use parameters
  implicit none
  integer    :: nt, mt, i, j, ios
  complex(O) :: a(2*nt,2*mt)
!    
  i = 0
  do while (i < 2*nt)
    i = i + 1   
    read (iTmat,"(10(2x,1pe24.15,1x,1pe24.15),/)", iostat = ios) (a(i,j), j = 1, 2*mt)    
    if (ios /= 0) exit          
  end do  
  if (ios < 0 ) then
    print "(/,2x,'EOF detected during the reading of the T matrix;')"
    stop
  else if (ios > 0) then
    print "(/,2x,'Error during the reading of the T matrix;')"
    stop
  end if
end subroutine read_FileTmat
! **********************************************************************************
subroutine read_HeadFileTmatVct (nt)
  use parameters
  implicit none
  integer       :: nt, ios
  character(85) :: string
!
  read (iTmat, "(2x,a)",iostat = ios) string
  if (ios < 0 ) then
    print "(/,2x,'EOF detected during the reading of the T - vector file;')"
    stop
  else if (ios > 0) then
    print "(/,2x,'Error by reading the string: Half - Dimensions of the T Vector;')"
    stop
  end if   
  read (iTmat, "(2x,i10)",iostat = ios) nt
  if (ios < 0 ) then
    print "(/,2x,'EOF detected during the reading of the T - vector file;')"
    stop
  else if (ios > 0) then
    print "(/,2x,'Error during the reading of the dimensions of the T vector;')"
    stop
  end if 
  read (iTmat, "(2x,a)",iostat = ios) string
  if (ios < 0 ) then
    print "(/,2x,'EOF detected during the reading of the T - vector file;')"
    stop
  else if (ios > 0) then
    print "(/,2x,'Error during the reading of the string: T Vector;')"
    stop
  end if 
end subroutine read_HeadFileTmatVct
! **********************************************************************************
subroutine read_FileTmatVct (nt, v)
  use parameters
  implicit none
  integer    :: nt, i, ios
  complex(O) :: v(2*nt)
!
  i = 0
  do while (i < 2*nt)
    i = i + 1
    read (iTmat,"(2x,1pe24.15,1x,1pe24.15)",iostat = ios) v(i)
    if (ios /= 0) exit          
  end do  
  if (ios < 0 ) then
    print "(/,2x,'EOF detected during the reading of the T vector;')"
    stop
  else if (ios > 0) then
    print "(/,2x,'Error during the reading of the T vector;')"
    stop
  end if
end subroutine read_FileTmatVct
! **********************************************************************************
subroutine read_FileSmat (N, Nteta, S, Cext, Cscat, Qext, Qscat)
  use parameters
  implicit none
  integer    :: N, Nteta, i, j, ios
  real(O)    :: Cext, Cscat, Qext, Qscat
  complex(O) :: S(N,Nteta)
!    
  i = 0
  do while (i < N)
    i = i + 1   
    read (iSS,"(10(2x,1pe24.15,1x,1pe24.15),/)", iostat = ios) (S(i,j), j = 1, Nteta)    
    if (ios /= 0) exit          
  end do  
  if (ios < 0 ) then
    print "(/,2x,'EOF detected during the reading of the average quantities <SS*>;')"
    stop
  else if (ios > 0) then
    print "(/,2x,'Error during the reading of the average quantities <SS*>;')"
    stop
  end if
  read (iSS,"(4(2x,1pe13.4))", iostat = ios) Cext, Cscat, Qext, Qscat 
  if (ios < 0 ) then
    print "(/,2x,'EOF detected during the reading of cross sections;')"
    stop
  else if (ios > 0) then
    print "(/,2x,'Error during the reading of cross sections;')"
    stop
  end if
end subroutine read_FileSmat
! **********************************************************************************  
subroutine read_Tmatrix (chiral, Nrank, Mrank, Nmaxmax, TG, ntg, mtg)
  use parameters
  implicit none  
  integer       :: Mrank, Nrank, Nmaxmax, ntg, mtg
  complex(O)    :: TG(2*ntg,2*mtg)
  logical       :: chiral
!
  integer       :: m, Nmax, i, j, l, N0, ntl, mtl
  complex(O),allocatable :: TL(:,:)
!  
  call read_HeadFileTmat (ntl, mtl)
  call check_dimensionMat (ntl, mtl, Nrank)             
  allocate (TL(2*ntl, 2*mtl))   
  do m = 0, Mrank
    if (m == 0) then
      Nmax = Nrank
    else
      Nmax = Nrank - m + 1
    end if                                          
    call read_FileTmat (ntl, mtl, TL)
    if (m == 0) then
      do i = 1, Nmax
        do j = 1, Nmax
          TG(i,j)                = TL(i,j)
          TG(i,j+Nmaxmax)        = TL(i,j+Nmax)
          TG(i+Nmaxmax,j)        = TL(i+Nmax,j)
          TG(i+Nmaxmax,j+Nmaxmax)= TL(i+Nmax,j+Nmax)
        end do          
      end do
    else        
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      do l = 1, 2
        do i = 1, Nmax
          do j = 1, Nmax            
            TG(i+N0,j+N0)                 = TL(i,j)
            TG(i+N0,j+N0+Nmaxmax)         = TL(i,j+Nmax)
            TG(i+N0+Nmaxmax,j+N0)         = TL(i+Nmax,j)
            TG(i+N0+Nmaxmax,j+N0+Nmaxmax) = TL(i+Nmax,j+Nmax)
          end do            
        end do
        N0 = N0 + Nmax
        if (.not. chiral) then
          call matrix_m_negativ (Nmax, Nmax, TL, ntl, mtl)
        else              
          call read_FileTmat (ntl, mtl, TL)
        end if
      end do
    end if                                                                                           
  end do
  deallocate (TL)
end subroutine read_Tmatrix
! **********************************************************************************
recursive subroutine read_integer (int)
  implicit none
  integer  :: int, ierr
!
  read (*, *, iostat = ierr) int
  if (ierr /= 0) then
    print "(/,2x,'Input error during the read statement;')"
    print "(  2x,'- enter the integer variable again;')"
    call read_integer (int)
  end if
end subroutine read_integer
! **********************************************************************************
recursive subroutine read_integerbound (int, imin, imax)
  implicit none
  integer  :: int, imin, imax, ierr
!
  read (*, *, iostat = ierr) int
  if (ierr /= 0) then
    print "(/,2x,'Input error during the read statement;')"
    print "(  2x,'- enter the integer variable again;')"
    call read_integer (int)
  end if
  if (int < imin .or. int > imax) then
    print "(/,2x,'Input error: the integer variable is out of bounds;')"
    print "(  2x,'- enter the integer variable again;')"
    call read_integer (int)
  end if
end subroutine read_integerbound
! **********************************************************************************
recursive subroutine read_integer2 (int1, int2)
  implicit none
  integer  :: int1, int2, ierr
!
  read (*, *, iostat = ierr) int1, int2
  if (ierr /= 0) then
    print "(/,2x,'Input error during the read statement;')"
    print "(  2x,'- enter the integer variables again;')"
    call read_integer2 (int1, int2)
  end if
end subroutine read_integer2
! **********************************************************************************
recursive subroutine read_integer3 (int1, int2, int3)
  implicit none
  integer  :: int1, int2, int3, ierr
!
  read (*, *, iostat = ierr) int1, int2, int3
  if (ierr /= 0) then
    print "(/,2x,'Input error during the read statement;')"
    print "(  2x,'- enter the integer variables again;')"
    call read_integer3 (int1, int2, int3)
  end if
end subroutine read_integer3
! **********************************************************************************
recursive subroutine read_real (ral)
  use parameters
  implicit none
  integer  :: ierr
  real(O)  :: ral
!
  read (*, *, iostat = ierr) ral
  if (ierr /= 0) then
    print "(/,2x,'Input error during the read statement;')"
    print "(  2x,'- enter the real variable again;')"
    call read_real (ral)
  end if
end subroutine read_real
! **********************************************************************************
recursive subroutine read_logical (log)
  implicit none
  integer  :: ierr
  logical  :: log
!
  read (*, *, iostat = ierr) log
  if (ierr /= 0) then
    print "(/,2x,'Input error during the read statement;')"
    print "(  2x,'- enter the logical variable again;')"
    call read_logical (log)
  end if
end subroutine read_logical
! **********************************************************************************
recursive subroutine read_char80 (TypePath, char)
  use parameters
  implicit none
  integer        :: TypePath, ierr, LenString
  character(80)  :: char, charend
!
  read (*, *, iostat = ierr) charend
  if (ierr /= 0) then
    print "(/,2x,'Input error during the read statement;')"
    print "(  2x,'- enter the character type variable again;')"
    call read_char80 (TypePath, char)
  end if
  if (TypePath == 1) then
    char = PathOUTPUT(1:LenString(PathOUTPUT)) // charend(1:LenString(charend))
  else if (TypePath == 2) then
    char = PathTEMP(1:LenString(PathTEMP)) // charend(1:LenString(charend))
  else if (TypePath == 3) then
    char = PathGEOM(1:LenString(PathGEOM)) // charend(1:LenString(charend))
  end if
end subroutine read_char80
! **********************************************************************************
integer function LenString (str) 
  implicit none
  character(*) :: str
!
  LenString = len(str)
  do while (LenString > 0 .and. str(LenString:LenString) == ' ')
    LenString = LenString - 1
  end do   
end function LenString 
!***********************************************************************************        
logical function XFindPar ( nunit, parname )        
  implicit none
  integer       :: nunit  
  character(80) :: parname
!    
  integer       :: i, parlen, ios
  logical       :: more, secondsearch
  character(80) :: name, line
!
! --- length of the parameter name ---
  parlen = 0
  do i = len (parname), 1, - 1
    if (parname (i : i) /= ' ' ) then
      parlen = i      
      exit
    end if
  end do
  if (parlen == 0) then
    XFindPar = .true.
  else          
    name = parname (1 : parlen)
    call LcString ( name (1 : parlen) )    
    more = .true.
    secondsearch = .false.
    do while (more)
      line = ' '
      read (nunit,"(a)", iostat = ios) line
      if (ios < 0) then
        if (secondsearch) then
          XFindPar = .false.
          more     = .false.
        else
          secondsearch = .true.
        end if
      else	  	       	   	      			
        call LcString ( line (1 : parlen) )      
        if (line (1 : parlen) == name (1 : parlen)) then
          XFindPar = .true.
          more     = .false.  	    
        end if
      end if        
    end do                         
  end if       
end function XFindPar
!***********************************************************************************                
subroutine LcString ( string )
  implicit none
  character(*) :: string
  integer      :: ccc, i, offset
!
  offset = ichar ( 'a' ) - ichar ( 'a' )
  do i = 1, len (string)
    ccc = ichar ( string (i : i) )
    if (ccc >= ichar ( 'a' ) .and. ccc <= ichar ( 'z' )) then
      string ( i : i ) = char ( ccc + offset )
    end if
  end do       
end subroutine LcString       
! **********************************************************************************
! *                  ROUTINES FOR WRITING THE OUTPUT DATA                          *
! *    ------------------------------------------------------------------------    *
! *    Partial list pf subroutines:                                                *
! *      write_progress,        write_progress_m,        write_progress_low,       *
! *      write_HeadFileTmat,    write_FileTmat,          write_InfoFileTmat        *
! *      write_HeadFileTmatVct, write_FileTmatVct,       write_FileSmat(UNUSED),   *
! *      write_DSCS,            write_4ConvParam,        write_3ConvParam,         *
! *      write_2ConvParam,      write_2ConvParamAxsym,   write_1ConvParam,         *
! *      write_Effic,           write_NrankConvRes,      write_NintConvRes,        *
! *      write_MrankConvRes,    write_TypeConvHead,      write_3ConvParamReg,      *
! *      write_2ConvParamReg,   write_3ConvParamRegCOMP, write_2ConvParamRegCOMP,  *
! *      write_DSCS1,           write_SCAT,              write_ScatMatrix          *
! *      inputDSCS_SCAT,        inputDSCS_SCATAvrg,      inputDSCS_SCATAvrgSPH,    *
! *      write_ScatMatrixAvrg,  inputDSCS_EMF,           write_DSCSPARTSUB,        *
! *      write_DSCSPARTSUB1,    write_EMF                                          *
! **********************************************************************************
subroutine write_progress (start, ip, Np)
  implicit none
  integer       :: ip, Np
  logical       :: start
!
  if (start) print "(/,2x,'progress of main calculation:')"             
  print "(2x,'- ',i3,'  / ',i3,';')", ip, Np
end subroutine write_progress
! **********************************************************************************
subroutine write_progress_m (start, m, ip, Np)
  implicit none
  integer       :: m, ip, Np
  logical       :: start
!
  if (start)                                                                        &
    print "(/,2x,'progress of main calculation for azimuthal mode m =', i3,':')", m           
  print "(2x,'- ',i3,'  / ',i3,';')", ip, Np
end subroutine write_progress_m
! **********************************************************************************
subroutine write_progress_low
!
  print "(/,2x,'Calculations for the lower order configurations;')"  
end subroutine write_progress_low
! **********************************************************************************
subroutine write_HeadFileTmat (nt, mt)
  use parameters
  implicit none
  integer   :: nt, mt
!
  write (iTmat, "(2x,'Half - Dimensions of the T Matrix:')")
  write (iTmat, "(2x,i10,2x,i10)") nt, mt
  write (iTmat, "(2x,'T Matrix:')")
end subroutine write_HeadFileTmat
! **********************************************************************************
subroutine write_FileTmat (nt, mt, a)
  use parameters
  implicit none
  integer    :: nt, mt, i, j
  complex(O) :: a(2*nt,2*mt)
!
  do i = 1, 2*nt
    write (iTmat,"(10(2x,1pe24.15,1x,1pe24.15),/)") (a(i,j), j = 1, 2*mt)
  end do  
end subroutine write_FileTmat
! **********************************************************************************
subroutine write_InfoFileTmat (FileTmat, Mrank, Nrank, axsym, sphere, chiral)
  use parameters
  implicit none
  integer        :: Nrank, Mrank, LenString       
  character(80)  :: FileTmat, FileTmatRoot, FileTmatInfo  
  logical        :: axsym, sphere, chiral
!
  FileTmatRoot = FileTmat(14:LenString(FileTmat))
  FileTmatInfo = '../TMATFILES/Info' // FileTmatRoot(1:LenString(FileTmatRoot))
  open (unit = iTmatInfo, file = FileTmatInfo, status = 'replace')      
  if (.not. sphere) then
    write (iTmatInfo,"(2x,'The T matrix is stored in the file',a55)") FileTmat
  else
    write (iTmatInfo,"(2x,'The T vector is stored in the file',a55)") FileTmat
  end if
  if (axsym) then
    if (sphere) then
      write (iTmatInfo,"(2x,'The scatterer is a spherical particle.')") 
    else
      if (chiral) then
        write (iTmatInfo,"(2x,'The scatterer is an axisymmetric and chiral particle.')") 
      else
        write (iTmatInfo,"(2x,'The scatterer is an axisymmetric particle.')") 
      end if
    end if
  else
    if (chiral) then
      write (iTmatInfo,"(2x,'The scatterer is a nonaxisymmetric and chiral particle.')")
    else
      write (iTmatInfo,"(2x,'The scatterer is a nonaxisymmetric particle.')")
    end if
  end if  
  if (.not. sphere) then            
    write (iTmatInfo,"(2x,'The dimensions of the T matrix are given by:')") 
    write (iTmatInfo,"(2x,'- maximum expansion order,   Nrank = ',i3,',')") Nrank
    write (iTmatInfo,"(2x,'- number of azimuthal modes, Mrank = ',i3,'.')") Mrank
  else
    write (iTmatInfo,"(2x,'The dimension of the T vector is given by:')") 
    write (iTmatInfo,"(2x,'- maximum expansion order,   Nrank = ',i3,'.')") Nrank
  end if
  close (unit = iTmatInfo)
end subroutine write_InfoFileTmat
! **********************************************************************************
subroutine write_HeadFileTmatVct (nt)
  use parameters
  implicit none
  integer   :: nt
!
  write (iTmat, "(2x,'Half - Dimensions of the T Vector:')")
  write (iTmat, "(2x,i10)") nt
  write (iTmat, "(2x,'T Vector:')")
end subroutine write_HeadFileTmatVct
! **********************************************************************************
subroutine write_FileTmatVct (nt, v)
  use parameters
  implicit none
  integer    :: nt, i
  complex(O) :: v(2*nt)
!  
  do i = 1, 2*nt
    write (iTmat,"(2x,1pe24.15,1x,1pe24.15)") v(i)
  end do  
end subroutine write_FileTmatVct
! **********************************************************************************
subroutine write_FileSmat (N, Nteta, S, Cext, Cscat, Qext, Qscat)
  use parameters
  implicit none
  integer    :: N, Nteta, i, j
  real(O)    :: Cext, Cscat, Qext, Qscat
  complex(O) :: S(N,Nteta)
!
  do i = 1, N
    write (iSS,"(10(2x,1pe24.15,1x,1pe24.15),/)") (S(i,j), j = 1, Nteta)
  end do 
  write (iSS,"(4(2x,1pe13.4))") Cext, Cscat, Qext, Qscat 
end subroutine write_FileSmat
! **********************************************************************************
subroutine write_DSCS (Nteta, ExtThetaDom, h, v)
  use parameters
  implicit none      
  integer   :: Nteta, i
  real(O)   :: teta, h(Nteta), v(Nteta)                 
  logical   :: ExtThetaDom
!
  write (iOutput,"(1x, a, //, 2x, a, 9x, a, 8x, a, /)")                             &
 'normalized differential scattering cross section', 'theta', 'parallel',           &
 'perpendicular'        
  do i = 1, Nteta
    if (ExtThetaDom) then         
      teta = real(i - 1,O) * 360._O / real(Nteta - 1,O)                           
    else 
      teta = real(i - 1,O) * 180._O / real(Nteta - 1,O)     
    end if       
    write (iOutput,"(1x,f6.2,5x,1pe13.4,5x,1pe13.4)") teta, h(i), v(i)   
  end do 
  write (iOutput, "(/)")                  
end subroutine write_DSCS
! **********************************************************************************
subroutine  write_4ConvParam (Nint1, Nint2, Nrank, Mrank)
  use parameters
  implicit none
  integer :: Nint1, Nint2, Nrank, Mrank
!
  write (iOutput,"(1x, a, i5, a, 1x, a, i5, a, 1x, a, i3, a, 1x, a, i3, /)")        &
 'Nint1 = ', Nint1, ',', 'Nint2 = ', Nint2, ',', 'Nrank = ', Nrank,                 &
 ',', 'Mrank = ', Mrank
end subroutine write_4ConvParam
! **********************************************************************************
subroutine  write_3ConvParam (Nint, Nrank, m)
  use parameters
  implicit none
  integer :: Nint, Nrank, m
!
  write (iOutput,"(7x,'Nint = ',i5,',',1x,'Nrank = ',i3,',',1x,'Mrank = ',i3,/)")   &
         Nint, Nrank, m
end subroutine write_3ConvParam
! **********************************************************************************
subroutine  write_2ConvParam (Nrank, Mrank)
  use parameters
  implicit none
  integer :: Nrank, Mrank
! 
  write (iOutput, "(11x,'Nrank = ',i3,',',1x,'Mrank = ',i3,/)") Nrank, Mrank
end subroutine write_2ConvParam
! **********************************************************************************
subroutine  write_2ConvParamAxsym (Nint, Nrank)
  use parameters
  implicit none
  integer :: Nint, Nrank
!
  write (iOutput,"(11x,'Nint = ',i5,',',1x,'Nrank = ',i3,/)") Nint, Nrank
end subroutine write_2ConvParamAxsym 
! **********************************************************************************
subroutine  write_1ConvParam (m)
  use parameters
  implicit none
  integer :: m
!
  write (iOutput,"(18x,'m = ',i3,/)") m
end subroutine write_1ConvParam
! **********************************************************************************
subroutine write_Effic (Qscat, Qext)
  use parameters
  implicit none
  real(O) :: Qscat, Qext
!
  write (iOutput,"(6x,'scattering efficiency = ',1pe13.4)")   Qscat
  write (iOutput,"(6x,'extinction efficiency = ',1pe13.4,/)") Qext
end subroutine write_Effic
! **********************************************************************************
subroutine write_NrankConvRes (NthetaConv, Nteta, epsNrank)
  use parameters
  implicit none
  integer :: NthetaConv, Nteta
  real(O) :: epsNrank
!
  write (iOutput,"(1x, a, i2, a, / , 1x, a, 1f5.2, a, /)")                         &
 '--- the solution converges in ', NthetaConv,     ' points ---',                  &
 '--- with an relative error of ', 100 * epsNrank, ' %    ---'
  if (NthetaConv >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criterion for Nrank is satisfied;')" 
  else
    print "(/,2x,'Convergence criterion for Nrank is not satisfied;')"
  end if 
end subroutine write_NrankConvRes
! **********************************************************************************
subroutine write_NintConvRes (NthetaConv, Nteta, epsNint)
  use parameters
  implicit none
  integer :: NthetaConv, Nteta
  real(O) :: epsNint
!
  write (iOutput,"(1x, a, i2, a, / , 1x, a, 1f5.2, a, /)")                          &
 '--- the solution converges in ', NthetaConv,     ' points ---',                   &
 '--- with an relative error of ', 100 * epsNint,  ' %    ---'
  if (NthetaConv >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criterion for Nint is satisfied;')" 
  else
    print "(/,2x,'Convergence criterion for Nint is not satisfied;')"
  end if 
end subroutine write_NintConvRes    
! **********************************************************************************
subroutine write_MrankConvRes (NthetaConv, epsMrank)
  use parameters
  implicit none
  integer :: NthetaConv
  real(O) :: epsMrank
!  
  write (iOutput,"(1x, a, i2, a, / , 1x, a, 1f5.2, a, /)")                          &
 '--- the solution converges in ', NthetaConv,     ' points ---',                   &
 '--- with an relative error of ', 100 * epsMrank, ' %    ---'                          
end subroutine write_MrankConvRes
! **********************************************************************************
subroutine write_TypeConvHead (TypeConv)
  use parameters
  implicit none
  integer :: TypeConv
!
  if (TypeConv == 1) then
    write (iOutput,"(5x,'--- Convergence Test over Nint ---',/)")
  else if (TypeConv == 2) then 
    write (iOutput,"(5x,'--- Convergence Test over Nrank ---',/)")
  else if (TypeConv == 3) then
    write (iOutput,"(5x,'--- Convergence Test over Mrank ---',/)")
  else if (TypeConv == 4) then
    write (iOutput,"(2x,'-- Convergence Test over Nrank and Mrank ---',/)")  
  end if
end subroutine write_TypeConvHead
! **********************************************************************************
subroutine  write_3ConvParamRegCOMP (Nint, m, Nrank, Npart, Nrankp, ReduceOrder)
  use parameters
  implicit none
  integer :: Nint, m, Nrank, Npart, Nrankp(Npart), i
  logical :: ReduceOrder
!
  write (iOutput,"(7x,'Nint = ',i5,',',1x,'Nrank = ',i3,',',1x,'Mrank = ',i3,/)")   &
         Nint, Nrank, m
  do i = 1, Npart
    if (.not. ReduceOrder) then
      write (iOutput,"(7x,'Nrank for region ',i2,', Nrank = ',i3,/)")               &
             i, Nrankp(i)
    else
      write (iOutput,"(7x,'Nrank for region ',i2,', Nrank = ',i3,/)")               &
             i, Nrankp(i) - 1
    end if
  end do
end subroutine write_3ConvParamRegCOMP
! **********************************************************************************
subroutine  write_2ConvParamRegCOMP (Nint, Nrank, Npart, Nrankp)
  use parameters
  implicit none
  integer :: Nint, Nrank, Npart, Nrankp(Npart), i
!
  write (iOutput,"(7x,'Nint = ',i5,',',1x,'Nrank = ',i3,/)") Nint, Nrank
  do i = 1, Npart
    write (iOutput,"(7x,'Nrank for region ',i2,', Nrank = ',i3,/)") i, Nrankp(i)
  end do
end subroutine write_2ConvParamRegCOMP
! **********************************************************************************
subroutine  write_3ConvParamReg (Nint, m, Npart, Nrankp, ReduceOrder)
  use parameters
  implicit none
  integer :: Nint, m, Npart, Nrankp(Npart), i
  logical :: ReduceOrder
!
  write (iOutput,"(7x,'Nint = ',i5,',',8x,'Mrank = ',i3,/)") Nint, m
  do i = 1, Npart
    if (.not. ReduceOrder) then
      write (iOutput,"(7x,'Nrank for region ',i2,', Nrank = ',i3,/)")               &
             i, Nrankp(i)
    else
      write (iOutput,"(7x,'Nrank for region ',i2,', Nrank = ',i3,/)")               &
             i, Nrankp(i) - 1
    end if
  end do
end subroutine write_3ConvParamReg
! **********************************************************************************
subroutine  write_2ConvParamReg (Nint, Npart, Nrankp)
  use parameters
  implicit none
  integer :: Nint, Npart, Nrankp(Npart), i
!
  write (iOutput,"(7x,'Nint = ',i5,/)") Nint
  do i = 1, Npart
    write (iOutput,"(7x,'Nrank for region ',i2,', Nrank = ',i3,/)") i, Nrankp(i)
  end do
end subroutine write_2ConvParamReg
! **********************************************************************************                 
subroutine inputDSCS_SCAT (ComputeDSCS, axsym, sphere, chiral, Mrank, Nrank,        &
           phiGS, tetaGI, phiGI, alfamin, alfamax, Nalfa, betamin, betamax, Nbeta,  &
           gamamin, gamamax, Ngama, epol_beta, epol_alpha, alfapGauss, x0, y0, z0,  &
           w0, TypeExcit, wavelength, anorm, normalized, FileTmat)                                                          
  use parameters
  implicit none
  integer       :: Mrank, Nrank, Nalfa, Nbeta, Ngama, LenString, iOut
  real(O)       :: phiGS, tetaGI, phiGI, alfamin, alfamax, betamin, betamax,        &
                   gamamin, gamamax, alfapGauss, x0, y0, z0, w0, wavelength,        &
                   anorm, snorm, k, s, grd 
  complex(O)    :: epol_beta, epol_alpha		   
  character(5)  :: TypeExcit                  
  character(80) :: FileTmat, FileTmatWrite
  logical       :: ComputeDSCS, sphere, axsym, chiral, normalized
!
  if (ComputeDSCS) then
    iOut = iDSCS
  else
    iOut = iSCAT
  end if
  grd = 180._O / Pi
  write (iOut,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOut,"(2x, a, 1pe13.4, a)")                                                &
 'wavelength of the ambient medium, wavelength = ', wavelength, ';'
  if (axsym)   write (iOut,"(2x,'axisymmetric particle;')")
  if (sphere)  write (iOut,"(2x,'spherical particle;')")
  if (chiral)  write (iOut,"(2x,'chiral particle;')")
  FileTmatWrite = FileTmat(14:LenString(FileTmat))
  write (iOut,"(2x,'name of the file containing the T matrix, FileTmat = ',a)")     &
         FileTmatWrite
  write (iOut,"(2x,'maximum expansion order, Nrank = ',i3,';')") Nrank
  write (iOut,"(2x,'maximum azimuthal order, Mrank = ',i3,';')") Mrank     
  write (iOut,"(2x,'average over Euler orientation angles:')")
  write (iOut,"(2x,'alphamin = ',f7.2,', alphamax = ',f7.2,', Nalpha = ',i3,',')")  & 
         alfamin * grd, alfamax * grd, Nalfa 
  write (iOut,"(2x,'betamin  = ',f7.2,', betamax  = ',f7.2,', Nbeta  = ',i3,';')")  &
         betamin * grd, betamax * grd, Nbeta
  if (.not. axsym)                                                                  &
  write (iOut,"(2x,'gammamin = ',f7.2,', gammamax = ',f7.2,', Ngamma = ',i3,';')")  &
         gamamin * grd, gamamax * grd, Ngama                                            
  if (TypeExcit(1:1) == 'P') then
    write (iOut,"(2x,'plane wave excitation;')") 
  else if (TypeExcit(1:1) == 'G') then
    write (iOut,"(2x,'Gaussian beam excitation;')")
  end if
  write (iOut,"(2x,'incident direction, thetaGI = ',f7.2,', phiGI = ',f7.2,';')")   &
         tetaGI * grd, phiGI * grd  
  if (ComputeDSCS) then 	 
    if (TypeExcit(1:1) == 'P') then
      write (iOut,"(2x,'beta  polarization vector = (',1pe10.3,',',1pe10.3,')')")   &
             epol_beta
      write (iOut,"(2x,'alpha polarization vector = (',1pe10.3,',',1pe10.3,')')")   &
             epol_alpha 
    else if (TypeExcit(1:1) == 'G') then                                                                        
      write (iOut,"(2x,'polarization angle, alphap = ',f7.2,';')") alfapGauss * grd
    end if              
  end if     
  if (TypeExcit(1:1) == 'G') then         
    write (iOut,"(2x, a, 1pe10.3, a, 1pe10.3, a, 1pe10.3, a)")                      &
   'Cartesian coordinates of the focal point, x0 = ', x0, ', y0 = ', y0,            &
   ', z0 = ', z0, ';'
    write (iOut,"(2x,'waist radius, w0 = ',1pe10.3,';')") w0
    k = 2._O * Pi / wavelength
    s = 1._O / k / w0
    write (iOut,"(2x,'Gaussian beam parameter, s = ',1pe10.3,';')") s  
  end if
  if (ComputeDSCS) write (iOut,"(2x,'scattering plane, phiGS = ',f7.2,';')")        &
                          phiGS * grd  
  write (iOut,"(2x, a, 1pe10.3, a)")                                                &
 'characteristic length of the scatterer, anorm = ', anorm, ';'  
  if (normalized) then
    snorm = Pi * anorm * anorm
    write (iOut,"(2x,'normalization constant, pi * anorm**2 = ',1pe13.4,';')")      &
           snorm
  end if
  write (iOut,*)
end subroutine inputDSCS_SCAT 
! **********************************************************************************
subroutine write_DSCS1 (Nteta, normalized, ExtThetaDom, h, v, Cscat, Cext,           &
           Qscat, Qext)
  use parameters
  implicit none      
  integer   :: Nteta, i
  real(O)   :: teta, h(Nteta), v(Nteta), Cscat, Cext, Qscat, Qext               
  logical   :: normalized, ExtThetaDom
!   
  write (iDSCS,"(/,2x,'Results:',/)") 
  write (iDSCS,"(2x,'Cross Sections and Efficiencies:')")
  write (iDSCS,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                                  &
         '<Cscat> = ', Cscat, '<Qscat> = ', Qscat 
  write (iDSCS,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                                  &
         '<Cext>  = ', Cext,  '<Qext>  = ', Qext 	              
  write (iDSCS,*)  
  write (iDSCS,"(2x,'Differential Scattering Cross Section:')")     
  if (normalized) then     
    write (iDSCS,"(2x, a, /, 2x, a, 9x, a, 8x, a,/)")                               &
   'normalized average  differential scattering cross section', 'theta',            &
   'parallel', 'perpendicular'                                                            
  else
    write (iDSCS,"(8x, a, /, 2x, a, 9x, a, 8x, a,/)")                               &
   'average differential scattering cross section', 'theta', 'parallel',            &
   'perpendicular'                                                           
  end if
  do i = 1, Nteta
    if (ExtThetaDom) then         
      teta = real(i - 1,O) * 360._O / real(Nteta - 1,O)                           
    else 
      teta = real(i - 1,O) * 180._O / real(Nteta - 1,O)     
    end if                          
    write (iDSCS,"(1x,f6.2,5x,1pe13.4,5x,1pe13.4)") teta, h(i), v(i)     
  end do     
end subroutine write_DSCS1
! **********************************************************************************
subroutine write_SCAT (Nelem, NameElem, Nphi, phi, Ntheta, thetamin, thetamax,      &
           ZTPAv, NphiAL, NthetaAL, KeAv, CscatXAv, CscatYAv, CextXAv, CextYAv,     &
           QscatXAv, QscatYAv, QextXAv, QextYAv, ComputeAsymPar, gX_t, gX_p, gX_r,  &
           gY_t, gY_p, gY_r, TypeExcit)
  use parameters
  implicit none
  integer        :: Nelem, Ntheta(NphiMax), Nphi, NphiAL, NthetaAL, i, j, k,        &
                    itheta, iphi
  real(O)        :: thetamin(NphiMax), thetamax(NphiMax), phi(NphiMax), CscatXAv,   &
                    CscatYAv, CextXAv, CextYAv, QscatXAv, QscatYAv, QextXAv,        &
                    QextYAv, gX_t, gX_p, gX_r, gY_t, gY_p, gY_r, KeAv(4,4),         &
                    ZTPAv(NphiAL,NthetaAL,Nelem), dtheta, phiGS, thetaGS		   
  character(2)   :: NameElem(Nelem)
  character(5)   :: TypeExcit  
  logical        :: ComputeAsymPar    
!
  write (iSCAT,"(/,2x,'Results:',/)")
  write (iSCAT,"(2x,'Scattering Cross Sections and Efficiencies:')")
  write (iSCAT,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                                  &
        '<CscatX> = ',CscatXAv,'<QscatX> = ', QscatXAv
  write (iSCAT,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                                  &
        '<CscatY> = ',CscatYAv,'<QscatY> = ', QscatYAv  
  write (iSCAT,*)
  write (iSCAT,"(2x,'Extinction Cross Sections and Efficiencies:')")
  write (iSCAT,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                                  &
        '<CextX>  = ', CextXAv,'<QextX>  = ', QextXAv
  write (iSCAT,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                                  &
        '<CextY>  = ', CextYAv,'<QextY>  = ', QextYAv  	 		
  write (iSCAT,*)
  if (ComputeAsymPar) then	
    write (iSCAT,"(2x,'Mean direction of propagation of the scattered wave:')")
    write (iSCAT,"(2x, a, 1pe13.4, 5x, a, 1pe13.4, 5x, a, 1pe13.4)")                & 
          '<gX_beta> = ', gX_t,'<gX_alpha> = ', gX_p, '<gX_k> = ', gX_r    	
    write (iSCAT,"(2x, a, 1pe13.4, 5x, a, 1pe13.4, 5x, a, 1pe13.4)")                &
          '<gY_beta> = ', gY_t,'<gY_alpha> = ', gY_p, '<gY_k> = ', gY_r  		
    write (iSCAT,*)
  end if
  if (ComputeAsymPar) then    
    write (iSCAT,"(2x, a)")                                                           &
   'Note: <Cscat>, <Cext> and <g> correspond to linearly X- and Y-polarized waves'         	   	   	   	   	   
  else
    write (iSCAT,"(2x, a)")                                                           &
   'Note: <Cscat> and <Cext> correspond to linearly X- and Y-polarized waves'     
  end if     
  write (iSCAT,*)
  if (TypeExcit(1:5) == 'PLANE') then          
    write (iSCAT,"(2x,'Extinction Matrix:')")
    do i = 1, 4
      write (iSCAT,"(4(2x,1pe13.4))") (KeAv(i,j), j = 1, 4)
    end do
    write (iSCAT,*)  
  end if    
  write (iSCAT,"(2x,'Phase Matrix:')")
  write (iSCAT,"(3x,a3,7x,a5,9x,a2,15(13x,a2))") 'phi','theta', NameElem(1),        &
        (NameElem(k), k = 2, Nelem)
  do iphi = 1, Nphi
    phiGS = phi(iphi)
    if (Ntheta(iphi) /= 1) then
      dtheta = (thetamax(iphi) - thetamin(iphi)) / (Ntheta(iphi) - 1)
    else
      dtheta = 0._O
    end if          
    do itheta = 1, Ntheta(iphi)
      thetaGS = thetamin(iphi) + (itheta - 1) * dtheta  
      write (iSCAT,"(1x,f6.2,5x,f6.2,16(5x,1pe10.3))")  phiGS * 180._O / Pi,        &
             thetaGS * 180._O / Pi, (ZTPAv(iphi,itheta,k), k = 1, Nelem) 
    end do
  end do         
end subroutine write_SCAT
! **********************************************************************************
subroutine inputDSCS_SCATAvrg (ComputeDSCS, wavelength, axsym, chiral, FileTmat,    &
           Nrank, Mrank, anorm, normalized, DoNumAvrg, Nalpha, Nbeta, Ngamma,       &
           NthetaGS, epol_beta, epol_alpha)
  use parameters
  implicit none 
  integer       :: Nrank, Mrank, LenString, Nalpha, Nbeta, Ngamma, NthetaGS, iOut
  real(O)       :: wavelength, anorm, snorm                        
  complex(O)    :: epol_beta, epol_alpha
  character(80) :: FileTmat, FileWrite
  logical       :: ComputeDSCS, axsym, chiral, normalized, DoNumAvrg 
!
  if (ComputeDSCS) then
    iOut = iDSCS
  else
    iOut = iSCAT
  end if
  write (iOut,"(/,2x,'Input Parameters of the Scattering Problem:',/)") 
  write (iOut,"(2x,'wavelength of the ambient medium, wavelength = ',1pe13.4,';')") & 
         wavelength
  if (axsym)   write (iOut,"(2x,'axisymmetric particle;')")
  if (chiral)  write (iOut,"(2x,'chiral particle;')")
  FileWrite = FileTmat(14:LenString(FileTmat))
  write (iOut,"(2x,'name of the file containing the T matrix, FileTmat = ',a)")     &
         FileWrite
  write (iOut,"(2x,'maximum expansion order, Nrank = ',i3,';')") Nrank
  write (iOut,"(2x,'maximum azimuthal order, Mrank = ',i3,';')") Mrank   
  write (iOut,"(2x,'plane wave excitation;')")
  write (iOut,"(2x,'incident direction, thetaGI = 0, phiGI = 0;')")
  if (ComputeDSCS) then    
    write (iOut,"(2x,'beta  polarization vector = (',1pe10.3,',',1pe10.3,')')")     &
           epol_beta
    write (iOut,"(2x,'alpha polarization vector = (',1pe10.3,',',1pe10.3,')')")     &
           epol_alpha          
  end if                        
  write (iOut,"(2x,'scattering plane, phiGS = 0.00')")                         
  write (iOut,"(2x,'characteristic length of the particle, anorm = ',1pe10.3,';')") &
         anorm
  if (normalized) then
    snorm = Pi * anorm * anorm
    write (iOut,"(2x,'normalization constant, pi * anorm**2 = ',1pe13.4,';')")      &
           snorm
  end if        
  if (.not. DoNumAvrg) then
    write (iOut,"(2x, a)")                                                          &
   'analytical averaging procedure for computing the quantities <SS*>;'       
  else
    write (iOut,"(2x, a)")                                                          &
   'numerical averaging procedure for computing the quantities <SS*>;'       
    write (iOut,"(2x,'number of integration points for orientational averaging:')")
    if (axsym) then       
      write (iOut,"(2x,'Nalpha = ',i3,', Nbeta = ',i3,';')") Nalpha, Nbeta
    else
      write (iOut,"(2x,'Nalpha = ',i3,', Nbeta = ',i3,', Ngamma = ',i3,';')")       &
             Nalpha, Nbeta, Ngamma
    end if
  end if       
  write (iOut,"(2x, a, i3, a)")                                                     & 
 'the average quantities <SS*> are computed at NthetaGS = ', NthetaGS,              &
 ' scattering angles;'
  write (iOut,*)
end subroutine inputDSCS_SCATAvrg
! **********************************************************************************
subroutine write_ScatMatrix (MirorSym, axsym, FailHovTest, Nfail, FailMessage,      &
           KeAv, teta, Z, i, Nelem, IndI, IndJ, NameElem, Cscat, Cext, Qscat, Qext, &
           CscatV, CextV, QscatV, QextV, AsymPar, AsymParV)
  use parameters
  implicit none
  integer        :: i, Nfail, Nelem, IndI(Nelem), IndJ(Nelem), k, ii, jj, ifail
  real(O)        :: KeAv(4,4), teta, Z(4,4), Cscat, Cext, Qscat, Qext,              &
                    CscatV, CextV, QscatV, QextV, AsymPar, AsymParV, Elem(16)                      
  character(2)   :: NameElem(Nelem)
  logical        :: MirorSym, axsym, FailHovTest
  character(256) :: FailMessage(10)
!
  if (i == 1) then
    write (iSCAT,"(/,2x,'Results:',/)")
    write (iSCAT,"(  2x,'Cross Sections, Efficiencies and Asymmetry Parameter:')") 
    if (.not.MirorSym) then
      write (iSCAT,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                              &
            '<Cscat>_I = ', Cscat,  '<Qscat>_I = ', Qscat 
      write (iSCAT,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                              &
            '<Cscat>_V = ', CscatV, '<Qscat>_V = ', QscatV 
      write (iSCAT,*)	    
      write (iSCAT,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                              &
            '<Cext>_I  = ', Cext,   '<Qext>_I  = ', Qext
      write (iSCAT,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                              &
            '<Cext>_V  = ', CextV,  '<Qext>_V  = ', QextV	    
      write (iSCAT,*)
      write (iSCAT,"(2x, a, 1pe13.4)") '< cos >_I = ', AsymPar
      write (iSCAT,"(2x, a, 1pe13.4)") '< cos >_V = ', AsymParV      	    	                          
    else   
      write (iSCAT,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                              &
            '<Cscat> = ', Cscat,  '<Qscat> = ', Qscat
      write (iSCAT,"(2x, a, 1pe13.4, 5x, a, 1pe13.4)")                              &
            '<Cext>  = ', Cext,   '<Qext>  = ', Qext 
      write (iSCAT,"(2x, a, 1pe13.4)") '< cos > = ', AsymPar	    	                                        
    end if
    write (iSCAT,*)          
    write (iSCAT,"(2x,'Extinction Matrix:')")    
    do ii = 1, 4
      write (iSCAT,"(4(2x,1pe13.4))") (KeAv(ii,k), k = 1, 4)
    end do                           
    write (iSCAT,*)          
    write (iSCAT,"(2x,'Scattering Matrix:')")  
    write (iSCAT,"(2x,a5,9x,a2,15(13x,a2))") 'theta', NameElem(1),                  &
          (NameElem(k), k = 2, Nelem)
  end if    
  do k = 1, Nelem
    ii = IndI(k)
    jj = IndJ(k)
    Elem(k) = Z(ii,jj)
  end do         
  write (iSCAT,"(1x,f6.2,16(5x,1pe10.3))")  teta * 180._O / Pi,                     &
        (Elem(k), k = 1, Nelem)
  if (axsym .and. FailHovTest) then            
    write (iSCAT,"(2x,'test of Van der Mee and Hovenier is not satisfied;')")
    do ifail = 1, Nfail
      write (iScat,"(2x,a)") FailMessage(ifail)
    end do
  end if
end subroutine write_ScatMatrix
! **********************************************************************************
! *                           SPHERICAL PARTICLES                                  * 
! **********************************************************************************                 
subroutine inputDSCS_SCATAvrgSPH (ComputeDSCSAvrg, amin, amax, TypeDist, Npar, par, &
           Nrank, Nint, alfap, wavelength, anorm, normalized)                            
  use parameters
  implicit none
  integer  :: TypeDist, Npar, Nrank, Nint, iout, i
  real(O)  :: par(Npar), alfap, amin, amax, wavelength, anorm
  logical  :: ComputeDSCSAvrg, normalized
!
  if (ComputeDSCSAvrg) then
    iOut = iDSCS
  else
    iOut = iSCAT
  end if
  write (iOut,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOut,"(2x,'wavelength of the free space, wavelength = ',1pe13.4,';')")     &
         wavelength
  if (TypeDist == 1) then
    write (iOut,"(2x,'modified gamma distribution;')")
  else if (TypeDist == 2) then
    write (iOut,"(2x,'log normal distribution;')")
  else if (TypeDist == 3) then
    write (iOut,"(2x,'gamma distribution;')")
  else if (TypeDist == 4) then
    write (iOut,"(2x,'power law distribution;')")
  else if (TypeDist == 5) then
    write (iOut,"(2x,'modified bimodal log normal distribution;')")
  end if
  write (iOut,"(2x,'parameters of the size distribution:')")
  do i = 1, Npar
    write (iOut,"(2x,'par(',i2,') = ',1pe13.4,',')") i, par(i)
  end do
  write (iOut,"(2x, a, 1pe13.4, a, 1pe13.4, a)")                                    &
 'bounds of the particle size distribution, amin = ', amin, ', amax = ', amax, ';'
  write (iOut,"(2x,'number of integration points, Nint = ',i4,';')") Nint
  write (iOut,"(2x,'maximum expansion order, Nrank = ',i3,';')") Nrank
  if (ComputeDSCSAvrg) write (iOut,"(2x, a, f7.2, a)")                              &
 'polarization angle of the incident plane wave, alphap = ', alfap * 180._O / Pi, ';'   
  write (iOut,"(2x, a, 1pe10.3, a)")                                                &
 'characteristic length of the cluster, anorm = ', anorm, ';'    
  if (normalized) write (iOut,"(2x, a, 1pe13.4, a)")                                &
 'normalization constant, pi * anorm**2 = ', Pi * anorm * anorm, ';'
  write (iOut,*)
end subroutine inputDSCS_SCATAvrgSPH 
! **********************************************************************************
subroutine write_ScatMatrixAvrg (teta, Z, i, Cscat, Cext, Qscat, Qext, AsymPar,     &
           AvrgArea, EffRadius, AvrgRadius, AvrgVolume, VWAvrgRadius, EffVar)
  use parameters
  implicit none
  integer        :: i
  real(O)        :: teta, Z(4,4), Cscat, Cext, Qscat, Qext, AsymPar, AvrgArea,      &
                    EffRadius, AvrgRadius, AvrgVolume, VWAvrgRadius, EffVar
!
  if (i == 1) then
    write (iSCAT,"(/,2x,'Results:',/)")
    write (iSCAT,"(2x,'Cross Sections, Efficiencies and Asymmetry Parameter:')") 
    write (iSCAT,"(2x,'average scattering cross section = ',1pe13.4,';')") Cscat
    write (iSCAT,"(2x,'average extinction cross section = ',1pe13.4,';')") Cext                   
    write (iSCAT,*)
    write (iSCAT,"(2x,'average scattering efficiency    = ',1pe13.4,';')") Qscat
    write (iSCAT,"(2x,'average extinction efficiency    = ',1pe13.4,';')") Qext 
    write (iSCAT,*)
    write (iSCAT,"(2x,'average asymmetry parameter      = ',1pe13.4,';')") AsymPar
    write (iSCAT,*) 
    write (iSCAT,"(2x,'Characteristics of the size distribution:')")
    write (iSCAT,"(2x,'average area of the geometric projection  = ',1pe13.4,';')") &
           AvrgArea
    write (iSCAT,"(2x,'effective radius    = ',1pe13.4,';')") EffRadius
    write (iSCAT,"(2x,'effective variance  = ',1pe13.4,';')") EffVar
    write (iSCAT,"(2x,'average radius      = ',1pe13.4,';')") AvrgRadius
    write (iSCAT,"(2x,'average volume      = ',1pe13.4,';')") AvrgVolume
    write (iSCAT,"(2x,'volume - weighted average radius  = ',1pe13.4,';')")         &
           VWAvrgRadius
    write (iSCAT,*)
    write (iSCAT,"(2x,'Scattering Matrix:')")  
    write (iSCAT,"(2x,a5,9x,a2,3(13x,a2))") 'theta', '11', '33', '12', '34'               
  end if        
  write (iSCAT,"(1x,f6.2,16(5x,1pe10.3))") teta * 180._O / Pi,                      &
         Z(1,1), Z(3,3), Z(1,2), Z(3,4)  
end subroutine write_ScatMatrixAvrg
! **********************************************************************************
! *                       PARTICLE ON OR NEAR A PLANE SURFACE                      *
! **********************************************************************************                 
subroutine inputDSCS_EMF (ComputeDSCS, TypeScat, k, ind_ref_s, z0, Mrank, Nrank,    &
           phiGS, beta, alphap, snorm, normalized, FileTmat)                             
  use parameters
  implicit none
  integer       :: TypeScat, Mrank, Nrank, LenString, iOut
  real(O)       :: k, phiGS, beta, alphap, snorm, z0, wavelength, anorm, grd
  complex(O)    :: ind_ref_s                   
  character(80) :: FileTmat, FileTmatWrite
  logical       :: ComputeDSCS, normalized
!
  wavelength = 2._O * Pi / k
  anorm = sqrt(snorm / Pi) / k
  grd   = 180._O / Pi
  if (ComputeDSCS) then
    iOut = iDSCS
  else
    iOut = iSCAT
  end if
  write (iOut,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOut,"(2x,'wavelength of the ambient medium, wavelength = ',1pe13.4,';')") & 
         wavelength
  write (iOut,"(2x, a, 1pe10.3, ',', 1pe10.3, a)")                                  &
 'relative refractive index of the substrate, ind_refSUB = (', ind_ref_s, ');' 
  FileTmatWrite = FileTmat(14:LenString(FileTmat))                 
  write (iOut,"(2x,'name of the file containing the T matrix, FileTmat = ',a40)")   &
         FileTmatWrite
  write (iOut,"(2x,'maximum expansion order, Nrank = ',i3,';')") Nrank
  write (iOut,"(2x,'maximum azimuthal order, Mrank = ',i3,';')") Mrank           
  write (iOut,"(2x,'axial position of the particle, z0 = ',1pe10.3,';')") z0  
  if (TypeScat == 1)  then
    write (iOut,"(2x, a)")                                                          &
   'illumination by a plane wave traveling in the ambient medium;'
    write (iOut,"(2x,'incident angle, beta = ',f7.2,';')") beta * grd                          
  else if (TypeScat == 2)  then
    write (iOut,"(2x,'illumination by a plane wave traveling in the substrate;')")
    write (iOut,"(2x,'incident angle, beta = ',f7.2,';')") beta * grd       
    write (iOut,"(2x, a, f7.2, a)")                                                 &
   'propagation angle of the incident wave, Pi - beta = ', 180._O - beta * grd, ';'        
  end if
  write (iOut,"(2x,'polarization angle of the incident wave, alphap = ',f7.2,';')") &
         alphap * grd
  if (ComputeDSCS) write (iOut,"(2x,'scattering plane, phiGS = ', f7.2,';')")       &
                          phiGS * grd  
  write (iOut,"(2x, a, 1pe10.3, a)")                                                & 
 'characteristic length of the scatterer, anorm = ', anorm, ';'   
  if (normalized) write (iOut,"(2x, a, 1pe13.4, a)")                                &
 'normalization constant, pi * anorm**2 = ', Pi * anorm * anorm, ';'
  write (iOut,*)        
end subroutine inputDSCS_EMF
! **********************************************************************************
subroutine write_DSCSPARTSUB (Nteta, h, v)
  use parameters
  implicit none      
  integer   :: Nteta, i
  real(O)   :: teta, h(Nteta), v(Nteta)                 
!
  write (iOutput,"(1x, a, //, 2x, a, 9x, a, 8x, a, /)")                             &
 'normalized differential scattering cross section', 'theta', 'parallel',           &
 'perpendicular'                        
  do i = 1, Nteta
    teta = 90._O + real(i - 1,O) * 180._O / real(Nteta - 1,O)            
    write (iOutput,"(1x,f6.2,5x,1pe13.4,5x,1pe13.4)")  teta, h(i), v(i)  
  end do 
  write (iOutput, "(/)")                  
end subroutine write_DSCSPARTSUB
! **********************************************************************************
subroutine write_DSCSPARTSUB1 (NthetaGS, normalized, h, v)
  use parameters
  implicit none      
  integer   :: NthetaGS, i
  real(O)   :: teta, h(NthetaGS), v(NthetaGS)                   
  logical   :: normalized
!
  write (iDSCS,"(/,2x,'Results:',/)") 
  if (normalized) then
    write (iDSCS,"(2x, a, /, 2x, a, 9x, a, 8x, a, /)")                              &   
   'normalized differential scattering cross section', 'theta', 'parallel',         &
   'perpendicular' 
  else
    write (iDSCS,"(8x, a, /, 2x, a, 9x, a, 8x, a, /)")                              & 
   'differential scattering cross section', 'theta', 'parallel', 'perpendicular'  
  end if
  do i = 1, NthetaGS
    teta = 90._O + real(i - 1,O) * 180._O / real(NthetaGS - 1,O)                                    
    write (iDSCS,  "(1x,f6.2,5x,1pe13.4,5x,1pe13.4)") teta, h(i), v(i)          
  end do
end subroutine write_DSCSPARTSUB1  
! **********************************************************************************
subroutine write_EMF (Nphi, phi, Ntheta, thetamin, thetamax, emf, NphiAL, NthetaAL)
  use parameters
  implicit none
  integer    :: Nphi, Ntheta(NphiMax), NphiAL, NthetaAL, iphi, itheta
  real(O)    :: phi(NphiMax), thetamin(NphiMax), thetamax(NphiMax), phiGS, thetaGS, &
                dtheta, grd
  complex(O) :: emf(3,NphiAL,NthetaAL)
!
  grd = 180._O / Pi
  write (iSCAT,"(/,2x,'Results:',/)") 
  write (iSCAT,"(2x,'Electromagnetic Fields:')")
  write (iSCAT,"(3x, a3, 7x, a5, 12x, a8, 18x, a13)") 'phi','theta', 'parallel',    &
        'perpendicular'          
  do iphi = 1, Nphi
    phiGS = phi(iphi)
    if (Ntheta(iphi) /= 1) then
      dtheta = (thetamax(iphi) - thetamin(iphi)) / (Ntheta(iphi) - 1)
    else
      dtheta = 0._O
    end if          
    do itheta = 1, Ntheta(iphi)
      thetaGS = thetamin(iphi) + (itheta - 1) * dtheta  
      write                                                                                     &
     (iSCAT,"(1x,f6.2,5x,f6.2,5x,'(',1pe10.3,',',1pe10.3,')', 5x,'(',1pe10.3,',',1pe10.3,')')") & 
      phiGS * grd, thetaGS * grd, emf(2,iphi,itheta), emf(3,iphi,itheta)
    end do      
  end do
end subroutine write_EMF         




     
  

include 'Parameters.f90'
include 'Allocation.f90'
include 'AdditonTh.f90'
include 'BesLeg.f90'
include 'Check.f90'
include 'EFMED.f90'
include 'GeomLib.f90'
include 'GeomTrans.f90'
include 'IncCoeff.f90'
include 'InputOutput.f90'
include 'Integr.f90'
include 'Interp.f90'
include 'MachParam.f90'
include 'MatrixOp.f90'
include 'MatrixQ.f90'
include 'MatrixSolv.f90'
include 'MatrixTrans.f90'
include 'PostProces1.f90'
include 'PostProces2.f90'
include 'PostProces3.f90'
include 'Proces1.f90'
include 'Proces2.f90'
include 'Proces3.f90'
include 'Random.f90'
include 'SCT.f90'
include 'SCTAVRGSPH.f90'
include 'SVWF.f90'
include 'TLAY.f90'
include 'TNONAXSYM.f90'


!***********************************************************************************
subroutine appendtotmat (b,btot,m,Nrank,Nmax,Nmaxmax)
  use parameters
  implicit none   
  integer       :: Nrank, m, Nmax, Nmaxmax, k1, k2, N0, j, &
                   mmax
  complex(O)    :: btot(2*Nmaxmax,2*Nmaxmax)
  complex(O)    :: b(2*Nrank,2*Nrank)
!
  if (m==0) then    
    N0 = 0    
    mmax = Nrank
    do k1 = 1, mmax
      do k2 = 1, Nrank
        btot(k1+N0,k2+N0) = b(k1,k2)
        btot(k1+N0+Nmaxmax,k2+N0+Nmaxmax) = b(k1+Nmax,k2+Nmax)
        btot(k1+N0,k2+N0+Nmaxmax) = b(k1,k2+Nmax)
        btot(k1+N0+Nmaxmax,k2+N0) = b(k1+Nmax,k2)
      end do
    end do
  else
    N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
    mmax = Nrank - m + 1
    do j = 1,2
      do k1 = 1, mmax
        do k2 = 1, mmax          
          btot(k1+N0,k2+N0) = b(k1,k2)
          btot(k1+N0+Nmaxmax,k2+N0+Nmaxmax) = b(k1+Nmax,k2+Nmax)
          if (j==2) then
            b(k1,k2+Nmax)=-b(k1,k2+Nmax)
            b(k1+Nmax,k2)=-b(k1+Nmax,k2)
          end if
          btot(k1+N0,k2+N0+Nmaxmax) = b(k1,k2+Nmax)
          btot(k1+N0+Nmaxmax,k2+N0) = b(k1+Nmax,k2)
        end do
      end do
      N0 = N0 + Nrank - m + 1
    end do  
  end if
end subroutine appendtotmat
!***********************************************************************************
subroutine tmatrix_MrankAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm, Nsurf,    &
           surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, miror,         &
           perfectcond, DS, chiral, kb, epsMrank, FileTmat, PrnProgress,Nmaxmax,btot)                
  use parameters
  implicit none   
  integer       :: TypeGeom, Nsurf, Nface, Nparam, Nrank, Nint
  real(O)       :: k, surf(Nsurf), snorm, epsMrank, kb, zRe(Nrank), zIm(Nrank),     &
                   rp(2,NfacePD), np(2,NfacePD), area(NfacePD)
  complex(O)    :: ind_ref
  logical       :: FileGeom, miror, perfectcond, DS, chiral, PrnProgress
  character(80) :: FileTmat
!      
  integer       :: Nteta, Mstart, Mrank, Nmax, Nmaxmax, i, m, NthetaConv, Nprog, j
  real(O)       :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,     &
                   Cext, Qext  
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:), c(:), c1(:), cc(:)
  complex(O)    :: btot(2*Nmaxmax,2*Nmaxmax)
  complex(O)    :: b(2*Nrank,2*Nrank)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 0
!  Mstart = Nrank
  Mrank  = Nrank      
!  open (unit = iTmat, file = FileTmat, status = 'replace')  
!  call write_HeadFileTmat (Nrank, Nrank) 
!  call write_TypeConvHead (3)
!  call write_2ConvParamAxsym (Nint, Nrank)
  allocate (a(2*Nrank,2*Nrank), c(2*Nrank), c1(2*Nrank))
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do  
  allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
  if (.not. FileGeom) then
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, miror)
  else
    do i = 1, Nparam
      do j = 1, Nint
        paramG(i,j)   = 0._O 
        weightsG(i,j) = 0._O
      end do
      Nintparam(i) = 1
    end do
  end if        
  if (.not. chiral) then
    Nprog = 4
  else
    Nprog = 7
  end if
  Mrank = - 1
!  Mrank = Mrank - 1
  do m = Mstart, Nrank       
    call write_1ConvParam (m)
    Mrank = Mrank + 1
    if (m == 0) then
      Nmax = Nrank
    else
      Nmax = Nrank - m + 1
    end if  
    if (PrnProgress) call write_progress_m (.true., m, 1, Nprog)    
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank) 
    if (PrnProgress) call write_progress_m (.false., m, 2, Nprog)       
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, b, Nrank, Nrank) 
    if (PrnProgress) call write_progress_m (.false., m, 3, Nprog)                           
    call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress_m (.false., m, 4, Nprog)                   
!    call write_FileTmat (Nrank, Nrank, b)
    call appendtotmat (b,btot,m,Nrank,Nmax,Nmaxmax)     
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         Nmax, c)
    call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)       
    if (m /= 0) then
      if (.not. chiral) then
        call matrix_m_negativ (Nmax, Nmax, b, Nrank, Nrank)        
      else 
        call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, &
             area, Nface, zRe, zIm, -m, Nrank,Nmax, Nint, Nparam, Nintparam,        &
             paramG, weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
        if (PrnProgress) call write_progress_m (.false., m, 5, Nprog)                     
        call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, &
             area, Nface, zRe, zIm, -m, Nrank,Nmax, Nint, Nparam, Nintparam,        &
             paramG, weightsG, miror, perfectcond, DS, chiral, kb, b, Nrank, Nrank)    
        if (PrnProgress) call write_progress_m (.false., m, 6, Nprog)
        call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)       
        if (PrnProgress) call write_progress_m (.false., m, 7, Nprog)
!        call write_FileTmat (Nrank, Nrank, b)
        call appendtotmat (b,btot,-m,Nrank,Nmax,Nmaxmax)
      end if
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,  &
           Nmax, c) 
      call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, c, c1)
      call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)     
    end if
!    call DSCS (cc, Mrank, Nrank, Nmaxmax, Nteta, phiGS, alfa, beta, gama, k, snorm, &
!        .false.,.true., h, v)
!    call delta_DSCS (Nteta, h, v, oldh, oldv, epsMrank, NthetaConv)     
!    call write_DSCS (Nteta,.false., h, v)
!    if (NthetaConv >= int(0.8*Nteta)) exit 
  end do
!  close (unit = iTmat) 
!  call CQscat (cc, Mrank, Nrank, Nmaxmax, k, snorm, Cscat, Qscat)
!  call CQext (cc, Mrank, Nrank, Nmaxmax, tetaGI, phiGI, alfa, beta, gama,           &
!       alfap, k, snorm, Cext, Qext)
!  call write_Effic (Qscat, Qext)
!  call write_MrankConvRes (NthetaConv, epsMrank)
!  if (NthetaConv >= int(0.8*Nteta)) then
!    print "(/,2x,'Convergence criterion for Mrank is satisfied;')"                                              
!  else
!    print "(/,2x,'Convergence criterion for Mrank is not satisfied;')"
!  end if
!  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .true., .false., chiral)
!  call ScatCharact (k, FileTmat, Mrank, Nrank, .true., .false., chiral)
!  print "(/,2x,'T matrix is stored in ',a50)", FileTmat
  if (PrnProgress) then
	  print "(  2x,'The dimensions of the T matrix are given by:')"      
    print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank
    print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank                     
  end if
  deallocate (a, c, c1, cc, h, v, oldh, oldv, paramG, weightsG, Nintparam)
end subroutine tmatrix_MrankAXSYM
!***********************************************************************************
subroutine tmatrix_MrankDSAXSYM (FileGeom, TypeGeom, k, ind_ref, snorm, Nsurf,  &
           surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, miror,         &
           perfectcond, DS, chiral, kb, epsMrank, dNintMrank, FileTmat, PrnProgress,Nmaxmax,btot)            
  use parameters
  implicit none   
  integer       :: TypeGeom, Nsurf, Nface, Nparam, Nrank, Nint, dNintMrank
  real(O)       :: k, surf(Nsurf), snorm, epsMrank, kb, zRe(Nrank), zIm(Nrank),     &
                   rp(2,NfacePD), np(2,NfacePD), area(NfacePD)
  complex(O)    :: ind_ref
  logical       :: FileGeom, miror, perfectcond, DS, chiral, PrnProgress
  character(80) :: FileTmat
!      
  integer       :: Nteta, Mstart, Mrank, Nmax, Nmaxmax, i, m, NthetaConv, Nprog, j
  real(O)       :: alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,     &
                   Cext, Qext  
  logical       :: ComplexPlane
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), h(:), v(:), oldh(:), oldv(:)
  complex(O),allocatable :: a(:,:),  c(:), c1(:), cc(:)
  complex(O)    :: btot(2*Nmaxmax,2*Nmaxmax)
  complex(O)    :: b(2*Nrank,2*Nrank)
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Mstart = 0
  Mrank  = Nrank      
  allocate (a(2*Nrank,2*Nrank), c(2*Nrank), c1(2*Nrank))
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do  
  allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
  if (.not. FileGeom) then
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, miror)
  else
    do i = 1, Nparam
      do j = 1, Nint
        paramG(i,j)   = 0._O 
        weightsG(i,j) = 0._O
      end do
      Nintparam(i) = 1
    end do
  end if       
  ComplexPlane = .false.        
  do i = 1, Nrank                  
    if (zIm(i) /= 0._O) ComplexPlane = .true.
  end do
  if (.not. chiral) then
    Nprog = 5
  else
    Nprog = 9
  end if                        
  Mrank = - 1
  do m = Mstart, Nrank          
    call write_1ConvParam (m)
    Mrank = Mrank + 1
    if (m == 0) then
      Nmax = Nrank
    else
      Nmax = Nrank - m + 1
    end if  
    if (ComplexPlane) then
      deallocate (paramG, weightsG, Nintparam)
      Nint = Nint + dNintMrank
      allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
      call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,            &
           Nintparam, paramG, weightsG, miror)          
    end if 
    if (PrnProgress) call write_progress_m (.true., m, 1, Nprog)  
    call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    if (PrnProgress) call write_progress_m (.false., m, 2, Nprog) 
    call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area, Nface,&
         zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG, weightsG, b,    &
         Nrank, Nrank)
    if (PrnProgress) call write_progress_m (.false., m, 3, Nprog)
    call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank, 2*Nmax)
    if (PrnProgress) call write_progress_m (.false., m, 4, Nprog)
    call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np,     &
         area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,    &
         weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
    call product_matrices (2*Nmax, 2*Nrank, 2*Nmax, a, 2*Nrank, 2*Nrank, b, 2*Nrank,&
         2*Nrank)   
    if (PrnProgress) call write_progress_m (.false., m, 5, Nprog)
    call appendtotmat (a,btot,m,Nrank,Nmax,Nmaxmax)
    call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, m, Nrank,     &
         Nmax, c)           
    call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)       
    if (m /= 0) then
      if (.not. chiral) then
        call matrix_m_negativ (Nmax, Nmax, a, Nrank, Nrank)
      else 
        call matrix_Q_m (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, &
             area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam,       &
             paramG, weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
        if (PrnProgress) call write_progress_m (.false., m, 6, Nprog)
        call incident_matrix_m (FileGeom, TypeGeom, k, Nsurf, surf, rp, np, area,   &
             Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam, paramG,     &
             weightsG, b, Nrank, Nrank)
        if (PrnProgress) call write_progress_m (.false., m, 7, Nprog)
        call LU_SYSTEM_DIRECT (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nrank,   &
             2*Nmax)
        if (PrnProgress) call write_progress_m (.false., m, 8, Nprog)
        call matrix_Q_m (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, &
             area, Nface, zRe, zIm, -m, Nrank, Nmax, Nint, Nparam, Nintparam,       &
             paramG, weightsG, miror, perfectcond, DS, chiral, kb, a, Nrank, Nrank)
        call product_matrices (2*Nmax, 2*Nrank, 2*Nmax, a, 2*Nrank, 2*Nrank,        &
             b, 2*Nrank, 2*Nrank)               
        if (PrnProgress) call write_progress_m (.false., m, 9, Nprog)
        call appendtotmat (a,btot,-m,Nrank,Nmax,Nmaxmax)
      end if
      call PWcoefficients_ab_m (tetaGI, phiGI, alfa, beta, gama, alfap, -m, Nrank,  &
           Nmax, c)
      call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, c, c1)
      call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)
    end if
  end do
	if (PrnProgress) then
    print "(  2x,'The dimensions of the T matrix are given by:')"
    print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank 
    print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank             
  end if
  deallocate (a, c, c1, cc, h, v, oldh, oldv, paramG, weightsG, Nintparam)
end subroutine tmatrix_MrankDSAXSYM
subroutine TAXSYM ( wavelength, ind_refMed, ind_refRel, perfectcond,                &
           chiral, kb, FileGeom, TypeGeom, FileFEM, Nsurf, surf, Nparam, anorm,     &
           Rcirc, miror, DoConvTest, MishConvTest, DS, autGenDS, ComplexPlane,      &
           epsZReIm, Nint, Nrank, epsNint, epsNrank, epsMrank, dNint, dNintMrank,   &
           FileTmat, PrnProgress, Nface,Nmaxmax,b) 
  use parameters 
  use derived_parameters  
  implicit none 
  integer       :: TypeGeom, Nsurf, Nparam, TypeConvTest, dNint, Nrank, Nint,       &
                   Nrank1, dNintMrank, Ndgs, NrankMax, NrankW, Nface, i, j, Mrank,  &
                   Nmaxmax
  real(O)       :: k, ind_refMed, wavelength, anorm, surf(Nsurf), snorm,            &
                   kb, epsNint, epsNrank, epsMrank, zRe(NrankPD), zIm(NrankPD),     &
                   zRe1(NrankPD), zIm1(NrankPD), Rcirc, x, delta, Cscat1, Cext1,    &
                   epsZReIm, rp(2,NfacePD), np(2,NfacePD), area(NfacePD)                          
  complex(O)    :: ind_refRel
  logical       :: FileGeom, miror, perfectcond, DoConvTest, DS, chiral, autGenDS,  &
                   ComplexPlane, MishConvTest, PrnProgress
  character(80) :: FileTmat, FileFEM
  complex(O), intent(out)    :: b(2*Nmaxmax,2*Nmaxmax)
  !f2py real(O) :: wavelength  = 1
  !f2py real(O) :: ind_refMed = 1                                                                 
  !f2py complex(O) :: ind_refRel = (1.5,0) 
  !f2py real(O) :: epsNint  = 5.e-2
  !f2py real(O) :: epsNrank = 5.e-2
  !f2py real(O) :: epsMrank = 5.e-2
  !f2py integer :: dNint    = 4
  !f2py integer :: dNintMrank = 10
  !f2py character(80) :: FileTmat = '../TMATFILES/T.dat'
  !f2py logical :: PrnProgress = 1 
  !f2py logical :: perfectcond = 0  
  !f2py logical :: chiral = 0
  !f2py real(O) :: kb     = 0 
  !f2py logical :: FileGeom = 0
  !f2py character(80) :: FileFEM  = ' '  
  !f2py integer :: TypeGeom = 1 
  !f2py integer :: Nparam = 1
  !f2py real(O) :: anorm  = 1
  !f2py real(O) :: Rcirc  = 1 
  !f2py logical :: miror  = 0
  !f2py integer :: Nface = 1
  !f2py logical :: DoConvTest   = 0
  !f2py logical :: MishConvTest = 0
  !f2py logical :: ComplexPlane = 1
  !f2py real(O) :: epsZReIm = 0.95 
  !f2py integer :: Nint   = 100
  !f2py integer :: Nrank  =  17
  !f2py logical :: DS = 0
  !f2py logical :: autGenDS = 1 
!************************************************************************************
!  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  integer       :: ios                     
  real(O)       :: xpart,dp 
  logical       :: InputDS, XFindPar      
! -----------------------------------------------------------------------------------
!                        Read the input file FileInputAXSYM                         ! 
! -----------------------------------------------------------------------------------    
  call DrvParameters   
  call check_ind_ref (ind_refRel)
  k = 2._O * Pi * ind_refMed / wavelength 
!       
  call check_MatPropAXSYM (perfectcond, chiral, kb)   
  if (chiral) call check_chirality (kb)

!                          
  call check_geomAXSYM (TypeGeom, Nsurf, Nparam)
  call check_geomAXSYMOblate (TypeGeom, Nsurf, surf)  
  call check_anorm (anorm)
  xpart = k * anorm
  snorm = Pi * xpart * xpart 
  do i = 1, NfacePD
    do j = 1, 2
      rp(j,i) = 0._O
      np(j,i) = 0._O
    end do
    area(i) = 0._O
  end do  
  if (FileGeom) then    
    call read_FileFEMAxsym (FileFEM, Nface, rp, np, area)     
    Rcirc = 0._O    
    do i = 1, Nface
      dp = sqrt(rp(1,i)**2 + rp(2,i)**2)
      if (dp > Rcirc) Rcirc = dp
    end do    
  end if          
! 
  if (chiral)   MishConvTest = .false.     
  if (FileGeom) MishConvTest = .false.  
!    
  call check_inputAXSYM (miror, chiral, DS)
  if (FileGeom) autGenDS = .false.  
  InputDS = .false.
  if (DS .and. .not. autGenDS) InputDS = .true. 
  do i = 1, NrankPD
    zRe(i)  = 0._O
    zIm(i)  = 0._O
    zRe1(i) = 0._O
    zIm1(i) = 0._O
  end do                 
! -----------------------------------------------------------------------------------
!         Select the type of convergence test and the values of Nint and Nrank      !
! -----------------------------------------------------------------------------------
  x = k * Rcirc
  NrankW = int(x + 4.05_O * x**0.33_O + 2._O)
  if (.not. DS) then
!    else
    if (PrnProgress) then
  		print "(/,2x,'Convergence Test for an Axisymmetric Particle over Mrank')" 
      print "(  2x,'--------------------------------------------------------')"
      print "(/,2x,'Input values:')"
      if (.not. FileGeom) then
        print "(  2x, a, i4, a, i4, a)",                                            & 
       'the input values of Nint and Nrank are ', Nint, ' and ', Nrank,             &
       ', respectively,'  
        print "(  2x, a, i3, a)",                                                   &
       'while the estimated value of Nrank from Wiscombe''s criterion is ', NrankW,';'
      else
        print "(  2x,'the input value of Nrank is ', i4,', while')", Nrank
        print "(  2x, a, i3, a)",                                                   &
       'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';' 
      end if                                                                          
    end if
    TypeConvTest = 3      
!    end if
    Nrank1 = Nrank - 1 ! redundant            
  else
    if (autGenDS) then                       
!      else
      if (PrnProgress) then
        print "(/,2x,'Convergence Test for an Axisymmetric Particle over Mrank')" 
        print "(  2x,'--------------------------------------------------------')"
        print "(/,2x,'Input values:')"
        print "(  2x, a, i4, a, i4, a)",                                            &
       'the input values of Nint and Nrank are ', Nint, ' and ', Nrank,             &
       ', respectively,' 
        print "(  2x, a, i3, a)",                                                   &
       'while the estimated value of Nrank from Wiscombe''s criterion is ', NrankW,';'         
			end if
      call check_MaxNrank (Nrank)
      call zDSAXSYM (TypeGeom, Nsurf, surf, Nrank, ComplexPlane, epsZReIm, zRe, zIm) 
      TypeConvTest = 3    
!     end if
      Nrank1 = Nrank - 1 ! redundant  
    else 
!      else
      if (PrnProgress) then
        print "(/,2x,'Convergence Test for an Axisymmetric Particle over Mrank')" 
        print "(  2x,'--------------------------------------------------------')" 
        print "(/,2x,'Input values:')" 
        if (.not. FileGeom) then                  
          print "(  2x, a, i4, a, i4, a)",                                          &
         'the input values of Nint and Nrank are ', Nint, ' and ', Nrank,           &
         ', respectively,' 
          print "(  2x, a, i3, a)",                                                 &
         'while the estimated value of Nrank from Wiscombe''s criterion is ',       &
          NrankW,';' 
        else
          print "(  2x,'the input value of Nrank is ', i4,', while')", Nrank
          print "(  2x, a, i3, a)",                                                 &
         'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';' 
        end if
      end if
      TypeConvTest = 3              
!      end if
      Nrank1 = Nrank - 1 ! redundant          
    end if
  end if                                                                            
! -----------------------------------------------------------------------------------
!                               T-matrix calculation                                !
! -----------------------------------------------------------------------------------
!  else      
  if (.not. DS) then    
    call tmatrix_MrankAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm, Nsurf,     &
         surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint,                &
           miror, perfectcond, DS, chiral, kb, epsMrank, FileTmat, PrnProgress,   &
           Nmaxmax,b)
  else          
    call tmatrix_MrankDSAXSYM (FileGeom, TypeGeom, k, ind_refRel, snorm,          &
         Nsurf, surf, rp, np, area, Nface, zRe, zIm, Nparam, Nrank, Nint, miror,  &
         perfectcond, DS, chiral, kb, epsMrank, dNintMrank, FileTmat, PrnProgress,&
         Nmaxmax,b)
  end if  
!  end if 
end subroutine TAXSYM

! **********************************************************************************
! *                ROUTINES FOR SOLVING LINEAR ALGEBRAIC EQUATIONS                 *
! *     -----------------------------------------------------------------------    *      
! *     Partial list of subroutines:                                               *
! *        inverse_matrix ,    LU_SYSTEM,    LU_SYSTEM_DIRECT,     LUDCMP,         *
! *        LUBKSB,             LU,           equilibrate,          LUDCMP1,        *
! *        LUBKSB1,            LU1,          BICGSTAB,             Precond,        *
! *        MatSolve,           readinputMatrSolv                                   *
! ********************************************************************************** 
subroutine inverse_matrix (a, nap, map, b, nbp, mbp, n)
!------------------------------------------------------------------------------------
! The routine computes the inverse of a matrix, i.e., B(n,n) = [A(n,n)]^(-1).       ! 
!                                                                                   !
! Input parameters:                                                                 !
! - a (complex array) - square matrix.                                              !
! - nap, map (integer variables) - specify the physical dimensions of the           ! 
!   matrix a.                                                                       !
! - nbp, mbp (integer variables) - specify the physical dimensions of the           !
!   inverse matrix.                                                                 !
! - n (integer) - real dimension of the square matrix.                              !
!                                                                                   !
! Output parameter:                                                                 !  
! - b (complex array) - inverse of the matrix a.                                    !
!                                                                                   !
! The model control parameters specified in the file "../INPUTFILES/Input.dat" are  !
! given below.                                                                      !
!                                                                                   !
! - TypeMatrSolv (character array) - specifies the method for solving linear        !
!   algebraic equations. The permissive values are:                                 !
!   - 'LU1'  - LU decomposition method from Numerical Recipes,                      !
!   - 'LU2'  - LU decomposition method from Lapack library,                         !
!   - 'LU3'  - LU decomposition method from Lapack library with solution            !
!      improvement,                                                                 !
!   - 'BICG' - Bi-Conjugate-Gradients method.                                       !
!   The recommended value of the parameter TypeMatrSolv is 'LU2'.                   !
!                                                                                   !
! - itmax (integer) - maximum number of iteration for the 'LU3' method or BICG      !
!   method.                                                                         !
!                                                                                   !
! - TypePrecond (character array) - specifies the type of preconditioning for the   !
!   BICG method. The permissive values are:                                         !
!   - 'NEUMANN' - incomplete Neumann series,                                        !
!   - 'SILU'    - incomplete LU factorization,                                      !
!   - ' '       - diagonal elements of the matrix.                                  !
!                                                                                   !
! - NPrecOrder (integer) - truncation order of the Neumann series. This parameter   !
!   is used if TypePrecond = 'NEUMANN'.                                              !
!                                                                                   !
! - epsilon (real) - solution tolerance for the BICG method.                        !
!------------------------------------------------------------------------------------     
  use parameters
  implicit none
  integer    :: n, nap, map, nbp, mbp
  complex(O) :: a(nap,map), b(nbp,mbp)
!                     
  integer    :: i, j, itmax, NPrecOrder  
  real(O)    :: d, epsilon
  integer,allocatable    :: indx(:)
  real(O),allocatable    :: row(:), column(:)
  complex(O),allocatable :: c(:)
  character(20)          :: TypeMatrSolv, TypePrecond
!        
  call readinputMatrSolv ( TypeMatrSolv, itmax, TypePrecond, NPrecOrder, epsilon )    
  if (TypeMatrSolv(1:3) == 'LU1') then
    call identity_matrix (n, b, nbp, mbp)
    allocate (indx(n), c(n), row(n), column(n))      
    call equilibrate (a, nap, map, n, n, row, column)
    call LUDCMP (a, nap, map, n, indx, d)
    do j = 1, n
      do i = 1, n
        c(i) = b(i,j) * row(i)
      end do 
      call LUBKSB (a, nap, map, n, indx, c)
      do i = 1, n
        b(i,j) = c(i) * column(i)
      end do 
    end do 
    deallocate (indx, c, row, column)      
  else if (TypeMatrSolv(1:3) == 'LU2') then 
    call identity_matrix (n, b, nbp, mbp)
    allocate (indx(n), row(n), column(n))
    call equilibrate (a, nap, map, n, n, row, column)
    call LUDCMP1 (a, nap, map, n, indx)
    do j = 1, n
      do i = 1, n
        b(i,j) = row(i) * b(i,j)
      end do
    end do
    call LUBKSB1 (a, nap, map, n, n, indx, b, nbp, mbp)
    do j = 1, n
      do i = 1, n
        b(i,j) = column(i) * b(i,j)
      end do
    end do
    deallocate (indx, row, column)                                                  
  else if (TypeMatrSolv(1:3) == 'LU3') then
    call identity_matrix (n, b, nbp, mbp)
    allocate (row(n), column(n))
    call equilibrate (a, nap, map, n, n, row, column)
    do j = 1, n
      do i = 1, n
        b(i,j) = row(i) * b(i,j)
      end do
    end do      
    call LU1 (a, nap, map, b, nbp, mbp, n, n, itmax)
    do j = 1, n
      do i = 1, n
        b(i,j) = column(i) * b(i,j)
      end do
    end do      
    deallocate (row, column)
  else if (TypeMatrSolv(1:4) == 'BICG') then   
    call identity_matrix (n, b, nbp, mbp)           
    call BICGSTAB (TypePrecond, NPrecOrder, itmax, epsilon, n, n, a, nap, map,      &
         b, nbp, mbp)
  end if  
end subroutine inverse_matrix 
! ***********************************************************************************
subroutine LU_SYSTEM (a, nap, map, b, nbp, mbp, n)
!------------------------------------------------------------------------------------
! Given the square matrices a and b, the routine computes                           !
!                      x(n,n) = b(n,n) * a(n,n)^(-1)                                !
! using the following scheme:                                                       !
! - transpose the matrices a and b, i.e. compute a(n,n)^T and b(n,n)^T,             !
! - compute y(n,n) = [a(n,n)^T]^(-1) * b(n,n)^T, that is, solve the matrix system   !
!   [a(n,n)^T] * y(n,n) = b(n,n)^T, with y being stored in b,                       !
! - transpose the matrix y, i.e. compute x(n,n)= y(n,n)^T                           ! 
!                                                                                   !
! Input parameters:                                                                 !
! - a (complex array) - square matrix.                                              !
! - nap, map (integer variables) - specify the physical dimensions of the           ! 
!   matrix a.                                                                       !
! - nbp, mbp (integer variables) - specify the physical dimensions of the           !
!   matrix b.                                                                       !
! - n (integer) - real dimension of the square matrices.                            !
!                                                                                   !
! Input/Output parameter:                                                           !  
! - b (complex array) - input matrix b and output matrix x.                         !
!                                                                                   !
! The model control parameters TypeMatrSolv, itmax, TypePrecond, NPrecOrder and     !
! epsilon are specified in the file "../INPUTFILES/Input.dat".                      !
!------------------------------------------------------------------------------------ 
  use parameters
  implicit none
  integer    :: n, nap, map, nbp, mbp
  complex(O) :: a(nap,map), b(nbp,mbp)
!
  integer    :: i, j, itmax, NPrecOrder  
  real(O)    :: d, epsilon
  integer,allocatable    :: indx(:)
  real(O),allocatable    :: row(:), column(:)
  complex(O),allocatable :: c(:)
  character(20)          :: TypeMatrSolv, TypePrecond
!    
  call readinputMatrSolv ( TypeMatrSolv, itmax, TypePrecond, NPrecOrder, epsilon )      
  if (TypeMatrSolv(1:3) == 'LU1') then
    allocate (indx(n), c(n), row(n), column(n))
    call transpose (a, nap, map, n)
    call transpose (b, nbp, mbp, n)
    call equilibrate (a, nap, map, n, n, row, column)                                                   
    call LUDCMP (a, nap, map, n, indx, d)
    do j = 1, n
      do i = 1, n
        c(i) = b(i,j) * row(i)
      end do 
      call LUBKSB (a, nap, map, n, indx, c)
      do i = 1, n
        b(i,j) = c(i) * column(i)
      end do 
    end do 
    call transpose (b, nbp, mbp, n)     
    deallocate (indx, c, row, column)          
  else if (TypeMatrSolv(1:3) == 'LU2') then
    allocate (indx(n), row(n), column(n))
    call transpose (a, nap, map, n)
    call transpose (b, nbp, mbp, n)
    call equilibrate (a, nap, map, n, n, row, column)
    call LUDCMP1 (a, nap, map, n, indx)
    do j = 1, n
      do i = 1, n
        b(i,j) = row(i) * b(i,j)
      end do
    end do
    call LUBKSB1 (a, nap, map, n, n, indx, b, nbp, mbp)
    do j = 1, n
      do i = 1, n
        b(i,j) = column(i) * b(i,j)
      end do
    end do   
    call transpose (b, nbp, mbp, n) 
    deallocate (indx, row, column) 
  else if (TypeMatrSolv(1:3) == 'LU3') then
    allocate (row(n), column(n))
    call transpose (a, nap, map, n)
    call transpose (b, nbp, mbp, n)
    call equilibrate (a, nap, map, n, n, row, column)
    do j = 1, n
      do i = 1, n
        b(i,j) = row(i) * b(i,j)
      end do
    end do      
    call LU1 (a, nap, map, b, nbp, mbp, n, n, itmax)
    do j = 1, n
      do i = 1, n
        b(i,j) = column(i) * b(i,j)
      end do
    end do   
    call transpose (b, nbp, mbp, n) 
    deallocate (row, column)
  else if (TypeMatrSolv(1:4) == 'BICG') then    
    call transpose (a, nap, map, n)
    call transpose (b, nbp, mbp, n)    
    call BICGSTAB (TypePrecond, NPrecOrder, itmax, epsilon, n, n, a, nap, map,      &
         b, nbp, mbp)                
    call transpose (b, nbp, mbp, n)                                     
  end if  
end subroutine LU_SYSTEM   
! ***********************************************************************************
subroutine LU_SYSTEM_DIRECT (a, nap, map, b, nbp, mbp, n, m)
!------------------------------------------------------------------------------------
! The routine computes                                                              !
!                    x(n,m) = [a(n,n)]^(-1) * b(n,m),                               !
! that is, solves the matrix system                                                 !
!                    a(n,n) * x(n,m) = b(n,m),                                      !
! with x being stored in b.                                                         !
!                                                                                   !
! Input parameters:                                                                 !
! - a (complex array) - square matrix.                                              !
! - nap, map (integer variables) - specify the physical dimensions of the           ! 
!   matrix a.                                                                       !
! - nbp, mbp (integer variables) - specify the physical dimensions of the           !
!   matrix b.                                                                       !
! - n (integer) - real dimension of the matrix a. n also specifies the number of    !
!                 lines of the matrix b.                                            !
! - m (integer) - specifies the number of columns of the matrix b.                  ! 
!                                                                                   !
! Input/Output parameter:                                                           !  
! - b (complex array) - input matrix b and output matrix x.                         !
!                                                                                   !
! The model control parameters TypeMatrSolv, itmax, TypePrecond, NPrecOrder and     !
! epsilon are specified in the file "../INPUTFILES/Input.dat".                      !
!------------------------------------------------------------------------------------      
  use parameters
  implicit none
  integer    :: n, m, nap, map, nbp, mbp
  complex(O) :: a(nap,map), b(nbp,mbp)
!             
  integer    :: i, j, itmax, NPrecOrder  
  real(O)    :: d, epsilon
  integer,allocatable    :: indx(:)
  real(O),allocatable    :: row(:), column(:)
  complex(O),allocatable :: c(:)
  character(20)          :: TypeMatrSolv, TypePrecond
!    
  call readinputMatrSolv ( TypeMatrSolv, itmax, TypePrecond, NPrecOrder, epsilon )
  if (TypeMatrSolv(1:3) == 'LU1') then
    allocate (indx(n), c(n), row(n), column(n))
    call equilibrate (a, nap, map, n, n, row, column)
    call LUDCMP (a, nap, map, n, indx, d)       
    do j = 1, m
      do i = 1, n
        c(i) = b(i,j) * row(i)
      end do
      call LUBKSB (a, nap, map, n, indx, c)
      do i = 1, n
        b(i,j) = c(i) * column(i)
      end do
    end do
    deallocate (indx, c, row, column)                  
  else if (TypeMatrSolv(1:3) == 'LU2') then
    allocate (indx(n), row(n), column(n))
    call equilibrate (a, nap, map, n, n, row, column)
    call LUDCMP1 (a, nap, map, n, indx)
    do j = 1, m
      do i = 1, n
        b(i,j) = row(i) * b(i,j)
      end do
    end do
    call LUBKSB1 (a, nap, map, n, m, indx, b, nbp, mbp)
    do j = 1, m
      do i = 1, n
        b(i,j) = column(i) * b(i,j)
      end do
    end do
    deallocate (indx, row, column)                        
  else if (TypeMatrSolv(1:3) == 'LU3') then
    allocate (row(n), column(n))
    call equilibrate (a, nap, map, n, n, row, column)
    do j = 1, m
      do i = 1, n
        b(i,j) = row(i) * b(i,j)
      end do
    end do      
    call LU1 (a, nap, map, b, nbp, mbp, n, m, itmax)
    do j = 1, m
      do i = 1, n
        b(i,j) = column(i) * b(i,j)
      end do
    end do      
    deallocate (row, column)
  else if (TypeMatrSolv(1:4) == 'BICG') then                
  call BICGSTAB (TypePrecond, NPrecOrder, itmax, epsilon, n, m, a, nap, map,      &
       b, nbp, mbp)                                                                   
  end if      
end subroutine LU_SYSTEM_DIRECT
! ***********************************************************************************
subroutine readinputMatrSolv ( TypeMatrSolv, itmax, TypePrecond, NPrecOrder, epsilon ) 
  use parameters
  implicit none                     
  integer       :: ios, itmax, NPrecOrder  
  real(O)       :: epsilon
  character(20) :: TypeMatrSolv, TypePrecond
  character(80) :: string
  logical       :: XFindPar
!
  open (unit = iInput, file = FileInput, status = "old", position = "rewind")  
  TypeMatrSolv = 'LU1' 
  itmax        = 10
  TypePrecond  = 'NEUMANN'
  NPrecOrder   = 6
  epsilon      = 1.e-6_O
  string       = 'MatrixSolver'
  if (XFindPar (iInput, string)) then
    read (iInput, *, iostat = ios) TypeMatrSolv
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable TypeMatrSolv;')"
      stop
    end if
    read (iInput, *, iostat = ios) itmax
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable itmax;')"
      stop
    end if
    read (iInput, *, iostat = ios) TypePrecond
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable TypePrecond;')"
      stop
    end if
    read (iInput, *, iostat = ios) NPrecOrder
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable NPrecOrder;')"
      stop
    end if 
    read (iInput, *, iostat = ios) epsilon
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsilon;')"
      stop
    end if
  else
    print "(/,2x,'Group name MatrixSolver not found;')"
    stop  
  end if  
  call check_MatrixSolver (TypeMatrSolv)
  close (unit = iInput)  
end subroutine readinputMatrSolv  
! ************************************************************************************
! *               LU DECOMPOSITION - F90-VERSION FROM NUMERICAL RECIPES              *
! ************************************************************************************
subroutine LUDCMP (a, np, mp, n, indx, d)
  use parameters
  use derived_parameters
  implicit none
  integer    :: n, np, mp, indx(n)
  real(O)    :: d
  complex(O) :: a(np,mp)
!      
  integer    :: imax, i, j, k 
  real(O)    :: aamax, tampon 
  complex(O) :: sum, dum
  complex(O),allocatable :: vv(:)
!               
  allocate (vv(n))
  d = 1._O
  do i = 1, n
    aamax = 0._O
    do j = 1, n
      if (abs(a(i,j)) > aamax) aamax = abs(a(i,j))
    end do 
    if (aamax < SmallestPosNumber) then       
      print "(/,2x,'Error in subroutine LUDCMP in module MatrixSolv: singularity,')" 
      print "(  2x,'the matrix inversion can not be performed with the LU ')" 
      print "(  2x,'algorithm from Numerical Recipes;')"      
      stop
    end if 
    tampon = 1._O / aamax
    vv(i)  = cmplx(tampon,0.0,O)
  end do 
  do j = 1, n
    do i = 1, j - 1 
      sum = a(i,j)    
      do k = 1, i - 1
        sum = sum - a(i,k) * a(k,j)
      end do      
      a(i,j) = sum
    end do 
    aamax = 0._O
    do i = j, n 
      sum = a(i,j)     
      do k = 1, j - 1
        sum = sum - a(i,k) * a(k,j)
      end do      
      a(i,j) = sum
      dum    = vv(i) * abs(sum)
      if (abs(dum) >= aamax) then
        imax  = i
        aamax = abs(dum)
      end if
    end do 
    if (j /= imax) then
      do k = 1, n
        dum       = a(imax,k)
        a(imax,k) = a(j,k)
        a(j,k)    = dum
      end do 
      d = - d
      vv(imax) = vv(j)
    end if
    indx(j) = imax
    if (abs(a(j,j)) < SmallestPosNumber) a(j,j) = cmplx(ZeroLUVal,ZeroLUVal,O)
    if (j /= n) then
      dum = 1._O / a(j,j)
      do  i = j + 1, n
        a(i,j) = a(i,j) * dum
      end do 
    end if
  end do 
  deallocate (vv)      
end subroutine LUDCMP
! **********************************************************************************
subroutine LUBKSB (a, np, mp, n, indx, b)
  use parameters
  implicit none
  integer    :: n, np, mp, indx(n)
  complex(O) :: a(np,mp), b(n)
!      
  integer    :: i, j, ii, ll 
  complex(O) :: sum
!
  ii = 0
  do i = 1, n
    ll    = indx(i)
    sum   = b(ll)
    b(ll) = b(i)
    if (ii /= 0) then     
      do j = ii, i - 1
        sum = sum - a(i,j) * b(j)
      end do           
    else if (abs(sum) /= 0._O) then
      ii = i
    end if
    b(i) = sum
  end  do 
  do i = n, 1, -1
    sum = b(i)
    if (i < n) then
      do j = i + 1, n
        sum = sum - a(i,j) * b(j)
      end do          
    end if
    b(i) = sum / a(i,i)
  end do         
end subroutine LUBKSB
! **********************************************************************************
subroutine LU (a, np, mp, b, n)
  use parameters
  implicit none
  integer    :: n, np, mp
  complex(O) :: a(np,mp), b(n)
!
  real(O)    :: d
  integer,allocatable :: indx(:)
!
  allocate (indx(n))
  call LUDCMP (a, np, mp, n, indx, d)
  call LUBKSB (a, np, mp, n, indx, b)
  deallocate (indx)      
end subroutine LU
! ***********************************************************************************
subroutine equilibrate (a, np, mp, n, m, r, c)
! ----------------------------------------------------------------------------------
! This subroutine computes row and column scalings intended to equilibrate         !
! a matrix a and reduce its condition number. The equilibrated matrix anew is      !
!                   anew = r * a * c,                                              !
! where r and c are real diagonal matrices. Therefore                              !
!                   a = r^(-1) * anew * c^(-1).                                    !
! ----------------------------------------------------------------------------------        
  use parameters
  use derived_parameters
  implicit none
  integer    :: np, mp, n, m
  real(O)    :: r(m), c(n)
  complex(O) :: a(np,mp)
!
  integer    :: i, j
  real(O)    :: smlnum, bignum, norm, rcmin, rcmax, amax, rowcnd, colcnd, cj, tresh   
!
  smlnum = sqrt(SmallestPosNumber)
  bignum = 1._O / smlnum
  tresh  = 1.e-2_O
  do i = 1, m
    r(i) = 0._O
  end do
  do j = 1, n 
    do i = 1, m
      norm = abs(real(a(i,j),O)) + abs(aimag(a(i,j)))
      r(i) = max(r(i), norm)
    end do
  end do    
  rcmin = bignum 
  rcmax = 0._O 
  do i = 1, m
    rcmax = max(rcmax, r(i))
    rcmin = min(rcmin, r(i))
  end do
  amax  = rcmax
  if (rcmin == 0._O) then
    do i = 1, m
      if (r(i) == 0._O) then
        print "(/,2x,'Error in subroutine equilibrate in module MatrixSolv:')" 
        print "(  2x,'the row ',i5,' of the matrix is exactly zero;')", i             
        stop
      end if
    end do   
  else
    do i = 1, m
      r(i) = 1._O / min(max(r(i), smlnum), bignum)
    end do
    rowcnd = max(rcmin, smlnum) / min(rcmax, bignum)
  end if
!
  do j = 1, n
    c(j) = 0._O
  end do
  do j = 1, n
    do i = 1, m
      norm = abs(real(a(i,j),O)) + abs(aimag(a(i,j)))
      c(j) = max(c(j), norm * r(i))
    end do
  end do
  rcmin = bignum 
  rcmax = 0._O 
  do j = 1, n
    rcmax = max(rcmax, c(j))
    rcmin = min(rcmin, c(j))
  end do
  if (rcmin == 0._O) then
    do j = 1, n
      if (c(j) == 0._O) then
        print "(/,2x,'Error in subroutine equilibrate in module MatrixSolv:')" 
        print "(  2x,'the column ',i5,' of the matrix is exactly zero;')", j                  
        stop        
      end if
    end do   
  else
    do j = 1, n
      c(j) = 1._O / min(max(c(j), smlnum), bignum)
    end do
    colcnd = max(rcmin, smlnum) / min(rcmax, bignum)
  end if    
!
  if (rowcnd >= tresh .and. amax >= smlnum .and. amax <= bignum) then
   if (colcnd >= tresh) then
     do i = 1, m
       r(i) = 1._O
     end do
     do j = 1, n
       c(j) = 1._O
     end do      
   else    
     do j = 1, n
       cj = c(j)
       do i = 1, m
         a(i,j) = a(i,j) * cj
       end do
     end do
     do i = 1, m
       r(i) = 1._O
     end do         
   end if   
 else if (colcnd >= tresh) then  
   do j = 1, n
     do i = 1, m
       a(i,j) = r(i) * a(i,j)
     end do
   end do
   do j = 1, n
     c(j) = 1._O
   end do   
 else   
   do j = 1, n
     cj = c(j)
     do i = 1, m
       a(i,j)= r(i) * a(i,j) * cj
     end do
   end do   
 end if 
end subroutine equilibrate    
! ***********************************************************************************
! *            LU DECOMPOSITION - SIMPLIFIED VERSIONS FROM LAPACK LIBRARY           *
! ***********************************************************************************
subroutine LUDCMP1 (a, nap, map, n, ipiv)
  use parameters
  use derived_parameters
  implicit none
  integer    :: n, nap, map, ipiv(n)
  complex(O) :: a(nap,map)
!
  integer    :: j, nt, imax, jp, i, k, l
  real(O)    :: amax
  complex(O) :: temp    
!       
  do j = 1, n
    nt   = n - j + 1
    imax = 1
    if (nt > 1) then
      amax = abs(a(j,j))
      do i = 2, nt                      
        if (abs(a(j+i-1,j)) > amax) then
          imax = i
          amax = abs(a(j+i-1,j))
        end if  
      end do
    end if
    nt = n - j              
    jp = j - 1 + imax
    ipiv(j) = jp
    if (abs(a(jp,j)) > SmallestPosNumber) then
      if (jp /= j) then
        do i = 1, n
          temp    = a(j,i)
          a(j,i)  = a(jp,i)
          a(jp,i) = temp
        end do
      end if
      if (j < n) then
        temp = one / a(j,j)
        do i = 1,nt
          a(j+i,j) = temp * a(j+i,j)
        end do
      end if
    else          
      print "(/,2x,'Error in subroutine LUDCMP1 in module MatrixSolv: singularity,')" 
      print "(  2x,'the matrix inversion can not be performed with the LU ')" 
      print "(  2x,'algorithm from Lapack library;')"         
      stop                  
    end if                       
    if (j < n) then
      do k = 1, nt
        if (a(j,j+k) /= zero) then
          temp = - one * a(j,j+k)
          do l = 1, nt
            a(j+l,j+k) = a(j+l,j+k) + a(j+l,j) * temp
          end do
        end if
      end do 
    end if
  end do
end subroutine LUDCMP1
! **********************************************************************************
subroutine LUBKSB1 (a, nap, map, n, m, ipiv, b, nbp, mbp)
  use parameters
  implicit none
  integer    :: n, m, nap, map, nbp, mbp, ipiv(n)
  complex(O) :: a(nap,map), b(nbp,mbp)
!
  integer    :: i, ip, k, j
  complex(O) :: temp    
!            
  do i = 1, n
    ip = ipiv(i)
    if (ip /= i) then
      do k = 1, m
        temp    = b(i,k)
        b(i,k)  = b(ip,k)
        b(ip,k) = temp
      end do
    end if
  end do                
  do j = 1, m
    do k = 1, n
      if (b(k,j) /= zero) then
        do i = k + 1, n
          b(i,j) = b(i,j) - b(k,j) * a(i,k)
        end do
      end if
    end do
  end do        
  do j = 1, m
    do k = n, 1, - 1
      if (b(k,j) /= zero ) then
        b(k,j) = b(k,j) / a(k,k)
        do i = 1, k - 1
          b(i,j) = b(i,j) - b(k,j) * a(i,k)
        end do
      end if
    end do
  end do      
end subroutine LUBKSB1 
! **********************************************************************************
subroutine LU1 (a, nap, map, b, nbp, mbp, n, m, itmax)
  use parameters
  use derived_parameters
  implicit none
  integer    :: n, m, nap, map, nbp, mbp, itmax
  complex(O) :: a(nap,map), b(nbp,mbp)
!
  integer    :: i, j, k, nz, count
  real(O)    :: eps, safemin, safe1, safe2, lstres, s, absb, absx, absa, absw
  complex(O) :: sum
  logical    :: more
  integer,allocatable    :: ipiv(:)
  real(O),allocatable    :: rwork(:), berr(:) 
  complex(O),allocatable :: af(:,:), x(:,:), work(:,:)  
!
  allocate (ipiv(nap), af(nap,map), x(nbp,mbp), work(nbp,1), rwork(nap), berr(mbp))
  do i = 1, n
    do j = 1, n
      af(i,j) = a(i,j)
    end do
    do j = 1, m
      x(i,j) = b(i,j)
    end do
  end do
  call LUDCMP1 (af, nap, map, n, ipiv)
  call LUBKSB1 (af, nap, map, n, m, ipiv, x, nbp, mbp)
!
  nz  = n + 1
  eps = MachEps
  safemin = SmallestPosNumber
  safe1   = nz * safemin
  safe2   = safe1 / eps 
  do j = 1, m
    count  = 1
    lstres = 3._O
    more   = .true.
    do while (more)
      do i = 1, n
        work(i,1) = b(i,j)
      end do
      do i = 1, n
        sum = zero
        do k = 1, n
          sum = sum + a(i,k) * x(k,j)
        end do
        work(i,1) = work(i,1) - sum
      end do
      do i = 1, n
        absb = abs(real(b(i,j))) + abs(aimag(b(i,j)))
        rwork(i) = absb
      end do
      do k = 1, n
        absx = abs(real(x(k,j))) + abs(aimag(x(k,j)))
        do i = 1, n
          absa = abs(real(a(i,k))) + abs(aimag(a(i,k)))
          rwork(i) = rwork(i) + absa * absx
        end do
      end do
      s = 0._O
      do i = 1, n
        absw = abs(real(work(i,1))) + abs(aimag(work(i,1)))          
        if (rwork(i) > safe2 ) then
          s = max(s,absw / rwork(i))
        else                                      
          s = max(s,(absw + safe1) / (rwork(i) + safe1))
        end if
      end do
      berr(j) = s
      more = .false.
      if (berr(j) > eps .and. 2._O * berr(j) <= lstres .and. count <= itmax) then
        more = .true.
        call LUBKSB1 (af, nap, map, n, 1, ipiv, work, nbp, 1)                                   
        do i = 1, n
          x(i,j) = x(i,j) + work(i,1)
        end do
        lstres = berr(j)
        count  = count + 1        
      end if
    end do                                              
  end do              
  do i = 1, n
    do j = 1, m
      b(i,j) = x(i,j)
    end do
  end do
  deallocate (ipiv, af, x, work, rwork, berr)      
end subroutine LU1
! ***********************************************************************************
! *                                BICG Method                                      *
! ***********************************************************************************
subroutine BICGSTAB (TypePrecond, NPrecOrder, Niter, eps, n, m, a, nap, map,         &
           b, nbp, mbp)
  use parameters
  implicit none
  integer       :: NPrecOrder, Niter, n, m, nap, map, nbp, mbp
  real (O)      :: eps 
  complex(O)    :: a(nap,map), b(nbp,mbp)
  character(20) :: TypePrecond
  
  integer       :: i, j, k
  real(O)       :: error, normvct, normy, invnormy, normt, normt2
  complex(O)    :: alpha, beta, ro, roold, omega, cdot, vr0, minus_one, beta_omega,  &
                   roold_omega
  logical       :: more
  complex(O),allocatable :: r(:), r0(:), p(:), v(:), s(:), t(:), x(:), y(:),         &
                            q1(:), q2(:), pold(:), xold(:), dx(:), pm(:,:), pm0(:)
!
  minus_one = - one  
  allocate (r(n), r0(n), p(n), v(n), s(n), t(n), q1(n), q2(n), pold(n), xold(n), dx(n))
  allocate (x(n), y(n)) 
  if (TypePrecond(1:7) == 'NEUMANN' .or. TypePrecond(1:4) == 'SILU') then 
    allocate (pm(n,n)) 
    call Precond (TypePrecond, NPrecOrder, a, nap, map, pm, n, n, n) 
  else
    allocate (pm0(n))
    do i = 1, n
      pm0(i) = one / a(i,i)
    end do
  end if
  do j = 1, m
    do i = 1, n
      y(i) = b(i,j)
    end do
    normy = normvct (n, y)
    if (normy == 0._O) then
      do i = 1, n
        x(i) = zero
      end do
      go to 1
    end if
    invnormy = 1._O / normy
    call copy_vector (y, xold, n) 
    call product_matrix_vector3 (n, n, a, nap, map, xold, y, minus_one, one, r0) 
    if (normvct (n, r0) == 0._O) then
      call copy_vector (xold, x, n)
      go to 1
    end if
    call copy_vector (r0, r, n)
    more = .true.
    k    = 0
    do while (more) 
      k  = k + 1
      ro = cdot (n, r, r0)      
      if (abs(ro) == 0._O) then   
        call copy_vector (r0, r, n)   
        ro = cdot (n, r, r0)      
      end if  
      if (k == 1) then
        call copy_vector (r, p, n)  
      else
        roold_omega = roold * omega
        beta = ro * alpha / roold_omega      
        beta_omega  = - beta * omega        
        do i = 1, n
          p(i) = r(i) + beta * pold(i) + beta_omega * v(i)
        end do
      end if
      if (TypePrecond(1:7) == 'NEUMANN') then
        call product_matrix_vector  (n, n, pm, n, n, p, q1)  
      else if (TypePrecond(1:4) == 'SILU') then  
        call MatSolve (n, a, nap, map, pm, n, n, p, q1)
      else          
        do i = 1, n
          q1(i) = p(i) * pm0(i)
        end do
      end if 
      call product_matrix_vector (n, n, a, nap, map, q1, v)
      vr0 = cdot (n, v, r0)
      if (abs(vr0) /= 0._O) then
        alpha = ro / vr0
      else
        print "(/,2x,'Error in subroutine BICGSTAB: singularity,')" 
        print "(  2x,'BICG algorithm can not be used for matrix inversion;')"   
        stop 
      end if                 
      do i = 1, n
        s(i) = r(i) - alpha * v(i)
      end do
      error = normvct (n,s) * invnormy 
      if (error < eps) then             
        do i = 1, n
          x(i) = xold(i) + alpha * q1(i)
        end do
        more = .false.
      else
        if (TypePrecond(1:7) == 'NEUMANN') then
          call product_matrix_vector  (n, n, pm, n, n, s, q2)  
        else if (TypePrecond(1:4) == 'SILU') then  
          call MatSolve (n, a, nap, map, pm, n, n, s, q2)
        else           
          do i = 1, n
            q2(i) = s(i) * pm0(i)
          end do
        end if
        call product_matrix_vector (n, n, a, nap, map, q2, t)
        normt = normvct (n,t)
        if (normt /= 0._O) then
          normt2 = normt * normt
          omega  = cdot (n, s, t) / normt2
        else
          print "(/,2x,'Error in subroutine BICGSTAB: singularity,')"   
          print "(  2x,'BICG algorithm can not be used for matrix inversion;')" 
          stop 
        end if               
        do i = 1, n
          x(i) = xold(i) + alpha * q1(i) + omega * q2(i)
        end do                      
        do i = 1, n
          r(i) = s(i) - omega * t(i)
        end do         
        do i = 1, n
          dx(i) = x(i) - xold(i)
        end do   
        error = normvct (n, dx) * invnormy      
        if (error < eps .or. k == Niter) then
          more = .false.          
        else
          call copy_vector (x, xold, n)  
          call copy_vector (p, pold, n)  
          roold = ro
          if (abs(roold) == 0._O .or. abs(omega) == 0._O) then
            print "(/,2x,'Error in subroutine BICGSTAB: singularity,')"
            print "(  2x,'BICG algorithm can not be used for matrix inversion;')"    
            stop  
          end if
        end if
      end if  
    end do    
    if (k == Niter .and. error > eps) then
      print "(/,2x, a)",                                                             &
     'Error in subroutine BICGSTAB:  convergence is not achieved because'
      print "(  2x, a)",                                                             &
     'the tolerance TolConv or the iteration number NmaxIter are too low;'
      stop
    end if
1   continue
    do i = 1, n
      b(i,j) = x(i)
    end do             
  end do
  deallocate (r, r0, p, v, s, t, q1, q2, pold, xold, dx, x, y)
  if (TypePrecond(1:7) == 'NEUMANN' .or. TypePrecond(1:4) == 'SILU') then 
    deallocate (pm) 
  else
    deallocate (pm0)
  end if
end subroutine BICGSTAB    
!************************************************************************************
subroutine Precond (TypePrecond, Norder, a, nap, map, p, npp, mpp, n)
  use parameters
  implicit none
  integer       :: Norder, n, nap, map, npp, mpp
  complex(O)    :: a(nap,map), p(npp,mpp)
  character(20) :: TypePrecond
!  
  integer       :: iorder, i, j, k, imax   
  real(O)       :: maxl, absa
  complex(O)    :: sum, Yik, IP  
  complex(O),allocatable :: c(:), d(:)
!  
  call identity_matrix (n, p, npp, mpp)
  if (TypePrecond(1:7) == 'NEUMANN') then    
    allocate (c(n), d(n))  
    do j = 1, n
      maxl = 0._O
      do i = 1, n
        absa = abs(a(i,j))
        if (absa > maxl) then
          maxl = absa
          imax = i
        end if
      end do      
      if (abs(a(imax,j)) /= 0._O) then
        d(j) = one / a(imax,j) / real(n * n,O)    
      else           
        print "(/,2x,'Error in subroutine Precond: singularity,')" 
        print "(  2x,'Neumann preconditioning can not be used;')"   
        stop
      end if    
    end do                       
    do iorder = 1, Norder
      do j = 1, n
        do i = 1, n
          sum = zero
          do k = 1, n
            if (k == i) then
              Yik = one - a(i,k) * d(k)
            else
              Yik = - a(i,k) * d(k) 
            end if           
            sum = sum + Yik * p(k,j)
          end do
          c(i) = sum
        end do
        do i = 1, n
          p(i,j) = c(i)
          if (i == j) p(i,j) = p(i,j) + one
        end do        
      end do
    end do  
    do i = 1, n
      do j = 1, n
        p(i,j) = p(i,j) * d(i)
      end do
    end do    
    deallocate (c, d)   
  else if (TypePrecond(1:4) == 'SILU') then 
    do i = 1, n
      sum = zero
      do j = 1, i - 1
        sum = sum + a(i,j) * P(j,j) * a(j,i)
      end do
      IP = a(i,i) - sum
      if (abs(IP) /= 0._O) then
        P(i,i) = one / IP
      else
        print "(/,2x,'Error in subroutine Precond: singularity,')"
        print "(  2x,'SILU preconditioning can not be used;')"    
        stop
      end if    
    end do                   
  end if    
end subroutine Precond     
!************************************************************************************
subroutine MatSolve (n, a, nap, map, p, npp, mpp, y, x)
  use parameters
  implicit none
  integer     :: n, nap, map, npp, mpp  
  complex(O)  :: a(nap,map), p(npp,mpp), y(n), x(n)
!  
  integer     :: i, j
  complex(O)  :: sum 
  complex(O),allocatable :: z(:)
!  
  allocate (z(n))
  z(1) = y(1) * p(1,1)
  do i = 2, n
    sum = zero
    do j = 1, i - 1
      sum = sum + a(i,j) * z(j)
    end do
    z(i) = ( y(i) - sum ) * p(i,i)
  end do  
  x(n) = z(n)
  do i = n - 1, 1, -1
    sum = zero
    do j = i + 1, n
      sum = sum + a(i,j) * x(j)
    end do
    x(i) = z(i) - sum * p(i,i)
  end do
  deallocate (z)
end subroutine MatSolve




 

module parameters
  implicit none
  integer,parameter       :: O = kind(1.d0)
!
  real(O),parameter       :: Pi    = 3.1415926535897932384626433832795028841971_O
  complex(O),parameter    :: im    = (0._O,1._O),                                        &
                             one   = (1._O,0._O),                                        &
                             zero  = (0._O,0._O)
!
  integer,parameter       :: NsurfPD =     10,                                           &
                             NrankPD =    200,                                           &
                             NfacePD =  10000,                                           &
                             NparPD  =     10,                                           &
                             NphiMax =    361
!
  integer,parameter       :: iTmat        =  8,                                          &
                             iTmatInfo    =  9,                                          &
                             iDSCS        = 10,                                          &
                             iSCAT        = 11,                                          &
                             iSS          = 12,                                          & 			                               
                             iFEM         = 13
!
  integer,parameter       :: iamat = 14,                                                 &
                             ibmat = 15,                                                 &
                             icmat = 16,                                                 &
                             idmat = 17,                                                 &
                             iemat = 18,                                                 &
                             ifmat = 19
!
  integer,parameter       :: iOutput           = 20,                                     &
                             iInput            = 21,                                     &
                             iInputAXSYM       = 22,                                     &
                             iInputNONAXSYM    = 23,                                     &
                             iInputNONAXSYMFEM = 24,                                     &
                             iInputCOMP        = 25,                                     &
                             iInputLAY         = 26,                                     &
!
                             iInputINHOM       = 27,                                     &
                             iInputINHOM2SPH   = 28,                                     &
                             iInputINHOMSPH    = 29,                                     &
                             iInputINHOMSPHREC = 30,                                     &
!
                             iInputMULT        = 31,                                     &
                             iInputMULT2SPH    = 32,                                     &
                             iInputMULTSPH     = 33,                                     &
                             iInputMULTSPHREC  = 34,                                     &
!
                             iInputSPHERE      = 35,                                     &
                             iInputPARTSUB     = 36,                                     &
                             iInputANIS        = 37,                                     &
                             iInputEFMED       = 38,                                     &
!
                             iInputSCT         = 39,                                     &
                             iInputSCTAVRGSPH  = 40
!
  character(80),parameter ::                                                             &
                FileOutput           = "../OUTPUTFILES/Output.dat",                      &
                FileInput            = "../INPUTFILES/Input.dat",                        &
                FileInputAXSYM       = "../INPUTFILES/InputAXSYM.dat",                   &
                FileInputNONAXSYM    = "../INPUTFILES/InputNONAXSYM.dat",                &
                FileInputNONAXSYMFEM = "../INPUTFILES/InputNONAXSYMFEM.dat",             &
                FileInputCOMP        = "../INPUTFILES/InputCOMP.dat",                    &
                FileInputLAY         = "../INPUTFILES/InputLAY.dat",                     &
!
                FileInputINHOM       = "../INPUTFILES/InputINHOM.dat",                   &
                FileInputINHOM2SPH   = "../INPUTFILES/InputINHOM2SPH.dat",               & 
                FileInputINHOMSPH    = "../INPUTFILES/InputINHOMSPH.dat" ,               &
                FileInputINHOMSPHREC = "../INPUTFILES/InputINHOMSPHREC.dat",             &
!               			
                FileInputMULT        = "../INPUTFILES/InputMULT.dat",                    &
                FileInputMULT2SPH    = "../INPUTFILES/InputMULT2SPH.dat" ,               &
                FileInputMULTSPH     = "../INPUTFILES/InputMULTSPH.dat",                 &
                FileInputMULTSPHREC  = "../INPUTFILES/InputMULTSPHREC.dat",              &
!               									
                FileInputSPHERE      = "../INPUTFILES/InputSPHERE.dat",                  &
                FileInputPARTSUB     = "../INPUTFILES/InputPARTSUB.dat",                 &
                FileInputANIS        = "../INPUTFILES/InputANIS.dat",                    &
                FileInputEFMED       = "../INPUTFILES/InputEFMED.dat",                   &
!
                FileInputSCT         = "../INPUTFILES/InputSCT.dat",                     &
                FileInputSCTAVRGSPH  = "../INPUTFILES/InputSCTAVRGSPH.dat"
!
  character(15),parameter :: PathOUTPUT = "../OUTPUTFILES/",                             &
                             PathTEMP   = "../TEMPFILES/",                               &
                             PathGEOM   = "../GEOMFILES/"                       
end module parameters
! **************************************************************************************
module derived_parameters
  use parameters
  implicit none
!  
  integer,save :: NBaseDig
  integer,save :: NIterBes
  integer,save :: NIterPol
  real(O),save :: LargestPosNumber
  real(O),save :: SmallestPosNumber
  real(O),save :: MachEps           
  real(O),save :: ZeroCoord
  real(O),save :: TolJ0Val 
  real(O),save :: TolRootPol
  real(O),save :: InitBesVal
  real(O),save :: FactNBes
  real(O),save :: LargestBesVal
  real(O),save :: MaxArgBes
  real(O),save :: UpperBoundSeq 
  real(O),save :: LowerBoundSeq   
  real(O),save :: ZeroSinXX  
  real(O),save :: ZeroLUVal 
  real(O),save :: LargestSplineVal  
end module derived_parameters
                      

subroutine TMULT
!------------------------------------------------------------------------------------
! 1. General Considerations                                                         !
! --------------------------                                                        !
! TMULT is a routine for computing the T matrix and the scattering characteristics  !
! of clusters of arbitrarily shaped particles. As for inhomogeneous scatterers, the !
! individual T matrices of the particles are input parameters of the code (the      !
! names of the files containing the T matrices are supplied in the input file), and !
! they may correspond to homogeneous, axisymmetric or nonaxisymmetric particles and !
! inhomogeneous, composite or layered particles. The refractive indices of          !
! the ambient medium in the present T-matrix program and the programs computing     !
! individual T matrices must coincide. Note that the T matrix of a spherical        !
! particle must be computed with the routine TAXSYM and not with the program        !
! TSPHERE (because the T matrix of the particle must be specified as a              !
! two-dimensional array and the routine TSPHERE provides an one-dimensional array). ! 
!                                                                                   !
! The T matrix of a system of two particles 1 and 2 can be expressed in terms of    !
! the T matrices of each particle as                                                !
!                                                                                   !
!            T =  TR1(O,O1) * T1 * [I - TR3(O1,O2) * T2 * TR3(O2,O1) * T1 ]^(-1)    !
!               * [TR3(O1,O2) * T2 * TR1(O2,O) + TR1(O1,O) ]                        !
!               + TR1(O,O2) * T3 * [I - TR3(O2,O1) * T1 * TR3(O1,O2) * T2 ]^(-1)    ! 
!               * [TR3(O2,O1) * T1 * TR1(O1,O) + TR1(O2,O) ],                       !
!                                                                                   !
! where O is the origin of the cluster, O1 and O2 are the origins of the particles  !
! 1 and 2, respectively, T1 and T2 are the individual transition matrices, and      !
! TR(O1,O2) is the matrix transforming the vector spherical wave functions from     !
! the origin O1 to the origin O2 (through rotations and translations).              !
!                                                                                   !
! 2. Convergence Test                                                               !
! --------------------                                                              !
! In the code, the maximum expansion and azimuthal orders Nrank and Mrank of the    !
! cluster are independent on the maxium expansion and azimuthal orders              !
! NrankPart(i) and MrankPart(i), i = 1,...,Npart, of all particles forming the      !
! cluster. The convergence tests are carried out over Nrank and Mrank, while        !
! NrankPart(i) and MrankPart(i), i = 1,...,Npart, are kept constant.                !
!                                                                                   !
! For convergence tests, the incident wave is assumed to be a plane wave traveling  !
! along the Z-axis of the global coordinate system and the scattering               !
! characteristics are computed in the azimuthal plane  phi = 0°. The Euler          !
! orientation angles of the cluster are alphaC = betaC = 45° and gammaC = 0°, and   !
! interactive convergence tests over Nrank and Mrank are performed.                 !
!                                                                                   !  
! For the convergence test over the expansion order, the scattering problem is      !
! solved for the pairs (Nrank, Mrank) and (Nrank - 1, Mrank), while for the         !
! azimuthal order test, the cases (Nrank, Mrank) and (Nrank, Mrank - 1) are         !
! considered. The normalized differential scattering cross section will be checked  !
! at 20° increments for convergence within epsX (epsNint,epsNrank or epsMrank)      !
! tolerance. If the calculated results are converged within this tolerance at       !
! 80% of the scattering angles, then convergence is achieved. The T matrix is       !
! stored for later use by other programs, and the values of Nrank and Mrank are     !
! printed to the screen and to the T-matrix information file (see                   !
! "Description.txt"). These values together with the T matrix serve as INPUT        !
! PARAMETERS for other programs.                                                    !
!                                                                                   !
! An estimate of Nrank is given by Wiscombe's truncation limit criterion            !
! [W. J. Wiscombe, Improved Mie scattering algorithms, Applied Optics, 19,          !
! 1505-1509, 1980], i.e.,                                                           !
!                                                                                   !
!                NrankW = int(x + 4.05 * x**0.33 + 2),                              !
!                                                                                   !
! where x is the size parameter, x = k * Rcirc, k is the wave number and Rcirc is   !
! the radius of the smallest sphere enclosing the cluster. For the maximum azimuthal! 
! order test, we may use the conservative estimate Mrank = Nrank - 2,..,Nrank.      !  
!                                                                                   ! 
! The convergence tests can be switched off by setting the logical variable         !
! DoConvTest to false. In this case, the values of Nrank and Mrank must be          !
! specified in the input file.                                                      !
!                                                                                   !
! 3. Input Parameters                                                               !
! --------------------                                                              !
! The parameters specified in the input file "/INPUTFILES/InputMULT.dat" are listed !
! below.                                                                            !
!                                                                                   !
! - wavelength (real) - wavelength of the incident light in vacuo.                  !
!                                                                                   !
! - ind_refMed (real) - refractive index of the ambient medium (nonabsorbing        !
!   dielectric medium).                                                             !
!                                                                                   !
! - Npart (integer) - number of particles.                                          !
!                                                                                   !
! - anorm (real) - characteristic length of the cluster which is used to normalize  !
!   the differential scattering cross sections.                                     !
!                                                                                   !
! - Rcirc (real) - characteristic length of the cluster (usually the radius of the  !
!   smallest circumscribing sphere) which is used to compute an estimate of the     !
!   maximum expansion order by using Wiscombe's truncation limit criterion (the size!
!   parameter is x = k * Rcirc, where k is the wave number in the ambient medium).  !
!   This parameter must be specified if the interactive convergence tests are       !
!   performed (DoConvTest = t).                                                     ! 
!                                                                                   !
! The next parameters (specified in two group statements) correspond to each        !
! particle. THE GROUP STATEMENTS MUST BE REPEATED FOR ALL Npart PARTICLES.          !
!                                                                                   !  
! - FileTmatPart (character(80)) - name of the file containing the T matrix of      !
!   the actual particle.                                                            !
!                                                                                   !
! - axsymPart (logical) - if axsymPart = t, the actual scatterer is a rotationally  !
!   symmetric particle (axisymmetric particle).                                     !
!                                                                                   !
! - chiralPart (logical) - if chiralPart = t, the actual scatterer is an optical    !
!   active particle (chiral particle).                                              !
!                                                                                   !
! - NrankPart, MrankPart (integer variables) - the maximum expansion and azimuthal  !
!   orders of the actual particle.                                                  !
!                                                                                   !   
! - xPart, yPart, zPart (real variables) - Cartesian coordinates specifying the     !
!   position of the actual particle in the cluster coordinate system.               !
!                                                                                   ! 
! - alphaPart, betaPart, gammaPart (real variables) - Euler angles specifying the   !
!   orientation of the coordinate system of the particle with respect to the        !
!   coordinate system of the cluster.                                               !
!                                                                                   !
! - DoConvTest (logical) - if DoConvTest = t, the interactive convergence tests     !
!   over Nrank and Mrank are performed. An estimates of Nrank is given by           !
!   Wiscombe's truncation limit criterion. If DoConvTest = f, the values of Nrank   !
!   and Mrank must be supplied in the input file.                                   !
!                                                                                   !
! - ExtThetaDom (logical) - if ExtThetaDom = t the DSCS is computed for             !
!   scattering angles ranging from 0 to 180° in the azimuthal plane phiGS = 0° and  !
!   from 180° to 0° in the azimuthal plane phiGS = 180°. The total number of        !
!   scattering angles is 10. If ExtThetaDom = f the DSCS is computed for            !
!   scattering angles ranging from 0° to 180° in the azimuthal plane phiGS = 0°.    !
!                                                                                   !
! - Nrank (integer) - maximum expansion order for the cluster. This parameter is    !
!   used if the convergence tests are not performed (DoConvTest = f).               !
!                                                                                   !
! - Mrank (integer) - maximum azimuthal order for the cluster. This parameter is    !
!   used if the convergence tests are not performed (DoConvTest = f).               !
!                                                                                   !
! - epsNrank (real) - error tolerance for the expansion order test.                 !
!                                                                                   !
! - epsMrank (real) - error tolerance for the azimuthal order test.                 !
!                                                                                   !
! - FileTmat (character(80)) - name of the file to which the T matrix of the        !
!   cluster is written.                                                             !
!                                                                                   !
! - PrnProgress (logical) - if PrnProgress = t, the progress of calculation         !
!   is printed.                                                                     !
!                                                                                   !
! Note that all input parameters specifying lengths must be provided in the same    !
! units of lengths.                                                                 !
!                                                                                   !
! 4. Logical Scheme                                                                 !
! ------------------                                                                !  
! The organization of the code is as follows:                                       !
! 1. < read input data; the input file provides:                                    !
!    - the name of the file containing the T matrix of each particle,               !
!    - the maximum expansion and azimuthal orders NrankPart and MrankPart,          ! 
!    - the Cartesian coordinates specifying the position of each particle, and      !
!    - the Euler angles specifying the orientation of each particle >               !
!                                                                                   !   
! 2. < T-matrix calculation >                                                       !
!                                                                                   !
!    if ( do convergence test ) then                                                !
!                                                                                   !
!      < the code computes an estimate of Nrank accordingly to                      !
!        Wiscombe's truncation criterion >                                          !
!      < the code prompts for the estimated values of Nrank and Mrank >             !
!                                                                                   !
!    else if ( .not. do convergence test ) then                                     !
!                                                                                   !
!       < the input file provides the values of Nrank and Mrank >                   !
!                                                                                   !
!    end if                                                                         !
!    if ( do convergence test ) then                                                !
!       < the code computes the DSCS for (Nrank,Mrank), (Nrank - 1,Mrank) and       ! 
!         (Nrank, Mrank - 1) and write the results to the file "Output.dat" >       !
!       < the T matrix is stored in the file FileTmat and the T-matrix information  !
!         file is created >                                                         !
!       < Mrank and Nrank are written to the screen and to the T-matrix             !
!         information file >                                                        !
!       < go to Step 3 >                                                            !
!    end if                                                                         !
!    if ( .not. do convergence test ) then                                          !
!       < the T matrix is stored in the file FileTmat and the T-matrix information  !
!         file is created >                                                         !
!       < Mrank and Nrank are written to the screen and to the T-matrix             !
!         information file >                                                        !  
!       < go to Step 3 >                                                            !
!    end if                                                                         !
! 3. < scattering characteristics calculation >                                     !    
!------------------------------------------------------------------------------------
  use parameters
  use allocation, only: Mrankp, Nrankp, xp, yp, zp, alphap, betap, gammap,          &
                        FileTmatp, axsymp, chiralp  
  implicit none                                                                         
  integer       :: Npart, Mrank, Nrank                                   
  real(O)       :: k, ind_refMED, wavelength, anorm, snorm, epsNrank, epsMrank, Rcirc
  character(80) :: FileTmat
  logical       :: DoConvTest, ExtThetaDom, PrnProgress  
! -----------------------------------------------------------------------------------
!                               Read the input file                                 ! 
! -----------------------------------------------------------------------------------
  call readinputMULT ( wavelength, ind_refMed, Npart, anorm, Rcirc, DoConvTest,     &
       ExtThetaDom, Nrank, Mrank, epsNrank, epsMrank, FileTmat, PrnProgress,        &
       k, snorm ) 
! -----------------------------------------------------------------------------------
!                                      Main                                         !
! ----------------------------------------------------------------------------------- 
  if (DoConvTest) then            
    open (unit = iOutput,file = FileOutput,status = "replace")
    call printinputMULT (wavelength, ind_refMed, Npart, FileTmatp, axsymp, xp, yp,  &
         zp, alphap, betap, gammap, Mrankp, Nrankp, epsNrank, epsMrank, anorm, Rcirc)
    call convergence_Nrank_MrankMULT (k, snorm, Npart, FileTmatp, axsymp, chiralp,  &
         xp, yp, zp, alphap, betap, gammap, Mrankp, Nrankp, Mrank, Nrank, epsNrank, &
         epsMrank, ExtThetaDom, FileTmat, PrnProgress)
    close (unit = iOutput)
  else
    call TMatrix_Nrank_MrankMULT (k, Npart, FileTmatp, axsymp, chiralp, xp, yp, zp, &
         alphap, betap, gammap, Mrankp, Nrankp, Mrank, Nrank, FileTmat, PrnProgress)
  end if  
  deallocate (FileTmatp, axsymp, chiralp, Mrankp, Nrankp, xp, yp, zp, alphap,       &
              betap, gammap)  
end subroutine TMULT
!***********************************************************************************
subroutine readinputMULT ( wavelength, ind_refMed, Npart, anorm, Rcirc, DoConvTest, &
           ExtThetaDom, Nrank, Mrank, epsNrank, epsMrank, FileTmat, PrnProgress,    &
           k, snorm )    
  use parameters
  use derived_parameters
  use allocation, only: Mrankp, Nrankp, xp, yp, zp, alphap, betap, gammap,          &
                        FileTmatp, axsymp, chiralp
  implicit none                                                                         
  integer       :: Npart, MrankPart, NrankPart, ipart, Mrank, Nrank, NrankW, ios                                    
  real(O)       :: k, ind_refMED, wavelength, anorm, x, snorm, epsNrank, epsMrank,  &
                   xPart, yPart, zPart, alphaPart, betaPart, gammaPart, Rcirc, xR,  &
                   grd		   
  character(80) :: FileTmatPart, FileTmat, string
  logical       :: axsymPart, chiralPart, DoConvTest, ExtThetaDom, PrnProgress,     &
                   XFindPar  
! -----------------------------------------------------------------------------------
!                          Read the input file FileInputMULT                        ! 
! ----------------------------------------------------------------------------------- 
  call DrvParameters 
  open (unit = iInputMULT, file = FileInputMULT, status = "old", position = "rewind")   
  wavelength = 0.1_O * 2._O * Pi                                                                    
  ind_refMed = 1.5_O
  string     = 'OptProp'
  if (XFindPar (iInputMULT, string)) then
    read (iInputMULT, *, iostat = ios) wavelength
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if
    read (iInputMULT, *, iostat = ios) ind_refMed
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refMed;')"
      stop
    end if         
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if  
  k = 2._O * Pi * ind_refMed / wavelength
!    
  Npart  = 2
  anorm  = 1._O  
  Rcirc  = 1._O 
  string = 'GenProp'
  if (XFindPar (iInputMULT, string)) then
    read (iInputMULT, *, iostat = ios) Npart
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Npart')"
      stop
    end if
    read (iInputMULT, *, iostat = ios) anorm
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anorm;')"
      stop
    end if
    read (iInputMULT, *, iostat = ios) Rcirc
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Rcirc;')"
      stop
    end if
  else
    print "(/,2x,'Group name GenProp not found;')"
    stop  
  end if  
  call check_anorm (anorm)  
  x = k * anorm
  snorm = Pi * x * x  
!
  allocate (FileTmatp(Npart), axsymp(Npart), chiralp(Npart), Mrankp(Npart),         &
            Nrankp(Npart), xp(Npart), yp(Npart), zp(Npart), alphap(Npart),          &
            betap(Npart), gammap(Npart))
  grd = Pi / 180._O	    
  do ipart = 1, Npart
    FileTmatPart = '../TMATFILES/T.dat'
    axsymPart  = .true.
    chiralPart = .false.     
    NrankPart  = 6
    MrankPart  = 3
    string     = 'TmatPart'
    if (XFindPar (iInputMULT, string)) then
      read (iInputMULT, *, iostat = ios) FileTmatPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable FileTmatPart')"
        print "(  2x,'for the particle ',i3,';')", ipart
        stop
      end if
      read (iInputMULT, *, iostat = ios) axsymPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable axsymPart;')"
        print "(  2x,'for the particle ',i3,';')", ipart
        stop
      end if
      read (iInputMULT, *, iostat = ios) chiralPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable chiralPart;')"
        print "(  2x,'for the particle ',i3,';')", ipart
        stop
      end if
      read (iInputMULT, *, iostat = ios) NrankPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable NrankPart;')"
        print "(  2x,'for the particle ',i3,';')", ipart 
        stop
      end if
      read (iInputMULT, *, iostat = ios) MrankPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable MrankPart;')"
        print "(  2x,'for the particle ',i3,';')", ipart 
        stop
      end if
    else
      print "(/,2x,'Group name TmatPart not found;')"
      stop  
    end if      
    call check_MrankNrank (MrankPart, NrankPart)    
    FileTmatp(ipart) = FileTmatPart
    axsymp(ipart)  = axsymPart
    chiralp(ipart) = chiralPart     
    Nrankp(ipart)  = NrankPart  
    Mrankp(ipart)  = MrankPart      
!
    xPart = 0.1_O
    yPart = 0.1_O
    zPart = 0.1_O
    alphaPart = 45._O
    betaPart  = 45._O
    gammaPart = 0._O 
    string    = 'GeomPartProp'
    if (XFindPar (iInputMULT, string)) then
      read (iInputMULT, *, iostat = ios) xPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable xPart')"
        print "(  2x,'for the particle ',i3,';')", ipart
        stop
      end if
      read (iInputMULT, *, iostat = ios) yPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable yPart;')"
        print "(  2x,'for the particle ',i3,';')", ipart
        stop
      end if
      read (iInputMULT, *, iostat = ios) zPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable zPart;')"
        print "(  2x,'for the particle ',i3,';')", ipart
        stop
      end if
      read (iInputMULT, *, iostat = ios) alphaPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable alphaPart;')"
        print "(  2x,'for the particle ',i3,';')", ipart 
        stop
      end if
      read (iInputMULT, *, iostat = ios) betaPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable betaPart;')"
        print "(  2x,'for the particle ',i3,';')", ipart 
        stop
      end if
      read (iInputMULT, *, iostat = ios) gammaPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable gammaPart;')"
        print "(  2x,'for the particle ',i3,';')", ipart 
        stop
      end if
    else
      print "(/,2x,'Group name GeomPartProp not found;')"
      stop  
    end if            
    xp(ipart) = xPart
    yp(ipart) = yPart
    zp(ipart) = zPart
    alphap(ipart) = alphaPart * grd
    betap(ipart)  = betaPart  * grd
    gammap(ipart) = gammaPart * grd
  end do
!
  DoConvTest  = .true.
  ExtThetaDom = .true.
  string      = 'ConvTest'
  if (XFindPar (iInputMULT, string)) then
    read (iInputMULT, *, iostat = ios) DoConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DoConvTest')"
      stop
    end if
    read (iInputMULT, *, iostat = ios) ExtThetaDom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ExtThetaDom;')"
      stop
    end if            
  else
    print "(/,2x,'Group name ConvTest not found;')"
    stop  
  end if  
!
  if (DoConvTest) then
    print "(/,2x,'Convergence Test for a Cluster of Particles')"
    print "(  2x,'-------------------------------------------')"
  else
    print "(/,2x,'T-Matrix Computation for a Cluster of Particles')"
    print "(  2x,'-----------------------------------------------')"
  end if
!
  xR = k * Rcirc
  NrankW = int(xR + 4.05_O * xR**0.33_O + 2._O)
  if (.not. DoConvTest) then
    Nrank  =  16
    Mrank  =   8    
    string = 'NrankMrankCluster'
    if (XFindPar (iInputMULT, string)) then
      read (iInputMULT, *, iostat = ios) Nrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nrank')"
        stop
      end if
      read (iInputMULT, *, iostat = ios) Mrank
      if (ios /= 0) then
       print "(/,2x,'Error by reading the input variable Mrank;')"
       stop
      end if            
    else
      print "(/,2x,'Group name NrankMrankCluster not found;')"
      stop  
    end if     
    print "(/,2x,'Input values:')"
    print "(  2x, a, i4, a, i4, a)",                                                &
   'the input values of Nrank and Mrank are ', Nrank, ' and', Mrank, ', while' 
    print "(  2x, a, i3, a)",                                                       &
   'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'                 
  else   
    print "(/,2x,'Nrank estimate:')"                                                    
    print "(  2x, a, i3, a)",                                                       &
   'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'
    print "(/,2x,'- enter the estimated values of Nrank and Mrank, where')"     
    print "(  2x,'  it is recommended to set Mrank = Nrank - 2,...,Nrank;')"        
    call read_integer2 (Nrank, Mrank)           
  end if 
  call check_MrankNrank (Mrank, Nrank)    
!
  epsNrank = 5.e-2_O
  epsMrank = 5.e-2_O
  string   = 'Errors'
  if (XFindPar (iInputMULT, string)) then
    read (iInputMULT, *, iostat = ios) epsNrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNrank;')"
      stop
    end if
    read (iInputMULT, *, iostat = ios) epsMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsMrank;')"
      stop
    end if            
  else
    print "(/,2x,'Group name Errors not found;')"
    stop  
  end if          
!
  FileTmat = '../TMATFILES/TG.dat'
  string   = 'Tmat'
  if (XFindPar (iInputMULT, string)) then
    read (iInputMULT, *, iostat = ios) FileTmat
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileTmat;')"
      stop
    end if             
  else
    print "(/,2x,'Group name Tmat not found;')"
    stop  
  end if 
!
  PrnProgress = .true.
  string      = 'PrintProgress'
  if (XFindPar (iInputMULT, string)) then
    read (iInputMULT, *, iostat = ios) PrnProgress
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if             
  else
    print "(/,2x,'Group name PrintProgress not found;')"
    stop  
  end if        
  close (unit = iInputMULT)
end subroutine readinputMULT
!***********************************************************************************
subroutine printinputMULT (wavelength, ind_refMed, Npart, FileTmatp, axsymp, xp, yp,&
           zp, alfap, betap, gamap, Mrankp, Nrankp, epsNrank, epsMrank, anorm, Rcirc)
  use parameters
  implicit none  
  integer       :: Npart, i, Mrankp(Npart), Nrankp(Npart), LenString
  real(O)       :: wavelength, ind_refMed, xp(Npart), yp(Npart), zp(Npart),         &
                   alfap(Npart), betap(Npart), gamap(Npart), epsNrank, epsMrank,    &
                   anorm, Rcirc
  character(80) :: FileTmatp(Npart), FileTmatWrite              
  logical       :: axsymp(Npart)
!
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x,'wavelength of the free space, wavelength = ',1pe13.4,';')")  &
         wavelength
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'refractive index of the ambient medium, ind_refMed = ', ind_refMed, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'characteristic length of the cluster, anorm = ', anorm, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'radius of the circumscribing sphere, Rcirc = ', Rcirc, ';'
  write (iOutput,*)
  do i = 1, Npart    
    write (iOutput,"(2x,'particle: ',i3)") i
           FileTmatWrite = FileTmatp(i)(14:LenString(FileTmatp(i)))
    write (iOutput,"(2x,'name of the file containing the T matrix = ',a)")          &
           FileTmatWrite 
    if (axsymp(i)) then
      write (iOutput,"(2x,'axisymmetric particle;')")              
    else
      write (iOutput,"(2x,'nonaxisymmetric particle;')")             
    end if
    write (iOutput,"(2x,'maximum expansion order, Nrank = ',i3,';')") Nrankp(i)
    write (iOutput,"(2x,'maximum azimuthal order, Mrank = ',i3,';')") Mrankp(i)
    write (iOutput,"(2x, a, 1pe10.3, a, 1pe10.3, a, 1pe10.3, a)")                   &
   'Cartesian coordinates of the particle: x = ', xp(i), ', y = ', yp(i),           &
   ', z = ', zp(i), ';'          
    write (iOutput,"(2x, a, 1pe10.3, a, 1pe10.3, a, 1pe10.3, a)")                   &
   'Euler angles: alpha = ', alfap(i) * 180._O / Pi, ', beta = ',                   &
    betap(i) * 180._O / Pi, ', gamma = ', gamap(i) * 180._O / Pi, ';'  
    write (iOutput,*)
  end do
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum expansion order tolerance, epsNrank = ', epsNrank, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum azimuthal order tolerance, epsMrank = ', epsMrank, '.'            
  write (iOutput,"(/)")                       
end subroutine printinputMULT
!***********************************************************************************
subroutine convergence_Nrank_MrankMULT (k, snorm, Npart, FileTmatp, axsymp, chiralp,&
           xp, yp, zp, alfap, betap, gamap, Mrankp, Nrankp, Mrank, Nrank, epsNrank, &
           epsMrank, ExtThetaDom, FileTmat, PrnProgress)
  use parameters
  implicit none
  integer       :: Npart, Mrankp(Npart), Nrankp(Npart), Mrank, Nrank                   
  real(O)       :: k, snorm, xp(Npart), yp(Npart), zp(Npart), alfap(Npart),         &
                   betap(Npart), gamap(Npart), epsNrank, epsMrank
  character(80) :: FileTmatp(Npart), FileTmat         
  logical       :: axsymp(Npart), chiralp(Npart), ExtThetaDom, PrnProgress
!      
  integer       :: Nmax, Nmaxmax, NmaxAL, Nteta, ipart, jpart, NthetaConvN,         &
                   NthetaConvM, Nl, Nc, Mrankpl, Nrankpl, Nmaxpl, Mrankpl1,         &
                   Nrankpl1, Nmaxpl1, i, ntpg, mtpg  
  real(O)       :: alfa, beta, gama, alfaPol, x, y, z, tetaGI, phiGI, phiGS,        &
                   alfa1, beta1, gama1, x1, y1, z1, alfaC, betaC, gamaC, Cscat,     &
                   Qscat, Cext, Qext
  integer,allocatable    :: Nmaxp(:)
  real(O),allocatable    :: h(:), v(:), oldh(:), oldv(:), oldh0(:), oldv0(:)
  complex(O),allocatable :: aa(:,:), bb(:,:), a(:,:), b(:,:), t(:,:), c(:), c1(:)   
!
  tetaGI  = 0._O
  phiGI   = 0._O
  phiGS   = 0._O
  Nteta   = 10
  alfaC   = Pi / 4._O
  betaC   = Pi / 4._O
  gamaC   = 0._O
  alfaPol = Pi / 4._O
  Nmax = Nrank + Mrank * (2 * Nrank - Mrank + 1) 
  allocate (Nmaxp(Npart))
  NmaxAL  = Nmax
  Nmaxmax = 0
  do ipart = 1, Npart
    Nmaxp(ipart) = Nrankp(ipart) + Mrankp(ipart) * (2 * Nrankp(ipart) -             &
                   Mrankp(ipart) + 1)
    Nmaxmax      = Nmaxmax + Nmaxp(ipart)
    if (Nmaxp(ipart) > NmaxAL) NmaxAL = Nmaxp(ipart)
    if (Nmaxp(ipart) > Nmax) then
      print "(/,2x, a,i3,  a)",                                                     &
     'Warning: the input values of Nrank and Mrank are too low for particle ',ipart,';'        
    end if
  end do   
  call write_TypeConvHead (4) 
  allocate (aa(2*Nmaxmax,2*Nmaxmax), bb(2*Nmaxmax,2*NmaxAL))        
  allocate (a(2*NmaxAL,2*NmaxAL), b(2*NmaxAL,2*NmaxAL), c(2*NmaxAL), c1(2*NmaxAL))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta), oldh0(Nteta),             &
            oldv0(Nteta))       
  call identity_matrix (2*Nmaxmax, aa, 2*Nmaxmax, 2*Nmaxmax)
  if (PrnProgress) call write_progress (.true., 1, 2*Npart+2)            
  Nl = 0  
  do ipart = 1, Npart
    Mrankpl = Mrankp(ipart)
    Nrankpl = Nrankp(ipart)
    Nmaxpl  = Nmaxp(ipart)
    open (unit = iTmat, file = FileTmatp(ipart), status = "old", position = "rewind")
    if (.not. axsymp(ipart)) then
      call read_HeadFileTmat (ntpg, mtpg)
      call check_dimensionMat (ntpg, mtpg, Nmaxpl)            
      allocate (t(2*ntpg,2*mtpg))
      call read_FileTmat (ntpg, mtpg, t) 
    else
      ntpg = Nmaxpl
      mtpg = Nmaxpl
      allocate (t(2*ntpg,2*mtpg))
      call read_Tmatrix (chiralp(ipart), Nrankpl, Mrankpl, Nmaxpl, t, ntpg, mtpg)         
    end if
    close (unit = iTmat)                                                                                                       
    x = xp(ipart)
    y = yp(ipart)
    z = zp(ipart)
    alfa = alfap(ipart)
    beta = betap(ipart)
    gama = gamap(ipart)
    Nc   = 0      
    do jpart = 1, Npart            
      if (jpart /= ipart) then
        Mrankpl1 = Mrankp(jpart)
        Nrankpl1 = Nrankp(jpart)
        Nmaxpl1  = Nmaxp(jpart)
        x1 = xp(jpart)
        y1 = yp(jpart)
        z1 = zp(jpart)
        alfa1 = alfap(jpart)
        beta1 = betap(jpart)
        gama1 = gamap(jpart)            
        call MatRotTransRot_RTR_mn_m1n1 (3, k, x, y, z, alfa, beta, gama, Mrankpl,  &
             Nrankpl, Nmaxpl, x1, y1, z1, alfa1, beta1, gama1, Mrankpl1, Nrankpl1,  &
             Nmaxpl1, a, NmaxAL, NmaxAL)        
        call product_matrices1 (2*Nmaxpl, 2*Nmaxpl, 2*Nmaxpl1, t, 2*ntpg, 2*mtpg,   &
             a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)                      
        call extend_matrix1 (ipart, jpart, Npart, Nmaxp, Nl, Nc, b, NmaxAL, NmaxAL, &
             aa, Nmaxmax, Nmaxmax)                                                      
      end if
      Nc = Nc + 2 * Nmaxp(jpart)      
    end do                 
    call MatRotTrans_RT_mn_m1n1 (1, k, x, y, z, alfa, beta, gama, Mrankpl, Nrankpl, &
         Nmaxpl, Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)
    call product_matrices1 (2*Nmaxpl, 2*Nmaxpl, 2*Nmax, t, 2*ntpg, 2*mtpg,          &
         a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)              
    call extend_matrix2 (ipart, Npart, Nmaxp, Nmax, Nmaxmax, Nl, b, NmaxAL, NmaxAL, &
         bb, Nmaxmax, NmaxAL)            
    Nl = Nl + 2 * Nmaxp(ipart)
    if (PrnProgress) call write_progress (.false., ipart+1, 2*Npart+2)
    deallocate (t)
  end do
  call LU_SYSTEM_DIRECT (aa, 2*Nmaxmax, 2*Nmaxmax, bb, 2*Nmaxmax, 2*NmaxAL,         &
       2*Nmaxmax, 2*Nmax)
  if (PrnProgress) call write_progress (.false., Npart+2, 2*Npart+2)
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call  write_HeadFileTmat (NmaxAL, NmaxAL) 
  allocate (t(2*NmaxAL,2*NmaxAL))
  Nl = 0
  do ipart = 1, Npart
    Mrankpl = Mrankp(ipart)
    Nrankpl = Nrankp(ipart)
    Nmaxpl  = Nmaxp(ipart)          
    x = xp(ipart)
    y = yp(ipart)
    z = zp(ipart)
    alfa = alfap(ipart)
    beta = betap(ipart)
    gama = gamap(ipart)
    call extract_matrix1 (ipart, Npart, Nmaxp, Nmax, Nl, b, NmaxAL, NmaxAL,         &
         bb, Nmaxmax, NmaxAL)       
    call MatTransRot_TR_mn_m1n1 (1, k, x, y, z, alfa, beta, gama, Mrank, Nrank,     &
         Nmax, Mrankpl, Nrankpl, Nmaxpl, t, NmaxAL, NmaxAL)    
    call product_matrices2 (ipart, 2*Nmax, 2*Nmaxpl, 2*Nmax, t, 2*NmaxAL, 2*NmaxAL, &
         b, 2*NmaxAL, 2*NmaxAL, a, 2*NmaxAL, 2*NmaxAL)                      
    Nl = Nl + 2 * Nmaxpl
    if (PrnProgress) call write_progress (.false., Npart+2+ipart, 2*Npart+2)
  end do
  deallocate (t)  
  call copy_matrix (2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)
  call write_FileTmat (NmaxAL, NmaxAL, a)
  call PWcoefficients_ab (tetaGI, phiGI, alfaC, betaC, gamaC, alfaPol, Mrank,       &
       Nrank, Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfaC, betaC, gamaC, k, snorm,   & 
       ExtThetaDom,.true., h, v)
  call CQscat (c1, Mrank, Nrank, Nmax, k, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfaC, betaC, gamaC,           &
       alfaPol, k, snorm, Cext, Qext)        
  call write_2ConvParam (Nrank, Mrank)  
  call write_DSCS (Nteta,ExtThetaDom, h, v)        
  call write_Effic (Qscat, Qext)
  do i = 1, Nteta
    oldh(i)  = h(i)
    oldv(i)  = v(i)
    oldh0(i) = h(i)
    oldv0(i) = v(i)
  end do
  close (unit = iTmat)    
! --- (Nrank - 1) configuration ---
  if (PrnProgress) call write_progress_low
  call matrix_Nrank_1_right (Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)  
  call PWcoefficients_ab (tetaGI, phiGI, alfaC, betaC, gamaC, alfaPol, Mrank,       &
       Nrank, Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfaC, betaC, gamaC, k, snorm,   &
       ExtThetaDom,.true., h, v)
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConvN)
  call CQscat (c1, Mrank, Nrank, Nmax, k, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfaC, betaC, gamaC,           &
       alfaPol, k, snorm, Cext, Qext) 
  call write_2ConvParam (Nrank - 1, Mrank)
  call write_DSCS (Nteta, ExtThetaDom, h, v) 
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConvN, Nteta, epsNrank)
! --- (Mrank - 1) configuration ---  
  call matrix_Mrank_1_right (Mrank, Nrank, Nmax, b, NmaxAL, NmaxAL)  
  call PWcoefficients_ab (tetaGI, phiGI, alfaC, betaC, gamaC, alfaPol, Mrank,       &
       Nrank, Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfaC, betaC, gamaC, k, snorm,   &
       ExtThetaDom,.true., h, v)
  call delta_DSCS (Nteta, h, v, oldh0, oldv0, epsMrank, NthetaConvM)
  call CQscat (c1, Mrank, Nrank, Nmax, k, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfaC, betaC, gamaC,           &
       alfaPol, k, snorm, Cext, Qext) 
  call write_2ConvParam (Nrank, Mrank - 1)
  call write_DSCS (Nteta, ExtThetaDom, h, v) 
  call write_Effic (Qscat, Qext)
  call write_MrankConvRes (NthetaConvM, epsMrank)
  if (NthetaConvN >= int(0.8*Nteta) .and. NthetaConvM >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criteria for Nrank and Mrank are satisfied;')"                                    
  else
    print "(/,2x,'Convergence criteria for Nrank and Mrank are not satisfied;')"
  end if  
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .false., .false., .false.)
  call ScatCharact (k, FileTmat, Mrank, Nrank, .false., .false., .false.)
  print "(/,2x,'T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"           
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank  
  deallocate (aa, bb, a, b, c, c1, h, v, oldh, oldv, oldh0, oldv0, Nmaxp)      
end subroutine convergence_Nrank_MrankMULT
!***********************************************************************************
subroutine TMatrix_Nrank_MrankMULT (k, Npart, FileTmatp, axsymp, chiralp, xp, yp,   &
           zp, alfap, betap, gamap, Mrankp, Nrankp, Mrank, Nrank, FileTmat,         &
           PrnProgress)
  use parameters
  implicit none
  integer       :: Npart, Mrankp(Npart), Nrankp(Npart), Mrank, Nrank                   
  real(O)       :: k, xp(Npart), yp(Npart), zp(Npart), alfap(Npart), betap(Npart),  &
                   gamap(Npart)
  character(80) :: FileTmatp(Npart), FileTmat           
  logical       :: axsymp(Npart), chiralp(Npart), PrnProgress
!      
  integer       :: Nmax, Nmaxmax, NmaxAL, ipart, jpart, Nl, Nc, Mrankpl, Nrankpl,   &
                   Nmaxpl, Mrankpl1, Nrankpl1, Nmaxpl1, ntpg, mtpg  
  real(O)       :: alfa, beta, gama, x, y, z, alfa1, beta1, gama1, x1, y1, z1                              
  integer,allocatable    :: Nmaxp(:)
  complex(O),allocatable :: aa(:,:), bb(:,:), a(:,:), b(:,:), t(:,:)   
!  
  Nmax = Nrank + Mrank * (2 * Nrank - Mrank + 1) 
  allocate (Nmaxp(Npart))
  NmaxAL  = Nmax
  Nmaxmax = 0
  do ipart = 1, Npart
    Nmaxp(ipart) = Nrankp(ipart) + Mrankp(ipart) * (2 * Nrankp(ipart) -             &
                   Mrankp(ipart) + 1)
    Nmaxmax      = Nmaxmax + Nmaxp(ipart)
    if (Nmaxp(ipart) > NmaxAL) NmaxAL = Nmaxp(ipart)
    if (Nmaxp(ipart) > Nmax) then
      print "(/,2x, a, i3, a)",                                                     &
     'Warning: the input values of Nrank and Mrank are too low for particle ',ipart,';'        
    end if
  end do   
  allocate (aa(2*Nmaxmax,2*Nmaxmax), bb(2*Nmaxmax,2*NmaxAL))        
  allocate (a(2*NmaxAL,2*NmaxAL), b(2*NmaxAL,2*NmaxAL))         
  call identity_matrix (2*Nmaxmax, aa, 2*Nmaxmax, 2*Nmaxmax)
  if (PrnProgress) call write_progress (.true., 1, 2*Npart+2)            
  Nl = 0  
  do ipart = 1, Npart
    Mrankpl = Mrankp(ipart)
    Nrankpl = Nrankp(ipart)
    Nmaxpl  = Nmaxp(ipart)
    open (unit = iTmat, file = FileTmatp(ipart), status = "old", position = "rewind")
    if (.not. axsymp(ipart)) then
      call read_HeadFileTmat (ntpg, mtpg)
      call check_dimensionMat (ntpg, mtpg, Nmaxpl)            
      allocate (t(2*ntpg,2*mtpg))
      call read_FileTmat (ntpg, mtpg, t) 
    else
      ntpg = Nmaxpl
      mtpg = Nmaxpl
      allocate (t(2*ntpg,2*mtpg))
      call read_Tmatrix (chiralp(ipart), Nrankpl, Mrankpl, Nmaxpl, t, ntpg, mtpg)         
    end if
    close (unit = iTmat)                                                                                                       
    x = xp(ipart)
    y = yp(ipart)
    z = zp(ipart)
    alfa = alfap(ipart)
    beta = betap(ipart)
    gama = gamap(ipart)
    Nc   = 0    
    do jpart = 1, Npart     
      if (jpart /= ipart) then
        Mrankpl1 = Mrankp(jpart)
        Nrankpl1 = Nrankp(jpart)
        Nmaxpl1  = Nmaxp(jpart)
        x1 = xp(jpart)
        y1 = yp(jpart)
        z1 = zp(jpart)
        alfa1 = alfap(jpart)
        beta1 = betap(jpart)
        gama1 = gamap(jpart)            
        call MatRotTransRot_RTR_mn_m1n1 (3, k, x, y, z, alfa, beta, gama, Mrankpl,  &
             Nrankpl, Nmaxpl, x1, y1, z1, alfa1, beta1, gama1, Mrankpl1, Nrankpl1,  &
             Nmaxpl1, a, NmaxAL, NmaxAL)        
        call product_matrices1 (2*Nmaxpl, 2*Nmaxpl, 2*Nmaxpl1, t, 2*ntpg, 2*mtpg,   &
             a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)                      
        call extend_matrix1 (ipart, jpart, Npart, Nmaxp, Nl, Nc, b, NmaxAL, NmaxAL, &
             aa, Nmaxmax, Nmaxmax)                                                      
      end if
      Nc = Nc + 2 * Nmaxp(jpart)      
    end do              
    call MatRotTrans_RT_mn_m1n1 (1, k, x, y, z, alfa, beta, gama, Mrankpl, Nrankpl, &
         Nmaxpl, Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)
    call product_matrices1 (2*Nmaxpl, 2*Nmaxpl, 2*Nmax, t, 2*ntpg, 2*mtpg,          &
         a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)              
    call extend_matrix2 (ipart, Npart, Nmaxp, Nmax, Nmaxmax, Nl, b, NmaxAL, NmaxAL, &
         bb, Nmaxmax, NmaxAL)            
    Nl = Nl + 2 * Nmaxp(ipart)
    if (PrnProgress) call write_progress (.false., ipart+1, 2*Npart+2)
    deallocate (t)
  end do
  call LU_SYSTEM_DIRECT (aa, 2*Nmaxmax, 2*Nmaxmax, bb, 2*Nmaxmax, 2*NmaxAL,         &
       2*Nmaxmax, 2*Nmax)
  if (PrnProgress) call write_progress (.false., Npart+2, 2*Npart+2)
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call  write_HeadFileTmat (NmaxAL, NmaxAL) 
  allocate (t(2*NmaxAL,2*NmaxAL))
  Nl = 0
  do ipart = 1, Npart
    Mrankpl = Mrankp(ipart)
    Nrankpl = Nrankp(ipart)
    Nmaxpl  = Nmaxp(ipart)        
    x = xp(ipart)
    y = yp(ipart)
    z = zp(ipart)
    alfa = alfap(ipart)
    beta = betap(ipart)
    gama = gamap(ipart)
    call extract_matrix1 (ipart, Npart, Nmaxp, Nmax, Nl, b, NmaxAL, NmaxAL,         &
         bb, Nmaxmax, NmaxAL)       
    call MatTransRot_TR_mn_m1n1 (1, k, x, y, z, alfa, beta, gama, Mrank, Nrank,     &
         Nmax, Mrankpl, Nrankpl, Nmaxpl, t, NmaxAL, NmaxAL)    
    call product_matrices2 (ipart, 2*Nmax, 2*Nmaxpl, 2*Nmax, t, 2*NmaxAL, 2*NmaxAL, &
         b, 2*NmaxAL, 2*NmaxAL, a, 2*NmaxAL, 2*NmaxAL)                      
    Nl = Nl + 2 * Nmaxpl
    if (PrnProgress) call write_progress (.false., Npart+2+ipart, 2*Npart+2)
  end do  
  call write_FileTmat (NmaxAL, NmaxAL, a)  
  close (unit = iTmat)   
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .false., .false., .false.) 
  call ScatCharact (k, FileTmat, Mrank, Nrank, .false., .false., .false.)
  print "(/,2x,'T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"           
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank  
  deallocate (aa, bb, a, b, t, Nmaxp)   
end subroutine TMatrix_Nrank_MrankMULT

subroutine TPARTSUB
!------------------------------------------------------------------------------------
! 1. General Considerations                                                         !
! --------------------------                                                        !
! TPARTSUB is a routine for computing the scattering characteristics of a           !
! homogeneous, dielectric or perfectly conducting, axisymmetric particle on or      !
! near a plane surface.                                                             !
!                                                                                   !
! The axisymmetric particle is situated in the neighbourhood of a plane surface,    !
! so that its axis of symmetry coincides with the normal to the plane surface.      !
! The particle is illuminated by a vector pane wave traveling in the ambient medium,! 
! or by a vector plane wave traveling in the substrate (Figure 1). In the first     !
! case, the direction of the wave vector is (theta = beta, phi = Pi), while in the  !
! second case, the direction is (theta = Pi - beta, phi = 0), where beta is the     !
! incident angle.                                                                   !
!                                                                                   !
!                                                  beta ^ Z                         !
!                                                    !  | 		                      !                                                        			!
!                                                  * ...| 		                      ! 
!                                                   *   | 		                      !
!           Z ^ substrate              incident - -> *  |  substrate	              !
!             |    !                   direction      * |    !                      !
!             |    !                                   *|    !                      !
!     ================/=                         =======o=======/= --> x            ! 
!             |       !                                 |       !                   !
!          -------    ! z0                           -------    ! z0                ! 
!         |   |   |   !                             |   |   |   !                   !
!         |   |   |   !    X                        |   |   |   !    X              !
!      ---|---O---|---/---->                     ---|---O---|---/---->              ! 
!         |   |*  |                                 |   |   |                       !
!         |   | * |<- - particle                    |   |   |< - - particle         !
!          ------*                                   -------                        !
!             |   * <- - incident                       |                           !
!             |... *     direction                      |                           !
!             | !   *                                                               !
!              beta                                                                 !
!                                                                                   !
!            (a)                                        (b)                         !
!                                                                                   !
!  Figure 1. The particle is illuminated by: (a) a vector plane wave traveling in   !
!  the ambient medium and (b) a vector plane plane wave traveling in the substrate. !
!                                                                                   !
! The scattering problem is a multiple particles problem and the solution method    !
! is the separation of variables technique. To model the scattering problem in the  !
! framework of the separation of variables technique we must address how the        !
! radiation interacts with the particle. The incident field strikes the particle    !
! either directly or after interacting with the surface, while the fields           !
! emanating from the particle may also reflect off the surface and interact with    !
! the particle again. The transition matrix relating the incident and scattered     !
! field coefficients is computed in the framework of the null-field method.         !
! For axisymmetric particles, the T-matrix computation decouples over the           !
! azimuthal modes and the surface integrals reduce to line integrals over the       !
! generatrix. The integrals are evaluated by means of Gauss-Legendre quadrature     !
! method, and note that for particles with a plane of symmetry perpendicular to the !
! axis of rotation (mirror symmetric particles), the integration can be performed   !
! along the half-generatrix curve. The numerical stability and accuracy of T-matrix !
! computations for an unsmooth generatrix can be enhanced by dividing the           !
! generatrix into piecewise smooth curves and applying separate quadrature          !
! formulas to each curve. The reflection matrix characterizing the reflection of    !
! the scattered field by the surface is computed by using the integral              !
! representation for the vector spherical wave functions over plane waves. As a     !
! result, the elements of the reflection matrix are expressed as integrals over a   !
! complex angle.                                                                    !
!                                                                                   !
! Particle geometries currently supported include: spheroids, cylinders and         !
! rounded oblate cylinders. As for axisymmetric particles, the routines             !
! "interpolation_listAXSYM" and "elem_geomAXSYM" provide the required geometry      !
! parameters. For more details, consult the TAXSYM routine.                         !
!                                                                                   !
! IMPORTANT NOTE: For cylinders and rounded oblate cylinders, THE GEOMETRIC         !
! CONSTRAINT of the T-matrix method IS VIOLATED and convergence problems occur.     !
! Therefore, we recommend to use the code only for PROLATE SPHEROIDS.               !
!                                                                                   !
! The code computes the differential scattering cross sections for parallel and     !
! perpendicular polarizations in the azimuthal plane phiGS and at NthetaGS          !
! scattering angles. Denoting by                                                    !
!                                                                                   !
!            ES = [exp(jkR) / kR] * ESinf = [exp(jkR) / R] * FS                     !
!                                                                                   ! 
! the scattered field in the direction (theta,phi), where FS is the far-field       !
! pattern and ESinf = k * FS, and assuming the decomposition                        !
!                                                                                   !  
!            ESinf = ESinf_theta * e_theta + ESinf_phi * e_phi,                     !
!                                                                                   !
! where e_theta and e_phi are the spherical unit vectors, we define the             !
! differential scattering cross sections for parallel and perpendicular             !
! polarizations by                                                                  !
!                                                                                   ! 
!            h = |ESinf_theta|**2 / k**2 = |FS_theta|**2                            !
!                                                                                   !
! and                                                                               !
!            v = |ESinf_phi|**2 / k**2   = |FS_phi|**2,                             !
!                                                                                   !
! respectively. The normalized differential scattering cross sections for parallel  !
! and perpendicular polarizations are given by                                      ! 
!                                                                                   ! 
!     hn = |ESinf_theta|**2 / [Pi * (k*anorm)**2] = |FS_theta|**2 / [Pi * anorm**2] !
!                                                                                   !
! and                                                                               !
!                                                                                   !
!     vn = |ESinf_phi|**2 / [Pi * (k*anorm)**2]   = |FS_phi|**2 / [Pi * anorm**2],  !
!                                                                                   !
! where anorm is a characteristic dimension of the particle. For a more complex     !
! analysis, the code also computes the electromagnetic fields ESinf_theta and       !
! ES_inf_phi at Nphi scattering planes.                                             !
!                                                                                   !
! 2. Convergence Test                                                               !
! --------------------                                                              !
! Convergence tests precede the scattering characteristics calculation. The         !
! following parameters control the T-matrix computation:                            !
! - the number of integration points for computing integrals over the generatrix,   ! 
!   Nint,                                                                           !
! - the number of integration points for computing the elements of the reflection   !
!   matrix, NXint,                                                                  !
! - the maximum expansion order Nrank, and                                          !
! - the maximum azimuthal order Mrank.                                              ! 
! Nint is the global number of integration points on the generatrix curve and has   !
! the same significance as in the routine "TAXSYM".                                 ! 
! The integrals appearing in the expression of the reflection matrix are of the     !
! form                                                                              !
!                                                                                   !
!           |Pi/2 - j * inf                                                         !
!       I = |     f(cos(beta)) * exp{ 2 * j * q * cos(beta) } * sin(beta) dbeta.    !
!           |0                                                                      !
!                                                                                   !
! Changing variables from beta to x = - 2 * j * q * [cos(beta) - 1], we have        !
!                                                                                   !
!                                           |inf                                    !
!       I = [exp{2 * j* q} / (2 * j * q)] * |   f(1 - x/(2 * j * q)) * exp{ -x } dx.!
!                                           |0                                      !
!                                                                                   ! 
! and integrals of this type can be computed efficiently by using Laguerre          !
! polynomials. In this context, an important parameter of the convergence procedure !
! is the number of integration points NXint for the Laguerre quadrature method.     !
!                                                                                   !
! For convergence tests, the incident wave is assumed to be a vector plane wave and !
! the scattering characteristics are computed in the azimuthal plane  phi = 0°. The !
! convergence tests over Nint, NXint and Nrank are interactive, while the           !
! convergence test over Mrank is automatically performed.                           ! 
!                                                                                   !
! For the integration and expansion order test, the incident wave propagates along  !
! the axis of symmetry of the particle. In this case, all azimuthal modes are zero  !
! except for m = - 1 and m = 1. For the convergence test over Nint and NXint, the   !
! scattering problem is solved for the pairs (Nint,NXint) and                       !
! (Nint + dNint, NXint + dNint), while for the convergence test over Nrank, the     !
! scattering problem is solved for Nrank and Nrank - 1. The normalized              !
! differential scattering cross section (DSCS) will be checked at 20° increments    !
! for convergence within epsX (epsNint or epsNrank) tolerance. If the calculated    !
! results converge within this tolerance at 80% of the scattering angles, then      !
! convergence is achieved.                                                          !
!                                                                                   ! 
! After Nrank, Nint and NXint have been determined we pass to the azimuthal         !
! order test. The program automatically sets the incident angle to a more general   !
! orientation, i.e., beta = 45°, and solves the scattering problem  for increasing  !
! m values until convergence of the angular scattering is achieved.                 !
!                                                                                   !
! The convergence tests over Nint, NXint and Nrank can be switched off by setting   !
! the logical variable DoConvTest to false. In this case, the values of Nint,       !
! NXint and Nrank must be specified in the input file.                              !
!                                                                                   !
! 3. Estimates of Nint and Nrank                                                    !
! --------------------------------                                                  !
! The above convergence tests require estimates of Nint, NXint and Nrank.           ! 
! These estimates must be supplied by the user, and for this purpose, Wiscombe's    !
! truncation limit criterion [W. J. Wiscombe, Improved Mie scattering algorithms,   ! 
! Applied Optics, 19, 1505-1509, 1980] can be used.                                 !
!                                                                                   !
! The truncation limit criterion proposed by Wiscombe provides the estimate         !
!                                                                                   !
!                NrankW = int(x + 4.05 * x**0.33 + 2),                              !
!                                                                                   !
! where x is the size parameter, x = k * Rcirc, k is the wave number and Rcirc is   !
! the radius of the smallest circumscribing sphere.                                 !
!                                                                                   ! 
! The value of Nint depends on the size parameter, the particle shape and the       !
! relative refractive index. A conservative estimate of Nint is                     !
!                                                                                   !
!                        Nint = Ndgs * Nrank,                                       !
!                                                                                   !
! where Ndgs = 10, 15, 20, ....                                                     !
!                                                                                   !
! The value of NXint also depends on the size parameter of the particle. For size   !
! parameters smaller than 5, NXint = 60, 70,...,90.                                 !
!                                                                                   !
! 4. Input Parameters                                                               !
! --------------------                                                              !
! The parameters specified in the input file "/INPUTFILES/InputPARTSUB.dat" are     !
! listed below.                                                                     !
!                                                                                   !
! - wavelength (real) - wavelength of the incident light in the ambient medium.     !
!                                                                                   !
! - ind_refPART (complex) - relative refractive index of the particle with respect  !
!   to the ambient medium. The imaginary part of the relative refractive index      !
!   must be zero for nonabsorbing particles and positive for absorbing particles.   !
!                                                                                   !
! - ind_refSUB (complex) - relative refractive index of the substrate with respect  !
!   to the ambient medium. The imaginary part of the relative refractive index      !
!   must be zero or positive.                                                       !
!                                                                                   !
! - TypeScat (integer) - if TypeScat = 1, the particle is illuminated by a vector   !
!   pane wave traveling in the ambient medium, while for TypeScat = 2 the particle  !
!   is illuminated by a vector plane wave traveling in the substrate. In the first  !
!   case the direction of the wave vector is (theta = beta, phi = Pi), while in the !
!   second case the direction is (theta = Pi - beta, phi = 0), where beta is the    !
!   incident angle.                                                                 !
!                                                                                   !
! - TypeGeom (integer) - parameter specifying the type of the particle geometry.    !
!                                                                                   !
! - Nsurf (integer) - number of surface parameters.                                 !
!                                                                                   !
! - surf (real array: surf(1), surf(2),...,surf(Nsurf)) - surface parameters        !
!   specifying the shape of the particle. The dimension of the array surf is        !
!   NsurfPD. The integer parameter NsurfPD is specified in the routine              !
!   "Parameters.f90" and has the value NsurfPD = 10. If Nsurf > NsurfPD, the        !
!   execution is automatically terminated.                                          !
!                                                                                   !
! - Nparam (integer) - number of smooth curves forming the generatrix curve.        !
!                                                                                   !
!   The permissive values of the surface parameters (for the supported geometries)  !
!   are given below.                                                                !
!                                                                                   !
!   Particle      TypeGeom   Nsurf   Nparam                surf                     !
!   spheroid         1         2       1         surf(1) - length of the semi-      !
!                                                          axis along the           !
!                                                          symmetry axis            !
!                                                surf(2) - length of the second     !
!                                                          semi-axis                !
!                                                                                   !
!   cylinder         2         2       3         surf(1) - half-length of           !
!                                                          the cylinder             !
!                                                surf(2) - cylinder radius          !
!                                                                                   !
!   rounded          3         2       3         surf(1) - half-length of           !
!    oblate                                                the cylinder             !
!   cylinder                                     surf(2) - cylinder radius          ! 
!                                                          including the rounded    !
!                                                          part                     !
!                                                                                   !
!   NOTE: Due to convergence problems occurring for cylindrical particles, it is    !
!   recommended to use the code only for PROLATE SPHEROIDS.                         !
!                                                                                   !
! - z0 (real) - axial position of the substrate in the particle coordinate system.  !
!   Note that z0 must be a POSITIVE quantity.                                       !         
!                                                                                   !
! - anorm (real) - characteristic length of the particle which is used to           !
!   normalize the differential scattering cross sections.                           !
!                                                                                   !
! - Rcirc (real) - characteristic length of the particle (usually the radius of     !
!   the smallest circumscribing sphere) which is used to compute an estimate of the !
!   maximum expansion order by using Wiscombe's truncation limit criterion (the size!
!   parameter is x = k * Rcirc, where k is the wave number in the ambient medium).  !
!   Alternatively, Rcirc can be chosen as the equal-volume sphere radius or the     !
!   surface-equivalent-sphere radius. This parameter must be specified if the       !
!   interactive convergence tests over Nint, NXint and Nrank are used               !
!   (DoConvTest = t).                                                               ! 
!                                                                                   !
! - miror (logical) - if miror = t, the particle is mirror symmetric (the plane of  !
!   symmetry or the plane of reflection is perpendicular to the axis of rotation).  !
!                                                                                   !
! - perfectcond (logical) - if perfectcond = t, the particle is perfectly           !
!   conducting.                                                                     !
!                                                                                   !
! - DoConvTest (logical) - if DoConvTest = t, the interactive convergence tests     !
!   over Nint, NXint and Nrank are invoked. An estimate of Nrank is given by        !
!   Wiscombe's truncation limit criterion. If DoConvTest = f, the values of Nint,   !
!   NXint and Nrank must be supplied in the input file.                             !
!                                                                                   !
! - Nint (integer) - number of integration points in computing integrals over       !
!   the generatrix curve. This parameter is used if the convergence tests are not   !
!   performed (DoConvTest = f).                                                     !
!                                                                                   !
! - NXint (integer) - number of integration points for computing the elements of    !
!   the reflection matrix. This parameter is used if the convergence tests are      !
!   not performed (DoConvTest = f).                                                 ! 
!                                                                                   ! 
! - Nrank (integer) - maximum expansion order. This parameter is used if the        !
!   convergence tests are not performed (DoConvTest = f).                           !
!                                                                                   !
! - epsNint (real) - error tolerance for the integration test.                      !
!                                                                                   !
! - epsNrank (real) - error tolerance for the expansion order test.                 !
!                                                                                   !
! - epsMrank (real) - error tolerance for the azimuthal order test.                 !
!                                                                                   !
! - dNint (integer) - number of division points for the integration test. Note      !
!   that the scattering problem is solved for Nint and Nint + dNint.                ! 
!                                                                                   !
! The following parameters control the scattering characteristics calculation.      !
! - beta (real) - incident angle.                                                   !
!                                                                                   !
! - alphap (real) - polarization angle of the incident wave. If                     ! 
!  (e_r,e_theta,e_phi) are the spherical unit vectors of the incident               !
!   direction (thetaGI,phiGI), then alphap is the angle between the electric        ! 
!   field vector and the unit vector e_theta.                                       !
!                                                                                   !
! - ComputeDSCS (logical) - if ComputeDSCS = t, the differential scattering         !
!   cross sections are computed in the azimuthal plane phiGS at NthetaGS            !
!   scattering angles.                                                              !
!                                                                                   !
! - ComputeFields (logical) - if ComputeFields = t, the electromagnetic fields      !
!   are computed at Nphi scattering planes.                                         !
!                                                                                   !
! - phiGS (real) - azimuthal angle of the scattering plane in which the             !
!   differential scattering cross sections are computed.                            !
!                                                                                   !
! - NthetaGS (integer) - number of scattering angle at which the differential       !
!   scattering cross sections are computed. The scattering angles are uniformly     !
!   spaced.                                                                         !
!                                                                                   !
! - Nphi (integer) - number of scattering planes at which the electromagnetic       !
!   fields are computed.                                                            !
!                                                                                   !
! - phi (real array: phi(1), phi(2),..., phi(Nphi)) - azimuthal angles of the       !
!   scattering planes at which the electromagnetic fields are computed.             !
!                                                                                   !
! - Ntheta (integer array: Ntheta(1), Ntheta(2),..., Ntheta(Nphi)) - number of      !
!   zenith angle values in each scattering plane at which the electromagnetic       !
!   fields are computed.                                                            !
!                                                                                   !
! - thetamin, thetamax (real arrays: thetamin(1), thetamin(2),...,                  !
!   thetamin(Nphi) and thetamax(1), thetamax(2),..., thetamax(Nphi)) - specify      !
!   the minimal and maximal values of the zenith angle in each scattering plane     !
!   at which the electromagnetic fields are computed.                               !
!                                                                                   !
! - normalized (logical) - if normalized = t, the average differential              ! 
!   scattering cross sections are normalized by Pi * anorm**2, where anorm is the   !
!   characteristic length of the particle.                                          !
!                                                                                   !
! - FileDSCS (character(80)) - name of the file to which the differential           !
!   scattering cross sections are written.                                          !
!                                                                                   !
! - FileEMF (character(80)) - name of the file to which the electromagnetic         !
!   fields are written.                                                             !
!                                                                                   ! 
! - WriteInputInfo (logical) - if WriteInputInfo = t, the input parameters of       !
!   the scattering problem are written to the output files FileDSCS and             !
!   FileEMF.                                                                        !
!                                                                                   !
! - PrnProgress (logical) - if PrnProgress = t, the progress of calculation         !
!   is printed.                                                                     !
!                                                                                   !
! Note that all input parameters specifying lengths must be provided in the same    !
! units of lengths.                                                                 !
!                                                                                   !
! 5. Logical Scheme                                                                 !
! ------------------                                                                !  
! The organization of the code is as follows:                                       !
! 1. < read input data >                                                            !
! 2. < T-matrix calculation >                                                       !
!                                                                                   !
!    if ( do convergence test) then                                                 !                
!      < the code computes an estimate of Nrank accordingly to                      !
!         Wiscombe's truncation criterion >                                         !
!      < the code prompts for the estimated values of Nint, NXint and Nrank >       !
!      < the code prompts for the type of convergence test:                         !
!        1 - over Nint and NXint, 2 - over Nrank or 3 - over Mrank >                !
!    else if ( .not. do convergence test) then                                      !
!      < the input file provides the values of Nint, NXint and Nrank >              !
!      type of convergence test = 3 (convergence test over Mrank)                   !
!    end if                                                                         !
!                                                                                   !
!    if ( do integration test, i.e., type of convergence test = 1 ) then            !
!       < the code computes the DSCS for (Nint,NXint) and (Nint + dNint,            !
!         NXint + dNint) and write the results to the file "Output.dat" >           !
!       < the execution is terminated >                                             !
!    end if                                                                         !
!    if ( do expansion order test, i.e., type of convergence test = 2 ) then        !
!       < the code computes the DSCS for Nrank and Nrank - 1 and                    !
!         write the results to the file "Output.dat" >                              !
!       < the execution is terminated >                                             !
!    end if                                                                         !
!    if ( do azimuthal order test, i.e., type of convergence test = 3 ) then        !
!       < the code computes the DSCS for increasing m values and                    !
!         write the results to the file "Output.dat" >                              !
!       < go to Step 3 >                                                            !
!    end if                                                                         !
! 3. < scattering characteristics calculation >                                     !
!------------------------------------------------------------------------------------
  use parameters
  implicit none 
  integer       :: TypeGeom, TypeScat, Nsurf, Nparam, TypeConvTest, dNint, Nrank,   &
                   Nint, NXint                                   
  real(O)       :: wavelength, z0, anorm, surf(NsurfPD), snorm, epsNint, epsNrank,  &
                   epsMrank, k, Rcirc                                       
  complex(O)    :: ind_refPART, ind_refSUB
  logical       :: miror, perfectcond, DoConvTest, PrnProgress       
! -----------------------------------------------------------------------------------
!                                 Read the input file                               ! 
! -----------------------------------------------------------------------------------
  call readinputPARTSUB ( wavelength, ind_refPART, ind_refSUB, TypeScat,            &
       TypeGeom, Nsurf, surf, Nparam, z0, anorm, Rcirc, miror, perfectcond,         &
       DoConvTest, Nint, NXint, Nrank, epsNint, epsNrank, epsMrank, dNint,          &
       PrnProgress, TypeConvTest, k, snorm)  
! -----------------------------------------------------------------------------------
!                                      Main                                         !
! -----------------------------------------------------------------------------------   
  open (unit = iOutput, file = FileOutput, status = "replace")   
  call printinputPARTSUB (TypeGeom, TypeScat, Nsurf, Nparam, dNint, wavelength,     &
       anorm, Rcirc, z0, surf, epsNint, epsNrank, epsMrank, ind_refPART, ind_refSUB,&
       miror, perfectcond) 
  if (DoConvTest) then
    if (TypeConvTest == 1) then
      call convergence_NintPARTSUB (TypeGeom, TypeScat, k, ind_refSUB, ind_refPART, &
           z0, snorm, Nsurf, surf, Nparam, Nrank, Nint, NXint, dNint, miror,        &
           perfectcond, epsNint, PrnProgress)      
    else if (TypeConvTest == 2) then
      call convergence_NrankPARTSUB (TypeGeom, TypeScat, k, ind_refSUB, ind_refPART,&
           z0, snorm, Nsurf, surf, Nparam, Nrank, Nint, NXint, miror, perfectcond,  &
           epsNrank, PrnProgress)        
    else 
      call convergence_MrankPARTSUB (TypeGeom, TypeScat, k, ind_refSUB, ind_refPART,&
           z0, snorm, Nsurf, surf, Nparam, Nrank, Nint, NXint, miror, perfectcond,  &
           epsMrank, PrnProgress)         
    end if
  else
    call convergence_MrankPARTSUB (TypeGeom, TypeScat, k, ind_refSUB, ind_refPART,  &
         z0, snorm, Nsurf, surf, Nparam, Nrank, Nint, NXint, miror, perfectcond,    &
         epsMrank, PrnProgress) 
  end if
  close (unit = iOutput)           
end subroutine TPARTSUB
!***********************************************************************************
subroutine readinputPARTSUB ( wavelength, ind_refPART, ind_refSUB, TypeScat,        &
           TypeGeom, Nsurf, surf, Nparam, z0, anorm, Rcirc, miror, perfectcond,     &
           DoConvTest, Nint, NXint, Nrank, epsNint, epsNrank, epsMrank, dNint,      &
           PrnProgress, TypeConvTest, k, snorm)     
  use parameters
  use derived_parameters
  implicit none 
  integer       :: TypeGeom, TypeScat, Nsurf, Nparam, TypeConvTest, dNint, Nrank,   &
                   Nint, NXint, i, ios, NrankW                                    
  real(O)       :: wavelength, z0, anorm, surf(NsurfPD), xpart, snorm, epsNint,     &
                   epsNrank, epsMrank, k, Rcirc, x                                       
  complex(O)    :: ind_refPART, ind_refSUB
  character(80) :: string
  logical       :: miror, perfectcond, DoConvTest, PrnProgress, XFindPar     
! -----------------------------------------------------------------------------------
!                         Read the input file FileInputPARTSUB                      ! 
! -----------------------------------------------------------------------------------    
  call DrvParameters 
  open (unit = iInputPARTSUB, file = FileInputPARTSUB, status = "old",              &
        position = "rewind")   
  wavelength  = 0.1_O * 2._O * Pi  
  ind_refPART = (1.5_O,0._O)                                                                    
  ind_refSUB  = (1.3_O,0._O)
  string      = 'OptProp'
  if (XFindPar (iInputPARTSUB, string)) then
    read (iInputPARTSUB, *, iostat = ios) wavelength
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) ind_refPART
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refPART;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) ind_refSUB
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refSUB;')"
      stop
    end if      
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if 
  call check_ind_ref2 (ind_refPART, ind_refSUB)  
  k = 2._O * Pi / wavelength 
!
  TypeScat = 1
  TypeGeom = 1 
  Nsurf = 2
  do i = 1, NsurfPD
    surf(i) = 0.1_O
  end do
  Nparam = 1
  z0     = 0.1_O
  anorm  = 0.1_O
  Rcirc  = 0.1_O
  miror  = .true.
  perfectcond = .false.
  string      = 'GeomProp'
  if (XFindPar (iInputPARTSUB, string)) then
    read (iInputPARTSUB, *, iostat = ios) TypeScat
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable TypeScat;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) TypeGeom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable TypeGeom;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) Nsurf
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nsurf;')"
      stop
    end if
    if (Nsurf > NsurfPD) then
      print "(/,2x,'Input error: Nsurf exceeds NsurfPD;')"                                    
      stop
    end if          
    do i = 1, Nsurf
      read (iInputPARTSUB, *, iostat = ios) surf(i)
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable surf;')"
        stop
      end if
    end do
    read (iInputPARTSUB, *, iostat = ios) Nparam
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nparam;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) z0
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable z0;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) anorm
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anorm;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) Rcirc
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Rcirc;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) miror
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable miror;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) perfectcond
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable perfectcond;')"
      stop
    end if
  else
    print "(/,2x,'Group name GeomProp not found;')"
    stop  
  end if
  call check_geomAXSYM (TypeGeom, Nsurf, Nparam)
  call check_geomAXSYMOblate (TypeGeom, Nsurf, surf) 
  call check_anorm (anorm)  
  xpart = k * anorm
  snorm = Pi * xpart * xpart
!
  DoConvTest = .true.
  string     = 'ConvTest'
  if (XFindPar (iInputPARTSUB, string)) then
    read (iInputPARTSUB, *, iostat = ios) DoConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DoConvTest;')"
      stop
    end if        
  else
    print "(/,2x,'Group name ConvTest not found;')"
    stop  
  end if 
!
  if (DoConvTest) then
    print "(/,2x,'Convergence Test for a Particle on or Near a Plane Surface')"
    print "(  2x,'----------------------------------------------------------')"
  else
    print "(/,2x, a)",                                                              &
   'Convergence Test for a Particle on or Near a Plane Surface over Mrank'
    print "(  2x, a)",                                                              &
   '---------------------------------------------------------------------'
  end if   
! 
  x = k * Rcirc
  NrankW = int(x + 4.05_O * x**0.33_O + 2._O)
  if (.not. DoConvTest) then    
    Nint   = 60
    NXint  = 60 
    Nrank  = 10
    string = 'NintNrank'
    if (XFindPar (iInputPARTSUB, string)) then
      read (iInputPARTSUB, *, iostat = ios) Nint
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nint;')"
        stop
      end if
      read (iInputPARTSUB, *, iostat = ios) NXint
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable NXint;')"
        stop
      end if
      read (iInputPARTSUB, *, iostat = ios) Nrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nrank;')"
        stop
      end if
    else
      print "(/,2x,'Group name NintNrank not found;')"
      stop  
    end if 
    print "(/,2x,'Input values:')"
    print "(  2x, a, i4, a, i4, a, i3, a)",                                         &
   'the input values of Nint, NXint and Nrank are ', Nint, ', ', NXint, ' and ',    &
    Nrank, ',' 
    print "(  2x, a, i3, a)",                                                       &
   'while the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'                                             
  else          
    print "(/,2x,'Nrank estimate:')"                                                    
    print "(  2x, a, i3, a)",                                                       &
   'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'
    print "(/,2x,'- enter the estimated values of Nint, NXint and Nrank, where  ')"
    print "(  2x,'  Nint = Ndgs * Nrank, Ndgs = 10, 15,..., and NXint = 60, 70, ...;')"         
    call read_integer3 (Nint, NXint, Nrank) 
  end if
!
  if (DoConvTest) then
    print "(/,2x, a)",                                                              &
   '- enter the type of convergence test: 1 - Nint/NXint, 2 - Nrank, 3 - Mrank;'
    call read_integerbound (TypeConvTest, 1, 3)
  else
    TypeConvTest = 3 
  end if
!
  epsNint  = 5.e-2_O
  epsNrank = 5.e-2_O
  epsMrank = 5.e-2_O
  dNint    = 4
  string   = 'Errors'
  if (XFindPar (iInputPARTSUB, string)) then
    read (iInputPARTSUB, *, iostat = ios) epsNint
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNint;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) epsNrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNrank;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) epsMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsMrank;')"
      stop
    end if
    read (iInputPARTSUB, *, iostat = ios) dNint
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable dNint;')"
      stop
    end if
  else
    print "(/,2x,'Group name Errors not found;')"
    stop  
  end if  
!
  PrnProgress = .true.
  string      = 'PrintProgress'
  if (XFindPar (iInputPARTSUB, string)) then
    read (iInputPARTSUB, *, iostat = ios) PrnProgress
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if        
  else
    print "(/,2x,'Group name PrintProgress not found;')"
    stop  
  end if     
  close (unit = iInputPARTSUB)  
end subroutine readinputPARTSUB
!***********************************************************************************
subroutine printinputPARTSUB (TypeGeom, TypeScat, Nsurf, Nparam, dNint, wavelength, &
           anorm, Rcirc, z0, surf, epsNint, epsNrank, epsMrank, ind_refPART,        &
           ind_refSUB, miror, perfectcond)             
  use parameters
  implicit none
  integer    :: TypeGeom, TypeScat, Nsurf, Nparam, dNint, i
  real(O)    :: wavelength, anorm, Rcirc, surf(Nsurf), epsNint, epsNrank,           &
                epsMrank, z0
  complex(O) :: ind_refPART, ind_refSUB
  logical    :: miror, perfectcond
!
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x, a, 1pe13.4, a)")                                             &
 'wavelength of the ambient medium, wavelength = ', wavelength, ';'
  write (iOutput,"(2x, a, 1pe10.3, ',', 1pe10.3, a)")                               &
 'relative refractive index of the substrate, ind_refSUB = (', ind_refSUB, ');' 
  write (iOutput,"(2x, a, 1pe10.3, ',', 1pe10.3, a)")                               &
 'relative refractive index of the particle, ind_refPART = (', ind_refPART, ');'
  write (iOutput,*)
  write (iOutput,"(2x,'index of the particle geometry, TypeGeom = ',i2,';')")       &
         TypeGeom
  if (TypeGeom == 1) then
    write (iOutput,"(2x,'spheroid;')")  
  else if (TypeGeom == 2) then
    write (iOutput,"(2x,'cylinder;')")  
  end if
  write (iOutput,"(2x,'number of surface parameters, Nsurf = ',i2,';')") Nsurf
  write (iOutput,"(2x,'surface parameters:')")
  do i = 1, Nsurf
    write (iOutput,"(2x,'surf(',i2,') = ',1pe10.3,',')") i, surf(i)
  end do
  if (TypeGeom == 1) then
    write (iOutput,"(2x,'where surf(1) is the half-axis along the symmetry axis')")
    write (iOutput,"(2x,'and   surf(2) is the second half-axis;')")
  else if (TypeGeom == 2) then
    write (iOutput,"(2x,'where surf(1) is the half-length of the cylinder')")
    write (iOutput,"(2x,'and   surf(2) is the cylinder radius;')")
  end if         
  write (iOutput,"(2x,'number of integration surfaces, Nparam = ',i2,';')") Nparam
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'characteristic length of the particle, anorm = ', anorm, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'radius of the circumscribing sphere, Rcirc = ', Rcirc, ';'
  write (iOutput,"(2x,'axial position of the particle, z0 = ',1pe10.3,';')") z0
  if (miror) write (iOutput,"(2x,'mirror symmetric particle;')")  
  if (perfectcond) then
    write (iOutput,"(2x,'perfectly conducting particle;')") 
  else
    write (iOutput,"(2x,'dielectric particle;')")
  end if
  if (TypeScat == 1)  then
    write (iOutput,"(2x, a)")                                                       &
   'illumination by a plane wave traveling in the ambient medium;'          
  else if (TypeScat == 2)  then
    write (iOutput,"(2x,'illumination by a plane wave traveling in the substrate;')")   
  end if  
  write (iOutput,*)  
  write (iOutput,"(2x,'integration tolerance, epsNint = ',1pe10.3,';')") epsNint
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum expansion order tolerance, epsNrank = ', epsNrank, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum azimuthal order tolerance, epsMrank = ', epsMrank, ';'          
  write (iOutput,"(2x,'integration step, dNint = ',i4,'.')") dNint
  write (iOutput,"(/)")                       
end subroutine printinputPARTSUB
! **********************************************************************************
subroutine convergence_NintPARTSUB (TypeGeom, TypeScat, k, ind_ref_s, ind_ref_p,    &
           z0, snorm, Nsurf, surf, Nparam, Nrank, Nint, NXint, dNint, miror,        &
           perfectcond, epsNint, PrnProgress) 
  use parameters             
  implicit none 
  integer    :: Nsurf, Nparam, Nrank, Nint, NXint, dNint, TypeGeom, TypeScat   
  real(O)    :: surf(Nsurf), snorm, k, epsNint, z0
  complex(O) :: ind_ref_s, ind_ref_p
  logical    :: miror, perfectcond, PrnProgress 
!  
  integer    :: iNint, Mstart, Nteta, Mrank, Nmax, Nmaxmax, i, m, j, NthetaConv,    &
                Nface
  real(O)    :: beta, alfap, phiGS, kb 
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), Xint(:), pondereX(:),       &
                            h(:), v(:), oldh(:), oldv(:), zRe(:), zIm(:),           &
                            rp(:,:), np(:,:), area(:)
  complex(O),allocatable :: a(:,:), b(:,:), t(:,:), c(:), c1(:), cc(:), em(:,:)
!
  phiGS  = 0._O
  Nteta  = 11       
  beta   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1
  Nmax   = Nrank
  m  = 1
  write (iOutput,"(3x,'--- Convergence Test over Nint and NXint ---',/)")  
  allocate (a(2*Nrank,2*Nrank), b(2*Nrank,2*Nrank), t(2*Nrank,2*Nrank),             &
            c(2*Nrank), c1(2*Nrank), zRe(Nrank), zIm(Nrank),                        &
            rp(2,NfacePD), np(2,NfacePD), area(NfacePD))
  Nmaxmax = Nrank + Mrank*(2*Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta), em(3,Nteta))
  do i = 1, Nteta
    oldh(i) = 0._O
    oldv(i) = 0._O
  end do 
  do i = 1, Nrank
    zRe(i) = 0._O
    zIm(i) = 0._O
  end do
  Nface = 1
  do i = 1, NfacePD
    do j = 1, 2
      rp(j,i) = 0._O
      np(j,i) = 0._O
    end do
    area(i) = 0._O
  end do 
  kb = 0._O 
  if (PrnProgress) call write_progress (.true., 1, 11)   
  do iNint = 1, 2     
    allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam, Nintparam,   &
         paramG, weightsG, miror)      
    allocate (Xint(NXint), pondereX(NXint))
    call Laguerre (NXint, Xint, pondereX)       
    call matrix_Q_m (.false., TypeGeom, 3, 1, k, ind_ref_p, Nsurf, surf,            &
         rp, np, area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam,    &
         paramG, weightsG, miror, perfectcond, .false., .false., kb, a, Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 2+5*(iNint-1), 11)
    call matrix_Q_m (.false., TypeGeom, 1, 1, k, ind_ref_p, Nsurf, surf,            &
         rp, np, area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam,    &
         paramG, weightsG, miror, perfectcond, .false., .false., kb, b, Nrank, Nrank)
    if (PrnProgress) call write_progress (.false., 3+5*(iNint-1), 11)
    call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)        
    if (PrnProgress) call write_progress (.false., 4+5*(iNint-1), 11) 
    call copy_matrix (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, t, 2*Nrank, 2*Nrank)
    call matrixPARTSUB (k, ind_ref_s, z0, m, Nrank, Nmax, NXint, Xint, pondereX,    &
         a, Nrank, Nrank)   
    call product_matrixSUB (b, 2*Nrank, 2*Nrank, a, 2*Nrank, 2*Nrank, 2*Nmax)  
    if (PrnProgress) call write_progress (.false., 5+5*(iNint-1), 11)
    call LU_SYSTEM_DIRECT (b, 2*Nrank, 2*Nrank, t, 2*Nrank, 2*Nrank, 2*Nmax, 2*Nmax)
    if (PrnProgress) call write_progress (.false., 6+5*(iNint-1), 11)
    if (TypeScat == 1) then                       
      call PWcoefficientsPARTSUB (beta, alfap, m, Nrank, Nmax, c)
      call PWcoefficientsPARTSUBrefl (beta, alfap, z0, k, ind_ref_s, m, Nrank,      &
           Nmax, c1)
      call sum_vectors (c, c1, 2*Nmax)    
    else  
      call PWcoefficientsPARTSUBtrans (beta, alfap, z0, k, ind_ref_s, m, Nrank,     &
           Nmax, c)
    end if
    call product_matrix_vector (2*Nmax, 2*Nmax, t, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)         
    call matrix_m_negativ (Nmax, Nmax, t, Nrank, Nrank) 
    if (TypeScat == 1) then   
      call PWcoefficientsPARTSUB (beta, alfap, -m, Nrank, Nmax, c)
      call PWcoefficientsPARTSUBrefl (beta, alfap, z0, k, ind_ref_s, -m, Nrank,     &
           Nmax, c1)
      call sum_vectors (c, c1, 2*Nmax)    
    else
      call PWcoefficientsPARTSUBtrans (beta, alfap, z0, k, ind_ref_s, -m, Nrank,    &
           Nmax, c)
    end if
    call product_matrix_vector (2*Nmax, 2*Nmax, t, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)                                              
    do j = 1, 3
      do i = 1, Nteta        
        em(j,i) = zero 
      end do
    end do               
    call DSCSPARTSUB (1, cc, k, z0, ind_ref_s, Mrank, Nrank, Nmaxmax, Nteta, phiGS, &
         snorm, em,.true., h, v)
    call DSCSPARTSUB (2, cc, k, z0, ind_ref_s, Mrank, Nrank, Nmaxmax, Nteta, phiGS, &
         snorm, em,.true., h, v)                       
    call delta_DSCSPARTSUB (m, Nteta, h, v, oldh, oldv, epsNint, NthetaConv)
    write (iOutput, "(1x, a, i4, a, i4, a, i3, a, i3, /)")                          &
   'Nint = ', Nint, ', NXint = ', NXint, ', Nrank = ', Nrank, ', Mrank = ', m    
    call write_DSCSPARTSUB (Nteta, h, v)
    Nint  = Nint + dNint
    NXint = NXint + dNint
    deallocate (paramG, weightsG, Nintparam, Xint, pondereX)
  end do  
  write (iOutput,"(3x, a, i2, a, /, 3x, a, 1f5.2, a, /)")                           &
 '--- the solution converges in ', NthetaConv, ' points ---',                       &
 '--- with an relative error of', 100*epsNint, ' %    ---' 
  if (NthetaConv >= int(0.8*(Nteta - 2))) then
    print "(/,2x,'Convergence criterion for Nint and NXint is satisfied;')" 
  else
    print "(/,2x,'Convergence criterion for Nint and NXint is not satisfied;')"                 
  end if
  deallocate (a, b, t, c, c1, cc, h, v, oldh, oldv, em, zRe, zIm, rp, np, area)  
end subroutine convergence_NintPARTSUB 
! **********************************************************************************
subroutine convergence_NrankPARTSUB (TypeGeom, TypeScat, k, ind_ref_s, ind_ref_p,   &
           z0, snorm, Nsurf, surf, Nparam, Nrank, Nint, NXint, miror, perfectcond,  &
           epsNrank, PrnProgress) 
  use parameters                 
  implicit none 
  integer    :: Nsurf, Nparam, Nrank, Nint, NXint, TypeGeom, TypeScat        
  real(O)    :: surf(Nsurf), snorm, k, epsNrank, z0
  complex(O) :: ind_ref_s, ind_ref_p
  logical    :: miror, perfectcond, PrnProgress 
!  
  integer    :: Mstart, Nteta, Mrank, Nmax, Nmaxmax, i, m, j, NthetaConv, Nface
  real(O)    :: beta, alfap, phiGS, kb
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), Xint(:), pondereX(:),       &
                            h(:), v(:), oldh(:), oldv(:), zRe(:), zIm(:),           &
                            rp(:,:), np(:,:), area(:)
  complex(O),allocatable :: a(:,:), b(:,:), t(:,:), c(:), c1(:), cc(:), em(:,:),    &
                            a1(:,:), b1(:,:), a0(:,:)
!
  phiGS  = 0._O
  Nteta  = 11 
  beta   = 0._O
  alfap  = Pi / 4._O
  Mstart = 1
  Mrank  = 1
  Nmax   = Nrank
  m  = 1  
  call write_TypeConvHead (2)
  allocate (a(2*Nrank,2*Nrank), b(2*Nrank,2*Nrank), t(2*Nrank,2*Nrank),             &
            c(2*Nrank), c1(2*Nrank), zRe(Nrank), zIm(Nrank),                        &
            rp(2,NfacePD), np(2,NfacePD), area(NfacePD))    
  allocate (a1(2*Nrank,2*Nrank), b1(2*Nrank,2*Nrank), a0(2*Nrank,2*Nrank))
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta), em(3,Nteta))        
  allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
  call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam, Nintparam,     &
       paramG, weightsG, miror)      
  allocate (Xint(NXint), pondereX(NXint))
  call Laguerre (NXint, Xint, pondereX)           
  do i = 1, Nrank
    zRe(i) = 0._O
    zIm(i) = 0._O
  end do
  Nface = 1
  do i = 1, NfacePD
    do j = 1, 2
      rp(j,i) = 0._O
      np(j,i) = 0._O
    end do
    area(i) = 0._O
  end do
  kb = 0._O  
  if (PrnProgress) call write_progress (.true., 1, 10)
! --- Nrank configuration ---            
  call matrix_Q_m (.false., TypeGeom, 3, 1, k, ind_ref_p, Nsurf, surf,              &
       rp, np, area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam,      &
       paramG, weightsG, miror, perfectcond, .false., .false., kb, a, Nrank, Nrank)
  if (PrnProgress) call write_progress (.false., 2, 10)
  call copy_matrix (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, a1, 2*Nrank, 2*Nrank)  
  call matrix_Q_m (.false., TypeGeom, 1, 1, k, ind_ref_p, Nsurf, surf,              &
       rp, np, area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam,      &
       paramG, weightsG, miror, perfectcond, .false., .false., kb, b, Nrank, Nrank)
  if (PrnProgress) call write_progress (.false., 3, 10)
  call copy_matrix (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, b1, 2*Nrank, 2*Nrank)
  call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)          
  if (PrnProgress) call write_progress (.false., 4, 10)
  call copy_matrix (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, t, 2*Nrank, 2*Nrank)
  call matrixPARTSUB (k, ind_ref_s, z0, m, Nrank, Nmax, NXint, Xint, pondereX, a,   &
       Nrank, Nrank)                                                                                  
  call copy_matrix (2*Nmax, 2*Nmax, a, 2*Nrank, 2*Nrank, a0, 2*Nrank, 2*Nrank)
  call product_matrixSUB (b, 2*Nrank, 2*Nrank, a, 2*Nrank, 2*Nrank, 2*Nmax)      
  if (PrnProgress) call write_progress (.false., 5, 10)
  call LU_SYSTEM_DIRECT (b, 2*Nrank, 2*Nrank, t, 2*Nrank, 2*Nrank, 2*Nmax, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 6, 10)
  if (TypeScat == 1) then                         
    call PWcoefficientsPARTSUB (beta, alfap, m, Nrank, Nmax, c)
    call PWcoefficientsPARTSUBrefl (beta, alfap, z0, k, ind_ref_s, m, Nrank,        &
         Nmax, c1)
    call sum_vectors (c, c1, 2*Nmax)   
  else
    call PWcoefficientsPARTSUBtrans (beta, alfap, z0, k, ind_ref_s, m, Nrank,       &
         Nmax, c)   
  end if
  call product_matrix_vector (2*Nmax, 2*Nmax, t, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)         
  call matrix_m_negativ (Nmax, Nmax, t, Nrank, Nrank)
  if (TypeScat == 1) then
    call PWcoefficientsPARTSUB (beta, alfap, -m, Nrank, Nmax, c)
    call PWcoefficientsPARTSUBrefl (beta, alfap, z0, k, ind_ref_s, -m, Nrank,       &
         Nmax, c1)
    call sum_vectors (c, c1, 2*Nmax)  
  else
    call PWcoefficientsPARTSUBtrans (beta, alfap, z0, k, ind_ref_s, -m, Nrank,      &
         Nmax, c)
  end if
  call product_matrix_vector (2*Nmax, 2*Nmax, t, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)                                            
  do j = 1, 3
    do i = 1, Nteta
      em(j,i) = zero
    end do
  end do          
  call DSCSPARTSUB (1, cc, k, z0, ind_ref_s, Mrank, Nrank, Nmaxmax, Nteta, phiGS,   &
       snorm, em,.true., h, v)
  call DSCSPARTSUB (2, cc, k, z0, ind_ref_s, Mrank, Nrank, Nmaxmax, Nteta, phiGS,   &
       snorm, em,.true., h, v)                   
  do i = 1, Nteta
    oldh(i) = h(i)
    oldv(i) = v(i)
  end do  
  write (iOutput, "(1x, a, i4, a, i4, a, i3, a, i3, /)")                            &
 'Nint = ', Nint, ', NXint = ', NXint, ', Nrank = ', Nrank, ', Mrank = ', m 
  call write_DSCSPARTSUB (Nteta, h, v)  
! --- (Nrank - 1) configuration ---            
  call copy_matrix (2*Nmax, 2*Nmax, a1, 2*Nrank, 2*Nrank, a, 2*Nrank, 2*Nrank)
  call matrix_Nrank_m_left (Nmax, a, Nrank, Nrank)      
  call copy_matrix (2*Nmax, 2*Nmax, b1, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank)
  call matrix_Nrank_m (Nmax, b, Nrank, Nrank)                                      
  if (PrnProgress) call write_progress (.false., 7, 10)
  call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)        
  if (PrnProgress) call write_progress (.false., 8, 10)
  call copy_matrix (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, t, 2*Nrank, 2*Nrank)  
  call copy_matrix (2*Nmax, 2*Nmax, a0, 2*Nrank, 2*Nrank, a, 2*Nrank, 2*Nrank)
  call matrix_Nrank_m (Nmax, a, Nrank, Nrank)
  call product_matrixSUB (b, 2*Nrank, 2*Nrank, a, 2*Nrank, 2*Nrank, 2*Nmax)        
  if (PrnProgress) call write_progress (.false., 9, 10)
  call LU_SYSTEM_DIRECT (b, 2*Nrank, 2*Nrank, t, 2*Nrank, 2*Nrank, 2*Nmax, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 10, 10)
  if (TypeScat == 1) then                 
    call PWcoefficientsPARTSUB (beta, alfap, m, Nrank, Nmax, c)
    call PWcoefficientsPARTSUBrefl (beta, alfap, z0, k, ind_ref_s, m, Nrank,        &
         Nmax, c1)
    call sum_vectors (c, c1, 2*Nmax)  
  else
    call PWcoefficientsPARTSUBtrans (beta, alfap, z0, k, ind_ref_s, m, Nrank,       &
         Nmax, c)
  end if
  call product_matrix_vector (2*Nmax, 2*Nmax, t, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)         
  call matrix_m_negativ (Nmax, Nmax, t, Nrank, Nrank)
  if (TypeScat == 1) then
    call PWcoefficientsPARTSUB (beta, alfap, -m, Nrank, Nmax, c)
    call PWcoefficientsPARTSUBrefl (beta, alfap, z0, k, ind_ref_s, -m, Nrank,       &
         Nmax, c1)
    call sum_vectors (c, c1, 2*Nmax)  
  else
    call PWcoefficientsPARTSUBtrans (beta, alfap, z0, k, ind_ref_s, -m, Nrank,      &
         Nmax, c)
  end if
  call product_matrix_vector (2*Nmax, 2*Nmax, t, 2*Nrank, 2*Nrank, c, c1)
  call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)                                              
  do j = 1, 3
    do i = 1, Nteta
      em(j,i) = zero
    end do
  end do                
  call DSCSPARTSUB (1, cc, k, z0, ind_ref_s, Mrank, Nrank, Nmaxmax, Nteta, phiGS,   &
       snorm, em,.true., h, v)
  call DSCSPARTSUB (2, cc, k, z0, ind_ref_s, Mrank, Nrank, Nmaxmax, Nteta, phiGS,   &
       snorm, em,.true., h, v)                   
  call delta_DSCSPARTSUB (m, Nteta, h, v, oldh, oldv, epsNrank, NthetaConv)    
  write (iOutput, "(1x, a, i4, a, i4, a, i3, a, i3, /)")                            &
 'Nint = ', Nint, ', NXint = ', NXint, ', Nrank = ', Nrank - 1, ', Mrank = ', m 
  call write_DSCSPARTSUB (Nteta, h, v)
  call write_NrankConvRes (NthetaConv, Nteta - 2, epsNrank)
  deallocate (a1, b1, a0)
  deallocate (paramG, weightsG, Nintparam)
  deallocate (Xint, pondereX)
  deallocate (a, b, t, c, c1, cc, h, v, oldh, oldv, em, zRe, zIm, rp, np, area)      
end subroutine convergence_NrankPARTSUB      
! **********************************************************************************
subroutine convergence_MrankPARTSUB (TypeGeom, TypeScat, k, ind_ref_s, ind_ref_p,   &
           z0, snorm, Nsurf, surf, Nparam, Nrank, Nint, NXint, miror, perfectcond,  &
           epsMrank, PrnProgress) 
  use parameters                 
  implicit none 
  integer       :: Nsurf, Nparam, Nrank, Nint, NXint, TypeGeom, TypeScat     
  real(O)       :: surf(Nsurf), snorm, k, epsMrank, z0
  complex(O)    :: ind_ref_s, ind_ref_p
  logical       :: miror, perfectcond, PrnProgress      
!  
  integer       :: Mstart, Nteta, Mrank, Nmax, Nmaxmax, i, m, j, NthetaConv, Nface
  real(O)       :: beta, alfap, phiGS, kb
  character(80) :: FileTmat
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:), Xint(:), pondereX(:),       &
                            h(:), v(:), oldh(:), oldv(:), zRe(:), zIm(:),           &
                            rp(:,:), np(:,:), area(:)
  complex(O),allocatable :: a(:,:), b(:,:), t(:,:), c(:), c1(:), cc(:), em(:,:)               
!
  phiGS  = 0._O
  Nteta  = 11        
  beta   = Pi / 4._O
  alfap  = Pi / 4._O
  Mstart = 0
  Mrank  = Nrank  
  FileTmat = '../TMATFILES/TPartSub.dat'
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call  write_HeadFileTmat (Nrank, Nrank) 
  call write_TypeConvHead (3)
  write (iOutput, "(1x, a, i4, a, i4, a, i3, /)")                                   &
 'Nint = ', Nint, ', NXint = ', NXint, ', Nrank = ', Nrank
  allocate (a(2*Nrank,2*Nrank), b(2*Nrank,2*Nrank), t(2*Nrank,2*Nrank),             &
            c(2*Nrank), c1(2*Nrank), zRe(Nrank), zIm(Nrank),                        &
            rp(2,NfacePD), np(2,NfacePD), area(NfacePD))
  Nmaxmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (cc(2*Nmaxmax))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta), em(3,Nteta))   
  do i = 1, Nteta   
    oldh(i) = 0._O
    oldv(i) = 0._O          
  end do
  do i = 1, Nrank
    zRe(i) = 0._O
    zIm(i) = 0._O
  end do
  Nface = 1
  do i = 1, NfacePD
    do j = 1, 2
      rp(j,i) = 0._O
      np(j,i) = 0._O
    end do
    area(i) = 0._O
  end do
  kb = 0._O        
  allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
  call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam, Nintparam,     &
       paramG, weightsG, miror)      
  allocate (Xint(NXint), pondereX(NXint))
  call Laguerre (NXint, Xint, pondereX) 
  Mrank = - 1
  do m = Mstart, Nrank   
    call write_1ConvParam (m)         
    Mrank = Mrank + 1
    if (m == 0) then
      Nmax = Nrank
    else
      Nmax = Nrank - m + 1
    end if
    if (PrnProgress) call write_progress_m (.true., m, 1, 6)            
    call matrix_Q_m (.false., TypeGeom, 3, 1, k, ind_ref_p, Nsurf, surf,            &
         rp, np, area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam,    &
         paramG, weightsG, miror, perfectcond, .false., .false., kb, a, Nrank, Nrank)
    if (PrnProgress) call write_progress_m (.false., m, 2, 6)                                   
    call matrix_Q_m (.false., TypeGeom, 1, 1, k, ind_ref_p, Nsurf, surf,            &
         rp, np, area, Nface, zRe, zIm, m, Nrank, Nmax, Nint, Nparam, Nintparam,    &
         paramG, weightsG, miror, perfectcond, .false., .false., kb, b, Nrank, Nrank)
    if (PrnProgress) call write_progress_m (.false., m, 3, 6)
    call LU_SYSTEM (a, 2*Nrank, 2*Nrank, b, 2*Nrank, 2*Nrank, 2*Nmax)           
    if (PrnProgress) call write_progress_m (.false., m, 4, 6)
    call copy_matrix (2*Nmax, 2*Nmax, b, 2*Nrank, 2*Nrank, t, 2*Nrank, 2*Nrank)
    call matrixPARTSUB (k, ind_ref_s, z0, m, Nrank, Nmax, NXint, Xint, pondereX,    &
         a, Nrank, Nrank)
    call product_matrixSUB (b, 2*Nrank, 2*Nrank, a, 2*Nrank, 2*Nrank, 2*Nmax)     
    if (PrnProgress) call write_progress_m (.false., m, 5, 6)
    call LU_SYSTEM_DIRECT (b, 2*Nrank, 2*Nrank, t, 2*Nrank, 2*Nrank, 2*Nmax, 2*Nmax)  
    if (PrnProgress) call write_progress_m (.false., m, 6, 6)
    call write_FileTmat (Nrank, Nrank, t)
    if (TypeScat == 1) then                      
      call PWcoefficientsPARTSUB (beta, alfap, m, Nrank, Nmax, c)
      call PWcoefficientsPARTSUBrefl (beta, alfap, z0, k, ind_ref_s, m, Nrank,      &
           Nmax, c1)
      call sum_vectors (c, c1, 2*Nmax)     
    else
      call PWcoefficientsPARTSUBtrans (beta, alfap, z0, k, ind_ref_s, m, Nrank,     &
           Nmax, c)
    end if
    call product_matrix_vector (2*Nmax, 2*Nmax, t, 2*Nrank, 2*Nrank, c, c1)
    call extend_vector_positive (c1, cc, m, Mstart, Nrank, Nmax, Nmaxmax)         
    if (m /= 0) then
      call matrix_m_negativ (Nmax, Nmax, t, Nrank, Nrank)  
      if (TypeScat == 1) then    
        call PWcoefficientsPARTSUB (beta, alfap, -m, Nrank, Nmax, c)
        call PWcoefficientsPARTSUBrefl (beta, alfap, z0, k, ind_ref_s, -m, Nrank,   &
             Nmax, c1)
        call sum_vectors (c, c1, 2*Nmax)      
      else
        call PWcoefficientsPARTSUBtrans (beta, alfap, z0, k, ind_ref_s, -m, Nrank,  &
             Nmax, c)
      end if
      call product_matrix_vector (2*Nmax, 2*Nmax, t, 2*Nrank, 2*Nrank, c, c1)
      call extend_vector_negative (c1, cc, m, Nrank, Nmax, Nmaxmax)                                          
    end if
    do j = 1, 3
      do i = 1, Nteta
        em(j,i) = zero
      end do
    end do               
    call DSCSPARTSUB (1, cc, k, z0, ind_ref_s, Mrank, Nrank, Nmaxmax, Nteta, phiGS, &
         snorm, em,.true., h, v)
    call DSCSPARTSUB (2, cc, k, z0, ind_ref_s, Mrank, Nrank, Nmaxmax, Nteta, phiGS, &
         snorm, em,.true., h, v)                       
    call delta_DSCSPARTSUB (m, Nteta, h, v, oldh, oldv, epsMrank, NthetaConv)           
    call write_DSCSPARTSUB (Nteta, h, v)
    if (NthetaConv >= int(0.8*(Nteta - 2))) exit 
  end do
  close (unit = iTmat)
  call write_MrankConvRes (NthetaConv, epsMrank)
  if (NthetaConv >= int(0.8*(Nteta - 2))) then
    print "(/,2x,'Convergence criterion for Mrank is satisfied;')"                                  
  else
    print "(/,2x,'Convergence criterion for Mrank is not satisfied;')"
  end if
  call DiffScatCrossSectPARTSUB (TypeScat, k, ind_ref_s, z0, snorm, Nrank, Mrank,   &
       FileTmat)
  deallocate (paramG, weightsG, Nintparam)
  deallocate (Xint, pondereX)
  deallocate (a, b, t, c, c1, cc, h, v, oldh, oldv, em, zRe, zIm, rp, np, area)       
end subroutine convergence_MrankPARTSUB      

subroutine TMULTSPH
!------------------------------------------------------------------------------------
! 1. General Considerations                                                         !
! --------------------------                                                        !
! TMULTSPH is a routine for computing the T matrix and the scattering               !
! characteristics of clusters of homogeneous, dielectric spheres. The particles in  !
! the cluster can have the same radius or different radii.                          !
!                                                                                   !
! 2. Convergence Test                                                               !
! --------------------                                                              !
! In the code, the maximum expansion and azimuthal orders Nrank and Mrank of the    !
! cluster are independent on the maxium expansion and azimuthal orders              !
! NrankPart(i) and MrankPart(i), i = 1,...,Npart, of all spherical particles        !
! forming the cluster. The convergence tests are carried out over Nrank and Mrank,  !
! while NrankPart(i) and MrankPart(i), i = 1,...,Npart, are kept constant.          !
!                                                                                   !
! For convergence tests, the incident wave is assumed to be a plane wave traveling  !
! along the Z-axis of the global coordinate system and the scattering               !
! characteristics are computed in the azimuthal plane phi = 0°. The Euler           !
! orientation angles of the cluster are alphaC = betaC = 45° and gammaC = 0°, and   !
! interactive convergence tests over Nrank and Mrank are performed.                 !
!                                                                                   !  
! For the convergence test over the expansion order, the scattering problem is      !
! solved for the pairs (Nrank, Mrank) and (Nrank - 1, Mrank), while for the         !
! azimuthal order test, the cases (Nrank, Mrank) and (Nrank, Mrank - 1) are         !
! considered. The normalized differential scattering cross section will be checked  !
! at 20° increments for convergence within epsX (epsNint,epsNrank or epsMrank)      !
! tolerance. If the calculated results are converged within this tolerance at       !
! 80% of the scattering angles, then convergence is achieved. The T matrix is       !
! stored for later use by other programs, and the values of Nrank and Mrank are     !
! printed to the screen and to the T-matrix information file (see                   !
! "Description.txt"). These values together with the T matrix serve as INPUT        !
! PARAMETERS for other programs.                                                    !
!                                                                                   !
! An estimate of Nrank is given by Wiscombe's truncation limit criterion            !
! [W. J. Wiscombe, Improved Mie scattering algorithms, Applied Optics, 19,          !
! 1505-1509, 1980], i.e.,                                                           !
!                                                                                   !
!                NrankW = int(x + 4.05 * x**0.33 + 2),                              !
!                                                                                   !
! where x is the size parameter, x = k * Rcirc, k is the wave number and Rcirc is   !
! the radius of the smallest sphere enclosing the cluster. For the azimuthal order  !
! test, Mrank can be chosen as Nrank - 2,..,Nrank. The same prescriptions hold for  !
! NrankPart(i) and MrankPart(i) for all i = 1,2,...,Npart.                          !
!                                                                                   ! 
! The convergence tests can be switched off by setting the logical variable         !
! DoConvTest to false. In this case, the values of Nrank and Mrank must be          !
! specified in the input file.                                                      !
!                                                                                   !
! 3. Input Parameters                                                               !
! --------------------                                                              !
! The parameters specified in the input file "/INPUTFILES/InputMULTSPH.dat" are     !
! listed below.                                                                     !
!                                                                                   !
! - wavelength (real) - wavelength of the incident light in vacuo.                  !
!                                                                                   !
! - ind_refMed (real) - refractive index of the ambient medium (nonabsorbing        !
!   dielectric medium).                                                             !
!                                                                                   !
! - Npart (integer) - number of spherical particles.                                !
!                                                                                   !
! - anorm (real) - characteristic length of the cluster which is used to normalize  !
!   the differential scattering cross sections.                                     ! 
!                                                                                   !
! - Rcirc (real) - characteristic length of the cluster (usually the radius of the  !
!   smallest circumscribing sphere) which is used to compute an estimate of the     !
!   maximum expansion order by using Wiscombe's truncation limit criterion (the size!
!   parameter is x = k * Rcirc, where k is the wave number in the ambient medium).  !
!   This parameter must be specified if the interactive convergence tests are       !
!   performed (DoConvTest = t).                                                     ! 
!                                                                                   !
! - identical (logical) - if identical = true, the spherical particles have the     !
!   same radius. Otherwise, the radii are different.                                !
!                                                                                   !
! The next parameters (specified in two group statements) correspond to each        !
! spherical particle. THE GROUP STATEMENTS MUST BE REPEATED FOR ALL Npart           !
! PARTICLES. FOR IDENTICAL PARTICLES, USES AFTER THE TmatPart KEYWORD, A BLANK      !
! LINE.                                                                             ! 
!                                                                                   !
! - rPart (real) - radius of the actual spherical particle.                         !
!                                                                                   !
! - NrankPart, MrankPart (integer variables) - maximum expansion and azimuthal      !
!   orders for the actual spherical particle.                                       !
!                                                                                   !
! - ind_refPart (complex) - relative refractive index of the actual spherical       !
!   particle with respect to the ambient medium.                                    !
!                                                                                   !
! - xPart, yPart, zPart (real variables) - Cartesian coordinates specifying the     !
!   position of the actual spherical particle with respect to the coordinate        !
!   system of the cluster.                                                          !
!                                                                                   !
! - DoConvTest (logical) - if DoConvTest = t, the interactive convergence tests     !
!   over Nrank and Mrank are performed. An estimates of Nrank is given by           !
!   Wiscombe's truncation limit criterion. If DoConvTest = f, the values of Nrank   !
!   and Mrank must be supplied in the input file.                                   !
!                                                                                   !
! - ExtThetaDom (logical) - if ExtThetaDom = t the DSCS is computed for             !
!   scattering angles ranging from 0° to 180° in the azimuthal plane phiGS = 0°,    !
!   and from 180° to 0° in the azimuthal plane phiGS = 180°. The total number of    !
!   scattering angles is 10. If ExtThetaDom = f the DSCS is computed for            !
!   scattering angles ranging from 0° to 180° in the azimuthal plane phiGS = 0°.    !
!                                                                                   !
! - Nrank (integer) - maximum expansion order for the cluster. This parameter is    !
!   used if the convergence tests are not performed (DoConvTest = f).               !
!                                                                                   !
! - Mrank (integer) - maximum azimuthal order for the cluster. This parameter is    !
!   used if the convergence tests are not performed (DoConvTest = f).               !
!                                                                                   !
! - epsNrank (real) - error tolerance for the expansion order test.                 !
!                                                                                   !
! - epsMrank (real) - error tolerance for the azimuthal order test.                 !
!                                                                                   !
! - FileTmat (character(80)) - name of the file to which the T matrix of the        !
!   cluster is written.                                                             !
!                                                                                   !
! - PrnProgress (logical) - if PrnProgress = t, the progress of calculation         !
!   is printed.                                                                     !
!                                                                                   !
! Note that all input parameters specifying lengths must be provided in the same    !
! units of lengths.                                                                 !
!                                                                                   !
! 4. Logical Scheme                                                                 !
! ------------------                                                                !  
! The organization of the code is as follows:                                       !
! 1. < read input data; the input file provides:                                    !
!    - the radius of each spherical particle,                                       !
!    - the maximum expansion and azimuthal orders NrankPart and MrankPart, and      ! 
!    - the Cartesian coordinates specifying the position of each spherical          !
!      particle >                                                                   ! 
!                                                                                   !   
! 2. < T-matrix calculation >                                                       !
!                                                                                   !
!    if ( do convergence test ) then                                                !
!                                                                                   !
!      < the code computes an estimate of Nrank accordingly to                      !
!        Wiscombe's truncation criterion >                                          !
!      < the code prompts for the estimated values of Nrank and Mrank >             !
!                                                                                   !
!    else if ( .not. do convergence test ) then                                     !
!                                                                                   !
!       < the input file provides the values of Nrank and Mrank >                   !
!                                                                                   !
!    end if                                                                         !
!    if ( do convergence test ) then                                                !
!       < the code computes the DSCS for (Nrank,Mrank), (Nrank - 1,Mrank) and       ! 
!        (Nrank, Mrank - 1) and write the results to the file "Output.dat" >        !
!       < the T matrix is stored in the file FileTmat and the T-matrix information  !
!         file is created >                                                         !
!       < Mrank and Nrank are written to the screen and to the T-matrix             !
!         information file >                                                        ! 
!       < go to Step 3 >                                                            !
!    end if                                                                         !
!    if ( .not. convergence test ) then                                             !
!       < the T matrix is stored in the file FileTmat and the T-matrix information  !
!         file is created >                                                         !
!       < Mrank and Nrank are written to the screen and to the T-matrix             !
!         information file >                                                        ! 
!       < go to Step 3 >                                                            !
!    end if                                                                         !
! 3. < scattering characteristics calculation >                                     !   
!------------------------------------------------------------------------------------
  use parameters
  use allocation, only: Mrankp, Nrankp, rp, xp, yp, zp, ind_refp
  implicit none 
  integer       :: Npart, Mrank, Nrank
  real(O)       :: k, ind_refMED, wavelength, anorm, snorm, epsNrank, epsMrank, Rcirc
  character(80) :: FileTmat
  logical       :: identical, DoConvTest, ExtThetaDom, PrnProgress  
! -----------------------------------------------------------------------------------
!                      Read the input file FileInputMULTSPH                         ! 
! -----------------------------------------------------------------------------------
  call readinputMULTSPH ( wavelength, ind_refMed, Npart, anorm, Rcirc,              &
       identical, DoConvTest, ExtThetaDom, Nrank, Mrank, epsNrank, epsMrank,        &
       FileTmat, PrnProgress, k, snorm)  
! -----------------------------------------------------------------------------------
!                                      Main                                         !
! ----------------------------------------------------------------------------------- 
  if (DoConvTest) then     
    open (unit = iOutput, file = FileOutput, status = "replace")
    call printinputMULTSPH (wavelength, ind_refMed, Npart, identical, rp, xp, yp,   &
         zp, ind_refp, Mrankp, Nrankp, epsNrank, epsMrank, anorm, Rcirc)
    call convergence_Nrank_MrankMULTSPH (k, snorm, Npart, identical, rp, xp, yp,    &
         zp, ind_refp, Mrankp, Nrankp, Mrank, Nrank, epsNrank, epsMrank,            &
         ExtThetaDom, FileTmat, PrnProgress)
    close (unit = iOutput)
  else
    call TMatrix_Nrank_MrankMULTSPH (k, Npart, identical, rp, xp, yp, zp, ind_refp, &
         Mrankp, Nrankp, Mrank, Nrank, FileTmat, PrnProgress)
  end if
  deallocate (Mrankp, Nrankp, rp, xp, yp, zp, ind_refp)  
end subroutine TMULTSPH
!***********************************************************************************
subroutine readinputMULTSPH ( wavelength, ind_refMed, Npart, anorm, Rcirc,          &
           identical, DoConvTest, ExtThetaDom, Nrank, Mrank, epsNrank, epsMrank,    &
           FileTmat, PrnProgress, k, snorm)   
  use parameters
  use derived_parameters
  use allocation, only: Mrankp, Nrankp, rp, xp, yp, zp, ind_refp
  implicit none 
  integer       :: Npart, MrankPart, NrankPart, ipart, Mrank, Nrank, ios, NrankW
  real(O)       :: k, ind_refMED, wavelength, anorm, x, snorm, epsNrank, epsMrank,  &
                   rPart, xPart, yPart, zPart, Rcirc, xR
  complex(O)    :: ind_refPart
  character(80) :: FileTmat, string
  logical       :: identical, DoConvTest, ExtThetaDom, PrnProgress, XFindPar
! -----------------------------------------------------------------------------------
!                         Read the input file FileInputMULTSPH                      ! 
! ----------------------------------------------------------------------------------- 
  call DrvParameters 
  open (unit = iInputMULTSPH, file = FileInputMULTSPH, status = "old",              &
        position = "rewind")   
  wavelength = 0.1_O * 2._O * Pi                                                                    
  ind_refMed = 1.5_O
  string     = 'OptProp'
  if (XFindPar (iInputMULTSPH, string)) then
    read (iInputMULTSPH, *, iostat = ios) wavelength
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if
    read (iInputMULTSPH, *, iostat = ios) ind_refMed
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refMed;')"
      stop
    end if         
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if        
  k = 2._O * Pi * ind_refMed / wavelength  
!
  Npart = 2
  anorm = 1._O   
  Rcirc = 1._O
  identical = .false.
  string    = 'GenProp'
  if (XFindPar (iInputMULTSPH, string)) then
    read (iInputMULTSPH, *, iostat = ios) Npart
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Npart')"
      stop
    end if
    read (iInputMULTSPH, *, iostat = ios) anorm
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anorm;')"
      stop
    end if
    read (iInputMULTSPH, *, iostat = ios) Rcirc
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Rcirc;')"
      stop
    end if 
    read (iInputMULTSPH, *, iostat = ios) identical
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable identical;')"
      stop
    end if
  else
    print "(/,2x,'Group name GenProp not found;')"
    stop  
  end if    
  call check_anorm (anorm)    
  x = k * anorm
  snorm = Pi * x * x       
!
  allocate (Mrankp(Npart), Nrankp(Npart), rp(Npart), xp(Npart), yp(Npart),          &
            zp(Npart), ind_refp(Npart)) 
  do ipart = 1, Npart    
    rPart = 1.0_O    
    NrankPart   = 6
    MrankPart   = 4
    ind_refPart = (1.5_O,0._O) 
    string     = 'TmatPart'
    if (.not. identical .or. ipart == 1) then
      if (XFindPar (iInputMULTSPH, string)) then
        read (iInputMULTSPH, *, iostat = ios) rPart
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable rPart')"
          print "(  2x,'for the particle ',i3,';')", ipart
          stop
        end if      
        read (iInputMULTSPH, *, iostat = ios) NrankPart
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable NrankPart;')"
          print "(  2x,'for the particle ',i3,';')", ipart 
          stop
        end if
        read (iInputMULTSPH, *, iostat = ios) MrankPart
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable MrankPart;')"
          print "(  2x,'for the particle ',i3,';')", ipart 
          stop
        end if
        read (iInputMULTSPH, *, iostat = ios) ind_refPart
        if (ios /= 0) then
          print "(/,2x,'Error by reading the input variable ind_refPart;')"
          print "(  2x,'for the particle ',i3,';')", ipart 
          stop
        end if
      else
        print "(/,2x,'Group name TmatPart not found;')"
        stop  
      end if
      call check_MrankNrank (MrankPart, NrankPart)  
      rp(ipart) = rPart    
      Nrankp(ipart)   = NrankPart
      Mrankp(ipart)   = MrankPart
      ind_refp(ipart) = ind_refPart
    else
      rp(ipart) = rp(ipart-1)     
      Nrankp(ipart)   = Nrankp(ipart-1)
      Mrankp(ipart)   = Mrankp(ipart-1)
      ind_refp(ipart) = ind_refp(ipart-1)
    end if
!
    xPart = 0.1_O
    yPart = 0.1_O
    zPart = 0.1_O  
    string    = 'GeomPartProp'
    if (XFindPar (iInputMULTSPH, string)) then
      read (iInputMULTSPH, *, iostat = ios) xPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable xPart')"
        print "(  2x,'for the particle ',i3,';')", ipart
        stop
      end if
      read (iInputMULTSPH, *, iostat = ios) yPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable yPart;')"
        print "(  2x,'for the particle ',i3,';')", ipart
        stop
      end if
      read (iInputMULTSPH, *, iostat = ios) zPart
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable zPart;')"
        print "(  2x,'for the particle ',i3,';')", ipart
        stop
      end if
    else
      print "(/,2x,'Group name GeomPartProp not found;')"
      stop  
    end if
    xp(ipart) = xPart
    yp(ipart) = yPart
    zp(ipart) = zPart
  end do  
!
  DoConvTest  = .true.
  ExtThetaDom = .true.
  string      = 'ConvTest'
  if (XFindPar (iInputMULTSPH, string)) then
    read (iInputMULTSPH, *, iostat = ios) DoConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DoConvTest')"
      stop
    end if
    read (iInputMULTSPH, *, iostat = ios) ExtThetaDom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ExtThetaDom;')"
      stop
    end if            
  else
    print "(/,2x,'Group name ConvTest not found;')"
    stop  
  end if    
!
  if (DoConvTest) then
    print "(/,2x,'Convergence Test for a Cluster of Spheres')"
    print "(  2x,'-----------------------------------------')"
  else
    print "(/,2x,'T-Matrix Computation for a Cluster of Spheres')"
    print "(  2x,'---------------------------------------------')"
  end if
!
  xR = k * Rcirc
  NrankW = int(xR + 4.05_O * xR**0.33_O + 2._O)
  if (.not. DoConvTest) then
    Nrank  =  16
    Mrank  =   8
    string = 'NrankMrankCluster'
    if (XFindPar (iInputMULTSPH, string)) then
      read (iInputMULTSPH, *, iostat = ios) Nrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nrank')"
        stop
      end if
      read (iInputMULTSPH, *, iostat = ios) Mrank
      if (ios /= 0) then
       print "(/,2x,'Error by reading the input variable Mrank;')"
       stop
      end if            
    else
      print "(/,2x,'Group name NrankMrankCluster not found;')"
      stop  
    end if   
    print "(/,2x,'Input values:')"
    print "(  2x, a, i4, a, i4, a)",                                                &
   'the input values of Nrank and Mrank are ', Nrank, ' and', Mrank, ', while'
    print "(  2x, a, i3, a)",                                                       &
   'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'
  else  
    print "(/,2x,'Nrank estimate:')"                                                    
    print "(  2x, a, i3, a)",                                                       &
   'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'
    print "(/,2x,'- enter the estimated values of Nrank and Mrank, where')"     
    print "(  2x,'  it is recommended to set Mrank = Nrank - 2,...,Nrank;')"        
    call read_integer2 (Nrank, Mrank)                                   
  end if 
  call check_MrankNrank (Mrank, Nrank)    
!
  epsNrank = 5.e-2_O
  epsMrank = 5.e-2_O 
  string   = 'Errors'
  if (XFindPar (iInputMULTSPH, string)) then
    read (iInputMULTSPH, *, iostat = ios) epsNrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNrank;')"
      stop
    end if
    read (iInputMULTSPH, *, iostat = ios) epsMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsMrank;')"
      stop
    end if            
  else
    print "(/,2x,'Group name Errors not found;')"
    stop  
  end if           
!
  FileTmat = '../TMATFILES/T.dat'
  string   = 'Tmat'
  if (XFindPar (iInputMULTSPH, string)) then
    read (iInputMULTSPH, *, iostat = ios) FileTmat
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileTmat;')"
      stop
    end if             
  else
    print "(/,2x,'Group name Tmat not found;')"
    stop  
  end if    
!
  PrnProgress = .true.
  string      = 'PrintProgress'
  if (XFindPar (iInputMULTSPH, string)) then
    read (iInputMULTSPH, *, iostat = ios) PrnProgress
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if             
  else
    print "(/,2x,'Group name PrintProgress not found;')"
    stop  
  end if         
  close (unit = iInputMULTSPH)  
end subroutine readinputMULTSPH
!***********************************************************************************
subroutine printinputMULTSPH (wavelength, ind_refMed, Npart, identical, rp, xp, yp, &
           zp, ind_refp, Mrankp, Nrankp, epsNrank, epsMrank, anorm, Rcirc)
  use parameters
  implicit none  
  integer       :: Npart, i, Mrankp(Npart), Nrankp(Npart)
  real(O)       :: wavelength, ind_refMed, xp(Npart), yp(Npart), zp(Npart),         &
                   epsNrank, epsMrank, rp(Npart), anorm, Rcirc
  complex(O)    :: ind_refp(Npart)
  logical       :: identical  
!
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x,'wavelength of the free space, wavelength = ',1pe13.4,';')")  &
         wavelength
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'refractive index of the ambient medium, ind_refMed = ', ind_refMed, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'characteristic length of the cluster, anorm = ', anorm, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'radius of the circumscribing sphere, Rcirc =', Rcirc, ';'
  write (iOutput,*)
  if (identical) then
    write (iOutput,"(2x,'identical particles;')")
    write (iOutput,"(2x,'radius: r = ',1pe10.3,';')") rp(1)
    write (iOutput,"(2x, a, 1pe10.3,',', 1pe10.3, a)")                              &
   'relative refractive index, ind_refRel = (', ind_refp(1), ');'  
    write (iOutput,"(2x,'number of particles: Npart = ',i3,';')") Npart 
    write (iOutput,"(2x,'maximum expansion order, Nrank = ',i3,';')") Nrankp(1)
    write (iOutput,"(2x,'maximum azimuthal order, Mrank = ',i3,';')") Mrankp(1)      
    do i = 1, Npart        
      write (iOutput,"(2x, a, i3, a, 1pe10.3, a, 1pe10.3, a, 1pe10.3, a)")          &
     'Cartesian coordinates of the particle ', i, ': x = ', xp(i), ', y = ', yp(i), &
     ', z = ', zp(i), ';'                   
    end do
    write (iOutput,*)       
  else  
    write (iOutput,"(2x,'number of particles: Npart = ',i3,';')") Npart
    write (iOutput,*)
    do i = 1, Npart  
      write (iOutput,"(2x,'particle: ',i3)") i    
      write (iOutput,"(2x,'radius, r = ',1pe10.3,';')") rp(i)
      write (iOutput,"(2x, a, 1pe10.3, ',', 1pe10.3, a)")                           &
     'relative refractive index, ind_refRel = (', ind_refp(i), ');'  
      write (iOutput,"(2x,'maximum expansion order, Nrank = ',i3,';')") Nrankp(i)
      write (iOutput,"(2x,'maximum azimuthal order, Mrank = ',i3,';')") Mrankp(i)       
      write (iOutput,"(2x, a, i3, a, 1pe10.3, a, 1pe10.3, a, 1pe10.3, a)")          &
     'Cartesian coordinates of the particle ', i, ': x = ', xp(i), ', y = ', yp(i), &
     ', z = ', zp(i), ';'                             
      write (iOutput,*) 
    end do
  end if  
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum expansion order tolerance, epsNrank = ', epsNrank, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum azimuthal order tolerance, epsMrank = ', epsMrank, '.'            
  write (iOutput,"(/)")                       
end subroutine printinputMULTSPH
!***********************************************************************************
subroutine convergence_Nrank_MrankMULTSPH (k, snorm, Npart, identical, rp, xp, yp,  &
           zp, ind_refp, Mrankp, Nrankp, Mrank, Nrank, epsNrank, epsMrank,          &
           ExtThetaDom, FileTmat, PrnProgress)
  use parameters
  implicit none
  integer       :: Npart, Mrankp(Npart), Nrankp(Npart), Mrank, Nrank
  real(O)       :: k, snorm, rp(Npart), xp(Npart), yp(Npart), zp(Npart), epsNrank,  &
                   epsMrank
  complex(O)    :: ind_refp(Npart)
  character(80) :: FileTmat
  logical       :: identical, ExtThetaDom, PrnProgress
!       
  integer       :: Nmax, Nmaxmax, Nteta, ipart, jpart, NthetaConvN, NthetaConvM,    &
                   Nl, Nc, Mrankpl, Nrankpl, Nmaxpl, Mrankpl1, Nrankpl1, Nmaxpl1,   &
                   i, NmaxAL  
  real(O)       :: r, alfaPol, x, y, z, tetaGI, phiGI, phiGS,                       &
                   x1, y1, z1, dx, dy, dz, alfaC, betaC, gamaC, Cscat, Qscat,       &
                   Cext, Qext
  complex(O)    :: ind_ref
  integer,allocatable    :: Nmaxp(:)
  real(O),allocatable    :: h(:), v(:), oldh(:), oldv(:), oldh0(:), oldv0(:)
  complex(O),allocatable :: aa(:,:), bb(:,:), a(:,:), b(:,:), t(:), c(:), c1(:)   
!
  tetaGI  = 0._O
  phiGI   = 0._O
  phiGS   = 0._O
  Nteta   = 10
  alfaC   = Pi / 4._O
  betaC   = Pi / 4._O
  gamaC   = 0._O
  alfaPol = Pi / 4._O
  Nmax    = Nrank + Mrank * (2 * Nrank - Mrank + 1) 
  NmaxAL  = Nmax
  allocate (Nmaxp(Npart))
  if (.not. identical) then
    Nmaxmax = 0
    do ipart = 1, Npart
      Nmaxp(ipart) = Nrankp(ipart) + Mrankp(ipart) * (2 * Nrankp(ipart) -           &
                     Mrankp(ipart) + 1)
      Nmaxmax      = Nmaxmax + Nmaxp(ipart)      
      if (Nmaxp(ipart) > NmaxAL) NmaxAL = Nmaxp(ipart)
      if (Nmaxp(ipart) > Nmax) then
        print "(/,2x, a, i3, a)",                                                   &
       'Warning: the input values of Nrank and Mrank are too low for particle ',ipart, ';'        
      end if 
    end do
  else 
    Nmaxp(1) = Nrankp(1) + Mrankp(1) * (2 * Nrankp(1) - Mrankp(1) + 1)
    Nmaxmax  = Nmaxp(1) * Npart
    if (Nmaxp(1) > NmaxAL) then
      NmaxAL = Nmaxp(1)     
      print "(/,2x,'Warning: the input values of Nrank and Mrank are too low;')"
    end if  
  end if     
  call write_TypeConvHead (4)
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call  write_HeadFileTmat (NmaxAL, NmaxAL) 
  allocate (aa(2*Nmaxmax,2*Nmaxmax), bb(2*Nmaxmax,2*NmaxAL))        
  allocate (a(2*NmaxAL,2*NmaxAL), b(2*NmaxAL,2*NmaxAL), c(2*NmaxAL), c1(2*NmaxAL))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta), oldh0(Nteta),             &
            oldv0(Nteta))       
  call identity_matrix (2*Nmaxmax, aa, 2*Nmaxmax, 2*Nmaxmax)
  if (PrnProgress) call write_progress (.true., 1, 2*Npart+2)
  if (.not. identical) then              
    Nl = 0  
    do ipart = 1, Npart   
      Mrankpl = Mrankp(ipart)
      Nrankpl = Nrankp(ipart)
      Nmaxpl  = Nmaxp(ipart)
      allocate (t(2*Nmaxpl))
      r       = rp(ipart)
      ind_ref = ind_refp(ipart)
      call coefficients_fg (k, r, ind_ref, Mrankpl, Nrankpl, Nmaxpl, t)         
      x  = xp(ipart)
      y  = yp(ipart)
      z  = zp(ipart)    
      Nc = 0    
      do jpart = 1, Npart           
        if (jpart /= ipart) then
          Mrankpl1 = Mrankp(jpart)
          Nrankpl1 = Nrankp(jpart)
          Nmaxpl1  = Nmaxp(jpart)
          x1 = xp(jpart)
          y1 = yp(jpart)
          z1 = zp(jpart)
          dx = x1 - x
          dy = y1 - y
          dz = z1 - z       
          call MatTransAB_mn_m1n1 (3, k, dx, dy, dz, Mrankpl, Nrankpl, Nmaxpl,      &
               Mrankpl1, Nrankpl1, Nmaxpl1, a, NmaxAL, NmaxAL)
          call product_matrix_vector1 (2*Nmaxpl, 2*Nmaxpl1, t, a, 2*NmaxAL,         &
               2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)                         
          call extend_matrix1 (ipart, jpart, Npart, Nmaxp, Nl, Nc, b, NmaxAL,       &
               NmaxAL, aa, Nmaxmax, Nmaxmax)                                                    
        end if
        Nc = Nc + 2 * Nmaxp(jpart)      
      end do        
      call MatTransAB_mn_m1n1 (1, k, -x, -y, -z, Mrankpl, Nrankpl, Nmaxpl, Mrank,   &
           Nrank, Nmax, a, NmaxAL, NmaxAL)
      call product_matrix_vector1 (2*Nmaxpl, 2*Nmax, t, a, 2*NmaxAL, 2*NmaxAL,      &
           b, 2*NmaxAL, 2*NmaxAL)    
      call extend_matrix2 (ipart, Npart, Nmaxp, Nmax, Nmaxmax, Nl, b, NmaxAL,       &
           NmaxAL, bb, Nmaxmax, NmaxAL)          
      Nl = Nl + 2 * Nmaxp(ipart)          
      if (PrnProgress) call write_progress (.false., ipart+1, 2*Npart+2)     
      deallocate (t)
    end do
  else     
    Mrankpl = Mrankp(1)
    Nrankpl = Nrankp(1)
    Nmaxpl  = Nmaxp(1)
    allocate (t(2*Nmaxpl))
    r       = rp(1)
    ind_ref = ind_refp(1)   
    call coefficients_fg (k, r, ind_ref, Mrankpl, Nrankpl, Nmaxpl, t)
    Nl = 0  
    do ipart = 1, Npart                 
      x  = xp(ipart)
      y  = yp(ipart)
      z  = zp(ipart)    
      Nc = 0    
      do jpart = 1, Npart           
        if (jpart > ipart) then          
          x1 = xp(jpart)
          y1 = yp(jpart)
          z1 = zp(jpart)
          dx = x1 - x
          dy = y1 - y
          dz = z1 - z
          call MatTransAB_mn_m1n1 (3, k, dx, dy, dz, Mrankpl, Nrankpl, Nmaxpl,      &
               Mrankpl, Nrankpl, Nmaxpl, a, NmaxAL, NmaxAL)
          call product_matrix_vector1 (2*Nmaxpl, 2*Nmaxpl, t, a, 2*NmaxAL,          &
               2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)
          call extend_matrix3 (Nmaxpl, Nmaxpl, Nl, Nc, b, NmaxAL, NmaxAL,           &
               aa, Nmaxmax, Nmaxmax)
          call matrix_inverse (Mrankpl, Nrankpl, Nmaxpl, Mrankpl, Nrankpl, Nmaxpl,  &
               a, NmaxAL, NmaxAL)
          call product_matrix_vector1 (2*Nmaxpl, 2*Nmaxpl, t, a, 2*NmaxAL,          &
               2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)
          call extend_matrix3 (Nmaxpl, Nmaxpl, Nc, Nl, b, NmaxAL, NmaxAL,           &
               aa, Nmaxmax, Nmaxmax)                                                                    
        end if
        Nc = Nc + 2 * Nmaxpl      
      end do        
      call MatTransAB_mn_m1n1 (1, k, -x, -y, -z, Mrankpl, Nrankpl, Nmaxpl, Mrank,   &
           Nrank, Nmax, a, NmaxAL, NmaxAL)
      call product_matrix_vector1 (2*Nmaxpl, 2*Nmax, t, a, 2*NmaxAL, 2*NmaxAL,      &
           b, 2*NmaxAL, 2*NmaxAL)
      call extend_matrix4 (ipart, Nmaxpl, Nmax, Nmaxmax, Nl, b, NmaxAL, NmaxAL,     &
           bb, Nmaxmax, NmaxAL)                  
      Nl = Nl + 2 * Nmaxpl        
      if (PrnProgress) call write_progress (.false., ipart+1, 2*Npart+2)      
    end do
    deallocate (t)
  end if        
  call LU_SYSTEM_DIRECT (aa, 2*Nmaxmax, 2*Nmaxmax, bb, 2*Nmaxmax, 2*NmaxAL,         &
       2*Nmaxmax, 2*Nmax)
  if (PrnProgress) call write_progress (.false., Npart+2, 2*Npart+2)         
  deallocate (aa)
  allocate (aa(2*NmaxAL,2*NmaxAL))
  Nl = 0
  Mrankpl = Mrankp(1)
  Nrankpl = Nrankp(1)
  Nmaxpl  = Nmaxp(1)
  do ipart = 1, Npart    
    if (.not. identical) then
      Mrankpl = Mrankp(ipart)
      Nrankpl = Nrankp(ipart)
      Nmaxpl  = Nmaxp(ipart)      
    end if
    x = xp(ipart)
    y = yp(ipart)
    z = zp(ipart)    
    if (.not. identical) then
      call extract_matrix1 (ipart, Npart, Nmaxp, Nmax, Nl, b, NmaxAL, NmaxAL,       &
           bb, Nmaxmax, NmaxAL)
    else 
      call extract_matrix2 (Nmaxpl, Nmax, Nl, b, NmaxAL, NmaxAL, bb, Nmaxmax, NmaxAL)
    end if
    call MatTransAB_mn_m1n1 (1, k, x, y, z, Mrank, Nrank, Nmax, Mrankpl, Nrankpl,   &
         Nmaxpl, aa, NmaxAL, NmaxAL)                              
    call product_matrices2 (ipart, 2*Nmax, 2*Nmaxpl, 2*Nmax, aa, 2*NmaxAL,          &
         2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL, a, 2*NmaxAL, 2*NmaxAL)                            
    Nl = Nl + 2 * Nmaxpl
    if (PrnProgress) call write_progress (.false., Npart+2+ipart, 2*Npart+2)
  end do   
  call copy_matrix (2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)
  call write_FileTmat (NmaxAL, NmaxAL, a)
  call PWcoefficients_ab (tetaGI, phiGI, alfaC, betaC, gamaC, alfaPol, Mrank,       &
       Nrank, Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfaC, betaC, gamaC, k, snorm,   &
       ExtThetaDom,.true., h, v)
  call CQscat (c1, Mrank, Nrank, Nmax, k, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfaC, betaC, gamaC,           &
       alfaPol, k, snorm, Cext, Qext)    
  call write_2ConvParam (Nrank, Mrank)               
  call write_DSCS (Nteta, ExtThetaDom, h, v)  
  call write_Effic (Qscat, Qext)
  do i = 1, Nteta
    oldh(i)  = h(i)
    oldv(i)  = v(i)
    oldh0(i) = h(i)
    oldv0(i) = v(i)
  end do
  close (unit = iTmat)  
! --- (Nrank - 1) configuration ---  
  if (PrnProgress) call write_progress_low      
  call matrix_Nrank_1_right (Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)  
  call PWcoefficients_ab (tetaGI, phiGI, alfaC, betaC, gamaC, alfaPol, Mrank,       &
       Nrank, Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, a, 2*NmaxAL, 2*NmaxAL, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfaC, betaC, gamaC, k, snorm,   &
       ExtThetaDom,.true., h, v)
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConvN)
  call CQscat (c1, Mrank, Nrank, Nmax, k, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfaC, betaC, gamaC,           &
       alfaPol, k, snorm, Cext, Qext)    
  call write_2ConvParam (Nrank - 1, Mrank)
  call write_DSCS (Nteta, ExtThetaDom, h, v) 
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConvN, Nteta, epsNrank)
! --- (Mrank - 1) configuration ---  
  call matrix_Mrank_1_right (Mrank, Nrank, Nmax, b, NmaxAL, NmaxAL)  
  call PWcoefficients_ab (tetaGI, phiGI, alfaC, betaC, gamaC, alfaPol, Mrank,       &
       Nrank, Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfaC, betaC, gamaC, k, snorm,   &
       ExtThetaDom,.true., h, v)
  call delta_DSCS (Nteta, h, v, oldh0, oldv0, epsMrank, NthetaConvM)
  call CQscat (c1, Mrank, Nrank, Nmax, k, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfaC, betaC, gamaC,           &
       alfaPol, k, snorm, Cext, Qext)    
  call write_2ConvParam (Nrank, Mrank - 1)
  call write_DSCS (Nteta, ExtThetaDom, h, v) 
  call write_Effic (Qscat, Qext)
  call write_MrankConvRes (NthetaConvM, epsMrank)
  if (NthetaConvN >= int(0.8*Nteta) .and. NthetaConvM >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criteria for Nrank and Mrank are satisfied;')"                         
  else
    print "(/,2x,'Convergence criteria for Nrank and Mrank are not satisfied;')"
  end if   
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .false., .false., .false.)
  call ScatCharact (k, FileTmat, Mrank, Nrank, .false., .false., .false.) 
  print "(/,2x,'The T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank  
  deallocate (aa, bb, a, b, c, c1, h, v, oldh, oldv, oldh0, oldv0, Nmaxp)       
end subroutine convergence_Nrank_MrankMULTSPH
!***********************************************************************************
subroutine TMatrix_Nrank_MrankMULTSPH (k, Npart, identical, rp, xp, yp, zp,         &
           ind_refp, Mrankp, Nrankp, Mrank, Nrank, FileTmat, PrnProgress)
  use parameters
  implicit none
  integer       :: Npart, Mrankp(Npart), Nrankp(Npart), Mrank, Nrank
  real(O)       :: k, rp(Npart), xp(Npart), yp(Npart), zp(Npart)                   
  complex(O)    :: ind_refp(Npart)
  character(80) :: FileTmat
  logical       :: identical, PrnProgress
!       
  integer       :: Nmax, Nmaxmax, ipart, jpart, Nl, Nc, Mrankpl, Nrankpl, Nmaxpl,   &
                   Mrankpl1, Nrankpl1, Nmaxpl1, NmaxAL  
  real(O)       :: r, x, y, z, x1, y1, z1, dx, dy, dz                             
  complex(O)    :: ind_ref
  integer,allocatable    :: Nmaxp(:)
  complex(O),allocatable :: aa(:,:), bb(:,:), a(:,:), b(:,:), t(:)   
!  
  Nmax    = Nrank + Mrank * (2 * Nrank - Mrank + 1) 
  NmaxAL  = Nmax
  allocate (Nmaxp(Npart))
  if (.not. identical) then
    Nmaxmax = 0
    do ipart = 1, Npart
      Nmaxp(ipart) = Nrankp(ipart) + Mrankp(ipart) * (2 * Nrankp(ipart) -           &
                     Mrankp(ipart) + 1)
      Nmaxmax      = Nmaxmax + Nmaxp(ipart)      
      if (Nmaxp(ipart) > NmaxAL) NmaxAL = Nmaxp(ipart)
      if (Nmaxp(ipart) > Nmax) then
        print "(/,2x, a, i3, a)",                                                   &
       'Warning: the input values of Nrank and Mrank are too low for particle ',ipart,';'        
      end if 
    end do
  else 
    Nmaxp(1) = Nrankp(1) + Mrankp(1) * (2 * Nrankp(1) - Mrankp(1) + 1)
    Nmaxmax  = Nmaxp(1) * Npart
    if (Nmaxp(1) > NmaxAL) then
      NmaxAL = Nmaxp(1)     
      print "(/,2x,'Warning: the input values of Nrank and Mrank are too low;')"
    end if  
  end if     
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call  write_HeadFileTmat (NmaxAL, NmaxAL) 
  allocate (aa(2*Nmaxmax,2*Nmaxmax), bb(2*Nmaxmax,2*NmaxAL))        
  allocate (a(2*NmaxAL,2*NmaxAL), b(2*NmaxAL,2*NmaxAL))
  call identity_matrix (2*Nmaxmax, aa, 2*Nmaxmax, 2*Nmaxmax)
  if (PrnProgress) call write_progress (.true., 1, 2*Npart+2)
  if (.not. identical) then              
    Nl = 0  
    do ipart = 1, Npart   
      Mrankpl = Mrankp(ipart)
      Nrankpl = Nrankp(ipart)
      Nmaxpl  = Nmaxp(ipart)
      allocate (t(2*Nmaxpl))
      r       = rp(ipart)
      ind_ref = ind_refp(ipart)
      call coefficients_fg (k, r, ind_ref, Mrankpl, Nrankpl, Nmaxpl, t)         
      x  = xp(ipart)
      y  = yp(ipart)
      z  = zp(ipart)    
      Nc = 0    
      do jpart = 1, Npart           
        if (jpart /= ipart) then
          Mrankpl1 = Mrankp(jpart)
          Nrankpl1 = Nrankp(jpart)
          Nmaxpl1  = Nmaxp(jpart)
          x1 = xp(jpart)
          y1 = yp(jpart)
          z1 = zp(jpart)
          dx = x1 - x
          dy = y1 - y
          dz = z1 - z       
          call MatTransAB_mn_m1n1 (3, k, dx, dy, dz, Mrankpl, Nrankpl, Nmaxpl,      &
               Mrankpl1, Nrankpl1, Nmaxpl1, a, NmaxAL, NmaxAL)
          call product_matrix_vector1 (2*Nmaxpl, 2*Nmaxpl1, t, a, 2*NmaxAL,         &
               2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)                         
          call extend_matrix1 (ipart, jpart, Npart, Nmaxp, Nl, Nc, b, NmaxAL,       &
               NmaxAL, aa, Nmaxmax, Nmaxmax)                                                    
        end if
        Nc = Nc + 2 * Nmaxp(jpart)      
      end do        
      call MatTransAB_mn_m1n1 (1, k, -x, -y, -z, Mrankpl, Nrankpl, Nmaxpl, Mrank,   &
           Nrank, Nmax, a, NmaxAL, NmaxAL)
      call product_matrix_vector1 (2*Nmaxpl, 2*Nmax, t, a, 2*NmaxAL, 2*NmaxAL,      &
           b, 2*NmaxAL, 2*NmaxAL)    
      call extend_matrix2 (ipart, Npart, Nmaxp, Nmax, Nmaxmax, Nl, b, NmaxAL,       &
           NmaxAL, bb, Nmaxmax, NmaxAL)          
      Nl = Nl + 2 * Nmaxp(ipart)          
      if (PrnProgress) call write_progress (.false., ipart+1, 2*Npart+2)     
      deallocate (t)
    end do
  else     
    Mrankpl = Mrankp(1)
    Nrankpl = Nrankp(1)
    Nmaxpl  = Nmaxp(1)
    allocate (t(2*Nmaxpl))
    r       = rp(1)
    ind_ref = ind_refp(1)   
    call coefficients_fg (k, r, ind_ref, Mrankpl, Nrankpl, Nmaxpl, t)
    Nl = 0  
    do ipart = 1, Npart                 
      x  = xp(ipart)
      y  = yp(ipart)
      z  = zp(ipart)    
      Nc = 0    
      do jpart = 1, Npart           
        if (jpart > ipart) then          
          x1 = xp(jpart)
          y1 = yp(jpart)
          z1 = zp(jpart)
          dx = x1 - x
          dy = y1 - y
          dz = z1 - z
          call MatTransAB_mn_m1n1 (3, k, dx, dy, dz, Mrankpl, Nrankpl, Nmaxpl,      &
               Mrankpl, Nrankpl, Nmaxpl, a, NmaxAL, NmaxAL)
          call product_matrix_vector1 (2*Nmaxpl, 2*Nmaxpl, t, a, 2*NmaxAL,          &
               2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)
          call extend_matrix3 (Nmaxpl, Nmaxpl, Nl, Nc, b, NmaxAL, NmaxAL,           &
               aa, Nmaxmax, Nmaxmax)
          call matrix_inverse (Mrankpl, Nrankpl, Nmaxpl, Mrankpl, Nrankpl, Nmaxpl,  &
               a, NmaxAL, NmaxAL)
          call product_matrix_vector1 (2*Nmaxpl, 2*Nmaxpl, t, a, 2*NmaxAL,          &
               2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)
          call extend_matrix3 (Nmaxpl, Nmaxpl, Nc, Nl, b, NmaxAL, NmaxAL,           &
               aa, Nmaxmax, Nmaxmax)                                                                    
        end if
        Nc = Nc + 2 * Nmaxpl      
      end do        
      call MatTransAB_mn_m1n1 (1, k, -x, -y, -z, Mrankpl, Nrankpl, Nmaxpl, Mrank,   &
           Nrank, Nmax, a, NmaxAL, NmaxAL)
      call product_matrix_vector1 (2*Nmaxpl, 2*Nmax, t, a, 2*NmaxAL, 2*NmaxAL,      &
           b, 2*NmaxAL, 2*NmaxAL)
      call extend_matrix4 (ipart, Nmaxpl, Nmax, Nmaxmax, Nl, b, NmaxAL, NmaxAL,     &
           bb, Nmaxmax, NmaxAL)                  
      Nl = Nl + 2 * Nmaxpl        
      if (PrnProgress) call write_progress (.false., ipart+1, 2*Npart+2)      
    end do
    deallocate (t)
  end if        
  call LU_SYSTEM_DIRECT (aa, 2*Nmaxmax, 2*Nmaxmax, bb, 2*Nmaxmax, 2*NmaxAL,         &
       2*Nmaxmax, 2*Nmax)
  if (PrnProgress) call write_progress (.false., Npart+2, 2*Npart+2)         
  deallocate (aa)
  allocate (aa(2*NmaxAL,2*NmaxAL))
  Nl = 0
  Mrankpl = Mrankp(1)
  Nrankpl = Nrankp(1)
  Nmaxpl  = Nmaxp(1)
  do ipart = 1, Npart    
    if (.not. identical) then
      Mrankpl = Mrankp(ipart)
      Nrankpl = Nrankp(ipart)
      Nmaxpl  = Nmaxp(ipart)      
    end if
    x = xp(ipart)
    y = yp(ipart)
    z = zp(ipart)    
    if (.not. identical) then
      call extract_matrix1 (ipart, Npart, Nmaxp, Nmax, Nl, b, NmaxAL, NmaxAL,       &
           bb, Nmaxmax, NmaxAL)
    else 
      call extract_matrix2 (Nmaxpl, Nmax, Nl, b, NmaxAL, NmaxAL, bb, Nmaxmax, NmaxAL)
    end if
    call MatTransAB_mn_m1n1 (1, k, x, y, z, Mrank, Nrank, Nmax, Mrankpl, Nrankpl,   &
         Nmaxpl, aa, NmaxAL, NmaxAL)                              
    call product_matrices2 (ipart, 2*Nmax, 2*Nmaxpl, 2*Nmax, aa, 2*NmaxAL,          &
         2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL, a, 2*NmaxAL, 2*NmaxAL)                            
    Nl = Nl + 2 * Nmaxpl
    if (PrnProgress) call write_progress (.false., Npart+2+ipart, 2*Npart+2)
  end do   
  call write_FileTmat (NmaxAL, NmaxAL, a)  
  close (unit = iTmat)  
  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .false., .false., .false.)
  call ScatCharact (k, FileTmat, Mrank, Nrank, .false., .false., .false.) 
  print "(/,2x,'The T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank  
  deallocate (aa, bb, a, b, Nmaxp)      
end subroutine TMatrix_Nrank_MrankMULTSPH

program TMATRIX
  implicit none
  integer  :: TypeCode 
! -----------------------------------------------------------------------------------
!                           Select the type of T-matrix code                        ! 
! -----------------------------------------------------------------------------------   
   print "(/,2x,'T-Matrix Code for Light Scattering Calculation')"
   print "(  2x,'----------------------------------------------')"       
   print "(/,2x,'- enter an integer specifying the scattering problem:                ')"
   print "(  2x,'   1 - dielectric, perfectly conducting or chiral, axisymmetric particle;   ')"   
   print "(  2x,'   2 - dielectric, perfectly conducting or chiral, nonaxisymmetric particle;')"            
   print "(  2x,'   3 - axisymmetric, composite particle;                             ')"
   print "(  2x,'   4 - axisymmetric, layered particle;                               ')"
   print "(  2x,'   5 - inhomogeneous, axisymmetric particle with an arbitrary inclusion;    ')"  
   print "(  2x,'   6 - inhomogeneous sphere with a spherical inclusion;              ')"   
   print "(  2x,'   7 - inhomogeneous sphere with an arbitrarily shaped inclusion;    ')"
   print "(  2x,'   8 - inhomogeneous sphere with multiple spherical inclusions;      ')"
   print "(  2x,'   9 - cluster of arbitrarily shaped particles;                      ')"
   print "(  2x,'  10 - two dielectric spheres;                                       ')"
   print "(  2x,'  11 - cluster of dielectric spheres;                                ')"      
   print "(  2x,'  12 - cluster of dielectric spheres (recursive algorithm);          ')"
   print "(  2x,'  13 - concentrically, layered sphere;                               ')"
   print "(  2x,'  14 - dielectric or perfectly conducting, axisymmetric particle     ')"
   print "(  2x,'       on or near a plane surface;                                   ')"  
   print "(  2x,'  15 - scattering characteristics using the previously calculated T matrix; ')" 
   print "(  2x,'  16 - scattering characteristics of an ensemble of spherical particles;    ')" 
   print "(  2x,'  17 - effective wave number of a medium with spherical particles;          ')"                    
   call read_integer (TypeCode)   
   if (TypeCode < 1 .or. TypeCode > 17) then
     print "(/,2x,'Input error: the integer specifying the type of the T-matrix    ')"
     print "(  2x,'code is out of bounds;                                          ')"
     stop
   end if      
! -----------------------------------------------------------------------------------
!                                        Main                                       !
! -----------------------------------------------------------------------------------
  select case (TypeCode)
  case (1)
    call TAXSYM
  case (2)
    call TNONAXSYM
  case (3)    
    call TCOMP
  case (4)    
    call TLAY
  case (5)    
    call TINHOM
  case (6)    
    call TINHOM2SPH
  case (7)    
    call TINHOMSPH
  case (8)    
    call TINHOMSPHREC
  case (9)    
    call TMULT
  case (10)    
    call TMULT2SPH 
  case (11)    
    call TMULTSPH
  case (12)    
    call TMULTSPHREC 
  case (13)    
    call TSPHERE      
  case (14)    
    call TPARTSUB     
  case (15)    
    call SCT
  case (16)    
    call SCTAVRGSPH
  case (17)    
    call EFMED           
  end select
end 

subroutine TMULTSPHREC
!------------------------------------------------------------------------------------
! 1. General Considerations                                                         !
! --------------------------                                                        !
! TMULTSPH is a routine for computing the T matrix and the scattering               !
! characteristics of clusters of homogeneous, dielectric spheres using a recursive  ! 
! algorithm. The particles are IDENTICALLY and randomly distributed. The routine    !
! "SphConfig" from the file "Random.f90" generates a random distribution of         !
! particles using the sequential addition method. The user can implement other      !
! particle distributions by modifying this routine. However, the list of            !
! parameters must be maintained .                                                   !
!                                                                                   !
! The T matrix of a system of two particles 1 and 2 can be expressed in terms of    !
! the T matrices of each particle, i.e.,                                            !
!                                                                                   !
!            T =  TR1(O,O1) * T1 * [I - TR3(O1,O2) * T2 * TR3(O2,O1) * T1 ]^(-1)    !
!               * [TR3(O1,O2) * T2 * TR1(O2,O) + TR1(O1,O) ]                        !
!               + TR1(O,O2) * T3 * [I - TR3(O2,O1) * T1 * TR3(O1,O2) * T2 ]^(-1)    ! 
!               * [TR3(O2,O1) * T1 * TR1(O1,O) + TR1(O2,O) ],                       !
!                                                                                   ! 
! where T1 and T2 are the transition matrices of the particles 1 and 2,             !
! respectively. The recursive algorithm is used to compute the T matrix of          !
! the cluster. Essentially, the T matrix of a system of Npart particles is          !
! computed by using the T matrices of the new added q particles and the T matrix of !
! the previous system of Npart - q particles. Let us consider Ncs concentric        !
! spheres with radii Rcirc(i), i = 1,2,..,Ncs, in increasing order. Inside the      !
! sphere of radius Rcirc(1) there are N(1) particles, and in the spherical shell    !
! bounded by Rcirc(i-1) and Rcirc(i) there are N(i) particles. At the first         !
! iteration step we compute the T matrix T(1) of all particles situated inside the  !
! sphere of radius Rcirc(1). At the iteration step i, we compute the transition     !
! matrix T(i) of all particles situated inside the sphere of radius Rcirc(i), that  !
! is, the system T-matrix of the N(1) + N(2) + ...+ N(i) particles. The system      ! 
! T-matrix T(i) is computed by using the system T-matrix T(i-1) and the individual  !
! transition matrices of all N(i) particles situated in the spherical shell between !
! Rcirc(i-1) and Rcirc(i). The procedure is repeated unlit all particles are        !
! exhausted, and it is apparent that at each iteration step, only a                 !
! N(i)+1-scatterer problem needs to be solved, where N(i) usually is much smaller   !
! than Npart. Thus, we can keep the dimension of the problem manageable even when   !
! Npart is very large. The geometric constraint of the T-matrix method requires     !
! that the N(i) particles completely reside inside the spherical shell between      !
! Rcirc(i-1) and Rcirc(i). However, numerical simulations certify the accuracy      !
! of the recursive scheme for small size parameters and large particle numbers.     !
!                                                                                   !
! 2. Convergence Test                                                               !
! --------------------                                                              !
! The input file generates a sequence of Ncs concentric spheres with radii          !  
! Rcirc(i), i = 1,2,...,Ncs, in increasing order. For each auxiliary                !
! sphere i, the maximum expansion order NrankCirc(i) and the number of azimuthal    !
! modes MrankCirc(i) are specified in the input file. The maximum expansion         !  
! order Nrank and the number of azimuthal modes Mrank for the spherical particles   !
! are also supplied in the input file. The convergence tests are carried out over   !
! NrankCirc(Ncs) and MrankCirc(Ncs) (corresponding to the largest auxiliary sphere),!
! while Nrank and Mrank are kept constant.                                          !
!                                                                                   !
! For convergence tests, the incident wave is assumed to be a plane wave traveling  !
! along the Z-axis of the global coordinate system and the scattering               !
! characteristics are computed in the azimuthal plane  phi = 0°. The Euler          !
! orientation angles of the cluster are alphaC = betaC = 45° and gammaC = 0°, and   !
! convergence tests over NrankCirc(Ncs) and  MrankCirc(Ncs) are performed.          !
!                                                                                   !
! For the convergence tests over the expansion order, the scattering problem is     !
! solved for the pairs (NrankCirc(Ncs),MrankCirc(Ncs)) and                          !
! (NrankCirc(Ncs) - 1,MrankCirc(Ncs)), while for the azimuthal order test, the      !
! cases (NrankCirc(Ncs),MrankCirc(Ncs)) and (NrankCirc(Ncs),MrankCirc(Ncs) - 1) are !
! considered. The normalized differential scattering cross section will be checked  !
! at 20° increments for convergence within epsX (epsNint,epsNrank or epsMrank)      !
! tolerance. If the calculated results are converged within this tolerance at       !
! 80% of the scattering angles, then convergence is achieved. The T matrix is       !
! stored for later use by other programs, and the values of NrankCirc(Ncs) and      !
! MrankCirc(Ncs) are printed to the screen and to the T-matrix information file     !
! (see "Description.txt"). These values together with the T matrix serve as INPUT   !
! PARAMETERS for other programs.                                                    !
!                                                                                   !
! The values of NrankCirc(i), i = 1,2,...,Ncs, and Nrank can be computed with       !
! Wiscombe's truncation limit criterion [W. J. Wiscombe, Improved Mie scattering    !
! algorithms, Applied Optics, 19, 1505-1509, 1980]. MrankCirc(i) can be chosen as   !
! MrankCirc(i) = NrankCirc(i) - 2,...,NrankCirc(i) and Mrank as Mrank = Nrank.      !
! In general, these prescriptions guarantee convergence. The main problem which     !
! has to be solved is the selection of the concentric spheres. The radii must be    !
! chosen such that the numbers of particles in each spherical shell do not vary     !
! significantly. Because the total computer time can be expressed as                !
!                                                                                   !
!                      CPU_total = Ncs * CPU_shell,                                 !
!                                                                                   !
! where CPU_shell is the computer time for a specific shell calculation, and        !
!                                                                                   !  
!                      CPU_shell ~ Npart / Ncs,                                     !
!                                                                                   ! 
! an optimum value of Ncs should be found by repeated simulations.                  !
!                                                                                   !
! The convergence tests can be switched off by setting the logical variable         !
! DoConvTest to false.                                                              !
!                                                                                   !
! 3. Input Parameters                                                               !
! ---------------------                                                             !
! The parameters specified in the input file "/INPUTFILES/InputMULTSPHREC.dat" are  !
! listed below.                                                                     !
!                                                                                   !
! - wavelength (real) - wavelength of the incident light in vacuo.                  !
!                                                                                   !
! - ind_refMed (real) - refractive index of the ambient medium (nonabsorbing        !
!   dielectric medium).                                                             !
!                                                                                   !
! - Npart (integer) - number of spherical particles.                                !
!                                                                                   !
! - anorm (real) - characteristic length of the cluster which is used to normalize  !
!   the differential scattering cross sections.                                     !
!                                                                                   !
! - Ncs (integer) - number of concentric spheres.                                   !
!                                                                                   !
! - Ntry (integer) - maximum number of calls of the sequential addition method      !
!   routine for generating the desired random distribution of particles.            !
!                                                                                   !
! - DoConvTest (logical) - if DoConvTest = t, the convergence tests over            !
!   NrankCirc(Ncs) and MrankCirc(Ncs) are performed.                                !
!                                                                                   !
! - ExtThetaDom (logical) - if ExtThetaDom = t the DSCS is computed for             !
!   scattering angles ranging from 0° to 180° in the azimuthal plane phiGS = 0°, and!
!   from 180° to 0° in the azimuthal plane phiGS = 180°. The total number of        !
!   scattering angles is 10. If ExtThetaDom = f the DSCS is computed for            !
!   scattering angles ranging from 0° to 180° in the azimuthal plane phiGS = 0°.    !
!                                                                                   !
! - r (real) - radius of the spherical particles.                                   !
!                                                                                   !
! - ind_refPart (complex) - relative refractive index of the spherical particle     !
!   with respect to the ambient medium. The imaginary part of the relative          !
!   refractive index must be zero for nonabsorbing particles and positive for       !
!   absorbing particles.                                                            !
!                                                                                   !
! - Nrank, Mrank (integer variables) - maximum expansion and azimuthal orders for   !
!   the spherical particles.                                                        !
!                                                                                   !
! The next parameters (specified in a group statement) correspond to each            !
! auxiliary sphere. THE GROUP STATEMENT MUST BE REPEATED FOR ALL Ncs SPHERES.       !
!                                                                                   !
! - Rcirc (real) - radius of the actual auxiliary sphere. Rcs must be specified     !
!   in increasing order. Note that Rcirc(Ncs) is the radius of the largest          !  
!   auxiliary sphere.                                                               !   
!                                                                                   !
! - NrankCirc, MrankCirc (integer variables) - maximum expansion and azimuthal      !
!   orders corresponding to the actual auxiliary sphere.                            ! 
!                                                                                   !
! - epsNrank (real) - error tolerance for the expansion order test.                 !
!                                                                                   !
! - epsMrank (real) - error tolerance for the azimuthal order test.                 !
!                                                                                   !
! - FileTmat (character(80)) - name of the file to which the T matrix of the        !
!   cluster is written.                                                             !
!                                                                                   !
! - PrnProgress (logical) - if PrnProgress = t, the progress of calculation         !
!   is printed.                                                                     !
!                                                                                   !
! Note that all input parameters specifying lengths must be provided in the same    !
! units of lengths.                                                                 !  
!------------------------------------------------------------------------------------
  use parameters
  use allocation, only: Mrankcs, Nrankcs, Rcs
  implicit none 
  integer       :: Npart, Ncs, Mrank, Nrank, Ntry                                    
  real(O)       :: k, ind_refMED, wavelength, anorm, snorm, epsNrank, epsMrank, r
  complex(O)    :: ind_refPart
  character(80) :: FileTmat
  logical       :: DoConvTest, ExtThetaDom, PrnProgress
  integer,allocatable    :: Npartcs(:)
  real(O),allocatable    :: xp(:,:), yp(:,:), zp(:,:) 
! -----------------------------------------------------------------------------------
!                                Read the input file                                ! 
! -----------------------------------------------------------------------------------
  call readinputMULTSPHREC ( wavelength, ind_refMed, Npart, anorm, Ncs, Ntry,       &
       DoConvTest, ExtThetaDom, r, ind_refPart, Nrank, Mrank, epsNrank, epsMrank,   &
       FileTmat, PrnProgress, k, snorm )
! -----------------------------------------------------------------------------------
!                                      Main                                         !
! -----------------------------------------------------------------------------------           
  allocate (Npartcs(Ncs), xp(Ncs,Npart), yp(Ncs,Npart), zp(Ncs,Npart))
  call SphConfig (Ntry, Npart, Ncs, Npartcs, r, Rcs, xp, yp, zp)  
  if (DoConvTest) then
    open (unit = iOutput, file = FileOutput, status = "replace")    
    call printinputMULTSPHREC (wavelength, ind_refMed, ind_refPart, r, Npart, Ncs,  &
         Npartcs, Rcs, Mrankcs, Nrankcs, Mrank, Nrank, epsNrank, epsMrank, anorm)
    call conv_Nrank_MrankMULTSPHREC (k, snorm, r, ind_refPart, Npart, Ncs, Npartcs, &
         xp, yp, zp, Mrankcs, Nrankcs, Mrank, Nrank, epsNrank, epsMrank,            &
         ExtThetaDom, FileTmat, PrnProgress)
    close (unit = iOutput)
  else
    call TMatrix_Nrank_MrankMULTSPHREC (k, r, ind_refPart, Npart, Ncs, Npartcs, xp, &
         yp, zp, Mrankcs, Nrankcs, Mrank, Nrank, FileTmat, PrnProgress)
  end if  
  deallocate (Rcs, Mrankcs, Nrankcs, Npartcs, xp, yp, zp)  
end subroutine TMULTSPHREC
!***********************************************************************************
subroutine readinputMULTSPHREC ( wavelength, ind_refMed, Npart, anorm, Ncs, Ntry,  &
           DoConvTest, ExtThetaDom, r, ind_refPart, Nrank, Mrank, epsNrank,        &
           epsMrank, FileTmat, PrnProgress, k, snorm )     
  use parameters
  use derived_parameters
  use allocation, only: Mrankcs, Nrankcs, Rcs
  implicit none 
  integer       :: Npart, Ncs, MrankCirc, NrankCirc, Mrank, Nrank, NrankW, ics,     &
                   Ntry, ios                                    
  real(O)       :: k, ind_refMED, wavelength, anorm, x, snorm, epsNrank, epsMrank,  &
                   r, Rcirc, xR
  complex(O)    :: ind_refPart
  character(80) :: FileTmat, string
  logical       :: DoConvTest, ExtThetaDom, PrnProgress, XFindPar 
! -----------------------------------------------------------------------------------
!                         Read the input file FileInputMULTSPHREC                   ! 
! ----------------------------------------------------------------------------------- 
  call DrvParameters 
  open (unit = iInputMULTSPHREC, file = FileInputMULTSPHREC, status = "old",        &
        position = "rewind")   
  wavelength = 0.1_O * 2._O * Pi                                                                    
  ind_refMed = 1.5_O
  string     = 'OptProp'
  if (XFindPar (iInputMULTSPHREC, string)) then
    read (iInputMULTSPHREC, *, iostat = ios) wavelength
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if
    read (iInputMULTSPHREC, *, iostat = ios) ind_refMed
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refMed;')"
      stop
    end if         
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if       
  k = 2._O * Pi * ind_refMed / wavelength         
!
  Npart  = 2
  anorm  = 1._O 
  Ncs    = 2  
  Ntry   = 1000
  string = 'GenProp'
  if (XFindPar (iInputMULTSPHREC, string)) then
    read (iInputMULTSPHREC, *, iostat = ios) Npart
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Npart')"
      stop
    end if
    read (iInputMULTSPHREC, *, iostat = ios) anorm
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anorm;')"
      stop
    end if
    read (iInputMULTSPHREC, *, iostat = ios) Ncs
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Ncs;')"
      stop
    end if 
    read (iInputMULTSPHREC, *, iostat = ios) Ntry
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Ntry;')"
      stop
    end if
  else
    print "(/,2x,'Group name GenProp not found;')"
    stop  
  end if        
  call check_anorm (anorm)         
  x = k * anorm
  snorm = Pi * x * x  
!
  DoConvTest  = .true.
  ExtThetaDom = .true.
  string      = 'ConvTest'
  if (XFindPar (iInputMULTSPHREC, string)) then
    read (iInputMULTSPHREC, *, iostat = ios) DoConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DoConvTest')"
      stop
    end if
    read (iInputMULTSPHREC, *, iostat = ios) ExtThetaDom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ExtThetaDom;')"
      stop
    end if            
  else
    print "(/,2x,'Group name ConvTest not found;')"
    stop  
  end if   
!
  r = 0.2
  ind_refPart = (1.5_O,0._O) 
  Nrank  = 3
  Mrank  = 3
  string = 'TmatPart'
  if (XFindPar (iInputMULTSPHREC, string)) then
    read (iInputMULTSPHREC, *, iostat = ios) r
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable r')"
      stop
    end if
    read (iInputMULTSPHREC, *, iostat = ios) ind_refPart
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refPart;')"
      stop
    end if
    read (iInputMULTSPHREC, *, iostat = ios) Nrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nrank')"
      stop
    end if
    read (iInputMULTSPHREC, *, iostat = ios) Mrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Mrank')"
      stop
    end if
  else
    print "(/,2x,'Group name TmatPart not found;')"
    stop  
  end if   
  call check_MrankNrank (Mrank, Nrank)  
  call check_ind_ref (ind_refPart) 
!  
  if (DoConvTest) then    
    print "(/,2x,'Convergence Test for a Cluster of Spheres')"
    print "(  2x,'-----------------------------------------')"               
  else
    print "(/,2x,'T-Matrix Computation for a Cluster of Spheres')"
    print "(  2x,'---------------------------------------------')"
  end if      
!
  allocate (Rcs(Ncs), Mrankcs(Ncs), Nrankcs(Ncs))
  do ics = 1, Ncs
    Rcirc = 0.5 
    NrankCirc = 7
    MrankCirc = 5 
    string    = 'RecProp'
    if (XFindPar (iInputMULTSPHREC, string)) then
      read (iInputMULTSPHREC, *, iostat = ios) Rcirc
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Rcirc')"
        print "(  2x,'for the circumscribing sphere ',i3,';')", ics
        stop
      end if
      read (iInputMULTSPHREC, *, iostat = ios) NrankCirc
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable NrankCirc;')"
        print "(  2x,'for the circumscribing sphere ',i3,';')", ics
        stop
      end if
      read (iInputMULTSPHREC, *, iostat = ios) MrankCirc
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable MrankCirc;')"
        print "(  2x,'for the circumscribing sphere ',i3,';')", ics
        stop
      end if
    else
      print "(/,2x,'Group name RecProp not found;')"
      stop  
    end if      
    call check_MrankNrank (MrankCirc, NrankCirc)
    Rcs(ics) = Rcirc
    Mrankcs(ics) = MrankCirc
    Nrankcs(ics) = NrankCirc
  end do        
  if (Ncs > 1) call check_circum_radii (Ncs, Rcs)  
  xR = k * Rcs(Ncs)
  NrankW = int(xR + 4.05_O * xR**0.33_O + 2._O)
  print "(/,2x,'Input values:')"
  print "(  2x, a, i3, a, i3, a)",                                                  &
 'the input values of Nrank and Mrank for the largest sphere are ', Nrankcs(Ncs),   &
 ' and ', Mrankcs(Ncs), ',' 
  print "(  2x, a, i3, a, /)",                                                      &
 'while the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'
!
  epsNrank = 5.e-2_O
  epsMrank = 5.e-2_O 
  string   = 'Errors'
  if (XFindPar (iInputMULTSPHREC, string)) then
    read (iInputMULTSPHREC, *, iostat = ios) epsNrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNrank;')"
      stop
    end if
    read (iInputMULTSPHREC, *, iostat = ios) epsMrank
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsMrank;')"
      stop
    end if            
  else
    print "(/,2x,'Group name Errors not found;')"
    stop  
  end if      
!
  FileTmat = '../TMATFILES/T.dat'
  string   = 'Tmat'
  if (XFindPar (iInputMULTSPHREC, string)) then
    read (iInputMULTSPHREC, *, iostat = ios) FileTmat
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileTmat;')"
      stop
    end if             
  else
    print "(/,2x,'Group name Tmat not found;')"
    stop  
  end if    
!
  PrnProgress = .true.
  string      = 'PrintProgress'
  if (XFindPar (iInputMULTSPHREC, string)) then
    read (iInputMULTSPHREC, *, iostat = ios) PrnProgress
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if             
  else
    print "(/,2x,'Group name PrintProgress not found;')"
    stop  
  end if             
  close (unit = iInputMULTSPHREC)  
end subroutine readinputMULTSPHREC
!***********************************************************************************
subroutine printinputMULTSPHREC (wavelength, ind_refMed, ind_ref, r, Npart, Ncs,    &
           Npartcs, Rcs, Mrankcs, Nrankcs, Mrank, Nrank, epsNrank, epsMrank, anorm)
  use parameters
  implicit none  
  integer       :: Npart, Ncs, Npartcs(Ncs), Mrankcs(Ncs), Nrankcs(Ncs), Mrank,     &
                   Nrank, ics
  real(O)       :: wavelength, ind_refMed, anorm, r, Rcs(Ncs), epsNrank, epsMrank, f
  complex(O)    :: ind_ref  
!
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x,'wavelength of the free space, wavelength = ',1pe13.4,';')")  &
         wavelength
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'refractive index of the ambient medium, ind_refMed = ', ind_refMed, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'characteristic length of the cluster, anorm = ', anorm, ';'
  write (iOutput,"(2x,'number of particles: Npart = ',i3,';')") Npart
  write (iOutput,"(2x,'radius, r = ',1pe10.3,';')") r  
  f = Npart * r**3 / (Rcs(Ncs) - r)**3
  write (iOutput,"(2x,'fractional volume, f = ',1pe10.3,';')") f
  write (iOutput,"(2x, a, 1pe10.3, ',', 1pe10.3, a)")                               &
 'relative refractive index, ind_refRel = (', ind_ref, ');' 
  write (iOutput,"(2x, a, i3, a)")                                                  &
 'maximum expansion order for each particle, Nrank = ', Nrank, ';'
  write (iOutput,"(2x, a, i3, a)")                                                  &
 'maximum azimuthal order for each particle, Mrank = ', Mrank, ';'
  write (iOutput,"(2x,'number of auxiliary surfaces, Ncs = ',i3,';')") Ncs
  write (iOutput,*)
  do ics = 1, Ncs
    write (iOutput,"(2x, a, i3, a, i3, a)")                                         &
   'number of particles contained in the region ', ics, ', Npart = ',               &
    Npartcs(ics), ';'
    write (iOutput,"(2x, a, i3, a, 1pe10.3, a)")                                    &
   'radius of the region ',     ics, ', Rcs = ', Rcs(ics), ';'
    write (iOutput,"(2x, a, i3, a, i3, a)")                                         &
   'maximum expansion order for region ', ics, ', Nrank = ', Nrankcs(ics), ';'
    write (iOutput,"(2x, a, i3, a, i3, a)")                                         &
   'maximum azimuthal order for region ', ics, ', Mrank = ', Mrankcs(ics), ';'
    write (iOutput,*)
  end do
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum expansion order tolerance, epsNrank = ', epsNrank, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum azimuthal order tolerance, epsMrank = ', epsMrank, '.'            
  write (iOutput,"(/)")                               
end subroutine printinputMULTSPHREC
!***********************************************************************************
subroutine conv_Nrank_MrankMULTSPHREC (k, snorm, r, ind_ref, Npart, Ncs, Npartcs,   &
           xp, yp, zp, Mrankcs, Nrankcs, Mrank, Nrank, epsNrank, epsMrank,          &
           ExtThetaDom, FileTmat, PrnProgress)
  use parameters
  implicit none
  integer       :: Npart, Ncs, Npartcs(Ncs), Mrankcs(Ncs), Nrankcs(Ncs), Mrank,     &
                   Nrank
  real(O)       :: k, snorm, r, xp(Ncs,Npart), yp(Ncs,Npart), zp(Ncs,Npart),        &
                   epsNrank, epsMrank
  complex(O)    :: ind_ref
  character(80) :: FileTmat
  logical       :: ExtThetaDom, PrnProgress
!       
  integer       :: Nmax, Nmaxmax, Nteta, ipart, jpart, NthetaConvN, NthetaConvM,    &
                   Nl, Nc, i, NmaxAL, ics  
  real(O)       :: alfaPol, x, y, z, tetaGI, phiGI, phiGS, x1, y1, z1, dx, dy, dz,  &
                   alfaC, betaC, gamaC, Cscat, Qscat, Cext, Qext
  integer,allocatable    :: Nmaxcs(:)
  real(O),allocatable    :: h(:), v(:), oldh(:), oldv(:), oldh0(:), oldv0(:)
  complex(O),allocatable :: aa(:,:), bb(:,:), a(:,:), b(:,:), c(:,:), tt(:,:),      &
                            t(:), cc(:), cc1(:)   
!
  tetaGI  = 0._O
  phiGI   = 0._O
  phiGS   = 0._O
  Nteta   = 10
  alfaC   = Pi / 4._O
  betaC   = Pi / 4._O
  gamaC   = 0._O
  alfaPol = Pi / 4._O
  Nmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (Nmaxcs(Ncs))
  do ics = 1, Ncs
    Nmaxcs(ics) = Nrankcs(ics) + Mrankcs(ics) * (2 * Nrankcs(ics) -                 &
                  Mrankcs(ics) + 1)
  end do 
  call write_TypeConvHead (4) 
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call write_HeadFileTmat (Nmaxcs(Ncs), Nmaxcs(Ncs))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta), oldh0(Nteta),             &
            oldv0(Nteta))
  allocate (tt(2*Nmaxcs(1),2*Nmaxcs(1)), t(2*Nmax))      
  call coefficients_fg (k, r, ind_ref, Mrank, Nrank, Nmax, t)
  do ics = 1, Ncs  
    if (PrnProgress) print "(2x,'progress of main calculation for region',i3,':')", &
                             ics  
    if (ics == 1) then
      Nmaxmax = Nmax * Npartcs(ics)
    else
      Nmaxmax = Nmax * Npartcs(ics) + Nmaxcs(ics-1)
    end if
    NmaxAL = Nmaxcs(ics)
    if (ics > 1) NmaxAL = max(Nmaxcs(ics),Nmaxcs(ics-1))
    if (Nmax > NmaxAL) then
      NmaxAL = Nmax 
      print "(/,2x,'Warning: the input values of Nrank and Mrank for the')"
      print "(2x,'auxiliary sphere ',i2,' are too low;')", ics
    end if 
    allocate (aa(2*Nmaxmax,2*Nmaxmax), bb(2*Nmaxmax,2*NmaxAL))        
    allocate (a(2*NmaxAL,2*NmaxAL), b(2*NmaxAL,2*NmaxAL), c(2*NmaxAL,2*NmaxAL))
    call identity_matrix (2*Nmaxmax, aa, 2*Nmaxmax, 2*Nmaxmax)    
    Nl = 0  
    do ipart = 1, Npartcs(ics)              
      x  = xp(ics,ipart)
      y  = yp(ics,ipart)
      z  = zp(ics,ipart)    
      Nc = 0    
      do jpart = 1, Npartcs(ics)            
        if (jpart > ipart) then          
          x1 = xp(ics,jpart)
          y1 = yp(ics,jpart)
          z1 = zp(ics,jpart)
          dx = x1 - x
          dy = y1 - y
          dz = z1 - z
          call MatTransAB_mn_m1n1 (3, k, dx, dy, dz, Mrank, Nrank, Nmax, Mrank,     &
               Nrank, Nmax, a, NmaxAL, NmaxAL)
          call product_matrix_vector1 (2*Nmax, 2*Nmax, t, a, 2*NmaxAL, 2*NmaxAL,    &
               b, 2*NmaxAL, 2*NmaxAL)
          call extend_matrix3 (Nmax, Nmax, Nl, Nc, b, NmaxAL, NmaxAL,               &
               aa, Nmaxmax, Nmaxmax)
          call matrix_inverse (Mrank, Nrank, Nmax, Mrank, Nrank, Nmax,              &
               a, NmaxAL, NmaxAL)
          call product_matrix_vector1 (2*Nmax, 2*Nmax, t, a, 2*NmaxAL, 2*NmaxAL,    &
               b, 2*NmaxAL, 2*NmaxAL)
          call extend_matrix3 (Nmax, Nmax, Nc, Nl, b, NmaxAL, NmaxAL,               &
               aa, Nmaxmax, Nmaxmax)                                                                    
        end if
        Nc = Nc + 2 * Nmax      
      end do      
      if (ics > 1) then
        call MatTransAB_mn_m1n1 (3, k, -x, -y, -z, Mrank, Nrank, Nmax,              &
             Mrankcs(ics-1), Nrankcs(ics-1), Nmaxcs(ics-1), a, NmaxAL, NmaxAL)
        call product_matrix_vector1 (2*Nmax, 2*Nmaxcs(ics-1), t, a, 2*NmaxAL,       &
             2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)
        call extend_matrix3 (Nmax, Nmaxcs(ics-1), Nl, Nc, b, NmaxAL, NmaxAL,        &
             aa, Nmaxmax, Nmaxmax)          
        call MatTransAB_mn_m1n1 (3, k, x, y, z, Mrankcs(ics-1), Nrankcs(ics-1),     &
             Nmaxcs(ics-1), Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)
        call product_matrices1 (2*Nmaxcs(ics-1), 2*Nmaxcs(ics-1), 2*Nmax, tt,       &
             2*Nmaxcs(ics-1), 2*Nmaxcs(ics-1), a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL,  &
             2*NmaxAL)       
        call extend_matrix3 (Nmaxcs(ics-1), Nmax, Nc, Nl, b, NmaxAL, NmaxAL,        &
             aa, Nmaxmax, Nmaxmax)          
      end if  
      call MatTransAB_mn_m1n1 (1, k, -x, -y, -z, Mrank, Nrank, Nmax, Mrankcs(ics),  &
           Nrankcs(ics), Nmaxcs(ics), a, NmaxAL, NmaxAL)
      call product_matrix_vector1 (2*Nmax, 2*Nmaxcs(ics), t, a, 2*NmaxAL, 2*NmaxAL, &
           b, 2*NmaxAL, 2*NmaxAL)
      call extend_matrix4 (ipart, Nmax, Nmaxcs(ics), Nmaxmax, Nl, b, NmaxAL,        &
           NmaxAL, bb, Nmaxmax, NmaxAL)                  
      Nl = Nl + 2 * Nmax      
      if (PrnProgress) call write_progress (.false., ipart, 2*Npartcs(ics)+1)
    end do
    if (ics > 1) then
      call identity_transformation (Mrankcs(ics-1), Nrankcs(ics-1), Nmaxcs(ics-1),  &
           Mrankcs(ics), Nrankcs(ics), Nmaxcs(ics), a, NmaxAL, NmaxAL)
      call product_matrices1 (2*Nmaxcs(ics-1), 2*Nmaxcs(ics-1), 2*Nmaxcs(ics), tt,  &
           2*Nmaxcs(ics-1), 2*Nmaxcs(ics-1), a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL,    &
           2*NmaxAL)
      call extend_matrix4 (2, Nmaxcs(ics-1), Nmaxcs(ics), Nmaxmax, Nl, b, NmaxAL,   &
           NmaxAL, bb, Nmaxmax, NmaxAL)             
    end if
    call LU_SYSTEM_DIRECT (aa, 2*Nmaxmax, 2*Nmaxmax, bb, 2*Nmaxmax, 2*NmaxAL,       &
         2*Nmaxmax, 2*Nmaxcs(ics))  
    if (PrnProgress) call write_progress (.false., Npartcs(ics)+1, 2*Npartcs(ics)+1)
    Nl = 0  
    do ipart = 1, Npartcs(ics)    
      x = xp(ics,ipart)
      y = yp(ics,ipart)
      z = zp(ics,ipart)         
      call extract_matrix2 (Nmax, Nmaxcs(ics), Nl, b, NmaxAL, NmaxAL, bb, Nmaxmax,  &
           NmaxAL)
      call MatTransAB_mn_m1n1 (1, k, x, y, z, Mrankcs(ics), Nrankcs(ics),           &
           Nmaxcs(ics), Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)                          
      call product_matrices2 (ipart, 2*Nmaxcs(ics), 2*Nmax, 2*Nmaxcs(ics), a,       &
           2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL, c, 2*NmaxAL, 2*NmaxAL)                        
      Nl = Nl + 2 * Nmax
      if (PrnProgress) call write_progress (.false., Npartcs(ics)+1+ipart,          &
                            2*Npartcs(ics)+1)
    end do   
    if (ics > 1) then
      call extract_matrix2 (Nmaxcs(ics-1), Nmaxcs(ics), Nl, b, NmaxAL, NmaxAL,      &
           bb, Nmaxmax, NmaxAL)
      call identity_transformation (Mrankcs(ics), Nrankcs(ics), Nmaxcs(ics),        &
           Mrankcs(ics-1), Nrankcs(ics-1), Nmaxcs(ics-1), a, NmaxAL, NmaxAL)
      call product_matrices2 (2, 2*Nmaxcs(ics), 2*Nmaxcs(ics-1), 2*Nmaxcs(ics),     &
           a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL, c, 2*NmaxAL, 2*NmaxAL)
      deallocate (tt)
      allocate (tt(2*Nmaxcs(ics),2*Nmaxcs(ics)))
    end if
    call copy_matrix (2*Nmaxcs(ics), 2*Nmaxcs(ics), c, 2*NmaxAL, 2*NmaxAL,          &
         tt, 2*NmaxAL, 2*NmaxAL)
    deallocate (aa, bb, a, b, c)
  end do 
  allocate (a(2*Nmaxcs(Ncs),2*Nmaxcs(Ncs)), cc(2*Nmaxcs(Ncs)), cc1(2*Nmaxcs(Ncs)))     
  call copy_matrix (2*Nmaxcs(Ncs), 2*Nmaxcs(Ncs), tt, 2*Nmaxcs(Ncs), 2*Nmaxcs(Ncs), &
       a, 2*Nmaxcs(Ncs), 2*Nmaxcs(Ncs))
  call write_FileTmat (Nmaxcs(Ncs), Nmaxcs(Ncs), a)
  call PWcoefficients_ab (tetaGI, phiGI, alfaC, betaC, gamaC, alfaPol,              &
       Mrankcs(Ncs), Nrankcs(Ncs), Nmaxcs(Ncs), cc)    
  call product_matrix_vector (2*Nmaxcs(Ncs), 2*Nmaxcs(Ncs), a, 2*Nmaxcs(Ncs),       &
       2*Nmaxcs(Ncs), cc, cc1)
  call DSCS (cc1, Mrankcs(Ncs), Nrankcs(Ncs), Nmaxcs(Ncs), Nteta, phiGS, alfaC,     &
       betaC, gamaC, k, snorm, ExtThetaDom,.true., h, v)
  call CQscat (cc1, Mrankcs(Ncs), Nrankcs(Ncs), Nmaxcs(Ncs), k, snorm, Cscat, Qscat)
  call CQext (cc1, Mrankcs(Ncs), Nrankcs(Ncs), Nmaxcs(Ncs), tetaGI, phiGI, alfaC,   &
       betaC, gamaC, alfaPol, k, snorm, Cext, Qext) 
  call write_2ConvParam (Nrankcs(Ncs), Mrankcs(Ncs))                         
  call write_DSCS (Nteta, ExtThetaDom, h, v)  
  call write_Effic (Qscat, Qext)
  do i = 1, Nteta
    oldh(i)  = h(i)
    oldv(i)  = v(i)
    oldh0(i) = h(i)
    oldv0(i) = v(i)
  end do
  close (unit = iTmat)  
! --- (Nrank - 1) configuration ---  
  if (PrnProgress) call write_progress_low
  call matrix_Nrank_1_right (Mrankcs(Ncs), Nrankcs(Ncs), Nmaxcs(Ncs), a,            &
       Nmaxcs(Ncs), Nmaxcs(Ncs))  
  call PWcoefficients_ab (tetaGI, phiGI, alfaC, betaC, gamaC, alfaPol,              &
       Mrankcs(Ncs), Nrankcs(Ncs), Nmaxcs(Ncs), cc)    
  call product_matrix_vector (2*Nmaxcs(Ncs), 2*Nmaxcs(Ncs), a, 2*Nmaxcs(Ncs),       &
       2*Nmaxcs(Ncs), cc, cc1)
  call DSCS (cc1, Mrankcs(Ncs), Nrankcs(Ncs), Nmaxcs(Ncs), Nteta, phiGS, alfaC,     &
       betaC, gamaC, k, snorm, ExtThetaDom,.true., h, v)
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConvN)
  call CQscat (cc1, Mrankcs(Ncs), Nrankcs(Ncs), Nmaxcs(Ncs), k, snorm, Cscat, Qscat)
  call CQext (cc1, Mrankcs(Ncs), Nrankcs(Ncs), Nmaxcs(Ncs), tetaGI, phiGI, alfaC,   &
       betaC, gamaC, alfaPol, k, snorm, Cext, Qext) 
  call write_2ConvParam (Nrankcs(Ncs) - 1, Mrankcs(Ncs))                 
  call write_DSCS (Nteta, ExtThetaDom, h, v) 
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConvN, Nteta, epsNrank)
! --- (Mrank - 1) configuration ---  
  call matrix_Mrank_1_right (Mrankcs(Ncs), Nrankcs(Ncs), Nmaxcs(Ncs), tt,           &
       Nmaxcs(Ncs), Nmaxcs(Ncs))  
  call PWcoefficients_ab (tetaGI, phiGI, alfaC, betaC, gamaC, alfaPol, Mrankcs(Ncs),&
       Nrankcs(Ncs), Nmaxcs(Ncs), cc)    
  call product_matrix_vector (2*Nmaxcs(Ncs), 2*Nmaxcs(Ncs), tt, 2*Nmaxcs(Ncs),      &
       2*Nmaxcs(Ncs), cc, cc1)
  call DSCS (cc1, Mrankcs(Ncs), Nrankcs(Ncs), Nmaxcs(Ncs), Nteta, phiGS, alfaC,     &
       betaC, gamaC, k, snorm, ExtThetaDom,.true., h, v)
  call delta_DSCS (Nteta, h, v, oldh0, oldv0, epsMrank, NthetaConvM)
  call CQscat (cc1, Mrankcs(Ncs), Nrankcs(Ncs), Nmaxcs(Ncs), k, snorm, Cscat, Qscat)
  call CQext (cc1, Mrankcs(Ncs), Nrankcs(Ncs), Nmaxcs(Ncs), tetaGI, phiGI, alfaC,   &
       betaC, gamaC, alfaPol, k, snorm, Cext, Qext)      
  call write_2ConvParam (Nrankcs(Ncs), Mrankcs(Ncs) - 1)
  call write_DSCS (Nteta, ExtThetaDom, h, v) 
  call write_Effic (Qscat, Qext)
  call write_MrankConvRes (NthetaConvM, epsMrank)
  if (NthetaConvN >= int(0.8*Nteta) .and. NthetaConvM >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criteria for Nrank and Mrank are satisfied;')"                    
  else
    print "(/,2x,'Convergence criteria for Nrank and Mrank are not satisfied;')"
  end if
  call write_InfoFileTmat (FileTmat, Mrankcs(Ncs), Nrankcs(Ncs), .false., .false.,  &
      .false.)
  call ScatCharact (k, FileTmat, Mrankcs(Ncs), Nrankcs(Ncs), .false., .false.,      &
      .false.)  
  print "(/,2x,'The T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The the dimensions of the T matrix are given by:')"         
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrankcs(Ncs)
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrankcs(Ncs)     
  deallocate (a, tt, t, cc, cc1, h, v, oldh, oldv, oldh0, oldv0, Nmaxcs)        
end subroutine conv_Nrank_MrankMULTSPHREC
!***********************************************************************************
subroutine TMatrix_Nrank_MrankMULTSPHREC (k, r, ind_ref, Npart, Ncs, Npartcs, xp,   &
           yp, zp, Mrankcs, Nrankcs, Mrank, Nrank, FileTmat, PrnProgress)
  use parameters
  implicit none
  integer       :: Npart, Ncs, Npartcs(Ncs), Mrankcs(Ncs), Nrankcs(Ncs), Mrank,     &
                   Nrank
  real(O)       :: k, r, xp(Ncs,Npart), yp(Ncs,Npart), zp(Ncs,Npart)
  complex(O)    :: ind_ref
  character(80) :: FileTmat
  logical       :: PrnProgress
!       
  integer       :: Nmax, Nmaxmax, ipart, jpart, Nl, Nc, NmaxAL, ics  
  real(O)       :: x, y, z, x1, y1, z1, dx, dy, dz                  
  integer,allocatable    :: Nmaxcs(:)
  complex(O),allocatable :: aa(:,:), bb(:,:), a(:,:), b(:,:), c(:,:), tt(:,:), t(:)   
!  
  Nmax = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  allocate (Nmaxcs(Ncs))
  do ics = 1, Ncs
    Nmaxcs(ics) = Nrankcs(ics) + Mrankcs(ics) * (2 * Nrankcs(ics) -                 &
                  Mrankcs(ics) + 1)
  end do 
  open (unit = iTmat, file = FileTmat, status = 'replace')
  call write_HeadFileTmat (Nmaxcs(Ncs), Nmaxcs(Ncs))  
  allocate (tt(2*Nmaxcs(1),2*Nmaxcs(1)), t(2*Nmax))      
  call coefficients_fg (k, r, ind_ref, Mrank, Nrank, Nmax, t)
  do ics = 1, Ncs  
    if (PrnProgress) print "(2x,'progress of main calculation for region',i3,':')", &
                             ics  
    if (ics == 1) then
      Nmaxmax = Nmax * Npartcs(ics)
    else
      Nmaxmax = Nmax * Npartcs(ics) + Nmaxcs(ics-1)
    end if
    NmaxAL = Nmaxcs(ics)
    if (ics > 1) NmaxAL = max(Nmaxcs(ics),Nmaxcs(ics-1))
    if (Nmax > NmaxAL) then
      NmaxAL = Nmax 
      print "(/,2x,'Warning: the input values of Nrank and Mrank for the')"
      print "(2x,'auxiliary sphere ',i2,' are too low;')", ics
    end if 
    allocate (aa(2*Nmaxmax,2*Nmaxmax), bb(2*Nmaxmax,2*NmaxAL))        
    allocate (a(2*NmaxAL,2*NmaxAL), b(2*NmaxAL,2*NmaxAL), c(2*NmaxAL,2*NmaxAL))
    call identity_matrix (2*Nmaxmax, aa, 2*Nmaxmax, 2*Nmaxmax)    
    Nl = 0  
    do ipart = 1, Npartcs(ics)              
      x  = xp(ics,ipart)
      y  = yp(ics,ipart)
      z  = zp(ics,ipart)    
      Nc = 0    
      do jpart = 1, Npartcs(ics)            
        if (jpart > ipart) then          
          x1 = xp(ics,jpart)
          y1 = yp(ics,jpart)
          z1 = zp(ics,jpart)
          dx = x1 - x
          dy = y1 - y
          dz = z1 - z
          call MatTransAB_mn_m1n1 (3, k, dx, dy, dz, Mrank, Nrank, Nmax, Mrank,     &
               Nrank, Nmax, a, NmaxAL, NmaxAL)
          call product_matrix_vector1 (2*Nmax, 2*Nmax, t, a, 2*NmaxAL, 2*NmaxAL,    &
               b, 2*NmaxAL, 2*NmaxAL)
          call extend_matrix3 (Nmax, Nmax, Nl, Nc, b, NmaxAL, NmaxAL,               &
               aa, Nmaxmax, Nmaxmax)
          call matrix_inverse (Mrank, Nrank, Nmax, Mrank, Nrank, Nmax,              &
               a, NmaxAL, NmaxAL)
          call product_matrix_vector1 (2*Nmax, 2*Nmax, t, a, 2*NmaxAL, 2*NmaxAL,    &
               b, 2*NmaxAL, 2*NmaxAL)
          call extend_matrix3 (Nmax, Nmax, Nc, Nl, b, NmaxAL, NmaxAL,               &
               aa, Nmaxmax, Nmaxmax)                                                                    
        end if
        Nc = Nc + 2 * Nmax      
      end do      
      if (ics > 1) then
        call MatTransAB_mn_m1n1 (3, k, -x, -y, -z, Mrank, Nrank, Nmax,              &
             Mrankcs(ics-1), Nrankcs(ics-1), Nmaxcs(ics-1), a, NmaxAL, NmaxAL)
        call product_matrix_vector1 (2*Nmax, 2*Nmaxcs(ics-1), t, a, 2*NmaxAL,       &
             2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL)
        call extend_matrix3 (Nmax, Nmaxcs(ics-1), Nl, Nc, b, NmaxAL, NmaxAL,        &
             aa, Nmaxmax, Nmaxmax)          
        call MatTransAB_mn_m1n1 (3, k, x, y, z, Mrankcs(ics-1), Nrankcs(ics-1),     &
             Nmaxcs(ics-1), Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)
        call product_matrices1 (2*Nmaxcs(ics-1), 2*Nmaxcs(ics-1), 2*Nmax, tt,       &
             2*Nmaxcs(ics-1), 2*Nmaxcs(ics-1), a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL,  &
             2*NmaxAL)       
        call extend_matrix3 (Nmaxcs(ics-1), Nmax, Nc, Nl, b, NmaxAL, NmaxAL,        &
             aa, Nmaxmax, Nmaxmax)          
      end if  
      call MatTransAB_mn_m1n1 (1, k, -x, -y, -z, Mrank, Nrank, Nmax, Mrankcs(ics),  &
           Nrankcs(ics), Nmaxcs(ics), a, NmaxAL, NmaxAL)
      call product_matrix_vector1 (2*Nmax, 2*Nmaxcs(ics), t, a, 2*NmaxAL, 2*NmaxAL, &
           b, 2*NmaxAL, 2*NmaxAL)
      call extend_matrix4 (ipart, Nmax, Nmaxcs(ics), Nmaxmax, Nl, b, NmaxAL,        &
           NmaxAL, bb, Nmaxmax, NmaxAL)                  
      Nl = Nl + 2 * Nmax      
      if (PrnProgress) call write_progress (.false., ipart, 2*Npartcs(ics)+1)
    end do
    if (ics > 1) then
      call identity_transformation (Mrankcs(ics-1), Nrankcs(ics-1), Nmaxcs(ics-1),  &
           Mrankcs(ics), Nrankcs(ics), Nmaxcs(ics), a, NmaxAL, NmaxAL)
      call product_matrices1 (2*Nmaxcs(ics-1), 2*Nmaxcs(ics-1), 2*Nmaxcs(ics), tt,  &
           2*Nmaxcs(ics-1), 2*Nmaxcs(ics-1), a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL,    &
           2*NmaxAL)
      call extend_matrix4 (2, Nmaxcs(ics-1), Nmaxcs(ics), Nmaxmax, Nl, b, NmaxAL,   &
           NmaxAL, bb, Nmaxmax, NmaxAL)             
    end if
    call LU_SYSTEM_DIRECT (aa, 2*Nmaxmax, 2*Nmaxmax, bb, 2*Nmaxmax, 2*NmaxAL,       &
         2*Nmaxmax, 2*Nmaxcs(ics))  
    if (PrnProgress) call write_progress (.false., Npartcs(ics)+1, 2*Npartcs(ics)+1)
    Nl = 0  
    do ipart = 1, Npartcs(ics)    
      x = xp(ics,ipart)
      y = yp(ics,ipart)
      z = zp(ics,ipart)         
      call extract_matrix2 (Nmax, Nmaxcs(ics), Nl, b, NmaxAL, NmaxAL, bb, Nmaxmax,  &
           NmaxAL)
      call MatTransAB_mn_m1n1 (1, k, x, y, z, Mrankcs(ics), Nrankcs(ics),           &
           Nmaxcs(ics), Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)                          
      call product_matrices2 (ipart, 2*Nmaxcs(ics), 2*Nmax, 2*Nmaxcs(ics), a,       &
           2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL, c, 2*NmaxAL, 2*NmaxAL)                        
      Nl = Nl + 2 * Nmax
      if (PrnProgress) call write_progress (.false., Npartcs(ics)+1+ipart,          &
                            2*Npartcs(ics)+1)
    end do   
    if (ics > 1) then
      call extract_matrix2 (Nmaxcs(ics-1), Nmaxcs(ics), Nl, b, NmaxAL, NmaxAL,      &
           bb, Nmaxmax, NmaxAL)
      call identity_transformation (Mrankcs(ics), Nrankcs(ics), Nmaxcs(ics),        &
           Mrankcs(ics-1), Nrankcs(ics-1), Nmaxcs(ics-1), a, NmaxAL, NmaxAL)
      call product_matrices2 (2, 2*Nmaxcs(ics), 2*Nmaxcs(ics-1), 2*Nmaxcs(ics),     &
           a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL, c, 2*NmaxAL, 2*NmaxAL)
      deallocate (tt)
      allocate (tt(2*Nmaxcs(ics),2*Nmaxcs(ics)))
    end if
    call copy_matrix (2*Nmaxcs(ics), 2*Nmaxcs(ics), c, 2*NmaxAL, 2*NmaxAL,          &
         tt, 2*NmaxAL, 2*NmaxAL)
    deallocate (aa, bb, a, b, c)
  end do 
  call write_FileTmat (Nmaxcs(Ncs), Nmaxcs(Ncs), tt)  
  close (unit = iTmat)  
  call write_InfoFileTmat (FileTmat, Mrankcs(Ncs), Nrankcs(Ncs), .false., .false.,  &
      .false.)
  call ScatCharact (k, FileTmat, Mrankcs(Ncs), Nrankcs(Ncs), .false., .false.,      &
      .false.)  
  print "(/,2x,'The T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The the dimensions of the T matrix are given by:')"         
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrankcs(Ncs)
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrankcs(Ncs)     
  deallocate (tt, t, Nmaxcs)    
end subroutine TMatrix_Nrank_MrankMULTSPHREC

! **********************************************************************************
! *                           INTERPOLATION ROUTINES                               *
! *      --------------------------------------------------------------------      *
! *      Partial list of subroutines:                                              *
! *        Interp,  linterp,  spline,  splint,  dpchim,  dpchfe,  dchfev,  dpchst, *
! *        readinputInterp                                                         *
! ********************************************************************************** 
subroutine Interp (n, x, y, xpoint, ypoint)
!------------------------------------------------------------------------------------ 
! Given the pairs (x_1,y_1), (x_2,y_2),..., (x_n,y_n), the routine computes the     !
! value ypoint at xpoint using linear, spline or cubic Hermite interpolation.       !
!                                                                                   !
! Input parameters:                                                                 !
! - n (integer)    - number of data points.                                         !
! - x (real array) - set of discrete points (abscissas).                            !
! - y (real array) - function values at discrete points.                            ! 
! - xpoint (real)  - evaluation point.                                              !
!                                                                                   !
! Output parameters:                                                                !
! - ypoint (real) - value of the function at xpoint.                                !
!                                                                                   !
! The parameter TypeInterp (specified in the group statement "Interpolation"        !
! from the input file "../INPUTFILES/Input.dat") provides the type of               !
! interpolation method.                                                             ! 
!------------------------------------------------------------------------------------
  use parameters
  implicit none
  integer   :: n
  real(O)   :: x(n), y(n), xpoint, ypoint
!
  integer       :: i
  real(O)       :: yd1, ydn
  character(20) :: TypeInterp
  logical       :: ascending
  real(O),allocatable :: x1(:), y1(:), yd(:)             
!   
  call readinputInterp ( TypeInterp )    
  allocate (x1(n), y1(n))            
  ascending = .true.
  do i = 1, n - 1
    if (x(i) > x(i+1)) then
      ascending = .false.
      exit
    end if
  end do
  do i = 1, n
    if (ascending) then
      x1(i) = x(i)
      y1(i) = y(i)
    else
      x1(i) = x(n-i+1)
      y1(i) = y(n-i+1)
    end if
  end do   
  if (xpoint < x1(1) .and. xpoint > x1(n)) then
    print "(/,2x,'Error in subroutine Interp in file Interp.f90:')"
    print "(  2x, a)",                                                               &
   'the interpolation point does not belong to the set of discrete points;'    
    stop    
  end if                                             
  if (TypeInterp(1:6) == 'LINEAR') then
    call linterp (x1, y1, n, xpoint, ypoint)  
  else if (TypeInterp(1:6) == 'SPLINE') then    
    allocate (yd(n))
    yd1 = 0._O
    ydn = 0._O     
    call spline (x1, y1, n, yd1, ydn, yd)  
    call splint (x1, y1, yd, n, xpoint, ypoint)
    deallocate (yd)
  else if (TypeInterp(1:7) == 'HERMITE') then   
    allocate ( yd(n))                  
    call dpchim (n, x1, y1, yd)        
    call dpchfe (n, x1, y1, yd, xpoint, ypoint)
    deallocate  (yd)
  end if
  deallocate  (x1, y1)  
end subroutine Interp
! ************************************************************************************
subroutine readinputInterp ( TypeInterp ) 
  use parameters
  implicit none
  integer       :: ios
  character(20) :: TypeInterp
  character(80) :: string
  logical       :: XFindPar
!
  open (unit = iInput, file = FileInput, status = "old", position = "rewind")  
  TypeInterp = 'LINEAR'  
  string     = 'Interpolation'
  if (XFindPar (iInput, string)) then
    read (iInput, *, iostat = ios) TypeInterp
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable TypeInterp;')"
      stop
    end if
  else
    print "(/,2x,'Group name Interpolation not found;')"
    stop  
  end if  
  call check_Interpolation (TypeInterp) 
  close (unit = iInput)   
end subroutine readinputInterp   
! ************************************************************************************
! *                           LINEAR INTERPOLATION ROUTINE                           *
! ************************************************************************************
subroutine linterp (xa, ya, n, x, y)
  use parameters
  use derived_parameters
  implicit none
  integer  :: n
  real(O)  :: xa(n), ya(n), x, y
!  
  integer  :: i,ix
  real(O)  :: xs, xd, csi, dx
  logical  :: found  
! 
  found = .false.   
  do i = 1, n - 1
    xs = xa(i)
    xd = xa(i+1)
    dx = xd - xs
    if (abs(dx) < MachEps) then
      print "(/,2x,'Error in subroutine linterp in file Interp.f90:')"
      print "(  2x,'coincident knots;')"
      stop      
    end if      
    if (x >= xs .and. x < xd) then
      ix    = i
      csi   = (x - xs) / dx
      found = .true.
      exit
    end if                   
  end do
  if (found) then
    y = (1._O - csi) * ya(ix) + csi * ya(ix+1)
  else
    y = ya(n)
  end if    
end subroutine linterp  
! ************************************************************************************
! *         SPLINE INTERPOLATION ROUTINE - F90-VERSION FROM NUMERICAL RECIPES        *
! ************************************************************************************
subroutine spline (x, y, n, yp1, ypn, y2)
!-----------------------------------------------------------------------------------
! The routine computes the derivatives needed to determine a spline interpolant    !
! to given data.                                                                   !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none  
  integer  :: n
  real(O)  :: x(n), y(n), yp1, ypn, y2(n)
!    
  integer  :: i, k
  real(O)  :: sig, p, qn, un, dy, dx, dyp, dym, dxp, dxm
  real(O),allocatable :: u(:)
!  
  allocate (u(n))
  if (yp1 > LargestSplineVal) then
    y2(1) = 0._O
    u (1) = 0._O
  else
    y2(1) = - 0.5_O
    dy    = y(2) - y(1)
    dx    = x(2) - x(1)
    if (abs(dx) < MachEps) then
      print "(/,2x,'Error in subroutine spline in file Interp.f90:')"
      print "(  2x,'coincident knots;')"
      stop      
    end if 
    u (1) = (3._O / dx ) * (dy / dx - yp1)    
  end if
  do i = 2, n - 1
    sig   = (x(i) - x(i-1)) / (x(i+1) - x(i-1))
    p     = sig * y2(i-1) + 2._O
    y2(i) = (sig - 1._O) / p
    dyp   = y(i+1) - y(i)
    dym   = y(i) - y(i-1)
    dxp   = x(i+1) - x(i)
    dxm   = x(i) - x(i-1)
    dx    = x(i+1) - x(i-1)
    if (abs(dxp) < MachEps ) then
      print "(/,2x,'Error in subroutine spline in file Interp.f90:')"
      print "(  2x,'coincident knots;')"
      stop      
    end if 
    u(i)  = (6._O * (dyp / dxp - dym / dxm) / dx - sig * u(i-1)) / p    
  end do
  if (ypn > LargestSplineVal) then
    qn = 0._O
    un = 0._O
  else
    qn = 0.5_O
    dy = y(n) - y(n-1)
    dx = x(n) - x(n-1)
    un = (3._O / dx) * (ypn - dy / dx)    
  end if
  y2(n) = (un - qn * u(n-1)) / (qn * y2(n-1) + 1._O)
  do k = n - 1, 1, - 1
    y2(k) = y2(k) * y2(k+1) + u(k)
  end do
  deallocate (u)
end subroutine spline
! *********************************************************************************** 
subroutine splint (xa, ya, y2a, n, x, y)   
!------------------------------------------------------------------------------------
! The routine evaluates a spline interpolant at a point.                            !
!------------------------------------------------------------------------------------    
  use parameters
  implicit none
  integer  :: n
  real(O)  :: xa(n), ya(n), y2a(n), x, y
!  
  integer  :: klo, khi, k
  real(O)  :: h, a, b 
  logical  :: more
!  
  klo = 1
  khi = n
  more = .true.
  do while (more)
    k = (khi + klo) / 2
    if (xa(k) > x) then
      khi = k
    else
      klo = k
    end if
    if (khi - klo <= 1) more = .false.
  end do
  h = xa(khi) - xa(klo)
  a = (xa(khi) - x) / h
  b = (x - xa(klo)) / h
  y = a * ya(klo) + b * ya(khi) + ((a**3 - a) * y2a(klo) +                          &
     (b**3 - b) * y2a(khi)) * (h**2) / 6._O  
end subroutine splint    
! ************************************************************************************
! *           HERMITE INTERPOLATION ROUTINE - F90-VERSION FROM SLATEC LIBRARY        *
! ************************************************************************************            
subroutine dpchim (n, x, f, d)
!-----------------------------------------------------------------------------------
! The routine computes the derivatives needed to determine a monotone piecewise    !
! cubic Hermite interpolant to given data.                                         !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer  :: n
  real(O)  :: x(n), f(n), d(n)
!
  integer  :: i, nless1
  real(O)  :: del1, del2, dmax, dmin, drat1, drat2, h1, h2, hsum, hsumt3,           &
              w1, w2, dpchst                
!              
  if (n < 2) then
    print "(/,2x,'Error in subroutine dpchfe in file Interp.f90:')"
    print "(  2x,'number of data points less than two;')"
    stop      
  end if             
  nless1 = n - 1
  h1     = x(2) - x(1)
  del1   = (f(2) - f(1)) / h1  
  if (nless1 > 1) then
    h2    =   x(3) - x(2)
    del2  =   (f(3) - f(2)) / h2
    hsum  =   h1 + h2
    w1    =   (h1 + hsum) / hsum
    w2    = - h1 / hsum
    d(1)  =   w1 * del1 + w2 * del2
    if (dpchst (d(1), del1) <= 0._O)  then
      d(1) = 0._O
    else if (dpchst (del1, del2) < 0._O)  then
      dmax = 3._O * del1
      if (abs(d(1)) > abs(dmax))  d(1) = dmax
    end if
    do i = 2, nless1          
      if (i /= 2) then
        h1   = h2
        h2   = x(i+1) - x(i)
        hsum = h1 + h2
        del1 = del2
        del2 = (f(i+1) - f(i)) / h2
      end if          
      d(i) = 0._O
      if (dpchst (del1, del2) > 0._O) then
        hsumt3 = hsum + hsum + hsum
        w1     = (hsum + h1) / hsumt3
        w2     = (hsum + h2) / hsumt3
        dmax   = max(abs(del1), abs(del2) )
        dmin   = min(abs(del1), abs(del2) )
        drat1  = del1 / dmax
        drat2  = del2 / dmax
        d(i)   = dmin / (w1 * drat1 + w2 * drat2)
      end if      
    end do   
    w1   = - h2 / hsum
    w2   =  (h2 + hsum) / hsum
    d(n) = w1 * del1 + w2 * del2
    if (dpchst (d(n), del2) <= 0._O)  then
      d(n) = 0._O
    else if (dpchst (del1, del2) < 0._O)  then
      dmax = 3._O * del2
      if (abs(d(n)) > abs(dmax)) d(n) = dmax
    end if
  else
    d(1) = del1
    d(n) = del1
  end if       
end subroutine dpchim
!************************************************************************************
subroutine dpchfe (n, x, f, d, xe, fe)
!------------------------------------------------------------------------------------
! The routine evaluates a cubic polynomial given in Hermite form at a point.        !
!------------------------------------------------------------------------------------ 
  use parameters  
  implicit none
  integer  :: n
  real(O)  :: x(n), f(n), d(n), xe, fe
!
  integer  :: i, ix
  real(O)  :: xs, xd, x1, x2, f1, f2, d1, d2
  logical  :: found
!  
  found = .false.
  do i = 1, n - 1
    xs = x(i)
    xd = x(i+1)            
    if (xe >= xs .and. xe < xd) then
      ix    = i
      found = .true.      
      exit             
    end if                   
  end do
  if (found) then  
    x1 = x(ix)
    x2 = x(ix+1)
    f1 = f(ix)
    f2 = f(ix+1)
    d1 = d(ix)
    d2 = d(ix+1)          
    call dchfev (x1, x2, f1, f2, d1, d2, xe, fe)
  else
    fe = f(n)
  end if      
end subroutine dpchfe
! ***********************************************************************************
subroutine dchfev (x1, x2, f1, f2, d1, d2, xe, fe) 
  use parameters
  use derived_parameters  
  implicit none  
  real(O)  :: x1, x2, f1, f2, d1, d2, xe, fe
!
  real(O)  :: c2, c3, del1, del2, delta, h, x     
!    
  h =   x2 - x1
  if (abs(h) < MachEps) then
    print "(/,2x,'Error in subroutine dchfev in file Interp.f90:')"
    print "(  2x,'coincident knots;')"
    stop      
  end if          
  delta   =   (f2 - f1) / h
  del1    =   (d1 - delta) / h
  del2    =   (d2 - delta) / h                                          
  c2      = - (del1 + del1 + del2)
  c3      =   (del1 + del2) / h
  x       =   xe - x1
  fe      =   f1 + x * (d1 + x * (c2 + x * c3))        
end subroutine dchfev
! ***********************************************************************************
function dpchst (arg1, arg2) result (func)
  use parameters
  implicit none
  real(O),intent(in) :: arg1, arg2
  real(O)            :: func
!  
  func = 0._O
  if ((arg1 /= 0._O) .and. (arg2 /= 0._O)) then
    func = sign(1._O,arg1) * sign(1._O,arg2)
  end if 
end function dpchst

! **********************************************************************************
! *    ROUTINES FOR COMPUTING THE SCATTERED FIELD COEFFICIENTS FOR SPHERES AND     *
! *    THE Q MATRIX FOR UNIAXIAL ANISOTROPIC PARTICLES AND PARTICLES ON OR NEAR    *
! *                              A PLANE SURFACE                                   * 
! *    -----------------------------------------------------------------------     *
! *    Partial list of subroutines:                                                *
! *      coefficients_fg,                  coefficients_fg_m,                      *
! *      coefficients_fg_m_coated,         coefficients_fg_m_rec,                  *
! *      vector_Q_sphere,                  vector_Q_sphere1,                       *
! *      vector_Q_sphere1_m,               An,      Bn,                            *
! *      matrix_S1,                        matrix_Q_anis,                          *
! *      ConvergenceMatrixElemAnis,        matrixPARTSUB                           *
! **********************************************************************************
subroutine coefficients_fg (wavenumber, r, ind_ref, Mrank, Nrank, Nmax, c)
!-----------------------------------------------------------------------------------
! The routine computes the scattered field coefficients for a spherical particle   !
! and the azimuthal modes m = 0,1,..., Mrank.                                      !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none      
  integer    :: Mrank, Nrank, Nmax
  real(O)    :: r, wavenumber
  complex(O) :: ind_ref, c(2*Nmax)
!
  integer    :: k, n, m, l, N0
  real(O)    :: nr
  complex(O) :: x, f, f1, f2
  complex(O),allocatable :: j(:), y(:), h(:), hd(:), A(:)
!
  allocate (j(0:Nrank), y(0:Nrank), h(0:Nrank), hd(0:Nrank), A(Nrank))
  x = cmplx(wavenumber * r,0.0,O)
  if (abs(x) < MachEps) x = cmplx(MachEps,MachEps,O)
  call besel_h_complete (x, Nrank, j, y, h, hd)
  call An (x, ind_ref, Nrank, A)
  do m = 0, Mrank         
    if (m == 0) then
      do k = 1, Nrank
        n  = k
        nr = real(n,O)
        f  = ind_ref * A(n) + nr / x                                                                                             
        f1 = f * j(n) - j(n-1)
        f2 = f * h(n) - h(n-1)
        c(k) = - f1 / f2
        f  = A(n) / ind_ref + nr / x
        f1 = f * j(n) - j(n-1)
        f2 = f * h(n) - h(n-1)
        c(Nmax+k) = - f1 / f2 
      end do
    else         
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      do l = 1, 2
        do k = 1, Nrank - m + 1
          n  = m + k - 1
          nr = real(n,O)
          f  = ind_ref * A(n) + nr / x                                                                                           
          f1 = f * j(n) - j(n-1)
          f2 = f * h(n) - h(n-1)
          c(N0+k) = - f1 / f2 
          f  = A(n) / ind_ref + nr / x
          f1 = f * j(n) - j(n-1)
          f2 = f * h(n) - h(n-1)
          c(Nmax+N0+k) = - f1 / f2 
        end do
        N0 = N0 + Nrank - m + 1
      end do       
    end if
  end do      
  deallocate (j, y, h, hd, A)      
end subroutine coefficients_fg
!***********************************************************************************
subroutine coefficients_fg_m (wavenumber, r, ind_ref, m, Nrank, Nmax, c)
!-----------------------------------------------------------------------------------
! The routine computes the scattered field coefficients for a spherical particle   !
! and the azimuthal modes m.                                                       !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none  
  integer    :: m, Nrank, Nmax
  real(O)    :: r, wavenumber
  complex(O) :: ind_ref, c(2*Nmax)
!    
  integer    :: k, n
  real(O)    :: nr
  complex(O) :: x, f, f1, f2
  complex(O),allocatable :: j(:), y(:), h(:), hd(:), A(:)
!
  allocate (j(0:Nrank), y(0:Nrank), h(0:Nrank), hd(0:Nrank), A(Nrank))
  x = cmplx(wavenumber * r,0.0,O)
  if (abs(x) < MachEps) x = cmplx(MachEps,MachEps,O)
  call besel_h_complete (x, Nrank, j, y, h, hd)
  call An (x, ind_ref, Nrank, A)
  if (m == 0) then
    do k = 1, Nmax
      n  = k
      nr = real(n,O)
      f  = ind_ref * A(n) + nr / x                                                                                   
      f1 = f * j(n) - j(n-1)
      f2 = f * h(n) - h(n-1)
      c(k) = - f1 / f2
      f  = A(n) / ind_ref + nr / x 
      f1 = f * j(n) - j(n-1)
      f2 = f * h(n) - h(n-1)
      c(Nmax+k) = - f1 / f2 
    end do
  else
    do k = 1, Nmax
      n  = m + k - 1
      nr = real(n,O)
      f  = ind_ref * A(n) + nr / x                                                                                           
      f1 = f * j(n) - j(n-1)
      f2 = f * h(n) - h(n-1)
      c(k) = - f1 / f2 
      f  = A(n) / ind_ref + nr / x 
      f1 = f * j(n) - j(n-1)
      f2 = f * h(n) - h(n-1)
      c(Nmax+k) = - f1 / f2             
    end do                                                 
  end if        
  deallocate (j, y, h, hd, A)      
end subroutine coefficients_fg_m
!***********************************************************************************
subroutine coefficients_fg_m_coated (wavenumber, Npart, r, ind_ref, m, Nrank,       &
           Nmax, c)
!-----------------------------------------------------------------------------------
! The routine computes the scattered field coefficients for a coated spherical     !
! particle and the azimuthal modes m.                                              !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none  
  integer    :: m, Npart, Nrank, Nmax
  real(O)    :: wavenumber, r(Npart) 
  complex(O) :: ind_ref(Npart), c(2*Nmax)   
!
  integer    :: p
  complex(O) :: x, ind_refC 
!
  if (Npart == 1) then
    x = cmplx(wavenumber * r(1),0.0,O)
    ind_refC = ind_ref(1)
  else
    x = ind_ref(Npart-1) * wavenumber * r(Npart)
    ind_refC = ind_ref(Npart) / ind_ref(Npart-1)
  end if
  if (abs(x) < MachEps) x = cmplx(MachEps,MachEps,O)
  call coefficients_fg_m_rec (.true., x, ind_refC, m, Nrank, Nmax, c)
  if (Npart > 1) then
    do p = Npart - 1, 1, -1
      if (p > 1) then
        x = ind_ref(p-1) * wavenumber * r(p)
        ind_refC = ind_ref(p) / ind_ref(p-1)
      else
        x = cmplx(wavenumber * r(1),0.0,O)
        ind_refC = ind_ref(1)
      end if
      if (abs(x) < MachEps) x = cmplx(MachEps,MachEps,O)
      call coefficients_fg_m_rec (.false., x, ind_refC, m, Nrank, Nmax, c)
    end do
  end if
end subroutine coefficients_fg_m_coated    
!***********************************************************************************
subroutine coefficients_fg_m_rec (firstcall, x, ind_ref, m, Nrank, Nmax, c)
!-----------------------------------------------------------------------------------
! The routine computes the scattered field coefficients for a coated sphere and    !
! the azimuthal mode m using a reccurence relation.                                !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none  
  integer    :: m, Nrank, Nmax
  complex(O) :: x, ind_ref, c(2*Nmax)
  logical    :: firstcall
!    
  integer    :: k, n
  real(O)    :: nr
  complex(O) :: xm, f, f1, f2, b1, b2, pn, sn, qn, rn
  complex(O),allocatable :: j(:), y(:), h(:), hd(:), A(:), B(:), jm(:), ym(:),      &
                            hm(:), hdm(:)
!
  allocate (j(0:Nrank), y(0:Nrank), h(0:Nrank), hd(0:Nrank), A(Nrank))   
  call besel_h_complete (x, Nrank, j, y, h, hd)
  call An (x, ind_ref, Nrank, A)
  if (.not. firstcall) then
    xm = x * ind_ref
    allocate (jm(0:Nrank), ym(0:Nrank), hm(0:Nrank), hdm(0:Nrank), B(Nrank)) 
    call besel_h_complete (xm, Nrank, jm, ym, hm, hdm)  
    call Bn (x, ind_ref, Nrank, B)
  end if
  if (m == 0) then
    do k = 1, Nmax
      n  = k
      nr = real(n,O)
      if (firstcall) then
        pn = one
        sn = one
        qn = one
        rn = one
      else
        b1 = hm(n) / jm(n)
        b2 = B(n) / A(n)
        pn = one + c(k) * b1
        sn = one + c(Nmax+k) * b1
        qn = one + c(Nmax+k) * b1 * b2
        rn = one + c(k) * b1 * b2
      end if
      f  = rn * ind_ref * A(n) + pn * nr / x
      f1 = f * j(n) - pn * j(n-1)
      f2 = f * h(n) - pn * h(n-1)
      c(k) = - f1 / f2
      f  = qn * A(n) / ind_ref + sn * nr / x 
      f1 = f * j(n) - sn * j(n-1)
      f2 = f * h(n) - sn * h(n-1)
      c(Nmax+k) = - f1 / f2 
    end do
  else
    do k = 1, Nmax
      n  = m + k - 1
      nr = real(n,O)
      if (firstcall) then
        pn = one
        sn = one
        qn = one
        rn = one
      else
        b1 = hm(n) / jm(n)
        b2 = B(n) / A(n)
        pn = one + c(k) * b1
        sn = one + c(Nmax+k) * b1
        qn = one + c(Nmax+k) * b1 * b2
        rn = one + c(k) * b1 * b2
      end if
      f  = rn * ind_ref * A(n) + pn * nr / x
      f1 = f * j(n) - pn * j(n-1)
      f2 = f * h(n) - pn * h(n-1)
      c(k) = - f1 / f2
      f  = qn * A(n) / ind_ref + sn * nr / x 
      f1 = f * j(n) - sn * j(n-1)
      f2 = f * h(n) - sn * h(n-1)
      c(Nmax+k) = - f1 / f2             
    end do                                                 
  end if        
  deallocate (j, y, h, hd, A)
  if (.not.firstcall) deallocate (jm, ym, hm, hdm, B)      
end subroutine coefficients_fg_m_rec
!***********************************************************************************
subroutine vector_Q_sphere (index1, index2, wavenumber, r, ind_ref, Mrank, Nrank,   &
           Nmax, c)     
!-----------------------------------------------------------------------------------
! The routine computes the Q vector for a spherical particle and the azimuthal     !
! modes m = 0,1,...,Mrank.                                                         !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none  
  integer    :: Mrank, Nrank, Nmax, index1, index2
  real(O)    :: r, wavenumber
  complex(O) :: ind_ref, c(2*Nmax)
!
  integer    :: k, n, m, l, N0
  complex(O) :: x, mx, f, f1, f2
  complex(O),allocatable :: j(:), jd(:), h(:), hd(:)
!
  allocate (j(0:Nrank), jd(0:Nrank), h(0:Nrank), hd(0:Nrank)) 
  x = cmplx(wavenumber * r,0.0,O)
  if (abs(x) < MachEps) x = cmplx(MachEps,MachEps,O)
  mx = x * ind_ref
  if (index1 == 3 .and. index2 == 1) then
    call besel_h (x, Nrank, h, hd)
    call besel_j (mx, Nrank, j, jd)
  else if (index1 == 3 .and. index2 == 3) then
    call besel_h (x, Nrank, h, hd)
    call besel_h (mx, Nrank, j, jd)
  else if (index1 == 1 .and. index2 == 1) then
    call besel_j (x, Nrank, h, hd)
    call besel_j (mx, Nrank, j, jd)
  else if (index1 == 1 .and. index2 == 3) then
    call besel_j (x, Nrank, h, hd)
    call besel_h (mx, Nrank, j, jd)   
  end if
  f = im * x
  do m = 0, Mrank         
    if (m == 0) then
      do k = 1, Nrank
        n  = k  
        f1 = f * j(n) * hd(n)
        f2 = f * h(n) * jd(n)                                                                                    
        c(k)      = f1 - f2 
        c(Nmax+k) = (ind_ref**2 * f1 - f2) / ind_ref
      end do
    else         
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      do l = 1, 2
        do k = 1, Nrank - m + 1
          n = m + k - 1
          f1 = f * j(n) * hd(n)
          f2 = f * h(n) * jd(n)
          c(N0+k)      = f1 - f2 
          c(Nmax+N0+k) = (ind_ref**2 * f1 - f2) / ind_ref               
        end do                                             
        N0 = N0 + Nrank - m + 1
      end do      
    end if
  end do
  deallocate (j, jd, h, hd)     
end subroutine vector_Q_sphere
!***********************************************************************************
subroutine vector_Q_sphere1 (index1, index2, wavenumber, r, ind_ref, Mrank, Nrank,  &
           Nmax, c)
!-----------------------------------------------------------------------------------
! The routine computes the Q vector for a spherical particle and the azimuthal     !
! modes m = 0,1,..., Mrank. In contrast to the subroutine "vector_Q_sphere" the    !
! derivative of the Bessel and Hankel functions are expressed in terms of the      !
! An and Bn coefficients.                                                          !
!-----------------------------------------------------------------------------------
  use parameters        
  use derived_parameters
  implicit none      
  integer    :: Mrank, Nrank, Nmax, index1, index2
  real(O)    :: r, wavenumber
  complex(O) :: ind_ref, c(2*Nmax)
!
  integer    :: k, n, m, l, N0
  real(O)    :: nr
  complex(O) :: x, mx, f, f1, f2, fn
  complex(O),allocatable :: j(:), jd(:), h(:), hd(:), A(:)
!
  allocate (j(0:Nrank), jd(0:Nrank), h(0:Nrank), hd(0:Nrank), A(Nrank)) 
  x = cmplx(wavenumber * r,0._O)
  if (abs(x) < MachEps) x = cmplx(MachEps,MachEps,O)
  mx = x * ind_ref
  if (index2 == 1) then
    call An (x, ind_ref, Nrank, A)
  else
    call Bn (x, ind_ref, Nrank, A)
  end if
  if (index1 == 3 .and. index2 == 1) then
    call besel_h (x, Nrank, h, hd)
    call besel_j (mx, Nrank, j, jd)
  else if(index1 == 3 .and. index2 == 3) then
    call besel_h (x, Nrank, h, hd)
    call besel_h (mx, Nrank, j, jd)
  else if(index1 == 1 .and. index2 == 1) then
    call besel_j (x, Nrank, h, hd)
    call besel_j (mx, Nrank, j, jd)
  else if (index1 == 1 .and. index2 == 3) then
    call besel_j (x, Nrank, h, hd)
    call besel_h (mx, Nrank, j, jd)   
  end if
  f = - im * x * x
  do m = 0, Mrank         
    if (m == 0) then
      do k = 1, Nrank
        n  = k                          
        nr = real(n,O)
        f1 = ind_ref * A(n) + nr / x
        f2 = A(n) / ind_ref + nr / x                                                             
        fn = f * j(n)
        c(k) = fn * (f1*h(n) - h(n-1))
        c(Nmax+k) = ind_ref * fn * (f2 * h(n) - h(n-1))
      end do
    else
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      do l = 1, 2
        do k = 1, Nrank - m + 1
          n = m + k - 1
          nr = real(n,O)
          f1 = ind_ref * A(n) + nr / x
          f2 = A(n) / ind_ref + nr / x                                                           
          fn = f * j(n)
          c(N0+k) = fn * (f1 * h(n) - h(n-1))
          c(Nmax+N0+k) = ind_ref * fn * (f2 * h(n) - h(n-1))            
        end do                                             
        N0 = N0 + Nrank - m + 1
      end do      
    end if
  end do
  deallocate (j, jd, h, hd, A)      
end subroutine vector_Q_sphere1
!***********************************************************************************
subroutine vector_Q_sphere1_m (index1, index2, wavenumber, r,ind_ref, m, Nrank,     &
           Nmax, c)
!-----------------------------------------------------------------------------------
! The routine computes the Q vector for a spherical particle and the azimuthal     !
! mode m.                                                                          !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none  
  integer    :: m, Nrank, Nmax, index1, index2
  real(O)    :: wavenumber, r
  complex(O) :: ind_ref, c(2*Nmax)
!
  integer    :: k, n
  real(O)    :: nr
  complex(O) :: x, mx, f, f1, f2, fn
  complex(O),allocatable :: j(:), jd(:), h(:), hd(:), A(:)
!
  allocate (j(0:Nrank), jd(0:Nrank), h(0:Nrank), hd(0:Nrank), A(Nrank)) 
  x = cmplx(wavenumber * r,0.0,O)
  if (abs(x) < MachEps) x = cmplx(MachEps,MachEps,O)
  mx = x * ind_ref
  if (index2 == 1) then
    call An (x, ind_ref, Nrank, A)
  else
    call Bn (x, ind_ref, Nrank, A)
  end if
  if (index1 == 3 .and. index2 == 1) then
    call besel_h (x, Nrank, h, hd)
    call besel_j (mx, Nrank, j, jd)
  else if (index1 == 3 .and. index2 == 3) then
    call besel_h (x, Nrank, h, hd)
    call besel_h (mx, Nrank, j, jd)
  else if (index1 == 1 .and. index2 == 1) then
    call besel_j (x, Nrank, h, hd)
    call besel_j (mx, Nrank, j, jd)
  else if (index1 == 1 .and. index2 == 3) then
    call besel_j (x, Nrank, h, hd)
    call besel_h (mx, Nrank, j, jd)   
  end if 
  f = - im * x * x     
  if (m == 0) then
    do k = 1, Nmax
      n = k
      nr = real(n,O)
      f1 = ind_ref * A(n) + nr / x
      f2 = A(n) / ind_ref + nr / x                                                           
      fn = f * j(n)                                                                                          
      c(k)      = fn * (f1 * h(n) - h(n-1))
      c(Nmax+k) = ind_ref * fn * (f2 * h(n) - h(n-1))
    end do
  else
    do k = 1, Nmax
      n = m + k - 1
      nr = real(n,O)
      f1 = ind_ref * A(n) + nr / x
      f2 = A(n) / ind_ref + nr / x                                                           
      fn = f * j(n)
      c(k)      = fn * (f1 * h(n) - h(n-1))
      c(Nmax+k) = ind_ref * fn * (f2 * h(n) - h(n-1))           
    end do                                                 
  end if          
  deallocate (j, jd, h, hd, A)      
end subroutine vector_Q_sphere1_m       
!***********************************************************************************
subroutine An (x, m, Nrank, A)
!-----------------------------------------------------------------------------------
! The routine computes                                                             ! 
!                  A(n) = d[ln(x*jn(x))] = [x*jn(x)]'/[x*jn(x)],                   !
! where jn are the Bessel functions.                                               !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none 
  integer    :: Nrank
  complex(O) :: x, m, A(Nrank)
!       
  real(O)    :: DNc, DNmax, n1r
  integer    :: Nmax, n
  complex(O) :: mx, fp, f, tamp
!
  DNc   = abs(x + 4._O * x**0.33_O + 2._O)
  DNmax = max(DNc,abs(m * x)) + 100._O
  Nmax  = int(DNmax)
  mx = m * x
  fp = zero
  do n = Nmax, 1, -1
    n1r  = real(n + 1,O)
    tamp = n1r / mx
    f = tamp - 1._O / (fp + tamp)
    if (n <= Nrank) A(n) = f
    fp = f            
  end do        
end subroutine An
!***********************************************************************************
subroutine Bn (x, m, Nrank, B)
!-----------------------------------------------------------------------------------
! The routine computes                                                             !
!                    B(n) = d[ln(x*hn(x))] = [x*hn(x)]'/[x*hn(x)],                 !
! where hn are the Hankel functions.                                               !  
!-----------------------------------------------------------------------------------
  use parameters
  implicit none 
  integer    :: Nrank
  complex(O) :: x, m, B(Nrank)
!       
  integer    :: n
  real(O)    :: n1r
  complex(O) :: mx, smx, cmx, j0, j1, y0, y1, h0, h1, tamp
!
  mx  = m * x
  smx = sin(mx)
  cmx = cos(mx)
  j0  = smx / mx
  j1  = j0 / mx - cmx / mx
  y0  = - cmx / mx
  y1  = y0 / mx - smx / mx
  h0  = j0 + im * y0
  h1  = j1 + im * y1
  B(1)= h0 / h1 - 1._O / mx
  do n = 1, Nrank - 1
    n1r  = real(n + 1,O)          
    tamp = n1r / mx 
    B(n+1) = - tamp + 1._O / (tamp - B(n))         
  end do        
end subroutine Bn
!***********************************************************************************
subroutine matrix_S1 (Nmax, Nmax1, S2, n2p, m2p, S1, n1p, m1p)
  use parameters
  implicit none
  integer    :: Nmax, Nmax1, n1p, m1p, n2p, m2p, k, k1  
  complex(O) :: S1(2*n1p,2*m1p), S2(2*n2p,2*m2p)
!
  do k = 1, Nmax
    do k1 = 1, Nmax1
      S1(k,k1) = S2(k1,k)
      S1(k,k1+Nmax1) = - S2(k1+Nmax1,k)
      S1(k+Nmax,k1)  =   S1(k,k1+Nmax1)
      S1(k+Nmax,k1+Nmax1) = S1(k,k1)
    end do     
  end do      
end subroutine matrix_S1
!***********************************************************************************
subroutine matrix_Q_anis (FileGeom, TypeGeom, index1, index2, k, ind_ref, ind_refZ, &
           alphaP, betaP, gamaP, Nsurf, surf, rpX, npX, areaX, Nface, Mrank, Nrank, &
           Nmax, Nbeta, NintAL, Nparam, Nintparam, paramG1, paramG2, weightsG,      &
           A, nap, map)
!-----------------------------------------------------------------------------------
! The routine compute the Q matrix of an uniaxial anisotropic particle.            ! 
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer     :: TypeGeom, index1, index2, Mrank, Nrank, Nmax, Nsurf, Nface,         &
                 NintAL, Nparam, Nintparam(Nparam), Nbeta, nap, map
  real(O)     :: k, alphaP, betaP, gamaP, surf(Nsurf), paramG1(Nparam,NintAL*NintAL),&
                 paramG2(Nparam,NintAL*NintAL), weightsG(Nparam,NintAL*NintAL),      &
                 rpX(3,NfacePD), npX(3,NfacePD), areaX(NfacePD)
  complex(O)  :: ind_ref, ind_refZ, A(2*nap,2*map)
  logical     :: FileGeom
!
  integer     :: i, j, pint, iparam, Nintl
  real(O)     :: r, theta, phi, dA, param1, param2, pondere, sign, n(3), x, y, z,    &
                 xl, yl, zl, thetal, phil, rl, nr, nt, np, nx, ny, nz, nxl, nyl, nzl 
  complex(O)  :: ki, zkl, ml(3), nl(3), xec(3), yec(3), v1, v2, fact, f, xhc(3),     &
                 yhc(3), mixt_product
  complex(O),allocatable :: Xe(:,:), Ye(:,:), m3(:,:), n3(:,:), Xh(:,:), Yh(:,:)
!
  allocate (Xe(3,Nmax), Ye(3,Nmax), Xh(3,Nmax), Yh(3,Nmax), m3(3,Nmax), n3(3,Nmax)) 
  do i = 1, 2*Nmax
    do j = 1, 2*Nmax
      A(i,j) = zero
    end do
  end do      
  ki   = k * ind_ref
  sign = 1._O
  if (index1 == 3 .and. index2 == 1) sign = - 1._O
  f = sign * im * k * k / Pi
  if (.not. FileGeom) then
    do iparam = 1, Nparam
      Nintl = Nintparam(iparam)
      do pint = 1, Nintl          
        param1  = paramG1(iparam,pint)
        param2  = paramG2(iparam,pint)
        pondere = weightsG(iparam,pint)
        call elem_geom3D (TypeGeom, Nsurf, surf, param1, param2, iparam, r, theta,   &
             phi, dA, n, .false., 1)                                                      
        call MN_anisotrop (ki, ind_ref, ind_refZ, r, theta, phi, alphaP, betaP,      &
             gamaP, Mrank, Nrank, Nmax, Nbeta, Xe, Ye, Xh, Yh)
!       --- compute the localized SWVF in the principal coordinate system ----
        x = r * sin(theta) * cos(phi)
        y = r * sin(theta) * sin(phi)
        z = r * cos(theta) 
        call T_cartesian_global_local (x, y, z, alphaP, betaP, gamaP, xl, yl, zl)  
        call T_cartesian_spherical (xl, yl, zl, rl, thetal, phil) 
        zkl = cmplx(k * rl,0.0,O) 
        if (index1 == 3 .and. index2 == 1) then       
          call MN_complete (3, zkl, thetal, phil, Mrank, Nrank, Nmax,.false.,.false.,&
               m3, n3)
        else if (index1 == 1 .and. index2 == 1) then            
          call MN_complete (1, zkl, thetal, phil, Mrank, Nrank, Nmax,.false.,.false.,&
               m3, n3)
        end if
!       --- transform the unit normal vector in the principal coordinate system ---
        nr = n(1)
        nt = n(2)
        np = n(3)
        nx = sin(theta) * cos(phi)  * nr + cos(theta) * cos(phi)  * nt - sin(phi) * np 
        ny = sin(theta) * sin(phi)  * nr + cos(theta) * sin(phi)  * nt + cos(phi) * np
        nz =             cos(theta) * nr -             sin(theta) * nt 
        call T_cartesian_global_local (nx, ny, nz, alphaP, betaP, gamaP, nxl, nyl, nzl)
        n(1) =   sin(thetal) * cos(phil) * nxl + sin(thetal) * sin(phil) * nyl +     &
                 cos(thetal) * nzl
        n(2) =   cos(thetal) * cos(phil) * nxl + cos(thetal) * sin(phil) * nyl -     &
                 sin(thetal) * nzl
        n(3) =               - sin(phil) * nxl +               cos(phil) * nyl      
        fact = f * dA * pondere
        do i = 1, Nmax
          ml(1) = m3(1,i)
          ml(2) = m3(2,i)
          ml(3) = m3(3,i)
          nl(1) = n3(1,i)
          nl(2) = n3(2,i)
          nl(3) = n3(3,i)
          do j = 1, Nmax
            xec(1) = Xe(1,j)
            xec(2) = Xe(2,j)
            xec(3) = Xe(3,j)
            yec(1) = Ye(1,j)
            yec(2) = Ye(2,j)
            yec(3) = Ye(3,j)
            xhc(1) = Xh(1,j)
            xhc(2) = Xh(2,j)
            xhc(3) = Xh(3,j)
            yhc(1) = Yh(1,j)
            yhc(2) = Yh(2,j)
            yhc(3) = Yh(3,j)
            v1 = mixt_product (n, xec, nl)
            v2 = mixt_product (n, xhc, ml)                                                                             
            A(i,j) = A(i,j) + (v1 + ind_ref * v2) * fact
            v1 = mixt_product (n, yec, nl)
            v2 = mixt_product (n, yhc, ml)
            A(i,j+Nmax) = A(i,j+Nmax) + (v1 + ind_ref * v2) * fact
            v1 = mixt_product (n, xec, ml)
            v2 = mixt_product (n, xhc, nl)
            A(i+Nmax,j) = A(i+Nmax,j) + (v1 + ind_ref * v2) * fact
            v1 = mixt_product (n, yec, ml)
            v2 = mixt_product (n, yhc, nl)
            A(i+Nmax,j+Nmax) = A(i+Nmax,j+Nmax) + (v1 + ind_ref * v2) * fact          
          end do
        end do    
      end do
    end do
  else
    do pint = 1, Nface
      x = rpX(1,pint)
      y = rpX(2,pint)
      z = rpX(3,pint)
      call T_cartesian_spherical (x, y, z, r, theta, phi)
      dA = areaX(pint)
      nr =   sin(theta) * cos(phi) * npX(1,pint) +                                   &
             sin(theta) * sin(phi) * npX(2,pint) + cos(theta) * npX(3,pint) 
      nt =   cos(theta) * cos(phi) * npX(1,pint) +                                   &
             cos(theta) * sin(phi) * npX(2,pint) - sin(theta) * npX(3,pint)
      np = - sin(phi) * npX(1,pint) + cos(phi) * npX(2,pint)
      call MN_anisotrop (ki, ind_ref, ind_refZ, r, theta, phi, alphaP, betaP, gamaP, &
           Mrank, Nrank, Nmax, Nbeta, Xe, Ye, Xh, Yh)
!     --- compute the localized SWVF in the principal coordinate system ----       
      call T_cartesian_global_local (x, y, z, alphaP, betaP, gamaP, xl, yl, zl)  
      call T_cartesian_spherical (xl, yl, zl, rl, thetal, phil) 
      zkl = cmplx(k * rl,0.0,O) 
      if (index1 == 3 .and. index2 == 1) then       
        call MN_complete (3, zkl, thetal, phil, Mrank, Nrank, Nmax,.false.,.false.,  &
             m3, n3)
      else if (index1 == 1 .and. index2 == 1) then      
        call MN_complete (1, zkl, thetal, phil, Mrank, Nrank, Nmax,.false.,.false.,  &
             m3, n3)
      end if
!     --- transform the unit normal vector in the principal coordinate system ---     
      nx = sin(theta) * cos(phi)  * nr + cos(theta) * cos(phi)  * nt - sin(phi) * np 
      ny = sin(theta) * sin(phi)  * nr + cos(theta) * sin(phi)  * nt + cos(phi) * np
      nz =             cos(theta) * nr -             sin(theta) * nt 
      call T_cartesian_global_local (nx, ny, nz, alphaP, betaP, gamaP, nxl, nyl, nzl)
      n(1) =   sin(thetal) * cos(phil) * nxl + sin(thetal) * sin(phil) * nyl +       &
               cos(thetal) * nzl
      n(2) =   cos(thetal) * cos(phil) * nxl + cos(thetal) * sin(phil) * nyl -       &
               sin(thetal) * nzl
      n(3) =               - sin(phil) * nxl +               cos(phil) * nyl      
      fact = f * dA
      do i = 1, Nmax
        ml(1) = m3(1,i)
        ml(2) = m3(2,i)
        ml(3) = m3(3,i)
        nl(1) = n3(1,i)
        nl(2) = n3(2,i)
        nl(3) = n3(3,i)
        do j = 1, Nmax
          xec(1) = Xe(1,j)
          xec(2) = Xe(2,j)
          xec(3) = Xe(3,j)
          yec(1) = Ye(1,j)
          yec(2) = Ye(2,j)
          yec(3) = Ye(3,j)
          xhc(1) = Xh(1,j)
          xhc(2) = Xh(2,j)
          xhc(3) = Xh(3,j)
          yhc(1) = Yh(1,j)
          yhc(2) = Yh(2,j)
          yhc(3) = Yh(3,j)
          v1 = mixt_product (n, xec, nl)
          v2 = mixt_product (n, xhc, ml)                                                                               
          A(i,j) = A(i,j) + (v1 + ind_ref * v2) * fact
          v1 = mixt_product (n, yec, nl)
          v2 = mixt_product (n, yhc, ml)
          A(i,j+Nmax) = A(i,j+Nmax) + (v1 + ind_ref * v2) * fact
          v1 = mixt_product (n, xec, ml)
          v2 = mixt_product (n, xhc, nl)
          A(i+Nmax,j) = A(i+Nmax,j) + (v1 + ind_ref * v2) * fact
          v1 = mixt_product (n, yec, ml)
          v2 = mixt_product (n, yhc, nl)
          A(i+Nmax,j+Nmax) = A(i+Nmax,j+Nmax) + (v1 + ind_ref * v2) * fact          
        end do
      end do          
    end do
  end if                            
  deallocate (Xe, Ye, Xh, Yh, m3, n3)
end subroutine matrix_Q_anis 
!***********************************************************************************
subroutine ConvergenceMatrixElemAnis (TypeGeom, index1, index2, k, ind_ref,         &
           ind_refZ, alphaP, betaP, gamaP, Nsurf, surf, mline, mcol, Nrank,         &
           NintMax, Nint1, Nint2, Nbeta, Nparam)
  use parameters
  use derived_parameters
  implicit none
  integer     :: TypeGeom, index1, index2, mline, mcol, Nrank, NintMax, Nint1,      &
                 Nint2, Nsurf, Nparam, Nbeta
  real(O)     :: k, alphaP, betaP, gamaP, surf(Nsurf)
  complex(O)  :: ind_ref, ind_refZ
!
  integer     :: NmaxL, NmaxC, ml_minus, i, j, pint, iparam, Nint1l, Nint2l,        &
                 Nintl, NintAL, iint, imn, jmn
  real(O)     :: r, theta, phi, dA, param1, param2, pondere, sign, n(3), x, y, z,   &
                 xl, yl, zl, thetal, phil, rl, nr, nt, np, nx, ny, nz, nxl, nyl,    &
                 nzl, MaxA(2), MinA(2)
  complex(O)  :: ki, zkl, ml(3), nl(3), xec(3), yec(3), v1, v2, fact, f, xhc(3),    &
                 yhc(3), mixt_product, A11(2,2), A12(2,2), A21(2,2), A22(2,2),      &
                 expfctL
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG1(:,:), paramG2(:,:), weightsG(:,:) 
  complex(O),allocatable :: Xe(:,:), Ye(:,:), m3(:,:), n3(:,:), Xh(:,:), Yh(:,:)
!
  NmaxL = Nrank - mline + 1  ! mline >= 0
  NmaxC = Nrank - mcol  + 1  ! mcol  >= 0
  ml_minus = - mline
  allocate (Xe(3,NmaxC), Ye(3,NmaxC), Xh(3,NmaxC), Yh(3,NmaxC),                     &
            m3(3,NmaxL), n3(3,NmaxL))      
  ki   = k * ind_ref
  sign = 1._O
  if (index1 == 3 .and. index2 == 1) sign = - 1._O
  f = sign * im * k * k / Pi
  if (mline == 1) then 
    print "(2x,'Integral Test over Matrix Elements of Blocks (1,Mrank):')"
  else 
    print "(2x,'Integral Test over Matrix Elements of Blocks (Mrank,Mrank):')"
  end if
  print "(2x,'Nint1   Nint2          max-min (A11,A22)             max-min (A12,A21) ')"    
  do iint = 1, NintMax
    Nint1l = Nint1 + iint - 1
    Nint2l = Nint2 + iint - 1
    NintAL = max(Nint1l,Nint2l)                      
    allocate (paramG1(Nparam,NintAL*NintAL), paramG2(Nparam,NintAL*NintAL),         &
              weightsG(Nparam,NintAL*NintAL))
    allocate (Nintparam(Nparam))
    call interpolation_list3D (TypeGeom, Nsurf, surf, Nint1l, Nint2l, NintAL,       &
         Nparam, Nintparam, paramG1, paramG2, weightsG, .false., 1) 
    do i = 1, 2
      do j = 1, 2
        A11(i,j) = zero
        A12(i,j) = zero
        A21(i,j) = zero
        A22(i,j) = zero
      end do
    end do   
    do iparam = 1, Nparam
      Nintl = Nintparam(iparam)
      do pint = 1, Nintl          
        param1  = paramG1(iparam,pint)
        param2  = paramG2(iparam,pint)
        pondere = weightsG(iparam,pint)
        call elem_geom3D (TypeGeom, Nsurf, surf, param1, param2, iparam, r, theta,   &
             phi, dA, n, .false., 1)                                                      
        call MN_m_anisotrop (ki, ind_ref, ind_refZ, r, theta, phi, alphaP, betaP,    &
             gamaP, mcol, Nrank, NmaxC, Nbeta, Xe, Ye, Xh, Yh)        
!       --- compute the localized SWVF in the principal coordinate system ----
        x = r * sin(theta) * cos(phi)
        y = r * sin(theta) * sin(phi)
        z = r * cos(theta) 
        call T_cartesian_global_local (x, y, z, alphaP, betaP, gamaP, xl, yl, zl)  
        call T_cartesian_spherical (xl, yl, zl, rl, thetal, phil) 
        zkl = cmplx(k * rl,0.0,O) 
        if (index1 == 3 .and. index2 == 1) then  
          call MN (3, zkl, thetal, ml_minus, Nrank, NmaxL, m3, n3)                                 
        else if (index1 == 1 .and. index2 == 1) then            
          call MN (1, zkl, thetal, ml_minus, Nrank, NmaxL, m3, n3)          
        end if
!       --- transform the unit normal vector in the principal coordinate system ---
        nr = n(1)
        nt = n(2)
        np = n(3)
        nx = sin(theta) * cos(phi)  * nr + cos(theta) * cos(phi)  * nt - sin(phi) * np 
        ny = sin(theta) * sin(phi)  * nr + cos(theta) * sin(phi)  * nt + cos(phi) * np
        nz =             cos(theta) * nr -             sin(theta) * nt 
        call T_cartesian_global_local (nx, ny, nz, alphaP, betaP, gamaP, nxl, nyl, nzl)
        n(1) = sin(thetal) * cos(phil) * nxl + sin(thetal) * sin(phil) * nyl + cos(thetal) * nzl
        n(2) = cos(thetal) * cos(phil) * nxl + cos(thetal) * sin(phil) * nyl - sin(thetal) * nzl
        n(3) =             - sin(phil) * nxl +               cos(phil) * nyl      
        fact = f * dA * pondere
        expfctL =  exp(im * ml_minus * phil)            
        do i = 1, 2
          if (i == 1) then
            imn = 1
          else
            imn = NmaxL
          end if            
          ml(1) = m3(1,imn) * expfctL
          ml(2) = m3(2,imn) * expfctL
          ml(3) = m3(3,imn) * expfctL
          nl(1) = n3(1,imn) * expfctL
          nl(2) = n3(2,imn) * expfctL
          nl(3) = n3(3,imn) * expfctL
          do j = 1, 2
            if (j == 1) then
              jmn = 1
            else
              jmn = NmaxC
            end if           
            xec(1) = Xe(1,jmn)
            xec(2) = Xe(2,jmn)
            xec(3) = Xe(3,jmn)
            yec(1) = Ye(1,jmn)
            yec(2) = Ye(2,jmn)
            yec(3) = Ye(3,jmn)
            xhc(1) = Xh(1,jmn)
            xhc(2) = Xh(2,jmn)
            xhc(3) = Xh(3,jmn)
            yhc(1) = Yh(1,jmn)
            yhc(2) = Yh(2,jmn)
            yhc(3) = Yh(3,jmn)
            v1 = mixt_product (n, xec, nl)
            v2 = mixt_product (n, xhc, ml)                                                                             
            A11(i,j) = A11(i,j) + (v1 + ind_ref * v2) * fact
            v1 = mixt_product (n, yec, nl)
            v2 = mixt_product (n, yhc, ml)
            A12(i,j) = A12(i,j) + (v1 + ind_ref * v2) * fact
            v1 = mixt_product (n, xec, ml)
            v2 = mixt_product (n, xhc, nl)
            A21(i,j) = A21(i,j) + (v1 + ind_ref * v2) * fact
            v1 = mixt_product (n, yec, ml)
            v2 = mixt_product (n, yhc, nl)
            A22(i,j) = A22(i,j) + (v1 + ind_ref * v2) * fact          
          end do
        end do    
      end do
    end do 
    MaxA(1) = max(abs(A11(1,1)), abs(A11(1,2)), abs(A11(2,1)), abs(A11(2,2)),       &
                  abs(A22(1,1)), abs(A22(1,2)), abs(A22(2,1)), abs(A22(2,2)))
    MinA(1) = min(abs(A11(1,1)), abs(A11(1,2)), abs(A11(2,1)), abs(A11(2,2)),       &
                  abs(A22(1,1)), abs(A22(1,2)), abs(A22(2,1)), abs(A22(2,2)))
        
    MaxA(2) = max(abs(A12(1,1)), abs(A12(1,2)), abs(A12(2,1)), abs(A12(2,2)),       &
                  abs(A21(1,1)), abs(A21(1,2)), abs(A21(2,1)), abs(A21(2,2)))
    MinA(2) = min(abs(A12(1,1)), abs(A12(1,2)), abs(A12(2,1)), abs(A12(2,2)),       &
                  abs(A21(1,1)), abs(A21(1,2)), abs(A21(2,1)), abs(A21(2,2)))
    print "(3x,i3,5x,i3,4x,1pe14.6,1x,1pe14.6,1x,1pe14.6,1x,1pe14.6)", Nint1l,      &
            Nint2l, MaxA(1), MinA(1), MaxA(2), MinA(2)
    deallocate (paramG1, paramG2, weightsG, Nintparam)
  end do
  deallocate (Xe, Ye, Xh, Yh, m3, n3)
end subroutine  ConvergenceMatrixElemAnis       
!***********************************************************************************
subroutine matrixPARTSUB (k, ind_ref, z0, m, Nrank, Nmax, Nx, x, pond, A, na, ma)
!-----------------------------------------------------------------------------------
! The routine computes the reflection matrix for the scattering of a particle      !
! near or on a plane surface.                                                      ! 
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: m, Nrank, Nmax, Nx, na, ma
  real(O)    :: k, z0, x(Nx), pond(Nx)
  complex(O) :: ind_ref, A(2*na,2*ma)
!
  integer    :: i, j, pint, n, n1
  real(O)    :: D, nm, n1m, mr
  complex(O) :: fact, t, Rpar, Rperp, Tpar, Tperp, q, cosb, sinb, cosbM0,           &
                sinbM0, sinb0, cosb0, f, fpp, ftp, fpt, ftt
  complex(O),allocatable :: Pnm(:), dPnm(:), pinm(:), taunm(:),                     &
                            PnmM(:), dPnmM(:), pinmM(:), taunmM(:)      
!
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  allocate (PnmM(0:Nrank), dPnmM(0:Nrank), pinmM(0:Nrank), taunmM(0:Nrank))
  do i = 1, 2*Nmax
    do j = 1, 2*Nmax
      A(i,j) = zero
    end do
  end do                           
  q = cmplx(k * z0,0.0,O)
  q = 2._O * im * q   
  if (abs(q) < MachEps) q = cmplx(MachEps,MachEps,O)
  mr = real(m,O)
  do pint = 1, Nx
    t     = one - x(pint) / q
    fact  = 4._O * exp(q) * pond(pint) / q    
    cosb0 = t
    sinb0 = sqrt(one - t * t)
    call Leg_normalized_complex (sinb0, cosb0, abs(m), Nrank, Pnm, dPnm, pinm, taunm)                     
    call Fresnel_aer_sub (cosb0, ind_ref, Rpar, Rperp, Tpar, Tperp, cosb, sinb)     
    cosbM0 = - t
    sinbM0 = sqrt(one - t * t)
    call Leg_normalized_complex (sinbM0, cosbM0, abs(m), Nrank, PnmM, dPnmM,        &
         pinmM, taunmM)                                                 
    do i = 1, Nmax
      if (m == 0) then
        n1 = i
      else
        n1 = abs(m) + i - 1
      end if
      n1m = real(2 * n1 * (n1 + 1),O)
      n1m = 1._O / sqrt(n1m)
      do j = 1, Nmax
        if (m == 0) then
          n = j
        else
          n = abs(m) + j - 1
        end if
        nm  = real(2 * n * (n + 1),O)
        nm  = 1._O / sqrt(nm)
        D   = nm * n1m
        f   = fact * D * im**(n1 - n)
        fpp = f * pinm(n) * pinmM(n1)
        ftt = f * taunm(n) * taunmM(n1)
        fpt = f * pinm(n) * taunmM(n1)
        ftp = f * taunm(n) * pinmM(n1)        
        A(i,j) = A(i,j) + (mr**2 * fpp * Rpar + ftt * Rperp)        
        A(i+Nmax,j) = A(i+Nmax,j) + mr * (fpt * Rpar + ftp * Rperp)
        A(i,j+Nmax) = A(i,j+Nmax) + mr *(ftp * Rpar + fpt * Rperp)
        A(i+Nmax,j+Nmax) = A(i+Nmax,j+Nmax) + (mr**2 * fpp * Rperp + ftt * Rpar)
      end do
    end do
  end do           
  deallocate (Pnm, dPnm, pinm, taunm, PnmM, dPnmM, pinmM, taunmM)        
end subroutine matrixPARTSUB 

! **********************************************************************************
! *          ROUTINES FOR COMPUTING THE Q MATRIX AND THE INCIDENT MATRIX           * 
! *                         AT AN INTEGRATION POINT                                *
! *    ------------------------------------------------------------------------    *
! *    Partial list of subroutines:                                                *
! *      matQ,        matQ_m,      matQ_COMP,     matQ_LAY,      matQ_LAY_a,       *
! *      matQ_LAY_b,  matQinc_m,   mvnv,          mvnv_m,        mvnvinc_m         *
! *    The routines for performing convergence tests are specified below.          *
! **********************************************************************************
subroutine matQ (NmaxC, NmaxL, chiral, perfectcond, ind_ref, fact, mv3, nv3,        &
           mv1, nv1, nuv, A, nap, map)
  use parameters
  implicit none
  integer    :: NmaxC, NmaxL, nap, map
  real(O)    :: nuv(3)
  complex(O) :: ind_ref, fact, mv1(3,NmaxC), nv1(3,NmaxC), mv3(3,NmaxL),            &
                nv3(3,NmaxL), A(2*nap,2*map)
  logical    :: chiral, perfectcond
!
  integer    :: i, j
  complex(O) :: mvl(3), nvl(3), mvc(3), nvc(3), v1, v2, mixt_product
!
  do i = 1, NmaxL
    mvl(1) = mv3(1,i)
    mvl(2) = mv3(2,i)
    mvl(3) = mv3(3,i)
    nvl(1) = nv3(1,i)
    nvl(2) = nv3(2,i)
    nvl(3) = nv3(3,i)
    do j = 1, NmaxC
      mvc(1) = mv1(1,j)
      mvc(2) = mv1(2,j)
      mvc(3) = mv1(3,j)
      nvc(1) = nv1(1,j)
      nvc(2) = nv1(2,j)
      nvc(3) = nv1(3,j)
      if (.not. chiral) then
        v1 = mixt_product (nuv, mvc, nvl)
        v2 = mixt_product (nuv, nvc, mvl)          
        if (.not. perfectcond) then
          A(i,j) = A(i,j) + (v1 + ind_ref * v2) * fact
        else 
          A(i,j) = A(i,j) + v2 * fact
        end if
      else 
        v1 = mixt_product (nuv, mvc, nvl)
        v2 = mixt_product (nuv, mvc, mvl)                           
        A(i,j) = A(i,j) + (v1 + ind_ref * v2) * fact
      end if
      if (.not. chiral) then
        v1 = mixt_product (nuv, nvc, nvl)
        v2 = mixt_product (nuv, mvc, mvl)
        if (.not. perfectcond) then
          A(i,j+NmaxC) = A(i,j+NmaxC) + (v1 + ind_ref * v2) * fact
        else 
          A(i,j+NmaxC) = A(i,j+NmaxC) + v2 * fact
        end if
      else 
        v1 = mixt_product (nuv, nvc, nvl)
        v2 = mixt_product (nuv, nvc, mvl)                   
        A(i,j+NmaxC) = A(i,j+NmaxC) + (v1 - ind_ref * v2) * fact
      end if 
      if (.not. chiral) then
        v1 = mixt_product (nuv, mvc, mvl)
        v2 = mixt_product (nuv, nvc, nvl)
        if (.not. perfectcond) then
          A(i+NmaxL,j) = A(i+NmaxL,j) + (v1 + ind_ref * v2) * fact
        else 
          A(i+NmaxL,j) = A(i+NmaxL,j) + v2 * fact
        end if
      else 
        v1 = mixt_product (nuv, mvc, mvl)
        v2 = mixt_product (nuv, mvc, nvl)                   
        A(i+NmaxL,j) = A(i+NmaxL,j) + (v1 + ind_ref * v2) * fact
      end if     
      if (.not. chiral) then
        v1 = mixt_product (nuv, nvc, mvl)
        v2 = mixt_product (nuv, mvc, nvl)
        if (.not. perfectcond) then
          A(i+NmaxL,j+NmaxC) = A(i+NmaxL,j+NmaxC) + (v1 + ind_ref * v2) * fact
        else 
          A(i+NmaxL,j+NmaxC) = A(i+NmaxL,j+NmaxC) + v2 * fact
        end if
      else 
        v1 = mixt_product (nuv, nvc, mvl)
        v2 = mixt_product (nuv, nvc, nvl)            
        A(i+NmaxL,j+NmaxC) = A(i+NmaxL,j+NmaxC) + (v1 - ind_ref * v2) * fact 
      end if
    end do        
  end do
end subroutine matQ
! **********************************************************************************
subroutine matQ_m (m, NmaxC, NmaxL, chiral, perfectcond, mirror, ind_ref, fact,     &
           mv3, nv3, mv1, nv1, nuv, A, nap, map)
  use parameters
  implicit none
  integer    :: m, NmaxC, NmaxL, nap, map
  real(O)    :: nuv(3)
  complex(O) :: ind_ref, fact, mv1(3,NmaxC), nv1(3,NmaxC), mv3(3,NmaxL),            &
                nv3(3,NmaxL), A(2*nap,2*map)
  logical    :: chiral, perfectcond, mirror
!
  integer    :: i, j, ni, nj
  real(O)    :: s
  complex(O) :: mvl(3), nvl(3), mvc(3), nvc(3), v1, v2, mixt_product
!
  do i = 1, NmaxL
    if (abs(m) == 0) then
      ni = i
    else
      ni = abs(m) + i - 1
    end if
    mvl(1) = mv3(1,i)
    mvl(2) = mv3(2,i)
    mvl(3) = mv3(3,i)
    nvl(1) = nv3(1,i)
    nvl(2) = nv3(2,i)
    nvl(3) = nv3(3,i)
    do j = 1, NmaxC
      if (abs(m) == 0) then
        nj = j
      else
        nj = abs(m) + j - 1
      end if
      mvc(1) = mv1(1,j)
      mvc(2) = mv1(2,j)
      mvc(3) = mv1(3,j)
      nvc(1) = nv1(1,j)
      nvc(2) = nv1(2,j)
      nvc(3) = nv1(3,j)
      s = (-1._O)**(ni + nj)
      if (.not. chiral) then
        v1 = mixt_product (nuv, mvc, nvl)
        v2 = mixt_product (nuv, nvc, mvl)
        if (.not. perfectcond) then
          A(i,j) = A(i,j) + (v1 + ind_ref * v2) * fact
          if (mirror) A(i,j) = A(i,j)+ s * (v1 + ind_ref * v2) * fact
        else 
          A(i,j) = A(i,j) + v2 * fact
          if (mirror) A(i,j) = A(i,j) + s * v2 * fact
        end if
      else 
        v1 = mixt_product (nuv, mvc, nvl)
        v2 = mixt_product (nuv, mvc, mvl)                   
        A(i,j) = A(i,j) + (v1 + ind_ref * v2) * fact                    
      end if                              
      if (.not. chiral) then
        if (m /= 0) then
          v1 = mixt_product (nuv, nvc, nvl)
          v2 = mixt_product (nuv, mvc, mvl)
          if (.not. perfectcond) then
            A(i,j+NmaxC) = A(i,j+NmaxC) + (v1 + ind_ref * v2) * fact
            if (mirror) A(i,j+NmaxC) = A(i,j+NmaxC) - s * (v1 + ind_ref * v2) * fact
          else 
            A(i,j+NmaxC) = A(i,j+NmaxC) + v2 * fact
            if (mirror) A(i,j+NmaxC) = A(i,j+NmaxC) - s * v2 * fact
          end if
          v1 = mixt_product (nuv, mvc, mvl)
          v2 = mixt_product (nuv, nvc, nvl)
          if (.not. perfectcond) then
            A(i+NmaxL,j) = A(i+NmaxL,j) + (v1 + ind_ref * v2) * fact
            if (mirror) A(i+NmaxL,j) = A(i+NmaxL,j) - s * (v1 + ind_ref * v2) * fact
          else 
            A(i+NmaxL,j) = A(i+NmaxL,j) + v2 * fact
            if (mirror) A(i+NmaxL,j) = A(i+NmaxL,j) - s * v2 * fact
          end if
        end if
      else 
        v1 = mixt_product (nuv, nvc, nvl)
        v2 = mixt_product (nuv, nvc, mvl)                         
        A(i,j+NmaxC) = A(i,j+NmaxC) + (v1 - ind_ref * v2) * fact
        v1 = mixt_product (nuv, mvc, mvl)
        v2 = mixt_product (nuv, mvc, nvl)                         
        A(i+NmaxL,j) = A(i+NmaxL,j) + (v1 + ind_ref * v2) * fact 
      end if
      if (.not. chiral) then 
        v1 = mixt_product (nuv, nvc, mvl)
        v2 = mixt_product (nuv, mvc, nvl)
        if (.not. perfectcond) then
          A(i+NmaxL,j+NmaxC) = A(i+NmaxL,j+NmaxC) + (v1 + ind_ref * v2) * fact
          if (mirror) A(i+NmaxL,j+NmaxC) = A(i+NmaxL,j+NmaxC) +                     &
                                          s * (v1 + ind_ref * v2) * fact
        else 
          A(i+NmaxL,j+NmaxC) = A(i+NmaxL,j+NmaxC) + v2 * fact
          if (mirror) A(i+NmaxL,j+NmaxC) = A(i+NmaxL,j+NmaxC) + s * v2 * fact
        end if
      else 
        v1 = mixt_product (nuv, nvc, mvl)
        v2 = mixt_product (nuv, nvc, nvl)                   
        A(i+NmaxL,j+NmaxC) = A(i+NmaxL,j+NmaxC) + (v1 - ind_ref * v2) * fact    
      end if                              
    end do   
  end do
end subroutine matQ_m
! **********************************************************************************
subroutine matQ_COMP (m, NmaxC, NmaxL, ind_ref, fact, mv3, nv3, mv1, nv1, nuv,      &
           A, nap, map)
  use parameters
  implicit none
  integer    :: m, NmaxC, NmaxL, nap, map
  real(O)    :: nuv(3)
  complex(O) :: ind_ref, fact, mv1(3,NmaxC), nv1(3,NmaxC), mv3(3,NmaxL),            &
                nv3(3,NmaxL), A(2*nap,2*map)
!
  integer    :: i, j
  complex(O) :: mvl(3), nvl(3), mvc(3), nvc(3), v1, v2, mixt_product
!
  do i = 1, NmaxL 
    mvl(1) = mv3(1,i)
    mvl(2) = mv3(2,i)
    mvl(3) = mv3(3,i)
    nvl(1) = nv3(1,i)
    nvl(2) = nv3(2,i)
    nvl(3) = nv3(3,i)
    do j = 1, NmaxC
      mvc(1) = mv1(1,j)
      mvc(2) = mv1(2,j)
      mvc(3) = mv1(3,j)
      nvc(1) = nv1(1,j)
      nvc(2) = nv1(2,j)
      nvc(3) = nv1(3,j)
      v1 = mixt_product (nuv, mvc, nvl)
      v2 = mixt_product (nuv, nvc, mvl)
      A(i,j) = A(i,j) + (v1 + ind_ref  *v2) * fact
      if (m /= 0) then
        v1 = mixt_product (nuv, nvc, nvl)
        v2 = mixt_product (nuv, mvc, mvl)
        A(i,j+NmaxC) = A(i,j+NmaxC) + (v1 + ind_ref * v2) * fact
        v1 = mixt_product (nuv, mvc, mvl)
        v2 = mixt_product (nuv, nvc, nvl)
        A(i+NmaxL,j) = A(i+NmaxL,j) + (v1 + ind_ref * v2) * fact
      end if
      v1 = mixt_product (nuv, nvc, mvl)
      v2 = mixt_product (nuv, mvc, nvl)
      A(i+NmaxL,j+NmaxC) = A(i+NmaxL,j+NmaxC) + (v1 + ind_ref * v2) * fact
    end do
  end do
end subroutine matQ_COMP
! **********************************************************************************
subroutine matQ_LAY (m, ipart, Npartlim, NmaxC, NmaxL, Nmax, index, fact, mv3, nv3, &
           mv2, nv2, mv1, nv1, nuv, a, nap, map, b, nbp, mbp)
  use parameters
  implicit none
  integer    :: m, ipart, Npartlim, NmaxC, NmaxL, Nmax, nap, map, nbp, mbp
  real(O)    :: nuv(3)
  complex(O) :: index, fact, mv1(3,Nmax), nv1(3,Nmax), mv2(3,Nmax),                 &
                nv2(3,Nmax), mv3(3,Nmax), nv3(3,Nmax), a(2*nap,2*map),              &
                b(2*nbp,2*mbp)
!
  integer    :: i, j
  complex(O) :: mvl(3), nvl(3), mvc(3), nvc(3), v1, v2, mixt_product
!
  do i = 1, NmaxL
    mvl(1) = mv3(1,i)
    mvl(2) = mv3(2,i)
    mvl(3) = mv3(3,i)
    nvl(1) = nv3(1,i)
    nvl(2) = nv3(2,i)
    nvl(3) = nv3(3,i)
    do j = 1, NmaxC
      mvc(1) = mv1(1,j)
      mvc(2) = mv1(2,j)
      mvc(3) = mv1(3,j)
      nvc(1) = nv1(1,j)
      nvc(2) = nv1(2,j)
      nvc(3) = nv1(3,j)
      v1 = mixt_product (nuv, mvc, nvl)
      v2 = mixt_product (nuv, nvc, mvl)
      a(i,j) = a(i,j) + (v1 + index * v2) * fact
      if (m /= 0) then
        v1 = mixt_product (nuv, nvc, nvl)
        v2 = mixt_product (nuv, mvc, mvl)
        a(i,j+NmaxC) = a(i,j+NmaxC) + (v1 + index * v2) * fact
        v1 = mixt_product (nuv, mvc, mvl)
        v2 = mixt_product (nuv, nvc, nvl)
        a(i+NmaxL,j) = a(i+NmaxL,j) + (v1 + index * v2) * fact
      end if
      v1 = mixt_product (nuv, nvc, mvl)
      v2 = mixt_product (nuv, mvc, nvl)
      a(i+NmaxL,j+NmaxC) = a(i+NmaxL,j+NmaxC) + (v1 + index * v2) * fact
    end do
    if (ipart < Npartlim) then
      do j = 1, NmaxC
        mvc(1) = mv2(1,j)
        mvc(2) = mv2(2,j)
        mvc(3) = mv2(3,j)
        nvc(1) = nv2(1,j)
        nvc(2) = nv2(2,j)
        nvc(3) = nv2(3,j)
        v1 = mixt_product (nuv, mvc, nvl)
        v2 = mixt_product (nuv, nvc, mvl)
        b(i,j) = b(i,j) + (v1 + index * v2) * fact
        if (m /= 0) then
          v1 = mixt_product (nuv, nvc, nvl)
          v2 = mixt_product (nuv, mvc, mvl)
          b(i,j+NmaxC) = b(i,j+NmaxC) + (v1 + index * v2) * fact
          v1 = mixt_product (nuv, mvc, mvl)
          v2 = mixt_product (nuv, nvc, nvl)
          b(i+NmaxL,j) = b(i+NmaxL,j) + (v1 + index * v2) * fact
        end if
        v1 = mixt_product (nuv, nvc, mvl)
        v2 = mixt_product (nuv, mvc, nvl)
        b(i+NmaxL,j+NmaxC) = b(i+NmaxL,j+NmaxC) + (v1 + index * v2) * fact
      end do
    end if
  end do
end subroutine matQ_LAY
! **********************************************************************************
subroutine matQ_LAY_a (m, NmaxC, NmaxL, Nmax, index, fact, mv3, nv3, mv1, nv1,      &
           nuv, a, nap, map)
  use parameters
  implicit none
  integer    :: m, NmaxC, NmaxL, Nmax, nap, map
  real(O)    :: nuv(3)
  complex(O) :: index, fact, mv1(3,Nmax), nv1(3,Nmax), mv3(3,Nmax), nv3(3,Nmax),    &
                a(2*nap,2*map)                              
!
  integer    :: i, j
  complex(O) :: mvl(3), nvl(3), mvc(3), nvc(3), v1, v2, mixt_product
!
  do i = 1, NmaxL
    mvl(1) = mv3(1,i)
    mvl(2) = mv3(2,i)
    mvl(3) = mv3(3,i)
    nvl(1) = nv3(1,i)
    nvl(2) = nv3(2,i)
    nvl(3) = nv3(3,i)
    do j = 1, NmaxC
      mvc(1) = mv1(1,j)
      mvc(2) = mv1(2,j)
      mvc(3) = mv1(3,j)
      nvc(1) = nv1(1,j)
      nvc(2) = nv1(2,j)
      nvc(3) = nv1(3,j)
      v1 = mixt_product (nuv, mvc, nvl)
      v2 = mixt_product (nuv, nvc, mvl)
      a(i,j) = a(i,j) + (v1 + index * v2) * fact
      if (m /= 0) then
        v1 = mixt_product (nuv, nvc, nvl)
        v2 = mixt_product (nuv, mvc, mvl)
        a(i,j+NmaxC) = a(i,j+NmaxC) + (v1 + index * v2) * fact
        v1 = mixt_product (nuv, mvc, mvl)
        v2 = mixt_product (nuv, nvc, nvl)
        a(i+NmaxL,j) = a(i+NmaxL,j) + (v1 + index * v2) * fact
      end if
      v1 = mixt_product (nuv, nvc, mvl)
      v2 = mixt_product (nuv, mvc, nvl)
      a(i+NmaxL,j+NmaxC) = a(i+NmaxL,j+NmaxC) + (v1 + index * v2) * fact
    end do    
  end do
end subroutine matQ_LAY_a
! **********************************************************************************
subroutine matQ_LAY_b (m, ipart, Npartlim, NmaxC, NmaxL, Nmax, index, fact, mv3,    &
           nv3, mv2, nv2, nuv, b, nbp, mbp)
  use parameters
  implicit none
  integer    :: m, ipart, Npartlim, NmaxC, NmaxL, Nmax, nbp, mbp
  real(O)    :: nuv(3)
  complex(O) :: index, fact, mv2(3,Nmax), nv2(3,Nmax), mv3(3,Nmax), nv3(3,Nmax),    &
                b(2*nbp,2*mbp)
!
  integer    :: i, j
  complex(O) :: mvl(3), nvl(3), mvc(3), nvc(3), v1, v2, mixt_product
!
  do i = 1, NmaxL
    mvl(1) = mv3(1,i)
    mvl(2) = mv3(2,i)
    mvl(3) = mv3(3,i)
    nvl(1) = nv3(1,i)
    nvl(2) = nv3(2,i)
    nvl(3) = nv3(3,i)    
    if (ipart < Npartlim) then
      do j = 1, NmaxC
        mvc(1) = mv2(1,j)
        mvc(2) = mv2(2,j)
        mvc(3) = mv2(3,j)
        nvc(1) = nv2(1,j)
        nvc(2) = nv2(2,j)
        nvc(3) = nv2(3,j)
        v1 = mixt_product (nuv, mvc, nvl)
        v2 = mixt_product (nuv, nvc, mvl)
        b(i,j) = b(i,j) + (v1 + index * v2) * fact
        if (m /= 0) then
          v1 = mixt_product (nuv, nvc, nvl)
          v2 = mixt_product (nuv, mvc, mvl)
          b(i,j+NmaxC) = b(i,j+NmaxC) + (v1 + index * v2) * fact
          v1 = mixt_product (nuv, mvc, mvl)
          v2 = mixt_product (nuv, nvc, nvl)
          b(i+NmaxL,j) = b(i+NmaxL,j) + (v1 + index * v2) * fact
        end if
        v1 = mixt_product (nuv, nvc, mvl)
        v2 = mixt_product (nuv, mvc, nvl)
        b(i+NmaxL,j+NmaxC) = b(i+NmaxL,j+NmaxC) + (v1 + index * v2) * fact
      end do
    end if
  end do
end subroutine matQ_LAY_b
!***********************************************************************************
subroutine matQinc_m (m, NmaxC, NmaxL, fact, mv3, nv3, mv1, nv1, nuv, A, nap, map)
  use parameters
  implicit none
  integer    :: m, NmaxL, NmaxC, nap, map
  real(O)    :: nuv(3)
  complex(O) :: fact, mv1(3,NmaxC), nv1(3,NmaxC), mv3(3,NmaxL), nv3(3,NmaxL),       &
                A(2*nap,2*map)
!
  integer    :: i, j
  complex(O) :: mvl(3), nvl(3), mvc(3), nvc(3), v1, v2, mixt_product
!
  do i = 1, NmaxL
    mvl(1) = mv3(1,i)
    mvl(2) = mv3(2,i)
    mvl(3) = mv3(3,i)
    nvl(1) = nv3(1,i)
    nvl(2) = nv3(2,i)
    nvl(3) = nv3(3,i)
    do j = 1, NmaxC
      mvc(1) = mv1(1,j)
      mvc(2) = mv1(2,j)
      mvc(3) = mv1(3,j)
      nvc(1) = nv1(1,j)
      nvc(2) = nv1(2,j)
      nvc(3) = nv1(3,j)
      v1 = mixt_product (nuv, mvc, nvl)
      v2 = mixt_product (nuv, nvc, mvl)
      A(i,j) = A(i,j) + (v1 + v2) * fact
      if (m /= 0) then
        v1 = mixt_product (nuv, nvc, nvl)
        v2 = mixt_product (nuv, mvc, mvl)
        A(i,j+NmaxC) = A(i,j+NmaxC) + (v1 + v2) * fact
        v1 = mixt_product (nuv, mvc, mvl)
        v2 = mixt_product (nuv, nvc, nvl)
        A(i+NmaxL,j) = A(i+NmaxL,j) + (v1 + v2) * fact
      end if
      v1 = mixt_product (nuv, nvc, mvl)
      v2 = mixt_product (nuv, mvc, nvl)
      A(i+NmaxL,j+NmaxC) = A(i+NmaxL,j+NmaxC) + (v1 + v2) * fact
    end do
  end do           
end subroutine matQinc_m
! ***********************************************************************************
! *     THE FOLLOWING ROUTINES ARE IMPORTANT FOR THE SPEED AND FLEXIBILITY          *
! *     OF THE PROGRAMS. WE SACRIFICE THE SPEED IN FAVOUR OF THE FLEXIBILTY,        *
! *     CLARITY AND SIMPLICITY OF THE COMPUTER CODE. THE SPEED CAN BE INCREASED     *
! *     IF THE VECTOR SPHERICAL WAVE FUNCTIONS ARE EXPLICITELY COMPUTED.            *
! ***********************************************************************************
subroutine mvnv (index1, index2, chiral, zl, zc, zcl, zcr, theta, phi, Mrank,       &
           Nrank, Nmax, NmaxC, NmaxL, mv3, nv3, mv1, nv1)
  use parameters
  implicit none
  integer    :: index1, index2, Mrank, Nrank, Nmax, NmaxC, NmaxL
  real(O)    :: theta, phi
  complex(O) :: zc, zl, zcl, zcr, mv1(3,NmaxC), nv1(3,NmaxC), mv3(3,NmaxL),         &
                nv3(3,NmaxL)
  logical    :: chiral
!  
  complex(O),allocatable :: mvl1(:,:), nvl1(:,:), mvr1(:,:), nvr1(:,:)                     
!                  
  if (chiral) allocate (mvl1(3,NmaxC), nvl1(3,NmaxC), mvr1(3,NmaxC), nvr1(3,NmaxC))                                 
  if (index1 == 3 .and. index2 == 1) then
    call MN_complete (3, zl, theta, phi, Mrank, Nrank, Nmax,.false.,.false.,        &
         mv3, nv3)
    if (.not. chiral) then
      call MN_complete (1, zc, theta, phi, Mrank, Nrank, Nmax,.true.,.false.,       &
           mv1, nv1)
    else 
      call MN_complete (1, zcl, theta, phi, Mrank, Nrank, Nmax,.true.,.false.,      &
           mvl1, nvl1)
      call MN_complete (1, zcr, theta, phi, Mrank, Nrank, Nmax,.true.,.false.,      &
           mvr1, nvr1)
      call MN_left_right (Nmax, mvl1, nvl1, mvr1, nvr1, mv1, nv1)
    end if
  else if (index1 == 3 .and. index2 == 3) then
    call MN_complete (3, zl, theta, phi, Mrank, Nrank, Nmax,.false.,.false.,        &
         mv3, nv3)
    call MN_complete (3, zc, theta, phi, Mrank, Nrank, Nmax,.true.,.false.,         &
         mv1, nv1)
  else if (index1 == 1 .and. index2 == 1) then
    call MN_complete (1, zl, theta, phi, Mrank, Nrank, Nmax,.false.,.false.,        &
         mv3, nv3)
    if (.not. chiral) then
      call MN_complete (1, zc, theta, phi, Mrank, Nrank, Nmax,.true.,.false.,       &
           mv1, nv1)
    else 
      call MN_complete (1, zcl, theta, phi, Mrank, Nrank, Nmax,.true.,.false.,      &
           mvl1, nvl1)
      call MN_complete (1, zcr, theta, phi, Mrank, Nrank, Nmax,.true.,.false.,      &
           mvr1, nvr1)
      call MN_left_right (Nmax, mvl1, nvl1, mvr1, nvr1, mv1, nv1)
    end if 
  else if (index1 == 1 .and. index2 == 3) then
    call MN_complete (1, zl, theta, phi, Mrank, Nrank, Nmax,.false.,.false.,        &
         mv3, nv3)
    call MN_complete (3, zc, theta, phi, Mrank, Nrank, Nmax,.true.,.false.,         &
         mv1, nv1)
  end if    
  if(chiral) deallocate (mvl1, nvl1, mvr1, nvr1)  
end subroutine mvnv 
! **********************************************************************************
subroutine mvnv_m (index1, index2, chiral, DS, zl, zc, zcl, zcr, kc, ki, kil, kir,  &
           r, theta, m, Nrank, Nmax, NmaxC, NmaxL, zRe, zIm, mv3, nv3, mv1, nv1)
  use parameters
  implicit none
  integer    :: index1, index2, m, m_minus, Nrank, Nmax, NmaxC, NmaxL
  real(O)    :: zRe(Nrank), zIm(Nrank), r, theta
  complex(O) :: kc, ki, kil, kir, zc, zl, zcl, zcr, mv1(3,NmaxC), nv1(3,NmaxC),     &
                mv3(3,NmaxL), nv3(3,NmaxL)
  logical    :: DS, chiral
!  
  complex(O),allocatable :: mvl1(:,:), nvl1(:,:), mvr1(:,:), nvr1(:,:)                     
!
  m_minus = - m            
  if (chiral) allocate (mvl1(3,NmaxC), nvl1(3,NmaxC), mvr1(3,NmaxC), nvr1(3,NmaxC))
  if (.not. DS) then      
    if (index1 == 3 .and. index2 == 1) then
      call MN (3, zl, theta, m_minus, Nrank, Nmax, mv3, nv3)
      if (.not. chiral) then
        call MN (1, zc, theta, m, Nrank, Nmax, mv1, nv1)           
      else
        call MN (1, zcl, theta, m, Nrank, Nmax, mvl1, nvl1)
        call MN (1, zcr, theta, m, Nrank, Nmax, mvr1, nvr1)
        call MN_left_right (Nmax, mvl1, nvl1, mvr1, nvr1, mv1, nv1)
      end if                        
    else if (index1 == 3 .and. index2 == 3) then
      call MN (3, zl, theta, m_minus, Nrank, Nmax, mv3, nv3)
      call MN (3, zc, theta, m, Nrank, Nmax, mv1, nv1)               
    else if (index1 == 1 .and. index2 == 1) then
      call MN (1, zl, theta, m_minus, Nrank, Nmax, mv3, nv3)
      if (.not. chiral) then
        call MN (1, zc, theta, m, Nrank, Nmax, mv1, nv1)             
      else 
        call MN (1, zcl, theta, m, Nrank, Nmax, mvl1, nvl1)
        call MN (1, zcr, theta, m, Nrank, Nmax, mvr1, nvr1)
        call MN_left_right (Nmax, mvl1, nvl1, mvr1, nvr1, mv1, nv1)
      end if
    else if (index1 == 1 .and. index2 == 3) then
      call MN (1, zl, theta, m_minus, Nrank, Nmax, mv3, nv3)
      call MN (3, zc, theta, m, Nrank, Nmax, mv1, nv1)       
    end if
  else 
    if (index1 == 3 .and. index2 == 1) then
      call MN_DS (3, kc, r, theta, zRe, zIm, m_minus, Nrank, mv3, nv3)
      if (.not. chiral) then
        call MN_DS (1, ki, r, theta, zRe, zIm, m, Nrank, mv1, nv1)             
      else 
        call MN_DS (1, kil, r, theta, zRe, zIm, m, Nrank, mvl1, nvl1)
        call MN_DS (1, kir, r, theta, zRe, zIm, m, Nrank, mvr1, nvr1)
        call MN_left_right (Nrank, mvl1, nvl1, mvr1, nvr1, mv1, nv1)
      end if                            
    else if (index1 == 1 .and. index2 == 1) then         
      call MN (1, zl, theta, m_minus, Nrank, Nmax, mv3, nv3)
      if (.not. chiral) then
        call MN_DS (1, ki, r, theta, zRe, zIm, m, Nrank, mv1, nv1)       
      else 
        call MN_DS (1, kil, r, theta, zRe, zIm, m, Nrank, mvl1, nvl1)
        call MN_DS (1, kir, r, theta, zRe, zIm, m, Nrank, mvr1, nvr1)
        call MN_left_right (Nrank, mvl1, nvl1, mvr1, nvr1, mv1, nv1)
      end if               
    end if
  end if                            
  if (chiral) deallocate (mvl1, nvl1, mvr1, nvr1)  
end subroutine mvnv_m  
!***********************************************************************************
subroutine mvnvinc_m (zl, kc, r, theta, m, Nrank, Nmax, zRe, zIm, mv3, nv3,        &
           mv1, nv1)
  use parameters
  implicit none
  integer    :: m, m_minus, Nrank, Nmax
  real(O)    :: zRe(Nrank), zIm(Nrank), r, theta
  complex(O) :: kc, zl, mv1(3,Nmax), nv1(3,Nmax), mv3(3,Nrank), nv3(3,Nrank)
!   
  m_minus = - m
  call MN (1, zl, theta, m, Nrank, Nmax, mv1, nv1)
  call MN_DS (3, kc, r, theta, zRe, zIm, m_minus, Nrank, mv3, nv3) 
end subroutine mvnvinc_m
! **********************************************************************************
! *      ROUTINES FOR PERFORMING CONVERGENCE TESTS USING MISHCHENKO'S PROCEDURE    * 
! *    ------------------------------------------------------------------------    *
! *    Partial list of subroutines:                                                *
! *      estimateNrankMishchenko,           estimateNintMishchenko,                *
! *      CscatCextConvLS,                   CscatCextConvDS,                       *
! *      matQConv,                          matQincConv,                           *
! **********************************************************************************
recursive subroutine estimateNrankMishchenko (TypeGeom, k, ind_ref, Nsurf, surf,    &
           zRe, zIm, Nparam, mirror, perfectcond, DS, ComplexPlane, EpsZIm,         &
           x, delta, Ndgs, Nint, Nrank, NrankMax, Cscat1, Cext1)
  use parameters
  use derived_parameters
  implicit none
  integer    :: Nsurf, Nparam, TypeGeom, Nint, Nrank, Ndgs
  real(O)    :: k, surf(Nsurf), zRe(NrankPD), zIm(NrankPD), EpsZIm, x, delta,       &
                Cscat1, Cext1
  complex(O) :: ind_ref
  logical    :: mirror, perfectcond, DS, ComplexPlane 
! 
  integer    :: irank, i, NrankMin, NrankWis, NrankMax
  real(O)    :: Cext, Cscat, DeltaScat, DeltaExt, ErrScat, ErrExt, ErrMax
  logical    :: diverge, repeat
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:)
!
  delta = 1.e-3_O
  print "(/,2x, a, 1pe10.2, a)",                                                    &
 '- enter the accuracy of the T-matrix calculations as for instance', delta, ';'
  call read_real (delta)  
  print "(/,2x,'- enter the estimated value of  Ndgs, where the number of integration ')"
  print "(  2x,'points for the Nrank convergence test is Nint = Ndgs * Nrank;         ')"  
  call read_integer (Ndgs)         
  NrankWis = int(x + 4.05_O * x**0.33_O)
  NrankMin = max(4,NrankWis)        
  print "(/,2x, a, i3, a)",                                                         &
  'The estimate of the lower bound of Nrank from Wiscombe''s criterion is ',        &
  NrankMin, ';'  
  print "(/,2x,'- enter the lower and upper bounds of Nrank;')"  
  call read_integer2 (NrankMin, NrankMax)       
  print "( )"
  print "(/,2x,'Convergence Test over Nrank')"
  print "(2x,'iteration',1x,'Nrank',3x,'Nint',6x,'EpsScat',8x,'EpsExt')"
  Cscat1  = 0._O
  Cext1   = 0._O
  diverge = .true.
  irank   = NrankMin - 1
  i = 0
  do while (diverge .and. irank < NrankMax)
    i     = i + 1
    irank = irank + 1
    Nrank = irank
    Nint  = Ndgs * Nrank
    allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, mirror)
    if (DS) then  
      call check_MaxNrank (Nrank)    
      call zDSAXSYM (TypeGeom, Nsurf, surf, Nrank, ComplexPlane, EpsZIm, zRe, zIm)
      call CscatCextConvDS (TypeGeom, k, ind_ref, Nsurf, surf, zRe, zIm, Nrank,     &
           Nint, Nparam, Nintparam, paramG, weightsG, perfectcond, Cscat, Cext)
    else
      call CscatCextConvLS (TypeGeom, k, ind_ref, Nsurf, surf, Nrank, Nint,         &
           Nparam, Nintparam, paramG, weightsG, mirror, perfectcond, Cscat, Cext)
    end if       
    DeltaScat = abs(Cscat1 - Cscat)
    DeltaExt  = abs(Cext1  - Cext )
    Cscat1    = Cscat
    Cext1     = Cext
    print "(4x,i3,2(5x,i3),2(2x,1pe13.4))", i, Nrank, Nint, DeltaScat, DeltaExt
    if (abs(Cscat) > MachEps .and. abs(Cext) > MachEps) then          
      ErrScat = DeltaScat / abs(Cscat) 
      ErrExt  = DeltaExt  / abs(Cext)
      ErrMax  = max(ErrScat, ErrExt)
      if (ErrMax <= delta) diverge = .false.     
    else
      exit
    end if
    deallocate (paramG, weightsG, Nintparam)                
  end do
  print "( )"
  if (diverge) then
    print "(/,2x,'Convergence over Nrank is not achieved;')"
    print "(  2x,'- repeat the convergence test with new inputs ?:')"
    print "(  1x,'.true. - yes, .false. - no;')"
    call read_logical (repeat)
    if (repeat) then
      call estimateNrankMishchenko (TypeGeom, k, ind_ref, Nsurf, surf,              &
           zRe, zIm, Nparam, mirror, perfectcond, DS, ComplexPlane, EpsZIm,         &
           x, delta, Ndgs, Nint, Nrank, NrankMax, Cscat1, Cext1)                                 
    end if
  end if  
end subroutine estimateNrankMishchenko
! **********************************************************************************
recursive subroutine estimateNintMishchenko (TypeGeom, k, ind_ref, Nsurf, surf,     &
          zRe, zIm, Nparam, mirror, perfectcond, DS, x, delta, Ndgs, Nint, dNint,   &
          Nrank, NrankMax, Cscat1, Cext1)
  use parameters
  use derived_parameters
  implicit none
  integer    :: Nsurf, Nparam, TypeGeom, Nint, dNint, Nrank, NrankMax, Ndgs
  real(O)    :: k, surf(Nsurf), zRe(NrankPD), zIm(NrankPD), x, delta, Cscat1, Cext1
  complex(O) :: ind_ref
  logical    :: mirror, perfectcond, DS
! 
  integer    :: iint, i, NintMax  
  real(O)    :: Cext, Cscat, DeltaScat, DeltaExt, ErrScat, ErrExt
  logical    :: diverge, repeat
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG(:,:), weightsG(:,:)
!                
  print "(/,2x, a, i3, a)",                                                         &
 '- enter an integer value greater than ', Nint + 1, ' for the upper bound of Nint'
  print "(2x,'as for instance ',i4,';')", (Ndgs + 1) * NrankMax
  call read_integer (NintMax)  
  print "( )"
  print "(/,2x,'Convergence Test over Nint')"
  print "(2x,'iteration',1x,'Nrank',3x,'Nint',6x,'EpsScat',8x,'EpsExt')" 
  diverge = .true.
  iint    = Nint
  i = 0
  do while (diverge .and. iint < NintMax)
    i    = i + 1
    iint = iint + dNint
    Nint = iint
    allocate (paramG(Nparam,Nint), weightsG(Nparam,Nint), Nintparam(Nparam))
    call interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam,              &
         Nintparam, paramG, weightsG, mirror)    
    if (DS) then
      call CscatCextConvDS (TypeGeom, k, ind_ref, Nsurf, surf, zRe, zIm, Nrank,     &
           Nint, Nparam, Nintparam, paramG, weightsG, perfectcond, Cscat, Cext)
    else
      call CscatCextConvLS (TypeGeom, k, ind_ref, Nsurf, surf, Nrank, Nint,         &
           Nparam, Nintparam, paramG, weightsG, mirror, perfectcond, Cscat, Cext)
    end if  
    DeltaScat = abs(Cscat1 - Cscat)
    DeltaExt  = abs(Cext1  - Cext )
    Cscat1    = Cscat
    Cext1     = Cext        
    print "(4x,i3,2(5x,i3),2(2x,1pe13.4))", i, Nrank, Nint, DeltaScat, DeltaExt
    if (abs(Cscat) > MachEps .and. abs(Cext) > MachEps) then
      ErrScat = DeltaScat / abs(Cscat) 
      ErrExt  = DeltaExt  / abs(Cext)                 
      if (ErrScat <= delta .and. ErrExt <= delta) diverge = .false.
    else
      exit
    end if      
    deallocate (paramG, weightsG, Nintparam)
  end do  
  print "( )"
  if (diverge) then
    print "(/,2x,'Convergence over Nint is not achieved;')"
    print "(2x,'- repeat the convergence test with new inputs ?:')"
    print "(1x,'.true. - yes, .false. - no;')"
    call read_logical (repeat)
    if (repeat) then
      call estimateNintMishchenko (TypeGeom, k, ind_ref, Nsurf, surf,               &
           zRe, zIm, Nparam, mirror, perfectcond, DS, x, delta, Ndgs, Nint,         &
           dNint, Nrank, NrankMax, Cscat1, Cext1)                            
    end if
  else
    print "(/,2x,'Nint and Nrank estimates:')"
    print "(  2x,'the estimated values of Nint and Nrank from Mishchenko''s convergence')"
    print "(  2x,'criterion are: Nint = ',i4,' and Nrank = ',i3,';')", Nint, Nrank      
  end if  
end subroutine estimateNintMishchenko    
!***********************************************************************************
subroutine CscatCextConvLS  (TypeGeom, k, ind_ref, Nsurf, surf, Nrank, Nint,        &
           Nparam, Nintparam, paramG, weightsG, mirror, perfectcond, Cscat, Cext)
  use parameters
  use derived_parameters
  implicit none
  integer    :: Nrank, Nsurf, Nint, Nparam, Nintparam(Nparam), TypeGeom
  real(O)    :: k, surf(Nsurf), paramG(Nparam,Nint), weightsG(Nparam,Nint),         &
                Cscat, Cext
  complex(O) :: ind_ref
  logical    :: mirror, perfectcond
!      
  integer    :: i, j, pint, iparam, Nintl, n
  real(O)    :: r, theta, phi, dA, param, pondere, nuv(3), ir, QA, QB,              &
                nm, nr, ft, fl 
  complex(O) :: ki, zc, zl, factp, factm, f 
  real(O),allocatable    :: Pnm(:), dPnm(:), pinm(:), taunm(:)
  complex(O),allocatable :: jb(:), jbd(:), jba(:), jbda(:), hb(:), hbd(:),          &
                            Q31A(:,:), Q31B(:,:), Q11A(:,:), Q11B(:,:),             &
                            mv1(:,:), nv1(:,:), mv3(:,:), nv3(:,:),                 &
                            mv1a(:,:), nv1a(:,:)
! 
  allocate (Q31A(Nrank,Nrank), Q31B(Nrank,Nrank), Q11A(Nrank,Nrank),                &
            Q11B(Nrank,Nrank))  
  allocate (mv1(3,Nrank), nv1(3,Nrank), mv3(3,Nrank), nv3(3,Nrank),                 &
            mv1a(3,Nrank), nv1a(3,Nrank))
  allocate (jb(0:Nrank), jbd(0:Nrank), jba(0:Nrank), jbda(0:Nrank),                 &     
            hb(0:Nrank), hbd(0:Nrank)) 
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank)) 
  do i = 1, Nrank
    do j = 1, Nrank
      Q31A(i,j) = zero
      Q31B(i,j) = zero
      Q11A(i,j) = zero
      Q11B(i,j) = zero
    end do
  end do              
  ki = k * ind_ref      
  f  = im * 2._O * k * k 
  do iparam = 1, Nparam
    Nintl = Nintparam(iparam)
    do pint = 1, Nintl
      param   = paramG(iparam,pint)
      pondere = weightsG(iparam,pint)     
      call elem_geomAXSYM (TypeGeom, Nsurf, surf, param, iparam, r, theta, phi,     &
           dA, nuv)  
      zc = ki * r
      if (abs(zc) < MachEps) zc = cmplx(MachEps,MachEps,O) 
      zl = cmplx(k * r,0.0,O)                    
      if (abs(zl) < MachEps) zl = cmplx(MachEps,MachEps,O)                                 
      call leg_normalized (theta, 0, Nrank, Pnm, dPnm, pinm, taunm)
      call besel_j (zc, Nrank, jb, jbd) 
      call besel_j (zl, Nrank, jba, jbda) 
      call besel_h (zl, Nrank, hb, hbd)     
      do n = 1, Nrank                
        nr = real(n * (n + 1),O)
        nm = 1._O / sqrt(2._O * nr)     
        ft = taunm(n) * nm
        fl = nr * Pnm(n) * nm
        mv1(1,n)  =   zero
        mv1(2,n)  =   zero   
        mv1(3,n)  = - jb(n) * ft         
        nv1(1,n)  =   jb(n) * fl / zc
        nv1(2,n)  =   jbd(n) * ft/ zc
        nv1(3,n)  =   zero
        mv1a(1,n) =   zero
        mv1a(2,n) =   zero
        mv1a(3,n) = - jba(n)  * ft         
        nv1a(1,n) =   jba(n)  * fl / zl
        nv1a(2,n) =   jbda(n) * ft / zl
        nv1a(3,n) =   zero
        mv3(1,n)  =   zero
        mv3(2,n)  =   zero
        mv3(3,n)  = - hb(n)  * ft         
        nv3(1,n)  =   hb(n)  * fl / zl
        nv3(2,n)  =   hbd(n) * ft / zl
        nv3(3,n)  =   zero
      end do                                                                                                                
      factm = - f * dA * pondere 
      call matQConv (Nrank, perfectcond, mirror, ind_ref, factm,                     &
           mv3, nv3, mv1, nv1, nuv, Q31A, Q31B, Nrank, Nrank)
      factp = - factm 
      call matQConv (Nrank, perfectcond, mirror, ind_ref, factp,                     &
           mv1a, nv1a, mv1, nv1, nuv, Q11A, Q11B, Nrank, Nrank)
    end do
  end do                  
  call LU_SYSTEM (Q31A, Nrank, Nrank, Q11A, Nrank, Nrank, Nrank)
  call LU_SYSTEM (Q31B, Nrank, Nrank, Q11B, Nrank, Nrank, Nrank)            
  Cscat = 0._O
  Cext  = 0._O
  do n = 1, Nrank
    ir    = real(2 * n + 1,O)
    QA    = abs(Q11A(n,n))
    QB    = abs(Q11B(n,n))
    Cscat = Cscat + ir * (QA * QA + QB * QB)
    QA    = real(Q11A(n,n))
    QB    = real(Q11B(n,n))
    Cext  = Cext + ir * (QA + QB)  
  end do
  deallocate (Q31A, Q31B, Q11A, Q11B) 
  deallocate (mv1, nv1, mv3, nv3, mv1a, nv1a)
  deallocate (jb, jbd, jba, jbda, hb, hbd)
  deallocate (Pnm, dPnm, pinm, taunm)
end subroutine CscatCextConvLS
!***********************************************************************************
subroutine CscatCextConvDS (TypeGeom, k, ind_ref, Nsurf, surf, zRe, zIm, Nrank,     &
           Nint, Nparam, Nintparam, paramG, weightsG, perfectcond, Cscat, Cext)
  use parameters
  use derived_parameters
  implicit none
  integer    :: Nrank, Nsurf, Nint, Nparam, Nintparam(Nparam), TypeGeom
  real(O)    :: k, surf(Nsurf), paramG(Nparam,Nint), weightsG(Nparam,Nint),         &
                zRe(Nrank), zIm(Nrank), Cscat, Cext
  complex(O) :: ind_ref
  logical    :: perfectcond
!      
  integer    :: i, j, pint, iparam, Nintl, n
  real(O)    :: r, theta, phi, dA, param, pondere, nuv(3), ir, QA, QB, ro, z, nm,   &
                nr, cth, sth, ftr, flr, dz
  complex(O) :: kc, ki, zl, factp, factm, f, RR, sint, cost, argJi, argJc,          &
                sinc, cosc, Pmm, taumm, ft, fl, factt, factl, roc, dzc
  real(O),allocatable    :: Pnm(:), dPnm(:), pinm(:), taunm(:)
  complex(O),allocatable :: jb(:), jbd(:), jba(:), jbda(:), hb(:), hbd(:),          &
                            Q31A(:,:), Q31B(:,:), Q11A(:,:), Q11B(:,:),             &
                            QincA(:,:), QincB(:,:), mv1(:,:), nv1(:,:),             &
                            mv3(:,:), nv3(:,:), mv1a(:,:), nv1a(:,:) 
! 
  allocate (Q31A(Nrank,Nrank), Q31B(Nrank,Nrank),  Q11A(Nrank,Nrank),               &
            Q11B(Nrank,Nrank), QincA(Nrank,Nrank), QincB(Nrank,Nrank))
  allocate (mv1(3,Nrank), nv1(3,Nrank), mv3(3,Nrank), nv3(3,Nrank),                 &
            mv1a(3,Nrank), nv1a(3,Nrank))
  allocate (jb(0:2), jbd(0:2), jba(0:Nrank), jbda(0:Nrank),                         &     
            hb(0:2), hbd(0:2)) 
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))                             
  kc = cmplx(k,0.0,O)
  do i = 1, Nrank
    do j = 1, Nrank
      Q31A(i,j)  = zero
      Q31B(i,j)  = zero
      Q11A(i,j)  = zero
      Q11B(i,j)  = zero
      QincA(i,j) = zero 
      QincB(i,j) = zero
    end do
  end do      
  ki = k * ind_ref      
  f  = im * 2._O * k * k 
  do iparam = 1, Nparam
    Nintl = Nintparam(iparam)
    do pint = 1, Nintl
      param   = paramG(iparam,pint)
      pondere = weightsG(iparam,pint)     
      call elem_geomAXSYM (TypeGeom, Nsurf, surf, param, iparam, r, theta, phi,     &
           dA, nuv)        
      zl = cmplx(k * r,0.0,O)
      if (abs(zl) < MachEps) zl = cmplx(MachEps,MachEps,O)                            
      call leg_normalized (theta, 0, Nrank, Pnm, dPnm, pinm, taunm) 
      call besel_j (zl, Nrank, jba, jbda)         
      sth = sin(theta)
      cth = cos(theta)
      ro  = r * sth
      z   = r * cth
      roc = cmplx(ro,0.0,O)
      do n = 1, Nrank    
        dz    = z - zRe(n)
        dzc   = cmplx(dz,0.0,O)
        RR    = sqrt(roc * roc + (dzc - im * zIm(n))**2)
        if (abs(RR) < MachEps) RR = cmplx(MachEps,MachEps,O)
        sint  = ro / RR
        cost  = (dzc - im * zIm(n)) / RR
        argJi = ki * RR
        argJc = kc * RR    
        call besel_j (argJi, 2, jb, jbd)      
        call besel_h (argJc, 2, hb, hbd)
        Pmm   =   sqrt(3._O / 2._O) * cost              
        taumm = - sqrt(3._O / 2._O) * sint
        sinc  = sth * cost - cth * sint
        cosc  = cth * cost + sth * sint     
        ft    = 0.5_O * taumm 
        fl    = Pmm
        mv1(1,n) =   zero
        mv1(2,n) =   zero
        mv1(3,n) = - jb(1)  * ft         
        factl    =   jb(1)  * fl           
        factt    =   jbd(1) * ft
        nv1(1,n) =   (   factl * cosc + factt * sinc) / argJi
        nv1(2,n) =   ( - factl * sinc + factt * cosc) / argJi
        nv1(3,n) =   zero
        mv3(1,n) =   zero
        mv3(2,n) =   zero
        mv3(3,n) = - hb(1)  * ft         
        factl    =   hb(1)  * fl           
        factt    =   hbd(1) * ft
        nv3(1,n) =   (   factl * cosc + factt * sinc) / argJc
        nv3(2,n) =   ( - factl * sinc + factt * cosc) / argJc
        nv3(3,n) =   zero
        nr  = real(n * (n + 1),O)
        nm  = 1._O / sqrt(2._O * nr)            
        ftr = taunm(n) * nm
        flr = nr * Pnm(n) * nm        
        mv1a(1,n) =   zero
        mv1a(2,n) =   zero
        mv1a(3,n) = - jba(n)  * ftr         
        nv1a(1,n) =   jba(n)  * flr / zl
        nv1a(2,n) =   jbda(n) * ftr / zl
        nv1a(3,n) =   zero
      end do
      factm = - f * dA * pondere 
      call matQConv (Nrank, perfectcond, .false., ind_ref, factm,                   &
           mv3, nv3, mv1, nv1, nuv, Q31A, Q31B, Nrank, Nrank)
      factp = - factm 
      call matQConv (Nrank, perfectcond, .false., ind_ref, factp,                   &
           mv1a, nv1a, mv1, nv1, nuv, Q11A, Q11B, Nrank, Nrank) 
      call matQincConv (Nrank, factp, mv3, nv3, mv1a, nv1a, nuv,                    &
           QincA, QincB, Nrank, Nrank)
    end do
  end do                                
  call LU_SYSTEM_DIRECT (Q31A, Nrank, Nrank, QincA, Nrank, Nrank, Nrank, Nrank)
  call LU_SYSTEM_DIRECT (Q31B, Nrank, Nrank, QincB, Nrank, Nrank, Nrank, Nrank)                                           
  call product_matrices (Nrank, Nrank, Nrank, Q11A, Nrank, Nrank, QincA, Nrank,     &
       Nrank) 
  call product_matrices (Nrank, Nrank, Nrank, Q11B, Nrank, Nrank, QincB, Nrank,     &
       Nrank)              
  Cscat = 0._O
  Cext  = 0._O
  do i = 1, Nrank
    ir    = real(2 * i + 1,O)
    QA    = abs(Q11A(i,i))
    QB    = abs(Q11B(i,i))           
    Cscat = Cscat + ir * (QA * QA + QB * QB)
    QA    = real(Q11A(i,i))
    QB    = real(Q11B(i,i))
    Cext  = Cext + ir * (QA + QB)  
  end do  
  deallocate (Q31A, Q31B, Q11A, Q11B, QincA, QincB) 
  deallocate (mv1, nv1, mv3, nv3, mv1a, nv1a)
  deallocate (jb, jbd, jba, jbda, hb, hbd)
  deallocate (Pnm, dPnm, pinm, taunm)
end subroutine CscatCextConvDS
! **********************************************************************************
subroutine matQConv (Nrank, perfectcond, mirror, ind_ref, fact, mv3, nv3, mv1, nv1,  &
           nuv, QA, QB, nap, map)
  use parameters
  implicit none
  integer    :: Nrank, nap, map
  real(O)    :: nuv(3)
  complex(O) :: ind_ref, fact, mv1(3,Nrank), nv1(3,Nrank), mv3(3,Nrank),            &
                nv3(3,Nrank), QA(nap,map), QB(nap,map)
  logical    :: perfectcond, mirror
!
  integer    :: i, j, ni, nj
  real(O)    :: s
  complex(O) :: mvl(3), nvl(3), mvc(3), nvc(3), v1, v2, mixt_product
!
  do i = 1, Nrank    
    ni = i
    mvl(1) = mv3(1,i)
    mvl(2) = mv3(2,i)
    mvl(3) = mv3(3,i)
    nvl(1) = nv3(1,i)
    nvl(2) = nv3(2,i)
    nvl(3) = nv3(3,i)
    do j = 1, Nrank      
      nj = j
      mvc(1) = mv1(1,j)
      mvc(2) = mv1(2,j)
      mvc(3) = mv1(3,j)
      nvc(1) = nv1(1,j)
      nvc(2) = nv1(2,j)
      nvc(3) = nv1(3,j)
      s = (-1._O)**(ni + nj)                     
      v1 = mixt_product (nuv, mvc, nvl)
      v2 = mixt_product (nuv, nvc, mvl)
      if (.not. perfectcond) then
        QA(i,j) = QA(i,j) + (v1 + ind_ref * v2) * fact
        if (mirror) QA(i,j) = QA(i,j) + s * (v1 + ind_ref * v2) * fact
      else 
        QA(i,j) = QA(i,j) + v2 * fact
        if (mirror) QA(i,j) = QA(i,j) + s * v2 * fact
      end if                                              
      v1 = mixt_product (nuv, nvc, mvl)
      v2 = mixt_product (nuv, mvc, nvl)
      if (.not. perfectcond) then
        QB(i,j) = QB(i,j) + (v1 + ind_ref * v2) * fact
        if (mirror) QB(i,j) = QB(i,j) + s * (v1 + ind_ref * v2) * fact
      else 
        QB(i,j) = QB(i,j) + v2 * fact
        if (mirror) QB(i,j) = QB(i,j) + s * v2 * fact
      end if                                      
    end do   
  end do
end subroutine matQConv
!***********************************************************************************
subroutine matQincConv (Nrank, fact, mv3, nv3, mv1, nv1, nuv, QA, QB, nap, map)
  use parameters
  implicit none
  integer    :: Nrank, nap, map
  real(O)    :: nuv(3)
  complex(O) :: fact, mv1(3,Nrank), nv1(3,Nrank), mv3(3,Nrank), nv3(3,Nrank),       &
                QA(nap,map), QB(nap,map)
!
  integer    :: i, j
  complex(O) :: mvl(3), nvl(3), mvc(3), nvc(3), v1, v2, mixt_product
!
  do i = 1, Nrank
    mvl(1) = mv3(1,i)
    mvl(2) = mv3(2,i)
    mvl(3) = mv3(3,i)
    nvl(1) = nv3(1,i)
    nvl(2) = nv3(2,i)
    nvl(3) = nv3(3,i)
    do j = 1, Nrank
      mvc(1) = mv1(1,j)
      mvc(2) = mv1(2,j)
      mvc(3) = mv1(3,j)
      nvc(1) = nv1(1,j)
      nvc(2) = nv1(2,j)
      nvc(3) = nv1(3,j)
      v1 = mixt_product (nuv, mvc, nvl)
      v2 = mixt_product (nuv, nvc, mvl)
      QA(i,j) = QA(i,j) + (v1 + v2) * fact        
      v1 = mixt_product (nuv, nvc, mvl)
      v2 = mixt_product (nuv, mvc, nvl)
      QB(i,j) = QB(i,j) + (v1 + v2) * fact
    end do
  end do           
end subroutine matQincConv

! **********************************************************************************
! *            ROUTINES FOR COMPUTING THE INCIDENT FIELD COEFFICIENTS              *
! *    ------------------------------------------------------------------------    *
! *    Partial list of subroutines:                                                *
! *      PWcoefficients_ab,                    PWcoefficients_CircPolab(UNUSED),   *
! *      PWcoefficients_Polab,                 PWcoefficients_ab_m,                *
! *      PWcoefficients_CircPolab_m(UNUSED),   PWcoefficients_Polab_m,             *
! *      PWcoefficientsPARTSUB,                PWcoefficientsPARTSUBrefl,          *
! *      PWcoefficientsPARTSUBtrans,           Kcor,                               *
! *      Fresnel_aer_sub,                      Fresnel_sub_aer,                    *
! *      GBcoefficients_ab,                    GBcoefficients_ab_m,                *
! *      product_rotcoefficients,              GBcoefficients_ab_local             *
! **********************************************************************************
subroutine PWcoefficients_ab (thetaGI, phiGI, alpha, beta, gamma, alphap, Mrank,   &
           Nrank, Nmax, c) 
!-----------------------------------------------------------------------------------
! The routine computes the expansion coefficients of a linearly polarized plane    !
! wave for the azimuthal modes m = 0,1,...,Mrank.                                  ! 
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax
  real(O)    :: thetaGI, phiGI, alpha, beta, gamma, alphap      
  complex(O) :: c(2*Nmax)
!                 
  integer    :: k, m, n, N0, ml, l      
  real(O)    :: nm, thetaLI, phiLI, e0eT, e0eP, mlr, arg
  complex(O) :: fact, factc, factp, factt
  real(O),allocatable :: Pnm(:), dPnm(:), pinm(:), taunm(:)  
!
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  call T_spherical_global_local (thetaGI, phiGI, alpha, beta, gamma, thetaLI, phiLI)
  call parameters_coefficients_ab (thetaGI, phiGI, thetaLI, phiLI, alpha, beta,     &
       gamma, alphap, e0eT, e0eP)
  do m = 0, Mrank        
    call leg_normalized (thetaLI, m, Nrank, Pnm, dPnm, pinm, taunm)      
    if (m == 0) then
      do k = 1, Nrank
        n     = k               
        nm    = real(2 * n * (n + 1),O)         
        nm    = 1._O / sqrt(nm)            
        fact  = 4._O * im**n * nm          
        factt = fact * taunm(n)     
        c(k)      = - factt * e0eP
        c(Nmax+k) = - im * factt * e0eT               
      end do
    else        
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      ml = m        
      do l = 1, 2
        mlr  = real(ml,O)
        arg  = mlr * phiLI
        fact = exp(- im * arg)                  
        do k = 1, Nrank - m + 1
          n     = m + k - 1
          nm    = real(2 * n * (n + 1),O)               
          nm    = 1._O / sqrt(nm)             
          factc = 4._O * im**n * fact * nm
          factp = factc * im * mlr * pinm(n)
          factt = factc * taunm(n)          
          c(N0+k)      = - factp * e0eT - factt * e0eP
          c(Nmax+N0+k) = - im * (factt * e0eT - factp * e0eP) 
        end do
        N0 =   N0 + Nrank - m + 1
        ml = - ml
      end do                  
    end if
  end do
  deallocate (Pnm, dPnm, pinm, taunm)
end subroutine PWcoefficients_ab
! **********************************************************************************
subroutine PWcoefficients_CircPolab (thetaGI, phiGI, alpha, beta, gamma, right,     &
           Mrank, Nrank, Nmax, c) 
!-----------------------------------------------------------------------------------
! The routine computes the expansion coefficients of a circularly polarized        !
! plane wave for the azimuthal modes m = 0,1,...,Mrank.                            ! 
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax
  real(O)    :: thetaGI, phiGI, alpha, beta, gamma
  complex(O) :: c(2*Nmax)
  logical    :: right
!                 
  integer    :: k, m, n, N0, ml, l      
  real(O)    :: norm, nm, thetaLI, phiLI, mlr, arg
  complex(O) :: epol_theta, epol_phi, e0eT, e0eP, fact, factc, factp, factt
  real(O),allocatable :: Pnm(:), dPnm(:), pinm(:), taunm(:)  
!
  norm = sqrt(2._O) / 2._O 
  if (right) then
    epol_theta = norm * one
    epol_phi   = norm * im
  else
    epol_theta =   norm * one
    epol_phi   = - norm * im
  end if
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  call T_spherical_global_local (thetaGI, phiGI, alpha, beta, gamma, thetaLI, phiLI)
  call parameters_coefficients_Polab (thetaGI, phiGI, thetaLI, phiLI, alpha, beta,  &
       gamma, epol_theta, epol_phi, e0eT, e0eP) 
  do m = 0, Mrank        
    call leg_normalized (thetaLI, m, Nrank, Pnm, dPnm, pinm, taunm)      
    if (m == 0) then
      do k = 1, Nrank
        n     = k               
        nm    = real(2 * n * (n + 1),O)         
        nm    = 1._O / sqrt(nm)            
        fact  = 4._O * im**n * nm          
        factt = fact * taunm(n)     
        c(k)      = - factt * e0eP
        c(Nmax+k) = - im * factt * e0eT               
      end do
    else        
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      ml = m        
      do l = 1, 2
        mlr  = real(ml,O)
        arg  = mlr * phiLI
        fact = exp(- im * arg)                  
        do k = 1, Nrank - m + 1
          n     = m + k - 1
          nm    = real(2 * n * (n + 1),O)               
          nm    = 1._O / sqrt(nm)             
          factc = 4._O * im**n * fact * nm
          factp = factc * im * mlr * pinm(n)
          factt = factc * taunm(n)          
          c(N0+k)      = - factp * e0eT - factt * e0eP
          c(Nmax+N0+k) = - im * (factt * e0eT - factp * e0eP) 
        end do
        N0 =   N0 + Nrank - m + 1
        ml = - ml
      end do                  
    end if
  end do
  deallocate (Pnm, dPnm, pinm, taunm)
end subroutine PWcoefficients_CircPolab
! **********************************************************************************
subroutine PWcoefficients_Polab (thetaGI, phiGI, alpha, beta, gamma, epol_theta,    &
           epol_phi, Mrank, Nrank, Nmax, c) 
!-----------------------------------------------------------------------------------
! The routine computes the expansion coefficients of an arbitrarily polarized      !
! plane wave for the azimuthal modes m = 0,1,...,Mrank.                            ! 
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax
  real(O)    :: thetaGI, phiGI, alpha, beta, gamma
  complex(O) :: epol_theta, epol_phi, c(2*Nmax)
!                 
  integer    :: k, m, n, N0, ml, l      
  real(O)    :: nm, thetaLI, phiLI, mlr, arg
  complex(O) :: e0eT, e0eP, fact, factc, factp, factt
  real(O),allocatable :: Pnm(:), dPnm(:), pinm(:), taunm(:)  
!  
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  call T_spherical_global_local (thetaGI, phiGI, alpha, beta, gamma, thetaLI, phiLI)
  call parameters_coefficients_Polab (thetaGI, phiGI, thetaLI, phiLI, alpha, beta,  &
       gamma, epol_theta, epol_phi, e0eT, e0eP) 
  do m = 0, Mrank        
    call leg_normalized (thetaLI, m, Nrank, Pnm, dPnm, pinm, taunm)      
    if (m == 0) then
      do k = 1, Nrank
        n     = k               
        nm    = real(2 * n * (n + 1),O)         
        nm    = 1._O / sqrt(nm)            
        fact  = 4._O * im**n * nm          
        factt = fact * taunm(n)     
        c(k)      = - factt * e0eP
        c(Nmax+k) = - im * factt * e0eT               
      end do
    else        
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      ml = m        
      do l = 1, 2
        mlr  = real(ml,O)
        arg  = mlr * phiLI
        fact = exp(- im * arg)                  
        do k = 1, Nrank - m + 1
          n     = m + k - 1
          nm    = real(2 * n * (n + 1),O)               
          nm    = 1._O / sqrt(nm)             
          factc = 4._O * im**n * fact * nm
          factp = factc * im * mlr * pinm(n)
          factt = factc * taunm(n)          
          c(N0+k)      = - factp * e0eT - factt * e0eP
          c(Nmax+N0+k) = - im * (factt * e0eT - factp * e0eP) 
        end do
        N0 =   N0 + Nrank - m + 1
        ml = - ml
      end do                  
    end if
  end do
  deallocate (Pnm, dPnm, pinm, taunm)
end subroutine PWcoefficients_Polab
! **********************************************************************************
subroutine PWcoefficients_ab_m (thetaGI, phiGI, alpha, beta, gamma, alphap, m,      &
           Nrank, Nmax, c)
!-----------------------------------------------------------------------------------
! The routine computes the expansion coefficients of a linearly polarized plane    !
! wave for the azimuthal mode m.                                                   !
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none
  integer    :: m, Nrank, Nmax
  real(O)    :: thetaGI, phiGI, alpha, beta, gamma, alphap      
  complex(O) :: c(2*Nmax)
!      
  integer    :: k, n     
  real(O)    :: nm, thetaLI, phiLI, e0eT, e0eP, mr, arg
  complex(O) :: fact, factc, factp, factt
  real(O),allocatable :: Pnm(:), dPnm(:), pinm(:), taunm(:)  
! 
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  call T_spherical_global_local (thetaGI, phiGI, alpha, beta, gamma, thetaLI, phiLI)
  call parameters_coefficients_ab (thetaGI, phiGI, thetaLI, phiLI, alpha, beta,     &
       gamma, alphap, e0eT, e0eP)
  call leg_normalized (thetaLI, abs(m), Nrank, Pnm, dPnm, pinm, taunm)
  mr   = real(m,O)
  arg  = mr * phiLI
  fact = exp(- im * arg)
  do k = 1, Nmax
    if (m == 0) then
      n = k
    else
      n = abs(m) + k - 1
    end if
    nm    = real(2 * n * (n + 1),O)             
    nm    = 1._O / sqrt(nm)     
    factc = 4._O * im**n * fact * nm        
    factp = factc * im * mr * pinm(n)
    factt = factc * taunm(n)        
    c(k)      = - factp * e0eT - factt * e0eP
    c(Nmax+k) = - im * (factt * e0eT - factp * e0eP)
  end do                    
  deallocate (Pnm, dPnm, pinm, taunm)
end subroutine PWcoefficients_ab_m 
! **********************************************************************************
subroutine PWcoefficients_CircPolab_m (thetaGI, phiGI, alpha, beta, gamma, right,   &
           m, Nrank, Nmax, c)
!-----------------------------------------------------------------------------------
! The routine computes the expansion coefficients of a circularly polarized        !
! plane wave for the azimuthal mode m.                                             !
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none
  integer    :: m, Nrank, Nmax
  real(O)    :: thetaGI, phiGI, alpha, beta, gamma     
  complex(O) :: c(2*Nmax)
  logical    :: right  
!      
  integer    :: k, n     
  real(O)    :: norm, nm, thetaLI, phiLI, mr, arg
  complex(O) :: epol_theta, epol_phi, e0eT, e0eP, fact, factc, factp, factt
  real(O),allocatable :: Pnm(:), dPnm(:), pinm(:), taunm(:)  
! 
  norm = sqrt(2._O) / 2._O 
  if (right) then
    epol_theta = norm * one
    epol_phi   = norm * im
  else
    epol_theta =   norm * one
    epol_phi   = - norm * im
  end if
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  call T_spherical_global_local (thetaGI, phiGI, alpha, beta, gamma, thetaLI, phiLI)
  call parameters_coefficients_Polab (thetaGI, phiGI, thetaLI, phiLI, alpha, beta,  &
       gamma, epol_theta, epol_phi, e0eT, e0eP)        
  call leg_normalized (thetaLI, abs(m), Nrank, Pnm, dPnm, pinm, taunm)
  mr   = real(m,O)
  arg  = mr * phiLI
  fact = exp(- im * arg)
  do k = 1, Nmax
    if (m == 0) then
      n = k
    else
      n = abs(m) + k - 1
    end if
    nm    = real(2 * n * (n + 1),O)             
    nm    = 1._O / sqrt(nm)     
    factc = 4._O * im**n * fact * nm        
    factp = factc * im * mr * pinm(n)
    factt = factc * taunm(n)        
    c(k)      = - factp * e0eT - factt * e0eP
    c(Nmax+k) = - im * (factt * e0eT - factp * e0eP)
  end do                    
  deallocate (Pnm, dPnm, pinm, taunm)
end subroutine PWcoefficients_CircPolab_m 
! **********************************************************************************
subroutine PWcoefficients_Polab_m (thetaGI, phiGI, alpha, beta, gamma, epol_theta,  &
           epol_phi, m, Nrank, Nmax, c)
!-----------------------------------------------------------------------------------
! The routine computes the expansion coefficients of an arbitrarily polarized      !
! plane wave for the azimuthal mode m.                                             !
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none
  integer    :: m, Nrank, Nmax
  real(O)    :: thetaGI, phiGI, alpha, beta, gamma
  complex(O) :: epol_theta, epol_phi, c(2*Nmax)
!      
  integer    :: k, n     
  real(O)    :: nm, thetaLI, phiLI, mr, arg
  complex(O) :: e0eT, e0eP, fact, factc, factp, factt
  real(O),allocatable :: Pnm(:), dPnm(:), pinm(:), taunm(:)  
!   
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  call T_spherical_global_local (thetaGI, phiGI, alpha, beta, gamma, thetaLI, phiLI)
  call parameters_coefficients_Polab (thetaGI, phiGI, thetaLI, phiLI, alpha, beta,  &
       gamma, epol_theta, epol_phi, e0eT, e0eP)        
  call leg_normalized (thetaLI, abs(m), Nrank, Pnm, dPnm, pinm, taunm)
  mr   = real(m,O)
  arg  = mr * phiLI
  fact = exp(- im * arg)
  do k = 1, Nmax
    if (m == 0) then
      n = k
    else
      n = abs(m) + k - 1
    end if
    nm    = real(2 * n * (n + 1),O)             
    nm    = 1._O / sqrt(nm)     
    factc = 4._O * im**n * fact * nm        
    factp = factc * im * mr * pinm(n)
    factt = factc * taunm(n)        
    c(k)      = - factp * e0eT - factt * e0eP
    c(Nmax+k) = - im * (factt * e0eT - factp * e0eP)
  end do                    
  deallocate (Pnm, dPnm, pinm, taunm)
end subroutine PWcoefficients_Polab_m 
! **********************************************************************************
subroutine PWcoefficientsPARTSUB (beta0, alphap, m, Nrank, Nmax, c)
!------------------------------------------------------------------------------------
! The routine computes the expansion coefficients of a plane wave (traveling in     !
! the Oxz plane) for the azimuthal mode m.                                          !
!------------------------------------------------------------------------------------ 
  use parameters
  implicit none
  integer    :: m, Nrank, Nmax
  real(O)    :: beta0, alphap
  complex(O) :: c(2*Nmax)    
!
  integer    :: k, n      
  real(O)    :: nm, mr, ca, sa
  complex(O) :: factc, factp, factt
  real(O),allocatable :: Pnm(:), dPnm(:), pinm(:), taunm(:)
!
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  call leg_normalized (beta0, abs(m), Nrank, Pnm, dPnm, pinm, taunm)
  mr = real(m,O)
  ca = cos(alphap)
  sa = sin(alphap)
  do k = 1, Nmax
    if (m == 0) then
      n = k
    else
      n = abs(m) + k - 1
    end if
    nm    = real(2 * n * (n + 1),O)         
    nm    = 1._O / sqrt(nm)     
    factc = 4._O * im**n * nm * cos(mr * Pi)        
    factp = factc * im * mr * pinm(n)
    factt = factc * taunm(n)
    c(k)      = - factp * ca - factt * sa
    c(Nmax+k) = - im * (factt * ca - factp * sa)
  end do
  deallocate (Pnm, dPnm, pinm, taunm)     
end subroutine PWcoefficientsPARTSUB
! **********************************************************************************
subroutine PWcoefficientsPARTSUBrefl (beta0, alphap, z0, wavenumber, ind_ref, m,    &
           Nrank, Nmax, c)
!-----------------------------------------------------------------------------------
! The routine computes the expansion coefficients of the reflected plane wave      !
! (traveling in the Oxz plane) for the azimuthal mode m.                           !
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none
  integer    :: m, Nrank, Nmax
  real(O)    :: beta0, alphap, z0, wavenumber      
  complex(O) :: c(2*Nmax), ind_ref
!
  integer    :: k, n      
  real(O)    :: nm, betaM0, mr
  complex(O) :: Rpar, Rperp, Tpar, Tperp, et, ep, cosb, sinb, cosb0, factc,         &
                factp, factt, phase
  real(O),allocatable :: Pnm(:), dPnm(:), pinm(:), taunm(:)
!
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  cosb0 = cmplx(cos(beta0),0._O)
  call Fresnel_aer_sub (cosb0, ind_ref, Rpar, Rperp, Tpar, Tperp, cosb, sinb)
  phase  = exp(2._O * im * wavenumber * cosb0 * z0)
  et     = cos(alphap) * Rpar * phase
  ep     = sin(alphap) * Rperp * phase
  betaM0 = Pi - beta0
  call leg_normalized (betaM0, abs(m), Nrank, Pnm, dPnm, pinm, taunm)
  mr = real(m,O)  
  do k = 1, Nmax
    if (m == 0) then
      n = k
    else
      n = abs(m) + k - 1
    end if
    nm    = real(2 * n * (n + 1),O)         
    nm    = 1._O / sqrt(nm)     
    factc = 4._O * im**n * nm * cos(mr * Pi)        
    factp = factc * im * mr * pinm(n)
    factt = factc * taunm(n)
    c(k)      = - factp * et - factt * ep
    c(Nmax+k) = - im * (factt * et - factp * ep)
  end do      
  deallocate (Pnm, dPnm, pinm, taunm)      
end subroutine PWcoefficientsPARTSUBrefl
! **********************************************************************************
subroutine PWcoefficientsPARTSUBtrans (beta, alphap, z0, wavenumber, ind_ref, m,    &
           Nrank, Nmax, c)
!----------------------------------------------------------------------------------
! The routine computes the expansion coefficients of the transmitted plane wave   !
! (traveling in the Oxz plane) for the azimuthal mode m.                          !
! --------------------------------------------------------------------------------- 
  use parameters
  implicit none
  integer    :: m, Nrank, Nmax
  real(O)    :: beta, alphap, z0, wavenumber
  complex(O) :: c(2*Nmax), ind_ref     
!
  integer    :: k, n
  real(O)    :: nm, mr
  complex(O) :: Rpar, Rperp, Tpar, Tperp, et, ep, cosb, sinb0, cosb0, factc, factp, &
                factt, phase
  complex(O),allocatable :: Pnm(:), dPnm(:), pinm(:), taunm(:)
!
  allocate (Pnm(0:Nrank), dPnm(0:Nrank), pinm(0:Nrank), taunm(0:Nrank))
  cosb = cmplx(cos(beta),0._O)   
  call Fresnel_sub_aer (cosb, ind_ref, Rpar, Rperp, Tpar, Tperp, cosb0, sinb0)  
  phase = exp(im * wavenumber * (cosb0 - ind_ref * cosb) * z0)       
  et    = cos(alphap) * Tpar * phase
  ep    = sin(alphap) * Tperp * phase
  cosb0 = - cosb0 
  call Leg_normalized_complex (sinb0, cosb0, abs(m), Nrank, Pnm, dPnm, pinm, taunm)
  mr = real(m,O) 
  do k = 1, Nmax
    if (m == 0) then
      n = k
    else
      n = abs(m) + k - 1
    end if
    nm    = real(2 * n * (n + 1),O)         
    nm    = 1._O / sqrt(nm)     
    factc = 4._O * im**n * nm
    factp = factc * im * mr * pinm(n)
    factt = factc * taunm(n)
    c(k)      = - factp * et - factt * ep
    c(Nmax+k) = - im * (factt * et - factp * ep)
  end do   
  deallocate (Pnm, dPnm, pinm, taunm)    
end subroutine PWcoefficientsPARTSUBtrans
! **********************************************************************************
subroutine Fresnel_aer_sub (cosb0, m, Rpar, Rperp, Tpar, Tperp, cosb, sinb)
  use parameters
  use derived_parameters
  implicit none
  complex(O) :: cosb0, sinb0, m, Rpar, Rperp, Tpar, Tperp, cosb, sinb        
! 
  sinb0 = sqrt(1._O - cosb0**2)
  sinb  = sinb0 / m
  cosb  = sqrt(1._O - sinb**2)
  if (aimag(m * cosb) < 0._O) cosb = - cosb 
  if (abs(m * cosb0 + cosb) < MachEps) then
    print "(/,2x,'Warning in subroutine Fresnel_aer_sub in module IncCoeff:')"
    print "(  2x,'the denominator in the expression of the Fresnel reflection')"
    print "(  2x,'coefficients is smaller than the machine precision;')"    
  end if            
  if (abs(m * cosb0 - cosb) < MachEps) then      ! redundant
    Rpar = zero
    Tpar = 1._O / m
  else
    Rpar = (m * cosb0 - cosb) / (m * cosb0 + cosb)
    Tpar = 2._O * cosb0 / (m * cosb0 + cosb)
  end if
  if (abs(cosb0 - m * cosb) < MachEps) then      ! redundant
    Rperp = zero
    Tperp = one
  else
    Rperp = (cosb0 - m * cosb) / (cosb0 + m * cosb)
    Tperp = 2._O * cosb0 / (cosb0 + m * cosb)
  end if      
end subroutine Fresnel_aer_sub
! **********************************************************************************
subroutine Fresnel_sub_aer (cosb, m, Rpar, Rperp, Tpar, Tperp, cosb0, sinb0)
  use parameters
  use derived_parameters
  implicit none
  complex(O) :: cosb, m, Rpar, Rperp, Tpar, Tperp, sinb0, cosb0, sinb
!
  sinb  = sqrt(1._O - cosb**2)
  sinb0 = m * sinb
  cosb0 = sqrt(1._O - sinb0**2)       
  if (aimag(cosb0) < 0._O) cosb0 = - cosb0  
  if (abs(m * cosb0 + cosb) < MachEps) then
    print "(/,2x,'Warning in subroutine Fresnel_sub_aer in module IncCoeff:')"
    print "(  2x,'the denominator in the expression of the Fresnel transmission')"
    print "(  2x,'coefficients is smaller than the machine precision;')"    
  end if         
  if (abs(cosb - m * cosb0) < MachEps) then      ! redundant
    Rpar = zero
    Tpar = m   
  else
    Rpar = (cosb - m * cosb0) / (m * cosb0 + cosb)
    Tpar = 2._O * m * cosb / (m * cosb0 + cosb)
  end if
  if (abs(m * cosb - cosb0) < MachEps) then      ! redundant
    Rperp = zero
    Tperp = one 
  else
    Rperp = (m * cosb - cosb0) / (cosb0 + m * cosb)
    Tperp = 2._O * m * cosb / (cosb0 + m * cosb) 
  end if      
end subroutine Fresnel_sub_aer                  
! **********************************************************************************
subroutine GBcoefficients_ab (wavenumber, x0, y0, z0, w0, thetaGI, phiGI, alpha,    &
           beta, gamma, alphap, Mrank, Nrank, Nmax, c)
!------------------------------------------------------------------------------------
! The routine computes the expansion coefficients of a Gaussian beam for the        !
! azimuthal modes m = 0,1,...,Mrank.  Note that x0, y0, z0 are the coordinates of   !
! the beam focal point with respect to a global coordinate system (having the same  !
! origin as the particle coordinate system).                                        ! 
!------------------------------------------------------------------------------------ 
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax
  real(O)    :: wavenumber, x0, y0, z0, w0, thetaGI, phiGI, alpha, beta, gamma,     &
                alphap          
  complex(O) :: c(2*Nmax)
!      
  integer    :: m, Nmaxl, k, N0, l, ml
  complex(O),allocatable :: cl(:)
!
  do m = 0, Mrank                       
    if (m == 0) then
      Nmaxl = Nrank
      allocate (cl(2*Nmaxl))
      call GBcoefficients_ab_m (wavenumber, x0, y0, z0, w0, thetaGI, phiGI, alpha,  &
           beta, gamma, alphap, m, Nmaxl, cl)
      do k = 1, Nmaxl        
        c(k)      = cl(k)
        c(Nmax+k) = cl(k+Nmaxl)
      end do
      deallocate (cl)
    else        
      N0    = Nrank + (m - 1) * (2 * Nrank - m + 2)
      Nmaxl = Nrank - m + 1
      allocate (cl(2*Nmaxl))           
      ml = m
      do l = 1, 2
        call GBcoefficients_ab_m (wavenumber, x0, y0, z0, w0, thetaGI, phiGI,       &
             alpha, beta, gamma, alphap, ml, Nmaxl, cl)
        do k = 1, Nmaxl                           
          c(N0+k)      = cl(k)
          c(Nmax+N0+k) = cl(k+Nmaxl)                
        end do
        N0 =   N0 + Nrank - m + 1
        ml = - ml
      end do 
      deallocate (cl)                 
    end if
  end do     
end subroutine GBcoefficients_ab     
! **********************************************************************************
subroutine GBcoefficients_ab_m (wavenumber, x0, y0, z0, w0, thetaGI, phiGI, alpha,  &
           beta, gamma, alphap, m, Nmax, c)
!------------------------------------------------------------------------------------
! The routine computes the expansion coefficients of a Gaussian beam for the        !
! azimuthal mode m. Note that x0, y0, z0 are the coordinates of the beam focal point!
! with respect to a global coordinate system (having the same origin as the         !
! particle coordinate system).                                                      !
!------------------------------------------------------------------------------------ 
  use parameters
  implicit none
  integer    :: m, Nmax
  real(O)    :: wavenumber, x0, y0, z0, w0, thetaGI, phiGI, alpha, beta, gamma,     &
                alphap          
  complex(O) :: c(2*Nmax)
!      
  integer    :: k, n, m1, p
  real(O)    :: xpG, ypG, zpG, xpL, ypL, zpL
  complex(O) :: suma, sumb
  complex(O),allocatable :: a(:), b(:), d(:)
!
  xpG = - x0
  ypG = - y0
  zpG = - z0
  call T_cartesian_global_local (xpG, ypG, zpG, phiGI, thetaGI, alphap, xpL, ypL, zpL)            
  do k = 1, Nmax
    if (m == 0) then
      n = k
    else
      n = abs(m) + k - 1
    end if
    allocate (a(2*n+1), b(2*n+1), d(2*n+1)) 
    call GBcoefficients_ab_local (wavenumber, xpL, ypL, zpL, w0, n, a, b)   
    call product_rotcoefficients (thetaGI, phiGI, alpha, beta, gamma, alphap, m, n, d) 
    suma = zero
    sumb = zero
    do m1 = 0, n
      if (m1 == 0) then        
        suma = suma + a(1) * d(1)
        sumb = sumb + b(1) * d(1)
      else
        p    = 2 * m1
        suma = suma + a(p) * d(p) + a(p+1) * d(p+1)
        sumb = sumb + b(p) * d(p) + b(p+1) * d(p+1)
      end if
    end do
    c(k)     = suma
    c(k+Nmax)= sumb        
    deallocate (a, b, d)
  end do
end subroutine GBcoefficients_ab_m      
! **********************************************************************************
subroutine product_rotcoefficients (thetaGI, phiGI, alpha, beta, gamma, alphap,     &
           m, n, d)
  use parameters
  implicit none
  integer     :: m, n
  real(O)     :: thetaGI, phiGI, alpha, beta, gamma, alphap
  complex(O)  :: d(2*n+1)   
!      
  integer     :: m1, m2, k       
  complex(O)  :: sum, Dnm1m2, Dnm2m, coef_rotation
!
  do m1 = 0, n
    if (m1 == 0) then     
      sum = zero
      do m2 = - n, n
        Dnm1m2 = coef_rotation (- alphap, - thetaGI, - phiGI, n, m1, m2)
        Dnm2m  = coef_rotation (  alpha, beta, gamma, n, m2, m)        
        sum    = sum + Dnm1m2 * Dnm2m
      end do
      d(1) = sum
    else
      k = 2 * m1 
!     --- m1 > 0 ---
      sum = zero         
      do m2 =  - n, n
        Dnm1m2 = coef_rotation (- alphap, - thetaGI, - phiGI, n, m1, m2)
        Dnm2m  = coef_rotation ( alpha, beta, gamma, n, m2, m)
        sum    = sum + Dnm1m2 * Dnm2m
      end do
      d(k) = sum
!     --- m1 < 0 ---
      sum = zero          
      do m2 = - n, n
        Dnm1m2 = coef_rotation (- alphap, - thetaGI, - phiGI, n, - m1, m2)
        Dnm2m  = coef_rotation ( alpha, beta, gamma, n, m2, m)
        sum    = sum + Dnm1m2 * Dnm2m
      end do
      d(k+1) = sum
    end if
  end do      
end subroutine product_rotcoefficients                    
! **********************************************************************************
subroutine GBcoefficients_ab_local (wavenumber, x0, y0, z0, w0, n, a, b)
  use parameters
  use derived_parameters
  implicit none
  integer     :: n
  real(O)     :: wavenumber, x0, y0, z0, w0      
  complex(O)  :: a(2*n+1), b(2*n+1)
!      
  integer     :: m, k
  real(O)     :: l, ro0, phi0, ron, argz, argpm, argpp, sig, w02, dz
  complex(O)  :: Q, PSI, arg, fact, Kcor, factz, factm, factp, imQ, dzc
  complex(O),allocatable :: Jbes(:)
!
  if (abs(w0) < MachEps) then
    print "(/,2x,'Warning in subroutine GBcoefficients_ab_local in module IncCoeff:')"
    print "(  2x,'the waist radius of the Gaussian beam is smaller than the machine')"
    print "(  2x,'precision;')"    
  end if
  l   = wavenumber * w0 * w0  
  dz  = 2._O * z0 / l
  dzc = cmplx(dz,0.0,O)
  Q   = 1._O / (im - dzc)
  ro0 = sqrt(x0 * x0 + y0 * y0)     
  if (ro0 < MachEps) then
    phi0 = 0._O                  
  else    
    phi0 = atan2(y0,x0)
    if (phi0 < 0._O) phi0 = 2._O * Pi + phi0     
  end if 
  ron = (real(n,O) + 0.5_O) / wavenumber
  w02 = w0 * w0
  imQ = im * Q
  PSI = imQ * exp(-imQ * (ro0 * ro0 + ron * ron) / w02)
  arg = 2._O * Q * ro0 * ron / w02
  allocate (Jbes(0:n+1))  
  call bes_J (arg, n + 1, Jbes)     
  argz  = wavenumber * z0
  factz = exp(im * argz)   
  do m = 0, n
    if (m == 0) then              
      fact =   2._O * factz * Jbes(1) * Kcor(m,n) * PSI       
      a(1) = - cos(phi0) * fact       
      b(1) =   im * sin(phi0) * fact
    else
      k     = 2 * m   
      argpm = real(m - 1,O) * phi0
      argpp = real(m + 1,O) * phi0
      fact  = factz * Kcor(m,n) * PSI
!     --- m > 0 ---      
      factm = exp(im * argpm) * Jbes(m-1)
      factp = exp(im * argpp) * Jbes(m+1)             
      a(k)  = fact * (factm - factp)          
      b(k)  = fact * (factm + factp) 
!     --- m < 0 ---
      sig    = (- 1._O)**(m - 1)
      factm  = sig * exp(- im * argpm) * Jbes(m-1)
      factp  = sig * exp(- im * argpp) * Jbes(m+1)           
      a(k+1) = fact * (factp - factm)       
      b(k+1) = fact * (factp + factm)  
    end if
  end do
  deallocate (Jbes)   
end subroutine GBcoefficients_ab_local    
! **********************************************************************************
function Kcor (m, n) result (K)
  use parameters
  implicit none
  integer      :: m, n
  complex(O)   :: K
!      
  integer      :: p
  real(O)      :: fact, sum, lnx  
!
  if (m == 0) then
    fact = 2._O * sqrt(real(n * (n + 1),O) / real(2 * n + 1,O))      
    K    = im**n * fact
  else
    sum = 0._O
    do p = 1, 2 * abs(m)
      sum = sum + log(real(n - abs(m) + p,O))
    end do
    lnx = real(abs(m) - 1,O) * log(2._O / real(2 * n + 1,O))
    lnx = lnx + 0.5_O * (log(real(2 * n + 1,O)) - log(real(n * (n + 1),O)) + sum)     
    K   = im**(n + abs(m)) * (-1._O)**abs(m) * exp(lnx)
  end if     
end function Kcor

! **********************************************************************************
! *         ROUTINES FOR COMPUTING THE Q MATRIX AND THE INCIDENT MATRIX            * 
! *         FOR A COMPOSITE PARTICLE                                               *
! *    -----------------------------------------------------------------------     *
! *    Partial list of subroutines (including the subroutines for a layered        *
! *    particle)                                                                   *
! *      matrix_Q_COMP,                     incident_matrix_COMP,                  *
! *      matrix_Q_DS_COMP,                  incident_matrix_DS_COMP,               *
! *      matrix_Q31_LAY,                    auxmatrices_Q31_LAY,                   *
! *      matrix_Q1_LAY,                     incident_matrix_LAY,                   *
! *      matrix_Q31_DS_LAY,                 auxmatrices_Q31_DS_LAY,                *
! *      matrix_Q1_DS_LAY,                  incident_matrix_DS_LAY                 *
! **********************************************************************************
subroutine matrix_Q_COMP (TypeGeom, index1, index2, k, ind_ref, Nsurfmax, surf, m,  &
           Npart, zpart, Nrankp, NmaxC, NrankL, NmaxL, Nint, Nparammax, Nparam,     &
           Nintparam, paramG, weightsG, A, nap, map)
!------------------------------------------------------------------------------------
! The routine computes the Q matrix of a composite particle for the azimuthal       !
! mode m. Localized sources are used for calculation.                               ! 
!------------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: TypeGeom, index1, index2, m, Nsurfmax, Npart, Nrankp(Npart),        &
                NmaxC, NrankL, NmaxL, Nint, Nparammax, Nintparam(Npart,Nparammax),  &
                Nparam(Npart), nap, map
  real(O)    :: k, zpart(Npart), surf(Npart,Nsurfmax),                              &
                paramG(Npart,Nparammax,Nint), weightsG(Npart,Nparammax,Nint)
  complex(O) :: ind_ref(Npart), A(2*nap,2*map)
!  
  integer    :: i, j, pint, m_minus, iparam, Nintl, ipart, Nparaml
  real(O)    :: r, theta, phi, dA, param, pondere, r1, theta1, n(3), nn(3), tamp,   &
                sign, ct, st
  complex(O) :: kc, ki, zl, fact, f
  complex(O),allocatable :: m1(:,:), n1(:,:), m3(:,:), n3(:,:)
!
  if (index1 == 3 .and. index2 == 1 .and. NmaxL /= NmaxC) then
    print "(/,2x,'Error in subroutine matrix_Q_COMP in module Proces2:')"
    print "(  2x,'the relation NmaxL = NmaxC does not hold;')"
    stop
  end if
  allocate (m1(3,NmaxC), n1(3,NmaxC), m3(3,NmaxL), n3(3,NmaxL))
  kc = cmplx(k,0.0,O)
  do i = 1, 2*NmaxL
    do j = 1, 2*NmaxC
      A(i,j) = zero
    end do
  end do     
  m_minus = - m
  sign = 1._O
  if (index1 == 3 .and. index2 == 1) sign = - 1._O
  f = sign * im * 2._O * k * k
  do ipart = 1, Npart
    ki = k * ind_ref(ipart)
    Nparaml = Nparam(ipart)
    do iparam = 1, Nparaml
      Nintl = Nintparam(ipart,iparam)
      do pint = 1, Nintl
        param   = paramG(ipart,iparam,pint)
        pondere = weightsG(ipart,iparam,pint)
        call elem_geomCOMP (TypeGeom, Npart, ipart, Nsurfmax, surf, param, iparam,  &
             r1, theta1, phi, dA, nn)
        ct = cos(theta1)
        r  = sqrt(r1**2 + zpart(ipart)**2 + 2._O * r1 * zpart(ipart) * ct)
        if (r < MachEps) r = MachEps
        theta = acos((zpart(ipart) + r1 * ct) / r)
        ct   = cos(theta1 - theta)
        st   = sin(theta1 - theta)
        n(1) = nn(1) * ct - nn(2) * st
        n(2) = nn(1) * st + nn(2) * ct
        n(3) = 0._O
        tamp = sqrt(n(1)**2 + n(2)**2)
        if (tamp < MachEps) then
          print "(/,2x,'Error in subroutine matrix_Q_COMP in module Proces2:')"
          print "(  2x,'the module of the normal unit vector is zero;')"
          stop
        end if
        n(1) = n(1) / tamp
        n(2) = n(2) / tamp
        zl   = cmplx(k * r,0.0,O)
        if (index1 == 3 .and. index2 == 1) then       
          call MN_poles_COMP1 (1, ipart, ki, r, theta, m, Npart, zpart, Nrankp,     &
               NmaxC, m1, n1)                                         
          call MN_poles_COMP (3, kc, r, theta, m_minus, Npart, zpart, Nrankp,       &
               NmaxC, m3, n3) 
        else if (index1 == 1 .and. index2 == 1) then
          call MN_poles_COMP1 (1, ipart, ki, r, theta, m, Npart, zpart, Nrankp,     &
               NmaxC, m1, n1)                                                                               
          call MN (1, zl, theta, m_minus, NrankL, NmaxL, m3, n3)
        end if                                   
        fact = f * dA * pondere
        call matQ_COMP(m, NmaxC, NmaxL, ind_ref(ipart), fact, m3, n3, m1, n1, n,    &
             A, nap, map)        
      end do  
    end do
  end do
  deallocate (m1, n1, m3, n3)    
end subroutine matrix_Q_COMP
!***********************************************************************************
subroutine incident_matrix_COMP (TypeGeom, k, Nsurfmax, surf, m, Npart, zpart,      &
           Nrankp, NmaxC, NrankL, NmaxL, Nint, Nparammax, Nparam, Nintparam, paramG,&
           weightsG, A, nap, map)
!----------------------------------------------------------------------------------- 
! The routine computes the incident matrix of a composite particle using           !
! localized sources,                                                               !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: TypeGeom, m, Nsurfmax, Npart, Nrankp(Npart), NmaxC, Nint,           &
                Nparammax, Nparam(Npart), NrankL, NmaxL, Nintparam(Npart,Nparammax),&
                nap, map
  real(O)    :: k, surf(Npart,Nsurfmax), paramG(Npart,Nparammax,Nint),              &
                weightsG(Npart,Nparammax,Nint), zpart(Npart)
  complex(O) :: A(2*nap,2*map)
!
  integer    :: i, j, pint, m_minus, iparam, Nintl, ipart, Nparaml
  real(O)    :: r, theta, phi, dA, param, pondere, r1, theta1, n(3), nn(3), tamp,   &
                ct, st
  complex(O) :: kc, fact, zl, f
  complex(O),allocatable :: m1(:,:), n1(:,:), m3(:,:), n3(:,:)
!
  allocate (m1(3,NmaxL), n1(3,NmaxL), m3(3,NmaxC), n3(3,NmaxC))
  kc = cmplx(k,0.0,O)
  do i = 1, 2*NmaxC
    do j = 1, 2*NmaxL
      A(i,j) = zero
    end do
  end do  
  m_minus = - m
  f = - im * 2._O * k * k
  do ipart = 1, Npart
    Nparaml = Nparam(ipart)
    do iparam = 1, Nparaml
      Nintl = Nintparam(ipart,iparam)
      do pint = 1, Nintl
        param   = paramG(ipart,iparam,pint)
        pondere = weightsG(ipart,iparam,pint)
        call elem_geomCOMP (TypeGeom, Npart, ipart, Nsurfmax, surf, param, iparam,  &
             r1, theta1, phi, dA, nn)
        ct = cos(theta1)
        r  = sqrt(r1**2 + zpart(ipart)**2 + 2._O * r1 * zpart(ipart) * ct)
        if (r < MachEps) r = MachEps
        theta = acos((zpart(ipart) + r1 * ct) / r)
        ct   = cos(theta1 - theta)
        st   = sin(theta1 - theta)
        n(1) = nn(1) * ct - nn(2) * st
        n(2) = nn(1) * st + nn(2) * ct
        n(3) = 0._O
        tamp = sqrt(n(1)**2 + n(2)**2)
        if (tamp < MachEps) then
          print "(/,2x,'Error in subroutine incident_matrix_COMP in module Proces2:')"
          print "(  2x,'the module of the normal unit vector is zero;')"
          stop
        end if
        n(1) = n(1) / tamp
        n(2) = n(2) / tamp
        zl   = cmplx(k * r,0.0,O)        
        call MN (1, zl, theta, m, NrankL, NmaxL, m1, n1)                                                                             
        call MN_poles_COMP (3, kc, r, theta, m_minus, Npart, zpart, Nrankp, NmaxC,  &
             m3, n3)      
        fact = f * dA * pondere
        call matQinc_m(m, NmaxL, NmaxC, fact, m3, n3, m1, n1, n, A, nap, map)        
      end do
    end do
  end do                 
  deallocate (m1, n1, m3, n3)      
end subroutine incident_matrix_COMP
!***********************************************************************************
subroutine matrix_Q_DS_COMP (TypeGeom, index1, index2, k, ind_ref, Nsurfmax, surf,  &
           Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, m, NmaxC, NrankL, NmaxL,      &
           Nint, Nparammax, Nparam, Nintparam, paramG, weightsG, A, nap, map)
!------------------------------------------------------------------------------------
! The routine computes the Q matrix of a composite particle for the azimuthal       !
! mode m. Distributed sources are used for calculation.                             !
!------------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: TypeGeom, index1, index2, m, Nsurfmax, Npart, Nrankpmax,            &
                NmaxC, NrankL, NmaxL, Nint, Nparammax, Nintparam(Npart,Nparammax),  &
                Nparam(Npart), Nrankp(Npart), nap, map
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), zRe(Npart,Nrankpmax),        &
                zIm(Npart,Nrankpmax), paramG(Npart,Nparammax,Nint),                 &
                weightsG(Npart,Nparammax,Nint)  
  complex(O) :: ind_ref(Npart), A(2*nap,2*map)        
!      
  integer    :: i, j, pint, m_minus, iparam, Nintl, ipart, Nparaml
  real(O)    :: r, theta, phi, dA, param, pondere, r1, theta1, n(3), nn(3), tamp,   &
                sign, ct, st
  complex(O) :: kc, ki, zl, fact, f
  complex(O),allocatable :: m1(:,:), n1(:,:), m3(:,:), n3(:,:) 
!
  if (index1 == 3 .and. index2 == 1 .and. NmaxC /= NmaxL) then
    print "(/,2x,'Error in subroutine matrix_Q_DS_COMP in module Proces2:')"
    print "(  2x,'the relation NmaxC = NmaxL does not hold;')"
    stop
  end if
  allocate (m1(3,NmaxC), n1(3,NmaxC), m3(3,NmaxL), n3(3,NmaxL))
  kc = cmplx(k,0.0,O)
  do i = 1, 2*NmaxL
    do j = 1, 2*NmaxC
      A(i,j) = zero
    end do  
  end do       
  m_minus = - m
  sign = 1._O
  if (index1 == 3 .and. index2 == 1) sign = - 1._O
  f = sign * im * 2._O * k * k
  do ipart = 1, Npart
    ki = k * ind_ref(ipart)
    Nparaml= Nparam(ipart)
    do iparam = 1, Nparaml
      Nintl = Nintparam(ipart,iparam)
      do pint = 1, Nintl
        param   = paramG(ipart,iparam,pint)
        pondere = weightsG(ipart,iparam,pint)
        call elem_geomCOMP (TypeGeom, Npart, ipart, Nsurfmax, surf, param, iparam,  &
             r1, theta1, phi, dA, nn)
        ct = cos(theta1)
        r  = sqrt(r1**2 + zpart(ipart)**2 + 2._O * r1 * zpart(ipart) * ct)
        if (r < MachEps) r = MachEps
        theta = acos((zpart(ipart) + r1 * ct) / r)
        ct   = cos(theta1 - theta)
        st   = sin(theta1 - theta)
        n(1) = nn(1) * ct - nn(2) * st
        n(2) = nn(1) * st + nn(2) * ct
        n(3) = 0._O
        tamp = sqrt(n(1)**2 + n(2)**2)
        if (tamp < MachEps) then
          print "(/,2x,'Error in subroutine matrix_Q_DS_COMP in module Proces2:')"
          print "(  2x,'the module of the normal unit vector is zero;')"
          stop
        end if
        n(1) = n(1) / tamp
        n(2) = n(2) / tamp
        zl   = cmplx(k * r,0.0,O)
        if (index1 == 3 .and. index2 == 1) then          
          call MN_DS_COMP1 (1, ipart, ki, r, theta, Npart, Nrankpmax, Nrankp,       &
               zRe, zIm, m, NmaxC, m1, n1)                                                     
          call MN_DS_COMP (3, kc, r, theta, Npart, Nrankpmax, Nrankp, zRe, zIm,     &
               m_minus, NmaxC, m3, n3)
        else if (index1 == 1 .and. index2 == 1) then              
          call MN_DS_COMP1 (1, ipart, ki, r, theta, Npart, Nrankpmax, Nrankp,       &
               zRe, zIm, m, NmaxC, m1, n1)                                                         
          call MN (1, zl, theta, m_minus, NrankL, NmaxL, m3, n3)
        end if           
        fact = f * dA * pondere
        call matQ_COMP(m, NmaxC, NmaxL, ind_ref(ipart), fact, m3, n3, m1, n1, n,    &
             A, nap, map)          
      end do
    end do
  end do                             
  deallocate (m1, n1, m3, n3)
end subroutine matrix_Q_DS_COMP
!***********************************************************************************
subroutine incident_matrix_DS_COMP (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax,  &
           Nrankp, zRe, zIm, zpart, m, NmaxC, NrankL, NmaxL, Nint, Nparammax,       &
           Nparam, Nintparam, paramG, weightsG, A, nap, map)
!-----------------------------------------------------------------------------------
! The routine computes the incident matrix of a composite particle using           !
! distrubuted sources.                                                             !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: TypeGeom, m, Nsurfmax, Npart, Nrankpmax, Nrankp(Npart),             &
                NmaxC, NrankL, NmaxL, Nint, Nparammax, Nparam(Npart),               &
                Nintparam(Npart,Nparammax), nap, map
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), paramG(Npart,Nparammax,Nint),&
                weightsG(Npart,Nparammax,Nint), zRe(Npart,Nrankpmax),               &
                zIm(Npart,Nrankpmax)
  complex(O) :: A(2*nap,2*map)                       
!      
  integer    :: i, j, pint, m_minus, iparam, Nintl, ipart, Nparaml
  real(O)    :: r, theta, phi, dA, param, pondere, r1, theta1, n(3), nn(3), tamp,   &
                ct, st
  complex(O) :: kc, fact, zl, f
  complex(O),allocatable :: m1(:,:), n1(:,:), m3(:,:), n3(:,:) 
!
  allocate (m1(3,NmaxL), n1(3,NmaxL), m3(3,NmaxC), n3(3,NmaxC))
  kc = cmplx(k,0.0,O)
  do i = 1, 2*NmaxC
    do j = 1, 2*NmaxL
      A(i,j) = zero
    end do  
  end do
  m_minus = - m
  f = - im * 2._O * k * k
  do ipart = 1, Npart
    Nparaml = Nparam(ipart)
    do iparam = 1, Nparaml
      Nintl = Nintparam(ipart,iparam)
      do pint = 1, Nintl
        param   = paramG(ipart,iparam,pint)
        pondere = weightsG(ipart,iparam,pint)
        call elem_geomCOMP (TypeGeom, Npart, ipart, Nsurfmax, surf, param, iparam,  &
             r1, theta1, phi, dA, nn)
        ct = cos(theta1)
        r  = sqrt(r1**2 + zpart(ipart)**2 + 2._O * r1 * zpart(ipart) * ct)
        if (r < MachEps) r = MachEps
        theta = acos((zpart(ipart) + r1 * ct) / r)
        ct   = cos(theta1 - theta)
        st   = sin(theta1 - theta)
        n(1) = nn(1) * ct - nn(2) * st
        n(2) = nn(1) * st + nn(2) * ct
        n(3) = 0._O
        tamp = sqrt(n(1)**2 + n(2)**2)
        if (tamp < MachEps) then
          print "(/,2x,'Error in subroutine incident_matrix_DS_COMP in module Proces2:')"
          print "(  2x,'the module of the normal unit vector is zero;')"
          stop
        end if
        n(1) = n(1) / tamp
        n(2) = n(2) / tamp
        zl   = cmplx(k * r,0.0,O)        
        call MN (1, zl, theta, m, NrankL, NmaxL, m1, n1)                                                                  
        call MN_DS_COMP (3, kc, r, theta, Npart, Nrankpmax, Nrankp, zRe, zIm,       &
             m_minus, NmaxC, m3, n3)                      
        fact = f * dA * pondere
        call matQinc_m(m, NmaxL, NmaxC, fact, m3, n3, m1, n1, n, A, nap, map)         
      end do
    end do
  end do                             
  deallocate (m1, n1, m3, n3)   
end subroutine incident_matrix_DS_COMP
! **********************************************************************************
! *          ROUTINES FOR COMPUTING THE Q MATRIX AND THE INCIDENT MATRIX           * 
! *                         FOR A LAYERED PARTICLE                                 *
! **********************************************************************************
subroutine matrix_Q31_LAY (TypeGeom, k, ind_ref, Nsurfmax, surf, Npart, Nrankp,     &
           Nmaxpmax, Nmaxp, zpart, m, Nmax, Nint, Nparammax, Nparam, Nintparam,     &
           paramG, weightsG, AA, nap, map)
!------------------------------------------------------------------------------------
! The routine computes the Q(3,1) matrix of a layered particle for the azimuthal    !
! mode m. Localized sources are used for calculation.                               !
!------------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: TypeGeom, m, Nsurfmax, Npart, Nmaxpmax, Nmax, Nint, Nparammax,      &
                Nintparam(Npart,Nparammax), Nparam(Npart), Nrankp(Npart),           &
                Nmaxp(Npart), nap, map
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), paramG(Npart,Nparammax,Nint),&
                weightsG(Npart,Nparammax,Nint)
  complex(O) :: ind_ref(Npart), AA(2*nap,2*map)
!       
  integer    :: i, j, ipart, Nrankl, Nrankc, Nl, Nc  
  complex(O) :: kc, kl, index
  complex(O),allocatable :: a(:,:), b(:,:) 
!
  do i = 1, 2*Nmax
    do j = 1, 2*Nmax
      AA(i,j) = zero
    end do               
  end do  
  do ipart = 1, Npart     
    if (ipart == 1) then
      Nrankl = Nmaxp(ipart)
      Nrankc = Nmaxp(ipart)   
      allocate (a(2*Nrankl,2*Nrankc), b(2*Nrankl,2*Nrankc))          
      kl = cmplx(k,0.0,O)
      kc = k * ind_ref(ipart)
      if (abs(kl) < MachEps) kl = cmplx(MachEps,MachEps,O)
      index = kc / kl
      call auxmatrices_Q31_LAY (TypeGeom, ipart, kl, kc, index, Npart+1,            &
           Nsurfmax, surf, Npart, Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint,          &
           Nparammax, Nparam, Nintparam, paramG, weightsG, Nrankl, Nrankc,          &
           22, a, Nrankl, Nrankc, b, Nrankl, Nrankc) 
      do i = 1, 2*Nrankl
        do j = 1, 2*Nrankc
          AA(i,j) = a(i,j)
          AA(i,j+2*Nrankc) = b(i,j)
        end do
      end do
      deallocate (a, b)
      Nl = 2 * Nmaxp(ipart)
      Nc = 0        
    else    
      Nrankl = Nmaxp(ipart-1)
      Nrankc = Nmaxp(ipart-1) 
      allocate (a(2*Nrankl,2*Nrankc), b(2*Nrankl,2*Nrankc)) 
      do i = 1, 2*Nrankl
        do j = 1, 2*Nrankc
          a(i,j) = zero
          b(i,j) = zero
          if (i == j) b(i,j) = - one
        end do
      end do                
      do i = 1, 2*Nrankl
        do j = 1, 2*Nrankc
          AA(i+Nl,j+Nc) = a(i,j)
          AA(i+Nl,j+Nc+2*Nrankc) = b(i,j)
        end do
      end do
      deallocate (a, b)
      Nc = Nc + 4 * Nmaxp(ipart-1)
!
      Nrankl = Nmaxp(ipart-1)
      Nrankc = Nmaxp(ipart) 
      allocate (a(2*Nrankl,2*Nrankc), b(2*Nrankl,2*Nrankc))            
      kl = k * ind_ref(ipart-1) 
      kc = k * ind_ref(ipart)
      if (abs(kl) < MachEps) kl = cmplx(MachEps,MachEps,O)
      index = kc / kl
      call auxmatrices_Q31_LAY (TypeGeom, ipart, kl, kc, index, Npart,              &
           Nsurfmax, surf, Npart, Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint,          &
           Nparammax, Nparam, Nintparam, paramG, weightsG, Nrankl, Nrankc,          &
           12, a, Nrankl, Nrankc, b, Nrankl, Nrankc) 
      do i = 1, 2*Nrankl
        do j = 1, 2*Nrankc
          AA(i+Nl,j+Nc) = a(i,j)
          if(ipart < Npart) AA(i+Nl,j+Nc+2*Nrankc) = b(i,j)
        end do
      end do                 
      Nl = Nl + 2 * Nmaxp(ipart-1)
      Nc = Nc - 4 * Nmaxp(ipart-1)
      deallocate (a, b)
!
      Nrankl = Nmaxp(ipart)
      Nrankc = Nmaxp(ipart-1) 
      allocate (a(2*Nrankl,2*Nrankc), b(2*Nrankl,2*Nrankc)) 
      kl = k * ind_ref(ipart-1) 
      kc = k * ind_ref(ipart-1)
      if (abs(kl) < MachEps) kl = cmplx(MachEps,MachEps,O)
      index = kc / kl
      if (zpart(ipart) /= zpart(ipart-1)) then
        call auxmatrices_Q31_LAY (TypeGeom, ipart, kl, kc, index, Npart+1,          &
             Nsurfmax, surf, Npart, Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint,        &
             Nparammax, Nparam, Nintparam, paramG, weightsG, Nrankl, Nrankc,        &
             21, a, Nrankl, Nrankc, b, Nrankl, Nrankc)	         	     
      else        
        do i = 1, Nrankl
          do j = 1, Nrankc
            a(i,j) = zero
            a(i,j+Nrankc) = zero
            a(i+Nrankl,j) = zero
            a(i+Nrankl,j+Nrankc) = zero	                	    
            if (j == i) then
              a(i,j) = one
              a(i+Nrankl,j+Nrankc) = one
            end if
          end do
        end do
      end if
      do i = 1, 2*Nrankl
        do j = 1, 2*Nrankc
          AA(i+Nl,j+Nc) = a(i,j)
          AA(i+Nl,j+Nc+2*Nrankc) = zero
        end do
      end do
      Nc = Nc + 4 * Nmaxp(ipart-1)
      deallocate (a, b)
!
      Nrankl = Nmaxp(ipart)
      Nrankc = Nmaxp(ipart) 
      allocate (a(2*Nrankl,2*Nrankc), b(2*Nrankl,2*Nrankc))           
      kl = k * ind_ref(ipart-1) 
      kc = k * ind_ref(ipart)
      if (abs(kl) < MachEps) kl = cmplx(MachEps,MachEps,O)
      index = kc / kl
      call auxmatrices_Q31_LAY (TypeGeom, ipart, kl, kc, index, Npart,              &
           Nsurfmax, surf, Npart, Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint,          &
           Nparammax, Nparam, Nintparam, paramG, weightsG, Nrankl, Nrankc,          &
           22, a, Nrankl, Nrankc, b, Nrankl, Nrankc) 
      do i = 1, 2*Nrankl
        do j = 1, 2*Nrankc
          AA(i+Nl,j+Nc) = a(i,j)
          if (ipart < Npart) AA(i+Nl,j+Nc+2*Nrankc) = b(i,j)
        end do
      end do
      Nl = Nl + 2 * Nmaxp(ipart)
      deallocate (a, b)       
    end if
  end do  
end subroutine matrix_Q31_LAY
!***********************************************************************************
subroutine auxmatrices_Q31_LAY (TypeGeom, ipart, kl, kc, index, Npartlim, Nsurfmax, &
           surf, Npart, Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint, Nparammax, Nparam, &
           Nintparam, paramG, weightsG, Nrankl, Nrankc, Block, a, nap, map,         &
           b, nbp, mbp)
!-----------------------------------------------------------------------------------
! The routine computes the auxiliary matrices a and b used in the subroutine       !
! matrix_Q31_LAY.                                                                  !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: TypeGeom, ipart, Npartlim, m, Nsurfmax, Npart, Nmaxpmax, Nint,      &
                Nparammax, Nintparam(Npart,Nparammax), Nparam(Npart),               &
                Nrankp(Npart), Nmaxp(Npart), Nrankl, Nrankc, nap, map, nbp, mbp,    &
                Block
  real(O)    :: surf(Npart,Nsurfmax), zpart(Npart), paramG(Npart,Nparammax,Nint),   &
                weightsG(Npart,Nparammax,Nint)
  complex(O) :: kl, kc, index, a(2*nap,2*map), b(2*nbp,2*mbp)
!       
  integer    :: i, j, pint, m_minus, iparam, Nintl, Nparaml, ipartl
  real(O)    :: r, theta, phi, dA, param, pondere, r1, theta1, n(3), nn(3), sign,   &
                tamp, ct, st
  complex(O) :: fact, f
  complex(O),allocatable :: m1(:,:), n1(:,:), m3(:,:), n3(:,:), m2(:,:), n2(:,:) 
!
  allocate (m1(3,Nmaxpmax), n1(3,Nmaxpmax), m2(3,Nmaxpmax), n2(3,Nmaxpmax),         &
            m3(3,Nmaxpmax), n3(3,Nmaxpmax))  
  m_minus = - m  
  do i = 1, 2*Nrankl
    do j = 1, 2*Nrankc
      a(i,j) = zero
      b(i,j) = zero
    end do
  end do  
  if (Block == 22 .or. Block == 12) then
    sign   = 1._O
    ipartl = ipart
  else if (Block == 21) then
    sign   = - 1._O
    ipartl =   ipart - 1
  end if                  
  Nparaml = Nparam(ipartl)
  f = sign * im * 2._O * kl * kl
  do iparam = 1, Nparaml
    Nintl = Nintparam(ipartl,iparam)
    do pint = 1, Nintl
      param   = paramG(ipartl,iparam,pint)
      pondere = weightsG(ipartl,iparam,pint)
      call elem_geomLAY (TypeGeom, Npart, ipartl, Nsurfmax, surf, param, iparam,    &
           r1, theta1, phi, dA, nn)
      ct = cos(theta1)
      r  = sqrt(r1**2 + zpart(ipartl)**2 + 2._O * r1 * zpart(ipartl) * ct)
      if (r < MachEps) r = MachEps
      theta = acos((zpart(ipartl) + r1 * ct) / r)
      ct   = cos(theta1 - theta)
      st   = sin(theta1 - theta)
      n(1) = nn(1) * ct - nn(2) * st
      n(2) = nn(1) * st + nn(2) * ct
      n(3) = 0._O
      tamp = sqrt(n(1)**2 + n(2)**2)
      if (tamp < MachEps) then
        print "(/,2x,'Error in subroutine auxmatrices_Q31_LAY in module Proces2:')"
        print "(  2x,'the module of the normal unit vector is zero;')"
        stop
      end if
      n(1) = n(1) / tamp  
      n(2) = n(2) / tamp  
      if (Block == 21) then  
        call MN_poles_LAY (1, kc, r, theta, m, ipart-1, Npart, Nrankp, Nmaxpmax,    &
             Nmaxp, zpart, m1, n1)           
        !call MN_poles_LAY (3, kc, r, theta, m, ipart-1, Npart, Nrankp, Nmaxpmax,   &
        !     Nmaxp, zpart, m2, n2)               
        call MN_poles_LAY (3, kl, r, theta, m_minus, ipart, Npart, Nrankp, Nmaxpmax,&
             Nmaxp, zpart, m3, n3)
      else if (Block == 22) then
        call MN_poles_LAY (1, kc, r, theta, m, ipart, Npart, Nrankp, Nmaxpmax,      &
             Nmaxp, zpart, m1, n1)           
        call MN_poles_LAY (3, kc, r, theta, m, ipart, Npart, Nrankp, Nmaxpmax,      &
             Nmaxp, zpart, m2, n2)               
        call MN_poles_LAY (3, kl, r, theta, m_minus, ipart, Npart, Nrankp, Nmaxpmax,&
             Nmaxp, zpart, m3, n3)
      else if (Block == 12) then 
        call MN_poles_LAY (1, kc, r, theta, m, ipart, Npart, Nrankp, Nmaxpmax,      &
             Nmaxp, zpart, m1, n1)           
        call MN_poles_LAY (3, kc, r, theta, m, ipart, Npart, Nrankp, Nmaxpmax,      &
             Nmaxp, zpart, m2, n2)
        call MN_poles_LAY (1, kl, r, theta, m_minus, ipart-1, Npart, Nrankp,        &
             Nmaxpmax, Nmaxp, zpart, m3, n3)
      end if 
      fact = f * dA * pondere
      if (Block == 21) then
        call matQ_LAY_a (m, Nrankc, Nrankl, Nmaxpmax, index, fact, m3, n3, m1, n1,  &
             n, a, nap, map)            
      else       
        call matQ_LAY (m, ipart, Npartlim, Nrankc, Nrankl, Nmaxpmax, index, fact,   &
             m3, n3, m2, n2, m1, n1, n, a, nap, map, b, nbp, mbp)      
      end if	     
    end do
  end do
  deallocate (m1, n1, m2, n2, m3, n3)
end subroutine auxmatrices_Q31_LAY 
!***********************************************************************************
subroutine matrix_Q1_LAY (TypeGeom, indexC, k, ind_ref, Nsurfmax, surf, Npart,      &
           Nrankpmax, Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint, Nparammax, Nparam,   &
           Nintparam, paramG, weightsG, A, nap, map)
!-----------------------------------------------------------------------------------
! The routine computes the Q(1,1) or the Q(1,3) matrices of a layered particle     !
! for the azimuthal mode m. Localized sources are used for calculation.            !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: TypeGeom, m, Npart, Nsurfmax, Nmaxpmax, Nrankp(Npart),              &
                Nmaxp(Npart), Nint, Nparammax, Nintparam(Npart,Nparammax),          &
                Nparam(Npart), Nrankpmax, indexC, nap, map
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), paramG(Npart,Nparammax,Nint),&
                weightsG(Npart,Nparammax,Nint)
  complex(O) :: ind_ref(Npart), A(2*nap,2*map)
!           
  integer    :: i, j, pint, m_minus, iparam, Nintl, ipart, Nparaml
  real(O)    :: r, theta, phi, dA, param, pondere, r1, theta1, n(3), nn(3), tamp,   &
                ct, st
  complex(O) :: kc, zl, fact, f
  complex(O),allocatable :: m1(:,:), n1(:,:), m3(:,:), n3(:,:)  
!
  allocate (m1(3,Nmaxpmax), n1(3,Nmaxpmax), m3(3,Nmaxpmax), n3(3,Nmaxpmax))
  do i = 1, 2*Nmaxpmax
    do j = 1, 2*Nmaxpmax
      A(i,j) = zero
    end do
  end do
  m_minus = - m 
  ipart   =   1  
  Nparaml =   Nparam(ipart)
  kc = k * ind_ref(ipart)
  f  = im * 2._O * k * k
  do iparam = 1, Nparaml
    Nintl = Nintparam(ipart,iparam)
    do pint = 1, Nintl
      param   = paramG(ipart,iparam,pint)
      pondere = weightsG(ipart,iparam,pint)
      call elem_geomLAY (TypeGeom, Npart, ipart, Nsurfmax, surf, param, iparam,     &
           r1, theta1, phi, dA, nn)
      ct = cos(theta1)
      r  = sqrt(r1**2 + zpart(ipart)**2 + 2._O * r1 * zpart(ipart) * ct)
      if (r < MachEps) r = MachEps
      theta = acos((zpart(ipart) + r1 * ct) / r)
      ct   = cos(theta1 - theta)
      st   = sin(theta1 - theta)
      n(1) = nn(1) * ct - nn(2) * st
      n(2) = nn(1) * st + nn(2) * ct
      n(3) = 0._O
      tamp = sqrt(n(1)**2 + n(2)**2)
      if (tamp < MachEps) then
        print "(/,2x,'Error in subroutine matrix_Q1_LAY in module Proces2:')"
        print "(  2x,'the module of the normal unit vector is zero;')"
        stop
      end if
      n(1) = n(1) / tamp
      n(2) = n(2) / tamp          
      if (indexC == 1) then      
        call MN_poles_LAY (1, kc, r, theta, m, ipart, Npart, Nrankp, Nmaxpmax,      &
             Nmaxp, zpart, m1, n1)        
      else     
        call MN_poles_LAY (3, kc, r, theta, m, ipart, Npart, Nrankp, Nmaxpmax,      &
             Nmaxp, zpart, m1, n1)
      end if
      zl = cmplx(k * r,0.0,O)              
      call MN (1, zl, theta, m_minus, Nrankpmax, Nmaxpmax, m3, n3)
      fact = f * dA * pondere
      call matQ_COMP(m, Nmaxpmax, Nmaxpmax, ind_ref(ipart), fact, m3, n3, m1, n1,   &
           n, A, nap, map)      
    end do
  end do
  deallocate (m1, n1, m3, n3)     
end subroutine matrix_Q1_LAY
!***********************************************************************************
subroutine incident_matrix_LAY (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax,      &
           Nrankp, Nmaxpmax, Nmaxp, zpart, m, Nint, Nparammax, Nparam, Nintparam,   &
           paramG, weightsG, A, nap, map)
!-----------------------------------------------------------------------------------
! The routine computes the incident matrix of a layered particle using             !
! localized sources.                                                               !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: TypeGeom, m, Nsurfmax, Npart, Nrankpmax, Nrankp(Npart), Nint,       &
                Nparammax, Nparam(Npart), Nmaxpmax, Nmaxp(Npart),                   &
                Nintparam(Npart,Nparammax), nap, map
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), paramG(Npart,Nparammax,Nint),&
                weightsG(Npart,Nparammax,Nint)
  complex(O) :: A(2*nap,2*map)
!      
  integer    :: i, j, pint, m_minus, iparam, Nintl, ipart, Nparaml
  real(O)    :: r, theta, phi, dA, param, pondere, r1, theta1, n(3), nn(3), tamp,   &
                ct, st
  complex(O) :: kc, fact, zl, f
  complex(O),allocatable :: m1(:,:), n1(:,:), m3(:,:), n3(:,:) 
!
  allocate (m1(3,Nmaxpmax), n1(3,Nmaxpmax), m3(3,Nmaxpmax), n3(3,Nmaxpmax))
  kc = cmplx(k,0.0,O)
  do i = 1, 2*Nmaxpmax
    do j = 1, 2*Nmaxpmax
      A(i,j) = zero       
    end do
  end do        
  m_minus = - m
  ipart   =   1
  Nparaml =   Nparam(ipart)
  f = im * 2._O * k * k
  do iparam = 1, Nparaml
    Nintl = Nintparam(ipart,iparam)
    do pint = 1, Nintl
      param   = paramG(ipart,iparam,pint)
      pondere = weightsG(ipart,iparam,pint)
      call elem_geomLAY (TypeGeom, Npart, ipart, Nsurfmax, surf, param, iparam,     &
           r1, theta1, phi, dA, nn)
      ct = cos(theta1)
      r  = sqrt(r1**2 + zpart(ipart)**2 + 2._O * r1 * zpart(ipart) * ct)
      if (r < MachEps) r = MachEps
      theta = acos((zpart(ipart) + r1 * ct) / r)
      ct   = cos(theta1 - theta)
      st   = sin(theta1 - theta)
      n(1) = nn(1) * ct - nn(2) * st
      n(2) = nn(1) * st + nn(2) * ct
      n(3) = 0._O
      tamp = sqrt(n(1)**2 + n(2)**2)
      if (tamp < MachEps) then
        print "(/,2x,'Error in subroutine incident_matrix_LAY in module Proces2:')"
        print "(  2x,'the module of the normal unit vector is zero;')"
        stop
      end if
      n(1) = n(1) / tamp
      n(2) = n(2) / tamp
      zl   = cmplx(k * r,0.0,O)      
      call MN (1, zl, theta, m, Nrankpmax, Nmaxpmax, m1, n1)                                           
      call MN_poles_LAY (3, kc, r, theta, m_minus, ipart, Npart, Nrankp, Nmaxpmax,  &
           Nmaxp, zpart, m3, n3)                        
      fact =  f * dA * pondere
      call matQinc_m(m, Nmaxpmax, Nmaxpmax, fact, m3, n3, m1, n1, n, A, nap, map)      
    end do
  end do                   
  deallocate (m1, n1, m3, n3)      
end subroutine incident_matrix_LAY
!***********************************************************************************
subroutine matrix_Q31_DS_LAY (TypeGeom, k, ind_ref, Nsurfmax, surf, Npart,          &
           Nrankpmax, Nrankp, zRe, zIm, zpart, m, Nrank, Nint, Nparammax, Nparam,   &
           Nintparam, paramG, weightsG, AA, nap, map)
!------------------------------------------------------------------------------------
! The routine computes the Q(3,1) matrix of a layered particle for the azimuthal    !
! mode m. Distributed sources are used for calculation.                             !
!------------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: TypeGeom, m, Nsurfmax, Npart, Nrankpmax, Nrank, Nint, Nparammax,    &
                Nintparam(Npart,Nparammax), Nparam(Npart), Nrankp(Npart), nap, map
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), paramG(Npart,Nparammax,Nint),&
                weightsG(Npart,Nparammax,Nint), zRe(Npart,Nrankpmax),               &
                zIm(Npart,Nrankpmax)
  complex(O) :: ind_ref(Npart), AA(2*nap,2*map)
!      
  integer    :: i, j, ipart, Nrankl, Nrankc, Nl, Nc
  complex(O) :: kc, kl, index
  complex(O),allocatable :: a(:,:), b(:,:) 
!
  do i = 1, 2*Nrank
    do j = 1, 2*Nrank
      AA(i,j) = zero
    end do
  end do  
  do ipart = 1, Npart
    if (ipart == 1) then
      Nrankl = Nrankp(ipart)
      Nrankc = Nrankp(ipart) 
      allocate (a(2*Nrankl,2*Nrankc), b(2*Nrankl,2*Nrankc))         
      kl = cmplx(k,0.0,O)
      kc = k * ind_ref(ipart)
      if (abs(kl) < MachEps) kl = cmplx(MachEps,MachEps,O)
      index = kc / kl
      call auxmatrices_Q31_DS_LAY (TypeGeom, ipart, kl, kc, index, Npart+1,         &
           Nsurfmax, surf, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, m, Nint,      &
           Nparammax, Nparam, Nintparam, paramG, weightsG, Nrankl, Nrankc,          &
           22, a, Nrankl, Nrankc, b, Nrankl, Nrankc)
      do i = 1, 2*Nrankl
        do j = 1, 2*Nrankc
          AA(i,j) = a(i,j)
          AA(i,j+2*Nrankc) = b(i,j)
        end do
      end do
      deallocate (a, b)
      Nl = 2 * Nrankp(ipart)
      Nc = 0
    else
      Nrankl = Nrankp(ipart-1)
      Nrankc = Nrankp(ipart-1) 
      allocate (a(2*Nrankl,2*Nrankc), b(2*Nrankl,2*Nrankc))           
      kl = k * ind_ref(ipart-1) 
      kc = k * ind_ref(ipart-1)
      if (abs(kl) < MachEps) kl = cmplx(MachEps,MachEps,O)
      index = kc / kl
      call auxmatrices_Q31_DS_LAY (TypeGeom, ipart, kl, kc, index, Npart+1,         &
           Nsurfmax, surf, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, m, Nint,      &
           Nparammax, Nparam, Nintparam, paramG, weightsG, Nrankl, Nrankc,          &
           11, a, Nrankl, Nrankc, b, Nrankl, Nrankc)	
      do i = 1, 2*Nrankl
        do j = 1, 2*Nrankc
          AA(i+Nl,j+Nc) = zero
          AA(i+Nl,j+Nc+2*Nrankc) = b(i,j)
        end do
      end do
      deallocate (a, b)
      Nc = Nc + 4 * Nrankp(ipart-1)
!
      Nrankl = Nrankp(ipart-1)
      Nrankc = Nrankp(ipart) 
      allocate (a(2*Nrankl,2*Nrankc), b(2*Nrankl,2*Nrankc))      
      kl = k * ind_ref(ipart-1) 
      kc = k * ind_ref(ipart)
      if (abs(kl) < MachEps) kl = cmplx(MachEps,MachEps,O)
      index = kc / kl
      call auxmatrices_Q31_DS_LAY (TypeGeom, ipart, kl, kc, index, Npart,           &
           Nsurfmax, surf, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, m, Nint,      &
           Nparammax, Nparam, Nintparam, paramG, weightsG, Nrankl, Nrankc,          &
           12, a, Nrankl, Nrankc, b, Nrankl, Nrankc)
      do i = 1, 2*Nrankl
        do j = 1, 2*Nrankc
          AA(i+Nl,j+Nc) = a(i,j)
          if (ipart < Npart) AA(i+Nl,j+Nc+2*Nrankc) = b(i,j)
        end do   
      end do
      Nl = Nl + 2 * Nrankp(ipart-1)
      Nc = Nc - 4 * Nrankp(ipart-1)
      deallocate (a, b)
!
      Nrankl = Nrankp(ipart)
      Nrankc = Nrankp(ipart-1) 
      allocate (a(2*Nrankl,2*Nrankc), b(2*Nrankl,2*Nrankc))          
      kl = k * ind_ref(ipart-1) 
      kc = k * ind_ref(ipart-1)
      if (abs(kl) < MachEps) kl = cmplx(MachEps,MachEps,O)
      index = kc / kl
      call auxmatrices_Q31_DS_LAY (TypeGeom, ipart, kl, kc, index, Npart+1,         &
           Nsurfmax, surf, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, m, Nint,      &
           Nparammax, Nparam, Nintparam, paramG, weightsG, Nrankl, Nrankc,          &
           21, a, Nrankl, Nrankc, b, Nrankl, Nrankc)	              	     	  	  	       	     	     	     	      	   	   	   
      do i = 1, 2*Nrankl
        do j = 1, 2*Nrankc
          AA(i+Nl,j+Nc) = a(i,j)
          AA(i+Nl,j+Nc+2*Nrankc) = zero
        end do
      end do 
      Nc = Nc + 4 * Nrankp(ipart-1)
      deallocate (a, b)
!
      Nrankl = Nrankp(ipart)
      Nrankc = Nrankp(ipart) 
      allocate (a(2*Nrankl,2*Nrankc), b(2*Nrankl,2*Nrankc))         
      kl = k * ind_ref(ipart-1) 
      kc = k * ind_ref(ipart)
      if (abs(kl) < MachEps) kl = cmplx(MachEps,MachEps,O)
      index = kc / kl
      call auxmatrices_Q31_DS_LAY (TypeGeom, ipart, kl, kc, index, Npart,           &
           Nsurfmax, surf, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, m, Nint,      &
           Nparammax, Nparam, Nintparam, paramG, weightsG, Nrankl, Nrankc,          &
           22, a, Nrankl, Nrankc, b, Nrankl, Nrankc)
      do i = 1, 2 * Nrankl
        do j = 1, 2 * Nrankc
          AA(i+Nl,j+Nc) = a(i,j)
          if (ipart < Npart) AA(i+Nl,j+Nc+2*Nrankc) = b(i,j)
        end do
      end do  
      Nl = Nl + 2 * Nrankp(ipart)
      deallocate (a, b)       
    end if
  end do       
end subroutine matrix_Q31_DS_LAY
!***********************************************************************************
subroutine auxmatrices_Q31_DS_LAY (TypeGeom, ipart, kl, kc, index, Npartlim,        &
           Nsurfmax, surf, Npart, Nrankpmax, Nrankp, zRe, zIm, zpart, m, Nint,      &
           Nparammax, Nparam, Nintparam, paramG, weightsG, Nrankl, Nrankc, Block,   &
           a, nap, map, b, nbp, mbp)
!------------------------------------------------------------------------------------
! The routine computes the auxiliary matrices a and b used in the subroutine        !
! matrix_Q31_DS_LAY.                                                                !
!------------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: TypeGeom, ipart, Npartlim, m, Nsurfmax, Npart, Nrankpmax, Nint,     &
                Nparammax, Nintparam(Npart,Nparammax), Nparam(Npart), Nrankp(Npart),&
                Nrankl, Nrankc, Block, nap, map, nbp, mbp
  real(O)    :: surf(Npart,Nsurfmax), zpart(Npart), paramG(Npart,Nparammax,Nint),   &
                weightsG(Npart,Nparammax,Nint), zRe(Npart,Nrankpmax),               &
                zIm(Npart,Nrankpmax)
  complex(O) :: kl, kc, index, a(2*nap,2*map), b(2*nbp,2*mbp)
!      
  integer    :: i, j, pint, m_minus, iparam, Nintl, Nparaml, ipartl
  real(O)    :: r, theta, phi, dA, param, pondere, r1, theta1, n(3), nn(3), sign,   &
                tamp, ct, st
  complex(O) :: fact, f
  complex(O),allocatable :: m1(:,:), n1(:,:), m3(:,:), n3(:,:), m2(:,:), n2(:,:)
!
  allocate (m1(3,Nrankpmax), n1(3,Nrankpmax), m2(3,Nrankpmax), n2(3,Nrankpmax),     &
            m3(3,Nrankpmax), n3(3,Nrankpmax))  
  m_minus = - m 
  do i = 1, 2*Nrankl
    do j = 1, 2*Nrankc
      a(i,j) = zero
      b(i,j) = zero
    end do
  end do
  if (Block == 22 .or. Block == 12) then
    sign   = 1._O
    ipartl = ipart
  else if (Block == 11 .or. Block == 21) then
    sign   = - 1._O
    ipartl = ipart - 1
  end if                         
  Nparaml = Nparam(ipartl)
  f = sign * im * 2._O * kl * kl 
  do iparam = 1, Nparaml
    Nintl = Nintparam(ipartl,iparam)
    do pint = 1, Nintl
      param   = paramG(ipartl,iparam,pint)
      pondere = weightsG(ipartl,iparam,pint)
      call elem_geomLAY (TypeGeom, Npart, ipartl, Nsurfmax, surf, param, iparam,    &
           r1, theta1, phi, dA, nn)
      ct = cos(theta1)
      r  = sqrt(r1**2 + zpart(ipartl)**2 + 2._O * r1 * zpart(ipartl) * ct)
      if (r < MachEps) r = MachEps
      theta = acos((zpart(ipartl) + r1 * ct) / r)
      ct   = cos(theta1 - theta)
      st   = sin(theta1 - theta)
      n(1) = nn(1) * ct - nn(2) * st
      n(2) = nn(1) * st + nn(2) * ct
      n(3) = 0._O
      tamp = sqrt(n(1)**2 + n(2)**2)
      if (tamp < MachEps) then
        print "(/,2x,'Error in subroutine auxmatrices_Q31_DS_LAY in module Proces2:')"
        print "(  2x,'the module of the normal unit vector is zero;')"
        stop
      end if
      n(1) = n(1) / tamp 
      n(2) = n(2) / tamp
      if (Block == 22) then           
        call MN_DS_LAY (1, kc, r, theta, ipart, Npart, Nrankpmax, Nrankp, zRe, zIm,  &
             m, m1, n1)   
        call MN_DS_LAY (3, kc, r, theta, ipart, Npart, Nrankpmax, Nrankp, zRe, zIm,  &
             m, m2, n2)   
        call MN_DS_LAY (3, kl, r, theta, ipart, Npart, Nrankpmax, Nrankp, zRe, zIm,  &
             m_minus, m3, n3) 
      else if (Block == 11) then
       !call MN_DS_LAY (1, kc, r, theta, ipart-1, Npart, Nrankpmax, Nrankp, zRe, zIm,&
       !     m, m1, n1)   
        call MN_DS_LAY (3, kc, r, theta, ipart-1, Npart, Nrankpmax, Nrankp, zRe, zIm,&
             m, m2, n2)   
        call MN_DS_LAY (1, kl, r, theta, ipart-1, Npart, Nrankpmax, Nrankp, zRe, zIm,&
             m_minus, m3, n3) 
      else if (Block == 12) then
        call MN_DS_LAY (1, kc, r, theta, ipart, Npart, Nrankpmax, Nrankp, zRe, zIm,  &
             m, m1, n1)   
        call MN_DS_LAY (3, kc, r, theta, ipart, Npart, Nrankpmax, Nrankp, zRe, zIm,  &
             m, m2, n2)   
        call MN_DS_LAY (1, kl, r, theta, ipart-1, Npart, Nrankpmax, Nrankp, zRe, zIm,&
             m_minus, m3, n3) 
      else if (Block == 21) then
        call MN_DS_LAY (1, kc, r, theta, ipart-1, Npart, Nrankpmax, Nrankp, zRe, zIm,&
             m, m1, n1)   
       !call MN_DS_LAY (3, kc, r, theta, ipart-1, Npart, Nrankpmax, Nrankp, zRe, zIm,&
       !     m, m2, n2)   
        call MN_DS_LAY (3, kl, r, theta, ipart, Npart, Nrankpmax, Nrankp, zRe, zIm,  &
             m_minus, m3, n3) 
      end if
      fact = f * dA * pondere
      if (Block == 11) then
        call matQ_LAY_b (m, ipart, Npartlim, Nrankc, Nrankl, Nrankpmax, index, fact, & 
             m3, n3, m2, n2, n, b, nbp, mbp)            
      else if (Block == 21) then
        call matQ_LAY_a (m, Nrankc, Nrankl, Nrankpmax, index, fact, m3, n3, m1, n1,  &
           n, a, nap, map)            
      else 
        call matQ_LAY(m, ipart, Npartlim, Nrankc, Nrankl, Nrankpmax, index, fact,    &
             m3, n3, m2, n2, m1, n1, n, a, nap, map, b, nbp, mbp)       
      end if	     
    end do
  end do
  deallocate (m1, n1, m2, n2, m3, n3)
end subroutine auxmatrices_Q31_DS_LAY 
!***********************************************************************************
subroutine matrix_Q1_DS_LAY (TypeGeom, indexC, k, ind_ref, Nsurfmax, surf, Npart,   &
           Nrankpmax, Nrankp, zRe, zIm, zpart, m, NrankG, NmaxG, Nint, Nparammax,   &
           Nparam, Nintparam, paramG, weightsG, A, nap, map)
!------------------------------------------------------------------------------------
! The routine computes the Q(1,1) or the Q(1,3) matrices of a layered particle      !
! for the azimuthal mode m. Distributed sources are used for calculation.           !
!------------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: TypeGeom, m, Npart, Nsurfmax, Nrankpmax, Nrankp(Npart),             &
                NrankG, NmaxG, Nint, Nparammax, Nintparam(Npart,Nparammax),         &
                Nparam(Npart), indexC, nap, map
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), paramG(Npart,Nparammax,Nint),&
                weightsG(Npart,Nparammax,Nint), zRe(Npart,Nrankpmax),               &
                zIm(Npart,Nrankpmax) 
  complex(O) :: ind_ref(Npart), A(2*nap,2*map)
!            
  integer    :: i, j, pint, m_minus, iparam, Nintl, ipart, Nparaml
  real(O)    :: r, theta, phi, dA, param, pondere, r1, theta1, n(3), nn(3), tamp,   &
                ct, st
  complex(O) :: kc, zl, fact, f
  complex(O),allocatable :: m1(:,:), n1(:,:), m3(:,:), n3(:,:)  
!
  allocate (m1(3,Nrankpmax), n1(3,Nrankpmax), m3(3,NmaxG), n3(3,NmaxG))
  do i = 1, 2*NmaxG
    do j = 1, 2*Nrankpmax
      A(i,j) = zero
    end do
  end do
  m_minus = - m         
  ipart   =   1  
  Nparaml =   Nparam(ipart)
  kc = k * ind_ref(ipart)
  f  = im * 2._O * k * k 
  do iparam = 1, Nparaml
    Nintl = Nintparam(ipart,iparam)
    do pint = 1, Nintl
      param   = paramG(ipart,iparam,pint)
      pondere = weightsG(ipart,iparam,pint)
      call elem_geomLAY (TypeGeom, Npart, ipart, Nsurfmax, surf, param, iparam, r1, &
           theta1, phi, dA, nn)
      ct = cos(theta1)
      r  = sqrt(r1**2 + zpart(ipart)**2 + 2._O * r1 * zpart(ipart) * ct)
      if (r < MachEps) r = MachEps
      theta = acos((zpart(ipart) + r1 * ct) / r)
      ct   = cos(theta1 - theta)
      st   = sin(theta1 - theta)
      n(1) = nn(1) * ct - nn(2) * st
      n(2) = nn(1) * st + nn(2) * ct
      n(3) = 0._O
      tamp = sqrt(n(1)**2 + n(2)**2)
      if (tamp < MachEps) then
        print "(/,2x,'Error in subroutine matrix_Q1_DS_LAY in module Proces2:')"
        print "(  2x,'the module of the normal unit vector is zero;')"
        stop
      end if
      n(1) = n(1) / tamp
      n(2) = n(2) / tamp          
      if (indexC == 1) then      
        call MN_DS_LAY (1, kc, r, theta, ipart, Npart, Nrankpmax, Nrankp, zRe, zIm, &
             m, m1, n1)
      else     
        call MN_DS_LAY (3, kc, r, theta, ipart, Npart, Nrankpmax, Nrankp, zRe, zIm, &
             m, m1, n1)
      end if
      zl = cmplx(k * r,0.0,O)              
      call MN (1, zl, theta, m_minus, NrankG, NmaxG, m3, n3)
      fact = f * dA * pondere
      call matQ_COMP(m, Nrankpmax, NmaxG, ind_ref(ipart), fact, m3, n3, m1, n1,     &
           n, A, nap, map)       
    end do
  end do                     
  deallocate (m1, n1, m3, n3)     
end subroutine matrix_Q1_DS_LAY
!***********************************************************************************
subroutine incident_matrix_DS_LAY (TypeGeom, k, Nsurfmax, surf, Npart, Nrankpmax,   &
           Nrankp, zRe, zIm, zpart, m, NrankG, NmaxG, Nint, Nparammax, Nparam,      &
           Nintparam, paramG, weightsG, A, nap, map)
!-----------------------------------------------------------------------------------
! The routine computes the incident matrix of a layered particle using             !
! distributed sources.                                                             !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: TypeGeom, m, Nsurfmax, Npart, Nrankpmax, Nrankp(Npart), NrankG,     &
                NmaxG, Nint, Nparammax, Nparam(Npart), Nintparam(Npart,Nparammax),  &
                nap, map
  real(O)    :: k, surf(Npart,Nsurfmax), zpart(Npart), paramG(Npart,Nparammax,Nint),&
                weightsG(Npart,Nparammax,Nint), zRe(Npart,Nrankpmax),               &
                zIm(Npart,Nrankpmax)
  complex(O) :: A(2*nap,2*map)
!      
  integer    :: i, j, pint, m_minus, iparam, Nintl, ipart, Nparaml
  real(O)    :: r, theta, phi, dA, param, pondere, r1, theta1, n(3), nn(3), tamp,   &
                ct, st
  complex(O) :: kc, fact, zl, f
  complex(O),allocatable :: m1(:,:), n1(:,:), m3(:,:), n3(:,:) 
!
  allocate (m1(3,NmaxG), n1(3,NmaxG), m3(3,Nrankpmax), n3(3,Nrankpmax))
  kc = cmplx(k,0.0,O)
  do i = 1, 2*Nrankpmax
    do j = 1, 2*NmaxG
      A(i,j) = zero
    end do
  end do 
  m_minus = - m 
  ipart   =   1
  Nparaml =   Nparam(ipart)
  f = im * 2._O * k * k
  do iparam = 1, Nparaml
    Nintl = Nintparam(ipart,iparam)
    do pint = 1, Nintl
      param   = paramG(ipart,iparam,pint)
      pondere = weightsG(ipart,iparam,pint)
      call elem_geomLAY (TypeGeom, Npart, ipart, Nsurfmax, surf, param, iparam,     &
           r1, theta1, phi, dA, nn)
      ct = cos(theta1)
      r  = sqrt(r1**2 + zpart(ipart)**2 + 2._O * r1 * zpart(ipart) * ct)
      if (r < MachEps) r = MachEps 
      theta = acos((zpart(ipart) + r1 * ct) / r)
      ct   = cos(theta1 - theta)
      st   = sin(theta1 - theta)
      n(1) = nn(1) * ct - nn(2) * st
      n(2) = nn(1) * st + nn(2) * ct
      n(3) = 0._O
      tamp = sqrt(n(1)**2 + n(2)**2)
      if (tamp < MachEps) then
        print "(/,2x,'Error in subroutine incident_matrix_DS_LAY in module Proces2:')"
        print "(  2x,'the module of the normal unit vector is zero;')"
        stop
      end if
      n(1) = n(1) / tamp
      n(2) = n(2) / tamp
      zl   = cmplx(k * r,0.0,O)      
      call MN (1, zl, theta, m, NrankG, NmaxG, m1, n1)                                                           
      call MN_DS_LAY (3, kc, r, theta, ipart, Npart, Nrankpmax, Nrankp, zRe, zIm,    &
           m_minus, m3, n3)                   
      fact = f * dA * pondere
      call matQinc_m(m, NmaxG, Nrankpmax, fact, m3, n3, m1, n1, n, A, nap, map)       
    end do
  end do
  deallocate (m1, n1, m3, n3)      
end subroutine incident_matrix_DS_LAY

! **********************************************************************************
! *                       RANDOM DISTRIBUTION OF PARTICLES                         * 
! *    ------------------------------------------------------------------------    *
! *    Partial list of subroutines:                                                *
! *      SphConfig,  SeqAddMet,  RANSLATEC,  RANLAP,  RANZIG,  readinputRND        *
! **********************************************************************************
subroutine SphConfig (Ntry, Npart, Ncs, Npartcs, r, Rcs, xp, yp, zp)
!-----------------------------------------------------------------------------------
! The routine generates a random distribution of particles using the sequential    !
! addition method.                                                                 !
!                                                                                  !
! Input parameters:                                                                !
! - Ntry (integer) - maximum number of calls of the sequential addition method     !
!   routine for generating the desired random distribution of particles.           !
! - Npart (integer) - number of particles.                                         !
! - Ncs (integer) - number of concentric (auxiliary) spheres.                      !
! - r (real) - particle radius.                                                    !
! - Rcs (real array) - radii of auxiliary spheres.                                 !
!                                                                                  !
! Output parameters:                                                               !
! - Npartcs (integer array) - number of particles inside each auxiliary            !
!   sphere.                                                                        !
! - xp, yp, zp (real arrays) - Cartesian coordinates of the particles.             !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer       :: Ntry, Npart, Ncs, Npartcs(Ncs)
  real(O)       :: r, Rcs(Ncs), xp(Ncs,Npart), yp(Ncs,Npart), zp(Ncs,Npart)
!  
  integer       :: i, ics
  real(O)       :: Rcirc, d 
  character(20) :: TypeRND
  real(O),allocatable :: x(:), y(:), z(:)
!                 
  Rcirc = Rcs(Ncs) - r 
  allocate (x(Npart), y(Npart), z(Npart))
  call readinputRND (TypeRND)
  call SeqAddMet (TypeRND, Ntry, Npart, Rcirc, r, x, y, z)
  do ics = 1, Ncs
    Npartcs(ics) = 0
  end do  
  do i = 1, Npart
    d = sqrt(x(i)**2 + y(i)**2 + z(i)**2)       
    if (d < Rcs(1)) then
      Npartcs(1) = Npartcs(1) + 1      
      xp(1,Npartcs(1)) = x(i) 
      yp(1,Npartcs(1)) = y(i)
      zp(1,Npartcs(1)) = z(i)
    end if
    do ics = 2, Ncs       
      if (d >= Rcs(ics-1) .and. d < Rcs(ics)) then
        Npartcs(ics) = Npartcs(ics) + 1      
        xp(ics,Npartcs(ics)) = x(i) 
        yp(ics,Npartcs(ics)) = y(i)
        zp(ics,Npartcs(ics)) = z(i)
      end if
    end do              
  end do    
  deallocate (x, y, z)  
end subroutine SphConfig
! ************************************************************************************
subroutine readinputRND ( TypeRND ) 
  use parameters
  implicit none
  integer       :: ios   
  character(20) :: TypeRND    
  character(80) :: string
  logical       :: XFindPar
!
  open (unit = iInput, file = FileInput, status = "old", position = "rewind")  
  TypeRND = 'SLAT'
  string  = 'RandomNumbers'
  if (XFindPar (iInput, string)) then
    read (iInput, *, iostat = ios) TypeRND
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable TypeRND;')"
      stop
    end if
  else
    print "(/,2x,'Group name TypeRND not found;')"
    stop  
  end if  
  call check_Random (TypeRND)   
  close (unit = iInput)   
end subroutine readinputRND   
! **********************************************************************************
subroutine SeqAddMet (TypeRND, Ntry, Npart, Rcirc, r, x, y, z)
  use parameters  
  implicit none
  integer       :: Ntry, Npart
  real(O)       :: r, Rcirc, x(Npart), y(Npart), z(Npart)
  character(20) :: TypeRND
!  
  integer       :: i, itry, j, idum
  real(O)       :: RANSLATEC, RANLAP, RANZIG, u, v, w, diam, d 
  logical       :: tryagain, overlap, out
  integer       :: iseed(4)
!  
  if (TypeRND(1:4) == 'LPCK') then      
    iseed(1) = 11
    iseed(2) = 22
    iseed(3) = 33
    iseed(4) = 44
  else if (TypeRND(1:4) == 'ZIGG') then
    idum = - 15    
  end if       
  diam  = 2._O * r
  do i = 1, Npart
    tryagain = .true.
    itry     = 0
    do while (tryagain)
      itry = itry + 1                                               
      if (TypeRND(1:4) == 'SLAT') then                                                            
        u = RANSLATEC (0._O)                   
        v = RANSLATEC (0._O)      
        w = RANSLATEC (0._O)           
      else if (TypeRND(1:4) == 'LPCK') then
        u = RANLAP (iseed)                  
        v = RANLAP (iseed)
        w = RANLAP (iseed)
      else if (TypeRND(1:4) == 'ZIGG') then
        u = RANZIG (idum)                   
        v = RANZIG (idum)
        w = RANZIG (idum)		
      end if	            	 	      
      x(i) = Rcirc * (2._O * u - 1._O)
      y(i) = Rcirc * (2._O * v - 1._O)
      z(i) = Rcirc * (2._O * w - 1._O)
      overlap = .false.        
      if (i > 1) then
        do j = 1, i - 1
          d = sqrt((x(i) - x(j))**2 + (y(i) - y(j))**2 + (z(i) - z(j))**2)
          if (d < diam) overlap = .true.             
        end do
      end if
      out = .false.
      d   = sqrt(x(i)**2 + y(i)**2 + z(i)**2)
      if (d > Rcirc) out = .true.
      if ((.not.out .and. .not.overlap) .or. (itry == Ntry)) tryagain = .false.
    end do  
    if ((out .or. overlap) .and. (itry == Ntry)) then
      print "(/,2x,'Error in subroutine SeqAddMet:')"
      print "(  2x,'the integer Ntry is too low for the desired configuration;')"     
      stop      
    end if
  end do
end subroutine SeqAddMet
! ***********************************************************************************
! *                          RANDOM NUMBER GENERATORS                               *
! *********************************************************************************** 
function RANSLATEC (r) result (rand)
!-----------------------------------------------------------------------------------
! Linear Congruential Generator (modified routine from Slatec library)             !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  real(O) :: r, rand
!  
  integer           :: iy0, iy1  
  integer,parameter :: ia1 = 1536, ia0 = 1029, ia1ma0 = 507, ic = 1731, ib = 2048
  integer,save      :: ix1 = 0,    ix0 = 0     
!        
  if (r == 0._O) then
    iy0 = ia0 * ix0
    iy1 = ia1 * ix1 + ia1ma0 * (ix0 - ix1) + iy0
    iy0 = iy0 + ic
    ix0 = mod (iy0, ib)
    iy1 = iy1 + (iy0 - ix0) / ib
    ix1 = mod (iy1, ib)        
  else if (r > 0._O) then
    ix1 = mod(r,1._O) * 4194304._O + 0.5_O
    ix0 = mod(ix1, ib)
    ix1 = (ix1 - ix0) / ib		
  end if      
  rand = ix1 * ib + ix0
  rand = rand / 4194304._O
end function RANSLATEC
! **********************************************************************************
function RANLAP (iseed) result (rand)
!-----------------------------------------------------------------------------------
! Modified routine from Lapack library                                             !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer  :: iseed(4)
  real(O)  :: rand
!
  integer,parameter :: m1 = 494, m2 = 322, m3 = 2508, m4 = 2549, ipw2 = 4096
  real(O),parameter :: r = 1._O / ipw2
  integer           :: it1, it2, it3, it4  
!        
  it4 = iseed(4) * m4
  it3 = it4 / ipw2
  it4 = it4 - ipw2 * it3
  it3 = it3 + iseed(3) * m4 + iseed(4) * m3
  it2 = it3 / ipw2
  it3 = it3 - ipw2 * it2
  it2 = it2 + iseed(2) * m4 + iseed(3) * m3 + iseed(4) * m2
  it1 = it2 / ipw2
  it2 = it2 - ipw2 * it1
  it1 = it1 + iseed(1) * m4 + iseed(2) * m3 + iseed(3) * m2 + iseed(4) * m1
  it1 = mod(it1,ipw2)
!
  iseed(1) = it1
  iseed(2) = it2
  iseed(3) = it3
  iseed(4) = it4
!
  rand = r * (real(it1,O) + r * (real(it2,O) + r * (real(it3,O) + r * (real(it4,O)))))
end function RANLAP      
! **********************************************************************************
function RANZIG (jsr) result (rand)
!-----------------------------------------------------------------------------------
! Ziggurat method (routine of Marsaglia and Tsang                                  !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer   :: jsr, jz, ival
  real(O)   :: rand

  jz   = jsr
  jsr  = IEOR( jsr, ISHFT( jsr,  13 ) )
  jsr  = IEOR( jsr, ISHFT( jsr, -17 ) )
  jsr  = IEOR( jsr, ISHFT( jsr,   5 ) )
  ival = jz + jsr
!
  rand = 0.5_O + 0.2328306e-9_O * ival  
end function RANZIG  
  
  
  
  
  
  
  
  
  
  
  
    

subroutine SCTAVRGSPH
!------------------------------------------------------------------------------------ 
! 1. General Considerations                                                         !
! --------------------------                                                        !     
! The routine computes the scattering characteristics of an ensemble of             !
! polydisperse, homogeneous spherical particles. The external excitation is a       !
! vector plane wave propagating along the Z-axis of the global coordinate system    !
! and the scattering plane is the XZ-plane. The code computes the following average !
! quantities:                                                                       ! 
! - the extinction and scattering cross sections,                                   !
! - the asymmetry parameter,                                                        ! 
! - the scattering matrix at a set of NthetaAvrg scattering angles,                 !
! - the differential scattering cross sections (DSCS) at a set of NthetaGSAvrg      !
!   scattering angles and for a specified incident polarization state               !
!   (alphapAvrg).                                                                   !
! The scattering matrix is computed at scattering angles which are uniformly        !
! spaced in the interval (thetaminAvrg, thetamaxAvrg), while the differential       !
! scattering cross sections are computed at scattering angles which are uniformly   !
! spaced in the interval (0, 180°).                                                 !
!                                                                                   !
! The basic optical characteristics of a homogeneous spherical particles can be     !
! directly expressed in terms of the Lorenz-Mie coefficients Fn and Gn, and         !
! simple formulas are available for the average quantities. For example, the        !
! average scattering cross section is given by                                      !
!                                                                                   ! 
!                       2*Pi                                                        !
!              Cscat = ------ SUM { (2n + 1) * [<|Fn|**2> + <|Gn|**2>] }            !
!                       k**2                                                        !
!                                                                                   !
! and the the scattering efficiency by                                              !
!                                                                                   ! 
!                         Cscat                                                     ! 
!              Qscat = -------------,                                               ! 
!                       Pi*anorm**2                                                 !
!                                                                                   !
! where anorm is the normalization length and k is the wave number. The average     !
! extinction cross section can be computed as                                       !
!                                                                                   !           
!                         2*Pi                                                      !
!               Cext = - ------ RE { SUM { (2n + 1) * [<Fn> + <Gn>] }}              !
!                         k**2                                                      !
!                                                                                   !
! and the the extinction efficiency as                                              !
!                                                                                   !
!                          Cext                                                     !
!               Qext = -------------.                                               !
!                       Pi*anorm**2                                                 !
!                                                                                   !
! The average asymmetry parameter is given by                                       ! 
!                                                                                   !
!                          2*Pi                                                     !
!                  g = ------------ RE{ SUM { a(n) * [<Fn * conjg(Fn+1)             ! 
!                       Cscat*k**2                                                  !
!                      + Gn * conjg(Gn+1)>] + b(n) * < Fn * conjg(Gn) > } },        !
!                                                                                   !
! where                                                                             !
!                       n * (n + 2)                                                 !
!               a(n) = -------------,                                               !
!                          n + 1                                                    !
! and                                                                               !
!                        2 * n + 1                                                  !
!               b(n) = -------------.                                               ! 
!                       n * (n + 1)                                                 !
!                                                                                   !
! The following analytical size distribution are considered:                        !
! - the modified gamma distribution                                                 !
!                                                                                   !    
!         n(a) ~ exp { alpha * log(a) - alpha * (a / ac)**gamma / gamma },          !
!                                                                                   !
! - the log normal distribution                                                     !
!                                                                                   !
!         n(a) ~ exp { - log(a) - 0.5_O * (log(a/ag) / log(sg))**2 },               !
!                                                                                   ! 
! - the gamma distribution                                                          !
!                                                                                   !
!         n(a) ~ exp {(1._O - 3._O * gamma) * log(a) / gamma - a / alpha / gamma }, !
!                                                                                   !
! - the power law distribution                                                      !
!                                                                                   !
!         n(a)  ~   exp { - alpha * log(a) },                                       !
!                                                                                   !
! - the modified bimodal log normal distribution                                    !
!                                                                                   !
!         n(a)  ~ exp { - 4._O * log(a) - 0.5_O * (log(a/ag)  / log(sg))**2 }       !
!                 + gamma * exp { - 4._O * log(a) - 0.5_O * (log(a/ag1)             !
!                 / log(sg1))**2},                                                  !
!                                                                                   !
! where a is the particle radii and alpha, gamma, ag, sg, ag1 and sg1 are the       !
! parameters of the size distributions. The constant for each size distribution     !
! is chosen such that the size distribution satisfies the normalization             !
! condition. For analytical size distributions, the particle radii varies           !
! between zero and infinity. In the code, we consider truncated size                !
! distributions, i.e., the particle radii varies in the interval (amin, amax).      !
! The numerical integration of scattering characteristics over a size               !
! distribution is performed with Simpson's rule and the number of integration       !
! points Nint must be an odd number.                                                !
!                                                                                   !
! The code also computes the following characteristics of the size distribution:    !
! - the effective radius                                                            !
!                                                                                   !
!         a_eff = < a * Pi * a**2 > / area_avrg,                                    !
!                                                                                   !
! - the effective variance                                                          !
!                                                                                   ! 
!         v_eff = < (a - aeff)**2 * Pi * a**2 > / (area_avrg * aeff**2>),           !
!                                                                                   !
! - the average area of the geometric projection                                    !
!                                                                                   !
!         area_avrg  = < Pi * a**2 >,                                               !
!                                                                                   !
! - the average radius                                                              !
!                                                                                   !
!         a_avrg = < a >,                                                           !
!                                                                                   ! 
! - the average volume                                                              !
!                                                                                   !
!         v_avrg = < 4/3 * Pi * a**3 >,                                             !
!                                                                                   ! 
! - the volume-weighted average radius                                              !
!                                                                                   !
!         avw_avrg = < a * 4/3 * Pi * a**3 > / v_avrg.                              ! 
!                                                                                   !
! The average quantities are expressed in terms of three average quantities         !
! <S_pq(e_r,e_z) S_p1q1(e_r,e_z)*>, where S_pq are the elements of the              ! 
! amplitude matrix, e_r is the unit vector along the scattering direction           !
! (theta,0) and e_z is the unit vector along the Z axis. The average quantities     !
! are computed at NthetaGSAvrg scattering angles, which are uniformly spaced in     !  
! the interval (0,180°). The scattering matrix is computed at the same sample       !
! angles and polynomial interpolation is used to evaluate the scattering matrix     ! 
! at any zenith angle theta (in the range (thetaminAvrg, thetamaxAvrg)). The        !
! same scattering angles are used for computing the DSCS and the average            !
! quantities <S_pq S_p1q1*>.                                                        !
!                                                                                   !
! 2. Input Parameters                                                               !
! --------------------                                                              !
! The input parameters specified in the file "/INPUTFILES/InputSCTAVRGSPH.dat"      !
! are listed below.                                                                 !
!                                                                                   !
! - wavelength (real) - wavelenght of the ambient medium.                           !
!                                                                                   !
! - ind_ref (complex) - refractive index of the spherical particles.                !
!                                                                                   !
! - anormAvrg (real) - characteristic length of the ensemble which is used          !
!   to normalize the average differential scattering cross sections.                !
!                                                                                   ! 
! - TypeDist (integer) - specifies the type of the size distribution. The           !
!   permissive values are:                                                          !
!   - 1 for the modified gamma distribution,                                        !
!   - 2 for the log normal distribution,                                            !
!   - 3 for the gamma distribution,                                                 !
!   - 4 for the power law distribution,                                             !   
!   - 5 for the modified bimodal log normal distribution.                           !
!                                                                                   ! 
! - amin, amax (real variables) - specify the minimal and maximal values of the     !
!   particle radii for the truncated size distributions. These values are the       !  
!   integration limits for particle size averaging.                                 !
!                                                                                   !
! - Npar (integer) - number of parameters characterizing the size distributions.    !
!   The permissive values are:                                                      !
!   - 3 for the modified gamma distribution,                                        !
!   - 2 for the log normal distribution,                                            !
!   - 2 for the gamma distribution,                                                 !
!   - 1 for the power law distribution,                                             !   
!   - 5 for the modified bimodal log normal distribution.                           !
!                                                                                   ! 
! - par (real array) - parameters of the size distributions. The significance of    !
!   the parameters is as follows:                                                   !
!   - par(1) = alpha, par(2) = gamma and par(3) = ac for the modified gamma         !
!     distribution,                                                                 !
!   - par(1) = ag and par(2) = sg for the log normal distribution,                  !
!   - par(1) = alpha and par(2) = gamma for the gamma distribution,                 !
!   - par(1) = alpha for the power law distribution,                                !  
!   - par(1) = ag, par(2) = sg, par(3) = ag1, par(4) = sg1 and par(5) = gamma       !
!     for the modified bimodal log normal distribution.                             !
!                                                                                   !
! - Nint (integer) - number of integration points for the numerical integration     !
!   of the scattering characteritics over a size distribution. Because the          !
!   numerical integration is performed with Simpson's rule, Nint should be an       !
!   ODD number.                                                                     !
!                                                                                   !
! - alphapAvrg (real) - polarization angle of the incident wave. In general, if     ! 
!  (e_r,e_theta,e_phi) are the spherical unit vectors of the incident               !
!   direction (thetaGI,phiGI), then alphapAvrg is the angle between the electric    ! 
!   field vector and the unit vector e_theta. In the present case, the incident     !
!   direction is (0,0) and alphapAvrg is the angle between the electric field       !
!   vector and the X-axis of the global coordinate system. This parameter is        !
!   used for computing the average differential scattering cross sections.          !
!                                                                                   !
! - ComputeDSCSAvrg (logical) - if ComputeDSCSAvrg = t, the average differential    ! 
!   scattering cross sections are computed in the azimuthal plane phi = 0°.         !
!                                                                                   !
! - NthetaGSAvrg (integer) - number of zenith angles at which the average           !
!   differential scattering cross section are computed. The scattering angles       !
!   are uniformly spaced in the interval (0, 180°).                                 !
!                                                                                   !
! - normalizedAvrg (logical) - if normalizedAvrg = t, the average differential      ! 
!   scattering cross section are normalized by Pi * anormAvrg**2, where             !
!   anormAvrg is the characteristic lenght of the ensemble.                         !
!                                                                                   !
! - FileDSCSAvrg (character(80)) - name of the file to which the average            !
!   differential scattering cross sections are written.                             !
!                                                                                   !
! - ComputeScatParAvrg (logical) - if ComputeScatParAvrg = t, the scattering        !
!   characteristics are computed at specified scattering directions.                !
!   The following average quantities are computed: the extinction and               !
!   scattering cross sections, the asymmetry parameter and the scattering           !
!   matrix at NthetaAvrg scattering angles.                                         !
!                                                                                   !
! - NthetaAvrg (integer) - number of zenith angle values in the interval            !
!  (thetaminAvrg, thetamaxAvrg) at which the scattering matrix is computed.         !
!   The zenith angles are uniformly spaced.                                         !    
!                                                                                   !
! - thetaminAvrg, thetamaxAvrg (real variables) - specify the minimal and           !
!   maximal values of the zenith angle theta at which the scattering matrix         !
!   is computed.                                                                    !
!                                                                                   !
! - FileSCATAvrg (character(80)) - name of the file to which the scattering         !
!   characteristics are written.                                                    !
!                                                                                   ! 
! - PrnProgress (logical) - if PrnProgress = t, the progress of calculation         ! 
!   is printed.                                                                     !
!                                                                                   !  
! - WriteInputInfo (logical) - if WriteInputInfo = t, the input parameters of       !
!   the scattering problem are written to the output files FileDSCSAvrg and         !
!   FileSCATAvrg.                                                                   !
!------------------------------------------------------------------------------------
  use parameters
  implicit none
  integer       :: TypeDist, Nrank, NthetaGSAvrg, NthetaAvrg, Nint, Npar, i                   
  real(O)       :: wavelength, k, anormAvrg, snormAvrg, Cext, Cscat, Qext, Qscat,   &
                   AsymPar, thetaGS, Z(4,4), alphapAvrg, amin, amax, par(NparPD),   &
                   Cnst, thetaminAvrg, thetamaxAvrg, dtheta, AvrgArea, EffRadius,   &
                   AvrgRadius, AvrgVolume, VWAvrgRadius, EffVar
  complex(O)    :: ind_ref
  character(80) :: FileDSCSAvrg, FileScatAvrg 
  logical       :: ComputeDSCSAvrg, normalizedAvrg, ComputeScatParAvrg,             &
                   PrnProgress, WriteInputInfo
  real(O),allocatable    :: ZE(:,:)
  complex(O),allocatable :: SS(:,:)
! -----------------------------------------------------------------------------------
!                               Read the input file                                 !
! -----------------------------------------------------------------------------------
  call readinputSCTAVRGSPH ( wavelength, ind_ref, anormAvrg, TypeDist,              &
       amin, amax, Npar, par, Nint, alphapAvrg, ComputeDSCSAvrg, NthetaGSAvrg,      &
       normalizedAvrg, FileDSCSAvrg, ComputeScatParAvrg, NthetaAvrg,                &
       thetaminAvrg, thetamaxAvrg, FileScatAvrg, PrnProgress, WriteInputInfo,       &
       k, snormAvrg, Nrank, Cnst, AvrgArea, EffRadius, AvrgRadius, AvrgVolume,      &
       VWAvrgRadius, EffVar ) 
! -----------------------------------------------------------------------------------
!                                       Main                                        !
! -----------------------------------------------------------------------------------       
  print "(/,2x,'Scattering Characteristics of an Ensemble of Spheres')"
  print "(  2x,'----------------------------------------------------',/)"     
  allocate (SS(3,NthetaGSAvrg))        
  if (PrnProgress)                                                                  &
      print "(/,2x,'progress of main calculation for the average matrix <SS*>:')"    
  call SijSCpqSPH (k, ind_ref, amin, amax, TypeDist, Npar, par, Cnst, Nrank,        &
       Nint, NthetaGSAvrg, SS, PrnProgress)                   
  call AvCscatCextSPH (k, snormAvrg, ind_ref, amin, amax, TypeDist, Npar, par,      &
       Cnst, Nrank, Nint, Cext, Cscat, Qext, Qscat, AsymPar)
  if (ComputeDSCSAvrg) then     
    open (unit = iDSCS, file = FileDSCSAvrg, status = "replace")                         
    if (WriteInputInfo) call inputDSCS_SCATAvrgSPH (.true., amin, amax, TypeDist,   &
                             Npar, par, Nrank, Nint, alphapAvrg, wavelength,        &
                             anormAvrg, normalizedAvrg)
    call DiffScatCrossSectAvrgSPH (anormAvrg, alphapAvrg, NthetaGSAvrg, SS,         &
         normalizedAvrg, Cext, Cscat, Qext, Qscat)                                                                             
    close (unit = iDSCS)                       
  end if        
  if (ComputeScatParAvrg) then
    if (NthetaAvrg /= 1) then
      dtheta = (thetamaxAvrg - thetaminAvrg) / (NthetaAvrg - 1)
    else
      dtheta = 0._O
    end if
    open (unit = iSCAT, file = FileScatAvrg, status = "replace")
    if (WriteInputInfo) call inputDSCS_SCATAvrgSPH (.false., amin, amax, TypeDist,  &
                             Npar, par, Nrank, Nint, alphapAvrg, wavelength,        &
                             anormAvrg, normalizedAvrg)     
    allocate (ZE(4,NthetaGSAvrg))
    call ExtendedScatteringMatrixSPH (NthetaGSAvrg, SS, ZE)     
    do i = 1, NthetaAvrg
      thetaGS = thetaminAvrg + (i - 1) * dtheta                        
      call ScatteringMatrixSPH (thetaGS, NthetaGSAvrg, ZE, Z)
      call write_ScatMatrixAvrg (thetaGS, Z, i, Cscat, Cext, Qscat, Qext, AsymPar,  &
           AvrgArea, EffRadius, AvrgRadius, AvrgVolume, VWAvrgRadius, EffVar)
    end do                   
    close (unit = iSCAT)                                         
    deallocate (ZE)                                      
  end if  
  deallocate (SS)            
end subroutine SCTAVRGSPH
!***********************************************************************************
subroutine readinputSCTAVRGSPH ( wavelength, ind_ref, anormAvrg, TypeDist,          &
           amin, amax, Npar, par, Nint, alphapAvrg, ComputeDSCSAvrg, NthetaGSAvrg,  &
           normalizedAvrg, FileDSCSAvrg, ComputeScatParAvrg, NthetaAvrg,            &
           thetaminAvrg, thetamaxAvrg, FileScatAvrg, PrnProgress, WriteInputInfo,   &
           k, snormAvrg, Nrank, Cnst, AvrgArea, EffRadius, AvrgRadius, AvrgVolume,  &
           VWAvrgRadius, EffVar )
  use parameters
  use derived_parameters
  implicit none
  integer       :: TypeDist, Nrank, NthetaGSAvrg, NthetaAvrg, Nint, Npar, i, ios                   
  real(O)       :: wavelength, k, anormAvrg, xnorm, snormAvrg, xmax, alphapAvrg,    &
                   amin, amax, par(NparPD), Cnst, thetaminAvrg, thetamaxAvrg, grd,  &
                   AvrgArea, EffRadius, AvrgRadius, AvrgVolume, VWAvrgRadius, EffVar
  complex(O)    :: ind_ref
  character(80) :: FileDSCSAvrg, FileScatAvrg, string 
  logical       :: ComputeDSCSAvrg, normalizedAvrg, ComputeScatParAvrg,             &
                   PrnProgress, WriteInputInfo, XFindPar
! -----------------------------------------------------------------------------------
!                        Read the input file FileInputSCTAVRGSPH                    !
! -----------------------------------------------------------------------------------
  call DrvParameters   
  open (unit = iInputSCTAVRGSPH, file = FileInputSCTAVRGSPH, status = "old",        &
        position = "rewind")   
  wavelength = 0.1_O * 2._O * Pi  
  string     = 'OptProp'
  if (XFindPar (iInputSCTAVRGSPH, string)) then
    read (iInputSCTAVRGSPH, *, iostat = ios) wavelength
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if            
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if  
  k = 2._O * Pi / wavelength
!
  ind_ref = (1.5_O,0._O)
  string  = 'Tmat'
  if (XFindPar (iInputSCTAVRGSPH, string)) then
    read (iInputSCTAVRGSPH, *, iostat = ios) ind_ref
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_ref;')"
      stop
    end if            
  else
    print "(/,2x,'Group name Tmat not found;')"
    stop  
  end if  
  call check_ind_ref (ind_ref) 
!
  anormAvrg = 1._O
  string    = 'GeomProp'
  if (XFindPar (iInputSCTAVRGSPH, string)) then
    read (iInputSCTAVRGSPH, *, iostat = ios) anormAvrg
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anormAvrg;')"
      stop
    end if            
  else
    print "(/,2x,'Group name GeomProp not found;')"
    stop  
  end if  
  call check_anorm (anormAvrg)             
  xnorm     = k * anormAvrg
  snormAvrg = Pi * xnorm * xnorm  
!
  TypeDist = 1
  amin = 1._O
  amax = 20._O
  Npar = 3
  do i = 1, NparPD
    par(i) = 1._O
  end do
  Nint   = 181
  string = 'SizeDst'
  if (XFindPar (iInputSCTAVRGSPH, string)) then
    read (iInputSCTAVRGSPH, *, iostat = ios) TypeDist
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable TypeDist;')"
      stop
    end if
    read (iInputSCTAVRGSPH, *, iostat = ios) amin
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable amin;')"
      stop
    end if
    read (iInputSCTAVRGSPH, *, iostat = ios) amax
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable amax;')"
      stop
    end if
    read (iInputSCTAVRGSPH, *, iostat = ios) Npar
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Npar;')"
      stop
    end if
    do i = 1, Npar
      read (iInputSCTAVRGSPH, *, iostat = ios) par(i)
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable par;')"
        stop
      end if
    end do
    read (iInputSCTAVRGSPH, *, iostat = ios) Nint
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nint;')"
      stop
    end if
  else
    print "(/,2x,'Group name SizeDst not found;')"
    stop  
  end if 
  call check_inputSCTAVRGSPH (amin, amax, TypeDist, Npar)
  call check_NSimpson (Nint)
  xmax  = k * amax
  Nrank = int(xmax + 4.05_O * xmax**0.33_O + 2._O)                  
  call GeometryPars (amin, amax, TypeDist, Npar, par, Nint, Cnst, AvrgArea,         &
       EffRadius, AvrgRadius, AvrgVolume, VWAvrgRadius, EffVar)
!
  alphapAvrg = 45._O
  string     = 'IncWaveAvrg'
  if (XFindPar (iInputSCTAVRGSPH, string)) then
    read (iInputSCTAVRGSPH, *, iostat = ios) alphapAvrg
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable alphapAvrg;')"
      stop
    end if            
  else
    print "(/,2x,'Group name IncWaveAvrg not found;')"
    stop  
  end if  
  call check_polarization_angle (alphapAvrg)
  grd = Pi / 180._O
  alphapAvrg = alphapAvrg * grd
!
  ComputeDSCSAvrg = .true. 
  NthetaGSAvrg    = 91 
  normalizedAvrg  = .true. 
  FileDSCSAvrg    = '../OUTPUTFILES/dscsavrg_sph.dat'
  string          = 'DSCSAvrg'
  if (XFindPar (iInputSCTAVRGSPH, string)) then
    read (iInputSCTAVRGSPH, *, iostat = ios) ComputeDSCSAvrg
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ComputeDSCSAvrg;')"
      stop
    end if 
    read (iInputSCTAVRGSPH, *, iostat = ios) NthetaGSAvrg
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable NthetaGSAvrg;')"
      stop
    end if
    read (iInputSCTAVRGSPH, *, iostat = ios) normalizedAvrg
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable normalizedAvrg;')"
      stop
    end if
    read (iInputSCTAVRGSPH, *, iostat = ios) FileDSCSAvrg
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileDSCSAvrg;')"
      stop
    end if
  else
    print "(/,2x,'Group name DSCSAvrg not found;')"
    stop  
  end if 
!
  ComputeScatParAvrg = .true.
  NthetaAvrg    = 1
  thetaminAvrg  = 72._O 
  thetamaxAvrg  = 72._O    
  FileScatAvrg  = '../OUTPUTFILES/scat_avrg_sph.dat'
  string        = 'ScatParAvrg'
  if (XFindPar (iInputSCTAVRGSPH, string)) then
    read (iInputSCTAVRGSPH, *, iostat = ios) ComputeScatParAvrg
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ComputeScatParAvrg;')"
      stop
    end if 
    read (iInputSCTAVRGSPH, *, iostat = ios) NthetaAvrg 
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable NthetaAvrg;')"
      stop
    end if
    read (iInputSCTAVRGSPH, *, iostat = ios) thetaminAvrg
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable thetaminAvrg;')"
      stop
    end if
    read (iInputSCTAVRGSPH, *, iostat = ios) thetamaxAvrg
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable thetamaxAvrg;')"
      stop
    end if
    read (iInputSCTAVRGSPH, *, iostat = ios) FileScatAvrg
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileScatAvrg;')"
      stop
    end if
  else
    print "(/,2x,'Group name ScatParAvrg not found;')"
    stop  
  end if         
  call check_tetaminmax (thetaminAvrg, thetamaxAvrg, NthetaAvrg)
  thetaminAvrg = thetaminAvrg * grd
  thetamaxAvrg = thetamaxAvrg * grd
!
  PrnProgress    = .true.
  WriteInputInfo = .true.
  string         = 'PrintInfo'
  if (XFindPar (iInputSCTAVRGSPH, string)) then
    read (iInputSCTAVRGSPH, *, iostat = ios) PrnProgress
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if 
    read (iInputSCTAVRGSPH, *, iostat = ios) WriteInputInfo
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable WriteInputInfo;')"
      stop
    end if
  else
    print "(/,2x,'Group name PrintInfo not found;')"
    stop  
  end if        
  close (unit = iInputSCTAVRGSPH)
end subroutine readinputSCTAVRGSPH

!***********************************************************************************
subroutine printinputNONAXSYM (FileGeom, TypeGeom, FileFEM, Nsurf, Nparam,          &
           Nazimutsym, dNint1, dNint2, ind_refMed, wavelength, anorm, Rcirc, surf,  &
           kb, epsNint, epsNrank, epsMrank, ind_refRel, ind_refRelZ, alphaPR,       &
           betaPR, anisotropic, miror, perfectcond, chiral)
  use parameters
  implicit none
  integer        :: TypeGeom, Nsurf, Nparam, Nazimutsym, dNint1, dNint2, i, LenString                     
  real(O)        :: ind_refMed, wavelength, anorm, surf(Nsurf), kb, epsNint,        &
                    epsNrank, epsMrank, Rcirc, alphaPR, betaPR
  complex(O)     :: ind_refRel, ind_refRelZ
  character(80)  :: FileFEM, FileFEMWrite
  logical        :: FileGeom, miror, perfectcond, chiral, anisotropic
!
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x,'wavelength of the free space, wavelength = ',1pe13.4,';')")  &
         wavelength
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'refractive index of the ambient medium,ind_refMed = ', ind_refMed, ';'
  if (.not. anisotropic) then
    write (iOutput,"(2x, a, 1pe10.3, ',', 1pe10.3, a)")                             &
   'relative refractive index of the particle, ind_refRel = (', ind_refRel, ');'
  else
    write (iOutput,"(2x,'relative refractive indices of the uniaxial particle:')")
    write (iOutput,"(2x, a, 1pe10.3, ',', 1pe10.3, a, 1pe10.3, ',', 1pe10.3, a)")   &
   'ind_refRel = (', ind_refRel, '), ind_refRelZ = (', ind_refRelZ, ');' 
  end if
  write (iOutput,*)
  if (FileGeom) then
    FileFEMWrite = FileFEM(14:LenString(FileFEM))
    write (iOutput,"(2x, a, a30)")                                                  &
   'name of the file containing the particle geometry, FileFEM = ',     FileFEMWrite
  else
    write (iOutput,"(2x,'index of the particle geometry, TypeGeom = ',i2,';')")     &
           TypeGeom
    if (TypeGeom == 1) then
      write (iOutput,"(2x,'ellipsoid;')")       
    else if (TypeGeom == 2) then
      write (iOutput,"(2x,'quadratic prism;')") 
    else if (TypeGeom == 3) then
      write (iOutput,"(2x,'regular N-hedral prism;')")
    end if
    write (iOutput,"(2x,'number of surface parameters, Nsurf = ',i2,';')") Nsurf
    write (iOutput,"(2x,'surface parameters:')")
    do i = 1, Nsurf
      write (iOutput,"(2x,'surf(',i2,') = ',1pe10.3,',')") i, surf(i)
    end do       
    if (TypeGeom == 1) then
      write (iOutput,"(2x,'where surf(1) is the semi-axis along the x-axis,')")
      write (iOutput,"(2x,'surf(2) is the semi-axis along the y-axis and')")
      write (iOutput,"(2x,'surf(3) is the semi-axis along the z-axis;')")
    else if (TypeGeom == 2 .or. TypeGeom == 3) then
      write (iOutput,"(2x,'where surf(1) is the half-length of the prism,')")
      write (iOutput,"(2x,'and   surf(2) is the half-length of the basis side;')")
    end if 
    write (iOutput,"(2x,'number of integration surfaces, Nparam = ',i2,';')")       &
           Nparam
  end if
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'characteristic length of the particle, anorm = ', anorm, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'radius of the circumscribing sphere, Rcirc = ', Rcirc, ';'
  if (anisotropic) then
    write (iOutput,"(2x, a)")                                                       &
   'Euler angles specifying the orientation of the principal coordinate system:'
    write (iOutput,"(2x, a, 1pe10.3, a, 1pe10.3, a, 1pe10.3, a)")                   &
   'alpha = ', alphaPR * 180._O / Pi, ', beta = ', betaPR * 180._O / Pi,            &
   ', gamma = ', 0._O, ';'        
  end if
  if (miror) write (iOutput,"(2x,'mirror symmetric particle;')")
  write (iOutput,"(2x, a, i2, a)")                                                  &
 'number of azimuthal symmetric sections, Nazimutsym = ', Nazimutsym, ';'
  if (Nazimutsym >=2) then
    write (iOutput,"(2x,'azimuthal symmetry is taken into account;')")
  else
    write (iOutput,"(2x,'azimuthal symmetry is disregarded;')")
  end if
  write (iOutput,*)
  if (perfectcond) then
    write (iOutput,"(2x,'perfectly conducting particle;')")
  else if (chiral) then
    write (iOutput,"(2x,'chiral particle;')")
    write (iOutput,"(2x,'characteristic of chirality, kb = ',1pe10.3,';')") kb  
  else if (anisotropic) then
    write (iOutput,"(2x,'uniaxial anisotropic particle;')")
  else 
    write (iOutput,"(2x,'dielectric particle;')")
  end if 
  write (iOutput,*)    
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum expansion order tolerance, epsNrank = ', epsNrank, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum azimuthal order tolerance, epsMrank = ', epsMrank, ';'
  if (.not. FileGeom) then               
    write (iOutput,"(2x,'integration tolerance, epsNint = ',1pe10.3,';')") epsNint                         
    write (iOutput,"(2x,'integration steps, dNint1 = ',i4,', dNint2 = ',i4,'.')")   &
           dNint1, dNint2 
  end if
  write (iOutput,"(/)")                       
end subroutine printinputNONAXSYM
!***********************************************************************************
subroutine TMatrix_Nrank_MrankNONAXSYM (FileGeom, TypeGeom, k, ind_ref, Nsurf,    &
           surf,rp, np, area, Nface, Nparam, Mrank, Nrank, Nint1, Nint2, miror,     &
           Nazimutsym, perfectcond, chiral, kb, FileTmat, PrnProgress,Nmax,b)
  use parameters
  implicit none
  integer       :: TypeGeom, Nsurf, Nface, Nparam, Mrank, Nrank, Nint1, Nint2,      &
                   Nazimutsym                   
  real(O)       :: k, surf(Nsurf), rp(3,NfacePD), np(3,NfacePD), area(NfacePD), kb
  complex(O)    :: ind_ref
  logical       :: FileGeom, miror, perfectcond, chiral, PrnProgress 
  character(80) :: FileTmat
!      
  integer       :: Nmax, i, j, NintAL
  integer,allocatable    :: Nintparam(:) 
  real(O),allocatable    :: paramG1(:,:), paramG2(:,:), weightsG(:,:)
  complex(O) :: a(2*Nmax,2*Nmax), b(2*Nmax,2*Nmax)
!  
  Nmax   = Nrank + Mrank * (2 * Nrank - Mrank + 1)
  NintAL = max(Nint1,Nint2)  
  allocate (paramG1(Nparam,NintAL*NintAL), paramG2(Nparam,NintAL*NintAL),           &
            weightsG(Nparam,NintAL*NintAL))
  allocate (Nintparam(Nparam))
  if (.not. FileGeom) then    
    call interpolation_list3D (TypeGeom, Nsurf, surf, Nint1, Nint2, NintAL, Nparam, &
         Nintparam, paramG1, paramG2, weightsG, miror, Nazimutsym)                            
  else
    do i = 1, Nparam
      do j = 1, NintAL*NintAL
        paramG1(i,j)  = 0._O
        paramG2(i,j)  = 0._O
        weightsG(i,j) = 0._O
      end do
      Nintparam(i) = 1
    end do   
  end if
  if (PrnProgress) call write_progress (.true., 1, 4)
  call matrix_Q (FileGeom, TypeGeom, 3, 1, k, ind_ref, Nsurf, surf, rp, np, area,   &
       Nface, Mrank, Nrank, Nmax, NintAL, Nparam, Nintparam, paramG1, paramG2,      &
       weightsG, miror, Nazimutsym, perfectcond, chiral, kb, a, Nmax, Nmax)
  if (PrnProgress) call write_progress (.false., 2, 4)  
  call matrix_Q (FileGeom, TypeGeom, 1, 1, k, ind_ref, Nsurf, surf, rp, np, area,   &
       Nface, Mrank, Nrank, Nmax, NintAL, Nparam, Nintparam, paramG1, paramG2,      &
       weightsG, miror, Nazimutsym, perfectcond, chiral, kb, b, Nmax, Nmax)
  if (PrnProgress) call write_progress (.false., 3, 4)  
  call LU_SYSTEM (a, 2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 4, 4)
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank  
  deallocate (paramG1, paramG2, weightsG, Nintparam)      
end subroutine TMatrix_Nrank_MrankNONAXSYM 
!***********************************************************************************
subroutine TMatrix_Nrank_MrankAnis (FileGeom, TypeGeom, k, ind_ref, ind_refZ,       &
           alfaPR, betaPR, gamaPR, Nsurf, surf, rp, np, area, Nface, Nparam, Mrank, &
           Nrank, Nbeta, Nint1, Nint2, FileTmat, PrnProgress,Nmax,b)
  use parameters
  implicit none
  integer       :: TypeGeom, Nsurf, Nface, Nparam, Mrank, Nrank, Nint1, Nint2, Nbeta
  real(O)       :: k, surf(Nsurf), rp(3,NfacePD), np(3,NfacePD), area(NfacePD),     &
                   alfaPR, betaPR, gamaPR
  complex(O)    :: ind_ref, ind_refZ
  character(80) :: FileTmat
  logical       :: FileGeom, PrnProgress
!        
  integer       :: Nmax, NintAL  
  integer,allocatable    :: Nintparam(:)
  real(O),allocatable    :: paramG1(:,:), paramG2(:,:), weightsG(:,:)
  complex(O)             :: a(2*Nmax,2*Nmax), b(2*Nmax,2*Nmax) 
!  
  Nmax   = Nrank + Mrank * (2 * Nrank - Mrank + 1)   
  NintAL = max(Nint1,Nint2)  
!  open (unit = iTmat, file = FileTmat, status = 'replace')
!  call  write_HeadFileTmat (Nmax, Nmax)    
!  allocate (a(2*Nmax,2*Nmax), b(2*Nmax,2*Nmax))                          
  allocate (paramG1(Nparam,NintAL*NintAL), paramG2(Nparam,NintAL*NintAL),           &
            weightsG(Nparam,NintAL*NintAL))
  allocate (Nintparam(Nparam))
  call interpolation_list3D (TypeGeom, Nsurf, surf, Nint1, Nint2, NintAL, Nparam,   &
       Nintparam, paramG1, paramG2, weightsG,.false., 1)   
  if (PrnProgress) call write_progress (.true., 1, 4)
  call matrix_Q_anis (FileGeom, TypeGeom, 3, 1, k, ind_ref, ind_refZ, alfaPR,       &
       betaPR, gamaPR, Nsurf, surf, rp, np, area, Nface, Mrank, Nrank, Nmax, Nbeta, &
       NintAL, Nparam, Nintparam, paramG1, paramG2, weightsG, a, Nmax, Nmax)
  if (PrnProgress) call write_progress (.false., 2, 4)   
  call matrix_Q_anis (FileGeom, TypeGeom, 1, 1, k, ind_ref, ind_refZ, alfaPR,       &
       betaPR, gamaPR, Nsurf, surf, rp, np, area, Nface, Mrank, Nrank, Nmax, Nbeta, &
       NintAL, Nparam, Nintparam, paramG1, paramG2, weightsG, b, Nmax, Nmax)
  if (PrnProgress) call write_progress (.false., 3, 4)  
  call LU_SYSTEM (a, 2*Nmax, 2*Nmax, b, 2*Nmax, 2*Nmax, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 4, 4)
!  call write_FileTmat (Nmax, Nmax, b)
!  close (unit = iTmat)
!  call write_InfoFileTmat (FileTmat, Mrank, Nrank, .false., .false., .false.)
!  call ScatCharact (k, FileTmat, Mrank, Nrank, .false., .false., .false.)
  print "(/,2x,'The T matrix is stored in ',a50)", FileTmat
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,';')", Nrank
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank  
  deallocate (paramG1, paramG2, weightsG, Nintparam)      
end subroutine TMatrix_Nrank_MrankAnis
subroutine TNONAXSYM (wavelength, ind_refMed, ind_refRel, ind_RefRelZ,            &
       alphaPR, betaPR, perfectcond, anisotropic, chiral, kb, FileGeom,             &
       TypeGeom, FileFEM, Nsurf, surf, Nparam, anorm, Rcirc, miror, Nazimutsym,     &   
       DoConvTest, ExtThetaDom, Nbeta, Nint1, Nint2, Nrank, Mrank, epsNint,         &
       epsNrank, epsMrank, dNint1, dNint2, PrnProgress, gammaPR, Nface,Nmax,b) 
  !k, snorm, rp, np, area,  TypeConvTest      
  use parameters  
  use derived_parameters  
  implicit none 
  integer       :: TypeGeom, Nsurf, Nface, Nparam, Nazimutsym, TypeConvTest, Mrank, &
                   Nrank, Nbeta, Nint1, Nint2, dNint1, dNint2, Nmax                     
  real(O)       :: k, ind_refMed, wavelength, anorm, surf(Nsurf), snorm,            &
                   kb, epsNint, epsNrank, epsMrank, Rcirc, rp(3,NfacePD),           &
                   np(3,NfacePD), area(NfacePD), alphaPR, betaPR, gammaPR
  complex(O)    :: ind_refRel, ind_RefRelZ
  logical       :: FileGeom, miror, perfectcond, chiral, anisotropic, DoConvTest,   &
                   ExtThetaDom, PrnProgress
  character(80) :: FileTmat, FileFEM     
  integer       :: NrankW, i, j, ios, icall                     
  real(O)       :: xpart, x, dp, grd
  logical       :: more, continuare, IntTest, XFindPar
  complex(O), intent(out)    :: b(2*Nmax,2*Nmax) 
  !f2py real(O) :: wavelength  = 1
  !f2py real(O) :: ind_refMed  = 1
  !f2py real(O) :: kb = 0
  !f2py character(80) :: FileFEM  = '../GEOMFILES/cubekc.fem'
  !f2py logical :: miror  = 0 
  !f2py logical :: FileGeom = 1   
  !f2py integer :: TypeGeom = 1  
  !f2py integer :: Nparam = 1 
  !f2py real(O) :: anorm  = 1
  !f2py real(O) :: Rcirc  = 1
  !f2py integer :: Nazimutsym = 0  
  !f2py integer :: Nface = 1
  !f2py complex(O) :: ind_refRelZ = (1.5,0.)
  !f2py complex(O) :: ind_refRel  = (4,0.)  
  !f2py real(O) :: alphaPR = 0
  !f2py real(O) :: betaPR  = 0
  !f2py integer :: Nbeta   = 60
  !f2py integer :: Nrank  = 10
  !f2py integer :: Mrank  = 10
  !f2py integer :: Nint1 = 100
  !f2py integer :: Nint2 = 100          
  !f2py real(O) :: epsNint  = 5.e-2
  !f2py real(O) :: epsNrank = 5.e-2
  !f2py real(O) :: epsMrank = 5.e-2
  !f2py integer :: dNint1 = 4
  !f2py integer :: dNint2 = 4
  !f2py real(O) :: gammaPR = 0 
  !f2py logical :: perfectcond = 0 
  !f2py logical :: anisotropic = 0  
  !f2py logical :: chiral      = 0
  !f2py logical :: DoConvTest   = 0
  !f2py logical :: ExtThetaDom  = 1          
  !f2py logical :: PrnProgress = 1 
! -----------------------------------------------------------------------------------
!                        Read the input file FileInputNONAXSYM                      ! 
! ----------------------------------------------------------------------------------- 
  call DrvParameters        
  k   = 2._O * Pi * ind_refMed / wavelength
  grd = Pi / 180._O    
  call check_MatPropNONAXSYM (perfectcond, anisotropic, chiral, kb) 
  if (chiral) call check_chirality (kb)        
  call check_inputNONAXSYM (FileGeom, FileFEM, miror, chiral, anisotropic,          &
       Nazimutsym)
  call check_geom3D (TypeGeom, Nsurf, Nparam, anisotropic, miror, Nazimutsym)    
  call check_anorm (anorm)
  xpart = k * anorm
  snorm = Pi * xpart * xpart 
  do i = 1, NfacePD
    do j = 1, 3
      rp(j,i) = 0._O
      np(j,i) = 0._O
    end do
    area(i) = 0._O
  end do 
  if (FileGeom) then    
    call read_FileFEM (FileFEM, Nface, rp, np, area) 
    Rcirc = 0._O
    do i = 1, Nface
      dp = sqrt(rp(1,i)**2 + rp(2,i)**2 + rp(3,i)**2)
      if (dp > Rcirc) Rcirc = dp
    end do            
  end if                      
  if (anisotropic) call check_ind_ref3 (ind_refRel, ind_refRelZ)  
  alphaPR = alphaPR * grd
  betaPR  = betaPR  * grd    
  x = k * Rcirc
  NrankW = int(x + 4.05_O * x**0.33_O + 2._O) 
  call check_MrankNrank (Mrank, Nrank)  
! -----------------------------------------------------------------------------------
!                                      Main                                         !
! -----------------------------------------------------------------------------------                                    
  if (.not. anisotropic) then                
    call TMatrix_Nrank_MrankNONAXSYM (FileGeom, TypeGeom, k, ind_refRel, Nsurf, &
         surf, rp, np, area, Nface, Nparam, Mrank, Nrank, Nint1, Nint2, miror,    &
         Nazimutsym, perfectcond, chiral, kb, FileTmat, PrnProgress,Nmax,b)                                                     
  else
    call TMatrix_Nrank_MrankAnis (FileGeom, TypeGeom, k, ind_refRel, ind_refRelZ, &
         alphaPR, betaPR, gammaPR, Nsurf, surf, rp, np, area, Nface, Nparam,      &
         Mrank, Nrank, Nbeta, Nint1, Nint2, FileTmat, PrnProgress,Nmax,b) 
  end if 
end subroutine TNONAXSYM

subroutine SCT
!------------------------------------------------------------------------------------
!   The routine computes the scattering characteristics of a particle using the     !
!   previously calculated T matrix. The T matrix is read from the file FileTmat.    ! 
!   The input parameters are specified in the file "InputSCT.dat". The significance !
!   of the input parameters is given in the description file "Description.txt".     ! 
!------------------------------------------------------------------------------------
  use parameters
  use allocation, only: IndI, IndJ, NameElem
  implicit none
  integer        :: Nrank, Mrank, Nalpha, Nbeta, Ngamma, NthetaGS, NthetaRND, Nphi, &
                    Ntheta(NphiMax), Nelem, MatrixElem(16), NthetaAsym, NphiAsym,   &
                    Nrankeff, Mrankeff, ifail, itheta, Nfail, ialpha, ibeta,        &
                    igamma, i, j, kelem, iphi, NthetaAL, NphiAL
  real(O)        :: k, wavelength, alphamin, alphamax, betamin, betamax, gammamin,  &
                    gammamax, anorm, snorm, thetaGI, phiGI, alphapGauss, x0, y0,    &
                    z0, w0, deltaOrder, phiGS, thetaminRND, thetamaxRND,            &
                    phi(NphiMax), thetamin(Nphimax), thetamax(NphiMax), theta,      &
                    dtheta, AsymPar, AsymParV, Cext, Cscat, Qext, Qscat, Z(4,4),    &
                    CextAv, CscatAv, QextAv, QscatAv, alpha, beta, gamma, fact,     &
                    norm, CscatPAv, CscatSAv, CextPAv, CextSAv, QscatPAv, QscatSAv, &
                    QextPAv, QextSAv, gP_xAv, gP_yAv, gP_zAv, gS_xAv, gS_yAv,       &
                    gS_zAv, gP_x, gP_y, gP_z, gS_x, gS_y, gS_z, gP_t, gP_p, gP_r,   &
                    gS_t, gS_p, gS_r, KeAv(4,4), Ke(4,4), CscatP, CscatS, CextP,    &
                    CextS, CscatV, CextV, QscatV, QextV, aphi, bphi, atheta, btheta
  complex(O)     :: epol_beta, epol_alpha		    
  character(5)   :: TypeExcit  
  character(80)  :: FileTmat, FileDSCS, FileSCAT
  character(256) :: FailMessage(10)
  logical        :: MirorSym, axsym, sphere, chiral, RandomOrientation, DoNumAvrg,  &
                    UseSimpson, ReducedOrder, ExtThetaDom, normalized, ComputeDSCS, &
                    ComputeScatPar, FailHovTest, ComputeAsymPar, PrnProgress,       &
                    WriteInputInfo
  real(O),allocatable      :: ZE(:,:,:), walpha(:), xalpha(:), wbeta(:), xbeta(:),  &
                              wgamma(:), xgamma(:), hAv(:), vAv(:), h(:), v(:),     &
                              ZTPAv(:,:,:), ZTP(:,:,:), wphi(:), xphi(:), wtheta(:),&
                              xtheta(:)
  complex(O),allocatable   :: SS(:,:)
! -----------------------------------------------------------------------------------
!                                Read the input file                                !
! -----------------------------------------------------------------------------------           
  call readinputSCT ( .true., wavelength, k, FileTmat, Nrank, Mrank,                &
       axsym, sphere, chiral, RandomOrientation, MirorSym, DoNumAvrg,               &
       UseSimpson, ReducedOrder, deltaOrder, alphamin, alphamax, Nalpha,            &
       betamin, betamax, Nbeta, gammamin, gammamax, Ngamma, anorm, TypeExcit,       &
       thetaGI, phiGI, epol_beta, epol_alpha, alphapGauss, x0, y0, z0, w0,          &
       ComputeDSCS, phiGS, NthetaGS, ExtThetaDom, normalized, FileDSCS,             &
       ComputeScatPar, NthetaRND, thetaminRND, thetamaxRND, Nphi, phi, Ntheta,      &
       thetamin, thetamax, FileScat, Nelem, MatrixElem, ComputeAsymPar,             &
       NthetaAsym, NphiAsym, PrnProgress, WriteInputInfo, snorm )   
! -----------------------------------------------------------------------------------
!                                       Main                                        !
! -----------------------------------------------------------------------------------              
  if (RandomOrientation) then          
    print "(/,2x,'Scattering Characteristics of a Randomly Oriented Particle')"  
    print "(  2x,'----------------------------------------------------------')"     
    allocate (SS(10,NthetaGS))    
    if (PrnProgress)                                                                &
    print "(/,2x,'progress of main calculation for the average matrix <SS*>:')"
    if (.not. DoNumAvrg) then                   
      call AvCscatCextEff (ReducedOrder, k, snorm, FileTmat, axsym, chiral,         &
           deltaOrder, Nrank, Mrank, Nrankeff, Mrankeff, Cext, Cscat,               &
           Qext, Qscat)                                                                       
      print "(2x,'effective number of azimuthal modes, Mrankeff = ',i3,';')",       &
              Mrankeff
      print "(2x,'effective maximum expansion order,   Nrankeff = ',i3,';')",       &
              Nrankeff   								                                        
      call SijSCpqEff (MirorSym, k, axsym, chiral, FileTmat, Nrank, Mrank,          &
           Nrankeff, Mrankeff, NthetaGS, SS, PrnProgress)                       
    else                                                               
      call SijSCpqInt (MirorSym, k, snorm, FileTmat, axsym, chiral, Nrank, Mrank,   &
           Nalpha, Nbeta, Ngamma, NthetaGS, UseSimpson, Cext, Cscat, Qext, Qscat,   &
           SS, PrnProgress)
    end if                                                                  
    CscatV = 0._O
    CextV  = 0._O
    QscatV = 0._O
    QextV  = 0._O    
    if (ComputeScatPar) then
      if (NthetaRND /= 1) then
        dtheta = (thetamaxRND - thetaminRND) / (NthetaRND - 1)
      else
        dtheta = 0._O
      end if  
      open (unit = iSCAT, file = FileScat, status = "replace")
      if (WriteInputInfo) call inputDSCS_SCATAvrg (.false., wavelength, axsym,      &
                               chiral, FileTmat, Nrank, Mrank, anorm, normalized,   &                              
                               DoNumAvrg, Nalpha, Nbeta, Ngamma, NthetaGS,          &
                               epol_beta, epol_alpha) 
      call RandomExtinctionMatrix (k, FileTmat, MirorSym, axsym, chiral, Nrank,     &
           Mrank, KeAv)     	   			                                            
      allocate (ZE(4,4,NthetaGS))
      call ExtendedScatteringMatrix (MirorSym, NthetaGS, SS, ZE)
      if (.not.MirorSym) call AvCscatCextV (k, snorm, NthetaGS, ZE, KeAv, CscatV,   &
                              CextV, QscatV, QextV)            
      call AsymmetryParameter (MirorSym, NthetaGS, ZE, Cscat, AsymPar, AsymParV)
      FailHovTest = .false.
      Nfail = 0
      do ifail = 1, 10
        FailMessage(ifail) = ' '
      end do                                
      do itheta = 1, NthetaRND
        theta = thetaminRND + (itheta - 1) * dtheta                          
        call ScatteringMatrix (MirorSym, theta, NthetaGS, ZE, Z)                      
        if (axsym) then
          FailHovTest = .false. 
          call HovTest (Z, FailHovTest, Nfail, FailMessage)
        end if          
        call write_ScatMatrix (MirorSym, axsym, FailHovTest, Nfail, FailMessage,    &
             KeAv, theta, Z, itheta, Nelem, IndI, IndJ, NameElem, Cscat, Cext,      &
             Qscat, Qext, CscatV, CextV, QscatV, QextV, AsymPar, AsymParV)
      end do        
      close (unit = iSCAT)    
      deallocate (ZE)                                            
    end if
    if (ComputeDSCS) then
      open (unit = iDSCS, file = FileDSCS, status = "replace")       			      
      if (WriteInputInfo) call inputDSCS_SCATAvrg (.true., wavelength, axsym,       &
                               chiral, FileTmat, Nrank, Mrank, anorm, normalized,   &                              
                               DoNumAvrg, Nalpha, Nbeta, Ngamma, NthetaGS,          &
                               epol_beta, epol_alpha)
      if (.not.MirorSym)  then      
        call RandomExtinctionMatrix (k, FileTmat, MirorSym, axsym, chiral, Nrank,   &
             Mrank, KeAv)     	   			                                            
        allocate (ZE(4,4,NthetaGS))
        call ExtendedScatteringMatrix (MirorSym, NthetaGS, SS, ZE)
        call AvCscatCextV (k, snorm, NthetaGS, ZE, KeAv, CscatV, CextV, QscatV,     &
	     QextV)                  
      end if  			       
      call DiffScatCrossSectAvrg (MirorSym, SS, NthetaGS, anorm, epol_beta,         &
           epol_alpha, phiGS, normalized, Cscat, Cext, Qscat, Qext, CscatV, CextV,  &
           QscatV, QextV)
      close (unit = iDSCS) 
      if (.not.MirorSym) deallocate (ZE)                          
    end if                       
    deallocate (SS)   
  else      
    print "(/,2x,'Scattering Characteristics of a Nonrandomly Oriented Particle')" 
    print "(  2x,'-------------------------------------------------------------')" 
    allocate (walpha(Nalpha), xalpha(Nalpha), wbeta(Nbeta), xbeta(Nbeta),           &
              wgamma(Ngamma), xgamma(Ngamma))                                   
    NphiAL   = Nphi
    NthetaAL = 0
    do iphi = 1, Nphi
      if (Ntheta(iphi) > NthetaAL) NthetaAL = Ntheta(iphi)
    end do
    allocate (h(NthetaGS), v(NthetaGS), ZTP(NphiAL,NthetaAL,Nelem))    
    allocate (xphi(NphiAsym), wphi(NphiAsym), xtheta(NthetaAsym), wtheta(NthetaAsym))                
    call NodesAlphaBetaGamma (alphamin, alphamax, Nalpha, betamin, betamax, Nbeta,  &
         gammamin, gammamax, Ngamma, UseSimpson, xalpha, walpha, xbeta, wbeta,      &
         xgamma, wgamma)	    	                                         
    if (ComputeDSCS)    open (unit = iDSCS, file = FileDSCS, status = "replace")       
    if (ComputeScatPar) open (unit = iSCAT, file = FileScat, status = "replace")                                            
    if (ComputeDSCS .and. WriteInputInfo)                                           &                      
      call inputDSCS_SCAT (.true., axsym, sphere, chiral, Mrank, Nrank, phiGS,      &
           thetaGI, phiGI, alphamin, alphamax, Nalpha, betamin, betamax, Nbeta,     &
           gammamin, gammamax, Ngamma, epol_beta, epol_alpha, alphapGauss, x0,      &
           y0, z0, w0, TypeExcit, wavelength, anorm, normalized, FileTmat)
    if (ComputeScatPar .and. WriteInputInfo)                                        &   
      call inputDSCS_SCAT (.false., axsym, sphere, chiral, Mrank, Nrank, phiGS,     &
           thetaGI, phiGI, alphamin, alphamax, Nalpha, betamin, betamax, Nbeta,     &
           gammamin, gammamax, Ngamma, epol_beta, epol_alpha, alphapGauss, x0,      &
           y0, z0, w0, TypeExcit, wavelength, anorm, normalized, FileTmat)                  
    if (ComputeDSCS) then
      allocate (hAv(NthetaGS), vAv(NthetaGS))
      CextAv  = 0._O
      CscatAv = 0._O
      do itheta = 1, NthetaGS
        hAv(itheta) = 0._O
        vAv(itheta) = 0._O
      end do    
    end if
    if (ComputeScatPar) then
      allocate (ZTPAv(NphiAL,NthetaAL,Nelem))  
      CextPAv  = 0._O
      CextSAv  = 0._O         
      CscatPAv = 0._O
      CscatSAv = 0._O                  
      do iphi = 1, NphiAL 
        do itheta = 1, NthetaAL               
          do kelem = 1, Nelem        
            ZTPAv(iphi,itheta,kelem) = 0._O
          end do
        end do
      end do
      do i = 1, 4
        do j = 1, 4
          KeAv(i,j) = 0._O
        end do
      end do
      if (ComputeAsymPar) then                    
        gP_xAv = 0._O
        gP_yAv = 0._O
        gP_zAv = 0._O      
        gS_xAv = 0._O
        gS_yAv = 0._O
        gS_zAv = 0._O  
!        
        aphi = 0._O
        bphi = 2._O * Pi
        call Simpson (aphi, bphi, NphiAsym, xphi, wphi)   
        if (.not. UseSimpson) then
          atheta = 0._O
          btheta = Pi   
          call Gauss_Legendre (atheta, btheta, NthetaAsym, wtheta, xtheta)   
          do itheta = 1, NthetaAsym
            theta = xtheta(itheta)
            wtheta(itheta) = wtheta(itheta) * sin(theta)      
          end do        
        else
          atheta = - 1._O
          btheta =   1._O
          call Simpson (atheta, btheta, NthetaAsym, xtheta, wtheta)     
        end if     	                  
      end if 	
    end if
    if (PrnProgress .and. Nalpha > 1)                                               &
        print "(/,2x,'progress of main calculation for the averaging procedure:')"   
    do ialpha = 1, Nalpha
      alpha = xalpha(ialpha)
      if (PrnProgress .and. Nalpha > 1) call write_progress (.false., ialpha, Nalpha)
      do ibeta = 1, Nbeta          
        if (.not. UseSimpson) then 
          beta = xbeta(ibeta)
        else
          beta = acos(xbeta(ibeta))
        end if
        do igamma = 1, Ngamma 
          gamma = xgamma(igamma)           
          fact  = walpha(ialpha) * wbeta(ibeta) * wgamma(igamma)          	       	       	       
          call DSCS_SCAT (ComputeDSCS, ComputeScatPar, ComputeAsymPar, axsym,       &
               sphere, chiral, Mrank, Nrank, NthetaGS, phiGS, Nphi, phi, Ntheta,    &
               thetamin, thetamax, NthetaAsym, NphiAsym, UseSimpson, xphi, wphi,    &
               xtheta, wtheta, thetaGI, phiGI, alpha, beta, gamma, epol_beta,       &
               epol_alpha, alphapGauss, x0, y0, z0, w0, TypeExcit, k, snorm,        &
               FileTmat, ExtThetaDom, normalized, Nelem, IndI, IndJ, h, v, ZTP,     &
               NphiAL, NthetaAL, Ke, Cscat, Cext, CscatP, CscatS, CextP, CextS,     &
               gP_x, gP_y, gP_z, gS_x, gS_y, gS_z)  	       	        
          if (ComputeDSCS) then                                        
            CextAv  = CextAv  + Cext  * fact
            CscatAv = CscatAv + Cscat * fact
            do itheta = 1, NthetaGS
              hAv(itheta) = hAv(itheta) + h(itheta) * fact
              vAv(itheta) = vAv(itheta) + v(itheta) * fact
            end do
          end if   
          if (ComputeScatPar) then
            CextPAv  = CextPAv  + CextP  * fact
            CextSAv  = CextSAv  + CextS  * fact               	    
            CscatPAv = CscatPAv + CscatP * fact
            CscatSAv = CscatSAv + CscatS * fact             	        
            do iphi = 1, Nphi 
              do itheta = 1, Ntheta(iphi)                           
                do kelem = 1, Nelem        
                  ZTPAv(iphi,itheta,kelem) = ZTPAv(iphi,itheta,kelem) +             &
                                             ZTP(iphi,itheta,kelem) * fact
                end do
              end do
            end do
            if (TypeExcit(1:5) == 'PLANE') then  
              do i = 1, 4
                do j = 1, 4
                  KeAv(i,j) = KeAv(i,j) + Ke(i,j) * fact
                end do
              end do           
            end if
	    if (ComputeAsymPar) then
              gP_xAv = gP_xAv + gP_x * fact
              gP_yAv = gP_yAv + gP_y * fact
              gP_zAv = gP_zAv + gP_z * fact	                
              gS_xAv = gS_xAv + gS_x * fact
              gS_yAv = gS_yAv + gS_y * fact
              gS_zAv = gS_zAv + gS_z * fact	                	    	    	    
            end if 	      
          end if
        end do
      end do
    end do      
    norm = Pi * anorm * anorm
    norm = 1._O / norm                 
    if (ComputeDSCS) then
      QextAv  = CextAv  * norm  
      QscatAv = CscatAv * norm      
      call write_DSCS1 (NthetaGS, normalized, ExtThetaDom, hAv, vAv, CscatAv,       &
           CextAv, QscatAv, QextAv)                                            
      close (unit = iDSCS)
      deallocate (hAv, vAv)
    end if
    if (ComputeScatPar) then
      QextPAv  = CextPAv  * norm 
      QextSAv  = CextSAv  * norm                   
      QscatPAv = CscatPAv * norm 
      QscatSAv = CscatSAv * norm 
      gP_t = 0._O
      gP_p = 0._O
      gP_r = 0._O  
      gS_t = 0._O 
      gS_p = 0._O
      gS_r = 0._O      
      if (ComputeAsymPar) then                                           
        call T_cartesian_global_local (gP_xAv, gP_yAv, gP_zAv, phiGI, thetaGI,      &
             0._O, gP_t, gP_p, gP_r)
        call T_cartesian_global_local (gS_xAv, gS_yAv, gS_zAv, phiGI, thetaGI,      &
             0._O, gS_t, gS_p, gS_r)      
      end if	     
      call write_SCAT (Nelem, NameElem, Nphi, phi, Ntheta, thetamin, thetamax,      &
           ZTPAv, NphiAL, NthetaAL, KeAv, CscatPAv, CscatSAv, CextPAv, CextSAv,     &
           QscatPAv, QscatSAv, QextPAv, QextSAv, ComputeAsymPar, gP_t, gP_p, gP_r,  &
           gS_t, gS_p, gS_r, TypeExcit)
      close (unit = iSCAT)             
      deallocate (ZTPAv)      
    end if
    deallocate (walpha, xalpha, wbeta, xbeta, wgamma, xgamma)
    deallocate (h, v, ZTP)
    deallocate (xphi, wphi, xtheta, wtheta)    
  end if
  deallocate (IndI, IndJ, NameElem)  
end 

! **********************************************************************************
! *       ROUTINES FOR COMPUTING THE SPHERICAL BESSEL AND HANKEL FUNCTIONS,        *
! *    THE CYLINDRICAL BESSEL FUNCTIONS AND THE ASSOCIATED LEGENDRE FUNCTIONS      *
! *    -------------------------------------------------------------------------   *
! *    Partial list of subroutines:                                                *
! *      besel_j,                 besel_h,              besel_h_complete,          *
! *      J01,                     bes_J,                Pmm,                       *
! *      pimm,                    Leg,                  P_mm_real,                 *
! *      pi_mm_real,              tau_mm_real,          Leg_normalized,            *
! *      P_mm,                    pi_mm,                tau_mm,                    *
! *      Leg_normalized_complex                                                    * 
! *    Partial list of alternative subroutines:                                    * 
! *      besel_jA,                besel_hA,             besel_h_completeA,         *
! *      besel_jB,                besel_jC,             bes_JA,                    *
! *      MSTA1,                   MSTA2,                ENVJ                       *
! **********************************************************************************
subroutine besel_j (z, N, j, jd)
!-----------------------------------------------------------------------------------
! The routine computes the spherical Bessel functions j(z) and the derivatives     !
! jd(z) = d(z*j(z))/dz. The order of the Bessel functions varies between 0 and N,  !
! and the backward recurrence relation                                             !
!                     j(n-1,z) + j(n+1,z) = [(2n+1) / z] * j(n,z).                 !
! is used for computation. Here j(n,z) denotes the Bessel function of order n and  !
! argument z. The following parameters control the computation:                    !                                
! - ZeroSinXX (real) - for |z| < ZeroSinXX, we set j(0,z) = sin(z)/z = 1 and       !
!   j(n,z) = 0, for n = 1,2,...,N.                                                 !
! - FactNBes (real) - determines the order of the Bessel functions Nstart,         !
!   at which the backward recurrence is started, i.e., Nstart = FactNBes * N.      !
!   Default value: FactNBes = 400._O.                                              !
! - InitBesVal (real) - initial value of the Bessel function at the beginning of   !
!   the backward recurrence. Default value: InitBesVal = 1.e-35_O.                 !
! - MaxArgBes (real) - for |z| > MaxArgBes, the asymptotic expressions of          !
!   spherical Bessel functions for large arguments are used.                       !
! - UpperBoundSeq (real) - upper bound of the sequence of Bessel functions         !
!   (if a Bessel function value exceeds this bound the entire sequence is scaled). !
!   Default value: UpperBoundSeq = 1.e+10_O.                                       !
! - LowerBoundSeq (real) - lower bound of the sequence of Bessel functions.        !
!   Default value: LowerBoundSeq = 1.e-10_O.                                       !
! These parameters are specified in the routine "DrvParameters" from the file      !
! '../TMATROUTINES/MachParam.f90'.                                                 !
!                                                                                  !
! Input parameters:                                                                ! 
! - z (complex) - argument of the spherical Bessel functions.                      !
! - N (integer) - maximum order of the spherical Bessel functions.                 !
!                                                                                  !
! Output parameters:                                                               !
! - j  (complex array) - spherical Bessel functions.                               !
! - jd (complex array) - derivatives of the spherical Bessel functions.            !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: N
  complex(O) :: z, j(0:N), jd(0:N)
!
  complex(O) :: j0, j1, f2, f1, f, kc, scale, argc
  real(O)    :: a0, arg
  integer    :: M, Ma, Mn, k, l
!  
  a0 = abs(z)
  do k = 0, N 
    j(k)  = zero
    jd(k) = zero
  end do
  if (a0 < ZeroSinXX) then
    j(0) = one
  else if (a0 >= ZeroSinXX .and. a0 < MaxArgBes) then
    j(0) = sin(z) / z
    j(1) = j(0) / z - cos(z) / z
    if (N >= 2) then
      j0 = j(0)
      j1 = j(1)
      Ma = nint(a0 + 4._O * a0**0.33_O + 2._O + sqrt(101._O + a0)) + 20  
      Mn = N + nint(sqrt(FactNBes * N))
      M  = max(Ma,Mn)  
      f2 = zero
      f1 = cmplx(InitBesVal,0.0,O)
      do k = M, 0, -1
        kc = cmplx(2 * k + 3,0.0,O)
        f  = kc * f1 / z - f2   
        if (k <= N) j(k) = f
        f2 = f1
        f1 = f
        if (abs(f1) > UpperBoundSeq) then
          f2 = f2 * LowerBoundSeq
          f1 = f1 * LowerBoundSeq
          do l = k, N
            j(l) = j(l) * LowerBoundSeq
          end do
        else if (abs(f1) < LowerBoundSeq) then
          f2 = f2 * UpperBoundSeq
          f1 = f1 * UpperBoundSeq
          do l = k, N
            j(l) = j(l) * UpperBoundSeq
          end do
        end if
      end do        
      if (abs(f1) > abs(f2)) then
        scale = j0 / f1
      else
        scale = j1 / f2
      end if                             
      do k = 0, N
        j(k) = scale * j(k)
      end do
    end if 
    do k = 1, N
      kc    = cmplx(k,0.0,O)
      jd(k) = z * j(k-1) - kc * j(k)
    end do
  else
    do k = 0, N
      arg  = 0.5_O * real(k + 1,O) * pi
      argc = cmplx(arg,0.0,O) 
      j(k) = cos (z - argc) / z
    end do 
    do k = 1, N
      kc    = cmplx(k,0.0,O)
      jd(k) = z * j(k-1) - kc * j(k)
    end do
  end if 
end subroutine besel_j
!**********************************************************************************
subroutine besel_h (z, N, h, hd)
!-----------------------------------------------------------------------------------
! The routine computes the spherical Hankel functions of the first kind            !
! h(z) = j(z) + i*y(z) and the derivatives hd(z) = d(z*h(z))/dz, where j(z) and    !
! y(z) are the spherical Bessel and Neumann functions, respectively. The order of  !
! the functions varies between 0 and N, and the control parameters ZeroSinXX,      !
! FactNBes, InitBesVal, UpperBoundSeq and LowerBoundSeq are specified in the       !
! routine "DrvParameters" from the file '../TMATROUTINES/MachParam.f90'.           !
!                                                                                  !
! Input parameters:                                                                ! 
! - z (complex) - argument of the spherical Hankel functions.                      !
! - N (integer) - maximum order of the spherical Hankel functions.                 !
!                                                                                  !
! Output parameters:                                                               !
! - h  (complex array) - spherical Hankel functions.                               !
! - hd (complex array) - derivatives of the spherical Hankel functions.            !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: N
  complex(O) :: z, h(0:N), hd(0:N)
!
  integer    :: Ma, Mn, M, k, l
  real(O)    :: a0, arg
  complex(O) :: j0, j1, f, f1, f2, kc, z2, z3, scale, argc
  complex(O),allocatable :: j(:), y(:)
!                   
  z2 = z * z
  z3 = z2 * z
  a0 = abs(z)
  allocate (j(0:N), y(0:N))
  do k = 0, N 
    j(k)  = zero
    y(k)  = zero
    h(k)  = zero
    hd(k) = zero
  end do
  if (a0 < ZeroSinXX) then
    j(0) = one
  else if (a0 >= ZeroSinXX .and. a0 < MaxArgBes) then
    j(0) = sin(z) / z
    j(1) = j(0) / z - cos(z) / z
    if (N >= 2) then
      j0 = j(0)
      j1 = j(1)
      Ma = nint(a0 + 4._O * a0**0.33_O + 2._O + sqrt(101._O + a0)) + 20  
      Mn = N + nint(sqrt(FactNBes * N))
      M  = max(Ma,Mn)  
      f2 = zero
      f1 = cmplx(InitBesVal,0.0,O)
      do k = M, 0, -1
        kc = cmplx(2 * k + 3,0.0,O)
        f  = kc * f1 / z - f2   
        if (k <= N) j(k) = f
        f2 = f1
        f1 = f
        if (abs(f1) > UpperBoundSeq) then
          f2 = f2 * LowerBoundSeq
          f1 = f1 * LowerBoundSeq
          do l = k, N
            j(l) = j(l) * LowerBoundSeq
          end do
        else if (abs(f1) < LowerBoundSeq) then
          f2 = f2 * UpperBoundSeq
          f1 = f1 * UpperBoundSeq
          do l = k, N
            j(l) = j(l) * UpperBoundSeq
          end do
        end if
      end do        
      if (abs(f1) > abs(f2)) then
        scale = j0 / f1
      else
        scale = j1 / f2
      end if                             
      do k = 0, N
        j(k) = scale * j(k)
      end do      
    end if               
    y(0) = - cos(z) / z
    y(1) = (y(0) - sin(z)) / z
    if (N >= 2) then   
      do k = 2, N
        if (abs(j(k-1)) > abs(j(k-2))) then               
          y(k) = (j(k) * y(k-1) - one / z2) / j(k-1)
        else 
          kc   = cmplx(2 * k - 1,0.0,O)
          y(k) = (j(k) * y(k-2) - kc / z3) / j(k-2)
        end if 
      end do 
    end if    
    do k = 0, N
      h(k) = j(k) + im * y(k)
    end do
    do k = 1, N
      kc    = cmplx(k,0.0,O)
      hd(k) = z * h(k-1) - kc * h(k)
    end do
  else
    do k = 0, N 
      arg  = 0.5_O * real(k + 1,O) * pi
      argc = cmplx(arg,0.0,O)    
      h(k) = exp(im * (z - argc)) / z      
    end do 
    do k = 1, N
      kc    = cmplx(k,0.0,O)
      hd(k) = z * h(k-1) - kc * h(k)
    end do
  end if
  deallocate (j, y)
end subroutine besel_h
!**********************************************************************************
subroutine besel_h_complete (z, N, j, y, h, hd)
!-----------------------------------------------------------------------------------
! The routine computes the spherical Bessel and Neumann functions j(z) and y(z),   !
! the spherical Hankel functions of the first kind h(z) = j(z) + i*y(z) and the    !
! derivatives hd(z) = d(z*h(z))/dz. The order of the functions varies between 0    !
! and N, and the control parameters ZeroSinXX, FactNBes, InitBesVal, UpperBoundSeq !
! and LowerBoundSeq are specified in the routine "DrvParameters" from the file     !
! '../TMATROUTINES/MachParam.f90'.                                                 !
!                                                                                  !
! Input parameters:                                                                ! 
! - z (complex) - argument of the spherical Bessel, Neumann and Hankel functions.  !
! - N (integer) - maximum order of the spherical functions.                        !
!                                                                                  !
! Output parameters:                                                               !
! - j  (complex array) - spherical Bessel functions.                               !
! - y  (complex array) - spherical Neumann functions.                              !
! - h  (complex array) - spherical Hankel functions.                               !
! - hd (complex array) - derivatives of the spherical Hankel functions.            !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: N
  complex(O) :: z, j(0:N), y(0:N), h(0:N), hd(0:N)
!
  integer    :: Ma, Mn, M, k, l
  real(O)    :: a0, arg
  complex(O) :: j0, j1, f, f1, f2, kc, z2, z3, scale, argc
!                   
  z2 = z * z
  z3 = z2 * z
  a0 = abs(z)
  do k = 0, N 
    j(k)  = zero
    y(k)  = zero
    h(k)  = zero
    hd(k) = zero
  end do
  if (a0 < ZeroSinXX) then
    j(0) = one
  else if (a0 >= ZeroSinXX .and. a0 < MaxArgBes) then    
    j(0) = sin(z) / z
    j(1) = j(0) / z - cos(z) / z
    if (N >= 2) then
      j0 = j(0)
      j1 = j(1)
      Ma = nint(a0 + 4._O * a0**0.33_O + 2._O + sqrt(101._O + a0)) + 20  
      Mn = N + nint(sqrt(FactNBes * N))
      M  = max(Ma,Mn)  
      f2 = zero
      f1 = cmplx(InitBesVal,0.0,O)
      do k = M, 0, -1
        kc = cmplx(2 * k + 3,0.0,O)
        f  = kc * f1 / z - f2   
        if (k <= N) j(k) = f
        f2 = f1
        f1 = f
        if (abs(f1) > UpperBoundSeq) then
          f2 = f2 * LowerBoundSeq
          f1 = f1 * LowerBoundSeq
          do l = k, N
            j(l) = j(l) * LowerBoundSeq
          end do
        else if (abs(f1) < LowerBoundSeq) then
          f2 = f2 * UpperBoundSeq
          f1 = f1 * UpperBoundSeq
          do l = k, N
            j(l) = j(l) * UpperBoundSeq
          end do
        end if
      end do        
      if (abs(f1) > abs(f2)) then
        scale = j0 / f1
      else
        scale = j1 / f2
      end if                             
      do k = 0, N
        j(k) = scale * j(k)
      end do      
    end if               
    y(0) = - cos(z) / z
    y(1) = (y(0) - sin(z)) / z
    if (N >= 2) then   
      do k = 2, N
        if (abs(j(k-1)) > abs(j(k-2))) then               
          y(k) = (j(k) * y(k-1) - one / z2) / j(k-1)
        else 
          kc   = cmplx(2 * k - 1,0.0,O)
          y(k) = (j(k) * y(k-2) - kc / z3) / j(k-2)
        end if 
      end do 
    end if    
    do k = 0, N
      h(k) = j(k) + im * y(k)
    end do
    do k = 1, N
      kc    = cmplx(k,0.0,O)
      hd(k) = z * h(k-1) - kc * h(k)
    end do
  else    
    do k = 0, N 
      arg  = 0.5_O * real(k + 1,O) * pi
      argc = cmplx(arg,0.0,O)     
      j(k) = cos (z - argc) / z
      y(k) = sin (z - argc) / z
      h(k) = j(k) + im * y(k) 
    end do   
    do k = 1, N
      kc    = cmplx(k,0.0,O)
      hd(k) = z * h(k-1) - kc * h(k)
    end do
  end if
end subroutine besel_h_complete
!***********************************************************************************
subroutine J01 (z, J0, J1)
  use parameters
  use derived_parameters
  implicit none
  complex(O) :: z, J0, J1
!
  complex(O) :: z2, z1, r, t1, p0, q0, u, t2, p1, q1, kc
  real(O)    :: a0, rp2, A(12), B(12), A1(12), B1(12)
  integer    :: k, k0 
!
  rp2 = 2._O / pi
  a0  = abs(z)
  z2  = z * z
  z1  = z
  if (a0 == 0._O) then
    J0 = one
    J1 = zero          
  else 
    if (real(z) < 0._O) z1 = - z
    if (a0 <= 12._O) then
      J0 = one
      r  = one
      do k = 1, 40
        kc = cmplx(k * k,0.0,O)             
        r  = - 0.25_O * r * z2 / kc
        J0 = J0 + r
        if (abs(r) < MachEps * abs(J0)) exit
      end do 
      J1 = one
      r  = one
      do k = 1, 40
        kc = cmplx(k * (k + 1),0.0,O)
        r  = - 0.25_O * r * z2 / kc
        J1 = J1 + r
        if (abs(r) < MachEps * abs(J1)) exit
      end do 
      J1 = 0.5_O * z1 * J1      
    else 
      A  = (/-.703125e-01_O          , .1121520996093750e+00_O,                     & 
             -.5725014209747314e+00_O, .6074042001273483e+01_O,                     &
             -.1100171402692467e+03_O, .3038090510922384e+04_O,                     &
             -.1188384262567832e+06_O, .6252951493434797e+07_O,                     &
             -.4259392165047669e+09_O, .3646840080706556e+11_O,                     &
             -.3833534661393944e+13_O, .4854014686852901e+15_O/)
      B  = (/ .732421875e-01_O       ,-.2271080017089844e+00_O,                     &
              .1727727502584457e+01_O,-.2438052969955606e+02_O,                     &
              .5513358961220206e+03_O,-.1825775547429318e+05_O,                     &
              .8328593040162893e+06_O,-.5006958953198893e+08_O,                     &
              .3836255180230433e+10_O,-.3649010818849833e+12_O,                     &
              .4218971570284096e+14_O,-.5827244631566907e+16_O/)
      A1 = (/ .1171875e+00_O         ,-.1441955566406250e+00_O,                     &
              .6765925884246826e+00_O,-.6883914268109947e+01_O,                     &
              .1215978918765359e+03_O,-.3302272294480852e+04_O,                     &
              .1276412726461746e+06_O,-.6656367718817688e+07_O,                     &
              .4502786003050393e+09_O,-.3833857520742790e+11_O,                     &
              .4011838599133198e+13_O,-.5060568503314727e+15_O/)
      B1 = (/-.1025390625e+00_O      , .2775764465332031e+00_O,                     &
             -.1993531733751297e+01_O, .2724882731126854e+02_O,                     &
             -.6038440767050702e+03_O, .1971837591223663e+05_O,                     &
             -.8902978767070678e+06_O, .5310411010968522e+08_O,                     &
             -.4043620325107754e+10_O, .3827011346598605e+12_O,                     &
             -.4406481417852278e+14_o, .6065091351222699e+16_O/)
      k0 = 12
      if (a0 >= 35._O) k0 = 10
      if (a0 >= 50._O) k0 = 8
      t1 = z1 - 0.25_O * pi
      p0 = one
      do k = 1, k0
        p0 = p0 + A(k) * z1**(- 2 * k)
      end do
      q0 = - 0.125_O / z1
      do k = 1, k0
        q0 = q0 + B(k) * z1**(- 2 * k - 1)
      end do
      u  = sqrt(rp2 / z1)
      J0 = u * (p0 * cos(t1) - q0 * sin(t1))      
      t2 = z1 - 0.75_O * pi
      p1 = one
      do k = 1, k0
        p1 = p1 + A1(k) * z1**(- 2 * k)
      end do
      q1 = 0.375_O / z1
      do k = 1, k0
        q1 = q1 + B1(k) * z1**(- 2 * k - 1)
      end do
      J1 = u * (p1 * cos(t2) - q1 * sin(t2))      
    end if 
    if (real(z) < 0._O) then
      J1 = - J1
    end if
  end if     
end subroutine J01
!***********************************************************************************
subroutine bes_J (z, N, J)
!-----------------------------------------------------------------------------------
! The routine computes the cylindrical Bessel function J(z). The order of the      !
! Bessel function varies between 0 and N, and the control parameters ZeroSinXX,    !
! FactNBes, InitBesVal, UpperBoundSeq and LowerBoundSeq are specified in the       !
! routine "DrvParameters" from the file '../TMATROUTINES/MachParam.f90'.           !
!                                                                                  !
! Input parameters:                                                                ! 
! - z (complex) - argument of the cylindrical Bessel functions.                    !
! - N (integer) - maximum order of cylindrical Bessel functions.                   !
!                                                                                  !
! Output parameters:                                                               !
! - J (complex array) - cylindrical Bessel functions.                              !  
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: N
  complex(O) :: z, J(0:N)
!
  complex(O) :: J0, J1, S, S0, f2, f1, f, kc
  real(O)    :: y0, a0
  integer    :: k, M, Ma, Mn, l
!   
  y0 = abs(aimag(z))
  a0 = abs(z)
  do k = 0, N
    J(k) = zero
  end do
  if (a0 < ZeroSinXX) then      
    J(0) = one
  else 
    call J01 (z, J0, J1)      
    J(0) = J0      
    J(1) = J1
    if (N > 1) then   
      if (a0 <= 300._O .or. N > int(0.25_O * a0)) then
        Ma = nint(a0 + 4._O * a0**0.33_O + 2._O + sqrt(101._O + a0)) + 10 
        Mn = N + nint(sqrt(FactNBes * N))
        M  = max(Ma,Mn)                                   
        S  = zero     
        f2 = zero
        f1 = cmplx(InitBesVal,0.0,O) 
        do k = M, 0, -1
          kc = cmplx(k + 1,0.0,O)
          f  = 2._O * kc / z * f1 - f2
          if (k <= N) J(k) = f
          if (k == 2 * int(k / 2) .and. k /= 0) then
            if (y0 <= 1._O) then
              S = S + 2._O * f
            else 
              S = S + (- 1._O)**(k / 2) * 2._O * f
            end if 
          end if    
          f2 = f1
          f1 = f
          if (abs(f1) > UpperBoundSeq) then
            f2 = f2 * LowerBoundSeq
            f1 = f1 * LowerBoundSeq
            S  = S * LowerBoundSeq
            do l = k, N
              J(l) = J(l) * LowerBoundSeq
            end do
          else if (abs(f1) < LowerBoundSeq) then
            f2 = f2 * UpperBoundSeq
            f1 = f1 * UpperBoundSeq
            S  = S * UpperBoundSeq
            do l = k, N
              J(l) = J(l) * UpperBoundSeq
            end do
          end if
        end do 
        if (y0 <= 1._O) then
          S0 = S + f1
        else 
          S0 = (S + f1) / cos(z)
        end if 
        do k = 0, N
          J(k) = J(k) / S0
        end do 
      else      
        do k = 2, N
          kc   = cmplx(k - 1,0.0,O)
          J(k) = 2._O * kc / z * J(k-1) - J(k-2)  
        end do
      end if 
    end if
  endif   
end subroutine bes_J
!***********************************************************************************
subroutine Pmm (theta, m, Pm)
!-----------------------------------------------------------------------------------
! The routine computes the Legendre function Pmm(theta) for m > 0.                 !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none  
  integer :: k, m
  real(O) :: theta, Pm, tamp, f, sth
!
  sth  = sin(theta)
  tamp = 1._O
  do k = 1, m
    f    = real(2 * k - 1,O)
    tamp = f * sth * tamp  
  end do
  Pm = tamp 
end subroutine Pmm
!***********************************************************************************
subroutine pimm (theta, m, pim)
!-----------------------------------------------------------------------------------
! The routine computes the auxiliary function pimm,                                !
!                    pimm(theta) = Pmm[cos(theta)] / sin(theta)                    !
! for m > 1.                                                                       !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer :: k, m
  real(O) :: theta, pim, tamp, f, sth  
!
  sth  = sin(theta)
  tamp = 1._O
  do k = 1, m - 1
    f    = real(2 * k - 1,O)
    tamp = f * sth * tamp  
  end do
  f   = real(2 * m - 1,O)
  pim = f * tamp
end subroutine pimm
!***********************************************************************************
subroutine Leg (theta, m, Nmax, Pnm, dPnm, pinm, taunm)
!-----------------------------------------------------------------------------------
! The routine computes the associated Legendre functions Pnm[cos(theta)], the      !
! derivatives dPn0[cos(theta)] = dPn0[cos(theta)]/d[cos(theta)], and the auxiliary !
! functions pinm(theta) = Pnm[cos(theta)]/sin(theta), and taunm(theta) =           !
! dPnm[cos(theta)]/d(theta) of degree m. The order of the associated Legendre      !
! functions varies between 0 and Nmax, and note that for m > 0, the first m values !
! of Pnm, pinm and taunm (corresponding to the orders 0, 1, ..., m - 1) are zero.  !
! The derivatives dPn0 are computed for the azimuthal mode m = 0 (for m >0, the    !
! Nmax values of dPn0 are zero).                                                   ! 
!                                                                                  !
! Input parameteres:                                                               !
! - theta (real) - polar angle (argument of the associated Legendre functions).    !
! - m (integer) - degree of the associated Legendre functions.                     !
! - Nmax (integer) - maximum order of the associated Legendre functions.           !
!                                                                                  ! 
! Output parameters:                                                               !
! - Pnm (real array) - associated Legendre functions.                              ! 
! - dPnm (real array) - derivatives of the associated Legendre functions           !
!   for m = 0.                                                                     !
! - pinm and taunm (real arrays) - auxiliary functions.                            !  
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none
  real(O) :: theta
  integer :: m, Nmax
  real(O) :: Pnm(0:Nmax), dPnm(0:Nmax), pinm(0:Nmax), taunm(0:Nmax)
!
  real(O) :: Pm, pim, f1, f2, cth, sth
  integer :: n
!
  cth = cos(theta)
  sth = sin(theta)
  if (m == 0) then
    Pnm(0) = 1._O
    Pnm(1) = cth
    do n = 1, Nmax - 1
      f1 = real(2 * n + 1,O) / real(n + 1,O)
      f2 = real(n,O) / real(n + 1,O)
      Pnm(n+1) = f1 * cth * Pnm(n) - f2 * Pnm(n-1)
    end do
  else
    do n = 0, m - 1
      Pnm(n) = 0._O
    end do
    call Pmm (theta, m, Pm)
    Pnm(m) = Pm
    do n = m, Nmax - 1
      f1 = real(2 * n + 1,O) / real(n + 1 - m,O)
      f2 = real(n + m,O) / real(n + 1 - m,O)
      Pnm(n+1) = f1 * cth * Pnm(n) - f2 * Pnm(n-1)
    end do
  end if
  if (m == 0) then
    dPnm(0) = 0._O
    do n = 1, Nmax
      f1 = real(n,O)
      dPnm(n) = f1 * Pnm(n-1) + cth * dPnm(n-1)
    end do
  else
    do n = 0, Nmax
      dPnm(n) = 0._O
    end do
  end if
  if (m == 0) then
    do n = 0, Nmax
      pinm(n)  =   0._O
      taunm(n) = - sth * dPnm(n)
    end do
  else
    if (m == 1) then
      pinm(0)  = 0._O     
      taunm(0) = 0._O
      pinm(1)  = 1._O
    else
      do n = 0, m - 1
        pinm(n)  = 0._O
        taunm(n) = 0._O
      end do
      call pimm (theta, m, pim)
      pinm(m) = pim
    end if
    do n = m, Nmax - 1
      f1 = real(2 * n + 1,O) / real(n + 1 - m,O)
      f2 = real(n + m,O) / real(n + 1 - m,O)
      pinm(n+1) = f1 * cth * pinm(n) - f2 * pinm(n-1)
    end do
    do n = m, Nmax
      f1 = real(n,O)
      f2 = real(n + m,O)
      taunm(n) = f1 * cth * pinm(n) - f2 * pinm(n-1)
    end do
  end if   
end subroutine Leg
!***********************************************************************************
subroutine P_mm_real (theta, m, Pm)
!-----------------------------------------------------------------------------------
! The routine computes the normalized Legendre function Pmm(theta) of real         !
! argument (real angle).                                                           !  
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer :: k, m
  real(O) :: theta, Pm, tamp, f, cth, sth
!
  cth = cos(theta)
  sth = sin(theta) 
  if (m == 0) then
    Pm = sqrt(3._O / 2._O) * cth
  else
    tamp = 1._O
    do k = 1, m
      f    = sqrt(real(m + k,O) / 4._O / real(k,O))
      tamp = f * sth * tamp        
    end do
    f  = sqrt(real(2 * m + 1,O) / 2._O)
    Pm = f * tamp
  end if
end subroutine P_mm_real
!***********************************************************************************
subroutine pi_mm_real (theta, m, pim)
!-----------------------------------------------------------------------------------
! The routine computes the normalized auxiliary function pimm,                     !
!                    pimm(theta) = Pmm[cos(theta)] / sin(theta)                    !
! of real argument (real angle).                                                   !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer :: k, m
  real(O) :: theta, pim, tamp, f, sth
!
  sth = sin(theta)
  if (m == 0) then
    pim = 0._O
  else
    tamp = 1._O
    do k = 1, m - 1
      f    = sqrt(real(m + k,O) / 4._O / real(k,O))
      tamp = f * sth * tamp        
    end do   
    f   = sqrt(real(2 * m + 1,O)) / 2._O
    pim = f * tamp
  end if
end subroutine pi_mm_real
!***********************************************************************************
subroutine tau_mm_real (theta, m, taum)
!-----------------------------------------------------------------------------------
! The routine computes the normalized auxiliary function taumm,                    !
!                  taumm(theta) = dPmm[cos(theta)] / d(theta)                      !
! of real argument (real angle).                                                   !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer :: k, m
  real(O) :: theta, taum, tamp, f, cth, sth  
!
  cth = cos(theta)
  sth = sin(theta)
  if (m == 0) then
    taum = - sqrt(3._O / 2._O) * sth
  else
    tamp = 1._O
    do k = 1, m - 1
      f    = sqrt(real(m + k,O) / 4._O / real(k,O)) 
      tamp = f * sth * tamp       
    end do
    f    = real(m,O) * sqrt(real(2 * m + 1,O)) / 2._O
    taum = f * cth * tamp
  end if
end subroutine tau_mm_real
!***********************************************************************************
subroutine Leg_normalized (theta, m, Nmax, Pnm, dPnm, pinm, taunm)
!------------------------------------------------------------------------------------
! The routine computes the normalized associated Legendre functions                 !
! Pnm[cos(theta)], the derivatives dPn0[cos(theta)] = dPn0[cos(theta)]/d[cos(theta)]!
! and the auxiliary functions pinm(theta) = Pnm[cos(theta)]/sin(theta), and         !
! taunm(theta) = dPnm[cos(theta)]/d(theta) of degree m. The order of the normalized !
! associated Legendre functions varies between 0 and Nmax, and note that for        !
! m > 0, the first m values of Pnm, pinm and taunm (corresponding to the orders     !
! 0, 1, ..., m - 1)are zero. The derivatives dPn0 are computed for the azimuthal    !
! mode m = 0 (for m >0, the Nmax values of dPn0 are zero).                          ! 
!                                                                                   !
! Input parameteres:                                                                !
! - theta (real) - polar angle (argument of the normalized associated Legendre      !
!   functions).                                                                     !
! - m (integer) - degree of the normalized associated Legendre functions.           !
! - Nmax (integer) - maximum order of the normalized associated Legendre            !
!   functions.                                                                      !
!                                                                                   ! 
! Output parameters:                                                                !
! - Pnm (real array) - normalized associated Legendre functions.                    ! 
! - dPnm (real array) - derivatives of the normalized associated Legendre           !
!   functions for m = 0.                                                            !
! - pinm and taunm (real arrays) - normalized auxiliary functions.                  !  
!------------------------------------------------------------------------------------ 
  use parameters
  implicit none
  real(O) :: theta
  integer :: m, Nmax
  real(O) :: Pnm(0:Nmax), dPnm(0:Nmax), pinm(0:Nmax), taunm(0:Nmax)
!
  real(O) :: Pm, pim, f1, f2, cth, sth
  integer :: n
!
  cth = cos(theta)
  sth = sin(theta)
  if (m == 0) then
    Pnm(0) = sqrt(2._O) / 2._O
    Pnm(1) = sqrt(3._O / 2._O) * cos(theta)
    do n = 1, Nmax - 1
      f1 = sqrt(real(2 * n + 1,O) / real(n + 1,O))
      f1 = f1 * sqrt(real(2 * n + 3,O) / real(n + 1,O))
      f2 = sqrt(real(2 * n + 3,O) / real(2 * n - 1,O))
      f2 = f2 * real(n,O) / real(n + 1,O)
      Pnm(n+1) = f1 * cth * Pnm(n) - f2 * Pnm(n-1)
    end do
  else
    do n = 0, m - 1
      Pnm(n) = 0._O
    end do
    call P_mm_real (theta, m, Pm)
    Pnm(m) = Pm
    do n = m, Nmax - 1
      f1 = sqrt(real(2 * n + 1,O) / real(n + 1 - m,O))
      f1 = f1 * sqrt(real(2 * n + 3,O) / real(n + 1 + m,O))
      f2 = sqrt(real(2 * n + 3,O) / real(2 * n - 1,O))
      f2 = f2 * sqrt(real(n - m,O) / real(n - m + 1,O))
      f2 = f2 * sqrt(real(n + m,O) / real(n + m + 1,O))
      Pnm(n+1) = f1 * cth * Pnm(n) - f2 * Pnm(n-1)
    end do
  end if
  if (m == 0) then
    dPnm(0) = 0._O
    do n = 1, Nmax
      f2 = sqrt(real(2 * n + 1,O) / real(2 * n - 1,O))
      f1 = real(n,O) * f2
      dPnm(n) = f1 * Pnm(n-1) + f2 * cth * dPnm(n-1)
    end do
  else
    do n = 0, Nmax
      dPnm(n) = 0._O
    end do
  end if
  if (m == 0) then
    do n = 0, Nmax
      pinm(n)  =   0._O
      taunm(n) = - sth * dPnm(n)
    end do
  else
    if (m == 1) then
      pinm(0)  = 0._O     
      taunm(0) = 0._O
      pinm(1)  = sqrt(3._O) / 2._O
    else
      do n = 0, m - 1
        pinm(n)  = 0._O
        taunm(n) = 0._O
      end do
      call pi_mm_real (theta, m, pim)
      pinm(m) = pim
    end if
    do n = m, Nmax - 1
      f1 = sqrt(real(2 * n + 1,O) / real(n + 1 - m,O))
      f1 = f1 * sqrt(real(2 * n + 3,O) / real(n + 1 + m,O))
      f2 = sqrt(real(2 * n + 3,O) / real(2 * n - 1,O))
      f2 = f2 * sqrt(real(n - m,O) / real(n - m + 1,O))
      f2 = f2 * sqrt(real(n + m,O) / real(n + m + 1,O))
      pinm(n+1) = f1 * cth * pinm(n) - f2 * pinm(n-1)
    end do
    do n = m, Nmax
      f1 = real(n,O)
      f2 = sqrt(real(2 * n + 1,O) / real(2 * n - 1,O))
      f2 = f2 * sqrt(real(n - m,O) / real(n + m,O))
      f2 = f2 * real(n + m,O)
      taunm(n) = f1 * cth * pinm(n) - f2 * pinm(n-1)
    end do
  end if   
end subroutine Leg_normalized
!***********************************************************************************
subroutine P_mm (sint, cost, m, Pm)
!-----------------------------------------------------------------------------------
! The routine computes the normalized Legendre function Pmm(theta) of complex      !
! argument (complex angle).                                                        !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer     :: k, m
  real(O)     :: f
  complex(O)  :: sint, cost, Pm, tamp  
!
  if (m == 0) then
    Pm = sqrt(3._O/2._O) * cost
  else
    tamp = one
    do k = 1, m
      f    = sqrt(real(m + k,O) / 4._O / real(k,O)) 
      tamp = f * sint * tamp  
    end do
    f  = sqrt(real(2 * m + 1,O) / 2._O)
    Pm = f * tamp
  end if 
end subroutine P_mm
!***********************************************************************************
subroutine pi_mm (sint, m, pim)
!-----------------------------------------------------------------------------------
! The routine computes the normalized auxiliary function                           !
!                     pimm(theta) = Pmm[cos(theta)] / sin(theta)                   !
! of complex argument (complex angle).                                             !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer     :: k, m
  real(O)     :: f
  complex(O)  :: sint, pim, tamp  
!
  if (m == 0) then
    pim = zero
  else
    tamp = one
    do k = 1, m - 1
      f    = sqrt(real(m + k,O) / 4._O / real(k,O))
      tamp = sint * f * tamp  
    end do    
    f   = sqrt(real(2 * m + 1,O)) / 2._O
    pim = f * tamp
  end if 
end subroutine pi_mm
!***********************************************************************************
subroutine tau_mm (sint, cost, m, taum)
!-----------------------------------------------------------------------------------
! The routine computes the normalized auxiliary function                           !
!                      taumm(theta) = dPmm[cos(theta)] / d(theta)                  !
! of complex argument (complex angle).                                             !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer     :: k, m
  real(O)     :: f
  complex(O)  :: sint, cost, taum, tamp  
!
  if (m == 0) then
    taum = - sqrt(3._O / 2._O) * sint
  else
    tamp = one
    do k = 1, m - 1
      f    = sqrt(real(m + k,O) / 4._O / real(k,O))
      tamp = f * sint * tamp   
    end do    
    f    = real(m,O) * sqrt(real(2 * m + 1,O)) / 2._O
    taum = f * cost * tamp
  end if 
end subroutine tau_mm
!***********************************************************************************
subroutine Leg_normalized_complex (sint, cost, m, Nmax, Pnm, dPnm, pinm, taunm)
!------------------------------------------------------------------------------------
! The routine computes the normalized associated Legendre functions                 !
! Pnm[cos(theta)], the derivatives dPn0[cos(theta)] = dPn0[cos(theta)]/d[cos(theta)]!
! and the auxiliary functions pinm(theta) = Pnm[cos(theta)]/sin(theta), and         !
! taunm(theta) = dPnm[cos(theta)]/d(theta) of degree m and complex argument.        !
! The order of the normalized  associated Legendre functions varies between 0 and   !
! Nmax, and note that for m > 0, the first m values of Pnm, pinm and taunm          !
! (corresponding to the orders 0, 1, ..., m - 1) are zero. The derivatives dPn0     !
! are computed for the azimuthal mode m = 0 (for m >0, the Nmax values of dPn0      !
! are zero).                                                                        ! 
!                                                                                   !
! Input parameteres:                                                                !
! - sint (complex) - sint = sin(theta), where theta is the complex polar angle.     !
! - cost (complex) - cost = cos(theta), where theta is the complex polar angle.     !
! - m (integer) - degree of the normalized associated Legendre functions.           !
! - Nmax (integer) - maximum order of the normalized associated Legendre            !
!   functions.                                                                      !
!                                                                                   ! 
! Output parameters:                                                                !
! - Pnm (complex array) - normalized associated Legendre functions.                 ! 
! - dPnm (complex array) - derivatives of the normalized associated Legendre        !
!   functions for m = 0.                                                            !
! - pinm and taunm (complex arrays) - normalized auxiliary functions.               !  
!------------------------------------------------------------------------------------ 
  use parameters
  implicit none
  integer     :: m, Nmax
  complex(O)  :: sint, cost
  complex(O)  :: Pnm(0:Nmax), dPnm(0:Nmax), pinm(0:Nmax), taunm(0:Nmax)
!
  complex(O)  :: Pm, pim
  real(O)     :: f1, f2
  integer     :: n
!
  if (m == 0) then
    Pnm(0) = cmplx(sqrt(2._O) / 2._O,0.0,O)
    Pnm(1) = sqrt(3._O / 2._O) * cost
    do n = 1, Nmax - 1
      f1 = sqrt(real(2 * n + 1,O) / real(n + 1,O))
      f1 = f1 * sqrt(real(2 * n + 3,O) / real(n + 1,O))
      f2 = sqrt(real(2 * n + 3,O) / real(2 * n - 1,O))
      f2 = f2 * real(n,O) / real(n + 1,O)
      Pnm(n+1) = f1 * cost * Pnm(n) - f2 * Pnm(n-1)
    end do
  else
    do n = 0, m - 1
      Pnm(n) = zero
    end do
    call P_mm (sint, cost, m, Pm)
    Pnm(m) = Pm
    do n = m, Nmax - 1
      f1 = sqrt(real(2 * n + 1,O) / real(n + 1 - m,O))
      f1 = f1 * sqrt(real(2 * n + 3,O) / real(n + 1 + m,O))
      f2 = sqrt(real(2 * n + 3,O) / real(2 * n - 1,O))
      f2 = f2 * sqrt(real(n - m,O) / real(n - m + 1,O))
      f2 = f2 * sqrt(real(n + m,O) / real(n + m + 1,O))
      Pnm(n+1) = f1 * cost * Pnm(n) - f2 * Pnm(n-1)
    end do
  end if
  if (m == 0) then
    dPnm(0) = zero
    do n = 1, Nmax
      f2 = sqrt(real(2 * n + 1,O) / real(2 * n - 1,O))
      f1 = real(n,O) * f2
      dPnm(n) = f1 * Pnm(n-1) + f2 * cost * dPnm(n-1)
    end do
  else
    do n = 0, Nmax
      dPnm(n) = zero
    end do
  end if
  if (m == 0) then
    do n = 0, Nmax
      pinm(n)  =   zero
      taunm(n) = - sint * dPnm(n)
    end do
  else
    if (m == 1) then
      pinm(0)  = zero
      taunm(0) = zero
      pinm(1)  = cmplx(sqrt(3._O) / 2._O,0.0,O)
    else
      do n = 0, m - 1
        pinm(n)  = zero
        taunm(n) = zero
      end do
      call pi_mm (sint, m, pim)     
      pinm(m) = pim
    end if
    do n = m, Nmax - 1
      f1 = sqrt(real(2 * n + 1,O) / real(n + 1 - m,O))
      f1 = f1 * sqrt(real(2 * n + 3,O) / real(n + 1 + m,O))
      f2 = sqrt(real(2 * n + 3,O) / real(2 * n - 1,O))
      f2 = f2 * sqrt(real(n - m,O) / real(n - m + 1,O))
      f2 = f2 * sqrt(real(n + m,O) / real(n + m + 1,O))
      pinm(n+1) = f1 * cost * pinm(n) - f2 * pinm(n-1)
    end do
    do n = m, Nmax
      f1 = real(n,O)
      f2 = sqrt(real(2 * n + 1,O) / real(2 * n - 1,O))
      f2 = f2 * sqrt(real(n - m,O) / real(n + m,O))
      f2 = f2 * real(n + m,O)
      taunm(n) = f1 * cost * pinm(n) - f2 * pinm(n-1)
    end do    
  end if   
end subroutine Leg_normalized_complex
! **********************************************************************************
! *       ALTERNATIVE ROUTINES FOR COMPUTING THE SPHERICAL BESSEL AND HANKEL       *
! *               FUNCTIONS AND THE CYLINDRICAL BESSEL FUNCTIONS                   *
! **********************************************************************************
subroutine besel_jA (z, N, j, jd)
!-----------------------------------------------------------------------------------
! The routine computes the spherical Bessel functions j(z) and the derivatives     !
! jd(z) = d(z*j(z))/dz. The order of the Bessel functions varies between 0 and N,  !
! and the backward recurrence relation                                             !
!          csi(n,z) = 1.0 / ((2n+1) / z - csi(n+1,z)), n = Nstart,...,1,           !
! and the forward recurrence relations                                             !
!          j(n,z)   = csi(n,z) * j(n-1,z)                                          !
!          jd(n,z)  = ( z - n * csi(n,z)) * j(n-1,z),    n = 1,...,N,              !
! with j(0,z) = sin(z) / z, are used for computation. Here Nstart is the downward  !
! starting index and j(n,z) denotes the Bessel function of order n and argument z. !
! Note that:                                                                       !
!          csi(n,z) = j(n,z) / j(n-1,z).                                           ! 
! The following parmeters control the computation:                                 !                                
! - ZeroSinXX (real) - for |z| < ZeroSinXX, we set j(0,z) = sin(z)/z = 1 and       !
!   j(n,z) = 0, for n = 1,2,...,N.                                                 !
! - NIterBes (integer) - maximum number of backward recurrences. Default value     !
!   NIterBes = 5000.                                                               !
! - TolJ0Val (real) - if abs(j(0,z) - sin(z)/z) > TolJ0Val, the starting index     !
!   Nstart (of the backward recurrence) is increased by 20 and the recurrence is   !
!   restarted. Default value: TolJ0Val = MachEps**0.666_O                          !
! These parameters are specified in the routine "DrvParameters" from the file      !
! '../TMATROUTINES/MachParam.f90'.                                                 !
!                                                                                  !
! Input parameters:                                                                ! 
! - z (complex) - argument of the spherical Bessel functions.                      !
! - N (integer) - maximum order of the spherical Bessel functions.                 !
!                                                                                  !
! Output parameters:                                                               !
! - j  (complex array) - spherical Bessel functions.                               !
! - jd (complex array) - derivatives of the spherical Bessel functions.            !
!                                                                                  !
! Note: This routine does not use the asymptotic expressions of spherical Bessel   !
! functions for large arguments.                                                   !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: N
  complex(O) :: z, j(0:N), jd(0:N)
!  
  integer    :: M, k
  real(O)    :: a0, deps
  complex(O) :: csin1, csin, fct, j0, kc
  logical    :: more
  complex(O),allocatable :: csi(:)
!                   
  a0 = abs(z)   
  allocate (csi(N))
  do k = 0, N 
    j(k)  = zero
    jd(k) = zero
  end do
  if (a0 < ZeroSinXX) then
    j(0) = one
  else
    j(0)  = sin(z) / z
    j(1)  = j(0) / z - cos(z) / z
    jd(1) = z * j(0) - j(1)
    if (N >= 2) then
      M = N + nint(a0 + 4._O * a0**0.33_O + 2._O + sqrt(101._O + a0)) + 10 
      more = .true.       
      do while (more .and. M < NIterBes)
        csin1 = zero
        do k = M, 1, -1        
          fct  = cmplx(2 * k + 1,0.0,O) / z
          csin = one / (fct - csin1)
          if (k <= N) csi(k) = csin
          csin1 = csin
        end do
        j(0) = cos(z) / (one - z * csi(1))
        j0   = sin(z) / z 
        deps = abs (j0 - j(0))                          
        if (deps < TolJ0Val) then
          more = .false.
        else
          M = M + 20
        end if
      end do
      if (more) then
        print "(/,2x,'Error in subroutine besel_j:')"
        print "(2x,'the  csi  sequence can not be computed with the desired accuracy.')"
        print "(2x,'The tolerance TolJ0Val or the iteration number NIterBes specified')"
        print "(2x,'in the subroutine MachParam are too low.                         ')"
        stop 
      end if              
      j(1)  = csi(1) * j(0)
      jd(1) = (z - csi(1)) * j(0)
      do k = 2, N
        kc    = cmplx(k,0.0,O)
        j(k)  = csi(k) * j(k-1)
        jd(k) = (z - kc * csi(k)) * j(k-1)
      end do      
    end if     
  end if 
  deallocate (csi)
end subroutine besel_jA
!**********************************************************************************
subroutine besel_hA (z, N, h, hd)
!-----------------------------------------------------------------------------------
! The routine computes the spherical Hankel functions of the first kind            !
! h(z) = j(z) + i*y(z) and the derivatives hd(z) = d(z*h(z))/dz, where j(z) and    !
! y(z) are the spherical Bessel and Neumann functions, respectively. The order of  !
! the functions varies between 0 and N, and the control parameters ZeroSinXX,      !
! NIterBes and TolJ0Val are specified in the routine "DrvParameters" from the file !
! '../TMATROUTINES/MachParam.f90'.                                                 !
!                                                                                  !
! Input parameters:                                                                ! 
! - z (complex) - argument of the spherical Hankel functions.                      !
! - N (integer) - maximum order of the spherical Hankel functions.                 !
!                                                                                  !
! Output parameters:                                                               !
! - h  (complex array) - spherical Hankel functions.                               !
! - hd (complex array) - derivatives of the spherical Hankel functions.            !
!                                                                                  !
! Note: This routine does not use the asymptotic expressions of spherical Bessel   !
! functions for large arguments.                                                   !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: N
  complex(O) :: z, h(0:N), hd(0:N)
!
  integer    :: M, k
  real(O)    :: a0, deps
  complex(O) :: csin1, csin, fct, j0, kc, z2, z3
  logical    :: more
  complex(O),allocatable :: csi(:), j(:), y(:)
!                   
  z2 = z * z
  z3 = z2 * z
  a0 = abs(z)
  allocate (csi(N), j(0:N), y(0:N))
  do k = 0, N 
    j(k)  = zero
    y(k)  = zero
    h(k)  = zero
    hd(k) = zero
  end do
  if (a0 < ZeroSinXX) then
    j(0) = one
  else
    j(0) = sin(z) / z
    j(1) = j(0) / z - cos(z) / z
    if (N >= 2) then
      M = N + nint(a0 + 4._O * a0**0.33_O + 2._O + sqrt(101._O + a0)) + 10
      more = .true.       
      do while (more .and. M < NIterBes)
        csin1 = zero
        do k = M, 1, -1        
          fct  = cmplx(2 * k + 1,0.0,O) / z
          csin = one / (fct - csin1)
          if (k <= N) csi(k) = csin
          csin1 = csin
        end do
        j(0) = cos(z) / (one - z * csi(1))
        j0   = sin(z) / z 
        deps = abs (j0 - j(0))                          
        if (deps < TolJ0Val) then
          more = .false.
        else
          M = M + 20
        end if
      end do  
      if (more) then
        print "(/,2x,'Error in subroutine besel_h:')"
        print "(2x,'the  csi  sequence can not be computed with the desired accuracy.')"
        print "(2x,'The tolerance TolJ0Val or the iteration number NIterBes specified')"
        print "(2x,'in the subroutine MachParam are too low.                         ')"                
        stop 
      end if              
      j(1) = csi(1) * j(0)    
      do k = 2, N       
        j(k) = csi(k) * j(k-1)              
      end do      
    end if               
    y(0) = - cos(z) / z
    y(1) = (y(0) - sin(z)) / z
    if (N >= 2) then   
      do k = 2, N
        if (abs(j(k-1)) > abs(j(k-2))) then               
          y(k) = (j(k) * y(k-1) - one / z2) / j(k-1)
        else 
          kc   = cmplx(2 * k - 1,0.0,O)
          y(k) = (j(k) * y(k-2) - kc / z3) / j(k-2)
        end if 
      end do 
    end if    
    do k = 0, N
      h(k) = j(k) + im * y(k)
    end do
    do k = 1, N
      kc    = cmplx(k,0.0,O)
      hd(k) = z * h(k-1) - kc * h(k)
    end do
  end if
  deallocate (csi, j, y)
end subroutine besel_hA
!**********************************************************************************
subroutine besel_h_completeA (z, N, j, y, h, hd)
!-----------------------------------------------------------------------------------
! The routine computes the spherical Bessel and Neumann functions j(z) and y(z),   !
! the spherical Hankel functions of the first kind h(z) = j(z) + i*y(z) and the    !
! derivatives hd(z) = d(z*h(z))/dz. The order of the functions varies between 0    !
! and N, and the control parameters ZeroSinXX, NIterBes and TolJ0Val are specified !
! in the routine "DrvParameters" from the file '../TMATROUTINES/MachParam.f90'.    !
!                                                                                  !
! Input parameters:                                                                ! 
! - z (complex) - argument of the spherical Bessel, Neumann and Hankel functions.  !
! - N (integer) - maximum order of the spherical functions.                        !
!                                                                                  !
! Output parameters:                                                               !
! - j  (complex array) - spherical Bessel functions.                               !
! - y  (complex array) - spherical Neumann functions.                              !
! - h  (complex array) - spherical Hankel functions.                               !
! - hd (complex array) - derivatives of the spherical Hankel functions.            !
!                                                                                  !
! Note: This routine does not use the asymptotic expressions of spherical Bessel   !
! functions for large arguments.                                                   !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: N
  complex(O) :: z, j(0:N), y(0:N), h(0:N), hd(0:N)
!
  integer    :: M, k
  real(O)    :: a0, deps
  complex(O) :: csin1, csin, fct, j0, kc, z2, z3
  logical    :: more
  complex(O),allocatable :: csi(:)
!                   
  z2 = z * z
  z3 = z2 * z
  a0 = abs(z)  
  allocate (csi(N))
  do k = 0, N 
    j(k)  = zero
    y(k)  = zero
    h(k)  = zero
    hd(k) = zero
  end do
  if (a0 < ZeroSinXX) then
    j(0) = one
  else
    j(0) = sin(z) / z
    j(1) = j(0) / z - cos(z) / z
    if (N >= 2) then
      M = N + nint(a0 + 4._O * a0**0.33_O + 2._O + sqrt(101._O + a0)) + 10
      more = .true.       
      do while (more .and. M < NIterBes)
        csin1 = zero
        do k = M, 1, -1        
          fct  = cmplx(2 * k + 1,0.0,O) / z
          csin = one / (fct - csin1)
          if (k <= N) csi(k) = csin
          csin1 = csin
        end do
        j(0) = cos(z) / (one - z * csi(1))
        j0   = sin(z) / z 
        deps = abs (j0 - j(0))                          
        if (deps < TolJ0Val) then
          more = .false.
        else
          M = M + 20
        end if
      end do
      if (more) then
        print "(/,2x,'Error in subroutine besel_h_complete:')"
        print "(2x,'the  csi  sequence can not be computed with the desired accuracy.')"
        print "(2x,'The tolerance TolJ0Val or the iteration number NIterBes specified')"
        print "(2x,'in the subroutine MachParam are too low.                         ')"                
        stop 
      end if              
      j(1) = csi(1) * j(0)    
      do k = 2, N       
        j(k) = csi(k) * j(k-1)              
      end do      
    end if               
    y(0) = - cos(z) / z
    y(1) = (y(0) - sin(z)) / z
    if (N >= 2) then   
      do k = 2, N
        if (abs(j(k-1)) > abs(j(k-2))) then               
          y(k) = (j(k) * y(k-1) - one / z2) / j(k-1)
        else 
          kc   = cmplx(2 * k - 1,0.0,O)
          y(k) = (j(k) * y(k-2) - kc / z3) / j(k-2)
        end if 
      end do 
    end if    
    do k = 0, N
      h(k) = j(k) + im * y(k)
    end do
    do k = 1, N
      kc    = cmplx(k,0.0,O)
      hd(k) = z * h(k-1) - kc * h(k)
    end do
  end if
  deallocate (csi)
end subroutine besel_h_completeA
! **********************************************************************************
subroutine besel_jB (z, N, j, y)
!-----------------------------------------------------------------------------------
! The routine computes the spherical Bessel functions j(z) and the spherical       !
! Neumann functions y(z). The order of the functions varies between 0 and N, and   !
! a backward recurrence relation is used to compute the Bessel functions, while    !
! an upward recurrence relation is employed to compute the spherical Neumann       !
! functions. The control parameters ZeroSinXX, FactNBes, InitBesVal, UpperBoundSeq !
! and LowerBoundSeq are specified in the routine "DrvParameters" from the file     !
! '../TMATROUTINES/MachParam.f90'.                                                 !
!                                                                                  !
! Input parameters:                                                                ! 
! - z (complex) - argument of the spherical Bessel and Neumann functions.          !
! - N (integer) - maximum order of the spherical functions.                        !
!                                                                                  !
! Output parameters:                                                               !
! - j (complex array) - spherical Bessel functions.                                !
! - y (complex array) - spherical Neumann functions.                               !
!                                                                                  !
! Note: This routine does not use the asymptotic expressions of spherical Bessel   !
! functions for large arguments.                                                   !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: N
  complex(O) :: z, j(0:N), y(0:N)
!
  complex(O) :: j0, j1, j2, f2, f1, f, kc, scale, z2, z3
  real(O)    :: a0, ajscale
  integer    :: M, Ma, Mn, k, l
!
  z2 = z * z
  z3 = z2 * z
  a0 = abs(z) 
  do k = 0, N 
    j(k) = zero
    y(k) = zero
  end do
  if (a0 < ZeroSinXX) then
    j(0) = one
  else
    j(0) = sin(z) / z
    j(1) = j(0) / z - cos(z) / z
    if (N >= 2) then
      j0 = j(0)
      j1 = j(1)
      j2 = 3._O * j1 / z - j0
      Ma = nint(a0 + 4._O * a0**0.33_O + 2._O + sqrt(101._O + a0)) + 10 
      Mn = N + nint(sqrt(FactNBes * N))
      M  = max(Ma,Mn)  
      f2 = zero
      f1 = cmplx(InitBesVal,0.0,O)
      do k = M - 1, N, -1
        kc = cmplx(2 * k + 1,0.0,O)
        f  = kc * f1 / z - f2               
        f2 = f1
        f1 = f
        if (abs(f1) > UpperBoundSeq) then
          f2 = f2 * LowerBoundSeq
          f1 = f1 * LowerBoundSeq             
        else if (abs(f1) < LowerBoundSeq) then
          f2 = f2 * UpperBoundSeq
          f1 = f1 * UpperBoundSeq            
        end if        
      end do
      j(N)   = f2
      j(N-1) = f1
      do k = N - 1, 1, -1
        kc = cmplx(2 * k + 1,0.0,O)
        j(k-1) = kc * j(k)/z - j(k+1)
        if (abs(j(k-1)) > UpperBoundSeq) then           
          do l = k - 1, N
            j(l) = j(l) * LowerBoundSeq
          end do
        else if (abs(j(k-1)) < LowerBoundSeq) then          
          do l = k - 1, N
            j(l) = j(l) * UpperBoundSeq
          end do 
        end if
      end do
      ajscale = max(abs(j0), abs(j1), abs(j2))
      if (ajscale == abs(j0)) then
        scale = j0 / j(0)
      else if (ajscale == abs(j1)) then
        scale = j1 / j(1)
      else
        scale = j2 / j(2)           
      end if
      do k = 0, N
        j(k) = scale * j(k)
      end do
    end if 
    y(0) = - cos(z) / z
    y(1) = (y(0) - sin(z)) / z
    if (N >= 2) then   
      do k = 2, N
        if (abs(j(k-1)) > abs(j(k-2))) then
          y(k) = (j(k) * y(k-1) - 1._O / z2) / j(k-1)
        else 
          kc   = cmplx(2 * k - 1,0.0,O)
          y(k) = (j(k) * y(k-2) - kc / z3) / j(k-2)
        end if 
      end do 
    end if
  end if 
end subroutine besel_jB
!***********************************************************************************
subroutine besel_jC (z, N, j, y)
!-----------------------------------------------------------------------------------
! The routine computes the spherical Bessel functions j(z) and the spherical       !
! Neumann functions y(z). The order of the functions varies between 0 and N, and   !
! a backward recurrence relation is used to compute the Bessel functions, while    !
! an upward recurrence relation is employed to compute the spherical Neumann       !
! functions. The parameters which control the computation are ZeroSinXX,           !
! InitBesVal, UpperBoundSeq, LowerBoundSeq and LargestBesVal. LargestBesVal        !
! is real and denotes the largest (accepted) values of the spherical Neumann       !
! functions (default value: LargestBesVal = LargestPosNumber**0.333). These        !
! parameters are specified in the routine "DrvParameters" from the file            !
! '../TMATROUTINES/MachParam.f90'.                                                 !
!                                                                                  !
! Input parameters:                                                                ! 
! - z (complex) - argument of the spherical Bessel functions.                      !
! - N (integer) - maximum order of the spherical Bessel functions.                 !
!                                                                                  !
! Output parameters:                                                               !
! - j (complex array) - spherical Bessel functions.                                !
! - y (complex array) - spherical Neumann functions.                               !
!                                                                                  !
! Note: This routine does not use the asymptotic expressions of spherical Bessel   !
! functions for large arguments.                                                   !
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none
  integer    :: N
  complex(O) :: z, j(0:N), y(0:N)
!
  complex(O) :: j0, j1, j2, f2, f1, f, y0, y1, g0, g1, yk, h2, h1, h0, yl2, yl1,    &
                ylk, P11, P12, P21, P22, scale, z2, kc
  real(O)    :: a0, yak, ya1, wa, ya0, ajscale
  integer    :: NM, M, k, l, LB, LB0, MSTA1, MSTA2
!
  z2 = z * z
  a0 = abs(z) 
  NM = N         
  do k = 0, N 
    j(k) = zero
    y(k) = zero
  end do
  if (a0 < ZeroSinXX) then
    j(0) = one
  else
    j(0) = sin(z) / z
    j(1) = (j(0) - cos(z)) / z
    if (NM >= 2) then
       j0 = j(0)
       j1 = j(1)
       j2 = 3._O * j1 / z - j0      
       M  = MSTA1 (a0, 200)
       if (M < N) then
         NM = M       
       else 
         M = MSTA2 (A0, N, 15)
       end if                                   
       f2 = zero
       f1 = cmplx(InitBesVal,0.0,O)
       do k = M - 1, NM, -1
         kc = cmplx(2 * k + 1,0.0,O)
         f  = kc * f1 / z - f2   
         f2 = f1
         f1 = f
         if (abs(f1) > UpperBoundSeq) then
           f2 = f2 * LowerBoundSeq
           f1 = f1 * LowerBoundSeq            
         else if (abs(f1) < LowerBoundSeq) then
           f2 = f2 * UpperBoundSeq
           f1 = f1 * UpperBoundSeq           
         end if         
       end do
       j(NM)   = f2
       j(NM-1) = f1
       do k = NM - 1, 1, -1
         kc     = cmplx(2 * k + 1,0.0,O) 
         j(k-1) = kc * j(k) / z - j(k+1)
         if (abs(j(k-1)) > UpperBoundSeq) then      
           do l = k - 1, NM
             j(l) = j(l) * LowerBoundSeq
           end do
         else if (abs(j(k-1)) < LowerBoundSeq) then         
           do l = k - 1, NM
             j(l) = j(l) * UpperBoundSeq
           end do 
         end if 
       end do
       ajscale = max(abs(j0), abs(j1), abs(j2))
       if (ajscale == abs(j0)) then
         scale = j0 / j(0)
       else if (ajscale == abs(j1)) then
         scale = j1 / j(1)
       else
         scale = j2 / j(2)
       end if          
       do k = 0, NM
         j(k) = scale * j(k)
       end do
    end if 
    y(0) = - cos(z) / z
    y(1) = (y(0) - sin(z)) / z    
    if (NM >= 2) then
       y0  = y(0)
       y1  = y(1)   
       ya0 = abs(y0)
       LB  = 0
       g0  = y0
       g1  = y1
       do k = 2, NM
         kc = cmplx(2 * k - 1,0.0,O)
         yk = kc / z * g1 - g0
         if (abs (yk) > LargestBesVal) exit  
         yak = abs(yk)
         ya1 = abs(g0)
         if ((yak < ya0) .and. (yak < ya1)) LB = k
         y(k) = yk
         g0   = g1
         g1   = yk
       end do       
       do while ((LB > 4) .and. (aimag(z) /= 0._O) .and. (LB /= LB0))     
         h2  = one
         h1  = zero
         LB0 = LB
         do k = LB, 1, -1
           kc = cmplx(2 * k + 1,0.0,O)
           h0 = kc / z * h1 - h2
           h2 = h1
           h1 = h0
         end do
         P12 = h0
         P22 = h2
         h2  = zero
         h1  = one
         do k = LB, 1, -1
           kc = cmplx(2 * k + 1,0.0,O)
           h0 = kc / z * h1 - h2
           h2 = h1
           h1 = h0
         end do
         P11 = h0
         P21 = h2
         if (LB == NM) j(LB+1) = (2._O * LB + 1._O) / z * j(LB) - j(LB-1)
         if (abs(j(0)) > abs(j(1))) then                   
           y(LB+1) = (j(LB+1) * y0 - P11 / z2) / j(0)
           y(LB)   = (j(LB) * y0   + P12 / z2) / j(0)
         else 
           y(LB+1) = (j(LB+1) * y1 - P21 / z2) / j(1)
           y(LB)   = (j(LB) * y1   + P22 / z2) / j(1)
         end if 
         yl2 = y(LB+1)
         yl1 = y(LB)
         do k = LB - 1, 0, -1
           kc = cmplx(2 * k + 3,0.0,O)
           ylk = kc / z * yl1 - yl2
           y(k)= ylk 
           yl2 = yl1
           yl1 = ylk 
         end do
         yl1 = y(LB)
         yl2 = y(LB+1)
         do k = LB + 1, NM - 1
           kc     = cmplx(2 * k + 1,0.0,O)
           ylk    = kc /z * yl2 - yl1 
           y(k+1) = ylk 
           yl1    = yl2
           yl2    = ylk
         end do
         do k = 2, NM
           wa = abs(y(k))
           IF (wa < abs(y(k-1))) LB = k
         end do 
       end do     
    end if
  end if 
end subroutine besel_jC
! **********************************************************************************
subroutine bes_JA (z, N, J)
!-----------------------------------------------------------------------------------
! The routine computes the cylindrical Bessel function J(z). The order of the      !
! Bessel functions varies between 0 and N, and the control parameters ZeroSinXX,   !
! InitBesVal, UpperBoundSeq and LowerBoundSeq are specified in the routine         !
! "DrvParameters" from the file '../TMATROUTINES/MachParam.f90'.                   !
!                                                                                  !
! Input parameters:                                                                ! 
! - z (complex) - argument of the cylindrical Bessel functions.                    !
! - N (integer) - maximum order of cylindrical Bessel functions.                   !
!                                                                                  !
! Output parameters:                                                               !
! - J (complex array) - cylindrical Bessel functions.                              !  
!-----------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none 
  integer    :: N
  complex(O) :: z, J(0:N)
!
  complex(O) :: J0, J1, f2, f1, f, scale, kc
  real(O)    :: a0
  integer    :: NM, M, k, l, MSTA1, MSTA2 
!
  a0 = abs(z)
  NM = N  
  do k = 0, N
    J(k) = zero
  end do
  if (a0 < ZeroSinXX) then      
    J(0) = one
  else 
    call J01 (z, J0, J1)
    J(0) = J0
    J(1) = J1   
    if (N > 1) then
      if (N < int(0.25_O * a0)) then        
        do k = 2, N
          kc   = cmplx(2 * (k - 1),0.0,O)
          J(k) = kc * J(k-1) / z - J(k-2)    
        end do 
      else 
        M = MSTA1 (a0, 200)
        if (M < N) then
          NM = M              
        else 
          M = MSTA2 (A0, N, 15)
        end if  
        f2 = zero
        f1 = cmplx(InitBesVal,0.0,O) 
        do k = M, 0, -1
          kc = cmplx(2 * (k + 1),0.0,O)           
          f  = kc * f1 / z - f2           
          if (k <= NM) J(k) = f
          f2 = f1
          f1 = f
          if (abs(f1) > UpperBoundSeq) then
            f2 = f2 * LowerBoundSeq
            f1 = f1 * LowerBoundSeq
            do l = k, NM
              J(l) = J(l) * LowerBoundSeq
            end do
          else if (abs(f1) < LowerBoundSeq) then
            f2 = f2 * UpperBoundSeq
            f1 = f1 * UpperBoundSeq
            do l = k, NM
              J(l) = J(l) * UpperBoundSeq
            end do       
          end if 
        end do
        if (abs(f1) > abs(f2)) then
          scale = J0 / f1
        else 
          scale = J1 / f2
        end if 
        do k = 0, NM
          J(k) = scale * J(k)
        end do 
      end if
    end if
  end if    
end subroutine bes_JA
!***********************************************************************************
function MSTA1 (x, MP) result (MSTA)
  use parameters
  implicit none 
  real(O), intent(in) :: x
  integer,intent(in)  :: MP  
  integer             :: MSTA, N0, N1, it, NN 
  real(O)             :: a0, f0, f1, f, ENVJ    
!
  a0 = abs(x)
  if (a0 < 1._O) a0 = 1._O
  N0 = int(1.1_O * a0) + 1
  f0 = ENVJ(N0,a0) - MP
  N1 = N0 + 5
  f1 = ENVJ(N1,a0) - MP
  do it = 1, 50   
    NN = N1 - int((N1 - N0) / (1._O - f0 / f1))   
    f  = ENVJ(NN,a0) - MP
    if (abs(NN - N1) < 1) exit
    N0 = N1
    f0 = f1
    N1 = NN
    f1 = f
  end do 
  MSTA = NN  
end function MSTA1
!***********************************************************************************
function MSTA2 (x, N, MP) result (MSTA)
  use parameters
  implicit none 
  real(O), intent(in) :: x
  integer,intent(in)  :: N, MP 
  integer             :: MSTA, N0, N1, it, NN
  real(O)             :: a0, hmp, ejn, obj, f0, f1, f, ENVJ  
!
  a0 = abs(X)
  if (a0 < 1._O) a0 = 1._O
  hmp = 0.5_O * MP
  ejn = ENVJ(N,a0)
  if (ejn <= hmp) then
    obj = 1._O * MP
    N0  = int(1.1_O * a0)
  else
    obj = hmp + ejn
    N0  = N
  end if
  f0 = ENVJ(N0,a0) - obj
  N1 = N0 + 5
  f1 = ENVJ(N1,A0) - obj
  do it = 1, 50
    NN = N1 - int((N1 - N0) / (1._O - f0 / f1))
    f  = ENVJ(NN,a0) - obj
    if (abs(NN - N1) < 1) exit
    N0 = N1
    f0 = f1
    N1 = NN
    f1 = f
  end do
  MSTA = NN + 10
end function MSTA2
!***********************************************************************************
function ENVJ (N, x) result (ENV)  
  use parameters
  implicit none 
  real(O), intent(in) :: x
  integer,intent(in)  :: N 
  real(O)             :: ENV
!
  ENV = 0.5_O * log10(6.28_O * N) - N * log10(1.36_O * x / N) 
end function ENVJ

! **********************************************************************************
! *                           MATRIX TRANSFORMATIONS                               *
! *    ------------------------------------------------------------------------    *                           
! *    Partial list of subroutines:                                                *
! *      form_Tvector,            extend_matrix1,          extend_matrix2,         *
! *      extend_matrix3,          extend_matrix4,          extract_matrix1,        *
! *      extract_matrix2,         extract_matrix3,         dimension_column,       *
! *      dimension_row,           matrix_Nrank_m,          matrix_Nrank_m_left,    *
! *      vector_Nrank_m,          matrix_Nrank_1_right,    matrix_Mrank_1_right,   *
! *      matrix_Nrank_1_left,     matrix_Mrank_1_left,     vector_Nrank_1,         *
! *      vector_Mrank_1,          internal_matrix_Nrank_m, incident_matrix_Nrank_m,*
! *      difusion_matrix_Nrank_m, internal_matrix_LAY_Nrank_m                      *
! ********************************************************************************** 
subroutine form_Tvector (Nrank, Nmax, m, tvg, tv)
  use parameters
  implicit none
  integer    :: Nrank, Nmax, m, k, n
  complex(O) :: tvg(2*Nrank), tv(2*Nmax)
!
  if (m == 0) then
    do k = 1, Nmax
      tv(k)      = tvg(k)
      tv(k+Nmax) = tvg(k+Nrank)      
    end do
  else
    do k = 1, Nmax
      n = m + k - 1                                                                                              
      tv(k)      = tvg(n)
      tv(k+Nmax) = tvg(n+Nrank)         
    end do
  endif   
end subroutine form_Tvector
!*********************************************************************************** 
subroutine extend_matrix1 (ipart, jpart, Npart, Nmaxp, Nl, Nc, a, nap, map, aa,     &
           naap, maap)
!-----------------------------------------------------------------------------------      
! Extend the matrix a(2*Nmaxp(ipart),2*Nmaxp(jpart)) into the global matrix        !
! aa(2*Nmaxmax,2*Nmaxmax).                                                         !
!-----------------------------------------------------------------------------------      
  use parameters
  implicit none 
  integer    :: ipart, jpart, Npart, Nmaxp(Npart), Nl, Nc, nap, map, naap, maap, i, j
  complex(O) :: a(2*nap,2*map), aa(2*naap,2*maap)  
!
  do i = 1, 2*Nmaxp(ipart)
    do j = 1, 2*Nmaxp(jpart)
      aa(i+Nl,j+Nc) = - a(i,j)
    end do        
  end do            
end subroutine extend_matrix1
!***********************************************************************************
subroutine extend_matrix2 (ipart, Npart, Nmaxp, Nmax, Nmaxmax, Nl, a, nap, map, aa, &
           naap, maap)
!-----------------------------------------------------------------------------------     
! Extend the matrix a(2*Nmaxp(ipart),2*Nmax) into the global matrix                !
! aa(2*Nmaxmax,2*Nmax).                                                            !
!-----------------------------------------------------------------------------------    
  use parameters
  implicit none 
  integer    :: ipart, Npart, Nmaxp(Npart), Nmax, Nmaxmax, Nl, nap, map, naap,      &
                maap, i, j  
  complex(O) :: a(2*nap,2*map), aa(2*naap,2*maap)      
!
  if (ipart == 1) then
    do i = 1, 2*Nmaxmax
      do j = 1, 2*Nmax
        aa(i,j) = zero
      end do        
    end do
  end if
  do i = 1, 2*Nmaxp(ipart)
    do j = 1, 2*Nmax
      aa(i+Nl,j) = a(i,j)
    end do        
  end do
end subroutine extend_matrix2
!***********************************************************************************
subroutine extend_matrix3 (Nmax, Nmax1, Nl, Nc, a, nap, map, aa, naap, maap)
!-----------------------------------------------------------------------------------
! Extend the matrix a(2*Nmax,2*Nmax1) into the global matrix                       !
! aa(2*Nmaxmax,2*Nmaxmax).                                                         !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none 
  integer    :: Nmax, Nmax1, Nl, Nc, nap, map, naap, maap, i, j
  complex(O) :: a(2*nap,2*map), aa(2*naap,2*maap)      
!
  do i = 1, 2*Nmax
    do j = 1, 2*Nmax1
      aa(i+Nl,j+Nc) = - a(i,j)
    end do        
  end do            
end subroutine extend_matrix3
!***********************************************************************************
subroutine extend_matrix4 (ipart, Nmax, Nmax1, Nmaxmax, Nl, a, nap, map, aa,        &
           naap, maap)
!-----------------------------------------------------------------------------------
! Extend the matrix a(2*Nmax,2*Nmax1) into the global matrix aa(2*Nmaxmax,2*Nmax1).!      
!-----------------------------------------------------------------------------------
  use parameters
  implicit none 
  integer    :: ipart, Nmax, Nmax1, Nmaxmax, Nl, nap, map, naap, maap, i, j
  complex(O) :: a(2*nap,2*map), aa(2*naap,2*maap)    
!
  if (ipart == 1) then
    do i = 1, 2*Nmaxmax
      do j = 1, 2*Nmax1
        aa(i,j) = zero
      end do        
    end do
  end if
  do i = 1, 2*Nmax
    do j = 1, 2*Nmax1
      aa(i+Nl,j) = a(i,j)
    end do        
  end do  
end subroutine extend_matrix4
!***********************************************************************************
subroutine extract_matrix1 (ipart, Npart, Nmaxp, Nmax, Nl, a, nap, map, aa,         &
           naap, maap)
!-----------------------------------------------------------------------------------
! Extract the matrix a(2*Nmaxp(ipart),2*Nmax) from aa(2*Nmaxmax,2*Nmax).           !
!-----------------------------------------------------------------------------------   
  use parameters
  implicit none 
  integer    :: ipart, Npart, Nmaxp(Npart), Nmax, nap, map, naap, maap, Nl, i, j
  complex(O) :: a(2*nap,2*map), aa(2*naap,2*maap)
!
  do i = 1, 2*Nmaxp(ipart)
    do j = 1, 2*Nmax
      a(i,j) = aa(i+Nl,j)
    end do        
  end do     
end subroutine extract_matrix1
!***********************************************************************************
subroutine extract_matrix2 (Nmax, Nmax1, Nl, a, nap, map, aa, naap, maap)
!-----------------------------------------------------------------------------------
! Extract the matrix a(2*Nmax,2*Nmax1) from aa(2*Nmaxmax,2*Nmax1).                 !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none 
  integer    :: Nmax, Nmax1, Nl, nap, map, naap, maap, i, j
  complex(O) :: a(2*nap,2*map), aa(2*naap,2*maap)
!
  do i = 1, 2*Nmax
    do j = 1, 2*Nmax1
      a(i,j) = aa(i+Nl,j)
    end do        
  end do     
end subroutine extract_matrix2
! **********************************************************************************
subroutine extract_matrix3 (index, Nmaxpmax, aa, naap, maap, a, nap, map)
!-----------------------------------------------------------------------------------
! Extract the matrix aa(2*Nmax,2*Nmax) from a(2*Nmaxpmax,2*Nmaxpmax).              !
!-----------------------------------------------------------------------------------
  use parameters
  implicit none
  integer    :: index, Nmaxpmax, naap, maap, nap, map, i, j
  complex(O) :: aa(2*naap,2*maap), a(2*nap,2*map)
!
  if (index == 1) then
    do i = 1, 2*Nmaxpmax
      do j = 1, 2*Nmaxpmax
        a(i,j) = aa(i,j)
      end do
    end do      
  else
    do i = 1, 2*Nmaxpmax
      do j = 1, 2*Nmaxpmax
        a(i,j) = aa(i+2*Nmaxpmax,j)
      end do
    end do      
  end if
end subroutine extract_matrix3 
!***********************************************************************************
function dimension_column (m, Npart, Nrankp) result (NmaxC)
  implicit none
  integer :: m, Npart, Nrankp(Npart), NmaxC, Nstart, p, Nmax
!
  Nstart = 0
  do p = 1, Npart
    if (Nrankp(p) >= abs(m)) then
      if (abs(m) == 0) then
        Nmax = Nrankp(p)
      else
        Nmax = Nrankp(p) - abs(m) + 1
      end if
      Nstart = Nstart + Nmax
    end if
  end do
  NmaxC = Nstart 
end function dimension_column
! **********************************************************************************
function dimension_row (m, Nrank) result (Nmax)
  implicit none
  integer :: m, Nrank, Nmax
!
  if (abs(m) == 0) then
    Nmax = Nrank
  else
    Nmax = Nrank - abs(m) + 1
  end if      
end function dimension_row      
!***********************************************************************************
subroutine matrix_Nrank_m (Nmax, a, nap, map)
  use parameters
  implicit none
  integer    :: Nmax, nap, map, i
  complex(O) :: a(2*nap,2*map)
!
  do i = 1, Nmax
    a(i,Nmax)        = zero
    a(Nmax,i)        = zero
    a(i,2*Nmax)      = zero
    a(Nmax,i+Nmax)   = zero
    a(i+Nmax,Nmax)   = zero
    a(2*Nmax,i)      = zero 
    a(i+Nmax,2*Nmax) = zero
    a(2*Nmax,i+Nmax) = zero
  end do             
end subroutine matrix_Nrank_m 
!***********************************************************************************
subroutine matrix_Nrank_m_left (Nmax, a, nap, map)
  use parameters
  implicit none
  integer    :: Nmax, nap, map, i
  complex(O) :: a(2*nap,2*map)
!
  do i = 1, Nmax
    a(i,Nmax)        = zero
    a(Nmax,i)        = zero
    a(i,2*Nmax)      = zero
    a(Nmax,i+Nmax)   = zero
    a(i+Nmax,Nmax)   = zero
    a(2*Nmax,i)      = zero
    a(i+Nmax,2*Nmax) = zero
    a(2*Nmax,i+Nmax) = zero
  end do
  a(Nmax,Nmax) = one
  a(Nmax,2*Nmax)   =   one
  a(2*Nmax,Nmax)   =   one
  a(2*Nmax,2*Nmax) = - one      
end subroutine matrix_Nrank_m_left
!***********************************************************************************
subroutine vector_Nrank_m (Nmax, c)
  use parameters
  implicit none
  integer    :: Nmax
  complex(O) :: c(2*Nmax)
!
  c(Nmax)  = zero
  c(2*Nmax)= zero      
end subroutine vector_Nrank_m
!***********************************************************************************
subroutine matrix_Nrank_1_right (Mrank, Nrank, Nmax, a, nap, map)
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax, nap, map, m, i, l, N0
  complex(O) :: a(2*nap,2*map)
!
  do m = 0, Mrank
    if (m == 0) then
      do i = 1, Nmax
        a(i,Nrank)           = zero
        a(Nrank,i)           = zero
        a(i,Nrank+Nmax)      = zero
        a(Nrank,i+Nmax)      = zero
        a(i+Nmax,Nrank)      = zero
        a(Nrank+Nmax,i)      = zero
        a(i+Nmax,Nrank+Nmax) = zero
        a(Nrank+Nmax,i+Nmax) = zero
      end do
    else          
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      do l = 1, 2
        do i = 1, Nmax
          a(i,N0+Nrank-m+1)           = zero
          a(N0+Nrank-m+1,i)           = zero
          a(i,N0+Nrank-m+1+Nmax)      = zero
          a(N0+Nrank-m+1,i+Nmax)      = zero
          a(i+Nmax,N0+Nrank-m+1)      = zero
          a(N0+Nrank-m+1+Nmax,i)      = zero
          a(i+Nmax,N0+Nrank-m+1+Nmax) = zero
          a(N0+Nrank-m+1+Nmax,i+Nmax) = zero
        end do
        N0 = N0 + Nrank - m + 1
      end do              
    end if
  end do   
end subroutine matrix_Nrank_1_right
!***********************************************************************************
subroutine matrix_Mrank_1_right (Mrank, Nrank, Nmax, a, nap, map)
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax, nap, map, m, i, j, l, N0
  complex(O) :: a(2*nap,2*map)
!
  m  = Mrank
  N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
  do l = 1, 2           
    do i = 1, Nmax
      do j = 1, Nrank - m + 1
        a(i,j+N0)           = zero
        a(j+N0,i)           = zero
        a(i,j+N0+Nmax)      = zero
        a(j+N0,i+Nmax)      = zero
        a(i+Nmax,j+N0)      = zero
        a(j+N0+Nmax,i)      = zero
        a(i+Nmax,j+N0+Nmax) = zero
        a(j+N0+Nmax,i+Nmax) = zero
      end do
    end do
    N0 = N0 + Nrank - m + 1
  end do                   
end subroutine matrix_Mrank_1_right
!***********************************************************************************
subroutine matrix_Nrank_1_left (Mrank, Nrank, Nmax, a, nap, map)
  use parameters
  implicit none 
  integer    :: Mrank, Nrank, Nmax, nap, map, m, i, l, N0
  complex(O) :: a(2*nap,2*map)   
!
  do m = 0, Mrank
    if (m == 0) then
      do i = 1, Nmax
        a(i,Nrank)           = zero
        a(Nrank,i)           = zero
        a(i,Nrank+Nmax)      = zero
        a(Nrank,i+Nmax)      = zero
        a(i+Nmax,Nrank)      = zero
        a(Nrank+Nmax,i)      = zero
        a(i+Nmax,Nrank+Nmax) = zero
        a(Nrank+Nmax,i+Nmax) = zero
      end do
    else      
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      do l = 1, 2
        do i = 1, Nmax
          a(i,N0+Nrank-m+1)           = zero
          a(N0+Nrank-m+1,i)           = zero
          a(i,N0+Nrank-m+1+Nmax)      = zero
          a(N0+Nrank-m+1,i+Nmax)      = zero
          a(i+Nmax,N0+Nrank-m+1)      = zero
          a(N0+Nrank-m+1+Nmax,i)      = zero
          a(i+Nmax,N0+Nrank-m+1+Nmax) = zero
          a(N0+Nrank-m+1+Nmax,i+Nmax) = zero
        end do
        N0 = N0 + Nrank - m + 1
      end do              
    end if
  end do
  do m = 0, Mrank
    if (m == 0) then
      a(Nrank,Nrank)           =   one
      a(Nrank,Nrank+Nmax)      =   one
      a(Nrank+Nmax,Nrank)      =   one
      a(Nrank+Nmax,Nrank+Nmax) = - one
    else      
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      do l = 1, 2
        a(N0+Nrank-m+1,N0+Nrank-m+1)           =   one
        a(N0+Nrank-m+1,N0+Nrank-m+1+Nmax)      =   one
        a(N0+Nrank-m+1+Nmax,N0+Nrank-m+1)      =   one
        a(N0+Nrank-m+1+Nmax,N0+Nrank-m+1+Nmax) = - one
        N0 = N0 + Nrank - m + 1
      end do              
    end if
  end do
end subroutine matrix_Nrank_1_left
!***********************************************************************************
subroutine matrix_Mrank_1_left (Mrank, Nrank, Nmax, a, nap, map)
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax, nap, map, m, i, j, l, N0
  complex(O) :: a(2*nap,2*map)   
!
  m  = Mrank
  N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
  do l = 1, 2           
    do i = 1, Nmax
      do j = 1, Nrank - m + 1
        a(i,j+N0)           = zero
        a(j+N0,i)           = zero
        a(i,j+N0+Nmax)      = zero
        a(j+N0,i+Nmax)      = zero
        a(i+Nmax,j+N0)      = zero
        a(j+N0+Nmax,i)      = zero
        a(i+Nmax,j+N0+Nmax) = zero
        a(j+N0+Nmax,i+Nmax) = zero
      end do
    end do
    N0 = N0 + Nrank - m + 1
  end do              
  N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
  do l = 1, 2
    do j = 1, Nrank - m + 1
      a(j+N0,j+N0)           =   one
      a(j+N0,j+N0+Nmax)      =   one
      a(j+N0+Nmax,j+N0)      =   one
      a(j+N0+Nmax,j+N0+Nmax) = - one
    end do
    N0 = N0 + Nrank - m + 1
  end do                   
end subroutine matrix_Mrank_1_left
!***********************************************************************************
subroutine vector_Nrank_1 (Mrank, Nrank, Nmax, c)
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax, m, l, N0
  complex(O) :: c(2*Nmax)
!
  do m = 0, Mrank
    if (m==0) then        
      c(Nrank)      = zero
      c(Nrank+Nmax) = zero
    else      
      N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
      do l = 1, 2      
        c(N0+Nrank-m+1)      = zero
        c(N0+Nrank-m+1+Nmax) = zero
        N0 = N0 + Nrank - m + 1         
      end do              
    end if
  end do     
end subroutine vector_Nrank_1
! **********************************************************************************
subroutine vector_Mrank_1 (Mrank, Nrank, Nmax, c)
  use parameters
  implicit none
  integer    :: Mrank, Nrank, Nmax, m, j, l, N0
  complex(O) :: c(2*Nmax)
!
  m  = Mrank
  N0 = Nrank + (m - 1) * (2 * Nrank - m + 2)
  do l = 1, 2
    do j = 1, Nrank - m + 1
      c(j+N0)      = zero
      c(j+N0+Nmax) = zero
    end do
    N0 = N0 + Nrank - m + 1
  end do              
end subroutine vector_Mrank_1
!***********************************************************************************
subroutine internal_matrix_Nrank_m (m, Npart, Nrankp, NmaxC, a, nap, map)
  use parameters
  implicit none
  integer    :: m, Npart, Nrankp(Npart), NmaxC, nap, map
  complex(O) :: a(2*nap,2*map)
!       
  integer    :: p, i, Nmaxp, Nstart
!
  Nstart = 0
  do p = 1, Npart
    if (m == 0) then
      Nmaxp = Nrankp(p)
    else
      Nmaxp = Nrankp(p) - abs(m) + 1
    end if
    do i = 1, 2*NmaxC
      a(i,Nmaxp+Nstart)       = zero
      a(Nmaxp+Nstart,i)       = zero
      a(i,Nmaxp+Nstart+NmaxC) = zero
      a(Nmaxp+Nstart+NmaxC,i) = zero
    end do
    a(Nmaxp+Nstart,Nmaxp+Nstart)             =   one
    a(Nmaxp+Nstart,Nmaxp+Nstart+NmaxC)       =   one
    a(Nmaxp+Nstart+NmaxC,Nmaxp+Nstart)       =   one
    a(Nmaxp+Nstart+NmaxC,Nmaxp+Nstart+NmaxC) = - one
    Nstart = Nstart + Nmaxp
  end do
end subroutine internal_matrix_Nrank_m
!***********************************************************************************
subroutine incident_matrix_Nrank_m (m, Npart, Nrankp, NmaxC, NmaxL, a, nap, map)
  use parameters
  implicit none
  integer    :: m, Npart, Nrankp(Npart), NmaxC, NmaxL, nap, map
  complex(O) :: a(2*nap,2*map)
!       
  integer    :: p, i, j, Nmaxp, Nstart
!
  Nstart = 0
  do p = 1, Npart
    if (m == 0) then
      Nmaxp = Nrankp(p)
    else
      Nmaxp = Nrankp(p) - abs(m) + 1
    end if
    do j = 1, 2*NmaxL
      a(Nmaxp+Nstart,j)       = zero
      a(Nmaxp+Nstart+NmaxC,j) = zero
    end do	
    Nstart = Nstart + Nmaxp        
  end do
  do i = 1, 2*NmaxC
    a(i,NmaxL)       = zero
    a(i,NmaxL+NmaxL) = zero
  end do
end subroutine incident_matrix_Nrank_m
!***********************************************************************************
subroutine difusion_matrix_Nrank_m (m, Npart, Nrankp, NmaxC, NmaxL, a, nap, map)
  use parameters
  implicit none
  integer    :: m, Npart, Nrankp(Npart), NmaxC, NmaxL, nap, map
  complex(O) :: a(2*nap,2*map)
!       
  integer    :: p, i, j, Nmaxp, Nstart
!
  Nstart = 0
  do p = 1, Npart
    if (m == 0) then
      Nmaxp = Nrankp(p)
    else
      Nmaxp = Nrankp(p) - abs(m) + 1
    end if
    do i = 1, 2*NmaxL
      a(i,Nmaxp+Nstart)       = zero
      a(i,Nmaxp+Nstart+NmaxC) = zero
    end do		         
    Nstart = Nstart + Nmaxp
  end do
  do j = 1, 2*NmaxC
    a(NmaxL,j)       = zero
    a(NmaxL+NmaxL,j) = zero
  end do 
end subroutine difusion_matrix_Nrank_m  
!***********************************************************************************
subroutine internal_matrix_LAY_Nrank_m (Npart, Nmaxp, aa, nap, map)
  use parameters
  implicit none
  integer    :: Npart, Nmaxp(Npart), nap, map      
  complex(O) :: aa(2*nap,2*map)
!
  integer    :: i, j, ipart, Nrankl, Nrankc, Nl, Nc
!
  do ipart = 1, Npart     
    if (ipart == 1) then
      Nrankl = Nmaxp(ipart)
      Nrankc = Nmaxp(ipart)           
      do j = 1, 2*Nrankc
        aa(  Nrankl,j) = zero
        aa(2*Nrankl,j) = zero
      end do
      do i = 1, 2*Nrankl
        aa(i,  Nrankc) = zero
        aa(i,2*Nrankc) = zero
        aa(i,3*Nrankc) = zero
        aa(i,4*Nrankc) = zero
      end do
      aa(  Nrankl,  Nrankc) =   one
      aa(  Nrankl,2*Nrankc) =   one
      aa(2*Nrankl,  Nrankc) =   one
      aa(2*Nrankl,2*Nrankc) = - one        
      Nl = 2 * Nmaxp(ipart)
      Nc = 0        
    else    
      Nrankl = Nmaxp(ipart-1)
      Nrankc = Nmaxp(ipart-1) 
      do j = 1, 2*Nrankc
        aa(  Nrankl+Nl,j+Nc) = zero
        aa(2*Nrankl+Nl,j+Nc) = zero
      end do
      do i = 1, 2*Nrankl
        aa(i+Nl,  Nrankc+Nc) = zero
        aa(i+Nl,2*Nrankc+Nc) = zero
        aa(i+Nl,3*Nrankc+Nc) = zero
        aa(i+Nl,4*Nrankc+Nc) = zero
      end do
      aa(  Nrankl+Nl,3*Nrankc+Nc) =   one
      aa(  Nrankl+Nl,4*Nrankc+Nc) =   one
      aa(2*Nrankl+Nl,3*Nrankc+Nc) =   one
      aa(2*Nrankl+Nl,4*Nrankc+Nc) = - one  
      Nc = Nc + 4 * Nmaxp(ipart-1)
      Nrankl = Nmaxp(ipart-1)
      Nrankc = Nmaxp(ipart) 
      do j = 1, 2*Nrankc
        aa(  Nrankl+Nl,j+Nc) = zero
        aa(2*Nrankl+Nl,j+Nc) = zero
      end do
      do i = 1, 2*Nrankl
        aa(i+Nl,  Nrankc+Nc) = zero
        aa(i+Nl,2*Nrankc+Nc) = zero
        if (ipart < Npart) then
          aa(i+Nl,3*Nrankc+Nc) = zero
          aa(i+Nl,4*Nrankc+Nc) = zero
        end if
      end do                     
      Nl = Nl + 2 * Nmaxp(ipart-1)
      Nc = Nc - 4 * Nmaxp(ipart-1)    
      Nrankl = Nmaxp(ipart)
      Nrankc = Nmaxp(ipart-1) 
      do j = 1, 2*Nrankc
        aa(  Nrankl+Nl,j+Nc) = zero
        aa(2*Nrankl+Nl,j+Nc) = zero
      end do
      do i = 1, 2*Nrankl
        aa(i+Nl,  Nrankc+Nc) = zero
        aa(i+Nl,2*Nrankc+Nc) = zero
        aa(i+Nl,3*Nrankc+Nc) = zero
        aa(i+Nl,4*Nrankc+Nc) = zero
      end do 
      Nc = Nc + 4 * Nmaxp(ipart-1)    
      Nrankl = Nmaxp(ipart)
      Nrankc = Nmaxp(ipart) 
      do j = 1, 2*Nrankc
        aa(  Nrankl+Nl,j+Nc) = zero
        aa(2*Nrankl+Nl,j+Nc) = zero
      end do
      do i = 1, 2*Nrankl
        aa(i+Nl,  Nrankc+Nc) = zero
        aa(i+Nl,2*Nrankc+Nc) = zero
        if (ipart < Npart) then
          aa(i+Nl,3*Nrankc+Nc) = zero
          aa(i+Nl,4*Nrankc+Nc) = zero
        end if
      end do  
      aa(  Nrankl+Nl,  Nrankc+Nc) =   one
      aa(  Nrankl+Nl,2*Nrankc+Nc) =   one
      aa(2*Nrankl+Nl,  Nrankc+Nc) =   one
      aa(2*Nrankl+Nl,2*Nrankc+Nc) = - one             
      Nl = Nl + 2 * Nmaxp(ipart)              
    end if
  end do   
end subroutine internal_matrix_LAY_Nrank_m   

! ----------------------------------------------------------------------------------
!                       LIBRARY OF PARTICLE GEOMETRIES                             !   
!    -------------------------------------------------------------------------     !
!                           AXISYMMETRIC PARTICLES                                 !             
!                                                                                  !
! The significance of the geometry parameters specified in the input files is      !
! given below.                                                                     !
!                                                                                  !           
!    Particle      TypeGeom   Nsurf   Nparam                surf                   !
!    spheroid         1         2       1         surf(1) - length of the semi-    !
!                                                           axis along the         !
!                                                           symmetry axis          !
!                                                 surf(2) - length of the second   !
!                                                           semi-axis              !
!    cylinder         2         2       3         surf(1) - half-length of         !
!                                                           the cylinder           !
!                                                 surf(2) - cylinder radius        !
!                                                                                  !
!    rounded          3         2       3         surf(1) - half-length of         !
!     oblate                                                the cylinder           ! 
!    cylinder                                     surf(2) - cylinder radius        !
!                                                           including the rounded  !
!                                                           part                   ! 
!                                                                                  !
! 1. In order to explain the significance of the surface parameters we consider    !
! the geometry depicted in Figure 1.                                               !
!                                                                                  !
!      z ^                                                                         !
!        |          a                                                              !
!        |/- - - - - - - - -/:                                                     !
!        |                   :                                                     !
!        |        L_1        :                                                     !
!        |--------->---------.............                                         !
!        |        t_1        |          /                                          !
!        |                   |          ! b                                        !
!        |               t_2 v   x      !                                          !
!      O o - - - - - - - - - | - >....../.                                         !
!        |                   | L_3      !                                          !
!        |       t_3         |          ! c                                        !
!        |--------<----------.........../.                                         !
!        |       L_3                                                               !
!                                                                                  !
!                                   Figure 1                                       !
!                                                                                  !
! The generatrix curve L is characterized by Nsurf = 3 surface parameters:         !
!                                                                                  !
!                   surf(1) = a, surf(2) = b and surf(3) = c,                      !
!                                                                                  !
! and consists of Nparam = 3 smooth curves L_1, L_2 and L_3, i.e.,                 !
!                                                                                  !
!                          L = L_1  U  L_2  U  L_3.                                !
!                                                                                  !
! On each smooth curve L_i, i = 1,2,... Nparam, we consider the curve parameter    !
! t_i (which varies in the interval I_i) and assume the following parametric       !
! representation:                                                                  !
!                                                                                  !
!                  L_i = {(x,z) / x = x_i(t_i), z = z_i(t_i) with t_i in I_i }.    !
!                                                                                  !
! In the routines contained in the geometry library, "iparam" stands for i and for !
! a given index i, "param" stands for t_i. In order to define the geometry         !
! parameters, we consider a generic smooth curve, for which we omit to indicate    !
! the dependency on the index i,                                                   !
!                                                                                  !
!                  L = {(x,z) / x = x(t), z = z(t) with t in I }                   !
!                                                                                  !
! The magnitude of the position vector is given by                                 !
!                                                                                  !
!                 r(t) = sqrt ( x(t)**2 + z(t)**2 ),                               !
!                                                                                  !
! the zenith angle theta is                                                        !
!                                                                                  !
!                 theta(t) = atan ( x(t) / z(t) ),                                 !
!                                                                                  !
! the azimuthal angle phi is phi = 0, the normal unit vector in spherical          !
! coordinates is given by                                                          !
!                                      r(t)                                        !
!                  n_r(t) = ---------------------------,                           ! 
!                           sqrt ( r(t)**2 + r'(t)**2 )                            !
!                                                                                  !
!                                             r'(t)                                !
!                  n_theta(t) = - ----------------------------- ,                  !
!                                  sqrt ( r(t)**2 + r'(t)**2 )                     !
!                                                                                  !
!                  n_phi(t) = 0,                                                   !
! where                                                                            !
!                           dr                                                     ! 
!                  r'(t) =  --(t),                                                 ! 
!                           dt                                                     !
!                                                                                  !
! and the surface element is defined as                                            !
!                                                                                  !
!                 dA(t) = sqrt ( r(t)**2 + r'(t)**2 ) * r(t) * sin[theta(t)].      !
!                                                                                  !
! 2. To compute the integrals over the particle surface we define nodes and        !
! weights on each smooth curve L_i. The number of integration points on the curve  !
! L_i is                                                                           !
!                                                                                  !
!                      Nint_i = int { c_i * Nint },                                !
!                                                                                  !
! where c_i is a multiplicative factor, c_i < 1, and Nint is the global number of  !
! integration points. Note that in the routines contained in the geometry library, !
! Nintparam(i) stands for Nint_i, where i = 1,2,...,Nparam. The code generates     !
! Nint_i nodes and weights in the interval I_i, and store these quantities in the  !
! arrays:                                                                          !
!                                                                                  ! 
!              paramG(i,j), i = 1,2,...,Nparam and j = 1,2,...,Nintparam(i)        !
!                                                                                  !
! and                                                                              !
!                                                                                  !
!              weightsG(i,j), i = 1,2,...,Nparam and j = 1,2,...,Nintparam(i),     !
!                                                                                  !
! respectively. An important parameter of the routines is the logical variable     !
! "mirror ". For particles with a plane of symmetry perpendicular to the axis of   !
! rotation (mirror symmetric particles with mirror  = .true.) with the surface     !
! parametrization                                                                  !
!                                                                                  !
!                       r(theta) = r(Pi - theta),                                  !
!                                                                                  !
! the T matrix can be computed by integrating theta over the interval [0,Pi/2].    !
!                                                                                  !
! 3. The distributed sources can be situated on the axis of symmetry of the       !
! particle (for highly elongated particles) or in the complex plane (for highly    !
! flattened particles). In Figure 2 we show the generatrix of a prolate cylinder   !
! and the image of the generatrix in the complex plane.                            !
!                                                                                  !
!          z ^                           Rez ^                                     !
!            |------                   ------|------                               !
!            |      |                 |      |      |                              !
!            |      |                 |Rez_4 o      |                              !
!            |      |                 |      |      |                              !
!            |      |                 |Rez_2 o      |                              !
!            |      |      x          |      | O    |    Im z                      !
!          O o - - -| - - - >         |Rez_1 o - - -| - - - >                      !
!            |      |                 |      |      |                              !
!            |      |                 |Rez_3 o      |                              !
!            |      |                 |      |      |                              !
!            |      |                 |Rez_5 o      |                              !
!            |      |                 |      |      |                              !
!            |------                   ------|------                               !
!            |                               |                                     !
!        Generatrix of a      Image of the generatrix in the complex plane and     !
!        prolate cylinder     the distribution of 5 sources on the Rez-axis        !
!                                                                                  !
!                                    Figure 2                                      !
!                                                                                  !
! For this configuration, the sources are distributed along the axis of            !
! symmetry (Rez-axis), i.e., Imz_1 = 0, Imz_2 = 0,...,Imz_5 = 0. In Figure 3       !
! we show the generatrix of an oblate cylinder and the image of the generatrix     !
! in the complex plane.                                                            !
!                                                                                  !
!         z  ^                                    Re z ^                           !
!            |----------------         ----------------|----------------           !
!            |                |       |                |                |          !
!            |                |   x   |      Imz_4     | Imz_1   Imz_5  |  Im z    !
!          O o - - - - - - - -| >    -|- - o - o - o - o - o - o - o - -| - - >    !
!            |                |       |  Imz_6   Imz_2 | O   Imz_3      |          !
!            |                |       |                |                |          !
!            |----------------         ----------------|----------------           !
!            |                                         |                           !
!        Generatrix of an     Image of the generatrix in the complex plane and     !
!        oblate cylinder      the distribution of 6 sources on the Imz-axis        !
!                                                                                  !
!                                     Figure 3                                     !   
!                                                                                  ! 
! For this configuration, the sources are distributed along the Imz-axis, i.e.,    ! 
! Rez_1 = 0, Rez_2 = 0,...,Rez_6 = 0.                                              !
!                                                                                  !
! 4. The user can easily modify the routines: "elem_geomAXSYM",                    !
! "interpolation_listAXSYM" and "zDSAXSYM" to generate particles with other        !
! geometries. A new geometry with the index TypeGeom = 4 can be added to the       !
! existing geometries, but the list of parameters must be maintained.              !
! ----------------------------------------------------------------------------------
subroutine elem_geomAXSYM (TypeGeom, Nsurf, surf, param, iparam, r, theta, phi,     &
           dA, n)
!-----------------------------------------------------------------------------------
! The routine computes the geometry parameters of an axisymmetric surface          !
! for a given curve (surface) parameter.                                           !
!                                                                                  !
! Input parameters:                                                                !
! - TypeGeom - integer, index of the particle geometry.                            !
! - Nsurf (integer) - number of surface parameters.                                !
! - surf (real array) - surface parameters specifying the shape of the particle.   !          
! - param (real) - actual curve (surface) parameter.                               !
! - iparam (integer) - index of the actual curve (surface) parameter.              !
!                                                                                  !
! Output parameters:                                                               !
! - r (real) - magnitude of the position vector.                                   !    
! - theta (real) - zenith angle.                                                   !
! - phi (real) - azimuthal angle.                                                  !
! - dA (real) - surface element.                                                   !
! - n (real array) - normal unit vector in spherical coordinates.                  !
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none  
  integer :: TypeGeom, Nsurf, iparam
  real(O) :: surf(Nsurf), param, r, theta, phi, dA, n(3)
!
  real(O) :: a, b, tamp, invtamp, dr, e, e2, invsin, invcos
!
  select case (TypeGeom)
  case (1)
!   --- spheroid ---
    a  = surf(1)
    b  = surf(2)
    e  = a / b
    e2 = e * e
    theta = param   
    phi  = 0._O  
    if (iparam == 1) then          
      tamp    = cos(theta) * cos(theta) + sin(theta) * sin(theta) * e2
      invtamp = 1._O / sqrt(tamp)
      r  =   a * invtamp
      dr = - a * cos(theta) * sin(theta) * (e2 - 1._O) * invtamp / tamp           
    end if
    tamp    = sqrt(r * r + dr * dr)
    invtamp = 1._O / tamp
    dA   =   tamp * r * sin(theta)      
    n(1) =   r * invtamp
    n(2) = - dr * invtamp
    n(3) =   0._O  
  case (2,3) 
!   --- cylinder and rounded oblate cylinder---
    a = surf(1)
    b = surf(2)
    theta  = param  
    phi    = 0._O               
    if (iparam == 1) then
      invcos = 1._O / cos(theta)      
      r  = a * invcos 
      dr = a * sin(theta) * invcos * invcos  
    else if (iparam == 2) then 
      if (TypeGeom == 2) then
        invsin = 1._O / sin(theta)     
        r  =   b * invsin
        dr = - b * cos(theta) * invsin * invsin  
      else
        e  = b - a
        e2 = e * e
        tamp = sqrt(a * a - e2 * cos(theta) * cos(theta))
        r  = e * sin(theta) + tamp
        dr = e * cos(theta) + e2 * sin(theta) * cos(theta) / tamp 
      end if
    else if (iparam == 3) then 
      invcos = 1._O / cos(theta)     
      r  = - a * invcos
      dr = - a * sin(theta) * invcos * invcos 
    end if
    tamp    = sqrt(r * r + dr * dr)
    invtamp = 1._O / tamp
    dA   =   tamp * r * sin(theta)
    n(1) =   r * invtamp
    n(2) = - dr * invtamp
    n(3) =   0._O   
  end select     
end subroutine elem_geomAXSYM     
! **********************************************************************************
subroutine interpolation_listAXSYM (TypeGeom, Nsurf, surf, Nint, Nparam, Nintparam, &
           paramG, weightsG, mirror)
!-----------------------------------------------------------------------------------
! The routine provides the nodes and weights for computing integrals over an       !
! axisymmmetric surface.                                                           !
!                                                                                  !
! Input parameters:                                                                !
! - TypeGeom (integer) - index of the particle geometry.                           !
! - Nsurf (integer) - number of surface parameters.                                !
! - surf (real array) - surface parameters specifying the shape of the particle.   !
! - Nint (integer) - global number of integration points.                          !
! - Nparam (integer) - number of integration curves.                               !
! - mirror  (logical) - if mirror  = t, the particle is mirror symmetric (the      !
!   plane of symmetry or the plane of reflection is perpendicular to the axis of   !
!   rotation).                                                                     !
!                                                                                  ! 
! Output parameters:                                                               !
! - Nintparam (integer array) - number of integration points (nodes) on all        !
!   integration curves.                                                            !
! - paramG (real array) - integration points (nodes) on all integration curves.    !
! - weightsG (real array) - weights on all integration curves.                     !            
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none
  integer :: TypeGeom, Nsurf, Nint, Nparam, Nintparam(Nparam)
  real(O) :: surf(Nsurf), paramG(Nparam,Nint), weightsG(Nparam,Nint)      
  logical :: mirror 
!
  integer :: iparam, p, Nintl, Ninta, Nintb
  real(O) :: a, b, theta0, atheta, btheta, e  
  real(O),allocatable :: xt(:), wt(:)
!
  do iparam = 1, Nparam
    do p = 1, Nint
      paramG  (iparam,p) = 0._O
      weightsG(iparam,p) = 0._O
    end do
  end do
  select case (TypeGeom)
  case (1)
!   --- spheroid ---    
    Nintparam(1) = Nint     
    Nintl = Nint
    allocate (xt(Nintl),wt(Nintl))      
    atheta = 0._O
    if (mirror) then
      btheta = Pi / 2
    else
      btheta = Pi
    end if
    call Gauss_Legendre (atheta, btheta, Nintl, wt, xt)
    do p = 1, Nintl
      paramG  (1,p) = xt(p)
      weightsG(1,p) = wt(p)
    end do 
    deallocate (xt, wt)
  case (2,3)
!   --- cylinder and rounded oblate cylinder---
    a = surf(1)
    b = surf(2)
    if (TypeGeom == 2) then
      theta0 = atan(b / a)
    else
      e = b - a
      theta0 = atan(e / a)
    end if
    Nintb = int(b * Nint / 2 / (a + b))
    Ninta = Nint - 2 * Nintb
    if (Nintb < 20) then
      Nintb = 20
      if (Nintb > Nint) then
        print "(/,2x,'Error in the input file:')"
        print "(2x,'the number of integration points Nint is too low;')"        
        stop
      end if
    end if
    if (Ninta < 20) then
      Ninta = 20
      if (Ninta > Nint) then
        print "(/,2x,'Error in the input file:')"
        print "(2x,'the number of integration points Nint is too low;')"        
        stop
      end if
    end if
    Nintparam(1) = Nintb
    Nintparam(3) = Nintb
    Nintparam(2) = Ninta
    do iparam = 1, 3
      Nintl = Nintparam(iparam)
      allocate (xt(Nintl), wt(Nintl))
      if (iparam == 1) then
        atheta = 0._O
        btheta = theta0
      else if (iparam == 2) then
        atheta = theta0
        btheta = Pi - theta0
      else if (iparam == 3) then
        atheta = Pi - theta0
        btheta = Pi
      end if
      call Gauss_Legendre (atheta, btheta, Nintl, wt, xt)
      do p = 1, Nintl
        paramG  (iparam,p) = xt(p)
        weightsG(iparam,p) = wt(p)
      end do
      deallocate (wt, xt)
    end do      
  end select
end subroutine interpolation_listAXSYM
!***********************************************************************************
subroutine zDSAXSYM (TypeGeom, Nsurf, surf, Nrank, ComplexPlane, EpsZReIm, zRe, zIm)
!-----------------------------------------------------------------------------------
! The routine generates the coordinates of the distributed sources in the complex  !
! plane for an axisymmetric particle.                                              !
!                                                                                  !
! Input parameters:                                                                !
! - TypeGeom (integer) - index of the particle geometry.                           !
! - Nsurf (integer) - number of surface parameters.                                !
! - surf (real array) - surface parameters.                                        !              
! - Nrank (integer) - number of distributed sources (maximum expansion order).     !
! - ComplexPlane (logical) - if ComplexPlane = t, the distributed sources          !
!   are placed in the complex plane.                                               !
! - EpsZReIm (real) - parameter controlling the distribution of the discrete       !
!   sources.                                                                       !
!                                                                                  ! 
! Output parameters:                                                               !
! - zRe, zIm (real arrays) - coordinates of the distributed sources in the         !
!   complex plane.                                                                 ! 
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none
  integer :: TypeGeom, Nrank, Nsurf
  real(O) :: surf(Nsurf), EpsZReIm, zRe(Nrank), zIm(Nrank)  
  logical :: ComplexPlane
!
  integer :: i
  real(O) :: zmin, zmax      
!  
  select case (TypeGeom)        
  case (1,2,3)
! ---- spheroid & cylinder ---        
    if (.not. ComplexPlane) then
      zmin = - EpsZReIm * surf(1)
      zmax =   EpsZReIm * surf(1)
      do i = 1, Nrank       
        zRe(i) = zmin + (i - 1) * 2._O * zmax / (Nrank - 1)
        zIm(i) = 0._O  
      end do
    else 
      zmin = - EpsZReIm * surf(2)
      zmax =   EpsZReIm * surf(2) 
      do i = 1, Nrank       
        zRe(i) = 0._O
        zIm(i) = zmin + (i - 1) * 2._O * zmax / (Nrank - 1)
      end do
    end if
  end select
end subroutine zDSAXSYM
! ----------------------------------------------------------------------------------
!                           NONAXISYMMETRIC PARTICLES                              !
!                                                                                  ! 
! The significance of the geometry parameters specified in the input files is      !
! given below.                                                                     !
!                                                                                  ! 
!    Particle      TypeGeom   Nsurf   Nparam                surf                   !
!    ellipsoid        1         3       1         surf(1) - length of the semi-    !
!                                                           axis along the x-axis  !          
!                                                 surf(2) - length of the semi-    !
!                                                           axis along the y-axis  ! 
!                                                 surf(3) - length of the semi-    !
!                                                           axis along the z-axis  ! 
!                                                                                  !
!    quadratic        2         2       6         surf(1) - half-length of         !
!      prism                                                the prism              !  
!                                                 surf(2) - half-length of the     !
!                                                           square side            !
!                                                                                  !
!   regular N-hedral  3         2       2         surf(1) - half-length of         !
!       prism                       if mirror  = t;         the prism              !
!   (with azimuthal                     3         surf(2) - half-lenght of the     !
!    symmetry and                   if mirror  = f          side of the regular    !
!    optionally with                                        basis                  !
!    mirror symmetry                                                               !
!                                                                                  !
! 1. In order to explain the significance of the surface parameters we consider    !
! the geometry depicted in Figure 1.                                               !
!                                                                                  !
!                                                                                  ! 
!               :       a        :                            v_i /\   u_i         !
!               :/- - - - - - - /:                            \  /  \              !
!               :                :                             \/    \ /           ! 
!               ----------------- .........                    /\     /            !
!             / | z ^          / |      /            z ^      /  \   / \           !
!           /       |        /   |    /  b             |     /    \ /   \          !
!         /     |   |      /     |  /                  |     \ O_i o     \         !
!        ----------------- ......|....                 |      \   / \    /         ! 
!       |       |   |     |      | /                   |       \ /   \  /          !
!       |           |     | y    | !                   |    S_i /     \/           !
!       |       | O o - - |->    | !                   |       / \    /\           !
!       |       _ _/_ _ _ |_ _ _ | !                 O |        y \  /  \          !
!       |         /       |        !  c                o --------> \/              !
!       |     /  / x      |    /   !                  /                            !
!       |   /             |  /     !                 /                             !
!       | /               |/       !                /                              !
!        ----------------- ......../..           x /                               !
!                                                                                  !
!                                   Figure 1                                       !
!                                                                                  !
! The surface S is characterized by Nsurf = 3 surface parameters:                  !
!                                                                                  !
!                 surf(1) = a, surf(2) = b and surf(3) = c,                        !
!                                                                                  !
! and consists of Nparam = 6 smooth surfaces S_1, S_2,...,S_6, i.e.,               !
!                                                                                  !
!                          S = S_1  U  S_2  U ... U  S_6.                          !
!                                                                                  !
! On each smooth surface S_i, i = 1,2,... Nparam, we consider the surface          !
! parameters u_i and v_i (which vary in the intervals Iu_i and Iv_i, respectively),!
! and assume the following parametric representation:                              !
!                                                                                  !
!        S_i = {(x,y,z) / x = x_i(u_i,v_i), y = y_i(u_i,v_i), z = z_i(u_i,v_i)     !
!                with u_i in Iu_i and v_i in Iv_i }.                               !
!                                                                                  !
! In the routines contained in the geometry library, "iparam" stands for i and for !
! a given index i, "param1" stands for u_i and "param2" stands for v_i. In order   !
! to define the geometry parameters, we consider a generic smooth surface, for     !
! which we omit to indicate the dependency on the index i,                         !
!                                                                                  !
!        S = {(x,y,z) / x = x(u,v), y = y(u,v), z = z(u,v)                         !
!              with u in Iu and v in Iv }                                          !
!                                                                                  !
! The magnitude of the position vector is given                                    !
!                                                                                  !
!               r(u,v) = sqrt ( x(u,v)**2 + y(u,v)**2 + z(u,v)**2 ),               !
!                                                                                  !
! and the zenith angle theta and the azimuthal angle phi are the polar angles of   !
! the position vector r. Setting                                                   !
!                          dx                   dx                                 !
!               x_u(u,v) = --(u,v),  x_v(u,v) = --(u,v),                           !
!                          du                   dv                                 ! 
! and similarly for y_u, y_v, z_u and z_v, and introducing the fundamental         !
! parameters of the surface by                                                     !
!                                                                                  !
!        E(u,v) = x_u(u,v)**2 + y_u(u,v)**2 + z_u(u,v)**2,                         !
!                                                                                  !
!        G(u,v) = x_v(u,v)**2 + y_v(u,v)**2 + z_v(u,v)**2,                         !
!                                                                                  !
!        F(u,v) = x_u(u,v) * x_v(u,v) + y_u(u,v) * y_v(u,v) + z_u(u,v) * z_v(u,v), !
!                                                                                  !        
! we define the surface element as                                                 !
!                                                                                  !
!        dA(u,v) = sqrt ( E(u,v) * G(u,v) - F(u,v)**2 ).                           !
!                                                                                  ! 
! The tangential unit vectors to the line coordinates of S tau1 and tau2 are given !
! by (in Cartesian coordinates)                                                    !
!                                                                                  !
!        tau1_x(u,v) = x_u(u,v) / sqrt (x_u(u,v)**2 + y_u(u,v)**2 + z_u(u,v)**2),  !
!                                                                                  !
!        tau1_y(u,v) = y_u(u,v) / sqrt (x_u(u,v)**2 + y_u(u,v)**2 + z_u(u,v)**2),  !
!                                                                                  !
!        tau1_z(u,v) = z_u(u,v) / sqrt (x_u(u,v)**2 + y_u(u,v)**2 + z_u(u,v)**2),  !
!                                                                                  !
! and                                                                              !
!                                                                                  !
!        tau2_x(u,v) = x_v(u,v) / sqrt (x_v(u,v)**2 + y_v(u,v)**2 + z_v(u,v)**2),  !
!                                                                                  !
!        tau2_y(u,v) = y_v(u,v) / sqrt (x_v(u,v)**2 + y_v(u,v)**2 + z_v(u,v)**2),  !
!                                                                                  !
!        tau2_z(u,v) = z_v(u,v) / sqrt (x_v(u,v)**2 + y_v(u,v)**2 + z_v(u,v)**2),  !
!                                                                                  !
! respectively, while the normal unit vector is (in Cartesian coordinates)         !
!                                                                                  !  
!                n(u,v) = tau1(u,v) x tau2(u,v) / |tau1(u,v) x tau2(u,v)|.         !
!                                                                                  !
! Note that in spherical coordinates, we have                                      !
!                                                                                  !
!      n_r(u,v)     =   sin(theta) * cos(phi) * n_x(u,v) +                         !               
!                       sin(theta) * sin(phi) * n_y(u,v) + cos(theta) * n_z(u,v)   !
!                                                                                  !
!      n_theta(u,v) =   cos(theta) * cos(phi) * n_x(u,v) +                         !              
!                       cos(theta) * sin(phi) * n_y(u,v) - sin(theta) * n_z(u,v)   !
!                                                                                  !
!      n_phi(u,v)   = - sin(phi) * n_x(u,v) + cos(phi) * n_y(u,v)                  !
!                                                                                  !
! 2. To compute the integrals over the particle surface we define nodes and weights! 
! on each smooth surface S_i. The numbers of integration points on the surface S_i !
! are                                                                              !
!                                                                                  !
!                      Nint1_i = int { c1_i * Nint1 },                             !
!                                                                                  !
! and                                                                              !
!                                                                                  !
!                      Nint2_i = int { c2_i * Nint2 },                             !
!                                                                                  !                     
! where c1_i and c2_i are multiplicative factors, c1_i < 1 and c2_i < 1, and Nint1 !
! and Nint2 are the global numbers of integration points. In the routines          !
! contained in the geometry library, Nintparam(i) stands for Nint1_i and Nint2_i,  !
! where i = 1,2,...,Nparam. The code generate Nint1_i nodes and weights in the     !
! interval Iu_i, and Nint2_i nodes and weights in the interval Iv_i. The nodes are !
! stored in the arrays                                                             !
!                                                                                  !
!              paramG1(i,j), i = 1,2,...,Nparam and j = 1,2,...,Nintparam(i)       !
!                                                                                  !
! and                                                                              !
!                                                                                  !
!              paramG2(i,j), i = 1,2,...,Nparam and j = 1,2,...,Nintparam(i)       !
!                                                                                  !
! while the weights are stored in the array                                        !
!                                                                                  !
!              weightsG(i,j), i = 1,2,...,Nparam and j = 1,2,...,Nintparam(i),     !
!                                                                                  !
! respectively. In order to explain the occupation of the arrays "paramG1",        !
! "paramG2" and "weightsG", we fix i and consider the discretization depicted in   !
! Figure 2.                                                                        !   
!                                                                                  !          
!             v ^                                                                  !
!          Nint2|...o-----o-----o-----o                                            !
!             : |   |     |     |     |                                            !
!             : |   |     |     |     |                                            !
!             l |...o-----o-----o-----o                                            !
!             : |   |     |     |     |                                            !
!             : |   |     |     |     |                                            !
!             2 o...o-----o-----o-----o                                            !
!               |   |     |     |     |                                            !
!               |   |     |     |     |                                            !
!             1 o...o-----o-----o-----o                                            !
!               |   :     :     :     :                                            !
!             O o --o-----o-----o-----------> u                                    !
!                   1     2 ... k...Nint1                                          ! 
!                                                                                  !
!                                      Figure 2                                    !
!                                                                                  !
! With {u_k}, k = 1,2,...,Nint1, being a discretization of the interval Iu, and    !
! {v_l}, l = 1,2,...,Nint2, being a discretization of the interval Iv, we have     !
!                                                                                  !
!               paramG1(*,(k-1)*Nint2+l) = u_k                                     !
!                                                                                  !
! and                                                                              !
!                                                                                  !
!               paramG1(*,(k-1)*Nint2+l) = v_l.                                    !
!                                                                                  !   
! Further,                                                                         !
!                                                                                  !
!               weightsG(*,(k-1)*Nint2+l) = wu_k * wv_l,                           !
!                                                                                  !
! where {wu_k} are the weights on the interval Iu and {wv_l} are the weights on    !
! the interval Iv.                                                                 !
!                                                                                  !
! Two important parameters of the routines are the logical variable "mirror " and  !
! the integer variable "Nazimutsym". For particles with a plane of symmetry        !
! perpendicular to the axis of rotation (mirror symmetric particles with mirror  = !
! .true.) with the surface parametrization                                         !
!                                                                                  !
!                       r(theta,phi) = r(Pi - theta,phi),                          !
!                                                                                  !
! the T matrix can be computed by integrating theta over the interval [0,Pi/2].    !
! For particles with azimuthal symmetry, i.e., particles with the surface          !       
! parametrization                                                                  !
!                                                                                  !
!                       r(theta,phi) = r(theta,phi + 2Pi / Nazimutsym),            !
!                                                                                  ! 
! where Nazimutsym >= 2, the T matrix can be computed by integrating phi over      !
! the interval [0,2Pi/Nazimutsym].                                                 !
!                                                                                  ! 
! 3. The routine "SurfaceElemNint" computes the following parameters of each       !
! discretized smooth surface i:                                                    !
! - the total area                                                                 !
!                dAtot = SUM {p = 1,2,...,Nintparam(i)} dA(p) * ponderG(i,p),      ! 
! - the mean area of the surface elements                                          !
!                dAmean = dAtot / Nintparam(i),                                    !
! - the maximum area of the surface elements                                       !
!                dAmax = MAX {p = 1,2,...,Nintparam(i)} dA(p) * ponderG(i,p),      !
! - the minimum area of the surface elements                                       !
!                dAmax = MIN {p = 1,2,...,Nintparam(i)} dA(p) * ponderG(i,p),      !
! - and the number of elements per unit surface (number density).                  !
!                Nd = Nintparam(i) / dAtot                                         !
!                                                                                  !
! 4. The user can easily modify the routines: "elem_geom3D", "interpolation_list3D"!
! and "SurfaceElemNint" to generate particles with other geometries. A new geometry!
! with the index TypeGeom = 4 can be added to the existing geometries, but the     !
! list of parameters must be maintained.                                           ! 
! ----------------------------------------------------------------------------------
subroutine elem_geom3D (TypeGeom, Nsurf, surf, param1, param2, iparam, r, theta,    &
           phi, dA, n, mirror , Nazimutsym)
!-----------------------------------------------------------------------------------
! The routine computes the geometry parameters of a nonaxisymmmetric surface       !
! for a given surface parameter.                                                   !
!                                                                                  !
! Input parameters:                                                                !
! - TypeGeom (integer) - index of the particle geometry.                           !
! - Nsurf (integer) - number of surface parameters.                                !
! - surf (real array) - surface parameters specifying the shape of the particle.   !              
! - param1, param2 (real variables) - actual surface parameters.                   !
! - iparam (integer) - index of the actual surface parameters.                     !
! - mirror  (logical) - if mirror  = t, the particle is mirror symmetric (the plane!
!   of symmetry or the plane of reflection is perpendicular to the axis of         !
!   rotation).                                                                     !
! - Nazimutsym (integer) - number of azimuthal symmetric sections. Note that       !
!   Nazimutsym >= 2.                                                               !
!                                                                                  !
! Output parameters:                                                               !
! - r (real) - module of the position vector.                                      !    
! - theta (real) - zenith angle.                                                   !
! - phi (real) - azimuthal angle.                                                  !
! - dA (real) - surface element.                                                   !
! - n (real array) - normal unit vector in spherical coordinates.                  !
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none  
  integer  :: TypeGeom, Nsurf, iparam, Nazimutsym
  real(O)  :: surf(Nsurf), param1, param2, r, theta, phi, dA, n(3)
  logical  :: mirror 
!
  real(O)  :: a, b, c, u, v, x, y, z, xt, yt, zt, xp, yp, zp, E,F , G, tampon,      &
              tau1(3), tau2(3), nc(3), ro, l, alpha
!
  select case (TypeGeom)
  case (1)
!   --- ellipsoid ---  
    a = surf(1)
    b = surf(2)
    c = surf(3)
    if (iparam == 1) then
      u = param1
      v = param2
      x = a * sin(u) * cos(v)
      y = b * sin(u) * sin(v)
      z = c * cos(u)      
      call T_cartesian_spherical (x, y, z, r, theta, phi)
      xt =   a * cos(u) * cos(v)
      yt =   b * cos(u) * sin(v)
      zt = - c * sin(u)
      xp = - a * sin(u) * sin(v)
      yp =   b * sin(u) * cos(v)
      zp =   0._O
      E  =   xt * xt + yt * yt + zt * zt
      G  =   xp * xp + yp * yp + zp * zp
      F  =   xt * xp + yt * yp + zt * zp
      dA =   sqrt(E * G - F * F)
      tampon  = sqrt(xt * xt + yt * yt + zt * zt)
      tau1(1) = xt / tampon
      tau1(2) = yt / tampon
      tau1(3) = zt / tampon
      tampon = sqrt(xp * xp + yp * yp + zp * zp)
      if (tampon == 0._O) then
        tau2(1) = 0._O
        tau2(2) = 1._O
        tau2(3) = 0._O
      else
        tau2(1) = xp / tampon
        tau2(2) = yp / tampon
        tau2(3) = 0._O
      end if
      call vector_product_real (tau1, tau2, nc)
      tampon = sqrt(nc(1)**2 + nc(2)**2 + nc(3)**2)
      nc(1) =  nc(1) / tampon
      nc(2) =  nc(2) / tampon
      nc(3) =  nc(3) / tampon        
      n(1)  =   sin(theta) * cos(phi) * nc(1) +                                     &
                sin(theta) * sin(phi) * nc(2) + cos(theta) * nc(3)
      n(2)  =   cos(theta) * cos(phi) * nc(1) +                                     &
                cos(theta) * sin(phi) * nc(2) - sin(theta) * nc(3)
      n(3)  = - sin(phi) * nc(1) + cos(phi) * nc(2)
    endif
  case (2)
!   --- quadratic prism --- 
    a = surf(1)
    l = surf(2)
    if (iparam == 1) then
      x = a
      y = param2
      z = param1
      nc(1) = 1._O
      nc(2) = 0._O
      nc(3) = 0._O
    else if (iparam == 2) then
      x = param2
      y = a
      z = param1
      nc(1) = 0._O
      nc(2) = 1._O
      nc(3) = 0._O
    else if (iparam == 3) then
      x = - a
      y =   param2
      z =   param1
      nc(1) = - 1._O
      nc(2) =   0._O
      nc(3) =   0._O
    else if (iparam == 4) then
      x =   param2
      y = - a
      z =   param1
      nc(1) =   0._O
      nc(2) = - 1._O
      nc(3) =   0._O
    else if (iparam == 5) then
      x =    param2
      y =    param1
      z =  - l
      nc(1) =   0._O
      nc(2) =   0._O
      nc(3) = - 1._O
    else if (iparam == 6) then
      x = param2
      y = param1
      z = l
      nc(1) = 0._O
      nc(2) = 0._O
      nc(3) = 1._O
    end if 
    call T_cartesian_spherical (x, y, z, r, theta, phi)
    dA = 1._O
    n(1) =   sin(theta) * cos(phi) * nc(1) + sin(theta) * sin(phi) * nc(2) +        &
             cos(theta) * nc(3)
    n(2) =   cos(theta) * cos(phi) * nc(1) + cos(theta) * sin(phi) * nc(2) -        &
             sin(theta) * nc(3)
    n(3) = - sin(phi) * nc(1) + cos(phi) * nc(2)
  case (3)
!  --- regular N-hedral prism --- 
    a = surf(1)
    l = surf(2) 
    alpha = Pi / Nazimutsym
    b = a / tan(alpha)  
    if (iparam == 1) then
      x  = param2
      y  = b
      z  = param1
      dA = 1._O
      nc(1) = 0._O
      nc(2) = 1._O
      nc(3) = 0._O     
    else if (iparam == 2) then
      ro  = param2
      phi = param1
      x  = ro * sin(phi)
      y  = ro * cos(phi)
      z  = l
      dA = ro
      nc(1) = 0._O
      nc(2) = 0._O
      nc(3) = 1._O 
    else if (iparam == 3 .and. .not. mirror ) then
      ro  = param2
      phi = param1
      x  =   ro * sin(phi)
      y  =   ro * cos(phi)
      z  = - l
      dA =   ro
      nc(1) =   0._O
      nc(2) =   0._O
      nc(3) = - 1._O            
    end if
    call T_cartesian_spherical (x, y, z, r, theta, phi) 
    n(1) =   sin(theta) * cos(phi) * nc(1) + sin(theta) * sin(phi) * nc(2) +        &
             cos(theta) * nc(3)
    n(2) =   cos(theta) * cos(phi) * nc(1) + cos(theta) * sin(phi) * nc(2) -        &
             sin(theta) * nc(3)
    n(3) = - sin(phi) * nc(1) + cos(phi) * nc(2)          
  end select
end subroutine elem_geom3D 
! **********************************************************************************
subroutine interpolation_list3D (TypeGeom, Nsurf, surf, Nint1, Nint2, NintAL,       &
           Nparam, Nintparam, paramG1, paramG2, weightsG, mirror , Nazimutsym)
!-----------------------------------------------------------------------------------
! The routine provides the nodes and weights for computing integrals over a        !
! nonaxisymmmetric surface.                                                        !
!                                                                                  !
! Input parameters:                                                                !
! - TypeGeom (integer) - index of the particle geometry.                           !
! - Nsurf (integer) - number of surface parameters.                                !
! - surf (real array) - surface parameters specifying the shape of the particle.   !
! - Nint1, Nint2 (integer variables) - global numbers of integration points.       !
! - NintAL (integer) - specifies the dimension of Nintparam, paramaG1, paramG2     !
!   and weightsG.                                                                  !
! - Nparam (integer) - number of integration surfaces.                             !
! - mirror  (logical) - if mirror  = t, the particle is mirror symmetric (the plane!
!   of symmetry or the plane of reflection is perpendicular to the axis of         !
!   rotation).                                                                     !
! - Nazimutsym (integer) - number of azimuthal symmetric sections. Note that       !
!   Nazimutsym >= 2.                                                               !
!                                                                                  ! 
! Output parameters:                                                               !
! - Nintparam (integer array) - number of integration points (nodes) on all        !
!   integration surfaces.                                                          !
! - paramG1, paramG2 (real arrays) - integration points (nodes) on all             !
!   integration surfaces.                                                          !
! - weightsG (real array) - weights on all integration surfaces.                   !            
!-----------------------------------------------------------------------------------  
  use parameters
  implicit none
  integer :: TypeGeom, Nsurf, Nint1, Nint2, NintAL, Nparam, Nazimutsym,             &
             Nintparam(Nparam)
  real(O) :: surf(Nsurf), paramG1(Nparam,NintAL*NintAL),                            &
             paramG2(Nparam,NintAL*NintAL), weightsG(Nparam,NintAL*NintAL)
  logical :: mirror 
!
  integer :: i, j, N1, N2, N3, k
  real(O) :: a, b, l, alpha, phi, ro
  real(O),allocatable :: xt(:), wt(:), xp(:), wp(:) 
!
  do i = 1, Nparam
    do j = 1, NintAL * NintAL
      paramG1 (i,j) = 0._O
      paramG2 (i,j) = 0._O
      weightsG(i,j) = 0._O
    end do
  end do
  select case (TypeGeom)
  case (1)
!   --- ellipsoid ----  
    if (mirror) then
      N1 = int(Nint1 / 2) + 1  ! alternative setting N1 = Nint1
    else    
      N1 = Nint1
    end if
    N2 = Nint2
    Nintparam(1) = N1 * N2
    allocate (xt(N1), wt(N1), xp(N2), wp(N2))     
    a = 0._O
    if (.not. mirror) then
      b = Pi
    else
      b = Pi / 2._O
    end if
    call Gauss_Legendre (a, b, N1, wt, xt)
    a = 0._O
    b = 2._O * Pi
    call Gauss_Legendre (a, b, N2, wp, xp)      
    do j = 1, N1
      do i = 1, N2
        paramG1 (1,(j-1)*N2+i) = xt(j)
        paramG2 (1,(j-1)*N2+i) = xp(i)
        weightsG(1,(j-1)*N2+i) = wt(j) * wp(i)
      end do
    end do
    deallocate (xt, wt, xp, wp)
  case (2)
!   --- quadratic prism ---
    a  = surf(1)
    l  = surf(2)       
    N1 = Nint1
    N2 = Nint2
    allocate (xt(N1), wt(N1), xp(N2), wp(N2))       
    call Gauss_Legendre (- l, l, N1, wt, xt)
    call Gauss_Legendre (- a, a, N2, wp, xp)  
    do k = 1, 4
      Nintparam(k) = N1 * N2
      do i = 1, N1
        do j = 1, N2
          paramG1 (k,(i-1)*N2+j) = xt(i)
          paramG2 (k,(i-1)*N2+j) = xp(j)
          weightsG(k,(i-1)*N2+j) = wt(i) * wp(j)
        end do
      end do
    end do
    do k = 5, 6
      Nintparam(k) = N2 * N2
      do i = 1, N2
        do j = 1, N2
          paramG1 (k,(i-1)*N2+j) = xp(i)
          paramG2 (k,(i-1)*N2+j) = xp(j)
          weightsG(k,(i-1)*N2+j) = wp(i) * wp(j)
        end do
      end do
    end do
    deallocate (xt, wt, xp, wp)
  case (3)
!   --- regular N-hedral prism --- 
    a  = surf(1)
    l  = surf(2)
    if (mirror) then
      N1 = int(Nint1 / 2) + 1 ! alternative setting: N1 = Nint1  
    else
      N1 = Nint1
    end if
    N2 = Nint2
    N3 = N2       ! alternative setting: N3 = int(Nint2 / 4) + 3                                      
    Nintparam(1) = N1 * N2  
    allocate (xt(N1), wt(N1), xp(N2), wp(N2))       
    if (mirror) then
      call Gauss_Legendre (0._O, l, N1, wt, xt)
    else
      call Gauss_Legendre (- l, l, N1, wt, xt)
    end if
    call Gauss_Legendre (- a, a, N2, wp, xp)                
    do i = 1, N1
      do j = 1, N2
        paramG1 (1,(i-1)*N2+j) = xt(i)
        paramG2 (1,(i-1)*N2+j) = xp(j)
        weightsG(1,(i-1)*N2+j) = wt(i) * wp(j)
      end do
    end do      
    deallocate (xt, wt)
    allocate (xt(N3), wt(N3))
    Nintparam(2) = N2 * N3 
    if (.not. mirror) Nintparam(3) = N2 * N3
    alpha = Pi / Nazimutsym
    b = a / tan(alpha)                      
    call Gauss_Legendre (- alpha, alpha, N2, wp, xp)
    do i = 1, N2
      phi = xp(i)             
      ro  = b / cos(phi)      
      call Gauss_Legendre (0._O, ro, N3, wt, xt)
      do j = 1, N3      
        paramG1 (2,(i-1)*N3+j) = xp(i)
        paramG2 (2,(i-1)*N3+j) = xt(j)
        weightsG(2,(i-1)*N3+j) = wp(i) * wt(j)  
        if (.not. mirror) then
          paramG1 (3,(i-1)*N3+j) = xp(i)
          paramG2 (3,(i-1)*N3+j) = xt(j)
          weightsG(3,(i-1)*N3+j) = wp(i) * wt(j)                
        end if 
      end do
    end do      
    deallocate (xt, wt, xp, wp)      
  end select
end subroutine interpolation_list3D
! **********************************************************************************
subroutine SurfaceElemNint (wavenumber, TypeGeom, Nparam, Nsurf, surf, mirror ,       &
           Nazimutsym, Nint1, Nint2)
! ----------------------------------------------------------------------------------
! The routine computes some parameters of the discretized surface: the mean,       !
! maximum and minimum areas of the surface elements and the number of elements per !
! unit surface (number density).                                                   !
! ----------------------------------------------------------------------------------
  use parameters
  integer     :: TypeGeom, Nparam, Nsurf, Nint1, Nint2, Nazimutsym
  real(O)     :: wavenumber, surf(Nsurf)
  logical     :: mirror 
!
  integer     :: i, j, k, NintAL, N1, N2, N3, iparam, pint, Nintl
  real(O)     :: a, b, c, u, v, x, y, z, xth, yth, zth, xph, yph, zph, E, F, G,     &
                 dA, dAmean, dAtot, dAmax, dAmin, l, alpha, phi, ro, param1,        &
                 param2, r, theta  
  integer,allocatable :: Nintparam(:)
  real(O),allocatable :: paramG1(:,:), paramG2(:,:), weightsG(:,:), xt(:), wt(:),   &
                         xp(:), wp(:)   
!       
  NintAL = max(Nint1,Nint2)
  allocate (paramG1(Nparam,NintAL * NintAL), paramG2(Nparam,NintAL * NintAL),       &
            weightsG(Nparam,NintAL * NintAL))
  allocate (Nintparam(Nparam))
  do i = 1, Nparam
    do j = 1, NintAL * NintAL
      paramG1 (i,j) = 0._O
      paramG2 (i,j) = 0._O 
      weightsG(1,j) = 0._O
    end do
  end do  
  print "(/,2x,'Surface Elements for the Input Values of Nint1 and Nint2:')"
  print "(  2x,'surface    dAmean      dAmax       dAmin       dAtotal    NoDens')"                
  select case (TypeGeom)
  case(1)
!   --- ellipsoid ----
    if (mirror) then
      N1 = int(Nint1 / 2) + 1   ! alternative setting: N1 = Nint1
    else    
      N1 = Nint1
    end if                       
    N2 = Nint2
    Nintparam(1) = N1 * N2
    allocate (xt(N1), wt(N1), xp(N2), wp(N2))
    a = 0._O
    if (.not. mirror) then
      b = Pi
    else
      b = Pi / 2._O
    end if                  
    call Gauss_Legendre (a, b, N1, wt, xt)
    a = 0._O
    b = 2._O * Pi
    call Gauss_Legendre (a, b, N2, wp, xp)      
    do j = 1, N1
      do i = 1, N2
        paramG1 (1,(j-1)*N2+i) = xt(j)
        paramG2 (1,(j-1)*N2+i) = xp(i)   
        weightsG(1,(j-1)*N2+i) = wt(j) * wp(i)      
      end do
    end do      
    deallocate (xt, wt, xp, wp) 
    a = wavenumber * surf(1)
    b = wavenumber * surf(2)
    c = wavenumber * surf(3) 
    do iparam = 1, Nparam    
      Nintl  = Nintparam(iparam)
      dAtot =   0._O
      dAmax = - 1.e+10_O
      dAmin =   1.e+10_O
      do pint = 1, Nintl
        param1 = paramG1(iparam,pint)
        param2 = paramG2(iparam,pint)      
        u = param1
        v = param2
        x = a * sin(u) * cos(v)
        y = b * sin(u) * sin(v)
        z = c * cos(u)        
        call T_cartesian_spherical (x, y, z, r, theta, phi)
        xth =   a * cos(u) * cos(v)
        yth =   b * cos(u) * sin(v)
        zth = - c * sin(u)
        xph = - a * sin(u) * sin(v)
        yph =   b * sin(u) * cos(v)
        zph =   0._O
        E  = xth * xth + yth * yth + zth * zth
        G  = xph * xph + yph * yph + zph * zph
        F  = xth * xph + yth * yph + zth * zph
        dA = sqrt(E * G - F * F) * weightsG(iparam,pint)         
        dAtot = dAtot + dA
        if (dA > dAmax) dAmax = dA
        if (dA < dAmin) dAmin = dA
      end do
      dAmean = dAtot / Nintl
      print "(4x,i2,4x,1pe10.2,2x,1pe10.2,2x,1pe10.2,2x,1pe10.2,1x,1pe10.2)",       &
              iparam, dAmean, dAmax, dAmin, dAtot, Nintl / dAtot                                                
    end do
  case(2)
!   --- quadratic prism ---
    a  = wavenumber * surf(1)
    l  = wavenumber * surf(2)
    N1 = Nint1
    N2 = Nint2
    allocate (xt(N1), wt(N1), xp(N2), wp(N2))
    call Gauss_Legendre (-l, l, N1, wt, xt)
    call Gauss_Legendre (-a, a, N2, wp, xp)
    do k = 1, 4
      Nintparam(k) = N1 * N2
      do i = 1, N1
        do j = 1, N2
          paramG1 (k,(i-1)*N2+j) = xt(i)
          paramG2 (k,(i-1)*N2+j) = xp(j)   
          weightsG(k,(i-1)*N2+j) = wt(i) * wp(j)      
        end do
      end do  
    end do
    do k = 5, 6
      Nintparam(k) = N2 * N2
      do i = 1, N2
        do j = 1, N2
          paramG1 (k,(i-1)*N2+j) = xp(i)
          paramG2 (k,(i-1)*N2+j) = xp(j)   
          weightsG(k,(i-1)*N2+j) = wp(i) * wp(j)      
        end do
      end do  
    end do 
    deallocate (xt, wt, xp, wp)
    do iparam = 1, Nparam    
      Nintl  = Nintparam(iparam)
      dAtot =   0._O
      dAmax = - 1.e+10_O
      dAmin =   1.e+10_O
      do pint = 1, Nintl        
        dA    = weightsG(iparam,pint)    
        dAtot = dAtot + dA
        if (dA > dAmax) dAmax = dA
        if (dA < dAmin) dAmin = dA
      end do
      dAmean = dAtot / Nintl
      print "(4x,i2,4x,1pe10.2,2x,1pe10.2,2x,1pe10.2,2x,1pe10.2,1x,1pe10.2)",       &
              iparam, dAmean, dAmax, dAmin, dAtot, Nintl / dAtot                        
    end do             
  case(3)
!   --- regular N-hedral prism --- 
    a  = wavenumber * surf(1)
    l  = wavenumber * surf(2)
    if (mirror) then
      N1 = int(Nint1 / 2) + 1  ! alternative setting: N1 = Nint1 
    else    
      N1 = Nint1
    end if    
    N2 = Nint2
    N3 = N2       ! alternative setting: N3 = int(Nint2 / 4) + 3 
    Nintparam(1) = N1 * N2
    allocate (xt(N1), wt(N1), xp(N2), wp(N2))
    if (mirror) then
      call Gauss_Legendre (0._O, l, N1, wt, xt)
    else
      call Gauss_Legendre (-l, l, N1, wt, xt)
    end if
    call Gauss_Legendre (-a, a, N2, wp, xp)
    do i = 1, N1
      do j = 1, N2
        paramG1 (1,(i-1)*N2+j) = xt(i)
        paramG2 (1,(i-1)*N2+j) = xp(j)   
        weightsG(1,(i-1)*N2+j) = wt(i) * wp(j)      
      end do
    end do  
    deallocate (xt, wt)
    allocate (xt(N3), wt(N3))
    Nintparam(2) = N2 * N3
    if (.not. mirror) Nintparam(3) = N2 * N3
    alpha = Pi / Nazimutsym
    b = a / tan(alpha)    
    call Gauss_Legendre (-alpha, alpha, N2, wp, xp)
    do i = 1, N2
      phi = xp(i)
      ro  = b / cos(phi)
      call Gauss_Legendre (0._O, ro, N3, wt, xt)
      do j = 1, N3
        paramG1 (2,(i-1)*N3+j) = xp(i)
        paramG2 (2,(i-1)*N3+j) = xt(j)   
        weightsG(2,(i-1)*N3+j) = wp(i) * wt(j)
        if (.not. mirror) then
          paramG1 (3,(i-1)*N2+j) = xp(i)
          paramG2 (3,(i-1)*N3+j) = xt(j)   
          weightsG(3,(i-1)*N3+j) = wp(i) * wt(j)                
        end if
      end do
    end do  
    deallocate (xt, wt, xp, wp)  
    do iparam = 1, Nparam    
      Nintl  = Nintparam(iparam)
      dAtot =   0._O
      dAmax = - 1.e+10_O
      dAmin =   1.e+10_O
      do pint = 1, Nintl   
        param1 = paramG1(iparam,pint)
        param2 = paramG2(iparam,pint)
        if (iparam == 1) then                            
          dA = weightsG(iparam,pint)     
        else if (iparam == 2 .or. (iparam == 3 .and. .not. mirror)) then
          ro = param2
          dA = ro * weightsG(iparam,pint)   
        end if                        
        dAtot = dAtot + dA
        if (dA > dAmax) dAmax = dA
        if (dA < dAmin) dAmin = dA
      end do
      dAmean = dAtot / Nintl
      print "(4x,i2,4x,1pe10.2,2x,1pe10.2,2x,1pe10.2,2x,1pe10.2,1x,1pe10.2)",       &
              iparam, dAmean, dAmax, dAmin, dAtot, Nintl / dAtot                              
    end do                        
  end select  
  deallocate (paramG1, paramG2, Nintparam)
end subroutine SurfaceElemNint
!-----------------------------------------------------------------------------------
!                              COMPOSITE PARTICLES                                 !
!                                                                                  !
! The significance of the geometry parameters specified in the input files is      !
! given below.                                                                     !
!                                                                                  ! 
!    Particle      TypeGeom   Nsurf   Nparam                surf                   !
!  half-spheroids                                                                  !
!  with offset        1         3       2         surf(1) - length of the semi-    ! 
!    origins                                                axis along the         !
!                                                           symmetry axis          !
!                                                 surf(2) - length of the second   !
!                                                           semi-axis              !
!                                                 surf(3) - distance between the   !
!                                                           half-spheroids basis   !
!                                                           and the origin of the  !
!                                                           local coordinate       !
!                                                           system                 ! 
!                                                                                  ! 
!   3 cylinders       2         2       3         surf(1) - half-length of         !
!                                                           the cylinder           ! 
!                                                 surf(2) - cylinder radius        !
!                                                                                  !
! 1. In order to explain the significance of the surface parameters we consider    !
! the geometry depicted in Figure 1.                                               !
!                                                                                  !
!                                                                    curve iparam  !
!                  a1                                       a1     /               !
!            z ^/- - - /:                           z  ^ /- - -/:/                 !       
!              |        :                              |       /:                  !       
!              |--------............                   |--->---- ......            !                         
!              |        |     /                        | param  |    /             !
!              |        |     !                        |        |    !             !
!              |        |     !                        |        |    ! x1          !
!      ../..O1 o        |     !  b1                 O1 o- - - - | - - ->           !
!    z1  !     |        |     !       x                |        |    ! b1          !
!      ../...O o - - - - - - - - - - - >               |        |    !             !
!        !     |        |     !                        |        |    !             !
!    z2  !     |--------....../.....                   |-------- ..../.            !
!        !     |        |     !                        |                           !
!      ../..O2 o        |     !  b2                                                !
!              |        |     !                                                    ! 
!              |--------....../.....                                               !
!              |   a2   :                                                          !
!              |/- - - /:                                                          !
!                                                                                  !
!           Composite particle             Homogeneous region ipart = 1. The       !
!                                          generatrix consists of Nparam(1) = 3    !
!                                          smooth curves. On the smooth curve      !
!                                          iparam, the curve parameter is param    !
!                                                                                  !
!                                   Figure 1                                       !
!                                                                                  !
! The composite particle consists of Npart = 2 homogeneous regions (cylinders),    !
! and the axial positions of the local coordinate systems (corresponding to the    !
! homogeneous regions) with respect to the global coordinate system of the         !
! composite particle are given by the array "zpart", i.e., zpart(1) = z1 and       !
! zpart(2) = z2. The region ipart = 1 is characterized by Nsurf(ipart) = 2 surface !
! parameters:                                                                      !
!                                                                                  !
!                 surf(ipart,1) = a1 and surf(ipart,2) = b1,                       !
!                                                                                  !
! and the region ipart = 2 is also characterized by Nsurf(ipart) = 2 surface       !
! parameters:                                                                      !
!                                                                                  !
!                 surf(ipart,1) = a2 and surf(ipart,2) = b2.                       !
!                                                                                  !
! In addition to Nsurf(ipart),                                                     !
!                                                                                  !
!              Nsurfmax = MAX {ipart = 1,2,...,Npart} Nsurf(ipart).                !
!                                                                                  !
! is an input parameter of the code. The generatrix of the region "ipart" consists !
! of Nparam(ipart) smooth curves, and                                              !
!                                                                                  ! 
!              Nparammax = MAX {ipart = 1,2,...,Npart} Nparam(ipart)               !
!                                                                                  !
! is also an input parameter of the code. On the smooth curve "iparam" (which      !
! belongs to the region "ipart") we consider the curve parameter "param", which    !
! is defined with respect to the local coordinate system of the region "ipart".    !
! Consequently, the magnitude of the position vector r, the zenith angle theta,    !
! the surface element dA and the normal unit vector in spherical coordinates n (on !
! each smooth curve "iparam" belonging to the region "ipart") correspond to the    !
! LOCAL COORDINATE SYSTEM of the region. The significance of these parameters is   !
! as for axisymmetric particles.                                                   !
!                                                                                  ! 
! 2. To compute the integrals over the particle surface we define nodes and weights!
! on each smooth curve "iparam" (which belongs to the region "ipart"). As for      !
! axisymmetric particles, the numbers of integration points is                     !
!   Nintparam(ipart,iparam), ipart = 1,2,.,Npart, iparam = 1,2,.., Nparam(ipart)   !
! while the nodes and weights are stored in the arrays:                            !
!   paramG(ipart,iparam,j), ipart = 1,2,...,Npart, iparam = 1,2,..,Nparam(ipart),  !
!                           j = 1,2,...,Nintparam(ipart,iparam),                   !
! and                                                                              !
!   weightsG(ipart,iparam,j), ipart = 1,2,...,Npart, iparam = 1,2,..,Nparam(ipart),!
!                             j = 1,2,...,Nintparam(ipart,iparam),                 !
! respectively. Because the curve parameter "param" is defined with respect to the !
! local coordinate system of the region "ipart", the nodes correspond to the LOCAL !  
! COORDINATE SYSTEM of the region.                                                 !
!                                                                                  !
! 3. To distribute the discrete sources we follow the same prescriptions as for    !
! axisymmetric particles. However, the coordinates of the discrete sources are     !
! defined with respect to the GLOBAL COORDINATE SYSTEM. If Nranp(ipart) is the     !
! number of discrete sources for the region "ipart", and zRe'(ipart,j) and         !
! zIm'(ipart,j) with j = 1,2,...,Nranp(ipart), are the coordinates of the discrete !
! sources in the local coordinate system of the region, then                       !
!                                                                                  !
!            zRe(ipart,j) = zRe'(ipart,j) + zpart(ipart) and                       !
!                                                                                  ! 
!            zIm(ipart,j) = zIm'(ipart,j) + zpart(ipart).                          !
!                                                                                  !
! 4. The user can easily modify the routines: "elem_geomCOMP",                     !
! "interpolation_listCOMP" and "zDSCOMP" to generate particles with other          !
! geometries. A new geometry with the index TypeGeom = 3 can be added to the       !
! existing geometries, but the list of parameters must be maintained.              !  
!-----------------------------------------------------------------------------------
subroutine elem_geomCOMP (TypeGeom, Npart, ipart, Nsurfmax, surf, param, iparam, r, &
           theta, phi, dA, n)
!-----------------------------------------------------------------------------------
! The routine computes the geometry parameters of a composite particle.            !
!                                                                                  !
! Input parameters:                                                                !
! - TypeGeom (integer) - index of the particle geometry.                           !
! - Npart (integer) - number of homogeneous regions.                               !
! - ipart (integer) - index of the actual homogeneous region.                      !
! - Nsurfmax (integer) - maximum number of surface parameters.                     !
! - surf (real array) - surface parameters of all regions.                         !              
! - param (real) - actual curve (surface) parameter for the region ipart.          !
! - iparam (integer) - index of the actual curve (surface) parameter for the       !
!   region ipart.                                                                  !
!                                                                                  !
! Output parameters:                                                               !
! - r (real) - magnitude of the position vector.                                   !    
! - theta (real) - zenith angle.                                                   !
! - phi (real) - azimuthal angle.                                                  !
! - dA (real) - surface element.                                                   !
! - n (real array) - normal unit vector in spherical coordinates.                  ! 
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none  
  integer :: TypeGeom, Npart, ipart, Nsurfmax, iparam
  real(O) :: surf(Npart,Nsurfmax), param, r, theta, phi, dA, n(3)
!
  real(O) :: a, b, c, e, tamp, dr, tamp1, tamp2, tamp3, tamp4
!
  select case (TypeGeom)
  case (1)
!   --- half-spheroids with offset origins ---
    phi = 0._O
    a = surf(ipart,1)
    b = surf(ipart,2)
    c = surf(ipart,3)
    e = a / b
    theta  = param
    if (ipart == 1) then      
      if (iparam == 1) then     
        tamp1 =   a * a * cos(theta) * cos(theta) +                                 &
                 (a * a - c * c) * e * e * sin(theta) * sin(theta)
        tamp2 = - a * a * cos(theta) * sin(theta) +                                 &
                 (a * a - c * c) * e * e * sin(theta) * cos(theta)
        tamp3 =   cos(theta) * cos(theta) + e * e * sin(theta) * sin(theta)
        tamp4 = - cos(theta) * sin(theta) + e * e * sin(theta) * cos(theta)
        r  = (sqrt(tamp1) - c * cos(theta)) / tamp3
        dr = (tamp2 / sqrt(tamp1) + c * sin(theta)) / tamp3 -                       &
              2._O * (sqrt(tamp1) - c * cos(theta)) * tamp4 / tamp3 / tamp3          
      else if (iparam == 2) then       
        r  = - c / cos(theta)
        dr = - c * sin(theta) / cos(theta) / cos(theta)
      end if
    else if (ipart == 2) then         
      if (iparam == 1) then     
        r  = c / cos(theta)
        dr = c * sin(theta) / cos(theta) / cos(theta) 
      else if (iparam == 2) then        
        tamp1 =   a * a * cos(theta) * cos(theta) +                                 &
                 (a * a - c * c) * e * e * sin(theta) * sin(theta)
        tamp2 = - a * a * cos(theta) * sin(theta) +                                 &
                 (a * a - c * c) * e * e * sin(theta) * cos(theta)
        tamp3 =   cos(theta) * cos(theta) + e * e * sin(theta) * sin(theta)
        tamp4 = - cos(theta) * sin(theta) + e * e * sin(theta) * cos(theta)
        r  = (sqrt(tamp1) + c * cos(theta)) / tamp3
        dr = (tamp2 / sqrt(tamp1) - c * sin(theta)) / tamp3 -                       &
              2._O * (sqrt(tamp1) + c * cos(theta)) * tamp4 / tamp3 / tamp3                     
      end if
    end if
    tamp =   sqrt(r * r + dr * dr)
    dA   =   tamp * r * sin(theta)
    n(1) =   r / tamp
    n(2) = - dr / tamp
    n(3) =   0._O
  case (2)
!   --- 3 cylinders ---
    phi  = 0._O
    a = surf(ipart,1)
    b = surf(ipart,2)    
    theta = param         
    if (iparam == 1) then      
      r  = a / cos(theta)
      dr = a * sin(theta) / cos(theta) / cos(theta)                    
    else if (iparam == 2) then      
      r  =   b / sin(theta)
      dr = - b * cos(theta) / sin(theta) / sin(theta)                             
    else if (iparam == 3) then      
      r  = - a / cos(theta)
      dr = - a * sin(theta) / cos(theta) / cos(theta)                    
    end if
    tamp =   sqrt(r * r + dr * dr)
    dA   =   tamp * r * sin(theta)
    n(1) =   r / tamp
    n(2) = - dr / tamp      
    n(3) =   0._O
  end select     
end subroutine elem_geomCOMP
! **********************************************************************************
subroutine interpolation_listCOMP (TypeGeom, Npart, Nsurfmax, surf, Nint, Nparammax,&
               Nintparam, paramG, weightsG)
!-----------------------------------------------------------------------------------
! The routine provides the nodes and weights for computing integrals over the      !
! surface of a composite particle.                                                 !
!                                                                                  !
! Input parameters:                                                                !
! - TypeGeom (integer) - index of the particle geometry.                           !
! - Npart (integer) - number of homogeneous regions.                               !
! - Nsurfmax (integer) - maximum number of surface parameters.                     !
! - surf (real array) - surface parameters of all regions.                         !              
! - Nint (integer) - global number of integration points.                          !
! - Nparammax (integer) - maximum number of integration curves.                    !
!                                                                                  ! 
! Output parameters:                                                               !
! - Nintparam (integer array) - number of integration points (nodes) on all        !
!   integration curves and regions.                                                !    
! - paramG (real array) - integration points (nodes) on all integration curves     !
!   and regions.                                                                   !
! - weightsG (real array) - weights on all integration curves and regions.         !
!----------------------------------------------------------------------------------- 
  use parameters                    
  implicit none
  integer :: TypeGeom, Npart, Nsurfmax, Nint, Nparammax, Nintparam(Npart,Nparammax)
  real(O) :: surf(Npart,Nsurfmax), paramG(Npart,Nparammax,Nint),                    &
             weightsG(Npart,Nparammax,Nint)      
!      
  integer  :: ipart, iparam, p, Nintl, NintElip, NintLine, Ninta, Nintb
  real(O)  :: a, b, c, theta0, atheta, btheta, LElip, LLine
  real(O),allocatable :: xt(:), wt(:)
!
  do ipart = 1, Npart
    do iparam = 1, Nparammax
      Nintparam(ipart,iparam) = 0
      do p = 1, Nint
        paramG  (ipart,iparam,p) = 0._O
        weightsG(ipart,iparam,p) = 0._O
      end do
    end do
  end do        
  select case (TypeGeom)
  case (1)
!   --- half-spheroids with offset origins ---          
    do ipart = 1, Npart
      a = surf(ipart,1)
      b = surf(ipart,2)
      c = surf(ipart,3)
      theta0 = atan(b / c)
      LElip = 0.25_O * Pi * (3._O * (a + b) - sqrt((a + 3._O * b) * (3._O * a + b))) 
      LLine = b
      NintElip = int( LElip * Nint / (LElip + LLine) )
      NintLine = Nint - NintElip
      if (NintElip < 20) then
        NintElip = 20
        if (NintElip > Nint) then
          print "(/,2x,'Error in the input file:')"
          print "(2x,'the number of integration points Nint is too low;')"      
          stop
        end if
      end if
      if (NintLine < 20) then
        NintLine = 20
        if (NintLine > Nint) then
          print "(/,2x,'Error in the input file:')"
          print "(2x,'the number of integration points Nint is too low;')"      
          stop
        end if
      end if
      if (ipart == 1) then
        Nintparam(ipart,1) = NintElip
        Nintparam(ipart,2) = NintLine
      else if (ipart == 2) then 
        Nintparam(ipart,1) = NintLine
        Nintparam(ipart,2) = NintElip
      end if       
      do iparam = 1, 2
        Nintl = Nintparam(ipart,iparam)
        allocate (xt(Nintl), wt(Nintl))
        if (ipart == 1) then
          if (iparam == 1) then
            atheta = 0._O
            btheta = Pi - theta0
          else if (iparam == 2) then
            atheta = Pi - theta0
            btheta = Pi
          end if
        else if (ipart == 2) then
          if (iparam == 1) then
            atheta = 0._O
            btheta = theta0
          else if (iparam == 2) then
            atheta = theta0
            btheta = Pi  
          end if
         end if          
         call Gauss_Legendre (atheta, btheta, Nintl, wt, xt)
        do p = 1, Nintl
          paramG  (ipart,iparam,p) = xt(p)
          weightsG(ipart,iparam,p) = wt(p)
        end do
        deallocate (xt, wt)
      end do  
    end do        
  case(2)
!   --- 3 cylinders ---    
    do ipart = 1, Npart
      a = surf(ipart,1)
      b = surf(ipart,2)
      theta0 = atan(b / a)
      Nintb  = int(b * Nint / 2 / (a + b))
      Ninta  = Nint - 2 * Nintb
      if (Nintb < 20) then
        Nintb = 20
        if (Nintb > Nint) then
          print "(/,2x,'Error in the input file:')"
          print "(2x,'the number of integration points Nint is too low;')"      
          stop
        end if
      end if
      if (Ninta < 20) then
        Ninta = 20
        if (Ninta > Nint) then
          print "(/,2x,'Error in the input file:')"
          print "(2x,'the number of integration points Nint is too low;')"      
          stop
        end if
      end if
      Nintparam(ipart,1) = Nintb
      Nintparam(ipart,3) = Nintb
      Nintparam(ipart,2) = Ninta
      do iparam = 1, 3
        Nintl = Nintparam(ipart,iparam)
        allocate (xt(Nintl), wt(Nintl))
        if (iparam == 1) then
          atheta = 0._O
          btheta = theta0
        else if (iparam == 2) then
          atheta = theta0
          btheta = Pi - theta0
        else if (iparam == 3) then
          atheta = Pi - theta0
          btheta = Pi
        end if
        call Gauss_Legendre (atheta, btheta, Nintl, wt, xt)
        do p = 1, Nintl
          paramG  (ipart,iparam,p) = xt(p)
          weightsG(ipart,iparam,p) = wt(p)
        end do
        deallocate (wt, xt)
      end do              
    end do
  end select
end subroutine interpolation_listCOMP
! **********************************************************************************
subroutine zDSCOMP (TypeGeom, Npart, Nsurfmax, surf, Nrankpmax, Nrankp, zpart,      &
           ComplexPlane, EpsZReIm, zRe, zIm)
!-----------------------------------------------------------------------------------
! The routine generates the coordinates of the distributed sources in the complex  !
! plane for a composite particle.                                                  !
!                                                                                  !
! Input parameters:                                                                !
! - TypeGeom (integer) - index of the particle geometry.                           !
! - Npart (integer) - number of homogeneous regions.                               !
! - Nsurfmax (integer) - maximum number of surface parameters.                     !
! - surf (real array) - surface parameters of all regions.                         ! 
! - Nrankpmax (integer) - maximum number of distríbuted sources over all regions.  !            
! - Nrankp (integer array) - numbers of distributed sources (maximum expansion     !
!   orders) for all regions.                                                       !
! - zart (real array) - axial positions of the local coordinate systems of the     !
!   regions with respect to the global coordinate system of the composite          !
!   particle.                                                                      !
! - ComplexPlane (logical array) - if ComplexPlane = t, the distributed sources    !
!   for a specific region are placed in the complex plane.                         !
! - EpsZReIm (real array) - parameters controlling the distribution of the         !
!   discrete sources for all regions.                                              !
!                                                                                  ! 
! Output parameters:                                                               !
! - zRe, zIm (real arrays) - coordinates of the distributed sources in the         !
!   complex plane for all regions.                                                 !
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none
  integer :: TypeGeom, Npart, Nrankpmax, Nrankp(Npart), Nsurfmax
  real(O) :: surf(Npart,Nsurfmax), zpart(Npart), zRe(Npart,Nrankpmax),              &
             zIm(Npart,Nrankpmax), EpsZReIm(Npart)
  logical :: ComplexPlane(Npart)
!    
  integer :: i, ipart, p, Nrankpl
  real(O) :: zmin, zmax, a, b, c  
!
  do ipart = 1, Npart
    do p = 1, Nrankpmax
      zRe(ipart,p) = 0._O
      zIm(ipart,p) = 0._O
    end do
  end do
  select case (TypeGeom)
  case (1)      
!   --- half-spheroids with offset origins ---                          
    do ipart = 1, Npart      
      a = surf(ipart,1)
      b = surf(ipart,2)
      c = surf(ipart,3)                   
      if (.not. ComplexPlane(ipart)) then
        if (ipart == 1) then
          zmin = (1._O - EpsZReIm(ipart)) * a
          zmax = EpsZReIm(ipart) * a
        else if (ipart == 2) then
          zmax = - (1._O - EpsZReIm(ipart)) * a
          zmin = - EpsZReIm(ipart) * a
        end if
        Nrankpl = Nrankp(ipart)
        do i = 1, Nrankpl           
          zRe(ipart,i) = zmin + (i - 1) * (zmax - zmin) / (Nrankpl - 1)
          zIm(ipart,i) = 0._O  
        end do
      else                    
        zmin = - EpsZReIm(ipart) * b * sqrt(1 - c * c / a / a)
        zmax =   EpsZReIm(ipart) * b * sqrt(1 - c * c / a / a)                
        Nrankpl = Nrankp(ipart)
        do i = 1, Nrankpl           
          zRe(ipart,i) = zpart(ipart)
          zIm(ipart,i) = zmin + (i - 1) * (zmax - zmin) / (Nrankpl - 1)
        end do                    
      end if
    end do  
  case (2)
! ---- 3 cylinders ---    
    do ipart = 1, Npart              
      a = surf(ipart,1)
      b = surf(ipart,2)      
      if (.not.ComplexPlane(ipart)) then
        zmin = zpart(ipart) - EpsZReIm(ipart) * a
        zmax = zpart(ipart) + EpsZReIm(ipart) * a
        Nrankpl = Nrankp(ipart)
        do i = 1, Nrankpl           
          zRe(ipart,i) = zmin + (i - 1) * (zmax - zmin) / (Nrankpl - 1)
          zIm(ipart,i) = 0._O  
        end do
      else 
        zmin = - EpsZReIm(ipart) * b
        zmax =   EpsZReIm(ipart) * b
        Nrankpl = Nrankp(ipart)
        do i = 1, Nrankpl           
          zRe(ipart,i) = zpart(ipart)
          zIm(ipart,i) = zmin + (i - 1) * (zmax - zmin) / (Nrankpl - 1) 
        end do      
      end if     
    end do   
  end select      
end subroutine zDSCOMP
!-----------------------------------------------------------------------------------
!                              LAYERED PARTICLES                                   !
!                                                                                  !
! The significance of the geometry parameters specified in the input files is      !
! given below.                                                                     !
!                                                                                  ! 
!    Particle      TypeGeom   Nsurf   Nparam                surf                   !
!     layered         1         2        1        surf(1) - length of the semi-    !
!    spheroids                                              axis along the         !
!                                                           symmetry axis          ! 
!                                                 surf(2) - length of the second   !
!                                                           semi-axis              !    
!                                                                                  !
!     layered         2         2        3        surf(1) - half-length of         !
!    cylinders                                              the cylinder           ! 
!                                                 surf(2) - cylinder radius        !
!                                                                                  !
! 1. In order to explain the significance of the surface parameters we consider    !
! the geometry depicted in Figure 1.                                               !
!                                                                                  !
!                   a1                                      a1                     !
!            z ^/ - - -/:                             z ^/ - - -/:                 !
!              |--------:........                       |        :                 !
!              |        |      /                        |--->---- .......          !
!              |        |      !                        |/param  |    /            !
!              |        |< - - ! - -layer 1            /|        |    !            !
!              |        |      !                     /  |        |    !            !
!              |        |      !                   /    |        |    !            !       
!              |  a2    |      !              curve     |        |    !            !
!              |/ - /:  |      !              iparam    |        |    !            !
!              |     :  |      !                        |        |    !            !
!              |----- ..|....  ! b1                     |        |    ! b1   x1    !
!      ../..O1 o     |  |  /   !                     O1 o- - - - | - - - - - >     !
!    z1  !     |     |  |  !   |        x               |        |    !            !
!      ../..O  o - - - - - - - - - - - >                |        |    !            !
!    z2  !     |     |  |  !   !                        |        |    !            !
!       ./..O2 o     |  |  ! b2!                        |        |    !            !
!              |     |  |  !   !                        |        |    !            !
!              |     |<-| -! - !- - layer 2             |        |    !            !
!              |     |  |  !   !                        |        |    !            !
!              |----- ..|../.  !                        |        |    !            !
!              |--------......./..                      |--------...../..          !
!                                                                                  !
!           Layered particle               Layer ipart = 1. The generatrix         !
!                                          consists of Nparam(1) = 3 smooth        !
!                                          curves. On the smooth curve iparam,     !
!                                          the curve parameter is param.           !
!                                                                                  !
!                                   Figure 1                                       !
!                                                                                  !
! The layered particle consists of Npart = 2 layers, and the axial positions of    !
! the local coordinate systems (of the layers) with respect to the global          !
! coordinate system of the layered particle are given by the array "zpart", i.e.,  !
! zpart(1) = z1 and zpart(2) = z2. The layer ipart = 1 is characterized by         !
! Nsurf(ipart) = 2 surface parameters:                                             !
!                                                                                  !
!                 surf(ipart,1) = a1 and surf(ipart,2) = b1,                       !
!                                                                                  !
! and the layer ipart = 2 is also characterized by Nsurf(ipart) = 2 surface        !
! parameters:                                                                      !
!                                                                                  !
!                 surf(ipart,1) = a2 and surf(ipart,2) = b2.                       !
!                                                                                  !
! In addition to Nsurf(ipart),                                                     !
!                                                                                  !
!              Nsurfmax = MAX {ipart = 1,2,...,Npart} Nsurf(ipart).                !
!                                                                                  !
! is an input parameter of the code. The generatrix of the layer "ipart" consists  !
! of Nparam(ipart) smooth curves, and                                              !
!                                                                                  ! 
!              Nparammax = MAX {ipart = 1,2,...,Npart} Nparam(ipart)               !
!                                                                                  !
! is also an imput parameter of the code. On the smooth curve "iparam" (which      !
! belongs to the layer "ipart") we consider the curve parameter "param", which     !
! is defined with respect to the local coordinate system of the layer "ipart".     !
! Consequently, the magnitude of the position vector r, the zenith angle theta,    !
! the surface element dA and the normal unit vector in spherical coordinates n (on !
! each smooth curve "iparam" belonging to the layer "ipart") correspond to the     !
! LOCAL COORDINATE SYSTEM of the layer. The significance of these parameters is    !
! as for axisymmetric particles.                                                   !
!                                                                                  !
! 2. To compute the integrals over the particle surface we define nodes and weights!
! on each smooth curve "iparam" (which belongs to the layer "ipart"). As for       !
! axisymmetric particles, the numbers of integration points is                     !
!   Nintparam(ipart,iparam), ipart = 1,2,.,Npart, iparam = 1,2,.., Nparam(ipart)   !
! while the nodes and weights are stored in the arrays:                            !
!   paramG(ipart,iparam,j), ipart = 1,2,...,Npart, iparam = 1,2,..,Nparam(ipart),  !
!                           j = 1,2,...,Nintparam(ipart,iparam),                   !
! and                                                                              !
!   weightsG(ipart,iparam,j), ipart = 1,2,...,Npart, iparam = 1,2,..,Nparam(ipart),!
!                             j = 1,2,...,Nintparam(ipart,iparam),                 !
! respectively. Because the curve parameter "param" is defined with respect to the !
! local coordinate system of the layer "ipart", the nodes correspond to the LOCAL  !  
! COORDINATE SYSTEM of the layer.                                                  !
!                                                                                  !
! 3. To distribute the discrete sources we follow the same prescriptions as for    !
! axisymmetric particles. However, the coordinates of the discrete sources are     !
! defined with respect to the GLOBAL COORDINATE SYSTEM. If Nranp(ipart) is the     !
! number of discrete sources for the layer "ipart", and zRe'(ipart,j) and          !
! zIm'(ipart,j) with j = 1,2,...,Nranp(ipart), are the coordinates of the discrete !
! sources in the local coordinate system of the layer, then                        !
!                                                                                  !
!            zRe(ipart,j) = zRe'(ipart,j) + zpart(ipart) and                       !
!                                                                                  ! 
!            zIm(ipart,j) = zIm'(ipart,j) + zpart(ipart).                          !
!                                                                                  !
! 4. The user can easily modify the routines: "elem_geomLAY",                      !
! "interpolation_listLAY" and "zDSLAY" to generate particles with other            !
! geometries. A new geometry with the index TypeGeom = 3 can be added to the       !
! existing geometries, but the list of parameters must be maintained               !  
!-----------------------------------------------------------------------------------
subroutine elem_geomLAY (TypeGeom, Npart, ipart, Nsurfmax, surf, param, iparam, r,  &
           theta, phi, dA, n)
!-----------------------------------------------------------------------------------
! The routine computes the geometry parameters of a layered particle.              !
!                                                                                  !
! Input parameters:                                                                !
! - TypeGeom (integer) - index of the particle geometry.                           !
! - Npart (integer) - number of layers.                                            !
! - ipart (integer) - index of the actual layer.                                   !
! - Nsurfmax (integer) - maximum number of surface parameters.                     !
! - surf (real array) - surface parameters of all layers.                          !              
! - param (real) - actual curve (surface) parameter for the layer ipart.           !
! - iparam (integer) - index of the actual curve (surface) parameter for the       !
!   layer ipart.                                                                   !
!                                                                                  !
! Output parameters:                                                               !
! - r (real) - magnitude of the position vector.                                   !    
! - theta (real) - zenith angle.                                                   !
! - phi (real) - azimuthal angle.                                                  !
! - dA (real) - surface element.                                                   !
! - n (real array) - normal unit vector in spherical coordinates.                  !
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none  
  integer :: TypeGeom, Npart, ipart, Nsurfmax, iparam
  real(O) :: surf(Npart,Nsurfmax), param, r, theta, phi, dA, n(3)
!
  real(O) :: a, b, tamp, dr
!
  select case (TypeGeom)
  case (1)
!   --- concentric spheroids ---
    phi  = 0._O
    a = surf(ipart,1)
    b = surf(ipart,2)
    theta = param   
    if (iparam == 1) then     
      tamp =   cos(theta) * cos(theta) + sin(theta) * sin(theta) * a * a / b / b
      r  =   a / sqrt(tamp)
      dr = - a * cos(theta) * sin(theta) * ((a * a) / (b * b) - 1) /                &
            (tamp * sqrt(tamp))    
    end if          
    tamp =   sqrt(r * r + dr * dr)
    dA   =   tamp * r * sin(theta)
    n(1) =   r / tamp
    n(2) = - dr / tamp
    n(3) =   0._O 
  case (2)
!   --- concentric cylinders ---
    phi  = 0._O
    a = surf(ipart,1)
    b = surf(ipart,2)
    theta = param       
    if (iparam == 1) then      
      r  = a / cos(theta)
      dr = a * sin(theta) / cos(theta) / cos(theta)            
    else if (iparam == 2) then      
      r  =   b / sin(theta)
      dr = - b * cos(theta) / sin(theta) / sin(theta)                 
    else if (iparam == 3) then      
      r  = - a / cos(theta)
      dr = - a * sin(theta) / cos(theta) / cos(theta)            
    end if
    tamp =   sqrt(r * r + dr * dr)
    dA   =   tamp * r * sin(theta)
    n(1) =   r / tamp
    n(2) = - dr / tamp
    n(3) =   0._O                       
  end select
end subroutine elem_geomLAY     
!***********************************************************************************
subroutine interpolation_listLAY (TypeGeom, Npart, Nsurfmax, surf, Nint, Nparammax, &
               Nintparam, paramG, weightsG)
!-----------------------------------------------------------------------------------
! The routine provides the nodes and weights for computing integrals over the      !
! surface of a layered particle.                                                   !
!                                                                                  !
! Input parameters:                                                                !
! - TypeGeom (integer) - index of the particle geometry.                           !
! - Npart (integer) - number of layers.                                            !
! - Nsurfmax (integer) - maximum number of surface parameters.                     !
! - surf (real array) - surface parameters of all layers.                          !              
! - Nint (integer) - global number of integration points.                          !
! - Nparammax (integer) - maximum number of integration curves.                    !
!                                                                                  ! 
! Output parameters:                                                               !
! - Nintparam (integer array) - number of integration points (nodes) on all        !
!   integration curves and layers.                                                 !   
! - paramG (real array) - integration points (nodes) on all integration curves     !
!   and layers.                                                                    !
! - weightsG (real array) - weights on all integration curves and layers.          !
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none
  integer :: TypeGeom, Npart, Nsurfmax, Nint, Nparammax, Nintparam(Npart,Nparammax)
  real(O) :: surf(Npart,Nsurfmax), paramG(Npart,Nparammax,Nint),                    &
                 weightsG(Npart,Nparammax,Nint)
!      
  integer :: ipart, iparam, p, Nint0, Nintl, Ninta, Nintb
  real(O) :: a, b, ab, ab0, atheta, btheta, theta0
  real(O),allocatable :: xt(:), wt(:)
!
  do ipart = 1, Npart
    do iparam = 1, Nparammax
      Nintparam(ipart,iparam) = 0
      do p = 1, Nint
        paramG  (ipart,iparam,p) = 0._O
        weightsG(ipart,iparam,p) = 0._O
      end do
    end do
  end do        
  select case (TypeGeom)
  case (1)
!   --- concentric spheroids ---        
    do ipart = 1, Npart
      a  = surf(ipart,1)
      b  = surf(ipart,2) 
      ab = max(a,b)
      if (ipart == 1) then
        ab0   = ab
        Nint0 = Nint                
      else
        Nint0 = int(ab * Nint / ab0)
      end if
      if (Nint0 < 40) then
        Nint0 = 40
        if (Nint0 > Nint) then
          print "(/,2x,'Error in the input file:')"
          print "(2x,'the number of integration points Nint is too low;')"      
          stop
        end if
      end if
      Nintparam(ipart,1) = Nint0
      Nintl = Nintparam(ipart,1)
      allocate (xt(Nintl),wt(Nintl))
      atheta = 0._O
      btheta = Pi
      call Gauss_Legendre (atheta, btheta, Nintl, wt, xt)
      do p = 1, Nintl
        paramG  (ipart,1,p) = xt(p)
        weightsG(ipart,1,p) = wt(p)
      end do
      deallocate (xt, wt) 
    end do  
  case (2)
!   --- concentric cylinders ---
    do ipart = 1, Npart
      a  = surf(ipart,1)
      b  = surf(ipart,2)
      ab = max(a,b)
      theta0 = atan(b / a)    
      if (ipart == 1) then
        ab0   = ab
        Nint0 = Nint
      else
        Nint0 = int(ab * Nint / ab0)
      end if
      if (Nint0 < 40) Nint0 = 40
      Nintb = int(b * Nint0 / 2 / (a + b))
      Ninta = Nint0 - 2 * Nintb
      if (Nintb < 20) then
        Nintb = 20
        if (Nintb > Nint) then
          print "(/,2x,'Error in the input file:')"
          print "(2x,'the number of integration points Nint is too low;')"      
          stop
        end if
      end if
      if (Ninta < 20) then
        Ninta = 20
        if (Ninta > Nint) then
          print "(/,2x,'Error in the input file:')"
          print "(2x,'the number of integration points Nint is too low;')"      
          stop
        end if
      end if
      Nintparam(ipart,1) = Nintb
      Nintparam(ipart,3) = Nintb
      Nintparam(ipart,2) = Ninta
      do iparam = 1, 3
        Nintl = Nintparam(ipart,iparam)
        allocate (xt(Nintl), wt(Nintl))
        if (iparam == 1) then
          atheta = 0._O
          btheta = theta0
        else if (iparam == 2) then
          atheta = theta0
          btheta = Pi - theta0
        else if (iparam == 3) then
          atheta = Pi - theta0
          btheta = Pi
        end if
        call Gauss_Legendre (atheta, btheta, Nintl, wt, xt)
        do p = 1, Nintl
          paramG  (ipart,iparam,p) = xt(p)
          weightsG(ipart,iparam,p) = wt(p)
        end do
        deallocate (wt, xt)
      end do
    end do    
  end select
end subroutine interpolation_listLAY
!***********************************************************************************
subroutine zDSLAY (TypeGeom, Npart, Nsurfmax, surf, Nrankpmax, Nrankp, zpart,       &
           ComplexPlane, EpsZReIm, zRe, zIm)
!-----------------------------------------------------------------------------------
! The routine generates the coordinates of the distributed sources in the complex  !
! plane for a layered particle.                                                    !
!                                                                                  !
! Input parameters:                                                                !
! - TypeGeom (integer) - index of the particle geometry.                           !
! - Npart (integer) - number of layers.                                            !
! - Nsurfmax (integer) - maximum number of surface parameters.                     !
! - surf (real array) - surface parameters of all layers.                          ! 
! - Nrankpmax (integer) - maximum number of distríbuted sources over all layers.   !            
! - Nrankp (integer array) - numbers of distributed sources (maximum expansion     !
!   orders) for all layers.                                                        !
! - zpart (real array) - axial positions of the local coordinate systems of the    !
!   layers with respect to the global coordinate system of the layered             !
!   particle.                                                                      ! 
! - ComplexPlane (logical array) - if ComplexPlane = t, the distributed sources    !
!   for a specific layer are placed in the complex plane.                          !
! - EpsZReIm (real array) - parameters controlling the distribution of the         !
!   discrete sources for all layers.                                               !
!                                                                                  ! 
! Output parameters:                                                               !
! - zRe, zIm (real arrays) - coordinates of the distributed sources in the         !
!   complex plane for all layers.                                                  !
!----------------------------------------------------------------------------------- 
  use parameters
  implicit none
  integer :: TypeGeom, Npart, Nrankpmax, Nrankp(Npart), Nsurfmax
  real(O) :: surf(Npart,Nsurfmax), zpart(Npart), zRe(Npart,Nrankpmax),              &
             zIm(Npart,Nrankpmax), EpsZReIm(Npart)
  logical :: ComplexPlane(Npart)
!   
  integer :: i, ipart, p, Nrankpl
  real(O) :: zmin, zmax, a, b   
!
  select case (TypeGeom)
  case (1,2)
!   ---- concentric spheroids and cylinders ----        
    do ipart = 1, Npart
      do p = 1, Nrankpmax
        zRe(ipart,p) = 0._O
        zIm(ipart,p) = 0._O
      end do
    end do      
    do ipart = 1, Npart       
      a = surf(ipart,1)
      b = surf(ipart,2)                      
      if (.not. ComplexPlane(ipart)) then
        zmin = zpart(ipart) - EpsZReIm(ipart) * a
        zmax = zpart(ipart) + EpsZReIm(ipart) * a
        Nrankpl = Nrankp(ipart)
        do i = 1, Nrankpl           
          zRe(ipart,i) = zmin + (i - 1) * (zmax - zmin) / (Nrankpl - 1)
          zIm(ipart,i) = 0._O  
        end do          
      else 
        zmin = - EpsZReIm(Npart) * b
        zmax =   EpsZReIm(Npart) * b
        Nrankpl = Nrankp(ipart)
        do i = 1, Nrankpl           
          zRe(ipart,i) = zpart(ipart)
          zIm(ipart,i) = zmin + (i - 1) * (zmax - zmin) / (Nrankpl - 1)
        end do          
      end if
    end do  
  end select
end subroutine zDSLAY

subroutine TINHOMSPH
!------------------------------------------------------------------------------------
! 1. General Considerations                                                         !
! --------------------------                                                        !
! TINHOMSPH is a code for computing the T matrix and the scattering characteristics !
! of an an inhomogeneous, dielectric sphere with an arbitrarily shaped inclusion.   !
! The program supports calculation for dielectric host spheres with REAL refractive !
! index. The main feature of this routine is that the T matrix of the inclusion is  !
! provided as input parameter in the file FileTmat. The inclusion can be a          !
! homogeneous, axisymmetric or nonaxisymmetric particle, a composite or a layered   !
! scatterer and an aggregate. For computing the T matrix of the inclusion, the      !
! refractive index of the ambient medium (the parameter ind_refMed in the           !
! corresponding T-matrix program) must be identical with the relative refractive    !
! index of host particle (the parameter indrefRel in the present T-matrix program). ! 
! Note that the T matrix of a spherical inclusion must be computed with the TAXSYM  !
! routine and not with the TSPHERE routine (the T matrix of the inclusion must be   !
! specified as a two-dimensional array and the TSPHERE routine provides an          !
! one-dimensional array).                                                           ! 
!                                                                                   !
! 2. Convergence Test                                                               !
! --------------------                                                              !
! Convergence tests precede the scattering characteristics calculation. The         !
! parameters which control the T-matrix computation are the maximum expansion order !
! Nrank and the maximum azimuthal order Mrank for the host particle.                !
!                                                                                   !
! For convergence tests, the incident wave is assumed to be a plane wave traveling  !
! along the Z-axis of the global coordinate system and the scattering               !
! characteristics are computed in the azimuthal plane  phi = 0°. The Euler          !
! orientation angles of the host sphere are alpha = beta = 45° and gamma = 0°, and  !
! interactive convergence tests over Nrank and Mrank are performed.                 !
!                                                                                   !  
! Nrank and Mrank are assumed to not depend on Nrank1 and Mrank1, which are the     !
! maximum expansion and azimuthal orders of the inclusion. The convergence tests    !
! are carried out over Nrank and Mrank, while Nrank1 and Mrank1 are kept constant.  !
! For the convergence test over the expansion order, the scattering problem is      !
! solved for the pairs (Nrank, Mrank) and (Nrank - 1, Mrank), while for the         !
! azimuthal order test, the cases (Nrank, Mrank) and (Nrank, Mrank - 1) are         !
! considered. The normalized differential scattering cross section will be checked  !
! at 20° increments for convergence within epsX (epsNint,epsNrank or epsMrank)      !
! tolerance. If the calculated results are converged within this tolerance at       !
! 80% of the scattering angles, then convergence is achieved. The T matrix is       !
! stored for later use by other programs, and the values of Nrank and Mrank are     !
! printed to the screen and to the T-matrix information file (see                   !
! "Description.txt"). These values together with the T matrix serve as INPUT        !
! PARAMETERS for other programs.                                                    !
!                                                                                   !
! 3. Estimates of Nrank and Mrank                                                   !
! --------------------------------                                                  !
! The above convergence tests require estimates of Nrank and Mrank. These estimates !
! must be supplied by the user, and for this purpose, Wiscombe's truncation limit   !
! criterion [W. J. Wiscombe, Improved Mie scattering algorithms, Applied Optics,    !
! 19, 1505-1509, 1980] can be used.                                                 !
!                                                                                   !
! The truncation limit criterion proposed by Wiscombe provides the estimate         !
!                                                                                   ! 
!                NrankW = int(x + 4.05 * x**0.33 + 2),                              !
!                                                                                   !
! where x is the size parameter, x = k * r, k is the wave number and r is the       !
! radius of the smallest circumscribing sphere. For the maximum azimuthal order     !
! test, we may use the conservative estimate Mrank = Nrank - 2,..,Nrank.            ! 
!                                                                                   !
! 4. Strategies for Performing Convergence Tests                                    !
! -----------------------------------------------                                   !
! The following strategy for performing the convergence test can be employed:       !
! 1. choose a value of Nrank close to the value predicted by Wiscombe's truncation  !
!    limit criterion (or smaller) and set Mrank = Nrank - 2 (or smaller);           !
! 2. perform the convergence tests over Nrank and Mrank;                            ! 
! 3. if convergence is not achieved, set Nrank = Nrank + 1, maintain the relation   !
!    Mrank = Nrank - 2 and go to Step 2.                                            !
! For particles which are too extreme in size, the errors of the extinction and     !
! scattering cross sections (instead of the differential scattering cross section)  !
! can be analyzed.                                                                  ! 
!                                                                                   !
! 5. Additional Comments                                                            !
! -----------------------                                                           !
! The convergence tests can be switched off by setting the logical variable         !
! DoConvTest to false. In this case, the values of Nrank and Mrank must be          !
! specified in the input file.                                                      !
!                                                                                   !
! 6. Input Parameters                                                               !
! --------------------                                                              !
! The parameters specified in the input file "/INPUTFILES/InputINHOMSPH.dat"        !
! are listed below.                                                                 !
!                                                                                   !
! - wavelength (real) - wavelength of the incident light in vacuo.                  !
!                                                                                   !
! - ind_refMed (real) - refractive index of the ambient medium (nonabsorbing        !
!   dielectric medium).                                                             !
!                                                                                   !
! - ind_refRel (REAL) - relative refractive index of the host sphere with           ! 
!   respect to the ambient medium.                                                  !
!                                                                                   !
! - r (real) - radius of the host sphere.                                           ! 
!                                                                                   !
! - anorm (real) - characteristic length of the host sphere which is used to        !
!   normalize the differential scattering cross sections.                           !
!                                                                                   !
! - FileTmat (character(80)) - name of the file containing the T matrix of the      !
!   inclusion.                                                                      !
!                                                                                   !
! - axsym1 (logical) - if axsym1 = t, the inclusion is a rotationally symmetric     !
!   particle (axisymmetric particle).                                               !
!                                                                                   !
! - chiral1 (logical) - if chiral1 = t, the inclusion is an optical active particle  !
!   (chiral particle).                                                              !
!                                                                                   !
! - Nrank1, Mrank1 (integer variables) - the maximum expansion and azimuthal        !
!   orders of the inclusion.                                                        !
!                                                                                   !   
! - x1, y1, z1 (real variables) - Cartesian coordinates specifying the position     !
!   of the inclusion with respect to the coordinate system of the host sphere.      !
!                                                                                   ! 
! - alpha1, beta1, gamma1 (real variables) - Euler angles specifying the            !
!   orientation of the coordinate system of the inclusion with respect to the       !
!   coordinate system of the host sphere.                                           !
!                                                                                   !
! - DoConvTest (logical) - if DoConvTest = t, the interactive convergence tests     !
!   over Nrank and Mrank are invoked. An estimates of Nrank is given by             !
!   Wiscombe's truncation limit criterion. If DoConvTest = f, the values of Nrank   !
!   and Mrank must be supplied in the input file.                                   !
!                                                                                   !
! - ExtThetaDom (logical) - if ExtThetaDom = t the DSCS is computed for             !
!   scattering angles ranging from 0° to 180° in the azimuthal plane phiGS = 0°,    !
!   and from 180° to 0° in the azimuthal plane phiGS = 180°. The total number of    !
!   scattering angles is 10. If ExtThetaDom = f the DSCS is computed for            !
!   scattering angles ranging from 0 to 180° in the azimuthal plane phiGS = 0.      !
!                                                                                   !
! - Nrank (integer) - maximum expansion order for the host sphere. This             !
!   parameter is used if the convergence tests are not performed (DoConvTest = f).  !
!                                                                                   !
! - Mrank (integer) - maximum azimuthal order for the host sphere. This             !
!   parameter is used if the convergence test are not performed (DoConvTest = f).   !
!                                                                                   !
!   The following table explain the significance of the variables Nrank and Mrank.  !
!                                                                                   !
!                  DoConvTest       Nrank and Mrank                                 !
!                     t             console input                                   !
!                     f              file input                                     ! 
!                                                                                   !
! - epsNrank (real) - error tolerance for the expansion order test.                 !
!                                                                                   !
! - epsMrank (real) - error tolerance for the azimuthal order test.                 !
!                                                                                   !
! - FileTmatG (character(80)) - name of the file to which the T matrix of the       !
!   inhomogeneous spherical particle is written.                                    !
!                                                                                   !
! - PrnProgress (logical) - if PrnProgress = t, the progress of calculation         !
!   is printed.                                                                     !
!                                                                                   !
! Note that all input parameters specifying lengths must be provided in the same    !
! units of lengths.                                                                 !
!                                                                                   !
! 7. Logical Scheme                                                                 !
! ------------------                                                                !  
! The organization of the code is as follows:                                       !
! 1. < read input data; the input file provides:                                    !
!    - the name of the file containing the T matrix of the inclusion,               !
!    - the maximum expansion and azimuthal orders Nrank1 and Mrank1,                ! 
!    - the Cartesian coordinates specifying the position of the inclusion, and      !
!    - the Euler angles specifying the orientation of the inclusion >               !   
!                                                                                   !
! 2. < T-matrix calculation >                                                       !
!                                                                                   !
!    if ( do convergence test ) then                                                !
!                                                                                   !
!      < the code computes an estimate of Nrank accordingly to                      !
!        Wiscombe's truncation criterion >                                          !
!      < the code prompts for the estimated values of Nrank and Mrank >             !
!                                                                                   !
!    else if ( .not. do convergence test ) then                                     !
!                                                                                   !
!       < the input file provides the values of Nrank and Mrank >                   !
!                                                                                   !
!    end if                                                                         !
!    if ( do convergence test ) then                                                !
!       < the code computes the DSCS for (Nrank,Mrank), (Nrank - 1,Mrank) and       ! 
!         (Nrank, Mrank - 1) and write the results to the file "Output.dat" >       !
!       < the T matrix is stored in the file FileTmatG and the T-matrix             !
!         information file is created >                                             !
!       < Mrank and Nrank are written to the screen and to the T-matrix             !
!         information file >                                                        !
!       < go to Step 3 >                                                            !
!    end if                                                                         !
!    if ( .not. do convergence test ) then                                          !
!       < the T matrix is computed and stored in the file FileTmatG >               !
!       < the T-matrix information file is created >                                !
!       < Mrank and Nrank are written to the screen and to the T-matrix             !
!         information file >                                                        !
!       < go to Step 3 >                                                            !
!    end if                                                                         !
! 3. < scattering characteristics calculation >                                     !   
!------------------------------------------------------------------------------------
  use parameters
  use derived_parameters
  implicit none 
  integer       :: Mrank, Nrank, Nrank1, Mrank1                    
  real(O)       :: ks, ind_refMed, ind_refRel, wavelength, r, anorm, snorm,         &
                   epsNrank, epsMrank, x1, y1, z1, alpha1, beta1, gamma1 
  character(80) :: FileTmat, FileTmatG
  logical       :: axsym1, chiral1, DoConvTest, ExtThetaDom, PrnProgress 
! -----------------------------------------------------------------------------------
!                              Read the input file                                  ! 
! -----------------------------------------------------------------------------------  
  call readinputINHOMSPH ( wavelength, ind_refMed, ind_refRel, r, anorm,             &
       FileTmat, axsym1, chiral1, Nrank1, Mrank1, x1, y1, z1, alpha1, beta1,         &
       gamma1, DoConvTest, ExtThetaDom, Nrank, Mrank, epsNrank, epsMrank,            &
       FileTmatG, PrnProgress, ks, snorm ) 
! -----------------------------------------------------------------------------------
!                                      Main                                         !
! -----------------------------------------------------------------------------------
  if (DoConvTest) then    
    open (unit = iOutput, file = FileOutput, status = "replace") 
    call printinputINHOMSPH (r, FileTmat, axsym1, x1, y1, z1, alpha1, beta1, gamma1,&
         Mrank1, Nrank1, wavelength, anorm, ind_refMed, ind_refRel, epsNrank,       &
         epsMrank)
    call convergence_Nrank_MrankINHOMSPH (r, ks, ind_refRel, snorm, Mrank, Nrank,   &
         x1, y1, z1, alpha1, beta1, gamma1, Mrank1, Nrank1, FileTmat, axsym1,       &
         chiral1, epsNrank, epsMrank, ExtThetaDom, FileTmatG, PrnProgress)   
    close (unit = iOutput)
  else
    call TMatrix_Nrank_MrankINHOMSPH (r, ks, ind_refRel, Mrank, Nrank, x1, y1, z1,  &
         alpha1, beta1, gamma1, Mrank1, Nrank1, FileTmat, axsym1, chiral1,          &
         FileTmatG, PrnProgress)
  end if
end subroutine TINHOMSPH
!***********************************************************************************
subroutine readinputINHOMSPH ( wavelength, ind_refMed, ind_refRel, r, anorm,        &
           FileTmat, axsym1, chiral1, Nrank1, Mrank1, x1, y1, z1, alpha1, beta1,    &
           gamma1, DoConvTest, ExtThetaDom, Nrank, Mrank, epsNrank, epsMrank,       &
           FileTmatG, PrnProgress, ks, snorm )     
  use parameters
  use derived_parameters
  implicit none 
  integer       :: Mrank, Nrank, NrankW, Mrank1, Nrank1, ios                     
  real(O)       :: ks, ind_refMed, ind_refRel, wavelength, r, anorm, xpart, snorm,  &
                   epsNrank, epsMrank, x1, y1, z1, alpha1, beta1, gamma1, x, grd 
  character(80) :: FileTmat, FileTmatG, string
  logical       :: axsym1, chiral1, DoConvTest, ExtThetaDom, PrnProgress, XFindPar 
! -----------------------------------------------------------------------------------
!                        Read the input file FileInputINHOMSPH                      ! 
! ----------------------------------------------------------------------------------- 
  call DrvParameters 
  open (unit = iInputINHOMSPH, file = FileInputINHOMSPH, status = "old",            &
        position = "rewind")   
  wavelength = 0.1_O * 2._O * Pi
  ind_refMed = 1._O                                                                 
  ind_refRel = 1.2_O
  string     = 'OptProp'
  if (XFindPar (iInputINHOMSPH, string)) then
    read (iInputINHOMSPH, *, iostat = ios) wavelength
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable wavelength;')"
      stop
    end if
    read (iInputINHOMSPH, *, iostat = ios) ind_refMed
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refMed;')"
      stop
    end if
    read (iInputINHOMSPH, *, iostat = ios) ind_refRel
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ind_refRel;')"
      stop
    end if      
  else
    print "(/,2x,'Group name OptProp not found;')"
    stop  
  end if  
  ks = 2._O * Pi * ind_refMed / wavelength
!       
  r = 1._O
  anorm  = 1._O
  string = 'GeomPropHost'
  if (XFindPar (iInputINHOMSPH, string)) then
    read (iInputINHOMSPH, *, iostat = ios) r
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable r;')"
      stop
    end if
    read (iInputINHOMSPH, *, iostat = ios) anorm
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable anorm;')"
      stop
    end if         
  else
    print "(/,2x,'Group name GeomPropHost not found;')"
    stop  
  end if                
  call check_anorm (anorm)   
  xpart = ks * anorm
  snorm = Pi * xpart * xpart  
!
  FileTmat = '../TMATFILES/T.dat'
  axsym1   = .true.
  chiral1  = .false. 
  Nrank1   = 6
  Mrank1   = 4 
  string   = 'TmatIncl'
  if (XFindPar (iInputINHOMSPH, string)) then
    read (iInputINHOMSPH, *, iostat = ios) FileTmat
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileTmat;')"
      stop
    end if
    read (iInputINHOMSPH, *, iostat = ios) axsym1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable axsym1;')"
      stop
    end if 
    read (iInputINHOMSPH, *, iostat = ios) chiral1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable chiral1;')"
      stop
    end if
    read (iInputINHOMSPH, *, iostat = ios) Nrank1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Nrank1;')"
      stop
    end if
    read (iInputINHOMSPH, *, iostat = ios) Mrank1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable Mrank1;')"
      stop
    end if
  else
    print "(/,2x,'Group name TmatIncl not found;')"
    stop  
  end if  
  call check_MrankNrank (Mrank1, Nrank1) 
!
  x1 = 0.1_O
  y1 = 0.1_O
  z1 = 0.1_O
  alpha1 = 45._O
  beta1  = 45._O
  gamma1 = 0._O
  string = 'GeomPropIncl'
  if (XFindPar (iInputINHOMSPH, string)) then
    read (iInputINHOMSPH, *, iostat = ios) x1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable x1;')"
      stop
    end if
    read (iInputINHOMSPH, *, iostat = ios) y1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable y1;')"
      stop
    end if 
    read (iInputINHOMSPH, *, iostat = ios) z1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable z1;')"
      stop
    end if
    read (iInputINHOMSPH, *, iostat = ios) alpha1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable alpha1;')"
      stop
    end if
    read (iInputINHOMSPH, *, iostat = ios) beta1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable beta1;')"
      stop
    end if
    read (iInputINHOMSPH, *, iostat = ios) gamma1
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable gamma1;')"
      stop
    end if
  else
    print "(/,2x,'Group name GeomPropIncl not found;')"
    stop  
  end if    
  grd    = Pi / 180._O 
  alpha1 = alpha1 * grd
  beta1  = beta1 * grd
  gamma1 = gamma1 * grd
!
  DoConvTest  = .true.
  ExtThetaDom = .true.
  string      = 'ConvTest'
  if (XFindPar (iInputINHOMSPH, string)) then
    read (iInputINHOMSPH, *, iostat = ios) DoConvTest
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable DoConvTest;')"
      stop
    end if
    read (iInputINHOMSPH, *, iostat = ios) ExtThetaDom
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable ExtThetaDom;')"
      stop
    end if         
  else
    print "(/,2x,'Group name ConvTest not found;')"
    stop  
  end if         
!  
  if (DoConvTest) then    
    print "(/,2x,'Convergence Test for an Inhomogeneous Sphere')"
    print "(  2x,'--------------------------------------------')"            
  else
    print "(/,2x,'T-Matrix Computation for an Inhomogeneous Sphere')"
    print "(  2x,'------------------------------------------------')"
  end if
!  
  x = ks * r
  NrankW = int(x + 4.05_O * x**0.33_O + 2._O)
  if (.not. DoConvTest) then
    Nrank  =  16
    Mrank  =   8
    string = 'NrankMrankHost'
    if (XFindPar (iInputINHOMSPH, string)) then
      read (iInputINHOMSPH, *, iostat = ios) Nrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Nrank;')"
        stop
      end if
      read (iInputINHOMSPH, *, iostat = ios) Mrank
      if (ios /= 0) then
        print "(/,2x,'Error by reading the input variable Mrank;')"
        stop
      end if         
    else
      print "(/,2x,'Group name NrankMrankHost not found;')"
      stop  
    end if    
    print "(/,2x,'Input values:')"
    print "(  2x, a, i3, a, i3, a)",                                                &
   'the input values of Nrank and Mrank are ', Nrank, ' and ', Mrank, ', while'
    print "(  2x, a, i3, a)",                                                       &
   'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'                           
  else       
    print "(/,2x,'Nrank estimate:')"                                                    
    print "(  2x, a, i3, a)",                                                       &
   'the estimated value of Nrank from Wiscombe''s criterion is ', NrankW, ';'
    print "(/,2x,'- enter the estimated values of Nrank and Mrank, where')"
    print "(  2x,'  Mrank = Nrank - 2,...,Nrank;')"     
    call read_integer2 (Nrank, Mrank)           
  end if  
  call check_MrankNrank (Mrank, Nrank)
  if (Nrank < Nrank1) print "(/,2x,'warning: Nrank is too low;')"
  if (Mrank < Mrank1) print "(/,2x,'warning: Mrank is too low;')" 
!
  epsNrank = 5.e-2_O
  epsMrank = 5.e-2_O 
  string   = 'Errors'
  if (XFindPar (iInputINHOMSPH, string)) then
    read (iInputINHOMSPH, *, iostat = ios) epsNrank 
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsNrank;')"
      stop
    end if
    read (iInputINHOMSPH, *, iostat = ios) epsMrank 
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable epsMrank;')"
      stop
    end if         
  else
    print "(/,2x,'Group name Errors not found;')"
    stop  
  end if        
!
  FileTmatG = '../TMATFILES/TG.dat'
  string    = 'Tmat'
  if (XFindPar (iInputINHOMSPH, string)) then
    read (iInputINHOMSPH, *, iostat = ios) FileTmatG 
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable FileTmatG;')"
      stop
    end if            
  else
    print "(/,2x,'Group name Tmat not found;')"
    stop  
  end if   
!
  PrnProgress = .true.
  string      = 'PrintProgress'
  if (XFindPar (iInputINHOMSPH, string)) then
    read (iInputINHOMSPH, *, iostat = ios) PrnProgress 
    if (ios /= 0) then
      print "(/,2x,'Error by reading the input variable PrnProgress;')"
      stop
    end if            
  else
    print "(/,2x,'Group name PrintProgress not found;')"
    stop  
  end if        
  close (unit = iInputINHOMSPH)  
end subroutine readinputINHOMSPH
!***********************************************************************************
subroutine printinputINHOMSPH (r, FileTmat, axsym1, x1, y1, z1, alfa1, beta1, gama1,&
           Mrank1, Nrank1, wavelength, anorm, ind_refMed, ind_refRel, epsNrank,     &
           epsMrank)
  use parameters
  implicit none
  integer       :: Mrank1, Nrank1, LenString
  real(O)       :: wavelength, anorm, ind_refMed, ind_refRel, r, x1, y1, z1, alfa1, &
                   beta1, gama1, epsNrank, epsMrank
  character(80) :: FileTmat, FileTmatWrite
  logical       :: axsym1
!
  write (iOutput,"(/,2x,'Input Parameters of the Scattering Problem:',/)")
  write (iOutput,"(2x,'wavelength of the free space, wavelength = ',1pe13.4,';')")  &
         wavelength
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'refractive index of the ambient medium, ind_refMed = ', ind_refMed, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'relative refractive index of the host particle, ind_refRel = ', ind_refRel, ';'
  write (iOutput,*)
  write (iOutput,"(2x,'radius of the host particle, r = ',1pe10.3,';')") r  
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'characteristic length of the host particle, anorm = ', anorm, ';'
  write (iOutput,*)
  FileTmatWrite = FileTmat(14:LenString(FileTmat))
  write (iOutput,"(2x, a, a)")                                                      &
 'name of the file containing the T matrix of the inclusion = ', FileTmatWrite
  if (axsym1) then
    write (iOutput,"(2x,'axisymmetric inclusion;')")     
  else
    write (iOutput,"(2x,'nonaxisymmetric inclusion;')")          
  end if
  write (iOutput,"(2x,'maximum expansion order, Nrank =',i3,';')") Nrank1
  write (iOutput,"(2x,'maximum azimuthal order, Mrank =',i3,';')") Mrank1
  write (iOutput,"(2x, a, 1pe10.3, a, 1pe10.3, a, 1pe10.3, a)")                     &
 'Cartesian coordinates of the inclusion: x = ', x1, ', y = ', y1, ', z = ', z1, ';'             
  write (iOutput,"(2x, a, 1pe10.3, a, 1pe10.3, a, 1pe10.3, a)")                     &
 'Euler angles: alpha = ', alfa1 * 180._O / Pi, ', beta = ', beta1 * 180._O / Pi,   &
 ', gamma = ', gama1 * 180._O / Pi, ';'  
  write (iOutput,*)
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum expansion order tolerance, epsNrank = ', epsNrank, ';'
  write (iOutput,"(2x, a, 1pe10.3, a)")                                             &
 'maximum azimuthal order tolerance, epsMrank = ', epsMrank, '.'          
  write (iOutput,"(/)")                       
end subroutine printinputINHOMSPH
!***********************************************************************************
subroutine convergence_Nrank_MrankINHOMSPH (Rb, ks, ind_ref, snorm, Mrank, Nrank,   &
           x1, y1, z1, alfa1, beta1, gama1, Mrank1, Nrank1, FileTmat, axsym1,       &
           chiral1, epsNrank, epsMrank, ExtThetaDom, FileTmatG, PrnProgress)
  use parameters
  implicit none
  integer       :: Mrank, Nrank, Mrank1, Nrank1
  real(O)       :: ks, ind_ref, Rb, snorm, x1, y1, z1, alfa1, beta1, gama1,         &
                   epsNrank, epsMrank  
  character(80) :: FileTmat, FileTmatG
  logical       :: axsym1, chiral1, ExtThetaDom, PrnProgress 
!
  integer       :: Nmax, Nmax1, Nteta, i, NthetaConvN, NthetaConvM, NmaxAL,         &
                   nt1g, mt1g
  real(O)       :: k, alfa, beta, gama, alfap, tetaGI, phiGI, phiGS, Cscat, Qscat,  &
                   Cext, Qext, r1, sumang
  complex(O)    :: ind_refC
  real(O),allocatable    :: h(:), v(:), oldh(:), oldv(:), oldh0(:), oldv0(:)
  complex(O),allocatable :: a(:,:), b(:,:), s(:,:), c(:), c1(:), t1(:,:), t(:),     &
                            t11(:), t13(:), t31(:), t33(:)     
!
  tetaGI = 0._O
  phiGI  = 0._O
  phiGS  = 0._O
  Nteta  = 10
  alfa   = Pi / 4._O
  beta   = Pi / 4._O
  gama   = 0._O
  alfap  = Pi / 4._O
  Nmax   = Nrank + Mrank * (2 * Nrank - Mrank + 1) 
  Nmax1  = Nrank1 + Mrank1 * (2 * Nrank1 - Mrank1 + 1) 
  NmaxAL = max(Nmax, Nmax1)
  k = ks * ind_ref  
  ind_refC = cmplx(ind_ref,0.0,O)  
  call write_TypeConvHead (4)
  allocate (a(2*NmaxAL,2*NmaxAL), b(2*NmaxAL,2*NmaxAL), s(2*NmaxAL,2*NmaxAL),       &
            c(2*NmaxAL), c1(2*NmaxAL))
  allocate (t(2*NmaxAL), t11(2*NmaxAL), t13(2*NmaxAL), t31(2*NmaxAL), t33(2*NmaxAL))
  allocate (h(Nteta), v(Nteta), oldh(Nteta), oldv(Nteta), oldh0(Nteta), oldv0(Nteta))
  open (unit = iTmat, file = FileTmat, status = "old", position = "rewind")
  if (.not. axsym1) then
    call read_HeadFileTmat (nt1g, mt1g)
    call check_dimensionMat (nt1g, mt1g, Nmax1)       
    allocate (t1(2*nt1g,2*mt1g))
    call read_FileTmat (nt1g, mt1g, t1) 
  else
    nt1g = Nmax1
    mt1g = Nmax1
    allocate (t1(2*nt1g,2*mt1g))
    call read_Tmatrix (chiral1, Nrank1, Mrank1, Nmax1, t1, nt1g, mt1g)            
  end if
  close (unit = iTmat)
  open  (unit = iTmat, file = FileTmatG, status = 'replace')
  call  write_HeadFileTmat (NmaxAL, NmaxAL)  
  if (PrnProgress) call  write_progress (.true., 1, 6)            
  r1 = sqrt(x1**2 + y1**2 + z1**2)
  sumang = abs(alfa1) + abs(beta1) + abs(gama1)
  if (r1 /=0 .and. sumang /= 0) then
    call MatTransRot_TR_mn_m1n1 (1, k, x1, y1, z1, alfa1, beta1, gama1, Mrank,      &
         Nrank, Nmax, Mrank1, Nrank1, Nmax1, s, NmaxAL, NmaxAL)
  else if (r1 /=0 .and. sumang == 0) then 
    call MatTransAB_mn_m1n1 (1, k, x1, y1, z1, Mrank, Nrank, Nmax, Mrank1,          &
         Nrank1, Nmax1, s, NmaxAL, NmaxAL)
  else if (r1 == 0 .and. sumang /= 0) then    
    call MatRot_R_mn_m1n1 (alfa1, beta1, gama1, Mrank, Nrank, Nmax, Mrank1,         &
         Nrank1, Nmax1, s, NmaxAL, NmaxAL, .true.)
  else if (r1 == 0 .and. sumang == 0) then
    call identity_transformation (Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1, s,     &
         NmaxAL, NmaxAL)    
  end if  
  call product_matrices (2*Nmax, 2*Nmax1, 2*Nmax1, s, 2*NmaxAL, 2*NmaxAL, t1,       &
       2*nt1g, 2*mt1g)
  if (PrnProgress) call write_progress (.false., 2, 6)
  if (r1 /=0 .and. sumang /= 0) then
    call MatRotTrans_RT_mn_m1n1 (1, k, x1, y1, z1, alfa1, beta1, gama1, Mrank1,     &
         Nrank1, Nmax1, Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)
  else if (r1 /=0 .and. sumang == 0) then 
    call MatTransAB_mn_m1n1 (1, k, -x1, -y1, -z1, Mrank1, Nrank1, Nmax1, Mrank,     &
         Nrank, Nmax, a, NmaxAL, NmaxAL)
  else if (r1 == 0 .and. sumang /= 0) then    
    call MatRot_R_mn_m1n1 (-gama1, -beta1, -alfa1, Mrank1, Nrank1, Nmax1, Mrank,    &
         Nrank, Nmax, a, NmaxAL, NmaxAL, .true.)
  else if (r1 == 0 .and. sumang == 0) then
    call identity_transformation (Mrank1, Nrank1, Nmax1, Mrank, Nrank, Nmax,        &
         a, NmaxAL, NmaxAL)    
  end if   
  call product_matrices (2*Nmax, 2*Nmax1, 2*Nmax, s, 2*NmaxAL, 2*NmaxAL, a,         &
       2*NmaxAL, 2*NmaxAL) 
  if (PrnProgress) call write_progress (.false., 3, 6)      
  call vector_Q_sphere (3, 3, ks, Rb, ind_refC, Mrank, Nrank, Nmax, t)
  call copy_vector (t, t33, 2*Nmax)     
  call product_matrix_vector1 (2*Nmax, 2*Nmax, t, s, 2*NmaxAL, 2*NmaxAL,            &
       a, 2*NmaxAL, 2*NmaxAL)
  call vector_Q_sphere (3, 1, ks, Rb, ind_refC, Mrank, Nrank, Nmax, t)
  call copy_vector (t, t31, 2*Nmax)     
  call sum_diagonal_elements (2*Nmax, t, a, 2*NmaxAL, 2*NmaxAL) 
  if (PrnProgress) call write_progress (.false., 4, 6)
  call vector_Q_sphere (1, 3, ks, Rb, ind_refC, Mrank, Nrank, Nmax, t)
  call copy_vector (t, t13, 2*Nmax)     
  call product_matrix_vector1 (2*Nmax, 2*Nmax, t, s, 2*NmaxAL, 2*NmaxAL,            &
       b, 2*NmaxAL, 2*NmaxAL)
  call vector_Q_sphere (1, 1, ks, Rb, ind_refC, Mrank, Nrank, Nmax, t)
  call copy_vector (t, t11, 2*Nmax)     
  call sum_diagonal_elements (2*Nmax, t, b, 2*NmaxAL, 2*NmaxAL)  
  if (PrnProgress) call write_progress (.false., 5, 6)
  call LU_SYSTEM (a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 6, 6)
  call minus_matrix (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL)
  call write_FileTmat (NmaxAL, NmaxAL, b)       
  call PWcoefficients_ab (tetaGI, phiGI, alfa, beta, gama, alfap, Mrank, Nrank,     &
       Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfa, beta, gama, ks, snorm,     &
       ExtThetaDom,.true., h, v)
  call CQscat (c1, Mrank, Nrank, Nmax, ks, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfa, beta, gama,              &
       alfap, ks, snorm, Cext, Qext)       
  call write_2ConvParam (Nrank, Mrank)  
  call write_DSCS (Nteta, ExtThetaDom, h, v)
  call write_Effic (Qscat, Qext)
  do i = 1, Nteta
    oldh(i)  = h(i)
    oldv(i)  = v(i)
    oldh0(i) = h(i)
    oldv0(i) = v(i)
  end do 
  close (unit = iTmat) 
! --- (Nrank - 1) configuration ---
  if (PrnProgress) call write_progress_low
  call copy_vector (t33, t, 2*Nmax)
  call vector_Nrank_1 (Mrank, Nrank, Nmax, t)   
  call product_matrix_vector1 (2*Nmax, 2*Nmax, t, s, 2*NmaxAL, 2*NmaxAL,            &
       a, 2*NmaxAL, 2*NmaxAL)
  call copy_vector (t31, t, 2*Nmax)
  call vector_Nrank_1 (Mrank, Nrank, Nmax, t)   
  call sum_diagonal_elements (2*Nmax, t, a, 2*NmaxAL, 2*NmaxAL)
  call matrix_Nrank_1_left (Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)  
  call copy_vector (t13, t, 2*Nmax)
  call vector_Nrank_1 (Mrank, Nrank, Nmax, t)   
  call product_matrix_vector1 (2*Nmax, 2*Nmax, t, s, 2*NmaxAL, 2*NmaxAL,            &
       b, 2*NmaxAL, 2*NmaxAL)
  call copy_vector (t11, t, 2*Nmax)
  call vector_Nrank_1 (Mrank, Nrank, Nmax, t)   
  call sum_diagonal_elements (2*Nmax, t, b, 2*NmaxAL, 2*NmaxAL)  
  call matrix_Nrank_1_right (Mrank, Nrank, Nmax, b, NmaxAL, NmaxAL)  
  call LU_SYSTEM (a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL, 2*Nmax)
  call minus_matrix (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL) 
  call PWcoefficients_ab (tetaGI, phiGI, alfa, beta, gama, alfap, Mrank, Nrank,     &
       Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfa, beta, gama, ks, snorm,     &
       ExtThetaDom,.true., h, v)
  call CQscat (c1, Mrank, Nrank, Nmax, ks, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfa, beta, gama,              &
       alfap, ks, snorm, Cext, Qext)
  call delta_DSCS (Nteta, h, v, oldh, oldv, epsNrank, NthetaConvN)
  call write_2ConvParam (Nrank - 1, Mrank)
  call write_DSCS (Nteta, ExtThetaDom, h, v)
  call write_Effic (Qscat, Qext)
  call write_NrankConvRes (NthetaConvN, Nteta, epsNrank)
! --- (Mrank - 1) configuration ---
  call copy_vector (t33, t, 2*Nmax)
  call vector_Mrank_1 (Mrank, Nrank, Nmax, t)   
  call product_matrix_vector1 (2*Nmax, 2*Nmax, t, s, 2*NmaxAL, 2*NmaxAL,            &
       a, 2*NmaxAL, 2*NmaxAL)
  call copy_vector (t31, t, 2*Nmax)
  call vector_Mrank_1 (Mrank, Nrank, Nmax, t)   
  call sum_diagonal_elements (2*Nmax, t, a, 2*NmaxAL, 2*NmaxAL)
  call matrix_Mrank_1_left (Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL) 
  call copy_vector (t13, t, 2*Nmax)
  call vector_Mrank_1 (Mrank, Nrank, Nmax, t)   
  call product_matrix_vector1 (2*Nmax, 2*Nmax, t, s, 2*NmaxAL, 2*NmaxAL,            &
       b, 2*NmaxAL, 2*NmaxAL)
  call copy_vector (t11, t, 2*Nmax)
  call vector_Mrank_1 (Mrank, Nrank, Nmax, t)   
  call sum_diagonal_elements (2*Nmax, t, b, 2*NmaxAL, 2*NmaxAL)  
  call matrix_Mrank_1_right (Mrank, Nrank, Nmax, b, NmaxAL, NmaxAL) 
  call LU_SYSTEM (a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL, 2*Nmax)
  call minus_matrix (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL)
  call PWcoefficients_ab (tetaGI, phiGI, alfa, beta, gama, alfap, Mrank, Nrank,     &
       Nmax, c)    
  call product_matrix_vector (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL, c, c1)
  call DSCS (c1, Mrank, Nrank, Nmax, Nteta, phiGS, alfa, beta, gama, ks, snorm,     &
       ExtThetaDom,.true., h, v)
  call CQscat (c1, Mrank, Nrank, Nmax, ks, snorm, Cscat, Qscat)
  call CQext (c1, Mrank, Nrank, Nmax, tetaGI, phiGI, alfa, beta, gama,              &
       alfap, ks, snorm, Cext, Qext)
  call delta_DSCS (Nteta, h, v, oldh0, oldv0, epsMrank, NthetaConvM)
  call write_2ConvParam (Nrank, Mrank - 1)
  call write_DSCS (Nteta, ExtThetaDom, h, v)
  call write_Effic (Qscat, Qext)
  call write_MrankConvRes (NthetaConvM, epsMrank)
  if (NthetaConvN >= int(0.8*Nteta) .and. NthetaConvM >= int(0.8*Nteta)) then
    print "(/,2x,'Convergence criteria for Nrank and Mrank are satisfied;')"                       
  else
    print "(/,2x,'Convergence criteria for Nrank and Mrank are not satisfied;')"
  end if 
  call write_InfoFileTmat (FileTmatG, Mrank, Nrank, .false., .false., .false.)
  call ScatCharact (ks, FileTmatG, Mrank, Nrank, .false., .false., .false.)  
  print "(/,2x,'T matrix is stored in ',a50)", FileTmatG
  print "(  2x,'The dimensions of the T matrix are given by:')"
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank                  
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank              
  deallocate (a, b, s, c, c1, t1, t, t11, t13, t31, t33, h, v, oldh, oldv,          &
              oldh0, oldv0)     
end subroutine convergence_Nrank_MrankINHOMSPH
!***********************************************************************************
subroutine TMatrix_Nrank_MrankINHOMSPH (Rb, ks, ind_ref, Mrank, Nrank, x1, y1, z1,  &
           alfa1, beta1, gama1, Mrank1, Nrank1, FileTmat, axsym1, chiral1,          &
           FileTmatG, PrnProgress)
  use parameters
  implicit none
  integer       :: Mrank, Nrank, Mrank1, Nrank1
  real(O)       :: ks, ind_ref, Rb, x1, y1, z1, alfa1, beta1, gama1                    
  character(80) :: FileTmat, FileTmatG
  logical       :: axsym1, chiral1, PrnProgress 
!
  integer       :: Nmax, Nmax1, NmaxAL, nt1g, mt1g
  real(O)       :: k, r1, sumang
  complex(O)    :: ind_refC
  complex(O),allocatable :: a(:,:), b(:,:), s(:,:), t1(:,:), t(:)                            
!  
  Nmax   = Nrank + Mrank * (2 * Nrank - Mrank + 1) 
  Nmax1  = Nrank1 + Mrank1 * (2 * Nrank1 - Mrank1 + 1) 
  NmaxAL = max(Nmax, Nmax1)
  k = ks * ind_ref  
  ind_refC = cmplx(ind_ref,0.0,O)  
  allocate (a(2*NmaxAL,2*NmaxAL), b(2*NmaxAL,2*NmaxAL), s(2*NmaxAL,2*NmaxAL))
  allocate (t(2*NmaxAL))
  open (unit = iTmat, file = FileTmat, status = "old", position = "rewind")
  if (.not. axsym1) then
    call read_HeadFileTmat (nt1g, mt1g)
    call check_dimensionMat (nt1g, mt1g, Nmax1)       
    allocate (t1(2*nt1g,2*mt1g))
    call read_FileTmat (nt1g, mt1g, t1) 
  else
    nt1g = Nmax1
    mt1g = Nmax1
    allocate (t1(2*nt1g,2*mt1g))
    call read_Tmatrix (chiral1, Nrank1, Mrank1, Nmax1, t1, nt1g, mt1g)            
  end if
  close (unit = iTmat)
  open  (unit = iTmat, file = FileTmatG, status = 'replace')
  call  write_HeadFileTmat (NmaxAL, NmaxAL)  
  if (PrnProgress) call  write_progress (.true., 1, 6)            
  r1 = sqrt(x1**2 + y1**2 + z1**2)
  sumang = abs(alfa1) + abs(beta1) + abs(gama1)
  if (r1 /=0 .and. sumang /= 0) then
    call MatTransRot_TR_mn_m1n1 (1, k, x1, y1, z1, alfa1, beta1, gama1, Mrank,      &
         Nrank, Nmax, Mrank1, Nrank1, Nmax1, s, NmaxAL, NmaxAL)
  else if (r1 /=0 .and. sumang == 0) then 
    call MatTransAB_mn_m1n1 (1, k, x1, y1, z1, Mrank, Nrank, Nmax, Mrank1,          &
         Nrank1, Nmax1, s, NmaxAL, NmaxAL)
  else if (r1 == 0 .and. sumang /= 0) then    
    call MatRot_R_mn_m1n1 (alfa1, beta1, gama1, Mrank, Nrank, Nmax, Mrank1,         &
         Nrank1, Nmax1, s, NmaxAL, NmaxAL, .true.)
  else if (r1 == 0 .and. sumang == 0) then
    call identity_transformation (Mrank, Nrank, Nmax, Mrank1, Nrank1, Nmax1, s,     &
         NmaxAL, NmaxAL)    
  end if  
  call product_matrices (2*Nmax, 2*Nmax1, 2*Nmax1, s, 2*NmaxAL, 2*NmaxAL, t1,       &
       2*nt1g, 2*mt1g)
  if (PrnProgress) call write_progress (.false., 2, 6)
  if (r1 /=0 .and. sumang /= 0) then
    call MatRotTrans_RT_mn_m1n1 (1, k, x1, y1, z1, alfa1, beta1, gama1, Mrank1,     &
         Nrank1, Nmax1, Mrank, Nrank, Nmax, a, NmaxAL, NmaxAL)
  else if (r1 /=0 .and. sumang == 0) then 
    call MatTransAB_mn_m1n1 (1, k, -x1, -y1, -z1, Mrank1, Nrank1, Nmax1, Mrank,     &
         Nrank, Nmax, a, NmaxAL, NmaxAL)
  else if (r1 == 0 .and. sumang /= 0) then    
    call MatRot_R_mn_m1n1 (-gama1, -beta1, -alfa1, Mrank1, Nrank1, Nmax1, Mrank,    &
         Nrank, Nmax, a, NmaxAL, NmaxAL, .true.)
  else if (r1 == 0 .and. sumang == 0) then
    call identity_transformation (Mrank1, Nrank1, Nmax1, Mrank, Nrank, Nmax,        &
         a, NmaxAL, NmaxAL)    
  end if   
  call product_matrices (2*Nmax, 2*Nmax1, 2*Nmax, s, 2*NmaxAL, 2*NmaxAL, a,         &
       2*NmaxAL, 2*NmaxAL) 
  if (PrnProgress) call write_progress (.false., 3, 6)      
  call vector_Q_sphere (3, 3, ks, Rb, ind_refC, Mrank, Nrank, Nmax, t)
  call product_matrix_vector1 (2*Nmax, 2*Nmax, t, s, 2*NmaxAL, 2*NmaxAL,            &
       a, 2*NmaxAL, 2*NmaxAL)
  call vector_Q_sphere (3, 1, ks, Rb, ind_refC, Mrank, Nrank, Nmax, t)
  call sum_diagonal_elements (2*Nmax, t, a, 2*NmaxAL, 2*NmaxAL) 
  if (PrnProgress) call write_progress (.false., 4, 6)
  call vector_Q_sphere (1, 3, ks, Rb, ind_refC, Mrank, Nrank, Nmax, t)
  call product_matrix_vector1 (2*Nmax, 2*Nmax, t, s, 2*NmaxAL, 2*NmaxAL,            &
       b, 2*NmaxAL, 2*NmaxAL)
  call vector_Q_sphere (1, 1, ks, Rb, ind_refC, Mrank, Nrank, Nmax, t)
  call sum_diagonal_elements (2*Nmax, t, b, 2*NmaxAL, 2*NmaxAL)  
  if (PrnProgress) call write_progress (.false., 5, 6)
  call LU_SYSTEM (a, 2*NmaxAL, 2*NmaxAL, b, 2*NmaxAL, 2*NmaxAL, 2*Nmax)
  if (PrnProgress) call write_progress (.false., 6, 6)
  call minus_matrix (2*Nmax, 2*Nmax, b, 2*NmaxAL, 2*NmaxAL)
  call write_FileTmat (NmaxAL, NmaxAL, b)         
  close (unit = iTmat) 
  call write_InfoFileTmat (FileTmatG, Mrank, Nrank, .false., .false., .false.)
  call ScatCharact (ks, FileTmatG, Mrank, Nrank, .false., .false., .false.) 
  print "(/,2x,'T matrix is stored in ',a50)", FileTmatG
  print "(  2x,'The dimensions of the T matrix are given by:')"         
  print "(  2x,'- maximum expansion order,   Nrank = ',i3,',')", Nrank          
  print "(  2x,'- number of azimuthal modes, Mrank = ',i3,';')", Mrank              
  deallocate (a, b, s, t1, t)   
end subroutine TMatrix_Nrank_MrankINHOMSPH
